/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_00gd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (00|gd) integrals */

void d12hrr_order_00gd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[0][6][11] = int_stack + 0;
 Libderiv->deriv_classes[0][6][10] = int_stack + 28;
 Libderiv->deriv_classes[0][6][9] = int_stack + 56;
 Libderiv->deriv_classes[0][6][8] = int_stack + 84;
 Libderiv->deriv_classes[0][6][7] = int_stack + 112;
 Libderiv->dvrr_classes[0][5] = int_stack + 140;
 Libderiv->deriv_classes[0][6][6] = int_stack + 161;
 Libderiv->deriv_classes[0][6][2] = int_stack + 189;
 Libderiv->deriv_classes[0][6][1] = int_stack + 217;
 Libderiv->deriv_classes[0][6][0] = int_stack + 245;
 Libderiv->deriv2_classes[0][4][143] = int_stack + 273;
 Libderiv->deriv2_classes[0][5][143] = int_stack + 288;
 Libderiv->deriv2_classes[0][6][143] = int_stack + 309;
 Libderiv->deriv2_classes[0][4][131] = int_stack + 337;
 Libderiv->deriv2_classes[0][5][131] = int_stack + 352;
 Libderiv->deriv2_classes[0][6][131] = int_stack + 373;
 Libderiv->deriv2_classes[0][4][130] = int_stack + 401;
 Libderiv->deriv2_classes[0][5][130] = int_stack + 416;
 Libderiv->deriv2_classes[0][6][130] = int_stack + 437;
 Libderiv->deriv2_classes[0][4][119] = int_stack + 465;
 Libderiv->deriv2_classes[0][5][119] = int_stack + 480;
 Libderiv->deriv2_classes[0][6][119] = int_stack + 501;
 Libderiv->deriv2_classes[0][4][118] = int_stack + 529;
 Libderiv->deriv2_classes[0][5][118] = int_stack + 544;
 Libderiv->deriv2_classes[0][6][118] = int_stack + 565;
 Libderiv->deriv2_classes[0][4][117] = int_stack + 593;
 Libderiv->deriv2_classes[0][5][117] = int_stack + 608;
 Libderiv->deriv2_classes[0][6][117] = int_stack + 629;
 Libderiv->deriv2_classes[0][4][107] = int_stack + 657;
 Libderiv->deriv2_classes[0][5][107] = int_stack + 672;
 Libderiv->deriv2_classes[0][6][107] = int_stack + 693;
 Libderiv->deriv2_classes[0][4][106] = int_stack + 721;
 Libderiv->deriv2_classes[0][5][106] = int_stack + 736;
 Libderiv->deriv2_classes[0][6][106] = int_stack + 757;
 Libderiv->deriv2_classes[0][4][105] = int_stack + 785;
 Libderiv->deriv2_classes[0][5][105] = int_stack + 800;
 Libderiv->deriv2_classes[0][6][105] = int_stack + 821;
 Libderiv->deriv2_classes[0][4][104] = int_stack + 849;
 Libderiv->deriv2_classes[0][5][104] = int_stack + 864;
 Libderiv->deriv2_classes[0][6][104] = int_stack + 885;
 Libderiv->deriv2_classes[0][4][95] = int_stack + 913;
 Libderiv->deriv2_classes[0][5][95] = int_stack + 928;
 Libderiv->deriv2_classes[0][6][95] = int_stack + 949;
 Libderiv->deriv2_classes[0][4][94] = int_stack + 977;
 Libderiv->deriv2_classes[0][5][94] = int_stack + 992;
 Libderiv->deriv2_classes[0][6][94] = int_stack + 1013;
 Libderiv->deriv2_classes[0][4][93] = int_stack + 1041;
 Libderiv->deriv2_classes[0][5][93] = int_stack + 1056;
 Libderiv->deriv2_classes[0][6][93] = int_stack + 1077;
 Libderiv->deriv2_classes[0][4][92] = int_stack + 1105;
 Libderiv->deriv2_classes[0][5][92] = int_stack + 1120;
 Libderiv->deriv2_classes[0][6][92] = int_stack + 1141;
 Libderiv->deriv2_classes[0][4][91] = int_stack + 1169;
 Libderiv->deriv2_classes[0][5][91] = int_stack + 1184;
 Libderiv->deriv2_classes[0][6][91] = int_stack + 1205;
 Libderiv->deriv_classes[0][4][11] = int_stack + 1233;
 Libderiv->deriv2_classes[0][4][83] = int_stack + 1248;
 Libderiv->deriv_classes[0][5][11] = int_stack + 1263;
 Libderiv->deriv2_classes[0][5][83] = int_stack + 1284;
 Libderiv->deriv2_classes[0][6][83] = int_stack + 1305;
 Libderiv->deriv_classes[0][4][10] = int_stack + 1333;
 Libderiv->deriv2_classes[0][4][82] = int_stack + 1348;
 Libderiv->deriv_classes[0][5][10] = int_stack + 1363;
 Libderiv->deriv2_classes[0][5][82] = int_stack + 1384;
 Libderiv->deriv2_classes[0][6][82] = int_stack + 1405;
 Libderiv->deriv_classes[0][4][9] = int_stack + 1433;
 Libderiv->deriv2_classes[0][4][81] = int_stack + 1448;
 Libderiv->deriv_classes[0][5][9] = int_stack + 1463;
 Libderiv->deriv2_classes[0][5][81] = int_stack + 1484;
 Libderiv->deriv2_classes[0][6][81] = int_stack + 1505;
 Libderiv->deriv_classes[0][4][8] = int_stack + 1533;
 Libderiv->deriv2_classes[0][4][80] = int_stack + 1548;
 Libderiv->deriv_classes[0][5][8] = int_stack + 1563;
 Libderiv->deriv2_classes[0][5][80] = int_stack + 1584;
 Libderiv->deriv2_classes[0][6][80] = int_stack + 1605;
 Libderiv->deriv_classes[0][4][7] = int_stack + 1633;
 Libderiv->deriv2_classes[0][4][79] = int_stack + 1648;
 Libderiv->deriv_classes[0][5][7] = int_stack + 1663;
 Libderiv->deriv2_classes[0][5][79] = int_stack + 1684;
 Libderiv->deriv2_classes[0][6][79] = int_stack + 1705;
 Libderiv->dvrr_classes[0][4] = int_stack + 1733;
 Libderiv->deriv_classes[0][4][6] = int_stack + 1748;
 Libderiv->deriv2_classes[0][4][78] = int_stack + 1763;
 Libderiv->deriv_classes[0][5][6] = int_stack + 1778;
 Libderiv->deriv2_classes[0][5][78] = int_stack + 1799;
 Libderiv->deriv2_classes[0][6][78] = int_stack + 1820;
 Libderiv->deriv2_classes[0][4][35] = int_stack + 1848;
 Libderiv->deriv2_classes[0][5][35] = int_stack + 1863;
 Libderiv->deriv2_classes[0][6][35] = int_stack + 1884;
 Libderiv->deriv2_classes[0][4][34] = int_stack + 1912;
 Libderiv->deriv2_classes[0][5][34] = int_stack + 1927;
 Libderiv->deriv2_classes[0][6][34] = int_stack + 1948;
 Libderiv->deriv2_classes[0][4][33] = int_stack + 1976;
 Libderiv->deriv2_classes[0][5][33] = int_stack + 1991;
 Libderiv->deriv2_classes[0][6][33] = int_stack + 2012;
 Libderiv->deriv2_classes[0][4][32] = int_stack + 2040;
 Libderiv->deriv2_classes[0][5][32] = int_stack + 2055;
 Libderiv->deriv2_classes[0][6][32] = int_stack + 2076;
 Libderiv->deriv2_classes[0][4][31] = int_stack + 2104;
 Libderiv->deriv2_classes[0][5][31] = int_stack + 2119;
 Libderiv->deriv2_classes[0][6][31] = int_stack + 2140;
 Libderiv->deriv_classes[0][4][2] = int_stack + 2168;
 Libderiv->deriv2_classes[0][4][30] = int_stack + 2183;
 Libderiv->deriv_classes[0][5][2] = int_stack + 2198;
 Libderiv->deriv2_classes[0][5][30] = int_stack + 2219;
 Libderiv->deriv2_classes[0][6][30] = int_stack + 2240;
 Libderiv->deriv2_classes[0][4][26] = int_stack + 2268;
 Libderiv->deriv2_classes[0][5][26] = int_stack + 2283;
 Libderiv->deriv2_classes[0][6][26] = int_stack + 2304;
 Libderiv->deriv2_classes[0][4][23] = int_stack + 2332;
 Libderiv->deriv2_classes[0][5][23] = int_stack + 2347;
 Libderiv->deriv2_classes[0][6][23] = int_stack + 2368;
 Libderiv->deriv2_classes[0][4][22] = int_stack + 2396;
 Libderiv->deriv2_classes[0][5][22] = int_stack + 2411;
 Libderiv->deriv2_classes[0][6][22] = int_stack + 2432;
 Libderiv->deriv2_classes[0][4][21] = int_stack + 2460;
 Libderiv->deriv2_classes[0][5][21] = int_stack + 2475;
 Libderiv->deriv2_classes[0][6][21] = int_stack + 2496;
 Libderiv->deriv2_classes[0][4][20] = int_stack + 2524;
 Libderiv->deriv2_classes[0][5][20] = int_stack + 2539;
 Libderiv->deriv2_classes[0][6][20] = int_stack + 2560;
 Libderiv->deriv2_classes[0][4][19] = int_stack + 2588;
 Libderiv->deriv2_classes[0][5][19] = int_stack + 2603;
 Libderiv->deriv2_classes[0][6][19] = int_stack + 2624;
 Libderiv->deriv_classes[0][4][1] = int_stack + 2652;
 Libderiv->deriv2_classes[0][4][18] = int_stack + 2667;
 Libderiv->deriv_classes[0][5][1] = int_stack + 2682;
 Libderiv->deriv2_classes[0][5][18] = int_stack + 2703;
 Libderiv->deriv2_classes[0][6][18] = int_stack + 2724;
 Libderiv->deriv2_classes[0][4][14] = int_stack + 2752;
 Libderiv->deriv2_classes[0][5][14] = int_stack + 2767;
 Libderiv->deriv2_classes[0][6][14] = int_stack + 2788;
 Libderiv->deriv2_classes[0][4][13] = int_stack + 2816;
 Libderiv->deriv2_classes[0][5][13] = int_stack + 2831;
 Libderiv->deriv2_classes[0][6][13] = int_stack + 2852;
 Libderiv->deriv2_classes[0][4][11] = int_stack + 2880;
 Libderiv->deriv2_classes[0][5][11] = int_stack + 2895;
 Libderiv->deriv2_classes[0][6][11] = int_stack + 2916;
 Libderiv->deriv2_classes[0][4][10] = int_stack + 2944;
 Libderiv->deriv2_classes[0][5][10] = int_stack + 2959;
 Libderiv->deriv2_classes[0][6][10] = int_stack + 2980;
 Libderiv->deriv2_classes[0][4][9] = int_stack + 3008;
 Libderiv->deriv2_classes[0][5][9] = int_stack + 3023;
 Libderiv->deriv2_classes[0][6][9] = int_stack + 3044;
 Libderiv->deriv2_classes[0][4][8] = int_stack + 3072;
 Libderiv->deriv2_classes[0][5][8] = int_stack + 3087;
 Libderiv->deriv2_classes[0][6][8] = int_stack + 3108;
 Libderiv->deriv2_classes[0][4][7] = int_stack + 3136;
 Libderiv->deriv2_classes[0][5][7] = int_stack + 3151;
 Libderiv->deriv2_classes[0][6][7] = int_stack + 3172;
 Libderiv->deriv_classes[0][4][0] = int_stack + 3200;
 Libderiv->deriv2_classes[0][4][6] = int_stack + 3215;
 Libderiv->deriv_classes[0][5][0] = int_stack + 3230;
 Libderiv->deriv2_classes[0][5][6] = int_stack + 3251;
 Libderiv->deriv2_classes[0][6][6] = int_stack + 3272;
 Libderiv->deriv2_classes[0][4][2] = int_stack + 3300;
 Libderiv->deriv2_classes[0][5][2] = int_stack + 3315;
 Libderiv->deriv2_classes[0][6][2] = int_stack + 3336;
 Libderiv->deriv2_classes[0][4][1] = int_stack + 3364;
 Libderiv->deriv2_classes[0][5][1] = int_stack + 3379;
 Libderiv->deriv2_classes[0][6][1] = int_stack + 3400;
 Libderiv->deriv2_classes[0][4][0] = int_stack + 3428;
 Libderiv->deriv2_classes[0][5][0] = int_stack + 3443;
 Libderiv->deriv2_classes[0][6][0] = int_stack + 3464;
 memset(int_stack,0,27936);

 Libderiv->dvrr_stack = int_stack + 6435;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_00gd(Libderiv, Data);
   Data++;
 }

 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+3492,int_stack+140,int_stack+1733,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3537,int_stack+1263,int_stack+1233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1733,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3582,int_stack+0,int_stack+1263, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+140,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3645,int_stack+1363,int_stack+1333, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1733, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3690,int_stack+28,int_stack+1363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+140, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+1463,int_stack+1433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1733, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3753,int_stack+56,int_stack+1463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+140, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3816,int_stack+1563,int_stack+1533, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3861,int_stack+84,int_stack+1563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+45,int_stack+1663,int_stack+1633, 0.0, zero_stack, 1.0, int_stack+1733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3924,int_stack+112,int_stack+1663, 0.0, zero_stack, 1.0, int_stack+140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+90,int_stack+1778,int_stack+1748, 1.0, int_stack+1733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3987,int_stack+161,int_stack+1778, 1.0, int_stack+140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+135,int_stack+2198,int_stack+2168,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4050,int_stack+189,int_stack+2198,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+4113,int_stack+2682,int_stack+2652,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4158,int_stack+217,int_stack+2682,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+180,int_stack+3230,int_stack+3200,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4221,int_stack+245,int_stack+3230,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+225,int_stack+288,int_stack+273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1233,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4284,int_stack+309,int_stack+288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1263,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+270,int_stack+352,int_stack+337, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1233, 1.0, int_stack+1333,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4347,int_stack+373,int_stack+352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1263, 1.0, int_stack+1363,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+315,int_stack+416,int_stack+401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1333, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4410,int_stack+437,int_stack+416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1363, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+360,int_stack+480,int_stack+465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1233, 0.0, zero_stack, 1.0, int_stack+1433,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+405,int_stack+501,int_stack+480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1263, 0.0, zero_stack, 1.0, int_stack+1463,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+468,int_stack+544,int_stack+529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1333, 1.0, int_stack+1433, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4473,int_stack+565,int_stack+544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1363, 1.0, int_stack+1463, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+513,int_stack+608,int_stack+593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1433, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4536,int_stack+629,int_stack+608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1463, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+558,int_stack+672,int_stack+657, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1233, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1533,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+603,int_stack+693,int_stack+672, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1263, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1563,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+666,int_stack+736,int_stack+721, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1333, 0.0, zero_stack, 1.0, int_stack+1533, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4599,int_stack+757,int_stack+736, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1363, 0.0, zero_stack, 1.0, int_stack+1563, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+711,int_stack+800,int_stack+785, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1433, 1.0, int_stack+1533, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4662,int_stack+821,int_stack+800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1463, 1.0, int_stack+1563, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+756,int_stack+864,int_stack+849, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+801,int_stack+885,int_stack+864, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+864,int_stack+928,int_stack+913, 0.0, zero_stack, 1.0, int_stack+1233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1633,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4725,int_stack+949,int_stack+928, 0.0, zero_stack, 1.0, int_stack+1263, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1663,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+909,int_stack+992,int_stack+977, 0.0, zero_stack, 1.0, int_stack+1333, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1633, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4788,int_stack+1013,int_stack+992, 0.0, zero_stack, 1.0, int_stack+1363, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1663, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+954,int_stack+1056,int_stack+1041, 0.0, zero_stack, 1.0, int_stack+1433, 0.0, zero_stack, 1.0, int_stack+1633, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4851,int_stack+1077,int_stack+1056, 0.0, zero_stack, 1.0, int_stack+1463, 0.0, zero_stack, 1.0, int_stack+1663, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+999,int_stack+1120,int_stack+1105, 0.0, zero_stack, 1.0, int_stack+1533, 1.0, int_stack+1633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1044,int_stack+1141,int_stack+1120, 0.0, zero_stack, 1.0, int_stack+1563, 1.0, int_stack+1663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1107,int_stack+1184,int_stack+1169, 0.0, zero_stack, 2.0, int_stack+1633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4914,int_stack+1205,int_stack+1184, 0.0, zero_stack, 2.0, int_stack+1663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1152,int_stack+1284,int_stack+1248, 1.0, int_stack+1233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1748,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1197,int_stack+1305,int_stack+1284, 1.0, int_stack+1263, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1778,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1260,int_stack+1384,int_stack+1348, 1.0, int_stack+1333, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1748, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4977,int_stack+1405,int_stack+1384, 1.0, int_stack+1363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1778, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1305,int_stack+1484,int_stack+1448, 1.0, int_stack+1433, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1748, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1350,int_stack+1505,int_stack+1484, 1.0, int_stack+1463, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1778, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1413,int_stack+1584,int_stack+1548, 1.0, int_stack+1533, 0.0, zero_stack, 1.0, int_stack+1748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1458,int_stack+1605,int_stack+1584, 1.0, int_stack+1563, 0.0, zero_stack, 1.0, int_stack+1778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1521,int_stack+1684,int_stack+1648, 1.0, int_stack+1633, 1.0, int_stack+1748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1566,int_stack+1705,int_stack+1684, 1.0, int_stack+1663, 1.0, int_stack+1778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1629,int_stack+1799,int_stack+1763, 2.0, int_stack+1748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1674,int_stack+1820,int_stack+1799, 2.0, int_stack+1778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1737,int_stack+1863,int_stack+1848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2168,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1782,int_stack+1884,int_stack+1863, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2198,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1845,int_stack+1927,int_stack+1912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2168, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5040,int_stack+1948,int_stack+1927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2198, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1890,int_stack+1991,int_stack+1976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2168, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5103,int_stack+2012,int_stack+1991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2198, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1935,int_stack+2055,int_stack+2040, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1980,int_stack+2076,int_stack+2055, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2043,int_stack+2119,int_stack+2104, 0.0, zero_stack, 1.0, int_stack+2168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5166,int_stack+2140,int_stack+2119, 0.0, zero_stack, 1.0, int_stack+2198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2088,int_stack+2219,int_stack+2183, 1.0, int_stack+2168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2133,int_stack+2240,int_stack+2219, 1.0, int_stack+2198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+2196,int_stack+2283,int_stack+2268,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5229,int_stack+2304,int_stack+2283,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2241,int_stack+2347,int_stack+2332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2652,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5292,int_stack+2368,int_stack+2347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2682,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2286,int_stack+2411,int_stack+2396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2652, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2331,int_stack+2432,int_stack+2411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2682, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2394,int_stack+2475,int_stack+2460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2652, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5355,int_stack+2496,int_stack+2475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2682, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2439,int_stack+2539,int_stack+2524, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5418,int_stack+2560,int_stack+2539, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2484,int_stack+2603,int_stack+2588, 0.0, zero_stack, 1.0, int_stack+2652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2529,int_stack+2624,int_stack+2603, 0.0, zero_stack, 1.0, int_stack+2682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2592,int_stack+2703,int_stack+2667, 1.0, int_stack+2652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5481,int_stack+2724,int_stack+2703, 1.0, int_stack+2682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+2637,int_stack+2767,int_stack+2752,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2682,int_stack+2788,int_stack+2767,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+2745,int_stack+2831,int_stack+2816,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5544,int_stack+2852,int_stack+2831,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2790,int_stack+2895,int_stack+2880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3200,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5607,int_stack+2916,int_stack+2895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3230,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2835,int_stack+2959,int_stack+2944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3200, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2880,int_stack+2980,int_stack+2959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3230, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2943,int_stack+3023,int_stack+3008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3200, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5670,int_stack+3044,int_stack+3023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3230, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2988,int_stack+3087,int_stack+3072, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5733,int_stack+3108,int_stack+3087, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3033,int_stack+3151,int_stack+3136, 0.0, zero_stack, 1.0, int_stack+3200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3078,int_stack+3172,int_stack+3151, 0.0, zero_stack, 1.0, int_stack+3230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3141,int_stack+3251,int_stack+3215, 1.0, int_stack+3200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5796,int_stack+3272,int_stack+3251, 1.0, int_stack+3230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+3186,int_stack+3315,int_stack+3300,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3231,int_stack+3336,int_stack+3315,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+3294,int_stack+3379,int_stack+3364,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5859,int_stack+3400,int_stack+3379,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+3339,int_stack+3443,int_stack+3428,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5922,int_stack+3464,int_stack+3443,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3384,int_stack+3582,int_stack+3537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3492,1);
     Libderiv->ABCD[11] = int_stack + 3384;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+5985,int_stack+3690,int_stack+3645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3492, 0.0, zero_stack,1);
     Libderiv->ABCD[10] = int_stack + 5985;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+6075,int_stack+3753,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3492, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[9] = int_stack + 6075;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3690,int_stack+3861,int_stack+3816, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[8] = int_stack + 3690;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+6165,int_stack+3924,int_stack+45, 0.0, zero_stack, 1.0, int_stack+3492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[7] = int_stack + 6165;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3861,int_stack+3987,int_stack+90, 1.0, int_stack+3492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[6] = int_stack + 3861;
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+3951,int_stack+4050,int_stack+135,1);
     Libderiv->ABCD[2] = int_stack + 3951;
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+6255,int_stack+4158,int_stack+4113,1);
     Libderiv->ABCD[1] = int_stack + 6255;
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+6345,int_stack+4221,int_stack+180,1);
     Libderiv->ABCD[0] = int_stack + 6345;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4158,int_stack+4284,int_stack+225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3537,1);
     Libderiv->ABCD[155] = int_stack + 4158;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4248,int_stack+4347,int_stack+270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3537, 1.0, int_stack+3645,1);
     Libderiv->ABCD[143] = int_stack + 4248;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+225,int_stack+4410,int_stack+315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3645, 0.0, zero_stack,1);
     Libderiv->ABCD[142] = int_stack + 225;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4338,int_stack+405,int_stack+360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3537, 0.0, zero_stack, 1.0, int_stack+0,1);
     Libderiv->ABCD[131] = int_stack + 4338;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+315,int_stack+4473,int_stack+468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3645, 1.0, int_stack+0, 0.0, zero_stack,1);
     Libderiv->ABCD[130] = int_stack + 315;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+405,int_stack+4536,int_stack+513, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[129] = int_stack + 405;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4428,int_stack+603,int_stack+558, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3537, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3816,1);
     Libderiv->ABCD[119] = int_stack + 4428;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+495,int_stack+4599,int_stack+666, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3645, 0.0, zero_stack, 1.0, int_stack+3816, 0.0, zero_stack,1);
     Libderiv->ABCD[118] = int_stack + 495;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+585,int_stack+4662,int_stack+711, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+3816, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[117] = int_stack + 585;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4518,int_stack+801,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[116] = int_stack + 4518;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+675,int_stack+4725,int_stack+864, 0.0, zero_stack, 1.0, int_stack+3537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45,1);
     Libderiv->ABCD[107] = int_stack + 675;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+765,int_stack+4788,int_stack+909, 0.0, zero_stack, 1.0, int_stack+3645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45, 0.0, zero_stack,1);
     Libderiv->ABCD[106] = int_stack + 765;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+855,int_stack+4851,int_stack+954, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+45, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[105] = int_stack + 855;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4608,int_stack+1044,int_stack+999, 0.0, zero_stack, 1.0, int_stack+3816, 1.0, int_stack+45, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[104] = int_stack + 4608;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+945,int_stack+4914,int_stack+1107, 0.0, zero_stack, 2.0, int_stack+45, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[103] = int_stack + 945;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1035,int_stack+1197,int_stack+1152, 1.0, int_stack+3537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90,1);
     Libderiv->ABCD[95] = int_stack + 1035;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1125,int_stack+4977,int_stack+1260, 1.0, int_stack+3645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90, 0.0, zero_stack,1);
     Libderiv->ABCD[94] = int_stack + 1125;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1215,int_stack+1350,int_stack+1305, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[93] = int_stack + 1215;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1305,int_stack+1458,int_stack+1413, 1.0, int_stack+3816, 0.0, zero_stack, 1.0, int_stack+90, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[92] = int_stack + 1305;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1395,int_stack+1566,int_stack+1521, 1.0, int_stack+45, 1.0, int_stack+90, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[91] = int_stack + 1395;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+1674,int_stack+1629, 2.0, int_stack+90, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[90] = int_stack + 0;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1485,int_stack+1782,int_stack+1737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135,1);
     Libderiv->ABCD[47] = int_stack + 1485;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1575,int_stack+5040,int_stack+1845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135, 0.0, zero_stack,1);
     Libderiv->ABCD[46] = int_stack + 1575;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1665,int_stack+5103,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[45] = int_stack + 1665;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1755,int_stack+1980,int_stack+1935, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[44] = int_stack + 1755;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1845,int_stack+5166,int_stack+2043, 0.0, zero_stack, 1.0, int_stack+135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[43] = int_stack + 1845;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1935,int_stack+2133,int_stack+2088, 1.0, int_stack+135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[42] = int_stack + 1935;
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+90,int_stack+5229,int_stack+2196,1);
     Libderiv->ABCD[38] = int_stack + 90;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2025,int_stack+5292,int_stack+2241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4113,1);
     Libderiv->ABCD[35] = int_stack + 2025;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2115,int_stack+2331,int_stack+2286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4113, 0.0, zero_stack,1);
     Libderiv->ABCD[34] = int_stack + 2115;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2205,int_stack+5355,int_stack+2394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4113, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[33] = int_stack + 2205;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2295,int_stack+5418,int_stack+2439, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4113, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[32] = int_stack + 2295;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2385,int_stack+2529,int_stack+2484, 0.0, zero_stack, 1.0, int_stack+4113, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[31] = int_stack + 2385;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2475,int_stack+5481,int_stack+2592, 1.0, int_stack+4113, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[30] = int_stack + 2475;
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+4698,int_stack+2682,int_stack+2637,1);
     Libderiv->ABCD[26] = int_stack + 4698;
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2565,int_stack+5544,int_stack+2745,1);
     Libderiv->ABCD[25] = int_stack + 2565;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2655,int_stack+5607,int_stack+2790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180,1);
     Libderiv->ABCD[23] = int_stack + 2655;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2745,int_stack+2880,int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180, 0.0, zero_stack,1);
     Libderiv->ABCD[22] = int_stack + 2745;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2835,int_stack+5670,int_stack+2943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[21] = int_stack + 2835;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4788,int_stack+5733,int_stack+2988, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[20] = int_stack + 4788;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2925,int_stack+3078,int_stack+3033, 0.0, zero_stack, 1.0, int_stack+180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[19] = int_stack + 2925;
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3015,int_stack+5796,int_stack+3141, 1.0, int_stack+180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[18] = int_stack + 3015;
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+4878,int_stack+3231,int_stack+3186,1);
     Libderiv->ABCD[14] = int_stack + 4878;
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+3105,int_stack+5859,int_stack+3294,1);
     Libderiv->ABCD[13] = int_stack + 3105;
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+3195,int_stack+5922,int_stack+3339,1);
     Libderiv->ABCD[12] = int_stack + 3195;

}
