/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_g0fd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (g0|fd) integrals */

void d12hrr_order_g0fd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][5][11] = int_stack + 0;
 Libderiv->deriv_classes[4][5][10] = int_stack + 315;
 Libderiv->deriv_classes[4][5][9] = int_stack + 630;
 Libderiv->deriv_classes[4][5][8] = int_stack + 945;
 Libderiv->deriv_classes[4][5][7] = int_stack + 1260;
 Libderiv->dvrr_classes[4][4] = int_stack + 1575;
 Libderiv->deriv_classes[4][5][6] = int_stack + 1800;
 Libderiv->deriv_classes[4][5][2] = int_stack + 2115;
 Libderiv->deriv_classes[4][5][1] = int_stack + 2430;
 Libderiv->deriv_classes[4][5][0] = int_stack + 2745;
 Libderiv->deriv2_classes[4][3][143] = int_stack + 3060;
 Libderiv->deriv2_classes[4][4][143] = int_stack + 3210;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 3435;
 Libderiv->deriv2_classes[4][3][131] = int_stack + 3750;
 Libderiv->deriv2_classes[4][4][131] = int_stack + 3900;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 4125;
 Libderiv->deriv2_classes[4][3][130] = int_stack + 4440;
 Libderiv->deriv2_classes[4][4][130] = int_stack + 4590;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 4815;
 Libderiv->deriv2_classes[4][3][119] = int_stack + 5130;
 Libderiv->deriv2_classes[4][4][119] = int_stack + 5280;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 5505;
 Libderiv->deriv2_classes[4][3][118] = int_stack + 5820;
 Libderiv->deriv2_classes[4][4][118] = int_stack + 5970;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 6195;
 Libderiv->deriv2_classes[4][3][117] = int_stack + 6510;
 Libderiv->deriv2_classes[4][4][117] = int_stack + 6660;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 6885;
 Libderiv->deriv2_classes[4][3][107] = int_stack + 7200;
 Libderiv->deriv2_classes[4][4][107] = int_stack + 7350;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 7575;
 Libderiv->deriv2_classes[4][3][106] = int_stack + 7890;
 Libderiv->deriv2_classes[4][4][106] = int_stack + 8040;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 8265;
 Libderiv->deriv2_classes[4][3][105] = int_stack + 8580;
 Libderiv->deriv2_classes[4][4][105] = int_stack + 8730;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 8955;
 Libderiv->deriv2_classes[4][3][104] = int_stack + 9270;
 Libderiv->deriv2_classes[4][4][104] = int_stack + 9420;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 9645;
 Libderiv->deriv2_classes[4][3][95] = int_stack + 9960;
 Libderiv->deriv2_classes[4][4][95] = int_stack + 10110;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 10335;
 Libderiv->deriv2_classes[4][3][94] = int_stack + 10650;
 Libderiv->deriv2_classes[4][4][94] = int_stack + 10800;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 11025;
 Libderiv->deriv2_classes[4][3][93] = int_stack + 11340;
 Libderiv->deriv2_classes[4][4][93] = int_stack + 11490;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 11715;
 Libderiv->deriv2_classes[4][3][92] = int_stack + 12030;
 Libderiv->deriv2_classes[4][4][92] = int_stack + 12180;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 12405;
 Libderiv->deriv2_classes[4][3][91] = int_stack + 12720;
 Libderiv->deriv2_classes[4][4][91] = int_stack + 12870;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 13095;
 Libderiv->deriv_classes[4][3][11] = int_stack + 13410;
 Libderiv->deriv2_classes[4][3][83] = int_stack + 13560;
 Libderiv->deriv_classes[4][4][11] = int_stack + 13710;
 Libderiv->deriv2_classes[4][4][83] = int_stack + 13935;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 14160;
 Libderiv->deriv_classes[4][3][10] = int_stack + 14475;
 Libderiv->deriv2_classes[4][3][82] = int_stack + 14625;
 Libderiv->deriv_classes[4][4][10] = int_stack + 14775;
 Libderiv->deriv2_classes[4][4][82] = int_stack + 15000;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 15225;
 Libderiv->deriv_classes[4][3][9] = int_stack + 15540;
 Libderiv->deriv2_classes[4][3][81] = int_stack + 15690;
 Libderiv->deriv_classes[4][4][9] = int_stack + 15840;
 Libderiv->deriv2_classes[4][4][81] = int_stack + 16065;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 16290;
 Libderiv->deriv_classes[4][3][8] = int_stack + 16605;
 Libderiv->deriv2_classes[4][3][80] = int_stack + 16755;
 Libderiv->deriv_classes[4][4][8] = int_stack + 16905;
 Libderiv->deriv2_classes[4][4][80] = int_stack + 17130;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 17355;
 Libderiv->deriv_classes[4][3][7] = int_stack + 17670;
 Libderiv->deriv2_classes[4][3][79] = int_stack + 17820;
 Libderiv->deriv_classes[4][4][7] = int_stack + 17970;
 Libderiv->deriv2_classes[4][4][79] = int_stack + 18195;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 18420;
 Libderiv->dvrr_classes[4][3] = int_stack + 18735;
 Libderiv->deriv_classes[4][3][6] = int_stack + 18885;
 Libderiv->deriv2_classes[4][3][78] = int_stack + 19035;
 Libderiv->deriv_classes[4][4][6] = int_stack + 19185;
 Libderiv->deriv2_classes[4][4][78] = int_stack + 19410;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 19635;
 Libderiv->deriv2_classes[4][3][35] = int_stack + 19950;
 Libderiv->deriv2_classes[4][4][35] = int_stack + 20100;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 20325;
 Libderiv->deriv2_classes[4][3][34] = int_stack + 20640;
 Libderiv->deriv2_classes[4][4][34] = int_stack + 20790;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 21015;
 Libderiv->deriv2_classes[4][3][33] = int_stack + 21330;
 Libderiv->deriv2_classes[4][4][33] = int_stack + 21480;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 21705;
 Libderiv->deriv2_classes[4][3][32] = int_stack + 22020;
 Libderiv->deriv2_classes[4][4][32] = int_stack + 22170;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 22395;
 Libderiv->deriv2_classes[4][3][31] = int_stack + 22710;
 Libderiv->deriv2_classes[4][4][31] = int_stack + 22860;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 23085;
 Libderiv->deriv_classes[4][3][2] = int_stack + 23400;
 Libderiv->deriv2_classes[4][3][30] = int_stack + 23550;
 Libderiv->deriv_classes[4][4][2] = int_stack + 23700;
 Libderiv->deriv2_classes[4][4][30] = int_stack + 23925;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 24150;
 Libderiv->deriv2_classes[4][3][26] = int_stack + 24465;
 Libderiv->deriv2_classes[4][4][26] = int_stack + 24615;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 24840;
 Libderiv->deriv2_classes[4][3][23] = int_stack + 25155;
 Libderiv->deriv2_classes[4][4][23] = int_stack + 25305;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 25530;
 Libderiv->deriv2_classes[4][3][22] = int_stack + 25845;
 Libderiv->deriv2_classes[4][4][22] = int_stack + 25995;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 26220;
 Libderiv->deriv2_classes[4][3][21] = int_stack + 26535;
 Libderiv->deriv2_classes[4][4][21] = int_stack + 26685;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 26910;
 Libderiv->deriv2_classes[4][3][20] = int_stack + 27225;
 Libderiv->deriv2_classes[4][4][20] = int_stack + 27375;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 27600;
 Libderiv->deriv2_classes[4][3][19] = int_stack + 27915;
 Libderiv->deriv2_classes[4][4][19] = int_stack + 28065;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 28290;
 Libderiv->deriv_classes[4][3][1] = int_stack + 28605;
 Libderiv->deriv2_classes[4][3][18] = int_stack + 28755;
 Libderiv->deriv_classes[4][4][1] = int_stack + 28905;
 Libderiv->deriv2_classes[4][4][18] = int_stack + 29130;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 29355;
 Libderiv->deriv2_classes[4][3][14] = int_stack + 29670;
 Libderiv->deriv2_classes[4][4][14] = int_stack + 29820;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 30045;
 Libderiv->deriv2_classes[4][3][13] = int_stack + 30360;
 Libderiv->deriv2_classes[4][4][13] = int_stack + 30510;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 30735;
 Libderiv->deriv2_classes[4][3][11] = int_stack + 31050;
 Libderiv->deriv2_classes[4][4][11] = int_stack + 31200;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 31425;
 Libderiv->deriv2_classes[4][3][10] = int_stack + 31740;
 Libderiv->deriv2_classes[4][4][10] = int_stack + 31890;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 32115;
 Libderiv->deriv2_classes[4][3][9] = int_stack + 32430;
 Libderiv->deriv2_classes[4][4][9] = int_stack + 32580;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 32805;
 Libderiv->deriv2_classes[4][3][8] = int_stack + 33120;
 Libderiv->deriv2_classes[4][4][8] = int_stack + 33270;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 33495;
 Libderiv->deriv2_classes[4][3][7] = int_stack + 33810;
 Libderiv->deriv2_classes[4][4][7] = int_stack + 33960;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 34185;
 Libderiv->deriv_classes[4][3][0] = int_stack + 34500;
 Libderiv->deriv2_classes[4][3][6] = int_stack + 34650;
 Libderiv->deriv_classes[4][4][0] = int_stack + 34800;
 Libderiv->deriv2_classes[4][4][6] = int_stack + 35025;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 35250;
 Libderiv->deriv2_classes[4][3][2] = int_stack + 35565;
 Libderiv->deriv2_classes[4][4][2] = int_stack + 35715;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 35940;
 Libderiv->deriv2_classes[4][3][1] = int_stack + 36255;
 Libderiv->deriv2_classes[4][4][1] = int_stack + 36405;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 36630;
 Libderiv->deriv2_classes[4][3][0] = int_stack + 36945;
 Libderiv->deriv2_classes[4][4][0] = int_stack + 37095;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 37320;
 memset(int_stack,0,301080);

 Libderiv->dvrr_stack = int_stack + 65760;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_g0fd(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+37635,int_stack+1575,int_stack+18735,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+38085,int_stack+13710,int_stack+13410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18735,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38535,int_stack+0,int_stack+13710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+39210,int_stack+14775,int_stack+14475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18735, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+39660,int_stack+315,int_stack+14775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+0,int_stack+15840,int_stack+15540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18735, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+40335,int_stack+630,int_stack+15840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+450,int_stack+16905,int_stack+16605, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41010,int_stack+945,int_stack+16905, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+41685,int_stack+17970,int_stack+17670, 0.0, zero_stack, 1.0, int_stack+18735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42135,int_stack+1260,int_stack+17970, 0.0, zero_stack, 1.0, int_stack+1575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+900,int_stack+19185,int_stack+18885, 1.0, int_stack+18735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42810,int_stack+1800,int_stack+19185, 1.0, int_stack+1575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+1350,int_stack+23700,int_stack+23400,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+43485,int_stack+2115,int_stack+23700,15);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+1800,int_stack+28905,int_stack+28605,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+44160,int_stack+2430,int_stack+28905,15);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+2250,int_stack+34800,int_stack+34500,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+44835,int_stack+2745,int_stack+34800,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+45510,int_stack+3210,int_stack+3060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+13410,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+45960,int_stack+3435,int_stack+3210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+13710,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+2700,int_stack+3900,int_stack+3750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13410, 1.0, int_stack+14475,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3150,int_stack+4125,int_stack+3900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13710, 1.0, int_stack+14775,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+3825,int_stack+4590,int_stack+4440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+14475, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+46635,int_stack+4815,int_stack+4590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+14775, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+4275,int_stack+5280,int_stack+5130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13410, 0.0, zero_stack, 1.0, int_stack+15540,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+47310,int_stack+5505,int_stack+5280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13710, 0.0, zero_stack, 1.0, int_stack+15840,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+4725,int_stack+5970,int_stack+5820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14475, 1.0, int_stack+15540, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5175,int_stack+6195,int_stack+5970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14775, 1.0, int_stack+15840, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+5850,int_stack+6660,int_stack+6510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+15540, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+47985,int_stack+6885,int_stack+6660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+15840, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+6300,int_stack+7350,int_stack+7200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13410, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16605,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+48660,int_stack+7575,int_stack+7350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13710, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16905,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+6750,int_stack+8040,int_stack+7890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14475, 0.0, zero_stack, 1.0, int_stack+16605, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7200,int_stack+8265,int_stack+8040, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14775, 0.0, zero_stack, 1.0, int_stack+16905, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+7875,int_stack+8730,int_stack+8580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15540, 1.0, int_stack+16605, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+49335,int_stack+8955,int_stack+8730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15840, 1.0, int_stack+16905, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8325,int_stack+9420,int_stack+9270, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+16605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+50010,int_stack+9645,int_stack+9420, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+16905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8775,int_stack+10110,int_stack+9960, 0.0, zero_stack, 1.0, int_stack+13410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17670,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9225,int_stack+10335,int_stack+10110, 0.0, zero_stack, 1.0, int_stack+13710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17970,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+9900,int_stack+10800,int_stack+10650, 0.0, zero_stack, 1.0, int_stack+14475, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17670, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+50685,int_stack+11025,int_stack+10800, 0.0, zero_stack, 1.0, int_stack+14775, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17970, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+10350,int_stack+11490,int_stack+11340, 0.0, zero_stack, 1.0, int_stack+15540, 0.0, zero_stack, 1.0, int_stack+17670, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+10800,int_stack+11715,int_stack+11490, 0.0, zero_stack, 1.0, int_stack+15840, 0.0, zero_stack, 1.0, int_stack+17970, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+11475,int_stack+12180,int_stack+12030, 0.0, zero_stack, 1.0, int_stack+16605, 1.0, int_stack+17670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+51360,int_stack+12405,int_stack+12180, 0.0, zero_stack, 1.0, int_stack+16905, 1.0, int_stack+17970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+11925,int_stack+12870,int_stack+12720, 0.0, zero_stack, 2.0, int_stack+17670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+52035,int_stack+13095,int_stack+12870, 0.0, zero_stack, 2.0, int_stack+17970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+12375,int_stack+13935,int_stack+13560, 1.0, int_stack+13410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18885,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12825,int_stack+14160,int_stack+13935, 1.0, int_stack+13710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19185,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+13500,int_stack+15000,int_stack+14625, 1.0, int_stack+14475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18885, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+13950,int_stack+15225,int_stack+15000, 1.0, int_stack+14775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19185, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+14625,int_stack+16065,int_stack+15690, 1.0, int_stack+15540, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18885, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15075,int_stack+16290,int_stack+16065, 1.0, int_stack+15840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19185, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+15750,int_stack+17130,int_stack+16755, 1.0, int_stack+16605, 0.0, zero_stack, 1.0, int_stack+18885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+16200,int_stack+17355,int_stack+17130, 1.0, int_stack+16905, 0.0, zero_stack, 1.0, int_stack+19185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+16875,int_stack+18195,int_stack+17820, 1.0, int_stack+17670, 1.0, int_stack+18885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+52710,int_stack+18420,int_stack+18195, 1.0, int_stack+17970, 1.0, int_stack+19185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+17325,int_stack+19410,int_stack+19035, 2.0, int_stack+18885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+17775,int_stack+19635,int_stack+19410, 2.0, int_stack+19185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+18450,int_stack+20100,int_stack+19950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23400,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+18900,int_stack+20325,int_stack+20100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23700,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+19575,int_stack+20790,int_stack+20640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23400, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+20025,int_stack+21015,int_stack+20790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23700, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+20700,int_stack+21480,int_stack+21330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23400, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+53385,int_stack+21705,int_stack+21480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23700, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+21150,int_stack+22170,int_stack+22020, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+54060,int_stack+22395,int_stack+22170, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+21600,int_stack+22860,int_stack+22710, 0.0, zero_stack, 1.0, int_stack+23400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+22050,int_stack+23085,int_stack+22860, 0.0, zero_stack, 1.0, int_stack+23700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+22725,int_stack+23925,int_stack+23550, 1.0, int_stack+23400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+54735,int_stack+24150,int_stack+23925, 1.0, int_stack+23700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+23175,int_stack+24615,int_stack+24465,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+23625,int_stack+24840,int_stack+24615,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+24300,int_stack+25305,int_stack+25155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28605,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+55410,int_stack+25530,int_stack+25305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28905,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+24750,int_stack+25995,int_stack+25845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28605, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+25200,int_stack+26220,int_stack+25995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28905, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+25875,int_stack+26685,int_stack+26535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28605, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+56085,int_stack+26910,int_stack+26685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28905, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26325,int_stack+27375,int_stack+27225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+56760,int_stack+27600,int_stack+27375, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26775,int_stack+28065,int_stack+27915, 0.0, zero_stack, 1.0, int_stack+28605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+27225,int_stack+28290,int_stack+28065, 0.0, zero_stack, 1.0, int_stack+28905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+27900,int_stack+29130,int_stack+28755, 1.0, int_stack+28605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+57435,int_stack+29355,int_stack+29130, 1.0, int_stack+28905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+28350,int_stack+29820,int_stack+29670,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+28800,int_stack+30045,int_stack+29820,15);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+29475,int_stack+30510,int_stack+30360,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+58110,int_stack+30735,int_stack+30510,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+29925,int_stack+31200,int_stack+31050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34500,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+30375,int_stack+31425,int_stack+31200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34800,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+31050,int_stack+31890,int_stack+31740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34500, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+58785,int_stack+32115,int_stack+31890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34800, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+31500,int_stack+32580,int_stack+32430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34500, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+59460,int_stack+32805,int_stack+32580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34800, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+31950,int_stack+33270,int_stack+33120, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+32400,int_stack+33495,int_stack+33270, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+33075,int_stack+33960,int_stack+33810, 0.0, zero_stack, 1.0, int_stack+34500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+60135,int_stack+34185,int_stack+33960, 0.0, zero_stack, 1.0, int_stack+34800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+33525,int_stack+35025,int_stack+34650, 1.0, int_stack+34500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+33975,int_stack+35250,int_stack+35025, 1.0, int_stack+34800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+34650,int_stack+35715,int_stack+35565,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+60810,int_stack+35940,int_stack+35715,15);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+35100,int_stack+36405,int_stack+36255,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+35550,int_stack+36630,int_stack+36405,15);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+36225,int_stack+37095,int_stack+36945,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+61485,int_stack+37320,int_stack+37095,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+36675,int_stack+38535,int_stack+38085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37635,15);
     Libderiv->ABCD[11] = int_stack + 36675;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+62160,int_stack+39660,int_stack+39210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37635, 0.0, zero_stack,15);
     Libderiv->ABCD[10] = int_stack + 62160;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+63060,int_stack+40335,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37635, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[9] = int_stack + 63060;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+39660,int_stack+41010,int_stack+450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[8] = int_stack + 39660;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+40560,int_stack+42135,int_stack+41685, 0.0, zero_stack, 1.0, int_stack+37635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[7] = int_stack + 40560;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+63960,int_stack+42810,int_stack+900, 1.0, int_stack+37635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[6] = int_stack + 63960;
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+42135,int_stack+43485,int_stack+1350,15);
     Libderiv->ABCD[2] = int_stack + 42135;
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+43035,int_stack+44160,int_stack+1800,15);
     Libderiv->ABCD[1] = int_stack + 43035;
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+43935,int_stack+44835,int_stack+2250,15);
     Libderiv->ABCD[0] = int_stack + 43935;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+64860,int_stack+45960,int_stack+45510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+38085,15);
     Libderiv->ABCD[155] = int_stack + 64860;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+44835,int_stack+3150,int_stack+2700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38085, 1.0, int_stack+39210,15);
     Libderiv->ABCD[143] = int_stack + 44835;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+45735,int_stack+46635,int_stack+3825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+39210, 0.0, zero_stack,15);
     Libderiv->ABCD[142] = int_stack + 45735;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+2700,int_stack+47310,int_stack+4275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38085, 0.0, zero_stack, 1.0, int_stack+0,15);
     Libderiv->ABCD[131] = int_stack + 2700;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+46635,int_stack+5175,int_stack+4725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39210, 1.0, int_stack+0, 0.0, zero_stack,15);
     Libderiv->ABCD[130] = int_stack + 46635;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+3600,int_stack+47985,int_stack+5850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[129] = int_stack + 3600;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+47535,int_stack+48660,int_stack+6300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38085, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450,15);
     Libderiv->ABCD[119] = int_stack + 47535;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+48435,int_stack+7200,int_stack+6750, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39210, 0.0, zero_stack, 1.0, int_stack+450, 0.0, zero_stack,15);
     Libderiv->ABCD[118] = int_stack + 48435;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+4500,int_stack+49335,int_stack+7875, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+450, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[117] = int_stack + 4500;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+5400,int_stack+50010,int_stack+8325, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[116] = int_stack + 5400;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+49335,int_stack+9225,int_stack+8775, 0.0, zero_stack, 1.0, int_stack+38085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41685,15);
     Libderiv->ABCD[107] = int_stack + 49335;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+6300,int_stack+50685,int_stack+9900, 0.0, zero_stack, 1.0, int_stack+39210, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41685, 0.0, zero_stack,15);
     Libderiv->ABCD[106] = int_stack + 6300;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+50235,int_stack+10800,int_stack+10350, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+41685, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[105] = int_stack + 50235;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+7200,int_stack+51360,int_stack+11475, 0.0, zero_stack, 1.0, int_stack+450, 1.0, int_stack+41685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[104] = int_stack + 7200;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+51135,int_stack+52035,int_stack+11925, 0.0, zero_stack, 2.0, int_stack+41685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[103] = int_stack + 51135;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+8100,int_stack+12825,int_stack+12375, 1.0, int_stack+38085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+900,15);
     Libderiv->ABCD[95] = int_stack + 8100;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+9000,int_stack+13950,int_stack+13500, 1.0, int_stack+39210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+900, 0.0, zero_stack,15);
     Libderiv->ABCD[94] = int_stack + 9000;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+9900,int_stack+15075,int_stack+14625, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+900, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[93] = int_stack + 9900;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+10800,int_stack+16200,int_stack+15750, 1.0, int_stack+450, 0.0, zero_stack, 1.0, int_stack+900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[92] = int_stack + 10800;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+0,int_stack+52710,int_stack+16875, 1.0, int_stack+41685, 1.0, int_stack+900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[91] = int_stack + 0;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+52035,int_stack+17775,int_stack+17325, 2.0, int_stack+900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[90] = int_stack + 52035;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+11700,int_stack+18900,int_stack+18450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350,15);
     Libderiv->ABCD[47] = int_stack + 11700;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+12600,int_stack+20025,int_stack+19575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack,15);
     Libderiv->ABCD[46] = int_stack + 12600;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+13500,int_stack+53385,int_stack+20700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[45] = int_stack + 13500;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+52935,int_stack+54060,int_stack+21150, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[44] = int_stack + 52935;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+53835,int_stack+22050,int_stack+21600, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[43] = int_stack + 53835;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+14400,int_stack+54735,int_stack+22725, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[42] = int_stack + 14400;
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+900,int_stack+23625,int_stack+23175,15);
     Libderiv->ABCD[38] = int_stack + 900;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+15300,int_stack+55410,int_stack+24300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1800,15);
     Libderiv->ABCD[35] = int_stack + 15300;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+54735,int_stack+25200,int_stack+24750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1800, 0.0, zero_stack,15);
     Libderiv->ABCD[34] = int_stack + 54735;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+16200,int_stack+56085,int_stack+25875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1800, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[33] = int_stack + 16200;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+55635,int_stack+56760,int_stack+26325, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[32] = int_stack + 55635;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+56535,int_stack+27225,int_stack+26775, 0.0, zero_stack, 1.0, int_stack+1800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[31] = int_stack + 56535;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+17100,int_stack+57435,int_stack+27900, 1.0, int_stack+1800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[30] = int_stack + 17100;
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+18000,int_stack+28800,int_stack+28350,15);
     Libderiv->ABCD[26] = int_stack + 18000;
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+18900,int_stack+58110,int_stack+29475,15);
     Libderiv->ABCD[25] = int_stack + 18900;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+57435,int_stack+30375,int_stack+29925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2250,15);
     Libderiv->ABCD[23] = int_stack + 57435;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+19800,int_stack+58785,int_stack+31050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2250, 0.0, zero_stack,15);
     Libderiv->ABCD[22] = int_stack + 19800;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+58335,int_stack+59460,int_stack+31500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2250, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[21] = int_stack + 58335;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+59235,int_stack+32400,int_stack+31950, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[20] = int_stack + 59235;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+20700,int_stack+60135,int_stack+33075, 0.0, zero_stack, 1.0, int_stack+2250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[19] = int_stack + 20700;
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+21600,int_stack+33975,int_stack+33525, 1.0, int_stack+2250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[18] = int_stack + 21600;
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+1800,int_stack+60810,int_stack+34650,15);
     Libderiv->ABCD[14] = int_stack + 1800;
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+60135,int_stack+35550,int_stack+35100,15);
     Libderiv->ABCD[13] = int_stack + 60135;
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+22500,int_stack+61485,int_stack+36225,15);
     Libderiv->ABCD[12] = int_stack + 22500;

}
