/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_p0h0(Libderiv_t *, prim_data *);

  /* Computes derivatives of (p0|h0) integrals */

void d12hrr_order_p0h0(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[1][5][11] = int_stack + 0;
 Libderiv->deriv_classes[1][5][10] = int_stack + 63;
 Libderiv->deriv_classes[1][5][9] = int_stack + 126;
 Libderiv->deriv_classes[1][5][8] = int_stack + 189;
 Libderiv->deriv_classes[1][5][7] = int_stack + 252;
 Libderiv->deriv_classes[1][5][6] = int_stack + 315;
 Libderiv->deriv_classes[1][5][2] = int_stack + 378;
 Libderiv->deriv_classes[1][5][1] = int_stack + 441;
 Libderiv->deriv_classes[1][5][0] = int_stack + 504;
 Libderiv->deriv2_classes[1][5][143] = int_stack + 567;
 Libderiv->deriv2_classes[1][5][131] = int_stack + 630;
 Libderiv->deriv2_classes[1][5][130] = int_stack + 693;
 Libderiv->deriv2_classes[1][5][119] = int_stack + 756;
 Libderiv->deriv2_classes[1][5][118] = int_stack + 819;
 Libderiv->deriv2_classes[1][5][117] = int_stack + 882;
 Libderiv->deriv2_classes[1][5][107] = int_stack + 945;
 Libderiv->deriv2_classes[1][5][106] = int_stack + 1008;
 Libderiv->deriv2_classes[1][5][105] = int_stack + 1071;
 Libderiv->deriv2_classes[1][5][104] = int_stack + 1134;
 Libderiv->deriv2_classes[1][5][95] = int_stack + 1197;
 Libderiv->deriv2_classes[1][5][94] = int_stack + 1260;
 Libderiv->deriv2_classes[1][5][93] = int_stack + 1323;
 Libderiv->deriv2_classes[1][5][92] = int_stack + 1386;
 Libderiv->deriv2_classes[1][5][91] = int_stack + 1449;
 Libderiv->deriv2_classes[1][5][83] = int_stack + 1512;
 Libderiv->deriv2_classes[1][5][82] = int_stack + 1575;
 Libderiv->deriv2_classes[1][5][81] = int_stack + 1638;
 Libderiv->deriv2_classes[1][5][80] = int_stack + 1701;
 Libderiv->deriv2_classes[1][5][79] = int_stack + 1764;
 Libderiv->deriv2_classes[1][5][78] = int_stack + 1827;
 Libderiv->deriv2_classes[1][5][35] = int_stack + 1890;
 Libderiv->deriv2_classes[1][5][34] = int_stack + 1953;
 Libderiv->deriv2_classes[1][5][33] = int_stack + 2016;
 Libderiv->deriv2_classes[1][5][32] = int_stack + 2079;
 Libderiv->deriv2_classes[1][5][31] = int_stack + 2142;
 Libderiv->deriv2_classes[1][5][30] = int_stack + 2205;
 Libderiv->deriv2_classes[1][5][26] = int_stack + 2268;
 Libderiv->deriv2_classes[1][5][23] = int_stack + 2331;
 Libderiv->deriv2_classes[1][5][22] = int_stack + 2394;
 Libderiv->deriv2_classes[1][5][21] = int_stack + 2457;
 Libderiv->deriv2_classes[1][5][20] = int_stack + 2520;
 Libderiv->deriv2_classes[1][5][19] = int_stack + 2583;
 Libderiv->deriv2_classes[1][5][18] = int_stack + 2646;
 Libderiv->deriv2_classes[1][5][14] = int_stack + 2709;
 Libderiv->deriv2_classes[1][5][13] = int_stack + 2772;
 Libderiv->deriv2_classes[1][5][11] = int_stack + 2835;
 Libderiv->deriv2_classes[1][5][10] = int_stack + 2898;
 Libderiv->deriv2_classes[1][5][9] = int_stack + 2961;
 Libderiv->deriv2_classes[1][5][8] = int_stack + 3024;
 Libderiv->deriv2_classes[1][5][7] = int_stack + 3087;
 Libderiv->deriv2_classes[1][5][6] = int_stack + 3150;
 Libderiv->deriv2_classes[1][5][2] = int_stack + 3213;
 Libderiv->deriv2_classes[1][5][1] = int_stack + 3276;
 Libderiv->deriv2_classes[1][5][0] = int_stack + 3339;
 memset(int_stack,0,27216);

 Libderiv->dvrr_stack = int_stack + 3402;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_p0h0(Libderiv, Data);
   Data++;
 }

 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[11] = int_stack + 0;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[10] = int_stack + 63;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[9] = int_stack + 126;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[8] = int_stack + 189;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[7] = int_stack + 252;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[6] = int_stack + 315;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[2] = int_stack + 378;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[1] = int_stack + 441;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[0] = int_stack + 504;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[155] = int_stack + 567;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[143] = int_stack + 630;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[142] = int_stack + 693;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[131] = int_stack + 756;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[130] = int_stack + 819;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[129] = int_stack + 882;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[119] = int_stack + 945;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[118] = int_stack + 1008;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[117] = int_stack + 1071;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[116] = int_stack + 1134;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[107] = int_stack + 1197;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[106] = int_stack + 1260;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[105] = int_stack + 1323;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[104] = int_stack + 1386;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[103] = int_stack + 1449;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[95] = int_stack + 1512;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[94] = int_stack + 1575;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[93] = int_stack + 1638;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[92] = int_stack + 1701;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[91] = int_stack + 1764;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[90] = int_stack + 1827;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[47] = int_stack + 1890;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[46] = int_stack + 1953;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[45] = int_stack + 2016;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[44] = int_stack + 2079;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[43] = int_stack + 2142;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[42] = int_stack + 2205;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[38] = int_stack + 2268;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[35] = int_stack + 2331;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[34] = int_stack + 2394;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[33] = int_stack + 2457;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[32] = int_stack + 2520;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[31] = int_stack + 2583;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[30] = int_stack + 2646;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[26] = int_stack + 2709;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[25] = int_stack + 2772;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[23] = int_stack + 2835;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[22] = int_stack + 2898;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[21] = int_stack + 2961;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[20] = int_stack + 3024;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[19] = int_stack + 3087;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[18] = int_stack + 3150;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[14] = int_stack + 3213;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[13] = int_stack + 3276;
 /*--- compute (p0|h0) ---*/
     Libderiv->ABCD[12] = int_stack + 3339;

}
