/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_00ip(Libderiv_t *, prim_data *);

  /* Computes derivatives of (00|ip) integrals */

void d1hrr_order_00ip(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[0][6][11] = int_stack + 0;
 Libderiv->deriv_classes[0][7][11] = int_stack + 28;
 Libderiv->deriv_classes[0][6][10] = int_stack + 64;
 Libderiv->deriv_classes[0][7][10] = int_stack + 92;
 Libderiv->deriv_classes[0][6][9] = int_stack + 128;
 Libderiv->deriv_classes[0][7][9] = int_stack + 156;
 Libderiv->deriv_classes[0][6][8] = int_stack + 192;
 Libderiv->deriv_classes[0][7][8] = int_stack + 220;
 Libderiv->deriv_classes[0][6][7] = int_stack + 256;
 Libderiv->deriv_classes[0][7][7] = int_stack + 284;
 Libderiv->dvrr_classes[0][6] = int_stack + 320;
 Libderiv->deriv_classes[0][6][6] = int_stack + 348;
 Libderiv->deriv_classes[0][7][6] = int_stack + 376;
 Libderiv->deriv_classes[0][6][2] = int_stack + 412;
 Libderiv->deriv_classes[0][7][2] = int_stack + 440;
 Libderiv->deriv_classes[0][6][1] = int_stack + 476;
 Libderiv->deriv_classes[0][7][1] = int_stack + 504;
 Libderiv->deriv_classes[0][6][0] = int_stack + 540;
 Libderiv->deriv_classes[0][7][0] = int_stack + 568;
 memset(int_stack,0,4832);

 Libderiv->dvrr_stack = int_stack + 856;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_00ip(Libderiv, Data);
   Data++;
 }

 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+604,int_stack+28,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320,1);
     Libderiv->ABCD[11] = int_stack + 604;
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+688,int_stack+92,int_stack+64, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320, 0.0, zero_stack,1);
     Libderiv->ABCD[10] = int_stack + 688;
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+156,int_stack+128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[9] = int_stack + 0;
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84,int_stack+220,int_stack+192, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[8] = int_stack + 84;
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+168,int_stack+284,int_stack+256, 0.0, zero_stack, 1.0, int_stack+320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[7] = int_stack + 168;
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+772,int_stack+376,int_stack+348, 1.0, int_stack+320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[6] = int_stack + 772;
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+252,int_stack+440,int_stack+412,1);
     Libderiv->ABCD[2] = int_stack + 252;
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+336,int_stack+504,int_stack+476,1);
     Libderiv->ABCD[1] = int_stack + 336;
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+420,int_stack+568,int_stack+540,1);
     Libderiv->ABCD[0] = int_stack + 420;

}
