/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_d0hf(Libderiv_t *, prim_data *);

  /* Computes derivatives of (d0|hf) integrals */

void d1hrr_order_d0hf(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][5][11] = int_stack + 0;
 Libderiv->deriv_classes[2][6][11] = int_stack + 126;
 Libderiv->deriv_classes[2][7][11] = int_stack + 294;
 Libderiv->deriv_classes[2][8][11] = int_stack + 510;
 Libderiv->deriv_classes[2][5][10] = int_stack + 780;
 Libderiv->deriv_classes[2][6][10] = int_stack + 906;
 Libderiv->deriv_classes[2][7][10] = int_stack + 1074;
 Libderiv->deriv_classes[2][8][10] = int_stack + 1290;
 Libderiv->deriv_classes[2][5][9] = int_stack + 1560;
 Libderiv->deriv_classes[2][6][9] = int_stack + 1686;
 Libderiv->deriv_classes[2][7][9] = int_stack + 1854;
 Libderiv->deriv_classes[2][8][9] = int_stack + 2070;
 Libderiv->deriv_classes[2][5][8] = int_stack + 2340;
 Libderiv->deriv_classes[2][6][8] = int_stack + 2466;
 Libderiv->deriv_classes[2][7][8] = int_stack + 2634;
 Libderiv->deriv_classes[2][8][8] = int_stack + 2850;
 Libderiv->deriv_classes[2][5][7] = int_stack + 3120;
 Libderiv->deriv_classes[2][6][7] = int_stack + 3246;
 Libderiv->deriv_classes[2][7][7] = int_stack + 3414;
 Libderiv->deriv_classes[2][8][7] = int_stack + 3630;
 Libderiv->dvrr_classes[2][5] = int_stack + 3900;
 Libderiv->deriv_classes[2][5][6] = int_stack + 4026;
 Libderiv->dvrr_classes[2][6] = int_stack + 4152;
 Libderiv->deriv_classes[2][6][6] = int_stack + 4320;
 Libderiv->dvrr_classes[2][7] = int_stack + 4488;
 Libderiv->deriv_classes[2][7][6] = int_stack + 4704;
 Libderiv->deriv_classes[2][8][6] = int_stack + 4920;
 Libderiv->deriv_classes[2][5][2] = int_stack + 5190;
 Libderiv->deriv_classes[2][6][2] = int_stack + 5316;
 Libderiv->deriv_classes[2][7][2] = int_stack + 5484;
 Libderiv->deriv_classes[2][8][2] = int_stack + 5700;
 Libderiv->deriv_classes[2][5][1] = int_stack + 5970;
 Libderiv->deriv_classes[2][6][1] = int_stack + 6096;
 Libderiv->deriv_classes[2][7][1] = int_stack + 6264;
 Libderiv->deriv_classes[2][8][1] = int_stack + 6480;
 Libderiv->deriv_classes[2][5][0] = int_stack + 6750;
 Libderiv->deriv_classes[2][6][0] = int_stack + 6876;
 Libderiv->deriv_classes[2][7][0] = int_stack + 7044;
 Libderiv->deriv_classes[2][8][0] = int_stack + 7260;
 memset(int_stack,0,60240);

 Libderiv->dvrr_stack = int_stack + 20526;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_d0hf(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+7530,int_stack+4152,int_stack+3900,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7908,int_stack+4488,int_stack+4152,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+8412,int_stack+7908,int_stack+7530,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9168,int_stack+126,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3900,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9546,int_stack+294,int_stack+126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4152,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10050,int_stack+9546,int_stack+9168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7530,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10806,int_stack+510,int_stack+294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4488,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+11454,int_stack+10806,int_stack+9546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7908,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10806,int_stack+906,int_stack+780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3900, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9168,int_stack+1074,int_stack+906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4152, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+9168,int_stack+10806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7530, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10806,int_stack+1290,int_stack+1074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4488, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12462,int_stack+10806,int_stack+9168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7908, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9168,int_stack+1686,int_stack+1560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3900, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9546,int_stack+1854,int_stack+1686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4152, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+756,int_stack+9546,int_stack+9168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7530, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10806,int_stack+2070,int_stack+1854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4488, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13470,int_stack+10806,int_stack+9546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7908, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10806,int_stack+2466,int_stack+2340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9168,int_stack+2634,int_stack+2466, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1512,int_stack+9168,int_stack+10806, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10806,int_stack+2850,int_stack+2634, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14478,int_stack+10806,int_stack+9168, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9168,int_stack+3246,int_stack+3120, 0.0, zero_stack, 1.0, int_stack+3900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9546,int_stack+3414,int_stack+3246, 0.0, zero_stack, 1.0, int_stack+4152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2268,int_stack+9546,int_stack+9168, 0.0, zero_stack, 1.0, int_stack+7530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10806,int_stack+3630,int_stack+3414, 0.0, zero_stack, 1.0, int_stack+4488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15486,int_stack+10806,int_stack+9546, 0.0, zero_stack, 1.0, int_stack+7908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10806,int_stack+4320,int_stack+4026, 1.0, int_stack+3900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9168,int_stack+4704,int_stack+4320, 1.0, int_stack+4152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3024,int_stack+9168,int_stack+10806, 1.0, int_stack+7530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10806,int_stack+4920,int_stack+4704, 1.0, int_stack+4488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3780,int_stack+10806,int_stack+9168, 1.0, int_stack+7908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+9168,int_stack+5316,int_stack+5190,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+9546,int_stack+5484,int_stack+5316,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+7530,int_stack+9546,int_stack+9168,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+10806,int_stack+5700,int_stack+5484,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4788,int_stack+10806,int_stack+9546,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+10806,int_stack+6096,int_stack+5970,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+9168,int_stack+6264,int_stack+6096,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+16494,int_stack+9168,int_stack+10806,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+10806,int_stack+6480,int_stack+6264,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+17250,int_stack+10806,int_stack+9168,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+9168,int_stack+6876,int_stack+6750,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+9546,int_stack+7044,int_stack+6876,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5796,int_stack+9546,int_stack+9168,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+10806,int_stack+7260,int_stack+7044,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+18258,int_stack+10806,int_stack+9546,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+19266,int_stack+11454,int_stack+10050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8412,6);
     Libderiv->ABCD[11] = int_stack + 19266;
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9168,int_stack+12462,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8412, 0.0, zero_stack,6);
     Libderiv->ABCD[10] = int_stack + 9168;
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+10428,int_stack+13470,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8412, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[9] = int_stack + 10428;
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+14478,int_stack+1512, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+11688,int_stack+15486,int_stack+2268, 0.0, zero_stack, 1.0, int_stack+8412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[7] = int_stack + 11688;
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1260,int_stack+3780,int_stack+3024, 1.0, int_stack+8412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[6] = int_stack + 1260;
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2520,int_stack+4788,int_stack+7530,6);
     Libderiv->ABCD[2] = int_stack + 2520;
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+3780,int_stack+17250,int_stack+16494,6);
     Libderiv->ABCD[1] = int_stack + 3780;
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+12948,int_stack+18258,int_stack+5796,6);
     Libderiv->ABCD[0] = int_stack + 12948;

}
