/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_f0hp(Libderiv_t *, prim_data *);

  /* Computes derivatives of (f0|hp) integrals */

void d1hrr_order_f0hp(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[3][5][11] = int_stack + 0;
 Libderiv->deriv_classes[3][6][11] = int_stack + 210;
 Libderiv->deriv_classes[3][5][10] = int_stack + 490;
 Libderiv->deriv_classes[3][6][10] = int_stack + 700;
 Libderiv->deriv_classes[3][5][9] = int_stack + 980;
 Libderiv->deriv_classes[3][6][9] = int_stack + 1190;
 Libderiv->deriv_classes[3][5][8] = int_stack + 1470;
 Libderiv->deriv_classes[3][6][8] = int_stack + 1680;
 Libderiv->deriv_classes[3][5][7] = int_stack + 1960;
 Libderiv->deriv_classes[3][6][7] = int_stack + 2170;
 Libderiv->dvrr_classes[3][5] = int_stack + 2450;
 Libderiv->deriv_classes[3][5][6] = int_stack + 2660;
 Libderiv->deriv_classes[3][6][6] = int_stack + 2870;
 Libderiv->deriv_classes[3][5][2] = int_stack + 3150;
 Libderiv->deriv_classes[3][6][2] = int_stack + 3360;
 Libderiv->deriv_classes[3][5][1] = int_stack + 3640;
 Libderiv->deriv_classes[3][6][1] = int_stack + 3850;
 Libderiv->deriv_classes[3][5][0] = int_stack + 4130;
 Libderiv->deriv_classes[3][6][0] = int_stack + 4340;
 memset(int_stack,0,36960);

 Libderiv->dvrr_stack = int_stack + 6510;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_f0hp(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4620,int_stack+210,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2450,10);
     Libderiv->ABCD[11] = int_stack + 4620;
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5250,int_stack+700,int_stack+490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2450, 0.0, zero_stack,10);
     Libderiv->ABCD[10] = int_stack + 5250;
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+1190,int_stack+980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2450, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[9] = int_stack + 0;
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+630,int_stack+1680,int_stack+1470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[8] = int_stack + 630;
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1260,int_stack+2170,int_stack+1960, 0.0, zero_stack, 1.0, int_stack+2450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[7] = int_stack + 1260;
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5880,int_stack+2870,int_stack+2660, 1.0, int_stack+2450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[6] = int_stack + 5880;
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+3360,int_stack+3150,10);
     Libderiv->ABCD[2] = int_stack + 1890;
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2520,int_stack+3850,int_stack+3640,10);
     Libderiv->ABCD[1] = int_stack + 2520;
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3150,int_stack+4340,int_stack+4130,10);
     Libderiv->ABCD[0] = int_stack + 3150;

}
