/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_ffid(Libderiv_t *, prim_data *);

  /* Computes derivatives of (ff|id) integrals */

void d1hrr_order_ffid(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[3][6][11] = int_stack + 0;
 Libderiv->deriv_classes[3][7][11] = int_stack + 280;
 Libderiv->deriv_classes[3][8][11] = int_stack + 640;
 Libderiv->deriv_classes[4][6][11] = int_stack + 1090;
 Libderiv->deriv_classes[4][7][11] = int_stack + 1510;
 Libderiv->deriv_classes[4][8][11] = int_stack + 2050;
 Libderiv->deriv_classes[5][6][11] = int_stack + 2725;
 Libderiv->deriv_classes[5][7][11] = int_stack + 3313;
 Libderiv->deriv_classes[5][8][11] = int_stack + 4069;
 Libderiv->deriv_classes[6][6][11] = int_stack + 5014;
 Libderiv->deriv_classes[6][7][11] = int_stack + 5798;
 Libderiv->deriv_classes[6][8][11] = int_stack + 6806;
 Libderiv->deriv_classes[3][6][10] = int_stack + 8066;
 Libderiv->deriv_classes[3][7][10] = int_stack + 8346;
 Libderiv->deriv_classes[3][8][10] = int_stack + 8706;
 Libderiv->deriv_classes[4][6][10] = int_stack + 9156;
 Libderiv->deriv_classes[4][7][10] = int_stack + 9576;
 Libderiv->deriv_classes[4][8][10] = int_stack + 10116;
 Libderiv->deriv_classes[5][6][10] = int_stack + 10791;
 Libderiv->deriv_classes[5][7][10] = int_stack + 11379;
 Libderiv->deriv_classes[5][8][10] = int_stack + 12135;
 Libderiv->deriv_classes[6][6][10] = int_stack + 13080;
 Libderiv->deriv_classes[6][7][10] = int_stack + 13864;
 Libderiv->deriv_classes[6][8][10] = int_stack + 14872;
 Libderiv->deriv_classes[3][6][9] = int_stack + 16132;
 Libderiv->deriv_classes[3][7][9] = int_stack + 16412;
 Libderiv->deriv_classes[3][8][9] = int_stack + 16772;
 Libderiv->deriv_classes[4][6][9] = int_stack + 17222;
 Libderiv->deriv_classes[4][7][9] = int_stack + 17642;
 Libderiv->deriv_classes[4][8][9] = int_stack + 18182;
 Libderiv->deriv_classes[5][6][9] = int_stack + 18857;
 Libderiv->deriv_classes[5][7][9] = int_stack + 19445;
 Libderiv->deriv_classes[5][8][9] = int_stack + 20201;
 Libderiv->deriv_classes[6][6][9] = int_stack + 21146;
 Libderiv->deriv_classes[6][7][9] = int_stack + 21930;
 Libderiv->deriv_classes[6][8][9] = int_stack + 22938;
 Libderiv->deriv_classes[3][6][8] = int_stack + 24198;
 Libderiv->deriv_classes[3][7][8] = int_stack + 24478;
 Libderiv->deriv_classes[3][8][8] = int_stack + 24838;
 Libderiv->deriv_classes[4][6][8] = int_stack + 25288;
 Libderiv->deriv_classes[4][7][8] = int_stack + 25708;
 Libderiv->deriv_classes[4][8][8] = int_stack + 26248;
 Libderiv->deriv_classes[5][6][8] = int_stack + 26923;
 Libderiv->deriv_classes[5][7][8] = int_stack + 27511;
 Libderiv->deriv_classes[5][8][8] = int_stack + 28267;
 Libderiv->deriv_classes[6][6][8] = int_stack + 29212;
 Libderiv->deriv_classes[6][7][8] = int_stack + 29996;
 Libderiv->deriv_classes[6][8][8] = int_stack + 31004;
 Libderiv->deriv_classes[3][6][7] = int_stack + 32264;
 Libderiv->deriv_classes[3][7][7] = int_stack + 32544;
 Libderiv->deriv_classes[3][8][7] = int_stack + 32904;
 Libderiv->deriv_classes[4][6][7] = int_stack + 33354;
 Libderiv->deriv_classes[4][7][7] = int_stack + 33774;
 Libderiv->deriv_classes[4][8][7] = int_stack + 34314;
 Libderiv->deriv_classes[5][6][7] = int_stack + 34989;
 Libderiv->deriv_classes[5][7][7] = int_stack + 35577;
 Libderiv->deriv_classes[5][8][7] = int_stack + 36333;
 Libderiv->deriv_classes[6][6][7] = int_stack + 37278;
 Libderiv->deriv_classes[6][7][7] = int_stack + 38062;
 Libderiv->deriv_classes[6][8][7] = int_stack + 39070;
 Libderiv->deriv_classes[3][6][6] = int_stack + 40330;
 Libderiv->deriv_classes[3][7][6] = int_stack + 40610;
 Libderiv->deriv_classes[3][8][6] = int_stack + 40970;
 Libderiv->deriv_classes[4][6][6] = int_stack + 41420;
 Libderiv->deriv_classes[4][7][6] = int_stack + 41840;
 Libderiv->deriv_classes[4][8][6] = int_stack + 42380;
 Libderiv->deriv_classes[5][6][6] = int_stack + 43055;
 Libderiv->deriv_classes[5][7][6] = int_stack + 43643;
 Libderiv->deriv_classes[5][8][6] = int_stack + 44399;
 Libderiv->dvrr_classes[6][6] = int_stack + 45344;
 Libderiv->deriv_classes[6][6][6] = int_stack + 46128;
 Libderiv->dvrr_classes[6][7] = int_stack + 46912;
 Libderiv->deriv_classes[6][7][6] = int_stack + 47920;
 Libderiv->deriv_classes[6][8][6] = int_stack + 48928;
 Libderiv->deriv_classes[3][6][2] = int_stack + 50188;
 Libderiv->deriv_classes[3][7][2] = int_stack + 50468;
 Libderiv->deriv_classes[3][8][2] = int_stack + 50828;
 Libderiv->deriv_classes[4][6][2] = int_stack + 51278;
 Libderiv->deriv_classes[4][7][2] = int_stack + 51698;
 Libderiv->deriv_classes[4][8][2] = int_stack + 52238;
 Libderiv->deriv_classes[5][6][2] = int_stack + 52913;
 Libderiv->deriv_classes[5][7][2] = int_stack + 53501;
 Libderiv->deriv_classes[5][8][2] = int_stack + 54257;
 Libderiv->deriv_classes[6][6][2] = int_stack + 55202;
 Libderiv->deriv_classes[6][7][2] = int_stack + 55986;
 Libderiv->deriv_classes[6][8][2] = int_stack + 56994;
 Libderiv->deriv_classes[3][6][1] = int_stack + 58254;
 Libderiv->deriv_classes[3][7][1] = int_stack + 58534;
 Libderiv->deriv_classes[3][8][1] = int_stack + 58894;
 Libderiv->deriv_classes[4][6][1] = int_stack + 59344;
 Libderiv->deriv_classes[4][7][1] = int_stack + 59764;
 Libderiv->deriv_classes[4][8][1] = int_stack + 60304;
 Libderiv->deriv_classes[5][6][1] = int_stack + 60979;
 Libderiv->deriv_classes[5][7][1] = int_stack + 61567;
 Libderiv->deriv_classes[5][8][1] = int_stack + 62323;
 Libderiv->deriv_classes[6][6][1] = int_stack + 63268;
 Libderiv->deriv_classes[6][7][1] = int_stack + 64052;
 Libderiv->deriv_classes[6][8][1] = int_stack + 65060;
 Libderiv->dvrr_classes[3][6] = int_stack + 66320;
 Libderiv->dvrr_classes[3][7] = int_stack + 66600;
 Libderiv->dvrr_classes[3][8] = int_stack + 66960;
 Libderiv->deriv_classes[3][6][0] = int_stack + 67410;
 Libderiv->deriv_classes[3][7][0] = int_stack + 67690;
 Libderiv->deriv_classes[3][8][0] = int_stack + 68050;
 Libderiv->dvrr_classes[4][6] = int_stack + 68500;
 Libderiv->dvrr_classes[4][7] = int_stack + 68920;
 Libderiv->dvrr_classes[4][8] = int_stack + 69460;
 Libderiv->deriv_classes[4][6][0] = int_stack + 70135;
 Libderiv->deriv_classes[4][7][0] = int_stack + 70555;
 Libderiv->deriv_classes[4][8][0] = int_stack + 71095;
 Libderiv->dvrr_classes[5][6] = int_stack + 71770;
 Libderiv->dvrr_classes[5][7] = int_stack + 72358;
 Libderiv->dvrr_classes[5][8] = int_stack + 73114;
 Libderiv->deriv_classes[5][6][0] = int_stack + 74059;
 Libderiv->deriv_classes[5][7][0] = int_stack + 74647;
 Libderiv->deriv_classes[5][8][0] = int_stack + 75403;
 Libderiv->deriv_classes[6][6][0] = int_stack + 76348;
 Libderiv->deriv_classes[6][7][0] = int_stack + 77132;
 Libderiv->deriv_classes[6][8][0] = int_stack + 78140;
 memset(int_stack,0,635200);

 Libderiv->dvrr_stack = int_stack + 335000;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_ffid(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+79400,int_stack+66600,int_stack+66320,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+80240,int_stack+280,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66320,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+81080,int_stack+640,int_stack+280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66600,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+82160,int_stack+81080,int_stack+80240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79400,10);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+80240,int_stack+68920,int_stack+68500,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83840,int_stack+1510,int_stack+1090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68500,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+85100,int_stack+2050,int_stack+1510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68920,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+85100,int_stack+83840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80240,15);
 /*--- compute (fp|id) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+83840,int_stack+0,int_stack+82160,168);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+81500,int_stack+72358,int_stack+71770,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+88880,int_stack+3313,int_stack+2725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71770,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+90644,int_stack+4069,int_stack+3313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72358,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+92912,int_stack+90644,int_stack+88880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81500,21);
 /*--- compute (gp|id) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+96440,int_stack+92912,int_stack+0,168);
 /*--- compute (fd|id) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+104000,int_stack+96440,int_stack+83840,168);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+46912,int_stack+45344,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2352,int_stack+5798,int_stack+5014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45344,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+83264,int_stack+6806,int_stack+5798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46912,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+86288,int_stack+83264,int_stack+2352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,28);
 /*--- compute (hp|id) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+114080,int_stack+86288,int_stack+92912,168);
 /*--- compute (gd|id) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+124664,int_stack+114080,int_stack+96440,168);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+114080,int_stack+8346,int_stack+8066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66320, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+114920,int_stack+8706,int_stack+8346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66600, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+116000,int_stack+114920,int_stack+114080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79400, 0.0, zero_stack,10);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+114080,int_stack+9576,int_stack+9156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68500, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+117680,int_stack+10116,int_stack+9576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68920, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+119300,int_stack+117680,int_stack+114080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80240, 0.0, zero_stack,15);
 /*--- compute (fp|id) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+2352,int_stack+119300,int_stack+116000,168);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+114080,int_stack+11379,int_stack+10791, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71770, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+115844,int_stack+12135,int_stack+11379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72358, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7392,int_stack+115844,int_stack+114080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81500, 0.0, zero_stack,21);
 /*--- compute (gp|id) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+83264,int_stack+7392,int_stack+119300,168);
 /*--- compute (fd|id) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+114080,int_stack+83264,int_stack+2352,168);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2352,int_stack+13864,int_stack+13080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45344, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+90824,int_stack+14872,int_stack+13864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46912, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+10920,int_stack+90824,int_stack+2352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,28);
 /*--- compute (hp|id) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+90824,int_stack+10920,int_stack+7392,168);
 /*--- compute (gd|id) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+139784,int_stack+90824,int_stack+83264,168);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83264,int_stack+16412,int_stack+16132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66320, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+84104,int_stack+16772,int_stack+16412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66600, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+85184,int_stack+84104,int_stack+83264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79400, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83264,int_stack+17642,int_stack+17222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68500, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86864,int_stack+18182,int_stack+17642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68920, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+88484,int_stack+86864,int_stack+83264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80240, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|id) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+91004,int_stack+88484,int_stack+85184,168);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83264,int_stack+19445,int_stack+18857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71770, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+85028,int_stack+20201,int_stack+19445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72358, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+96044,int_stack+85028,int_stack+83264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81500, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|id) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2352,int_stack+96044,int_stack+88484,168);
 /*--- compute (fd|id) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+9912,int_stack+2352,int_stack+91004,168);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83264,int_stack+21930,int_stack+21146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45344, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+85616,int_stack+22938,int_stack+21930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46912, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+88640,int_stack+85616,int_stack+83264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|id) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+154904,int_stack+88640,int_stack+96044,168);
 /*--- compute (gd|id) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+83264,int_stack+154904,int_stack+2352,168);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2352,int_stack+24478,int_stack+24198, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3192,int_stack+24838,int_stack+24478, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4272,int_stack+3192,int_stack+2352, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2352,int_stack+25708,int_stack+25288, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5952,int_stack+26248,int_stack+25708, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+154904,int_stack+5952,int_stack+2352, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|id) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+157424,int_stack+154904,int_stack+4272,168);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2352,int_stack+27511,int_stack+26923, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4116,int_stack+28267,int_stack+27511, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6384,int_stack+4116,int_stack+2352, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|id) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+19992,int_stack+6384,int_stack+154904,168);
 /*--- compute (fd|id) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+162464,int_stack+19992,int_stack+157424,168);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+154904,int_stack+29996,int_stack+29212, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+157256,int_stack+31004,int_stack+29996, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+98384,int_stack+157256,int_stack+154904, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|id) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+172544,int_stack+98384,int_stack+6384,168);
 /*--- compute (gd|id) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+183128,int_stack+172544,int_stack+19992,168);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19992,int_stack+32544,int_stack+32264, 0.0, zero_stack, 1.0, int_stack+66320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+20832,int_stack+32904,int_stack+32544, 0.0, zero_stack, 1.0, int_stack+66600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+21912,int_stack+20832,int_stack+19992, 0.0, zero_stack, 1.0, int_stack+79400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19992,int_stack+33774,int_stack+33354, 0.0, zero_stack, 1.0, int_stack+68500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+23592,int_stack+34314,int_stack+33774, 0.0, zero_stack, 1.0, int_stack+68920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+25212,int_stack+23592,int_stack+19992, 0.0, zero_stack, 1.0, int_stack+80240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|id) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+27732,int_stack+25212,int_stack+21912,168);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19992,int_stack+35577,int_stack+34989, 0.0, zero_stack, 1.0, int_stack+71770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+21756,int_stack+36333,int_stack+35577, 0.0, zero_stack, 1.0, int_stack+72358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+32772,int_stack+21756,int_stack+19992, 0.0, zero_stack, 1.0, int_stack+81500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|id) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+154904,int_stack+32772,int_stack+25212,168);
 /*--- compute (fd|id) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+172544,int_stack+154904,int_stack+27732,168);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19992,int_stack+38062,int_stack+37278, 0.0, zero_stack, 1.0, int_stack+45344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+22344,int_stack+39070,int_stack+38062, 0.0, zero_stack, 1.0, int_stack+46912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+25368,int_stack+22344,int_stack+19992, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|id) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+198248,int_stack+25368,int_stack+32772,168);
 /*--- compute (gd|id) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+19992,int_stack+198248,int_stack+154904,168);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+154904,int_stack+40610,int_stack+40330, 1.0, int_stack+66320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+155744,int_stack+40970,int_stack+40610, 1.0, int_stack+66600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+156824,int_stack+155744,int_stack+154904, 1.0, int_stack+79400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+154904,int_stack+41840,int_stack+41420, 1.0, int_stack+68500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+158504,int_stack+42380,int_stack+41840, 1.0, int_stack+68920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+198248,int_stack+158504,int_stack+154904, 1.0, int_stack+80240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|id) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+200768,int_stack+198248,int_stack+156824,168);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+154904,int_stack+43643,int_stack+43055, 1.0, int_stack+71770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+156668,int_stack+44399,int_stack+43643, 1.0, int_stack+72358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+158936,int_stack+156668,int_stack+154904, 1.0, int_stack+81500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|id) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2352,int_stack+158936,int_stack+198248,168);
 /*--- compute (fd|id) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+35112,int_stack+2352,int_stack+200768,168);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+198248,int_stack+47920,int_stack+46128, 1.0, int_stack+45344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+200600,int_stack+48928,int_stack+47920, 1.0, int_stack+46912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+203624,int_stack+200600,int_stack+198248, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|id) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+208328,int_stack+203624,int_stack+158936,168);
 /*--- compute (gd|id) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+218912,int_stack+208328,int_stack+2352,168);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+66960,int_stack+66600,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1080,int_stack+0,int_stack+79400,10);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2760,int_stack+69460,int_stack+68920,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4380,int_stack+2760,int_stack+80240,15);
 /*--- compute (fp|id) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+198248,int_stack+4380,int_stack+1080,168);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6900,int_stack+73114,int_stack+72358,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+203288,int_stack+6900,int_stack+81500,21);
 /*--- compute (gp|id) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+154904,int_stack+203288,int_stack+4380,168);
 /*--- compute (fd|id) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+206816,int_stack+154904,int_stack+198248,168);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6900,int_stack+50468,int_stack+50188,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+50828,int_stack+50468,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+7740,int_stack+0,int_stack+6900,10);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2760,int_stack+51698,int_stack+51278,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+79400,int_stack+52238,int_stack+51698,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+45192,int_stack+79400,int_stack+2760,15);
 /*--- compute (fp|id) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+47712,int_stack+45192,int_stack+7740, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+79400,int_stack+53501,int_stack+52913,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6900,int_stack+54257,int_stack+53501,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+98384,int_stack+6900,int_stack+79400,21);
 /*--- compute (gp|id) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+234032,int_stack+98384,int_stack+45192, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (fd|id) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+241592,int_stack+234032,int_stack+47712, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+45192,int_stack+55986,int_stack+55202,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+47544,int_stack+56994,int_stack+55986,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+50568,int_stack+47544,int_stack+45192,28);
 /*--- compute (hp|id) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+251672,int_stack+50568,int_stack+98384, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (gd|id) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+262256,int_stack+251672,int_stack+234032, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+154904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+234032,int_stack+58534,int_stack+58254,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+58894,int_stack+58534,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+234872,int_stack+0,int_stack+234032,10);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+236552,int_stack+59764,int_stack+59344,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2760,int_stack+60304,int_stack+59764,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+237812,int_stack+2760,int_stack+236552,15);
 /*--- compute (fp|id) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+251672,int_stack+237812,int_stack+234872, 0.0, zero_stack, 1.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+234032,int_stack+61567,int_stack+60979,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+256712,int_stack+62323,int_stack+61567,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+98384,int_stack+256712,int_stack+234032,21);
 /*--- compute (gp|id) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+45192,int_stack+98384,int_stack+237812, 0.0, zero_stack, 1.0, int_stack+4380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (fd|id) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+52752,int_stack+45192,int_stack+251672, 0.0, zero_stack, 1.0, int_stack+198248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+251672,int_stack+64052,int_stack+63268,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+254024,int_stack+65060,int_stack+64052,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+257048,int_stack+254024,int_stack+251672,28);
 /*--- compute (hp|id) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+277376,int_stack+257048,int_stack+98384, 0.0, zero_stack, 1.0, int_stack+203288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (gd|id) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+287960,int_stack+277376,int_stack+45192, 0.0, zero_stack, 1.0, int_stack+154904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+45192,int_stack+67690,int_stack+67410,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+68050,int_stack+67690,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+46032,int_stack+0,int_stack+45192,10);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+47712,int_stack+70555,int_stack+70135,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2760,int_stack+71095,int_stack+70555,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+48972,int_stack+2760,int_stack+47712,15);
 /*--- compute (fp|id) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+277376,int_stack+48972,int_stack+46032, 1.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+45192,int_stack+74647,int_stack+74059,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+75403,int_stack+74647,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+282416,int_stack+0,int_stack+45192,21);
 /*--- compute (gp|id) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+234032,int_stack+282416,int_stack+48972, 1.0, int_stack+4380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (fd|id) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+251672,int_stack+234032,int_stack+277376, 1.0, int_stack+198248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+198248,int_stack+77132,int_stack+76348,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+277376,int_stack+78140,int_stack+77132,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+45192,int_stack+277376,int_stack+198248,28);
 /*--- compute (hp|id) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+62832,int_stack+45192,int_stack+282416, 1.0, int_stack+203288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (gd|id) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+303080,int_stack+62832,int_stack+234032, 1.0, int_stack+154904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (ff|id) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+62832,int_stack+124664,int_stack+104000,168);
     Libderiv->ABCD[11] = int_stack + 62832;
 /*--- compute (ff|id) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+318200,int_stack+139784,int_stack+114080,168);
     Libderiv->ABCD[10] = int_stack + 318200;
 /*--- compute (ff|id) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+98384,int_stack+83264,int_stack+9912,168);
     Libderiv->ABCD[9] = int_stack + 98384;
 /*--- compute (ff|id) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+79632,int_stack+183128,int_stack+162464,168);
     Libderiv->ABCD[8] = int_stack + 79632;
 /*--- compute (ff|id) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+0,int_stack+19992,int_stack+172544,168);
     Libderiv->ABCD[7] = int_stack + 0;
 /*--- compute (ff|id) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+16800,int_stack+218912,int_stack+35112,168);
     Libderiv->ABCD[6] = int_stack + 16800;
 /*--- compute (ff|id) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+33600,int_stack+262256,int_stack+241592, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
     Libderiv->ABCD[2] = int_stack + 33600;
 /*--- compute (ff|id) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+115184,int_stack+287960,int_stack+52752, 0.0, zero_stack, 1.0, int_stack+206816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
     Libderiv->ABCD[1] = int_stack + 115184;
 /*--- compute (ff|id) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+131984,int_stack+303080,int_stack+251672, 1.0, int_stack+206816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
     Libderiv->ABCD[0] = int_stack + 131984;

}
