/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_fpip(Libderiv_t *, prim_data *);

  /* Computes derivatives of (fp|ip) integrals */

void d1hrr_order_fpip(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[3][6][11] = int_stack + 0;
 Libderiv->deriv_classes[3][7][11] = int_stack + 280;
 Libderiv->deriv_classes[4][6][11] = int_stack + 640;
 Libderiv->deriv_classes[4][7][11] = int_stack + 1060;
 Libderiv->deriv_classes[3][6][10] = int_stack + 1600;
 Libderiv->deriv_classes[3][7][10] = int_stack + 1880;
 Libderiv->deriv_classes[4][6][10] = int_stack + 2240;
 Libderiv->deriv_classes[4][7][10] = int_stack + 2660;
 Libderiv->deriv_classes[3][6][9] = int_stack + 3200;
 Libderiv->deriv_classes[3][7][9] = int_stack + 3480;
 Libderiv->deriv_classes[4][6][9] = int_stack + 3840;
 Libderiv->deriv_classes[4][7][9] = int_stack + 4260;
 Libderiv->deriv_classes[3][6][8] = int_stack + 4800;
 Libderiv->deriv_classes[3][7][8] = int_stack + 5080;
 Libderiv->deriv_classes[4][6][8] = int_stack + 5440;
 Libderiv->deriv_classes[4][7][8] = int_stack + 5860;
 Libderiv->deriv_classes[3][6][7] = int_stack + 6400;
 Libderiv->deriv_classes[3][7][7] = int_stack + 6680;
 Libderiv->deriv_classes[4][6][7] = int_stack + 7040;
 Libderiv->deriv_classes[4][7][7] = int_stack + 7460;
 Libderiv->deriv_classes[3][6][6] = int_stack + 8000;
 Libderiv->deriv_classes[3][7][6] = int_stack + 8280;
 Libderiv->dvrr_classes[4][6] = int_stack + 8640;
 Libderiv->deriv_classes[4][6][6] = int_stack + 9060;
 Libderiv->deriv_classes[4][7][6] = int_stack + 9480;
 Libderiv->deriv_classes[3][6][2] = int_stack + 10020;
 Libderiv->deriv_classes[3][7][2] = int_stack + 10300;
 Libderiv->deriv_classes[4][6][2] = int_stack + 10660;
 Libderiv->deriv_classes[4][7][2] = int_stack + 11080;
 Libderiv->deriv_classes[3][6][1] = int_stack + 11620;
 Libderiv->deriv_classes[3][7][1] = int_stack + 11900;
 Libderiv->deriv_classes[4][6][1] = int_stack + 12260;
 Libderiv->deriv_classes[4][7][1] = int_stack + 12680;
 Libderiv->dvrr_classes[3][6] = int_stack + 13220;
 Libderiv->dvrr_classes[3][7] = int_stack + 13500;
 Libderiv->deriv_classes[3][6][0] = int_stack + 13860;
 Libderiv->deriv_classes[3][7][0] = int_stack + 14140;
 Libderiv->deriv_classes[4][6][0] = int_stack + 14500;
 Libderiv->deriv_classes[4][7][0] = int_stack + 14920;
 memset(int_stack,0,123680);

 Libderiv->dvrr_stack = int_stack + 28900;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_fpip(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15460,int_stack+280,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13220,10);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+16300,int_stack+1060,int_stack+640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8640,15);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+1880,int_stack+1600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13220, 0.0, zero_stack,10);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+840,int_stack+2660,int_stack+2240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8640, 0.0, zero_stack,15);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2100,int_stack+3480,int_stack+3200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13220, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17560,int_stack+4260,int_stack+3840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8640, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2940,int_stack+5080,int_stack+4800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3780,int_stack+5860,int_stack+5440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5040,int_stack+6680,int_stack+6400, 0.0, zero_stack, 1.0, int_stack+13220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+18820,int_stack+7460,int_stack+7040, 0.0, zero_stack, 1.0, int_stack+8640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5880,int_stack+8280,int_stack+8000, 1.0, int_stack+13220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6720,int_stack+9480,int_stack+9060, 1.0, int_stack+8640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7980,int_stack+13500,int_stack+13220,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+8820,int_stack+10300,int_stack+10020,10);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+20080,int_stack+11080,int_stack+10660,15);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+9660,int_stack+11900,int_stack+11620,10);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+10500,int_stack+12680,int_stack+12260,15);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+11760,int_stack+14140,int_stack+13860,10);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+12600,int_stack+14920,int_stack+14500,15);
 /*--- compute (fp|ip) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+21340,int_stack+16300,int_stack+15460,84);
     Libderiv->ABCD[11] = int_stack + 21340;
 /*--- compute (fp|ip) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+13860,int_stack+840,int_stack+0,84);
     Libderiv->ABCD[10] = int_stack + 13860;
 /*--- compute (fp|ip) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+23860,int_stack+17560,int_stack+2100,84);
     Libderiv->ABCD[9] = int_stack + 23860;
 /*--- compute (fp|ip) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+0,int_stack+3780,int_stack+2940,84);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (fp|ip) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+2520,int_stack+18820,int_stack+5040,84);
     Libderiv->ABCD[7] = int_stack + 2520;
 /*--- compute (fp|ip) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+16380,int_stack+6720,int_stack+5880,84);
     Libderiv->ABCD[6] = int_stack + 16380;
 /*--- compute (fp|ip) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+5040,int_stack+20080,int_stack+8820, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
     Libderiv->ABCD[2] = int_stack + 5040;
 /*--- compute (fp|ip) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+26380,int_stack+10500,int_stack+9660, 0.0, zero_stack, 1.0, int_stack+7980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
     Libderiv->ABCD[1] = int_stack + 26380;
 /*--- compute (fp|ip) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+8820,int_stack+12600,int_stack+11760, 1.0, int_stack+7980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
     Libderiv->ABCD[0] = int_stack + 8820;

}
