/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_g0hd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (g0|hd) integrals */

void d1hrr_order_g0hd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][5][11] = int_stack + 0;
 Libderiv->deriv_classes[4][6][11] = int_stack + 315;
 Libderiv->deriv_classes[4][7][11] = int_stack + 735;
 Libderiv->deriv_classes[4][5][10] = int_stack + 1275;
 Libderiv->deriv_classes[4][6][10] = int_stack + 1590;
 Libderiv->deriv_classes[4][7][10] = int_stack + 2010;
 Libderiv->deriv_classes[4][5][9] = int_stack + 2550;
 Libderiv->deriv_classes[4][6][9] = int_stack + 2865;
 Libderiv->deriv_classes[4][7][9] = int_stack + 3285;
 Libderiv->deriv_classes[4][5][8] = int_stack + 3825;
 Libderiv->deriv_classes[4][6][8] = int_stack + 4140;
 Libderiv->deriv_classes[4][7][8] = int_stack + 4560;
 Libderiv->deriv_classes[4][5][7] = int_stack + 5100;
 Libderiv->deriv_classes[4][6][7] = int_stack + 5415;
 Libderiv->deriv_classes[4][7][7] = int_stack + 5835;
 Libderiv->dvrr_classes[4][5] = int_stack + 6375;
 Libderiv->deriv_classes[4][5][6] = int_stack + 6690;
 Libderiv->dvrr_classes[4][6] = int_stack + 7005;
 Libderiv->deriv_classes[4][6][6] = int_stack + 7425;
 Libderiv->deriv_classes[4][7][6] = int_stack + 7845;
 Libderiv->deriv_classes[4][5][2] = int_stack + 8385;
 Libderiv->deriv_classes[4][6][2] = int_stack + 8700;
 Libderiv->deriv_classes[4][7][2] = int_stack + 9120;
 Libderiv->deriv_classes[4][5][1] = int_stack + 9660;
 Libderiv->deriv_classes[4][6][1] = int_stack + 9975;
 Libderiv->deriv_classes[4][7][1] = int_stack + 10395;
 Libderiv->deriv_classes[4][5][0] = int_stack + 10935;
 Libderiv->deriv_classes[4][6][0] = int_stack + 11250;
 Libderiv->deriv_classes[4][7][0] = int_stack + 11670;
 memset(int_stack,0,97680);

 Libderiv->dvrr_stack = int_stack + 24810;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_g0hd(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+12210,int_stack+7005,int_stack+6375,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+13155,int_stack+315,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6375,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14100,int_stack+735,int_stack+315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7005,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+1590,int_stack+1275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6375, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15360,int_stack+2010,int_stack+1590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7005, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+945,int_stack+2865,int_stack+2550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6375, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+16620,int_stack+3285,int_stack+2865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7005, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+4140,int_stack+3825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2835,int_stack+4560,int_stack+4140, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4095,int_stack+5415,int_stack+5100, 0.0, zero_stack, 1.0, int_stack+6375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17880,int_stack+5835,int_stack+5415, 0.0, zero_stack, 1.0, int_stack+7005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5040,int_stack+7425,int_stack+6690, 1.0, int_stack+6375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19140,int_stack+7845,int_stack+7425, 1.0, int_stack+7005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5985,int_stack+8700,int_stack+8385,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6930,int_stack+9120,int_stack+8700,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+8190,int_stack+9975,int_stack+9660,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+20400,int_stack+10395,int_stack+9975,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+9135,int_stack+11250,int_stack+10935,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+21660,int_stack+11670,int_stack+11250,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10080,int_stack+14100,int_stack+13155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12210,15);
     Libderiv->ABCD[11] = int_stack + 10080;
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+13155,int_stack+15360,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12210, 0.0, zero_stack,15);
     Libderiv->ABCD[10] = int_stack + 13155;
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22920,int_stack+16620,int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12210, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[9] = int_stack + 22920;
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+2835,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1890,int_stack+17880,int_stack+4095, 0.0, zero_stack, 1.0, int_stack+12210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[7] = int_stack + 1890;
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15045,int_stack+19140,int_stack+5040, 1.0, int_stack+12210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[6] = int_stack + 15045;
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3780,int_stack+6930,int_stack+5985,15);
     Libderiv->ABCD[2] = int_stack + 3780;
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5670,int_stack+20400,int_stack+8190,15);
     Libderiv->ABCD[1] = int_stack + 5670;
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+16935,int_stack+21660,int_stack+9135,15);
     Libderiv->ABCD[0] = int_stack + 16935;

}
