/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_i0gd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (i0|gd) integrals */

void d1hrr_order_i0gd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][4][11] = int_stack + 0;
 Libderiv->deriv_classes[6][5][11] = int_stack + 420;
 Libderiv->deriv_classes[6][6][11] = int_stack + 1008;
 Libderiv->deriv_classes[6][4][10] = int_stack + 1792;
 Libderiv->deriv_classes[6][5][10] = int_stack + 2212;
 Libderiv->deriv_classes[6][6][10] = int_stack + 2800;
 Libderiv->deriv_classes[6][4][9] = int_stack + 3584;
 Libderiv->deriv_classes[6][5][9] = int_stack + 4004;
 Libderiv->deriv_classes[6][6][9] = int_stack + 4592;
 Libderiv->deriv_classes[6][4][8] = int_stack + 5376;
 Libderiv->deriv_classes[6][5][8] = int_stack + 5796;
 Libderiv->deriv_classes[6][6][8] = int_stack + 6384;
 Libderiv->deriv_classes[6][4][7] = int_stack + 7168;
 Libderiv->deriv_classes[6][5][7] = int_stack + 7588;
 Libderiv->deriv_classes[6][6][7] = int_stack + 8176;
 Libderiv->dvrr_classes[6][4] = int_stack + 8960;
 Libderiv->deriv_classes[6][4][6] = int_stack + 9380;
 Libderiv->dvrr_classes[6][5] = int_stack + 9800;
 Libderiv->deriv_classes[6][5][6] = int_stack + 10388;
 Libderiv->deriv_classes[6][6][6] = int_stack + 10976;
 Libderiv->deriv_classes[6][4][2] = int_stack + 11760;
 Libderiv->deriv_classes[6][5][2] = int_stack + 12180;
 Libderiv->deriv_classes[6][6][2] = int_stack + 12768;
 Libderiv->deriv_classes[6][4][1] = int_stack + 13552;
 Libderiv->deriv_classes[6][5][1] = int_stack + 13972;
 Libderiv->deriv_classes[6][6][1] = int_stack + 14560;
 Libderiv->deriv_classes[6][4][0] = int_stack + 15344;
 Libderiv->deriv_classes[6][5][0] = int_stack + 15764;
 Libderiv->deriv_classes[6][6][0] = int_stack + 16352;
 memset(int_stack,0,137088);

 Libderiv->dvrr_stack = int_stack + 35280;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_i0gd(Libderiv, Data);
   Data++;
 }

 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+17136,int_stack+9800,int_stack+8960,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+18396,int_stack+420,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8960,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19656,int_stack+1008,int_stack+420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9800,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+2212,int_stack+1792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8960, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21420,int_stack+2800,int_stack+2212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9800, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1260,int_stack+4004,int_stack+3584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8960, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+23184,int_stack+4592,int_stack+4004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9800, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2520,int_stack+5796,int_stack+5376, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3780,int_stack+6384,int_stack+5796, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5544,int_stack+7588,int_stack+7168, 0.0, zero_stack, 1.0, int_stack+8960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+24948,int_stack+8176,int_stack+7588, 0.0, zero_stack, 1.0, int_stack+9800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6804,int_stack+10388,int_stack+9380, 1.0, int_stack+8960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+26712,int_stack+10976,int_stack+10388, 1.0, int_stack+9800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+8064,int_stack+12180,int_stack+11760,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+9324,int_stack+12768,int_stack+12180,28);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+11088,int_stack+13972,int_stack+13552,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+28476,int_stack+14560,int_stack+13972,28);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+12348,int_stack+15764,int_stack+15344,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+13608,int_stack+16352,int_stack+15764,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+30240,int_stack+19656,int_stack+18396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17136,28);
     Libderiv->ABCD[11] = int_stack + 30240;
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+18396,int_stack+21420,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17136, 0.0, zero_stack,28);
     Libderiv->ABCD[10] = int_stack + 18396;
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+32760,int_stack+23184,int_stack+1260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17136, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[9] = int_stack + 32760;
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+3780,int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2520,int_stack+24948,int_stack+5544, 0.0, zero_stack, 1.0, int_stack+17136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[7] = int_stack + 2520;
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+20916,int_stack+26712,int_stack+6804, 1.0, int_stack+17136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[6] = int_stack + 20916;
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+5040,int_stack+9324,int_stack+8064,28);
     Libderiv->ABCD[2] = int_stack + 5040;
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+7560,int_stack+28476,int_stack+11088,28);
     Libderiv->ABCD[1] = int_stack + 7560;
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+23436,int_stack+13608,int_stack+12348,28);
     Libderiv->ABCD[0] = int_stack + 23436;

}
