/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_i0hp(Libderiv_t *, prim_data *);

  /* Computes derivatives of (i0|hp) integrals */

void d1hrr_order_i0hp(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][5][11] = int_stack + 0;
 Libderiv->deriv_classes[6][6][11] = int_stack + 588;
 Libderiv->deriv_classes[6][5][10] = int_stack + 1372;
 Libderiv->deriv_classes[6][6][10] = int_stack + 1960;
 Libderiv->deriv_classes[6][5][9] = int_stack + 2744;
 Libderiv->deriv_classes[6][6][9] = int_stack + 3332;
 Libderiv->deriv_classes[6][5][8] = int_stack + 4116;
 Libderiv->deriv_classes[6][6][8] = int_stack + 4704;
 Libderiv->deriv_classes[6][5][7] = int_stack + 5488;
 Libderiv->deriv_classes[6][6][7] = int_stack + 6076;
 Libderiv->dvrr_classes[6][5] = int_stack + 6860;
 Libderiv->deriv_classes[6][5][6] = int_stack + 7448;
 Libderiv->deriv_classes[6][6][6] = int_stack + 8036;
 Libderiv->deriv_classes[6][5][2] = int_stack + 8820;
 Libderiv->deriv_classes[6][6][2] = int_stack + 9408;
 Libderiv->deriv_classes[6][5][1] = int_stack + 10192;
 Libderiv->deriv_classes[6][6][1] = int_stack + 10780;
 Libderiv->deriv_classes[6][5][0] = int_stack + 11564;
 Libderiv->deriv_classes[6][6][0] = int_stack + 12152;
 memset(int_stack,0,103488);

 Libderiv->dvrr_stack = int_stack + 18228;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_i0hp(Libderiv, Data);
   Data++;
 }

 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12936,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6860,28);
     Libderiv->ABCD[11] = int_stack + 12936;
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14700,int_stack+1960,int_stack+1372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6860, 0.0, zero_stack,28);
     Libderiv->ABCD[10] = int_stack + 14700;
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+3332,int_stack+2744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6860, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[9] = int_stack + 0;
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1764,int_stack+4704,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[8] = int_stack + 1764;
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3528,int_stack+6076,int_stack+5488, 0.0, zero_stack, 1.0, int_stack+6860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[7] = int_stack + 3528;
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16464,int_stack+8036,int_stack+7448, 1.0, int_stack+6860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[6] = int_stack + 16464;
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5292,int_stack+9408,int_stack+8820,28);
     Libderiv->ABCD[2] = int_stack + 5292;
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+7056,int_stack+10780,int_stack+10192,28);
     Libderiv->ABCD[1] = int_stack + 7056;
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+8820,int_stack+12152,int_stack+11564,28);
     Libderiv->ABCD[0] = int_stack + 8820;

}
