/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_i0ig(Libderiv_t *, prim_data *);

  /* Computes derivatives of (i0|ig) integrals */

void d1hrr_order_i0ig(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][6][11] = int_stack + 0;
 Libderiv->deriv_classes[6][7][11] = int_stack + 784;
 Libderiv->deriv_classes[6][8][11] = int_stack + 1792;
 Libderiv->deriv_classes[6][9][11] = int_stack + 3052;
 Libderiv->deriv_classes[6][10][11] = int_stack + 4592;
 Libderiv->deriv_classes[6][6][10] = int_stack + 6440;
 Libderiv->deriv_classes[6][7][10] = int_stack + 7224;
 Libderiv->deriv_classes[6][8][10] = int_stack + 8232;
 Libderiv->deriv_classes[6][9][10] = int_stack + 9492;
 Libderiv->deriv_classes[6][10][10] = int_stack + 11032;
 Libderiv->deriv_classes[6][6][9] = int_stack + 12880;
 Libderiv->deriv_classes[6][7][9] = int_stack + 13664;
 Libderiv->deriv_classes[6][8][9] = int_stack + 14672;
 Libderiv->deriv_classes[6][9][9] = int_stack + 15932;
 Libderiv->deriv_classes[6][10][9] = int_stack + 17472;
 Libderiv->deriv_classes[6][6][8] = int_stack + 19320;
 Libderiv->deriv_classes[6][7][8] = int_stack + 20104;
 Libderiv->deriv_classes[6][8][8] = int_stack + 21112;
 Libderiv->deriv_classes[6][9][8] = int_stack + 22372;
 Libderiv->deriv_classes[6][10][8] = int_stack + 23912;
 Libderiv->deriv_classes[6][6][7] = int_stack + 25760;
 Libderiv->deriv_classes[6][7][7] = int_stack + 26544;
 Libderiv->deriv_classes[6][8][7] = int_stack + 27552;
 Libderiv->deriv_classes[6][9][7] = int_stack + 28812;
 Libderiv->deriv_classes[6][10][7] = int_stack + 30352;
 Libderiv->dvrr_classes[6][6] = int_stack + 32200;
 Libderiv->deriv_classes[6][6][6] = int_stack + 32984;
 Libderiv->dvrr_classes[6][7] = int_stack + 33768;
 Libderiv->deriv_classes[6][7][6] = int_stack + 34776;
 Libderiv->dvrr_classes[6][8] = int_stack + 35784;
 Libderiv->deriv_classes[6][8][6] = int_stack + 37044;
 Libderiv->dvrr_classes[6][9] = int_stack + 38304;
 Libderiv->deriv_classes[6][9][6] = int_stack + 39844;
 Libderiv->deriv_classes[6][10][6] = int_stack + 41384;
 Libderiv->deriv_classes[6][6][2] = int_stack + 43232;
 Libderiv->deriv_classes[6][7][2] = int_stack + 44016;
 Libderiv->deriv_classes[6][8][2] = int_stack + 45024;
 Libderiv->deriv_classes[6][9][2] = int_stack + 46284;
 Libderiv->deriv_classes[6][10][2] = int_stack + 47824;
 Libderiv->deriv_classes[6][6][1] = int_stack + 49672;
 Libderiv->deriv_classes[6][7][1] = int_stack + 50456;
 Libderiv->deriv_classes[6][8][1] = int_stack + 51464;
 Libderiv->deriv_classes[6][9][1] = int_stack + 52724;
 Libderiv->deriv_classes[6][10][1] = int_stack + 54264;
 Libderiv->deriv_classes[6][6][0] = int_stack + 56112;
 Libderiv->deriv_classes[6][7][0] = int_stack + 56896;
 Libderiv->deriv_classes[6][8][0] = int_stack + 57904;
 Libderiv->deriv_classes[6][9][0] = int_stack + 59164;
 Libderiv->deriv_classes[6][10][0] = int_stack + 60704;
 memset(int_stack,0,500416);

 Libderiv->dvrr_stack = int_stack + 225512;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_i0ig(Libderiv, Data);
   Data++;
 }

 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+62552,int_stack+33768,int_stack+32200,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+64904,int_stack+35784,int_stack+33768,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+67928,int_stack+64904,int_stack+62552,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+72632,int_stack+38304,int_stack+35784,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+76412,int_stack+72632,int_stack+64904,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+82460,int_stack+76412,int_stack+67928,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+90300,int_stack+784,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32200,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+92652,int_stack+1792,int_stack+784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33768,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+95676,int_stack+92652,int_stack+90300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62552,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+100380,int_stack+3052,int_stack+1792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35784,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+104160,int_stack+100380,int_stack+92652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+64904,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+110208,int_stack+104160,int_stack+95676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+67928,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+90300,int_stack+4592,int_stack+3052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38304,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+118048,int_stack+90300,int_stack+100380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72632,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+90300,int_stack+118048,int_stack+104160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76412,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+118048,int_stack+7224,int_stack+6440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32200, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+120400,int_stack+8232,int_stack+7224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33768, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+100380,int_stack+120400,int_stack+118048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62552, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+105084,int_stack+9492,int_stack+8232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35784, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+105084,int_stack+120400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+64904, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+118048,int_stack+0,int_stack+100380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+67928, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+100380,int_stack+11032,int_stack+9492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38304, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+125888,int_stack+100380,int_stack+105084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72632, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+133448,int_stack+125888,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76412, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+13664,int_stack+12880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32200, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2352,int_stack+14672,int_stack+13664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33768, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5376,int_stack+2352,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62552, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+10080,int_stack+15932,int_stack+14672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35784, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+125888,int_stack+10080,int_stack+2352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+64904, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+100380,int_stack+125888,int_stack+5376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+67928, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+17472,int_stack+15932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38304, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+143528,int_stack+0,int_stack+10080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72632, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+0,int_stack+143528,int_stack+125888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76412, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+125888,int_stack+20104,int_stack+19320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+128240,int_stack+21112,int_stack+20104, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+143528,int_stack+128240,int_stack+125888, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+10080,int_stack+22372,int_stack+21112, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+13860,int_stack+10080,int_stack+128240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+64904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+148232,int_stack+13860,int_stack+143528, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+67928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+143528,int_stack+23912,int_stack+22372, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+125888,int_stack+143528,int_stack+10080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+156072,int_stack+125888,int_stack+13860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+125888,int_stack+26544,int_stack+25760, 0.0, zero_stack, 1.0, int_stack+32200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+128240,int_stack+27552,int_stack+26544, 0.0, zero_stack, 1.0, int_stack+33768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+143528,int_stack+128240,int_stack+125888, 0.0, zero_stack, 1.0, int_stack+62552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+10080,int_stack+28812,int_stack+27552, 0.0, zero_stack, 1.0, int_stack+35784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+13860,int_stack+10080,int_stack+128240, 0.0, zero_stack, 1.0, int_stack+64904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+19908,int_stack+13860,int_stack+143528, 0.0, zero_stack, 1.0, int_stack+67928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+143528,int_stack+30352,int_stack+28812, 0.0, zero_stack, 1.0, int_stack+38304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+125888,int_stack+143528,int_stack+10080, 0.0, zero_stack, 1.0, int_stack+72632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+166152,int_stack+125888,int_stack+13860, 0.0, zero_stack, 1.0, int_stack+76412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+125888,int_stack+34776,int_stack+32984, 1.0, int_stack+32200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+128240,int_stack+37044,int_stack+34776, 1.0, int_stack+33768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+143528,int_stack+128240,int_stack+125888, 1.0, int_stack+62552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+10080,int_stack+39844,int_stack+37044, 1.0, int_stack+35784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+13860,int_stack+10080,int_stack+128240, 1.0, int_stack+64904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+27748,int_stack+13860,int_stack+143528, 1.0, int_stack+67928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+143528,int_stack+41384,int_stack+39844, 1.0, int_stack+38304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+125888,int_stack+143528,int_stack+10080, 1.0, int_stack+72632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+62552,int_stack+125888,int_stack+13860, 1.0, int_stack+76412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+125888,int_stack+44016,int_stack+43232,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+128240,int_stack+45024,int_stack+44016,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+143528,int_stack+128240,int_stack+125888,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+10080,int_stack+46284,int_stack+45024,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+13860,int_stack+10080,int_stack+128240,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+72632,int_stack+13860,int_stack+143528,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+143528,int_stack+47824,int_stack+46284,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+125888,int_stack+143528,int_stack+10080,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+35588,int_stack+125888,int_stack+13860,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+125888,int_stack+50456,int_stack+49672,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+128240,int_stack+51464,int_stack+50456,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+143528,int_stack+128240,int_stack+125888,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+10080,int_stack+52724,int_stack+51464,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+13860,int_stack+10080,int_stack+128240,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+176232,int_stack+13860,int_stack+143528,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+143528,int_stack+54264,int_stack+52724,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+125888,int_stack+143528,int_stack+10080,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+45668,int_stack+125888,int_stack+13860,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+125888,int_stack+56896,int_stack+56112,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+128240,int_stack+57904,int_stack+56896,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+143528,int_stack+128240,int_stack+125888,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+10080,int_stack+59164,int_stack+57904,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+13860,int_stack+10080,int_stack+128240,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+184072,int_stack+13860,int_stack+143528,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+143528,int_stack+60704,int_stack+59164,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+125888,int_stack+143528,int_stack+10080,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+191912,int_stack+125888,int_stack+13860,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+201992,int_stack+90300,int_stack+110208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82460,28);
     Libderiv->ABCD[11] = int_stack + 201992;
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+213752,int_stack+133448,int_stack+118048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82460, 0.0, zero_stack,28);
     Libderiv->ABCD[10] = int_stack + 213752;
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+108220,int_stack+0,int_stack+100380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82460, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[9] = int_stack + 108220;
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+156072,int_stack+148232, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+90300,int_stack+166152,int_stack+19908, 0.0, zero_stack, 1.0, int_stack+82460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[7] = int_stack + 90300;
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+11760,int_stack+62552,int_stack+27748, 1.0, int_stack+82460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[6] = int_stack + 11760;
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+23520,int_stack+35588,int_stack+72632,28);
     Libderiv->ABCD[2] = int_stack + 23520;
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+55748,int_stack+45668,int_stack+176232,28);
     Libderiv->ABCD[1] = int_stack + 55748;
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+35280,int_stack+191912,int_stack+184072,28);
     Libderiv->ABCD[0] = int_stack + 35280;

}
