/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ks|ps) integrals */

#include "libint.h"

void _build_k0p0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  oneo2zn = 1.0*Data->oo2zn;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U40 = Data->U[4][0];
  U41 = Data->U[4][1];
  U42 = Data->U[4][2];


*(vp++) = U00*I0[0] + U40*I1[0]
           + (sixo2z)*(I2[0] - (lpoz)*I3[0])
           + (oneo2zn)*I4[0];
*(vp++) = U00*I0[1] + U40*I1[1]
           + (sixo2z)*(I2[1] - (lpoz)*I3[1]);
*(vp++) = U00*I0[2] + U40*I1[2]
           + (sixo2z)*(I2[2] - (lpoz)*I3[2]);
*(vp++) = U00*I0[3] + U40*I1[3]
           + (fiveo2z)*(I2[3] - (lpoz)*I3[3])
           + (oneo2zn)*I4[1];
*(vp++) = U00*I0[4] + U40*I1[4]
           + (fiveo2z)*(I2[4] - (lpoz)*I3[4]);
*(vp++) = U00*I0[5] + U40*I1[5]
           + (fiveo2z)*(I2[5] - (lpoz)*I3[5]);
*(vp++) = U00*I0[6] + U40*I1[6]
           + (fiveo2z)*(I2[6] - (lpoz)*I3[6])
           + (oneo2zn)*I4[2];
*(vp++) = U00*I0[7] + U40*I1[7]
           + (fiveo2z)*(I2[7] - (lpoz)*I3[7]);
*(vp++) = U00*I0[8] + U40*I1[8]
           + (fiveo2z)*(I2[8] - (lpoz)*I3[8]);
*(vp++) = U00*I0[9] + U40*I1[9]
           + (fouro2z)*(I2[9] - (lpoz)*I3[9])
           + (oneo2zn)*I4[3];
*(vp++) = U00*I0[10] + U40*I1[10]
           + (fouro2z)*(I2[10] - (lpoz)*I3[10]);
*(vp++) = U00*I0[11] + U40*I1[11]
           + (fouro2z)*(I2[11] - (lpoz)*I3[11]);
*(vp++) = U00*I0[12] + U40*I1[12]
           + (fouro2z)*(I2[12] - (lpoz)*I3[12])
           + (oneo2zn)*I4[4];
*(vp++) = U00*I0[13] + U40*I1[13]
           + (fouro2z)*(I2[13] - (lpoz)*I3[13]);
*(vp++) = U00*I0[14] + U40*I1[14]
           + (fouro2z)*(I2[14] - (lpoz)*I3[14]);
*(vp++) = U00*I0[15] + U40*I1[15]
           + (fouro2z)*(I2[15] - (lpoz)*I3[15])
           + (oneo2zn)*I4[5];
*(vp++) = U00*I0[16] + U40*I1[16]
           + (fouro2z)*(I2[16] - (lpoz)*I3[16]);
*(vp++) = U00*I0[17] + U40*I1[17]
           + (fouro2z)*(I2[17] - (lpoz)*I3[17]);
*(vp++) = U00*I0[18] + U40*I1[18]
           + (threeo2z)*(I2[18] - (lpoz)*I3[18])
           + (oneo2zn)*I4[6];
*(vp++) = U00*I0[19] + U40*I1[19]
           + (threeo2z)*(I2[19] - (lpoz)*I3[19]);
*(vp++) = U00*I0[20] + U40*I1[20]
           + (threeo2z)*(I2[20] - (lpoz)*I3[20]);
*(vp++) = U00*I0[21] + U40*I1[21]
           + (threeo2z)*(I2[21] - (lpoz)*I3[21])
           + (oneo2zn)*I4[7];
*(vp++) = U00*I0[22] + U40*I1[22]
           + (threeo2z)*(I2[22] - (lpoz)*I3[22]);
*(vp++) = U00*I0[23] + U40*I1[23]
           + (threeo2z)*(I2[23] - (lpoz)*I3[23]);
*(vp++) = U00*I0[24] + U40*I1[24]
           + (threeo2z)*(I2[24] - (lpoz)*I3[24])
           + (oneo2zn)*I4[8];
*(vp++) = U00*I0[25] + U40*I1[25]
           + (threeo2z)*(I2[25] - (lpoz)*I3[25]);
*(vp++) = U00*I0[26] + U40*I1[26]
           + (threeo2z)*(I2[26] - (lpoz)*I3[26]);
*(vp++) = U00*I0[27] + U40*I1[27]
           + (threeo2z)*(I2[27] - (lpoz)*I3[27])
           + (oneo2zn)*I4[9];
*(vp++) = U00*I0[28] + U40*I1[28]
           + (threeo2z)*(I2[28] - (lpoz)*I3[28]);
*(vp++) = U00*I0[29] + U40*I1[29]
           + (threeo2z)*(I2[29] - (lpoz)*I3[29]);
*(vp++) = U00*I0[30] + U40*I1[30]
           + (twoo2z)*(I2[30] - (lpoz)*I3[30])
           + (oneo2zn)*I4[10];
*(vp++) = U00*I0[31] + U40*I1[31]
           + (twoo2z)*(I2[31] - (lpoz)*I3[31]);
*(vp++) = U00*I0[32] + U40*I1[32]
           + (twoo2z)*(I2[32] - (lpoz)*I3[32]);
*(vp++) = U00*I0[33] + U40*I1[33]
           + (twoo2z)*(I2[33] - (lpoz)*I3[33])
           + (oneo2zn)*I4[11];
*(vp++) = U00*I0[34] + U40*I1[34]
           + (twoo2z)*(I2[34] - (lpoz)*I3[34]);
*(vp++) = U00*I0[35] + U40*I1[35]
           + (twoo2z)*(I2[35] - (lpoz)*I3[35]);
*(vp++) = U00*I0[36] + U40*I1[36]
           + (twoo2z)*(I2[36] - (lpoz)*I3[36])
           + (oneo2zn)*I4[12];
*(vp++) = U00*I0[37] + U40*I1[37]
           + (twoo2z)*(I2[37] - (lpoz)*I3[37]);
*(vp++) = U00*I0[38] + U40*I1[38]
           + (twoo2z)*(I2[38] - (lpoz)*I3[38]);
*(vp++) = U00*I0[39] + U40*I1[39]
           + (twoo2z)*(I2[39] - (lpoz)*I3[39])
           + (oneo2zn)*I4[13];
*(vp++) = U00*I0[40] + U40*I1[40]
           + (twoo2z)*(I2[40] - (lpoz)*I3[40]);
*(vp++) = U00*I0[41] + U40*I1[41]
           + (twoo2z)*(I2[41] - (lpoz)*I3[41]);
*(vp++) = U00*I0[42] + U40*I1[42]
           + (twoo2z)*(I2[42] - (lpoz)*I3[42])
           + (oneo2zn)*I4[14];
*(vp++) = U00*I0[43] + U40*I1[43]
           + (twoo2z)*(I2[43] - (lpoz)*I3[43]);
*(vp++) = U00*I0[44] + U40*I1[44]
           + (twoo2z)*(I2[44] - (lpoz)*I3[44]);
*(vp++) = U00*I0[45] + U40*I1[45]
           + (oneo2z)*(I2[45] - (lpoz)*I3[45])
           + (oneo2zn)*I4[15];
*(vp++) = U00*I0[46] + U40*I1[46]
           + (oneo2z)*(I2[46] - (lpoz)*I3[46]);
*(vp++) = U00*I0[47] + U40*I1[47]
           + (oneo2z)*(I2[47] - (lpoz)*I3[47]);
*(vp++) = U00*I0[48] + U40*I1[48]
           + (oneo2z)*(I2[48] - (lpoz)*I3[48])
           + (oneo2zn)*I4[16];
*(vp++) = U00*I0[49] + U40*I1[49]
           + (oneo2z)*(I2[49] - (lpoz)*I3[49]);
*(vp++) = U00*I0[50] + U40*I1[50]
           + (oneo2z)*(I2[50] - (lpoz)*I3[50]);
*(vp++) = U00*I0[51] + U40*I1[51]
           + (oneo2z)*(I2[51] - (lpoz)*I3[51])
           + (oneo2zn)*I4[17];
*(vp++) = U00*I0[52] + U40*I1[52]
           + (oneo2z)*(I2[52] - (lpoz)*I3[52]);
*(vp++) = U00*I0[53] + U40*I1[53]
           + (oneo2z)*(I2[53] - (lpoz)*I3[53]);
*(vp++) = U00*I0[54] + U40*I1[54]
           + (oneo2z)*(I2[54] - (lpoz)*I3[54])
           + (oneo2zn)*I4[18];
*(vp++) = U00*I0[55] + U40*I1[55]
           + (oneo2z)*(I2[55] - (lpoz)*I3[55]);
*(vp++) = U00*I0[56] + U40*I1[56]
           + (oneo2z)*(I2[56] - (lpoz)*I3[56]);
*(vp++) = U00*I0[57] + U40*I1[57]
           + (oneo2z)*(I2[57] - (lpoz)*I3[57])
           + (oneo2zn)*I4[19];
*(vp++) = U00*I0[58] + U40*I1[58]
           + (oneo2z)*(I2[58] - (lpoz)*I3[58]);
*(vp++) = U00*I0[59] + U40*I1[59]
           + (oneo2z)*(I2[59] - (lpoz)*I3[59]);
*(vp++) = U00*I0[60] + U40*I1[60]
           + (oneo2z)*(I2[60] - (lpoz)*I3[60])
           + (oneo2zn)*I4[20];
*(vp++) = U00*I0[61] + U40*I1[61]
           + (oneo2z)*(I2[61] - (lpoz)*I3[61]);
*(vp++) = U00*I0[62] + U40*I1[62]
           + (oneo2z)*(I2[62] - (lpoz)*I3[62]);
*(vp++) = U00*I0[63] + U40*I1[63]
           + (oneo2zn)*I4[21];
*(vp++) = U00*I0[64] + U40*I1[64];
*(vp++) = U00*I0[65] + U40*I1[65];
*(vp++) = U00*I0[66] + U40*I1[66]
           + (oneo2zn)*I4[22];
*(vp++) = U00*I0[67] + U40*I1[67];
*(vp++) = U00*I0[68] + U40*I1[68];
*(vp++) = U00*I0[69] + U40*I1[69]
           + (oneo2zn)*I4[23];
*(vp++) = U00*I0[70] + U40*I1[70];
*(vp++) = U00*I0[71] + U40*I1[71];
*(vp++) = U00*I0[72] + U40*I1[72]
           + (oneo2zn)*I4[24];
*(vp++) = U00*I0[73] + U40*I1[73];
*(vp++) = U00*I0[74] + U40*I1[74];
*(vp++) = U00*I0[75] + U40*I1[75]
           + (oneo2zn)*I4[25];
*(vp++) = U00*I0[76] + U40*I1[76];
*(vp++) = U00*I0[77] + U40*I1[77];
*(vp++) = U00*I0[78] + U40*I1[78]
           + (oneo2zn)*I4[26];
*(vp++) = U00*I0[79] + U40*I1[79];
*(vp++) = U00*I0[80] + U40*I1[80];
*(vp++) = U00*I0[81] + U40*I1[81]
           + (oneo2zn)*I4[27];
*(vp++) = U00*I0[82] + U40*I1[82];
*(vp++) = U00*I0[83] + U40*I1[83];
*(vp++) = U01*I0[63] + U41*I1[63]
           + (sixo2z)*(I2[45] - (lpoz)*I3[45]);
*(vp++) = U01*I0[64] + U41*I1[64]
           + (sixo2z)*(I2[46] - (lpoz)*I3[46])
           + (oneo2zn)*I4[21];
*(vp++) = U01*I0[65] + U41*I1[65]
           + (sixo2z)*(I2[47] - (lpoz)*I3[47]);
*(vp++) = U01*I0[66] + U41*I1[66]
           + (fiveo2z)*(I2[48] - (lpoz)*I3[48]);
*(vp++) = U01*I0[67] + U41*I1[67]
           + (fiveo2z)*(I2[49] - (lpoz)*I3[49])
           + (oneo2zn)*I4[22];
*(vp++) = U01*I0[68] + U41*I1[68]
           + (fiveo2z)*(I2[50] - (lpoz)*I3[50]);
*(vp++) = U01*I0[69] + U41*I1[69]
           + (fouro2z)*(I2[51] - (lpoz)*I3[51]);
*(vp++) = U01*I0[70] + U41*I1[70]
           + (fouro2z)*(I2[52] - (lpoz)*I3[52])
           + (oneo2zn)*I4[23];
*(vp++) = U01*I0[71] + U41*I1[71]
           + (fouro2z)*(I2[53] - (lpoz)*I3[53]);
*(vp++) = U01*I0[72] + U41*I1[72]
           + (threeo2z)*(I2[54] - (lpoz)*I3[54]);
*(vp++) = U01*I0[73] + U41*I1[73]
           + (threeo2z)*(I2[55] - (lpoz)*I3[55])
           + (oneo2zn)*I4[24];
*(vp++) = U01*I0[74] + U41*I1[74]
           + (threeo2z)*(I2[56] - (lpoz)*I3[56]);
*(vp++) = U01*I0[75] + U41*I1[75]
           + (twoo2z)*(I2[57] - (lpoz)*I3[57]);
*(vp++) = U01*I0[76] + U41*I1[76]
           + (twoo2z)*(I2[58] - (lpoz)*I3[58])
           + (oneo2zn)*I4[25];
*(vp++) = U01*I0[77] + U41*I1[77]
           + (twoo2z)*(I2[59] - (lpoz)*I3[59]);
*(vp++) = U01*I0[78] + U41*I1[78]
           + (oneo2z)*(I2[60] - (lpoz)*I3[60]);
*(vp++) = U01*I0[79] + U41*I1[79]
           + (oneo2z)*(I2[61] - (lpoz)*I3[61])
           + (oneo2zn)*I4[26];
*(vp++) = U01*I0[80] + U41*I1[80]
           + (oneo2z)*(I2[62] - (lpoz)*I3[62]);
*(vp++) = U01*I0[81] + U41*I1[81];
*(vp++) = U01*I0[82] + U41*I1[82]
           + (oneo2zn)*I4[27];
*(vp++) = U01*I0[83] + U41*I1[83];
*(vp++) = U02*I0[81] + U42*I1[81]
           + (sixo2z)*(I2[60] - (lpoz)*I3[60]);
*(vp++) = U02*I0[82] + U42*I1[82]
           + (sixo2z)*(I2[61] - (lpoz)*I3[61]);
*(vp++) = U02*I0[83] + U42*I1[83]
           + (sixo2z)*(I2[62] - (lpoz)*I3[62])
           + (oneo2zn)*I4[27];

}
/* Total number of FLOPs = 732 */
