/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of |id) integrals */

#include "libint.h"

void hrr3_build_id(const REALTYPE *CD, REALTYPE *vp, REALTYPE *I0, REALTYPE *I1, int ab_num)
{
  const REALTYPE CD0 = CD[0];
  const REALTYPE CD1 = CD[1];
  const REALTYPE CD2 = CD[2];
  int ab;

  for(ab=0;ab<ab_num;ab++) {
    *(vp++) = I0[0] + CD0*I1[0];
    *(vp++) = I0[1] + CD0*I1[1];
    *(vp++) = I0[2] + CD0*I1[2];
    *(vp++) = I0[4] + CD1*I1[1];
    *(vp++) = I0[5] + CD1*I1[2];
    *(vp++) = I0[8] + CD2*I1[2];
    *(vp++) = I0[3] + CD0*I1[3];
    *(vp++) = I0[4] + CD0*I1[4];
    *(vp++) = I0[5] + CD0*I1[5];
    *(vp++) = I0[10] + CD1*I1[4];
    *(vp++) = I0[11] + CD1*I1[5];
    *(vp++) = I0[14] + CD2*I1[5];
    *(vp++) = I0[6] + CD0*I1[6];
    *(vp++) = I0[7] + CD0*I1[7];
    *(vp++) = I0[8] + CD0*I1[8];
    *(vp++) = I0[13] + CD1*I1[7];
    *(vp++) = I0[14] + CD1*I1[8];
    *(vp++) = I0[17] + CD2*I1[8];
    *(vp++) = I0[9] + CD0*I1[9];
    *(vp++) = I0[10] + CD0*I1[10];
    *(vp++) = I0[11] + CD0*I1[11];
    *(vp++) = I0[19] + CD1*I1[10];
    *(vp++) = I0[20] + CD1*I1[11];
    *(vp++) = I0[23] + CD2*I1[11];
    *(vp++) = I0[12] + CD0*I1[12];
    *(vp++) = I0[13] + CD0*I1[13];
    *(vp++) = I0[14] + CD0*I1[14];
    *(vp++) = I0[22] + CD1*I1[13];
    *(vp++) = I0[23] + CD1*I1[14];
    *(vp++) = I0[26] + CD2*I1[14];
    *(vp++) = I0[15] + CD0*I1[15];
    *(vp++) = I0[16] + CD0*I1[16];
    *(vp++) = I0[17] + CD0*I1[17];
    *(vp++) = I0[25] + CD1*I1[16];
    *(vp++) = I0[26] + CD1*I1[17];
    *(vp++) = I0[29] + CD2*I1[17];
    *(vp++) = I0[18] + CD0*I1[18];
    *(vp++) = I0[19] + CD0*I1[19];
    *(vp++) = I0[20] + CD0*I1[20];
    *(vp++) = I0[31] + CD1*I1[19];
    *(vp++) = I0[32] + CD1*I1[20];
    *(vp++) = I0[35] + CD2*I1[20];
    *(vp++) = I0[21] + CD0*I1[21];
    *(vp++) = I0[22] + CD0*I1[22];
    *(vp++) = I0[23] + CD0*I1[23];
    *(vp++) = I0[34] + CD1*I1[22];
    *(vp++) = I0[35] + CD1*I1[23];
    *(vp++) = I0[38] + CD2*I1[23];
    *(vp++) = I0[24] + CD0*I1[24];
    *(vp++) = I0[25] + CD0*I1[25];
    *(vp++) = I0[26] + CD0*I1[26];
    *(vp++) = I0[37] + CD1*I1[25];
    *(vp++) = I0[38] + CD1*I1[26];
    *(vp++) = I0[41] + CD2*I1[26];
    *(vp++) = I0[27] + CD0*I1[27];
    *(vp++) = I0[28] + CD0*I1[28];
    *(vp++) = I0[29] + CD0*I1[29];
    *(vp++) = I0[40] + CD1*I1[28];
    *(vp++) = I0[41] + CD1*I1[29];
    *(vp++) = I0[44] + CD2*I1[29];
    *(vp++) = I0[30] + CD0*I1[30];
    *(vp++) = I0[31] + CD0*I1[31];
    *(vp++) = I0[32] + CD0*I1[32];
    *(vp++) = I0[46] + CD1*I1[31];
    *(vp++) = I0[47] + CD1*I1[32];
    *(vp++) = I0[50] + CD2*I1[32];
    *(vp++) = I0[33] + CD0*I1[33];
    *(vp++) = I0[34] + CD0*I1[34];
    *(vp++) = I0[35] + CD0*I1[35];
    *(vp++) = I0[49] + CD1*I1[34];
    *(vp++) = I0[50] + CD1*I1[35];
    *(vp++) = I0[53] + CD2*I1[35];
    *(vp++) = I0[36] + CD0*I1[36];
    *(vp++) = I0[37] + CD0*I1[37];
    *(vp++) = I0[38] + CD0*I1[38];
    *(vp++) = I0[52] + CD1*I1[37];
    *(vp++) = I0[53] + CD1*I1[38];
    *(vp++) = I0[56] + CD2*I1[38];
    *(vp++) = I0[39] + CD0*I1[39];
    *(vp++) = I0[40] + CD0*I1[40];
    *(vp++) = I0[41] + CD0*I1[41];
    *(vp++) = I0[55] + CD1*I1[40];
    *(vp++) = I0[56] + CD1*I1[41];
    *(vp++) = I0[59] + CD2*I1[41];
    *(vp++) = I0[42] + CD0*I1[42];
    *(vp++) = I0[43] + CD0*I1[43];
    *(vp++) = I0[44] + CD0*I1[44];
    *(vp++) = I0[58] + CD1*I1[43];
    *(vp++) = I0[59] + CD1*I1[44];
    *(vp++) = I0[62] + CD2*I1[44];
    *(vp++) = I0[45] + CD0*I1[45];
    *(vp++) = I0[46] + CD0*I1[46];
    *(vp++) = I0[47] + CD0*I1[47];
    *(vp++) = I0[64] + CD1*I1[46];
    *(vp++) = I0[65] + CD1*I1[47];
    *(vp++) = I0[68] + CD2*I1[47];
    *(vp++) = I0[48] + CD0*I1[48];
    *(vp++) = I0[49] + CD0*I1[49];
    *(vp++) = I0[50] + CD0*I1[50];
    *(vp++) = I0[67] + CD1*I1[49];
    *(vp++) = I0[68] + CD1*I1[50];
    *(vp++) = I0[71] + CD2*I1[50];
    *(vp++) = I0[51] + CD0*I1[51];
    *(vp++) = I0[52] + CD0*I1[52];
    *(vp++) = I0[53] + CD0*I1[53];
    *(vp++) = I0[70] + CD1*I1[52];
    *(vp++) = I0[71] + CD1*I1[53];
    *(vp++) = I0[74] + CD2*I1[53];
    *(vp++) = I0[54] + CD0*I1[54];
    *(vp++) = I0[55] + CD0*I1[55];
    *(vp++) = I0[56] + CD0*I1[56];
    *(vp++) = I0[73] + CD1*I1[55];
    *(vp++) = I0[74] + CD1*I1[56];
    *(vp++) = I0[77] + CD2*I1[56];
    *(vp++) = I0[57] + CD0*I1[57];
    *(vp++) = I0[58] + CD0*I1[58];
    *(vp++) = I0[59] + CD0*I1[59];
    *(vp++) = I0[76] + CD1*I1[58];
    *(vp++) = I0[77] + CD1*I1[59];
    *(vp++) = I0[80] + CD2*I1[59];
    *(vp++) = I0[60] + CD0*I1[60];
    *(vp++) = I0[61] + CD0*I1[61];
    *(vp++) = I0[62] + CD0*I1[62];
    *(vp++) = I0[79] + CD1*I1[61];
    *(vp++) = I0[80] + CD1*I1[62];
    *(vp++) = I0[83] + CD2*I1[62];
    *(vp++) = I0[63] + CD0*I1[63];
    *(vp++) = I0[64] + CD0*I1[64];
    *(vp++) = I0[65] + CD0*I1[65];
    *(vp++) = I0[85] + CD1*I1[64];
    *(vp++) = I0[86] + CD1*I1[65];
    *(vp++) = I0[89] + CD2*I1[65];
    *(vp++) = I0[66] + CD0*I1[66];
    *(vp++) = I0[67] + CD0*I1[67];
    *(vp++) = I0[68] + CD0*I1[68];
    *(vp++) = I0[88] + CD1*I1[67];
    *(vp++) = I0[89] + CD1*I1[68];
    *(vp++) = I0[92] + CD2*I1[68];
    *(vp++) = I0[69] + CD0*I1[69];
    *(vp++) = I0[70] + CD0*I1[70];
    *(vp++) = I0[71] + CD0*I1[71];
    *(vp++) = I0[91] + CD1*I1[70];
    *(vp++) = I0[92] + CD1*I1[71];
    *(vp++) = I0[95] + CD2*I1[71];
    *(vp++) = I0[72] + CD0*I1[72];
    *(vp++) = I0[73] + CD0*I1[73];
    *(vp++) = I0[74] + CD0*I1[74];
    *(vp++) = I0[94] + CD1*I1[73];
    *(vp++) = I0[95] + CD1*I1[74];
    *(vp++) = I0[98] + CD2*I1[74];
    *(vp++) = I0[75] + CD0*I1[75];
    *(vp++) = I0[76] + CD0*I1[76];
    *(vp++) = I0[77] + CD0*I1[77];
    *(vp++) = I0[97] + CD1*I1[76];
    *(vp++) = I0[98] + CD1*I1[77];
    *(vp++) = I0[101] + CD2*I1[77];
    *(vp++) = I0[78] + CD0*I1[78];
    *(vp++) = I0[79] + CD0*I1[79];
    *(vp++) = I0[80] + CD0*I1[80];
    *(vp++) = I0[100] + CD1*I1[79];
    *(vp++) = I0[101] + CD1*I1[80];
    *(vp++) = I0[104] + CD2*I1[80];
    *(vp++) = I0[81] + CD0*I1[81];
    *(vp++) = I0[82] + CD0*I1[82];
    *(vp++) = I0[83] + CD0*I1[83];
    *(vp++) = I0[103] + CD1*I1[82];
    *(vp++) = I0[104] + CD1*I1[83];
    *(vp++) = I0[107] + CD2*I1[83];
    I0 += 108;
    I1 += 84;
  }
}
/* Total number of FLOPs = 336 * ab_num */
