/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_d0ih(Libint_t*, prim_data*);

  /* Computes quartets of (d0|ih) integrals */

REALTYPE *hrr_order_d0ih(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][6] = int_stack + 0;
 Libint->vrr_classes[2][7] = int_stack + 168;
 Libint->vrr_classes[2][8] = int_stack + 384;
 Libint->vrr_classes[2][9] = int_stack + 654;
 Libint->vrr_classes[2][10] = int_stack + 984;
 Libint->vrr_classes[2][11] = int_stack + 1380;
 memset(int_stack,0,1848*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1848;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_d0ih(Libint, Data);
   Data++;
 }
 /*--- compute (d0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+1848,int_stack+168,int_stack+0,6);
 /*--- compute (d0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+2352,int_stack+384,int_stack+168,6);
 /*--- compute (d0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+3000,int_stack+2352,int_stack+1848,6);
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+4008,int_stack+654,int_stack+384,6);
 /*--- compute (d0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+4818,int_stack+4008,int_stack+2352,6);
 /*--- compute (d0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+6114,int_stack+4818,int_stack+3000,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1848,int_stack+984,int_stack+654,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+7794,int_stack+1848,int_stack+4008,6);
 /*--- compute (d0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+9414,int_stack+7794,int_stack+4818,6);
 /*--- compute (d0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+2838,int_stack+9414,int_stack+6114,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+5358,int_stack+1380,int_stack+984,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+11574,int_stack+5358,int_stack+1848,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+11574,int_stack+7794,6);
 /*--- compute (d0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+5358,int_stack+0,int_stack+9414,6);
 /*--- compute (d0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+8598,int_stack+5358,int_stack+2838,6);
 return int_stack+8598;}
