/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_d0nn(Libint_t*, prim_data*);

  /* Computes quartets of (d0|nn) integrals */

REALTYPE *hrr_order_d0nn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][10] = int_stack + 0;
 Libint->vrr_classes[2][11] = int_stack + 396;
 Libint->vrr_classes[2][12] = int_stack + 864;
 Libint->vrr_classes[2][13] = int_stack + 1410;
 Libint->vrr_classes[2][14] = int_stack + 2040;
 Libint->vrr_classes[2][15] = int_stack + 2760;
 Libint->vrr_classes[2][16] = int_stack + 3576;
 Libint->vrr_classes[2][17] = int_stack + 4494;
 Libint->vrr_classes[2][18] = int_stack + 5520;
 Libint->vrr_classes[2][19] = int_stack + 6660;
 Libint->vrr_classes[2][20] = int_stack + 7920;
 memset(int_stack,0,9306*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 9306;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_d0nn(Libint, Data);
   Data++;
 }
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9306,int_stack+396,int_stack+0,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10494,int_stack+864,int_stack+396,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+11898,int_stack+10494,int_stack+9306,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+14274,int_stack+1410,int_stack+864,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+15912,int_stack+14274,int_stack+10494,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+18720,int_stack+15912,int_stack+11898,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+9306,int_stack+2040,int_stack+1410,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+22680,int_stack+9306,int_stack+14274,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+11196,int_stack+22680,int_stack+15912,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+25956,int_stack+11196,int_stack+18720,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+15876,int_stack+2760,int_stack+2040,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+18036,int_stack+15876,int_stack+9306,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+31896,int_stack+18036,int_stack+22680,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+37356,int_stack+31896,int_stack+11196,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+44376,int_stack+37356,int_stack+25956,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+9306,int_stack+3576,int_stack+2760,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+21816,int_stack+9306,int_stack+15876,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+52692,int_stack+21816,int_stack+18036,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+11754,int_stack+52692,int_stack+31896,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+26136,int_stack+11754,int_stack+37356,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+58992,int_stack+26136,int_stack+44376,6);
 /*--- compute (d0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+35964,int_stack+4494,int_stack+3576,6);
 /*--- compute (d0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+38718,int_stack+35964,int_stack+9306,6);
 /*--- compute (d0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+43614,int_stack+38718,int_stack+21816,6);
 /*--- compute (d0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+70080,int_stack+43614,int_stack+52692,6);
 /*--- compute (d0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+79530,int_stack+70080,int_stack+11754,6);
 /*--- compute (d0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+9306,int_stack+79530,int_stack+26136,6);
 /*--- compute (d0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+90996,int_stack+9306,int_stack+58992,6);
 /*--- compute (d0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+22410,int_stack+5520,int_stack+4494,6);
 /*--- compute (d0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+25488,int_stack+22410,int_stack+35964,6);
 /*--- compute (d0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+50814,int_stack+25488,int_stack+38718,6);
 /*--- compute (d0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+30996,int_stack+50814,int_stack+43614,6);
 /*--- compute (d0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+105252,int_stack+30996,int_stack+70080,6);
 /*--- compute (d0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+58974,int_stack+105252,int_stack+79530,6);
 /*--- compute (d0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+118482,int_stack+58974,int_stack+9306,6);
 /*--- compute (d0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+135330,int_stack+118482,int_stack+90996,6);
 /*--- compute (d0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+9306,int_stack+6660,int_stack+5520,6);
 /*--- compute (d0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+12726,int_stack+9306,int_stack+22410,6);
 /*--- compute (d0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+74262,int_stack+12726,int_stack+25488,6);
 /*--- compute (d0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+83442,int_stack+74262,int_stack+50814,6);
 /*--- compute (d0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+41796,int_stack+83442,int_stack+30996,6);
 /*--- compute (d0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+18882,int_stack+41796,int_stack+105252,6);
 /*--- compute (d0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+95682,int_stack+18882,int_stack+58974,6);
 /*--- compute (d0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+153150,int_stack+95682,int_stack+118482,6);
 /*--- compute (d0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+174210,int_stack+153150,int_stack+135330,6);
 /*--- compute (d0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+36522,int_stack+7920,int_stack+6660,6);
 /*--- compute (d0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+56916,int_stack+36522,int_stack+9306,6);
 /*--- compute (d0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+63756,int_stack+56916,int_stack+12726,6);
 /*--- compute (d0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+115338,int_stack+63756,int_stack+74262,6);
 /*--- compute (d0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+56916,int_stack+115338,int_stack+83442,6);
 /*--- compute (d0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+115338,int_stack+56916,int_stack+41796,6);
 /*--- compute (d0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+36522,int_stack+115338,int_stack+18882,6);
 /*--- compute (d0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+115338,int_stack+36522,int_stack+95682,6);
 /*--- compute (d0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+115338,int_stack+153150,6);
 /*--- compute (d0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+25740,int_stack+0,int_stack+174210,6);
 return int_stack+25740;}
