/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddih(Libint_t*, prim_data*);

  /* Computes quartets of (dd|ih) integrals */

REALTYPE *hrr_order_ddih(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][6] = int_stack + 0;
 Libint->vrr_classes[2][7] = int_stack + 168;
 Libint->vrr_classes[2][8] = int_stack + 384;
 Libint->vrr_classes[2][9] = int_stack + 654;
 Libint->vrr_classes[2][10] = int_stack + 984;
 Libint->vrr_classes[2][11] = int_stack + 1380;
 Libint->vrr_classes[3][6] = int_stack + 1848;
 Libint->vrr_classes[3][7] = int_stack + 2128;
 Libint->vrr_classes[3][8] = int_stack + 2488;
 Libint->vrr_classes[3][9] = int_stack + 2938;
 Libint->vrr_classes[3][10] = int_stack + 3488;
 Libint->vrr_classes[3][11] = int_stack + 4148;
 Libint->vrr_classes[4][6] = int_stack + 4928;
 Libint->vrr_classes[4][7] = int_stack + 5348;
 Libint->vrr_classes[4][8] = int_stack + 5888;
 Libint->vrr_classes[4][9] = int_stack + 6563;
 Libint->vrr_classes[4][10] = int_stack + 7388;
 Libint->vrr_classes[4][11] = int_stack + 8378;
 memset(int_stack,0,9548*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 9548;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddih(Libint, Data);
   Data++;
 }
 /*--- compute (d0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+9548,int_stack+168,int_stack+0,6);
 /*--- compute (d0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+10052,int_stack+384,int_stack+168,6);
 /*--- compute (d0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+10700,int_stack+10052,int_stack+9548,6);
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+11708,int_stack+654,int_stack+384,6);
 /*--- compute (d0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+12518,int_stack+11708,int_stack+10052,6);
 /*--- compute (d0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+13814,int_stack+12518,int_stack+10700,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+9548,int_stack+984,int_stack+654,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+15494,int_stack+9548,int_stack+11708,6);
 /*--- compute (d0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+17114,int_stack+15494,int_stack+12518,6);
 /*--- compute (d0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+10538,int_stack+17114,int_stack+13814,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+13058,int_stack+1380,int_stack+984,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19274,int_stack+13058,int_stack+9548,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+21254,int_stack+19274,int_stack+15494,6);
 /*--- compute (d0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+13058,int_stack+21254,int_stack+17114,6);
 /*--- compute (d0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+16298,int_stack+13058,int_stack+10538,6);
 /*--- compute (f0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+9548,int_stack+2128,int_stack+1848,10);
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+10388,int_stack+2488,int_stack+2128,10);
 /*--- compute (f0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+11468,int_stack+10388,int_stack+9548,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+13148,int_stack+2938,int_stack+2488,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+19826,int_stack+13148,int_stack+10388,10);
 /*--- compute (f0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+19826,int_stack+11468,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+9548,int_stack+3488,int_stack+2938,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+21986,int_stack+9548,int_stack+13148,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+11198,int_stack+21986,int_stack+19826,10);
 /*--- compute (f0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+24686,int_stack+11198,int_stack+0,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+4148,int_stack+3488,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28886,int_stack+0,int_stack+9548,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+28886,int_stack+21986,10);
 /*--- compute (f0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+28886,int_stack+0,int_stack+11198,10);
 /*--- compute (f0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+9548,int_stack+28886,int_stack+24686,10);
 /*--- compute (dp|ih) ---*/
 hrr1_build_dp(Libint->AB,int_stack+19826,int_stack+9548,int_stack+16298,588);
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+5348,int_stack+4928,15);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+1260,int_stack+5888,int_stack+5348,15);
 /*--- compute (g0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+2880,int_stack+1260,int_stack+0,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15428,int_stack+6563,int_stack+5888,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+30410,int_stack+15428,int_stack+1260,15);
 /*--- compute (g0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+33650,int_stack+30410,int_stack+2880,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+7388,int_stack+6563,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+2475,int_stack+0,int_stack+15428,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+37850,int_stack+2475,int_stack+30410,15);
 /*--- compute (g0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+43250,int_stack+37850,int_stack+33650,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+30410,int_stack+8378,int_stack+7388,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+49550,int_stack+30410,int_stack+0,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+30410,int_stack+49550,int_stack+2475,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+30410,int_stack+37850,15);
 /*--- compute (g0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+30410,int_stack+0,int_stack+43250,15);
 /*--- compute (fp|ih) ---*/
 hrr1_build_fp(Libint->AB,int_stack+39230,int_stack+30410,int_stack+9548,588);
 /*--- compute (dd|ih) ---*/
 hrr1_build_dd(Libint->AB,int_stack+56870,int_stack+39230,int_stack+19826,588);
 return int_stack+56870;}
