/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddld(Libint_t*, prim_data*);

  /* Computes quartets of (dd|ld) integrals */

REALTYPE *hrr_order_ddld(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][8] = int_stack + 0;
 Libint->vrr_classes[2][9] = int_stack + 270;
 Libint->vrr_classes[2][10] = int_stack + 600;
 Libint->vrr_classes[3][8] = int_stack + 996;
 Libint->vrr_classes[3][9] = int_stack + 1446;
 Libint->vrr_classes[3][10] = int_stack + 1996;
 Libint->vrr_classes[4][8] = int_stack + 2656;
 Libint->vrr_classes[4][9] = int_stack + 3331;
 Libint->vrr_classes[4][10] = int_stack + 4156;
 memset(int_stack,0,5146*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 5146;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddld(Libint, Data);
   Data++;
 }
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5146,int_stack+270,int_stack+0,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+5956,int_stack+600,int_stack+270,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+6946,int_stack+5956,int_stack+5146,6);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5146,int_stack+1446,int_stack+996,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8566,int_stack+1996,int_stack+1446,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+10216,int_stack+8566,int_stack+5146,10);
 /*--- compute (dp|ld) ---*/
 hrr1_build_dp(Libint->AB,int_stack+12916,int_stack+10216,int_stack+6946,270);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5146,int_stack+3331,int_stack+2656,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7171,int_stack+4156,int_stack+3331,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+7171,int_stack+5146,15);
 /*--- compute (fp|ld) ---*/
 hrr1_build_fp(Libint->AB,int_stack+17776,int_stack+0,int_stack+10216,270);
 /*--- compute (dd|ld) ---*/
 hrr1_build_dd(Libint->AB,int_stack+0,int_stack+17776,int_stack+12916,270);
 return int_stack+0;}
