/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddli(Libint_t*, prim_data*);

  /* Computes quartets of (dd|li) integrals */

REALTYPE *hrr_order_ddli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][8] = int_stack + 0;
 Libint->vrr_classes[2][9] = int_stack + 270;
 Libint->vrr_classes[2][10] = int_stack + 600;
 Libint->vrr_classes[2][11] = int_stack + 996;
 Libint->vrr_classes[2][12] = int_stack + 1464;
 Libint->vrr_classes[2][13] = int_stack + 2010;
 Libint->vrr_classes[2][14] = int_stack + 2640;
 Libint->vrr_classes[3][8] = int_stack + 3360;
 Libint->vrr_classes[3][9] = int_stack + 3810;
 Libint->vrr_classes[3][10] = int_stack + 4360;
 Libint->vrr_classes[3][11] = int_stack + 5020;
 Libint->vrr_classes[3][12] = int_stack + 5800;
 Libint->vrr_classes[3][13] = int_stack + 6710;
 Libint->vrr_classes[3][14] = int_stack + 7760;
 Libint->vrr_classes[4][8] = int_stack + 8960;
 Libint->vrr_classes[4][9] = int_stack + 9635;
 Libint->vrr_classes[4][10] = int_stack + 10460;
 Libint->vrr_classes[4][11] = int_stack + 11450;
 Libint->vrr_classes[4][12] = int_stack + 12620;
 Libint->vrr_classes[4][13] = int_stack + 13985;
 Libint->vrr_classes[4][14] = int_stack + 15560;
 memset(int_stack,0,17360*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 17360;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddli(Libint, Data);
   Data++;
 }
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+17360,int_stack+270,int_stack+0,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+18170,int_stack+600,int_stack+270,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19160,int_stack+18170,int_stack+17360,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+20780,int_stack+996,int_stack+600,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+21968,int_stack+20780,int_stack+18170,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+23948,int_stack+21968,int_stack+19160,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+17360,int_stack+1464,int_stack+996,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+26648,int_stack+17360,int_stack+20780,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+29024,int_stack+26648,int_stack+21968,6);
 /*--- compute (d0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+18764,int_stack+29024,int_stack+23948,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+22814,int_stack+2010,int_stack+1464,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+32324,int_stack+22814,int_stack+17360,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+35132,int_stack+32324,int_stack+26648,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+39092,int_stack+35132,int_stack+29024,6);
 /*--- compute (d0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+24452,int_stack+39092,int_stack+18764,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+17360,int_stack+2640,int_stack+2010,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+19250,int_stack+17360,int_stack+22814,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+44042,int_stack+19250,int_stack+32324,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+17360,int_stack+44042,int_stack+35132,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+30122,int_stack+17360,int_stack+39092,6);
 /*--- compute (d0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+37052,int_stack+30122,int_stack+24452,6);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+17360,int_stack+3810,int_stack+3360,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+18710,int_stack+4360,int_stack+3810,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+20360,int_stack+18710,int_stack+17360,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+23060,int_stack+5020,int_stack+4360,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+25040,int_stack+23060,int_stack+18710,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+28340,int_stack+25040,int_stack+20360,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+17360,int_stack+5800,int_stack+5020,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+32840,int_stack+17360,int_stack+23060,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+32840,int_stack+25040,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+19700,int_stack+0,int_stack+28340,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+26450,int_stack+6710,int_stack+5800,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+44612,int_stack+26450,int_stack+17360,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+49292,int_stack+44612,int_stack+32840,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+55892,int_stack+49292,int_stack+0,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+64142,int_stack+55892,int_stack+19700,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+7760,int_stack+6710,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3150,int_stack+0,int_stack+26450,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+17360,int_stack+3150,int_stack+44612,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+25160,int_stack+17360,int_stack+49292,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+73592,int_stack+25160,int_stack+55892,10);
 /*--- compute (f0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+17360,int_stack+73592,int_stack+64142,10);
 /*--- compute (dp|li) ---*/
 hrr1_build_dp(Libint->AB,int_stack+44612,int_stack+17360,int_stack+37052,1260);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+29960,int_stack+9635,int_stack+8960,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+31985,int_stack+10460,int_stack+9635,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+34460,int_stack+31985,int_stack+29960,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+38510,int_stack+11450,int_stack+10460,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+67292,int_stack+38510,int_stack+31985,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+72242,int_stack+67292,int_stack+34460,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+29960,int_stack+12620,int_stack+11450,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+78992,int_stack+29960,int_stack+38510,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+33470,int_stack+78992,int_stack+67292,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+33470,int_stack+72242,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+67292,int_stack+13985,int_stack+12620,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+71387,int_stack+67292,int_stack+29960,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+84932,int_stack+71387,int_stack+78992,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+94832,int_stack+84932,int_stack+33470,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+29960,int_stack+94832,int_stack+0,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+15560,int_stack+13985,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+4725,int_stack+0,int_stack+67292,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+107207,int_stack+4725,int_stack+71387,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+67292,int_stack+107207,int_stack+84932,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+67292,int_stack+94832,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+67292,int_stack+0,int_stack+29960,15);
 /*--- compute (fp|li) ---*/
 hrr1_build_fp(Libint->AB,int_stack+86192,int_stack+67292,int_stack+17360,1260);
 /*--- compute (dd|li) ---*/
 hrr1_build_dd(Libint->AB,int_stack+123992,int_stack+86192,int_stack+44612,1260);
 return int_stack+123992;}
