/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddnd(Libint_t*, prim_data*);

  /* Computes quartets of (dd|nd) integrals */

REALTYPE *hrr_order_ddnd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][10] = int_stack + 0;
 Libint->vrr_classes[2][11] = int_stack + 396;
 Libint->vrr_classes[2][12] = int_stack + 864;
 Libint->vrr_classes[3][10] = int_stack + 1410;
 Libint->vrr_classes[3][11] = int_stack + 2070;
 Libint->vrr_classes[3][12] = int_stack + 2850;
 Libint->vrr_classes[4][10] = int_stack + 3760;
 Libint->vrr_classes[4][11] = int_stack + 4750;
 Libint->vrr_classes[4][12] = int_stack + 5920;
 memset(int_stack,0,7285*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 7285;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddnd(Libint, Data);
   Data++;
 }
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7285,int_stack+396,int_stack+0,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8473,int_stack+864,int_stack+396,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+9877,int_stack+8473,int_stack+7285,6);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7285,int_stack+2070,int_stack+1410,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+12253,int_stack+2850,int_stack+2070,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+14593,int_stack+12253,int_stack+7285,10);
 /*--- compute (dp|nd) ---*/
 hrr1_build_dp(Libint->AB,int_stack+18553,int_stack+14593,int_stack+9877,396);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7285,int_stack+4750,int_stack+3760,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10255,int_stack+5920,int_stack+4750,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+10255,int_stack+7285,15);
 /*--- compute (fp|nd) ---*/
 hrr1_build_fp(Libint->AB,int_stack+25681,int_stack+0,int_stack+14593,396);
 /*--- compute (dd|nd) ---*/
 hrr1_build_dd(Libint->AB,int_stack+0,int_stack+25681,int_stack+18553,396);
 return int_stack+0;}
