/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdmh(Libint_t*, prim_data*);

  /* Computes quartets of (fd|mh) integrals */

REALTYPE *hrr_order_fdmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][9] = int_stack + 0;
 Libint->vrr_classes[3][10] = int_stack + 550;
 Libint->vrr_classes[3][11] = int_stack + 1210;
 Libint->vrr_classes[3][12] = int_stack + 1990;
 Libint->vrr_classes[3][13] = int_stack + 2900;
 Libint->vrr_classes[3][14] = int_stack + 3950;
 Libint->vrr_classes[4][9] = int_stack + 5150;
 Libint->vrr_classes[4][10] = int_stack + 5975;
 Libint->vrr_classes[4][11] = int_stack + 6965;
 Libint->vrr_classes[4][12] = int_stack + 8135;
 Libint->vrr_classes[4][13] = int_stack + 9500;
 Libint->vrr_classes[4][14] = int_stack + 11075;
 Libint->vrr_classes[5][9] = int_stack + 12875;
 Libint->vrr_classes[5][10] = int_stack + 14030;
 Libint->vrr_classes[5][11] = int_stack + 15416;
 Libint->vrr_classes[5][12] = int_stack + 17054;
 Libint->vrr_classes[5][13] = int_stack + 18965;
 Libint->vrr_classes[5][14] = int_stack + 21170;
 memset(int_stack,0,23690*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 23690;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdmh(Libint, Data);
   Data++;
 }
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+23690,int_stack+550,int_stack+0,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+25340,int_stack+1210,int_stack+550,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+27320,int_stack+25340,int_stack+23690,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+30620,int_stack+1990,int_stack+1210,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+32960,int_stack+30620,int_stack+25340,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+36920,int_stack+32960,int_stack+27320,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+23690,int_stack+2900,int_stack+1990,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+42420,int_stack+23690,int_stack+30620,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+47100,int_stack+42420,int_stack+32960,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+26420,int_stack+47100,int_stack+36920,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+34670,int_stack+3950,int_stack+2900,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+53700,int_stack+34670,int_stack+23690,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+59160,int_stack+53700,int_stack+42420,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+34670,int_stack+59160,int_stack+47100,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+44570,int_stack+34670,int_stack+26420,10);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+23690,int_stack+5975,int_stack+5150,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+26165,int_stack+6965,int_stack+5975,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+29135,int_stack+26165,int_stack+23690,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+34085,int_stack+8135,int_stack+6965,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+37595,int_stack+34085,int_stack+26165,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+56120,int_stack+37595,int_stack+29135,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+23690,int_stack+9500,int_stack+8135,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+23690,int_stack+34085,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+64370,int_stack+0,int_stack+37595,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+27785,int_stack+64370,int_stack+56120,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+56120,int_stack+11075,int_stack+9500,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+74270,int_stack+56120,int_stack+23690,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+82460,int_stack+74270,int_stack+0,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+94160,int_stack+82460,int_stack+64370,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+56120,int_stack+94160,int_stack+27785,15);
 /*--- compute (fp|mh) ---*/
 hrr1_build_fp(Libint->AB,int_stack+73445,int_stack+56120,int_stack+44570,1155);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+14030,int_stack+12875,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3465,int_stack+15416,int_stack+14030,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+7623,int_stack+3465,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+23690,int_stack+17054,int_stack+15416,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28604,int_stack+23690,int_stack+3465,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+36920,int_stack+28604,int_stack+7623,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+18965,int_stack+17054,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+5733,int_stack+0,int_stack+23690,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+108095,int_stack+5733,int_stack+28604,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+121955,int_stack+108095,int_stack+36920,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+23690,int_stack+21170,int_stack+18965,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+30305,int_stack+23690,int_stack+0,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+139280,int_stack+30305,int_stack+5733,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+139280,int_stack+108095,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+20790,int_stack+0,int_stack+121955,21);
 /*--- compute (gp|mh) ---*/
 hrr1_build_gp(Libint->AB,int_stack+108095,int_stack+20790,int_stack+56120,1155);
 /*--- compute (fd|mh) ---*/
 hrr1_build_fd(Libint->AB,int_stack+0,int_stack+108095,int_stack+73445,1155);
 return int_stack+0;}
