/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdnf(Libint_t*, prim_data*);

  /* Computes quartets of (fd|nf) integrals */

REALTYPE *hrr_order_fdnf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][10] = int_stack + 0;
 Libint->vrr_classes[3][11] = int_stack + 660;
 Libint->vrr_classes[3][12] = int_stack + 1440;
 Libint->vrr_classes[3][13] = int_stack + 2350;
 Libint->vrr_classes[4][10] = int_stack + 3400;
 Libint->vrr_classes[4][11] = int_stack + 4390;
 Libint->vrr_classes[4][12] = int_stack + 5560;
 Libint->vrr_classes[4][13] = int_stack + 6925;
 Libint->vrr_classes[5][10] = int_stack + 8500;
 Libint->vrr_classes[5][11] = int_stack + 9886;
 Libint->vrr_classes[5][12] = int_stack + 11524;
 Libint->vrr_classes[5][13] = int_stack + 13435;
 memset(int_stack,0,15640*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 15640;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdnf(Libint, Data);
   Data++;
 }
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15640,int_stack+660,int_stack+0,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+17620,int_stack+1440,int_stack+660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+19960,int_stack+17620,int_stack+15640,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+23920,int_stack+2350,int_stack+1440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+26650,int_stack+23920,int_stack+17620,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+31330,int_stack+26650,int_stack+19960,10);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15640,int_stack+4390,int_stack+3400,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18610,int_stack+5560,int_stack+4390,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+22120,int_stack+18610,int_stack+15640,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+6925,int_stack+5560,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+37930,int_stack+0,int_stack+18610,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+44950,int_stack+37930,int_stack+22120,15);
 /*--- compute (fp|nf) ---*/
 hrr1_build_fp(Libint->AB,int_stack+54850,int_stack+44950,int_stack+31330,660);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+9886,int_stack+8500,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+4158,int_stack+11524,int_stack+9886,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+15640,int_stack+4158,int_stack+0,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+23956,int_stack+13435,int_stack+11524,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+29689,int_stack+23956,int_stack+4158,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+29689,int_stack+15640,21);
 /*--- compute (gp|nf) ---*/
 hrr1_build_gp(Libint->AB,int_stack+13860,int_stack+0,int_stack+44950,660);
 /*--- compute (fd|nf) ---*/
 hrr1_build_fd(Libint->AB,int_stack+74650,int_stack+13860,int_stack+54850,660);
 return int_stack+74650;}
