/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdnp(Libint_t*, prim_data*);

  /* Computes quartets of (fd|np) integrals */

REALTYPE *hrr_order_fdnp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][10] = int_stack + 0;
 Libint->vrr_classes[3][11] = int_stack + 660;
 Libint->vrr_classes[4][10] = int_stack + 1440;
 Libint->vrr_classes[4][11] = int_stack + 2430;
 Libint->vrr_classes[5][10] = int_stack + 3600;
 Libint->vrr_classes[5][11] = int_stack + 4986;
 memset(int_stack,0,6624*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 6624;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdnp(Libint, Data);
   Data++;
 }
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+6624,int_stack+660,int_stack+0,10);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+8604,int_stack+2430,int_stack+1440,15);
 /*--- compute (fp|np) ---*/
 hrr1_build_fp(Libint->AB,int_stack+11574,int_stack+8604,int_stack+6624,198);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17514,int_stack+4986,int_stack+3600,21);
 /*--- compute (gp|np) ---*/
 hrr1_build_gp(Libint->AB,int_stack+21672,int_stack+17514,int_stack+8604,198);
 /*--- compute (fd|np) ---*/
 hrr1_build_fd(Libint->AB,int_stack+30582,int_stack+21672,int_stack+11574,198);
 return int_stack+30582;}
