/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffk0(Libint_t*, prim_data*);

  /* Computes quartets of (ff|k0) integrals */

REALTYPE *hrr_order_ffk0(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][7] = int_stack + 0;
 Libint->vrr_classes[4][7] = int_stack + 360;
 Libint->vrr_classes[5][7] = int_stack + 900;
 Libint->vrr_classes[6][7] = int_stack + 1656;
 memset(int_stack,0,2664*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 2664;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffk0(Libint, Data);
   Data++;
 }
 /*--- compute (fp|k0) ---*/
 hrr1_build_fp(Libint->AB,int_stack+2664,int_stack+360,int_stack+0,36);
 /*--- compute (gp|k0) ---*/
 hrr1_build_gp(Libint->AB,int_stack+3744,int_stack+900,int_stack+360,36);
 /*--- compute (fd|k0) ---*/
 hrr1_build_fd(Libint->AB,int_stack+5364,int_stack+3744,int_stack+2664,36);
 /*--- compute (hp|k0) ---*/
 hrr1_build_hp(Libint->AB,int_stack+7524,int_stack+1656,int_stack+900,36);
 /*--- compute (gd|k0) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+7524,int_stack+3744,36);
 /*--- compute (ff|k0) ---*/
 hrr1_build_ff(Libint->AB,int_stack+7524,int_stack+0,int_stack+5364,36);
 return int_stack+7524;}
