/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffmi(Libint_t*, prim_data*);

  /* Computes quartets of (ff|mi) integrals */

REALTYPE *hrr_order_ffmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][9] = int_stack + 0;
 Libint->vrr_classes[3][10] = int_stack + 550;
 Libint->vrr_classes[3][11] = int_stack + 1210;
 Libint->vrr_classes[3][12] = int_stack + 1990;
 Libint->vrr_classes[3][13] = int_stack + 2900;
 Libint->vrr_classes[3][14] = int_stack + 3950;
 Libint->vrr_classes[3][15] = int_stack + 5150;
 Libint->vrr_classes[4][9] = int_stack + 6510;
 Libint->vrr_classes[4][10] = int_stack + 7335;
 Libint->vrr_classes[4][11] = int_stack + 8325;
 Libint->vrr_classes[4][12] = int_stack + 9495;
 Libint->vrr_classes[4][13] = int_stack + 10860;
 Libint->vrr_classes[4][14] = int_stack + 12435;
 Libint->vrr_classes[4][15] = int_stack + 14235;
 Libint->vrr_classes[5][9] = int_stack + 16275;
 Libint->vrr_classes[5][10] = int_stack + 17430;
 Libint->vrr_classes[5][11] = int_stack + 18816;
 Libint->vrr_classes[5][12] = int_stack + 20454;
 Libint->vrr_classes[5][13] = int_stack + 22365;
 Libint->vrr_classes[5][14] = int_stack + 24570;
 Libint->vrr_classes[5][15] = int_stack + 27090;
 Libint->vrr_classes[6][9] = int_stack + 29946;
 Libint->vrr_classes[6][10] = int_stack + 31486;
 Libint->vrr_classes[6][11] = int_stack + 33334;
 Libint->vrr_classes[6][12] = int_stack + 35518;
 Libint->vrr_classes[6][13] = int_stack + 38066;
 Libint->vrr_classes[6][14] = int_stack + 41006;
 Libint->vrr_classes[6][15] = int_stack + 44366;
 memset(int_stack,0,48174*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 48174;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffmi(Libint, Data);
   Data++;
 }
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+48174,int_stack+550,int_stack+0,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+49824,int_stack+1210,int_stack+550,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+51804,int_stack+49824,int_stack+48174,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+55104,int_stack+1990,int_stack+1210,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+57444,int_stack+55104,int_stack+49824,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+61404,int_stack+57444,int_stack+51804,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+48174,int_stack+2900,int_stack+1990,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+66904,int_stack+48174,int_stack+55104,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+71584,int_stack+66904,int_stack+57444,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+50904,int_stack+71584,int_stack+61404,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+59154,int_stack+3950,int_stack+2900,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+78184,int_stack+59154,int_stack+48174,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+83644,int_stack+78184,int_stack+66904,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+91444,int_stack+83644,int_stack+71584,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+62304,int_stack+91444,int_stack+50904,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+48174,int_stack+5150,int_stack+3950,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+51774,int_stack+48174,int_stack+59154,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+101344,int_stack+51774,int_stack+78184,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+48174,int_stack+101344,int_stack+83644,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+73854,int_stack+48174,int_stack+91444,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+87714,int_stack+73854,int_stack+62304,10);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+48174,int_stack+7335,int_stack+6510,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+50649,int_stack+8325,int_stack+7335,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+53619,int_stack+50649,int_stack+48174,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+58569,int_stack+9495,int_stack+8325,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+62079,int_stack+58569,int_stack+50649,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+68019,int_stack+62079,int_stack+53619,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+48174,int_stack+10860,int_stack+9495,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+76269,int_stack+48174,int_stack+58569,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+76269,int_stack+62079,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+52269,int_stack+0,int_stack+68019,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+64644,int_stack+12435,int_stack+10860,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+103114,int_stack+64644,int_stack+48174,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+111304,int_stack+103114,int_stack+76269,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+69369,int_stack+111304,int_stack+0,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+123004,int_stack+69369,int_stack+52269,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+14235,int_stack+12435,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+5400,int_stack+0,int_stack+64644,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+48174,int_stack+5400,int_stack+103114,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+140329,int_stack+48174,int_stack+111304,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+48174,int_stack+140329,int_stack+69369,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+140329,int_stack+48174,int_stack+123004,15);
 /*--- compute (fp|mi) ---*/
 hrr1_build_fp(Libint->AB,int_stack+163429,int_stack+140329,int_stack+87714,1540);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+48174,int_stack+17430,int_stack+16275,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+51639,int_stack+18816,int_stack+17430,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+55797,int_stack+51639,int_stack+48174,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+62727,int_stack+20454,int_stack+18816,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+67641,int_stack+62727,int_stack+51639,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+75957,int_stack+67641,int_stack+55797,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+48174,int_stack+22365,int_stack+20454,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+87507,int_stack+48174,int_stack+62727,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+97335,int_stack+87507,int_stack+67641,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+53907,int_stack+97335,int_stack+75957,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+71232,int_stack+24570,int_stack+22365,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+111195,int_stack+71232,int_stack+48174,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+122661,int_stack+111195,int_stack+87507,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+122661,int_stack+97335,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+77847,int_stack+0,int_stack+53907,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+48174,int_stack+27090,int_stack+24570,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+55734,int_stack+48174,int_stack+71232,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+209629,int_stack+55734,int_stack+111195,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+48174,int_stack+209629,int_stack+122661,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+102102,int_stack+48174,int_stack+0,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+209629,int_stack+102102,int_stack+77847,21);
 /*--- compute (gp|mi) ---*/
 hrr1_build_gp(Libint->AB,int_stack+48174,int_stack+209629,int_stack+140329,1540);
 /*--- compute (fd|mi) ---*/
 hrr1_build_fd(Libint->AB,int_stack+241969,int_stack+48174,int_stack+163429,1540);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+31486,int_stack+29946,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4620,int_stack+33334,int_stack+31486,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+10164,int_stack+4620,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+19404,int_stack+35518,int_stack+33334,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+117474,int_stack+19404,int_stack+4620,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+128562,int_stack+117474,int_stack+10164,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+38066,int_stack+35518,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+143962,int_stack+0,int_stack+19404,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+7644,int_stack+143962,int_stack+117474,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+157066,int_stack+7644,int_stack+128562,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+117474,int_stack+41006,int_stack+38066,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+126294,int_stack+117474,int_stack+0,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+180166,int_stack+126294,int_stack+143962,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+334369,int_stack+180166,int_stack+7644,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+334369,int_stack+157066,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+141582,int_stack+44366,int_stack+41006,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+151662,int_stack+141582,int_stack+117474,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+362089,int_stack+151662,int_stack+126294,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+117474,int_stack+362089,int_stack+180166,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+150234,int_stack+117474,int_stack+334369,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+334369,int_stack+150234,int_stack+0,28);
 /*--- compute (hp|mi) ---*/
 hrr1_build_hp(Libint->AB,int_stack+377489,int_stack+334369,int_stack+209629,1540);
 /*--- compute (gd|mi) ---*/
 hrr1_build_gd(Libint->AB,int_stack+474509,int_stack+377489,int_stack+48174,1540);
 /*--- compute (ff|mi) ---*/
 hrr1_build_ff(Libint->AB,int_stack+0,int_stack+474509,int_stack+241969,1540);
 return int_stack+0;}
