/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffmp(Libint_t*, prim_data*);

  /* Computes quartets of (ff|mp) integrals */

REALTYPE *hrr_order_ffmp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][9] = int_stack + 0;
 Libint->vrr_classes[3][10] = int_stack + 550;
 Libint->vrr_classes[4][9] = int_stack + 1210;
 Libint->vrr_classes[4][10] = int_stack + 2035;
 Libint->vrr_classes[5][9] = int_stack + 3025;
 Libint->vrr_classes[5][10] = int_stack + 4180;
 Libint->vrr_classes[6][9] = int_stack + 5566;
 Libint->vrr_classes[6][10] = int_stack + 7106;
 memset(int_stack,0,8954*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 8954;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffmp(Libint, Data);
   Data++;
 }
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8954,int_stack+550,int_stack+0,10);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10604,int_stack+2035,int_stack+1210,15);
 /*--- compute (fp|mp) ---*/
 hrr1_build_fp(Libint->AB,int_stack+13079,int_stack+10604,int_stack+8954,165);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+18029,int_stack+4180,int_stack+3025,21);
 /*--- compute (gp|mp) ---*/
 hrr1_build_gp(Libint->AB,int_stack+21494,int_stack+18029,int_stack+10604,165);
 /*--- compute (fd|mp) ---*/
 hrr1_build_fd(Libint->AB,int_stack+28919,int_stack+21494,int_stack+13079,165);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8954,int_stack+7106,int_stack+5566,28);
 /*--- compute (hp|mp) ---*/
 hrr1_build_hp(Libint->AB,int_stack+38819,int_stack+8954,int_stack+18029,165);
 /*--- compute (gd|mp) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+38819,int_stack+21494,165);
 /*--- compute (ff|mp) ---*/
 hrr1_build_ff(Libint->AB,int_stack+38819,int_stack+0,int_stack+28919,165);
 return int_stack+38819;}
