/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffnd(Libint_t*, prim_data*);

  /* Computes quartets of (ff|nd) integrals */

REALTYPE *hrr_order_ffnd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][10] = int_stack + 0;
 Libint->vrr_classes[3][11] = int_stack + 660;
 Libint->vrr_classes[3][12] = int_stack + 1440;
 Libint->vrr_classes[4][10] = int_stack + 2350;
 Libint->vrr_classes[4][11] = int_stack + 3340;
 Libint->vrr_classes[4][12] = int_stack + 4510;
 Libint->vrr_classes[5][10] = int_stack + 5875;
 Libint->vrr_classes[5][11] = int_stack + 7261;
 Libint->vrr_classes[5][12] = int_stack + 8899;
 Libint->vrr_classes[6][10] = int_stack + 10810;
 Libint->vrr_classes[6][11] = int_stack + 12658;
 Libint->vrr_classes[6][12] = int_stack + 14842;
 memset(int_stack,0,17390*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 17390;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffnd(Libint, Data);
   Data++;
 }
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17390,int_stack+660,int_stack+0,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+19370,int_stack+1440,int_stack+660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+21710,int_stack+19370,int_stack+17390,10);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17390,int_stack+3340,int_stack+2350,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+25670,int_stack+4510,int_stack+3340,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+29180,int_stack+25670,int_stack+17390,15);
 /*--- compute (fp|nd) ---*/
 hrr1_build_fp(Libint->AB,int_stack+35120,int_stack+29180,int_stack+21710,396);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17390,int_stack+7261,int_stack+5875,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+21548,int_stack+8899,int_stack+7261,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+21548,int_stack+17390,21);
 /*--- compute (gp|nd) ---*/
 hrr1_build_gp(Libint->AB,int_stack+47000,int_stack+0,int_stack+29180,396);
 /*--- compute (fd|nd) ---*/
 hrr1_build_fd(Libint->AB,int_stack+64820,int_stack+47000,int_stack+35120,396);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17390,int_stack+12658,int_stack+10810,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+22934,int_stack+14842,int_stack+12658,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+29486,int_stack+22934,int_stack+17390,28);
 /*--- compute (hp|nd) ---*/
 hrr1_build_hp(Libint->AB,int_stack+88580,int_stack+29486,int_stack+0,396);
 /*--- compute (gd|nd) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+88580,int_stack+47000,396);
 /*--- compute (ff|nd) ---*/
 hrr1_build_ff(Libint->AB,int_stack+88580,int_stack+0,int_stack+64820,396);
 return int_stack+88580;}
