/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fpnn(Libint_t*, prim_data*);

  /* Computes quartets of (fp|nn) integrals */

REALTYPE *hrr_order_fpnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][10] = int_stack + 0;
 Libint->vrr_classes[3][11] = int_stack + 660;
 Libint->vrr_classes[3][12] = int_stack + 1440;
 Libint->vrr_classes[3][13] = int_stack + 2350;
 Libint->vrr_classes[3][14] = int_stack + 3400;
 Libint->vrr_classes[3][15] = int_stack + 4600;
 Libint->vrr_classes[3][16] = int_stack + 5960;
 Libint->vrr_classes[3][17] = int_stack + 7490;
 Libint->vrr_classes[3][18] = int_stack + 9200;
 Libint->vrr_classes[3][19] = int_stack + 11100;
 Libint->vrr_classes[3][20] = int_stack + 13200;
 Libint->vrr_classes[4][10] = int_stack + 15510;
 Libint->vrr_classes[4][11] = int_stack + 16500;
 Libint->vrr_classes[4][12] = int_stack + 17670;
 Libint->vrr_classes[4][13] = int_stack + 19035;
 Libint->vrr_classes[4][14] = int_stack + 20610;
 Libint->vrr_classes[4][15] = int_stack + 22410;
 Libint->vrr_classes[4][16] = int_stack + 24450;
 Libint->vrr_classes[4][17] = int_stack + 26745;
 Libint->vrr_classes[4][18] = int_stack + 29310;
 Libint->vrr_classes[4][19] = int_stack + 32160;
 Libint->vrr_classes[4][20] = int_stack + 35310;
 memset(int_stack,0,38775*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 38775;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fpnn(Libint, Data);
   Data++;
 }
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+38775,int_stack+660,int_stack+0,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+40755,int_stack+1440,int_stack+660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+43095,int_stack+40755,int_stack+38775,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+47055,int_stack+2350,int_stack+1440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+49785,int_stack+47055,int_stack+40755,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+54465,int_stack+49785,int_stack+43095,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+38775,int_stack+3400,int_stack+2350,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+61065,int_stack+38775,int_stack+47055,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+41925,int_stack+61065,int_stack+49785,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+66525,int_stack+41925,int_stack+54465,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+49725,int_stack+4600,int_stack+3400,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+53325,int_stack+49725,int_stack+38775,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+76425,int_stack+53325,int_stack+61065,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+85525,int_stack+76425,int_stack+41925,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+97225,int_stack+85525,int_stack+66525,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+38775,int_stack+5960,int_stack+4600,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+59625,int_stack+38775,int_stack+49725,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+111085,int_stack+59625,int_stack+53325,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+42855,int_stack+111085,int_stack+76425,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+66825,int_stack+42855,int_stack+85525,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+121585,int_stack+66825,int_stack+97225,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+83205,int_stack+7490,int_stack+5960,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+87795,int_stack+83205,int_stack+38775,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+95955,int_stack+87795,int_stack+59625,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+140065,int_stack+95955,int_stack+111085,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+155815,int_stack+140065,int_stack+42855,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+38775,int_stack+155815,int_stack+66825,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+174925,int_stack+38775,int_stack+121585,10);
 /*--- compute (f0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+60615,int_stack+9200,int_stack+7490,10);
 /*--- compute (f0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+65745,int_stack+60615,int_stack+83205,10);
 /*--- compute (f0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+107955,int_stack+65745,int_stack+87795,10);
 /*--- compute (f0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+74925,int_stack+107955,int_stack+95955,10);
 /*--- compute (f0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+198685,int_stack+74925,int_stack+140065,10);
 /*--- compute (f0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+121555,int_stack+198685,int_stack+155815,10);
 /*--- compute (f0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+220735,int_stack+121555,int_stack+38775,10);
 /*--- compute (f0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+248815,int_stack+220735,int_stack+174925,10);
 /*--- compute (f0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+38775,int_stack+11100,int_stack+9200,10);
 /*--- compute (f0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+44475,int_stack+38775,int_stack+60615,10);
 /*--- compute (f0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+147035,int_stack+44475,int_stack+65745,10);
 /*--- compute (f0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+162335,int_stack+147035,int_stack+107955,10);
 /*--- compute (f0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+92925,int_stack+162335,int_stack+74925,10);
 /*--- compute (f0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+54735,int_stack+92925,int_stack+198685,10);
 /*--- compute (f0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+182735,int_stack+54735,int_stack+121555,10);
 /*--- compute (f0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+278515,int_stack+182735,int_stack+220735,10);
 /*--- compute (f0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+313615,int_stack+278515,int_stack+248815,10);
 /*--- compute (f0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+84135,int_stack+13200,int_stack+11100,10);
 /*--- compute (f0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+118125,int_stack+84135,int_stack+38775,10);
 /*--- compute (f0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+129525,int_stack+118125,int_stack+44475,10);
 /*--- compute (f0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+215495,int_stack+129525,int_stack+147035,10);
 /*--- compute (f0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+118125,int_stack+215495,int_stack+162335,10);
 /*--- compute (f0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+215495,int_stack+118125,int_stack+92925,10);
 /*--- compute (f0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+84135,int_stack+215495,int_stack+54735,10);
 /*--- compute (f0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+215495,int_stack+84135,int_stack+182735,10);
 /*--- compute (f0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+38775,int_stack+215495,int_stack+278515,10);
 /*--- compute (f0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+81675,int_stack+38775,int_stack+313615,10);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+38775,int_stack+16500,int_stack+15510,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+41745,int_stack+17670,int_stack+16500,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+45255,int_stack+41745,int_stack+38775,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+51195,int_stack+19035,int_stack+17670,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+55290,int_stack+51195,int_stack+41745,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+62310,int_stack+55290,int_stack+45255,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+38775,int_stack+20610,int_stack+19035,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+72210,int_stack+38775,int_stack+51195,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+43500,int_stack+72210,int_stack+55290,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+125235,int_stack+43500,int_stack+62310,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+55200,int_stack+22410,int_stack+20610,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+60600,int_stack+55200,int_stack+38775,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+140085,int_stack+60600,int_stack+72210,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+153735,int_stack+140085,int_stack+43500,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+171285,int_stack+153735,int_stack+125235,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+125235,int_stack+24450,int_stack+22410,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+38775,int_stack+125235,int_stack+55200,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+192075,int_stack+38775,int_stack+60600,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+49575,int_stack+192075,int_stack+140085,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+207825,int_stack+49575,int_stack+153735,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+131355,int_stack+207825,int_stack+171285,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+159075,int_stack+26745,int_stack+24450,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+165960,int_stack+159075,int_stack+125235,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+232395,int_stack+165960,int_stack+38775,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+250395,int_stack+232395,int_stack+192075,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+178200,int_stack+250395,int_stack+49575,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+38775,int_stack+178200,int_stack+207825,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+274020,int_stack+38775,int_stack+131355,15);
 /*--- compute (g0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+71535,int_stack+29310,int_stack+26745,15);
 /*--- compute (g0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+125235,int_stack+71535,int_stack+159075,15);
 /*--- compute (g0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+139005,int_stack+125235,int_stack+165960,15);
 /*--- compute (g0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+309660,int_stack+139005,int_stack+232395,15);
 /*--- compute (g0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+206865,int_stack+309660,int_stack+250395,15);
 /*--- compute (g0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+336660,int_stack+206865,int_stack+178200,15);
 /*--- compute (g0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+159405,int_stack+336660,int_stack+38775,15);
 /*--- compute (g0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+374880,int_stack+159405,int_stack+274020,15);
 /*--- compute (g0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+38775,int_stack+32160,int_stack+29310,15);
 /*--- compute (g0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+47325,int_stack+38775,int_stack+71535,15);
 /*--- compute (g0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+239940,int_stack+47325,int_stack+125235,15);
 /*--- compute (g0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+262890,int_stack+239940,int_stack+139005,15);
 /*--- compute (g0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+419430,int_stack+262890,int_stack+309660,15);
 /*--- compute (g0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+457230,int_stack+419430,int_stack+206865,15);
 /*--- compute (g0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+501330,int_stack+457230,int_stack+336660,15);
 /*--- compute (g0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+293490,int_stack+501330,int_stack+159405,15);
 /*--- compute (g0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+125235,int_stack+293490,int_stack+374880,15);
 /*--- compute (g0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+179685,int_stack+35310,int_stack+32160,15);
 /*--- compute (g0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+189135,int_stack+179685,int_stack+38775,15);
 /*--- compute (g0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+206235,int_stack+189135,int_stack+47325,15);
 /*--- compute (g0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+346140,int_stack+206235,int_stack+239940,15);
 /*--- compute (g0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+179685,int_stack+346140,int_stack+262890,15);
 /*--- compute (g0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+346140,int_stack+179685,int_stack+419430,15);
 /*--- compute (g0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+179685,int_stack+346140,int_stack+457230,15);
 /*--- compute (g0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+346140,int_stack+179685,int_stack+501330,15);
 /*--- compute (g0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+179685,int_stack+346140,int_stack+293490,15);
 /*--- compute (g0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+244035,int_stack+179685,int_stack+125235,15);
 /*--- compute (fp|nn) ---*/
 hrr1_build_fp(Libint->AB,int_stack+309375,int_stack+244035,int_stack+81675,4356);
 return int_stack+309375;}
