/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_g0lk(Libint_t*, prim_data*);

  /* Computes quartets of (g0|lk) integrals */

REALTYPE *hrr_order_g0lk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][8] = int_stack + 0;
 Libint->vrr_classes[4][9] = int_stack + 675;
 Libint->vrr_classes[4][10] = int_stack + 1500;
 Libint->vrr_classes[4][11] = int_stack + 2490;
 Libint->vrr_classes[4][12] = int_stack + 3660;
 Libint->vrr_classes[4][13] = int_stack + 5025;
 Libint->vrr_classes[4][14] = int_stack + 6600;
 Libint->vrr_classes[4][15] = int_stack + 8400;
 memset(int_stack,0,10440*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 10440;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_g0lk(Libint, Data);
   Data++;
 }
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+10440,int_stack+675,int_stack+0,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12465,int_stack+1500,int_stack+675,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+14940,int_stack+12465,int_stack+10440,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+18990,int_stack+2490,int_stack+1500,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+21960,int_stack+18990,int_stack+12465,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+26910,int_stack+21960,int_stack+14940,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10440,int_stack+3660,int_stack+2490,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33660,int_stack+10440,int_stack+18990,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+39600,int_stack+33660,int_stack+21960,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+13950,int_stack+39600,int_stack+26910,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+24075,int_stack+5025,int_stack+3660,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+47850,int_stack+24075,int_stack+10440,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+54870,int_stack+47850,int_stack+33660,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+64770,int_stack+54870,int_stack+39600,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+28170,int_stack+64770,int_stack+13950,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+10440,int_stack+6600,int_stack+5025,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+15165,int_stack+10440,int_stack+24075,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+77145,int_stack+15165,int_stack+47850,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+88845,int_stack+77145,int_stack+54870,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+42345,int_stack+88845,int_stack+64770,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+103695,int_stack+42345,int_stack+28170,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+23355,int_stack+8400,int_stack+6600,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+28755,int_stack+23355,int_stack+10440,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+59670,int_stack+28755,int_stack+15165,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+59670,int_stack+77145,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+59670,int_stack+0,int_stack+88845,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+59670,int_stack+42345,15);
 /*--- compute (g0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+23100,int_stack+0,int_stack+103695,15);
 return int_stack+23100;}
