/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdkg(Libint_t*, prim_data*);

  /* Computes quartets of (gd|kg) integrals */

REALTYPE *hrr_order_gdkg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][7] = int_stack + 0;
 Libint->vrr_classes[4][8] = int_stack + 540;
 Libint->vrr_classes[4][9] = int_stack + 1215;
 Libint->vrr_classes[4][10] = int_stack + 2040;
 Libint->vrr_classes[4][11] = int_stack + 3030;
 Libint->vrr_classes[5][7] = int_stack + 4200;
 Libint->vrr_classes[5][8] = int_stack + 4956;
 Libint->vrr_classes[5][9] = int_stack + 5901;
 Libint->vrr_classes[5][10] = int_stack + 7056;
 Libint->vrr_classes[5][11] = int_stack + 8442;
 Libint->vrr_classes[6][7] = int_stack + 10080;
 Libint->vrr_classes[6][8] = int_stack + 11088;
 Libint->vrr_classes[6][9] = int_stack + 12348;
 Libint->vrr_classes[6][10] = int_stack + 13888;
 Libint->vrr_classes[6][11] = int_stack + 15736;
 memset(int_stack,0,17920*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 17920;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdkg(Libint, Data);
   Data++;
 }
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+17920,int_stack+540,int_stack+0,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+19540,int_stack+1215,int_stack+540,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+21565,int_stack+19540,int_stack+17920,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+24805,int_stack+2040,int_stack+1215,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+27280,int_stack+24805,int_stack+19540,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+31330,int_stack+27280,int_stack+21565,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17920,int_stack+3030,int_stack+2040,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+36730,int_stack+17920,int_stack+24805,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+17920,int_stack+36730,int_stack+27280,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+36730,int_stack+17920,int_stack+31330,15);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+17920,int_stack+4956,int_stack+4200,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+20188,int_stack+5901,int_stack+4956,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+23023,int_stack+20188,int_stack+17920,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+27559,int_stack+7056,int_stack+5901,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+31024,int_stack+27559,int_stack+20188,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+44830,int_stack+31024,int_stack+23023,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17920,int_stack+8442,int_stack+7056,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+17920,int_stack+27559,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+17920,int_stack+0,int_stack+31024,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+52390,int_stack+17920,int_stack+44830,21);
 /*--- compute (gp|kg) ---*/
 hrr1_build_gp(Libint->AB,int_stack+63730,int_stack+52390,int_stack+36730,540);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+17920,int_stack+11088,int_stack+10080,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+20944,int_stack+12348,int_stack+11088,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+24724,int_stack+20944,int_stack+17920,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+30772,int_stack+13888,int_stack+12348,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+35392,int_stack+30772,int_stack+20944,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+35392,int_stack+24724,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17920,int_stack+15736,int_stack+13888,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+42952,int_stack+17920,int_stack+30772,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+10080,int_stack+42952,int_stack+35392,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+22680,int_stack+10080,int_stack+0,28);
 /*--- compute (hp|kg) ---*/
 hrr1_build_hp(Libint->AB,int_stack+88030,int_stack+22680,int_stack+52390,540);
 /*--- compute (gd|kg) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+88030,int_stack+63730,540);
 return int_stack+0;}
