/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdmp(Libint_t*, prim_data*);

  /* Computes quartets of (gd|mp) integrals */

REALTYPE *hrr_order_gdmp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][9] = int_stack + 0;
 Libint->vrr_classes[4][10] = int_stack + 825;
 Libint->vrr_classes[5][9] = int_stack + 1815;
 Libint->vrr_classes[5][10] = int_stack + 2970;
 Libint->vrr_classes[6][9] = int_stack + 4356;
 Libint->vrr_classes[6][10] = int_stack + 5896;
 memset(int_stack,0,7744*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 7744;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdmp(Libint, Data);
   Data++;
 }
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7744,int_stack+825,int_stack+0,15);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10219,int_stack+2970,int_stack+1815,21);
 /*--- compute (gp|mp) ---*/
 hrr1_build_gp(Libint->AB,int_stack+13684,int_stack+10219,int_stack+7744,165);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+21109,int_stack+5896,int_stack+4356,28);
 /*--- compute (hp|mp) ---*/
 hrr1_build_hp(Libint->AB,int_stack+25729,int_stack+21109,int_stack+10219,165);
 /*--- compute (gd|mp) ---*/
 hrr1_build_gd(Libint->AB,int_stack+36124,int_stack+25729,int_stack+13684,165);
 return int_stack+36124;}
