/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gfkg(Libint_t*, prim_data*);

  /* Computes quartets of (gf|kg) integrals */

REALTYPE *hrr_order_gfkg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][7] = int_stack + 0;
 Libint->vrr_classes[4][8] = int_stack + 540;
 Libint->vrr_classes[4][9] = int_stack + 1215;
 Libint->vrr_classes[4][10] = int_stack + 2040;
 Libint->vrr_classes[4][11] = int_stack + 3030;
 Libint->vrr_classes[5][7] = int_stack + 4200;
 Libint->vrr_classes[5][8] = int_stack + 4956;
 Libint->vrr_classes[5][9] = int_stack + 5901;
 Libint->vrr_classes[5][10] = int_stack + 7056;
 Libint->vrr_classes[5][11] = int_stack + 8442;
 Libint->vrr_classes[6][7] = int_stack + 10080;
 Libint->vrr_classes[6][8] = int_stack + 11088;
 Libint->vrr_classes[6][9] = int_stack + 12348;
 Libint->vrr_classes[6][10] = int_stack + 13888;
 Libint->vrr_classes[6][11] = int_stack + 15736;
 Libint->vrr_classes[7][7] = int_stack + 17920;
 Libint->vrr_classes[7][8] = int_stack + 19216;
 Libint->vrr_classes[7][9] = int_stack + 20836;
 Libint->vrr_classes[7][10] = int_stack + 22816;
 Libint->vrr_classes[7][11] = int_stack + 25192;
 memset(int_stack,0,28000*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 28000;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gfkg(Libint, Data);
   Data++;
 }
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+28000,int_stack+540,int_stack+0,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+29620,int_stack+1215,int_stack+540,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+31645,int_stack+29620,int_stack+28000,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+34885,int_stack+2040,int_stack+1215,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+37360,int_stack+34885,int_stack+29620,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+41410,int_stack+37360,int_stack+31645,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+28000,int_stack+3030,int_stack+2040,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+46810,int_stack+28000,int_stack+34885,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+28000,int_stack+46810,int_stack+37360,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+46810,int_stack+28000,int_stack+41410,15);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+28000,int_stack+4956,int_stack+4200,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+30268,int_stack+5901,int_stack+4956,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+33103,int_stack+30268,int_stack+28000,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+37639,int_stack+7056,int_stack+5901,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+41104,int_stack+37639,int_stack+30268,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+54910,int_stack+41104,int_stack+33103,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+28000,int_stack+8442,int_stack+7056,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+28000,int_stack+37639,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+28000,int_stack+0,int_stack+41104,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+62470,int_stack+28000,int_stack+54910,21);
 /*--- compute (gp|kg) ---*/
 hrr1_build_gp(Libint->AB,int_stack+73810,int_stack+62470,int_stack+46810,540);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+28000,int_stack+11088,int_stack+10080,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+31024,int_stack+12348,int_stack+11088,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+34804,int_stack+31024,int_stack+28000,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+40852,int_stack+13888,int_stack+12348,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+45472,int_stack+40852,int_stack+31024,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+45472,int_stack+34804,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+28000,int_stack+15736,int_stack+13888,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+53032,int_stack+28000,int_stack+40852,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+28000,int_stack+53032,int_stack+45472,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+40600,int_stack+28000,int_stack+0,28);
 /*--- compute (hp|kg) ---*/
 hrr1_build_hp(Libint->AB,int_stack+98110,int_stack+40600,int_stack+62470,540);
 /*--- compute (gd|kg) ---*/
 hrr1_build_gd(Libint->AB,int_stack+132130,int_stack+98110,int_stack+73810,540);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+19216,int_stack+17920,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3888,int_stack+20836,int_stack+19216,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+8748,int_stack+3888,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+28000,int_stack+22816,int_stack+20836,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+55720,int_stack+28000,int_stack+3888,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+65440,int_stack+55720,int_stack+8748,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+25192,int_stack+22816,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+7128,int_stack+0,int_stack+28000,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+19008,int_stack+7128,int_stack+55720,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+78400,int_stack+19008,int_stack+65440,36);
 /*--- compute (ip|kg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+180730,int_stack+78400,int_stack+40600,540);
 /*--- compute (hd|kg) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+180730,int_stack+98110,540);
 /*--- compute (gf|kg) ---*/
 hrr1_build_gf(Libint->AB,int_stack+180730,int_stack+0,int_stack+132130,540);
 return int_stack+180730;}
