/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gfki(Libint_t*, prim_data*);

  /* Computes quartets of (gf|ki) integrals */

REALTYPE *hrr_order_gfki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][7] = int_stack + 0;
 Libint->vrr_classes[4][8] = int_stack + 540;
 Libint->vrr_classes[4][9] = int_stack + 1215;
 Libint->vrr_classes[4][10] = int_stack + 2040;
 Libint->vrr_classes[4][11] = int_stack + 3030;
 Libint->vrr_classes[4][12] = int_stack + 4200;
 Libint->vrr_classes[4][13] = int_stack + 5565;
 Libint->vrr_classes[5][7] = int_stack + 7140;
 Libint->vrr_classes[5][8] = int_stack + 7896;
 Libint->vrr_classes[5][9] = int_stack + 8841;
 Libint->vrr_classes[5][10] = int_stack + 9996;
 Libint->vrr_classes[5][11] = int_stack + 11382;
 Libint->vrr_classes[5][12] = int_stack + 13020;
 Libint->vrr_classes[5][13] = int_stack + 14931;
 Libint->vrr_classes[6][7] = int_stack + 17136;
 Libint->vrr_classes[6][8] = int_stack + 18144;
 Libint->vrr_classes[6][9] = int_stack + 19404;
 Libint->vrr_classes[6][10] = int_stack + 20944;
 Libint->vrr_classes[6][11] = int_stack + 22792;
 Libint->vrr_classes[6][12] = int_stack + 24976;
 Libint->vrr_classes[6][13] = int_stack + 27524;
 Libint->vrr_classes[7][7] = int_stack + 30464;
 Libint->vrr_classes[7][8] = int_stack + 31760;
 Libint->vrr_classes[7][9] = int_stack + 33380;
 Libint->vrr_classes[7][10] = int_stack + 35360;
 Libint->vrr_classes[7][11] = int_stack + 37736;
 Libint->vrr_classes[7][12] = int_stack + 40544;
 Libint->vrr_classes[7][13] = int_stack + 43820;
 memset(int_stack,0,47600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 47600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gfki(Libint, Data);
   Data++;
 }
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+47600,int_stack+540,int_stack+0,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+49220,int_stack+1215,int_stack+540,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+51245,int_stack+49220,int_stack+47600,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+54485,int_stack+2040,int_stack+1215,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+56960,int_stack+54485,int_stack+49220,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+61010,int_stack+56960,int_stack+51245,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47600,int_stack+3030,int_stack+2040,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+66410,int_stack+47600,int_stack+54485,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+71360,int_stack+66410,int_stack+56960,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+50570,int_stack+71360,int_stack+61010,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+58670,int_stack+4200,int_stack+3030,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+78110,int_stack+58670,int_stack+47600,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+84050,int_stack+78110,int_stack+66410,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+92300,int_stack+84050,int_stack+71360,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+62180,int_stack+92300,int_stack+50570,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+47600,int_stack+5565,int_stack+4200,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+47600,int_stack+58670,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+47600,int_stack+0,int_stack+78110,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+102425,int_stack+47600,int_stack+84050,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+47600,int_stack+102425,int_stack+92300,15);
 /*--- compute (g0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+73520,int_stack+47600,int_stack+62180,15);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+47600,int_stack+7896,int_stack+7140,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+49868,int_stack+8841,int_stack+7896,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+52703,int_stack+49868,int_stack+47600,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+57239,int_stack+9996,int_stack+8841,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+60704,int_stack+57239,int_stack+49868,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+60704,int_stack+52703,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47600,int_stack+11382,int_stack+9996,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+66374,int_stack+47600,int_stack+57239,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+88640,int_stack+66374,int_stack+60704,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+51758,int_stack+88640,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+13020,int_stack+11382,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+98090,int_stack+0,int_stack+47600,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+106406,int_stack+98090,int_stack+66374,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+117956,int_stack+106406,int_stack+88640,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+132131,int_stack+117956,int_stack+51758,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+88640,int_stack+14931,int_stack+13020,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+47600,int_stack+88640,int_stack+0,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+47600,int_stack+98090,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+47600,int_stack+0,int_stack+106406,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+88640,int_stack+47600,int_stack+117956,21);
 /*--- compute (h0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+47600,int_stack+88640,int_stack+132131,21);
 /*--- compute (gp|ki) ---*/
 hrr1_build_gp(Libint->AB,int_stack+88640,int_stack+47600,int_stack+73520,1008);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+134000,int_stack+18144,int_stack+17136,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+137024,int_stack+19404,int_stack+18144,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+140804,int_stack+137024,int_stack+134000,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+68768,int_stack+20944,int_stack+19404,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+73388,int_stack+68768,int_stack+137024,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+73388,int_stack+140804,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+134000,int_stack+22792,int_stack+20944,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+139544,int_stack+134000,int_stack+68768,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+10080,int_stack+139544,int_stack+73388,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+68768,int_stack+10080,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+24976,int_stack+22792,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+148784,int_stack+0,int_stack+134000,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+159872,int_stack+148784,int_stack+139544,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+175272,int_stack+159872,int_stack+10080,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+194172,int_stack+175272,int_stack+68768,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+68768,int_stack+27524,int_stack+24976,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+134000,int_stack+68768,int_stack+0,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+134000,int_stack+148784,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+134000,int_stack+0,int_stack+159872,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+134000,int_stack+175272,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+134000,int_stack+0,int_stack+194172,28);
 /*--- compute (hp|ki) ---*/
 hrr1_build_hp(Libint->AB,int_stack+162224,int_stack+134000,int_stack+47600,1008);
 /*--- compute (gd|ki) ---*/
 hrr1_build_gd(Libint->AB,int_stack+225728,int_stack+162224,int_stack+88640,1008);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+47600,int_stack+31760,int_stack+30464,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+51488,int_stack+33380,int_stack+31760,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+56348,int_stack+51488,int_stack+47600,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+64124,int_stack+35360,int_stack+33380,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+70064,int_stack+64124,int_stack+51488,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+79784,int_stack+70064,int_stack+56348,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47600,int_stack+37736,int_stack+35360,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+92744,int_stack+47600,int_stack+64124,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+104624,int_stack+92744,int_stack+70064,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+54728,int_stack+104624,int_stack+79784,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+74168,int_stack+40544,int_stack+37736,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+74168,int_stack+47600,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+14256,int_stack+0,int_stack+92744,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+316448,int_stack+14256,int_stack+104624,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+82592,int_stack+316448,int_stack+54728,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+47600,int_stack+43820,int_stack+40544,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+109808,int_stack+47600,int_stack+74168,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+34056,int_stack+109808,int_stack+0,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+340748,int_stack+34056,int_stack+14256,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+340748,int_stack+316448,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+316448,int_stack+0,int_stack+82592,36);
 /*--- compute (ip|ki) ---*/
 hrr1_build_ip(Libint->AB,int_stack+0,int_stack+316448,int_stack+134000,1008);
 /*--- compute (hd|ki) ---*/
 hrr1_build_hd(Libint->AB,int_stack+316448,int_stack+0,int_stack+162224,1008);
 /*--- compute (gf|ki) ---*/
 hrr1_build_gf(Libint->AB,int_stack+0,int_stack+316448,int_stack+225728,1008);
 return int_stack+0;}
