/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gfmk(Libint_t*, prim_data*);

  /* Computes quartets of (gf|mk) integrals */

REALTYPE *hrr_order_gfmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][9] = int_stack + 0;
 Libint->vrr_classes[4][10] = int_stack + 825;
 Libint->vrr_classes[4][11] = int_stack + 1815;
 Libint->vrr_classes[4][12] = int_stack + 2985;
 Libint->vrr_classes[4][13] = int_stack + 4350;
 Libint->vrr_classes[4][14] = int_stack + 5925;
 Libint->vrr_classes[4][15] = int_stack + 7725;
 Libint->vrr_classes[4][16] = int_stack + 9765;
 Libint->vrr_classes[5][9] = int_stack + 12060;
 Libint->vrr_classes[5][10] = int_stack + 13215;
 Libint->vrr_classes[5][11] = int_stack + 14601;
 Libint->vrr_classes[5][12] = int_stack + 16239;
 Libint->vrr_classes[5][13] = int_stack + 18150;
 Libint->vrr_classes[5][14] = int_stack + 20355;
 Libint->vrr_classes[5][15] = int_stack + 22875;
 Libint->vrr_classes[5][16] = int_stack + 25731;
 Libint->vrr_classes[6][9] = int_stack + 28944;
 Libint->vrr_classes[6][10] = int_stack + 30484;
 Libint->vrr_classes[6][11] = int_stack + 32332;
 Libint->vrr_classes[6][12] = int_stack + 34516;
 Libint->vrr_classes[6][13] = int_stack + 37064;
 Libint->vrr_classes[6][14] = int_stack + 40004;
 Libint->vrr_classes[6][15] = int_stack + 43364;
 Libint->vrr_classes[6][16] = int_stack + 47172;
 Libint->vrr_classes[7][9] = int_stack + 51456;
 Libint->vrr_classes[7][10] = int_stack + 53436;
 Libint->vrr_classes[7][11] = int_stack + 55812;
 Libint->vrr_classes[7][12] = int_stack + 58620;
 Libint->vrr_classes[7][13] = int_stack + 61896;
 Libint->vrr_classes[7][14] = int_stack + 65676;
 Libint->vrr_classes[7][15] = int_stack + 69996;
 Libint->vrr_classes[7][16] = int_stack + 74892;
 memset(int_stack,0,80400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 80400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gfmk(Libint, Data);
   Data++;
 }
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+80400,int_stack+825,int_stack+0,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+82875,int_stack+1815,int_stack+825,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+85845,int_stack+82875,int_stack+80400,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+90795,int_stack+2985,int_stack+1815,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+94305,int_stack+90795,int_stack+82875,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+100245,int_stack+94305,int_stack+85845,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+80400,int_stack+4350,int_stack+2985,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+108495,int_stack+80400,int_stack+90795,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+115515,int_stack+108495,int_stack+94305,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+84495,int_stack+115515,int_stack+100245,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+96870,int_stack+5925,int_stack+4350,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+125415,int_stack+96870,int_stack+80400,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+133605,int_stack+125415,int_stack+108495,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+145305,int_stack+133605,int_stack+115515,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+101595,int_stack+145305,int_stack+84495,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+80400,int_stack+7725,int_stack+5925,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+85800,int_stack+80400,int_stack+96870,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+160155,int_stack+85800,int_stack+125415,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+173805,int_stack+160155,int_stack+133605,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+118920,int_stack+173805,int_stack+145305,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+191355,int_stack+118920,int_stack+101595,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+95250,int_stack+9765,int_stack+7725,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+101370,int_stack+95250,int_stack+80400,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+139710,int_stack+101370,int_stack+85800,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+80400,int_stack+139710,int_stack+160155,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+139710,int_stack+80400,int_stack+173805,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+80400,int_stack+139710,int_stack+118920,15);
 /*--- compute (g0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+108120,int_stack+80400,int_stack+191355,15);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+80400,int_stack+13215,int_stack+12060,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+83865,int_stack+14601,int_stack+13215,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+88023,int_stack+83865,int_stack+80400,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+94953,int_stack+16239,int_stack+14601,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+137820,int_stack+94953,int_stack+83865,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+146136,int_stack+137820,int_stack+88023,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+80400,int_stack+18150,int_stack+16239,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+157686,int_stack+80400,int_stack+94953,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+86133,int_stack+157686,int_stack+137820,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+167514,int_stack+86133,int_stack+146136,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+137820,int_stack+20355,int_stack+18150,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+144435,int_stack+137820,int_stack+80400,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+184839,int_stack+144435,int_stack+157686,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+201219,int_stack+184839,int_stack+86133,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+80400,int_stack+201219,int_stack+167514,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+155901,int_stack+22875,int_stack+20355,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+163461,int_stack+155901,int_stack+137820,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+163461,int_stack+144435,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+222009,int_stack+0,int_stack+184839,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+246579,int_stack+222009,int_stack+201219,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+176691,int_stack+246579,int_stack+80400,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+80400,int_stack+25731,int_stack+22875,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+88968,int_stack+80400,int_stack+155901,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+137820,int_stack+88968,int_stack+163461,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+275685,int_stack+137820,int_stack+0,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+137820,int_stack+275685,int_stack+222009,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+275685,int_stack+137820,int_stack+246579,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+209031,int_stack+275685,int_stack+176691,21);
 /*--- compute (gp|mk) ---*/
 hrr1_build_gp(Libint->AB,int_stack+250611,int_stack+209031,int_stack+108120,1980);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+30484,int_stack+28944,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4620,int_stack+32332,int_stack+30484,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+10164,int_stack+4620,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+19404,int_stack+34516,int_stack+32332,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+80400,int_stack+19404,int_stack+4620,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+91488,int_stack+80400,int_stack+10164,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+37064,int_stack+34516,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+106888,int_stack+0,int_stack+19404,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+7644,int_stack+106888,int_stack+80400,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+119992,int_stack+7644,int_stack+91488,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+80400,int_stack+40004,int_stack+37064,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+89220,int_stack+80400,int_stack+0,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+143092,int_stack+89220,int_stack+106888,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+164932,int_stack+143092,int_stack+7644,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+164932,int_stack+119992,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+104508,int_stack+43364,int_stack+40004,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+114588,int_stack+104508,int_stack+80400,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+339711,int_stack+114588,int_stack+89220,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+365191,int_stack+339711,int_stack+143092,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+397951,int_stack+365191,int_stack+164932,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+132228,int_stack+397951,int_stack+0,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+47172,int_stack+43364,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+11424,int_stack+0,int_stack+104508,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+80400,int_stack+11424,int_stack+114588,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+80400,int_stack+339711,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+80400,int_stack+0,int_stack+365191,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+339711,int_stack+80400,int_stack+397951,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+391455,int_stack+339711,int_stack+132228,28);
 /*--- compute (hp|mk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+80400,int_stack+391455,int_stack+209031,1980);
 /*--- compute (gd|mk) ---*/
 hrr1_build_gd(Libint->AB,int_stack+446895,int_stack+80400,int_stack+250611,1980);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+205140,int_stack+53436,int_stack+51456,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+211080,int_stack+55812,int_stack+53436,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+218208,int_stack+211080,int_stack+205140,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+230088,int_stack+58620,int_stack+55812,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+238512,int_stack+230088,int_stack+211080,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+252768,int_stack+238512,int_stack+218208,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+205140,int_stack+61896,int_stack+58620,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+272568,int_stack+205140,int_stack+230088,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+289416,int_stack+272568,int_stack+238512,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+214968,int_stack+289416,int_stack+252768,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+244668,int_stack+65676,int_stack+61896,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+313176,int_stack+244668,int_stack+205140,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+332832,int_stack+313176,int_stack+272568,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+332832,int_stack+289416,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+256008,int_stack+0,int_stack+214968,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+205140,int_stack+69996,int_stack+65676,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+218100,int_stack+205140,int_stack+244668,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+35640,int_stack+218100,int_stack+313176,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+625095,int_stack+35640,int_stack+332832,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+297588,int_stack+625095,int_stack+0,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+667215,int_stack+297588,int_stack+256008,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+74892,int_stack+69996,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+240780,int_stack+0,int_stack+205140,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+347484,int_stack+240780,int_stack+218100,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+205140,int_stack+347484,int_stack+35640,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+205140,int_stack+625095,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+205140,int_stack+0,int_stack+297588,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+205140,int_stack+667215,36);
 /*--- compute (ip|mk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+205140,int_stack+0,int_stack+391455,1980);
 /*--- compute (hd|mk) ---*/
 hrr1_build_hd(Libint->AB,int_stack+625095,int_stack+205140,int_stack+80400,1980);
 /*--- compute (gf|mk) ---*/
 hrr1_build_gf(Libint->AB,int_stack+0,int_stack+625095,int_stack+446895,1980);
 return int_stack+0;}
