/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ggnk(Libint_t*, prim_data*);

  /* Computes quartets of (gg|nk) integrals */

REALTYPE *hrr_order_ggnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[4][14] = int_stack + 5100;
 Libint->vrr_classes[4][15] = int_stack + 6900;
 Libint->vrr_classes[4][16] = int_stack + 8940;
 Libint->vrr_classes[4][17] = int_stack + 11235;
 Libint->vrr_classes[5][10] = int_stack + 13800;
 Libint->vrr_classes[5][11] = int_stack + 15186;
 Libint->vrr_classes[5][12] = int_stack + 16824;
 Libint->vrr_classes[5][13] = int_stack + 18735;
 Libint->vrr_classes[5][14] = int_stack + 20940;
 Libint->vrr_classes[5][15] = int_stack + 23460;
 Libint->vrr_classes[5][16] = int_stack + 26316;
 Libint->vrr_classes[5][17] = int_stack + 29529;
 Libint->vrr_classes[6][10] = int_stack + 33120;
 Libint->vrr_classes[6][11] = int_stack + 34968;
 Libint->vrr_classes[6][12] = int_stack + 37152;
 Libint->vrr_classes[6][13] = int_stack + 39700;
 Libint->vrr_classes[6][14] = int_stack + 42640;
 Libint->vrr_classes[6][15] = int_stack + 46000;
 Libint->vrr_classes[6][16] = int_stack + 49808;
 Libint->vrr_classes[6][17] = int_stack + 54092;
 Libint->vrr_classes[7][10] = int_stack + 58880;
 Libint->vrr_classes[7][11] = int_stack + 61256;
 Libint->vrr_classes[7][12] = int_stack + 64064;
 Libint->vrr_classes[7][13] = int_stack + 67340;
 Libint->vrr_classes[7][14] = int_stack + 71120;
 Libint->vrr_classes[7][15] = int_stack + 75440;
 Libint->vrr_classes[7][16] = int_stack + 80336;
 Libint->vrr_classes[7][17] = int_stack + 85844;
 Libint->vrr_classes[8][10] = int_stack + 92000;
 Libint->vrr_classes[8][11] = int_stack + 94970;
 Libint->vrr_classes[8][12] = int_stack + 98480;
 Libint->vrr_classes[8][13] = int_stack + 102575;
 Libint->vrr_classes[8][14] = int_stack + 107300;
 Libint->vrr_classes[8][15] = int_stack + 112700;
 Libint->vrr_classes[8][16] = int_stack + 118820;
 Libint->vrr_classes[8][17] = int_stack + 125705;
 memset(int_stack,0,133400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 133400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ggnk(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+133400,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+136370,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+139880,int_stack+136370,int_stack+133400,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+145820,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+149915,int_stack+145820,int_stack+136370,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+156935,int_stack+149915,int_stack+139880,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+133400,int_stack+5100,int_stack+3525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+166835,int_stack+133400,int_stack+145820,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+138125,int_stack+166835,int_stack+149915,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+175025,int_stack+138125,int_stack+156935,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+149825,int_stack+6900,int_stack+5100,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+155225,int_stack+149825,int_stack+133400,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+189875,int_stack+155225,int_stack+166835,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+203525,int_stack+189875,int_stack+138125,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+221075,int_stack+203525,int_stack+175025,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+133400,int_stack+8940,int_stack+6900,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+164675,int_stack+133400,int_stack+149825,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+241865,int_stack+164675,int_stack+155225,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+139520,int_stack+241865,int_stack+189875,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+175475,int_stack+139520,int_stack+203525,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+257615,int_stack+175475,int_stack+221075,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+200045,int_stack+11235,int_stack+8940,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+206930,int_stack+200045,int_stack+133400,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+219170,int_stack+206930,int_stack+164675,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+285335,int_stack+219170,int_stack+241865,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+200045,int_stack+285335,int_stack+139520,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+133400,int_stack+200045,int_stack+175475,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+166160,int_stack+133400,int_stack+257615,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+133400,int_stack+15186,int_stack+13800,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+137558,int_stack+16824,int_stack+15186,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+142472,int_stack+137558,int_stack+133400,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+150788,int_stack+18735,int_stack+16824,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+201800,int_stack+150788,int_stack+137558,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+211628,int_stack+201800,int_stack+142472,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+133400,int_stack+20940,int_stack+18735,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+225488,int_stack+133400,int_stack+150788,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+140015,int_stack+225488,int_stack+201800,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+236954,int_stack+140015,int_stack+211628,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+201800,int_stack+23460,int_stack+20940,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+209360,int_stack+201800,int_stack+133400,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+257744,int_stack+209360,int_stack+225488,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+276854,int_stack+257744,int_stack+140015,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+133400,int_stack+276854,int_stack+236954,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+222590,int_stack+26316,int_stack+23460,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+231158,int_stack+222590,int_stack+201800,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+231158,int_stack+209360,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+301424,int_stack+0,int_stack+257744,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+330089,int_stack+301424,int_stack+276854,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+246278,int_stack+330089,int_stack+133400,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+133400,int_stack+29529,int_stack+26316,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+143039,int_stack+133400,int_stack+222590,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+201800,int_stack+143039,int_stack+231158,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+364487,int_stack+201800,int_stack+0,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+201800,int_stack+364487,int_stack+301424,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+364487,int_stack+201800,int_stack+330089,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+285086,int_stack+364487,int_stack+246278,21);
 /*--- compute (gp|nk) ---*/
 hrr1_build_gp(Libint->AB,int_stack+334982,int_stack+285086,int_stack+166160,2376);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+34968,int_stack+33120,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5544,int_stack+37152,int_stack+34968,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+12096,int_stack+5544,int_stack+0,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+23184,int_stack+39700,int_stack+37152,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+133400,int_stack+23184,int_stack+5544,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+146504,int_stack+133400,int_stack+12096,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+42640,int_stack+39700,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+164984,int_stack+0,int_stack+23184,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+8820,int_stack+164984,int_stack+133400,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+180272,int_stack+8820,int_stack+146504,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+133400,int_stack+46000,int_stack+42640,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+143480,int_stack+133400,int_stack+0,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+207992,int_stack+143480,int_stack+164984,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+233472,int_stack+207992,int_stack+8820,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+233472,int_stack+180272,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+161120,int_stack+49808,int_stack+46000,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+172544,int_stack+161120,int_stack+133400,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+441902,int_stack+172544,int_stack+143480,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+471302,int_stack+441902,int_stack+207992,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+509522,int_stack+471302,int_stack+233472,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+192704,int_stack+509522,int_stack+0,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+54092,int_stack+49808,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+12852,int_stack+0,int_stack+161120,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+133400,int_stack+12852,int_stack+172544,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+133400,int_stack+441902,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+133400,int_stack+0,int_stack+471302,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+441902,int_stack+133400,int_stack+509522,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+503054,int_stack+441902,int_stack+192704,28);
 /*--- compute (hp|nk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+133400,int_stack+503054,int_stack+285086,2376);
 /*--- compute (gd|nk) ---*/
 hrr1_build_gd(Libint->AB,int_stack+569582,int_stack+133400,int_stack+334982,2376);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+283088,int_stack+61256,int_stack+58880,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+290216,int_stack+64064,int_stack+61256,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+298640,int_stack+290216,int_stack+283088,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+312896,int_stack+67340,int_stack+64064,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+322724,int_stack+312896,int_stack+290216,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+339572,int_stack+322724,int_stack+298640,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+283088,int_stack+71120,int_stack+67340,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+363332,int_stack+283088,int_stack+312896,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+294428,int_stack+363332,int_stack+322724,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+382988,int_stack+294428,int_stack+339572,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+322508,int_stack+75440,int_stack+71120,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+335468,int_stack+322508,int_stack+283088,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+418628,int_stack+335468,int_stack+363332,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+451388,int_stack+418628,int_stack+294428,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+451388,int_stack+382988,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+283088,int_stack+80336,int_stack+75440,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+358148,int_stack+283088,int_stack+322508,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+783422,int_stack+358148,int_stack+335468,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+297776,int_stack+783422,int_stack+418628,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+384068,int_stack+297776,int_stack+451388,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+821222,int_stack+384068,int_stack+0,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+85844,int_stack+80336,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+16524,int_stack+0,int_stack+283088,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+45900,int_stack+16524,int_stack+358148,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+443036,int_stack+45900,int_stack+783422,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+443036,int_stack+297776,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+283088,int_stack+0,int_stack+384068,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+283088,int_stack+821222,36);
 /*--- compute (ip|nk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+283088,int_stack+0,int_stack+503054,2376);
 /*--- compute (hd|nk) ---*/
 hrr1_build_hd(Libint->AB,int_stack+783422,int_stack+283088,int_stack+133400,2376);
 /*--- compute (gf|nk) ---*/
 hrr1_build_gf(Libint->AB,int_stack+1082798,int_stack+783422,int_stack+569582,2376);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+133400,int_stack+94970,int_stack+92000,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+142310,int_stack+98480,int_stack+94970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+152840,int_stack+142310,int_stack+133400,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+170660,int_stack+102575,int_stack+98480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+182945,int_stack+170660,int_stack+142310,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+204005,int_stack+182945,int_stack+152840,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+133400,int_stack+107300,int_stack+102575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+233705,int_stack+133400,int_stack+170660,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+147575,int_stack+233705,int_stack+182945,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+482672,int_stack+147575,int_stack+204005,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+182675,int_stack+112700,int_stack+107300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+198875,int_stack+182675,int_stack+133400,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+527222,int_stack+198875,int_stack+233705,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+227225,int_stack+527222,int_stack+147575,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+568172,int_stack+227225,int_stack+482672,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+482672,int_stack+118820,int_stack+112700,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+133400,int_stack+482672,int_stack+182675,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+630542,int_stack+133400,int_stack+198875,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+165800,int_stack+630542,int_stack+527222,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+677792,int_stack+165800,int_stack+227225,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1439198,int_stack+677792,int_stack+568172,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+227225,int_stack+125705,int_stack+118820,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+501032,int_stack+227225,int_stack+482672,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+227225,int_stack+501032,int_stack+133400,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+482672,int_stack+227225,int_stack+630542,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+553547,int_stack+482672,int_stack+165800,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+85536,int_stack+553547,int_stack+677792,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+482672,int_stack+85536,int_stack+1439198,45);
 /*--- compute (kp|nk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+1439198,int_stack+482672,int_stack+0,2376);
 /*--- compute (id|nk) ---*/
 hrr1_build_id(Libint->AB,int_stack+1695806,int_stack+1439198,int_stack+283088,2376);
 /*--- compute (hf|nk) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+1695806,int_stack+783422,2376);
 /*--- compute (gg|nk) ---*/
 hrr1_build_gg(Libint->AB,int_stack+1439198,int_stack+0,int_stack+1082798,2376);
 return int_stack+1439198;}
