/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdid(Libint_t*, prim_data*);

  /* Computes quartets of (hd|id) integrals */

REALTYPE *hrr_order_hdid(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][6] = int_stack + 0;
 Libint->vrr_classes[5][7] = int_stack + 588;
 Libint->vrr_classes[5][8] = int_stack + 1344;
 Libint->vrr_classes[6][6] = int_stack + 2289;
 Libint->vrr_classes[6][7] = int_stack + 3073;
 Libint->vrr_classes[6][8] = int_stack + 4081;
 Libint->vrr_classes[7][6] = int_stack + 5341;
 Libint->vrr_classes[7][7] = int_stack + 6349;
 Libint->vrr_classes[7][8] = int_stack + 7645;
 memset(int_stack,0,9265*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 9265;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdid(Libint, Data);
   Data++;
 }
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+9265,int_stack+588,int_stack+0,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+11029,int_stack+1344,int_stack+588,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+13297,int_stack+11029,int_stack+9265,21);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+9265,int_stack+3073,int_stack+2289,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+4081,int_stack+3073,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+16825,int_stack+0,int_stack+9265,28);
 /*--- compute (hp|id) ---*/
 hrr1_build_hp(Libint->AB,int_stack+21529,int_stack+16825,int_stack+13297,168);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+9265,int_stack+6349,int_stack+5341,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+12289,int_stack+7645,int_stack+6349,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+0,int_stack+12289,int_stack+9265,36);
 /*--- compute (ip|id) ---*/
 hrr1_build_ip(Libint->AB,int_stack+32113,int_stack+0,int_stack+16825,168);
 /*--- compute (hd|id) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+32113,int_stack+21529,168);
 return int_stack+0;}
