/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdif(Libint_t*, prim_data*);

  /* Computes quartets of (hd|if) integrals */

REALTYPE *hrr_order_hdif(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][6] = int_stack + 0;
 Libint->vrr_classes[5][7] = int_stack + 588;
 Libint->vrr_classes[5][8] = int_stack + 1344;
 Libint->vrr_classes[5][9] = int_stack + 2289;
 Libint->vrr_classes[6][6] = int_stack + 3444;
 Libint->vrr_classes[6][7] = int_stack + 4228;
 Libint->vrr_classes[6][8] = int_stack + 5236;
 Libint->vrr_classes[6][9] = int_stack + 6496;
 Libint->vrr_classes[7][6] = int_stack + 8036;
 Libint->vrr_classes[7][7] = int_stack + 9044;
 Libint->vrr_classes[7][8] = int_stack + 10340;
 Libint->vrr_classes[7][9] = int_stack + 11960;
 memset(int_stack,0,13940*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 13940;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdif(Libint, Data);
   Data++;
 }
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+13940,int_stack+588,int_stack+0,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+15704,int_stack+1344,int_stack+588,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+17972,int_stack+15704,int_stack+13940,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+21500,int_stack+2289,int_stack+1344,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+24335,int_stack+21500,int_stack+15704,21);
 /*--- compute (h0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+28871,int_stack+24335,int_stack+17972,21);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+13940,int_stack+4228,int_stack+3444,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+16292,int_stack+5236,int_stack+4228,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+19316,int_stack+16292,int_stack+13940,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+24020,int_stack+6496,int_stack+5236,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+0,int_stack+24020,int_stack+16292,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+34751,int_stack+0,int_stack+19316,28);
 /*--- compute (hp|if) ---*/
 hrr1_build_hp(Libint->AB,int_stack+42591,int_stack+34751,int_stack+28871,280);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+9044,int_stack+8036,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3024,int_stack+10340,int_stack+9044,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+13940,int_stack+3024,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+19988,int_stack+11960,int_stack+10340,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+24848,int_stack+19988,int_stack+3024,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+24848,int_stack+13940,36);
 /*--- compute (ip|if) ---*/
 hrr1_build_ip(Libint->AB,int_stack+10080,int_stack+0,int_stack+34751,280);
 /*--- compute (hd|if) ---*/
 hrr1_build_hd(Libint->AB,int_stack+60231,int_stack+10080,int_stack+42591,280);
 return int_stack+60231;}
