/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdli(Libint_t*, prim_data*);

  /* Computes quartets of (hd|li) integrals */

REALTYPE *hrr_order_hdli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[5][12] = int_stack + 5124;
 Libint->vrr_classes[5][13] = int_stack + 7035;
 Libint->vrr_classes[5][14] = int_stack + 9240;
 Libint->vrr_classes[6][8] = int_stack + 11760;
 Libint->vrr_classes[6][9] = int_stack + 13020;
 Libint->vrr_classes[6][10] = int_stack + 14560;
 Libint->vrr_classes[6][11] = int_stack + 16408;
 Libint->vrr_classes[6][12] = int_stack + 18592;
 Libint->vrr_classes[6][13] = int_stack + 21140;
 Libint->vrr_classes[6][14] = int_stack + 24080;
 Libint->vrr_classes[7][8] = int_stack + 27440;
 Libint->vrr_classes[7][9] = int_stack + 29060;
 Libint->vrr_classes[7][10] = int_stack + 31040;
 Libint->vrr_classes[7][11] = int_stack + 33416;
 Libint->vrr_classes[7][12] = int_stack + 36224;
 Libint->vrr_classes[7][13] = int_stack + 39500;
 Libint->vrr_classes[7][14] = int_stack + 43280;
 memset(int_stack,0,47600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 47600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdli(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+47600,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+50435,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+53900,int_stack+50435,int_stack+47600,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59570,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+63728,int_stack+59570,int_stack+50435,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+70658,int_stack+63728,int_stack+53900,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+47600,int_stack+5124,int_stack+3486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+80108,int_stack+47600,int_stack+59570,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+88424,int_stack+80108,int_stack+63728,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+52514,int_stack+88424,int_stack+70658,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+66689,int_stack+7035,int_stack+5124,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+99974,int_stack+66689,int_stack+47600,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+109802,int_stack+99974,int_stack+80108,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+123662,int_stack+109802,int_stack+88424,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+72422,int_stack+123662,int_stack+52514,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+47600,int_stack+9240,int_stack+7035,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+54215,int_stack+47600,int_stack+66689,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+140987,int_stack+54215,int_stack+99974,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+47600,int_stack+140987,int_stack+109802,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+92267,int_stack+47600,int_stack+123662,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+116522,int_stack+92267,int_stack+72422,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+47600,int_stack+13020,int_stack+11760,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+51380,int_stack+14560,int_stack+13020,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+56000,int_stack+51380,int_stack+47600,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+63560,int_stack+16408,int_stack+14560,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+69104,int_stack+63560,int_stack+51380,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+78344,int_stack+69104,int_stack+56000,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+47600,int_stack+18592,int_stack+16408,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+90944,int_stack+47600,int_stack+63560,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+90944,int_stack+69104,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+54152,int_stack+0,int_stack+78344,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+73052,int_stack+21140,int_stack+18592,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+102032,int_stack+73052,int_stack+47600,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142982,int_stack+102032,int_stack+90944,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+161462,int_stack+142982,int_stack+0,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+184562,int_stack+161462,int_stack+54152,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+24080,int_stack+21140,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+8820,int_stack+0,int_stack+73052,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+47600,int_stack+8820,int_stack+102032,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+69440,int_stack+47600,int_stack+142982,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+211022,int_stack+69440,int_stack+161462,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+142982,int_stack+211022,int_stack+184562,28);
 /*--- compute (hp|li) ---*/
 hrr1_build_hp(Libint->AB,int_stack+178262,int_stack+142982,int_stack+116522,1260);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+47600,int_stack+29060,int_stack+27440,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+52460,int_stack+31040,int_stack+29060,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+58400,int_stack+52460,int_stack+47600,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68120,int_stack+33416,int_stack+31040,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+75248,int_stack+68120,int_stack+52460,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+87128,int_stack+75248,int_stack+58400,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+47600,int_stack+36224,int_stack+33416,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+103328,int_stack+47600,int_stack+68120,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+117584,int_stack+103328,int_stack+75248,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+56024,int_stack+117584,int_stack+87128,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+80324,int_stack+39500,int_stack+36224,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+80324,int_stack+47600,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+257642,int_stack+0,int_stack+103328,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+281402,int_stack+257642,int_stack+117584,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+90152,int_stack+281402,int_stack+56024,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+47600,int_stack+43280,int_stack+39500,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+58940,int_stack+47600,int_stack+80324,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+16848,int_stack+58940,int_stack+0,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+44928,int_stack+16848,int_stack+257642,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+44928,int_stack+281402,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+257642,int_stack+0,int_stack+90152,36);
 /*--- compute (ip|li) ---*/
 hrr1_build_ip(Libint->AB,int_stack+0,int_stack+257642,int_stack+142982,1260);
 /*--- compute (hd|li) ---*/
 hrr1_build_hd(Libint->AB,int_stack+257642,int_stack+0,int_stack+178262,1260);
 return int_stack+257642;}
