/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hfll(Libint_t*, prim_data*);

  /* Computes quartets of (hf|ll) integrals */

REALTYPE *hrr_order_hfll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[5][12] = int_stack + 5124;
 Libint->vrr_classes[5][13] = int_stack + 7035;
 Libint->vrr_classes[5][14] = int_stack + 9240;
 Libint->vrr_classes[5][15] = int_stack + 11760;
 Libint->vrr_classes[5][16] = int_stack + 14616;
 Libint->vrr_classes[6][8] = int_stack + 17829;
 Libint->vrr_classes[6][9] = int_stack + 19089;
 Libint->vrr_classes[6][10] = int_stack + 20629;
 Libint->vrr_classes[6][11] = int_stack + 22477;
 Libint->vrr_classes[6][12] = int_stack + 24661;
 Libint->vrr_classes[6][13] = int_stack + 27209;
 Libint->vrr_classes[6][14] = int_stack + 30149;
 Libint->vrr_classes[6][15] = int_stack + 33509;
 Libint->vrr_classes[6][16] = int_stack + 37317;
 Libint->vrr_classes[7][8] = int_stack + 41601;
 Libint->vrr_classes[7][9] = int_stack + 43221;
 Libint->vrr_classes[7][10] = int_stack + 45201;
 Libint->vrr_classes[7][11] = int_stack + 47577;
 Libint->vrr_classes[7][12] = int_stack + 50385;
 Libint->vrr_classes[7][13] = int_stack + 53661;
 Libint->vrr_classes[7][14] = int_stack + 57441;
 Libint->vrr_classes[7][15] = int_stack + 61761;
 Libint->vrr_classes[7][16] = int_stack + 66657;
 Libint->vrr_classes[8][8] = int_stack + 72165;
 Libint->vrr_classes[8][9] = int_stack + 74190;
 Libint->vrr_classes[8][10] = int_stack + 76665;
 Libint->vrr_classes[8][11] = int_stack + 79635;
 Libint->vrr_classes[8][12] = int_stack + 83145;
 Libint->vrr_classes[8][13] = int_stack + 87240;
 Libint->vrr_classes[8][14] = int_stack + 91965;
 Libint->vrr_classes[8][15] = int_stack + 97365;
 Libint->vrr_classes[8][16] = int_stack + 103485;
 memset(int_stack,0,110370*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 110370;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hfll(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+110370,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+113205,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+116670,int_stack+113205,int_stack+110370,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+122340,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+126498,int_stack+122340,int_stack+113205,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+133428,int_stack+126498,int_stack+116670,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+110370,int_stack+5124,int_stack+3486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+142878,int_stack+110370,int_stack+122340,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+151194,int_stack+142878,int_stack+126498,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+115284,int_stack+151194,int_stack+133428,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+129459,int_stack+7035,int_stack+5124,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+162744,int_stack+129459,int_stack+110370,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+172572,int_stack+162744,int_stack+142878,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+186432,int_stack+172572,int_stack+151194,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+135192,int_stack+186432,int_stack+115284,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+110370,int_stack+9240,int_stack+7035,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+116985,int_stack+110370,int_stack+129459,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+203757,int_stack+116985,int_stack+162744,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+220137,int_stack+203757,int_stack+172572,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+155037,int_stack+220137,int_stack+186432,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+240927,int_stack+155037,int_stack+135192,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+128451,int_stack+11760,int_stack+9240,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+136011,int_stack+128451,int_stack+110370,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+179292,int_stack+136011,int_stack+116985,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+267387,int_stack+179292,int_stack+203757,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+291957,int_stack+267387,int_stack+220137,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+198402,int_stack+291957,int_stack+155037,21);
 /*--- compute (h0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+321063,int_stack+198402,int_stack+240927,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+110370,int_stack+14616,int_stack+11760,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+149241,int_stack+110370,int_stack+128451,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+110370,int_stack+149241,int_stack+136011,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+132420,int_stack+110370,int_stack+179292,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+161085,int_stack+132420,int_stack+267387,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+110370,int_stack+161085,int_stack+291957,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+149178,int_stack+110370,int_stack+198402,21);
 /*--- compute (h0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+190758,int_stack+149178,int_stack+321063,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+110370,int_stack+19089,int_stack+17829,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+114150,int_stack+20629,int_stack+19089,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+118770,int_stack+114150,int_stack+110370,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+126330,int_stack+22477,int_stack+20629,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+131874,int_stack+126330,int_stack+114150,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+141114,int_stack+131874,int_stack+118770,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+110370,int_stack+24661,int_stack+22477,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+153714,int_stack+110370,int_stack+126330,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+164802,int_stack+153714,int_stack+131874,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+116922,int_stack+164802,int_stack+141114,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+135822,int_stack+27209,int_stack+24661,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+233283,int_stack+135822,int_stack+110370,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+246387,int_stack+233283,int_stack+153714,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+264867,int_stack+246387,int_stack+164802,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+143466,int_stack+264867,int_stack+116922,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+110370,int_stack+30149,int_stack+27209,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+119190,int_stack+110370,int_stack+135822,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+287967,int_stack+119190,int_stack+233283,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+309807,int_stack+287967,int_stack+246387,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+337527,int_stack+309807,int_stack+264867,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+233283,int_stack+337527,int_stack+143466,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+268563,int_stack+33509,int_stack+30149,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+134478,int_stack+268563,int_stack+110370,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+152118,int_stack+134478,int_stack+119190,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+152118,int_stack+287967,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+369867,int_stack+0,int_stack+309807,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+278643,int_stack+369867,int_stack+337527,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+321763,int_stack+278643,int_stack+233283,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+233283,int_stack+37317,int_stack+33509,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+244707,int_stack+233283,int_stack+268563,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+408675,int_stack+244707,int_stack+134478,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+233283,int_stack+408675,int_stack+152118,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+110370,int_stack+233283,int_stack+0,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+408675,int_stack+110370,int_stack+369867,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+110370,int_stack+408675,int_stack+278643,28);
 /*--- compute (i0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+233283,int_stack+110370,int_stack+321763,28);
 /*--- compute (hp|ll) ---*/
 hrr1_build_hp(Libint->AB,int_stack+289983,int_stack+233283,int_stack+190758,2025);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+110370,int_stack+43221,int_stack+41601,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+115230,int_stack+45201,int_stack+43221,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+121170,int_stack+115230,int_stack+110370,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+130890,int_stack+47577,int_stack+45201,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+138018,int_stack+130890,int_stack+115230,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+149898,int_stack+138018,int_stack+121170,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+110370,int_stack+50385,int_stack+47577,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+166098,int_stack+110370,int_stack+130890,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+180354,int_stack+166098,int_stack+138018,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+118794,int_stack+180354,int_stack+149898,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+143094,int_stack+53661,int_stack+50385,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+200154,int_stack+143094,int_stack+110370,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+200154,int_stack+166098,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+23760,int_stack+0,int_stack+180354,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+152922,int_stack+23760,int_stack+118794,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+110370,int_stack+57441,int_stack+53661,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+121710,int_stack+110370,int_stack+143094,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+417558,int_stack+121710,int_stack+200154,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+186942,int_stack+417558,int_stack+0,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+445638,int_stack+186942,int_stack+23760,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+445638,int_stack+152922,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+141366,int_stack+61761,int_stack+57441,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+154326,int_stack+141366,int_stack+110370,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+487218,int_stack+154326,int_stack+121710,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+519978,int_stack+487218,int_stack+417558,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+562098,int_stack+519978,int_stack+186942,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+177006,int_stack+562098,int_stack+445638,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+417558,int_stack+177006,int_stack+0,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+66657,int_stack+61761,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+14688,int_stack+0,int_stack+141366,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+110370,int_stack+14688,int_stack+154326,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+110370,int_stack+487218,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+110370,int_stack+0,int_stack+519978,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+110370,int_stack+562098,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+475878,int_stack+0,int_stack+177006,36);
 /*--- compute (k0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+110370,int_stack+475878,int_stack+417558,36);
 /*--- compute (ip|ll) ---*/
 hrr1_build_ip(Libint->AB,int_stack+417558,int_stack+110370,int_stack+233283,2025);
 /*--- compute (hd|ll) ---*/
 hrr1_build_hd(Libint->AB,int_stack+587658,int_stack+417558,int_stack+289983,2025);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+74190,int_stack+72165,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+6075,int_stack+76665,int_stack+74190,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+13500,int_stack+6075,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+25650,int_stack+79635,int_stack+76665,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+34560,int_stack+25650,int_stack+6075,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+49410,int_stack+34560,int_stack+13500,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+83145,int_stack+79635,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+183270,int_stack+0,int_stack+25650,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+201090,int_stack+183270,int_stack+34560,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+10530,int_stack+201090,int_stack+49410,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+40905,int_stack+87240,int_stack+83145,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+53190,int_stack+40905,int_stack+0,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+225840,int_stack+53190,int_stack+183270,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+255540,int_stack+225840,int_stack+201090,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+183270,int_stack+255540,int_stack+10530,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+91965,int_stack+87240,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+14175,int_stack+0,int_stack+40905,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+292665,int_stack+14175,int_stack+53190,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+38745,int_stack+292665,int_stack+225840,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+327765,int_stack+38745,int_stack+255540,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+225795,int_stack+327765,int_stack+183270,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+183270,int_stack+97365,int_stack+91965,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+379740,int_stack+183270,int_stack+0,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+842808,int_stack+379740,int_stack+14175,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+883758,int_stack+842808,int_stack+292665,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+936408,int_stack+883758,int_stack+38745,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+936408,int_stack+327765,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+282495,int_stack+0,int_stack+225795,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+69300,int_stack+103485,int_stack+97365,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+199470,int_stack+69300,int_stack+183270,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+231870,int_stack+199470,int_stack+379740,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+355395,int_stack+231870,int_stack+842808,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+183270,int_stack+355395,int_stack+883758,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+842808,int_stack+183270,int_stack+936408,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+183270,int_stack+842808,int_stack+0,45);
 /*--- compute (l0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+183270,int_stack+282495,45);
 /*--- compute (kp|ll) ---*/
 hrr1_build_kp(Libint->AB,int_stack+183270,int_stack+0,int_stack+110370,2025);
 /*--- compute (id|ll) ---*/
 hrr1_build_id(Libint->AB,int_stack+842808,int_stack+183270,int_stack+417558,2025);
 /*--- compute (hf|ll) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+842808,int_stack+587658,2025);
 return int_stack+0;}
