/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hfnk(Libint_t*, prim_data*);

  /* Computes quartets of (hf|nk) integrals */

REALTYPE *hrr_order_hfnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[5][15] = int_stack + 9660;
 Libint->vrr_classes[5][16] = int_stack + 12516;
 Libint->vrr_classes[5][17] = int_stack + 15729;
 Libint->vrr_classes[6][10] = int_stack + 19320;
 Libint->vrr_classes[6][11] = int_stack + 21168;
 Libint->vrr_classes[6][12] = int_stack + 23352;
 Libint->vrr_classes[6][13] = int_stack + 25900;
 Libint->vrr_classes[6][14] = int_stack + 28840;
 Libint->vrr_classes[6][15] = int_stack + 32200;
 Libint->vrr_classes[6][16] = int_stack + 36008;
 Libint->vrr_classes[6][17] = int_stack + 40292;
 Libint->vrr_classes[7][10] = int_stack + 45080;
 Libint->vrr_classes[7][11] = int_stack + 47456;
 Libint->vrr_classes[7][12] = int_stack + 50264;
 Libint->vrr_classes[7][13] = int_stack + 53540;
 Libint->vrr_classes[7][14] = int_stack + 57320;
 Libint->vrr_classes[7][15] = int_stack + 61640;
 Libint->vrr_classes[7][16] = int_stack + 66536;
 Libint->vrr_classes[7][17] = int_stack + 72044;
 Libint->vrr_classes[8][10] = int_stack + 78200;
 Libint->vrr_classes[8][11] = int_stack + 81170;
 Libint->vrr_classes[8][12] = int_stack + 84680;
 Libint->vrr_classes[8][13] = int_stack + 88775;
 Libint->vrr_classes[8][14] = int_stack + 93500;
 Libint->vrr_classes[8][15] = int_stack + 98900;
 Libint->vrr_classes[8][16] = int_stack + 105020;
 Libint->vrr_classes[8][17] = int_stack + 111905;
 memset(int_stack,0,119600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 119600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hfnk(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+119600,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+123758,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+128672,int_stack+123758,int_stack+119600,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+136988,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+142721,int_stack+136988,int_stack+123758,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+152549,int_stack+142721,int_stack+128672,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+119600,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+166409,int_stack+119600,int_stack+136988,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+126215,int_stack+166409,int_stack+142721,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+177875,int_stack+126215,int_stack+152549,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+142595,int_stack+9660,int_stack+7140,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+150155,int_stack+142595,int_stack+119600,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+198665,int_stack+150155,int_stack+166409,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+217775,int_stack+198665,int_stack+126215,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+242345,int_stack+217775,int_stack+177875,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+119600,int_stack+12516,int_stack+9660,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+163385,int_stack+119600,int_stack+142595,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+271451,int_stack+163385,int_stack+150155,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+128168,int_stack+271451,int_stack+198665,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+178505,int_stack+128168,int_stack+217775,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+293501,int_stack+178505,int_stack+242345,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+212903,int_stack+15729,int_stack+12516,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+222542,int_stack+212903,int_stack+119600,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+239678,int_stack+222542,int_stack+163385,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+332309,int_stack+239678,int_stack+271451,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+212903,int_stack+332309,int_stack+128168,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+119600,int_stack+212903,int_stack+178505,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+165464,int_stack+119600,int_stack+293501,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+119600,int_stack+21168,int_stack+19320,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+125144,int_stack+23352,int_stack+21168,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+131696,int_stack+125144,int_stack+119600,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+142784,int_stack+25900,int_stack+23352,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+150428,int_stack+142784,int_stack+125144,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+215360,int_stack+150428,int_stack+131696,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+119600,int_stack+28840,int_stack+25900,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+233840,int_stack+119600,int_stack+142784,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+128420,int_stack+233840,int_stack+150428,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+249128,int_stack+128420,int_stack+215360,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+215360,int_stack+32200,int_stack+28840,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+276848,int_stack+215360,int_stack+119600,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+294488,int_stack+276848,int_stack+233840,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+319968,int_stack+294488,int_stack+128420,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+119600,int_stack+319968,int_stack+249128,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+225440,int_stack+36008,int_stack+32200,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+236864,int_stack+225440,int_stack+215360,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+236864,int_stack+276848,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+352728,int_stack+0,int_stack+294488,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+257024,int_stack+352728,int_stack+319968,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+390948,int_stack+257024,int_stack+119600,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+119600,int_stack+40292,int_stack+36008,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+132452,int_stack+119600,int_stack+225440,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+302888,int_stack+132452,int_stack+236864,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+119600,int_stack+302888,int_stack+0,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+442692,int_stack+119600,int_stack+352728,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+302888,int_stack+442692,int_stack+257024,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+215360,int_stack+302888,int_stack+390948,28);
 /*--- compute (hp|nk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+281888,int_stack+215360,int_stack+165464,2376);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+119600,int_stack+47456,int_stack+45080,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+126728,int_stack+50264,int_stack+47456,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+135152,int_stack+126728,int_stack+119600,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+149408,int_stack+53540,int_stack+50264,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+159236,int_stack+149408,int_stack+126728,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+176084,int_stack+159236,int_stack+135152,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+119600,int_stack+57320,int_stack+53540,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+119600,int_stack+149408,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+130940,int_stack+0,int_stack+159236,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+19656,int_stack+130940,int_stack+176084,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+159020,int_stack+61640,int_stack+57320,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+171980,int_stack+159020,int_stack+119600,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+431576,int_stack+171980,int_stack+0,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+464336,int_stack+431576,int_stack+130940,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+506456,int_stack+464336,int_stack+19656,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+66536,int_stack+61640,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+14688,int_stack+0,int_stack+159020,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+119600,int_stack+14688,int_stack+171980,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+157400,int_stack+119600,int_stack+431576,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+556352,int_stack+157400,int_stack+464336,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+431576,int_stack+556352,int_stack+506456,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+498104,int_stack+72044,int_stack+66536,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+514628,int_stack+498104,int_stack+0,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+615320,int_stack+514628,int_stack+14688,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+615320,int_stack+119600,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+615320,int_stack+0,int_stack+157400,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+119600,int_stack+615320,int_stack+556352,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+498104,int_stack+119600,int_stack+431576,36);
 /*--- compute (ip|nk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+583640,int_stack+498104,int_stack+215360,2376);
 /*--- compute (hd|nk) ---*/
 hrr1_build_hd(Libint->AB,int_stack+783224,int_stack+583640,int_stack+281888,2376);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+119600,int_stack+81170,int_stack+78200,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+128510,int_stack+84680,int_stack+81170,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+139040,int_stack+128510,int_stack+119600,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+156860,int_stack+88775,int_stack+84680,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+169145,int_stack+156860,int_stack+128510,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+190205,int_stack+169145,int_stack+139040,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+119600,int_stack+93500,int_stack+88775,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+219905,int_stack+119600,int_stack+156860,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+133775,int_stack+219905,int_stack+169145,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+244475,int_stack+133775,int_stack+190205,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+168875,int_stack+98900,int_stack+93500,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+185075,int_stack+168875,int_stack+119600,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+289025,int_stack+185075,int_stack+219905,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+329975,int_stack+289025,int_stack+133775,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+382625,int_stack+329975,int_stack+244475,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+119600,int_stack+105020,int_stack+98900,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+213425,int_stack+119600,int_stack+168875,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+444995,int_stack+213425,int_stack+185075,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+137960,int_stack+444995,int_stack+289025,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+245825,int_stack+137960,int_stack+329975,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+245825,int_stack+382625,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+319535,int_stack+111905,int_stack+105020,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+340190,int_stack+319535,int_stack+119600,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+376910,int_stack+340190,int_stack+213425,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1082600,int_stack+376910,int_stack+444995,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+319535,int_stack+1082600,int_stack+137960,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+83160,int_stack+319535,int_stack+245825,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+181440,int_stack+83160,int_stack+0,45);
 /*--- compute (kp|nk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+1082600,int_stack+181440,int_stack+498104,2376);
 /*--- compute (id|nk) ---*/
 hrr1_build_id(Libint->AB,int_stack+0,int_stack+1082600,int_stack+583640,2376);
 /*--- compute (hf|nk) ---*/
 hrr1_build_hf(Libint->AB,int_stack+1082600,int_stack+0,int_stack+783224,2376);
 return int_stack+1082600;}
