/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgki(Libint_t*, prim_data*);

  /* Computes quartets of (hg|ki) integrals */

REALTYPE *hrr_order_hgki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[5][10] = int_stack + 2856;
 Libint->vrr_classes[5][11] = int_stack + 4242;
 Libint->vrr_classes[5][12] = int_stack + 5880;
 Libint->vrr_classes[5][13] = int_stack + 7791;
 Libint->vrr_classes[6][7] = int_stack + 9996;
 Libint->vrr_classes[6][8] = int_stack + 11004;
 Libint->vrr_classes[6][9] = int_stack + 12264;
 Libint->vrr_classes[6][10] = int_stack + 13804;
 Libint->vrr_classes[6][11] = int_stack + 15652;
 Libint->vrr_classes[6][12] = int_stack + 17836;
 Libint->vrr_classes[6][13] = int_stack + 20384;
 Libint->vrr_classes[7][7] = int_stack + 23324;
 Libint->vrr_classes[7][8] = int_stack + 24620;
 Libint->vrr_classes[7][9] = int_stack + 26240;
 Libint->vrr_classes[7][10] = int_stack + 28220;
 Libint->vrr_classes[7][11] = int_stack + 30596;
 Libint->vrr_classes[7][12] = int_stack + 33404;
 Libint->vrr_classes[7][13] = int_stack + 36680;
 Libint->vrr_classes[8][7] = int_stack + 40460;
 Libint->vrr_classes[8][8] = int_stack + 42080;
 Libint->vrr_classes[8][9] = int_stack + 44105;
 Libint->vrr_classes[8][10] = int_stack + 46580;
 Libint->vrr_classes[8][11] = int_stack + 49550;
 Libint->vrr_classes[8][12] = int_stack + 53060;
 Libint->vrr_classes[8][13] = int_stack + 57155;
 Libint->vrr_classes[9][7] = int_stack + 61880;
 Libint->vrr_classes[9][8] = int_stack + 63860;
 Libint->vrr_classes[9][9] = int_stack + 66335;
 Libint->vrr_classes[9][10] = int_stack + 69360;
 Libint->vrr_classes[9][11] = int_stack + 72990;
 Libint->vrr_classes[9][12] = int_stack + 77280;
 Libint->vrr_classes[9][13] = int_stack + 82285;
 memset(int_stack,0,88060*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 88060;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgki(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+88060,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+90328,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+93163,int_stack+90328,int_stack+88060,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+97699,int_stack+2856,int_stack+1701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+101164,int_stack+97699,int_stack+90328,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+106834,int_stack+101164,int_stack+93163,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+88060,int_stack+4242,int_stack+2856,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+114394,int_stack+88060,int_stack+97699,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+121324,int_stack+114394,int_stack+101164,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+92218,int_stack+121324,int_stack+106834,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+103558,int_stack+5880,int_stack+4242,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+130774,int_stack+103558,int_stack+88060,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+139090,int_stack+130774,int_stack+114394,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+150640,int_stack+139090,int_stack+121324,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+108472,int_stack+150640,int_stack+92218,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+88060,int_stack+7791,int_stack+5880,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+88060,int_stack+103558,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+88060,int_stack+0,int_stack+130774,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+164815,int_stack+88060,int_stack+139090,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+88060,int_stack+164815,int_stack+150640,21);
 /*--- compute (h0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+124348,int_stack+88060,int_stack+108472,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+88060,int_stack+11004,int_stack+9996,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+91084,int_stack+12264,int_stack+11004,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+94864,int_stack+91084,int_stack+88060,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+100912,int_stack+13804,int_stack+12264,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+105532,int_stack+100912,int_stack+91084,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+113092,int_stack+105532,int_stack+94864,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+88060,int_stack+15652,int_stack+13804,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+88060,int_stack+100912,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+145516,int_stack+0,int_stack+105532,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+93604,int_stack+145516,int_stack+113092,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+108724,int_stack+17836,int_stack+15652,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+158116,int_stack+108724,int_stack+88060,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+169204,int_stack+158116,int_stack+0,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+184604,int_stack+169204,int_stack+145516,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+203504,int_stack+184604,int_stack+93604,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+145516,int_stack+20384,int_stack+17836,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+145516,int_stack+108724,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+88060,int_stack+0,int_stack+158116,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+88060,int_stack+169204,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+88060,int_stack+0,int_stack+184604,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+145516,int_stack+88060,int_stack+203504,28);
 /*--- compute (hp|ki) ---*/
 hrr1_build_hp(Libint->AB,int_stack+173740,int_stack+145516,int_stack+124348,1008);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+88060,int_stack+24620,int_stack+23324,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+91948,int_stack+26240,int_stack+24620,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+96808,int_stack+91948,int_stack+88060,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+104584,int_stack+28220,int_stack+26240,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+110524,int_stack+104584,int_stack+91948,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+120244,int_stack+110524,int_stack+96808,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+88060,int_stack+30596,int_stack+28220,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+133204,int_stack+88060,int_stack+104584,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+133204,int_stack+110524,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+95188,int_stack+0,int_stack+120244,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+114628,int_stack+33404,int_stack+30596,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+16200,int_stack+114628,int_stack+88060,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+237244,int_stack+16200,int_stack+133204,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+257044,int_stack+237244,int_stack+0,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+281344,int_stack+257044,int_stack+95188,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+36680,int_stack+33404,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+88060,int_stack+0,int_stack+114628,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+104908,int_stack+88060,int_stack+16200,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+104908,int_stack+237244,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+88060,int_stack+0,int_stack+257044,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+0,int_stack+88060,int_stack+281344,36);
 /*--- compute (ip|ki) ---*/
 hrr1_build_ip(Libint->AB,int_stack+237244,int_stack+0,int_stack+145516,1008);
 /*--- compute (hd|ki) ---*/
 hrr1_build_hd(Libint->AB,int_stack+321916,int_stack+237244,int_stack+173740,1008);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+88060,int_stack+42080,int_stack+40460,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+92920,int_stack+44105,int_stack+42080,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+98995,int_stack+92920,int_stack+88060,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+108715,int_stack+46580,int_stack+44105,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+116140,int_stack+108715,int_stack+92920,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+128290,int_stack+116140,int_stack+98995,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+88060,int_stack+49550,int_stack+46580,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+144490,int_stack+88060,int_stack+108715,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+159340,int_stack+144490,int_stack+116140,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+96970,int_stack+159340,int_stack+128290,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+121270,int_stack+53060,int_stack+49550,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+179590,int_stack+121270,int_stack+88060,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+197410,int_stack+179590,int_stack+144490,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+448924,int_stack+197410,int_stack+159340,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+131800,int_stack+448924,int_stack+96970,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+88060,int_stack+57155,int_stack+53060,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+36288,int_stack+88060,int_stack+121270,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+88060,int_stack+36288,int_stack+179590,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+479299,int_stack+88060,int_stack+197410,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+88060,int_stack+479299,int_stack+448924,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+448924,int_stack+88060,int_stack+131800,45);
 /*--- compute (kp|ki) ---*/
 hrr1_build_kp(Libint->AB,int_stack+88060,int_stack+448924,int_stack+0,1008);
 /*--- compute (id|ki) ---*/
 hrr1_build_id(Libint->AB,int_stack+494284,int_stack+88060,int_stack+237244,1008);
 /*--- compute (hf|ki) ---*/
 hrr1_build_hf(Libint->AB,int_stack+663628,int_stack+494284,int_stack+321916,1008);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+63860,int_stack+61880,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5940,int_stack+66335,int_stack+63860,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+13365,int_stack+5940,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25245,int_stack+69360,int_stack+66335,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+34320,int_stack+25245,int_stack+5940,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+49170,int_stack+34320,int_stack+13365,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+72990,int_stack+69360,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+196924,int_stack+0,int_stack+25245,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+215074,int_stack+196924,int_stack+34320,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+10890,int_stack+215074,int_stack+49170,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+40590,int_stack+77280,int_stack+72990,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+53460,int_stack+40590,int_stack+0,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+239824,int_stack+53460,int_stack+196924,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+270074,int_stack+239824,int_stack+215074,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+196924,int_stack+270074,int_stack+10890,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+82285,int_stack+77280,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+307199,int_stack+0,int_stack+40590,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+307199,int_stack+53460,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+307199,int_stack+0,int_stack+239824,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+307199,int_stack+270074,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+238504,int_stack+0,int_stack+196924,55);
 /*--- compute (lp|ki) ---*/
 hrr1_build_lp(Libint->AB,int_stack+293944,int_stack+238504,int_stack+448924,1008);
 /*--- compute (kd|ki) ---*/
 hrr1_build_kd(Libint->AB,int_stack+875308,int_stack+293944,int_stack+88060,1008);
 /*--- compute (if|ki) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+875308,int_stack+494284,1008);
 /*--- compute (hg|ki) ---*/
 hrr1_build_hg(Libint->AB,int_stack+282240,int_stack+0,int_stack+663628,1008);
 return int_stack+282240;}
