/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgkk(Libint_t*, prim_data*);

  /* Computes quartets of (hg|kk) integrals */

REALTYPE *hrr_order_hgkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[5][10] = int_stack + 2856;
 Libint->vrr_classes[5][11] = int_stack + 4242;
 Libint->vrr_classes[5][12] = int_stack + 5880;
 Libint->vrr_classes[5][13] = int_stack + 7791;
 Libint->vrr_classes[5][14] = int_stack + 9996;
 Libint->vrr_classes[6][7] = int_stack + 12516;
 Libint->vrr_classes[6][8] = int_stack + 13524;
 Libint->vrr_classes[6][9] = int_stack + 14784;
 Libint->vrr_classes[6][10] = int_stack + 16324;
 Libint->vrr_classes[6][11] = int_stack + 18172;
 Libint->vrr_classes[6][12] = int_stack + 20356;
 Libint->vrr_classes[6][13] = int_stack + 22904;
 Libint->vrr_classes[6][14] = int_stack + 25844;
 Libint->vrr_classes[7][7] = int_stack + 29204;
 Libint->vrr_classes[7][8] = int_stack + 30500;
 Libint->vrr_classes[7][9] = int_stack + 32120;
 Libint->vrr_classes[7][10] = int_stack + 34100;
 Libint->vrr_classes[7][11] = int_stack + 36476;
 Libint->vrr_classes[7][12] = int_stack + 39284;
 Libint->vrr_classes[7][13] = int_stack + 42560;
 Libint->vrr_classes[7][14] = int_stack + 46340;
 Libint->vrr_classes[8][7] = int_stack + 50660;
 Libint->vrr_classes[8][8] = int_stack + 52280;
 Libint->vrr_classes[8][9] = int_stack + 54305;
 Libint->vrr_classes[8][10] = int_stack + 56780;
 Libint->vrr_classes[8][11] = int_stack + 59750;
 Libint->vrr_classes[8][12] = int_stack + 63260;
 Libint->vrr_classes[8][13] = int_stack + 67355;
 Libint->vrr_classes[8][14] = int_stack + 72080;
 Libint->vrr_classes[9][7] = int_stack + 77480;
 Libint->vrr_classes[9][8] = int_stack + 79460;
 Libint->vrr_classes[9][9] = int_stack + 81935;
 Libint->vrr_classes[9][10] = int_stack + 84960;
 Libint->vrr_classes[9][11] = int_stack + 88590;
 Libint->vrr_classes[9][12] = int_stack + 92880;
 Libint->vrr_classes[9][13] = int_stack + 97885;
 Libint->vrr_classes[9][14] = int_stack + 103660;
 memset(int_stack,0,110260*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 110260;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgkk(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+110260,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+112528,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+115363,int_stack+112528,int_stack+110260,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+119899,int_stack+2856,int_stack+1701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+123364,int_stack+119899,int_stack+112528,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+129034,int_stack+123364,int_stack+115363,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+110260,int_stack+4242,int_stack+2856,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+136594,int_stack+110260,int_stack+119899,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+143524,int_stack+136594,int_stack+123364,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+114418,int_stack+143524,int_stack+129034,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+125758,int_stack+5880,int_stack+4242,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+152974,int_stack+125758,int_stack+110260,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+161290,int_stack+152974,int_stack+136594,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+172840,int_stack+161290,int_stack+143524,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+130672,int_stack+172840,int_stack+114418,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+110260,int_stack+7791,int_stack+5880,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+187015,int_stack+110260,int_stack+125758,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+115993,int_stack+187015,int_stack+152974,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+196843,int_stack+115993,int_stack+161290,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+146548,int_stack+196843,int_stack+172840,21);
 /*--- compute (h0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+214168,int_stack+146548,int_stack+130672,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+129853,int_stack+9996,int_stack+7791,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+166393,int_stack+129853,int_stack+110260,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+129853,int_stack+166393,int_stack+187015,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+166393,int_stack+129853,int_stack+115993,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+110260,int_stack+166393,int_stack+196843,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+166393,int_stack+110260,int_stack+146548,21);
 /*--- compute (h0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+110260,int_stack+166393,int_stack+214168,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+137476,int_stack+13524,int_stack+12516,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+140500,int_stack+14784,int_stack+13524,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+144280,int_stack+140500,int_stack+137476,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+150328,int_stack+16324,int_stack+14784,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+154948,int_stack+150328,int_stack+140500,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+162508,int_stack+154948,int_stack+144280,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+137476,int_stack+18172,int_stack+16324,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+172588,int_stack+137476,int_stack+150328,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+181828,int_stack+172588,int_stack+154948,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+143020,int_stack+181828,int_stack+162508,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+158140,int_stack+20356,int_stack+18172,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+194428,int_stack+158140,int_stack+137476,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+205516,int_stack+194428,int_stack+172588,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+205516,int_stack+181828,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+164692,int_stack+0,int_stack+143020,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+137476,int_stack+22904,int_stack+20356,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+220916,int_stack+137476,int_stack+158140,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+145120,int_stack+220916,int_stack+194428,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+234020,int_stack+145120,int_stack+205516,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+185860,int_stack+234020,int_stack+0,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+257120,int_stack+185860,int_stack+164692,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+25844,int_stack+22904,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+8820,int_stack+0,int_stack+137476,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+163600,int_stack+8820,int_stack+220916,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+163600,int_stack+145120,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+137476,int_stack+0,int_stack+234020,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+212320,int_stack+137476,int_stack+185860,28);
 /*--- compute (i0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+137476,int_stack+212320,int_stack+257120,28);
 /*--- compute (hp|kk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+173764,int_stack+137476,int_stack+110260,1296);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+110260,int_stack+30500,int_stack+29204,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+114148,int_stack+32120,int_stack+30500,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+119008,int_stack+114148,int_stack+110260,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+126784,int_stack+34100,int_stack+32120,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+255412,int_stack+126784,int_stack+114148,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+265132,int_stack+255412,int_stack+119008,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+110260,int_stack+36476,int_stack+34100,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+110260,int_stack+126784,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+117388,int_stack+0,int_stack+255412,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+11880,int_stack+117388,int_stack+265132,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+255412,int_stack+39284,int_stack+36476,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+263836,int_stack+255412,int_stack+110260,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+278092,int_stack+263836,int_stack+0,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+297892,int_stack+278092,int_stack+117388,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+110260,int_stack+297892,int_stack+11880,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+42560,int_stack+39284,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+9828,int_stack+0,int_stack+255412,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+322192,int_stack+9828,int_stack+263836,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+345952,int_stack+322192,int_stack+278092,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+255412,int_stack+345952,int_stack+297892,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+375652,int_stack+255412,int_stack+110260,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+110260,int_stack+46340,int_stack+42560,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+289432,int_stack+110260,int_stack+0,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+411940,int_stack+289432,int_stack+9828,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+411940,int_stack+322192,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+289432,int_stack+0,int_stack+345952,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+289432,int_stack+255412,36);
 /*--- compute (k0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+255412,int_stack+0,int_stack+375652,36);
 /*--- compute (ip|kk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+302068,int_stack+255412,int_stack+137476,1296);
 /*--- compute (hd|kk) ---*/
 hrr1_build_hd(Libint->AB,int_stack+410932,int_stack+302068,int_stack+173764,1296);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+52280,int_stack+50660,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+4860,int_stack+54305,int_stack+52280,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+10935,int_stack+4860,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+20655,int_stack+56780,int_stack+54305,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+28080,int_stack+20655,int_stack+4860,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+40230,int_stack+28080,int_stack+10935,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+59750,int_stack+56780,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+110260,int_stack+0,int_stack+20655,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+125110,int_stack+110260,int_stack+28080,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+8910,int_stack+125110,int_stack+40230,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33210,int_stack+63260,int_stack+59750,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+43740,int_stack+33210,int_stack+0,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+145360,int_stack+43740,int_stack+110260,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+170110,int_stack+145360,int_stack+125110,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+110260,int_stack+170110,int_stack+8910,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+67355,int_stack+63260,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+200485,int_stack+0,int_stack+33210,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+12285,int_stack+200485,int_stack+43740,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+574228,int_stack+12285,int_stack+145360,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+611353,int_stack+574228,int_stack+170110,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+144280,int_stack+611353,int_stack+110260,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+110260,int_stack+72080,int_stack+67355,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+41985,int_stack+110260,int_stack+0,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+653878,int_stack+41985,int_stack+200485,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+189640,int_stack+653878,int_stack+12285,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+189640,int_stack+574228,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+189640,int_stack+0,int_stack+611353,45);
 /*--- compute (l0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+0,int_stack+189640,int_stack+144280,45);
 /*--- compute (kp|kk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+110260,int_stack+0,int_stack+255412,1296);
 /*--- compute (id|kk) ---*/
 hrr1_build_id(Libint->AB,int_stack+574228,int_stack+110260,int_stack+302068,1296);
 /*--- compute (hf|kk) ---*/
 hrr1_build_hf(Libint->AB,int_stack+791956,int_stack+574228,int_stack+410932,1296);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+58320,int_stack+79460,int_stack+77480,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+64260,int_stack+81935,int_stack+79460,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+250228,int_stack+64260,int_stack+58320,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+71685,int_stack+84960,int_stack+81935,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+262108,int_stack+71685,int_stack+64260,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+276958,int_stack+262108,int_stack+250228,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+250228,int_stack+88590,int_stack+84960,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+296758,int_stack+250228,int_stack+71685,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+58320,int_stack+296758,int_stack+262108,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+314908,int_stack+58320,int_stack+276958,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+261118,int_stack+92880,int_stack+88590,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+273988,int_stack+261118,int_stack+250228,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+344608,int_stack+273988,int_stack+296758,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+374858,int_stack+344608,int_stack+58320,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+411983,int_stack+374858,int_stack+314908,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+58320,int_stack+97885,int_stack+92880,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+295768,int_stack+58320,int_stack+261118,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+453563,int_stack+295768,int_stack+273988,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+250228,int_stack+453563,int_stack+344608,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+321508,int_stack+250228,int_stack+374858,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+489863,int_stack+321508,int_stack+411983,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+73335,int_stack+103660,int_stack+97885,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+373483,int_stack+73335,int_stack+58320,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+58320,int_stack+373483,int_stack+295768,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+373483,int_stack+58320,int_stack+453563,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1064116,int_stack+373483,int_stack+250228,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+250228,int_stack+1064116,int_stack+321508,55);
 /*--- compute (m0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+319528,int_stack+250228,int_stack+489863,55);
 /*--- compute (lp|kk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+390808,int_stack+319528,int_stack+0,1296);
 /*--- compute (kd|kk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1064116,int_stack+390808,int_stack+110260,1296);
 /*--- compute (if|kk) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+1064116,int_stack+574228,1296);
 /*--- compute (hg|kk) ---*/
 hrr1_build_hg(Libint->AB,int_stack+362880,int_stack+0,int_stack+791956,1296);
 return int_stack+362880;}
