/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgm0(Libint_t*, prim_data*);

  /* Computes quartets of (hg|m0) integrals */

REALTYPE *hrr_order_hgm0(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1155;
 Libint->vrr_classes[7][9] = int_stack + 2695;
 Libint->vrr_classes[8][9] = int_stack + 4675;
 Libint->vrr_classes[9][9] = int_stack + 7150;
 memset(int_stack,0,10175*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 10175;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgm0(Libint, Data);
   Data++;
 }
 /*--- compute (hp|m0) ---*/
 hrr1_build_hp(Libint->AB,int_stack+10175,int_stack+1155,int_stack+0,55);
 /*--- compute (ip|m0) ---*/
 hrr1_build_ip(Libint->AB,int_stack+13640,int_stack+2695,int_stack+1155,55);
 /*--- compute (hd|m0) ---*/
 hrr1_build_hd(Libint->AB,int_stack+18260,int_stack+13640,int_stack+10175,55);
 /*--- compute (kp|m0) ---*/
 hrr1_build_kp(Libint->AB,int_stack+25190,int_stack+4675,int_stack+2695,55);
 /*--- compute (id|m0) ---*/
 hrr1_build_id(Libint->AB,int_stack+31130,int_stack+25190,int_stack+13640,55);
 /*--- compute (hf|m0) ---*/
 hrr1_build_hf(Libint->AB,int_stack+40370,int_stack+31130,int_stack+18260,55);
 /*--- compute (lp|m0) ---*/
 hrr1_build_lp(Libint->AB,int_stack+10175,int_stack+7150,int_stack+4675,55);
 /*--- compute (kd|m0) ---*/
 hrr1_build_kd(Libint->AB,int_stack+51920,int_stack+10175,int_stack+25190,55);
 /*--- compute (if|m0) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+51920,int_stack+31130,55);
 /*--- compute (hg|m0) ---*/
 hrr1_build_hg(Libint->AB,int_stack+15400,int_stack+0,int_stack+40370,55);
 return int_stack+15400;}
