/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgmf(Libint_t*, prim_data*);

  /* Computes quartets of (hg|mf) integrals */

REALTYPE *hrr_order_hgmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[6][9] = int_stack + 6090;
 Libint->vrr_classes[6][10] = int_stack + 7630;
 Libint->vrr_classes[6][11] = int_stack + 9478;
 Libint->vrr_classes[6][12] = int_stack + 11662;
 Libint->vrr_classes[7][9] = int_stack + 14210;
 Libint->vrr_classes[7][10] = int_stack + 16190;
 Libint->vrr_classes[7][11] = int_stack + 18566;
 Libint->vrr_classes[7][12] = int_stack + 21374;
 Libint->vrr_classes[8][9] = int_stack + 24650;
 Libint->vrr_classes[8][10] = int_stack + 27125;
 Libint->vrr_classes[8][11] = int_stack + 30095;
 Libint->vrr_classes[8][12] = int_stack + 33605;
 Libint->vrr_classes[9][9] = int_stack + 37700;
 Libint->vrr_classes[9][10] = int_stack + 40725;
 Libint->vrr_classes[9][11] = int_stack + 44355;
 Libint->vrr_classes[9][12] = int_stack + 48645;
 memset(int_stack,0,53650*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 53650;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgmf(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+53650,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+57115,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+61273,int_stack+57115,int_stack+53650,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+68203,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+73117,int_stack+68203,int_stack+57115,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+81433,int_stack+73117,int_stack+61273,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+53650,int_stack+7630,int_stack+6090,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+58270,int_stack+9478,int_stack+7630,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+63814,int_stack+58270,int_stack+53650,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+73054,int_stack+11662,int_stack+9478,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+73054,int_stack+58270,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+92983,int_stack+0,int_stack+63814,28);
 /*--- compute (hp|mf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+108383,int_stack+92983,int_stack+81433,550);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+16190,int_stack+14210,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+5940,int_stack+18566,int_stack+16190,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+53650,int_stack+5940,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+65530,int_stack+21374,int_stack+18566,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+73954,int_stack+65530,int_stack+5940,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+73954,int_stack+53650,36);
 /*--- compute (ip|mf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+143033,int_stack+0,int_stack+92983,550);
 /*--- compute (hd|mf) ---*/
 hrr1_build_hd(Libint->AB,int_stack+189233,int_stack+143033,int_stack+108383,550);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+53650,int_stack+27125,int_stack+24650,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+61075,int_stack+30095,int_stack+27125,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+69985,int_stack+61075,int_stack+53650,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84835,int_stack+33605,int_stack+30095,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+95365,int_stack+84835,int_stack+61075,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+113185,int_stack+95365,int_stack+69985,45);
 /*--- compute (kp|mf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+53650,int_stack+113185,int_stack+0,550);
 /*--- compute (id|mf) ---*/
 hrr1_build_id(Libint->AB,int_stack+258533,int_stack+53650,int_stack+143033,550);
 /*--- compute (hf|mf) ---*/
 hrr1_build_hf(Libint->AB,int_stack+350933,int_stack+258533,int_stack+189233,550);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+40725,int_stack+37700,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9075,int_stack+44355,int_stack+40725,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19965,int_stack+9075,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+137935,int_stack+48645,int_stack+44355,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+150805,int_stack+137935,int_stack+9075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+172585,int_stack+150805,int_stack+19965,55);
 /*--- compute (lp|mf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+466433,int_stack+172585,int_stack+113185,550);
 /*--- compute (kd|mf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+113050,int_stack+466433,int_stack+53650,550);
 /*--- compute (if|mf) ---*/
 hrr1_build_if(Libint->AB,int_stack+466433,int_stack+113050,int_stack+258533,550);
 /*--- compute (hg|mf) ---*/
 hrr1_build_hg(Libint->AB,int_stack+0,int_stack+466433,int_stack+350933,550);
 return int_stack+0;}
