/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgmm(Libint_t*, prim_data*);

  /* Computes quartets of (hg|mm) integrals */

REALTYPE *hrr_order_hgmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[5][14] = int_stack + 8295;
 Libint->vrr_classes[5][15] = int_stack + 10815;
 Libint->vrr_classes[5][16] = int_stack + 13671;
 Libint->vrr_classes[5][17] = int_stack + 16884;
 Libint->vrr_classes[5][18] = int_stack + 20475;
 Libint->vrr_classes[6][9] = int_stack + 24465;
 Libint->vrr_classes[6][10] = int_stack + 26005;
 Libint->vrr_classes[6][11] = int_stack + 27853;
 Libint->vrr_classes[6][12] = int_stack + 30037;
 Libint->vrr_classes[6][13] = int_stack + 32585;
 Libint->vrr_classes[6][14] = int_stack + 35525;
 Libint->vrr_classes[6][15] = int_stack + 38885;
 Libint->vrr_classes[6][16] = int_stack + 42693;
 Libint->vrr_classes[6][17] = int_stack + 46977;
 Libint->vrr_classes[6][18] = int_stack + 51765;
 Libint->vrr_classes[7][9] = int_stack + 57085;
 Libint->vrr_classes[7][10] = int_stack + 59065;
 Libint->vrr_classes[7][11] = int_stack + 61441;
 Libint->vrr_classes[7][12] = int_stack + 64249;
 Libint->vrr_classes[7][13] = int_stack + 67525;
 Libint->vrr_classes[7][14] = int_stack + 71305;
 Libint->vrr_classes[7][15] = int_stack + 75625;
 Libint->vrr_classes[7][16] = int_stack + 80521;
 Libint->vrr_classes[7][17] = int_stack + 86029;
 Libint->vrr_classes[7][18] = int_stack + 92185;
 Libint->vrr_classes[8][9] = int_stack + 99025;
 Libint->vrr_classes[8][10] = int_stack + 101500;
 Libint->vrr_classes[8][11] = int_stack + 104470;
 Libint->vrr_classes[8][12] = int_stack + 107980;
 Libint->vrr_classes[8][13] = int_stack + 112075;
 Libint->vrr_classes[8][14] = int_stack + 116800;
 Libint->vrr_classes[8][15] = int_stack + 122200;
 Libint->vrr_classes[8][16] = int_stack + 128320;
 Libint->vrr_classes[8][17] = int_stack + 135205;
 Libint->vrr_classes[8][18] = int_stack + 142900;
 Libint->vrr_classes[9][9] = int_stack + 151450;
 Libint->vrr_classes[9][10] = int_stack + 154475;
 Libint->vrr_classes[9][11] = int_stack + 158105;
 Libint->vrr_classes[9][12] = int_stack + 162395;
 Libint->vrr_classes[9][13] = int_stack + 167400;
 Libint->vrr_classes[9][14] = int_stack + 173175;
 Libint->vrr_classes[9][15] = int_stack + 179775;
 Libint->vrr_classes[9][16] = int_stack + 187255;
 Libint->vrr_classes[9][17] = int_stack + 195670;
 Libint->vrr_classes[9][18] = int_stack + 205075;
 memset(int_stack,0,215525*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 215525;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgmm(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+215525,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+218990,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+223148,int_stack+218990,int_stack+215525,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+230078,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+234992,int_stack+230078,int_stack+218990,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+243308,int_stack+234992,int_stack+223148,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+215525,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+254858,int_stack+215525,int_stack+230078,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+264686,int_stack+254858,int_stack+234992,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+221258,int_stack+264686,int_stack+243308,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+238583,int_stack+8295,int_stack+6090,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+278546,int_stack+238583,int_stack+215525,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+290012,int_stack+278546,int_stack+254858,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+306392,int_stack+290012,int_stack+264686,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+245198,int_stack+306392,int_stack+221258,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+215525,int_stack+10815,int_stack+8295,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+223085,int_stack+215525,int_stack+238583,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+327182,int_stack+223085,int_stack+278546,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+346292,int_stack+327182,int_stack+290012,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+269453,int_stack+346292,int_stack+306392,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+370862,int_stack+269453,int_stack+245198,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+236315,int_stack+13671,int_stack+10815,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+244883,int_stack+236315,int_stack+215525,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+298559,int_stack+244883,int_stack+223085,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+403202,int_stack+298559,int_stack+327182,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+431867,int_stack+403202,int_stack+346292,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+320609,int_stack+431867,int_stack+269453,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+466265,int_stack+320609,int_stack+370862,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+215525,int_stack+16884,int_stack+13671,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+260003,int_stack+215525,int_stack+236315,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+359417,int_stack+260003,int_stack+244883,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+225164,int_stack+359417,int_stack+298559,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+277139,int_stack+225164,int_stack+403202,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+384617,int_stack+277139,int_stack+431867,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+507845,int_stack+384617,int_stack+320609,21);
 /*--- compute (h0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+557741,int_stack+507845,int_stack+466265,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+317270,int_stack+20475,int_stack+16884,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+328043,int_stack+317270,int_stack+215525,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+430481,int_stack+328043,int_stack+260003,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+317270,int_stack+430481,int_stack+359417,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+430481,int_stack+317270,int_stack+225164,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+317270,int_stack+430481,int_stack+277139,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+430481,int_stack+317270,int_stack+384617,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+215525,int_stack+430481,int_stack+507845,21);
 /*--- compute (h0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+277895,int_stack+215525,int_stack+557741,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+215525,int_stack+26005,int_stack+24465,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+220145,int_stack+27853,int_stack+26005,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+225689,int_stack+220145,int_stack+215525,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+234929,int_stack+30037,int_stack+27853,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+241481,int_stack+234929,int_stack+220145,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+252569,int_stack+241481,int_stack+225689,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+215525,int_stack+32585,int_stack+30037,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+341420,int_stack+215525,int_stack+234929,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+354524,int_stack+341420,int_stack+241481,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+223169,int_stack+354524,int_stack+252569,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+246269,int_stack+35525,int_stack+32585,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+255089,int_stack+246269,int_stack+215525,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+373004,int_stack+255089,int_stack+341420,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+394844,int_stack+373004,int_stack+354524,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+422564,int_stack+394844,int_stack+223169,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+341420,int_stack+38885,int_stack+35525,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+351500,int_stack+341420,int_stack+246269,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+215525,int_stack+351500,int_stack+255089,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+241005,int_stack+215525,int_stack+373004,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+454904,int_stack+241005,int_stack+394844,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+369140,int_stack+454904,int_stack+422564,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+412260,int_stack+42693,int_stack+38885,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+423684,int_stack+412260,int_stack+341420,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+493712,int_stack+423684,int_stack+351500,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+523112,int_stack+493712,int_stack+215525,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+561332,int_stack+523112,int_stack+241005,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+215525,int_stack+561332,int_stack+454904,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+607196,int_stack+215525,int_stack+369140,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+341420,int_stack+46977,int_stack+42693,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+354272,int_stack+341420,int_stack+412260,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+377120,int_stack+354272,int_stack+423684,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+410720,int_stack+377120,int_stack+493712,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+454820,int_stack+410720,int_stack+523112,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+662636,int_stack+454820,int_stack+561332,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+508328,int_stack+662636,int_stack+215525,28);
 /*--- compute (i0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+723788,int_stack+508328,int_stack+607196,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+215525,int_stack+51765,int_stack+46977,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+229889,int_stack+215525,int_stack+341420,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+574856,int_stack+229889,int_stack+354272,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+215525,int_stack+574856,int_stack+377120,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+574856,int_stack+215525,int_stack+410720,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+341420,int_stack+574856,int_stack+454820,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+574856,int_stack+341420,int_stack+662636,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+341420,int_stack+574856,int_stack+508328,28);
 /*--- compute (i0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+424580,int_stack+341420,int_stack+723788,28);
 /*--- compute (hp|mm) ---*/
 hrr1_build_hp(Libint->AB,int_stack+509280,int_stack+424580,int_stack+277895,3025);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+699855,int_stack+59065,int_stack+57085,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+705795,int_stack+61441,int_stack+59065,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+712923,int_stack+705795,int_stack+699855,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+724803,int_stack+64249,int_stack+61441,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+733227,int_stack+724803,int_stack+705795,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+747483,int_stack+733227,int_stack+712923,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+699855,int_stack+67525,int_stack+64249,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+767283,int_stack+699855,int_stack+724803,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+215525,int_stack+767283,int_stack+733227,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+709683,int_stack+215525,int_stack+747483,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+739383,int_stack+71305,int_stack+67525,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+239285,int_stack+739383,int_stack+699855,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+258941,int_stack+239285,int_stack+767283,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+750723,int_stack+258941,int_stack+215525,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+287021,int_stack+750723,int_stack+709683,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+215525,int_stack+75625,int_stack+71305,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+699855,int_stack+215525,int_stack+739383,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+328601,int_stack+699855,int_stack+239285,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+361361,int_stack+328601,int_stack+258941,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+228485,int_stack+361361,int_stack+750723,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+722535,int_stack+228485,int_stack+287021,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+278381,int_stack+80521,int_stack+75625,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+293069,int_stack+278381,int_stack+215525,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+293069,int_stack+699855,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+777975,int_stack+0,int_stack+328601,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+827115,int_stack+777975,int_stack+361361,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+318989,int_stack+827115,int_stack+228485,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+886083,int_stack+318989,int_stack+722535,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+699855,int_stack+86029,int_stack+80521,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+716379,int_stack+699855,int_stack+278381,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+215525,int_stack+716379,int_stack+293069,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+258725,int_stack+215525,int_stack+0,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+258725,int_stack+777975,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+745755,int_stack+0,int_stack+827115,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+957363,int_stack+745755,int_stack+318989,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+315425,int_stack+957363,int_stack+886083,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+824379,int_stack+92185,int_stack+86029,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+842847,int_stack+824379,int_stack+699855,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+875895,int_stack+842847,int_stack+716379,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1042899,int_stack+875895,int_stack+215525,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+824379,int_stack+1042899,int_stack+258725,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+215525,int_stack+824379,int_stack+0,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+824379,int_stack+215525,int_stack+745755,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+699855,int_stack+824379,int_stack+957363,36);
 /*--- compute (k0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+806775,int_stack+699855,int_stack+315425,36);
 /*--- compute (ip|mm) ---*/
 hrr1_build_ip(Libint->AB,int_stack+915675,int_stack+806775,int_stack+424580,3025);
 /*--- compute (hd|mm) ---*/
 hrr1_build_hd(Libint->AB,int_stack+1169775,int_stack+915675,int_stack+509280,3025);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+215525,int_stack+101500,int_stack+99025,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+222950,int_stack+104470,int_stack+101500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+231860,int_stack+222950,int_stack+215525,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+246710,int_stack+107980,int_stack+104470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+257240,int_stack+246710,int_stack+222950,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+275060,int_stack+257240,int_stack+231860,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+215525,int_stack+112075,int_stack+107980,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+299810,int_stack+215525,int_stack+246710,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+320870,int_stack+299810,int_stack+257240,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+227810,int_stack+320870,int_stack+275060,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+264935,int_stack+116800,int_stack+112075,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+350570,int_stack+264935,int_stack+215525,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+375140,int_stack+350570,int_stack+299810,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+410240,int_stack+375140,int_stack+320870,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+279110,int_stack+410240,int_stack+227810,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+215525,int_stack+122200,int_stack+116800,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+231725,int_stack+215525,int_stack+264935,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+454790,int_stack+231725,int_stack+350570,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+495740,int_stack+454790,int_stack+375140,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+331085,int_stack+495740,int_stack+410240,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+548390,int_stack+331085,int_stack+279110,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+260075,int_stack+128320,int_stack+122200,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+278435,int_stack+260075,int_stack+215525,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+393455,int_stack+278435,int_stack+231725,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+617690,int_stack+393455,int_stack+454790,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+679115,int_stack+617690,int_stack+495740,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+440705,int_stack+679115,int_stack+331085,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+440705,int_stack+548390,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+215525,int_stack+135205,int_stack+128320,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+310835,int_stack+215525,int_stack+260075,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+523865,int_stack+310835,int_stack+278435,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+236180,int_stack+523865,int_stack+393455,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+347555,int_stack+236180,int_stack+617690,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+577865,int_stack+347555,int_stack+679115,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+676145,int_stack+577865,int_stack+440705,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1550925,int_stack+676145,int_stack+0,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+142900,int_stack+135205,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+23085,int_stack+0,int_stack+215525,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+64395,int_stack+23085,int_stack+310835,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+433550,int_stack+64395,int_stack+523865,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+433550,int_stack+236180,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+433550,int_stack+0,int_stack+347555,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+433550,int_stack+577865,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+215525,int_stack+0,int_stack+676145,45);
 /*--- compute (l0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+0,int_stack+215525,int_stack+1550925,45);
 /*--- compute (kp|mm) ---*/
 hrr1_build_kp(Libint->AB,int_stack+215525,int_stack+0,int_stack+806775,3025);
 /*--- compute (id|mm) ---*/
 hrr1_build_id(Libint->AB,int_stack+1550925,int_stack+215525,int_stack+915675,3025);
 /*--- compute (hf|mm) ---*/
 hrr1_build_hf(Libint->AB,int_stack+2059125,int_stack+1550925,int_stack+1169775,3025);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+542225,int_stack+154475,int_stack+151450,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+551300,int_stack+158105,int_stack+154475,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+562190,int_stack+551300,int_stack+542225,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+580340,int_stack+162395,int_stack+158105,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+593210,int_stack+580340,int_stack+551300,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+614990,int_stack+593210,int_stack+562190,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+542225,int_stack+167400,int_stack+162395,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+645240,int_stack+542225,int_stack+580340,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+670980,int_stack+645240,int_stack+593210,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+557240,int_stack+670980,int_stack+614990,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+602615,int_stack+173175,int_stack+167400,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+707280,int_stack+602615,int_stack+542225,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+737310,int_stack+707280,int_stack+645240,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+780210,int_stack+737310,int_stack+670980,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+619940,int_stack+780210,int_stack+557240,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+542225,int_stack+179775,int_stack+173175,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+562025,int_stack+542225,int_stack+602615,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+834660,int_stack+562025,int_stack+707280,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+884710,int_stack+834660,int_stack+737310,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+683465,int_stack+884710,int_stack+780210,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+949060,int_stack+683465,int_stack+619940,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+596675,int_stack+187255,int_stack+179775,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+619115,int_stack+596675,int_stack+542225,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+759695,int_stack+619115,int_stack+562025,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1033760,int_stack+759695,int_stack+834660,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1108835,int_stack+1033760,int_stack+884710,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+817445,int_stack+1108835,int_stack+683465,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1198925,int_stack+817445,int_stack+949060,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+542225,int_stack+195670,int_stack+187255,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+658715,int_stack+542225,int_stack+596675,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+919085,int_stack+658715,int_stack+619115,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+567470,int_stack+919085,int_stack+759695,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+703595,int_stack+567470,int_stack+1033760,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+985085,int_stack+703595,int_stack+1108835,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1307825,int_stack+985085,int_stack+817445,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2694375,int_stack+1307825,int_stack+1198925,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+808700,int_stack+205075,int_stack+195670,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+836915,int_stack+808700,int_stack+542225,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1105205,int_stack+836915,int_stack+658715,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+808700,int_stack+1105205,int_stack+919085,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1105205,int_stack+808700,int_stack+567470,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+808700,int_stack+1105205,int_stack+703595,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1105205,int_stack+808700,int_stack+985085,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+542225,int_stack+1105205,int_stack+1307825,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+705575,int_stack+542225,int_stack+2694375,55);
 /*--- compute (lp|mm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+871950,int_stack+705575,int_stack+0,3025);
 /*--- compute (kd|mm) ---*/
 hrr1_build_kd(Libint->AB,int_stack+2694375,int_stack+871950,int_stack+215525,3025);
 /*--- compute (if|mm) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+2694375,int_stack+1550925,3025);
 /*--- compute (hg|mm) ---*/
 hrr1_build_hg(Libint->AB,int_stack+847000,int_stack+0,int_stack+2059125,3025);
 return int_stack+847000;}
