/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgnp(Libint_t*, prim_data*);

  /* Computes quartets of (hg|np) integrals */

REALTYPE *hrr_order_hgnp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[6][10] = int_stack + 3024;
 Libint->vrr_classes[6][11] = int_stack + 4872;
 Libint->vrr_classes[7][10] = int_stack + 7056;
 Libint->vrr_classes[7][11] = int_stack + 9432;
 Libint->vrr_classes[8][10] = int_stack + 12240;
 Libint->vrr_classes[8][11] = int_stack + 15210;
 Libint->vrr_classes[9][10] = int_stack + 18720;
 Libint->vrr_classes[9][11] = int_stack + 22350;
 memset(int_stack,0,26640*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 26640;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgnp(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+26640,int_stack+1386,int_stack+0,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+30798,int_stack+4872,int_stack+3024,28);
 /*--- compute (hp|np) ---*/
 hrr1_build_hp(Libint->AB,int_stack+36342,int_stack+30798,int_stack+26640,198);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+48816,int_stack+9432,int_stack+7056,36);
 /*--- compute (ip|np) ---*/
 hrr1_build_ip(Libint->AB,int_stack+55944,int_stack+48816,int_stack+30798,198);
 /*--- compute (hd|np) ---*/
 hrr1_build_hd(Libint->AB,int_stack+72576,int_stack+55944,int_stack+36342,198);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+26640,int_stack+15210,int_stack+12240,45);
 /*--- compute (kp|np) ---*/
 hrr1_build_kp(Libint->AB,int_stack+97524,int_stack+26640,int_stack+48816,198);
 /*--- compute (id|np) ---*/
 hrr1_build_id(Libint->AB,int_stack+118908,int_stack+97524,int_stack+55944,198);
 /*--- compute (hf|np) ---*/
 hrr1_build_hf(Libint->AB,int_stack+152172,int_stack+118908,int_stack+72576,198);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+35550,int_stack+22350,int_stack+18720,55);
 /*--- compute (lp|np) ---*/
 hrr1_build_lp(Libint->AB,int_stack+46440,int_stack+35550,int_stack+26640,198);
 /*--- compute (kd|np) ---*/
 hrr1_build_kd(Libint->AB,int_stack+0,int_stack+46440,int_stack+97524,198);
 /*--- compute (if|np) ---*/
 hrr1_build_if(Libint->AB,int_stack+42768,int_stack+0,int_stack+118908,198);
 /*--- compute (hg|np) ---*/
 hrr1_build_hg(Libint->AB,int_stack+193752,int_stack+42768,int_stack+152172,198);
 return int_stack+193752;}
