/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hhlg(Libint_t*, prim_data*);

  /* Computes quartets of (hh|lg) integrals */

REALTYPE *hrr_order_hhlg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[5][12] = int_stack + 5124;
 Libint->vrr_classes[6][8] = int_stack + 7035;
 Libint->vrr_classes[6][9] = int_stack + 8295;
 Libint->vrr_classes[6][10] = int_stack + 9835;
 Libint->vrr_classes[6][11] = int_stack + 11683;
 Libint->vrr_classes[6][12] = int_stack + 13867;
 Libint->vrr_classes[7][8] = int_stack + 16415;
 Libint->vrr_classes[7][9] = int_stack + 18035;
 Libint->vrr_classes[7][10] = int_stack + 20015;
 Libint->vrr_classes[7][11] = int_stack + 22391;
 Libint->vrr_classes[7][12] = int_stack + 25199;
 Libint->vrr_classes[8][8] = int_stack + 28475;
 Libint->vrr_classes[8][9] = int_stack + 30500;
 Libint->vrr_classes[8][10] = int_stack + 32975;
 Libint->vrr_classes[8][11] = int_stack + 35945;
 Libint->vrr_classes[8][12] = int_stack + 39455;
 Libint->vrr_classes[9][8] = int_stack + 43550;
 Libint->vrr_classes[9][9] = int_stack + 46025;
 Libint->vrr_classes[9][10] = int_stack + 49050;
 Libint->vrr_classes[9][11] = int_stack + 52680;
 Libint->vrr_classes[9][12] = int_stack + 56970;
 Libint->vrr_classes[10][8] = int_stack + 61975;
 Libint->vrr_classes[10][9] = int_stack + 64945;
 Libint->vrr_classes[10][10] = int_stack + 68575;
 Libint->vrr_classes[10][11] = int_stack + 72931;
 Libint->vrr_classes[10][12] = int_stack + 78079;
 memset(int_stack,0,84085*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 84085;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hhlg(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+84085,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+86920,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+90385,int_stack+86920,int_stack+84085,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+96055,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+100213,int_stack+96055,int_stack+86920,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+107143,int_stack+100213,int_stack+90385,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84085,int_stack+5124,int_stack+3486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+116593,int_stack+84085,int_stack+96055,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+84085,int_stack+116593,int_stack+100213,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+116593,int_stack+84085,int_stack+107143,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+84085,int_stack+8295,int_stack+7035,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+87865,int_stack+9835,int_stack+8295,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+92485,int_stack+87865,int_stack+84085,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+100045,int_stack+11683,int_stack+9835,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+105589,int_stack+100045,int_stack+87865,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+130768,int_stack+105589,int_stack+92485,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84085,int_stack+13867,int_stack+11683,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+84085,int_stack+100045,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+84085,int_stack+0,int_stack+105589,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+143368,int_stack+84085,int_stack+130768,28);
 /*--- compute (hp|lg) ---*/
 hrr1_build_hp(Libint->AB,int_stack+162268,int_stack+143368,int_stack+116593,675);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+84085,int_stack+18035,int_stack+16415,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+88945,int_stack+20015,int_stack+18035,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+94885,int_stack+88945,int_stack+84085,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+104605,int_stack+22391,int_stack+20015,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+111733,int_stack+104605,int_stack+88945,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+123613,int_stack+111733,int_stack+94885,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84085,int_stack+25199,int_stack+22391,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+84085,int_stack+104605,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+84085,int_stack+0,int_stack+111733,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+84085,int_stack+123613,36);
 /*--- compute (ip|lg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+84085,int_stack+0,int_stack+143368,675);
 /*--- compute (hd|lg) ---*/
 hrr1_build_hd(Libint->AB,int_stack+204793,int_stack+84085,int_stack+162268,675);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+140785,int_stack+30500,int_stack+28475,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+146860,int_stack+32975,int_stack+30500,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+154285,int_stack+146860,int_stack+140785,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+166435,int_stack+35945,int_stack+32975,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+175345,int_stack+166435,int_stack+146860,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+289843,int_stack+175345,int_stack+154285,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+140785,int_stack+39455,int_stack+35945,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+24300,int_stack+140785,int_stack+166435,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+140785,int_stack+24300,int_stack+175345,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+165535,int_stack+140785,int_stack+289843,45);
 /*--- compute (kp|lg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+289843,int_stack+165535,int_stack+0,675);
 /*--- compute (id|lg) ---*/
 hrr1_build_id(Libint->AB,int_stack+362743,int_stack+289843,int_stack+84085,675);
 /*--- compute (hf|lg) ---*/
 hrr1_build_hf(Libint->AB,int_stack+476143,int_stack+362743,int_stack+204793,675);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+84085,int_stack+46025,int_stack+43550,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+91510,int_stack+49050,int_stack+46025,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+100585,int_stack+91510,int_stack+84085,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+115435,int_stack+52680,int_stack+49050,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+126325,int_stack+115435,int_stack+91510,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+126325,int_stack+100585,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84085,int_stack+56970,int_stack+52680,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+24750,int_stack+84085,int_stack+115435,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+84085,int_stack+24750,int_stack+126325,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+24750,int_stack+84085,int_stack+0,55);
 /*--- compute (lp|lg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+195910,int_stack+24750,int_stack+165535,675);
 /*--- compute (kd|lg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+617893,int_stack+195910,int_stack+289843,675);
 /*--- compute (if|lg) ---*/
 hrr1_build_if(Libint->AB,int_stack+763693,int_stack+617893,int_stack+362743,675);
 /*--- compute (hg|lg) ---*/
 hrr1_build_hg(Libint->AB,int_stack+952693,int_stack+763693,int_stack+476143,675);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+64945,int_stack+61975,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8910,int_stack+68575,int_stack+64945,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+84085,int_stack+8910,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+101905,int_stack+72931,int_stack+68575,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+114973,int_stack+101905,int_stack+8910,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+136753,int_stack+114973,int_stack+84085,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84085,int_stack+78079,int_stack+72931,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+166453,int_stack+84085,int_stack+101905,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+61875,int_stack+166453,int_stack+114973,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+287035,int_stack+61875,int_stack+136753,66);
 /*--- compute (mp|lg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+61875,int_stack+287035,int_stack+24750,675);
 /*--- compute (ld|lg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+287035,int_stack+61875,int_stack+195910,675);
 /*--- compute (kf|lg) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+287035,int_stack+617893,675);
 /*--- compute (ig|lg) ---*/
 hrr1_build_ig(Libint->AB,int_stack+243000,int_stack+0,int_stack+763693,675);
 /*--- compute (hh|lg) ---*/
 hrr1_build_hh(Libint->AB,int_stack+526500,int_stack+243000,int_stack+952693,675);
 return int_stack+526500;}
