/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_idkk(Libint_t*, prim_data*);

  /* Computes quartets of (id|kk) integrals */

REALTYPE *hrr_order_idkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][7] = int_stack + 0;
 Libint->vrr_classes[6][8] = int_stack + 1008;
 Libint->vrr_classes[6][9] = int_stack + 2268;
 Libint->vrr_classes[6][10] = int_stack + 3808;
 Libint->vrr_classes[6][11] = int_stack + 5656;
 Libint->vrr_classes[6][12] = int_stack + 7840;
 Libint->vrr_classes[6][13] = int_stack + 10388;
 Libint->vrr_classes[6][14] = int_stack + 13328;
 Libint->vrr_classes[7][7] = int_stack + 16688;
 Libint->vrr_classes[7][8] = int_stack + 17984;
 Libint->vrr_classes[7][9] = int_stack + 19604;
 Libint->vrr_classes[7][10] = int_stack + 21584;
 Libint->vrr_classes[7][11] = int_stack + 23960;
 Libint->vrr_classes[7][12] = int_stack + 26768;
 Libint->vrr_classes[7][13] = int_stack + 30044;
 Libint->vrr_classes[7][14] = int_stack + 33824;
 Libint->vrr_classes[8][7] = int_stack + 38144;
 Libint->vrr_classes[8][8] = int_stack + 39764;
 Libint->vrr_classes[8][9] = int_stack + 41789;
 Libint->vrr_classes[8][10] = int_stack + 44264;
 Libint->vrr_classes[8][11] = int_stack + 47234;
 Libint->vrr_classes[8][12] = int_stack + 50744;
 Libint->vrr_classes[8][13] = int_stack + 54839;
 Libint->vrr_classes[8][14] = int_stack + 59564;
 memset(int_stack,0,64964*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 64964;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_idkk(Libint, Data);
   Data++;
 }
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+64964,int_stack+1008,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+67988,int_stack+2268,int_stack+1008,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+71768,int_stack+67988,int_stack+64964,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+77816,int_stack+3808,int_stack+2268,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+82436,int_stack+77816,int_stack+67988,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+89996,int_stack+82436,int_stack+71768,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+64964,int_stack+5656,int_stack+3808,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+100076,int_stack+64964,int_stack+77816,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+109316,int_stack+100076,int_stack+82436,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+70508,int_stack+109316,int_stack+89996,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+85628,int_stack+7840,int_stack+5656,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+121916,int_stack+85628,int_stack+64964,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+133004,int_stack+121916,int_stack+100076,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+148404,int_stack+133004,int_stack+109316,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+92180,int_stack+148404,int_stack+70508,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64964,int_stack+10388,int_stack+7840,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+167304,int_stack+64964,int_stack+85628,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+72608,int_stack+167304,int_stack+121916,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+180408,int_stack+72608,int_stack+133004,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+113348,int_stack+180408,int_stack+148404,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+203508,int_stack+113348,int_stack+92180,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+91088,int_stack+13328,int_stack+10388,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+139808,int_stack+91088,int_stack+64964,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+91088,int_stack+139808,int_stack+167304,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+139808,int_stack+91088,int_stack+72608,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+64964,int_stack+139808,int_stack+180408,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+139808,int_stack+64964,int_stack+113348,28);
 /*--- compute (i0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+64964,int_stack+139808,int_stack+203508,28);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+101252,int_stack+17984,int_stack+16688,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+105140,int_stack+19604,int_stack+17984,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+110000,int_stack+105140,int_stack+101252,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+117776,int_stack+21584,int_stack+19604,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+123716,int_stack+117776,int_stack+105140,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+133436,int_stack+123716,int_stack+110000,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+101252,int_stack+23960,int_stack+21584,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+146396,int_stack+101252,int_stack+117776,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+158276,int_stack+146396,int_stack+123716,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+108380,int_stack+158276,int_stack+133436,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+127820,int_stack+26768,int_stack+23960,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+174476,int_stack+127820,int_stack+101252,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+188732,int_stack+174476,int_stack+146396,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+188732,int_stack+158276,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+136244,int_stack+0,int_stack+108380,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+101252,int_stack+30044,int_stack+26768,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+208532,int_stack+101252,int_stack+127820,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+111080,int_stack+208532,int_stack+174476,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+225380,int_stack+111080,int_stack+188732,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+163460,int_stack+225380,int_stack+0,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+255080,int_stack+163460,int_stack+136244,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+33824,int_stack+30044,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+11340,int_stack+0,int_stack+101252,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+134840,int_stack+11340,int_stack+208532,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+134840,int_stack+111080,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+101252,int_stack+0,int_stack+225380,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+197480,int_stack+101252,int_stack+163460,36);
 /*--- compute (k0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+101252,int_stack+197480,int_stack+255080,36);
 /*--- compute (ip|kk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+147908,int_stack+101252,int_stack+64964,1296);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+64964,int_stack+39764,int_stack+38144,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+69824,int_stack+41789,int_stack+39764,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+75899,int_stack+69824,int_stack+64964,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+85619,int_stack+44264,int_stack+41789,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+256772,int_stack+85619,int_stack+69824,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+268922,int_stack+256772,int_stack+75899,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+64964,int_stack+47234,int_stack+44264,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+64964,int_stack+85619,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+73874,int_stack+0,int_stack+256772,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+14850,int_stack+73874,int_stack+268922,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+256772,int_stack+50744,int_stack+47234,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+267302,int_stack+256772,int_stack+64964,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+285122,int_stack+267302,int_stack+0,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+309872,int_stack+285122,int_stack+73874,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+64964,int_stack+309872,int_stack+14850,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+54839,int_stack+50744,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+12285,int_stack+0,int_stack+256772,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+340247,int_stack+12285,int_stack+267302,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+369947,int_stack+340247,int_stack+285122,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+256772,int_stack+369947,int_stack+309872,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+407072,int_stack+256772,int_stack+64964,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+64964,int_stack+59564,int_stack+54839,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+299297,int_stack+64964,int_stack+0,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+33345,int_stack+299297,int_stack+12285,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+452432,int_stack+33345,int_stack+340247,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+299297,int_stack+452432,int_stack+369947,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+299297,int_stack+256772,45);
 /*--- compute (l0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+256772,int_stack+0,int_stack+407072,45);
 /*--- compute (kp|kk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+315092,int_stack+256772,int_stack+101252,1296);
 /*--- compute (id|kk) ---*/
 hrr1_build_id(Libint->AB,int_stack+455060,int_stack+315092,int_stack+147908,1296);
 return int_stack+455060;}
