/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ifld(Libint_t*, prim_data*);

  /* Computes quartets of (if|ld) integrals */

REALTYPE *hrr_order_ifld(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[7][8] = int_stack + 4648;
 Libint->vrr_classes[7][9] = int_stack + 6268;
 Libint->vrr_classes[7][10] = int_stack + 8248;
 Libint->vrr_classes[8][8] = int_stack + 10624;
 Libint->vrr_classes[8][9] = int_stack + 12649;
 Libint->vrr_classes[8][10] = int_stack + 15124;
 Libint->vrr_classes[9][8] = int_stack + 18094;
 Libint->vrr_classes[9][9] = int_stack + 20569;
 Libint->vrr_classes[9][10] = int_stack + 23594;
 memset(int_stack,0,27224*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 27224;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ifld(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+27224,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+31004,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+35624,int_stack+31004,int_stack+27224,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+27224,int_stack+6268,int_stack+4648,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+8248,int_stack+6268,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+43184,int_stack+0,int_stack+27224,36);
 /*--- compute (ip|ld) ---*/
 hrr1_build_ip(Libint->AB,int_stack+52904,int_stack+43184,int_stack+35624,270);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+27224,int_stack+12649,int_stack+10624,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+33299,int_stack+15124,int_stack+12649,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+33299,int_stack+27224,45);
 /*--- compute (kp|ld) ---*/
 hrr1_build_kp(Libint->AB,int_stack+75584,int_stack+0,int_stack+43184,270);
 /*--- compute (id|ld) ---*/
 hrr1_build_id(Libint->AB,int_stack+104744,int_stack+75584,int_stack+52904,270);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+27224,int_stack+20569,int_stack+18094,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+34649,int_stack+23594,int_stack+20569,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+43724,int_stack+34649,int_stack+27224,55);
 /*--- compute (lp|ld) ---*/
 hrr1_build_lp(Libint->AB,int_stack+150104,int_stack+43724,int_stack+0,270);
 /*--- compute (kd|ld) ---*/
 hrr1_build_kd(Libint->AB,int_stack+0,int_stack+150104,int_stack+75584,270);
 /*--- compute (if|ld) ---*/
 hrr1_build_if(Libint->AB,int_stack+150104,int_stack+0,int_stack+104744,270);
 return int_stack+150104;}
