/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ifnn(Libint_t*, prim_data*);

  /* Computes quartets of (if|nn) integrals */

REALTYPE *hrr_order_ifnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[6][12] = int_stack + 4032;
 Libint->vrr_classes[6][13] = int_stack + 6580;
 Libint->vrr_classes[6][14] = int_stack + 9520;
 Libint->vrr_classes[6][15] = int_stack + 12880;
 Libint->vrr_classes[6][16] = int_stack + 16688;
 Libint->vrr_classes[6][17] = int_stack + 20972;
 Libint->vrr_classes[6][18] = int_stack + 25760;
 Libint->vrr_classes[6][19] = int_stack + 31080;
 Libint->vrr_classes[6][20] = int_stack + 36960;
 Libint->vrr_classes[7][10] = int_stack + 43428;
 Libint->vrr_classes[7][11] = int_stack + 45804;
 Libint->vrr_classes[7][12] = int_stack + 48612;
 Libint->vrr_classes[7][13] = int_stack + 51888;
 Libint->vrr_classes[7][14] = int_stack + 55668;
 Libint->vrr_classes[7][15] = int_stack + 59988;
 Libint->vrr_classes[7][16] = int_stack + 64884;
 Libint->vrr_classes[7][17] = int_stack + 70392;
 Libint->vrr_classes[7][18] = int_stack + 76548;
 Libint->vrr_classes[7][19] = int_stack + 83388;
 Libint->vrr_classes[7][20] = int_stack + 90948;
 Libint->vrr_classes[8][10] = int_stack + 99264;
 Libint->vrr_classes[8][11] = int_stack + 102234;
 Libint->vrr_classes[8][12] = int_stack + 105744;
 Libint->vrr_classes[8][13] = int_stack + 109839;
 Libint->vrr_classes[8][14] = int_stack + 114564;
 Libint->vrr_classes[8][15] = int_stack + 119964;
 Libint->vrr_classes[8][16] = int_stack + 126084;
 Libint->vrr_classes[8][17] = int_stack + 132969;
 Libint->vrr_classes[8][18] = int_stack + 140664;
 Libint->vrr_classes[8][19] = int_stack + 149214;
 Libint->vrr_classes[8][20] = int_stack + 158664;
 Libint->vrr_classes[9][10] = int_stack + 169059;
 Libint->vrr_classes[9][11] = int_stack + 172689;
 Libint->vrr_classes[9][12] = int_stack + 176979;
 Libint->vrr_classes[9][13] = int_stack + 181984;
 Libint->vrr_classes[9][14] = int_stack + 187759;
 Libint->vrr_classes[9][15] = int_stack + 194359;
 Libint->vrr_classes[9][16] = int_stack + 201839;
 Libint->vrr_classes[9][17] = int_stack + 210254;
 Libint->vrr_classes[9][18] = int_stack + 219659;
 Libint->vrr_classes[9][19] = int_stack + 230109;
 Libint->vrr_classes[9][20] = int_stack + 241659;
 memset(int_stack,0,254364*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 254364;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ifnn(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+254364,int_stack+1848,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+259908,int_stack+4032,int_stack+1848,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+266460,int_stack+259908,int_stack+254364,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+277548,int_stack+6580,int_stack+4032,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+285192,int_stack+277548,int_stack+259908,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+298296,int_stack+285192,int_stack+266460,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+254364,int_stack+9520,int_stack+6580,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+316776,int_stack+254364,int_stack+277548,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+263184,int_stack+316776,int_stack+285192,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+332064,int_stack+263184,int_stack+298296,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+285024,int_stack+12880,int_stack+9520,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+295104,int_stack+285024,int_stack+254364,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+359784,int_stack+295104,int_stack+316776,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+385264,int_stack+359784,int_stack+263184,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+418024,int_stack+385264,int_stack+332064,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+254364,int_stack+16688,int_stack+12880,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+312744,int_stack+254364,int_stack+285024,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+456832,int_stack+312744,int_stack+295104,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+265788,int_stack+456832,int_stack+359784,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+332904,int_stack+265788,int_stack+385264,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+486232,int_stack+332904,int_stack+418024,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+378768,int_stack+20972,int_stack+16688,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+391620,int_stack+378768,int_stack+254364,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+414468,int_stack+391620,int_stack+312744,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+537976,int_stack+414468,int_stack+456832,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+582076,int_stack+537976,int_stack+265788,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+254364,int_stack+582076,int_stack+332904,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+635584,int_stack+254364,int_stack+486232,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+315516,int_stack+25760,int_stack+20972,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+329880,int_stack+315516,int_stack+378768,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+448068,int_stack+329880,int_stack+391620,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+355584,int_stack+448068,int_stack+414468,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+702112,int_stack+355584,int_stack+537976,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+486148,int_stack+702112,int_stack+582076,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+763852,int_stack+486148,int_stack+254364,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+842476,int_stack+763852,int_stack+635584,28);
 /*--- compute (i0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+254364,int_stack+31080,int_stack+25760,28);
 /*--- compute (i0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+270324,int_stack+254364,int_stack+315516,28);
 /*--- compute (i0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+557492,int_stack+270324,int_stack+329880,28);
 /*--- compute (i0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+600332,int_stack+557492,int_stack+448068,28);
 /*--- compute (i0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+405984,int_stack+600332,int_stack+355584,28);
 /*--- compute (i0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+299052,int_stack+405984,int_stack+702112,28);
 /*--- compute (i0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+657452,int_stack+299052,int_stack+486148,28);
 /*--- compute (i0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+925636,int_stack+657452,int_stack+763852,28);
 /*--- compute (i0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1023916,int_stack+925636,int_stack+842476,28);
 /*--- compute (i0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+381372,int_stack+36960,int_stack+31080,28);
 /*--- compute (i0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+476544,int_stack+381372,int_stack+254364,28);
 /*--- compute (i0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+508464,int_stack+476544,int_stack+270324,28);
 /*--- compute (i0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+749180,int_stack+508464,int_stack+557492,28);
 /*--- compute (i0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+476544,int_stack+749180,int_stack+600332,28);
 /*--- compute (i0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+749180,int_stack+476544,int_stack+405984,28);
 /*--- compute (i0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+381372,int_stack+749180,int_stack+299052,28);
 /*--- compute (i0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+749180,int_stack+381372,int_stack+657452,28);
 /*--- compute (i0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+254364,int_stack+749180,int_stack+925636,28);
 /*--- compute (i0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+374484,int_stack+254364,int_stack+1023916,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+254364,int_stack+45804,int_stack+43428,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+261492,int_stack+48612,int_stack+45804,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+269916,int_stack+261492,int_stack+254364,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+284172,int_stack+51888,int_stack+48612,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+294000,int_stack+284172,int_stack+261492,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+310848,int_stack+294000,int_stack+269916,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+254364,int_stack+55668,int_stack+51888,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+334608,int_stack+254364,int_stack+284172,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+265704,int_stack+334608,int_stack+294000,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+496452,int_stack+265704,int_stack+310848,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+293784,int_stack+59988,int_stack+55668,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+306744,int_stack+293784,int_stack+254364,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+532092,int_stack+306744,int_stack+334608,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+329424,int_stack+532092,int_stack+265704,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+564852,int_stack+329424,int_stack+496452,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+496452,int_stack+64884,int_stack+59988,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+254364,int_stack+496452,int_stack+293784,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+614748,int_stack+254364,int_stack+306744,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+280284,int_stack+614748,int_stack+532092,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+652548,int_stack+280284,int_stack+329424,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+711516,int_stack+652548,int_stack+564852,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+329424,int_stack+70392,int_stack+64884,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+511140,int_stack+329424,int_stack+496452,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+540516,int_stack+511140,int_stack+254364,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+778044,int_stack+540516,int_stack+614748,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+583716,int_stack+778044,int_stack+280284,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+834744,int_stack+583716,int_stack+652548,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+913368,int_stack+834744,int_stack+711516,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+254364,int_stack+76548,int_stack+70392,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+272832,int_stack+254364,int_stack+329424,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+305880,int_stack+272832,int_stack+511140,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+652512,int_stack+305880,int_stack+540516,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+496452,int_stack+652512,int_stack+778044,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+717312,int_stack+496452,int_stack+583716,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+998904,int_stack+717312,int_stack+834744,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1099992,int_stack+998904,int_stack+913368,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+575832,int_stack+83388,int_stack+76548,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+596352,int_stack+575832,int_stack+254364,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+809040,int_stack+596352,int_stack+272832,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+864120,int_stack+809040,int_stack+305880,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+254364,int_stack+864120,int_stack+652512,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1206912,int_stack+254364,int_stack+496452,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1312752,int_stack+1206912,int_stack+717312,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+633288,int_stack+1312752,int_stack+998904,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+937560,int_stack+633288,int_stack+1099992,36);
 /*--- compute (k0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+496452,int_stack+90948,int_stack+83388,36);
 /*--- compute (k0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+519132,int_stack+496452,int_stack+575832,36);
 /*--- compute (k0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1068240,int_stack+519132,int_stack+596352,36);
 /*--- compute (k0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+496452,int_stack+1068240,int_stack+809040,36);
 /*--- compute (k0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1068240,int_stack+496452,int_stack+864120,36);
 /*--- compute (k0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+496452,int_stack+1068240,int_stack+254364,36);
 /*--- compute (k0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1068240,int_stack+496452,int_stack+1206912,36);
 /*--- compute (k0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+759648,int_stack+1068240,int_stack+1312752,36);
 /*--- compute (k0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1068240,int_stack+759648,int_stack+633288,36);
 /*--- compute (k0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1222680,int_stack+1068240,int_stack+937560,36);
 /*--- compute (ip|nn) ---*/
 hrr1_build_ip(Libint->AB,int_stack+496452,int_stack+1222680,int_stack+374484,4356);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1379496,int_stack+102234,int_stack+99264,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1388406,int_stack+105744,int_stack+102234,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1398936,int_stack+1388406,int_stack+1379496,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1416756,int_stack+109839,int_stack+105744,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+862356,int_stack+1416756,int_stack+1388406,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+883416,int_stack+862356,int_stack+1398936,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1379496,int_stack+114564,int_stack+109839,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+913116,int_stack+1379496,int_stack+1416756,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1393671,int_stack+913116,int_stack+862356,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+937686,int_stack+1393671,int_stack+883416,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+862356,int_stack+119964,int_stack+114564,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+878556,int_stack+862356,int_stack+1379496,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+982236,int_stack+878556,int_stack+913116,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1023186,int_stack+982236,int_stack+1393671,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1075836,int_stack+1023186,int_stack+937686,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1379496,int_stack+126084,int_stack+119964,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1397856,int_stack+1379496,int_stack+862356,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+906906,int_stack+1397856,int_stack+878556,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1138206,int_stack+906906,int_stack+982236,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+254364,int_stack+1138206,int_stack+1023186,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+954156,int_stack+254364,int_stack+1075836,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+862356,int_stack+132969,int_stack+126084,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1037316,int_stack+862356,int_stack+1379496,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1074036,int_stack+1037316,int_stack+1397856,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+328074,int_stack+1074036,int_stack+906906,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+398949,int_stack+328074,int_stack+1138206,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+398949,int_stack+254364,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1379496,int_stack+0,int_stack+954156,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+254364,int_stack+140664,int_stack+132969,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+277449,int_stack+254364,int_stack+862356,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+862356,int_stack+277449,int_stack+1037316,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+923556,int_stack+862356,int_stack+1074036,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1004556,int_stack+923556,int_stack+328074,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1103781,int_stack+1004556,int_stack+398949,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+318759,int_stack+1103781,int_stack+0,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+318759,int_stack+1379496,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1379496,int_stack+149214,int_stack+140664,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1405146,int_stack+1379496,int_stack+254364,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1451316,int_stack+1405146,int_stack+277449,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1520166,int_stack+1451316,int_stack+862356,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1611966,int_stack+1520166,int_stack+923556,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+862356,int_stack+1611966,int_stack+1004556,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1725366,int_stack+862356,int_stack+1103781,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+994656,int_stack+1725366,int_stack+318759,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+254364,int_stack+994656,int_stack+0,45);
 /*--- compute (l0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+158664,int_stack+149214,45);
 /*--- compute (l0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+28350,int_stack+0,int_stack+1379496,45);
 /*--- compute (l0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+79650,int_stack+28350,int_stack+1405146,45);
 /*--- compute (l0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1872786,int_stack+79650,int_stack+1451316,45);
 /*--- compute (l0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1379496,int_stack+1872786,int_stack+1520166,45);
 /*--- compute (l0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+0,int_stack+1379496,int_stack+1611966,45);
 /*--- compute (l0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1379496,int_stack+0,int_stack+862356,45);
 /*--- compute (l0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1872786,int_stack+1379496,int_stack+1725366,45);
 /*--- compute (l0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1379496,int_stack+1872786,int_stack+994656,45);
 /*--- compute (l0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1572546,int_stack+1379496,int_stack+254364,45);
 /*--- compute (kp|nn) ---*/
 hrr1_build_kp(Libint->AB,int_stack+1768566,int_stack+1572546,int_stack+1222680,4356);
 /*--- compute (id|nn) ---*/
 hrr1_build_id(Libint->AB,int_stack+2239014,int_stack+1768566,int_stack+496452,4356);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+254364,int_stack+172689,int_stack+169059,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+265254,int_stack+176979,int_stack+172689,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+278124,int_stack+265254,int_stack+254364,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+299904,int_stack+181984,int_stack+176979,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+314919,int_stack+299904,int_stack+265254,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+340659,int_stack+314919,int_stack+278124,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+254364,int_stack+187759,int_stack+181984,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+376959,int_stack+254364,int_stack+299904,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+271689,int_stack+376959,int_stack+314919,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+406989,int_stack+271689,int_stack+340659,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+314589,int_stack+194359,int_stack+187759,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+334389,int_stack+314589,int_stack+254364,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+461439,int_stack+334389,int_stack+376959,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+511489,int_stack+461439,int_stack+271689,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+575839,int_stack+511489,int_stack+406989,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+254364,int_stack+201839,int_stack+194359,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+369039,int_stack+254364,int_stack+314589,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+652069,int_stack+369039,int_stack+334389,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+276804,int_stack+652069,int_stack+461439,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+408639,int_stack+276804,int_stack+511489,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+709819,int_stack+408639,int_stack+575839,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+498729,int_stack+210254,int_stack+201839,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+523974,int_stack+498729,int_stack+254364,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+568854,int_stack+523974,int_stack+369039,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+811459,int_stack+568854,int_stack+652069,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+898084,int_stack+811459,int_stack+276804,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+254364,int_stack+898084,int_stack+408639,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1003189,int_stack+254364,int_stack+709819,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+374484,int_stack+219659,int_stack+210254,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+402699,int_stack+374484,int_stack+498729,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+634854,int_stack+402699,int_stack+523974,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+453189,int_stack+634854,int_stack+568854,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1133869,int_stack+453189,int_stack+811459,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+709654,int_stack+1133869,int_stack+898084,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1255144,int_stack+709654,int_stack+254364,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1255144,int_stack+1003189,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+254364,int_stack+230109,int_stack+219659,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+285714,int_stack+254364,int_stack+374484,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+849794,int_stack+285714,int_stack+402699,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+933944,int_stack+849794,int_stack+634854,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+552189,int_stack+933944,int_stack+453189,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+342144,int_stack+552189,int_stack+1133869,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1046144,int_stack+342144,int_stack+709654,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2970822,int_stack+1046144,int_stack+1255144,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1226324,int_stack+2970822,int_stack+0,55);
 /*--- compute (m0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+241659,int_stack+230109,55);
 /*--- compute (m0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+34650,int_stack+0,int_stack+254364,55);
 /*--- compute (m0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+97350,int_stack+34650,int_stack+285714,55);
 /*--- compute (m0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+191400,int_stack+97350,int_stack+849794,55);
 /*--- compute (m0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+191400,int_stack+933944,55);
 /*--- compute (m0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+157080,int_stack+0,int_stack+552189,55);
 /*--- compute (m0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+503844,int_stack+157080,int_stack+342144,55);
 /*--- compute (m0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+0,int_stack+503844,int_stack+1046144,55);
 /*--- compute (m0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+225225,int_stack+0,int_stack+2970822,55);
 /*--- compute (m0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+461175,int_stack+225225,int_stack+1226324,55);
 /*--- compute (lp|nn) ---*/
 hrr1_build_lp(Libint->AB,int_stack+700755,int_stack+461175,int_stack+1572546,4356);
 /*--- compute (kd|nn) ---*/
 hrr1_build_kd(Libint->AB,int_stack+2970822,int_stack+700755,int_stack+1768566,4356);
 /*--- compute (if|nn) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+2970822,int_stack+2239014,4356);
 return int_stack+0;}
