/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_igkh(Libint_t*, prim_data*);

  /* Computes quartets of (ig|kh) integrals */

REALTYPE *hrr_order_igkh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][7] = int_stack + 0;
 Libint->vrr_classes[6][8] = int_stack + 1008;
 Libint->vrr_classes[6][9] = int_stack + 2268;
 Libint->vrr_classes[6][10] = int_stack + 3808;
 Libint->vrr_classes[6][11] = int_stack + 5656;
 Libint->vrr_classes[6][12] = int_stack + 7840;
 Libint->vrr_classes[7][7] = int_stack + 10388;
 Libint->vrr_classes[7][8] = int_stack + 11684;
 Libint->vrr_classes[7][9] = int_stack + 13304;
 Libint->vrr_classes[7][10] = int_stack + 15284;
 Libint->vrr_classes[7][11] = int_stack + 17660;
 Libint->vrr_classes[7][12] = int_stack + 20468;
 Libint->vrr_classes[8][7] = int_stack + 23744;
 Libint->vrr_classes[8][8] = int_stack + 25364;
 Libint->vrr_classes[8][9] = int_stack + 27389;
 Libint->vrr_classes[8][10] = int_stack + 29864;
 Libint->vrr_classes[8][11] = int_stack + 32834;
 Libint->vrr_classes[8][12] = int_stack + 36344;
 Libint->vrr_classes[9][7] = int_stack + 40439;
 Libint->vrr_classes[9][8] = int_stack + 42419;
 Libint->vrr_classes[9][9] = int_stack + 44894;
 Libint->vrr_classes[9][10] = int_stack + 47919;
 Libint->vrr_classes[9][11] = int_stack + 51549;
 Libint->vrr_classes[9][12] = int_stack + 55839;
 Libint->vrr_classes[10][7] = int_stack + 60844;
 Libint->vrr_classes[10][8] = int_stack + 63220;
 Libint->vrr_classes[10][9] = int_stack + 66190;
 Libint->vrr_classes[10][10] = int_stack + 69820;
 Libint->vrr_classes[10][11] = int_stack + 74176;
 Libint->vrr_classes[10][12] = int_stack + 79324;
 memset(int_stack,0,85330*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 85330;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_igkh(Libint, Data);
   Data++;
 }
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+85330,int_stack+1008,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+88354,int_stack+2268,int_stack+1008,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+92134,int_stack+88354,int_stack+85330,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+98182,int_stack+3808,int_stack+2268,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+102802,int_stack+98182,int_stack+88354,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+110362,int_stack+102802,int_stack+92134,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85330,int_stack+5656,int_stack+3808,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+120442,int_stack+85330,int_stack+98182,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+129682,int_stack+120442,int_stack+102802,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+90874,int_stack+129682,int_stack+110362,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+105994,int_stack+7840,int_stack+5656,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+142282,int_stack+105994,int_stack+85330,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+153370,int_stack+142282,int_stack+120442,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+105994,int_stack+153370,int_stack+129682,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+124894,int_stack+105994,int_stack+90874,28);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+85330,int_stack+11684,int_stack+10388,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+89218,int_stack+13304,int_stack+11684,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+94078,int_stack+89218,int_stack+85330,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+101854,int_stack+15284,int_stack+13304,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+107794,int_stack+101854,int_stack+89218,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+146062,int_stack+107794,int_stack+94078,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85330,int_stack+17660,int_stack+15284,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+85330,int_stack+101854,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+159022,int_stack+0,int_stack+107794,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+92458,int_stack+159022,int_stack+146062,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+146062,int_stack+20468,int_stack+17660,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+175222,int_stack+146062,int_stack+85330,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+189478,int_stack+175222,int_stack+0,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+209278,int_stack+189478,int_stack+159022,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+146062,int_stack+209278,int_stack+92458,36);
 /*--- compute (ip|kh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+173278,int_stack+146062,int_stack+124894,756);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+25364,int_stack+23744,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+4860,int_stack+27389,int_stack+25364,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+10935,int_stack+4860,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+85330,int_stack+29864,int_stack+27389,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+92755,int_stack+85330,int_stack+4860,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+104905,int_stack+92755,int_stack+10935,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+32834,int_stack+29864,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+8910,int_stack+0,int_stack+85330,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+121105,int_stack+8910,int_stack+92755,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+236782,int_stack+121105,int_stack+104905,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+85330,int_stack+36344,int_stack+32834,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+95860,int_stack+85330,int_stack+0,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+261082,int_stack+95860,int_stack+8910,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+261082,int_stack+121105,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+85330,int_stack+0,int_stack+236782,45);
 /*--- compute (kp|kh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+236782,int_stack+85330,int_stack+146062,756);
 /*--- compute (id|kh) ---*/
 hrr1_build_id(Libint->AB,int_stack+318430,int_stack+236782,int_stack+173278,756);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+42419,int_stack+40439,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5940,int_stack+44894,int_stack+42419,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+13365,int_stack+5940,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25245,int_stack+47919,int_stack+44894,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+119350,int_stack+25245,int_stack+5940,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+134200,int_stack+119350,int_stack+13365,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+51549,int_stack+47919,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+154000,int_stack+0,int_stack+25245,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+10890,int_stack+154000,int_stack+119350,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+172150,int_stack+10890,int_stack+134200,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+119350,int_stack+55839,int_stack+51549,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+132220,int_stack+119350,int_stack+0,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+201850,int_stack+132220,int_stack+154000,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+119350,int_stack+201850,int_stack+10890,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+119350,int_stack+172150,55);
 /*--- compute (lp|kh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+119350,int_stack+0,int_stack+85330,756);
 /*--- compute (kd|kh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+445438,int_stack+119350,int_stack+236782,756);
 /*--- compute (if|kh) ---*/
 hrr1_build_if(Libint->AB,int_stack+608734,int_stack+445438,int_stack+318430,756);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+85330,int_stack+63220,int_stack+60844,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+92458,int_stack+66190,int_stack+63220,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+101368,int_stack+92458,int_stack+85330,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+221410,int_stack+69820,int_stack+66190,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+232300,int_stack+221410,int_stack+92458,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+250120,int_stack+232300,int_stack+101368,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85330,int_stack+74176,int_stack+69820,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+273880,int_stack+85330,int_stack+221410,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+295660,int_stack+273880,int_stack+232300,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+325360,int_stack+295660,int_stack+250120,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+221410,int_stack+79324,int_stack+74176,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+236854,int_stack+221410,int_stack+85330,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+361000,int_stack+236854,int_stack+273880,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+221410,int_stack+361000,int_stack+295660,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+361000,int_stack+221410,int_stack+325360,66);
 /*--- compute (mp|kh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+221410,int_stack+361000,int_stack+0,756);
 /*--- compute (ld|kh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+820414,int_stack+221410,int_stack+119350,756);
 /*--- compute (kf|kh) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+820414,int_stack+445438,756);
 /*--- compute (ig|kh) ---*/
 hrr1_build_ig(Libint->AB,int_stack+272160,int_stack+0,int_stack+608734,756);
 return int_stack+272160;}
