/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_igmm(Libint_t*, prim_data*);

  /* Computes quartets of (ig|mm) integrals */

REALTYPE *hrr_order_igmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[6][13] = int_stack + 8120;
 Libint->vrr_classes[6][14] = int_stack + 11060;
 Libint->vrr_classes[6][15] = int_stack + 14420;
 Libint->vrr_classes[6][16] = int_stack + 18228;
 Libint->vrr_classes[6][17] = int_stack + 22512;
 Libint->vrr_classes[6][18] = int_stack + 27300;
 Libint->vrr_classes[7][9] = int_stack + 32620;
 Libint->vrr_classes[7][10] = int_stack + 34600;
 Libint->vrr_classes[7][11] = int_stack + 36976;
 Libint->vrr_classes[7][12] = int_stack + 39784;
 Libint->vrr_classes[7][13] = int_stack + 43060;
 Libint->vrr_classes[7][14] = int_stack + 46840;
 Libint->vrr_classes[7][15] = int_stack + 51160;
 Libint->vrr_classes[7][16] = int_stack + 56056;
 Libint->vrr_classes[7][17] = int_stack + 61564;
 Libint->vrr_classes[7][18] = int_stack + 67720;
 Libint->vrr_classes[8][9] = int_stack + 74560;
 Libint->vrr_classes[8][10] = int_stack + 77035;
 Libint->vrr_classes[8][11] = int_stack + 80005;
 Libint->vrr_classes[8][12] = int_stack + 83515;
 Libint->vrr_classes[8][13] = int_stack + 87610;
 Libint->vrr_classes[8][14] = int_stack + 92335;
 Libint->vrr_classes[8][15] = int_stack + 97735;
 Libint->vrr_classes[8][16] = int_stack + 103855;
 Libint->vrr_classes[8][17] = int_stack + 110740;
 Libint->vrr_classes[8][18] = int_stack + 118435;
 Libint->vrr_classes[9][9] = int_stack + 126985;
 Libint->vrr_classes[9][10] = int_stack + 130010;
 Libint->vrr_classes[9][11] = int_stack + 133640;
 Libint->vrr_classes[9][12] = int_stack + 137930;
 Libint->vrr_classes[9][13] = int_stack + 142935;
 Libint->vrr_classes[9][14] = int_stack + 148710;
 Libint->vrr_classes[9][15] = int_stack + 155310;
 Libint->vrr_classes[9][16] = int_stack + 162790;
 Libint->vrr_classes[9][17] = int_stack + 171205;
 Libint->vrr_classes[9][18] = int_stack + 180610;
 Libint->vrr_classes[10][9] = int_stack + 191060;
 Libint->vrr_classes[10][10] = int_stack + 194690;
 Libint->vrr_classes[10][11] = int_stack + 199046;
 Libint->vrr_classes[10][12] = int_stack + 204194;
 Libint->vrr_classes[10][13] = int_stack + 210200;
 Libint->vrr_classes[10][14] = int_stack + 217130;
 Libint->vrr_classes[10][15] = int_stack + 225050;
 Libint->vrr_classes[10][16] = int_stack + 234026;
 Libint->vrr_classes[10][17] = int_stack + 244124;
 Libint->vrr_classes[10][18] = int_stack + 255410;
 memset(int_stack,0,267950*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 267950;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_igmm(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+267950,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+272570,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+278114,int_stack+272570,int_stack+267950,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+287354,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+293906,int_stack+287354,int_stack+272570,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+304994,int_stack+293906,int_stack+278114,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+267950,int_stack+8120,int_stack+5572,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+320394,int_stack+267950,int_stack+287354,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+333498,int_stack+320394,int_stack+293906,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+275594,int_stack+333498,int_stack+304994,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+298694,int_stack+11060,int_stack+8120,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+351978,int_stack+298694,int_stack+267950,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+367266,int_stack+351978,int_stack+320394,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+389106,int_stack+367266,int_stack+333498,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+307514,int_stack+389106,int_stack+275594,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+267950,int_stack+14420,int_stack+11060,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+278030,int_stack+267950,int_stack+298694,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+416826,int_stack+278030,int_stack+351978,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+442306,int_stack+416826,int_stack+367266,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+339854,int_stack+442306,int_stack+389106,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+475066,int_stack+339854,int_stack+307514,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+295670,int_stack+18228,int_stack+14420,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+307094,int_stack+295670,int_stack+267950,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+378662,int_stack+307094,int_stack+278030,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+518186,int_stack+378662,int_stack+416826,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+556406,int_stack+518186,int_stack+442306,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+408062,int_stack+556406,int_stack+339854,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+602270,int_stack+408062,int_stack+475066,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+267950,int_stack+22512,int_stack+18228,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+327254,int_stack+267950,int_stack+295670,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+459806,int_stack+327254,int_stack+307094,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+280802,int_stack+459806,int_stack+378662,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+350102,int_stack+280802,int_stack+518186,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+493406,int_stack+350102,int_stack+556406,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+657710,int_stack+493406,int_stack+408062,28);
 /*--- compute (i0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+724238,int_stack+657710,int_stack+602270,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+403610,int_stack+27300,int_stack+22512,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+417974,int_stack+403610,int_stack+267950,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+554558,int_stack+417974,int_stack+327254,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+403610,int_stack+554558,int_stack+459806,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+554558,int_stack+403610,int_stack+280802,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+403610,int_stack+554558,int_stack+350102,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+554558,int_stack+403610,int_stack+493406,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+267950,int_stack+554558,int_stack+657710,28);
 /*--- compute (i0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+351110,int_stack+267950,int_stack+724238,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+267950,int_stack+34600,int_stack+32620,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+273890,int_stack+36976,int_stack+34600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+281018,int_stack+273890,int_stack+267950,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+292898,int_stack+39784,int_stack+36976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+301322,int_stack+292898,int_stack+273890,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+315578,int_stack+301322,int_stack+281018,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+267950,int_stack+43060,int_stack+39784,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+435810,int_stack+267950,int_stack+292898,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+452658,int_stack+435810,int_stack+301322,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+277778,int_stack+452658,int_stack+315578,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+307478,int_stack+46840,int_stack+43060,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+318818,int_stack+307478,int_stack+267950,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+476418,int_stack+318818,int_stack+435810,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+504498,int_stack+476418,int_stack+452658,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+540138,int_stack+504498,int_stack+277778,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+435810,int_stack+51160,int_stack+46840,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+448770,int_stack+435810,int_stack+307478,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+267950,int_stack+448770,int_stack+318818,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+300710,int_stack+267950,int_stack+476418,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+581718,int_stack+300710,int_stack+504498,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+471450,int_stack+581718,int_stack+540138,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+526890,int_stack+56056,int_stack+51160,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+541578,int_stack+526890,int_stack+435810,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+631614,int_stack+541578,int_stack+448770,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+669414,int_stack+631614,int_stack+267950,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+718554,int_stack+669414,int_stack+300710,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+267950,int_stack+718554,int_stack+581718,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+777522,int_stack+267950,int_stack+471450,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+334478,int_stack+61564,int_stack+56056,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+435810,int_stack+334478,int_stack+526890,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+465186,int_stack+435810,int_stack+541578,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+508386,int_stack+465186,int_stack+631614,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+565086,int_stack+508386,int_stack+669414,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+633882,int_stack+565086,int_stack+718554,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+848802,int_stack+633882,int_stack+267950,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+934338,int_stack+848802,int_stack+777522,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+267950,int_stack+67720,int_stack+61564,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+286418,int_stack+267950,int_stack+334478,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+712506,int_stack+286418,int_stack+435810,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+267950,int_stack+712506,int_stack+465186,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+712506,int_stack+267950,int_stack+508386,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+435810,int_stack+712506,int_stack+565086,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+712506,int_stack+435810,int_stack+633882,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+435810,int_stack+712506,int_stack+848802,36);
 /*--- compute (k0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+542730,int_stack+435810,int_stack+934338,36);
 /*--- compute (ip|mm) ---*/
 hrr1_build_ip(Libint->AB,int_stack+651630,int_stack+542730,int_stack+351110,3025);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+905730,int_stack+77035,int_stack+74560,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+913155,int_stack+80005,int_stack+77035,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+922065,int_stack+913155,int_stack+905730,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+936915,int_stack+83515,int_stack+80005,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+947445,int_stack+936915,int_stack+913155,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+965265,int_stack+947445,int_stack+922065,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+905730,int_stack+87610,int_stack+83515,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+990015,int_stack+905730,int_stack+936915,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+267950,int_stack+990015,int_stack+947445,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+918015,int_stack+267950,int_stack+965265,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+955140,int_stack+92335,int_stack+87610,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+297650,int_stack+955140,int_stack+905730,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+322220,int_stack+297650,int_stack+990015,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+969315,int_stack+322220,int_stack+267950,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+357320,int_stack+969315,int_stack+918015,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+267950,int_stack+97735,int_stack+92335,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+905730,int_stack+267950,int_stack+955140,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+409295,int_stack+905730,int_stack+297650,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+450245,int_stack+409295,int_stack+322220,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+284150,int_stack+450245,int_stack+969315,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+934080,int_stack+284150,int_stack+357320,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+346520,int_stack+103855,int_stack+97735,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+364880,int_stack+346520,int_stack+267950,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+364880,int_stack+905730,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1003380,int_stack+0,int_stack+409295,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1064805,int_stack+1003380,int_stack+450245,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+397280,int_stack+1064805,int_stack+284150,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1138515,int_stack+397280,int_stack+934080,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+905730,int_stack+110740,int_stack+103855,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+926385,int_stack+905730,int_stack+346520,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+267950,int_stack+926385,int_stack+364880,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+321950,int_stack+267950,int_stack+0,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+321950,int_stack+1003380,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+963105,int_stack+0,int_stack+1064805,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1227615,int_stack+963105,int_stack+397280,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+392825,int_stack+1227615,int_stack+1138515,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+85995,int_stack+118435,int_stack+110740,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1061385,int_stack+85995,int_stack+905730,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1102695,int_stack+1061385,int_stack+926385,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1334535,int_stack+1102695,int_stack+267950,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1061385,int_stack+1334535,int_stack+321950,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+267950,int_stack+1061385,int_stack+0,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+267950,int_stack+963105,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+905730,int_stack+0,int_stack+1227615,45);
 /*--- compute (l0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1039380,int_stack+905730,int_stack+392825,45);
 /*--- compute (kp|mm) ---*/
 hrr1_build_kp(Libint->AB,int_stack+1175505,int_stack+1039380,int_stack+542730,3025);
 /*--- compute (id|mm) ---*/
 hrr1_build_id(Libint->AB,int_stack+1502205,int_stack+1175505,int_stack+651630,3025);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+130010,int_stack+126985,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9075,int_stack+133640,int_stack+130010,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19965,int_stack+9075,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+38115,int_stack+137930,int_stack+133640,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+50985,int_stack+38115,int_stack+9075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+72765,int_stack+50985,int_stack+19965,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+142935,int_stack+137930,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+103015,int_stack+0,int_stack+38115,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+267950,int_stack+103015,int_stack+50985,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+15015,int_stack+267950,int_stack+72765,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+60390,int_stack+148710,int_stack+142935,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+304250,int_stack+60390,int_stack+0,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+334280,int_stack+304250,int_stack+103015,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+77715,int_stack+334280,int_stack+267950,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+377180,int_stack+77715,int_stack+15015,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+267950,int_stack+155310,int_stack+148710,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+267950,int_stack+60390,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+440705,int_stack+0,int_stack+304250,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+490755,int_stack+440705,int_stack+334280,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+287750,int_stack+490755,int_stack+77715,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+34650,int_stack+287750,int_stack+377180,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+363980,int_stack+162790,int_stack+155310,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+386420,int_stack+363980,int_stack+267950,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+555105,int_stack+386420,int_stack+0,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+612855,int_stack+555105,int_stack+440705,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+687930,int_stack+612855,int_stack+490755,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+426020,int_stack+687930,int_stack+287750,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+778020,int_stack+426020,int_stack+34650,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+171205,int_stack+162790,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+25245,int_stack+0,int_stack+363980,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+70125,int_stack+25245,int_stack+386420,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+267950,int_stack+70125,int_stack+555105,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+886920,int_stack+267950,int_stack+612855,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+527660,int_stack+886920,int_stack+687930,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2010405,int_stack+527660,int_stack+426020,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+354575,int_stack+2010405,int_stack+778020,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+136125,int_stack+180610,int_stack+171205,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+647780,int_stack+136125,int_stack+0,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+698270,int_stack+647780,int_stack+25245,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+773070,int_stack+698270,int_stack+70125,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+647780,int_stack+773070,int_stack+267950,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+647780,int_stack+886920,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+647780,int_stack+0,int_stack+527660,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+647780,int_stack+2010405,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+490700,int_stack+0,int_stack+354575,55);
 /*--- compute (lp|mm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+2010405,int_stack+490700,int_stack+1039380,3025);
 /*--- compute (kd|mm) ---*/
 hrr1_build_kd(Libint->AB,int_stack+2418780,int_stack+2010405,int_stack+1175505,3025);
 /*--- compute (if|mm) ---*/
 hrr1_build_if(Libint->AB,int_stack+3072180,int_stack+2418780,int_stack+1502205,3025);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+194690,int_stack+191060,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10890,int_stack+199046,int_stack+194690,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23958,int_stack+10890,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+45738,int_stack+204194,int_stack+199046,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+61182,int_stack+45738,int_stack+10890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+87318,int_stack+61182,int_stack+23958,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+210200,int_stack+204194,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+123618,int_stack+0,int_stack+45738,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+154506,int_stack+123618,int_stack+61182,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+18018,int_stack+154506,int_stack+87318,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+72468,int_stack+217130,int_stack+210200,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+267950,int_stack+72468,int_stack+0,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+303986,int_stack+267950,int_stack+123618,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+355466,int_stack+303986,int_stack+154506,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+93258,int_stack+355466,int_stack+18018,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+225050,int_stack+217130,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+23760,int_stack+0,int_stack+72468,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+420806,int_stack+23760,int_stack+267950,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+657075,int_stack+420806,int_stack+303986,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+734295,int_stack+657075,int_stack+355466,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+267950,int_stack+734295,int_stack+93258,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+369590,int_stack+234026,int_stack+225050,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+65340,int_stack+369590,int_stack+0,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+112860,int_stack+65340,int_stack+23760,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+825771,int_stack+112860,int_stack+420806,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+915861,int_stack+825771,int_stack+657075,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1023969,int_stack+915861,int_stack+734295,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+657075,int_stack+1023969,int_stack+267950,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+267950,int_stack+244124,int_stack+234026,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+298244,int_stack+267950,int_stack+369590,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+352100,int_stack+298244,int_stack+65340,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+352100,int_stack+112860,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+103950,int_stack+0,int_stack+825771,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1145937,int_stack+103950,int_stack+915861,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+787755,int_stack+1145937,int_stack+1023969,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+944571,int_stack+787755,int_stack+657075,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+657075,int_stack+255410,int_stack+244124,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+690933,int_stack+657075,int_stack+267950,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1290081,int_stack+690933,int_stack+298244,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+657075,int_stack+1290081,int_stack+352100,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1290081,int_stack+657075,int_stack+0,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1435611,int_stack+1290081,int_stack+103950,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+1435611,int_stack+1145937,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+185328,int_stack+0,int_stack+787755,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+657075,int_stack+185328,int_stack+944571,66);
 /*--- compute (mp|mm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+856725,int_stack+657075,int_stack+490700,3025);
 /*--- compute (ld|mm) ---*/
 hrr1_build_ld(Libint->AB,int_stack+0,int_stack+856725,int_stack+2010405,3025);
 /*--- compute (kf|mm) ---*/
 hrr1_build_kf(Libint->AB,int_stack+816750,int_stack+0,int_stack+2418780,3025);
 /*--- compute (ig|mm) ---*/
 hrr1_build_ig(Libint->AB,int_stack+3919180,int_stack+816750,int_stack+3072180,3025);
 return int_stack+3919180;}
