/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ihnm(Libint_t*, prim_data*);

  /* Computes quartets of (ih|nm) integrals */

REALTYPE *hrr_order_ihnm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[6][12] = int_stack + 4032;
 Libint->vrr_classes[6][13] = int_stack + 6580;
 Libint->vrr_classes[6][14] = int_stack + 9520;
 Libint->vrr_classes[6][15] = int_stack + 12880;
 Libint->vrr_classes[6][16] = int_stack + 16688;
 Libint->vrr_classes[6][17] = int_stack + 20972;
 Libint->vrr_classes[6][18] = int_stack + 25760;
 Libint->vrr_classes[6][19] = int_stack + 31080;
 Libint->vrr_classes[7][10] = int_stack + 36960;
 Libint->vrr_classes[7][11] = int_stack + 39336;
 Libint->vrr_classes[7][12] = int_stack + 42144;
 Libint->vrr_classes[7][13] = int_stack + 45420;
 Libint->vrr_classes[7][14] = int_stack + 49200;
 Libint->vrr_classes[7][15] = int_stack + 53520;
 Libint->vrr_classes[7][16] = int_stack + 58416;
 Libint->vrr_classes[7][17] = int_stack + 63924;
 Libint->vrr_classes[7][18] = int_stack + 70080;
 Libint->vrr_classes[7][19] = int_stack + 76920;
 Libint->vrr_classes[8][10] = int_stack + 84480;
 Libint->vrr_classes[8][11] = int_stack + 87450;
 Libint->vrr_classes[8][12] = int_stack + 90960;
 Libint->vrr_classes[8][13] = int_stack + 95055;
 Libint->vrr_classes[8][14] = int_stack + 99780;
 Libint->vrr_classes[8][15] = int_stack + 105180;
 Libint->vrr_classes[8][16] = int_stack + 111300;
 Libint->vrr_classes[8][17] = int_stack + 118185;
 Libint->vrr_classes[8][18] = int_stack + 125880;
 Libint->vrr_classes[8][19] = int_stack + 134430;
 Libint->vrr_classes[9][10] = int_stack + 143880;
 Libint->vrr_classes[9][11] = int_stack + 147510;
 Libint->vrr_classes[9][12] = int_stack + 151800;
 Libint->vrr_classes[9][13] = int_stack + 156805;
 Libint->vrr_classes[9][14] = int_stack + 162580;
 Libint->vrr_classes[9][15] = int_stack + 169180;
 Libint->vrr_classes[9][16] = int_stack + 176660;
 Libint->vrr_classes[9][17] = int_stack + 185075;
 Libint->vrr_classes[9][18] = int_stack + 194480;
 Libint->vrr_classes[9][19] = int_stack + 204930;
 Libint->vrr_classes[10][10] = int_stack + 216480;
 Libint->vrr_classes[10][11] = int_stack + 220836;
 Libint->vrr_classes[10][12] = int_stack + 225984;
 Libint->vrr_classes[10][13] = int_stack + 231990;
 Libint->vrr_classes[10][14] = int_stack + 238920;
 Libint->vrr_classes[10][15] = int_stack + 246840;
 Libint->vrr_classes[10][16] = int_stack + 255816;
 Libint->vrr_classes[10][17] = int_stack + 265914;
 Libint->vrr_classes[10][18] = int_stack + 277200;
 Libint->vrr_classes[10][19] = int_stack + 289740;
 Libint->vrr_classes[11][10] = int_stack + 303600;
 Libint->vrr_classes[11][11] = int_stack + 308748;
 Libint->vrr_classes[11][12] = int_stack + 314832;
 Libint->vrr_classes[11][13] = int_stack + 321930;
 Libint->vrr_classes[11][14] = int_stack + 330120;
 Libint->vrr_classes[11][15] = int_stack + 339480;
 Libint->vrr_classes[11][16] = int_stack + 350088;
 Libint->vrr_classes[11][17] = int_stack + 362022;
 Libint->vrr_classes[11][18] = int_stack + 375360;
 Libint->vrr_classes[11][19] = int_stack + 390180;
 memset(int_stack,0,406560*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 406560;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ihnm(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+406560,int_stack+1848,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+412104,int_stack+4032,int_stack+1848,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+418656,int_stack+412104,int_stack+406560,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+429744,int_stack+6580,int_stack+4032,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+437388,int_stack+429744,int_stack+412104,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+450492,int_stack+437388,int_stack+418656,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+406560,int_stack+9520,int_stack+6580,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+468972,int_stack+406560,int_stack+429744,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+415380,int_stack+468972,int_stack+437388,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+484260,int_stack+415380,int_stack+450492,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+437220,int_stack+12880,int_stack+9520,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+447300,int_stack+437220,int_stack+406560,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+511980,int_stack+447300,int_stack+468972,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+537460,int_stack+511980,int_stack+415380,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+570220,int_stack+537460,int_stack+484260,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+406560,int_stack+16688,int_stack+12880,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+464940,int_stack+406560,int_stack+437220,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+609028,int_stack+464940,int_stack+447300,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+417984,int_stack+609028,int_stack+511980,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+485100,int_stack+417984,int_stack+537460,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+638428,int_stack+485100,int_stack+570220,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+530964,int_stack+20972,int_stack+16688,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+543816,int_stack+530964,int_stack+406560,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+566664,int_stack+543816,int_stack+464940,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+690172,int_stack+566664,int_stack+609028,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+734272,int_stack+690172,int_stack+417984,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+406560,int_stack+734272,int_stack+485100,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+787780,int_stack+406560,int_stack+638428,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+467712,int_stack+25760,int_stack+20972,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+482076,int_stack+467712,int_stack+530964,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+600264,int_stack+482076,int_stack+543816,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+507780,int_stack+600264,int_stack+566664,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+854308,int_stack+507780,int_stack+690172,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+638344,int_stack+854308,int_stack+734272,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+916048,int_stack+638344,int_stack+406560,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+994672,int_stack+916048,int_stack+787780,28);
 /*--- compute (i0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+406560,int_stack+31080,int_stack+25760,28);
 /*--- compute (i0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+422520,int_stack+406560,int_stack+467712,28);
 /*--- compute (i0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+709688,int_stack+422520,int_stack+482076,28);
 /*--- compute (i0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+406560,int_stack+709688,int_stack+600264,28);
 /*--- compute (i0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+709688,int_stack+406560,int_stack+507780,28);
 /*--- compute (i0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+406560,int_stack+709688,int_stack+854308,28);
 /*--- compute (i0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+709688,int_stack+406560,int_stack+638344,28);
 /*--- compute (i0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+406560,int_stack+709688,int_stack+916048,28);
 /*--- compute (i0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+504840,int_stack+406560,int_stack+994672,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+406560,int_stack+39336,int_stack+36960,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+413688,int_stack+42144,int_stack+39336,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+422112,int_stack+413688,int_stack+406560,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+436368,int_stack+45420,int_stack+42144,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+446196,int_stack+436368,int_stack+413688,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+463044,int_stack+446196,int_stack+422112,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+406560,int_stack+49200,int_stack+45420,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+606480,int_stack+406560,int_stack+436368,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+417900,int_stack+606480,int_stack+446196,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+626136,int_stack+417900,int_stack+463044,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+445980,int_stack+53520,int_stack+49200,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+458940,int_stack+445980,int_stack+406560,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+661776,int_stack+458940,int_stack+606480,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+694536,int_stack+661776,int_stack+417900,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+736656,int_stack+694536,int_stack+626136,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+606480,int_stack+58416,int_stack+53520,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+621168,int_stack+606480,int_stack+445980,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+406560,int_stack+621168,int_stack+458940,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+444360,int_stack+406560,int_stack+661776,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+786552,int_stack+444360,int_stack+694536,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+647088,int_stack+786552,int_stack+736656,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+713616,int_stack+63924,int_stack+58416,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+730140,int_stack+713616,int_stack+606480,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+845520,int_stack+730140,int_stack+621168,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+888720,int_stack+845520,int_stack+406560,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+945420,int_stack+888720,int_stack+444360,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+406560,int_stack+945420,int_stack+786552,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+759516,int_stack+406560,int_stack+647088,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+485184,int_stack+70080,int_stack+63924,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+606480,int_stack+485184,int_stack+713616,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+639528,int_stack+606480,int_stack+730140,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+688488,int_stack+639528,int_stack+845520,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1014216,int_stack+688488,int_stack+888720,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+845052,int_stack+1014216,int_stack+945420,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1093596,int_stack+845052,int_stack+406560,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1194684,int_stack+1093596,int_stack+759516,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+406560,int_stack+76920,int_stack+70080,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+427080,int_stack+406560,int_stack+485184,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+753288,int_stack+427080,int_stack+606480,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+406560,int_stack+753288,int_stack+639528,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+753288,int_stack+406560,int_stack+688488,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+606480,int_stack+753288,int_stack+1014216,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+712320,int_stack+606480,int_stack+845052,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+830256,int_stack+712320,int_stack+1093596,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+606480,int_stack+830256,int_stack+1194684,36);
 /*--- compute (ip|nm) ---*/
 hrr1_build_ip(Libint->AB,int_stack+737160,int_stack+606480,int_stack+504840,3630);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1042080,int_stack+87450,int_stack+84480,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1050990,int_stack+90960,int_stack+87450,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1061520,int_stack+1050990,int_stack+1042080,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1079340,int_stack+95055,int_stack+90960,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1091625,int_stack+1079340,int_stack+1050990,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1112685,int_stack+1091625,int_stack+1061520,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1042080,int_stack+99780,int_stack+95055,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1142385,int_stack+1042080,int_stack+1079340,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1056255,int_stack+1142385,int_stack+1091625,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1166955,int_stack+1056255,int_stack+1112685,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1091355,int_stack+105180,int_stack+99780,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1107555,int_stack+1091355,int_stack+1042080,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1211505,int_stack+1107555,int_stack+1142385,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+406560,int_stack+1211505,int_stack+1056255,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+459210,int_stack+406560,int_stack+1166955,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1042080,int_stack+111300,int_stack+105180,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1135905,int_stack+1042080,int_stack+1091355,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1252455,int_stack+1135905,int_stack+1107555,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1060440,int_stack+1252455,int_stack+1211505,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1168305,int_stack+1060440,int_stack+406560,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+521580,int_stack+1168305,int_stack+459210,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+406560,int_stack+118185,int_stack+111300,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+427215,int_stack+406560,int_stack+1042080,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+463935,int_stack+427215,int_stack+1135905,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+463935,int_stack+1252455,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1242015,int_stack+0,int_stack+1060440,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1042080,int_stack+1242015,int_stack+1168305,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1328010,int_stack+1042080,int_stack+521580,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1140360,int_stack+125880,int_stack+118185,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1163445,int_stack+1140360,int_stack+406560,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+517935,int_stack+1163445,int_stack+427215,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1434930,int_stack+517935,int_stack+463935,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+406560,int_stack+1434930,int_stack+0,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+406560,int_stack+1242015,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1515930,int_stack+0,int_stack+1042080,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1642290,int_stack+1515930,int_stack+1328010,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1042080,int_stack+134430,int_stack+125880,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1067730,int_stack+1042080,int_stack+1140360,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1204755,int_stack+1067730,int_stack+1163445,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1042080,int_stack+1204755,int_stack+517935,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1133880,int_stack+1042080,int_stack+1434930,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1247280,int_stack+1133880,int_stack+406560,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+406560,int_stack+1247280,int_stack+0,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1042080,int_stack+406560,int_stack+1515930,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+406560,int_stack+1042080,int_stack+1642290,45);
 /*--- compute (kp|nm) ---*/
 hrr1_build_kp(Libint->AB,int_stack+1042080,int_stack+406560,int_stack+606480,3630);
 /*--- compute (id|nm) ---*/
 hrr1_build_id(Libint->AB,int_stack+1434120,int_stack+1042080,int_stack+737160,3630);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+569910,int_stack+147510,int_stack+143880,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+580800,int_stack+151800,int_stack+147510,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+593670,int_stack+580800,int_stack+569910,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+615450,int_stack+156805,int_stack+151800,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+630465,int_stack+615450,int_stack+580800,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+656205,int_stack+630465,int_stack+593670,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+569910,int_stack+162580,int_stack+156805,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+692505,int_stack+569910,int_stack+615450,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+587235,int_stack+692505,int_stack+630465,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+722535,int_stack+587235,int_stack+656205,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+630135,int_stack+169180,int_stack+162580,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+649935,int_stack+630135,int_stack+569910,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+776985,int_stack+649935,int_stack+692505,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+827035,int_stack+776985,int_stack+587235,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+891385,int_stack+827035,int_stack+722535,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+569910,int_stack+176660,int_stack+169180,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+684585,int_stack+569910,int_stack+630135,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+967615,int_stack+684585,int_stack+649935,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+592350,int_stack+967615,int_stack+776985,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+724185,int_stack+592350,int_stack+827035,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+724185,int_stack+891385,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+814275,int_stack+185075,int_stack+176660,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+839520,int_stack+814275,int_stack+569910,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+884400,int_stack+839520,int_stack+684585,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2043960,int_stack+884400,int_stack+967615,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2130585,int_stack+2043960,int_stack+592350,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+569910,int_stack+2130585,int_stack+724185,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2235690,int_stack+569910,int_stack+0,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+194480,int_stack+185075,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+28215,int_stack+0,int_stack+814275,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+78705,int_stack+28215,int_stack+839520,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+690030,int_stack+78705,int_stack+884400,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+789030,int_stack+690030,int_stack+2043960,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2366370,int_stack+789030,int_stack+2130585,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2043960,int_stack+2366370,int_stack+569910,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2506510,int_stack+2043960,int_stack+2235690,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+569910,int_stack+204930,int_stack+194480,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+601260,int_stack+569910,int_stack+0,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2198400,int_stack+601260,int_stack+28215,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+569910,int_stack+2198400,int_stack+78705,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2198400,int_stack+569910,int_stack+690030,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+569910,int_stack+2198400,int_stack+789030,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+731610,int_stack+569910,int_stack+2366370,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2198400,int_stack+731610,int_stack+2043960,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+569910,int_stack+2198400,int_stack+2506510,55);
 /*--- compute (lp|nm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+2043960,int_stack+569910,int_stack+406560,3630);
 /*--- compute (kd|nm) ---*/
 hrr1_build_kd(Libint->AB,int_stack+2534010,int_stack+2043960,int_stack+1042080,3630);
 /*--- compute (if|nm) ---*/
 hrr1_build_if(Libint->AB,int_stack+3318090,int_stack+2534010,int_stack+1434120,3630);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+406560,int_stack+220836,int_stack+216480,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+419628,int_stack+225984,int_stack+220836,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+435072,int_stack+419628,int_stack+406560,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+461208,int_stack+231990,int_stack+225984,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+479226,int_stack+461208,int_stack+419628,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+510114,int_stack+479226,int_stack+435072,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+406560,int_stack+238920,int_stack+231990,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+769560,int_stack+406560,int_stack+461208,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+427350,int_stack+769560,int_stack+479226,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+805596,int_stack+427350,int_stack+510114,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+478830,int_stack+246840,int_stack+238920,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+502590,int_stack+478830,int_stack+406560,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+870936,int_stack+502590,int_stack+769560,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+930996,int_stack+870936,int_stack+427350,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1008216,int_stack+930996,int_stack+805596,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+769560,int_stack+255816,int_stack+246840,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+796488,int_stack+769560,int_stack+478830,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+406560,int_stack+796488,int_stack+502590,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+475860,int_stack+406560,int_stack+870936,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1099692,int_stack+475860,int_stack+930996,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+844008,int_stack+1099692,int_stack+1008216,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+965976,int_stack+265914,int_stack+255816,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+996270,int_stack+965976,int_stack+769560,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1207800,int_stack+996270,int_stack+796488,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1287000,int_stack+1207800,int_stack+406560,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1390950,int_stack+1287000,int_stack+475860,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+406560,int_stack+1390950,int_stack+1099692,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1050126,int_stack+406560,int_stack+844008,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+769560,int_stack+277200,int_stack+265914,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+803418,int_stack+769560,int_stack+965976,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+864006,int_stack+803418,int_stack+996270,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1517076,int_stack+864006,int_stack+1207800,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1635876,int_stack+1517076,int_stack+1287000,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1206942,int_stack+1635876,int_stack+1390950,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1781406,int_stack+1206942,int_stack+406560,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1781406,int_stack+1050126,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+406560,int_stack+289740,int_stack+277200,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+444180,int_stack+406560,int_stack+769560,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+953766,int_stack+444180,int_stack+803418,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+406560,int_stack+953766,int_stack+864006,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+769560,int_stack+406560,int_stack+1517076,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+935880,int_stack+769560,int_stack+1635876,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1375110,int_stack+935880,int_stack+1206942,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+769560,int_stack+1375110,int_stack+1781406,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1001220,int_stack+769560,int_stack+0,66);
 /*--- compute (mp|nm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1240800,int_stack+1001220,int_stack+569910,3630);
 /*--- compute (ld|nm) ---*/
 hrr1_build_ld(Libint->AB,int_stack+4334490,int_stack+1240800,int_stack+2043960,3630);
 /*--- compute (kf|nm) ---*/
 hrr1_build_kf(Libint->AB,int_stack+5314590,int_stack+4334490,int_stack+2534010,3630);
 /*--- compute (ig|nm) ---*/
 hrr1_build_ig(Libint->AB,int_stack+6621390,int_stack+5314590,int_stack+3318090,3630);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+308748,int_stack+303600,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+314832,int_stack+308748,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+321930,int_stack+314832,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+122382,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+330120,int_stack+321930,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+173862,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+173862,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+216450,int_stack+24570,int_stack+122382,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+85410,int_stack+339480,int_stack+330120,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113490,int_stack+85410,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1839750,int_stack+113490,int_stack+173862,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1910730,int_stack+1839750,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2001990,int_stack+1910730,int_stack+216450,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+350088,int_stack+339480,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+162630,int_stack+0,int_stack+85410,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+218790,int_stack+162630,int_stack+113490,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+31824,int_stack+218790,int_stack+1839750,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2110098,int_stack+31824,int_stack+1910730,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1839750,int_stack+2110098,int_stack+2001990,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1983894,int_stack+362022,int_stack+350088,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2019696,int_stack+1983894,int_stack+0,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2237862,int_stack+2019696,int_stack+162630,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2331462,int_stack+2237862,int_stack+218790,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+138294,int_stack+2331462,int_stack+31824,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2454312,int_stack+138294,int_stack+2110098,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2624664,int_stack+2454312,int_stack+1839750,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1839750,int_stack+375360,int_stack+362022,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1879764,int_stack+1839750,int_stack+1983894,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+1879764,int_stack+2019696,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1951368,int_stack+0,int_stack+2237862,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2091768,int_stack+1951368,int_stack+2331462,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2809992,int_stack+2091768,int_stack+138294,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+106080,int_stack+2809992,int_stack+2454312,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2263758,int_stack+106080,int_stack+2624664,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+2495418,int_stack+390180,int_stack+375360,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+2539878,int_stack+2495418,int_stack+1839750,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2619906,int_stack+2539878,int_stack+1879764,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+325104,int_stack+2619906,int_stack+0,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2495418,int_stack+325104,int_stack+1951368,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+325104,int_stack+2495418,int_stack+2091768,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2495418,int_stack+325104,int_stack+2809992,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+325104,int_stack+2495418,int_stack+106080,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2495418,int_stack+325104,int_stack+2263758,78);
 /*--- compute (np|nm) ---*/
 hrr1_build_np(Libint->AB,int_stack+2778558,int_stack+2495418,int_stack+1001220,3630);
 /*--- compute (md|nm) ---*/
 hrr1_build_md(Libint->AB,int_stack+0,int_stack+2778558,int_stack+1240800,3630);
 /*--- compute (lf|nm) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1197900,int_stack+0,int_stack+4334490,3630);
 /*--- compute (kg|nm) ---*/
 hrr1_build_kg(Libint->AB,int_stack+2831400,int_stack+1197900,int_stack+5314590,3630);
 /*--- compute (ih|nm) ---*/
 hrr1_build_ih(Libint->AB,int_stack+0,int_stack+2831400,int_stack+6621390,3630);
 return int_stack+0;}
