/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iimg(Libint_t*, prim_data*);

  /* Computes quartets of (ii|mg) integrals */

REALTYPE *hrr_order_iimg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[6][13] = int_stack + 8120;
 Libint->vrr_classes[7][9] = int_stack + 11060;
 Libint->vrr_classes[7][10] = int_stack + 13040;
 Libint->vrr_classes[7][11] = int_stack + 15416;
 Libint->vrr_classes[7][12] = int_stack + 18224;
 Libint->vrr_classes[7][13] = int_stack + 21500;
 Libint->vrr_classes[8][9] = int_stack + 25280;
 Libint->vrr_classes[8][10] = int_stack + 27755;
 Libint->vrr_classes[8][11] = int_stack + 30725;
 Libint->vrr_classes[8][12] = int_stack + 34235;
 Libint->vrr_classes[8][13] = int_stack + 38330;
 Libint->vrr_classes[9][9] = int_stack + 43055;
 Libint->vrr_classes[9][10] = int_stack + 46080;
 Libint->vrr_classes[9][11] = int_stack + 49710;
 Libint->vrr_classes[9][12] = int_stack + 54000;
 Libint->vrr_classes[9][13] = int_stack + 59005;
 Libint->vrr_classes[10][9] = int_stack + 64780;
 Libint->vrr_classes[10][10] = int_stack + 68410;
 Libint->vrr_classes[10][11] = int_stack + 72766;
 Libint->vrr_classes[10][12] = int_stack + 77914;
 Libint->vrr_classes[10][13] = int_stack + 83920;
 Libint->vrr_classes[11][9] = int_stack + 90850;
 Libint->vrr_classes[11][10] = int_stack + 95140;
 Libint->vrr_classes[11][11] = int_stack + 100288;
 Libint->vrr_classes[11][12] = int_stack + 106372;
 Libint->vrr_classes[11][13] = int_stack + 113470;
 Libint->vrr_classes[12][9] = int_stack + 121660;
 Libint->vrr_classes[12][10] = int_stack + 126665;
 Libint->vrr_classes[12][11] = int_stack + 132671;
 Libint->vrr_classes[12][12] = int_stack + 139769;
 Libint->vrr_classes[12][13] = int_stack + 148050;
 memset(int_stack,0,157605*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 157605;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iimg(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+157605,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+162225,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+167769,int_stack+162225,int_stack+157605,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+177009,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+183561,int_stack+177009,int_stack+162225,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+194649,int_stack+183561,int_stack+167769,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+157605,int_stack+8120,int_stack+5572,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+210049,int_stack+157605,int_stack+177009,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+157605,int_stack+210049,int_stack+183561,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+210049,int_stack+157605,int_stack+194649,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+157605,int_stack+13040,int_stack+11060,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+163545,int_stack+15416,int_stack+13040,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+170673,int_stack+163545,int_stack+157605,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+182553,int_stack+18224,int_stack+15416,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+190977,int_stack+182553,int_stack+163545,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+233149,int_stack+190977,int_stack+170673,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+157605,int_stack+21500,int_stack+18224,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+157605,int_stack+182553,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+157605,int_stack+0,int_stack+190977,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+252949,int_stack+157605,int_stack+233149,36);
 /*--- compute (ip|mg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+282649,int_stack+252949,int_stack+210049,825);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+157605,int_stack+27755,int_stack+25280,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+165030,int_stack+30725,int_stack+27755,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+173940,int_stack+165030,int_stack+157605,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+188790,int_stack+34235,int_stack+30725,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+199320,int_stack+188790,int_stack+165030,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+217140,int_stack+199320,int_stack+173940,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+157605,int_stack+38330,int_stack+34235,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+157605,int_stack+188790,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+157605,int_stack+0,int_stack+199320,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+157605,int_stack+217140,45);
 /*--- compute (kp|mg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+157605,int_stack+0,int_stack+252949,825);
 /*--- compute (id|mg) ---*/
 hrr1_build_id(Libint->AB,int_stack+351949,int_stack+157605,int_stack+282649,825);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+246705,int_stack+46080,int_stack+43055,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+255780,int_stack+49710,int_stack+46080,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+266670,int_stack+255780,int_stack+246705,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+284820,int_stack+54000,int_stack+49710,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+297690,int_stack+284820,int_stack+255780,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+319470,int_stack+297690,int_stack+266670,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+246705,int_stack+59005,int_stack+54000,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+37125,int_stack+246705,int_stack+284820,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+246705,int_stack+37125,int_stack+297690,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+490549,int_stack+246705,int_stack+319470,55);
 /*--- compute (lp|mg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+535924,int_stack+490549,int_stack+0,825);
 /*--- compute (kd|mg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+647299,int_stack+535924,int_stack+157605,825);
 /*--- compute (if|mg) ---*/
 hrr1_build_if(Libint->AB,int_stack+825499,int_stack+647299,int_stack+351949,825);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+157605,int_stack+68410,int_stack+64780,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+168495,int_stack+72766,int_stack+68410,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+181563,int_stack+168495,int_stack+157605,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+203343,int_stack+77914,int_stack+72766,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+218787,int_stack+203343,int_stack+168495,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+244923,int_stack+218787,int_stack+181563,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+157605,int_stack+83920,int_stack+77914,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+281223,int_stack+157605,int_stack+203343,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+157605,int_stack+281223,int_stack+218787,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+281223,int_stack+157605,int_stack+244923,66);
 /*--- compute (mp|mg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+335673,int_stack+281223,int_stack+490549,825);
 /*--- compute (ld|mg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1056499,int_stack+335673,int_stack+535924,825);
 /*--- compute (kf|mg) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1279249,int_stack+1056499,int_stack+647299,825);
 /*--- compute (ig|mg) ---*/
 hrr1_build_ig(Libint->AB,int_stack+471798,int_stack+1279249,int_stack+825499,825);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+157605,int_stack+95140,int_stack+90850,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+170475,int_stack+100288,int_stack+95140,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+185919,int_stack+170475,int_stack+157605,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+211659,int_stack+106372,int_stack+100288,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+229911,int_stack+211659,int_stack+170475,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+818298,int_stack+229911,int_stack+185919,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+157605,int_stack+113470,int_stack+106372,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+861198,int_stack+157605,int_stack+211659,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+157605,int_stack+861198,int_stack+229911,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+861198,int_stack+157605,int_stack+818298,78);
 /*--- compute (np|mg) ---*/
 hrr1_build_np(Libint->AB,int_stack+1576249,int_stack+861198,int_stack+281223,825);
 /*--- compute (md|mg) ---*/
 hrr1_build_md(Libint->AB,int_stack+1739599,int_stack+1576249,int_stack+335673,825);
 /*--- compute (lf|mg) ---*/
 hrr1_build_lf(Libint->AB,int_stack+2011849,int_stack+1739599,int_stack+1056499,825);
 /*--- compute (kg|mg) ---*/
 hrr1_build_kg(Libint->AB,int_stack+2383099,int_stack+2011849,int_stack+1279249,825);
 /*--- compute (ih|mg) ---*/
 hrr1_build_ih(Libint->AB,int_stack+925548,int_stack+2383099,int_stack+471798,825);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+157605,int_stack+126665,int_stack+121660,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+172620,int_stack+132671,int_stack+126665,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+190638,int_stack+172620,int_stack+157605,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+220668,int_stack+139769,int_stack+132671,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+241962,int_stack+220668,int_stack+172620,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+277998,int_stack+241962,int_stack+190638,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+157605,int_stack+148050,int_stack+139769,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+328048,int_stack+157605,int_stack+220668,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+370636,int_stack+328048,int_stack+241962,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+430696,int_stack+370636,int_stack+277998,91);
 /*--- compute (op|mg) ---*/
 hrr1_build_op(Libint->AB,int_stack+505771,int_stack+430696,int_stack+861198,825);
 /*--- compute (nd|mg) ---*/
 hrr1_build_nd(Libint->AB,int_stack+0,int_stack+505771,int_stack+1576249,825);
 /*--- compute (mf|mg) ---*/
 hrr1_build_mf(Libint->AB,int_stack+326700,int_stack+0,int_stack+1739599,825);
 /*--- compute (lg|mg) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1410648,int_stack+326700,int_stack+2011849,825);
 /*--- compute (kh|mg) ---*/
 hrr1_build_kh(Libint->AB,int_stack+0,int_stack+1410648,int_stack+2383099,825);
 /*--- compute (ii|mg) ---*/
 hrr1_build_ii(Libint->AB,int_stack+1410648,int_stack+0,int_stack+925548,825);
 return int_stack+1410648;}
