/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ipii(Libint_t*, prim_data*);

  /* Computes quartets of (ip|ii) integrals */

REALTYPE *hrr_order_ipii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][6] = int_stack + 0;
 Libint->vrr_classes[6][7] = int_stack + 784;
 Libint->vrr_classes[6][8] = int_stack + 1792;
 Libint->vrr_classes[6][9] = int_stack + 3052;
 Libint->vrr_classes[6][10] = int_stack + 4592;
 Libint->vrr_classes[6][11] = int_stack + 6440;
 Libint->vrr_classes[6][12] = int_stack + 8624;
 Libint->vrr_classes[7][6] = int_stack + 11172;
 Libint->vrr_classes[7][7] = int_stack + 12180;
 Libint->vrr_classes[7][8] = int_stack + 13476;
 Libint->vrr_classes[7][9] = int_stack + 15096;
 Libint->vrr_classes[7][10] = int_stack + 17076;
 Libint->vrr_classes[7][11] = int_stack + 19452;
 Libint->vrr_classes[7][12] = int_stack + 22260;
 memset(int_stack,0,25536*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 25536;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ipii(Libint, Data);
   Data++;
 }
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+25536,int_stack+784,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+27888,int_stack+1792,int_stack+784,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+30912,int_stack+27888,int_stack+25536,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+35616,int_stack+3052,int_stack+1792,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+39396,int_stack+35616,int_stack+27888,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+45444,int_stack+39396,int_stack+30912,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25536,int_stack+4592,int_stack+3052,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+53284,int_stack+25536,int_stack+35616,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+60844,int_stack+53284,int_stack+39396,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+30156,int_stack+60844,int_stack+45444,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+41916,int_stack+6440,int_stack+4592,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+70924,int_stack+41916,int_stack+25536,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+80164,int_stack+70924,int_stack+53284,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+92764,int_stack+80164,int_stack+60844,28);
 /*--- compute (i0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+47460,int_stack+92764,int_stack+30156,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+25536,int_stack+8624,int_stack+6440,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+25536,int_stack+41916,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+25536,int_stack+0,int_stack+70924,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+107884,int_stack+25536,int_stack+80164,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+25536,int_stack+107884,int_stack+92764,28);
 /*--- compute (i0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+63924,int_stack+25536,int_stack+47460,28);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+25536,int_stack+12180,int_stack+11172,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+28560,int_stack+13476,int_stack+12180,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+32448,int_stack+28560,int_stack+25536,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+38496,int_stack+15096,int_stack+13476,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+43356,int_stack+38496,int_stack+28560,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+51132,int_stack+43356,int_stack+32448,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25536,int_stack+17076,int_stack+15096,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+25536,int_stack+38496,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+85876,int_stack+0,int_stack+43356,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+31476,int_stack+85876,int_stack+51132,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+46596,int_stack+19452,int_stack+17076,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+98836,int_stack+46596,int_stack+25536,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+110716,int_stack+98836,int_stack+0,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+110716,int_stack+85876,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+126916,int_stack+0,int_stack+31476,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+85876,int_stack+22260,int_stack+19452,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+19440,int_stack+85876,int_stack+46596,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+33696,int_stack+19440,int_stack+98836,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+85876,int_stack+33696,int_stack+110716,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+19440,int_stack+85876,int_stack+0,36);
 /*--- compute (k0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+85876,int_stack+19440,int_stack+126916,36);
 /*--- compute (ip|ii) ---*/
 hrr1_build_ip(Libint->AB,int_stack+114100,int_stack+85876,int_stack+63924,784);
 return int_stack+114100;}
