/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ipki(Libint_t*, prim_data*);

  /* Computes quartets of (ip|ki) integrals */

REALTYPE *hrr_order_ipki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][7] = int_stack + 0;
 Libint->vrr_classes[6][8] = int_stack + 1008;
 Libint->vrr_classes[6][9] = int_stack + 2268;
 Libint->vrr_classes[6][10] = int_stack + 3808;
 Libint->vrr_classes[6][11] = int_stack + 5656;
 Libint->vrr_classes[6][12] = int_stack + 7840;
 Libint->vrr_classes[6][13] = int_stack + 10388;
 Libint->vrr_classes[7][7] = int_stack + 13328;
 Libint->vrr_classes[7][8] = int_stack + 14624;
 Libint->vrr_classes[7][9] = int_stack + 16244;
 Libint->vrr_classes[7][10] = int_stack + 18224;
 Libint->vrr_classes[7][11] = int_stack + 20600;
 Libint->vrr_classes[7][12] = int_stack + 23408;
 Libint->vrr_classes[7][13] = int_stack + 26684;
 memset(int_stack,0,30464*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 30464;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ipki(Libint, Data);
   Data++;
 }
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+30464,int_stack+1008,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+33488,int_stack+2268,int_stack+1008,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+37268,int_stack+33488,int_stack+30464,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+43316,int_stack+3808,int_stack+2268,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+47936,int_stack+43316,int_stack+33488,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+55496,int_stack+47936,int_stack+37268,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+30464,int_stack+5656,int_stack+3808,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+65576,int_stack+30464,int_stack+43316,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+74816,int_stack+65576,int_stack+47936,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+36008,int_stack+74816,int_stack+55496,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+51128,int_stack+7840,int_stack+5656,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+87416,int_stack+51128,int_stack+30464,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+98504,int_stack+87416,int_stack+65576,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+113904,int_stack+98504,int_stack+74816,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+57680,int_stack+113904,int_stack+36008,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+30464,int_stack+10388,int_stack+7840,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+30464,int_stack+51128,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+30464,int_stack+0,int_stack+87416,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+132804,int_stack+30464,int_stack+98504,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+30464,int_stack+132804,int_stack+113904,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+78848,int_stack+30464,int_stack+57680,28);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+30464,int_stack+14624,int_stack+13328,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+34352,int_stack+16244,int_stack+14624,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+39212,int_stack+34352,int_stack+30464,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+46988,int_stack+18224,int_stack+16244,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+52928,int_stack+46988,int_stack+34352,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+62648,int_stack+52928,int_stack+39212,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+30464,int_stack+20600,int_stack+18224,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+30464,int_stack+46988,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+107072,int_stack+0,int_stack+52928,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+37592,int_stack+107072,int_stack+62648,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+57032,int_stack+23408,int_stack+20600,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+123272,int_stack+57032,int_stack+30464,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+137528,int_stack+123272,int_stack+0,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+157328,int_stack+137528,int_stack+107072,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+181628,int_stack+157328,int_stack+37592,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+107072,int_stack+26684,int_stack+23408,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+107072,int_stack+57032,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+16848,int_stack+0,int_stack+123272,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+107072,int_stack+16848,int_stack+137528,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+107072,int_stack+157328,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+107072,int_stack+0,int_stack+181628,36);
 /*--- compute (ip|ki) ---*/
 hrr1_build_ip(Libint->AB,int_stack+143360,int_stack+107072,int_stack+78848,1008);
 return int_stack+143360;}
