/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ipli(Libint_t*, prim_data*);

  /* Computes quartets of (ip|li) integrals */

REALTYPE *hrr_order_ipli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[6][12] = int_stack + 6832;
 Libint->vrr_classes[6][13] = int_stack + 9380;
 Libint->vrr_classes[6][14] = int_stack + 12320;
 Libint->vrr_classes[7][8] = int_stack + 15680;
 Libint->vrr_classes[7][9] = int_stack + 17300;
 Libint->vrr_classes[7][10] = int_stack + 19280;
 Libint->vrr_classes[7][11] = int_stack + 21656;
 Libint->vrr_classes[7][12] = int_stack + 24464;
 Libint->vrr_classes[7][13] = int_stack + 27740;
 Libint->vrr_classes[7][14] = int_stack + 31520;
 memset(int_stack,0,35840*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 35840;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ipli(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+35840,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+39620,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+44240,int_stack+39620,int_stack+35840,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+51800,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+57344,int_stack+51800,int_stack+39620,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+66584,int_stack+57344,int_stack+44240,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+35840,int_stack+6832,int_stack+4648,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+79184,int_stack+35840,int_stack+51800,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+90272,int_stack+79184,int_stack+57344,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+42392,int_stack+90272,int_stack+66584,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+61292,int_stack+9380,int_stack+6832,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+105672,int_stack+61292,int_stack+35840,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+118776,int_stack+105672,int_stack+79184,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+137256,int_stack+118776,int_stack+90272,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+68936,int_stack+137256,int_stack+42392,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+35840,int_stack+12320,int_stack+9380,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+44660,int_stack+35840,int_stack+61292,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+160356,int_stack+44660,int_stack+105672,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+35840,int_stack+160356,int_stack+118776,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+95396,int_stack+35840,int_stack+137256,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+127736,int_stack+95396,int_stack+68936,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+35840,int_stack+17300,int_stack+15680,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+40700,int_stack+19280,int_stack+17300,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+46640,int_stack+40700,int_stack+35840,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+56360,int_stack+21656,int_stack+19280,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+63488,int_stack+56360,int_stack+40700,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+75368,int_stack+63488,int_stack+46640,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+35840,int_stack+24464,int_stack+21656,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+91568,int_stack+35840,int_stack+56360,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+105824,int_stack+91568,int_stack+63488,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+44264,int_stack+105824,int_stack+75368,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+68564,int_stack+27740,int_stack+24464,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+163016,int_stack+68564,int_stack+35840,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+163016,int_stack+91568,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+179864,int_stack+0,int_stack+105824,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+78392,int_stack+179864,int_stack+44264,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+35840,int_stack+31520,int_stack+27740,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+47180,int_stack+35840,int_stack+68564,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+209564,int_stack+47180,int_stack+163016,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+23760,int_stack+209564,int_stack+0,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+209564,int_stack+23760,int_stack+179864,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+209564,int_stack+78392,36);
 /*--- compute (ip|li) ---*/
 hrr1_build_ip(Libint->AB,int_stack+163016,int_stack+0,int_stack+127736,1260);
 return int_stack+163016;}
