/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ipll(Libint_t*, prim_data*);

  /* Computes quartets of (ip|ll) integrals */

REALTYPE *hrr_order_ipll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[6][12] = int_stack + 6832;
 Libint->vrr_classes[6][13] = int_stack + 9380;
 Libint->vrr_classes[6][14] = int_stack + 12320;
 Libint->vrr_classes[6][15] = int_stack + 15680;
 Libint->vrr_classes[6][16] = int_stack + 19488;
 Libint->vrr_classes[7][8] = int_stack + 23772;
 Libint->vrr_classes[7][9] = int_stack + 25392;
 Libint->vrr_classes[7][10] = int_stack + 27372;
 Libint->vrr_classes[7][11] = int_stack + 29748;
 Libint->vrr_classes[7][12] = int_stack + 32556;
 Libint->vrr_classes[7][13] = int_stack + 35832;
 Libint->vrr_classes[7][14] = int_stack + 39612;
 Libint->vrr_classes[7][15] = int_stack + 43932;
 Libint->vrr_classes[7][16] = int_stack + 48828;
 memset(int_stack,0,54336*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 54336;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ipll(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+54336,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+58116,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+62736,int_stack+58116,int_stack+54336,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+70296,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+75840,int_stack+70296,int_stack+58116,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+85080,int_stack+75840,int_stack+62736,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54336,int_stack+6832,int_stack+4648,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+97680,int_stack+54336,int_stack+70296,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+108768,int_stack+97680,int_stack+75840,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+60888,int_stack+108768,int_stack+85080,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+79788,int_stack+9380,int_stack+6832,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+124168,int_stack+79788,int_stack+54336,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+137272,int_stack+124168,int_stack+97680,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+155752,int_stack+137272,int_stack+108768,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+87432,int_stack+155752,int_stack+60888,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+54336,int_stack+12320,int_stack+9380,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+63156,int_stack+54336,int_stack+79788,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+178852,int_stack+63156,int_stack+124168,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+200692,int_stack+178852,int_stack+137272,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+113892,int_stack+200692,int_stack+155752,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+228412,int_stack+113892,int_stack+87432,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+78444,int_stack+15680,int_stack+12320,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+88524,int_stack+78444,int_stack+54336,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+146232,int_stack+88524,int_stack+63156,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+263692,int_stack+146232,int_stack+178852,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+296452,int_stack+263692,int_stack+200692,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+171712,int_stack+296452,int_stack+113892,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+335260,int_stack+171712,int_stack+228412,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+54336,int_stack+19488,int_stack+15680,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+106164,int_stack+54336,int_stack+78444,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+54336,int_stack+106164,int_stack+88524,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+83736,int_stack+54336,int_stack+146232,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+121956,int_stack+83736,int_stack+263692,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+54336,int_stack+121956,int_stack+296452,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+106080,int_stack+54336,int_stack+171712,28);
 /*--- compute (i0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+161520,int_stack+106080,int_stack+335260,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+54336,int_stack+25392,int_stack+23772,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+59196,int_stack+27372,int_stack+25392,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+65136,int_stack+59196,int_stack+54336,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+74856,int_stack+29748,int_stack+27372,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+81984,int_stack+74856,int_stack+59196,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+93864,int_stack+81984,int_stack+65136,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54336,int_stack+32556,int_stack+29748,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+110064,int_stack+54336,int_stack+74856,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+124320,int_stack+110064,int_stack+81984,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+62760,int_stack+124320,int_stack+93864,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+87060,int_stack+35832,int_stack+32556,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+144120,int_stack+87060,int_stack+54336,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+218220,int_stack+144120,int_stack+110064,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+241980,int_stack+218220,int_stack+124320,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+96888,int_stack+241980,int_stack+62760,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+54336,int_stack+39612,int_stack+35832,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+65676,int_stack+54336,int_stack+87060,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+271680,int_stack+65676,int_stack+144120,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+299760,int_stack+271680,int_stack+218220,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+335400,int_stack+299760,int_stack+241980,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+218220,int_stack+335400,int_stack+96888,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+85332,int_stack+43932,int_stack+39612,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+98292,int_stack+85332,int_stack+54336,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+120972,int_stack+98292,int_stack+65676,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+120972,int_stack+271680,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+376980,int_stack+0,int_stack+299760,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+263580,int_stack+376980,int_stack+335400,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+426876,int_stack+263580,int_stack+218220,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+218220,int_stack+48828,int_stack+43932,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+232908,int_stack+218220,int_stack+85332,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+319020,int_stack+232908,int_stack+98292,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+42120,int_stack+319020,int_stack+120972,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+91260,int_stack+42120,int_stack+0,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+91260,int_stack+376980,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+66528,int_stack+0,int_stack+263580,36);
 /*--- compute (k0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+218220,int_stack+66528,int_stack+426876,36);
 /*--- compute (ip|ll) ---*/
 hrr1_build_ip(Libint->AB,int_stack+291120,int_stack+218220,int_stack+161520,2025);
 return int_stack+291120;}
