/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ipnm(Libint_t*, prim_data*);

  /* Computes quartets of (ip|nm) integrals */

REALTYPE *hrr_order_ipnm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[6][12] = int_stack + 4032;
 Libint->vrr_classes[6][13] = int_stack + 6580;
 Libint->vrr_classes[6][14] = int_stack + 9520;
 Libint->vrr_classes[6][15] = int_stack + 12880;
 Libint->vrr_classes[6][16] = int_stack + 16688;
 Libint->vrr_classes[6][17] = int_stack + 20972;
 Libint->vrr_classes[6][18] = int_stack + 25760;
 Libint->vrr_classes[6][19] = int_stack + 31080;
 Libint->vrr_classes[7][10] = int_stack + 36960;
 Libint->vrr_classes[7][11] = int_stack + 39336;
 Libint->vrr_classes[7][12] = int_stack + 42144;
 Libint->vrr_classes[7][13] = int_stack + 45420;
 Libint->vrr_classes[7][14] = int_stack + 49200;
 Libint->vrr_classes[7][15] = int_stack + 53520;
 Libint->vrr_classes[7][16] = int_stack + 58416;
 Libint->vrr_classes[7][17] = int_stack + 63924;
 Libint->vrr_classes[7][18] = int_stack + 70080;
 Libint->vrr_classes[7][19] = int_stack + 76920;
 memset(int_stack,0,84480*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 84480;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ipnm(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+84480,int_stack+1848,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+90024,int_stack+4032,int_stack+1848,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+96576,int_stack+90024,int_stack+84480,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+107664,int_stack+6580,int_stack+4032,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115308,int_stack+107664,int_stack+90024,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+128412,int_stack+115308,int_stack+96576,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+84480,int_stack+9520,int_stack+6580,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+146892,int_stack+84480,int_stack+107664,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+93300,int_stack+146892,int_stack+115308,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+162180,int_stack+93300,int_stack+128412,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+115140,int_stack+12880,int_stack+9520,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+125220,int_stack+115140,int_stack+84480,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+189900,int_stack+125220,int_stack+146892,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+215380,int_stack+189900,int_stack+93300,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+248140,int_stack+215380,int_stack+162180,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+84480,int_stack+16688,int_stack+12880,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+142860,int_stack+84480,int_stack+115140,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+286948,int_stack+142860,int_stack+125220,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+95904,int_stack+286948,int_stack+189900,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+163020,int_stack+95904,int_stack+215380,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+316348,int_stack+163020,int_stack+248140,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+208884,int_stack+20972,int_stack+16688,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+221736,int_stack+208884,int_stack+84480,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+244584,int_stack+221736,int_stack+142860,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+368092,int_stack+244584,int_stack+286948,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+412192,int_stack+368092,int_stack+95904,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+84480,int_stack+412192,int_stack+163020,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+465700,int_stack+84480,int_stack+316348,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+145632,int_stack+25760,int_stack+20972,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+159996,int_stack+145632,int_stack+208884,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+278184,int_stack+159996,int_stack+221736,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+185700,int_stack+278184,int_stack+244584,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+532228,int_stack+185700,int_stack+368092,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+316264,int_stack+532228,int_stack+412192,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+593968,int_stack+316264,int_stack+84480,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+672592,int_stack+593968,int_stack+465700,28);
 /*--- compute (i0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+84480,int_stack+31080,int_stack+25760,28);
 /*--- compute (i0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+100440,int_stack+84480,int_stack+145632,28);
 /*--- compute (i0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+387608,int_stack+100440,int_stack+159996,28);
 /*--- compute (i0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+84480,int_stack+387608,int_stack+278184,28);
 /*--- compute (i0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+387608,int_stack+84480,int_stack+185700,28);
 /*--- compute (i0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+84480,int_stack+387608,int_stack+532228,28);
 /*--- compute (i0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+387608,int_stack+84480,int_stack+316264,28);
 /*--- compute (i0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+84480,int_stack+387608,int_stack+593968,28);
 /*--- compute (i0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+182760,int_stack+84480,int_stack+672592,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+84480,int_stack+39336,int_stack+36960,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+91608,int_stack+42144,int_stack+39336,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+100032,int_stack+91608,int_stack+84480,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+114288,int_stack+45420,int_stack+42144,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+124116,int_stack+114288,int_stack+91608,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+140964,int_stack+124116,int_stack+100032,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+84480,int_stack+49200,int_stack+45420,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+284400,int_stack+84480,int_stack+114288,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+95820,int_stack+284400,int_stack+124116,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+304056,int_stack+95820,int_stack+140964,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+123900,int_stack+53520,int_stack+49200,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+136860,int_stack+123900,int_stack+84480,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+339696,int_stack+136860,int_stack+284400,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+372456,int_stack+339696,int_stack+95820,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+414576,int_stack+372456,int_stack+304056,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+284400,int_stack+58416,int_stack+53520,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+299088,int_stack+284400,int_stack+123900,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+84480,int_stack+299088,int_stack+136860,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+122280,int_stack+84480,int_stack+339696,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+464472,int_stack+122280,int_stack+372456,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+325008,int_stack+464472,int_stack+414576,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+391536,int_stack+63924,int_stack+58416,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+408060,int_stack+391536,int_stack+284400,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+523440,int_stack+408060,int_stack+299088,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+566640,int_stack+523440,int_stack+84480,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+623340,int_stack+566640,int_stack+122280,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+84480,int_stack+623340,int_stack+464472,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+437436,int_stack+84480,int_stack+325008,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+163104,int_stack+70080,int_stack+63924,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+284400,int_stack+163104,int_stack+391536,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+317448,int_stack+284400,int_stack+408060,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+366408,int_stack+317448,int_stack+523440,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+692136,int_stack+366408,int_stack+566640,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+522972,int_stack+692136,int_stack+623340,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+771516,int_stack+522972,int_stack+84480,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+872604,int_stack+771516,int_stack+437436,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+84480,int_stack+76920,int_stack+70080,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+105000,int_stack+84480,int_stack+163104,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+431208,int_stack+105000,int_stack+284400,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+614700,int_stack+431208,int_stack+317448,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+431208,int_stack+614700,int_stack+366408,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+284400,int_stack+431208,int_stack+692136,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+614700,int_stack+284400,int_stack+522972,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+284400,int_stack+614700,int_stack+771516,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+410760,int_stack+284400,int_stack+872604,36);
 /*--- compute (ip|nm) ---*/
 hrr1_build_ip(Libint->AB,int_stack+541440,int_stack+410760,int_stack+182760,3630);
 return int_stack+541440;}
