/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_k0ii(Libint_t*, prim_data*);

  /* Computes quartets of (k0|ii) integrals */

REALTYPE *hrr_order_k0ii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][6] = int_stack + 0;
 Libint->vrr_classes[7][7] = int_stack + 1008;
 Libint->vrr_classes[7][8] = int_stack + 2304;
 Libint->vrr_classes[7][9] = int_stack + 3924;
 Libint->vrr_classes[7][10] = int_stack + 5904;
 Libint->vrr_classes[7][11] = int_stack + 8280;
 Libint->vrr_classes[7][12] = int_stack + 11088;
 memset(int_stack,0,14364*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 14364;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_k0ii(Libint, Data);
   Data++;
 }
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+14364,int_stack+1008,int_stack+0,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+17388,int_stack+2304,int_stack+1008,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+21276,int_stack+17388,int_stack+14364,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+27324,int_stack+3924,int_stack+2304,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+32184,int_stack+27324,int_stack+17388,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+39960,int_stack+32184,int_stack+21276,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14364,int_stack+5904,int_stack+3924,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+50040,int_stack+14364,int_stack+27324,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+59760,int_stack+50040,int_stack+32184,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+20304,int_stack+59760,int_stack+39960,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+35424,int_stack+8280,int_stack+5904,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+72720,int_stack+35424,int_stack+14364,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+84600,int_stack+72720,int_stack+50040,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+100800,int_stack+84600,int_stack+59760,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+42552,int_stack+100800,int_stack+20304,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+14364,int_stack+11088,int_stack+8280,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+14364,int_stack+35424,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+14256,int_stack+0,int_stack+72720,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+120240,int_stack+14256,int_stack+84600,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+120240,int_stack+100800,36);
 /*--- compute (k0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+63720,int_stack+0,int_stack+42552,36);
 return int_stack+63720;}
