/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_k0nm(Libint_t*, prim_data*);

  /* Computes quartets of (k0|nm) integrals */

REALTYPE *hrr_order_k0nm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[7][17] = int_stack + 26964;
 Libint->vrr_classes[7][18] = int_stack + 33120;
 Libint->vrr_classes[7][19] = int_stack + 39960;
 memset(int_stack,0,47520*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 47520;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_k0nm(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47520,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54648,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+63072,int_stack+54648,int_stack+47520,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+77328,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+87156,int_stack+77328,int_stack+54648,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+104004,int_stack+87156,int_stack+63072,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+47520,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+127764,int_stack+47520,int_stack+77328,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+58860,int_stack+127764,int_stack+87156,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+147420,int_stack+58860,int_stack+104004,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+86940,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+99900,int_stack+86940,int_stack+47520,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+183060,int_stack+99900,int_stack+127764,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+215820,int_stack+183060,int_stack+58860,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+257940,int_stack+215820,int_stack+147420,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+47520,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+122580,int_stack+47520,int_stack+86940,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+307836,int_stack+122580,int_stack+99900,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+62208,int_stack+307836,int_stack+183060,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+148500,int_stack+62208,int_stack+215820,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+345636,int_stack+148500,int_stack+257940,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+207468,int_stack+26964,int_stack+21456,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+223992,int_stack+207468,int_stack+47520,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+253368,int_stack+223992,int_stack+122580,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+412164,int_stack+253368,int_stack+307836,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+468864,int_stack+412164,int_stack+62208,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+47520,int_stack+468864,int_stack+148500,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+537660,int_stack+47520,int_stack+345636,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+126144,int_stack+33120,int_stack+26964,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+144612,int_stack+126144,int_stack+207468,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+296568,int_stack+144612,int_stack+223992,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+177660,int_stack+296568,int_stack+253368,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+623196,int_stack+177660,int_stack+412164,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+345528,int_stack+623196,int_stack+468864,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+702576,int_stack+345528,int_stack+47520,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+803664,int_stack+702576,int_stack+537660,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+47520,int_stack+39960,int_stack+33120,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+68040,int_stack+47520,int_stack+126144,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+437256,int_stack+68040,int_stack+144612,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+492336,int_stack+437256,int_stack+296568,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+242460,int_stack+492336,int_stack+177660,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+437256,int_stack+242460,int_stack+623196,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+543096,int_stack+437256,int_stack+345528,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+543096,int_stack+702576,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+126360,int_stack+0,int_stack+803664,36);
 return int_stack+126360;}
