/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kfmg(Libint_t*, prim_data*);

  /* Computes quartets of (kf|mg) integrals */

REALTYPE *hrr_order_kfmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[8][9] = int_stack + 14220;
 Libint->vrr_classes[8][10] = int_stack + 16695;
 Libint->vrr_classes[8][11] = int_stack + 19665;
 Libint->vrr_classes[8][12] = int_stack + 23175;
 Libint->vrr_classes[8][13] = int_stack + 27270;
 Libint->vrr_classes[9][9] = int_stack + 31995;
 Libint->vrr_classes[9][10] = int_stack + 35020;
 Libint->vrr_classes[9][11] = int_stack + 38650;
 Libint->vrr_classes[9][12] = int_stack + 42940;
 Libint->vrr_classes[9][13] = int_stack + 47945;
 Libint->vrr_classes[10][9] = int_stack + 53720;
 Libint->vrr_classes[10][10] = int_stack + 57350;
 Libint->vrr_classes[10][11] = int_stack + 61706;
 Libint->vrr_classes[10][12] = int_stack + 66854;
 Libint->vrr_classes[10][13] = int_stack + 72860;
 memset(int_stack,0,79790*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 79790;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kfmg(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+79790,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85730,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+92858,int_stack+85730,int_stack+79790,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+104738,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+113162,int_stack+104738,int_stack+85730,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+127418,int_stack+113162,int_stack+92858,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+79790,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+147218,int_stack+79790,int_stack+104738,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+79790,int_stack+147218,int_stack+113162,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+147218,int_stack+79790,int_stack+127418,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+79790,int_stack+16695,int_stack+14220,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+87215,int_stack+19665,int_stack+16695,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+96125,int_stack+87215,int_stack+79790,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+110975,int_stack+23175,int_stack+19665,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+121505,int_stack+110975,int_stack+87215,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+176918,int_stack+121505,int_stack+96125,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+79790,int_stack+27270,int_stack+23175,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+79790,int_stack+110975,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+79790,int_stack+0,int_stack+121505,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+109490,int_stack+79790,int_stack+176918,45);
 /*--- compute (kp|mg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+176918,int_stack+109490,int_stack+147218,825);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+79790,int_stack+35020,int_stack+31995,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+88865,int_stack+38650,int_stack+35020,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+88865,int_stack+79790,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18150,int_stack+42940,int_stack+38650,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+146615,int_stack+18150,int_stack+88865,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+266018,int_stack+146615,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+47945,int_stack+42940,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+79790,int_stack+0,int_stack+18150,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+79790,int_stack+146615,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+296268,int_stack+0,int_stack+266018,55);
 /*--- compute (lp|mg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+341643,int_stack+296268,int_stack+109490,825);
 /*--- compute (kd|mg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+453018,int_stack+341643,int_stack+176918,825);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+57350,int_stack+53720,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10890,int_stack+61706,int_stack+57350,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23958,int_stack+10890,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+45738,int_stack+66854,int_stack+61706,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+79790,int_stack+45738,int_stack+10890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+105926,int_stack+79790,int_stack+23958,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+72860,int_stack+66854,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+142226,int_stack+0,int_stack+45738,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+142226,int_stack+79790,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+142226,int_stack+0,int_stack+105926,66);
 /*--- compute (mp|mg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+0,int_stack+142226,int_stack+296268,825);
 /*--- compute (ld|mg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+631218,int_stack+0,int_stack+341643,825);
 /*--- compute (kf|mg) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+631218,int_stack+453018,825);
 return int_stack+0;}
