/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_khmk(Libint_t*, prim_data*);

  /* Computes quartets of (kh|mk) integrals */

REALTYPE *hrr_order_khmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[7][14] = int_stack + 14220;
 Libint->vrr_classes[7][15] = int_stack + 18540;
 Libint->vrr_classes[7][16] = int_stack + 23436;
 Libint->vrr_classes[8][9] = int_stack + 28944;
 Libint->vrr_classes[8][10] = int_stack + 31419;
 Libint->vrr_classes[8][11] = int_stack + 34389;
 Libint->vrr_classes[8][12] = int_stack + 37899;
 Libint->vrr_classes[8][13] = int_stack + 41994;
 Libint->vrr_classes[8][14] = int_stack + 46719;
 Libint->vrr_classes[8][15] = int_stack + 52119;
 Libint->vrr_classes[8][16] = int_stack + 58239;
 Libint->vrr_classes[9][9] = int_stack + 65124;
 Libint->vrr_classes[9][10] = int_stack + 68149;
 Libint->vrr_classes[9][11] = int_stack + 71779;
 Libint->vrr_classes[9][12] = int_stack + 76069;
 Libint->vrr_classes[9][13] = int_stack + 81074;
 Libint->vrr_classes[9][14] = int_stack + 86849;
 Libint->vrr_classes[9][15] = int_stack + 93449;
 Libint->vrr_classes[9][16] = int_stack + 100929;
 Libint->vrr_classes[10][9] = int_stack + 109344;
 Libint->vrr_classes[10][10] = int_stack + 112974;
 Libint->vrr_classes[10][11] = int_stack + 117330;
 Libint->vrr_classes[10][12] = int_stack + 122478;
 Libint->vrr_classes[10][13] = int_stack + 128484;
 Libint->vrr_classes[10][14] = int_stack + 135414;
 Libint->vrr_classes[10][15] = int_stack + 143334;
 Libint->vrr_classes[10][16] = int_stack + 152310;
 Libint->vrr_classes[11][9] = int_stack + 162408;
 Libint->vrr_classes[11][10] = int_stack + 166698;
 Libint->vrr_classes[11][11] = int_stack + 171846;
 Libint->vrr_classes[11][12] = int_stack + 177930;
 Libint->vrr_classes[11][13] = int_stack + 185028;
 Libint->vrr_classes[11][14] = int_stack + 193218;
 Libint->vrr_classes[11][15] = int_stack + 202578;
 Libint->vrr_classes[11][16] = int_stack + 213186;
 Libint->vrr_classes[12][9] = int_stack + 225120;
 Libint->vrr_classes[12][10] = int_stack + 230125;
 Libint->vrr_classes[12][11] = int_stack + 236131;
 Libint->vrr_classes[12][12] = int_stack + 243229;
 Libint->vrr_classes[12][13] = int_stack + 251510;
 Libint->vrr_classes[12][14] = int_stack + 261065;
 Libint->vrr_classes[12][15] = int_stack + 271985;
 Libint->vrr_classes[12][16] = int_stack + 284361;
 memset(int_stack,0,298284*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 298284;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_khmk(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+298284,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+304224,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+311352,int_stack+304224,int_stack+298284,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+323232,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+331656,int_stack+323232,int_stack+304224,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+345912,int_stack+331656,int_stack+311352,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+298284,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+365712,int_stack+298284,int_stack+323232,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+382560,int_stack+365712,int_stack+331656,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+308112,int_stack+382560,int_stack+345912,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+337812,int_stack+14220,int_stack+10440,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+406320,int_stack+337812,int_stack+298284,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+425976,int_stack+406320,int_stack+365712,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+454056,int_stack+425976,int_stack+382560,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+349152,int_stack+454056,int_stack+308112,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+298284,int_stack+18540,int_stack+14220,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+311244,int_stack+298284,int_stack+337812,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+489696,int_stack+311244,int_stack+406320,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+522456,int_stack+489696,int_stack+425976,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+390732,int_stack+522456,int_stack+454056,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+564576,int_stack+390732,int_stack+349152,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+333924,int_stack+23436,int_stack+18540,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+348612,int_stack+333924,int_stack+298284,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+440628,int_stack+348612,int_stack+311244,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+298284,int_stack+440628,int_stack+489696,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+440628,int_stack+298284,int_stack+522456,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+298284,int_stack+440628,int_stack+390732,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+364812,int_stack+298284,int_stack+564576,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+298284,int_stack+31419,int_stack+28944,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+305709,int_stack+34389,int_stack+31419,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+314619,int_stack+305709,int_stack+298284,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+329469,int_stack+37899,int_stack+34389,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+339999,int_stack+329469,int_stack+305709,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+436092,int_stack+339999,int_stack+314619,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+298284,int_stack+41994,int_stack+37899,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+460842,int_stack+298284,int_stack+329469,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+481902,int_stack+460842,int_stack+339999,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+310569,int_stack+481902,int_stack+436092,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+436092,int_stack+46719,int_stack+41994,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+511602,int_stack+436092,int_stack+298284,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+536172,int_stack+511602,int_stack+460842,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+571272,int_stack+536172,int_stack+481902,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+450267,int_stack+571272,int_stack+310569,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+298284,int_stack+52119,int_stack+46719,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+314484,int_stack+298284,int_stack+436092,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+314484,int_stack+511602,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+615822,int_stack+0,int_stack+536172,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+502242,int_stack+615822,int_stack+571272,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+668472,int_stack+502242,int_stack+450267,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+436092,int_stack+58239,int_stack+52119,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+454452,int_stack+436092,int_stack+298284,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+564612,int_stack+454452,int_stack+314484,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+298284,int_stack+564612,int_stack+0,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+737772,int_stack+298284,int_stack+615822,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+564612,int_stack+737772,int_stack+502242,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+436092,int_stack+564612,int_stack+668472,45);
 /*--- compute (kp|mk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+525192,int_stack+436092,int_stack+364812,1980);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+298284,int_stack+68149,int_stack+65124,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+307359,int_stack+71779,int_stack+68149,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+318249,int_stack+307359,int_stack+298284,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+336399,int_stack+76069,int_stack+71779,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+349269,int_stack+336399,int_stack+307359,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+371049,int_stack+349269,int_stack+318249,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+298284,int_stack+81074,int_stack+76069,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+401299,int_stack+298284,int_stack+336399,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+401299,int_stack+349269,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+313299,int_stack+0,int_stack+371049,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+358674,int_stack+86849,int_stack+81074,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+36300,int_stack+358674,int_stack+298284,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+739032,int_stack+36300,int_stack+401299,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+375999,int_stack+739032,int_stack+0,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+781932,int_stack+375999,int_stack+313299,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+93449,int_stack+86849,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+298284,int_stack+0,int_stack+358674,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+845457,int_stack+298284,int_stack+36300,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+19800,int_stack+845457,int_stack+739032,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+895507,int_stack+19800,int_stack+375999,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+332934,int_stack+895507,int_stack+781932,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+739032,int_stack+100929,int_stack+93449,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+761472,int_stack+739032,int_stack+0,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+971737,int_stack+761472,int_stack+298284,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+739032,int_stack+971737,int_stack+845457,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+971737,int_stack+739032,int_stack+19800,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+739032,int_stack+971737,int_stack+895507,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+840672,int_stack+739032,int_stack+332934,55);
 /*--- compute (lp|mk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+949572,int_stack+840672,int_stack+436092,1980);
 /*--- compute (kd|mk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1216872,int_stack+949572,int_stack+525192,1980);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+298284,int_stack+112974,int_stack+109344,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+309174,int_stack+117330,int_stack+112974,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+322242,int_stack+309174,int_stack+298284,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+344022,int_stack+122478,int_stack+117330,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+359466,int_stack+344022,int_stack+309174,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+385602,int_stack+359466,int_stack+322242,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+298284,int_stack+128484,int_stack+122478,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+421902,int_stack+298284,int_stack+344022,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+452790,int_stack+421902,int_stack+359466,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+316302,int_stack+452790,int_stack+385602,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+370752,int_stack+135414,int_stack+128484,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+496350,int_stack+370752,int_stack+298284,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+532386,int_stack+496350,int_stack+421902,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+583866,int_stack+532386,int_stack+452790,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+391542,int_stack+583866,int_stack+316302,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+298284,int_stack+143334,int_stack+135414,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+322044,int_stack+298284,int_stack+370752,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+649206,int_stack+322044,int_stack+496350,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+709266,int_stack+649206,int_stack+532386,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+467772,int_stack+709266,int_stack+583866,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+467772,int_stack+391542,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+363624,int_stack+152310,int_stack+143334,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+390552,int_stack+363624,int_stack+298284,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+559248,int_stack+390552,int_stack+322044,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+298284,int_stack+559248,int_stack+649206,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+559248,int_stack+298284,int_stack+709266,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+298284,int_stack+559248,int_stack+467772,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+420252,int_stack+298284,int_stack+0,66);
 /*--- compute (mp|mk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1644552,int_stack+420252,int_stack+840672,1980);
 /*--- compute (ld|mk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1971252,int_stack+1644552,int_stack+949572,1980);
 /*--- compute (kf|mk) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2505852,int_stack+1971252,int_stack+1216872,1980);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+166698,int_stack+162408,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+171846,int_stack+166698,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54054,int_stack+177930,int_stack+171846,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+72306,int_stack+54054,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+103194,int_stack+72306,int_stack+28314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+185028,int_stack+177930,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+146094,int_stack+0,int_stack+54054,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+298284,int_stack+146094,int_stack+72306,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+21294,int_stack+298284,int_stack+103194,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+85644,int_stack+193218,int_stack+185028,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+349764,int_stack+85644,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+550932,int_stack+349764,int_stack+146094,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+110214,int_stack+550932,int_stack+298284,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+611772,int_stack+110214,int_stack+21294,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+298284,int_stack+202578,int_stack+193218,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+298284,int_stack+85644,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+701862,int_stack+0,int_stack+349764,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+326364,int_stack+701862,int_stack+550932,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+772842,int_stack+326364,int_stack+110214,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+49140,int_stack+772842,int_stack+611772,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+550932,int_stack+213186,int_stack+202578,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+582756,int_stack+550932,int_stack+298284,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+880950,int_stack+582756,int_stack+0,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+550932,int_stack+880950,int_stack+701862,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+880950,int_stack+550932,int_stack+326364,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+550932,int_stack+880950,int_stack+772842,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+695076,int_stack+550932,int_stack+49140,78);
 /*--- compute (np|mk) ---*/
 hrr1_build_np(Libint->AB,int_stack+849516,int_stack+695076,int_stack+420252,1980);
 /*--- compute (md|mk) ---*/
 hrr1_build_md(Libint->AB,int_stack+3218652,int_stack+849516,int_stack+1644552,1980);
 /*--- compute (lf|mk) ---*/
 hrr1_build_lf(Libint->AB,int_stack+3872052,int_stack+3218652,int_stack+1971252,1980);
 /*--- compute (kg|mk) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1241556,int_stack+3872052,int_stack+2505852,1980);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2310756,int_stack+230125,int_stack+225120,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2325771,int_stack+236131,int_stack+230125,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2343789,int_stack+2325771,int_stack+2310756,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2373819,int_stack+243229,int_stack+236131,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2395113,int_stack+2373819,int_stack+2325771,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2431149,int_stack+2395113,int_stack+2343789,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2310756,int_stack+251510,int_stack+243229,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2481199,int_stack+2310756,int_stack+2373819,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2523787,int_stack+2481199,int_stack+2395113,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2335599,int_stack+2523787,int_stack+2431149,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2410674,int_stack+261065,int_stack+251510,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2583847,int_stack+2410674,int_stack+2310756,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2633533,int_stack+2583847,int_stack+2481199,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2704513,int_stack+2633533,int_stack+2523787,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2439339,int_stack+2704513,int_stack+2335599,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2310756,int_stack+271985,int_stack+261065,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2343516,int_stack+2310756,int_stack+2410674,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2794603,int_stack+2343516,int_stack+2583847,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2877413,int_stack+2794603,int_stack+2633533,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2544444,int_stack+2877413,int_stack+2704513,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2983883,int_stack+2544444,int_stack+2439339,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2400846,int_stack+284361,int_stack+271985,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2437974,int_stack+2400846,int_stack+2310756,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2670570,int_stack+2437974,int_stack+2343516,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2310756,int_stack+2670570,int_stack+2794603,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2670570,int_stack+2310756,int_stack+2877413,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2310756,int_stack+2670570,int_stack+2544444,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2478924,int_stack+2310756,int_stack+2983883,91);
 /*--- compute (op|mk) ---*/
 hrr1_build_op(Libint->AB,int_stack+2659104,int_stack+2478924,int_stack+695076,1980);
 /*--- compute (nd|mk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+0,int_stack+2659104,int_stack+849516,1980);
 /*--- compute (mf|mk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+4763052,int_stack+0,int_stack+3218652,1980);
 /*--- compute (lg|mk) ---*/
 hrr1_build_lg(Libint->AB,int_stack+2310756,int_stack+4763052,int_stack+3872052,1980);
 /*--- compute (kh|mk) ---*/
 hrr1_build_kh(Libint->AB,int_stack+3647256,int_stack+2310756,int_stack+1241556,1980);
 return int_stack+3647256;}
