/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kikk(Libint_t*, prim_data*);

  /* Computes quartets of (ki|kk) integrals */

REALTYPE *hrr_order_kikk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][7] = int_stack + 0;
 Libint->vrr_classes[7][8] = int_stack + 1296;
 Libint->vrr_classes[7][9] = int_stack + 2916;
 Libint->vrr_classes[7][10] = int_stack + 4896;
 Libint->vrr_classes[7][11] = int_stack + 7272;
 Libint->vrr_classes[7][12] = int_stack + 10080;
 Libint->vrr_classes[7][13] = int_stack + 13356;
 Libint->vrr_classes[7][14] = int_stack + 17136;
 Libint->vrr_classes[8][7] = int_stack + 21456;
 Libint->vrr_classes[8][8] = int_stack + 23076;
 Libint->vrr_classes[8][9] = int_stack + 25101;
 Libint->vrr_classes[8][10] = int_stack + 27576;
 Libint->vrr_classes[8][11] = int_stack + 30546;
 Libint->vrr_classes[8][12] = int_stack + 34056;
 Libint->vrr_classes[8][13] = int_stack + 38151;
 Libint->vrr_classes[8][14] = int_stack + 42876;
 Libint->vrr_classes[9][7] = int_stack + 48276;
 Libint->vrr_classes[9][8] = int_stack + 50256;
 Libint->vrr_classes[9][9] = int_stack + 52731;
 Libint->vrr_classes[9][10] = int_stack + 55756;
 Libint->vrr_classes[9][11] = int_stack + 59386;
 Libint->vrr_classes[9][12] = int_stack + 63676;
 Libint->vrr_classes[9][13] = int_stack + 68681;
 Libint->vrr_classes[9][14] = int_stack + 74456;
 Libint->vrr_classes[10][7] = int_stack + 81056;
 Libint->vrr_classes[10][8] = int_stack + 83432;
 Libint->vrr_classes[10][9] = int_stack + 86402;
 Libint->vrr_classes[10][10] = int_stack + 90032;
 Libint->vrr_classes[10][11] = int_stack + 94388;
 Libint->vrr_classes[10][12] = int_stack + 99536;
 Libint->vrr_classes[10][13] = int_stack + 105542;
 Libint->vrr_classes[10][14] = int_stack + 112472;
 Libint->vrr_classes[11][7] = int_stack + 120392;
 Libint->vrr_classes[11][8] = int_stack + 123200;
 Libint->vrr_classes[11][9] = int_stack + 126710;
 Libint->vrr_classes[11][10] = int_stack + 131000;
 Libint->vrr_classes[11][11] = int_stack + 136148;
 Libint->vrr_classes[11][12] = int_stack + 142232;
 Libint->vrr_classes[11][13] = int_stack + 149330;
 Libint->vrr_classes[11][14] = int_stack + 157520;
 Libint->vrr_classes[12][7] = int_stack + 166880;
 Libint->vrr_classes[12][8] = int_stack + 170156;
 Libint->vrr_classes[12][9] = int_stack + 174251;
 Libint->vrr_classes[12][10] = int_stack + 179256;
 Libint->vrr_classes[12][11] = int_stack + 185262;
 Libint->vrr_classes[12][12] = int_stack + 192360;
 Libint->vrr_classes[12][13] = int_stack + 200641;
 Libint->vrr_classes[12][14] = int_stack + 210196;
 Libint->vrr_classes[13][7] = int_stack + 221116;
 Libint->vrr_classes[13][8] = int_stack + 224896;
 Libint->vrr_classes[13][9] = int_stack + 229621;
 Libint->vrr_classes[13][10] = int_stack + 235396;
 Libint->vrr_classes[13][11] = int_stack + 242326;
 Libint->vrr_classes[13][12] = int_stack + 250516;
 Libint->vrr_classes[13][13] = int_stack + 260071;
 Libint->vrr_classes[13][14] = int_stack + 271096;
 memset(int_stack,0,283696*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 283696;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kikk(Libint, Data);
   Data++;
 }
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+283696,int_stack+1296,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+287584,int_stack+2916,int_stack+1296,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+292444,int_stack+287584,int_stack+283696,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+300220,int_stack+4896,int_stack+2916,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+306160,int_stack+300220,int_stack+287584,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+315880,int_stack+306160,int_stack+292444,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+283696,int_stack+7272,int_stack+4896,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+328840,int_stack+283696,int_stack+300220,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+340720,int_stack+328840,int_stack+306160,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+290824,int_stack+340720,int_stack+315880,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+310264,int_stack+10080,int_stack+7272,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+356920,int_stack+310264,int_stack+283696,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+371176,int_stack+356920,int_stack+328840,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+390976,int_stack+371176,int_stack+340720,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+318688,int_stack+390976,int_stack+290824,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+283696,int_stack+13356,int_stack+10080,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+415276,int_stack+283696,int_stack+310264,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+293524,int_stack+415276,int_stack+356920,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+432124,int_stack+293524,int_stack+371176,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+345904,int_stack+432124,int_stack+390976,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+461824,int_stack+345904,int_stack+318688,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+317284,int_stack+17136,int_stack+13356,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+379924,int_stack+317284,int_stack+283696,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+317284,int_stack+379924,int_stack+415276,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+379924,int_stack+317284,int_stack+293524,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+283696,int_stack+379924,int_stack+432124,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+379924,int_stack+283696,int_stack+345904,36);
 /*--- compute (k0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+283696,int_stack+379924,int_stack+461824,36);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+330352,int_stack+23076,int_stack+21456,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+335212,int_stack+25101,int_stack+23076,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+341287,int_stack+335212,int_stack+330352,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+351007,int_stack+27576,int_stack+25101,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+358432,int_stack+351007,int_stack+335212,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+370582,int_stack+358432,int_stack+341287,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+330352,int_stack+30546,int_stack+27576,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+386782,int_stack+330352,int_stack+351007,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+401632,int_stack+386782,int_stack+358432,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+339262,int_stack+401632,int_stack+370582,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+363562,int_stack+34056,int_stack+30546,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+421882,int_stack+363562,int_stack+330352,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+439702,int_stack+421882,int_stack+386782,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+464452,int_stack+439702,int_stack+401632,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+374092,int_stack+464452,int_stack+339262,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+330352,int_stack+38151,int_stack+34056,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+330352,int_stack+363562,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+342637,int_stack+0,int_stack+421882,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+494827,int_stack+342637,int_stack+439702,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+408112,int_stack+494827,int_stack+464452,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+531952,int_stack+408112,int_stack+374092,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+372337,int_stack+42876,int_stack+38151,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+450637,int_stack+372337,int_stack+330352,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+372337,int_stack+450637,int_stack+0,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+372337,int_stack+342637,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+330352,int_stack+0,int_stack+494827,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+450637,int_stack+330352,int_stack+408112,45);
 /*--- compute (l0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+330352,int_stack+450637,int_stack+531952,45);
 /*--- compute (kp|kk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+388672,int_stack+330352,int_stack+283696,1296);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+283696,int_stack+50256,int_stack+48276,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+289636,int_stack+52731,int_stack+50256,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+297061,int_stack+289636,int_stack+283696,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+308941,int_stack+55756,int_stack+52731,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+528640,int_stack+308941,int_stack+289636,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+543490,int_stack+528640,int_stack+297061,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+283696,int_stack+59386,int_stack+55756,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+283696,int_stack+308941,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+294586,int_stack+0,int_stack+528640,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+18150,int_stack+294586,int_stack+543490,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+528640,int_stack+63676,int_stack+59386,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+541510,int_stack+528640,int_stack+283696,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+563290,int_stack+541510,int_stack+0,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+593540,int_stack+563290,int_stack+294586,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+283696,int_stack+593540,int_stack+18150,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+68681,int_stack+63676,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+15015,int_stack+0,int_stack+528640,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+630665,int_stack+15015,int_stack+541510,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+666965,int_stack+630665,int_stack+563290,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+528640,int_stack+666965,int_stack+593540,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+712340,int_stack+528640,int_stack+283696,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+283696,int_stack+74456,int_stack+68681,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+580615,int_stack+283696,int_stack+0,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+283696,int_stack+580615,int_stack+15015,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+283696,int_stack+630665,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+580615,int_stack+0,int_stack+666965,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+580615,int_stack+528640,55);
 /*--- compute (m0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+528640,int_stack+0,int_stack+712340,55);
 /*--- compute (lp|kk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+599920,int_stack+528640,int_stack+330352,1296);
 /*--- compute (kd|kk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+774880,int_stack+599920,int_stack+388672,1296);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+83432,int_stack+81056,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+7128,int_stack+86402,int_stack+83432,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+16038,int_stack+7128,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+30294,int_stack+90032,int_stack+86402,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+41184,int_stack+30294,int_stack+7128,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+59004,int_stack+41184,int_stack+16038,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+94388,int_stack+90032,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+283696,int_stack+0,int_stack+30294,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+305476,int_stack+283696,int_stack+41184,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+13068,int_stack+305476,int_stack+59004,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+48708,int_stack+99536,int_stack+94388,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+64152,int_stack+48708,int_stack+0,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+335176,int_stack+64152,int_stack+283696,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+371476,int_stack+335176,int_stack+305476,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+283696,int_stack+371476,int_stack+13068,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+105542,int_stack+99536,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+416026,int_stack+0,int_stack+48708,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+18018,int_stack+416026,int_stack+64152,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+446914,int_stack+18018,int_stack+335176,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1054816,int_stack+446914,int_stack+371476,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+333592,int_stack+1054816,int_stack+283696,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+283696,int_stack+112472,int_stack+105542,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+61578,int_stack+283696,int_stack+0,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1117186,int_stack+61578,int_stack+416026,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1168666,int_stack+1117186,int_stack+18018,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+1168666,int_stack+446914,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1117186,int_stack+0,int_stack+1054816,66);
 /*--- compute (n0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+0,int_stack+1117186,int_stack+333592,66);
 /*--- compute (mp|kk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+283696,int_stack+0,int_stack+528640,1296);
 /*--- compute (ld|kk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1054816,int_stack+283696,int_stack+599920,1296);
 /*--- compute (kf|kk) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1404736,int_stack+1054816,int_stack+774880,1296);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+85536,int_stack+123200,int_stack+120392,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+93960,int_stack+126710,int_stack+123200,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+104490,int_stack+93960,int_stack+85536,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+497536,int_stack+131000,int_stack+126710,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+510406,int_stack+497536,int_stack+93960,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+531466,int_stack+510406,int_stack+104490,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85536,int_stack+136148,int_stack+131000,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+100980,int_stack+85536,int_stack+497536,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+559546,int_stack+100980,int_stack+510406,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+594646,int_stack+559546,int_stack+531466,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+497536,int_stack+142232,int_stack+136148,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+515788,int_stack+497536,int_stack+85536,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+636766,int_stack+515788,int_stack+100980,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+85536,int_stack+636766,int_stack+559546,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+679666,int_stack+85536,int_stack+594646,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+546676,int_stack+149330,int_stack+142232,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+567970,int_stack+546676,int_stack+497536,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+738634,int_stack+567970,int_stack+515788,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+790114,int_stack+738634,int_stack+636766,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+604474,int_stack+790114,int_stack+85536,78);
 /*--- compute (o0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+854464,int_stack+604474,int_stack+679666,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+85536,int_stack+157520,int_stack+149330,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+110106,int_stack+85536,int_stack+546676,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+497536,int_stack+110106,int_stack+567970,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+85536,int_stack+497536,int_stack+738634,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+497536,int_stack+85536,int_stack+790114,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+678184,int_stack+497536,int_stack+604474,78);
 /*--- compute (o0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+497536,int_stack+678184,int_stack+854464,78);
 /*--- compute (np|kk) ---*/
 hrr1_build_np(Libint->AB,int_stack+598624,int_stack+497536,int_stack+0,1296);
 /*--- compute (md|kk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1871296,int_stack+598624,int_stack+283696,1296);
 /*--- compute (lf|kk) ---*/
 hrr1_build_lf(Libint->AB,int_stack+2298976,int_stack+1871296,int_stack+1054816,1296);
 /*--- compute (kg|kk) ---*/
 hrr1_build_kg(Libint->AB,int_stack+2882176,int_stack+2298976,int_stack+1404736,1296);
 /*--- compute (q0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+283696,int_stack+170156,int_stack+166880,91);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+293524,int_stack+174251,int_stack+170156,91);
 /*--- compute (q0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+305809,int_stack+293524,int_stack+283696,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+325465,int_stack+179256,int_stack+174251,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+340480,int_stack+325465,int_stack+293524,91);
 /*--- compute (q0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+365050,int_stack+340480,int_stack+305809,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+283696,int_stack+185262,int_stack+179256,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+397810,int_stack+283696,int_stack+325465,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+427840,int_stack+397810,int_stack+340480,91);
 /*--- compute (q0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+301714,int_stack+427840,int_stack+365050,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+350854,int_stack+192360,int_stack+185262,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+350854,int_stack+283696,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+36036,int_stack+0,int_stack+397810,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+86086,int_stack+36036,int_stack+427840,91);
 /*--- compute (q0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+372148,int_stack+86086,int_stack+301714,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+283696,int_stack+200641,int_stack+192360,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+440944,int_stack+283696,int_stack+350854,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+308539,int_stack+440944,int_stack+0,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+855232,int_stack+308539,int_stack+36036,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+855232,int_stack+86086,91);
 /*--- compute (q0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+85995,int_stack+0,int_stack+372148,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+368599,int_stack+210196,int_stack+200641,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+930307,int_stack+368599,int_stack+283696,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+368599,int_stack+930307,int_stack+440944,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+930307,int_stack+368599,int_stack+308539,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1020397,int_stack+930307,int_stack+855232,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+855232,int_stack+1020397,int_stack+0,91);
 /*--- compute (q0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+969892,int_stack+855232,int_stack+85995,91);
 /*--- compute (op|kk) ---*/
 hrr1_build_op(Libint->AB,int_stack+1087828,int_stack+969892,int_stack+497536,1296);
 /*--- compute (nd|kk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3582016,int_stack+1087828,int_stack+598624,1296);
 /*--- compute (mf|kk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+4095232,int_stack+3582016,int_stack+1871296,1296);
 /*--- compute (lg|kk) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1391092,int_stack+4095232,int_stack+2298976,1296);
 /*--- compute (kh|kk) ---*/
 hrr1_build_kh(Libint->AB,int_stack+4808032,int_stack+1391092,int_stack+2882176,1296);
 /*--- compute (r0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+224896,int_stack+221116,105);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+11340,int_stack+229621,int_stack+224896,105);
 /*--- compute (r0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+25515,int_stack+11340,int_stack+0,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+48195,int_stack+235396,int_stack+229621,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+65520,int_stack+48195,int_stack+11340,105);
 /*--- compute (r0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+93870,int_stack+65520,int_stack+25515,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+242326,int_stack+235396,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+131670,int_stack+0,int_stack+48195,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+166320,int_stack+131670,int_stack+65520,105);
 /*--- compute (r0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+20790,int_stack+166320,int_stack+93870,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+77490,int_stack+250516,int_stack+242326,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2265892,int_stack+77490,int_stack+0,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2307472,int_stack+2265892,int_stack+131670,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+2365222,int_stack+2307472,int_stack+166320,105);
 /*--- compute (r0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+102060,int_stack+2365222,int_stack+20790,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+260071,int_stack+250516,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+181440,int_stack+0,int_stack+77490,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+28665,int_stack+181440,int_stack+2265892,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2436097,int_stack+28665,int_stack+2307472,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+2265892,int_stack+2436097,int_stack+2365222,105);
 /*--- compute (r0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+2522722,int_stack+2265892,int_stack+102060,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2365117,int_stack+271096,int_stack+260071,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+97965,int_stack+2365117,int_stack+0,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+230580,int_stack+97965,int_stack+181440,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+97965,int_stack+230580,int_stack+28665,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+201915,int_stack+97965,int_stack+2436097,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+323190,int_stack+201915,int_stack+2265892,105);
 /*--- compute (r0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+2265892,int_stack+323190,int_stack+2522722,105);
 /*--- compute (qp|kk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2401972,int_stack+2265892,int_stack+969892,1296);
 /*--- compute (od|kk) ---*/
 hrr1_build_od(Libint->AB,int_stack+2755780,int_stack+2401972,int_stack+1087828,1296);
 /*--- compute (nf|kk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+2755780,int_stack+3582016,1296);
 /*--- compute (mg|kk) ---*/
 hrr1_build_mg(Libint->AB,int_stack+2265892,int_stack+0,int_stack+4095232,1296);
 /*--- compute (lh|kk) ---*/
 hrr1_build_lh(Libint->AB,int_stack+0,int_stack+2265892,int_stack+1391092,1296);
 /*--- compute (ki|kk) ---*/
 hrr1_build_ki(Libint->AB,int_stack+1224720,int_stack+0,int_stack+4808032,1296);
 return int_stack+1224720;}
