/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kknk(Libint_t*, prim_data*);

  /* Computes quartets of (kk|nk) integrals */

REALTYPE *hrr_order_kknk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[7][17] = int_stack + 26964;
 Libint->vrr_classes[8][10] = int_stack + 33120;
 Libint->vrr_classes[8][11] = int_stack + 36090;
 Libint->vrr_classes[8][12] = int_stack + 39600;
 Libint->vrr_classes[8][13] = int_stack + 43695;
 Libint->vrr_classes[8][14] = int_stack + 48420;
 Libint->vrr_classes[8][15] = int_stack + 53820;
 Libint->vrr_classes[8][16] = int_stack + 59940;
 Libint->vrr_classes[8][17] = int_stack + 66825;
 Libint->vrr_classes[9][10] = int_stack + 74520;
 Libint->vrr_classes[9][11] = int_stack + 78150;
 Libint->vrr_classes[9][12] = int_stack + 82440;
 Libint->vrr_classes[9][13] = int_stack + 87445;
 Libint->vrr_classes[9][14] = int_stack + 93220;
 Libint->vrr_classes[9][15] = int_stack + 99820;
 Libint->vrr_classes[9][16] = int_stack + 107300;
 Libint->vrr_classes[9][17] = int_stack + 115715;
 Libint->vrr_classes[10][10] = int_stack + 125120;
 Libint->vrr_classes[10][11] = int_stack + 129476;
 Libint->vrr_classes[10][12] = int_stack + 134624;
 Libint->vrr_classes[10][13] = int_stack + 140630;
 Libint->vrr_classes[10][14] = int_stack + 147560;
 Libint->vrr_classes[10][15] = int_stack + 155480;
 Libint->vrr_classes[10][16] = int_stack + 164456;
 Libint->vrr_classes[10][17] = int_stack + 174554;
 Libint->vrr_classes[11][10] = int_stack + 185840;
 Libint->vrr_classes[11][11] = int_stack + 190988;
 Libint->vrr_classes[11][12] = int_stack + 197072;
 Libint->vrr_classes[11][13] = int_stack + 204170;
 Libint->vrr_classes[11][14] = int_stack + 212360;
 Libint->vrr_classes[11][15] = int_stack + 221720;
 Libint->vrr_classes[11][16] = int_stack + 232328;
 Libint->vrr_classes[11][17] = int_stack + 244262;
 Libint->vrr_classes[12][10] = int_stack + 257600;
 Libint->vrr_classes[12][11] = int_stack + 263606;
 Libint->vrr_classes[12][12] = int_stack + 270704;
 Libint->vrr_classes[12][13] = int_stack + 278985;
 Libint->vrr_classes[12][14] = int_stack + 288540;
 Libint->vrr_classes[12][15] = int_stack + 299460;
 Libint->vrr_classes[12][16] = int_stack + 311836;
 Libint->vrr_classes[12][17] = int_stack + 325759;
 Libint->vrr_classes[13][10] = int_stack + 341320;
 Libint->vrr_classes[13][11] = int_stack + 348250;
 Libint->vrr_classes[13][12] = int_stack + 356440;
 Libint->vrr_classes[13][13] = int_stack + 365995;
 Libint->vrr_classes[13][14] = int_stack + 377020;
 Libint->vrr_classes[13][15] = int_stack + 389620;
 Libint->vrr_classes[13][16] = int_stack + 403900;
 Libint->vrr_classes[13][17] = int_stack + 419965;
 Libint->vrr_classes[14][10] = int_stack + 437920;
 Libint->vrr_classes[14][11] = int_stack + 445840;
 Libint->vrr_classes[14][12] = int_stack + 455200;
 Libint->vrr_classes[14][13] = int_stack + 466120;
 Libint->vrr_classes[14][14] = int_stack + 478720;
 Libint->vrr_classes[14][15] = int_stack + 493120;
 Libint->vrr_classes[14][16] = int_stack + 509440;
 Libint->vrr_classes[14][17] = int_stack + 527800;
 memset(int_stack,0,548320*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 548320;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kknk(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+548320,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+555448,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+563872,int_stack+555448,int_stack+548320,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+578128,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+587956,int_stack+578128,int_stack+555448,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+604804,int_stack+587956,int_stack+563872,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+548320,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+628564,int_stack+548320,int_stack+578128,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+559660,int_stack+628564,int_stack+587956,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+648220,int_stack+559660,int_stack+604804,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+587740,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+600700,int_stack+587740,int_stack+548320,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+683860,int_stack+600700,int_stack+628564,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+716620,int_stack+683860,int_stack+559660,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+758740,int_stack+716620,int_stack+648220,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+548320,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+623380,int_stack+548320,int_stack+587740,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+808636,int_stack+623380,int_stack+600700,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+563008,int_stack+808636,int_stack+683860,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+649300,int_stack+563008,int_stack+716620,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+846436,int_stack+649300,int_stack+758740,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+708268,int_stack+26964,int_stack+21456,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+724792,int_stack+708268,int_stack+548320,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+754168,int_stack+724792,int_stack+623380,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+912964,int_stack+754168,int_stack+808636,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+708268,int_stack+912964,int_stack+563008,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+548320,int_stack+708268,int_stack+649300,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+626944,int_stack+548320,int_stack+846436,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+548320,int_stack+36090,int_stack+33120,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+557230,int_stack+39600,int_stack+36090,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+567760,int_stack+557230,int_stack+548320,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+585580,int_stack+43695,int_stack+39600,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+597865,int_stack+585580,int_stack+557230,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+712480,int_stack+597865,int_stack+567760,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+548320,int_stack+48420,int_stack+43695,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+742180,int_stack+548320,int_stack+585580,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+562495,int_stack+742180,int_stack+597865,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+766750,int_stack+562495,int_stack+712480,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+712480,int_stack+53820,int_stack+48420,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+597595,int_stack+712480,int_stack+548320,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+811300,int_stack+597595,int_stack+742180,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+852250,int_stack+811300,int_stack+562495,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+904900,int_stack+852250,int_stack+766750,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+548320,int_stack+59940,int_stack+53820,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+728680,int_stack+548320,int_stack+712480,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+761080,int_stack+728680,int_stack+597595,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+967270,int_stack+761080,int_stack+811300,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1028695,int_stack+967270,int_stack+852250,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+808330,int_stack+1028695,int_stack+904900,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+566680,int_stack+66825,int_stack+59940,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+587335,int_stack+566680,int_stack+548320,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+891490,int_stack+587335,int_stack+728680,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+548320,int_stack+891490,int_stack+761080,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+712480,int_stack+548320,int_stack+967270,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+891490,int_stack+712480,int_stack+1028695,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+989770,int_stack+891490,int_stack+808330,45);
 /*--- compute (kp|nk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+712480,int_stack+989770,int_stack+626944,2376);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+969088,int_stack+78150,int_stack+74520,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+548320,int_stack+82440,int_stack+78150,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+561190,int_stack+548320,int_stack+969088,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+969088,int_stack+87445,int_stack+82440,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+582970,int_stack+969088,int_stack+548320,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+608710,int_stack+582970,int_stack+561190,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+548320,int_stack+93220,int_stack+87445,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+645010,int_stack+548320,int_stack+969088,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+645010,int_stack+582970,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1096690,int_stack+0,int_stack+608710,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+969088,int_stack+99820,int_stack+93220,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+565645,int_stack+969088,int_stack+548320,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+42900,int_stack+565645,int_stack+645010,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+600295,int_stack+42900,int_stack+0,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1151140,int_stack+600295,int_stack+1096690,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1096690,int_stack+107300,int_stack+99820,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+1096690,int_stack+969088,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1227370,int_stack+0,int_stack+565645,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1285120,int_stack+1227370,int_stack+42900,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1360195,int_stack+1285120,int_stack+600295,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+548320,int_stack+1360195,int_stack+1151140,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1119130,int_stack+115715,int_stack+107300,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1144375,int_stack+1119130,int_stack+1096690,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+39600,int_stack+1144375,int_stack+0,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1096690,int_stack+39600,int_stack+1227370,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+1096690,int_stack+1285120,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1096690,int_stack+0,int_stack+1360195,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1216810,int_stack+1096690,int_stack+548320,55);
 /*--- compute (lp|nk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1347490,int_stack+1216810,int_stack+989770,2376);
 /*--- compute (kd|nk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1668250,int_stack+1347490,int_stack+712480,2376);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+548320,int_stack+129476,int_stack+125120,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+561388,int_stack+134624,int_stack+129476,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+576832,int_stack+561388,int_stack+548320,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+602968,int_stack+140630,int_stack+134624,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+620986,int_stack+602968,int_stack+561388,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+651874,int_stack+620986,int_stack+576832,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+548320,int_stack+147560,int_stack+140630,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+695434,int_stack+548320,int_stack+602968,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+569110,int_stack+695434,int_stack+620986,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+731470,int_stack+569110,int_stack+651874,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+620590,int_stack+155480,int_stack+147560,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+644350,int_stack+620590,int_stack+548320,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+796810,int_stack+644350,int_stack+695434,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+856870,int_stack+796810,int_stack+569110,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+934090,int_stack+856870,int_stack+731470,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+548320,int_stack+164456,int_stack+155480,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+685930,int_stack+548320,int_stack+620590,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1025566,int_stack+685930,int_stack+644350,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+575248,int_stack+1025566,int_stack+796810,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+733450,int_stack+575248,int_stack+856870,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+733450,int_stack+934090,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+841558,int_stack+174554,int_stack+164456,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+871852,int_stack+841558,int_stack+548320,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+925708,int_stack+871852,int_stack+685930,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1094866,int_stack+925708,int_stack+1025566,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+841558,int_stack+1094866,int_stack+575248,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+548320,int_stack+841558,int_stack+733450,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+692464,int_stack+548320,int_stack+0,66);
 /*--- compute (mp|nk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+2181466,int_stack+692464,int_stack+1216810,2376);
 /*--- compute (ld|nk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2573506,int_stack+2181466,int_stack+1347490,2376);
 /*--- compute (kf|nk) ---*/
 hrr1_build_kf(Libint->AB,int_stack+3215026,int_stack+2573506,int_stack+1668250,2376);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+190988,int_stack+185840,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+197072,int_stack+190988,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+204170,int_stack+197072,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+122382,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+212360,int_stack+204170,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+548320,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+548320,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+590908,int_stack+24570,int_stack+122382,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+85410,int_stack+221720,int_stack+212360,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113490,int_stack+85410,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+849280,int_stack+113490,int_stack+548320,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+920260,int_stack+849280,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1011520,int_stack+920260,int_stack+590908,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+548320,int_stack+232328,int_stack+221720,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+580144,int_stack+548320,int_stack+85410,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+580144,int_stack+113490,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+81900,int_stack+0,int_stack+849280,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1119628,int_stack+81900,int_stack+920260,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+849280,int_stack+1119628,int_stack+1011520,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+993424,int_stack+244262,int_stack+232328,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1029226,int_stack+993424,int_stack+548320,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1247392,int_stack+1029226,int_stack+580144,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+548320,int_stack+1247392,int_stack+0,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1247392,int_stack+548320,int_stack+81900,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+1247392,int_stack+1119628,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+993424,int_stack+0,int_stack+849280,78);
 /*--- compute (np|nk) ---*/
 hrr1_build_np(Libint->AB,int_stack+1178752,int_stack+993424,int_stack+692464,2376);
 /*--- compute (md|nk) ---*/
 hrr1_build_md(Libint->AB,int_stack+4070386,int_stack+1178752,int_stack+2181466,2376);
 /*--- compute (lf|nk) ---*/
 hrr1_build_lf(Libint->AB,int_stack+4854466,int_stack+4070386,int_stack+2573506,2376);
 /*--- compute (kg|nk) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1649200,int_stack+4854466,int_stack+3215026,2376);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+263606,int_stack+257600,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+270704,int_stack+263606,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+278985,int_stack+270704,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142779,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+288540,int_stack+278985,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+202839,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+202839,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+548320,int_stack+28665,int_stack+142779,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99645,int_stack+299460,int_stack+288540,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+132405,int_stack+99645,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+638410,int_stack+132405,int_stack+202839,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+189735,int_stack+638410,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+721220,int_stack+189735,int_stack+548320,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+548320,int_stack+311836,int_stack+299460,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+548320,int_stack+99645,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+847346,int_stack+0,int_stack+132405,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+65520,int_stack+847346,int_stack+638410,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2932240,int_stack+65520,int_stack+189735,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3081298,int_stack+2932240,int_stack+721220,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+189735,int_stack+325759,int_stack+311836,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+231504,int_stack+189735,int_stack+548320,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+548320,int_stack+231504,int_stack+0,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+657520,int_stack+548320,int_stack+847346,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+800845,int_stack+657520,int_stack+65520,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+548320,int_stack+800845,int_stack+2932240,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+747064,int_stack+548320,int_stack+3081298,91);
 /*--- compute (op|nk) ---*/
 hrr1_build_op(Libint->AB,int_stack+2932240,int_stack+747064,int_stack+993424,2376);
 /*--- compute (nd|nk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+5923666,int_stack+2932240,int_stack+1178752,2376);
 /*--- compute (mf|nk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+6864562,int_stack+5923666,int_stack+4070386,2376);
 /*--- compute (lg|nk) ---*/
 hrr1_build_lg(Libint->AB,int_stack+8171362,int_stack+6864562,int_stack+4854466,2376);
 /*--- compute (kh|nk) ---*/
 hrr1_build_kh(Libint->AB,int_stack+3488224,int_stack+8171362,int_stack+1649200,2376);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+548320,int_stack+348250,int_stack+341320,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+569110,int_stack+356440,int_stack+348250,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+593680,int_stack+569110,int_stack+548320,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+635260,int_stack+365995,int_stack+356440,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+663925,int_stack+635260,int_stack+569110,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+5284480,int_stack+663925,int_stack+593680,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+548320,int_stack+377020,int_stack+365995,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+5353780,int_stack+548320,int_stack+635260,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+581395,int_stack+5353780,int_stack+663925,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+5411110,int_stack+581395,int_stack+5284480,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+5284480,int_stack+389620,int_stack+377020,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+663295,int_stack+5284480,int_stack+548320,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+5515060,int_stack+663295,int_stack+5353780,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+5610610,int_stack+5515060,int_stack+581395,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+5733460,int_stack+5610610,int_stack+5411110,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+548320,int_stack+403900,int_stack+389620,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+5322280,int_stack+548320,int_stack+5284480,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+5397880,int_stack+5322280,int_stack+663295,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+591160,int_stack+5397880,int_stack+5515060,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+963280,int_stack+591160,int_stack+5610610,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+5508130,int_stack+963280,int_stack+5733460,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+5702170,int_stack+419965,int_stack+403900,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+5750365,int_stack+5702170,int_stack+548320,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1135270,int_stack+5750365,int_stack+5322280,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+5702170,int_stack+1135270,int_stack+5397880,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1135270,int_stack+5702170,int_stack+591160,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1335925,int_stack+1135270,int_stack+963280,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+963280,int_stack+1335925,int_stack+5508130,105);
 /*--- compute (qp|nk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1212760,int_stack+963280,int_stack+747064,2376);
 /*--- compute (od|nk) ---*/
 hrr1_build_od(Libint->AB,int_stack+9775162,int_stack+1212760,int_stack+2932240,2376);
 /*--- compute (nf|nk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+1861408,int_stack+9775162,int_stack+5923666,2376);
 /*--- compute (mg|nk) ---*/
 hrr1_build_mg(Libint->AB,int_stack+10887130,int_stack+1861408,int_stack+6864562,2376);
 /*--- compute (lh|nk) ---*/
 hrr1_build_lh(Libint->AB,int_stack+5284480,int_stack+10887130,int_stack+8171362,2376);
 /*--- compute (ki|nk) ---*/
 hrr1_build_ki(Libint->AB,int_stack+12847330,int_stack+5284480,int_stack+3488224,2376);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3429568,int_stack+445840,int_stack+437920,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3453328,int_stack+455200,int_stack+445840,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+3481408,int_stack+3453328,int_stack+3429568,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3528928,int_stack+466120,int_stack+455200,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3561688,int_stack+3528928,int_stack+3453328,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3617848,int_stack+3561688,int_stack+3481408,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+3429568,int_stack+478720,int_stack+466120,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3697048,int_stack+3429568,int_stack+3528928,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3467368,int_stack+3697048,int_stack+3561688,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3762568,int_stack+3467368,int_stack+3617848,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3560968,int_stack+493120,int_stack+478720,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3604168,int_stack+3560968,int_stack+3429568,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3881368,int_stack+3604168,int_stack+3697048,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3990568,int_stack+3881368,int_stack+3467368,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+4130968,int_stack+3990568,int_stack+3762568,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+3429568,int_stack+509440,int_stack+493120,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+3679768,int_stack+3429568,int_stack+3560968,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4297288,int_stack+3679768,int_stack+3604168,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+3478528,int_stack+4297288,int_stack+3881368,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3766168,int_stack+3478528,int_stack+3990568,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+4423288,int_stack+3766168,int_stack+4130968,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3962728,int_stack+527800,int_stack+509440,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+4017808,int_stack+3962728,int_stack+3429568,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+4115728,int_stack+4017808,int_stack+3679768,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4645048,int_stack+4115728,int_stack+4297288,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3962728,int_stack+4645048,int_stack+3478528,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+4645048,int_stack+3962728,int_stack+3766168,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4907128,int_stack+4645048,int_stack+4423288,120);
 /*--- compute (rp|nk) ---*/
 hrr1_build_rp(Libint->AB,int_stack+3429568,int_stack+4907128,int_stack+963280,2376);
 /*--- compute (qd|nk) ---*/
 hrr1_build_qd(Libint->AB,int_stack+7529800,int_stack+3429568,int_stack+1212760,2376);
 /*--- compute (of|nk) ---*/
 hrr1_build_of(Libint->AB,int_stack+3429568,int_stack+7529800,int_stack+9775162,2376);
 /*--- compute (ng|nk) ---*/
 hrr1_build_ng(Libint->AB,int_stack+7529800,int_stack+3429568,int_stack+1861408,2376);
 /*--- compute (mh|nk) ---*/
 hrr1_build_mh(Libint->AB,int_stack+0,int_stack+7529800,int_stack+10887130,2376);
 /*--- compute (li|nk) ---*/
 hrr1_build_li(Libint->AB,int_stack+7529800,int_stack+0,int_stack+5284480,2376);
 /*--- compute (kk|nk) ---*/
 hrr1_build_kk(Libint->AB,int_stack+0,int_stack+7529800,int_stack+12847330,2376);
 return int_stack+0;}
