/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kpml(Libint_t*, prim_data*);

  /* Computes quartets of (kp|ml) integrals */

REALTYPE *hrr_order_kpml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[7][14] = int_stack + 14220;
 Libint->vrr_classes[7][15] = int_stack + 18540;
 Libint->vrr_classes[7][16] = int_stack + 23436;
 Libint->vrr_classes[7][17] = int_stack + 28944;
 Libint->vrr_classes[8][9] = int_stack + 35100;
 Libint->vrr_classes[8][10] = int_stack + 37575;
 Libint->vrr_classes[8][11] = int_stack + 40545;
 Libint->vrr_classes[8][12] = int_stack + 44055;
 Libint->vrr_classes[8][13] = int_stack + 48150;
 Libint->vrr_classes[8][14] = int_stack + 52875;
 Libint->vrr_classes[8][15] = int_stack + 58275;
 Libint->vrr_classes[8][16] = int_stack + 64395;
 Libint->vrr_classes[8][17] = int_stack + 71280;
 memset(int_stack,0,78975*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 78975;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kpml(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+78975,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+84915,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+92043,int_stack+84915,int_stack+78975,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+103923,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+112347,int_stack+103923,int_stack+84915,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+126603,int_stack+112347,int_stack+92043,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+78975,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+146403,int_stack+78975,int_stack+103923,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+163251,int_stack+146403,int_stack+112347,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+88803,int_stack+163251,int_stack+126603,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+118503,int_stack+14220,int_stack+10440,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+187011,int_stack+118503,int_stack+78975,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+206667,int_stack+187011,int_stack+146403,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+234747,int_stack+206667,int_stack+163251,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+129843,int_stack+234747,int_stack+88803,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+78975,int_stack+18540,int_stack+14220,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+91935,int_stack+78975,int_stack+118503,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+270387,int_stack+91935,int_stack+187011,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+303147,int_stack+270387,int_stack+206667,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+171423,int_stack+303147,int_stack+234747,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+345267,int_stack+171423,int_stack+129843,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+114615,int_stack+23436,int_stack+18540,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+129303,int_stack+114615,int_stack+78975,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+221319,int_stack+129303,int_stack+91935,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+400707,int_stack+221319,int_stack+270387,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+449847,int_stack+400707,int_stack+303147,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+259119,int_stack+449847,int_stack+171423,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+508815,int_stack+259119,int_stack+345267,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+78975,int_stack+28944,int_stack+23436,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+155223,int_stack+78975,int_stack+114615,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+78975,int_stack+155223,int_stack+129303,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+122175,int_stack+78975,int_stack+221319,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+178875,int_stack+122175,int_stack+400707,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+78975,int_stack+178875,int_stack+449847,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+157599,int_stack+78975,int_stack+259119,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+243135,int_stack+157599,int_stack+508815,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+78975,int_stack+37575,int_stack+35100,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+86400,int_stack+40545,int_stack+37575,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+95310,int_stack+86400,int_stack+78975,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+110160,int_stack+44055,int_stack+40545,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+120690,int_stack+110160,int_stack+86400,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+138510,int_stack+120690,int_stack+95310,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+78975,int_stack+48150,int_stack+44055,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+163260,int_stack+78975,int_stack+110160,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+184320,int_stack+163260,int_stack+120690,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+91260,int_stack+184320,int_stack+138510,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+128385,int_stack+52875,int_stack+48150,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+214020,int_stack+128385,int_stack+78975,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+332235,int_stack+214020,int_stack+163260,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+367335,int_stack+332235,int_stack+184320,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+142560,int_stack+367335,int_stack+91260,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+78975,int_stack+58275,int_stack+52875,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+95175,int_stack+78975,int_stack+128385,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+411885,int_stack+95175,int_stack+214020,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+452835,int_stack+411885,int_stack+332235,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+505485,int_stack+452835,int_stack+367335,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+332235,int_stack+505485,int_stack+142560,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+123525,int_stack+64395,int_stack+58275,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+141885,int_stack+123525,int_stack+78975,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+174285,int_stack+141885,int_stack+95175,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+174285,int_stack+411885,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+567855,int_stack+0,int_stack+452835,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+401535,int_stack+567855,int_stack+505485,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+641565,int_stack+401535,int_stack+332235,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+332235,int_stack+71280,int_stack+64395,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+352890,int_stack+332235,int_stack+123525,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+484695,int_stack+352890,int_stack+141885,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+61425,int_stack+484695,int_stack+174285,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+132300,int_stack+61425,int_stack+0,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+132300,int_stack+567855,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+98280,int_stack+0,int_stack+401535,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+332235,int_stack+98280,int_stack+641565,45);
 /*--- compute (kp|ml) ---*/
 hrr1_build_kp(Libint->AB,int_stack+443610,int_stack+332235,int_stack+243135,2475);
 return int_stack+443610;}
