/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_l0hg(Libint_t*, prim_data*);

  /* Computes quartets of (l0|hg) integrals */

REALTYPE *hrr_order_l0hg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][5] = int_stack + 0;
 Libint->vrr_classes[8][6] = int_stack + 945;
 Libint->vrr_classes[8][7] = int_stack + 2205;
 Libint->vrr_classes[8][8] = int_stack + 3825;
 Libint->vrr_classes[8][9] = int_stack + 5850;
 memset(int_stack,0,8325*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 8325;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_l0hg(Libint, Data);
   Data++;
 }
 /*--- compute (l0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+8325,int_stack+945,int_stack+0,45);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+11160,int_stack+2205,int_stack+945,45);
 /*--- compute (l0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+14940,int_stack+11160,int_stack+8325,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+20610,int_stack+3825,int_stack+2205,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+25470,int_stack+20610,int_stack+11160,45);
 /*--- compute (l0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+33030,int_stack+25470,int_stack+14940,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8325,int_stack+5850,int_stack+3825,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+42480,int_stack+8325,int_stack+20610,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+42480,int_stack+25470,45);
 /*--- compute (l0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+12600,int_stack+0,int_stack+33030,45);
 return int_stack+12600;}
