/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lfii(Libint_t*, prim_data*);

  /* Computes quartets of (lf|ii) integrals */

REALTYPE *hrr_order_lfii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][6] = int_stack + 0;
 Libint->vrr_classes[8][7] = int_stack + 1260;
 Libint->vrr_classes[8][8] = int_stack + 2880;
 Libint->vrr_classes[8][9] = int_stack + 4905;
 Libint->vrr_classes[8][10] = int_stack + 7380;
 Libint->vrr_classes[8][11] = int_stack + 10350;
 Libint->vrr_classes[8][12] = int_stack + 13860;
 Libint->vrr_classes[9][6] = int_stack + 17955;
 Libint->vrr_classes[9][7] = int_stack + 19495;
 Libint->vrr_classes[9][8] = int_stack + 21475;
 Libint->vrr_classes[9][9] = int_stack + 23950;
 Libint->vrr_classes[9][10] = int_stack + 26975;
 Libint->vrr_classes[9][11] = int_stack + 30605;
 Libint->vrr_classes[9][12] = int_stack + 34895;
 Libint->vrr_classes[10][6] = int_stack + 39900;
 Libint->vrr_classes[10][7] = int_stack + 41748;
 Libint->vrr_classes[10][8] = int_stack + 44124;
 Libint->vrr_classes[10][9] = int_stack + 47094;
 Libint->vrr_classes[10][10] = int_stack + 50724;
 Libint->vrr_classes[10][11] = int_stack + 55080;
 Libint->vrr_classes[10][12] = int_stack + 60228;
 Libint->vrr_classes[11][6] = int_stack + 66234;
 Libint->vrr_classes[11][7] = int_stack + 68418;
 Libint->vrr_classes[11][8] = int_stack + 71226;
 Libint->vrr_classes[11][9] = int_stack + 74736;
 Libint->vrr_classes[11][10] = int_stack + 79026;
 Libint->vrr_classes[11][11] = int_stack + 84174;
 Libint->vrr_classes[11][12] = int_stack + 90258;
 memset(int_stack,0,97356*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 97356;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lfii(Libint, Data);
   Data++;
 }
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+97356,int_stack+1260,int_stack+0,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+101136,int_stack+2880,int_stack+1260,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+105996,int_stack+101136,int_stack+97356,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+113556,int_stack+4905,int_stack+2880,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+119631,int_stack+113556,int_stack+101136,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+129351,int_stack+119631,int_stack+105996,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+97356,int_stack+7380,int_stack+4905,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+141951,int_stack+97356,int_stack+113556,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+154101,int_stack+141951,int_stack+119631,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+104781,int_stack+154101,int_stack+129351,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+123681,int_stack+10350,int_stack+7380,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+170301,int_stack+123681,int_stack+97356,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+185151,int_stack+170301,int_stack+141951,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+205401,int_stack+185151,int_stack+154101,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+132591,int_stack+205401,int_stack+104781,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+97356,int_stack+13860,int_stack+10350,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+97356,int_stack+123681,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+97356,int_stack+0,int_stack+170301,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+229701,int_stack+97356,int_stack+185151,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+97356,int_stack+229701,int_stack+205401,45);
 /*--- compute (l0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+159051,int_stack+97356,int_stack+132591,45);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+97356,int_stack+19495,int_stack+17955,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+101976,int_stack+21475,int_stack+19495,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+107916,int_stack+101976,int_stack+97356,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+117156,int_stack+23950,int_stack+21475,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+124581,int_stack+117156,int_stack+101976,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+136461,int_stack+124581,int_stack+107916,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+97356,int_stack+26975,int_stack+23950,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+97356,int_stack+117156,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+194331,int_stack+0,int_stack+124581,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+106431,int_stack+194331,int_stack+136461,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+129531,int_stack+30605,int_stack+26975,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+140421,int_stack+129531,int_stack+97356,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+214131,int_stack+140421,int_stack+0,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+214131,int_stack+194331,55);
 /*--- compute (m0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+238881,int_stack+0,int_stack+106431,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+194331,int_stack+34895,int_stack+30605,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+97356,int_stack+194331,int_stack+129531,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+271221,int_stack+97356,int_stack+140421,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+97356,int_stack+271221,int_stack+214131,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+194331,int_stack+97356,int_stack+0,55);
 /*--- compute (m0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+97356,int_stack+194331,int_stack+238881,55);
 /*--- compute (lp|ii) ---*/
 hrr1_build_lp(Libint->AB,int_stack+194331,int_stack+97356,int_stack+159051,784);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+41748,int_stack+39900,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+5544,int_stack+44124,int_stack+41748,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+12672,int_stack+5544,int_stack+0,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+23760,int_stack+47094,int_stack+44124,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+32670,int_stack+23760,int_stack+5544,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+140476,int_stack+32670,int_stack+12672,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+50724,int_stack+47094,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+158956,int_stack+0,int_stack+23760,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+300171,int_stack+158956,int_stack+32670,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+10890,int_stack+300171,int_stack+140476,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+140476,int_stack+55080,int_stack+50724,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+323931,int_stack+140476,int_stack+0,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+345711,int_stack+323931,int_stack+158956,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+153544,int_stack+345711,int_stack+300171,66);
 /*--- compute (n0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+375411,int_stack+153544,int_stack+10890,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+300171,int_stack+60228,int_stack+55080,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+300171,int_stack+140476,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+26136,int_stack+0,int_stack+323931,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+300171,int_stack+26136,int_stack+345711,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+300171,int_stack+153544,66);
 /*--- compute (n0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+300171,int_stack+0,int_stack+375411,66);
 /*--- compute (mp|ii) ---*/
 hrr1_build_mp(Libint->AB,int_stack+351915,int_stack+300171,int_stack+97356,784);
 /*--- compute (ld|ii) ---*/
 hrr1_build_ld(Libint->AB,int_stack+481275,int_stack+351915,int_stack+194331,784);
 /*--- compute (o0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+97356,int_stack+68418,int_stack+66234,78);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+103908,int_stack+71226,int_stack+68418,78);
 /*--- compute (o0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+112332,int_stack+103908,int_stack+97356,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+125436,int_stack+74736,int_stack+71226,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+135966,int_stack+125436,int_stack+103908,78);
 /*--- compute (o0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+152814,int_stack+135966,int_stack+112332,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+97356,int_stack+79026,int_stack+74736,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+174654,int_stack+97356,int_stack+125436,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+195714,int_stack+174654,int_stack+135966,78);
 /*--- compute (o0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+110226,int_stack+195714,int_stack+152814,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+142986,int_stack+84174,int_stack+79026,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+223794,int_stack+142986,int_stack+97356,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+249534,int_stack+223794,int_stack+174654,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+249534,int_stack+195714,78);
 /*--- compute (o0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+158430,int_stack+0,int_stack+110226,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+97356,int_stack+90258,int_stack+84174,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+42120,int_stack+97356,int_stack+142986,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+73008,int_stack+42120,int_stack+223794,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+692955,int_stack+73008,int_stack+249534,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+42120,int_stack+692955,int_stack+0,78);
 /*--- compute (o0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+204294,int_stack+42120,int_stack+158430,78);
 /*--- compute (np|ii) ---*/
 hrr1_build_np(Libint->AB,int_stack+0,int_stack+204294,int_stack+300171,784);
 /*--- compute (md|ii) ---*/
 hrr1_build_md(Libint->AB,int_stack+692955,int_stack+0,int_stack+351915,784);
 /*--- compute (lf|ii) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+692955,int_stack+481275,784);
 return int_stack+0;}
