/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lfmi(Libint_t*, prim_data*);

  /* Computes quartets of (lf|mi) integrals */

REALTYPE *hrr_order_lfmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[8][14] = int_stack + 17775;
 Libint->vrr_classes[8][15] = int_stack + 23175;
 Libint->vrr_classes[9][9] = int_stack + 29295;
 Libint->vrr_classes[9][10] = int_stack + 32320;
 Libint->vrr_classes[9][11] = int_stack + 35950;
 Libint->vrr_classes[9][12] = int_stack + 40240;
 Libint->vrr_classes[9][13] = int_stack + 45245;
 Libint->vrr_classes[9][14] = int_stack + 51020;
 Libint->vrr_classes[9][15] = int_stack + 57620;
 Libint->vrr_classes[10][9] = int_stack + 65100;
 Libint->vrr_classes[10][10] = int_stack + 68730;
 Libint->vrr_classes[10][11] = int_stack + 73086;
 Libint->vrr_classes[10][12] = int_stack + 78234;
 Libint->vrr_classes[10][13] = int_stack + 84240;
 Libint->vrr_classes[10][14] = int_stack + 91170;
 Libint->vrr_classes[10][15] = int_stack + 99090;
 Libint->vrr_classes[11][9] = int_stack + 108066;
 Libint->vrr_classes[11][10] = int_stack + 112356;
 Libint->vrr_classes[11][11] = int_stack + 117504;
 Libint->vrr_classes[11][12] = int_stack + 123588;
 Libint->vrr_classes[11][13] = int_stack + 130686;
 Libint->vrr_classes[11][14] = int_stack + 138876;
 Libint->vrr_classes[11][15] = int_stack + 148236;
 memset(int_stack,0,158844*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 158844;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lfmi(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+158844,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+166269,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+175179,int_stack+166269,int_stack+158844,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+190029,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+200559,int_stack+190029,int_stack+166269,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+218379,int_stack+200559,int_stack+175179,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+158844,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+243129,int_stack+158844,int_stack+190029,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+264189,int_stack+243129,int_stack+200559,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+171129,int_stack+264189,int_stack+218379,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+208254,int_stack+17775,int_stack+13050,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+293889,int_stack+208254,int_stack+158844,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+318459,int_stack+293889,int_stack+243129,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+353559,int_stack+318459,int_stack+264189,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+222429,int_stack+353559,int_stack+171129,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+158844,int_stack+23175,int_stack+17775,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+175044,int_stack+158844,int_stack+208254,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+398109,int_stack+175044,int_stack+293889,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+158844,int_stack+398109,int_stack+318459,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+274404,int_stack+158844,int_stack+353559,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+336774,int_stack+274404,int_stack+222429,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+158844,int_stack+32320,int_stack+29295,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+167919,int_stack+35950,int_stack+32320,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+178809,int_stack+167919,int_stack+158844,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+196959,int_stack+40240,int_stack+35950,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+209829,int_stack+196959,int_stack+167919,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+231609,int_stack+209829,int_stack+178809,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+158844,int_stack+45245,int_stack+40240,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+261859,int_stack+158844,int_stack+196959,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+287599,int_stack+261859,int_stack+209829,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+173859,int_stack+287599,int_stack+231609,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+219234,int_stack+51020,int_stack+45245,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+406074,int_stack+219234,int_stack+158844,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+406074,int_stack+261859,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+436104,int_stack+0,int_stack+287599,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+236559,int_stack+436104,int_stack+173859,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+158844,int_stack+57620,int_stack+51020,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+178644,int_stack+158844,int_stack+219234,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+490554,int_stack+178644,int_stack+406074,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+158844,int_stack+490554,int_stack+0,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+490554,int_stack+158844,int_stack+436104,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+566784,int_stack+490554,int_stack+236559,55);
 /*--- compute (lp|mi) ---*/
 hrr1_build_lp(Libint->AB,int_stack+651484,int_stack+566784,int_stack+336774,1540);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+158844,int_stack+68730,int_stack+65100,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+169734,int_stack+73086,int_stack+68730,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+182802,int_stack+169734,int_stack+158844,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+204582,int_stack+78234,int_stack+73086,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+220026,int_stack+204582,int_stack+169734,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+246162,int_stack+220026,int_stack+182802,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+158844,int_stack+84240,int_stack+78234,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+282462,int_stack+158844,int_stack+204582,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+313350,int_stack+282462,int_stack+220026,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+176862,int_stack+313350,int_stack+246162,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+231312,int_stack+91170,int_stack+84240,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+356910,int_stack+231312,int_stack+158844,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+392946,int_stack+356910,int_stack+282462,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+444426,int_stack+392946,int_stack+313350,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+252102,int_stack+444426,int_stack+176862,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+158844,int_stack+99090,int_stack+91170,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+182604,int_stack+158844,int_stack+231312,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+182604,int_stack+356910,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+158844,int_stack+0,int_stack+392946,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+158844,int_stack+444426,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+328332,int_stack+0,int_stack+252102,66);
 /*--- compute (mp|mi) ---*/
 hrr1_build_mp(Libint->AB,int_stack+859384,int_stack+328332,int_stack+566784,1540);
 /*--- compute (ld|mi) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1113484,int_stack+859384,int_stack+651484,1540);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+112356,int_stack+108066,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+117504,int_stack+112356,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54054,int_stack+123588,int_stack+117504,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+72306,int_stack+54054,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+158844,int_stack+72306,int_stack+28314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+130686,int_stack+123588,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+201744,int_stack+0,int_stack+54054,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+238248,int_stack+201744,int_stack+72306,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+21294,int_stack+238248,int_stack+158844,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+158844,int_stack+138876,int_stack+130686,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+85644,int_stack+158844,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+429972,int_stack+85644,int_stack+201744,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+490812,int_stack+429972,int_stack+238248,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+183414,int_stack+490812,int_stack+21294,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+148236,int_stack+138876,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+28080,int_stack+0,int_stack+158844,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+568032,int_stack+28080,int_stack+85644,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+568032,int_stack+429972,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+568032,int_stack+0,int_stack+490812,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+568032,int_stack+183414,78);
 /*--- compute (np|mi) ---*/
 hrr1_build_np(Libint->AB,int_stack+429972,int_stack+0,int_stack+328332,1540);
 /*--- compute (md|mi) ---*/
 hrr1_build_md(Libint->AB,int_stack+1529284,int_stack+429972,int_stack+859384,1540);
 /*--- compute (lf|mi) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+1529284,int_stack+1113484,1540);
 return int_stack+0;}
