/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lfml(Libint_t*, prim_data*);

  /* Computes quartets of (lf|ml) integrals */

REALTYPE *hrr_order_lfml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[8][14] = int_stack + 17775;
 Libint->vrr_classes[8][15] = int_stack + 23175;
 Libint->vrr_classes[8][16] = int_stack + 29295;
 Libint->vrr_classes[8][17] = int_stack + 36180;
 Libint->vrr_classes[9][9] = int_stack + 43875;
 Libint->vrr_classes[9][10] = int_stack + 46900;
 Libint->vrr_classes[9][11] = int_stack + 50530;
 Libint->vrr_classes[9][12] = int_stack + 54820;
 Libint->vrr_classes[9][13] = int_stack + 59825;
 Libint->vrr_classes[9][14] = int_stack + 65600;
 Libint->vrr_classes[9][15] = int_stack + 72200;
 Libint->vrr_classes[9][16] = int_stack + 79680;
 Libint->vrr_classes[9][17] = int_stack + 88095;
 Libint->vrr_classes[10][9] = int_stack + 97500;
 Libint->vrr_classes[10][10] = int_stack + 101130;
 Libint->vrr_classes[10][11] = int_stack + 105486;
 Libint->vrr_classes[10][12] = int_stack + 110634;
 Libint->vrr_classes[10][13] = int_stack + 116640;
 Libint->vrr_classes[10][14] = int_stack + 123570;
 Libint->vrr_classes[10][15] = int_stack + 131490;
 Libint->vrr_classes[10][16] = int_stack + 140466;
 Libint->vrr_classes[10][17] = int_stack + 150564;
 Libint->vrr_classes[11][9] = int_stack + 161850;
 Libint->vrr_classes[11][10] = int_stack + 166140;
 Libint->vrr_classes[11][11] = int_stack + 171288;
 Libint->vrr_classes[11][12] = int_stack + 177372;
 Libint->vrr_classes[11][13] = int_stack + 184470;
 Libint->vrr_classes[11][14] = int_stack + 192660;
 Libint->vrr_classes[11][15] = int_stack + 202020;
 Libint->vrr_classes[11][16] = int_stack + 212628;
 Libint->vrr_classes[11][17] = int_stack + 224562;
 memset(int_stack,0,237900*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 237900;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lfml(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+237900,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+245325,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+254235,int_stack+245325,int_stack+237900,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+269085,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+279615,int_stack+269085,int_stack+245325,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+297435,int_stack+279615,int_stack+254235,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+237900,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+322185,int_stack+237900,int_stack+269085,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+343245,int_stack+322185,int_stack+279615,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+250185,int_stack+343245,int_stack+297435,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+287310,int_stack+17775,int_stack+13050,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+372945,int_stack+287310,int_stack+237900,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+397515,int_stack+372945,int_stack+322185,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+432615,int_stack+397515,int_stack+343245,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+301485,int_stack+432615,int_stack+250185,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+237900,int_stack+23175,int_stack+17775,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+254100,int_stack+237900,int_stack+287310,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+477165,int_stack+254100,int_stack+372945,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+518115,int_stack+477165,int_stack+397515,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+353460,int_stack+518115,int_stack+432615,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+570765,int_stack+353460,int_stack+301485,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+282450,int_stack+29295,int_stack+23175,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+300810,int_stack+282450,int_stack+237900,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+415830,int_stack+300810,int_stack+254100,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+640065,int_stack+415830,int_stack+477165,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+701490,int_stack+640065,int_stack+518115,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+463080,int_stack+701490,int_stack+353460,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+775200,int_stack+463080,int_stack+570765,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+237900,int_stack+36180,int_stack+29295,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+333210,int_stack+237900,int_stack+282450,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+237900,int_stack+333210,int_stack+300810,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+291900,int_stack+237900,int_stack+415830,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+362775,int_stack+291900,int_stack+640065,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+237900,int_stack+362775,int_stack+701490,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+336180,int_stack+237900,int_stack+463080,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+443100,int_stack+336180,int_stack+775200,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+237900,int_stack+46900,int_stack+43875,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+246975,int_stack+50530,int_stack+46900,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+257865,int_stack+246975,int_stack+237900,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+276015,int_stack+54820,int_stack+50530,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+288885,int_stack+276015,int_stack+246975,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+310665,int_stack+288885,int_stack+257865,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+237900,int_stack+59825,int_stack+54820,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+340915,int_stack+237900,int_stack+276015,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+366655,int_stack+340915,int_stack+288885,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+252915,int_stack+366655,int_stack+310665,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+298290,int_stack+65600,int_stack+59825,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+402955,int_stack+298290,int_stack+237900,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+554475,int_stack+402955,int_stack+340915,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+597375,int_stack+554475,int_stack+366655,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+315615,int_stack+597375,int_stack+252915,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+237900,int_stack+72200,int_stack+65600,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+257700,int_stack+237900,int_stack+298290,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+651825,int_stack+257700,int_stack+402955,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+701875,int_stack+651825,int_stack+554475,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+766225,int_stack+701875,int_stack+597375,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+554475,int_stack+766225,int_stack+315615,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+292350,int_stack+79680,int_stack+72200,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+314790,int_stack+292350,int_stack+237900,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+354390,int_stack+314790,int_stack+257700,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+354390,int_stack+651825,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+842455,int_stack+0,int_stack+701875,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+639175,int_stack+842455,int_stack+766225,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+932545,int_stack+639175,int_stack+554475,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+554475,int_stack+88095,int_stack+79680,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+579720,int_stack+554475,int_stack+292350,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+237900,int_stack+579720,int_stack+314790,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+740815,int_stack+237900,int_stack+354390,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+237900,int_stack+740815,int_stack+0,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1041445,int_stack+237900,int_stack+842455,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+237900,int_stack+1041445,int_stack+639175,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+554475,int_stack+237900,int_stack+932545,55);
 /*--- compute (lp|ml) ---*/
 hrr1_build_lp(Libint->AB,int_stack+690600,int_stack+554475,int_stack+443100,2475);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+237900,int_stack+101130,int_stack+97500,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+248790,int_stack+105486,int_stack+101130,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+261858,int_stack+248790,int_stack+237900,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+283638,int_stack+110634,int_stack+105486,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+299082,int_stack+283638,int_stack+248790,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+325218,int_stack+299082,int_stack+261858,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+237900,int_stack+116640,int_stack+110634,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+361518,int_stack+237900,int_stack+283638,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+392406,int_stack+361518,int_stack+299082,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+255918,int_stack+392406,int_stack+325218,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+310368,int_stack+123570,int_stack+116640,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+435966,int_stack+310368,int_stack+237900,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+472002,int_stack+435966,int_stack+361518,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+472002,int_stack+392406,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+331158,int_stack+0,int_stack+255918,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+237900,int_stack+131490,int_stack+123570,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+261660,int_stack+237900,int_stack+310368,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+65340,int_stack+261660,int_stack+435966,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1024725,int_stack+65340,int_stack+472002,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+407388,int_stack+1024725,int_stack+0,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1101945,int_stack+407388,int_stack+331158,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+140466,int_stack+131490,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+303240,int_stack+0,int_stack+237900,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1203585,int_stack+303240,int_stack+261660,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1272885,int_stack+1203585,int_stack+65340,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+26928,int_stack+1272885,int_stack+1024725,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1362975,int_stack+26928,int_stack+407388,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+350760,int_stack+1362975,int_stack+1101945,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1024725,int_stack+150564,int_stack+140466,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1055019,int_stack+1024725,int_stack+0,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1108875,int_stack+1055019,int_stack+303240,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+237900,int_stack+1108875,int_stack+1203585,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1024725,int_stack+237900,int_stack+1272885,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1150851,int_stack+1024725,int_stack+26928,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1150851,int_stack+1362975,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1024725,int_stack+0,int_stack+350760,66);
 /*--- compute (mp|ml) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1188075,int_stack+1024725,int_stack+554475,2475);
 /*--- compute (ld|ml) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1596450,int_stack+1188075,int_stack+690600,2475);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+166140,int_stack+161850,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+171288,int_stack+166140,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54054,int_stack+177372,int_stack+171288,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+72306,int_stack+54054,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+103194,int_stack+72306,int_stack+28314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+184470,int_stack+177372,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+146094,int_stack+0,int_stack+54054,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+237900,int_stack+146094,int_stack+72306,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+21294,int_stack+237900,int_stack+103194,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+85644,int_stack+192660,int_stack+184470,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+289380,int_stack+85644,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+331968,int_stack+289380,int_stack+146094,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+110214,int_stack+331968,int_stack+237900,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+392808,int_stack+110214,int_stack+21294,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+237900,int_stack+202020,int_stack+192660,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+237900,int_stack+85644,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+482898,int_stack+0,int_stack+289380,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+553878,int_stack+482898,int_stack+331968,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+265980,int_stack+553878,int_stack+110214,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+49140,int_stack+265980,int_stack+392808,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+374088,int_stack+212628,int_stack+202020,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+405912,int_stack+374088,int_stack+237900,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+645138,int_stack+405912,int_stack+0,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+727038,int_stack+645138,int_stack+482898,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+833508,int_stack+727038,int_stack+553878,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+462072,int_stack+833508,int_stack+265980,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2264700,int_stack+462072,int_stack+49140,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+224562,int_stack+212628,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+35802,int_stack+0,int_stack+374088,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+99450,int_stack+35802,int_stack+405912,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+193050,int_stack+99450,int_stack+645138,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+193050,int_stack+727038,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+149058,int_stack+0,int_stack+833508,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+606216,int_stack+149058,int_stack+462072,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+606216,int_stack+2264700,78);
 /*--- compute (np|ml) ---*/
 hrr1_build_np(Libint->AB,int_stack+193050,int_stack+0,int_stack+1024725,2475);
 /*--- compute (md|ml) ---*/
 hrr1_build_md(Libint->AB,int_stack+2264700,int_stack+193050,int_stack+1188075,2475);
 /*--- compute (lf|ml) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+2264700,int_stack+1596450,2475);
 return int_stack+0;}
