/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lgli(Libint_t*, prim_data*);

  /* Computes quartets of (lg|li) integrals */

REALTYPE *hrr_order_lgli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][8] = int_stack + 0;
 Libint->vrr_classes[8][9] = int_stack + 2025;
 Libint->vrr_classes[8][10] = int_stack + 4500;
 Libint->vrr_classes[8][11] = int_stack + 7470;
 Libint->vrr_classes[8][12] = int_stack + 10980;
 Libint->vrr_classes[8][13] = int_stack + 15075;
 Libint->vrr_classes[8][14] = int_stack + 19800;
 Libint->vrr_classes[9][8] = int_stack + 25200;
 Libint->vrr_classes[9][9] = int_stack + 27675;
 Libint->vrr_classes[9][10] = int_stack + 30700;
 Libint->vrr_classes[9][11] = int_stack + 34330;
 Libint->vrr_classes[9][12] = int_stack + 38620;
 Libint->vrr_classes[9][13] = int_stack + 43625;
 Libint->vrr_classes[9][14] = int_stack + 49400;
 Libint->vrr_classes[10][8] = int_stack + 56000;
 Libint->vrr_classes[10][9] = int_stack + 58970;
 Libint->vrr_classes[10][10] = int_stack + 62600;
 Libint->vrr_classes[10][11] = int_stack + 66956;
 Libint->vrr_classes[10][12] = int_stack + 72104;
 Libint->vrr_classes[10][13] = int_stack + 78110;
 Libint->vrr_classes[10][14] = int_stack + 85040;
 Libint->vrr_classes[11][8] = int_stack + 92960;
 Libint->vrr_classes[11][9] = int_stack + 96470;
 Libint->vrr_classes[11][10] = int_stack + 100760;
 Libint->vrr_classes[11][11] = int_stack + 105908;
 Libint->vrr_classes[11][12] = int_stack + 111992;
 Libint->vrr_classes[11][13] = int_stack + 119090;
 Libint->vrr_classes[11][14] = int_stack + 127280;
 Libint->vrr_classes[12][8] = int_stack + 136640;
 Libint->vrr_classes[12][9] = int_stack + 140735;
 Libint->vrr_classes[12][10] = int_stack + 145740;
 Libint->vrr_classes[12][11] = int_stack + 151746;
 Libint->vrr_classes[12][12] = int_stack + 158844;
 Libint->vrr_classes[12][13] = int_stack + 167125;
 Libint->vrr_classes[12][14] = int_stack + 176680;
 memset(int_stack,0,187600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 187600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lgli(Libint, Data);
   Data++;
 }
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+187600,int_stack+2025,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+193675,int_stack+4500,int_stack+2025,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+201100,int_stack+193675,int_stack+187600,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+213250,int_stack+7470,int_stack+4500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+222160,int_stack+213250,int_stack+193675,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+237010,int_stack+222160,int_stack+201100,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+187600,int_stack+10980,int_stack+7470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+257260,int_stack+187600,int_stack+213250,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+275080,int_stack+257260,int_stack+222160,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+198130,int_stack+275080,int_stack+237010,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+228505,int_stack+15075,int_stack+10980,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+299830,int_stack+228505,int_stack+187600,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+320890,int_stack+299830,int_stack+257260,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+350590,int_stack+320890,int_stack+275080,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+240790,int_stack+350590,int_stack+198130,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+187600,int_stack+19800,int_stack+15075,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+201775,int_stack+187600,int_stack+228505,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+387715,int_stack+201775,int_stack+299830,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+187600,int_stack+387715,int_stack+320890,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+283315,int_stack+187600,int_stack+350590,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+335290,int_stack+283315,int_stack+240790,45);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+187600,int_stack+27675,int_stack+25200,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+195025,int_stack+30700,int_stack+27675,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+204100,int_stack+195025,int_stack+187600,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+218950,int_stack+34330,int_stack+30700,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+229840,int_stack+218950,int_stack+195025,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+247990,int_stack+229840,int_stack+204100,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+187600,int_stack+38620,int_stack+34330,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+272740,int_stack+187600,int_stack+218950,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+294520,int_stack+272740,int_stack+229840,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+200470,int_stack+294520,int_stack+247990,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+237595,int_stack+43625,int_stack+38620,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+391990,int_stack+237595,int_stack+187600,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+391990,int_stack+272740,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+417730,int_stack+0,int_stack+294520,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+252610,int_stack+417730,int_stack+200470,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+187600,int_stack+49400,int_stack+43625,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+204925,int_stack+187600,int_stack+237595,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+463105,int_stack+204925,int_stack+391990,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+187600,int_stack+463105,int_stack+0,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+463105,int_stack+187600,int_stack+417730,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+391990,int_stack+463105,int_stack+252610,55);
 /*--- compute (lp|li) ---*/
 hrr1_build_lp(Libint->AB,int_stack+461290,int_stack+391990,int_stack+335290,1260);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+187600,int_stack+58970,int_stack+56000,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+196510,int_stack+62600,int_stack+58970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+207400,int_stack+196510,int_stack+187600,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+225220,int_stack+66956,int_stack+62600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+238288,int_stack+225220,int_stack+196510,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+260068,int_stack+238288,int_stack+207400,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+187600,int_stack+72104,int_stack+66956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+289768,int_stack+187600,int_stack+225220,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+315904,int_stack+289768,int_stack+238288,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+203044,int_stack+315904,int_stack+260068,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+247594,int_stack+78110,int_stack+72104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+352204,int_stack+247594,int_stack+187600,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+352204,int_stack+289768,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+631390,int_stack+0,int_stack+315904,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+265612,int_stack+631390,int_stack+203044,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+187600,int_stack+85040,int_stack+78110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+208390,int_stack+187600,int_stack+247594,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+685840,int_stack+208390,int_stack+352204,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+187600,int_stack+685840,int_stack+0,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+187600,int_stack+631390,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+631390,int_stack+0,int_stack+265612,66);
 /*--- compute (mp|li) ---*/
 hrr1_build_mp(Libint->AB,int_stack+714550,int_stack+631390,int_stack+391990,1260);
 /*--- compute (ld|li) ---*/
 hrr1_build_ld(Libint->AB,int_stack+922450,int_stack+714550,int_stack+461290,1260);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+96470,int_stack+92960,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10530,int_stack+100760,int_stack+96470,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23400,int_stack+10530,int_stack+0,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44460,int_stack+105908,int_stack+100760,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+59904,int_stack+44460,int_stack+10530,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+187600,int_stack+59904,int_stack+23400,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+111992,int_stack+105908,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+222700,int_stack+0,int_stack+44460,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+253588,int_stack+222700,int_stack+59904,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+18252,int_stack+253588,int_stack+187600,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+187600,int_stack+119090,int_stack+111992,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+70902,int_stack+187600,int_stack+0,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+296488,int_stack+70902,int_stack+222700,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+347968,int_stack+296488,int_stack+253588,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+208894,int_stack+347968,int_stack+18252,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+127280,int_stack+119090,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+24570,int_stack+0,int_stack+187600,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+412318,int_stack+24570,int_stack+70902,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+412318,int_stack+296488,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+412318,int_stack+0,int_stack+347968,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+412318,int_stack+208894,78);
 /*--- compute (np|li) ---*/
 hrr1_build_np(Libint->AB,int_stack+187600,int_stack+0,int_stack+631390,1260);
 /*--- compute (md|li) ---*/
 hrr1_build_md(Libint->AB,int_stack+1262650,int_stack+187600,int_stack+714550,1260);
 /*--- compute (lf|li) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1678450,int_stack+1262650,int_stack+922450,1260);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+98280,int_stack+140735,int_stack+136640,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+110565,int_stack+145740,int_stack+140735,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+437080,int_stack+110565,int_stack+98280,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+125580,int_stack+151746,int_stack+145740,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+461650,int_stack+125580,int_stack+110565,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+491680,int_stack+461650,int_stack+437080,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+437080,int_stack+158844,int_stack+151746,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+532630,int_stack+437080,int_stack+125580,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+98280,int_stack+532630,int_stack+461650,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+568666,int_stack+98280,int_stack+491680,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+458374,int_stack+167125,int_stack+158844,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+483217,int_stack+458374,int_stack+437080,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+630091,int_stack+483217,int_stack+532630,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+690151,int_stack+630091,int_stack+98280,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+765226,int_stack+690151,int_stack+568666,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+98280,int_stack+176680,int_stack+167125,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+126945,int_stack+98280,int_stack+458374,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+525805,int_stack+126945,int_stack+483217,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+851221,int_stack+525805,int_stack+630091,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+437080,int_stack+851221,int_stack+690151,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+851221,int_stack+437080,int_stack+765226,91);
 /*--- compute (op|li) ---*/
 hrr1_build_op(Libint->AB,int_stack+437080,int_stack+851221,int_stack+0,1260);
 /*--- compute (nd|li) ---*/
 hrr1_build_nd(Libint->AB,int_stack+731920,int_stack+437080,int_stack+187600,1260);
 /*--- compute (mf|li) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+731920,int_stack+1262650,1260);
 /*--- compute (lg|li) ---*/
 hrr1_build_lg(Libint->AB,int_stack+693000,int_stack+0,int_stack+1678450,1260);
 return int_stack+693000;}
