/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lgml(Libint_t*, prim_data*);

  /* Computes quartets of (lg|ml) integrals */

REALTYPE *hrr_order_lgml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[8][14] = int_stack + 17775;
 Libint->vrr_classes[8][15] = int_stack + 23175;
 Libint->vrr_classes[8][16] = int_stack + 29295;
 Libint->vrr_classes[8][17] = int_stack + 36180;
 Libint->vrr_classes[9][9] = int_stack + 43875;
 Libint->vrr_classes[9][10] = int_stack + 46900;
 Libint->vrr_classes[9][11] = int_stack + 50530;
 Libint->vrr_classes[9][12] = int_stack + 54820;
 Libint->vrr_classes[9][13] = int_stack + 59825;
 Libint->vrr_classes[9][14] = int_stack + 65600;
 Libint->vrr_classes[9][15] = int_stack + 72200;
 Libint->vrr_classes[9][16] = int_stack + 79680;
 Libint->vrr_classes[9][17] = int_stack + 88095;
 Libint->vrr_classes[10][9] = int_stack + 97500;
 Libint->vrr_classes[10][10] = int_stack + 101130;
 Libint->vrr_classes[10][11] = int_stack + 105486;
 Libint->vrr_classes[10][12] = int_stack + 110634;
 Libint->vrr_classes[10][13] = int_stack + 116640;
 Libint->vrr_classes[10][14] = int_stack + 123570;
 Libint->vrr_classes[10][15] = int_stack + 131490;
 Libint->vrr_classes[10][16] = int_stack + 140466;
 Libint->vrr_classes[10][17] = int_stack + 150564;
 Libint->vrr_classes[11][9] = int_stack + 161850;
 Libint->vrr_classes[11][10] = int_stack + 166140;
 Libint->vrr_classes[11][11] = int_stack + 171288;
 Libint->vrr_classes[11][12] = int_stack + 177372;
 Libint->vrr_classes[11][13] = int_stack + 184470;
 Libint->vrr_classes[11][14] = int_stack + 192660;
 Libint->vrr_classes[11][15] = int_stack + 202020;
 Libint->vrr_classes[11][16] = int_stack + 212628;
 Libint->vrr_classes[11][17] = int_stack + 224562;
 Libint->vrr_classes[12][9] = int_stack + 237900;
 Libint->vrr_classes[12][10] = int_stack + 242905;
 Libint->vrr_classes[12][11] = int_stack + 248911;
 Libint->vrr_classes[12][12] = int_stack + 256009;
 Libint->vrr_classes[12][13] = int_stack + 264290;
 Libint->vrr_classes[12][14] = int_stack + 273845;
 Libint->vrr_classes[12][15] = int_stack + 284765;
 Libint->vrr_classes[12][16] = int_stack + 297141;
 Libint->vrr_classes[12][17] = int_stack + 311064;
 memset(int_stack,0,326625*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 326625;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lgml(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+326625,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+334050,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+342960,int_stack+334050,int_stack+326625,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+357810,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+368340,int_stack+357810,int_stack+334050,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+386160,int_stack+368340,int_stack+342960,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+326625,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+410910,int_stack+326625,int_stack+357810,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+431970,int_stack+410910,int_stack+368340,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+338910,int_stack+431970,int_stack+386160,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+376035,int_stack+17775,int_stack+13050,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+461670,int_stack+376035,int_stack+326625,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+486240,int_stack+461670,int_stack+410910,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+521340,int_stack+486240,int_stack+431970,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+390210,int_stack+521340,int_stack+338910,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+326625,int_stack+23175,int_stack+17775,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+342825,int_stack+326625,int_stack+376035,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+565890,int_stack+342825,int_stack+461670,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+606840,int_stack+565890,int_stack+486240,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+442185,int_stack+606840,int_stack+521340,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+659490,int_stack+442185,int_stack+390210,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+371175,int_stack+29295,int_stack+23175,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+389535,int_stack+371175,int_stack+326625,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+504555,int_stack+389535,int_stack+342825,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+728790,int_stack+504555,int_stack+565890,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+790215,int_stack+728790,int_stack+606840,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+551805,int_stack+790215,int_stack+442185,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+863925,int_stack+551805,int_stack+659490,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+326625,int_stack+36180,int_stack+29295,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+421935,int_stack+326625,int_stack+371175,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+326625,int_stack+421935,int_stack+389535,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+380625,int_stack+326625,int_stack+504555,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+451500,int_stack+380625,int_stack+728790,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+326625,int_stack+451500,int_stack+790215,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+424905,int_stack+326625,int_stack+551805,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+531825,int_stack+424905,int_stack+863925,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+326625,int_stack+46900,int_stack+43875,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+335700,int_stack+50530,int_stack+46900,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+346590,int_stack+335700,int_stack+326625,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+364740,int_stack+54820,int_stack+50530,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+377610,int_stack+364740,int_stack+335700,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+399390,int_stack+377610,int_stack+346590,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+326625,int_stack+59825,int_stack+54820,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+429640,int_stack+326625,int_stack+364740,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+455380,int_stack+429640,int_stack+377610,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+341640,int_stack+455380,int_stack+399390,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+387015,int_stack+65600,int_stack+59825,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+491680,int_stack+387015,int_stack+326625,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+643200,int_stack+491680,int_stack+429640,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+686100,int_stack+643200,int_stack+455380,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+404340,int_stack+686100,int_stack+341640,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+326625,int_stack+72200,int_stack+65600,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+346425,int_stack+326625,int_stack+387015,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+740550,int_stack+346425,int_stack+491680,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+790600,int_stack+740550,int_stack+643200,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+854950,int_stack+790600,int_stack+686100,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+643200,int_stack+854950,int_stack+404340,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+381075,int_stack+79680,int_stack+72200,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+403515,int_stack+381075,int_stack+326625,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+443115,int_stack+403515,int_stack+346425,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+443115,int_stack+740550,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+931180,int_stack+0,int_stack+790600,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+727900,int_stack+931180,int_stack+854950,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1021270,int_stack+727900,int_stack+643200,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+643200,int_stack+88095,int_stack+79680,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+668445,int_stack+643200,int_stack+381075,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+326625,int_stack+668445,int_stack+403515,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+829540,int_stack+326625,int_stack+443115,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+326625,int_stack+829540,int_stack+0,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1130170,int_stack+326625,int_stack+931180,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+326625,int_stack+1130170,int_stack+727900,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+643200,int_stack+326625,int_stack+1021270,55);
 /*--- compute (lp|ml) ---*/
 hrr1_build_lp(Libint->AB,int_stack+779325,int_stack+643200,int_stack+531825,2475);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+326625,int_stack+101130,int_stack+97500,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+337515,int_stack+105486,int_stack+101130,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+350583,int_stack+337515,int_stack+326625,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+372363,int_stack+110634,int_stack+105486,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+387807,int_stack+372363,int_stack+337515,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+413943,int_stack+387807,int_stack+350583,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+326625,int_stack+116640,int_stack+110634,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+450243,int_stack+326625,int_stack+372363,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+481131,int_stack+450243,int_stack+387807,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+344643,int_stack+481131,int_stack+413943,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+399093,int_stack+123570,int_stack+116640,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+524691,int_stack+399093,int_stack+326625,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+560727,int_stack+524691,int_stack+450243,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+560727,int_stack+481131,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+419883,int_stack+0,int_stack+344643,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+326625,int_stack+131490,int_stack+123570,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+350385,int_stack+326625,int_stack+399093,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+65340,int_stack+350385,int_stack+524691,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1113450,int_stack+65340,int_stack+560727,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+496113,int_stack+1113450,int_stack+0,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1190670,int_stack+496113,int_stack+419883,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+140466,int_stack+131490,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+391965,int_stack+0,int_stack+326625,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1292310,int_stack+391965,int_stack+350385,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1361610,int_stack+1292310,int_stack+65340,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+26928,int_stack+1361610,int_stack+1113450,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1451700,int_stack+26928,int_stack+496113,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+439485,int_stack+1451700,int_stack+1190670,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1113450,int_stack+150564,int_stack+140466,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1143744,int_stack+1113450,int_stack+0,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1197600,int_stack+1143744,int_stack+391965,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+326625,int_stack+1197600,int_stack+1292310,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1113450,int_stack+326625,int_stack+1361610,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1239576,int_stack+1113450,int_stack+26928,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1239576,int_stack+1451700,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1113450,int_stack+0,int_stack+439485,66);
 /*--- compute (mp|ml) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1276800,int_stack+1113450,int_stack+643200,2475);
 /*--- compute (ld|ml) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1685175,int_stack+1276800,int_stack+779325,2475);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+166140,int_stack+161850,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+171288,int_stack+166140,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54054,int_stack+177372,int_stack+171288,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+72306,int_stack+54054,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+103194,int_stack+72306,int_stack+28314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+184470,int_stack+177372,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+146094,int_stack+0,int_stack+54054,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+326625,int_stack+146094,int_stack+72306,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+21294,int_stack+326625,int_stack+103194,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+85644,int_stack+192660,int_stack+184470,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+378105,int_stack+85644,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+420693,int_stack+378105,int_stack+146094,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+110214,int_stack+420693,int_stack+326625,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+481533,int_stack+110214,int_stack+21294,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+326625,int_stack+202020,int_stack+192660,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+326625,int_stack+85644,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+571623,int_stack+0,int_stack+378105,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+642603,int_stack+571623,int_stack+420693,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+354705,int_stack+642603,int_stack+110214,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+49140,int_stack+354705,int_stack+481533,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+462813,int_stack+212628,int_stack+202020,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+494637,int_stack+462813,int_stack+326625,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+733863,int_stack+494637,int_stack+0,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+815763,int_stack+733863,int_stack+571623,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+922233,int_stack+815763,int_stack+642603,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+550797,int_stack+922233,int_stack+354705,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2353425,int_stack+550797,int_stack+49140,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+224562,int_stack+212628,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+35802,int_stack+0,int_stack+462813,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+99450,int_stack+35802,int_stack+494637,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+326625,int_stack+99450,int_stack+733863,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+326625,int_stack+815763,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+326625,int_stack+0,int_stack+922233,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+326625,int_stack+550797,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+326625,int_stack+0,int_stack+2353425,78);
 /*--- compute (np|ml) ---*/
 hrr1_build_np(Libint->AB,int_stack+519675,int_stack+326625,int_stack+1113450,2475);
 /*--- compute (md|ml) ---*/
 hrr1_build_md(Libint->AB,int_stack+2353425,int_stack+519675,int_stack+1276800,2475);
 /*--- compute (lf|ml) ---*/
 hrr1_build_lf(Libint->AB,int_stack+3170175,int_stack+2353425,int_stack+1685175,2475);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+242905,int_stack+237900,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+248911,int_stack+242905,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+256009,int_stack+248911,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84357,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+120393,int_stack+84357,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+264290,int_stack+256009,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+170443,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1009725,int_stack+170443,int_stack+84357,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+24843,int_stack+1009725,int_stack+120393,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+99918,int_stack+273845,int_stack+264290,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+213031,int_stack+99918,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1069785,int_stack+213031,int_stack+170443,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1140765,int_stack+1069785,int_stack+1009725,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1230855,int_stack+1140765,int_stack+24843,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1009725,int_stack+284765,int_stack+273845,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+1009725,int_stack+99918,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+57330,int_stack+0,int_stack+213031,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+140140,int_stack+57330,int_stack+1069785,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1335960,int_stack+140140,int_stack+1140765,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1042485,int_stack+1335960,int_stack+1230855,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1182625,int_stack+297141,int_stack+284765,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1219753,int_stack+1182625,int_stack+1009725,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1462086,int_stack+1219753,int_stack+0,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1557636,int_stack+1462086,int_stack+57330,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1681851,int_stack+1557636,int_stack+140140,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1681851,int_stack+1335960,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1830909,int_stack+0,int_stack+1042485,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+168168,int_stack+311064,int_stack+297141,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+209937,int_stack+168168,int_stack+1182625,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1009725,int_stack+209937,int_stack+1219753,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+168168,int_stack+1009725,int_stack+1462086,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1009725,int_stack+168168,int_stack+1557636,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1183626,int_stack+1009725,int_stack+1681851,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1382370,int_stack+1183626,int_stack+0,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+1382370,int_stack+1830909,91);
 /*--- compute (op|ml) ---*/
 hrr1_build_op(Libint->AB,int_stack+1009725,int_stack+0,int_stack+326625,2475);
 /*--- compute (nd|ml) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4283925,int_stack+1009725,int_stack+519675,2475);
 /*--- compute (mf|ml) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+4283925,int_stack+2353425,2475);
 /*--- compute (lg|ml) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1361250,int_stack+0,int_stack+3170175,2475);
 return int_stack+1361250;}
