/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lhkk(Libint_t*, prim_data*);

  /* Computes quartets of (lh|kk) integrals */

REALTYPE *hrr_order_lhkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][7] = int_stack + 0;
 Libint->vrr_classes[8][8] = int_stack + 1620;
 Libint->vrr_classes[8][9] = int_stack + 3645;
 Libint->vrr_classes[8][10] = int_stack + 6120;
 Libint->vrr_classes[8][11] = int_stack + 9090;
 Libint->vrr_classes[8][12] = int_stack + 12600;
 Libint->vrr_classes[8][13] = int_stack + 16695;
 Libint->vrr_classes[8][14] = int_stack + 21420;
 Libint->vrr_classes[9][7] = int_stack + 26820;
 Libint->vrr_classes[9][8] = int_stack + 28800;
 Libint->vrr_classes[9][9] = int_stack + 31275;
 Libint->vrr_classes[9][10] = int_stack + 34300;
 Libint->vrr_classes[9][11] = int_stack + 37930;
 Libint->vrr_classes[9][12] = int_stack + 42220;
 Libint->vrr_classes[9][13] = int_stack + 47225;
 Libint->vrr_classes[9][14] = int_stack + 53000;
 Libint->vrr_classes[10][7] = int_stack + 59600;
 Libint->vrr_classes[10][8] = int_stack + 61976;
 Libint->vrr_classes[10][9] = int_stack + 64946;
 Libint->vrr_classes[10][10] = int_stack + 68576;
 Libint->vrr_classes[10][11] = int_stack + 72932;
 Libint->vrr_classes[10][12] = int_stack + 78080;
 Libint->vrr_classes[10][13] = int_stack + 84086;
 Libint->vrr_classes[10][14] = int_stack + 91016;
 Libint->vrr_classes[11][7] = int_stack + 98936;
 Libint->vrr_classes[11][8] = int_stack + 101744;
 Libint->vrr_classes[11][9] = int_stack + 105254;
 Libint->vrr_classes[11][10] = int_stack + 109544;
 Libint->vrr_classes[11][11] = int_stack + 114692;
 Libint->vrr_classes[11][12] = int_stack + 120776;
 Libint->vrr_classes[11][13] = int_stack + 127874;
 Libint->vrr_classes[11][14] = int_stack + 136064;
 Libint->vrr_classes[12][7] = int_stack + 145424;
 Libint->vrr_classes[12][8] = int_stack + 148700;
 Libint->vrr_classes[12][9] = int_stack + 152795;
 Libint->vrr_classes[12][10] = int_stack + 157800;
 Libint->vrr_classes[12][11] = int_stack + 163806;
 Libint->vrr_classes[12][12] = int_stack + 170904;
 Libint->vrr_classes[12][13] = int_stack + 179185;
 Libint->vrr_classes[12][14] = int_stack + 188740;
 Libint->vrr_classes[13][7] = int_stack + 199660;
 Libint->vrr_classes[13][8] = int_stack + 203440;
 Libint->vrr_classes[13][9] = int_stack + 208165;
 Libint->vrr_classes[13][10] = int_stack + 213940;
 Libint->vrr_classes[13][11] = int_stack + 220870;
 Libint->vrr_classes[13][12] = int_stack + 229060;
 Libint->vrr_classes[13][13] = int_stack + 238615;
 Libint->vrr_classes[13][14] = int_stack + 249640;
 memset(int_stack,0,262240*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 262240;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lhkk(Libint, Data);
   Data++;
 }
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+262240,int_stack+1620,int_stack+0,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+267100,int_stack+3645,int_stack+1620,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+273175,int_stack+267100,int_stack+262240,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+282895,int_stack+6120,int_stack+3645,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+290320,int_stack+282895,int_stack+267100,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+302470,int_stack+290320,int_stack+273175,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+262240,int_stack+9090,int_stack+6120,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+318670,int_stack+262240,int_stack+282895,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+333520,int_stack+318670,int_stack+290320,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+271150,int_stack+333520,int_stack+302470,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+295450,int_stack+12600,int_stack+9090,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+353770,int_stack+295450,int_stack+262240,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+371590,int_stack+353770,int_stack+318670,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+396340,int_stack+371590,int_stack+333520,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+305980,int_stack+396340,int_stack+271150,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+262240,int_stack+16695,int_stack+12600,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+426715,int_stack+262240,int_stack+295450,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+274525,int_stack+426715,int_stack+353770,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+447775,int_stack+274525,int_stack+371590,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+340000,int_stack+447775,int_stack+396340,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+484900,int_stack+340000,int_stack+305980,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+304225,int_stack+21420,int_stack+16695,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+382525,int_stack+304225,int_stack+262240,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+304225,int_stack+382525,int_stack+426715,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+382525,int_stack+304225,int_stack+274525,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+262240,int_stack+382525,int_stack+447775,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+382525,int_stack+262240,int_stack+340000,45);
 /*--- compute (l0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+262240,int_stack+382525,int_stack+484900,45);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+320560,int_stack+28800,int_stack+26820,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+326500,int_stack+31275,int_stack+28800,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+333925,int_stack+326500,int_stack+320560,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+345805,int_stack+34300,int_stack+31275,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+354880,int_stack+345805,int_stack+326500,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+369730,int_stack+354880,int_stack+333925,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+320560,int_stack+37930,int_stack+34300,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+389530,int_stack+320560,int_stack+345805,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+407680,int_stack+389530,int_stack+354880,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+331450,int_stack+407680,int_stack+369730,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+361150,int_stack+42220,int_stack+37930,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+432430,int_stack+361150,int_stack+320560,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+454210,int_stack+432430,int_stack+389530,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+484460,int_stack+454210,int_stack+407680,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+374020,int_stack+484460,int_stack+331450,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+320560,int_stack+47225,int_stack+42220,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+320560,int_stack+361150,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+335575,int_stack+0,int_stack+432430,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+521585,int_stack+335575,int_stack+454210,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+415600,int_stack+521585,int_stack+484460,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+566960,int_stack+415600,int_stack+374020,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+371875,int_stack+53000,int_stack+47225,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+467575,int_stack+371875,int_stack+320560,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+371875,int_stack+467575,int_stack+0,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+371875,int_stack+335575,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+320560,int_stack+0,int_stack+521585,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+467575,int_stack+320560,int_stack+415600,55);
 /*--- compute (m0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+320560,int_stack+467575,int_stack+566960,55);
 /*--- compute (lp|kk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+391840,int_stack+320560,int_stack+262240,1296);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+262240,int_stack+61976,int_stack+59600,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+269368,int_stack+64946,int_stack+61976,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+278278,int_stack+269368,int_stack+262240,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+292534,int_stack+68576,int_stack+64946,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+566800,int_stack+292534,int_stack+269368,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+584620,int_stack+566800,int_stack+278278,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+262240,int_stack+72932,int_stack+68576,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+262240,int_stack+292534,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+275308,int_stack+0,int_stack+566800,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+21780,int_stack+275308,int_stack+584620,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+566800,int_stack+78080,int_stack+72932,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+582244,int_stack+566800,int_stack+262240,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+608380,int_stack+582244,int_stack+0,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+644680,int_stack+608380,int_stack+275308,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+262240,int_stack+644680,int_stack+21780,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+84086,int_stack+78080,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+18018,int_stack+0,int_stack+566800,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+689230,int_stack+18018,int_stack+582244,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+732790,int_stack+689230,int_stack+608380,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+566800,int_stack+732790,int_stack+644680,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+787240,int_stack+566800,int_stack+262240,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+262240,int_stack+91016,int_stack+84086,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+283030,int_stack+262240,int_stack+0,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+629170,int_stack+283030,int_stack+18018,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+629170,int_stack+689230,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+629170,int_stack+0,int_stack+732790,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+629170,int_stack+566800,66);
 /*--- compute (n0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+566800,int_stack+0,int_stack+787240,66);
 /*--- compute (mp|kk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+652336,int_stack+566800,int_stack+320560,1296);
 /*--- compute (ld|kk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+866176,int_stack+652336,int_stack+391840,1296);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+101744,int_stack+98936,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8424,int_stack+105254,int_stack+101744,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+18954,int_stack+8424,int_stack+0,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+35802,int_stack+109544,int_stack+105254,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+48672,int_stack+35802,int_stack+8424,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+69732,int_stack+48672,int_stack+18954,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+114692,int_stack+109544,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+262240,int_stack+0,int_stack+35802,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+287980,int_stack+262240,int_stack+48672,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+15444,int_stack+287980,int_stack+69732,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+57564,int_stack+120776,int_stack+114692,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+75816,int_stack+57564,int_stack+0,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+323080,int_stack+75816,int_stack+262240,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+365980,int_stack+323080,int_stack+287980,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+262240,int_stack+365980,int_stack+15444,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+127874,int_stack+120776,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+418630,int_stack+0,int_stack+57564,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+21294,int_stack+418630,int_stack+75816,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+455134,int_stack+21294,int_stack+323080,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1216096,int_stack+455134,int_stack+365980,78);
 /*--- compute (o0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+321208,int_stack+1216096,int_stack+262240,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+262240,int_stack+136064,int_stack+127874,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+72774,int_stack+262240,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1289806,int_stack+72774,int_stack+418630,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1350646,int_stack+1289806,int_stack+21294,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+1350646,int_stack+455134,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1289806,int_stack+0,int_stack+1216096,78);
 /*--- compute (o0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+0,int_stack+1289806,int_stack+321208,78);
 /*--- compute (np|kk) ---*/
 hrr1_build_np(Libint->AB,int_stack+262240,int_stack+0,int_stack+566800,1296);
 /*--- compute (md|kk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1216096,int_stack+262240,int_stack+652336,1296);
 /*--- compute (lf|kk) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1643776,int_stack+1216096,int_stack+866176,1296);
 /*--- compute (q0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+101088,int_stack+148700,int_stack+145424,91);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+110916,int_stack+152795,int_stack+148700,91);
 /*--- compute (q0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+123201,int_stack+110916,int_stack+101088,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+518848,int_stack+157800,int_stack+152795,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+533863,int_stack+518848,int_stack+110916,91);
 /*--- compute (q0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+558433,int_stack+533863,int_stack+123201,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+101088,int_stack+163806,int_stack+157800,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+119106,int_stack+101088,int_stack+518848,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+591193,int_stack+119106,int_stack+533863,91);
 /*--- compute (q0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+632143,int_stack+591193,int_stack+558433,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+518848,int_stack+170904,int_stack+163806,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+540142,int_stack+518848,int_stack+101088,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+681283,int_stack+540142,int_stack+119106,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+101088,int_stack+681283,int_stack+591193,91);
 /*--- compute (q0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+731333,int_stack+101088,int_stack+632143,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+576178,int_stack+179185,int_stack+170904,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+601021,int_stack+576178,int_stack+518848,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+800129,int_stack+601021,int_stack+540142,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+860189,int_stack+800129,int_stack+681283,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+643609,int_stack+860189,int_stack+101088,91);
 /*--- compute (q0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+935264,int_stack+643609,int_stack+731333,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+101088,int_stack+188740,int_stack+179185,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+129753,int_stack+101088,int_stack+576178,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+518848,int_stack+129753,int_stack+601021,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+101088,int_stack+518848,int_stack+800129,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+518848,int_stack+101088,int_stack+860189,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+729604,int_stack+518848,int_stack+643609,91);
 /*--- compute (q0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+518848,int_stack+729604,int_stack+935264,91);
 /*--- compute (op|kk) ---*/
 hrr1_build_op(Libint->AB,int_stack+636784,int_stack+518848,int_stack+0,1296);
 /*--- compute (nd|kk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2226976,int_stack+636784,int_stack+262240,1296);
 /*--- compute (mf|kk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2740192,int_stack+2226976,int_stack+1216096,1296);
 /*--- compute (lg|kk) ---*/
 hrr1_build_lg(Libint->AB,int_stack+3452992,int_stack+2740192,int_stack+1643776,1296);
 /*--- compute (r0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+262240,int_stack+203440,int_stack+199660,105);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+273580,int_stack+208165,int_stack+203440,105);
 /*--- compute (r0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+287755,int_stack+273580,int_stack+262240,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+310435,int_stack+213940,int_stack+208165,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+327760,int_stack+310435,int_stack+273580,105);
 /*--- compute (r0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+356110,int_stack+327760,int_stack+287755,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+262240,int_stack+220870,int_stack+213940,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+393910,int_stack+262240,int_stack+310435,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+428560,int_stack+393910,int_stack+327760,105);
 /*--- compute (r0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+283030,int_stack+428560,int_stack+356110,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+339730,int_stack+229060,int_stack+220870,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+475810,int_stack+339730,int_stack+262240,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+475810,int_stack+393910,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+57750,int_stack+0,int_stack+428560,105);
 /*--- compute (r0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+364300,int_stack+57750,int_stack+283030,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+262240,int_stack+238615,int_stack+229060,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+128625,int_stack+262240,int_stack+339730,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+290905,int_stack+128625,int_stack+475810,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+940048,int_stack+290905,int_stack+0,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1026673,int_stack+940048,int_stack+57750,105);
 /*--- compute (r0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+0,int_stack+1026673,int_stack+364300,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+360205,int_stack+249640,int_stack+238615,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+393280,int_stack+360205,int_stack+262240,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+177765,int_stack+393280,int_stack+128625,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+360205,int_stack+177765,int_stack+290905,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+105840,int_stack+360205,int_stack+940048,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+227115,int_stack+105840,int_stack+1026673,105);
 /*--- compute (r0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+940048,int_stack+227115,int_stack+0,105);
 /*--- compute (qp|kk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+0,int_stack+940048,int_stack+518848,1296);
 /*--- compute (od|kk) ---*/
 hrr1_build_od(Libint->AB,int_stack+940048,int_stack+0,int_stack+636784,1296);
 /*--- compute (nf|kk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+940048,int_stack+2226976,1296);
 /*--- compute (mg|kk) ---*/
 hrr1_build_mg(Libint->AB,int_stack+855360,int_stack+0,int_stack+2740192,1296);
 /*--- compute (lh|kk) ---*/
 hrr1_build_lh(Libint->AB,int_stack+1924560,int_stack+855360,int_stack+3452992,1296);
 return int_stack+1924560;}
