/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lhml(Libint_t*, prim_data*);

  /* Computes quartets of (lh|ml) integrals */

REALTYPE *hrr_order_lhml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[8][14] = int_stack + 17775;
 Libint->vrr_classes[8][15] = int_stack + 23175;
 Libint->vrr_classes[8][16] = int_stack + 29295;
 Libint->vrr_classes[8][17] = int_stack + 36180;
 Libint->vrr_classes[9][9] = int_stack + 43875;
 Libint->vrr_classes[9][10] = int_stack + 46900;
 Libint->vrr_classes[9][11] = int_stack + 50530;
 Libint->vrr_classes[9][12] = int_stack + 54820;
 Libint->vrr_classes[9][13] = int_stack + 59825;
 Libint->vrr_classes[9][14] = int_stack + 65600;
 Libint->vrr_classes[9][15] = int_stack + 72200;
 Libint->vrr_classes[9][16] = int_stack + 79680;
 Libint->vrr_classes[9][17] = int_stack + 88095;
 Libint->vrr_classes[10][9] = int_stack + 97500;
 Libint->vrr_classes[10][10] = int_stack + 101130;
 Libint->vrr_classes[10][11] = int_stack + 105486;
 Libint->vrr_classes[10][12] = int_stack + 110634;
 Libint->vrr_classes[10][13] = int_stack + 116640;
 Libint->vrr_classes[10][14] = int_stack + 123570;
 Libint->vrr_classes[10][15] = int_stack + 131490;
 Libint->vrr_classes[10][16] = int_stack + 140466;
 Libint->vrr_classes[10][17] = int_stack + 150564;
 Libint->vrr_classes[11][9] = int_stack + 161850;
 Libint->vrr_classes[11][10] = int_stack + 166140;
 Libint->vrr_classes[11][11] = int_stack + 171288;
 Libint->vrr_classes[11][12] = int_stack + 177372;
 Libint->vrr_classes[11][13] = int_stack + 184470;
 Libint->vrr_classes[11][14] = int_stack + 192660;
 Libint->vrr_classes[11][15] = int_stack + 202020;
 Libint->vrr_classes[11][16] = int_stack + 212628;
 Libint->vrr_classes[11][17] = int_stack + 224562;
 Libint->vrr_classes[12][9] = int_stack + 237900;
 Libint->vrr_classes[12][10] = int_stack + 242905;
 Libint->vrr_classes[12][11] = int_stack + 248911;
 Libint->vrr_classes[12][12] = int_stack + 256009;
 Libint->vrr_classes[12][13] = int_stack + 264290;
 Libint->vrr_classes[12][14] = int_stack + 273845;
 Libint->vrr_classes[12][15] = int_stack + 284765;
 Libint->vrr_classes[12][16] = int_stack + 297141;
 Libint->vrr_classes[12][17] = int_stack + 311064;
 Libint->vrr_classes[13][9] = int_stack + 326625;
 Libint->vrr_classes[13][10] = int_stack + 332400;
 Libint->vrr_classes[13][11] = int_stack + 339330;
 Libint->vrr_classes[13][12] = int_stack + 347520;
 Libint->vrr_classes[13][13] = int_stack + 357075;
 Libint->vrr_classes[13][14] = int_stack + 368100;
 Libint->vrr_classes[13][15] = int_stack + 380700;
 Libint->vrr_classes[13][16] = int_stack + 394980;
 Libint->vrr_classes[13][17] = int_stack + 411045;
 memset(int_stack,0,429000*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 429000;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lhml(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+429000,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+436425,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+445335,int_stack+436425,int_stack+429000,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+460185,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+470715,int_stack+460185,int_stack+436425,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+488535,int_stack+470715,int_stack+445335,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+429000,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+513285,int_stack+429000,int_stack+460185,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+534345,int_stack+513285,int_stack+470715,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+441285,int_stack+534345,int_stack+488535,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+478410,int_stack+17775,int_stack+13050,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+564045,int_stack+478410,int_stack+429000,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+588615,int_stack+564045,int_stack+513285,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+623715,int_stack+588615,int_stack+534345,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+492585,int_stack+623715,int_stack+441285,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+429000,int_stack+23175,int_stack+17775,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+445200,int_stack+429000,int_stack+478410,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+668265,int_stack+445200,int_stack+564045,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+709215,int_stack+668265,int_stack+588615,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+544560,int_stack+709215,int_stack+623715,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+761865,int_stack+544560,int_stack+492585,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+473550,int_stack+29295,int_stack+23175,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+491910,int_stack+473550,int_stack+429000,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+606930,int_stack+491910,int_stack+445200,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+831165,int_stack+606930,int_stack+668265,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+892590,int_stack+831165,int_stack+709215,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+654180,int_stack+892590,int_stack+544560,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+966300,int_stack+654180,int_stack+761865,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+429000,int_stack+36180,int_stack+29295,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+524310,int_stack+429000,int_stack+473550,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+429000,int_stack+524310,int_stack+491910,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+483000,int_stack+429000,int_stack+606930,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+553875,int_stack+483000,int_stack+831165,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+429000,int_stack+553875,int_stack+892590,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+527280,int_stack+429000,int_stack+654180,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+634200,int_stack+527280,int_stack+966300,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+429000,int_stack+46900,int_stack+43875,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+438075,int_stack+50530,int_stack+46900,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+448965,int_stack+438075,int_stack+429000,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+467115,int_stack+54820,int_stack+50530,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+479985,int_stack+467115,int_stack+438075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+501765,int_stack+479985,int_stack+448965,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+429000,int_stack+59825,int_stack+54820,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+532015,int_stack+429000,int_stack+467115,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+557755,int_stack+532015,int_stack+479985,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+444015,int_stack+557755,int_stack+501765,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+489390,int_stack+65600,int_stack+59825,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+594055,int_stack+489390,int_stack+429000,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+745575,int_stack+594055,int_stack+532015,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+788475,int_stack+745575,int_stack+557755,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+506715,int_stack+788475,int_stack+444015,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+429000,int_stack+72200,int_stack+65600,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+448800,int_stack+429000,int_stack+489390,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+842925,int_stack+448800,int_stack+594055,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+892975,int_stack+842925,int_stack+745575,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+957325,int_stack+892975,int_stack+788475,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+745575,int_stack+957325,int_stack+506715,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+483450,int_stack+79680,int_stack+72200,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+505890,int_stack+483450,int_stack+429000,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+545490,int_stack+505890,int_stack+448800,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+545490,int_stack+842925,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1033555,int_stack+0,int_stack+892975,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+830275,int_stack+1033555,int_stack+957325,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1123645,int_stack+830275,int_stack+745575,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+745575,int_stack+88095,int_stack+79680,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+770820,int_stack+745575,int_stack+483450,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+429000,int_stack+770820,int_stack+505890,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+931915,int_stack+429000,int_stack+545490,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+429000,int_stack+931915,int_stack+0,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1232545,int_stack+429000,int_stack+1033555,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+429000,int_stack+1232545,int_stack+830275,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+745575,int_stack+429000,int_stack+1123645,55);
 /*--- compute (lp|ml) ---*/
 hrr1_build_lp(Libint->AB,int_stack+881700,int_stack+745575,int_stack+634200,2475);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+429000,int_stack+101130,int_stack+97500,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+439890,int_stack+105486,int_stack+101130,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+452958,int_stack+439890,int_stack+429000,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+474738,int_stack+110634,int_stack+105486,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+490182,int_stack+474738,int_stack+439890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+516318,int_stack+490182,int_stack+452958,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+429000,int_stack+116640,int_stack+110634,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+552618,int_stack+429000,int_stack+474738,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+583506,int_stack+552618,int_stack+490182,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+447018,int_stack+583506,int_stack+516318,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+501468,int_stack+123570,int_stack+116640,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+627066,int_stack+501468,int_stack+429000,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+663102,int_stack+627066,int_stack+552618,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+663102,int_stack+583506,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+522258,int_stack+0,int_stack+447018,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+429000,int_stack+131490,int_stack+123570,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+452760,int_stack+429000,int_stack+501468,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+65340,int_stack+452760,int_stack+627066,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1215825,int_stack+65340,int_stack+663102,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+598488,int_stack+1215825,int_stack+0,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1293045,int_stack+598488,int_stack+522258,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+140466,int_stack+131490,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+494340,int_stack+0,int_stack+429000,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1394685,int_stack+494340,int_stack+452760,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1463985,int_stack+1394685,int_stack+65340,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+26928,int_stack+1463985,int_stack+1215825,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1554075,int_stack+26928,int_stack+598488,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+541860,int_stack+1554075,int_stack+1293045,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1215825,int_stack+150564,int_stack+140466,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1246119,int_stack+1215825,int_stack+0,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1299975,int_stack+1246119,int_stack+494340,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+429000,int_stack+1299975,int_stack+1394685,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1215825,int_stack+429000,int_stack+1463985,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1341951,int_stack+1215825,int_stack+26928,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1341951,int_stack+1554075,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1215825,int_stack+0,int_stack+541860,66);
 /*--- compute (mp|ml) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1379175,int_stack+1215825,int_stack+745575,2475);
 /*--- compute (ld|ml) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1787550,int_stack+1379175,int_stack+881700,2475);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+166140,int_stack+161850,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+171288,int_stack+166140,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54054,int_stack+177372,int_stack+171288,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+72306,int_stack+54054,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+103194,int_stack+72306,int_stack+28314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+184470,int_stack+177372,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+146094,int_stack+0,int_stack+54054,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+429000,int_stack+146094,int_stack+72306,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+21294,int_stack+429000,int_stack+103194,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+85644,int_stack+192660,int_stack+184470,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+480480,int_stack+85644,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+523068,int_stack+480480,int_stack+146094,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+110214,int_stack+523068,int_stack+429000,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+583908,int_stack+110214,int_stack+21294,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+429000,int_stack+202020,int_stack+192660,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+429000,int_stack+85644,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+673998,int_stack+0,int_stack+480480,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+744978,int_stack+673998,int_stack+523068,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+457080,int_stack+744978,int_stack+110214,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+49140,int_stack+457080,int_stack+583908,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+565188,int_stack+212628,int_stack+202020,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+597012,int_stack+565188,int_stack+429000,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+836238,int_stack+597012,int_stack+0,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+918138,int_stack+836238,int_stack+673998,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1024608,int_stack+918138,int_stack+744978,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+653172,int_stack+1024608,int_stack+457080,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2455800,int_stack+653172,int_stack+49140,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+224562,int_stack+212628,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+35802,int_stack+0,int_stack+565188,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+99450,int_stack+35802,int_stack+597012,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+429000,int_stack+99450,int_stack+836238,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+429000,int_stack+918138,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+429000,int_stack+0,int_stack+1024608,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+429000,int_stack+653172,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+429000,int_stack+0,int_stack+2455800,78);
 /*--- compute (np|ml) ---*/
 hrr1_build_np(Libint->AB,int_stack+622050,int_stack+429000,int_stack+1215825,2475);
 /*--- compute (md|ml) ---*/
 hrr1_build_md(Libint->AB,int_stack+2455800,int_stack+622050,int_stack+1379175,2475);
 /*--- compute (lf|ml) ---*/
 hrr1_build_lf(Libint->AB,int_stack+3272550,int_stack+2455800,int_stack+1787550,2475);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+242905,int_stack+237900,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+248911,int_stack+242905,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+256009,int_stack+248911,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84357,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+120393,int_stack+84357,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+264290,int_stack+256009,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+170443,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1112100,int_stack+170443,int_stack+84357,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+24843,int_stack+1112100,int_stack+120393,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+99918,int_stack+273845,int_stack+264290,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+213031,int_stack+99918,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1172160,int_stack+213031,int_stack+170443,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1243140,int_stack+1172160,int_stack+1112100,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1333230,int_stack+1243140,int_stack+24843,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1112100,int_stack+284765,int_stack+273845,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+1112100,int_stack+99918,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+57330,int_stack+0,int_stack+213031,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+140140,int_stack+57330,int_stack+1172160,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1438335,int_stack+140140,int_stack+1243140,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1144860,int_stack+1438335,int_stack+1333230,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1285000,int_stack+297141,int_stack+284765,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1322128,int_stack+1285000,int_stack+1112100,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1564461,int_stack+1322128,int_stack+0,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1660011,int_stack+1564461,int_stack+57330,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1784226,int_stack+1660011,int_stack+140140,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1784226,int_stack+1438335,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1933284,int_stack+0,int_stack+1144860,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+168168,int_stack+311064,int_stack+297141,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+209937,int_stack+168168,int_stack+1285000,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1112100,int_stack+209937,int_stack+1322128,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+168168,int_stack+1112100,int_stack+1564461,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1112100,int_stack+168168,int_stack+1660011,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1286001,int_stack+1112100,int_stack+1784226,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1484745,int_stack+1286001,int_stack+0,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+1484745,int_stack+1933284,91);
 /*--- compute (op|ml) ---*/
 hrr1_build_op(Libint->AB,int_stack+1112100,int_stack+0,int_stack+429000,2475);
 /*--- compute (nd|ml) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4386300,int_stack+1112100,int_stack+622050,2475);
 /*--- compute (mf|ml) ---*/
 hrr1_build_mf(Libint->AB,int_stack+5366400,int_stack+4386300,int_stack+2455800,2475);
 /*--- compute (lg|ml) ---*/
 hrr1_build_lg(Libint->AB,int_stack+6727650,int_stack+5366400,int_stack+3272550,2475);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+429000,int_stack+332400,int_stack+326625,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+446325,int_stack+339330,int_stack+332400,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+467115,int_stack+446325,int_stack+429000,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+501765,int_stack+347520,int_stack+339330,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+526335,int_stack+501765,int_stack+446325,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+567915,int_stack+526335,int_stack+467115,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+429000,int_stack+357075,int_stack+347520,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+625665,int_stack+429000,int_stack+501765,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+674805,int_stack+625665,int_stack+526335,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+457665,int_stack+674805,int_stack+567915,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+544290,int_stack+368100,int_stack+357075,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+744105,int_stack+544290,int_stack+429000,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+801435,int_stack+744105,int_stack+625665,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+883335,int_stack+801435,int_stack+674805,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+577365,int_stack+883335,int_stack+457665,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+429000,int_stack+380700,int_stack+368100,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+466800,int_stack+429000,int_stack+544290,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+987285,int_stack+466800,int_stack+744105,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+225225,int_stack+987285,int_stack+801435,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+698640,int_stack+225225,int_stack+883335,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1691250,int_stack+698640,int_stack+577365,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+532950,int_stack+394980,int_stack+380700,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+575790,int_stack+532950,int_stack+429000,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+844170,int_stack+575790,int_stack+466800,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1852950,int_stack+844170,int_stack+987285,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1996275,int_stack+1852950,int_stack+225225,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2168265,int_stack+1996275,int_stack+698640,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2362305,int_stack+2168265,int_stack+1691250,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1691250,int_stack+411045,int_stack+394980,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1739445,int_stack+1691250,int_stack+532950,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+225225,int_stack+1739445,int_stack+575790,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+351225,int_stack+225225,int_stack+844170,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+516600,int_stack+351225,int_stack+1852950,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+225225,int_stack+516600,int_stack+1996275,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+454545,int_stack+225225,int_stack+2168265,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+704025,int_stack+454545,int_stack+2362305,105);
 /*--- compute (qp|ml) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1691250,int_stack+704025,int_stack+0,2475);
 /*--- compute (od|ml) ---*/
 hrr1_build_od(Libint->AB,int_stack+2366925,int_stack+1691250,int_stack+1112100,2475);
 /*--- compute (nf|ml) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+2366925,int_stack+4386300,2475);
 /*--- compute (mg|ml) ---*/
 hrr1_build_mg(Libint->AB,int_stack+1633500,int_stack+0,int_stack+5366400,2475);
 /*--- compute (lh|ml) ---*/
 hrr1_build_lh(Libint->AB,int_stack+3675375,int_stack+1633500,int_stack+6727650,2475);
 return int_stack+3675375;}
