/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lini(Libint_t*, prim_data*);

  /* Computes quartets of (li|ni) integrals */

REALTYPE *hrr_order_lini(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[8][15] = int_stack + 20700;
 Libint->vrr_classes[8][16] = int_stack + 26820;
 Libint->vrr_classes[9][10] = int_stack + 33705;
 Libint->vrr_classes[9][11] = int_stack + 37335;
 Libint->vrr_classes[9][12] = int_stack + 41625;
 Libint->vrr_classes[9][13] = int_stack + 46630;
 Libint->vrr_classes[9][14] = int_stack + 52405;
 Libint->vrr_classes[9][15] = int_stack + 59005;
 Libint->vrr_classes[9][16] = int_stack + 66485;
 Libint->vrr_classes[10][10] = int_stack + 74900;
 Libint->vrr_classes[10][11] = int_stack + 79256;
 Libint->vrr_classes[10][12] = int_stack + 84404;
 Libint->vrr_classes[10][13] = int_stack + 90410;
 Libint->vrr_classes[10][14] = int_stack + 97340;
 Libint->vrr_classes[10][15] = int_stack + 105260;
 Libint->vrr_classes[10][16] = int_stack + 114236;
 Libint->vrr_classes[11][10] = int_stack + 124334;
 Libint->vrr_classes[11][11] = int_stack + 129482;
 Libint->vrr_classes[11][12] = int_stack + 135566;
 Libint->vrr_classes[11][13] = int_stack + 142664;
 Libint->vrr_classes[11][14] = int_stack + 150854;
 Libint->vrr_classes[11][15] = int_stack + 160214;
 Libint->vrr_classes[11][16] = int_stack + 170822;
 Libint->vrr_classes[12][10] = int_stack + 182756;
 Libint->vrr_classes[12][11] = int_stack + 188762;
 Libint->vrr_classes[12][12] = int_stack + 195860;
 Libint->vrr_classes[12][13] = int_stack + 204141;
 Libint->vrr_classes[12][14] = int_stack + 213696;
 Libint->vrr_classes[12][15] = int_stack + 224616;
 Libint->vrr_classes[12][16] = int_stack + 236992;
 Libint->vrr_classes[13][10] = int_stack + 250915;
 Libint->vrr_classes[13][11] = int_stack + 257845;
 Libint->vrr_classes[13][12] = int_stack + 266035;
 Libint->vrr_classes[13][13] = int_stack + 275590;
 Libint->vrr_classes[13][14] = int_stack + 286615;
 Libint->vrr_classes[13][15] = int_stack + 299215;
 Libint->vrr_classes[13][16] = int_stack + 313495;
 Libint->vrr_classes[14][10] = int_stack + 329560;
 Libint->vrr_classes[14][11] = int_stack + 337480;
 Libint->vrr_classes[14][12] = int_stack + 346840;
 Libint->vrr_classes[14][13] = int_stack + 357760;
 Libint->vrr_classes[14][14] = int_stack + 370360;
 Libint->vrr_classes[14][15] = int_stack + 384760;
 Libint->vrr_classes[14][16] = int_stack + 401080;
 memset(int_stack,0,419440*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 419440;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lini(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+419440,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+428350,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+438880,int_stack+428350,int_stack+419440,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+456700,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+468985,int_stack+456700,int_stack+428350,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+490045,int_stack+468985,int_stack+438880,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+419440,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+519745,int_stack+419440,int_stack+456700,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+433615,int_stack+519745,int_stack+468985,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+544315,int_stack+433615,int_stack+490045,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+468715,int_stack+20700,int_stack+15300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+484915,int_stack+468715,int_stack+419440,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+588865,int_stack+484915,int_stack+519745,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+629815,int_stack+588865,int_stack+433615,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+682465,int_stack+629815,int_stack+544315,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+419440,int_stack+26820,int_stack+20700,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+513265,int_stack+419440,int_stack+468715,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+419440,int_stack+513265,int_stack+484915,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+466690,int_stack+419440,int_stack+588865,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+528115,int_stack+466690,int_stack+629815,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+419440,int_stack+528115,int_stack+682465,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+502600,int_stack+37335,int_stack+33705,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+513490,int_stack+41625,int_stack+37335,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+526360,int_stack+513490,int_stack+502600,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+548140,int_stack+46630,int_stack+41625,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+563155,int_stack+548140,int_stack+513490,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+588895,int_stack+563155,int_stack+526360,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+502600,int_stack+52405,int_stack+46630,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+625195,int_stack+502600,int_stack+548140,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+519925,int_stack+625195,int_stack+563155,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+655225,int_stack+519925,int_stack+588895,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+562825,int_stack+59005,int_stack+52405,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+582625,int_stack+562825,int_stack+502600,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+582625,int_stack+625195,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+709675,int_stack+0,int_stack+519925,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+774025,int_stack+709675,int_stack+655225,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+502600,int_stack+66485,int_stack+59005,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+617275,int_stack+502600,int_stack+562825,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+502600,int_stack+617275,int_stack+582625,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+560350,int_stack+502600,int_stack+0,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+850255,int_stack+560350,int_stack+709675,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+502600,int_stack+850255,int_stack+774025,55);
 /*--- compute (lp|ni) ---*/
 hrr1_build_lp(Libint->AB,int_stack+604240,int_stack+502600,int_stack+419440,1848);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+419440,int_stack+79256,int_stack+74900,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+432508,int_stack+84404,int_stack+79256,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+447952,int_stack+432508,int_stack+419440,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+474088,int_stack+90410,int_stack+84404,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+474088,int_stack+432508,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+30888,int_stack+0,int_stack+447952,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+419440,int_stack+97340,int_stack+90410,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+853720,int_stack+419440,int_stack+474088,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+440230,int_stack+853720,int_stack+0,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+889756,int_stack+440230,int_stack+30888,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+105260,int_stack+97340,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+23760,int_stack+0,int_stack+419440,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+955096,int_stack+23760,int_stack+853720,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1015156,int_stack+955096,int_stack+440230,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1092376,int_stack+1015156,int_stack+889756,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+853720,int_stack+114236,int_stack+105260,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+880648,int_stack+853720,int_stack+0,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+419440,int_stack+880648,int_stack+23760,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+419440,int_stack+955096,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+853720,int_stack+0,int_stack+1015156,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+853720,int_stack+1092376,66);
 /*--- compute (mp|ni) ---*/
 hrr1_build_mp(Libint->AB,int_stack+853720,int_stack+0,int_stack+502600,1848);
 /*--- compute (ld|ni) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1158640,int_stack+853720,int_stack+604240,1848);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+419440,int_stack+129482,int_stack+124334,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+434884,int_stack+135566,int_stack+129482,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+453136,int_stack+434884,int_stack+419440,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+484024,int_stack+142664,int_stack+135566,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+505318,int_stack+484024,int_stack+434884,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+541822,int_stack+505318,int_stack+453136,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+419440,int_stack+150854,int_stack+142664,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+593302,int_stack+419440,int_stack+484024,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+444010,int_stack+593302,int_stack+505318,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+635890,int_stack+444010,int_stack+541822,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+504850,int_stack+160214,int_stack+150854,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+532930,int_stack+504850,int_stack+419440,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+713110,int_stack+532930,int_stack+593302,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1657600,int_stack+713110,int_stack+444010,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1748860,int_stack+1657600,int_stack+635890,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+419440,int_stack+170822,int_stack+160214,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+582070,int_stack+419440,int_stack+504850,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+419440,int_stack+582070,int_stack+532930,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+501340,int_stack+419440,int_stack+713110,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+607810,int_stack+501340,int_stack+1657600,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+419440,int_stack+607810,int_stack+1748860,78);
 /*--- compute (np|ni) ---*/
 hrr1_build_np(Libint->AB,int_stack+1657600,int_stack+419440,int_stack+0,1848);
 /*--- compute (md|ni) ---*/
 hrr1_build_md(Libint->AB,int_stack+2023504,int_stack+1657600,int_stack+853720,1848);
 /*--- compute (lf|ni) ---*/
 hrr1_build_lf(Libint->AB,int_stack+2633344,int_stack+2023504,int_stack+1158640,1848);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+188762,int_stack+182756,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+195860,int_stack+188762,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+204141,int_stack+195860,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142779,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+213696,int_stack+204141,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+563584,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+563584,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+613270,int_stack+28665,int_stack+142779,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99645,int_stack+224616,int_stack+213696,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+132405,int_stack+99645,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+703360,int_stack+132405,int_stack+563584,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+786170,int_stack+703360,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+892640,int_stack+786170,int_stack+613270,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+563584,int_stack+236992,int_stack+224616,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+600712,int_stack+563584,int_stack+99645,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+600712,int_stack+132405,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+563584,int_stack+0,int_stack+703360,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+563584,int_stack+786170,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+563584,int_stack+0,int_stack+892640,91);
 /*--- compute (op|ni) ---*/
 hrr1_build_op(Libint->AB,int_stack+731752,int_stack+563584,int_stack+419440,1848);
 /*--- compute (nd|ni) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3464944,int_stack+731752,int_stack+1657600,1848);
 /*--- compute (mf|ni) ---*/
 hrr1_build_mf(Libint->AB,int_stack+4196752,int_stack+3464944,int_stack+2023504,1848);
 /*--- compute (lg|ni) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1164184,int_stack+4196752,int_stack+2633344,1848);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+419440,int_stack+257845,int_stack+250915,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+440230,int_stack+266035,int_stack+257845,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+464800,int_stack+440230,int_stack+419440,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+506380,int_stack+275590,int_stack+266035,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+506380,int_stack+440230,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+49140,int_stack+0,int_stack+464800,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+419440,int_stack+286615,int_stack+275590,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+118440,int_stack+419440,int_stack+506380,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+452515,int_stack+118440,int_stack+0,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+175770,int_stack+452515,int_stack+49140,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+299215,int_stack+286615,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+37800,int_stack+0,int_stack+419440,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2411584,int_stack+37800,int_stack+118440,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2507134,int_stack+2411584,int_stack+452515,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2629984,int_stack+2507134,int_stack+175770,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+419440,int_stack+313495,int_stack+299215,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+462280,int_stack+419440,int_stack+0,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+103950,int_stack+462280,int_stack+37800,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+419440,int_stack+103950,int_stack+2411584,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+419440,int_stack+2507134,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2411584,int_stack+0,int_stack+2629984,105);
 /*--- compute (qp|ni) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2605624,int_stack+2411584,int_stack+563584,1848);
 /*--- compute (od|ni) ---*/
 hrr1_build_od(Libint->AB,int_stack+5213152,int_stack+2605624,int_stack+731752,1848);
 /*--- compute (nf|ni) ---*/
 hrr1_build_nf(Libint->AB,int_stack+6078016,int_stack+5213152,int_stack+3464944,1848);
 /*--- compute (mg|ni) ---*/
 hrr1_build_mg(Libint->AB,int_stack+7297696,int_stack+6078016,int_stack+4196752,1848);
 /*--- compute (lh|ni) ---*/
 hrr1_build_lh(Libint->AB,int_stack+3110128,int_stack+7297696,int_stack+1164184,1848);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+337480,int_stack+329560,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+23760,int_stack+346840,int_stack+337480,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51840,int_stack+23760,int_stack+0,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+99360,int_stack+357760,int_stack+346840,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+132120,int_stack+99360,int_stack+23760,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+188280,int_stack+132120,int_stack+51840,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+370360,int_stack+357760,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+267480,int_stack+0,int_stack+99360,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37800,int_stack+267480,int_stack+132120,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+419440,int_stack+37800,int_stack+188280,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+131400,int_stack+384760,int_stack+370360,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+174600,int_stack+131400,int_stack+0,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+538240,int_stack+174600,int_stack+267480,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+647440,int_stack+538240,int_stack+37800,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+787840,int_stack+647440,int_stack+419440,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+419440,int_stack+401080,int_stack+384760,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+419440,int_stack+131400,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+250200,int_stack+0,int_stack+174600,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+250200,int_stack+538240,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+163800,int_stack+0,int_stack+647440,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+360360,int_stack+163800,int_stack+787840,120);
 /*--- compute (rp|ni) ---*/
 hrr1_build_rp(Libint->AB,int_stack+582120,int_stack+360360,int_stack+2411584,1848);
 /*--- compute (qd|ni) ---*/
 hrr1_build_qd(Libint->AB,int_stack+1164240,int_stack+582120,int_stack+2605624,1848);
 /*--- compute (of|ni) ---*/
 hrr1_build_of(Libint->AB,int_stack+8822296,int_stack+1164240,int_stack+5213152,1848);
 /*--- compute (ng|ni) ---*/
 hrr1_build_ng(Libint->AB,int_stack+0,int_stack+8822296,int_stack+6078016,1848);
 /*--- compute (mh|ni) ---*/
 hrr1_build_mh(Libint->AB,int_stack+4856488,int_stack+0,int_stack+7297696,1848);
 /*--- compute (li|ni) ---*/
 hrr1_build_li(Libint->AB,int_stack+0,int_stack+4856488,int_stack+3110128,1848);
 return int_stack+0;}
