/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lplg(Libint_t*, prim_data*);

  /* Computes quartets of (lp|lg) integrals */

REALTYPE *hrr_order_lplg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][8] = int_stack + 0;
 Libint->vrr_classes[8][9] = int_stack + 2025;
 Libint->vrr_classes[8][10] = int_stack + 4500;
 Libint->vrr_classes[8][11] = int_stack + 7470;
 Libint->vrr_classes[8][12] = int_stack + 10980;
 Libint->vrr_classes[9][8] = int_stack + 15075;
 Libint->vrr_classes[9][9] = int_stack + 17550;
 Libint->vrr_classes[9][10] = int_stack + 20575;
 Libint->vrr_classes[9][11] = int_stack + 24205;
 Libint->vrr_classes[9][12] = int_stack + 28495;
 memset(int_stack,0,33500*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 33500;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lplg(Libint, Data);
   Data++;
 }
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+33500,int_stack+2025,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+39575,int_stack+4500,int_stack+2025,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+47000,int_stack+39575,int_stack+33500,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59150,int_stack+7470,int_stack+4500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+68060,int_stack+59150,int_stack+39575,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+82910,int_stack+68060,int_stack+47000,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33500,int_stack+10980,int_stack+7470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+103160,int_stack+33500,int_stack+59150,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+33500,int_stack+103160,int_stack+68060,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+103160,int_stack+33500,int_stack+82910,45);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+33500,int_stack+17550,int_stack+15075,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+40925,int_stack+20575,int_stack+17550,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+50000,int_stack+40925,int_stack+33500,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+64850,int_stack+24205,int_stack+20575,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+75740,int_stack+64850,int_stack+40925,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+133535,int_stack+75740,int_stack+50000,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33500,int_stack+28495,int_stack+24205,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+33500,int_stack+64850,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+21780,int_stack+0,int_stack+75740,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+52030,int_stack+21780,int_stack+133535,55);
 /*--- compute (lp|lg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+133535,int_stack+52030,int_stack+103160,675);
 return int_stack+133535;}
