/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lplk(Libint_t*, prim_data*);

  /* Computes quartets of (lp|lk) integrals */

REALTYPE *hrr_order_lplk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][8] = int_stack + 0;
 Libint->vrr_classes[8][9] = int_stack + 2025;
 Libint->vrr_classes[8][10] = int_stack + 4500;
 Libint->vrr_classes[8][11] = int_stack + 7470;
 Libint->vrr_classes[8][12] = int_stack + 10980;
 Libint->vrr_classes[8][13] = int_stack + 15075;
 Libint->vrr_classes[8][14] = int_stack + 19800;
 Libint->vrr_classes[8][15] = int_stack + 25200;
 Libint->vrr_classes[9][8] = int_stack + 31320;
 Libint->vrr_classes[9][9] = int_stack + 33795;
 Libint->vrr_classes[9][10] = int_stack + 36820;
 Libint->vrr_classes[9][11] = int_stack + 40450;
 Libint->vrr_classes[9][12] = int_stack + 44740;
 Libint->vrr_classes[9][13] = int_stack + 49745;
 Libint->vrr_classes[9][14] = int_stack + 55520;
 Libint->vrr_classes[9][15] = int_stack + 62120;
 memset(int_stack,0,69600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 69600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lplk(Libint, Data);
   Data++;
 }
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+69600,int_stack+2025,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+75675,int_stack+4500,int_stack+2025,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+83100,int_stack+75675,int_stack+69600,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+95250,int_stack+7470,int_stack+4500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+104160,int_stack+95250,int_stack+75675,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+119010,int_stack+104160,int_stack+83100,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+69600,int_stack+10980,int_stack+7470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+139260,int_stack+69600,int_stack+95250,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+157080,int_stack+139260,int_stack+104160,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+80130,int_stack+157080,int_stack+119010,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+110505,int_stack+15075,int_stack+10980,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+181830,int_stack+110505,int_stack+69600,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+202890,int_stack+181830,int_stack+139260,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+232590,int_stack+202890,int_stack+157080,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+122790,int_stack+232590,int_stack+80130,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+69600,int_stack+19800,int_stack+15075,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+83775,int_stack+69600,int_stack+110505,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+269715,int_stack+83775,int_stack+181830,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+304815,int_stack+269715,int_stack+202890,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+165315,int_stack+304815,int_stack+232590,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+349365,int_stack+165315,int_stack+122790,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+108345,int_stack+25200,int_stack+19800,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+124545,int_stack+108345,int_stack+69600,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+217290,int_stack+124545,int_stack+83775,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+69600,int_stack+217290,int_stack+269715,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+217290,int_stack+69600,int_stack+304815,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+69600,int_stack+217290,int_stack+165315,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+138900,int_stack+69600,int_stack+349365,45);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+69600,int_stack+33795,int_stack+31320,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+77025,int_stack+36820,int_stack+33795,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+86100,int_stack+77025,int_stack+69600,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+100950,int_stack+40450,int_stack+36820,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+111840,int_stack+100950,int_stack+77025,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+211800,int_stack+111840,int_stack+86100,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+69600,int_stack+44740,int_stack+40450,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+236550,int_stack+69600,int_stack+100950,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+258330,int_stack+236550,int_stack+111840,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+82470,int_stack+258330,int_stack+211800,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+211800,int_stack+49745,int_stack+44740,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+288580,int_stack+211800,int_stack+69600,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+314320,int_stack+288580,int_stack+236550,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+350620,int_stack+314320,int_stack+258330,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+226815,int_stack+350620,int_stack+82470,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+69600,int_stack+55520,int_stack+49745,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+86925,int_stack+69600,int_stack+211800,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+86925,int_stack+288580,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+395995,int_stack+0,int_stack+314320,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+278790,int_stack+395995,int_stack+350620,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+450445,int_stack+278790,int_stack+226815,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+211800,int_stack+62120,int_stack+55520,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+231600,int_stack+211800,int_stack+69600,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+342315,int_stack+231600,int_stack+86925,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+211800,int_stack+342315,int_stack+0,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+211800,int_stack+395995,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+342315,int_stack+0,int_stack+278790,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+0,int_stack+342315,int_stack+450445,55);
 /*--- compute (lp|lk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+211800,int_stack+0,int_stack+138900,1620);
 return int_stack+211800;}
