/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mdnl(Libint_t*, prim_data*);

  /* Computes quartets of (md|nl) integrals */

REALTYPE *hrr_order_mdnl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[9][17] = int_stack + 41195;
 Libint->vrr_classes[9][18] = int_stack + 50600;
 Libint->vrr_classes[10][10] = int_stack + 61050;
 Libint->vrr_classes[10][11] = int_stack + 65406;
 Libint->vrr_classes[10][12] = int_stack + 70554;
 Libint->vrr_classes[10][13] = int_stack + 76560;
 Libint->vrr_classes[10][14] = int_stack + 83490;
 Libint->vrr_classes[10][15] = int_stack + 91410;
 Libint->vrr_classes[10][16] = int_stack + 100386;
 Libint->vrr_classes[10][17] = int_stack + 110484;
 Libint->vrr_classes[10][18] = int_stack + 121770;
 Libint->vrr_classes[11][10] = int_stack + 134310;
 Libint->vrr_classes[11][11] = int_stack + 139458;
 Libint->vrr_classes[11][12] = int_stack + 145542;
 Libint->vrr_classes[11][13] = int_stack + 152640;
 Libint->vrr_classes[11][14] = int_stack + 160830;
 Libint->vrr_classes[11][15] = int_stack + 170190;
 Libint->vrr_classes[11][16] = int_stack + 180798;
 Libint->vrr_classes[11][17] = int_stack + 192732;
 Libint->vrr_classes[11][18] = int_stack + 206070;
 memset(int_stack,0,220890*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 220890;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mdnl(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+220890,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+231780,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+244650,int_stack+231780,int_stack+220890,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+266430,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+281445,int_stack+266430,int_stack+231780,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+307185,int_stack+281445,int_stack+244650,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+220890,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+343485,int_stack+220890,int_stack+266430,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+238215,int_stack+343485,int_stack+281445,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+373515,int_stack+238215,int_stack+307185,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+281115,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+300915,int_stack+281115,int_stack+220890,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+427965,int_stack+300915,int_stack+343485,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+478015,int_stack+427965,int_stack+238215,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+542365,int_stack+478015,int_stack+373515,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+220890,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+335565,int_stack+220890,int_stack+281115,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+618595,int_stack+335565,int_stack+300915,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+243330,int_stack+618595,int_stack+427965,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+375165,int_stack+243330,int_stack+478015,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+676345,int_stack+375165,int_stack+542365,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+465255,int_stack+41195,int_stack+32780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+490500,int_stack+465255,int_stack+220890,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+535380,int_stack+490500,int_stack+335565,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+777985,int_stack+535380,int_stack+618595,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+864610,int_stack+777985,int_stack+243330,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+220890,int_stack+864610,int_stack+375165,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+969715,int_stack+220890,int_stack+676345,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+341010,int_stack+50600,int_stack+41195,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+369225,int_stack+341010,int_stack+465255,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+601380,int_stack+369225,int_stack+490500,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+341010,int_stack+601380,int_stack+535380,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+440010,int_stack+341010,int_stack+777985,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+561285,int_stack+440010,int_stack+864610,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+341010,int_stack+561285,int_stack+220890,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+495450,int_stack+341010,int_stack+969715,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+220890,int_stack+65406,int_stack+61050,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+233958,int_stack+70554,int_stack+65406,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+249402,int_stack+233958,int_stack+220890,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+275538,int_stack+76560,int_stack+70554,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+293556,int_stack+275538,int_stack+233958,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+324444,int_stack+293556,int_stack+249402,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+220890,int_stack+83490,int_stack+76560,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+368004,int_stack+220890,int_stack+275538,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+241680,int_stack+368004,int_stack+293556,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+404040,int_stack+241680,int_stack+324444,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+293160,int_stack+91410,int_stack+83490,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+316920,int_stack+293160,int_stack+220890,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+658800,int_stack+316920,int_stack+368004,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+718860,int_stack+658800,int_stack+241680,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+796080,int_stack+718860,int_stack+404040,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+220890,int_stack+100386,int_stack+91410,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+358500,int_stack+220890,int_stack+293160,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+406020,int_stack+358500,int_stack+316920,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+247818,int_stack+406020,int_stack+658800,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+887556,int_stack+247818,int_stack+718860,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+658800,int_stack+887556,int_stack+796080,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+780768,int_stack+110484,int_stack+100386,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+811062,int_stack+780768,int_stack+220890,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+995664,int_stack+811062,int_stack+358500,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+995664,int_stack+406020,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+337908,int_stack+0,int_stack+247818,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1074864,int_stack+337908,int_stack+887556,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1219008,int_stack+1074864,int_stack+658800,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+658800,int_stack+121770,int_stack+110484,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+692658,int_stack+658800,int_stack+780768,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+220890,int_stack+692658,int_stack+811062,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+658800,int_stack+220890,int_stack+995664,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+777600,int_stack+658800,int_stack+0,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1375824,int_stack+777600,int_stack+337908,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+658800,int_stack+1375824,int_stack+1074864,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+844128,int_stack+658800,int_stack+1219008,66);
 /*--- compute (mp|nl) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1040148,int_stack+844128,int_stack+495450,2970);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+139458,int_stack+134310,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+145542,int_stack+139458,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+152640,int_stack+145542,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+220890,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+160830,int_stack+152640,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+272370,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+272370,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+314958,int_stack+24570,int_stack+220890,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+220890,int_stack+170190,int_stack+160830,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+85410,int_stack+220890,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+392178,int_stack+85410,int_stack+272370,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+463158,int_stack+392178,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+554418,int_stack+463158,int_stack+314958,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+180798,int_stack+170190,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+248970,int_stack+0,int_stack+220890,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+305130,int_stack+248970,int_stack+85410,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+31824,int_stack+305130,int_stack+392178,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+662526,int_stack+31824,int_stack+463158,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+387030,int_stack+662526,int_stack+554418,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+138294,int_stack+192732,int_stack+180798,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+531174,int_stack+138294,int_stack+0,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1530198,int_stack+531174,int_stack+248970,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1623798,int_stack+1530198,int_stack+305130,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+220890,int_stack+1623798,int_stack+31824,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1746648,int_stack+220890,int_stack+662526,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+594822,int_stack+1746648,int_stack+387030,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+206070,int_stack+192732,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+40014,int_stack+0,int_stack+138294,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+111618,int_stack+40014,int_stack+531174,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+369948,int_stack+111618,int_stack+1530198,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+369948,int_stack+1623798,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+369948,int_stack+0,int_stack+220890,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+369948,int_stack+1746648,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+219024,int_stack+0,int_stack+594822,78);
 /*--- compute (np|nl) ---*/
 hrr1_build_np(Libint->AB,int_stack+1530198,int_stack+219024,int_stack+844128,2970);
 /*--- compute (md|nl) ---*/
 hrr1_build_md(Libint->AB,int_stack+0,int_stack+1530198,int_stack+1040148,2970);
 return int_stack+0;}
