/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mfnd(Libint_t*, prim_data*);

  /* Computes quartets of (mf|nd) integrals */

REALTYPE *hrr_order_mfnd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[10][10] = int_stack + 12925;
 Libint->vrr_classes[10][11] = int_stack + 17281;
 Libint->vrr_classes[10][12] = int_stack + 22429;
 Libint->vrr_classes[11][10] = int_stack + 28435;
 Libint->vrr_classes[11][11] = int_stack + 33583;
 Libint->vrr_classes[11][12] = int_stack + 39667;
 Libint->vrr_classes[12][10] = int_stack + 46765;
 Libint->vrr_classes[12][11] = int_stack + 52771;
 Libint->vrr_classes[12][12] = int_stack + 59869;
 memset(int_stack,0,68150*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 68150;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mfnd(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68150,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+79040,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+91910,int_stack+79040,int_stack+68150,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68150,int_stack+17281,int_stack+12925,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+22429,int_stack+17281,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+113690,int_stack+0,int_stack+68150,66);
 /*--- compute (mp|nd) ---*/
 hrr1_build_mp(Libint->AB,int_stack+139826,int_stack+113690,int_stack+91910,396);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68150,int_stack+33583,int_stack+28435,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+83594,int_stack+39667,int_stack+33583,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+83594,int_stack+68150,78);
 /*--- compute (np|nd) ---*/
 hrr1_build_np(Libint->AB,int_stack+205166,int_stack+0,int_stack+113690,396);
 /*--- compute (md|nd) ---*/
 hrr1_build_md(Libint->AB,int_stack+283574,int_stack+205166,int_stack+139826,396);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68150,int_stack+52771,int_stack+46765,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+86168,int_stack+59869,int_stack+52771,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+107462,int_stack+86168,int_stack+68150,91);
 /*--- compute (op|nd) ---*/
 hrr1_build_op(Libint->AB,int_stack+414254,int_stack+107462,int_stack+0,396);
 /*--- compute (nd|nd) ---*/
 hrr1_build_nd(Libint->AB,int_stack+0,int_stack+414254,int_stack+205166,396);
 /*--- compute (mf|nd) ---*/
 hrr1_build_mf(Libint->AB,int_stack+414254,int_stack+0,int_stack+283574,396);
 return int_stack+414254;}
