/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mfni(Libint_t*, prim_data*);

  /* Computes quartets of (mf|ni) integrals */

REALTYPE *hrr_order_mfni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[10][10] = int_stack + 41195;
 Libint->vrr_classes[10][11] = int_stack + 45551;
 Libint->vrr_classes[10][12] = int_stack + 50699;
 Libint->vrr_classes[10][13] = int_stack + 56705;
 Libint->vrr_classes[10][14] = int_stack + 63635;
 Libint->vrr_classes[10][15] = int_stack + 71555;
 Libint->vrr_classes[10][16] = int_stack + 80531;
 Libint->vrr_classes[11][10] = int_stack + 90629;
 Libint->vrr_classes[11][11] = int_stack + 95777;
 Libint->vrr_classes[11][12] = int_stack + 101861;
 Libint->vrr_classes[11][13] = int_stack + 108959;
 Libint->vrr_classes[11][14] = int_stack + 117149;
 Libint->vrr_classes[11][15] = int_stack + 126509;
 Libint->vrr_classes[11][16] = int_stack + 137117;
 Libint->vrr_classes[12][10] = int_stack + 149051;
 Libint->vrr_classes[12][11] = int_stack + 155057;
 Libint->vrr_classes[12][12] = int_stack + 162155;
 Libint->vrr_classes[12][13] = int_stack + 170436;
 Libint->vrr_classes[12][14] = int_stack + 179991;
 Libint->vrr_classes[12][15] = int_stack + 190911;
 Libint->vrr_classes[12][16] = int_stack + 203287;
 memset(int_stack,0,217210*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 217210;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mfni(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+217210,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+228100,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+240970,int_stack+228100,int_stack+217210,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+262750,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+277765,int_stack+262750,int_stack+228100,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+303505,int_stack+277765,int_stack+240970,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+217210,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+339805,int_stack+217210,int_stack+262750,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+234535,int_stack+339805,int_stack+277765,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+369835,int_stack+234535,int_stack+303505,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+277435,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+297235,int_stack+277435,int_stack+217210,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+424285,int_stack+297235,int_stack+339805,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+474335,int_stack+424285,int_stack+234535,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+538685,int_stack+474335,int_stack+369835,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+217210,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+331885,int_stack+217210,int_stack+277435,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+217210,int_stack+331885,int_stack+297235,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+274960,int_stack+217210,int_stack+424285,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+350035,int_stack+274960,int_stack+474335,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+217210,int_stack+350035,int_stack+538685,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+318850,int_stack+45551,int_stack+41195,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+331918,int_stack+50699,int_stack+45551,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+347362,int_stack+331918,int_stack+318850,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+373498,int_stack+56705,int_stack+50699,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+391516,int_stack+373498,int_stack+331918,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+422404,int_stack+391516,int_stack+347362,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+318850,int_stack+63635,int_stack+56705,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+465964,int_stack+318850,int_stack+373498,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+339640,int_stack+465964,int_stack+391516,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+502000,int_stack+339640,int_stack+422404,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+391120,int_stack+71555,int_stack+63635,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+414880,int_stack+391120,int_stack+318850,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+414880,int_stack+465964,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+567340,int_stack+0,int_stack+339640,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+644560,int_stack+567340,int_stack+502000,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+318850,int_stack+80531,int_stack+71555,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+456460,int_stack+318850,int_stack+391120,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+318850,int_stack+456460,int_stack+414880,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+388150,int_stack+318850,int_stack+0,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+736036,int_stack+388150,int_stack+567340,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+318850,int_stack+736036,int_stack+644560,66);
 /*--- compute (mp|ni) ---*/
 hrr1_build_mp(Libint->AB,int_stack+440818,int_stack+318850,int_stack+217210,1848);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+217210,int_stack+95777,int_stack+90629,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+232654,int_stack+101861,int_stack+95777,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+250906,int_stack+232654,int_stack+217210,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+281794,int_stack+108959,int_stack+101861,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+281794,int_stack+232654,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+36504,int_stack+0,int_stack+250906,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+217210,int_stack+117149,int_stack+108959,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+745738,int_stack+217210,int_stack+281794,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+241780,int_stack+745738,int_stack+0,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+788326,int_stack+241780,int_stack+36504,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+126509,int_stack+117149,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+28080,int_stack+0,int_stack+217210,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+865546,int_stack+28080,int_stack+745738,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+936526,int_stack+865546,int_stack+241780,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1027786,int_stack+936526,int_stack+788326,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+745738,int_stack+137117,int_stack+126509,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+777562,int_stack+745738,int_stack+0,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+217210,int_stack+777562,int_stack+28080,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+217210,int_stack+865546,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+745738,int_stack+0,int_stack+936526,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+745738,int_stack+1027786,78);
 /*--- compute (np|ni) ---*/
 hrr1_build_np(Libint->AB,int_stack+745738,int_stack+0,int_stack+318850,1848);
 /*--- compute (md|ni) ---*/
 hrr1_build_md(Libint->AB,int_stack+1111642,int_stack+745738,int_stack+440818,1848);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+217210,int_stack+155057,int_stack+149051,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+235228,int_stack+162155,int_stack+155057,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+256522,int_stack+235228,int_stack+217210,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+292558,int_stack+170436,int_stack+162155,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+317401,int_stack+292558,int_stack+235228,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+359989,int_stack+317401,int_stack+256522,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+217210,int_stack+179991,int_stack+170436,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+420049,int_stack+217210,int_stack+292558,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+245875,int_stack+420049,int_stack+317401,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+469735,int_stack+245875,int_stack+359989,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+316855,int_stack+190911,int_stack+179991,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+349615,int_stack+316855,int_stack+217210,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+559825,int_stack+349615,int_stack+420049,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1721482,int_stack+559825,int_stack+245875,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1827952,int_stack+1721482,int_stack+469735,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+217210,int_stack+203287,int_stack+190911,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+406945,int_stack+217210,int_stack+316855,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+144144,int_stack+406945,int_stack+349615,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+239694,int_stack+144144,int_stack+559825,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+363909,int_stack+239694,int_stack+1721482,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+144144,int_stack+363909,int_stack+1827952,91);
 /*--- compute (op|ni) ---*/
 hrr1_build_op(Libint->AB,int_stack+312312,int_stack+144144,int_stack+0,1848);
 /*--- compute (nd|ni) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1721482,int_stack+312312,int_stack+745738,1848);
 /*--- compute (mf|ni) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+1721482,int_stack+1111642,1848);
 return int_stack+0;}
