/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mgmi(Libint_t*, prim_data*);

  /* Computes quartets of (mg|mi) integrals */

REALTYPE *hrr_order_mgmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[9][15] = int_stack + 28325;
 Libint->vrr_classes[10][9] = int_stack + 35805;
 Libint->vrr_classes[10][10] = int_stack + 39435;
 Libint->vrr_classes[10][11] = int_stack + 43791;
 Libint->vrr_classes[10][12] = int_stack + 48939;
 Libint->vrr_classes[10][13] = int_stack + 54945;
 Libint->vrr_classes[10][14] = int_stack + 61875;
 Libint->vrr_classes[10][15] = int_stack + 69795;
 Libint->vrr_classes[11][9] = int_stack + 78771;
 Libint->vrr_classes[11][10] = int_stack + 83061;
 Libint->vrr_classes[11][11] = int_stack + 88209;
 Libint->vrr_classes[11][12] = int_stack + 94293;
 Libint->vrr_classes[11][13] = int_stack + 101391;
 Libint->vrr_classes[11][14] = int_stack + 109581;
 Libint->vrr_classes[11][15] = int_stack + 118941;
 Libint->vrr_classes[12][9] = int_stack + 129549;
 Libint->vrr_classes[12][10] = int_stack + 134554;
 Libint->vrr_classes[12][11] = int_stack + 140560;
 Libint->vrr_classes[12][12] = int_stack + 147658;
 Libint->vrr_classes[12][13] = int_stack + 155939;
 Libint->vrr_classes[12][14] = int_stack + 165494;
 Libint->vrr_classes[12][15] = int_stack + 176414;
 Libint->vrr_classes[13][9] = int_stack + 188790;
 Libint->vrr_classes[13][10] = int_stack + 194565;
 Libint->vrr_classes[13][11] = int_stack + 201495;
 Libint->vrr_classes[13][12] = int_stack + 209685;
 Libint->vrr_classes[13][13] = int_stack + 219240;
 Libint->vrr_classes[13][14] = int_stack + 230265;
 Libint->vrr_classes[13][15] = int_stack + 242865;
 memset(int_stack,0,257145*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 257145;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mgmi(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+257145,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+266220,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+277110,int_stack+266220,int_stack+257145,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+295260,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+308130,int_stack+295260,int_stack+266220,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+329910,int_stack+308130,int_stack+277110,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+257145,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+360160,int_stack+257145,int_stack+295260,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+385900,int_stack+360160,int_stack+308130,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+272160,int_stack+385900,int_stack+329910,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+317535,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+422200,int_stack+317535,int_stack+257145,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+452230,int_stack+422200,int_stack+360160,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+495130,int_stack+452230,int_stack+385900,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+334860,int_stack+495130,int_stack+272160,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+257145,int_stack+28325,int_stack+21725,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+276945,int_stack+257145,int_stack+317535,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+549580,int_stack+276945,int_stack+422200,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+257145,int_stack+549580,int_stack+452230,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+398385,int_stack+257145,int_stack+495130,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+474615,int_stack+398385,int_stack+334860,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+257145,int_stack+39435,int_stack+35805,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+268035,int_stack+43791,int_stack+39435,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+281103,int_stack+268035,int_stack+257145,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+302883,int_stack+48939,int_stack+43791,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+318327,int_stack+302883,int_stack+268035,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+344463,int_stack+318327,int_stack+281103,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+257145,int_stack+54945,int_stack+48939,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+380763,int_stack+257145,int_stack+302883,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+411651,int_stack+380763,int_stack+318327,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+275163,int_stack+411651,int_stack+344463,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+329613,int_stack+61875,int_stack+54945,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+559315,int_stack+329613,int_stack+257145,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+559315,int_stack+380763,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+595351,int_stack+0,int_stack+411651,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+350403,int_stack+595351,int_stack+275163,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+257145,int_stack+69795,int_stack+61875,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+280905,int_stack+257145,int_stack+329613,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+660691,int_stack+280905,int_stack+559315,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+257145,int_stack+660691,int_stack+0,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+660691,int_stack+257145,int_stack+595351,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+752167,int_stack+660691,int_stack+350403,66);
 /*--- compute (mp|mi) ---*/
 hrr1_build_mp(Libint->AB,int_stack+853807,int_stack+752167,int_stack+474615,1540);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+257145,int_stack+83061,int_stack+78771,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+270015,int_stack+88209,int_stack+83061,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+285459,int_stack+270015,int_stack+257145,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+311199,int_stack+94293,int_stack+88209,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+329451,int_stack+311199,int_stack+270015,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+360339,int_stack+329451,int_stack+285459,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+257145,int_stack+101391,int_stack+94293,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+403239,int_stack+257145,int_stack+311199,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+439743,int_stack+403239,int_stack+329451,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+278439,int_stack+439743,int_stack+360339,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+342789,int_stack+109581,int_stack+101391,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+491223,int_stack+342789,int_stack+257145,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+533811,int_stack+491223,int_stack+403239,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+594651,int_stack+533811,int_stack+439743,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+367359,int_stack+594651,int_stack+278439,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+257145,int_stack+118941,int_stack+109581,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+285225,int_stack+257145,int_stack+342789,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+671871,int_stack+285225,int_stack+491223,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+257145,int_stack+671871,int_stack+533811,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+457449,int_stack+257145,int_stack+594651,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+565557,int_stack+457449,int_stack+367359,78);
 /*--- compute (np|mi) ---*/
 hrr1_build_np(Libint->AB,int_stack+257145,int_stack+565557,int_stack+752167,1540);
 /*--- compute (md|mi) ---*/
 hrr1_build_md(Libint->AB,int_stack+1107907,int_stack+257145,int_stack+853807,1540);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+685677,int_stack+134554,int_stack+129549,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+700692,int_stack+140560,int_stack+134554,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+718710,int_stack+700692,int_stack+685677,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+748740,int_stack+147658,int_stack+140560,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+770034,int_stack+748740,int_stack+700692,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+806070,int_stack+770034,int_stack+718710,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+685677,int_stack+155939,int_stack+147658,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+856120,int_stack+685677,int_stack+748740,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+898708,int_stack+856120,int_stack+770034,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+710520,int_stack+898708,int_stack+806070,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+785595,int_stack+165494,int_stack+155939,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+958768,int_stack+785595,int_stack+685677,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1008454,int_stack+958768,int_stack+856120,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+1008454,int_stack+898708,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+814260,int_stack+0,int_stack+710520,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+685677,int_stack+176414,int_stack+165494,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+718437,int_stack+685677,int_stack+785595,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+90090,int_stack+718437,int_stack+958768,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+685677,int_stack+90090,int_stack+1008454,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+919365,int_stack+685677,int_stack+0,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+919365,int_stack+814260,91);
 /*--- compute (op|mi) ---*/
 hrr1_build_op(Libint->AB,int_stack+685677,int_stack+0,int_stack+565557,1540);
 /*--- compute (nd|mi) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1616107,int_stack+685677,int_stack+257145,1540);
 /*--- compute (mf|mi) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2225947,int_stack+1616107,int_stack+1107907,1540);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+257145,int_stack+194565,int_stack+188790,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+274470,int_stack+201495,int_stack+194565,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+295260,int_stack+274470,int_stack+257145,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+329910,int_stack+209685,int_stack+201495,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+354480,int_stack+329910,int_stack+274470,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+396060,int_stack+354480,int_stack+295260,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+257145,int_stack+219240,int_stack+209685,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+453810,int_stack+257145,int_stack+329910,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+502950,int_stack+453810,int_stack+354480,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+285810,int_stack+502950,int_stack+396060,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+372435,int_stack+230265,int_stack+219240,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+572250,int_stack+372435,int_stack+257145,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+140140,int_stack+572250,int_stack+453810,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1046037,int_stack+140140,int_stack+502950,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+405510,int_stack+1046037,int_stack+285810,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+257145,int_stack+242865,int_stack+230265,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+294945,int_stack+257145,int_stack+372435,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1149987,int_stack+294945,int_stack+572250,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+526785,int_stack+1149987,int_stack+140140,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+140140,int_stack+526785,int_stack+1046037,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1046037,int_stack+140140,int_stack+405510,105);
 /*--- compute (qp|mi) ---*/
 hrr1_build_qp(Libint->AB,int_stack+140140,int_stack+1046037,int_stack+0,1540);
 /*--- compute (od|mi) ---*/
 hrr1_build_od(Libint->AB,int_stack+3072947,int_stack+140140,int_stack+685677,1540);
 /*--- compute (nf|mi) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+3072947,int_stack+1616107,1540);
 /*--- compute (mg|mi) ---*/
 hrr1_build_mg(Libint->AB,int_stack+3072947,int_stack+0,int_stack+2225947,1540);
 return int_stack+3072947;}
