/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mhmh(Libint_t*, prim_data*);

  /* Computes quartets of (mh|mh) integrals */

REALTYPE *hrr_order_mhmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[10][9] = int_stack + 28325;
 Libint->vrr_classes[10][10] = int_stack + 31955;
 Libint->vrr_classes[10][11] = int_stack + 36311;
 Libint->vrr_classes[10][12] = int_stack + 41459;
 Libint->vrr_classes[10][13] = int_stack + 47465;
 Libint->vrr_classes[10][14] = int_stack + 54395;
 Libint->vrr_classes[11][9] = int_stack + 62315;
 Libint->vrr_classes[11][10] = int_stack + 66605;
 Libint->vrr_classes[11][11] = int_stack + 71753;
 Libint->vrr_classes[11][12] = int_stack + 77837;
 Libint->vrr_classes[11][13] = int_stack + 84935;
 Libint->vrr_classes[11][14] = int_stack + 93125;
 Libint->vrr_classes[12][9] = int_stack + 102485;
 Libint->vrr_classes[12][10] = int_stack + 107490;
 Libint->vrr_classes[12][11] = int_stack + 113496;
 Libint->vrr_classes[12][12] = int_stack + 120594;
 Libint->vrr_classes[12][13] = int_stack + 128875;
 Libint->vrr_classes[12][14] = int_stack + 138430;
 Libint->vrr_classes[13][9] = int_stack + 149350;
 Libint->vrr_classes[13][10] = int_stack + 155125;
 Libint->vrr_classes[13][11] = int_stack + 162055;
 Libint->vrr_classes[13][12] = int_stack + 170245;
 Libint->vrr_classes[13][13] = int_stack + 179800;
 Libint->vrr_classes[13][14] = int_stack + 190825;
 Libint->vrr_classes[14][9] = int_stack + 203425;
 Libint->vrr_classes[14][10] = int_stack + 210025;
 Libint->vrr_classes[14][11] = int_stack + 217945;
 Libint->vrr_classes[14][12] = int_stack + 227305;
 Libint->vrr_classes[14][13] = int_stack + 238225;
 Libint->vrr_classes[14][14] = int_stack + 250825;
 memset(int_stack,0,265225*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 265225;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mhmh(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+265225,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+274300,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+285190,int_stack+274300,int_stack+265225,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+303340,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+316210,int_stack+303340,int_stack+274300,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+337990,int_stack+316210,int_stack+285190,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+265225,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+368240,int_stack+265225,int_stack+303340,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+393980,int_stack+368240,int_stack+316210,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+280240,int_stack+393980,int_stack+337990,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+325615,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+430280,int_stack+325615,int_stack+265225,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+460310,int_stack+430280,int_stack+368240,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+325615,int_stack+460310,int_stack+393980,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+380065,int_stack+325615,int_stack+280240,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+265225,int_stack+31955,int_stack+28325,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+276115,int_stack+36311,int_stack+31955,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+289183,int_stack+276115,int_stack+265225,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+310963,int_stack+41459,int_stack+36311,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+326407,int_stack+310963,int_stack+276115,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+443590,int_stack+326407,int_stack+289183,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+265225,int_stack+47465,int_stack+41459,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+265225,int_stack+310963,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+479890,int_stack+0,int_stack+326407,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+283243,int_stack+479890,int_stack+443590,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+443590,int_stack+54395,int_stack+47465,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+337693,int_stack+443590,int_stack+265225,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+523450,int_stack+337693,int_stack+0,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+574930,int_stack+523450,int_stack+479890,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+443590,int_stack+574930,int_stack+283243,66);
 /*--- compute (mp|mh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+519820,int_stack+443590,int_stack+380065,1155);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+66605,int_stack+62315,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+71753,int_stack+66605,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+265225,int_stack+77837,int_stack+71753,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+283477,int_stack+265225,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+314365,int_stack+283477,int_stack+28314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+84935,int_stack+77837,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+21294,int_stack+0,int_stack+265225,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+357265,int_stack+21294,int_stack+283477,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+710395,int_stack+357265,int_stack+314365,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+265225,int_stack+93125,int_stack+84935,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+289795,int_stack+265225,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+774745,int_stack+289795,int_stack+21294,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+774745,int_stack+357265,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+265225,int_stack+0,int_stack+710395,78);
 /*--- compute (np|mh) ---*/
 hrr1_build_np(Libint->AB,int_stack+710395,int_stack+265225,int_stack+443590,1155);
 /*--- compute (md|mh) ---*/
 hrr1_build_md(Libint->AB,int_stack+939085,int_stack+710395,int_stack+519820,1155);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+107490,int_stack+102485,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+113496,int_stack+107490,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+120594,int_stack+113496,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84357,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+355315,int_stack+84357,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+128875,int_stack+120594,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+405365,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+447953,int_stack+405365,int_stack+84357,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+24843,int_stack+447953,int_stack+355315,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+355315,int_stack+138430,int_stack+128875,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+508013,int_stack+355315,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+557699,int_stack+508013,int_stack+405365,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+355315,int_stack+557699,int_stack+447953,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+445405,int_stack+355315,int_stack+24843,91);
 /*--- compute (op|mh) ---*/
 hrr1_build_op(Libint->AB,int_stack+1320235,int_stack+445405,int_stack+265225,1155);
 /*--- compute (nd|mh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1590505,int_stack+1320235,int_stack+710395,1155);
 /*--- compute (mf|mh) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2047885,int_stack+1590505,int_stack+939085,1155);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+265225,int_stack+155125,int_stack+149350,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+282550,int_stack+162055,int_stack+155125,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+303340,int_stack+282550,int_stack+265225,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+337990,int_stack+170245,int_stack+162055,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+362560,int_stack+337990,int_stack+282550,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+362560,int_stack+303340,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+265225,int_stack+179800,int_stack+170245,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+57750,int_stack+265225,int_stack+337990,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+106890,int_stack+57750,int_stack+362560,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+293890,int_stack+106890,int_stack+0,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+190825,int_stack+179800,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+380515,int_stack+0,int_stack+265225,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+550510,int_stack+380515,int_stack+57750,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+550510,int_stack+106890,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+550510,int_stack+0,int_stack+293890,105);
 /*--- compute (qp|mh) ---*/
 hrr1_build_qp(Libint->AB,int_stack+671785,int_stack+550510,int_stack+445405,1155);
 /*--- compute (od|mh) ---*/
 hrr1_build_od(Libint->AB,int_stack+2683135,int_stack+671785,int_stack+1320235,1155);
 /*--- compute (nf|mh) ---*/
 hrr1_build_nf(Libint->AB,int_stack+3223675,int_stack+2683135,int_stack+1590505,1155);
 /*--- compute (mg|mh) ---*/
 hrr1_build_mg(Libint->AB,int_stack+987100,int_stack+3223675,int_stack+2047885,1155);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+210025,int_stack+203425,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+19800,int_stack+217945,int_stack+210025,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+43560,int_stack+19800,int_stack+0,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+83160,int_stack+227305,int_stack+217945,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+111240,int_stack+83160,int_stack+19800,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+158760,int_stack+111240,int_stack+43560,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+238225,int_stack+227305,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1939975,int_stack+0,int_stack+83160,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1996135,int_stack+1939975,int_stack+111240,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+32760,int_stack+1996135,int_stack+158760,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+131760,int_stack+250825,int_stack+238225,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+169560,int_stack+131760,int_stack+0,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+235080,int_stack+169560,int_stack+1939975,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+328680,int_stack+235080,int_stack+1996135,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1939975,int_stack+328680,int_stack+32760,120);
 /*--- compute (rp|mh) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2078575,int_stack+1939975,int_stack+550510,1155);
 /*--- compute (qd|mh) ---*/
 hrr1_build_qd(Libint->AB,int_stack+0,int_stack+2078575,int_stack+671785,1155);
 /*--- compute (of|mh) ---*/
 hrr1_build_of(Libint->AB,int_stack+3985975,int_stack+0,int_stack+2683135,1155);
 /*--- compute (ng|mh) ---*/
 hrr1_build_ng(Libint->AB,int_stack+1939975,int_stack+3985975,int_stack+3223675,1155);
 /*--- compute (mh|mh) ---*/
 hrr1_build_mh(Libint->AB,int_stack+3083425,int_stack+1939975,int_stack+987100,1155);
 return int_stack+3083425;}
