/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mhmk(Libint_t*, prim_data*);

  /* Computes quartets of (mh|mk) integrals */

REALTYPE *hrr_order_mhmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[9][15] = int_stack + 28325;
 Libint->vrr_classes[9][16] = int_stack + 35805;
 Libint->vrr_classes[10][9] = int_stack + 44220;
 Libint->vrr_classes[10][10] = int_stack + 47850;
 Libint->vrr_classes[10][11] = int_stack + 52206;
 Libint->vrr_classes[10][12] = int_stack + 57354;
 Libint->vrr_classes[10][13] = int_stack + 63360;
 Libint->vrr_classes[10][14] = int_stack + 70290;
 Libint->vrr_classes[10][15] = int_stack + 78210;
 Libint->vrr_classes[10][16] = int_stack + 87186;
 Libint->vrr_classes[11][9] = int_stack + 97284;
 Libint->vrr_classes[11][10] = int_stack + 101574;
 Libint->vrr_classes[11][11] = int_stack + 106722;
 Libint->vrr_classes[11][12] = int_stack + 112806;
 Libint->vrr_classes[11][13] = int_stack + 119904;
 Libint->vrr_classes[11][14] = int_stack + 128094;
 Libint->vrr_classes[11][15] = int_stack + 137454;
 Libint->vrr_classes[11][16] = int_stack + 148062;
 Libint->vrr_classes[12][9] = int_stack + 159996;
 Libint->vrr_classes[12][10] = int_stack + 165001;
 Libint->vrr_classes[12][11] = int_stack + 171007;
 Libint->vrr_classes[12][12] = int_stack + 178105;
 Libint->vrr_classes[12][13] = int_stack + 186386;
 Libint->vrr_classes[12][14] = int_stack + 195941;
 Libint->vrr_classes[12][15] = int_stack + 206861;
 Libint->vrr_classes[12][16] = int_stack + 219237;
 Libint->vrr_classes[13][9] = int_stack + 233160;
 Libint->vrr_classes[13][10] = int_stack + 238935;
 Libint->vrr_classes[13][11] = int_stack + 245865;
 Libint->vrr_classes[13][12] = int_stack + 254055;
 Libint->vrr_classes[13][13] = int_stack + 263610;
 Libint->vrr_classes[13][14] = int_stack + 274635;
 Libint->vrr_classes[13][15] = int_stack + 287235;
 Libint->vrr_classes[13][16] = int_stack + 301515;
 Libint->vrr_classes[14][9] = int_stack + 317580;
 Libint->vrr_classes[14][10] = int_stack + 324180;
 Libint->vrr_classes[14][11] = int_stack + 332100;
 Libint->vrr_classes[14][12] = int_stack + 341460;
 Libint->vrr_classes[14][13] = int_stack + 352380;
 Libint->vrr_classes[14][14] = int_stack + 364980;
 Libint->vrr_classes[14][15] = int_stack + 379380;
 Libint->vrr_classes[14][16] = int_stack + 395700;
 memset(int_stack,0,414060*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 414060;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mhmk(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+414060,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+423135,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+434025,int_stack+423135,int_stack+414060,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+452175,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+465045,int_stack+452175,int_stack+423135,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+486825,int_stack+465045,int_stack+434025,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+414060,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+517075,int_stack+414060,int_stack+452175,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+542815,int_stack+517075,int_stack+465045,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+429075,int_stack+542815,int_stack+486825,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+474450,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+579115,int_stack+474450,int_stack+414060,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+609145,int_stack+579115,int_stack+517075,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+652045,int_stack+609145,int_stack+542815,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+491775,int_stack+652045,int_stack+429075,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+414060,int_stack+28325,int_stack+21725,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+433860,int_stack+414060,int_stack+474450,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+706495,int_stack+433860,int_stack+579115,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+756545,int_stack+706495,int_stack+609145,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+555300,int_stack+756545,int_stack+652045,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+820895,int_stack+555300,int_stack+491775,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+468510,int_stack+35805,int_stack+28325,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+490950,int_stack+468510,int_stack+414060,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+631530,int_stack+490950,int_stack+433860,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+414060,int_stack+631530,int_stack+706495,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+631530,int_stack+414060,int_stack+756545,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+414060,int_stack+631530,int_stack+555300,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+515700,int_stack+414060,int_stack+820895,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+414060,int_stack+47850,int_stack+44220,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+424950,int_stack+52206,int_stack+47850,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+438018,int_stack+424950,int_stack+414060,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+459798,int_stack+57354,int_stack+52206,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+475242,int_stack+459798,int_stack+424950,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+624600,int_stack+475242,int_stack+438018,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+414060,int_stack+63360,int_stack+57354,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+660900,int_stack+414060,int_stack+459798,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+691788,int_stack+660900,int_stack+475242,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+432078,int_stack+691788,int_stack+624600,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+624600,int_stack+70290,int_stack+63360,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+735348,int_stack+624600,int_stack+414060,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+771384,int_stack+735348,int_stack+660900,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+822864,int_stack+771384,int_stack+691788,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+645390,int_stack+822864,int_stack+432078,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+414060,int_stack+78210,int_stack+70290,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+437820,int_stack+414060,int_stack+624600,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+437820,int_stack+735348,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+888204,int_stack+0,int_stack+771384,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+721620,int_stack+888204,int_stack+822864,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+965424,int_stack+721620,int_stack+645390,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+624600,int_stack+87186,int_stack+78210,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+651528,int_stack+624600,int_stack+414060,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+813096,int_stack+651528,int_stack+437820,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+414060,int_stack+813096,int_stack+0,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1067064,int_stack+414060,int_stack+888204,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+813096,int_stack+1067064,int_stack+721620,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+624600,int_stack+813096,int_stack+965424,66);
 /*--- compute (mp|mk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+755280,int_stack+624600,int_stack+515700,1980);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+414060,int_stack+101574,int_stack+97284,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+426930,int_stack+106722,int_stack+101574,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+442374,int_stack+426930,int_stack+414060,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+468114,int_stack+112806,int_stack+106722,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+486366,int_stack+468114,int_stack+426930,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+517254,int_stack+486366,int_stack+442374,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+414060,int_stack+119904,int_stack+112806,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+560154,int_stack+414060,int_stack+468114,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+560154,int_stack+486366,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+435354,int_stack+0,int_stack+517254,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+499704,int_stack+128094,int_stack+119904,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+51480,int_stack+499704,int_stack+414060,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1081980,int_stack+51480,int_stack+560154,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+524274,int_stack+1081980,int_stack+0,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1142820,int_stack+524274,int_stack+435354,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+137454,int_stack+128094,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+414060,int_stack+0,int_stack+499704,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1232910,int_stack+414060,int_stack+51480,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+28080,int_stack+1232910,int_stack+1081980,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1303890,int_stack+28080,int_stack+524274,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+463200,int_stack+1303890,int_stack+1142820,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1081980,int_stack+148062,int_stack+137454,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1113804,int_stack+1081980,int_stack+0,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1411998,int_stack+1113804,int_stack+414060,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1081980,int_stack+1411998,int_stack+1232910,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1411998,int_stack+1081980,int_stack+28080,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1081980,int_stack+1411998,int_stack+1303890,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1226124,int_stack+1081980,int_stack+463200,78);
 /*--- compute (np|mk) ---*/
 hrr1_build_np(Libint->AB,int_stack+1380564,int_stack+1226124,int_stack+624600,1980);
 /*--- compute (md|mk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1772604,int_stack+1380564,int_stack+755280,1980);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+414060,int_stack+165001,int_stack+159996,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+429075,int_stack+171007,int_stack+165001,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+447093,int_stack+429075,int_stack+414060,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+477123,int_stack+178105,int_stack+171007,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+498417,int_stack+477123,int_stack+429075,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+534453,int_stack+498417,int_stack+447093,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+414060,int_stack+186386,int_stack+178105,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+584503,int_stack+414060,int_stack+477123,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+627091,int_stack+584503,int_stack+498417,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+438903,int_stack+627091,int_stack+534453,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+513978,int_stack+195941,int_stack+186386,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+687151,int_stack+513978,int_stack+414060,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+736837,int_stack+687151,int_stack+584503,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+807817,int_stack+736837,int_stack+627091,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+542643,int_stack+807817,int_stack+438903,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+414060,int_stack+206861,int_stack+195941,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+446820,int_stack+414060,int_stack+513978,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+897907,int_stack+446820,int_stack+687151,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+980717,int_stack+897907,int_stack+736837,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+647748,int_stack+980717,int_stack+807817,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+647748,int_stack+542643,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+504150,int_stack+219237,int_stack+206861,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+541278,int_stack+504150,int_stack+414060,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+773874,int_stack+541278,int_stack+446820,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+414060,int_stack+773874,int_stack+897907,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+773874,int_stack+414060,int_stack+980717,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+414060,int_stack+773874,int_stack+647748,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+582228,int_stack+414060,int_stack+0,91);
 /*--- compute (op|mk) ---*/
 hrr1_build_op(Libint->AB,int_stack+762408,int_stack+582228,int_stack+1226124,1980);
 /*--- compute (nd|mk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2426004,int_stack+762408,int_stack+1380564,1980);
 /*--- compute (mf|mk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+3210084,int_stack+2426004,int_stack+1772604,1980);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+238935,int_stack+233160,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17325,int_stack+245865,int_stack+238935,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+38115,int_stack+17325,int_stack+0,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+72765,int_stack+254055,int_stack+245865,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+97335,int_stack+72765,int_stack+17325,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+138915,int_stack+97335,int_stack+38115,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+263610,int_stack+254055,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+196665,int_stack+0,int_stack+72765,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+414060,int_stack+196665,int_stack+97335,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+28665,int_stack+414060,int_stack+138915,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+115290,int_stack+274635,int_stack+263610,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+483360,int_stack+115290,int_stack+0,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1225728,int_stack+483360,int_stack+196665,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+148365,int_stack+1225728,int_stack+414060,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1307628,int_stack+148365,int_stack+28665,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+414060,int_stack+287235,int_stack+274635,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+414060,int_stack+115290,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1428903,int_stack+0,int_stack+483360,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+451860,int_stack+1428903,int_stack+1225728,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1524453,int_stack+451860,int_stack+148365,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+66150,int_stack+1524453,int_stack+1307628,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1225728,int_stack+301515,int_stack+287235,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1268568,int_stack+1225728,int_stack+414060,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1669983,int_stack+1268568,int_stack+0,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1225728,int_stack+1669983,int_stack+1428903,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1669983,int_stack+1225728,int_stack+451860,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1225728,int_stack+1669983,int_stack+1524453,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1419768,int_stack+1225728,int_stack+66150,105);
 /*--- compute (qp|mk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1627668,int_stack+1419768,int_stack+582228,1980);
 /*--- compute (od|mk) ---*/
 hrr1_build_od(Libint->AB,int_stack+4299084,int_stack+1627668,int_stack+762408,1980);
 /*--- compute (nf|mk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+5225724,int_stack+4299084,int_stack+2426004,1980);
 /*--- compute (mg|mk) ---*/
 hrr1_build_mg(Libint->AB,int_stack+6532524,int_stack+5225724,int_stack+3210084,1980);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2168208,int_stack+324180,int_stack+317580,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2188008,int_stack+332100,int_stack+324180,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2211768,int_stack+2188008,int_stack+2168208,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2251368,int_stack+341460,int_stack+332100,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2279448,int_stack+2251368,int_stack+2188008,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2326968,int_stack+2279448,int_stack+2211768,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2168208,int_stack+352380,int_stack+341460,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2392968,int_stack+2168208,int_stack+2251368,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2449128,int_stack+2392968,int_stack+2279448,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2200968,int_stack+2449128,int_stack+2326968,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2299968,int_stack+364980,int_stack+352380,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2528328,int_stack+2299968,int_stack+2168208,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2593848,int_stack+2528328,int_stack+2392968,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2687448,int_stack+2593848,int_stack+2449128,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2337768,int_stack+2687448,int_stack+2200968,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2168208,int_stack+379380,int_stack+364980,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2211408,int_stack+2168208,int_stack+2299968,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2806248,int_stack+2211408,int_stack+2528328,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2915448,int_stack+2806248,int_stack+2593848,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2476368,int_stack+2915448,int_stack+2687448,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+3055848,int_stack+2476368,int_stack+2337768,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2287008,int_stack+395700,int_stack+379380,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2335968,int_stack+2287008,int_stack+2168208,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2642688,int_stack+2335968,int_stack+2211408,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2168208,int_stack+2642688,int_stack+2806248,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2642688,int_stack+2168208,int_stack+2915448,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2168208,int_stack+2642688,int_stack+2476368,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2389968,int_stack+2168208,int_stack+3055848,120);
 /*--- compute (rp|mk) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2627568,int_stack+2389968,int_stack+1419768,1980);
 /*--- compute (qd|mk) ---*/
 hrr1_build_qd(Libint->AB,int_stack+0,int_stack+2627568,int_stack+1627668,1980);
 /*--- compute (of|mk) ---*/
 hrr1_build_of(Libint->AB,int_stack+1081080,int_stack+0,int_stack+4299084,1980);
 /*--- compute (ng|mk) ---*/
 hrr1_build_ng(Libint->AB,int_stack+2625480,int_stack+1081080,int_stack+5225724,1980);
 /*--- compute (mh|mk) ---*/
 hrr1_build_mh(Libint->AB,int_stack+0,int_stack+2625480,int_stack+6532524,1980);
 return int_stack+0;}
