/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mini(Libint_t*, prim_data*);

  /* Computes quartets of (mi|ni) integrals */

REALTYPE *hrr_order_mini(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[10][10] = int_stack + 41195;
 Libint->vrr_classes[10][11] = int_stack + 45551;
 Libint->vrr_classes[10][12] = int_stack + 50699;
 Libint->vrr_classes[10][13] = int_stack + 56705;
 Libint->vrr_classes[10][14] = int_stack + 63635;
 Libint->vrr_classes[10][15] = int_stack + 71555;
 Libint->vrr_classes[10][16] = int_stack + 80531;
 Libint->vrr_classes[11][10] = int_stack + 90629;
 Libint->vrr_classes[11][11] = int_stack + 95777;
 Libint->vrr_classes[11][12] = int_stack + 101861;
 Libint->vrr_classes[11][13] = int_stack + 108959;
 Libint->vrr_classes[11][14] = int_stack + 117149;
 Libint->vrr_classes[11][15] = int_stack + 126509;
 Libint->vrr_classes[11][16] = int_stack + 137117;
 Libint->vrr_classes[12][10] = int_stack + 149051;
 Libint->vrr_classes[12][11] = int_stack + 155057;
 Libint->vrr_classes[12][12] = int_stack + 162155;
 Libint->vrr_classes[12][13] = int_stack + 170436;
 Libint->vrr_classes[12][14] = int_stack + 179991;
 Libint->vrr_classes[12][15] = int_stack + 190911;
 Libint->vrr_classes[12][16] = int_stack + 203287;
 Libint->vrr_classes[13][10] = int_stack + 217210;
 Libint->vrr_classes[13][11] = int_stack + 224140;
 Libint->vrr_classes[13][12] = int_stack + 232330;
 Libint->vrr_classes[13][13] = int_stack + 241885;
 Libint->vrr_classes[13][14] = int_stack + 252910;
 Libint->vrr_classes[13][15] = int_stack + 265510;
 Libint->vrr_classes[13][16] = int_stack + 279790;
 Libint->vrr_classes[14][10] = int_stack + 295855;
 Libint->vrr_classes[14][11] = int_stack + 303775;
 Libint->vrr_classes[14][12] = int_stack + 313135;
 Libint->vrr_classes[14][13] = int_stack + 324055;
 Libint->vrr_classes[14][14] = int_stack + 336655;
 Libint->vrr_classes[14][15] = int_stack + 351055;
 Libint->vrr_classes[14][16] = int_stack + 367375;
 Libint->vrr_classes[15][10] = int_stack + 385735;
 Libint->vrr_classes[15][11] = int_stack + 394711;
 Libint->vrr_classes[15][12] = int_stack + 405319;
 Libint->vrr_classes[15][13] = int_stack + 417695;
 Libint->vrr_classes[15][14] = int_stack + 431975;
 Libint->vrr_classes[15][15] = int_stack + 448295;
 Libint->vrr_classes[15][16] = int_stack + 466791;
 memset(int_stack,0,487599*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 487599;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mini(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+487599,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+498489,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+511359,int_stack+498489,int_stack+487599,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+533139,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+548154,int_stack+533139,int_stack+498489,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+573894,int_stack+548154,int_stack+511359,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+487599,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+610194,int_stack+487599,int_stack+533139,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+504924,int_stack+610194,int_stack+548154,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+640224,int_stack+504924,int_stack+573894,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+547824,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+567624,int_stack+547824,int_stack+487599,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+694674,int_stack+567624,int_stack+610194,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+744724,int_stack+694674,int_stack+504924,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+809074,int_stack+744724,int_stack+640224,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+487599,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+602274,int_stack+487599,int_stack+547824,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+487599,int_stack+602274,int_stack+567624,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+545349,int_stack+487599,int_stack+694674,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+620424,int_stack+545349,int_stack+744724,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+487599,int_stack+620424,int_stack+809074,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+589239,int_stack+45551,int_stack+41195,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+602307,int_stack+50699,int_stack+45551,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+617751,int_stack+602307,int_stack+589239,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+643887,int_stack+56705,int_stack+50699,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+661905,int_stack+643887,int_stack+602307,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+692793,int_stack+661905,int_stack+617751,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+589239,int_stack+63635,int_stack+56705,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+736353,int_stack+589239,int_stack+643887,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+610029,int_stack+736353,int_stack+661905,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+772389,int_stack+610029,int_stack+692793,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+661509,int_stack+71555,int_stack+63635,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+685269,int_stack+661509,int_stack+589239,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+685269,int_stack+736353,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+837729,int_stack+0,int_stack+610029,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+914949,int_stack+837729,int_stack+772389,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+589239,int_stack+80531,int_stack+71555,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+726849,int_stack+589239,int_stack+661509,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+589239,int_stack+726849,int_stack+685269,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+658539,int_stack+589239,int_stack+0,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1006425,int_stack+658539,int_stack+837729,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+589239,int_stack+1006425,int_stack+914949,66);
 /*--- compute (mp|ni) ---*/
 hrr1_build_mp(Libint->AB,int_stack+711207,int_stack+589239,int_stack+487599,1848);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+487599,int_stack+95777,int_stack+90629,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+503043,int_stack+101861,int_stack+95777,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+521295,int_stack+503043,int_stack+487599,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+552183,int_stack+108959,int_stack+101861,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+552183,int_stack+503043,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+36504,int_stack+0,int_stack+521295,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+487599,int_stack+117149,int_stack+108959,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1016127,int_stack+487599,int_stack+552183,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+512169,int_stack+1016127,int_stack+0,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1058715,int_stack+512169,int_stack+36504,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+126509,int_stack+117149,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+28080,int_stack+0,int_stack+487599,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1135935,int_stack+28080,int_stack+1016127,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1206915,int_stack+1135935,int_stack+512169,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1298175,int_stack+1206915,int_stack+1058715,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1016127,int_stack+137117,int_stack+126509,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1047951,int_stack+1016127,int_stack+0,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+487599,int_stack+1047951,int_stack+28080,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+487599,int_stack+1135935,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1016127,int_stack+0,int_stack+1206915,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1016127,int_stack+1298175,78);
 /*--- compute (np|ni) ---*/
 hrr1_build_np(Libint->AB,int_stack+1016127,int_stack+0,int_stack+589239,1848);
 /*--- compute (md|ni) ---*/
 hrr1_build_md(Libint->AB,int_stack+1382031,int_stack+1016127,int_stack+711207,1848);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+487599,int_stack+155057,int_stack+149051,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+505617,int_stack+162155,int_stack+155057,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+526911,int_stack+505617,int_stack+487599,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+562947,int_stack+170436,int_stack+162155,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+587790,int_stack+562947,int_stack+505617,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+630378,int_stack+587790,int_stack+526911,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+487599,int_stack+179991,int_stack+170436,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+690438,int_stack+487599,int_stack+562947,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+516264,int_stack+690438,int_stack+587790,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+740124,int_stack+516264,int_stack+630378,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+587244,int_stack+190911,int_stack+179991,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+620004,int_stack+587244,int_stack+487599,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+830214,int_stack+620004,int_stack+690438,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1991871,int_stack+830214,int_stack+516264,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2098341,int_stack+1991871,int_stack+740124,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+487599,int_stack+203287,int_stack+190911,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+677334,int_stack+487599,int_stack+587244,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+487599,int_stack+677334,int_stack+620004,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+583149,int_stack+487599,int_stack+830214,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+707364,int_stack+583149,int_stack+1991871,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+487599,int_stack+707364,int_stack+2098341,91);
 /*--- compute (op|ni) ---*/
 hrr1_build_op(Libint->AB,int_stack+1991871,int_stack+487599,int_stack+0,1848);
 /*--- compute (nd|ni) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2424303,int_stack+1991871,int_stack+1016127,1848);
 /*--- compute (mf|ni) ---*/
 hrr1_build_mf(Libint->AB,int_stack+3156111,int_stack+2424303,int_stack+1382031,1848);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+224140,int_stack+217210,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20790,int_stack+232330,int_stack+224140,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+45360,int_stack+20790,int_stack+0,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86940,int_stack+241885,int_stack+232330,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115605,int_stack+86940,int_stack+20790,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+164745,int_stack+115605,int_stack+45360,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+252910,int_stack+241885,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+655767,int_stack+0,int_stack+86940,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+33075,int_stack+655767,int_stack+115605,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+713097,int_stack+33075,int_stack+164745,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+114975,int_stack+265510,int_stack+252910,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+152775,int_stack+114975,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+817047,int_stack+152775,int_stack+655767,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+912597,int_stack+817047,int_stack+33075,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1035447,int_stack+912597,int_stack+713097,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+655767,int_stack+279790,int_stack+265510,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+698607,int_stack+655767,int_stack+114975,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+698607,int_stack+152775,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+655767,int_stack+0,int_stack+817047,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+655767,int_stack+912597,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+655767,int_stack+0,int_stack+1035447,105);
 /*--- compute (qp|ni) ---*/
 hrr1_build_qp(Libint->AB,int_stack+849807,int_stack+655767,int_stack+487599,1848);
 /*--- compute (od|ni) ---*/
 hrr1_build_od(Libint->AB,int_stack+4172511,int_stack+849807,int_stack+1991871,1848);
 /*--- compute (nf|ni) ---*/
 hrr1_build_nf(Libint->AB,int_stack+5037375,int_stack+4172511,int_stack+2424303,1848);
 /*--- compute (mg|ni) ---*/
 hrr1_build_mg(Libint->AB,int_stack+1354311,int_stack+5037375,int_stack+3156111,1848);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+487599,int_stack+303775,int_stack+295855,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+511359,int_stack+313135,int_stack+303775,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+539439,int_stack+511359,int_stack+487599,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+586959,int_stack+324055,int_stack+313135,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+586959,int_stack+511359,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+56160,int_stack+0,int_stack+539439,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+487599,int_stack+336655,int_stack+324055,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+135360,int_stack+487599,int_stack+586959,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+525399,int_stack+135360,int_stack+0,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+200880,int_stack+525399,int_stack+56160,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+351055,int_stack+336655,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+43200,int_stack+0,int_stack+487599,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2878911,int_stack+43200,int_stack+135360,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2988111,int_stack+2878911,int_stack+525399,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+487599,int_stack+2988111,int_stack+200880,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+118800,int_stack+367375,int_stack+351055,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+167760,int_stack+118800,int_stack+0,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+254160,int_stack+167760,int_stack+43200,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+254160,int_stack+2878911,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+163800,int_stack+0,int_stack+2988111,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2878911,int_stack+163800,int_stack+487599,120);
 /*--- compute (rp|ni) ---*/
 hrr1_build_rp(Libint->AB,int_stack+3100671,int_stack+2878911,int_stack+655767,1848);
 /*--- compute (qd|ni) ---*/
 hrr1_build_qd(Libint->AB,int_stack+6257055,int_stack+3100671,int_stack+849807,1848);
 /*--- compute (of|ni) ---*/
 hrr1_build_of(Libint->AB,int_stack+7266063,int_stack+6257055,int_stack+4172511,1848);
 /*--- compute (ng|ni) ---*/
 hrr1_build_ng(Libint->AB,int_stack+8707503,int_stack+7266063,int_stack+5037375,1848);
 /*--- compute (mh|ni) ---*/
 hrr1_build_mh(Libint->AB,int_stack+3682791,int_stack+8707503,int_stack+1354311,1848);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+487599,int_stack+394711,int_stack+385735,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+514527,int_stack+405319,int_stack+394711,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+546351,int_stack+514527,int_stack+487599,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+600207,int_stack+417695,int_stack+405319,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+637335,int_stack+600207,int_stack+514527,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+700983,int_stack+637335,int_stack+546351,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+487599,int_stack+431975,int_stack+417695,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+790743,int_stack+487599,int_stack+600207,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+530439,int_stack+790743,int_stack+637335,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+864999,int_stack+530439,int_stack+700983,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+636519,int_stack+448295,int_stack+431975,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+685479,int_stack+636519,int_stack+487599,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+999639,int_stack+685479,int_stack+790743,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1123399,int_stack+999639,int_stack+530439,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1282519,int_stack+1123399,int_stack+864999,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+487599,int_stack+466791,int_stack+448295,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+771159,int_stack+487599,int_stack+636519,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1471015,int_stack+771159,int_stack+685479,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1613815,int_stack+1471015,int_stack+999639,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1799455,int_stack+1613815,int_stack+1123399,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1471015,int_stack+1799455,int_stack+1282519,136);
 /*--- compute (tp|ni) ---*/
 hrr1_build_tp(Libint->AB,int_stack+1722343,int_stack+1471015,int_stack+2878911,1848);
 /*--- compute (rd|ni) ---*/
 hrr1_build_rd(Libint->AB,int_stack+0,int_stack+1722343,int_stack+3100671,1848);
 /*--- compute (qf|ni) ---*/
 hrr1_build_qf(Libint->AB,int_stack+1164240,int_stack+0,int_stack+6257055,1848);
 /*--- compute (og|ni) ---*/
 hrr1_build_og(Libint->AB,int_stack+10537023,int_stack+1164240,int_stack+7266063,1848);
 /*--- compute (nh|ni) ---*/
 hrr1_build_nh(Libint->AB,int_stack+0,int_stack+10537023,int_stack+8707503,1848);
 /*--- compute (mi|ni) ---*/
 hrr1_build_mi(Libint->AB,int_stack+5817231,int_stack+0,int_stack+3682791,1848);
 return int_stack+5817231;}
