/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_minn(Libint_t*, prim_data*);

  /* Computes quartets of (mi|nn) integrals */

REALTYPE *hrr_order_minn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[9][17] = int_stack + 41195;
 Libint->vrr_classes[9][18] = int_stack + 50600;
 Libint->vrr_classes[9][19] = int_stack + 61050;
 Libint->vrr_classes[9][20] = int_stack + 72600;
 Libint->vrr_classes[10][10] = int_stack + 85305;
 Libint->vrr_classes[10][11] = int_stack + 89661;
 Libint->vrr_classes[10][12] = int_stack + 94809;
 Libint->vrr_classes[10][13] = int_stack + 100815;
 Libint->vrr_classes[10][14] = int_stack + 107745;
 Libint->vrr_classes[10][15] = int_stack + 115665;
 Libint->vrr_classes[10][16] = int_stack + 124641;
 Libint->vrr_classes[10][17] = int_stack + 134739;
 Libint->vrr_classes[10][18] = int_stack + 146025;
 Libint->vrr_classes[10][19] = int_stack + 158565;
 Libint->vrr_classes[10][20] = int_stack + 172425;
 Libint->vrr_classes[11][10] = int_stack + 187671;
 Libint->vrr_classes[11][11] = int_stack + 192819;
 Libint->vrr_classes[11][12] = int_stack + 198903;
 Libint->vrr_classes[11][13] = int_stack + 206001;
 Libint->vrr_classes[11][14] = int_stack + 214191;
 Libint->vrr_classes[11][15] = int_stack + 223551;
 Libint->vrr_classes[11][16] = int_stack + 234159;
 Libint->vrr_classes[11][17] = int_stack + 246093;
 Libint->vrr_classes[11][18] = int_stack + 259431;
 Libint->vrr_classes[11][19] = int_stack + 274251;
 Libint->vrr_classes[11][20] = int_stack + 290631;
 Libint->vrr_classes[12][10] = int_stack + 308649;
 Libint->vrr_classes[12][11] = int_stack + 314655;
 Libint->vrr_classes[12][12] = int_stack + 321753;
 Libint->vrr_classes[12][13] = int_stack + 330034;
 Libint->vrr_classes[12][14] = int_stack + 339589;
 Libint->vrr_classes[12][15] = int_stack + 350509;
 Libint->vrr_classes[12][16] = int_stack + 362885;
 Libint->vrr_classes[12][17] = int_stack + 376808;
 Libint->vrr_classes[12][18] = int_stack + 392369;
 Libint->vrr_classes[12][19] = int_stack + 409659;
 Libint->vrr_classes[12][20] = int_stack + 428769;
 Libint->vrr_classes[13][10] = int_stack + 449790;
 Libint->vrr_classes[13][11] = int_stack + 456720;
 Libint->vrr_classes[13][12] = int_stack + 464910;
 Libint->vrr_classes[13][13] = int_stack + 474465;
 Libint->vrr_classes[13][14] = int_stack + 485490;
 Libint->vrr_classes[13][15] = int_stack + 498090;
 Libint->vrr_classes[13][16] = int_stack + 512370;
 Libint->vrr_classes[13][17] = int_stack + 528435;
 Libint->vrr_classes[13][18] = int_stack + 546390;
 Libint->vrr_classes[13][19] = int_stack + 566340;
 Libint->vrr_classes[13][20] = int_stack + 588390;
 Libint->vrr_classes[14][10] = int_stack + 612645;
 Libint->vrr_classes[14][11] = int_stack + 620565;
 Libint->vrr_classes[14][12] = int_stack + 629925;
 Libint->vrr_classes[14][13] = int_stack + 640845;
 Libint->vrr_classes[14][14] = int_stack + 653445;
 Libint->vrr_classes[14][15] = int_stack + 667845;
 Libint->vrr_classes[14][16] = int_stack + 684165;
 Libint->vrr_classes[14][17] = int_stack + 702525;
 Libint->vrr_classes[14][18] = int_stack + 723045;
 Libint->vrr_classes[14][19] = int_stack + 745845;
 Libint->vrr_classes[14][20] = int_stack + 771045;
 Libint->vrr_classes[15][10] = int_stack + 798765;
 Libint->vrr_classes[15][11] = int_stack + 807741;
 Libint->vrr_classes[15][12] = int_stack + 818349;
 Libint->vrr_classes[15][13] = int_stack + 830725;
 Libint->vrr_classes[15][14] = int_stack + 845005;
 Libint->vrr_classes[15][15] = int_stack + 861325;
 Libint->vrr_classes[15][16] = int_stack + 879821;
 Libint->vrr_classes[15][17] = int_stack + 900629;
 Libint->vrr_classes[15][18] = int_stack + 923885;
 Libint->vrr_classes[15][19] = int_stack + 949725;
 Libint->vrr_classes[15][20] = int_stack + 978285;
 memset(int_stack,0,1009701*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1009701;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_minn(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1009701,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1020591,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1033461,int_stack+1020591,int_stack+1009701,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1055241,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1070256,int_stack+1055241,int_stack+1020591,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1095996,int_stack+1070256,int_stack+1033461,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1009701,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1132296,int_stack+1009701,int_stack+1055241,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1027026,int_stack+1132296,int_stack+1070256,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1162326,int_stack+1027026,int_stack+1095996,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1069926,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1089726,int_stack+1069926,int_stack+1009701,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1216776,int_stack+1089726,int_stack+1132296,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1266826,int_stack+1216776,int_stack+1027026,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1331176,int_stack+1266826,int_stack+1162326,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1009701,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1124376,int_stack+1009701,int_stack+1069926,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1407406,int_stack+1124376,int_stack+1089726,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1032141,int_stack+1407406,int_stack+1216776,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1163976,int_stack+1032141,int_stack+1266826,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1465156,int_stack+1163976,int_stack+1331176,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1254066,int_stack+41195,int_stack+32780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1279311,int_stack+1254066,int_stack+1009701,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1324191,int_stack+1279311,int_stack+1124376,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1566796,int_stack+1324191,int_stack+1407406,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1653421,int_stack+1566796,int_stack+1032141,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1009701,int_stack+1653421,int_stack+1163976,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1758526,int_stack+1009701,int_stack+1465156,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1129821,int_stack+50600,int_stack+41195,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1158036,int_stack+1129821,int_stack+1254066,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1390191,int_stack+1158036,int_stack+1279311,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1208526,int_stack+1390191,int_stack+1324191,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1889206,int_stack+1208526,int_stack+1566796,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1464991,int_stack+1889206,int_stack+1653421,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2010481,int_stack+1464991,int_stack+1009701,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2164921,int_stack+2010481,int_stack+1758526,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1009701,int_stack+61050,int_stack+50600,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1041051,int_stack+1009701,int_stack+1129821,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1605131,int_stack+1041051,int_stack+1158036,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1689281,int_stack+1605131,int_stack+1390191,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1307526,int_stack+1689281,int_stack+1208526,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1097481,int_stack+1307526,int_stack+1889206,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1801481,int_stack+1097481,int_stack+1464991,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2328271,int_stack+1801481,int_stack+2010481,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2521321,int_stack+2328271,int_stack+2164921,55);
 /*--- compute (m0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1259181,int_stack+72600,int_stack+61050,55);
 /*--- compute (m0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1446126,int_stack+1259181,int_stack+1009701,55);
 /*--- compute (m0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1508826,int_stack+1446126,int_stack+1041051,55);
 /*--- compute (m0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1981661,int_stack+1508826,int_stack+1605131,55);
 /*--- compute (m0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1446126,int_stack+1981661,int_stack+1689281,55);
 /*--- compute (m0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1981661,int_stack+1446126,int_stack+1307526,55);
 /*--- compute (m0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1259181,int_stack+1981661,int_stack+1097481,55);
 /*--- compute (m0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1981661,int_stack+1259181,int_stack+1801481,55);
 /*--- compute (m0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1009701,int_stack+1981661,int_stack+2328271,55);
 /*--- compute (m0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1245651,int_stack+1009701,int_stack+2521321,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1009701,int_stack+89661,int_stack+85305,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1022769,int_stack+94809,int_stack+89661,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1038213,int_stack+1022769,int_stack+1009701,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1064349,int_stack+100815,int_stack+94809,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1082367,int_stack+1064349,int_stack+1022769,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1113255,int_stack+1082367,int_stack+1038213,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1009701,int_stack+107745,int_stack+100815,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1156815,int_stack+1009701,int_stack+1064349,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1030491,int_stack+1156815,int_stack+1082367,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1485231,int_stack+1030491,int_stack+1113255,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1081971,int_stack+115665,int_stack+107745,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1105731,int_stack+1081971,int_stack+1009701,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1550571,int_stack+1105731,int_stack+1156815,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1147311,int_stack+1550571,int_stack+1030491,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1610631,int_stack+1147311,int_stack+1485231,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1485231,int_stack+124641,int_stack+115665,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1009701,int_stack+1485231,int_stack+1081971,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1702107,int_stack+1009701,int_stack+1105731,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1057221,int_stack+1702107,int_stack+1550571,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1771407,int_stack+1057221,int_stack+1147311,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1879515,int_stack+1771407,int_stack+1610631,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1147311,int_stack+134739,int_stack+124641,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1177605,int_stack+1147311,int_stack+1485231,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1485231,int_stack+1177605,int_stack+1009701,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1564431,int_stack+1485231,int_stack+1702107,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2001483,int_stack+1564431,int_stack+1057221,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2127609,int_stack+2001483,int_stack+1771407,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1668381,int_stack+2127609,int_stack+1879515,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1009701,int_stack+146025,int_stack+134739,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1043559,int_stack+1009701,int_stack+1147311,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1825197,int_stack+1043559,int_stack+1177605,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1104147,int_stack+1825197,int_stack+1485231,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2271753,int_stack+1104147,int_stack+1564431,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1485231,int_stack+2271753,int_stack+2001483,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1914957,int_stack+1485231,int_stack+2127609,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2417283,int_stack+1914957,int_stack+1668381,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1653399,int_stack+158565,int_stack+146025,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1691019,int_stack+1653399,int_stack+1009701,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2100285,int_stack+1691019,int_stack+1043559,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+2100285,int_stack+1825197,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2613303,int_stack+0,int_stack+1104147,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1009701,int_stack+2613303,int_stack+2271753,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2779623,int_stack+1009701,int_stack+1485231,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2995839,int_stack+2779623,int_stack+1914957,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1758735,int_stack+2995839,int_stack+2417283,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1485231,int_stack+172425,int_stack+158565,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1526811,int_stack+1485231,int_stack+1653399,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+2201265,int_stack+1526811,int_stack+1691019,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1485231,int_stack+2201265,int_stack+2100285,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1998315,int_stack+1485231,int_stack+0,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1485231,int_stack+1998315,int_stack+2613303,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1998315,int_stack+1485231,int_stack+1009701,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1485231,int_stack+1998315,int_stack+2779623,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1998315,int_stack+1485231,int_stack+2995839,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2281455,int_stack+1998315,int_stack+1758735,66);
 /*--- compute (mp|nn) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1485231,int_stack+2281455,int_stack+1245651,4356);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2203971,int_stack+192819,int_stack+187671,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2219415,int_stack+198903,int_stack+192819,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2237667,int_stack+2219415,int_stack+2203971,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2568951,int_stack+206001,int_stack+198903,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2590245,int_stack+2568951,int_stack+2219415,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2626749,int_stack+2590245,int_stack+2237667,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2203971,int_stack+214191,int_stack+206001,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2228541,int_stack+2203971,int_stack+2568951,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2678229,int_stack+2228541,int_stack+2590245,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2739069,int_stack+2678229,int_stack+2626749,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2568951,int_stack+223551,int_stack+214191,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2597031,int_stack+2568951,int_stack+2203971,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2816289,int_stack+2597031,int_stack+2228541,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2887269,int_stack+2816289,int_stack+2678229,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2978529,int_stack+2887269,int_stack+2739069,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2203971,int_stack+234159,int_stack+223551,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2646171,int_stack+2203971,int_stack+2568951,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2702331,int_stack+2646171,int_stack+2597031,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+3086637,int_stack+2702331,int_stack+2816289,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1009701,int_stack+3086637,int_stack+2887269,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2784231,int_stack+1009701,int_stack+2978529,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2568951,int_stack+246093,int_stack+234159,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2928375,int_stack+2568951,int_stack+2203971,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2992023,int_stack+2928375,int_stack+2646171,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1137465,int_stack+2992023,int_stack+2702331,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2604753,int_stack+1137465,int_stack+3086637,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1260315,int_stack+2604753,int_stack+1009701,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1260315,int_stack+2784231,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1009701,int_stack+259431,int_stack+246093,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1049715,int_stack+1009701,int_stack+2568951,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2753811,int_stack+1049715,int_stack+2928375,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3085623,int_stack+2753811,int_stack+2992023,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2859891,int_stack+3085623,int_stack+1137465,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3226023,int_stack+2859891,int_stack+2604753,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3424767,int_stack+3226023,int_stack+1260315,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1121319,int_stack+3424767,int_stack+0,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+274251,int_stack+259431,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+44460,int_stack+0,int_stack+1009701,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+124488,int_stack+44460,int_stack+1049715,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2568951,int_stack+124488,int_stack+2753811,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3643791,int_stack+2568951,int_stack+3085623,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+3840351,int_stack+3643791,int_stack+2859891,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2728071,int_stack+3840351,int_stack+3226023,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2983599,int_stack+2728071,int_stack+3424767,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+3257379,int_stack+2983599,int_stack+1121319,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1009701,int_stack+290631,int_stack+274251,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1058841,int_stack+1009701,int_stack+0,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1147761,int_stack+1058841,int_stack+44460,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1281141,int_stack+1147761,int_stack+124488,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+1281141,int_stack+2568951,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1009701,int_stack+0,int_stack+3643791,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+1009701,int_stack+3840351,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1009701,int_stack+0,int_stack+2728071,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2568951,int_stack+1009701,int_stack+2983599,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1009701,int_stack+2568951,int_stack+3257379,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+2568951,int_stack+1009701,int_stack+2281455,4356);
 /*--- compute (md|nn) ---*/
 hrr1_build_md(Libint->AB,int_stack+3431439,int_stack+2568951,int_stack+1485231,4356);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1349469,int_stack+314655,int_stack+308649,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1367487,int_stack+321753,int_stack+314655,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1388781,int_stack+1367487,int_stack+1349469,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1424817,int_stack+330034,int_stack+321753,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1449660,int_stack+1424817,int_stack+1367487,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1492248,int_stack+1449660,int_stack+1388781,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1349469,int_stack+339589,int_stack+330034,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1552308,int_stack+1349469,int_stack+1424817,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1378134,int_stack+1552308,int_stack+1449660,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1601994,int_stack+1378134,int_stack+1492248,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1449114,int_stack+350509,int_stack+339589,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1481874,int_stack+1449114,int_stack+1349469,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1692084,int_stack+1481874,int_stack+1552308,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1774894,int_stack+1692084,int_stack+1378134,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1881364,int_stack+1774894,int_stack+1601994,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1349469,int_stack+362885,int_stack+350509,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1539204,int_stack+1349469,int_stack+1449114,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2007490,int_stack+1539204,int_stack+1481874,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1386597,int_stack+2007490,int_stack+1692084,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1604724,int_stack+1386597,int_stack+1774894,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2103040,int_stack+1604724,int_stack+1881364,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1753782,int_stack+376808,int_stack+362885,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1795551,int_stack+1753782,int_stack+1349469,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1869807,int_stack+1795551,int_stack+1539204,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2271208,int_stack+1869807,int_stack+2007490,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+2271208,int_stack+1386597,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1349469,int_stack+0,int_stack+1604724,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4868919,int_stack+1349469,int_stack+2103040,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1548213,int_stack+392369,int_stack+376808,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1594896,int_stack+1548213,int_stack+1753782,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1979007,int_stack+1594896,int_stack+1795551,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1678434,int_stack+1979007,int_stack+1869807,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+173901,int_stack+1678434,int_stack+2271208,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2102767,int_stack+173901,int_stack+0,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+5085135,int_stack+2102767,int_stack+1349469,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+5340663,int_stack+5085135,int_stack+4868919,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+4868919,int_stack+409659,int_stack+392369,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+4920789,int_stack+4868919,int_stack+1548213,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1349469,int_stack+4920789,int_stack+1594896,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1488699,int_stack+1349469,int_stack+1979007,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1842234,int_stack+1488699,int_stack+1678434,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+5610933,int_stack+1842234,int_stack+173901,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+0,int_stack+5610933,int_stack+2102767,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2071554,int_stack+0,int_stack+5085135,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+5878473,int_stack+2071554,int_stack+5340663,91);
 /*--- compute (q0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+5014155,int_stack+428769,int_stack+409659,91);
 /*--- compute (q0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+5071485,int_stack+5014155,int_stack+4868919,91);
 /*--- compute (q0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+5175225,int_stack+5071485,int_stack+4920789,91);
 /*--- compute (q0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+4868919,int_stack+5175225,int_stack+1349469,91);
 /*--- compute (q0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+5077764,int_stack+4868919,int_stack+1488699,91);
 /*--- compute (q0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1349469,int_stack+5077764,int_stack+1842234,91);
 /*--- compute (q0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+4868919,int_stack+1349469,int_stack+5610933,91);
 /*--- compute (q0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1349469,int_stack+4868919,int_stack+0,91);
 /*--- compute (q0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+1349469,int_stack+2071554,91);
 /*--- compute (q0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1349469,int_stack+0,int_stack+5878473,91);
 /*--- compute (op|nn) ---*/
 hrr1_build_op(Libint->AB,int_stack+4868919,int_stack+1349469,int_stack+1009701,4356);
 /*--- compute (nd|nn) ---*/
 hrr1_build_nd(Libint->AB,int_stack+5888223,int_stack+4868919,int_stack+2568951,4356);
 /*--- compute (mf|nn) ---*/
 hrr1_build_mf(Libint->AB,int_stack+7613199,int_stack+5888223,int_stack+3431439,4356);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1009701,int_stack+456720,int_stack+449790,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1030491,int_stack+464910,int_stack+456720,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1055061,int_stack+1030491,int_stack+1009701,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1096641,int_stack+474465,int_stack+464910,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1125306,int_stack+1096641,int_stack+1030491,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1174446,int_stack+1125306,int_stack+1055061,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1009701,int_stack+485490,int_stack+474465,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1243746,int_stack+1009701,int_stack+1096641,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1042776,int_stack+1243746,int_stack+1125306,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+1042776,int_stack+1174446,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1124676,int_stack+498090,int_stack+485490,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1162476,int_stack+1124676,int_stack+1009701,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+103950,int_stack+1162476,int_stack+1243746,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+199500,int_stack+103950,int_stack+1042776,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+322350,int_stack+199500,int_stack+0,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+512370,int_stack+498090,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1009701,int_stack+0,int_stack+1124676,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1228626,int_stack+1009701,int_stack+1162476,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1085301,int_stack+1228626,int_stack+103950,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1745865,int_stack+1085301,int_stack+199500,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+42840,int_stack+1745865,int_stack+322350,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+236880,int_stack+528435,int_stack+512370,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+285075,int_stack+236880,int_stack+0,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+370755,int_stack+285075,int_stack+1009701,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1917855,int_stack+370755,int_stack+1228626,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2083230,int_stack+1917855,int_stack+1085301,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1009701,int_stack+2083230,int_stack+1745865,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2283885,int_stack+1009701,int_stack+42840,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1745865,int_stack+546390,int_stack+528435,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1799730,int_stack+1745865,int_stack+236880,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+1799730,int_stack+285075,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+142800,int_stack+0,int_stack+370755,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2533365,int_stack+142800,int_stack+1917855,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2764890,int_stack+2533365,int_stack+2083230,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1896120,int_stack+2764890,int_stack+1009701,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1009701,int_stack+1896120,int_stack+2283885,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+2190960,int_stack+566340,int_stack+546390,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+2250810,int_stack+2190960,int_stack+1745865,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2358540,int_stack+2250810,int_stack+1799730,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+331800,int_stack+2358540,int_stack+0,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3032430,int_stack+331800,int_stack+142800,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+0,int_stack+3032430,int_stack+2533365,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3297030,int_stack+0,int_stack+2764890,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2519190,int_stack+3297030,int_stack+1896120,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1745865,int_stack+2519190,int_stack+1009701,105);
 /*--- compute (r0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1009701,int_stack+588390,int_stack+566340,105);
 /*--- compute (r0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1075851,int_stack+1009701,int_stack+2190960,105);
 /*--- compute (r0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+3641010,int_stack+1075851,int_stack+2250810,105);
 /*--- compute (r0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1009701,int_stack+3641010,int_stack+2358540,105);
 /*--- compute (r0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+3641010,int_stack+1009701,int_stack+331800,105);
 /*--- compute (r0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+3940890,int_stack+3641010,int_stack+3032430,105);
 /*--- compute (r0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+4293690,int_stack+3940890,int_stack+0,105);
 /*--- compute (r0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+0,int_stack+4293690,int_stack+3297030,105);
 /*--- compute (r0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2887740,int_stack+0,int_stack+2519190,105);
 /*--- compute (r0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+0,int_stack+2887740,int_stack+1745865,105);
 /*--- compute (qp|nn) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1745865,int_stack+0,int_stack+1349469,4356);
 /*--- compute (od|nn) ---*/
 hrr1_build_od(Libint->AB,int_stack+10008999,int_stack+1745865,int_stack+4868919,4356);
 /*--- compute (nf|nn) ---*/
 hrr1_build_nf(Libint->AB,int_stack+2935053,int_stack+10008999,int_stack+5888223,4356);
 /*--- compute (mg|nn) ---*/
 hrr1_build_mg(Libint->AB,int_stack+12047607,int_stack+2935053,int_stack+7613199,4356);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+5810013,int_stack+620565,int_stack+612645,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5833773,int_stack+629925,int_stack+620565,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+5861853,int_stack+5833773,int_stack+5810013,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+5909373,int_stack+640845,int_stack+629925,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+5942133,int_stack+5909373,int_stack+5833773,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+5998293,int_stack+5942133,int_stack+5861853,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+5810013,int_stack+653445,int_stack+640845,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+6077493,int_stack+5810013,int_stack+5909373,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+5847813,int_stack+6077493,int_stack+5942133,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+6143013,int_stack+5847813,int_stack+5998293,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+5941413,int_stack+667845,int_stack+653445,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+5984613,int_stack+5941413,int_stack+5810013,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+6261813,int_stack+5984613,int_stack+6077493,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+6371013,int_stack+6261813,int_stack+5847813,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+6511413,int_stack+6371013,int_stack+6143013,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+5810013,int_stack+684165,int_stack+667845,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+6060213,int_stack+5810013,int_stack+5941413,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+6677733,int_stack+6060213,int_stack+5984613,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+5858973,int_stack+6677733,int_stack+6261813,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+6146613,int_stack+5858973,int_stack+6371013,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+6803733,int_stack+6146613,int_stack+6511413,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+6343173,int_stack+702525,int_stack+684165,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+6398253,int_stack+6343173,int_stack+5810013,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+6496173,int_stack+6398253,int_stack+6060213,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+7025493,int_stack+6496173,int_stack+6677733,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+7214493,int_stack+7025493,int_stack+5858973,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+5810013,int_stack+7214493,int_stack+6146613,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+7443813,int_stack+5810013,int_stack+6803733,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+6072093,int_stack+723045,int_stack+702525,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+6133653,int_stack+6072093,int_stack+6343173,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+6640173,int_stack+6133653,int_stack+6398253,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+6243813,int_stack+6640173,int_stack+6496173,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+7728933,int_stack+6243813,int_stack+7025493,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+6803373,int_stack+7728933,int_stack+7214493,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+7993533,int_stack+6803373,int_stack+5810013,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+8330493,int_stack+7993533,int_stack+7443813,120);
 /*--- compute (t0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+5810013,int_stack+745845,int_stack+723045,120);
 /*--- compute (t0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+5878413,int_stack+5810013,int_stack+6072093,120);
 /*--- compute (t0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+7109133,int_stack+5878413,int_stack+6133653,120);
 /*--- compute (t0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+7292733,int_stack+7109133,int_stack+6640173,120);
 /*--- compute (t0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+6459813,int_stack+7292733,int_stack+6243813,120);
 /*--- compute (t0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+6001533,int_stack+6459813,int_stack+7728933,120);
 /*--- compute (t0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+7537533,int_stack+6001533,int_stack+6803373,120);
 /*--- compute (t0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+8686893,int_stack+7537533,int_stack+7993533,120);
 /*--- compute (t0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+9108093,int_stack+8686893,int_stack+8330493,120);
 /*--- compute (t0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+6354333,int_stack+771045,int_stack+745845,120);
 /*--- compute (t0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+6762213,int_stack+6354333,int_stack+5810013,120);
 /*--- compute (t0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+6899013,int_stack+6762213,int_stack+5878413,120);
 /*--- compute (t0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+7930653,int_stack+6899013,int_stack+7109133,120);
 /*--- compute (t0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+6762213,int_stack+7930653,int_stack+7292733,120);
 /*--- compute (t0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+7930653,int_stack+6762213,int_stack+6459813,120);
 /*--- compute (t0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+6354333,int_stack+7930653,int_stack+6001533,120);
 /*--- compute (t0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+7930653,int_stack+6354333,int_stack+7537533,120);
 /*--- compute (t0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+5810013,int_stack+7930653,int_stack+8686893,120);
 /*--- compute (t0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+6324813,int_stack+5810013,int_stack+9108093,120);
 /*--- compute (rp|nn) ---*/
 hrr1_build_rp(Libint->AB,int_stack+6847533,int_stack+6324813,int_stack+0,4356);
 /*--- compute (qd|nn) ---*/
 hrr1_build_qd(Libint->AB,int_stack+15641307,int_stack+6847533,int_stack+1745865,4356);
 /*--- compute (of|nn) ---*/
 hrr1_build_of(Libint->AB,int_stack+18019683,int_stack+15641307,int_stack+10008999,4356);
 /*--- compute (ng|nn) ---*/
 hrr1_build_ng(Libint->AB,int_stack+21417363,int_stack+18019683,int_stack+2935053,4356);
 /*--- compute (mh|nn) ---*/
 hrr1_build_mh(Libint->AB,int_stack+1009701,int_stack+21417363,int_stack+12047607,4356);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+807741,int_stack+798765,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+26928,int_stack+818349,int_stack+807741,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+58752,int_stack+26928,int_stack+0,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+112608,int_stack+830725,int_stack+818349,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+149736,int_stack+112608,int_stack+26928,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+213384,int_stack+149736,int_stack+58752,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+845005,int_stack+830725,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+303144,int_stack+0,int_stack+112608,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+42840,int_stack+303144,int_stack+149736,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+377400,int_stack+42840,int_stack+213384,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+148920,int_stack+861325,int_stack+845005,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+197880,int_stack+148920,int_stack+0,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+512040,int_stack+197880,int_stack+303144,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+635800,int_stack+512040,int_stack+42840,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+8219673,int_stack+635800,int_stack+377400,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+879821,int_stack+861325,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+283560,int_stack+0,int_stack+148920,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+8408169,int_stack+283560,int_stack+197880,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+55488,int_stack+8408169,int_stack+512040,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+381480,int_stack+55488,int_stack+635800,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+604248,int_stack+381480,int_stack+8219673,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+8219673,int_stack+900629,int_stack+879821,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+8282097,int_stack+8219673,int_stack+0,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+8550969,int_stack+8282097,int_stack+283560,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+8714169,int_stack+8550969,int_stack+8408169,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+8928369,int_stack+8714169,int_stack+55488,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+8928369,int_stack+381480,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+9188265,int_stack+0,int_stack+604248,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+297024,int_stack+923885,int_stack+900629,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+366792,int_stack+297024,int_stack+8219673,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+491640,int_stack+366792,int_stack+8282097,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+8219673,int_stack+491640,int_stack+8550969,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+9511401,int_stack+8219673,int_stack+8714169,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+8464473,int_stack+9511401,int_stack+8928369,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+9811281,int_stack+8464473,int_stack+0,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+10193169,int_stack+9811281,int_stack+9188265,136);
 /*--- compute (u0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+949725,int_stack+923885,136);
 /*--- compute (u0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+77520,int_stack+0,int_stack+297024,136);
 /*--- compute (u0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+8811001,int_stack+77520,int_stack+366792,136);
 /*--- compute (u0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+9019081,int_stack+8811001,int_stack+491640,136);
 /*--- compute (u0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+217056,int_stack+9019081,int_stack+8219673,136);
 /*--- compute (u0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+10597089,int_stack+217056,int_stack+9511401,136);
 /*--- compute (u0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+9296521,int_stack+10597089,int_stack+8464473,136);
 /*--- compute (u0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+8219673,int_stack+9296521,int_stack+9811281,136);
 /*--- compute (u0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+10996929,int_stack+8219673,int_stack+10193169,136);
 /*--- compute (u0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+8697033,int_stack+978285,int_stack+949725,136);
 /*--- compute (u0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+559776,int_stack+8697033,int_stack+0,136);
 /*--- compute (u0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+714816,int_stack+559776,int_stack+77520,136);
 /*--- compute (u0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+9742057,int_stack+714816,int_stack+8811001,136);
 /*--- compute (u0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+559776,int_stack+9742057,int_stack+9019081,136);
 /*--- compute (u0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+9742057,int_stack+559776,int_stack+217056,136);
 /*--- compute (u0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+9742057,int_stack+10597089,136);
 /*--- compute (u0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+9742057,int_stack+0,int_stack+9296521,136);
 /*--- compute (u0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+9742057,int_stack+8219673,136);
 /*--- compute (u0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+8219673,int_stack+0,int_stack+10996929,136);
 /*--- compute (tp|nn) ---*/
 hrr1_build_tp(Libint->AB,int_stack+8812089,int_stack+8219673,int_stack+6324813,4356);
 /*--- compute (rd|nn) ---*/
 hrr1_build_rd(Libint->AB,int_stack+10380249,int_stack+8812089,int_stack+6847533,4356);
 /*--- compute (qf|nn) ---*/
 hrr1_build_qf(Libint->AB,int_stack+6040881,int_stack+10380249,int_stack+15641307,4356);
 /*--- compute (og|nn) ---*/
 hrr1_build_og(Libint->AB,int_stack+10004841,int_stack+6040881,int_stack+18019683,4356);
 /*--- compute (nh|nn) ---*/
 hrr1_build_nh(Libint->AB,int_stack+15101361,int_stack+10004841,int_stack+21417363,4356);
 /*--- compute (mi|nn) ---*/
 hrr1_build_mi(Libint->AB,int_stack+6040881,int_stack+15101361,int_stack+1009701,4356);
 return int_stack+6040881;}
