/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mmnn(Libint_t*, prim_data*);

  /* Computes quartets of (mm|nn) integrals */

REALTYPE *hrr_order_mmnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[9][17] = int_stack + 41195;
 Libint->vrr_classes[9][18] = int_stack + 50600;
 Libint->vrr_classes[9][19] = int_stack + 61050;
 Libint->vrr_classes[9][20] = int_stack + 72600;
 Libint->vrr_classes[10][10] = int_stack + 85305;
 Libint->vrr_classes[10][11] = int_stack + 89661;
 Libint->vrr_classes[10][12] = int_stack + 94809;
 Libint->vrr_classes[10][13] = int_stack + 100815;
 Libint->vrr_classes[10][14] = int_stack + 107745;
 Libint->vrr_classes[10][15] = int_stack + 115665;
 Libint->vrr_classes[10][16] = int_stack + 124641;
 Libint->vrr_classes[10][17] = int_stack + 134739;
 Libint->vrr_classes[10][18] = int_stack + 146025;
 Libint->vrr_classes[10][19] = int_stack + 158565;
 Libint->vrr_classes[10][20] = int_stack + 172425;
 Libint->vrr_classes[11][10] = int_stack + 187671;
 Libint->vrr_classes[11][11] = int_stack + 192819;
 Libint->vrr_classes[11][12] = int_stack + 198903;
 Libint->vrr_classes[11][13] = int_stack + 206001;
 Libint->vrr_classes[11][14] = int_stack + 214191;
 Libint->vrr_classes[11][15] = int_stack + 223551;
 Libint->vrr_classes[11][16] = int_stack + 234159;
 Libint->vrr_classes[11][17] = int_stack + 246093;
 Libint->vrr_classes[11][18] = int_stack + 259431;
 Libint->vrr_classes[11][19] = int_stack + 274251;
 Libint->vrr_classes[11][20] = int_stack + 290631;
 Libint->vrr_classes[12][10] = int_stack + 308649;
 Libint->vrr_classes[12][11] = int_stack + 314655;
 Libint->vrr_classes[12][12] = int_stack + 321753;
 Libint->vrr_classes[12][13] = int_stack + 330034;
 Libint->vrr_classes[12][14] = int_stack + 339589;
 Libint->vrr_classes[12][15] = int_stack + 350509;
 Libint->vrr_classes[12][16] = int_stack + 362885;
 Libint->vrr_classes[12][17] = int_stack + 376808;
 Libint->vrr_classes[12][18] = int_stack + 392369;
 Libint->vrr_classes[12][19] = int_stack + 409659;
 Libint->vrr_classes[12][20] = int_stack + 428769;
 Libint->vrr_classes[13][10] = int_stack + 449790;
 Libint->vrr_classes[13][11] = int_stack + 456720;
 Libint->vrr_classes[13][12] = int_stack + 464910;
 Libint->vrr_classes[13][13] = int_stack + 474465;
 Libint->vrr_classes[13][14] = int_stack + 485490;
 Libint->vrr_classes[13][15] = int_stack + 498090;
 Libint->vrr_classes[13][16] = int_stack + 512370;
 Libint->vrr_classes[13][17] = int_stack + 528435;
 Libint->vrr_classes[13][18] = int_stack + 546390;
 Libint->vrr_classes[13][19] = int_stack + 566340;
 Libint->vrr_classes[13][20] = int_stack + 588390;
 Libint->vrr_classes[14][10] = int_stack + 612645;
 Libint->vrr_classes[14][11] = int_stack + 620565;
 Libint->vrr_classes[14][12] = int_stack + 629925;
 Libint->vrr_classes[14][13] = int_stack + 640845;
 Libint->vrr_classes[14][14] = int_stack + 653445;
 Libint->vrr_classes[14][15] = int_stack + 667845;
 Libint->vrr_classes[14][16] = int_stack + 684165;
 Libint->vrr_classes[14][17] = int_stack + 702525;
 Libint->vrr_classes[14][18] = int_stack + 723045;
 Libint->vrr_classes[14][19] = int_stack + 745845;
 Libint->vrr_classes[14][20] = int_stack + 771045;
 Libint->vrr_classes[15][10] = int_stack + 798765;
 Libint->vrr_classes[15][11] = int_stack + 807741;
 Libint->vrr_classes[15][12] = int_stack + 818349;
 Libint->vrr_classes[15][13] = int_stack + 830725;
 Libint->vrr_classes[15][14] = int_stack + 845005;
 Libint->vrr_classes[15][15] = int_stack + 861325;
 Libint->vrr_classes[15][16] = int_stack + 879821;
 Libint->vrr_classes[15][17] = int_stack + 900629;
 Libint->vrr_classes[15][18] = int_stack + 923885;
 Libint->vrr_classes[15][19] = int_stack + 949725;
 Libint->vrr_classes[15][20] = int_stack + 978285;
 Libint->vrr_classes[16][10] = int_stack + 1009701;
 Libint->vrr_classes[16][11] = int_stack + 1019799;
 Libint->vrr_classes[16][12] = int_stack + 1031733;
 Libint->vrr_classes[16][13] = int_stack + 1045656;
 Libint->vrr_classes[16][14] = int_stack + 1061721;
 Libint->vrr_classes[16][15] = int_stack + 1080081;
 Libint->vrr_classes[16][16] = int_stack + 1100889;
 Libint->vrr_classes[16][17] = int_stack + 1124298;
 Libint->vrr_classes[16][18] = int_stack + 1150461;
 Libint->vrr_classes[16][19] = int_stack + 1179531;
 Libint->vrr_classes[16][20] = int_stack + 1211661;
 Libint->vrr_classes[17][10] = int_stack + 1247004;
 Libint->vrr_classes[17][11] = int_stack + 1258290;
 Libint->vrr_classes[17][12] = int_stack + 1271628;
 Libint->vrr_classes[17][13] = int_stack + 1287189;
 Libint->vrr_classes[17][14] = int_stack + 1305144;
 Libint->vrr_classes[17][15] = int_stack + 1325664;
 Libint->vrr_classes[17][16] = int_stack + 1348920;
 Libint->vrr_classes[17][17] = int_stack + 1375083;
 Libint->vrr_classes[17][18] = int_stack + 1404324;
 Libint->vrr_classes[17][19] = int_stack + 1436814;
 Libint->vrr_classes[17][20] = int_stack + 1472724;
 Libint->vrr_classes[18][10] = int_stack + 1512225;
 Libint->vrr_classes[18][11] = int_stack + 1524765;
 Libint->vrr_classes[18][12] = int_stack + 1539585;
 Libint->vrr_classes[18][13] = int_stack + 1556875;
 Libint->vrr_classes[18][14] = int_stack + 1576825;
 Libint->vrr_classes[18][15] = int_stack + 1599625;
 Libint->vrr_classes[18][16] = int_stack + 1625465;
 Libint->vrr_classes[18][17] = int_stack + 1654535;
 Libint->vrr_classes[18][18] = int_stack + 1687025;
 Libint->vrr_classes[18][19] = int_stack + 1723125;
 Libint->vrr_classes[18][20] = int_stack + 1763025;
 memset(int_stack,0,1806915*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1806915;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mmnn(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1806915,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1817805,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1830675,int_stack+1817805,int_stack+1806915,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1852455,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1867470,int_stack+1852455,int_stack+1817805,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1893210,int_stack+1867470,int_stack+1830675,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1806915,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1929510,int_stack+1806915,int_stack+1852455,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1824240,int_stack+1929510,int_stack+1867470,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1959540,int_stack+1824240,int_stack+1893210,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1867140,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1886940,int_stack+1867140,int_stack+1806915,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2013990,int_stack+1886940,int_stack+1929510,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2064040,int_stack+2013990,int_stack+1824240,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2128390,int_stack+2064040,int_stack+1959540,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1806915,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1921590,int_stack+1806915,int_stack+1867140,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2204620,int_stack+1921590,int_stack+1886940,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1829355,int_stack+2204620,int_stack+2013990,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1961190,int_stack+1829355,int_stack+2064040,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2262370,int_stack+1961190,int_stack+2128390,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2051280,int_stack+41195,int_stack+32780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2076525,int_stack+2051280,int_stack+1806915,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2121405,int_stack+2076525,int_stack+1921590,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2364010,int_stack+2121405,int_stack+2204620,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2450635,int_stack+2364010,int_stack+1829355,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1806915,int_stack+2450635,int_stack+1961190,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2555740,int_stack+1806915,int_stack+2262370,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1927035,int_stack+50600,int_stack+41195,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1955250,int_stack+1927035,int_stack+2051280,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2187405,int_stack+1955250,int_stack+2076525,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2005740,int_stack+2187405,int_stack+2121405,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2686420,int_stack+2005740,int_stack+2364010,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2262205,int_stack+2686420,int_stack+2450635,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2807695,int_stack+2262205,int_stack+1806915,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2962135,int_stack+2807695,int_stack+2555740,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1806915,int_stack+61050,int_stack+50600,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1838265,int_stack+1806915,int_stack+1927035,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2402345,int_stack+1838265,int_stack+1955250,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2486495,int_stack+2402345,int_stack+2187405,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2104740,int_stack+2486495,int_stack+2005740,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1894695,int_stack+2104740,int_stack+2686420,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2598695,int_stack+1894695,int_stack+2262205,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3125485,int_stack+2598695,int_stack+2807695,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+3318535,int_stack+3125485,int_stack+2962135,55);
 /*--- compute (m0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+2056395,int_stack+72600,int_stack+61050,55);
 /*--- compute (m0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+2243340,int_stack+2056395,int_stack+1806915,55);
 /*--- compute (m0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+2306040,int_stack+2243340,int_stack+1838265,55);
 /*--- compute (m0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2778875,int_stack+2306040,int_stack+2402345,55);
 /*--- compute (m0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+2243340,int_stack+2778875,int_stack+2486495,55);
 /*--- compute (m0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+2778875,int_stack+2243340,int_stack+2104740,55);
 /*--- compute (m0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+2056395,int_stack+2778875,int_stack+1894695,55);
 /*--- compute (m0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2778875,int_stack+2056395,int_stack+2598695,55);
 /*--- compute (m0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1806915,int_stack+2778875,int_stack+3125485,55);
 /*--- compute (m0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2042865,int_stack+1806915,int_stack+3318535,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1806915,int_stack+89661,int_stack+85305,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1819983,int_stack+94809,int_stack+89661,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1835427,int_stack+1819983,int_stack+1806915,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1861563,int_stack+100815,int_stack+94809,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1879581,int_stack+1861563,int_stack+1819983,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1910469,int_stack+1879581,int_stack+1835427,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1806915,int_stack+107745,int_stack+100815,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1954029,int_stack+1806915,int_stack+1861563,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1827705,int_stack+1954029,int_stack+1879581,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2282445,int_stack+1827705,int_stack+1910469,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1879185,int_stack+115665,int_stack+107745,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1902945,int_stack+1879185,int_stack+1806915,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2347785,int_stack+1902945,int_stack+1954029,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1944525,int_stack+2347785,int_stack+1827705,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2407845,int_stack+1944525,int_stack+2282445,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2282445,int_stack+124641,int_stack+115665,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1806915,int_stack+2282445,int_stack+1879185,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2499321,int_stack+1806915,int_stack+1902945,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1854435,int_stack+2499321,int_stack+2347785,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2568621,int_stack+1854435,int_stack+1944525,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2676729,int_stack+2568621,int_stack+2407845,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1944525,int_stack+134739,int_stack+124641,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1974819,int_stack+1944525,int_stack+2282445,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2282445,int_stack+1974819,int_stack+1806915,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2361645,int_stack+2282445,int_stack+2499321,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2798697,int_stack+2361645,int_stack+1854435,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2924823,int_stack+2798697,int_stack+2568621,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2465595,int_stack+2924823,int_stack+2676729,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1806915,int_stack+146025,int_stack+134739,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1840773,int_stack+1806915,int_stack+1944525,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2622411,int_stack+1840773,int_stack+1974819,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1901361,int_stack+2622411,int_stack+2282445,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3068967,int_stack+1901361,int_stack+2361645,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2282445,int_stack+3068967,int_stack+2798697,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2712171,int_stack+2282445,int_stack+2924823,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3214497,int_stack+2712171,int_stack+2465595,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+2450613,int_stack+158565,int_stack+146025,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+2488233,int_stack+2450613,int_stack+1806915,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2897499,int_stack+2488233,int_stack+1840773,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+2897499,int_stack+2622411,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3410517,int_stack+0,int_stack+1901361,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1806915,int_stack+3410517,int_stack+3068967,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3576837,int_stack+1806915,int_stack+2282445,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3793053,int_stack+3576837,int_stack+2712171,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2555949,int_stack+3793053,int_stack+3214497,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+2282445,int_stack+172425,int_stack+158565,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+2324025,int_stack+2282445,int_stack+2450613,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+2998479,int_stack+2324025,int_stack+2488233,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2282445,int_stack+2998479,int_stack+2897499,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+2795529,int_stack+2282445,int_stack+0,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+2282445,int_stack+2795529,int_stack+3410517,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+2795529,int_stack+2282445,int_stack+1806915,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2282445,int_stack+2795529,int_stack+3576837,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2795529,int_stack+2282445,int_stack+3793053,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+3078669,int_stack+2795529,int_stack+2555949,66);
 /*--- compute (mp|nn) ---*/
 hrr1_build_mp(Libint->AB,int_stack+2282445,int_stack+3078669,int_stack+2042865,4356);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3001185,int_stack+192819,int_stack+187671,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3016629,int_stack+198903,int_stack+192819,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+3034881,int_stack+3016629,int_stack+3001185,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3366165,int_stack+206001,int_stack+198903,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3387459,int_stack+3366165,int_stack+3016629,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3423963,int_stack+3387459,int_stack+3034881,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+3001185,int_stack+214191,int_stack+206001,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3025755,int_stack+3001185,int_stack+3366165,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3475443,int_stack+3025755,int_stack+3387459,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3536283,int_stack+3475443,int_stack+3423963,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3366165,int_stack+223551,int_stack+214191,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3394245,int_stack+3366165,int_stack+3001185,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3613503,int_stack+3394245,int_stack+3025755,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3684483,int_stack+3613503,int_stack+3475443,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3775743,int_stack+3684483,int_stack+3536283,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+3001185,int_stack+234159,int_stack+223551,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+3443385,int_stack+3001185,int_stack+3366165,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3499545,int_stack+3443385,int_stack+3394245,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+3883851,int_stack+3499545,int_stack+3613503,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1806915,int_stack+3883851,int_stack+3684483,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3581445,int_stack+1806915,int_stack+3775743,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3366165,int_stack+246093,int_stack+234159,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3725589,int_stack+3366165,int_stack+3001185,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3789237,int_stack+3725589,int_stack+3443385,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1934679,int_stack+3789237,int_stack+3499545,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3401967,int_stack+1934679,int_stack+3883851,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2057529,int_stack+3401967,int_stack+1806915,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2057529,int_stack+3581445,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1806915,int_stack+259431,int_stack+246093,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1846929,int_stack+1806915,int_stack+3366165,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3551025,int_stack+1846929,int_stack+3725589,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3882837,int_stack+3551025,int_stack+3789237,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3657105,int_stack+3882837,int_stack+1934679,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+4023237,int_stack+3657105,int_stack+3401967,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4221981,int_stack+4023237,int_stack+2057529,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1918533,int_stack+4221981,int_stack+0,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+274251,int_stack+259431,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+44460,int_stack+0,int_stack+1806915,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+124488,int_stack+44460,int_stack+1846929,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+3366165,int_stack+124488,int_stack+3551025,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+4441005,int_stack+3366165,int_stack+3882837,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+4637565,int_stack+4441005,int_stack+3657105,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3525285,int_stack+4637565,int_stack+4023237,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3780813,int_stack+3525285,int_stack+4221981,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+4054593,int_stack+3780813,int_stack+1918533,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1806915,int_stack+290631,int_stack+274251,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1856055,int_stack+1806915,int_stack+0,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1944975,int_stack+1856055,int_stack+44460,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2078355,int_stack+1944975,int_stack+124488,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+2078355,int_stack+3366165,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1806915,int_stack+0,int_stack+4441005,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+1806915,int_stack+4637565,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1806915,int_stack+0,int_stack+3525285,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+3366165,int_stack+1806915,int_stack+3780813,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1806915,int_stack+3366165,int_stack+4054593,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+3366165,int_stack+1806915,int_stack+3078669,4356);
 /*--- compute (md|nn) ---*/
 hrr1_build_md(Libint->AB,int_stack+4228653,int_stack+3366165,int_stack+2282445,4356);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2146683,int_stack+314655,int_stack+308649,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2164701,int_stack+321753,int_stack+314655,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2185995,int_stack+2164701,int_stack+2146683,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2222031,int_stack+330034,int_stack+321753,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2246874,int_stack+2222031,int_stack+2164701,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2289462,int_stack+2246874,int_stack+2185995,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2146683,int_stack+339589,int_stack+330034,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2349522,int_stack+2146683,int_stack+2222031,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2175348,int_stack+2349522,int_stack+2246874,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2399208,int_stack+2175348,int_stack+2289462,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2246328,int_stack+350509,int_stack+339589,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2279088,int_stack+2246328,int_stack+2146683,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2489298,int_stack+2279088,int_stack+2349522,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2572108,int_stack+2489298,int_stack+2175348,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2678578,int_stack+2572108,int_stack+2399208,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2146683,int_stack+362885,int_stack+350509,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2336418,int_stack+2146683,int_stack+2246328,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2804704,int_stack+2336418,int_stack+2279088,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2183811,int_stack+2804704,int_stack+2489298,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2401938,int_stack+2183811,int_stack+2572108,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2900254,int_stack+2401938,int_stack+2678578,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2550996,int_stack+376808,int_stack+362885,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2592765,int_stack+2550996,int_stack+2146683,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2667021,int_stack+2592765,int_stack+2336418,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3068422,int_stack+2667021,int_stack+2804704,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+3068422,int_stack+2183811,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2146683,int_stack+0,int_stack+2401938,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+5666133,int_stack+2146683,int_stack+2900254,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2345427,int_stack+392369,int_stack+376808,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2392110,int_stack+2345427,int_stack+2550996,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2776221,int_stack+2392110,int_stack+2592765,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2475648,int_stack+2776221,int_stack+2667021,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+173901,int_stack+2475648,int_stack+3068422,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2899981,int_stack+173901,int_stack+0,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+5882349,int_stack+2899981,int_stack+2146683,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+6137877,int_stack+5882349,int_stack+5666133,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+5666133,int_stack+409659,int_stack+392369,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+5718003,int_stack+5666133,int_stack+2345427,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2146683,int_stack+5718003,int_stack+2392110,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2285913,int_stack+2146683,int_stack+2776221,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2639448,int_stack+2285913,int_stack+2475648,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+6408147,int_stack+2639448,int_stack+173901,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+0,int_stack+6408147,int_stack+2899981,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2868768,int_stack+0,int_stack+5882349,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+6675687,int_stack+2868768,int_stack+6137877,91);
 /*--- compute (q0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+5811369,int_stack+428769,int_stack+409659,91);
 /*--- compute (q0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+5868699,int_stack+5811369,int_stack+5666133,91);
 /*--- compute (q0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+5972439,int_stack+5868699,int_stack+5718003,91);
 /*--- compute (q0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+5666133,int_stack+5972439,int_stack+2146683,91);
 /*--- compute (q0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+5874978,int_stack+5666133,int_stack+2285913,91);
 /*--- compute (q0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+2146683,int_stack+5874978,int_stack+2639448,91);
 /*--- compute (q0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+5666133,int_stack+2146683,int_stack+6408147,91);
 /*--- compute (q0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2146683,int_stack+5666133,int_stack+0,91);
 /*--- compute (q0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+2146683,int_stack+2868768,91);
 /*--- compute (q0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2146683,int_stack+0,int_stack+6675687,91);
 /*--- compute (op|nn) ---*/
 hrr1_build_op(Libint->AB,int_stack+5666133,int_stack+2146683,int_stack+1806915,4356);
 /*--- compute (nd|nn) ---*/
 hrr1_build_nd(Libint->AB,int_stack+6685437,int_stack+5666133,int_stack+3366165,4356);
 /*--- compute (mf|nn) ---*/
 hrr1_build_mf(Libint->AB,int_stack+8410413,int_stack+6685437,int_stack+4228653,4356);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1806915,int_stack+456720,int_stack+449790,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1827705,int_stack+464910,int_stack+456720,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1852275,int_stack+1827705,int_stack+1806915,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1893855,int_stack+474465,int_stack+464910,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1922520,int_stack+1893855,int_stack+1827705,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1971660,int_stack+1922520,int_stack+1852275,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1806915,int_stack+485490,int_stack+474465,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2040960,int_stack+1806915,int_stack+1893855,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1839990,int_stack+2040960,int_stack+1922520,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+1839990,int_stack+1971660,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1921890,int_stack+498090,int_stack+485490,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1959690,int_stack+1921890,int_stack+1806915,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+103950,int_stack+1959690,int_stack+2040960,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+199500,int_stack+103950,int_stack+1839990,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+322350,int_stack+199500,int_stack+0,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+512370,int_stack+498090,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1806915,int_stack+0,int_stack+1921890,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2025840,int_stack+1806915,int_stack+1959690,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1882515,int_stack+2025840,int_stack+103950,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2543079,int_stack+1882515,int_stack+199500,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+42840,int_stack+2543079,int_stack+322350,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+236880,int_stack+528435,int_stack+512370,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+285075,int_stack+236880,int_stack+0,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+370755,int_stack+285075,int_stack+1806915,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2715069,int_stack+370755,int_stack+2025840,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2880444,int_stack+2715069,int_stack+1882515,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1806915,int_stack+2880444,int_stack+2543079,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3081099,int_stack+1806915,int_stack+42840,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2543079,int_stack+546390,int_stack+528435,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2596944,int_stack+2543079,int_stack+236880,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+2596944,int_stack+285075,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+142800,int_stack+0,int_stack+370755,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3330579,int_stack+142800,int_stack+2715069,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3562104,int_stack+3330579,int_stack+2880444,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2693334,int_stack+3562104,int_stack+1806915,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1806915,int_stack+2693334,int_stack+3081099,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+2988174,int_stack+566340,int_stack+546390,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+3048024,int_stack+2988174,int_stack+2543079,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+3155754,int_stack+3048024,int_stack+2596944,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+331800,int_stack+3155754,int_stack+0,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3829644,int_stack+331800,int_stack+142800,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+0,int_stack+3829644,int_stack+3330579,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+4094244,int_stack+0,int_stack+3562104,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3316404,int_stack+4094244,int_stack+2693334,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2543079,int_stack+3316404,int_stack+1806915,105);
 /*--- compute (r0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1806915,int_stack+588390,int_stack+566340,105);
 /*--- compute (r0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1873065,int_stack+1806915,int_stack+2988174,105);
 /*--- compute (r0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+4438224,int_stack+1873065,int_stack+3048024,105);
 /*--- compute (r0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1806915,int_stack+4438224,int_stack+3155754,105);
 /*--- compute (r0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+4438224,int_stack+1806915,int_stack+331800,105);
 /*--- compute (r0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+4738104,int_stack+4438224,int_stack+3829644,105);
 /*--- compute (r0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+5090904,int_stack+4738104,int_stack+0,105);
 /*--- compute (r0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+0,int_stack+5090904,int_stack+4094244,105);
 /*--- compute (r0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+3684954,int_stack+0,int_stack+3316404,105);
 /*--- compute (r0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+0,int_stack+3684954,int_stack+2543079,105);
 /*--- compute (qp|nn) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2543079,int_stack+0,int_stack+2146683,4356);
 /*--- compute (od|nn) ---*/
 hrr1_build_od(Libint->AB,int_stack+10806213,int_stack+2543079,int_stack+5666133,4356);
 /*--- compute (nf|nn) ---*/
 hrr1_build_nf(Libint->AB,int_stack+3732267,int_stack+10806213,int_stack+6685437,4356);
 /*--- compute (mg|nn) ---*/
 hrr1_build_mg(Libint->AB,int_stack+12844821,int_stack+3732267,int_stack+8410413,4356);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+6607227,int_stack+620565,int_stack+612645,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+6630987,int_stack+629925,int_stack+620565,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+6659067,int_stack+6630987,int_stack+6607227,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+6706587,int_stack+640845,int_stack+629925,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+6739347,int_stack+6706587,int_stack+6630987,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+6795507,int_stack+6739347,int_stack+6659067,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+6607227,int_stack+653445,int_stack+640845,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+6874707,int_stack+6607227,int_stack+6706587,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+6645027,int_stack+6874707,int_stack+6739347,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+6940227,int_stack+6645027,int_stack+6795507,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+6738627,int_stack+667845,int_stack+653445,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+6781827,int_stack+6738627,int_stack+6607227,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+7059027,int_stack+6781827,int_stack+6874707,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+7168227,int_stack+7059027,int_stack+6645027,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+7308627,int_stack+7168227,int_stack+6940227,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+6607227,int_stack+684165,int_stack+667845,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+6857427,int_stack+6607227,int_stack+6738627,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+7474947,int_stack+6857427,int_stack+6781827,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+6656187,int_stack+7474947,int_stack+7059027,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+6943827,int_stack+6656187,int_stack+7168227,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+7600947,int_stack+6943827,int_stack+7308627,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+7140387,int_stack+702525,int_stack+684165,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+7195467,int_stack+7140387,int_stack+6607227,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+7293387,int_stack+7195467,int_stack+6857427,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+7822707,int_stack+7293387,int_stack+7474947,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+8011707,int_stack+7822707,int_stack+6656187,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+6607227,int_stack+8011707,int_stack+6943827,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+8241027,int_stack+6607227,int_stack+7600947,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+6869307,int_stack+723045,int_stack+702525,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+6930867,int_stack+6869307,int_stack+7140387,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+7437387,int_stack+6930867,int_stack+7195467,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+7041027,int_stack+7437387,int_stack+7293387,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+8526147,int_stack+7041027,int_stack+7822707,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+7600587,int_stack+8526147,int_stack+8011707,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+8790747,int_stack+7600587,int_stack+6607227,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+9127707,int_stack+8790747,int_stack+8241027,120);
 /*--- compute (t0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+6607227,int_stack+745845,int_stack+723045,120);
 /*--- compute (t0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+6675627,int_stack+6607227,int_stack+6869307,120);
 /*--- compute (t0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+7906347,int_stack+6675627,int_stack+6930867,120);
 /*--- compute (t0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+8089947,int_stack+7906347,int_stack+7437387,120);
 /*--- compute (t0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+7257027,int_stack+8089947,int_stack+7041027,120);
 /*--- compute (t0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+6798747,int_stack+7257027,int_stack+8526147,120);
 /*--- compute (t0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+8334747,int_stack+6798747,int_stack+7600587,120);
 /*--- compute (t0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+9484107,int_stack+8334747,int_stack+8790747,120);
 /*--- compute (t0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+9905307,int_stack+9484107,int_stack+9127707,120);
 /*--- compute (t0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+7151547,int_stack+771045,int_stack+745845,120);
 /*--- compute (t0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+7559427,int_stack+7151547,int_stack+6607227,120);
 /*--- compute (t0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+7696227,int_stack+7559427,int_stack+6675627,120);
 /*--- compute (t0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+8727867,int_stack+7696227,int_stack+7906347,120);
 /*--- compute (t0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+7559427,int_stack+8727867,int_stack+8089947,120);
 /*--- compute (t0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+8727867,int_stack+7559427,int_stack+7257027,120);
 /*--- compute (t0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+7151547,int_stack+8727867,int_stack+6798747,120);
 /*--- compute (t0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+8727867,int_stack+7151547,int_stack+8334747,120);
 /*--- compute (t0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+6607227,int_stack+8727867,int_stack+9484107,120);
 /*--- compute (t0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+7122027,int_stack+6607227,int_stack+9905307,120);
 /*--- compute (rp|nn) ---*/
 hrr1_build_rp(Libint->AB,int_stack+7644747,int_stack+7122027,int_stack+0,4356);
 /*--- compute (qd|nn) ---*/
 hrr1_build_qd(Libint->AB,int_stack+16438521,int_stack+7644747,int_stack+2543079,4356);
 /*--- compute (of|nn) ---*/
 hrr1_build_of(Libint->AB,int_stack+18816897,int_stack+16438521,int_stack+10806213,4356);
 /*--- compute (ng|nn) ---*/
 hrr1_build_ng(Libint->AB,int_stack+22214577,int_stack+18816897,int_stack+3732267,4356);
 /*--- compute (mh|nn) ---*/
 hrr1_build_mh(Libint->AB,int_stack+1806915,int_stack+22214577,int_stack+12844821,4356);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+807741,int_stack+798765,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+26928,int_stack+818349,int_stack+807741,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+58752,int_stack+26928,int_stack+0,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+112608,int_stack+830725,int_stack+818349,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+149736,int_stack+112608,int_stack+26928,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+213384,int_stack+149736,int_stack+58752,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+845005,int_stack+830725,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+303144,int_stack+0,int_stack+112608,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+42840,int_stack+303144,int_stack+149736,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+377400,int_stack+42840,int_stack+213384,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+148920,int_stack+861325,int_stack+845005,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+197880,int_stack+148920,int_stack+0,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+512040,int_stack+197880,int_stack+303144,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+635800,int_stack+512040,int_stack+42840,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+9016887,int_stack+635800,int_stack+377400,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+879821,int_stack+861325,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+283560,int_stack+0,int_stack+148920,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+9205383,int_stack+283560,int_stack+197880,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+55488,int_stack+9205383,int_stack+512040,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+381480,int_stack+55488,int_stack+635800,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+604248,int_stack+381480,int_stack+9016887,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+9016887,int_stack+900629,int_stack+879821,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+9079311,int_stack+9016887,int_stack+0,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+9348183,int_stack+9079311,int_stack+283560,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+9511383,int_stack+9348183,int_stack+9205383,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+9725583,int_stack+9511383,int_stack+55488,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+9725583,int_stack+381480,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+9985479,int_stack+0,int_stack+604248,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+297024,int_stack+923885,int_stack+900629,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+366792,int_stack+297024,int_stack+9016887,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+491640,int_stack+366792,int_stack+9079311,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+9016887,int_stack+491640,int_stack+9348183,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+10308615,int_stack+9016887,int_stack+9511383,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+9261687,int_stack+10308615,int_stack+9725583,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+10608495,int_stack+9261687,int_stack+0,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+10990383,int_stack+10608495,int_stack+9985479,136);
 /*--- compute (u0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+949725,int_stack+923885,136);
 /*--- compute (u0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+77520,int_stack+0,int_stack+297024,136);
 /*--- compute (u0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+9608215,int_stack+77520,int_stack+366792,136);
 /*--- compute (u0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+9816295,int_stack+9608215,int_stack+491640,136);
 /*--- compute (u0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+217056,int_stack+9816295,int_stack+9016887,136);
 /*--- compute (u0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+11394303,int_stack+217056,int_stack+10308615,136);
 /*--- compute (u0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+10093735,int_stack+11394303,int_stack+9261687,136);
 /*--- compute (u0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+9016887,int_stack+10093735,int_stack+10608495,136);
 /*--- compute (u0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+11794143,int_stack+9016887,int_stack+10990383,136);
 /*--- compute (u0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+9494247,int_stack+978285,int_stack+949725,136);
 /*--- compute (u0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+559776,int_stack+9494247,int_stack+0,136);
 /*--- compute (u0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+714816,int_stack+559776,int_stack+77520,136);
 /*--- compute (u0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+10539271,int_stack+714816,int_stack+9608215,136);
 /*--- compute (u0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+559776,int_stack+10539271,int_stack+9816295,136);
 /*--- compute (u0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+10539271,int_stack+559776,int_stack+217056,136);
 /*--- compute (u0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+10539271,int_stack+11394303,136);
 /*--- compute (u0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+10539271,int_stack+0,int_stack+10093735,136);
 /*--- compute (u0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+10539271,int_stack+9016887,136);
 /*--- compute (u0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+9016887,int_stack+0,int_stack+11794143,136);
 /*--- compute (tp|nn) ---*/
 hrr1_build_tp(Libint->AB,int_stack+9609303,int_stack+9016887,int_stack+7122027,4356);
 /*--- compute (rd|nn) ---*/
 hrr1_build_rd(Libint->AB,int_stack+11177463,int_stack+9609303,int_stack+7644747,4356);
 /*--- compute (qf|nn) ---*/
 hrr1_build_qf(Libint->AB,int_stack+26527017,int_stack+11177463,int_stack+16438521,4356);
 /*--- compute (og|nn) ---*/
 hrr1_build_og(Libint->AB,int_stack+30490977,int_stack+26527017,int_stack+18816897,4356);
 /*--- compute (nh|nn) ---*/
 hrr1_build_nh(Libint->AB,int_stack+13921743,int_stack+30490977,int_stack+22214577,4356);
 /*--- compute (mi|nn) ---*/
 hrr1_build_mi(Libint->AB,int_stack+35587497,int_stack+13921743,int_stack+1806915,4356);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1806915,int_stack+1019799,int_stack+1009701,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1837209,int_stack+1031733,int_stack+1019799,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1873011,int_stack+1837209,int_stack+1806915,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1933599,int_stack+1045656,int_stack+1031733,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1975368,int_stack+1933599,int_stack+1837209,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2046972,int_stack+1975368,int_stack+1873011,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1806915,int_stack+1061721,int_stack+1045656,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2147952,int_stack+1806915,int_stack+1933599,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1855110,int_stack+2147952,int_stack+1975368,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2231490,int_stack+1855110,int_stack+2046972,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1974450,int_stack+1080081,int_stack+1061721,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2029530,int_stack+1974450,int_stack+1806915,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2382960,int_stack+2029530,int_stack+2147952,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2522190,int_stack+2382960,int_stack+1855110,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2701200,int_stack+2522190,int_stack+2231490,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1806915,int_stack+1100889,int_stack+1080081,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2125920,int_stack+1806915,int_stack+1974450,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2913258,int_stack+2125920,int_stack+2029530,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1869339,int_stack+2913258,int_stack+2382960,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2236080,int_stack+1869339,int_stack+2522190,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3073908,int_stack+2236080,int_stack+2701200,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2486694,int_stack+1124298,int_stack+1100889,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2556921,int_stack+2486694,int_stack+1806915,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2681769,int_stack+2556921,int_stack+2125920,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3356652,int_stack+2681769,int_stack+2913258,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3597627,int_stack+3356652,int_stack+1869339,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1806915,int_stack+3597627,int_stack+2236080,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3890010,int_stack+1806915,int_stack+3073908,153);
 /*--- compute (v0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2141067,int_stack+1150461,int_stack+1124298,153);
 /*--- compute (v0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2219556,int_stack+2141067,int_stack+2486694,153);
 /*--- compute (v0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2865369,int_stack+2219556,int_stack+2556921,153);
 /*--- compute (v0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2360010,int_stack+2865369,int_stack+2681769,153);
 /*--- compute (v0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4253538,int_stack+2360010,int_stack+3356652,153);
 /*--- compute (v0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3073449,int_stack+4253538,int_stack+3597627,153);
 /*--- compute (v0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4590903,int_stack+3073449,int_stack+1806915,153);
 /*--- compute (v0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+5020527,int_stack+4590903,int_stack+3890010,153);
 /*--- compute (v0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1806915,int_stack+1179531,int_stack+1150461,153);
 /*--- compute (v0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1894125,int_stack+1806915,int_stack+2141067,153);
 /*--- compute (v0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+3463293,int_stack+1894125,int_stack+2219556,153);
 /*--- compute (v0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+3697383,int_stack+3463293,int_stack+2865369,153);
 /*--- compute (v0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2635410,int_stack+3697383,int_stack+2360010,153);
 /*--- compute (v0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2051103,int_stack+2635410,int_stack+4253538,153);
 /*--- compute (v0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+4009503,int_stack+2051103,int_stack+3073449,153);
 /*--- compute (v0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+5474937,int_stack+4009503,int_stack+4590903,153);
 /*--- compute (v0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+6011967,int_stack+5474937,int_stack+5020527,153);
 /*--- compute (v0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+2500923,int_stack+1211661,int_stack+1179531,153);
 /*--- compute (v0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+3020970,int_stack+2500923,int_stack+1806915,153);
 /*--- compute (v0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+3195390,int_stack+3020970,int_stack+1894125,153);
 /*--- compute (v0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+4510731,int_stack+3195390,int_stack+3463293,153);
 /*--- compute (v0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+3020970,int_stack+4510731,int_stack+3697383,153);
 /*--- compute (v0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+4510731,int_stack+3020970,int_stack+2635410,153);
 /*--- compute (v0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+2500923,int_stack+4510731,int_stack+2051103,153);
 /*--- compute (v0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+4510731,int_stack+2500923,int_stack+4009503,153);
 /*--- compute (v0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1806915,int_stack+4510731,int_stack+5474937,153);
 /*--- compute (v0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2463285,int_stack+1806915,int_stack+6011967,153);
 /*--- compute (up|nn) ---*/
 hrr1_build_up(Libint->AB,int_stack+3129753,int_stack+2463285,int_stack+9016887,4356);
 /*--- compute (td|nn) ---*/
 hrr1_build_td(Libint->AB,int_stack+4907001,int_stack+3129753,int_stack+9609303,4356);
 /*--- compute (rf|nn) ---*/
 hrr1_build_rf(Libint->AB,int_stack+19959159,int_stack+4907001,int_stack+11177463,4356);
 /*--- compute (qg|nn) ---*/
 hrr1_build_qg(Libint->AB,int_stack+42295737,int_stack+19959159,int_stack+26527017,4356);
 /*--- compute (oh|nn) ---*/
 hrr1_build_oh(Libint->AB,int_stack+48241677,int_stack+42295737,int_stack+30490977,4356);
 /*--- compute (ni|nn) ---*/
 hrr1_build_ni(Libint->AB,int_stack+24532959,int_stack+48241677,int_stack+13921743,4356);
 /*--- compute (mk|nn) ---*/
 hrr1_build_mk(Libint->AB,int_stack+8043321,int_stack+24532959,int_stack+35587497,4356);
 /*--- compute (w0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1806915,int_stack+1258290,int_stack+1247004,171);
 /*--- compute (w0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1840773,int_stack+1271628,int_stack+1258290,171);
 /*--- compute (w0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1880787,int_stack+1840773,int_stack+1806915,171);
 /*--- compute (w0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1948503,int_stack+1287189,int_stack+1271628,171);
 /*--- compute (w0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1995186,int_stack+1948503,int_stack+1840773,171);
 /*--- compute (w0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2075214,int_stack+1995186,int_stack+1880787,171);
 /*--- compute (w0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1806915,int_stack+1305144,int_stack+1287189,171);
 /*--- compute (w0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2188074,int_stack+1806915,int_stack+1948503,171);
 /*--- compute (w0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1860780,int_stack+2188074,int_stack+1995186,171);
 /*--- compute (w0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2281440,int_stack+1860780,int_stack+2075214,171);
 /*--- compute (w0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1994160,int_stack+1325664,int_stack+1305144,171);
 /*--- compute (w0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2055720,int_stack+1994160,int_stack+1806915,171);
 /*--- compute (w0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+16668201,int_stack+2055720,int_stack+2188074,171);
 /*--- compute (w0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+16823811,int_stack+16668201,int_stack+1860780,171);
 /*--- compute (w0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+17023881,int_stack+16823811,int_stack+2281440,171);
 /*--- compute (w0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1806915,int_stack+1348920,int_stack+1325664,171);
 /*--- compute (w0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2163450,int_stack+1806915,int_stack+1994160,171);
 /*--- compute (w0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+17260887,int_stack+2163450,int_stack+2055720,171);
 /*--- compute (w0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1876683,int_stack+17260887,int_stack+16668201,171);
 /*--- compute (w0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+17440437,int_stack+1876683,int_stack+16823811,171);
 /*--- compute (w0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+16668201,int_stack+17440437,int_stack+17023881,171);
 /*--- compute (w0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+16984209,int_stack+1375083,int_stack+1348920,171);
 /*--- compute (w0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+17062698,int_stack+16984209,int_stack+1806915,171);
 /*--- compute (w0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+17720535,int_stack+17062698,int_stack+2163450,171);
 /*--- compute (w0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2110098,int_stack+17720535,int_stack+17260887,171);
 /*--- compute (w0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+17925735,int_stack+2110098,int_stack+1876683,171);
 /*--- compute (w0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+18252516,int_stack+17925735,int_stack+17440437,171);
 /*--- compute (w0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+17202234,int_stack+18252516,int_stack+16668201,171);
 /*--- compute (w0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+16668201,int_stack+1404324,int_stack+1375083,171);
 /*--- compute (w0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+16755924,int_stack+16668201,int_stack+16984209,171);
 /*--- compute (w0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1806915,int_stack+16755924,int_stack+17062698,171);
 /*--- compute (w0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+18625980,int_stack+1806915,int_stack+17720535,171);
 /*--- compute (w0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+18933780,int_stack+18625980,int_stack+2110098,171);
 /*--- compute (w0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+19310835,int_stack+18933780,int_stack+17925735,171);
 /*--- compute (w0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+17608530,int_stack+19310835,int_stack+18252516,171);
 /*--- compute (w0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+18088698,int_stack+17608530,int_stack+17202234,171);
 /*--- compute (w0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+16912902,int_stack+1436814,int_stack+1404324,171);
 /*--- compute (w0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+17010372,int_stack+16912902,int_stack+16668201,171);
 /*--- compute (w0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+17185818,int_stack+17010372,int_stack+16755924,171);
 /*--- compute (w0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2039475,int_stack+17185818,int_stack+1806915,171);
 /*--- compute (w0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+0,int_stack+2039475,int_stack+18625980,171);
 /*--- compute (w0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+430920,int_stack+0,int_stack+18933780,171);
 /*--- compute (w0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+18596568,int_stack+430920,int_stack+19310835,171);
 /*--- compute (w0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+19156764,int_stack+18596568,int_stack+17608530,171);
 /*--- compute (w0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+17447448,int_stack+19156764,int_stack+18088698,171);
 /*--- compute (w0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1806915,int_stack+1472724,int_stack+1436814,171);
 /*--- compute (w0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+16668201,int_stack+1806915,int_stack+16912902,171);
 /*--- compute (w0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+18068178,int_stack+16668201,int_stack+17010372,171);
 /*--- compute (w0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+16668201,int_stack+18068178,int_stack+17185818,171);
 /*--- compute (w0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+18068178,int_stack+16668201,int_stack+2039475,171);
 /*--- compute (w0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+16668201,int_stack+18068178,int_stack+0,171);
 /*--- compute (w0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1806915,int_stack+16668201,int_stack+430920,171);
 /*--- compute (w0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+16668201,int_stack+1806915,int_stack+18596568,171);
 /*--- compute (w0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+16668201,int_stack+19156764,171);
 /*--- compute (w0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+16668201,int_stack+0,int_stack+17447448,171);
 /*--- compute (vp|nn) ---*/
 hrr1_build_vp(Libint->AB,int_stack+17413077,int_stack+16668201,int_stack+2463285,4356);
 /*--- compute (ud|nn) ---*/
 hrr1_build_ud(Libint->AB,int_stack+32582847,int_stack+17413077,int_stack+3129753,4356);
 /*--- compute (tf|nn) ---*/
 hrr1_build_tf(Libint->AB,int_stack+36137343,int_stack+32582847,int_stack+4907001,4356);
 /*--- compute (rg|nn) ---*/
 hrr1_build_rg(Libint->AB,int_stack+55376805,int_stack+36137343,int_stack+19959159,4356);
 /*--- compute (qh|nn) ---*/
 hrr1_build_qh(Libint->AB,int_stack+62237505,int_stack+55376805,int_stack+42295737,4356);
 /*--- compute (oi|nn) ---*/
 hrr1_build_oi(Libint->AB,int_stack+70561821,int_stack+62237505,int_stack+48241677,4356);
 /*--- compute (nk|nn) ---*/
 hrr1_build_nk(Libint->AB,int_stack+41364543,int_stack+70561821,int_stack+24532959,4356);
 /*--- compute (ml|nn) ---*/
 hrr1_build_ml(Libint->AB,int_stack+19412481,int_stack+41364543,int_stack+8043321,4356);
 /*--- compute (x0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+1524765,int_stack+1512225,190);
 /*--- compute (x0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+37620,int_stack+1539585,int_stack+1524765,190);
 /*--- compute (x0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+82080,int_stack+37620,int_stack+0,190);
 /*--- compute (x0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+157320,int_stack+1556875,int_stack+1539585,190);
 /*--- compute (x0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+209190,int_stack+157320,int_stack+37620,190);
 /*--- compute (x0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+298110,int_stack+209190,int_stack+82080,190);
 /*--- compute (x0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+1576825,int_stack+1556875,190);
 /*--- compute (x0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+423510,int_stack+0,int_stack+157320,190);
 /*--- compute (x0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+59850,int_stack+423510,int_stack+209190,190);
 /*--- compute (x0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+527250,int_stack+59850,int_stack+298110,190);
 /*--- compute (x0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+208050,int_stack+1599625,int_stack+1576825,190);
 /*--- compute (x0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+276450,int_stack+208050,int_stack+0,190);
 /*--- compute (x0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+715350,int_stack+276450,int_stack+423510,190);
 /*--- compute (x0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+888250,int_stack+715350,int_stack+59850,190);
 /*--- compute (x0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1110550,int_stack+888250,int_stack+527250,190);
 /*--- compute (x0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+1625465,int_stack+1599625,190);
 /*--- compute (x0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+396150,int_stack+0,int_stack+208050,190);
 /*--- compute (x0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1373890,int_stack+396150,int_stack+276450,190);
 /*--- compute (x0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+77520,int_stack+1373890,int_stack+715350,190);
 /*--- compute (x0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+532950,int_stack+77520,int_stack+888250,190);
 /*--- compute (x0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+30193581,int_stack+532950,int_stack+1110550,190);
 /*--- compute (x0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+844170,int_stack+1654535,int_stack+1625465,190);
 /*--- compute (x0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+931380,int_stack+844170,int_stack+0,190);
 /*--- compute (x0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1086420,int_stack+931380,int_stack+396150,190);
 /*--- compute (x0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+30544701,int_stack+1086420,int_stack+1373890,190);
 /*--- compute (x0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+30843951,int_stack+30544701,int_stack+77520,190);
 /*--- compute (x0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+30843951,int_stack+532950,190);
 /*--- compute (x0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+31207041,int_stack+0,int_stack+30193581,190);
 /*--- compute (x0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+30193581,int_stack+1687025,int_stack+1654535,190);
 /*--- compute (x0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+30291051,int_stack+30193581,int_stack+844170,190);
 /*--- compute (x0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+414960,int_stack+30291051,int_stack+931380,190);
 /*--- compute (x0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+673360,int_stack+414960,int_stack+1086420,190);
 /*--- compute (x0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1015360,int_stack+673360,int_stack+30544701,190);
 /*--- compute (x0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+31658481,int_stack+1015360,int_stack+30843951,190);
 /*--- compute (x0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+30465471,int_stack+31658481,int_stack+0,190);
 /*--- compute (x0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1806915,int_stack+30465471,int_stack+31207041,190);
 /*--- compute (x0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+1723125,int_stack+1687025,190);
 /*--- compute (x0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+108300,int_stack+0,int_stack+30193581,190);
 /*--- compute (x0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+30998991,int_stack+108300,int_stack+30291051,190);
 /*--- compute (x0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+32142601,int_stack+30998991,int_stack+414960,190);
 /*--- compute (x0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2371215,int_stack+32142601,int_stack+673360,190);
 /*--- compute (x0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+303240,int_stack+2371215,int_stack+1015360,190);
 /*--- compute (x0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+861840,int_stack+303240,int_stack+31658481,190);
 /*--- compute (x0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+31289691,int_stack+861840,int_stack+30465471,190);
 /*--- compute (x0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+30193581,int_stack+31289691,int_stack+1806915,190);
 /*--- compute (x0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1806915,int_stack+1763025,int_stack+1723125,190);
 /*--- compute (x0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1926615,int_stack+1806915,int_stack+0,190);
 /*--- compute (x0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1484280,int_stack+1926615,int_stack+108300,190);
 /*--- compute (x0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1809180,int_stack+1484280,int_stack+30998991,190);
 /*--- compute (x0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+2850015,int_stack+1809180,int_stack+32142601,190);
 /*--- compute (x0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1484280,int_stack+2850015,int_stack+2371215,190);
 /*--- compute (x0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+2122680,int_stack+1484280,int_stack+303240,190);
 /*--- compute (x0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2840880,int_stack+2122680,int_stack+861840,190);
 /*--- compute (x0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+3618930,int_stack+2840880,int_stack+31289691,190);
 /*--- compute (x0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+4434030,int_stack+3618930,int_stack+30193581,190);
 /*--- compute (wp|nn) ---*/
 hrr1_build_wp(Libint->AB,int_stack+30193581,int_stack+4434030,int_stack+16668201,4356);
 /*--- compute (vd|nn) ---*/
 hrr1_build_vd(Libint->AB,int_stack+0,int_stack+30193581,int_stack+17413077,4356);
 /*--- compute (uf|nn) ---*/
 hrr1_build_uf(Libint->AB,int_stack+3998808,int_stack+0,int_stack+32582847,4356);
 /*--- compute (tg|nn) ---*/
 hrr1_build_tg(Libint->AB,int_stack+9922968,int_stack+3998808,int_stack+36137343,4356);
 /*--- compute (rh|nn) ---*/
 hrr1_build_rh(Libint->AB,int_stack+0,int_stack+9922968,int_stack+55376805,4356);
 /*--- compute (qi|nn) ---*/
 hrr1_build_qi(Libint->AB,int_stack+30193581,int_stack+0,int_stack+62237505,4356);
 /*--- compute (ok|nn) ---*/
 hrr1_build_ok(Libint->AB,int_stack+0,int_stack+30193581,int_stack+70561821,4356);
 /*--- compute (nl|nn) ---*/
 hrr1_build_nl(Libint->AB,int_stack+51714399,int_stack+0,int_stack+41364543,4356);
 /*--- compute (mm|nn) ---*/
 hrr1_build_mm(Libint->AB,int_stack+0,int_stack+51714399,int_stack+19412481,4356);
 return int_stack+0;}
