/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mplg(Libint_t*, prim_data*);

  /* Computes quartets of (mp|lg) integrals */

REALTYPE *hrr_order_mplg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[9][11] = int_stack + 9130;
 Libint->vrr_classes[9][12] = int_stack + 13420;
 Libint->vrr_classes[10][8] = int_stack + 18425;
 Libint->vrr_classes[10][9] = int_stack + 21395;
 Libint->vrr_classes[10][10] = int_stack + 25025;
 Libint->vrr_classes[10][11] = int_stack + 29381;
 Libint->vrr_classes[10][12] = int_stack + 34529;
 memset(int_stack,0,40535*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 40535;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mplg(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+40535,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47960,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+57035,int_stack+47960,int_stack+40535,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+71885,int_stack+9130,int_stack+5500,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+82775,int_stack+71885,int_stack+47960,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+100925,int_stack+82775,int_stack+57035,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+40535,int_stack+13420,int_stack+9130,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+125675,int_stack+40535,int_stack+71885,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+40535,int_stack+125675,int_stack+82775,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+125675,int_stack+40535,int_stack+100925,55);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+40535,int_stack+21395,int_stack+18425,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+49445,int_stack+25025,int_stack+21395,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+60335,int_stack+49445,int_stack+40535,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+78155,int_stack+29381,int_stack+25025,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+91223,int_stack+78155,int_stack+49445,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+162800,int_stack+91223,int_stack+60335,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+40535,int_stack+34529,int_stack+29381,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+40535,int_stack+78155,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+26136,int_stack+0,int_stack+91223,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+62436,int_stack+26136,int_stack+162800,66);
 /*--- compute (mp|lg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+162800,int_stack+62436,int_stack+125675,675);
 return int_stack+162800;}
