/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ndli(Libint_t*, prim_data*);

  /* Computes quartets of (nd|li) integrals */

REALTYPE *hrr_order_ndli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][8] = int_stack + 0;
 Libint->vrr_classes[10][9] = int_stack + 2970;
 Libint->vrr_classes[10][10] = int_stack + 6600;
 Libint->vrr_classes[10][11] = int_stack + 10956;
 Libint->vrr_classes[10][12] = int_stack + 16104;
 Libint->vrr_classes[10][13] = int_stack + 22110;
 Libint->vrr_classes[10][14] = int_stack + 29040;
 Libint->vrr_classes[11][8] = int_stack + 36960;
 Libint->vrr_classes[11][9] = int_stack + 40470;
 Libint->vrr_classes[11][10] = int_stack + 44760;
 Libint->vrr_classes[11][11] = int_stack + 49908;
 Libint->vrr_classes[11][12] = int_stack + 55992;
 Libint->vrr_classes[11][13] = int_stack + 63090;
 Libint->vrr_classes[11][14] = int_stack + 71280;
 Libint->vrr_classes[12][8] = int_stack + 80640;
 Libint->vrr_classes[12][9] = int_stack + 84735;
 Libint->vrr_classes[12][10] = int_stack + 89740;
 Libint->vrr_classes[12][11] = int_stack + 95746;
 Libint->vrr_classes[12][12] = int_stack + 102844;
 Libint->vrr_classes[12][13] = int_stack + 111125;
 Libint->vrr_classes[12][14] = int_stack + 120680;
 memset(int_stack,0,131600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 131600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ndli(Libint, Data);
   Data++;
 }
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+131600,int_stack+2970,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+140510,int_stack+6600,int_stack+2970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+151400,int_stack+140510,int_stack+131600,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+169220,int_stack+10956,int_stack+6600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+182288,int_stack+169220,int_stack+140510,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+204068,int_stack+182288,int_stack+151400,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+131600,int_stack+16104,int_stack+10956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+233768,int_stack+131600,int_stack+169220,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+259904,int_stack+233768,int_stack+182288,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+147044,int_stack+259904,int_stack+204068,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+191594,int_stack+22110,int_stack+16104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+296204,int_stack+191594,int_stack+131600,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+327092,int_stack+296204,int_stack+233768,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+370652,int_stack+327092,int_stack+259904,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+209612,int_stack+370652,int_stack+147044,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+131600,int_stack+29040,int_stack+22110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+152390,int_stack+131600,int_stack+191594,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+425102,int_stack+152390,int_stack+296204,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+131600,int_stack+425102,int_stack+327092,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+271982,int_stack+131600,int_stack+370652,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+348212,int_stack+271982,int_stack+209612,66);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+131600,int_stack+40470,int_stack+36960,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+142130,int_stack+44760,int_stack+40470,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+155000,int_stack+142130,int_stack+131600,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+176060,int_stack+49908,int_stack+44760,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+191504,int_stack+176060,int_stack+142130,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+217244,int_stack+191504,int_stack+155000,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+131600,int_stack+55992,int_stack+49908,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+252344,int_stack+131600,int_stack+176060,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+283232,int_stack+252344,int_stack+191504,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+149852,int_stack+283232,int_stack+217244,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+202502,int_stack+63090,int_stack+55992,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+431372,int_stack+202502,int_stack+131600,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+431372,int_stack+252344,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+467876,int_stack+0,int_stack+283232,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+223796,int_stack+467876,int_stack+149852,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+131600,int_stack+71280,int_stack+63090,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+156170,int_stack+131600,int_stack+202502,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+532226,int_stack+156170,int_stack+431372,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+131600,int_stack+532226,int_stack+0,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+532226,int_stack+131600,int_stack+467876,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+431372,int_stack+532226,int_stack+223796,78);
 /*--- compute (np|li) ---*/
 hrr1_build_np(Libint->AB,int_stack+529652,int_stack+431372,int_stack+348212,1260);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+131600,int_stack+84735,int_stack+80640,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+143885,int_stack+89740,int_stack+84735,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+158900,int_stack+143885,int_stack+131600,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+183470,int_stack+95746,int_stack+89740,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+201488,int_stack+183470,int_stack+143885,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+231518,int_stack+201488,int_stack+158900,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+131600,int_stack+102844,int_stack+95746,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+272468,int_stack+131600,int_stack+183470,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+308504,int_stack+272468,int_stack+201488,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+152894,int_stack+308504,int_stack+231518,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+214319,int_stack+111125,int_stack+102844,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+358554,int_stack+214319,int_stack+131600,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+358554,int_stack+272468,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+779132,int_stack+0,int_stack+308504,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+239162,int_stack+779132,int_stack+152894,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+131600,int_stack+120680,int_stack+111125,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+160265,int_stack+131600,int_stack+214319,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+60060,int_stack+160265,int_stack+358554,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+325157,int_stack+60060,int_stack+0,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+325157,int_stack+779132,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+105105,int_stack+0,int_stack+239162,91);
 /*--- compute (op|li) ---*/
 hrr1_build_op(Libint->AB,int_stack+779132,int_stack+105105,int_stack+431372,1260);
 /*--- compute (nd|li) ---*/
 hrr1_build_nd(Libint->AB,int_stack+0,int_stack+779132,int_stack+529652,1260);
 return int_stack+0;}
