/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ndmg(Libint_t*, prim_data*);

  /* Computes quartets of (nd|mg) integrals */

REALTYPE *hrr_order_ndmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[11][9] = int_stack + 26070;
 Libint->vrr_classes[11][10] = int_stack + 30360;
 Libint->vrr_classes[11][11] = int_stack + 35508;
 Libint->vrr_classes[11][12] = int_stack + 41592;
 Libint->vrr_classes[11][13] = int_stack + 48690;
 Libint->vrr_classes[12][9] = int_stack + 56880;
 Libint->vrr_classes[12][10] = int_stack + 61885;
 Libint->vrr_classes[12][11] = int_stack + 67891;
 Libint->vrr_classes[12][12] = int_stack + 74989;
 Libint->vrr_classes[12][13] = int_stack + 83270;
 memset(int_stack,0,92825*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 92825;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ndmg(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+92825,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+103715,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+116783,int_stack+103715,int_stack+92825,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+138563,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+154007,int_stack+138563,int_stack+103715,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+180143,int_stack+154007,int_stack+116783,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+92825,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+216443,int_stack+92825,int_stack+138563,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+92825,int_stack+216443,int_stack+154007,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+216443,int_stack+92825,int_stack+180143,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+92825,int_stack+30360,int_stack+26070,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+105695,int_stack+35508,int_stack+30360,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+121139,int_stack+105695,int_stack+92825,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+146879,int_stack+41592,int_stack+35508,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+165131,int_stack+146879,int_stack+105695,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+270893,int_stack+165131,int_stack+121139,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+92825,int_stack+48690,int_stack+41592,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+92825,int_stack+146879,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+92825,int_stack+0,int_stack+165131,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+144305,int_stack+92825,int_stack+270893,78);
 /*--- compute (np|mg) ---*/
 hrr1_build_np(Libint->AB,int_stack+270893,int_stack+144305,int_stack+216443,825);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+92825,int_stack+61885,int_stack+56880,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+107840,int_stack+67891,int_stack+61885,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+107840,int_stack+92825,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+30030,int_stack+74989,int_stack+67891,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+208655,int_stack+30030,int_stack+107840,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+92825,int_stack+208655,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+83270,int_stack+74989,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+434243,int_stack+0,int_stack+30030,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+434243,int_stack+208655,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+434243,int_stack+0,int_stack+92825,91);
 /*--- compute (op|mg) ---*/
 hrr1_build_op(Libint->AB,int_stack+509318,int_stack+434243,int_stack+144305,825);
 /*--- compute (nd|mg) ---*/
 hrr1_build_nd(Libint->AB,int_stack+702368,int_stack+509318,int_stack+270893,825);
 return int_stack+702368;}
