/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ndmk(Libint_t*, prim_data*);

  /* Computes quartets of (nd|mk) integrals */

REALTYPE *hrr_order_ndmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[10][15] = int_stack + 33990;
 Libint->vrr_classes[10][16] = int_stack + 42966;
 Libint->vrr_classes[11][9] = int_stack + 53064;
 Libint->vrr_classes[11][10] = int_stack + 57354;
 Libint->vrr_classes[11][11] = int_stack + 62502;
 Libint->vrr_classes[11][12] = int_stack + 68586;
 Libint->vrr_classes[11][13] = int_stack + 75684;
 Libint->vrr_classes[11][14] = int_stack + 83874;
 Libint->vrr_classes[11][15] = int_stack + 93234;
 Libint->vrr_classes[11][16] = int_stack + 103842;
 Libint->vrr_classes[12][9] = int_stack + 115776;
 Libint->vrr_classes[12][10] = int_stack + 120781;
 Libint->vrr_classes[12][11] = int_stack + 126787;
 Libint->vrr_classes[12][12] = int_stack + 133885;
 Libint->vrr_classes[12][13] = int_stack + 142166;
 Libint->vrr_classes[12][14] = int_stack + 151721;
 Libint->vrr_classes[12][15] = int_stack + 162641;
 Libint->vrr_classes[12][16] = int_stack + 175017;
 memset(int_stack,0,188940*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 188940;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ndmk(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+188940,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+199830,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+212898,int_stack+199830,int_stack+188940,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+234678,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+250122,int_stack+234678,int_stack+199830,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+276258,int_stack+250122,int_stack+212898,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+188940,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+312558,int_stack+188940,int_stack+234678,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+343446,int_stack+312558,int_stack+250122,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+206958,int_stack+343446,int_stack+276258,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+261408,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+387006,int_stack+261408,int_stack+188940,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+423042,int_stack+387006,int_stack+312558,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+474522,int_stack+423042,int_stack+343446,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+282198,int_stack+474522,int_stack+206958,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+188940,int_stack+33990,int_stack+26070,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+212700,int_stack+188940,int_stack+261408,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+539862,int_stack+212700,int_stack+387006,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+599922,int_stack+539862,int_stack+423042,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+358428,int_stack+599922,int_stack+474522,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+677142,int_stack+358428,int_stack+282198,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+254280,int_stack+42966,int_stack+33990,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+281208,int_stack+254280,int_stack+188940,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+449904,int_stack+281208,int_stack+212700,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+188940,int_stack+449904,int_stack+539862,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+449904,int_stack+188940,int_stack+599922,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+188940,int_stack+449904,int_stack+358428,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+310908,int_stack+188940,int_stack+677142,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+188940,int_stack+57354,int_stack+53064,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+201810,int_stack+62502,int_stack+57354,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+217254,int_stack+201810,int_stack+188940,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+242994,int_stack+68586,int_stack+62502,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+261246,int_stack+242994,int_stack+201810,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+441588,int_stack+261246,int_stack+217254,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+188940,int_stack+75684,int_stack+68586,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+484488,int_stack+188940,int_stack+242994,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+520992,int_stack+484488,int_stack+261246,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+210234,int_stack+520992,int_stack+441588,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+441588,int_stack+83874,int_stack+75684,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+572472,int_stack+441588,int_stack+188940,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+615060,int_stack+572472,int_stack+484488,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+675900,int_stack+615060,int_stack+520992,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+466158,int_stack+675900,int_stack+210234,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+188940,int_stack+93234,int_stack+83874,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+217020,int_stack+188940,int_stack+441588,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+217020,int_stack+572472,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+753120,int_stack+0,int_stack+615060,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+556248,int_stack+753120,int_stack+675900,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+844380,int_stack+556248,int_stack+466158,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+441588,int_stack+103842,int_stack+93234,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+473412,int_stack+441588,int_stack+188940,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+664356,int_stack+473412,int_stack+217020,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+188940,int_stack+664356,int_stack+0,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+964500,int_stack+188940,int_stack+753120,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+664356,int_stack+964500,int_stack+556248,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+441588,int_stack+664356,int_stack+844380,78);
 /*--- compute (np|mk) ---*/
 hrr1_build_np(Libint->AB,int_stack+596028,int_stack+441588,int_stack+310908,1980);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+188940,int_stack+120781,int_stack+115776,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+203955,int_stack+126787,int_stack+120781,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+221973,int_stack+203955,int_stack+188940,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+252003,int_stack+133885,int_stack+126787,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+273297,int_stack+252003,int_stack+203955,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+309333,int_stack+273297,int_stack+221973,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+188940,int_stack+142166,int_stack+133885,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+359383,int_stack+188940,int_stack+252003,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+359383,int_stack+273297,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+213783,int_stack+0,int_stack+309333,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+288858,int_stack+151721,int_stack+142166,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+60060,int_stack+288858,int_stack+188940,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+988068,int_stack+60060,int_stack+359383,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+317523,int_stack+988068,int_stack+0,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1059048,int_stack+317523,int_stack+213783,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+162641,int_stack+151721,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+188940,int_stack+0,int_stack+288858,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1164153,int_stack+188940,int_stack+60060,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+32760,int_stack+1164153,int_stack+988068,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1246963,int_stack+32760,int_stack+317523,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+246270,int_stack+1246963,int_stack+1059048,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+988068,int_stack+175017,int_stack+162641,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1025196,int_stack+988068,int_stack+0,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1373089,int_stack+1025196,int_stack+188940,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+988068,int_stack+1373089,int_stack+1164153,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1373089,int_stack+988068,int_stack+32760,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+988068,int_stack+1373089,int_stack+1246963,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1156236,int_stack+988068,int_stack+246270,91);
 /*--- compute (op|mk) ---*/
 hrr1_build_op(Libint->AB,int_stack+1336416,int_stack+1156236,int_stack+441588,1980);
 /*--- compute (nd|mk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1799736,int_stack+1336416,int_stack+596028,1980);
 return int_stack+1799736;}
