/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nhmi(Libint_t*, prim_data*);

  /* Computes quartets of (nh|mi) integrals */

REALTYPE *hrr_order_nhmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[10][15] = int_stack + 33990;
 Libint->vrr_classes[11][9] = int_stack + 42966;
 Libint->vrr_classes[11][10] = int_stack + 47256;
 Libint->vrr_classes[11][11] = int_stack + 52404;
 Libint->vrr_classes[11][12] = int_stack + 58488;
 Libint->vrr_classes[11][13] = int_stack + 65586;
 Libint->vrr_classes[11][14] = int_stack + 73776;
 Libint->vrr_classes[11][15] = int_stack + 83136;
 Libint->vrr_classes[12][9] = int_stack + 93744;
 Libint->vrr_classes[12][10] = int_stack + 98749;
 Libint->vrr_classes[12][11] = int_stack + 104755;
 Libint->vrr_classes[12][12] = int_stack + 111853;
 Libint->vrr_classes[12][13] = int_stack + 120134;
 Libint->vrr_classes[12][14] = int_stack + 129689;
 Libint->vrr_classes[12][15] = int_stack + 140609;
 Libint->vrr_classes[13][9] = int_stack + 152985;
 Libint->vrr_classes[13][10] = int_stack + 158760;
 Libint->vrr_classes[13][11] = int_stack + 165690;
 Libint->vrr_classes[13][12] = int_stack + 173880;
 Libint->vrr_classes[13][13] = int_stack + 183435;
 Libint->vrr_classes[13][14] = int_stack + 194460;
 Libint->vrr_classes[13][15] = int_stack + 207060;
 Libint->vrr_classes[14][9] = int_stack + 221340;
 Libint->vrr_classes[14][10] = int_stack + 227940;
 Libint->vrr_classes[14][11] = int_stack + 235860;
 Libint->vrr_classes[14][12] = int_stack + 245220;
 Libint->vrr_classes[14][13] = int_stack + 256140;
 Libint->vrr_classes[14][14] = int_stack + 268740;
 Libint->vrr_classes[14][15] = int_stack + 283140;
 Libint->vrr_classes[15][9] = int_stack + 299460;
 Libint->vrr_classes[15][10] = int_stack + 306940;
 Libint->vrr_classes[15][11] = int_stack + 315916;
 Libint->vrr_classes[15][12] = int_stack + 326524;
 Libint->vrr_classes[15][13] = int_stack + 338900;
 Libint->vrr_classes[15][14] = int_stack + 353180;
 Libint->vrr_classes[15][15] = int_stack + 369500;
 memset(int_stack,0,387996*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 387996;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nhmi(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+387996,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+398886,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+411954,int_stack+398886,int_stack+387996,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+433734,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+449178,int_stack+433734,int_stack+398886,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+475314,int_stack+449178,int_stack+411954,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+387996,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+511614,int_stack+387996,int_stack+433734,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+542502,int_stack+511614,int_stack+449178,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+406014,int_stack+542502,int_stack+475314,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+460464,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+586062,int_stack+460464,int_stack+387996,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+622098,int_stack+586062,int_stack+511614,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+673578,int_stack+622098,int_stack+542502,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+481254,int_stack+673578,int_stack+406014,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+387996,int_stack+33990,int_stack+26070,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+411756,int_stack+387996,int_stack+460464,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+738918,int_stack+411756,int_stack+586062,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+387996,int_stack+738918,int_stack+622098,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+557484,int_stack+387996,int_stack+673578,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+648960,int_stack+557484,int_stack+481254,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+387996,int_stack+47256,int_stack+42966,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+400866,int_stack+52404,int_stack+47256,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+416310,int_stack+400866,int_stack+387996,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+442050,int_stack+58488,int_stack+52404,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+460302,int_stack+442050,int_stack+400866,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+491190,int_stack+460302,int_stack+416310,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+387996,int_stack+65586,int_stack+58488,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+534090,int_stack+387996,int_stack+442050,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+570594,int_stack+534090,int_stack+460302,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+409290,int_stack+570594,int_stack+491190,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+473640,int_stack+73776,int_stack+65586,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+750600,int_stack+473640,int_stack+387996,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+750600,int_stack+534090,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+793188,int_stack+0,int_stack+570594,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+498210,int_stack+793188,int_stack+409290,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+387996,int_stack+83136,int_stack+73776,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+416076,int_stack+387996,int_stack+473640,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+870408,int_stack+416076,int_stack+750600,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+387996,int_stack+870408,int_stack+0,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+870408,int_stack+387996,int_stack+793188,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+978516,int_stack+870408,int_stack+498210,78);
 /*--- compute (np|mi) ---*/
 hrr1_build_np(Libint->AB,int_stack+1098636,int_stack+978516,int_stack+648960,1540);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+387996,int_stack+98749,int_stack+93744,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+403011,int_stack+104755,int_stack+98749,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+421029,int_stack+403011,int_stack+387996,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+451059,int_stack+111853,int_stack+104755,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+472353,int_stack+451059,int_stack+403011,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+508389,int_stack+472353,int_stack+421029,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+387996,int_stack+120134,int_stack+111853,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+558439,int_stack+387996,int_stack+451059,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+601027,int_stack+558439,int_stack+472353,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+412839,int_stack+601027,int_stack+508389,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+487914,int_stack+129689,int_stack+120134,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+661087,int_stack+487914,int_stack+387996,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+710773,int_stack+661087,int_stack+558439,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+781753,int_stack+710773,int_stack+601027,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+516579,int_stack+781753,int_stack+412839,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+387996,int_stack+140609,int_stack+129689,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+420756,int_stack+387996,int_stack+487914,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+871843,int_stack+420756,int_stack+661087,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+387996,int_stack+871843,int_stack+710773,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+621684,int_stack+387996,int_stack+781753,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+747810,int_stack+621684,int_stack+516579,91);
 /*--- compute (op|mi) ---*/
 hrr1_build_op(Libint->AB,int_stack+1403556,int_stack+747810,int_stack+978516,1540);
 /*--- compute (nd|mi) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1763916,int_stack+1403556,int_stack+1098636,1540);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+387996,int_stack+158760,int_stack+152985,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+405321,int_stack+165690,int_stack+158760,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+426111,int_stack+405321,int_stack+387996,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+460761,int_stack+173880,int_stack+165690,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+485331,int_stack+460761,int_stack+405321,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+526911,int_stack+485331,int_stack+426111,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+387996,int_stack+183435,int_stack+173880,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+584661,int_stack+387996,int_stack+460761,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+633801,int_stack+584661,int_stack+485331,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+416661,int_stack+633801,int_stack+526911,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+503286,int_stack+194460,int_stack+183435,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+887950,int_stack+503286,int_stack+387996,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+945280,int_stack+887950,int_stack+584661,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1027180,int_stack+945280,int_stack+633801,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+536361,int_stack+1027180,int_stack+416661,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+387996,int_stack+207060,int_stack+194460,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+425796,int_stack+387996,int_stack+503286,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1131130,int_stack+425796,int_stack+887950,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+387996,int_stack+1131130,int_stack+945280,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1131130,int_stack+387996,int_stack+1027180,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+887950,int_stack+1131130,int_stack+536361,105);
 /*--- compute (qp|mi) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2373756,int_stack+887950,int_stack+747810,1540);
 /*--- compute (od|mi) ---*/
 hrr1_build_od(Libint->AB,int_stack+2794176,int_stack+2373756,int_stack+1403556,1540);
 /*--- compute (nf|mi) ---*/
 hrr1_build_nf(Libint->AB,int_stack+3514896,int_stack+2794176,int_stack+1763916,1540);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+387996,int_stack+227940,int_stack+221340,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+407796,int_stack+235860,int_stack+227940,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+431556,int_stack+407796,int_stack+387996,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+471156,int_stack+245220,int_stack+235860,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+499236,int_stack+471156,int_stack+407796,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+546756,int_stack+499236,int_stack+431556,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+387996,int_stack+256140,int_stack+245220,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+612756,int_stack+387996,int_stack+471156,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+668916,int_stack+612756,int_stack+499236,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+420756,int_stack+668916,int_stack+546756,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+519756,int_stack+268740,int_stack+256140,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+748116,int_stack+519756,int_stack+387996,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1049650,int_stack+748116,int_stack+612756,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1143250,int_stack+1049650,int_stack+668916,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+557556,int_stack+1143250,int_stack+420756,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+387996,int_stack+283140,int_stack+268740,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+431196,int_stack+387996,int_stack+519756,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1262050,int_stack+431196,int_stack+748116,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+387996,int_stack+1262050,int_stack+1049650,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1262050,int_stack+387996,int_stack+1143250,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1049650,int_stack+1262050,int_stack+557556,120);
 /*--- compute (rp|mi) ---*/
 hrr1_build_rp(Libint->AB,int_stack+387996,int_stack+1049650,int_stack+887950,1540);
 /*--- compute (qd|mi) ---*/
 hrr1_build_qd(Libint->AB,int_stack+1234450,int_stack+387996,int_stack+2373756,1540);
 /*--- compute (of|mi) ---*/
 hrr1_build_of(Libint->AB,int_stack+4531296,int_stack+1234450,int_stack+2794176,1540);
 /*--- compute (ng|mi) ---*/
 hrr1_build_ng(Libint->AB,int_stack+5732496,int_stack+4531296,int_stack+3514896,1540);
 /*--- compute (u0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+873096,int_stack+306940,int_stack+299460,136);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+895536,int_stack+315916,int_stack+306940,136);
 /*--- compute (u0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+922464,int_stack+895536,int_stack+873096,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+967344,int_stack+326524,int_stack+315916,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2075290,int_stack+967344,int_stack+895536,136);
 /*--- compute (u0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2129146,int_stack+2075290,int_stack+922464,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+873096,int_stack+338900,int_stack+326524,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2203946,int_stack+873096,int_stack+967344,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+910224,int_stack+2203946,int_stack+2075290,136);
 /*--- compute (u0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2267594,int_stack+910224,int_stack+2129146,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2075290,int_stack+353180,int_stack+338900,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2118130,int_stack+2075290,int_stack+873096,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2379794,int_stack+2118130,int_stack+2203946,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2485874,int_stack+2379794,int_stack+910224,136);
 /*--- compute (u0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+873096,int_stack+2485874,int_stack+2267594,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2192386,int_stack+369500,int_stack+353180,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2241346,int_stack+2192386,int_stack+2075290,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2620514,int_stack+2241346,int_stack+2118130,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2075290,int_stack+2620514,int_stack+2379794,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2620514,int_stack+2075290,int_stack+2485874,136);
 /*--- compute (u0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2075290,int_stack+2620514,int_stack+873096,136);
 /*--- compute (tp|mi) ---*/
 hrr1_build_tp(Libint->AB,int_stack+2284730,int_stack+2075290,int_stack+1049650,1540);
 /*--- compute (rd|mi) ---*/
 hrr1_build_rd(Libint->AB,int_stack+2839130,int_stack+2284730,int_stack+387996,1540);
 /*--- compute (qf|mi) ---*/
 hrr1_build_qf(Libint->AB,int_stack+7257096,int_stack+2839130,int_stack+1234450,1540);
 /*--- compute (og|mi) ---*/
 hrr1_build_og(Libint->AB,int_stack+0,int_stack+7257096,int_stack+4531296,1540);
 /*--- compute (nh|mi) ---*/
 hrr1_build_nh(Libint->AB,int_stack+1801800,int_stack+0,int_stack+5732496,1540);
 return int_stack+1801800;}
