/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nhml(Libint_t*, prim_data*);

  /* Computes quartets of (nh|ml) integrals */

REALTYPE *hrr_order_nhml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[10][15] = int_stack + 33990;
 Libint->vrr_classes[10][16] = int_stack + 42966;
 Libint->vrr_classes[10][17] = int_stack + 53064;
 Libint->vrr_classes[11][9] = int_stack + 64350;
 Libint->vrr_classes[11][10] = int_stack + 68640;
 Libint->vrr_classes[11][11] = int_stack + 73788;
 Libint->vrr_classes[11][12] = int_stack + 79872;
 Libint->vrr_classes[11][13] = int_stack + 86970;
 Libint->vrr_classes[11][14] = int_stack + 95160;
 Libint->vrr_classes[11][15] = int_stack + 104520;
 Libint->vrr_classes[11][16] = int_stack + 115128;
 Libint->vrr_classes[11][17] = int_stack + 127062;
 Libint->vrr_classes[12][9] = int_stack + 140400;
 Libint->vrr_classes[12][10] = int_stack + 145405;
 Libint->vrr_classes[12][11] = int_stack + 151411;
 Libint->vrr_classes[12][12] = int_stack + 158509;
 Libint->vrr_classes[12][13] = int_stack + 166790;
 Libint->vrr_classes[12][14] = int_stack + 176345;
 Libint->vrr_classes[12][15] = int_stack + 187265;
 Libint->vrr_classes[12][16] = int_stack + 199641;
 Libint->vrr_classes[12][17] = int_stack + 213564;
 Libint->vrr_classes[13][9] = int_stack + 229125;
 Libint->vrr_classes[13][10] = int_stack + 234900;
 Libint->vrr_classes[13][11] = int_stack + 241830;
 Libint->vrr_classes[13][12] = int_stack + 250020;
 Libint->vrr_classes[13][13] = int_stack + 259575;
 Libint->vrr_classes[13][14] = int_stack + 270600;
 Libint->vrr_classes[13][15] = int_stack + 283200;
 Libint->vrr_classes[13][16] = int_stack + 297480;
 Libint->vrr_classes[13][17] = int_stack + 313545;
 Libint->vrr_classes[14][9] = int_stack + 331500;
 Libint->vrr_classes[14][10] = int_stack + 338100;
 Libint->vrr_classes[14][11] = int_stack + 346020;
 Libint->vrr_classes[14][12] = int_stack + 355380;
 Libint->vrr_classes[14][13] = int_stack + 366300;
 Libint->vrr_classes[14][14] = int_stack + 378900;
 Libint->vrr_classes[14][15] = int_stack + 393300;
 Libint->vrr_classes[14][16] = int_stack + 409620;
 Libint->vrr_classes[14][17] = int_stack + 427980;
 Libint->vrr_classes[15][9] = int_stack + 448500;
 Libint->vrr_classes[15][10] = int_stack + 455980;
 Libint->vrr_classes[15][11] = int_stack + 464956;
 Libint->vrr_classes[15][12] = int_stack + 475564;
 Libint->vrr_classes[15][13] = int_stack + 487940;
 Libint->vrr_classes[15][14] = int_stack + 502220;
 Libint->vrr_classes[15][15] = int_stack + 518540;
 Libint->vrr_classes[15][16] = int_stack + 537036;
 Libint->vrr_classes[15][17] = int_stack + 557844;
 memset(int_stack,0,581100*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 581100;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nhml(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+581100,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+591990,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+605058,int_stack+591990,int_stack+581100,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+626838,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+642282,int_stack+626838,int_stack+591990,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+668418,int_stack+642282,int_stack+605058,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+581100,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+704718,int_stack+581100,int_stack+626838,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+735606,int_stack+704718,int_stack+642282,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+599118,int_stack+735606,int_stack+668418,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+653568,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+779166,int_stack+653568,int_stack+581100,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+815202,int_stack+779166,int_stack+704718,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+866682,int_stack+815202,int_stack+735606,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+674358,int_stack+866682,int_stack+599118,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+581100,int_stack+33990,int_stack+26070,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+604860,int_stack+581100,int_stack+653568,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+932022,int_stack+604860,int_stack+779166,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+992082,int_stack+932022,int_stack+815202,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+750588,int_stack+992082,int_stack+866682,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1069302,int_stack+750588,int_stack+674358,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+646440,int_stack+42966,int_stack+33990,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+673368,int_stack+646440,int_stack+581100,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+842064,int_stack+673368,int_stack+604860,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1170942,int_stack+842064,int_stack+932022,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1261032,int_stack+1170942,int_stack+992082,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+911364,int_stack+1261032,int_stack+750588,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1369140,int_stack+911364,int_stack+1069302,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+581100,int_stack+53064,int_stack+42966,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+720888,int_stack+581100,int_stack+646440,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+581100,int_stack+720888,int_stack+673368,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+660300,int_stack+581100,int_stack+842064,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+764250,int_stack+660300,int_stack+1170942,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+581100,int_stack+764250,int_stack+1261032,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+725244,int_stack+581100,int_stack+911364,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+882060,int_stack+725244,int_stack+1369140,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+581100,int_stack+68640,int_stack+64350,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+593970,int_stack+73788,int_stack+68640,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+609414,int_stack+593970,int_stack+581100,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+635154,int_stack+79872,int_stack+73788,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+653406,int_stack+635154,int_stack+593970,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+684294,int_stack+653406,int_stack+609414,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+581100,int_stack+86970,int_stack+79872,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+727194,int_stack+581100,int_stack+635154,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+763698,int_stack+727194,int_stack+653406,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+602394,int_stack+763698,int_stack+684294,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+666744,int_stack+95160,int_stack+86970,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+815178,int_stack+666744,int_stack+581100,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1045410,int_stack+815178,int_stack+727194,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1106250,int_stack+1045410,int_stack+763698,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+691314,int_stack+1106250,int_stack+602394,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+581100,int_stack+104520,int_stack+95160,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+609180,int_stack+581100,int_stack+666744,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1183470,int_stack+609180,int_stack+815178,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+781404,int_stack+1183470,int_stack+1045410,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1254450,int_stack+781404,int_stack+1106250,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1045410,int_stack+1254450,int_stack+691314,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+658320,int_stack+115128,int_stack+104520,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+690144,int_stack+658320,int_stack+581100,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1362558,int_stack+690144,int_stack+609180,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+1362558,int_stack+1183470,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1444458,int_stack+0,int_stack+781404,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1572222,int_stack+1444458,int_stack+1254450,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1165530,int_stack+1572222,int_stack+1045410,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1045410,int_stack+127062,int_stack+115128,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1081212,int_stack+1045410,int_stack+658320,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+581100,int_stack+1081212,int_stack+690144,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+674700,int_stack+581100,int_stack+1362558,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1716366,int_stack+674700,int_stack+0,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+581100,int_stack+1716366,int_stack+1444458,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1319970,int_stack+581100,int_stack+1572222,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+581100,int_stack+1319970,int_stack+1165530,78);
 /*--- compute (np|ml) ---*/
 hrr1_build_np(Libint->AB,int_stack+1045410,int_stack+581100,int_stack+882060,2475);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+774150,int_stack+145405,int_stack+140400,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+789165,int_stack+151411,int_stack+145405,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+807183,int_stack+789165,int_stack+774150,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+837213,int_stack+158509,int_stack+151411,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+858507,int_stack+837213,int_stack+789165,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+894543,int_stack+858507,int_stack+807183,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+774150,int_stack+166790,int_stack+158509,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+944593,int_stack+774150,int_stack+837213,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+944593,int_stack+858507,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+798993,int_stack+0,int_stack+894543,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+874068,int_stack+176345,int_stack+166790,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+987181,int_stack+874068,int_stack+774150,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+60060,int_stack+987181,int_stack+944593,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1535460,int_stack+60060,int_stack+0,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1625550,int_stack+1535460,int_stack+798993,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+187265,int_stack+176345,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+774150,int_stack+0,int_stack+874068,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+831480,int_stack+774150,int_stack+987181,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+914290,int_stack+831480,int_stack+60060,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+32760,int_stack+914290,int_stack+1535460,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1730655,int_stack+32760,int_stack+1625550,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1535460,int_stack+199641,int_stack+187265,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1572588,int_stack+1535460,int_stack+0,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1870795,int_stack+1572588,int_stack+774150,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1966345,int_stack+1870795,int_stack+831480,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2090560,int_stack+1966345,int_stack+914290,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+774150,int_stack+2090560,int_stack+32760,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+774150,int_stack+1730655,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+942318,int_stack+213564,int_stack+199641,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1638108,int_stack+942318,int_stack+1535460,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1712364,int_stack+1638108,int_stack+1572588,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1535460,int_stack+1712364,int_stack+1870795,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1678785,int_stack+1535460,int_stack+1966345,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1852686,int_stack+1678785,int_stack+2090560,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1535460,int_stack+1852686,int_stack+774150,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+774150,int_stack+1535460,int_stack+0,91);
 /*--- compute (op|ml) ---*/
 hrr1_build_op(Libint->AB,int_stack+1535460,int_stack+774150,int_stack+581100,2475);
 /*--- compute (nd|ml) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2114610,int_stack+1535460,int_stack+1045410,2475);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+581100,int_stack+234900,int_stack+229125,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+598425,int_stack+241830,int_stack+234900,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+619215,int_stack+598425,int_stack+581100,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+653865,int_stack+250020,int_stack+241830,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+678435,int_stack+653865,int_stack+598425,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+678435,int_stack+619215,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+581100,int_stack+259575,int_stack+250020,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+720015,int_stack+581100,int_stack+653865,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+57750,int_stack+720015,int_stack+678435,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+609765,int_stack+57750,int_stack+0,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+270600,int_stack+259575,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+127050,int_stack+0,int_stack+581100,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+184380,int_stack+127050,int_stack+720015,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+999375,int_stack+184380,int_stack+57750,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1103325,int_stack+999375,int_stack+609765,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+581100,int_stack+283200,int_stack+270600,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+618900,int_stack+581100,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+618900,int_stack+127050,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1224600,int_stack+0,int_stack+184380,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+95550,int_stack+1224600,int_stack+999375,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1347450,int_stack+95550,int_stack+1103325,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+999375,int_stack+297480,int_stack+283200,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1042215,int_stack+999375,int_stack+581100,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3094710,int_stack+1042215,int_stack+618900,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+581100,int_stack+3094710,int_stack+0,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3204960,int_stack+581100,int_stack+1224600,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1117815,int_stack+3204960,int_stack+95550,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+1117815,int_stack+1347450,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+207900,int_stack+313545,int_stack+297480,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1311855,int_stack+207900,int_stack+999375,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1397535,int_stack+1311855,int_stack+1042215,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3376950,int_stack+1397535,int_stack+3094710,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1311855,int_stack+3376950,int_stack+581100,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3376950,int_stack+1311855,int_stack+3204960,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3094710,int_stack+3376950,int_stack+1117815,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3344190,int_stack+3094710,int_stack+0,105);
 /*--- compute (qp|ml) ---*/
 hrr1_build_qp(Libint->AB,int_stack+3604065,int_stack+3344190,int_stack+774150,2475);
 /*--- compute (od|ml) ---*/
 hrr1_build_od(Libint->AB,int_stack+4279740,int_stack+3604065,int_stack+1535460,2475);
 /*--- compute (nf|ml) ---*/
 hrr1_build_nf(Libint->AB,int_stack+5438040,int_stack+4279740,int_stack+2114610,2475);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+338100,int_stack+331500,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+19800,int_stack+346020,int_stack+338100,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+43560,int_stack+19800,int_stack+0,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+83160,int_stack+355380,int_stack+346020,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+111240,int_stack+83160,int_stack+19800,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+158760,int_stack+111240,int_stack+43560,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+366300,int_stack+355380,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+224760,int_stack+0,int_stack+83160,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+280920,int_stack+224760,int_stack+111240,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+32760,int_stack+280920,int_stack+158760,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+131760,int_stack+378900,int_stack+366300,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+581100,int_stack+131760,int_stack+0,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+646620,int_stack+581100,int_stack+224760,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+740220,int_stack+646620,int_stack+280920,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+169560,int_stack+740220,int_stack+32760,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+393300,int_stack+378900,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+43200,int_stack+0,int_stack+131760,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+859020,int_stack+43200,int_stack+581100,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+968220,int_stack+859020,int_stack+646620,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1108620,int_stack+968220,int_stack+740220,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+581100,int_stack+1108620,int_stack+169560,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+765900,int_stack+409620,int_stack+393300,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+118800,int_stack+765900,int_stack+0,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+205200,int_stack+118800,int_stack+43200,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1274940,int_stack+205200,int_stack+859020,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1438740,int_stack+1274940,int_stack+968220,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+814860,int_stack+1438740,int_stack+1108620,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1036620,int_stack+814860,int_stack+581100,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+581100,int_stack+427980,int_stack+409620,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+636180,int_stack+581100,int_stack+765900,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1635300,int_stack+636180,int_stack+118800,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+581100,int_stack+1635300,int_stack+205200,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1635300,int_stack+581100,int_stack+1274940,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1864620,int_stack+1635300,int_stack+1438740,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2126700,int_stack+1864620,int_stack+814860,120);
 /*--- compute (t0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+581100,int_stack+2126700,int_stack+1036620,120);
 /*--- compute (rp|ml) ---*/
 hrr1_build_rp(Libint->AB,int_stack+878100,int_stack+581100,int_stack+3344190,2475);
 /*--- compute (qd|ml) ---*/
 hrr1_build_qd(Libint->AB,int_stack+1657725,int_stack+878100,int_stack+3604065,2475);
 /*--- compute (of|ml) ---*/
 hrr1_build_of(Libint->AB,int_stack+7071540,int_stack+1657725,int_stack+4279740,2475);
 /*--- compute (ng|ml) ---*/
 hrr1_build_ng(Libint->AB,int_stack+9002040,int_stack+7071540,int_stack+5438040,2475);
 /*--- compute (u0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3009075,int_stack+455980,int_stack+448500,136);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3031515,int_stack+464956,int_stack+455980,136);
 /*--- compute (u0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+3058443,int_stack+3031515,int_stack+3009075,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3103323,int_stack+475564,int_stack+464956,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+3135147,int_stack+3103323,int_stack+3031515,136);
 /*--- compute (u0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+3189003,int_stack+3135147,int_stack+3058443,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3009075,int_stack+487940,int_stack+475564,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3263803,int_stack+3009075,int_stack+3103323,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3327451,int_stack+3263803,int_stack+3135147,136);
 /*--- compute (u0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+3046203,int_stack+3327451,int_stack+3189003,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+3158403,int_stack+502220,int_stack+487940,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3417211,int_stack+3158403,int_stack+3009075,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3491467,int_stack+3417211,int_stack+3263803,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3597547,int_stack+3491467,int_stack+3327451,136);
 /*--- compute (u0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+3201243,int_stack+3597547,int_stack+3046203,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3009075,int_stack+518540,int_stack+502220,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3058035,int_stack+3009075,int_stack+3158403,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3732187,int_stack+3058035,int_stack+3417211,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3855947,int_stack+3732187,int_stack+3491467,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3358323,int_stack+3855947,int_stack+3597547,136);
 /*--- compute (u0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+4015067,int_stack+3358323,int_stack+3201243,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+3143715,int_stack+537036,int_stack+518540,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+3199203,int_stack+3143715,int_stack+3009075,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3546819,int_stack+3199203,int_stack+3058035,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+4224507,int_stack+3546819,int_stack+3732187,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+4410147,int_stack+4224507,int_stack+3855947,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3689619,int_stack+4410147,int_stack+3358323,136);
 /*--- compute (u0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+4632915,int_stack+3689619,int_stack+4015067,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3009075,int_stack+557844,int_stack+537036,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3297123,int_stack+3009075,int_stack+3143715,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3009075,int_stack+3297123,int_stack+3199203,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3172275,int_stack+3009075,int_stack+3546819,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3386475,int_stack+3172275,int_stack+4224507,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3009075,int_stack+3386475,int_stack+4410147,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3306099,int_stack+3009075,int_stack+3689619,136);
 /*--- compute (u0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3629235,int_stack+3306099,int_stack+4632915,136);
 /*--- compute (tp|ml) ---*/
 hrr1_build_tp(Libint->AB,int_stack+3965835,int_stack+3629235,int_stack+581100,2475);
 /*--- compute (rd|ml) ---*/
 hrr1_build_rd(Libint->AB,int_stack+4856835,int_stack+3965835,int_stack+878100,2475);
 /*--- compute (qf|ml) ---*/
 hrr1_build_qf(Libint->AB,int_stack+11452290,int_stack+4856835,int_stack+1657725,2475);
 /*--- compute (og|ml) ---*/
 hrr1_build_og(Libint->AB,int_stack+0,int_stack+11452290,int_stack+7071540,2475);
 /*--- compute (nh|ml) ---*/
 hrr1_build_nh(Libint->AB,int_stack+2895750,int_stack+0,int_stack+9002040,2475);
 return int_stack+2895750;}
