/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nhmm(Libint_t*, prim_data*);

  /* Computes quartets of (nh|mm) integrals */

REALTYPE *hrr_order_nhmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[10][15] = int_stack + 33990;
 Libint->vrr_classes[10][16] = int_stack + 42966;
 Libint->vrr_classes[10][17] = int_stack + 53064;
 Libint->vrr_classes[10][18] = int_stack + 64350;
 Libint->vrr_classes[11][9] = int_stack + 76890;
 Libint->vrr_classes[11][10] = int_stack + 81180;
 Libint->vrr_classes[11][11] = int_stack + 86328;
 Libint->vrr_classes[11][12] = int_stack + 92412;
 Libint->vrr_classes[11][13] = int_stack + 99510;
 Libint->vrr_classes[11][14] = int_stack + 107700;
 Libint->vrr_classes[11][15] = int_stack + 117060;
 Libint->vrr_classes[11][16] = int_stack + 127668;
 Libint->vrr_classes[11][17] = int_stack + 139602;
 Libint->vrr_classes[11][18] = int_stack + 152940;
 Libint->vrr_classes[12][9] = int_stack + 167760;
 Libint->vrr_classes[12][10] = int_stack + 172765;
 Libint->vrr_classes[12][11] = int_stack + 178771;
 Libint->vrr_classes[12][12] = int_stack + 185869;
 Libint->vrr_classes[12][13] = int_stack + 194150;
 Libint->vrr_classes[12][14] = int_stack + 203705;
 Libint->vrr_classes[12][15] = int_stack + 214625;
 Libint->vrr_classes[12][16] = int_stack + 227001;
 Libint->vrr_classes[12][17] = int_stack + 240924;
 Libint->vrr_classes[12][18] = int_stack + 256485;
 Libint->vrr_classes[13][9] = int_stack + 273775;
 Libint->vrr_classes[13][10] = int_stack + 279550;
 Libint->vrr_classes[13][11] = int_stack + 286480;
 Libint->vrr_classes[13][12] = int_stack + 294670;
 Libint->vrr_classes[13][13] = int_stack + 304225;
 Libint->vrr_classes[13][14] = int_stack + 315250;
 Libint->vrr_classes[13][15] = int_stack + 327850;
 Libint->vrr_classes[13][16] = int_stack + 342130;
 Libint->vrr_classes[13][17] = int_stack + 358195;
 Libint->vrr_classes[13][18] = int_stack + 376150;
 Libint->vrr_classes[14][9] = int_stack + 396100;
 Libint->vrr_classes[14][10] = int_stack + 402700;
 Libint->vrr_classes[14][11] = int_stack + 410620;
 Libint->vrr_classes[14][12] = int_stack + 419980;
 Libint->vrr_classes[14][13] = int_stack + 430900;
 Libint->vrr_classes[14][14] = int_stack + 443500;
 Libint->vrr_classes[14][15] = int_stack + 457900;
 Libint->vrr_classes[14][16] = int_stack + 474220;
 Libint->vrr_classes[14][17] = int_stack + 492580;
 Libint->vrr_classes[14][18] = int_stack + 513100;
 Libint->vrr_classes[15][9] = int_stack + 535900;
 Libint->vrr_classes[15][10] = int_stack + 543380;
 Libint->vrr_classes[15][11] = int_stack + 552356;
 Libint->vrr_classes[15][12] = int_stack + 562964;
 Libint->vrr_classes[15][13] = int_stack + 575340;
 Libint->vrr_classes[15][14] = int_stack + 589620;
 Libint->vrr_classes[15][15] = int_stack + 605940;
 Libint->vrr_classes[15][16] = int_stack + 624436;
 Libint->vrr_classes[15][17] = int_stack + 645244;
 Libint->vrr_classes[15][18] = int_stack + 668500;
 memset(int_stack,0,694340*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 694340;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nhmm(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+694340,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+705230,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+718298,int_stack+705230,int_stack+694340,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+740078,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+755522,int_stack+740078,int_stack+705230,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+781658,int_stack+755522,int_stack+718298,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+694340,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+817958,int_stack+694340,int_stack+740078,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+848846,int_stack+817958,int_stack+755522,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+712358,int_stack+848846,int_stack+781658,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+766808,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+892406,int_stack+766808,int_stack+694340,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+928442,int_stack+892406,int_stack+817958,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+979922,int_stack+928442,int_stack+848846,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+787598,int_stack+979922,int_stack+712358,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+694340,int_stack+33990,int_stack+26070,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+718100,int_stack+694340,int_stack+766808,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1045262,int_stack+718100,int_stack+892406,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1105322,int_stack+1045262,int_stack+928442,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+863828,int_stack+1105322,int_stack+979922,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1182542,int_stack+863828,int_stack+787598,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+759680,int_stack+42966,int_stack+33990,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+786608,int_stack+759680,int_stack+694340,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+955304,int_stack+786608,int_stack+718100,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1284182,int_stack+955304,int_stack+1045262,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1374272,int_stack+1284182,int_stack+1105322,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1024604,int_stack+1374272,int_stack+863828,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1482380,int_stack+1024604,int_stack+1182542,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+694340,int_stack+53064,int_stack+42966,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+834128,int_stack+694340,int_stack+759680,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1146572,int_stack+834128,int_stack+786608,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+724634,int_stack+1146572,int_stack+955304,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+887984,int_stack+724634,int_stack+1284182,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1225772,int_stack+887984,int_stack+1374272,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1613060,int_stack+1225772,int_stack+1024604,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1769876,int_stack+1613060,int_stack+1482380,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1014110,int_stack+64350,int_stack+53064,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1047968,int_stack+1014110,int_stack+694340,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1369916,int_stack+1047968,int_stack+834128,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1014110,int_stack+1369916,int_stack+1146572,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1369916,int_stack+1014110,int_stack+724634,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1014110,int_stack+1369916,int_stack+887984,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1369916,int_stack+1014110,int_stack+1225772,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+694340,int_stack+1369916,int_stack+1613060,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+890360,int_stack+694340,int_stack+1769876,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+694340,int_stack+81180,int_stack+76890,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+707210,int_stack+86328,int_stack+81180,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+722654,int_stack+707210,int_stack+694340,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+748394,int_stack+92412,int_stack+86328,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+766646,int_stack+748394,int_stack+707210,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+797534,int_stack+766646,int_stack+722654,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+694340,int_stack+99510,int_stack+92412,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+840434,int_stack+694340,int_stack+748394,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1090010,int_stack+840434,int_stack+766646,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+715634,int_stack+1090010,int_stack+797534,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+779984,int_stack+107700,int_stack+99510,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1141490,int_stack+779984,int_stack+694340,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1184078,int_stack+1141490,int_stack+840434,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+804554,int_stack+1184078,int_stack+1090010,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1244918,int_stack+804554,int_stack+715634,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1090010,int_stack+117060,int_stack+107700,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+694340,int_stack+1090010,int_stack+779984,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1335008,int_stack+694340,int_stack+1141490,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1405988,int_stack+1335008,int_stack+1184078,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1118090,int_stack+1405988,int_stack+804554,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+743480,int_stack+1118090,int_stack+1244918,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1226198,int_stack+127668,int_stack+117060,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1258022,int_stack+1226198,int_stack+1090010,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1497248,int_stack+1258022,int_stack+694340,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1579148,int_stack+1497248,int_stack+1335008,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1685618,int_stack+1579148,int_stack+1405988,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1314182,int_stack+1685618,int_stack+1118090,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1813382,int_stack+1314182,int_stack+743480,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+694340,int_stack+139602,int_stack+127668,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+730142,int_stack+694340,int_stack+1226198,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+793790,int_stack+730142,int_stack+1258022,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1090010,int_stack+793790,int_stack+1497248,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1967822,int_stack+1090010,int_stack+1579148,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1458326,int_stack+1967822,int_stack+1685618,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2116880,int_stack+1458326,int_stack+1314182,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1212860,int_stack+2116880,int_stack+1813382,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1405910,int_stack+152940,int_stack+139602,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1628678,int_stack+1405910,int_stack+694340,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1700282,int_stack+1628678,int_stack+730142,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1806362,int_stack+1700282,int_stack+793790,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1628678,int_stack+1806362,int_stack+1090010,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2302208,int_stack+1628678,int_stack+1967822,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1628678,int_stack+2302208,int_stack+1458326,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1847702,int_stack+1628678,int_stack+2116880,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+2079362,int_stack+1847702,int_stack+1212860,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+1090010,int_stack+2079362,int_stack+890360,3025);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2315312,int_stack+172765,int_stack+167760,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2330327,int_stack+178771,int_stack+172765,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2348345,int_stack+2330327,int_stack+2315312,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2378375,int_stack+185869,int_stack+178771,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2399669,int_stack+2378375,int_stack+2330327,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2435705,int_stack+2399669,int_stack+2348345,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2315312,int_stack+194150,int_stack+185869,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1688960,int_stack+2315312,int_stack+2378375,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1731548,int_stack+1688960,int_stack+2399669,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2340155,int_stack+1731548,int_stack+2435705,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2415230,int_stack+203705,int_stack+194150,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2443895,int_stack+2415230,int_stack+2315312,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1791608,int_stack+2443895,int_stack+1688960,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1862588,int_stack+1791608,int_stack+1731548,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1952678,int_stack+1862588,int_stack+2340155,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1688960,int_stack+214625,int_stack+203705,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1721720,int_stack+1688960,int_stack+2415230,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2315312,int_stack+1721720,int_stack+2443895,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+694340,int_stack+2315312,int_stack+1791608,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+800810,int_stack+694340,int_stack+1862588,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1779050,int_stack+800810,int_stack+1952678,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1919190,int_stack+227001,int_stack+214625,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1956318,int_stack+1919190,int_stack+1688960,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2398122,int_stack+1956318,int_stack+1721720,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+926936,int_stack+2398122,int_stack+2315312,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+926936,int_stack+694340,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2493672,int_stack+0,int_stack+800810,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+694340,int_stack+2493672,int_stack+1779050,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+874520,int_stack+240924,int_stack+227001,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2315312,int_stack+874520,int_stack+1919190,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1688960,int_stack+2315312,int_stack+1956318,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1798160,int_stack+1688960,int_stack+2398122,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2661840,int_stack+1798160,int_stack+926936,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2835741,int_stack+2661840,int_stack+0,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2835741,int_stack+2493672,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2389568,int_stack+0,int_stack+694340,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+694340,int_stack+256485,int_stack+240924,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+741023,int_stack+694340,int_stack+874520,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+824561,int_stack+741023,int_stack+2315312,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3034485,int_stack+824561,int_stack+1688960,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+694340,int_stack+3034485,int_stack+1798160,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1688960,int_stack+694340,int_stack+2661840,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+694340,int_stack+1688960,int_stack+2835741,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1688960,int_stack+694340,int_stack+0,91);
 /*--- compute (q0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+694340,int_stack+1688960,int_stack+2389568,91);
 /*--- compute (op|mm) ---*/
 hrr1_build_op(Libint->AB,int_stack+2315312,int_stack+694340,int_stack+2079362,3025);
 /*--- compute (nd|mm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3023162,int_stack+2315312,int_stack+1090010,3025);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+279550,int_stack+273775,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17325,int_stack+286480,int_stack+279550,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+38115,int_stack+17325,int_stack+0,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+72765,int_stack+294670,int_stack+286480,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+97335,int_stack+72765,int_stack+17325,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+138915,int_stack+97335,int_stack+38115,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+304225,int_stack+294670,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+196665,int_stack+0,int_stack+72765,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+969615,int_stack+196665,int_stack+97335,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+28665,int_stack+969615,int_stack+138915,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+115290,int_stack+315250,int_stack+304225,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+245805,int_stack+115290,int_stack+0,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1038915,int_stack+245805,int_stack+196665,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1120815,int_stack+1038915,int_stack+969615,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1224765,int_stack+1120815,int_stack+28665,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+969615,int_stack+327850,int_stack+315250,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+969615,int_stack+115290,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+66150,int_stack+0,int_stack+245805,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+161700,int_stack+66150,int_stack+1038915,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1346040,int_stack+161700,int_stack+1120815,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1007415,int_stack+1346040,int_stack+1224765,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1169115,int_stack+342130,int_stack+327850,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1211955,int_stack+1169115,int_stack+969615,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1491570,int_stack+1211955,int_stack+0,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1601820,int_stack+1491570,int_stack+66150,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1745145,int_stack+1601820,int_stack+161700,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1745145,int_stack+1346040,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1917135,int_stack+0,int_stack+1007415,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+194040,int_stack+358195,int_stack+342130,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+242235,int_stack+194040,int_stack+1169115,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+969615,int_stack+242235,int_stack+1211955,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1095615,int_stack+969615,int_stack+1491570,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1260990,int_stack+1095615,int_stack+1601820,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1461645,int_stack+1260990,int_stack+1745145,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4221062,int_stack+1461645,int_stack+0,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+4470542,int_stack+4221062,int_stack+1917135,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+376150,int_stack+358195,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+53865,int_stack+0,int_stack+194040,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1690965,int_stack+53865,int_stack+242235,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+1690965,int_stack+969615,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1690965,int_stack+0,int_stack+1095615,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+1690965,int_stack+1260990,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1690965,int_stack+0,int_stack+1461645,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1690965,int_stack+4221062,105);
 /*--- compute (r0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+969615,int_stack+0,int_stack+4470542,105);
 /*--- compute (qp|mm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1287240,int_stack+969615,int_stack+694340,3025);
 /*--- compute (od|mm) ---*/
 hrr1_build_od(Libint->AB,int_stack+4221062,int_stack+1287240,int_stack+2315312,3025);
 /*--- compute (nf|mm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+5636762,int_stack+4221062,int_stack+3023162,3025);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+694340,int_stack+402700,int_stack+396100,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+714140,int_stack+410620,int_stack+402700,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+737900,int_stack+714140,int_stack+694340,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+777500,int_stack+419980,int_stack+410620,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+805580,int_stack+777500,int_stack+714140,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+853100,int_stack+805580,int_stack+737900,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+694340,int_stack+430900,int_stack+419980,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+694340,int_stack+777500,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+56160,int_stack+0,int_stack+805580,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+727100,int_stack+56160,int_stack+853100,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+826100,int_stack+443500,int_stack+430900,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+863900,int_stack+826100,int_stack+694340,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+135360,int_stack+863900,int_stack+0,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+228960,int_stack+135360,int_stack+56160,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2113065,int_stack+228960,int_stack+727100,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+457900,int_stack+443500,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+43200,int_stack+0,int_stack+826100,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+694340,int_stack+43200,int_stack+863900,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+803540,int_stack+694340,int_stack+135360,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2251665,int_stack+803540,int_stack+228960,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+118800,int_stack+2251665,int_stack+2113065,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2113065,int_stack+474220,int_stack+457900,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2162025,int_stack+2113065,int_stack+0,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+303600,int_stack+2162025,int_stack+43200,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2417985,int_stack+303600,int_stack+694340,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2581785,int_stack+2417985,int_stack+803540,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+694340,int_stack+2581785,int_stack+2251665,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2778345,int_stack+694340,int_stack+118800,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+492580,int_stack+474220,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+55080,int_stack+0,int_stack+2113065,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+153000,int_stack+55080,int_stack+2162025,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2113065,int_stack+153000,int_stack+303600,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3015945,int_stack+2113065,int_stack+2417985,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2302065,int_stack+3015945,int_stack+2581785,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3245265,int_stack+2302065,int_stack+694340,120);
 /*--- compute (t0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3530385,int_stack+3245265,int_stack+2778345,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+694340,int_stack+513100,int_stack+492580,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+755900,int_stack+694340,int_stack+0,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2564145,int_stack+755900,int_stack+55080,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+694340,int_stack+2564145,int_stack+153000,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2564145,int_stack+694340,int_stack+2113065,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+2564145,int_stack+3015945,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2564145,int_stack+0,int_stack+2302065,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+2564145,int_stack+3245265,120);
 /*--- compute (t0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+2113065,int_stack+0,int_stack+3530385,120);
 /*--- compute (rp|mm) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2476065,int_stack+2113065,int_stack+969615,3025);
 /*--- compute (qd|mm) ---*/
 hrr1_build_qd(Libint->AB,int_stack+7633262,int_stack+2476065,int_stack+1287240,3025);
 /*--- compute (of|mm) ---*/
 hrr1_build_of(Libint->AB,int_stack+9284912,int_stack+7633262,int_stack+4221062,3025);
 /*--- compute (ng|mm) ---*/
 hrr1_build_ng(Libint->AB,int_stack+11644412,int_stack+9284912,int_stack+5636762,3025);
 /*--- compute (u0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+543380,int_stack+535900,136);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+22440,int_stack+552356,int_stack+543380,136);
 /*--- compute (u0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+49368,int_stack+22440,int_stack+0,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+94248,int_stack+562964,int_stack+552356,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+126072,int_stack+94248,int_stack+22440,136);
 /*--- compute (u0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+179928,int_stack+126072,int_stack+49368,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+575340,int_stack+562964,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+254728,int_stack+0,int_stack+94248,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+318376,int_stack+254728,int_stack+126072,136);
 /*--- compute (u0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+37128,int_stack+318376,int_stack+179928,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+149328,int_stack+589620,int_stack+575340,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+408136,int_stack+149328,int_stack+0,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+482392,int_stack+408136,int_stack+254728,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3428940,int_stack+482392,int_stack+318376,136);
 /*--- compute (u0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+192168,int_stack+3428940,int_stack+37128,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+605940,int_stack+589620,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+48960,int_stack+0,int_stack+149328,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3563580,int_stack+48960,int_stack+408136,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3687340,int_stack+3563580,int_stack+482392,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+349248,int_stack+3687340,int_stack+3428940,136);
 /*--- compute (u0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+3846460,int_stack+349248,int_stack+192168,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+3428940,int_stack+624436,int_stack+605940,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+134640,int_stack+3428940,int_stack+0,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4055900,int_stack+134640,int_stack+48960,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+4198700,int_stack+4055900,int_stack+3563580,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+4384340,int_stack+4198700,int_stack+3687340,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3484428,int_stack+4384340,int_stack+349248,136);
 /*--- compute (u0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+232560,int_stack+3484428,int_stack+3846460,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+645244,int_stack+624436,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3735756,int_stack+0,int_stack+3428940,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3846732,int_stack+3735756,int_stack+134640,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4607108,int_stack+3846732,int_stack+4055900,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+4821308,int_stack+4607108,int_stack+4198700,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+4009932,int_stack+4821308,int_stack+4384340,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+5081204,int_stack+4009932,int_stack+3484428,136);
 /*--- compute (u0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+5404340,int_stack+5081204,int_stack+232560,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+3428940,int_stack+668500,int_stack+645244,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+3498708,int_stack+3428940,int_stack+0,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+3498708,int_stack+3735756,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+184960,int_stack+0,int_stack+3846732,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+429760,int_stack+184960,int_stack+4607108,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+429760,int_stack+4821308,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+346528,int_stack+0,int_stack+4009932,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+728416,int_stack+346528,int_stack+5081204,136);
 /*--- compute (u0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+0,int_stack+728416,int_stack+5404340,136);
 /*--- compute (tp|mm) ---*/
 hrr1_build_tp(Libint->AB,int_stack+411400,int_stack+0,int_stack+2113065,3025);
 /*--- compute (rd|mm) ---*/
 hrr1_build_rd(Libint->AB,int_stack+3428940,int_stack+411400,int_stack+2476065,3025);
 /*--- compute (qf|mm) ---*/
 hrr1_build_qf(Libint->AB,int_stack+0,int_stack+3428940,int_stack+7633262,3025);
 /*--- compute (og|mm) ---*/
 hrr1_build_og(Libint->AB,int_stack+2752750,int_stack+0,int_stack+9284912,3025);
 /*--- compute (nh|mm) ---*/
 hrr1_build_nh(Libint->AB,int_stack+6292000,int_stack+2752750,int_stack+11644412,3025);
 return int_stack+6292000;}
