/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nknk(Libint_t*, prim_data*);

  /* Computes quartets of (nk|nk) integrals */

REALTYPE *hrr_order_nknk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[11][10] = int_stack + 60720;
 Libint->vrr_classes[11][11] = int_stack + 65868;
 Libint->vrr_classes[11][12] = int_stack + 71952;
 Libint->vrr_classes[11][13] = int_stack + 79050;
 Libint->vrr_classes[11][14] = int_stack + 87240;
 Libint->vrr_classes[11][15] = int_stack + 96600;
 Libint->vrr_classes[11][16] = int_stack + 107208;
 Libint->vrr_classes[11][17] = int_stack + 119142;
 Libint->vrr_classes[12][10] = int_stack + 132480;
 Libint->vrr_classes[12][11] = int_stack + 138486;
 Libint->vrr_classes[12][12] = int_stack + 145584;
 Libint->vrr_classes[12][13] = int_stack + 153865;
 Libint->vrr_classes[12][14] = int_stack + 163420;
 Libint->vrr_classes[12][15] = int_stack + 174340;
 Libint->vrr_classes[12][16] = int_stack + 186716;
 Libint->vrr_classes[12][17] = int_stack + 200639;
 Libint->vrr_classes[13][10] = int_stack + 216200;
 Libint->vrr_classes[13][11] = int_stack + 223130;
 Libint->vrr_classes[13][12] = int_stack + 231320;
 Libint->vrr_classes[13][13] = int_stack + 240875;
 Libint->vrr_classes[13][14] = int_stack + 251900;
 Libint->vrr_classes[13][15] = int_stack + 264500;
 Libint->vrr_classes[13][16] = int_stack + 278780;
 Libint->vrr_classes[13][17] = int_stack + 294845;
 Libint->vrr_classes[14][10] = int_stack + 312800;
 Libint->vrr_classes[14][11] = int_stack + 320720;
 Libint->vrr_classes[14][12] = int_stack + 330080;
 Libint->vrr_classes[14][13] = int_stack + 341000;
 Libint->vrr_classes[14][14] = int_stack + 353600;
 Libint->vrr_classes[14][15] = int_stack + 368000;
 Libint->vrr_classes[14][16] = int_stack + 384320;
 Libint->vrr_classes[14][17] = int_stack + 402680;
 Libint->vrr_classes[15][10] = int_stack + 423200;
 Libint->vrr_classes[15][11] = int_stack + 432176;
 Libint->vrr_classes[15][12] = int_stack + 442784;
 Libint->vrr_classes[15][13] = int_stack + 455160;
 Libint->vrr_classes[15][14] = int_stack + 469440;
 Libint->vrr_classes[15][15] = int_stack + 485760;
 Libint->vrr_classes[15][16] = int_stack + 504256;
 Libint->vrr_classes[15][17] = int_stack + 525064;
 Libint->vrr_classes[16][10] = int_stack + 548320;
 Libint->vrr_classes[16][11] = int_stack + 558418;
 Libint->vrr_classes[16][12] = int_stack + 570352;
 Libint->vrr_classes[16][13] = int_stack + 584275;
 Libint->vrr_classes[16][14] = int_stack + 600340;
 Libint->vrr_classes[16][15] = int_stack + 618700;
 Libint->vrr_classes[16][16] = int_stack + 639508;
 Libint->vrr_classes[16][17] = int_stack + 662917;
 Libint->vrr_classes[17][10] = int_stack + 689080;
 Libint->vrr_classes[17][11] = int_stack + 700366;
 Libint->vrr_classes[17][12] = int_stack + 713704;
 Libint->vrr_classes[17][13] = int_stack + 729265;
 Libint->vrr_classes[17][14] = int_stack + 747220;
 Libint->vrr_classes[17][15] = int_stack + 767740;
 Libint->vrr_classes[17][16] = int_stack + 790996;
 Libint->vrr_classes[17][17] = int_stack + 817159;
 memset(int_stack,0,846400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 846400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nknk(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+846400,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+859468,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+874912,int_stack+859468,int_stack+846400,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+901048,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+919066,int_stack+901048,int_stack+859468,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+949954,int_stack+919066,int_stack+874912,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+846400,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+993514,int_stack+846400,int_stack+901048,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+867190,int_stack+993514,int_stack+919066,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1029550,int_stack+867190,int_stack+949954,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+918670,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+942430,int_stack+918670,int_stack+846400,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1094890,int_stack+942430,int_stack+993514,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1154950,int_stack+1094890,int_stack+867190,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1232170,int_stack+1154950,int_stack+1029550,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+846400,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+984010,int_stack+846400,int_stack+918670,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1323646,int_stack+984010,int_stack+942430,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+873328,int_stack+1323646,int_stack+1094890,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1031530,int_stack+873328,int_stack+1154950,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1392946,int_stack+1031530,int_stack+1232170,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1139638,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1169932,int_stack+1139638,int_stack+846400,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1223788,int_stack+1169932,int_stack+984010,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1514914,int_stack+1223788,int_stack+1323646,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1139638,int_stack+1514914,int_stack+873328,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+846400,int_stack+1139638,int_stack+1031530,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+990544,int_stack+846400,int_stack+1392946,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+846400,int_stack+65868,int_stack+60720,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+861844,int_stack+71952,int_stack+65868,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+880096,int_stack+861844,int_stack+846400,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+910984,int_stack+79050,int_stack+71952,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+932278,int_stack+910984,int_stack+861844,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1147360,int_stack+932278,int_stack+880096,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+846400,int_stack+87240,int_stack+79050,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1198840,int_stack+846400,int_stack+910984,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+870970,int_stack+1198840,int_stack+932278,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1241428,int_stack+870970,int_stack+1147360,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1147360,int_stack+96600,int_stack+87240,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+931810,int_stack+1147360,int_stack+846400,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1318648,int_stack+931810,int_stack+1198840,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1389628,int_stack+1318648,int_stack+870970,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1480888,int_stack+1389628,int_stack+1241428,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+846400,int_stack+107208,int_stack+96600,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1175440,int_stack+846400,int_stack+1147360,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1231600,int_stack+1175440,int_stack+931810,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+878224,int_stack+1231600,int_stack+1318648,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1588996,int_stack+878224,int_stack+1389628,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1313500,int_stack+1588996,int_stack+1480888,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1457644,int_stack+119142,int_stack+107208,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1493446,int_stack+1457644,int_stack+846400,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+1493446,int_stack+1175440,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1457644,int_stack+0,int_stack+1231600,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1147360,int_stack+1457644,int_stack+878224,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1716760,int_stack+1147360,int_stack+1588996,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1457644,int_stack+1716760,int_stack+1313500,78);
 /*--- compute (np|nk) ---*/
 hrr1_build_np(Libint->AB,int_stack+1642972,int_stack+1457644,int_stack+990544,2376);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+138486,int_stack+132480,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+145584,int_stack+138486,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+153865,int_stack+145584,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+846400,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+163420,int_stack+153865,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+906460,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+906460,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+956146,int_stack+28665,int_stack+846400,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+846400,int_stack+174340,int_stack+163420,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+99645,int_stack+846400,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1046236,int_stack+99645,int_stack+906460,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1129046,int_stack+1046236,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1235516,int_stack+1129046,int_stack+956146,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+186716,int_stack+174340,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+879160,int_stack+0,int_stack+846400,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+944680,int_stack+879160,int_stack+99645,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+37128,int_stack+944680,int_stack+1046236,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2113420,int_stack+37128,int_stack+1129046,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1040230,int_stack+2113420,int_stack+1235516,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1208398,int_stack+200639,int_stack+186716,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1250167,int_stack+1208398,int_stack+0,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1324423,int_stack+1250167,int_stack+879160,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2262478,int_stack+1324423,int_stack+944680,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1208398,int_stack+2262478,int_stack+37128,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+1208398,int_stack+2113420,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2113420,int_stack+0,int_stack+1040230,91);
 /*--- compute (op|nk) ---*/
 hrr1_build_op(Libint->AB,int_stack+846400,int_stack+2113420,int_stack+1457644,2376);
 /*--- compute (nd|nk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2329636,int_stack+846400,int_stack+1642972,2376);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+223130,int_stack+216200,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20790,int_stack+231320,int_stack+223130,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+45360,int_stack+20790,int_stack+0,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86940,int_stack+240875,int_stack+231320,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115605,int_stack+86940,int_stack+20790,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+164745,int_stack+115605,int_stack+45360,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+251900,int_stack+240875,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1402384,int_stack+0,int_stack+86940,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+33075,int_stack+1402384,int_stack+115605,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1459714,int_stack+33075,int_stack+164745,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+114975,int_stack+264500,int_stack+251900,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+152775,int_stack+114975,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1563664,int_stack+152775,int_stack+1402384,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1659214,int_stack+1563664,int_stack+33075,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1782064,int_stack+1659214,int_stack+1459714,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1402384,int_stack+278780,int_stack+264500,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1445224,int_stack+1402384,int_stack+114975,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+1445224,int_stack+152775,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+110250,int_stack+0,int_stack+1563664,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1927594,int_stack+110250,int_stack+1659214,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1520824,int_stack+1927594,int_stack+1782064,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1714864,int_stack+294845,int_stack+278780,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1763059,int_stack+1714864,int_stack+1402384,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3270532,int_stack+1763059,int_stack+1445224,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1714864,int_stack+3270532,int_stack+0,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3270532,int_stack+1714864,int_stack+110250,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+3270532,int_stack+1927594,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1714864,int_stack+0,int_stack+1520824,105);
 /*--- compute (qp|nk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+3270532,int_stack+1714864,int_stack+2113420,2376);
 /*--- compute (od|nk) ---*/
 hrr1_build_od(Libint->AB,int_stack+3919180,int_stack+3270532,int_stack+846400,2376);
 /*--- compute (nf|nk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+5031148,int_stack+3919180,int_stack+2329636,2376);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+846400,int_stack+320720,int_stack+312800,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+870160,int_stack+330080,int_stack+320720,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+898240,int_stack+870160,int_stack+846400,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+945760,int_stack+341000,int_stack+330080,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+978520,int_stack+945760,int_stack+870160,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1034680,int_stack+978520,int_stack+898240,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+846400,int_stack+353600,int_stack+341000,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1113880,int_stack+846400,int_stack+945760,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+884200,int_stack+1113880,int_stack+978520,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1179400,int_stack+884200,int_stack+1034680,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+977800,int_stack+368000,int_stack+353600,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1021000,int_stack+977800,int_stack+846400,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1298200,int_stack+1021000,int_stack+1113880,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1407400,int_stack+1298200,int_stack+884200,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1547800,int_stack+1407400,int_stack+1179400,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+846400,int_stack+384320,int_stack+368000,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1096600,int_stack+846400,int_stack+977800,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+1096600,int_stack+1021000,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+895360,int_stack+0,int_stack+1298200,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1183000,int_stack+895360,int_stack+1407400,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+126000,int_stack+1183000,int_stack+1547800,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1379560,int_stack+402680,int_stack+384320,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1434640,int_stack+1379560,int_stack+846400,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1532560,int_stack+1434640,int_stack+1096600,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1964344,int_stack+1532560,int_stack+0,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1379560,int_stack+1964344,int_stack+895360,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1964344,int_stack+1379560,int_stack+1183000,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2226424,int_stack+1964344,int_stack+126000,120);
 /*--- compute (rp|nk) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2511544,int_stack+2226424,int_stack+1714864,2376);
 /*--- compute (qd|nk) ---*/
 hrr1_build_qd(Libint->AB,int_stack+846400,int_stack+2511544,int_stack+3270532,2376);
 /*--- compute (of|nk) ---*/
 hrr1_build_of(Libint->AB,int_stack+6599308,int_stack+846400,int_stack+3919180,2376);
 /*--- compute (ng|nk) ---*/
 hrr1_build_ng(Libint->AB,int_stack+8452588,int_stack+6599308,int_stack+5031148,2376);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3259984,int_stack+432176,int_stack+423200,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3286912,int_stack+442784,int_stack+432176,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+3318736,int_stack+3286912,int_stack+3259984,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3372592,int_stack+455160,int_stack+442784,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3409720,int_stack+3372592,int_stack+3286912,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3473368,int_stack+3409720,int_stack+3318736,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+3259984,int_stack+469440,int_stack+455160,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3563128,int_stack+3259984,int_stack+3372592,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3302824,int_stack+3563128,int_stack+3409720,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3637384,int_stack+3302824,int_stack+3473368,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3408904,int_stack+485760,int_stack+469440,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3457864,int_stack+3408904,int_stack+3259984,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3772024,int_stack+3457864,int_stack+3563128,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3895784,int_stack+3772024,int_stack+3302824,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+4054904,int_stack+3895784,int_stack+3637384,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+3259984,int_stack+504256,int_stack+485760,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+3543544,int_stack+3259984,int_stack+3408904,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4243400,int_stack+3543544,int_stack+3457864,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+3315472,int_stack+4243400,int_stack+3772024,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3641464,int_stack+3315472,int_stack+3895784,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+4386200,int_stack+3641464,int_stack+4054904,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3864232,int_stack+525064,int_stack+504256,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3926656,int_stack+3864232,int_stack+3259984,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+4037632,int_stack+3926656,int_stack+3543544,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4637528,int_stack+4037632,int_stack+4243400,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3864232,int_stack+4637528,int_stack+3315472,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+4637528,int_stack+3864232,int_stack+3641464,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4934552,int_stack+4637528,int_stack+4386200,136);
 /*--- compute (tp|nk) ---*/
 hrr1_build_tp(Libint->AB,int_stack+5257688,int_stack+4934552,int_stack+2226424,2376);
 /*--- compute (rd|nk) ---*/
 hrr1_build_rd(Libint->AB,int_stack+3259984,int_stack+5257688,int_stack+2511544,2376);
 /*--- compute (qf|nk) ---*/
 hrr1_build_qf(Libint->AB,int_stack+10804828,int_stack+3259984,int_stack+846400,2376);
 /*--- compute (og|nk) ---*/
 hrr1_build_og(Libint->AB,int_stack+12966988,int_stack+10804828,int_stack+6599308,2376);
 /*--- compute (nh|nk) ---*/
 hrr1_build_nh(Libint->AB,int_stack+15746908,int_stack+12966988,int_stack+8452588,2376);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+846400,int_stack+558418,int_stack+548320,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+876694,int_stack+570352,int_stack+558418,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+912496,int_stack+876694,int_stack+846400,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+973084,int_stack+584275,int_stack+570352,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1014853,int_stack+973084,int_stack+876694,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1086457,int_stack+1014853,int_stack+912496,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+846400,int_stack+600340,int_stack+584275,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1187437,int_stack+846400,int_stack+973084,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+894595,int_stack+1187437,int_stack+1014853,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1270975,int_stack+894595,int_stack+1086457,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1013935,int_stack+618700,int_stack+600340,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1069015,int_stack+1013935,int_stack+846400,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1422445,int_stack+1069015,int_stack+1187437,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1561675,int_stack+1422445,int_stack+894595,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1740685,int_stack+1561675,int_stack+1270975,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+846400,int_stack+639508,int_stack+618700,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1165405,int_stack+846400,int_stack+1013935,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1952743,int_stack+1165405,int_stack+1069015,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+908824,int_stack+1952743,int_stack+1422445,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1275565,int_stack+908824,int_stack+1561675,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2113393,int_stack+1275565,int_stack+1740685,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1526179,int_stack+662917,int_stack+639508,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1596406,int_stack+1526179,int_stack+846400,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1721254,int_stack+1596406,int_stack+1165405,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2396137,int_stack+1721254,int_stack+1952743,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1526179,int_stack+2396137,int_stack+908824,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2396137,int_stack+1526179,int_stack+1275565,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2730289,int_stack+2396137,int_stack+2113393,153);
 /*--- compute (up|nk) ---*/
 hrr1_build_up(Libint->AB,int_stack+846400,int_stack+2730289,int_stack+4934552,2376);
 /*--- compute (td|nk) ---*/
 hrr1_build_td(Libint->AB,int_stack+6113048,int_stack+846400,int_stack+5257688,2376);
 /*--- compute (rf|nk) ---*/
 hrr1_build_rf(Libint->AB,int_stack+7823768,int_stack+6113048,int_stack+3259984,2376);
 /*--- compute (qg|nk) ---*/
 hrr1_build_qg(Libint->AB,int_stack+19040044,int_stack+7823768,int_stack+10804828,2376);
 /*--- compute (oh|nk) ---*/
 hrr1_build_oh(Libint->AB,int_stack+22283284,int_stack+19040044,int_stack+12966988,2376);
 /*--- compute (ni|nk) ---*/
 hrr1_build_ni(Libint->AB,int_stack+10318568,int_stack+22283284,int_stack+15746908,2376);
 /*--- compute (w0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3093817,int_stack+700366,int_stack+689080,171);
 /*--- compute (w0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3127675,int_stack+713704,int_stack+700366,171);
 /*--- compute (w0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+3167689,int_stack+3127675,int_stack+3093817,171);
 /*--- compute (w0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3235405,int_stack+729265,int_stack+713704,171);
 /*--- compute (w0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3282088,int_stack+3235405,int_stack+3127675,171);
 /*--- compute (w0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3362116,int_stack+3282088,int_stack+3167689,171);
 /*--- compute (w0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+3093817,int_stack+747220,int_stack+729265,171);
 /*--- compute (w0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3474976,int_stack+3093817,int_stack+3235405,171);
 /*--- compute (w0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3147682,int_stack+3474976,int_stack+3282088,171);
 /*--- compute (w0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3568342,int_stack+3147682,int_stack+3362116,171);
 /*--- compute (w0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3281062,int_stack+767740,int_stack+747220,171);
 /*--- compute (w0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3342622,int_stack+3281062,int_stack+3093817,171);
 /*--- compute (w0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3737632,int_stack+3342622,int_stack+3474976,171);
 /*--- compute (w0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3893242,int_stack+3737632,int_stack+3147682,171);
 /*--- compute (w0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+4093312,int_stack+3893242,int_stack+3568342,171);
 /*--- compute (w0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+3093817,int_stack+790996,int_stack+767740,171);
 /*--- compute (w0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+3450352,int_stack+3093817,int_stack+3281062,171);
 /*--- compute (w0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4330318,int_stack+3450352,int_stack+3342622,171);
 /*--- compute (w0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+3163585,int_stack+4330318,int_stack+3737632,171);
 /*--- compute (w0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3573472,int_stack+3163585,int_stack+3893242,171);
 /*--- compute (w0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+4509868,int_stack+3573472,int_stack+4093312,171);
 /*--- compute (w0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3853570,int_stack+817159,int_stack+790996,171);
 /*--- compute (w0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3932059,int_stack+3853570,int_stack+3093817,171);
 /*--- compute (w0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+4071595,int_stack+3932059,int_stack+3450352,171);
 /*--- compute (w0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4825876,int_stack+4071595,int_stack+4330318,171);
 /*--- compute (w0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3853570,int_stack+4825876,int_stack+3163585,171);
 /*--- compute (w0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+4825876,int_stack+3853570,int_stack+3573472,171);
 /*--- compute (w0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+5199340,int_stack+4825876,int_stack+4509868,171);
 /*--- compute (vp|nk) ---*/
 hrr1_build_vp(Libint->AB,int_stack+3093817,int_stack+5199340,int_stack+2730289,2376);
 /*--- compute (ud|nk) ---*/
 hrr1_build_ud(Libint->AB,int_stack+14709416,int_stack+3093817,int_stack+846400,2376);
 /*--- compute (tf|nk) ---*/
 hrr1_build_tf(Libint->AB,int_stack+0,int_stack+14709416,int_stack+6113048,2376);
 /*--- compute (rg|nk) ---*/
 hrr1_build_rg(Libint->AB,int_stack+14709416,int_stack+0,int_stack+7823768,2376);
 /*--- compute (qh|nk) ---*/
 hrr1_build_qh(Libint->AB,int_stack+0,int_stack+14709416,int_stack+19040044,2376);
 /*--- compute (oi|nk) ---*/
 hrr1_build_oi(Libint->AB,int_stack+14709416,int_stack+0,int_stack+22283284,2376);
 /*--- compute (nk|nk) ---*/
 hrr1_build_nk(Libint->AB,int_stack+0,int_stack+14709416,int_stack+10318568,2376);
 return int_stack+0;}
