/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nknn(Libint_t*, prim_data*);

  /* Computes quartets of (nk|nn) integrals */

REALTYPE *hrr_order_nknn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[10][18] = int_stack + 60720;
 Libint->vrr_classes[10][19] = int_stack + 73260;
 Libint->vrr_classes[10][20] = int_stack + 87120;
 Libint->vrr_classes[11][10] = int_stack + 102366;
 Libint->vrr_classes[11][11] = int_stack + 107514;
 Libint->vrr_classes[11][12] = int_stack + 113598;
 Libint->vrr_classes[11][13] = int_stack + 120696;
 Libint->vrr_classes[11][14] = int_stack + 128886;
 Libint->vrr_classes[11][15] = int_stack + 138246;
 Libint->vrr_classes[11][16] = int_stack + 148854;
 Libint->vrr_classes[11][17] = int_stack + 160788;
 Libint->vrr_classes[11][18] = int_stack + 174126;
 Libint->vrr_classes[11][19] = int_stack + 188946;
 Libint->vrr_classes[11][20] = int_stack + 205326;
 Libint->vrr_classes[12][10] = int_stack + 223344;
 Libint->vrr_classes[12][11] = int_stack + 229350;
 Libint->vrr_classes[12][12] = int_stack + 236448;
 Libint->vrr_classes[12][13] = int_stack + 244729;
 Libint->vrr_classes[12][14] = int_stack + 254284;
 Libint->vrr_classes[12][15] = int_stack + 265204;
 Libint->vrr_classes[12][16] = int_stack + 277580;
 Libint->vrr_classes[12][17] = int_stack + 291503;
 Libint->vrr_classes[12][18] = int_stack + 307064;
 Libint->vrr_classes[12][19] = int_stack + 324354;
 Libint->vrr_classes[12][20] = int_stack + 343464;
 Libint->vrr_classes[13][10] = int_stack + 364485;
 Libint->vrr_classes[13][11] = int_stack + 371415;
 Libint->vrr_classes[13][12] = int_stack + 379605;
 Libint->vrr_classes[13][13] = int_stack + 389160;
 Libint->vrr_classes[13][14] = int_stack + 400185;
 Libint->vrr_classes[13][15] = int_stack + 412785;
 Libint->vrr_classes[13][16] = int_stack + 427065;
 Libint->vrr_classes[13][17] = int_stack + 443130;
 Libint->vrr_classes[13][18] = int_stack + 461085;
 Libint->vrr_classes[13][19] = int_stack + 481035;
 Libint->vrr_classes[13][20] = int_stack + 503085;
 Libint->vrr_classes[14][10] = int_stack + 527340;
 Libint->vrr_classes[14][11] = int_stack + 535260;
 Libint->vrr_classes[14][12] = int_stack + 544620;
 Libint->vrr_classes[14][13] = int_stack + 555540;
 Libint->vrr_classes[14][14] = int_stack + 568140;
 Libint->vrr_classes[14][15] = int_stack + 582540;
 Libint->vrr_classes[14][16] = int_stack + 598860;
 Libint->vrr_classes[14][17] = int_stack + 617220;
 Libint->vrr_classes[14][18] = int_stack + 637740;
 Libint->vrr_classes[14][19] = int_stack + 660540;
 Libint->vrr_classes[14][20] = int_stack + 685740;
 Libint->vrr_classes[15][10] = int_stack + 713460;
 Libint->vrr_classes[15][11] = int_stack + 722436;
 Libint->vrr_classes[15][12] = int_stack + 733044;
 Libint->vrr_classes[15][13] = int_stack + 745420;
 Libint->vrr_classes[15][14] = int_stack + 759700;
 Libint->vrr_classes[15][15] = int_stack + 776020;
 Libint->vrr_classes[15][16] = int_stack + 794516;
 Libint->vrr_classes[15][17] = int_stack + 815324;
 Libint->vrr_classes[15][18] = int_stack + 838580;
 Libint->vrr_classes[15][19] = int_stack + 864420;
 Libint->vrr_classes[15][20] = int_stack + 892980;
 Libint->vrr_classes[16][10] = int_stack + 924396;
 Libint->vrr_classes[16][11] = int_stack + 934494;
 Libint->vrr_classes[16][12] = int_stack + 946428;
 Libint->vrr_classes[16][13] = int_stack + 960351;
 Libint->vrr_classes[16][14] = int_stack + 976416;
 Libint->vrr_classes[16][15] = int_stack + 994776;
 Libint->vrr_classes[16][16] = int_stack + 1015584;
 Libint->vrr_classes[16][17] = int_stack + 1038993;
 Libint->vrr_classes[16][18] = int_stack + 1065156;
 Libint->vrr_classes[16][19] = int_stack + 1094226;
 Libint->vrr_classes[16][20] = int_stack + 1126356;
 Libint->vrr_classes[17][10] = int_stack + 1161699;
 Libint->vrr_classes[17][11] = int_stack + 1172985;
 Libint->vrr_classes[17][12] = int_stack + 1186323;
 Libint->vrr_classes[17][13] = int_stack + 1201884;
 Libint->vrr_classes[17][14] = int_stack + 1219839;
 Libint->vrr_classes[17][15] = int_stack + 1240359;
 Libint->vrr_classes[17][16] = int_stack + 1263615;
 Libint->vrr_classes[17][17] = int_stack + 1289778;
 Libint->vrr_classes[17][18] = int_stack + 1319019;
 Libint->vrr_classes[17][19] = int_stack + 1351509;
 Libint->vrr_classes[17][20] = int_stack + 1387419;
 memset(int_stack,0,1426920*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1426920;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nknn(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1426920,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1439988,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1455432,int_stack+1439988,int_stack+1426920,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1481568,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1499586,int_stack+1481568,int_stack+1439988,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1530474,int_stack+1499586,int_stack+1455432,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1426920,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1574034,int_stack+1426920,int_stack+1481568,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1447710,int_stack+1574034,int_stack+1499586,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1610070,int_stack+1447710,int_stack+1530474,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1499190,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1522950,int_stack+1499190,int_stack+1426920,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1675410,int_stack+1522950,int_stack+1574034,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1735470,int_stack+1675410,int_stack+1447710,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1812690,int_stack+1735470,int_stack+1610070,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1426920,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1564530,int_stack+1426920,int_stack+1499190,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1904166,int_stack+1564530,int_stack+1522950,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1453848,int_stack+1904166,int_stack+1675410,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1612050,int_stack+1453848,int_stack+1735470,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1973466,int_stack+1612050,int_stack+1812690,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1720158,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1750452,int_stack+1720158,int_stack+1426920,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1804308,int_stack+1750452,int_stack+1564530,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2095434,int_stack+1804308,int_stack+1904166,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2199384,int_stack+2095434,int_stack+1453848,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1426920,int_stack+2199384,int_stack+1612050,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2325510,int_stack+1426920,int_stack+1973466,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1571064,int_stack+60720,int_stack+49434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1604922,int_stack+1571064,int_stack+1720158,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1883508,int_stack+1604922,int_stack+1750452,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1665510,int_stack+1883508,int_stack+1804308,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2482326,int_stack+1665510,int_stack+2095434,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1973268,int_stack+2482326,int_stack+2199384,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2627856,int_stack+1973268,int_stack+1426920,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2813184,int_stack+2627856,int_stack+2325510,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1426920,int_stack+73260,int_stack+60720,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1464540,int_stack+1426920,int_stack+1571064,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2141436,int_stack+1464540,int_stack+1604922,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2242416,int_stack+2141436,int_stack+1883508,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1784310,int_stack+2242416,int_stack+1665510,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1532256,int_stack+1784310,int_stack+2482326,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2377056,int_stack+1532256,int_stack+1973268,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3009204,int_stack+2377056,int_stack+2627856,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+3240864,int_stack+3009204,int_stack+2813184,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1726296,int_stack+87120,int_stack+73260,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1950630,int_stack+1726296,int_stack+1426920,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+2025870,int_stack+1950630,int_stack+1464540,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2593272,int_stack+2025870,int_stack+2141436,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1950630,int_stack+2593272,int_stack+2242416,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+2593272,int_stack+1950630,int_stack+1784310,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1726296,int_stack+2593272,int_stack+1532256,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2593272,int_stack+1726296,int_stack+2377056,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1426920,int_stack+2593272,int_stack+3009204,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1710060,int_stack+1426920,int_stack+3240864,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1426920,int_stack+107514,int_stack+102366,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1442364,int_stack+113598,int_stack+107514,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1460616,int_stack+1442364,int_stack+1426920,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1491504,int_stack+120696,int_stack+113598,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1512798,int_stack+1491504,int_stack+1442364,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1549302,int_stack+1512798,int_stack+1460616,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1426920,int_stack+128886,int_stack+120696,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1600782,int_stack+1426920,int_stack+1491504,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1451490,int_stack+1600782,int_stack+1512798,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1997556,int_stack+1451490,int_stack+1549302,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1512330,int_stack+138246,int_stack+128886,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1540410,int_stack+1512330,int_stack+1426920,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2074776,int_stack+1540410,int_stack+1600782,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1589550,int_stack+2074776,int_stack+1451490,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2145756,int_stack+1589550,int_stack+1997556,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1997556,int_stack+148854,int_stack+138246,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1426920,int_stack+1997556,int_stack+1512330,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2253864,int_stack+1426920,int_stack+1540410,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1483080,int_stack+2253864,int_stack+2074776,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2335764,int_stack+1483080,int_stack+1589550,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2463528,int_stack+2335764,int_stack+2145756,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1589550,int_stack+160788,int_stack+148854,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1625352,int_stack+1589550,int_stack+1997556,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1997556,int_stack+1625352,int_stack+1426920,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2091156,int_stack+1997556,int_stack+2253864,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2607672,int_stack+2091156,int_stack+1483080,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2756730,int_stack+2607672,int_stack+2335764,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2214006,int_stack+2756730,int_stack+2463528,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1426920,int_stack+174126,int_stack+160788,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1466934,int_stack+1426920,int_stack+1589550,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2399334,int_stack+1466934,int_stack+1625352,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1538538,int_stack+2399334,int_stack+1997556,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2927082,int_stack+1538538,int_stack+2091156,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1997556,int_stack+2927082,int_stack+2607672,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2505414,int_stack+1997556,int_stack+2756730,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3099072,int_stack+2505414,int_stack+2214006,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+2196300,int_stack+188946,int_stack+174126,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+2240760,int_stack+2196300,int_stack+1426920,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2724438,int_stack+2240760,int_stack+1466934,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+2724438,int_stack+2399334,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3330732,int_stack+0,int_stack+1538538,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1426920,int_stack+3330732,int_stack+2927082,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3527292,int_stack+1426920,int_stack+1997556,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3782820,int_stack+3527292,int_stack+2505414,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2320788,int_stack+3782820,int_stack+3099072,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1997556,int_stack+205326,int_stack+188946,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+2046696,int_stack+1997556,int_stack+2196300,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+2843778,int_stack+2046696,int_stack+2240760,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1997556,int_stack+2843778,int_stack+2724438,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+2603928,int_stack+1997556,int_stack+0,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1997556,int_stack+2603928,int_stack+3330732,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+2603928,int_stack+1997556,int_stack+1426920,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1997556,int_stack+2603928,int_stack+3527292,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2603928,int_stack+1997556,int_stack+3782820,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2938548,int_stack+2603928,int_stack+2320788,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+1997556,int_stack+2938548,int_stack+1710060,4356);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2860044,int_stack+229350,int_stack+223344,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2878062,int_stack+236448,int_stack+229350,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2899356,int_stack+2878062,int_stack+2860044,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3278316,int_stack+244729,int_stack+236448,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3303159,int_stack+3278316,int_stack+2878062,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3345747,int_stack+3303159,int_stack+2899356,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2860044,int_stack+254284,int_stack+244729,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2888709,int_stack+2860044,int_stack+3278316,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3405807,int_stack+2888709,int_stack+3303159,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3476787,int_stack+3405807,int_stack+3345747,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3278316,int_stack+265204,int_stack+254284,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3311076,int_stack+3278316,int_stack+2860044,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3566877,int_stack+3311076,int_stack+2888709,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3649687,int_stack+3566877,int_stack+3405807,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3756157,int_stack+3649687,int_stack+3476787,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2860044,int_stack+277580,int_stack+265204,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+3368406,int_stack+2860044,int_stack+3278316,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3433926,int_stack+3368406,int_stack+3311076,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+3882283,int_stack+3433926,int_stack+3566877,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1426920,int_stack+3882283,int_stack+3649687,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3529476,int_stack+1426920,int_stack+3756157,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3278316,int_stack+291503,int_stack+277580,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3697644,int_stack+3278316,int_stack+2860044,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3771900,int_stack+3697644,int_stack+3368406,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1575978,int_stack+3771900,int_stack+3433926,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3320085,int_stack+1575978,int_stack+3882283,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1719303,int_stack+3320085,int_stack+1426920,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1719303,int_stack+3529476,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1426920,int_stack+307064,int_stack+291503,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1473603,int_stack+1426920,int_stack+3278316,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3493986,int_stack+1473603,int_stack+3697644,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3881100,int_stack+3493986,int_stack+3771900,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3617746,int_stack+3881100,int_stack+1575978,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+4044900,int_stack+3617746,int_stack+3320085,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4276768,int_stack+4044900,int_stack+1719303,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1557141,int_stack+4276768,int_stack+0,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+324354,int_stack+307064,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+51870,int_stack+0,int_stack+1426920,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+145236,int_stack+51870,int_stack+1473603,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+3278316,int_stack+145236,int_stack+3493986,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+4532296,int_stack+3278316,int_stack+3881100,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+4761616,int_stack+4532296,int_stack+3617746,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3463956,int_stack+4761616,int_stack+4044900,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3762072,int_stack+3463956,int_stack+4276768,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+4081482,int_stack+3762072,int_stack+1557141,91);
 /*--- compute (q0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1426920,int_stack+343464,int_stack+324354,91);
 /*--- compute (q0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1484250,int_stack+1426920,int_stack+0,91);
 /*--- compute (q0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1587990,int_stack+1484250,int_stack+51870,91);
 /*--- compute (q0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1743600,int_stack+1587990,int_stack+145236,91);
 /*--- compute (q0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+1743600,int_stack+3278316,91);
 /*--- compute (q0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1426920,int_stack+0,int_stack+4532296,91);
 /*--- compute (q0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+1426920,int_stack+4761616,91);
 /*--- compute (q0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1426920,int_stack+0,int_stack+3463956,91);
 /*--- compute (q0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+3278316,int_stack+1426920,int_stack+3762072,91);
 /*--- compute (q0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1426920,int_stack+3278316,int_stack+4081482,91);
 /*--- compute (op|nn) ---*/
 hrr1_build_op(Libint->AB,int_stack+3278316,int_stack+1426920,int_stack+2938548,4356);
 /*--- compute (nd|nn) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4297620,int_stack+3278316,int_stack+1997556,4356);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1823316,int_stack+371415,int_stack+364485,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1844106,int_stack+379605,int_stack+371415,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1868676,int_stack+1844106,int_stack+1823316,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1910256,int_stack+389160,int_stack+379605,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1938921,int_stack+1910256,int_stack+1844106,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1988061,int_stack+1938921,int_stack+1868676,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1823316,int_stack+400185,int_stack+389160,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2057361,int_stack+1823316,int_stack+1910256,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1856391,int_stack+2057361,int_stack+1938921,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2114691,int_stack+1856391,int_stack+1988061,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1938291,int_stack+412785,int_stack+400185,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1976091,int_stack+1938291,int_stack+1823316,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2218641,int_stack+1976091,int_stack+2057361,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2314191,int_stack+2218641,int_stack+1856391,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2437041,int_stack+2314191,int_stack+2114691,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1823316,int_stack+427065,int_stack+412785,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2042241,int_stack+1823316,int_stack+1938291,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2582571,int_stack+2042241,int_stack+1976091,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1866156,int_stack+2582571,int_stack+2218641,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2117841,int_stack+1866156,int_stack+2314191,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2692821,int_stack+2117841,int_stack+2437041,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2289831,int_stack+443130,int_stack+427065,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2338026,int_stack+2289831,int_stack+1823316,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2423706,int_stack+2338026,int_stack+2042241,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2886861,int_stack+2423706,int_stack+2582571,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3052236,int_stack+2886861,int_stack+1866156,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1823316,int_stack+3052236,int_stack+2117841,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1823316,int_stack+2692821,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2052636,int_stack+461085,int_stack+443130,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2106501,int_stack+2052636,int_stack+2289831,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2549706,int_stack+2106501,int_stack+2338026,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2202891,int_stack+2549706,int_stack+2423706,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+6022596,int_stack+2202891,int_stack+2886861,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2692506,int_stack+6022596,int_stack+3052236,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2960046,int_stack+2692506,int_stack+1823316,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+6254121,int_stack+2960046,int_stack+0,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+481035,int_stack+461085,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+59850,int_stack+0,int_stack+2052636,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+167580,int_stack+59850,int_stack+2106501,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1823316,int_stack+167580,int_stack+2549706,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2391891,int_stack+1823316,int_stack+2202891,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2037516,int_stack+2391891,int_stack+6022596,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+6565971,int_stack+2037516,int_stack+2692506,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+6909951,int_stack+6565971,int_stack+2960046,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2656491,int_stack+6909951,int_stack+6254121,105);
 /*--- compute (r0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+6022596,int_stack+503085,int_stack+481035,105);
 /*--- compute (r0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+6088746,int_stack+6022596,int_stack+0,105);
 /*--- compute (r0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+6208446,int_stack+6088746,int_stack+59850,105);
 /*--- compute (r0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+7278501,int_stack+6208446,int_stack+167580,105);
 /*--- compute (r0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+7278501,int_stack+1823316,105);
 /*--- compute (r0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+6022596,int_stack+0,int_stack+2391891,105);
 /*--- compute (r0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+6022596,int_stack+2037516,105);
 /*--- compute (r0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+6022596,int_stack+0,int_stack+6565971,105);
 /*--- compute (r0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+6022596,int_stack+6909951,105);
 /*--- compute (r0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+6022596,int_stack+0,int_stack+2656491,105);
 /*--- compute (qp|nn) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1823316,int_stack+6022596,int_stack+1426920,4356);
 /*--- compute (od|nn) ---*/
 hrr1_build_od(Libint->AB,int_stack+6479976,int_stack+1823316,int_stack+3278316,4356);
 /*--- compute (nf|nn) ---*/
 hrr1_build_nf(Libint->AB,int_stack+8518584,int_stack+6479976,int_stack+4297620,4356);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1426920,int_stack+535260,int_stack+527340,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1450680,int_stack+544620,int_stack+535260,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1478760,int_stack+1450680,int_stack+1426920,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1526280,int_stack+555540,int_stack+544620,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1559040,int_stack+1526280,int_stack+1450680,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1615200,int_stack+1559040,int_stack+1478760,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1426920,int_stack+568140,int_stack+555540,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1694400,int_stack+1426920,int_stack+1526280,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1464720,int_stack+1694400,int_stack+1559040,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+1464720,int_stack+1615200,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1558320,int_stack+582540,int_stack+568140,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1601520,int_stack+1558320,int_stack+1426920,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+118800,int_stack+1601520,int_stack+1694400,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1677120,int_stack+118800,int_stack+1464720,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+228000,int_stack+1677120,int_stack+0,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+598860,int_stack+582540,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1426920,int_stack+0,int_stack+1558320,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+394320,int_stack+1426920,int_stack+1601520,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1513320,int_stack+394320,int_stack+118800,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3012504,int_stack+1513320,int_stack+1677120,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3209064,int_stack+3012504,int_stack+228000,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1677120,int_stack+617220,int_stack+598860,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+48960,int_stack+1677120,int_stack+0,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+146880,int_stack+48960,int_stack+1426920,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3430824,int_stack+146880,int_stack+394320,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+290880,int_stack+3430824,int_stack+1513320,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3619824,int_stack+290880,int_stack+3012504,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3881904,int_stack+3619824,int_stack+3209064,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+3012504,int_stack+637740,int_stack+617220,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+3074064,int_stack+3012504,int_stack+1677120,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3184224,int_stack+3074064,int_stack+48960,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1426920,int_stack+3184224,int_stack+146880,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+1426920,int_stack+3430824,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+4167024,int_stack+0,int_stack+290880,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+264600,int_stack+4167024,int_stack+3619824,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3347424,int_stack+264600,int_stack+3881904,120);
 /*--- compute (t0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+3703824,int_stack+660540,int_stack+637740,120);
 /*--- compute (t0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+3772224,int_stack+3703824,int_stack+3012504,120);
 /*--- compute (t0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+3895344,int_stack+3772224,int_stack+3074064,120);
 /*--- compute (t0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+4472784,int_stack+3895344,int_stack+3184224,120);
 /*--- compute (t0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3012504,int_stack+4472784,int_stack+1426920,120);
 /*--- compute (t0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1426920,int_stack+3012504,int_stack+0,120);
 /*--- compute (t0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+4717584,int_stack+1426920,int_stack+4167024,120);
 /*--- compute (t0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+5110704,int_stack+4717584,int_stack+264600,120);
 /*--- compute (t0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+5110704,int_stack+3347424,120);
 /*--- compute (t0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+435600,int_stack+685740,int_stack+660540,120);
 /*--- compute (t0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+511200,int_stack+435600,int_stack+3703824,120);
 /*--- compute (t0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+3314904,int_stack+511200,int_stack+3772224,120);
 /*--- compute (t0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+435600,int_stack+3314904,int_stack+3895344,120);
 /*--- compute (t0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+3314904,int_stack+435600,int_stack+4472784,120);
 /*--- compute (t0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+3657624,int_stack+3314904,int_stack+3012504,120);
 /*--- compute (t0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+3012504,int_stack+3657624,int_stack+1426920,120);
 /*--- compute (t0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+3466104,int_stack+3012504,int_stack+4717584,120);
 /*--- compute (t0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+3957504,int_stack+3466104,int_stack+5110704,120);
 /*--- compute (t0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+3012504,int_stack+3957504,int_stack+0,120);
 /*--- compute (rp|nn) ---*/
 hrr1_build_rp(Libint->AB,int_stack+3535224,int_stack+3012504,int_stack+6022596,4356);
 /*--- compute (qd|nn) ---*/
 hrr1_build_qd(Libint->AB,int_stack+11393544,int_stack+3535224,int_stack+1823316,4356);
 /*--- compute (of|nn) ---*/
 hrr1_build_of(Libint->AB,int_stack+13771920,int_stack+11393544,int_stack+6479976,4356);
 /*--- compute (ng|nn) ---*/
 hrr1_build_ng(Libint->AB,int_stack+17169600,int_stack+13771920,int_stack+8518584,4356);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+722436,int_stack+713460,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+26928,int_stack+733044,int_stack+722436,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+58752,int_stack+26928,int_stack+0,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+112608,int_stack+745420,int_stack+733044,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+149736,int_stack+112608,int_stack+26928,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+213384,int_stack+149736,int_stack+58752,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+759700,int_stack+745420,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+303144,int_stack+0,int_stack+112608,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+42840,int_stack+303144,int_stack+149736,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+377400,int_stack+42840,int_stack+213384,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+148920,int_stack+776020,int_stack+759700,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+197880,int_stack+148920,int_stack+0,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+512040,int_stack+197880,int_stack+303144,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+4907364,int_stack+512040,int_stack+42840,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+5066484,int_stack+4907364,int_stack+377400,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+794516,int_stack+776020,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+283560,int_stack+0,int_stack+148920,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+635800,int_stack+283560,int_stack+197880,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+55488,int_stack+635800,int_stack+512040,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+381480,int_stack+55488,int_stack+4907364,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+5254980,int_stack+381480,int_stack+5066484,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+4907364,int_stack+815324,int_stack+794516,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+4969788,int_stack+4907364,int_stack+0,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+5080764,int_stack+4969788,int_stack+283560,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+5506308,int_stack+5080764,int_stack+635800,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+5720508,int_stack+5506308,int_stack+55488,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+5720508,int_stack+381480,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+297024,int_stack+0,int_stack+5254980,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+620160,int_stack+838580,int_stack+815324,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+689928,int_stack+620160,int_stack+4907364,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+5243964,int_stack+689928,int_stack+4969788,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+5980404,int_stack+5243964,int_stack+5080764,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4907364,int_stack+5980404,int_stack+5506308,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+6225204,int_stack+4907364,int_stack+5720508,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+5428924,int_stack+6225204,int_stack+0,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+6571732,int_stack+5428924,int_stack+297024,136);
 /*--- compute (u0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+864420,int_stack+838580,136);
 /*--- compute (u0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+77520,int_stack+0,int_stack+620160,136);
 /*--- compute (u0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+217056,int_stack+77520,int_stack+689928,136);
 /*--- compute (u0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+425136,int_stack+217056,int_stack+5243964,136);
 /*--- compute (u0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+6975652,int_stack+425136,int_stack+5980404,136);
 /*--- compute (u0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+5810812,int_stack+6975652,int_stack+4907364,136);
 /*--- compute (u0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+4907364,int_stack+5810812,int_stack+6225204,136);
 /*--- compute (u0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+7318372,int_stack+4907364,int_stack+5428924,136);
 /*--- compute (u0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+7795732,int_stack+7318372,int_stack+6571732,136);
 /*--- compute (u0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+5352900,int_stack+892980,int_stack+864420,136);
 /*--- compute (u0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+5438580,int_stack+5352900,int_stack+0,136);
 /*--- compute (u0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+6210652,int_stack+5438580,int_stack+77520,136);
 /*--- compute (u0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+5352900,int_stack+6210652,int_stack+217056,136);
 /*--- compute (u0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+6210652,int_stack+5352900,int_stack+425136,136);
 /*--- compute (u0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+5352900,int_stack+6210652,int_stack+6975652,136);
 /*--- compute (u0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+6210652,int_stack+5352900,int_stack+5810812,136);
 /*--- compute (u0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+5352900,int_stack+6210652,int_stack+4907364,136);
 /*--- compute (u0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+5909820,int_stack+5352900,int_stack+7318372,136);
 /*--- compute (u0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+4907364,int_stack+5909820,int_stack+7795732,136);
 /*--- compute (tp|nn) ---*/
 hrr1_build_tp(Libint->AB,int_stack+5499780,int_stack+4907364,int_stack+3012504,4356);
 /*--- compute (rd|nn) ---*/
 hrr1_build_rd(Libint->AB,int_stack+7067940,int_stack+5499780,int_stack+3535224,4356);
 /*--- compute (qf|nn) ---*/
 hrr1_build_qf(Libint->AB,int_stack+21482040,int_stack+7067940,int_stack+11393544,4356);
 /*--- compute (og|nn) ---*/
 hrr1_build_og(Libint->AB,int_stack+25446000,int_stack+21482040,int_stack+13771920,4356);
 /*--- compute (nh|nn) ---*/
 hrr1_build_nh(Libint->AB,int_stack+9812220,int_stack+25446000,int_stack+17169600,4356);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15849636,int_stack+934494,int_stack+924396,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15879930,int_stack+946428,int_stack+934494,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+15915732,int_stack+15879930,int_stack+15849636,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+15976320,int_stack+960351,int_stack+946428,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+16018089,int_stack+15976320,int_stack+15879930,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+16089693,int_stack+16018089,int_stack+15915732,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+15849636,int_stack+976416,int_stack+960351,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+16190673,int_stack+15849636,int_stack+15976320,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+15897831,int_stack+16190673,int_stack+16018089,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+16274211,int_stack+15897831,int_stack+16089693,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+16017171,int_stack+994776,int_stack+976416,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+16072251,int_stack+16017171,int_stack+15849636,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+16425681,int_stack+16072251,int_stack+16190673,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+16564911,int_stack+16425681,int_stack+15897831,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+16743921,int_stack+16564911,int_stack+16274211,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+15849636,int_stack+1015584,int_stack+994776,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+16168641,int_stack+15849636,int_stack+16017171,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+16955979,int_stack+16168641,int_stack+16072251,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+15912060,int_stack+16955979,int_stack+16425681,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+16278801,int_stack+15912060,int_stack+16564911,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+17116629,int_stack+16278801,int_stack+16743921,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+16529415,int_stack+1038993,int_stack+1015584,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+16599642,int_stack+16529415,int_stack+15849636,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+16724490,int_stack+16599642,int_stack+16168641,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+17399373,int_stack+16724490,int_stack+16955979,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+17640348,int_stack+17399373,int_stack+15912060,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+15849636,int_stack+17640348,int_stack+16278801,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+17932731,int_stack+15849636,int_stack+17116629,153);
 /*--- compute (v0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+16183788,int_stack+1065156,int_stack+1038993,153);
 /*--- compute (v0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+16262277,int_stack+16183788,int_stack+16529415,153);
 /*--- compute (v0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+16908090,int_stack+16262277,int_stack+16599642,153);
 /*--- compute (v0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+16402731,int_stack+16908090,int_stack+16724490,153);
 /*--- compute (v0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+18296259,int_stack+16402731,int_stack+17399373,153);
 /*--- compute (v0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+17116170,int_stack+18296259,int_stack+17640348,153);
 /*--- compute (v0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+18633624,int_stack+17116170,int_stack+15849636,153);
 /*--- compute (v0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+19063248,int_stack+18633624,int_stack+17932731,153);
 /*--- compute (v0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+15849636,int_stack+1094226,int_stack+1065156,153);
 /*--- compute (v0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+15936846,int_stack+15849636,int_stack+16183788,153);
 /*--- compute (v0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+17506014,int_stack+15936846,int_stack+16262277,153);
 /*--- compute (v0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+17740104,int_stack+17506014,int_stack+16908090,153);
 /*--- compute (v0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+16678131,int_stack+17740104,int_stack+16402731,153);
 /*--- compute (v0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+16093824,int_stack+16678131,int_stack+18296259,153);
 /*--- compute (v0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+18052224,int_stack+16093824,int_stack+17116170,153);
 /*--- compute (v0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+19517658,int_stack+18052224,int_stack+18633624,153);
 /*--- compute (v0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+20054688,int_stack+19517658,int_stack+19063248,153);
 /*--- compute (v0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+16543644,int_stack+1126356,int_stack+1094226,153);
 /*--- compute (v0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+17063691,int_stack+16543644,int_stack+15849636,153);
 /*--- compute (v0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+17238111,int_stack+17063691,int_stack+15936846,153);
 /*--- compute (v0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+18553452,int_stack+17238111,int_stack+17506014,153);
 /*--- compute (v0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+17063691,int_stack+18553452,int_stack+17740104,153);
 /*--- compute (v0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+18553452,int_stack+17063691,int_stack+16678131,153);
 /*--- compute (v0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+16543644,int_stack+18553452,int_stack+16093824,153);
 /*--- compute (v0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+18553452,int_stack+16543644,int_stack+18052224,153);
 /*--- compute (v0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+15849636,int_stack+18553452,int_stack+19517658,153);
 /*--- compute (v0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+16506006,int_stack+15849636,int_stack+20054688,153);
 /*--- compute (up|nn) ---*/
 hrr1_build_up(Libint->AB,int_stack+17172474,int_stack+16506006,int_stack+4907364,4356);
 /*--- compute (td|nn) ---*/
 hrr1_build_td(Libint->AB,int_stack+1426920,int_stack+17172474,int_stack+5499780,4356);
 /*--- compute (rf|nn) ---*/
 hrr1_build_rf(Libint->AB,int_stack+30542520,int_stack+1426920,int_stack+7067940,4356);
 /*--- compute (qg|nn) ---*/
 hrr1_build_qg(Libint->AB,int_stack+35116320,int_stack+30542520,int_stack+21482040,4356);
 /*--- compute (oh|nn) ---*/
 hrr1_build_oh(Libint->AB,int_stack+41062260,int_stack+35116320,int_stack+25446000,4356);
 /*--- compute (ni|nn) ---*/
 hrr1_build_ni(Libint->AB,int_stack+18949722,int_stack+41062260,int_stack+9812220,4356);
 /*--- compute (w0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+26999610,int_stack+1172985,int_stack+1161699,171);
 /*--- compute (w0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+27033468,int_stack+1186323,int_stack+1172985,171);
 /*--- compute (w0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+27073482,int_stack+27033468,int_stack+26999610,171);
 /*--- compute (w0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+27141198,int_stack+1201884,int_stack+1186323,171);
 /*--- compute (w0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+27187881,int_stack+27141198,int_stack+27033468,171);
 /*--- compute (w0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+27267909,int_stack+27187881,int_stack+27073482,171);
 /*--- compute (w0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+26999610,int_stack+1219839,int_stack+1201884,171);
 /*--- compute (w0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+27380769,int_stack+26999610,int_stack+27141198,171);
 /*--- compute (w0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+27053475,int_stack+27380769,int_stack+27187881,171);
 /*--- compute (w0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+27474135,int_stack+27053475,int_stack+27267909,171);
 /*--- compute (w0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+27186855,int_stack+1240359,int_stack+1219839,171);
 /*--- compute (w0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+27248415,int_stack+27186855,int_stack+26999610,171);
 /*--- compute (w0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+27643425,int_stack+27248415,int_stack+27380769,171);
 /*--- compute (w0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+27799035,int_stack+27643425,int_stack+27053475,171);
 /*--- compute (w0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+27999105,int_stack+27799035,int_stack+27474135,171);
 /*--- compute (w0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+26999610,int_stack+1263615,int_stack+1240359,171);
 /*--- compute (w0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+27356145,int_stack+26999610,int_stack+27186855,171);
 /*--- compute (w0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+28236111,int_stack+27356145,int_stack+27248415,171);
 /*--- compute (w0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+27069378,int_stack+28236111,int_stack+27643425,171);
 /*--- compute (w0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+27479265,int_stack+27069378,int_stack+27799035,171);
 /*--- compute (w0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+28415661,int_stack+27479265,int_stack+27999105,171);
 /*--- compute (w0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+27759363,int_stack+1289778,int_stack+1263615,171);
 /*--- compute (w0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+27837852,int_stack+27759363,int_stack+26999610,171);
 /*--- compute (w0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+27977388,int_stack+27837852,int_stack+27356145,171);
 /*--- compute (w0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+28731669,int_stack+27977388,int_stack+28236111,171);
 /*--- compute (w0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+29000994,int_stack+28731669,int_stack+27069378,171);
 /*--- compute (w0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+26999610,int_stack+29000994,int_stack+27479265,171);
 /*--- compute (w0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+29327775,int_stack+26999610,int_stack+28415661,171);
 /*--- compute (w0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+27373074,int_stack+1319019,int_stack+1289778,171);
 /*--- compute (w0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+27460797,int_stack+27373074,int_stack+27759363,171);
 /*--- compute (w0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+28182588,int_stack+27460797,int_stack+27837852,171);
 /*--- compute (w0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+27617775,int_stack+28182588,int_stack+27977388,171);
 /*--- compute (w0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+29734071,int_stack+27617775,int_stack+28731669,171);
 /*--- compute (w0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+28415148,int_stack+29734071,int_stack+29000994,171);
 /*--- compute (w0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+28415148,int_stack+26999610,171);
 /*--- compute (w0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+480168,int_stack+0,int_stack+29327775,171);
 /*--- compute (w0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+26999610,int_stack+1351509,int_stack+1319019,171);
 /*--- compute (w0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+27097080,int_stack+26999610,int_stack+27373074,171);
 /*--- compute (w0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+28850856,int_stack+27097080,int_stack+27460797,171);
 /*--- compute (w0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+29112486,int_stack+28850856,int_stack+28182588,171);
 /*--- compute (w0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+27925575,int_stack+29112486,int_stack+27617775,171);
 /*--- compute (w0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+27272526,int_stack+27925575,int_stack+29734071,171);
 /*--- compute (w0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+29461326,int_stack+27272526,int_stack+28415148,171);
 /*--- compute (w0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+4563240,int_stack+29461326,int_stack+0,171);
 /*--- compute (w0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+5163450,int_stack+4563240,int_stack+480168,171);
 /*--- compute (w0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+1387419,int_stack+1351509,171);
 /*--- compute (w0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+107730,int_stack+0,int_stack+26999610,171);
 /*--- compute (w0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+302670,int_stack+107730,int_stack+27097080,171);
 /*--- compute (w0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+595080,int_stack+302670,int_stack+28850856,171);
 /*--- compute (w0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+595080,int_stack+29112486,171);
 /*--- compute (w0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+488376,int_stack+0,int_stack+27925575,171);
 /*--- compute (w0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+27775266,int_stack+488376,int_stack+27272526,171);
 /*--- compute (w0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+0,int_stack+27775266,int_stack+29461326,171);
 /*--- compute (w0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+26999610,int_stack+0,int_stack+4563240,171);
 /*--- compute (w0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+0,int_stack+26999610,int_stack+5163450,171);
 /*--- compute (vp|nn) ---*/
 hrr1_build_vp(Libint->AB,int_stack+26999610,int_stack+0,int_stack+16506006,4356);
 /*--- compute (ud|nn) ---*/
 hrr1_build_ud(Libint->AB,int_stack+4563240,int_stack+26999610,int_stack+17172474,4356);
 /*--- compute (tf|nn) ---*/
 hrr1_build_tf(Libint->AB,int_stack+8117736,int_stack+4563240,int_stack+1426920,4356);
 /*--- compute (rg|nn) ---*/
 hrr1_build_rg(Libint->AB,int_stack+0,int_stack+8117736,int_stack+30542520,4356);
 /*--- compute (qh|nn) ---*/
 hrr1_build_qh(Libint->AB,int_stack+6860700,int_stack+0,int_stack+35116320,4356);
 /*--- compute (oi|nn) ---*/
 hrr1_build_oi(Libint->AB,int_stack+26999610,int_stack+6860700,int_stack+41062260,4356);
 /*--- compute (nk|nn) ---*/
 hrr1_build_nk(Libint->AB,int_stack+0,int_stack+26999610,int_stack+18949722,4356);
 return int_stack+0;}
