/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nplh(Libint_t*, prim_data*);

  /* Computes quartets of (np|lh) integrals */

REALTYPE *hrr_order_nplh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][8] = int_stack + 0;
 Libint->vrr_classes[10][9] = int_stack + 2970;
 Libint->vrr_classes[10][10] = int_stack + 6600;
 Libint->vrr_classes[10][11] = int_stack + 10956;
 Libint->vrr_classes[10][12] = int_stack + 16104;
 Libint->vrr_classes[10][13] = int_stack + 22110;
 Libint->vrr_classes[11][8] = int_stack + 29040;
 Libint->vrr_classes[11][9] = int_stack + 32550;
 Libint->vrr_classes[11][10] = int_stack + 36840;
 Libint->vrr_classes[11][11] = int_stack + 41988;
 Libint->vrr_classes[11][12] = int_stack + 48072;
 Libint->vrr_classes[11][13] = int_stack + 55170;
 memset(int_stack,0,63360*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 63360;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nplh(Libint, Data);
   Data++;
 }
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+63360,int_stack+2970,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+72270,int_stack+6600,int_stack+2970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+83160,int_stack+72270,int_stack+63360,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+100980,int_stack+10956,int_stack+6600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+114048,int_stack+100980,int_stack+72270,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+135828,int_stack+114048,int_stack+83160,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63360,int_stack+16104,int_stack+10956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+165528,int_stack+63360,int_stack+100980,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+191664,int_stack+165528,int_stack+114048,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+78804,int_stack+191664,int_stack+135828,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+123354,int_stack+22110,int_stack+16104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+227964,int_stack+123354,int_stack+63360,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+258852,int_stack+227964,int_stack+165528,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+123354,int_stack+258852,int_stack+191664,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+177804,int_stack+123354,int_stack+78804,66);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+63360,int_stack+32550,int_stack+29040,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+73890,int_stack+36840,int_stack+32550,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+86760,int_stack+73890,int_stack+63360,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+107820,int_stack+41988,int_stack+36840,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+123264,int_stack+107820,int_stack+73890,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+240174,int_stack+123264,int_stack+86760,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63360,int_stack+48072,int_stack+41988,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+63360,int_stack+107820,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+275274,int_stack+0,int_stack+123264,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+81612,int_stack+275274,int_stack+240174,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+240174,int_stack+55170,int_stack+48072,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+134262,int_stack+240174,int_stack+63360,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+318174,int_stack+134262,int_stack+0,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+318174,int_stack+275274,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+240174,int_stack+0,int_stack+81612,78);
 /*--- compute (np|lh) ---*/
 hrr1_build_np(Libint->AB,int_stack+313884,int_stack+240174,int_stack+177804,945);
 return int_stack+313884;}
