/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_npmg(Libint_t*, prim_data*);

  /* Computes quartets of (np|mg) integrals */

REALTYPE *hrr_order_npmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[11][9] = int_stack + 26070;
 Libint->vrr_classes[11][10] = int_stack + 30360;
 Libint->vrr_classes[11][11] = int_stack + 35508;
 Libint->vrr_classes[11][12] = int_stack + 41592;
 Libint->vrr_classes[11][13] = int_stack + 48690;
 memset(int_stack,0,56880*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 56880;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_npmg(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+56880,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+67770,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+80838,int_stack+67770,int_stack+56880,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+102618,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+118062,int_stack+102618,int_stack+67770,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+144198,int_stack+118062,int_stack+80838,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+56880,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+180498,int_stack+56880,int_stack+102618,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+56880,int_stack+180498,int_stack+118062,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+180498,int_stack+56880,int_stack+144198,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+56880,int_stack+30360,int_stack+26070,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+69750,int_stack+35508,int_stack+30360,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+85194,int_stack+69750,int_stack+56880,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+110934,int_stack+41592,int_stack+35508,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+129186,int_stack+110934,int_stack+69750,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+234948,int_stack+129186,int_stack+85194,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+56880,int_stack+48690,int_stack+41592,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+56880,int_stack+110934,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+36504,int_stack+0,int_stack+129186,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+87984,int_stack+36504,int_stack+234948,78);
 /*--- compute (np|mg) ---*/
 hrr1_build_np(Libint->AB,int_stack+234948,int_stack+87984,int_stack+180498,825);
 return int_stack+234948;}
