/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_npnl(Libint_t*, prim_data*);

  /* Computes quartets of (np|nl) integrals */

REALTYPE *hrr_order_npnl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[10][18] = int_stack + 60720;
 Libint->vrr_classes[11][10] = int_stack + 73260;
 Libint->vrr_classes[11][11] = int_stack + 78408;
 Libint->vrr_classes[11][12] = int_stack + 84492;
 Libint->vrr_classes[11][13] = int_stack + 91590;
 Libint->vrr_classes[11][14] = int_stack + 99780;
 Libint->vrr_classes[11][15] = int_stack + 109140;
 Libint->vrr_classes[11][16] = int_stack + 119748;
 Libint->vrr_classes[11][17] = int_stack + 131682;
 Libint->vrr_classes[11][18] = int_stack + 145020;
 memset(int_stack,0,159840*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 159840;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_npnl(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+159840,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+172908,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+188352,int_stack+172908,int_stack+159840,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+214488,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+232506,int_stack+214488,int_stack+172908,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+263394,int_stack+232506,int_stack+188352,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+159840,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+306954,int_stack+159840,int_stack+214488,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+180630,int_stack+306954,int_stack+232506,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+342990,int_stack+180630,int_stack+263394,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+232110,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+255870,int_stack+232110,int_stack+159840,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+408330,int_stack+255870,int_stack+306954,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+468390,int_stack+408330,int_stack+180630,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+545610,int_stack+468390,int_stack+342990,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+159840,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+297450,int_stack+159840,int_stack+232110,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+637086,int_stack+297450,int_stack+255870,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+186768,int_stack+637086,int_stack+408330,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+344970,int_stack+186768,int_stack+468390,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+706386,int_stack+344970,int_stack+545610,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+453078,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+483372,int_stack+453078,int_stack+159840,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+537228,int_stack+483372,int_stack+297450,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+828354,int_stack+537228,int_stack+637086,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+932304,int_stack+828354,int_stack+186768,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+159840,int_stack+932304,int_stack+344970,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1058430,int_stack+159840,int_stack+706386,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+303984,int_stack+60720,int_stack+49434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+337842,int_stack+303984,int_stack+453078,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+616428,int_stack+337842,int_stack+483372,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+303984,int_stack+616428,int_stack+537228,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+422784,int_stack+303984,int_stack+828354,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+568314,int_stack+422784,int_stack+932304,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+303984,int_stack+568314,int_stack+159840,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+489312,int_stack+303984,int_stack+1058430,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+159840,int_stack+78408,int_stack+73260,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+175284,int_stack+84492,int_stack+78408,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+193536,int_stack+175284,int_stack+159840,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+224424,int_stack+91590,int_stack+84492,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+245718,int_stack+224424,int_stack+175284,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+282222,int_stack+245718,int_stack+193536,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+159840,int_stack+99780,int_stack+91590,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+333702,int_stack+159840,int_stack+224424,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+184410,int_stack+333702,int_stack+245718,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+376290,int_stack+184410,int_stack+282222,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+245250,int_stack+109140,int_stack+99780,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+273330,int_stack+245250,int_stack+159840,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+685332,int_stack+273330,int_stack+333702,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+756312,int_stack+685332,int_stack+184410,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+847572,int_stack+756312,int_stack+376290,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+159840,int_stack+119748,int_stack+109140,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+322470,int_stack+159840,int_stack+245250,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+378630,int_stack+322470,int_stack+273330,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+191664,int_stack+378630,int_stack+685332,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+955680,int_stack+191664,int_stack+756312,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+685332,int_stack+955680,int_stack+847572,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+829476,int_stack+131682,int_stack+119748,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+865278,int_stack+829476,int_stack+159840,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1083444,int_stack+865278,int_stack+322470,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+1083444,int_stack+378630,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+298134,int_stack+0,int_stack+191664,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1177044,int_stack+298134,int_stack+955680,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1347396,int_stack+1177044,int_stack+685332,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+685332,int_stack+145020,int_stack+131682,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+725346,int_stack+685332,int_stack+829476,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+928926,int_stack+725346,int_stack+865278,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+685332,int_stack+928926,int_stack+1083444,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+825732,int_stack+685332,int_stack+0,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+825732,int_stack+298134,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+198744,int_stack+0,int_stack+1177044,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+685332,int_stack+198744,int_stack+1347396,78);
 /*--- compute (np|nl) ---*/
 hrr1_build_np(Libint->AB,int_stack+916992,int_stack+685332,int_stack+489312,2970);
 return int_stack+916992;}
