/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_npnn(Libint_t*, prim_data*);

  /* Computes quartets of (np|nn) integrals */

REALTYPE *hrr_order_npnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[10][18] = int_stack + 60720;
 Libint->vrr_classes[10][19] = int_stack + 73260;
 Libint->vrr_classes[10][20] = int_stack + 87120;
 Libint->vrr_classes[11][10] = int_stack + 102366;
 Libint->vrr_classes[11][11] = int_stack + 107514;
 Libint->vrr_classes[11][12] = int_stack + 113598;
 Libint->vrr_classes[11][13] = int_stack + 120696;
 Libint->vrr_classes[11][14] = int_stack + 128886;
 Libint->vrr_classes[11][15] = int_stack + 138246;
 Libint->vrr_classes[11][16] = int_stack + 148854;
 Libint->vrr_classes[11][17] = int_stack + 160788;
 Libint->vrr_classes[11][18] = int_stack + 174126;
 Libint->vrr_classes[11][19] = int_stack + 188946;
 Libint->vrr_classes[11][20] = int_stack + 205326;
 memset(int_stack,0,223344*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 223344;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_npnn(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+223344,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+236412,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+251856,int_stack+236412,int_stack+223344,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+277992,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+296010,int_stack+277992,int_stack+236412,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+326898,int_stack+296010,int_stack+251856,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+223344,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+370458,int_stack+223344,int_stack+277992,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+244134,int_stack+370458,int_stack+296010,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+406494,int_stack+244134,int_stack+326898,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+295614,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+319374,int_stack+295614,int_stack+223344,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+471834,int_stack+319374,int_stack+370458,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+531894,int_stack+471834,int_stack+244134,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+609114,int_stack+531894,int_stack+406494,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+223344,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+360954,int_stack+223344,int_stack+295614,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+700590,int_stack+360954,int_stack+319374,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+250272,int_stack+700590,int_stack+471834,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+408474,int_stack+250272,int_stack+531894,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+769890,int_stack+408474,int_stack+609114,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+516582,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+546876,int_stack+516582,int_stack+223344,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+600732,int_stack+546876,int_stack+360954,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+891858,int_stack+600732,int_stack+700590,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+995808,int_stack+891858,int_stack+250272,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+223344,int_stack+995808,int_stack+408474,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1121934,int_stack+223344,int_stack+769890,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+367488,int_stack+60720,int_stack+49434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+401346,int_stack+367488,int_stack+516582,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+679932,int_stack+401346,int_stack+546876,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+461934,int_stack+679932,int_stack+600732,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1278750,int_stack+461934,int_stack+891858,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+769692,int_stack+1278750,int_stack+995808,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1424280,int_stack+769692,int_stack+223344,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1609608,int_stack+1424280,int_stack+1121934,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+223344,int_stack+73260,int_stack+60720,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+260964,int_stack+223344,int_stack+367488,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+937860,int_stack+260964,int_stack+401346,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1038840,int_stack+937860,int_stack+679932,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+580734,int_stack+1038840,int_stack+461934,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+328680,int_stack+580734,int_stack+1278750,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1173480,int_stack+328680,int_stack+769692,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1805628,int_stack+1173480,int_stack+1424280,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2037288,int_stack+1805628,int_stack+1609608,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+522720,int_stack+87120,int_stack+73260,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+747054,int_stack+522720,int_stack+223344,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+822294,int_stack+747054,int_stack+260964,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1389696,int_stack+822294,int_stack+937860,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+747054,int_stack+1389696,int_stack+1038840,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1389696,int_stack+747054,int_stack+580734,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+522720,int_stack+1389696,int_stack+328680,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1389696,int_stack+522720,int_stack+1173480,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+223344,int_stack+1389696,int_stack+1805628,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+506484,int_stack+223344,int_stack+2037288,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+223344,int_stack+107514,int_stack+102366,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+238788,int_stack+113598,int_stack+107514,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+257040,int_stack+238788,int_stack+223344,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+287928,int_stack+120696,int_stack+113598,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+309222,int_stack+287928,int_stack+238788,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+345726,int_stack+309222,int_stack+257040,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+223344,int_stack+128886,int_stack+120696,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+397206,int_stack+223344,int_stack+287928,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+247914,int_stack+397206,int_stack+309222,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+793980,int_stack+247914,int_stack+345726,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+308754,int_stack+138246,int_stack+128886,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+336834,int_stack+308754,int_stack+223344,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+871200,int_stack+336834,int_stack+397206,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+385974,int_stack+871200,int_stack+247914,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+942180,int_stack+385974,int_stack+793980,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+793980,int_stack+148854,int_stack+138246,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+223344,int_stack+793980,int_stack+308754,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1050288,int_stack+223344,int_stack+336834,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+279504,int_stack+1050288,int_stack+871200,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1132188,int_stack+279504,int_stack+385974,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1259952,int_stack+1132188,int_stack+942180,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+385974,int_stack+160788,int_stack+148854,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+421776,int_stack+385974,int_stack+793980,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+793980,int_stack+421776,int_stack+223344,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+887580,int_stack+793980,int_stack+1050288,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1404096,int_stack+887580,int_stack+279504,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1553154,int_stack+1404096,int_stack+1132188,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1010430,int_stack+1553154,int_stack+1259952,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+223344,int_stack+174126,int_stack+160788,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+263358,int_stack+223344,int_stack+385974,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1195758,int_stack+263358,int_stack+421776,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+334962,int_stack+1195758,int_stack+793980,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1723506,int_stack+334962,int_stack+887580,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+793980,int_stack+1723506,int_stack+1404096,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1301838,int_stack+793980,int_stack+1553154,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1895496,int_stack+1301838,int_stack+1010430,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+992724,int_stack+188946,int_stack+174126,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1037184,int_stack+992724,int_stack+223344,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1520862,int_stack+1037184,int_stack+263358,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+1520862,int_stack+1195758,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2127156,int_stack+0,int_stack+334962,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+223344,int_stack+2127156,int_stack+1723506,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2323716,int_stack+223344,int_stack+793980,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2579244,int_stack+2323716,int_stack+1301838,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1117212,int_stack+2579244,int_stack+1895496,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+793980,int_stack+205326,int_stack+188946,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+843120,int_stack+793980,int_stack+992724,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1640202,int_stack+843120,int_stack+1037184,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+793980,int_stack+1640202,int_stack+1520862,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1400352,int_stack+793980,int_stack+0,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+793980,int_stack+1400352,int_stack+2127156,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1400352,int_stack+793980,int_stack+223344,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+793980,int_stack+1400352,int_stack+2323716,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1400352,int_stack+793980,int_stack+2579244,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1734972,int_stack+1400352,int_stack+1117212,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+793980,int_stack+1734972,int_stack+506484,4356);
 return int_stack+793980;}
