/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_p0ll(Libint_t*, prim_data*);

  /* Computes quartets of (p0|ll) integrals */

REALTYPE *hrr_order_p0ll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][8] = int_stack + 0;
 Libint->vrr_classes[1][9] = int_stack + 135;
 Libint->vrr_classes[1][10] = int_stack + 300;
 Libint->vrr_classes[1][11] = int_stack + 498;
 Libint->vrr_classes[1][12] = int_stack + 732;
 Libint->vrr_classes[1][13] = int_stack + 1005;
 Libint->vrr_classes[1][14] = int_stack + 1320;
 Libint->vrr_classes[1][15] = int_stack + 1680;
 Libint->vrr_classes[1][16] = int_stack + 2088;
 memset(int_stack,0,2547*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 2547;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_p0ll(Libint, Data);
   Data++;
 }
 /*--- compute (p0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+2547,int_stack+135,int_stack+0,3);
 /*--- compute (p0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2952,int_stack+300,int_stack+135,3);
 /*--- compute (p0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+3447,int_stack+2952,int_stack+2547,3);
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4257,int_stack+498,int_stack+300,3);
 /*--- compute (p0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+4851,int_stack+4257,int_stack+2952,3);
 /*--- compute (p0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+5841,int_stack+4851,int_stack+3447,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2547,int_stack+732,int_stack+498,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+7191,int_stack+2547,int_stack+4257,3);
 /*--- compute (p0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+8379,int_stack+7191,int_stack+4851,3);
 /*--- compute (p0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+3249,int_stack+8379,int_stack+5841,3);
 /*--- compute (p0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+5274,int_stack+1005,int_stack+732,3);
 /*--- compute (p0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+10029,int_stack+5274,int_stack+2547,3);
 /*--- compute (p0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+11433,int_stack+10029,int_stack+7191,3);
 /*--- compute (p0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+13413,int_stack+11433,int_stack+8379,3);
 /*--- compute (p0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+6093,int_stack+13413,int_stack+3249,3);
 /*--- compute (p0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2547,int_stack+1320,int_stack+1005,3);
 /*--- compute (p0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3492,int_stack+2547,int_stack+5274,3);
 /*--- compute (p0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+15888,int_stack+3492,int_stack+10029,3);
 /*--- compute (p0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+18228,int_stack+15888,int_stack+11433,3);
 /*--- compute (p0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+8928,int_stack+18228,int_stack+13413,3);
 /*--- compute (p0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+21198,int_stack+8928,int_stack+6093,3);
 /*--- compute (p0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+5130,int_stack+1680,int_stack+1320,3);
 /*--- compute (p0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+6210,int_stack+5130,int_stack+2547,3);
 /*--- compute (p0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+12393,int_stack+6210,int_stack+3492,3);
 /*--- compute (p0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+24978,int_stack+12393,int_stack+15888,3);
 /*--- compute (p0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+28488,int_stack+24978,int_stack+18228,3);
 /*--- compute (p0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+15123,int_stack+28488,int_stack+8928,3);
 /*--- compute (p0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+32646,int_stack+15123,int_stack+21198,3);
 /*--- compute (p0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2547,int_stack+2088,int_stack+1680,3);
 /*--- compute (p0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+8100,int_stack+2547,int_stack+5130,3);
 /*--- compute (p0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+19743,int_stack+8100,int_stack+6210,3);
 /*--- compute (p0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+19743,int_stack+12393,3);
 /*--- compute (p0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+19743,int_stack+0,int_stack+24978,3);
 /*--- compute (p0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+19743,int_stack+28488,3);
 /*--- compute (p0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+19743,int_stack+0,int_stack+15123,3);
 /*--- compute (p0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+19743,int_stack+32646,3);
 return int_stack+0;}
