/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (00|nm) integrals */

void vrr_order_00nm(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+9, Data->F+10, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+34, vrr_stack+15, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+50, vrr_stack+6, vrr_stack+3, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+56, vrr_stack+9, vrr_stack+50, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+66, vrr_stack+21, vrr_stack+56, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+81, vrr_stack+66, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+0, vrr_stack+31, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+15, vrr_stack+34, vrr_stack+0, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+127, vrr_stack+117, vrr_stack+40, vrr_stack+15, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+127, vrr_stack+81, vrr_stack+117, vrr_stack+40, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+3, vrr_stack+31, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+50, vrr_stack+34, vrr_stack+6, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+163, vrr_stack+56, vrr_stack+40, vrr_stack+9, vrr_stack+50, NULL);
 _BUILD_00h0(Data,vrr_stack+178, vrr_stack+66, vrr_stack+163, vrr_stack+21, vrr_stack+56, NULL);
 _BUILD_00i0(Data,vrr_stack+199, vrr_stack+96, vrr_stack+178, vrr_stack+81, vrr_stack+66, NULL);
 _BUILD_00i0(Data,vrr_stack+227, vrr_stack+142, vrr_stack+96, vrr_stack+127, vrr_stack+81, NULL);
 _BUILD_00k0(Data,vrr_stack+255, vrr_stack+227, vrr_stack+199, vrr_stack+142, vrr_stack+96, NULL);
 _BUILD_00p0(Data,vrr_stack+81, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+84, vrr_stack+81, vrr_stack+0, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+84, vrr_stack+15, vrr_stack+81, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+291, vrr_stack+21, vrr_stack+117, vrr_stack+84, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+306, vrr_stack+291, vrr_stack+127, vrr_stack+21, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+327, vrr_stack+306, vrr_stack+142, vrr_stack+291, vrr_stack+127, NULL);
 _BUILD_00k0(Data,vrr_stack+355, vrr_stack+327, vrr_stack+227, vrr_stack+306, vrr_stack+142, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+90, vrr_stack+31, vrr_stack+0, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+34, vrr_stack+90, vrr_stack+3, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+40, vrr_stack+117, vrr_stack+50, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+127, vrr_stack+163, vrr_stack+3, vrr_stack+56, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+391, vrr_stack+178, vrr_stack+127, vrr_stack+66, vrr_stack+163, NULL);
 _BUILD_00k0(Data,vrr_stack+419, vrr_stack+199, vrr_stack+391, vrr_stack+96, vrr_stack+178, NULL);
 _BUILD_00l0(Data,vrr_stack+455, vrr_stack+255, vrr_stack+419, vrr_stack+227, vrr_stack+199, NULL);
 _BUILD_00l0(Data,vrr_stack+500, vrr_stack+355, vrr_stack+255, vrr_stack+327, vrr_stack+227, NULL);
 _BUILD_00m0(Data,vrr_stack+545, vrr_stack+500, vrr_stack+455, vrr_stack+355, vrr_stack+255, NULL);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+227, vrr_stack+18, vrr_stack+81, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+233, vrr_stack+227, vrr_stack+84, vrr_stack+18, vrr_stack+81, NULL);
 _BUILD_00g0(Data,vrr_stack+148, vrr_stack+233, vrr_stack+21, vrr_stack+227, vrr_stack+84, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+148, vrr_stack+291, vrr_stack+233, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+50, vrr_stack+96, vrr_stack+306, vrr_stack+148, vrr_stack+291, NULL);
 _BUILD_00k0(Data,vrr_stack+600, vrr_stack+50, vrr_stack+327, vrr_stack+96, vrr_stack+306, NULL);
 _BUILD_00l0(Data,vrr_stack+636, vrr_stack+600, vrr_stack+355, vrr_stack+50, vrr_stack+327, NULL);
 _BUILD_00m0(Data,vrr_stack+291, vrr_stack+636, vrr_stack+500, vrr_stack+600, vrr_stack+355, NULL);
 _BUILD_00p0(Data,vrr_stack+346, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+349, vrr_stack+0, vrr_stack+346, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+90, vrr_stack+349, vrr_stack+31, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+355, vrr_stack+117, vrr_stack+21, vrr_stack+34, vrr_stack+90, NULL);
 _BUILD_00h0(Data,vrr_stack+370, vrr_stack+3, vrr_stack+355, vrr_stack+40, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+681, vrr_stack+127, vrr_stack+370, vrr_stack+163, vrr_stack+3, NULL);
 _BUILD_00k0(Data,vrr_stack+709, vrr_stack+391, vrr_stack+681, vrr_stack+178, vrr_stack+127, NULL);
 _BUILD_00l0(Data,vrr_stack+745, vrr_stack+419, vrr_stack+709, vrr_stack+199, vrr_stack+391, NULL);
 _BUILD_00m0(Data,vrr_stack+163, vrr_stack+455, vrr_stack+745, vrr_stack+255, vrr_stack+419, NULL);
 _BUILD_00n0(Data,vrr_stack+790, vrr_stack+545, vrr_stack+163, vrr_stack+500, vrr_stack+455, NULL);
 _BUILD_00n0(Data,vrr_stack+856, vrr_stack+291, vrr_stack+545, vrr_stack+636, vrr_stack+500, NULL);
 _BUILD_00o0(Data,vrr_stack+922, vrr_stack+856, vrr_stack+790, vrr_stack+291, vrr_stack+545, NULL);
 _BUILD_00p0(Data,vrr_stack+500, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+503, vrr_stack+500, vrr_stack+18, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+509, vrr_stack+503, vrr_stack+227, vrr_stack+500, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+519, vrr_stack+509, vrr_stack+233, vrr_stack+503, vrr_stack+227, NULL);
 _BUILD_00h0(Data,vrr_stack+243, vrr_stack+519, vrr_stack+148, vrr_stack+509, vrr_stack+233, NULL);
 _BUILD_00i0(Data,vrr_stack+1000, vrr_stack+243, vrr_stack+96, vrr_stack+519, vrr_stack+148, NULL);
 _BUILD_00k0(Data,vrr_stack+1028, vrr_stack+1000, vrr_stack+50, vrr_stack+243, vrr_stack+96, NULL);
 _BUILD_00l0(Data,vrr_stack+1064, vrr_stack+1028, vrr_stack+600, vrr_stack+1000, vrr_stack+50, NULL);
 _BUILD_00m0(Data,vrr_stack+31, vrr_stack+1064, vrr_stack+636, vrr_stack+1028, vrr_stack+600, NULL);
 _BUILD_00n0(Data,vrr_stack+1109, vrr_stack+31, vrr_stack+291, vrr_stack+1064, vrr_stack+636, NULL);
 _BUILD_00o0(Data,vrr_stack+600, vrr_stack+1109, vrr_stack+856, vrr_stack+31, vrr_stack+291, NULL);
 _BUILD_00p0(Data,vrr_stack+678, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+96, vrr_stack+346, vrr_stack+678, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+102, vrr_stack+349, vrr_stack+96, vrr_stack+0, vrr_stack+346, NULL);
 _BUILD_00g0(Data,vrr_stack+148, vrr_stack+21, vrr_stack+102, vrr_stack+90, vrr_stack+349, NULL);
 _BUILD_00h0(Data,vrr_stack+218, vrr_stack+355, vrr_stack+148, vrr_stack+117, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+264, vrr_stack+370, vrr_stack+218, vrr_stack+3, vrr_stack+355, NULL);
 _BUILD_00k0(Data,vrr_stack+292, vrr_stack+681, vrr_stack+264, vrr_stack+127, vrr_stack+370, NULL);
 _BUILD_00l0(Data,vrr_stack+1175, vrr_stack+709, vrr_stack+292, vrr_stack+391, vrr_stack+681, NULL);
 _BUILD_00m0(Data,vrr_stack+1220, vrr_stack+745, vrr_stack+1175, vrr_stack+419, vrr_stack+709, NULL);
 _BUILD_00n0(Data,vrr_stack+1275, vrr_stack+163, vrr_stack+1220, vrr_stack+455, vrr_stack+745, NULL);
 _BUILD_00o0(Data,vrr_stack+391, vrr_stack+790, vrr_stack+1275, vrr_stack+545, vrr_stack+163, NULL);
 _BUILD_00q0(Data,vrr_stack+1341, vrr_stack+922, vrr_stack+391, vrr_stack+856, vrr_stack+790, NULL);
 _BUILD_00q0(Data,vrr_stack+1432, vrr_stack+600, vrr_stack+922, vrr_stack+1109, vrr_stack+856, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1523, vrr_stack+1432, vrr_stack+1341, vrr_stack+600, vrr_stack+922, NULL);
 _BUILD_00p0(Data,vrr_stack+856, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+859, vrr_stack+856, vrr_stack+500, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+86, vrr_stack+859, vrr_stack+503, vrr_stack+856, vrr_stack+500, NULL);
 _BUILD_00g0(Data,vrr_stack+865, vrr_stack+86, vrr_stack+509, vrr_stack+859, vrr_stack+503, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+865, vrr_stack+519, vrr_stack+86, vrr_stack+509, NULL);
 _BUILD_00i0(Data,vrr_stack+880, vrr_stack+0, vrr_stack+243, vrr_stack+865, vrr_stack+519, NULL);
 _BUILD_00k0(Data,vrr_stack+112, vrr_stack+880, vrr_stack+1000, vrr_stack+0, vrr_stack+243, NULL);
 _BUILD_00l0(Data,vrr_stack+469, vrr_stack+112, vrr_stack+1028, vrr_stack+880, vrr_stack+1000, NULL);
 _BUILD_00m0(Data,vrr_stack+514, vrr_stack+469, vrr_stack+1064, vrr_stack+112, vrr_stack+1028, NULL);
 _BUILD_00n0(Data,vrr_stack+1628, vrr_stack+514, vrr_stack+31, vrr_stack+469, vrr_stack+1064, NULL);
 _BUILD_00o0(Data,vrr_stack+1000, vrr_stack+1628, vrr_stack+1109, vrr_stack+514, vrr_stack+31, NULL);
 _BUILD_00q0(Data,vrr_stack+1694, vrr_stack+1000, vrr_stack+600, vrr_stack+1628, vrr_stack+1109, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1785, vrr_stack+1694, vrr_stack+1432, vrr_stack+1000, vrr_stack+600, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+678, vrr_stack+31, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+96, vrr_stack+34, vrr_stack+346, vrr_stack+678, NULL);
 _BUILD_00g0(Data,vrr_stack+50, vrr_stack+102, vrr_stack+40, vrr_stack+349, vrr_stack+96, NULL);
 _BUILD_00h0(Data,vrr_stack+65, vrr_stack+148, vrr_stack+50, vrr_stack+21, vrr_stack+102, NULL);
 _BUILD_00i0(Data,vrr_stack+1078, vrr_stack+218, vrr_stack+65, vrr_stack+355, vrr_stack+148, NULL);
 _BUILD_00k0(Data,vrr_stack+1106, vrr_stack+264, vrr_stack+1078, vrr_stack+370, vrr_stack+218, NULL);
 _BUILD_00l0(Data,vrr_stack+569, vrr_stack+292, vrr_stack+1106, vrr_stack+681, vrr_stack+264, NULL);
 _BUILD_00m0(Data,vrr_stack+614, vrr_stack+1175, vrr_stack+569, vrr_stack+709, vrr_stack+292, NULL);
 _BUILD_00n0(Data,vrr_stack+1890, vrr_stack+1220, vrr_stack+614, vrr_stack+745, vrr_stack+1175, NULL);
 _BUILD_00o0(Data,vrr_stack+681, vrr_stack+1275, vrr_stack+1890, vrr_stack+163, vrr_stack+1220, NULL);
 _BUILD_00q0(Data,vrr_stack+1956, vrr_stack+391, vrr_stack+681, vrr_stack+790, vrr_stack+1275, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2047, vrr_stack+1341, vrr_stack+1956, vrr_stack+922, vrr_stack+391, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2152, vrr_stack+1523, vrr_stack+2047, vrr_stack+1432, vrr_stack+1341, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2272, vrr_stack+1785, vrr_stack+1523, vrr_stack+1694, vrr_stack+1432, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+2392, vrr_stack+2272, vrr_stack+2152, vrr_stack+1785, vrr_stack+1523, NULL);
 _BUILD_00p0(Data,vrr_stack+1432, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1435, vrr_stack+1432, vrr_stack+856, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+1435, vrr_stack+859, vrr_stack+1432, vrr_stack+856, NULL);
 _BUILD_00g0(Data,vrr_stack+1441, vrr_stack+21, vrr_stack+86, vrr_stack+1435, vrr_stack+859, NULL);
 _BUILD_00h0(Data,vrr_stack+1456, vrr_stack+1441, vrr_stack+865, vrr_stack+21, vrr_stack+86, NULL);
 _BUILD_00i0(Data,vrr_stack+1477, vrr_stack+1456, vrr_stack+0, vrr_stack+1441, vrr_stack+865, NULL);
 _BUILD_00k0(Data,vrr_stack+163, vrr_stack+1477, vrr_stack+880, vrr_stack+1456, vrr_stack+0, NULL);
 _BUILD_00l0(Data,vrr_stack+759, vrr_stack+163, vrr_stack+112, vrr_stack+1477, vrr_stack+880, NULL);
 _BUILD_00m0(Data,vrr_stack+804, vrr_stack+759, vrr_stack+469, vrr_stack+163, vrr_stack+112, NULL);
 _BUILD_00n0(Data,vrr_stack+859, vrr_stack+804, vrr_stack+514, vrr_stack+759, vrr_stack+469, NULL);
 _BUILD_00o0(Data,vrr_stack+2528, vrr_stack+859, vrr_stack+1628, vrr_stack+804, vrr_stack+514, NULL);
 _BUILD_00q0(Data,vrr_stack+469, vrr_stack+2528, vrr_stack+1000, vrr_stack+859, vrr_stack+1628, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2606, vrr_stack+469, vrr_stack+1694, vrr_stack+2528, vrr_stack+1000, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+925, vrr_stack+2606, vrr_stack+1785, vrr_stack+469, vrr_stack+1694, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+1628, vrr_stack+925, vrr_stack+2272, vrr_stack+2606, vrr_stack+1785, NULL);
 _BUILD_00p0(Data,vrr_stack+1764, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1767, vrr_stack+31, vrr_stack+1764, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+86, vrr_stack+34, vrr_stack+1767, vrr_stack+678, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+1773, vrr_stack+40, vrr_stack+86, vrr_stack+96, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+50, vrr_stack+1773, vrr_stack+102, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+96, vrr_stack+65, vrr_stack+0, vrr_stack+148, vrr_stack+50, NULL);
 _BUILD_00k0(Data,vrr_stack+124, vrr_stack+1078, vrr_stack+96, vrr_stack+218, vrr_stack+65, NULL);
 _BUILD_00l0(Data,vrr_stack+1788, vrr_stack+1106, vrr_stack+124, vrr_stack+264, vrr_stack+1078, NULL);
 _BUILD_00m0(Data,vrr_stack+1833, vrr_stack+569, vrr_stack+1788, vrr_stack+292, vrr_stack+1106, NULL);
 _BUILD_00n0(Data,vrr_stack+199, vrr_stack+614, vrr_stack+1833, vrr_stack+1175, vrr_stack+569, NULL);
 _BUILD_00o0(Data,vrr_stack+1142, vrr_stack+1890, vrr_stack+199, vrr_stack+1220, vrr_stack+614, NULL);
 _BUILD_00q0(Data,vrr_stack+265, vrr_stack+681, vrr_stack+1142, vrr_stack+1275, vrr_stack+1890, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1220, vrr_stack+1956, vrr_stack+265, vrr_stack+391, vrr_stack+681, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2711, vrr_stack+2047, vrr_stack+1220, vrr_stack+1341, vrr_stack+1956, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+2831, vrr_stack+2152, vrr_stack+2711, vrr_stack+1523, vrr_stack+2047, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+2967, vrr_stack+2392, vrr_stack+2831, vrr_stack+2272, vrr_stack+2152, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+3120, vrr_stack+1628, vrr_stack+2392, vrr_stack+925, vrr_stack+2272, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+3273, vrr_stack+3120, vrr_stack+2967, vrr_stack+1628, vrr_stack+2392, NULL);
 _BUILD_00p0(Data,vrr_stack+160, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2272, vrr_stack+160, vrr_stack+1432, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+2278, vrr_stack+2272, vrr_stack+1435, vrr_stack+160, vrr_stack+1432, NULL);
 _BUILD_00g0(Data,vrr_stack+2288, vrr_stack+2278, vrr_stack+21, vrr_stack+2272, vrr_stack+1435, NULL);
 _BUILD_00h0(Data,vrr_stack+2303, vrr_stack+2288, vrr_stack+1441, vrr_stack+2278, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+2324, vrr_stack+2303, vrr_stack+1456, vrr_stack+2288, vrr_stack+1441, NULL);
 _BUILD_00k0(Data,vrr_stack+2352, vrr_stack+2324, vrr_stack+1477, vrr_stack+2303, vrr_stack+1456, NULL);
 _BUILD_00l0(Data,vrr_stack+2272, vrr_stack+2352, vrr_stack+163, vrr_stack+2324, vrr_stack+1477, NULL);
 _BUILD_00m0(Data,vrr_stack+1325, vrr_stack+2272, vrr_stack+759, vrr_stack+2352, vrr_stack+163, NULL);
 _BUILD_00n0(Data,vrr_stack+2317, vrr_stack+1325, vrr_stack+804, vrr_stack+2272, vrr_stack+759, NULL);
   tmp = vrr_stack + 2317;
   target_ptr = Libint->vrr_classes[0][10];
   for(i=0;i<66;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+1380, vrr_stack+2317, vrr_stack+859, vrr_stack+1325, vrr_stack+804, NULL);
   tmp = vrr_stack + 1380;
   target_ptr = Libint->vrr_classes[0][11];
   for(i=0;i<78;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+759, vrr_stack+1380, vrr_stack+2528, vrr_stack+2317, vrr_stack+859, NULL);
   tmp = vrr_stack + 759;
   target_ptr = Libint->vrr_classes[0][12];
   for(i=0;i<91;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2272, vrr_stack+759, vrr_stack+469, vrr_stack+1380, vrr_stack+2528, NULL);
   tmp = vrr_stack + 2272;
   target_ptr = Libint->vrr_classes[0][13];
   for(i=0;i<105;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+1325, vrr_stack+2272, vrr_stack+2606, vrr_stack+759, vrr_stack+469, NULL);
   tmp = vrr_stack + 1325;
   target_ptr = Libint->vrr_classes[0][14];
   for(i=0;i<120;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+759, vrr_stack+1325, vrr_stack+925, vrr_stack+2272, vrr_stack+2606, NULL);
   tmp = vrr_stack + 759;
   target_ptr = Libint->vrr_classes[0][15];
   for(i=0;i<136;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+2528, vrr_stack+759, vrr_stack+1628, vrr_stack+1325, vrr_stack+925, NULL);
   tmp = vrr_stack + 2528;
   target_ptr = Libint->vrr_classes[0][16];
   for(i=0;i<153;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+1325, vrr_stack+2528, vrr_stack+3120, vrr_stack+759, vrr_stack+1628, NULL);
   tmp = vrr_stack + 1325;
   target_ptr = Libint->vrr_classes[0][17];
   for(i=0;i<171;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+759, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+762, vrr_stack+1764, vrr_stack+759, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+1767, vrr_stack+762, vrr_stack+31, vrr_stack+1764, NULL);
 _BUILD_00g0(Data,vrr_stack+759, vrr_stack+86, vrr_stack+21, vrr_stack+34, vrr_stack+1767, NULL);
 _BUILD_00h0(Data,vrr_stack+774, vrr_stack+1773, vrr_stack+759, vrr_stack+40, vrr_stack+86, NULL);
 _BUILD_00i0(Data,vrr_stack+21, vrr_stack+0, vrr_stack+774, vrr_stack+50, vrr_stack+1773, NULL);
 _BUILD_00k0(Data,vrr_stack+759, vrr_stack+96, vrr_stack+21, vrr_stack+65, vrr_stack+0, NULL);
 _BUILD_00l0(Data,vrr_stack+0, vrr_stack+124, vrr_stack+759, vrr_stack+1078, vrr_stack+96, NULL);
 _BUILD_00m0(Data,vrr_stack+759, vrr_stack+1788, vrr_stack+0, vrr_stack+1106, vrr_stack+124, NULL);
 _BUILD_00n0(Data,vrr_stack+0, vrr_stack+1833, vrr_stack+759, vrr_stack+569, vrr_stack+1788, NULL);
 _BUILD_00o0(Data,vrr_stack+759, vrr_stack+199, vrr_stack+0, vrr_stack+614, vrr_stack+1833, NULL);
 _BUILD_00q0(Data,vrr_stack+0, vrr_stack+1142, vrr_stack+759, vrr_stack+1890, vrr_stack+199, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+759, vrr_stack+265, vrr_stack+0, vrr_stack+681, vrr_stack+1142, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2272, vrr_stack+1220, vrr_stack+759, vrr_stack+1956, vrr_stack+265, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+2711, vrr_stack+2272, vrr_stack+2047, vrr_stack+1220, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+136, vrr_stack+2831, vrr_stack+0, vrr_stack+2152, vrr_stack+2711, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+289, vrr_stack+2967, vrr_stack+136, vrr_stack+2392, vrr_stack+2831, NULL);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+3273, vrr_stack+289, vrr_stack+3120, vrr_stack+2967, NULL);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+190, vrr_stack+1325, vrr_stack+3273, vrr_stack+2528, vrr_stack+3120, NULL);
   tmp = vrr_stack + 190;
   target_ptr = Libint->vrr_classes[0][18];
   for(i=0;i<190;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+380, vrr_stack+190, vrr_stack+0, vrr_stack+1325, vrr_stack+3273, NULL);
   tmp = vrr_stack + 380;
   target_ptr = Libint->vrr_classes[0][19];
   for(i=0;i<210;i++)
     target_ptr[i] += tmp[i];

}

