/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (dd|m0) integrals */

void vrr_order_ddm0(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+6, Data->F+7, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+34, vrr_stack+15, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+50, vrr_stack+6, vrr_stack+3, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+56, vrr_stack+9, vrr_stack+50, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+66, vrr_stack+21, vrr_stack+56, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+81, vrr_stack+66, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+50, vrr_stack+15, vrr_stack+6, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+127, vrr_stack+56, vrr_stack+117, vrr_stack+9, vrr_stack+50, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+66, vrr_stack+127, vrr_stack+21, vrr_stack+56, NULL);
 _BUILD_00i0(Data,vrr_stack+163, vrr_stack+96, vrr_stack+142, vrr_stack+81, vrr_stack+66, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+21, vrr_stack+31, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+191, vrr_stack+24, vrr_stack+34, vrr_stack+21, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+201, vrr_stack+191, vrr_stack+40, vrr_stack+24, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+216, vrr_stack+201, vrr_stack+81, vrr_stack+191, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+237, vrr_stack+216, vrr_stack+96, vrr_stack+201, vrr_stack+81, NULL);
 _BUILD_p0i0(Data,vrr_stack+265, vrr_stack+237, vrr_stack+163, NULL, NULL, vrr_stack+96);
 _BUILD_00k0(Data,vrr_stack+349, vrr_stack+237, vrr_stack+163, vrr_stack+216, vrr_stack+96, NULL);
 _BUILD_00p0(Data,vrr_stack+81, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+84, vrr_stack+81, vrr_stack+21, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+84, vrr_stack+24, vrr_stack+81, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+385, vrr_stack+30, vrr_stack+191, vrr_stack+84, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+400, vrr_stack+385, vrr_stack+201, vrr_stack+30, vrr_stack+191, NULL);
 _BUILD_00i0(Data,vrr_stack+421, vrr_stack+400, vrr_stack+216, vrr_stack+385, vrr_stack+201, NULL);
 _BUILD_00k0(Data,vrr_stack+449, vrr_stack+421, vrr_stack+237, vrr_stack+400, vrr_stack+216, NULL);
 _BUILD_00p0(Data,vrr_stack+191, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+90, vrr_stack+0, vrr_stack+191, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+15, vrr_stack+90, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+194, vrr_stack+117, vrr_stack+40, vrr_stack+50, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+209, vrr_stack+127, vrr_stack+194, vrr_stack+56, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+485, vrr_stack+142, vrr_stack+209, vrr_stack+66, vrr_stack+127, NULL);
 _BUILD_00k0(Data,vrr_stack+513, vrr_stack+163, vrr_stack+485, vrr_stack+96, vrr_stack+142, NULL);
 _BUILD_p0k0(Data,vrr_stack+549, vrr_stack+349, vrr_stack+513, NULL, NULL, vrr_stack+163);
 _BUILD_p0k0(Data,vrr_stack+657, vrr_stack+449, vrr_stack+349, NULL, NULL, vrr_stack+237);
 _BUILD_d0k0(Data,vrr_stack+765, vrr_stack+657, vrr_stack+549, vrr_stack+449, vrr_stack+349, vrr_stack+265);
 _BUILD_00l0(Data,vrr_stack+265, vrr_stack+349, vrr_stack+513, vrr_stack+237, vrr_stack+163, NULL);
 _BUILD_00l0(Data,vrr_stack+981, vrr_stack+449, vrr_stack+349, vrr_stack+421, vrr_stack+237, NULL);
 _BUILD_p0l0(Data,vrr_stack+1026, vrr_stack+981, vrr_stack+265, NULL, NULL, vrr_stack+349);
 _BUILD_00p0(Data,vrr_stack+310, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+313, vrr_stack+310, vrr_stack+81, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+319, vrr_stack+313, vrr_stack+84, vrr_stack+310, vrr_stack+81, NULL);
 _BUILD_00g0(Data,vrr_stack+329, vrr_stack+319, vrr_stack+30, vrr_stack+313, vrr_stack+84, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+329, vrr_stack+385, vrr_stack+319, vrr_stack+30, NULL);
 _BUILD_00i0(Data,vrr_stack+50, vrr_stack+96, vrr_stack+400, vrr_stack+329, vrr_stack+385, NULL);
 _BUILD_00k0(Data,vrr_stack+1161, vrr_stack+50, vrr_stack+421, vrr_stack+96, vrr_stack+400, NULL);
 _BUILD_00l0(Data,vrr_stack+1197, vrr_stack+1161, vrr_stack+449, vrr_stack+50, vrr_stack+421, NULL);
 _BUILD_p0l0(Data,vrr_stack+1242, vrr_stack+1197, vrr_stack+981, NULL, NULL, vrr_stack+449);
 _BUILD_00p0(Data,vrr_stack+385, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+388, vrr_stack+191, vrr_stack+385, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+394, vrr_stack+90, vrr_stack+388, vrr_stack+0, vrr_stack+191, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+40, vrr_stack+394, vrr_stack+15, vrr_stack+90, NULL);
 _BUILD_00h0(Data,vrr_stack+15, vrr_stack+194, vrr_stack+0, vrr_stack+117, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+404, vrr_stack+209, vrr_stack+15, vrr_stack+127, vrr_stack+194, NULL);
 _BUILD_00k0(Data,vrr_stack+1377, vrr_stack+485, vrr_stack+404, vrr_stack+142, vrr_stack+209, NULL);
 _BUILD_00l0(Data,vrr_stack+117, vrr_stack+513, vrr_stack+1377, vrr_stack+163, vrr_stack+485, NULL);
 _BUILD_p0l0(Data,vrr_stack+1413, vrr_stack+265, vrr_stack+117, NULL, NULL, vrr_stack+513);
 _BUILD_d0l0(Data,vrr_stack+1548, vrr_stack+1026, vrr_stack+1413, vrr_stack+981, vrr_stack+265, vrr_stack+549);
 _BUILD_d0l0(Data,vrr_stack+1818, vrr_stack+1242, vrr_stack+1026, vrr_stack+1197, vrr_stack+981, vrr_stack+657);
 _BUILD_f0l0(Data,vrr_stack+2088, vrr_stack+1818, vrr_stack+1548, vrr_stack+1242, vrr_stack+1026, vrr_stack+765);
 _BUILD_00m0(Data,vrr_stack+549, vrr_stack+981, vrr_stack+265, vrr_stack+449, vrr_stack+349, NULL);
 _BUILD_00m0(Data,vrr_stack+604, vrr_stack+1197, vrr_stack+981, vrr_stack+1161, vrr_stack+449, NULL);
 _BUILD_00m0(Data,vrr_stack+659, vrr_stack+265, vrr_stack+117, vrr_stack+349, vrr_stack+513, NULL);
 _BUILD_p0m0(Data,vrr_stack+714, vrr_stack+549, vrr_stack+659, NULL, NULL, vrr_stack+265);
 _BUILD_p0m0(Data,vrr_stack+2538, vrr_stack+604, vrr_stack+549, NULL, NULL, vrr_stack+981);
 _BUILD_d0m0(Data,vrr_stack+2703, vrr_stack+2538, vrr_stack+714, vrr_stack+604, vrr_stack+549, vrr_stack+1026);
 _BUILD_00p0(Data,vrr_stack+879, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+882, vrr_stack+879, vrr_stack+310, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+888, vrr_stack+882, vrr_stack+313, vrr_stack+879, vrr_stack+310, NULL);
 _BUILD_00g0(Data,vrr_stack+898, vrr_stack+888, vrr_stack+319, vrr_stack+882, vrr_stack+313, NULL);
 _BUILD_00h0(Data,vrr_stack+913, vrr_stack+898, vrr_stack+329, vrr_stack+888, vrr_stack+319, NULL);
 _BUILD_00i0(Data,vrr_stack+934, vrr_stack+913, vrr_stack+96, vrr_stack+898, vrr_stack+329, NULL);
 _BUILD_00k0(Data,vrr_stack+962, vrr_stack+934, vrr_stack+50, vrr_stack+913, vrr_stack+96, NULL);
 _BUILD_00l0(Data,vrr_stack+879, vrr_stack+962, vrr_stack+1161, vrr_stack+934, vrr_stack+50, NULL);
 _BUILD_00m0(Data,vrr_stack+998, vrr_stack+879, vrr_stack+1197, vrr_stack+962, vrr_stack+1161, NULL);
 _BUILD_p0m0(Data,vrr_stack+3033, vrr_stack+998, vrr_stack+604, NULL, NULL, vrr_stack+1197);
 _BUILD_d0m0(Data,vrr_stack+3198, vrr_stack+3033, vrr_stack+2538, vrr_stack+998, vrr_stack+604, vrr_stack+1242);
   tmp = vrr_stack + 3198;
   target_ptr = Libint->vrr_classes[2][9];
   for(i=0;i<330;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+604, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+607, vrr_stack+385, vrr_stack+604, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+613, vrr_stack+388, vrr_stack+607, vrr_stack+191, vrr_stack+385, NULL);
 _BUILD_00g0(Data,vrr_stack+623, vrr_stack+394, vrr_stack+613, vrr_stack+90, vrr_stack+388, NULL);
 _BUILD_00h0(Data,vrr_stack+638, vrr_stack+0, vrr_stack+623, vrr_stack+40, vrr_stack+394, NULL);
 _BUILD_00i0(Data,vrr_stack+604, vrr_stack+15, vrr_stack+638, vrr_stack+194, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+879, vrr_stack+404, vrr_stack+604, vrr_stack+209, vrr_stack+15, NULL);
 _BUILD_00l0(Data,vrr_stack+604, vrr_stack+1377, vrr_stack+879, vrr_stack+485, vrr_stack+404, NULL);
 _BUILD_00m0(Data,vrr_stack+879, vrr_stack+117, vrr_stack+604, vrr_stack+513, vrr_stack+1377, NULL);
 _BUILD_p0m0(Data,vrr_stack+934, vrr_stack+659, vrr_stack+879, NULL, NULL, vrr_stack+117);
 _BUILD_d0m0(Data,vrr_stack+0, vrr_stack+714, vrr_stack+934, vrr_stack+549, vrr_stack+659, vrr_stack+1413);
 _BUILD_f0m0(Data,vrr_stack+879, vrr_stack+2703, vrr_stack+0, vrr_stack+2538, vrr_stack+714, vrr_stack+1548);
 _BUILD_f0m0(Data,vrr_stack+0, vrr_stack+3198, vrr_stack+2703, vrr_stack+3033, vrr_stack+2538, vrr_stack+1818);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[3][9];
   for(i=0;i<550;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0m0(Data,vrr_stack+3528, vrr_stack+0, vrr_stack+879, vrr_stack+3198, vrr_stack+2703, vrr_stack+2088);
   tmp = vrr_stack + 3528;
   target_ptr = Libint->vrr_classes[4][9];
   for(i=0;i<825;i++)
     target_ptr[i] += tmp[i];

}

