/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (g0|ig) integrals */

void vrr_order_g0ig(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+0, vrr_stack+12, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+6, vrr_stack+15, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+34, vrr_stack+6, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+50, vrr_stack+40, vrr_stack+21, NULL, NULL, vrr_stack+6);
 _BUILD_00g0(Data,vrr_stack+80, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+6, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+95, vrr_stack+3, vrr_stack+31, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+101, vrr_stack+95, vrr_stack+34, vrr_stack+3, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+111, vrr_stack+101, vrr_stack+40, vrr_stack+95, vrr_stack+34, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+12, vrr_stack+31, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+126, vrr_stack+15, vrr_stack+34, vrr_stack+0, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+136, vrr_stack+21, vrr_stack+126, vrr_stack+6, vrr_stack+15, NULL);
 _BUILD_p0g0(Data,vrr_stack+151, vrr_stack+80, vrr_stack+136, NULL, NULL, vrr_stack+21);
 _BUILD_p0g0(Data,vrr_stack+196, vrr_stack+111, vrr_stack+80, NULL, NULL, vrr_stack+40);
 _BUILD_d0g0(Data,vrr_stack+241, vrr_stack+196, vrr_stack+151, vrr_stack+111, vrr_stack+80, vrr_stack+50);
 _BUILD_00h0(Data,vrr_stack+50, vrr_stack+80, vrr_stack+136, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+331, vrr_stack+111, vrr_stack+80, vrr_stack+101, vrr_stack+40, NULL);
 _BUILD_p0h0(Data,vrr_stack+352, vrr_stack+331, vrr_stack+50, NULL, NULL, vrr_stack+80);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+0, vrr_stack+3, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+6, vrr_stack+95, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+415, vrr_stack+40, vrr_stack+101, vrr_stack+6, vrr_stack+95, NULL);
 _BUILD_00h0(Data,vrr_stack+430, vrr_stack+415, vrr_stack+111, vrr_stack+40, vrr_stack+101, NULL);
 _BUILD_p0h0(Data,vrr_stack+451, vrr_stack+430, vrr_stack+331, NULL, NULL, vrr_stack+111);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+95, vrr_stack+31, vrr_stack+3, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+101, vrr_stack+34, vrr_stack+95, vrr_stack+12, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+514, vrr_stack+126, vrr_stack+101, vrr_stack+15, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+529, vrr_stack+136, vrr_stack+514, vrr_stack+21, vrr_stack+126, NULL);
 _BUILD_p0h0(Data,vrr_stack+550, vrr_stack+50, vrr_stack+529, NULL, NULL, vrr_stack+136);
 _BUILD_d0h0(Data,vrr_stack+613, vrr_stack+352, vrr_stack+550, vrr_stack+331, vrr_stack+50, vrr_stack+151);
 _BUILD_d0h0(Data,vrr_stack+739, vrr_stack+451, vrr_stack+352, vrr_stack+430, vrr_stack+331, vrr_stack+196);
 _BUILD_f0h0(Data,vrr_stack+865, vrr_stack+739, vrr_stack+613, vrr_stack+451, vrr_stack+352, vrr_stack+241);
 _BUILD_00i0(Data,vrr_stack+151, vrr_stack+331, vrr_stack+50, vrr_stack+111, vrr_stack+80, NULL);
 _BUILD_00i0(Data,vrr_stack+179, vrr_stack+430, vrr_stack+331, vrr_stack+415, vrr_stack+111, NULL);
 _BUILD_00i0(Data,vrr_stack+207, vrr_stack+50, vrr_stack+529, vrr_stack+80, vrr_stack+136, NULL);
 _BUILD_p0i0(Data,vrr_stack+235, vrr_stack+151, vrr_stack+207, NULL, NULL, vrr_stack+50);
 _BUILD_p0i0(Data,vrr_stack+1075, vrr_stack+179, vrr_stack+151, NULL, NULL, vrr_stack+331);
 _BUILD_d0i0(Data,vrr_stack+1159, vrr_stack+1075, vrr_stack+235, vrr_stack+179, vrr_stack+151, vrr_stack+352);
 _BUILD_00p0(Data,vrr_stack+352, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+355, vrr_stack+352, vrr_stack+0, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+361, vrr_stack+355, vrr_stack+6, vrr_stack+352, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+111, vrr_stack+361, vrr_stack+40, vrr_stack+355, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+6, vrr_stack+111, vrr_stack+415, vrr_stack+361, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+352, vrr_stack+6, vrr_stack+430, vrr_stack+111, vrr_stack+415, NULL);
 _BUILD_p0i0(Data,vrr_stack+1327, vrr_stack+352, vrr_stack+179, NULL, NULL, vrr_stack+430);
 _BUILD_d0i0(Data,vrr_stack+1411, vrr_stack+1327, vrr_stack+1075, vrr_stack+352, vrr_stack+179, vrr_stack+451);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+451, vrr_stack+3, vrr_stack+0, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+95, vrr_stack+451, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+111, vrr_stack+101, vrr_stack+40, vrr_stack+34, vrr_stack+95, NULL);
 _BUILD_00h0(Data,vrr_stack+457, vrr_stack+514, vrr_stack+111, vrr_stack+126, vrr_stack+101, NULL);
 _BUILD_00i0(Data,vrr_stack+478, vrr_stack+529, vrr_stack+457, vrr_stack+136, vrr_stack+514, NULL);
 _BUILD_p0i0(Data,vrr_stack+1579, vrr_stack+207, vrr_stack+478, NULL, NULL, vrr_stack+529);
 _BUILD_d0i0(Data,vrr_stack+1663, vrr_stack+235, vrr_stack+1579, vrr_stack+151, vrr_stack+207, vrr_stack+550);
 _BUILD_f0i0(Data,vrr_stack+1831, vrr_stack+1159, vrr_stack+1663, vrr_stack+1075, vrr_stack+235, vrr_stack+613);
 _BUILD_f0i0(Data,vrr_stack+2111, vrr_stack+1411, vrr_stack+1159, vrr_stack+1327, vrr_stack+1075, vrr_stack+739);
 _BUILD_00k0(Data,vrr_stack+1327, vrr_stack+151, vrr_stack+207, vrr_stack+331, vrr_stack+50, NULL);
 _BUILD_00k0(Data,vrr_stack+1363, vrr_stack+179, vrr_stack+151, vrr_stack+430, vrr_stack+331, NULL);
 _BUILD_00k0(Data,vrr_stack+550, vrr_stack+207, vrr_stack+478, vrr_stack+50, vrr_stack+529, NULL);
 _BUILD_p0k0(Data,vrr_stack+586, vrr_stack+1327, vrr_stack+550, NULL, NULL, vrr_stack+207);
 _BUILD_p0k0(Data,vrr_stack+694, vrr_stack+1363, vrr_stack+1327, NULL, NULL, vrr_stack+151);
 _BUILD_d0k0(Data,vrr_stack+2391, vrr_stack+694, vrr_stack+586, vrr_stack+1363, vrr_stack+1327, vrr_stack+235);
 _BUILD_00k0(Data,vrr_stack+235, vrr_stack+352, vrr_stack+179, vrr_stack+6, vrr_stack+430, NULL);
 _BUILD_p0k0(Data,vrr_stack+2607, vrr_stack+235, vrr_stack+1363, NULL, NULL, vrr_stack+179);
 _BUILD_d0k0(Data,vrr_stack+2715, vrr_stack+2607, vrr_stack+694, vrr_stack+235, vrr_stack+1363, vrr_stack+1075);
 _BUILD_00p0(Data,vrr_stack+1075, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1078, vrr_stack+0, vrr_stack+1075, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+1084, vrr_stack+451, vrr_stack+1078, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+40, vrr_stack+1084, vrr_stack+95, vrr_stack+451, NULL);
 _BUILD_00h0(Data,vrr_stack+18, vrr_stack+111, vrr_stack+3, vrr_stack+101, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+1094, vrr_stack+457, vrr_stack+18, vrr_stack+514, vrr_stack+111, NULL);
 _BUILD_00k0(Data,vrr_stack+1122, vrr_stack+478, vrr_stack+1094, vrr_stack+529, vrr_stack+457, NULL);
 _BUILD_p0k0(Data,vrr_stack+2931, vrr_stack+550, vrr_stack+1122, NULL, NULL, vrr_stack+478);
 _BUILD_d0k0(Data,vrr_stack+3039, vrr_stack+586, vrr_stack+2931, vrr_stack+1327, vrr_stack+550, vrr_stack+1579);
 _BUILD_f0k0(Data,vrr_stack+3255, vrr_stack+2391, vrr_stack+3039, vrr_stack+694, vrr_stack+586, vrr_stack+1663);
 _BUILD_f0k0(Data,vrr_stack+3615, vrr_stack+2715, vrr_stack+2391, vrr_stack+2607, vrr_stack+694, vrr_stack+1159);
 _BUILD_00l0(Data,vrr_stack+2607, vrr_stack+1327, vrr_stack+550, vrr_stack+151, vrr_stack+207, NULL);
 _BUILD_00l0(Data,vrr_stack+2652, vrr_stack+1363, vrr_stack+1327, vrr_stack+179, vrr_stack+151, NULL);
 _BUILD_00l0(Data,vrr_stack+1579, vrr_stack+550, vrr_stack+1122, vrr_stack+207, vrr_stack+478, NULL);
 _BUILD_p0l0(Data,vrr_stack+1624, vrr_stack+2607, vrr_stack+1579, NULL, NULL, vrr_stack+550);
 _BUILD_p0l0(Data,vrr_stack+3975, vrr_stack+2652, vrr_stack+2607, NULL, NULL, vrr_stack+1327);
 _BUILD_d0l0(Data,vrr_stack+4110, vrr_stack+3975, vrr_stack+1624, vrr_stack+2652, vrr_stack+2607, vrr_stack+586);
 _BUILD_00l0(Data,vrr_stack+586, vrr_stack+235, vrr_stack+1363, vrr_stack+352, vrr_stack+179, NULL);
 _BUILD_p0l0(Data,vrr_stack+271, vrr_stack+586, vrr_stack+2652, NULL, NULL, vrr_stack+1363);
 _BUILD_d0l0(Data,vrr_stack+4380, vrr_stack+271, vrr_stack+3975, vrr_stack+586, vrr_stack+2652, vrr_stack+694);
 _BUILD_00p0(Data,vrr_stack+631, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+634, vrr_stack+1075, vrr_stack+631, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+640, vrr_stack+1078, vrr_stack+634, vrr_stack+0, vrr_stack+1075, NULL);
 _BUILD_00g0(Data,vrr_stack+650, vrr_stack+1084, vrr_stack+640, vrr_stack+451, vrr_stack+1078, NULL);
 _BUILD_00h0(Data,vrr_stack+665, vrr_stack+3, vrr_stack+650, vrr_stack+40, vrr_stack+1084, NULL);
 _BUILD_00i0(Data,vrr_stack+686, vrr_stack+18, vrr_stack+665, vrr_stack+111, vrr_stack+3, NULL);
 _BUILD_00k0(Data,vrr_stack+714, vrr_stack+1094, vrr_stack+686, vrr_stack+457, vrr_stack+18, NULL);
 _BUILD_00l0(Data,vrr_stack+750, vrr_stack+1122, vrr_stack+714, vrr_stack+478, vrr_stack+1094, NULL);
 _BUILD_p0l0(Data,vrr_stack+39, vrr_stack+1579, vrr_stack+750, NULL, NULL, vrr_stack+1122);
 _BUILD_d0l0(Data,vrr_stack+4650, vrr_stack+1624, vrr_stack+39, vrr_stack+2607, vrr_stack+1579, vrr_stack+2931);
 _BUILD_f0l0(Data,vrr_stack+4920, vrr_stack+4110, vrr_stack+4650, vrr_stack+3975, vrr_stack+1624, vrr_stack+3039);
 _BUILD_f0l0(Data,vrr_stack+5370, vrr_stack+4380, vrr_stack+4110, vrr_stack+271, vrr_stack+3975, vrr_stack+2391);
 _BUILD_00m0(Data,vrr_stack+271, vrr_stack+2607, vrr_stack+1579, vrr_stack+1327, vrr_stack+550, NULL);
 _BUILD_00m0(Data,vrr_stack+326, vrr_stack+2652, vrr_stack+2607, vrr_stack+1363, vrr_stack+1327, NULL);
 _BUILD_00m0(Data,vrr_stack+381, vrr_stack+1579, vrr_stack+750, vrr_stack+550, vrr_stack+1122, NULL);
 _BUILD_p0m0(Data,vrr_stack+2931, vrr_stack+271, vrr_stack+381, NULL, NULL, vrr_stack+1579);
 _BUILD_p0m0(Data,vrr_stack+5820, vrr_stack+326, vrr_stack+271, NULL, NULL, vrr_stack+2607);
 _BUILD_d0m0(Data,vrr_stack+5985, vrr_stack+5820, vrr_stack+2931, vrr_stack+326, vrr_stack+271, vrr_stack+1624);
 _BUILD_00m0(Data,vrr_stack+1624, vrr_stack+586, vrr_stack+2652, vrr_stack+235, vrr_stack+1363, NULL);
 _BUILD_p0m0(Data,vrr_stack+6315, vrr_stack+1624, vrr_stack+326, NULL, NULL, vrr_stack+2652);
 _BUILD_d0m0(Data,vrr_stack+6480, vrr_stack+6315, vrr_stack+5820, vrr_stack+1624, vrr_stack+326, vrr_stack+3975);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3975, vrr_stack+631, vrr_stack+0, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+3981, vrr_stack+634, vrr_stack+3975, vrr_stack+1075, vrr_stack+631, NULL);
 _BUILD_00g0(Data,vrr_stack+3991, vrr_stack+640, vrr_stack+3981, vrr_stack+1078, vrr_stack+634, NULL);
 _BUILD_00h0(Data,vrr_stack+4006, vrr_stack+650, vrr_stack+3991, vrr_stack+1084, vrr_stack+640, NULL);
 _BUILD_00i0(Data,vrr_stack+4027, vrr_stack+665, vrr_stack+4006, vrr_stack+3, vrr_stack+650, NULL);
 _BUILD_00k0(Data,vrr_stack+4055, vrr_stack+686, vrr_stack+4027, vrr_stack+18, vrr_stack+665, NULL);
 _BUILD_00l0(Data,vrr_stack+1679, vrr_stack+714, vrr_stack+4055, vrr_stack+1094, vrr_stack+686, NULL);
 _BUILD_00m0(Data,vrr_stack+1724, vrr_stack+750, vrr_stack+1679, vrr_stack+1122, vrr_stack+714, NULL);
 _BUILD_p0m0(Data,vrr_stack+6810, vrr_stack+381, vrr_stack+1724, NULL, NULL, vrr_stack+750);
 _BUILD_d0m0(Data,vrr_stack+6975, vrr_stack+2931, vrr_stack+6810, vrr_stack+271, vrr_stack+381, vrr_stack+39);
 _BUILD_f0m0(Data,vrr_stack+7305, vrr_stack+5985, vrr_stack+6975, vrr_stack+5820, vrr_stack+2931, vrr_stack+4650);
 _BUILD_f0m0(Data,vrr_stack+7855, vrr_stack+6480, vrr_stack+5985, vrr_stack+6315, vrr_stack+5820, vrr_stack+4110);
 _BUILD_00n0(Data,vrr_stack+6315, vrr_stack+271, vrr_stack+381, vrr_stack+2607, vrr_stack+1579, NULL);
 _BUILD_00n0(Data,vrr_stack+6381, vrr_stack+326, vrr_stack+271, vrr_stack+2652, vrr_stack+2607, NULL);
 _BUILD_00n0(Data,vrr_stack+4650, vrr_stack+381, vrr_stack+1724, vrr_stack+1579, vrr_stack+750, NULL);
 _BUILD_p0n0(Data,vrr_stack+4716, vrr_stack+6315, vrr_stack+4650, NULL, NULL, vrr_stack+381);
 _BUILD_p0n0(Data,vrr_stack+381, vrr_stack+6381, vrr_stack+6315, NULL, NULL, vrr_stack+271);
 _BUILD_d0n0(Data,vrr_stack+8405, vrr_stack+381, vrr_stack+4716, vrr_stack+6381, vrr_stack+6315, vrr_stack+2931);
 _BUILD_00n0(Data,vrr_stack+2931, vrr_stack+1624, vrr_stack+326, vrr_stack+586, vrr_stack+2652, NULL);
 _BUILD_p0n0(Data,vrr_stack+2997, vrr_stack+2931, vrr_stack+6381, NULL, NULL, vrr_stack+326);
 _BUILD_d0n0(Data,vrr_stack+8801, vrr_stack+2997, vrr_stack+381, vrr_stack+2931, vrr_stack+6381, vrr_stack+5820);
 _BUILD_00p0(Data,vrr_stack+5820, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+4914, vrr_stack+0, vrr_stack+5820, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+5820, vrr_stack+3975, vrr_stack+4914, vrr_stack+631, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+3981, vrr_stack+5820, vrr_stack+634, vrr_stack+3975, NULL);
 _BUILD_00h0(Data,vrr_stack+5820, vrr_stack+3991, vrr_stack+0, vrr_stack+640, vrr_stack+3981, NULL);
 _BUILD_00i0(Data,vrr_stack+0, vrr_stack+4006, vrr_stack+5820, vrr_stack+650, vrr_stack+3991, NULL);
 _BUILD_00k0(Data,vrr_stack+5820, vrr_stack+4027, vrr_stack+0, vrr_stack+665, vrr_stack+4006, NULL);
 _BUILD_00l0(Data,vrr_stack+0, vrr_stack+4055, vrr_stack+5820, vrr_stack+686, vrr_stack+4027, NULL);
 _BUILD_00m0(Data,vrr_stack+5820, vrr_stack+1679, vrr_stack+0, vrr_stack+714, vrr_stack+4055, NULL);
 _BUILD_00n0(Data,vrr_stack+2931, vrr_stack+1724, vrr_stack+5820, vrr_stack+750, vrr_stack+1679, NULL);
 _BUILD_p0n0(Data,vrr_stack+0, vrr_stack+4650, vrr_stack+2931, NULL, NULL, vrr_stack+1724);
 _BUILD_d0n0(Data,vrr_stack+9197, vrr_stack+4716, vrr_stack+0, vrr_stack+6315, vrr_stack+4650, vrr_stack+6810);
 _BUILD_f0n0(Data,vrr_stack+9593, vrr_stack+8405, vrr_stack+9197, vrr_stack+381, vrr_stack+4716, vrr_stack+6975);
 _BUILD_f0n0(Data,vrr_stack+10253, vrr_stack+8801, vrr_stack+8405, vrr_stack+2997, vrr_stack+381, vrr_stack+5985);
 _BUILD_g0i0(Data,vrr_stack+6810, vrr_stack+2111, vrr_stack+1831, vrr_stack+1411, vrr_stack+1159, vrr_stack+865);
   tmp = vrr_stack + 6810;
   target_ptr = Libint->vrr_classes[4][6];
   for(i=0;i<420;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0k0(Data,vrr_stack+0, vrr_stack+3615, vrr_stack+3255, vrr_stack+2715, vrr_stack+2391, vrr_stack+1831);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[4][7];
   for(i=0;i<540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0l0(Data,vrr_stack+540, vrr_stack+5370, vrr_stack+4920, vrr_stack+4380, vrr_stack+4110, vrr_stack+3255);
   tmp = vrr_stack + 540;
   target_ptr = Libint->vrr_classes[4][8];
   for(i=0;i<675;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0m0(Data,vrr_stack+1215, vrr_stack+7855, vrr_stack+7305, vrr_stack+6480, vrr_stack+5985, vrr_stack+4920);
   tmp = vrr_stack + 1215;
   target_ptr = Libint->vrr_classes[4][9];
   for(i=0;i<825;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0n0(Data,vrr_stack+2040, vrr_stack+10253, vrr_stack+9593, vrr_stack+8801, vrr_stack+8405, vrr_stack+7305);
   tmp = vrr_stack + 2040;
   target_ptr = Libint->vrr_classes[4][10];
   for(i=0;i<990;i++)
     target_ptr[i] += tmp[i];

}

