/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (kd|mp) integrals */

void vrr_order_kdmp(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, NULL, NULL, Data->F+9);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+8, Data->F+9, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+21, vrr_stack+3, Data->F+7, Data->F+8, NULL);
 _BUILD_00p0(Data,vrr_stack+30, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+33, vrr_stack+0, vrr_stack+30, Data->F+9, Data->F+10, NULL);
 _BUILD_p0d0(Data,vrr_stack+39, vrr_stack+15, vrr_stack+33, NULL, NULL, vrr_stack+0);
 _BUILD_p0d0(Data,vrr_stack+57, vrr_stack+24, vrr_stack+15, NULL, NULL, vrr_stack+3);
 _BUILD_d0d0(Data,vrr_stack+75, vrr_stack+57, vrr_stack+39, vrr_stack+24, vrr_stack+15, vrr_stack+6);
 _BUILD_00f0(Data,vrr_stack+111, vrr_stack+15, vrr_stack+33, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00f0(Data,vrr_stack+121, vrr_stack+24, vrr_stack+15, vrr_stack+21, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+131, vrr_stack+121, vrr_stack+111, NULL, NULL, vrr_stack+15);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+21, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+161, vrr_stack+6, vrr_stack+24, vrr_stack+3, vrr_stack+21, NULL);
 _BUILD_p0f0(Data,vrr_stack+171, vrr_stack+161, vrr_stack+121, NULL, NULL, vrr_stack+24);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+201, vrr_stack+30, vrr_stack+21, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+207, vrr_stack+33, vrr_stack+201, vrr_stack+0, vrr_stack+30, NULL);
 _BUILD_p0f0(Data,vrr_stack+217, vrr_stack+111, vrr_stack+207, NULL, NULL, vrr_stack+33);
 _BUILD_d0f0(Data,vrr_stack+247, vrr_stack+131, vrr_stack+217, vrr_stack+121, vrr_stack+111, vrr_stack+39);
 _BUILD_d0f0(Data,vrr_stack+307, vrr_stack+171, vrr_stack+131, vrr_stack+161, vrr_stack+121, vrr_stack+57);
 _BUILD_f0f0(Data,vrr_stack+367, vrr_stack+307, vrr_stack+247, vrr_stack+171, vrr_stack+131, vrr_stack+75);
 _BUILD_00g0(Data,vrr_stack+39, vrr_stack+121, vrr_stack+111, vrr_stack+24, vrr_stack+15, NULL);
 _BUILD_00g0(Data,vrr_stack+54, vrr_stack+161, vrr_stack+121, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_00g0(Data,vrr_stack+69, vrr_stack+111, vrr_stack+207, vrr_stack+15, vrr_stack+33, NULL);
 _BUILD_p0g0(Data,vrr_stack+467, vrr_stack+39, vrr_stack+69, NULL, NULL, vrr_stack+111);
 _BUILD_p0g0(Data,vrr_stack+512, vrr_stack+54, vrr_stack+39, NULL, NULL, vrr_stack+121);
 _BUILD_d0g0(Data,vrr_stack+557, vrr_stack+512, vrr_stack+467, vrr_stack+54, vrr_stack+39, vrr_stack+131);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+0, vrr_stack+3, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+131, vrr_stack+24, vrr_stack+6, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+141, vrr_stack+131, vrr_stack+161, vrr_stack+24, vrr_stack+6, NULL);
 _BUILD_p0g0(Data,vrr_stack+647, vrr_stack+141, vrr_stack+54, NULL, NULL, vrr_stack+161);
 _BUILD_d0g0(Data,vrr_stack+692, vrr_stack+647, vrr_stack+512, vrr_stack+141, vrr_stack+54, vrr_stack+171);
 _BUILD_00p0(Data,vrr_stack+171, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+174, vrr_stack+21, vrr_stack+171, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+180, vrr_stack+201, vrr_stack+174, vrr_stack+30, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+207, vrr_stack+180, vrr_stack+33, vrr_stack+201, NULL);
 _BUILD_p0g0(Data,vrr_stack+782, vrr_stack+69, vrr_stack+3, NULL, NULL, vrr_stack+207);
 _BUILD_d0g0(Data,vrr_stack+827, vrr_stack+467, vrr_stack+782, vrr_stack+39, vrr_stack+69, vrr_stack+217);
 _BUILD_f0g0(Data,vrr_stack+917, vrr_stack+557, vrr_stack+827, vrr_stack+512, vrr_stack+467, vrr_stack+247);
 _BUILD_f0g0(Data,vrr_stack+1067, vrr_stack+692, vrr_stack+557, vrr_stack+647, vrr_stack+512, vrr_stack+307);
 _BUILD_g0g0(Data,vrr_stack+1217, vrr_stack+1067, vrr_stack+917, vrr_stack+692, vrr_stack+557, vrr_stack+367);
 _BUILD_00h0(Data,vrr_stack+217, vrr_stack+39, vrr_stack+69, vrr_stack+121, vrr_stack+111, NULL);
 _BUILD_00h0(Data,vrr_stack+238, vrr_stack+54, vrr_stack+39, vrr_stack+161, vrr_stack+121, NULL);
 _BUILD_p0h0(Data,vrr_stack+259, vrr_stack+238, vrr_stack+217, NULL, NULL, vrr_stack+39);
 _BUILD_00h0(Data,vrr_stack+322, vrr_stack+141, vrr_stack+54, vrr_stack+131, vrr_stack+161, NULL);
 _BUILD_p0h0(Data,vrr_stack+343, vrr_stack+322, vrr_stack+238, NULL, NULL, vrr_stack+54);
 _BUILD_00h0(Data,vrr_stack+406, vrr_stack+69, vrr_stack+3, vrr_stack+111, vrr_stack+207, NULL);
 _BUILD_p0h0(Data,vrr_stack+1442, vrr_stack+217, vrr_stack+406, NULL, NULL, vrr_stack+69);
 _BUILD_d0h0(Data,vrr_stack+1505, vrr_stack+259, vrr_stack+1442, vrr_stack+238, vrr_stack+217, vrr_stack+467);
 _BUILD_d0h0(Data,vrr_stack+1631, vrr_stack+343, vrr_stack+259, vrr_stack+322, vrr_stack+238, vrr_stack+512);
 _BUILD_f0h0(Data,vrr_stack+1757, vrr_stack+1631, vrr_stack+1505, vrr_stack+343, vrr_stack+259, vrr_stack+557);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+427, vrr_stack+18, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+433, vrr_stack+427, vrr_stack+24, vrr_stack+18, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+156, vrr_stack+433, vrr_stack+131, vrr_stack+427, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+443, vrr_stack+156, vrr_stack+141, vrr_stack+433, vrr_stack+131, NULL);
 _BUILD_p0h0(Data,vrr_stack+464, vrr_stack+443, vrr_stack+322, NULL, NULL, vrr_stack+141);
 _BUILD_d0h0(Data,vrr_stack+1967, vrr_stack+464, vrr_stack+343, vrr_stack+443, vrr_stack+322, vrr_stack+647);
 _BUILD_f0h0(Data,vrr_stack+2093, vrr_stack+1967, vrr_stack+1631, vrr_stack+464, vrr_stack+343, vrr_stack+692);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+171, vrr_stack+0, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+527, vrr_stack+174, vrr_stack+24, vrr_stack+21, vrr_stack+171, NULL);
 _BUILD_00g0(Data,vrr_stack+537, vrr_stack+180, vrr_stack+527, vrr_stack+201, vrr_stack+174, NULL);
 _BUILD_00h0(Data,vrr_stack+552, vrr_stack+3, vrr_stack+537, vrr_stack+207, vrr_stack+180, NULL);
 _BUILD_p0h0(Data,vrr_stack+573, vrr_stack+406, vrr_stack+552, NULL, NULL, vrr_stack+3);
 _BUILD_d0h0(Data,vrr_stack+636, vrr_stack+1442, vrr_stack+573, vrr_stack+217, vrr_stack+406, vrr_stack+782);
 _BUILD_f0h0(Data,vrr_stack+2303, vrr_stack+1505, vrr_stack+636, vrr_stack+259, vrr_stack+1442, vrr_stack+827);
 _BUILD_g0h0(Data,vrr_stack+2513, vrr_stack+1757, vrr_stack+2303, vrr_stack+1631, vrr_stack+1505, vrr_stack+917);
 _BUILD_g0h0(Data,vrr_stack+2828, vrr_stack+2093, vrr_stack+1757, vrr_stack+1967, vrr_stack+1631, vrr_stack+1067);
 _BUILD_h0h0(Data,vrr_stack+762, vrr_stack+2828, vrr_stack+2513, vrr_stack+2093, vrr_stack+1757, vrr_stack+1217);
 _BUILD_00i0(Data,vrr_stack+1203, vrr_stack+238, vrr_stack+217, vrr_stack+54, vrr_stack+39, NULL);
 _BUILD_00i0(Data,vrr_stack+1231, vrr_stack+322, vrr_stack+238, vrr_stack+141, vrr_stack+54, NULL);
 _BUILD_00i0(Data,vrr_stack+1259, vrr_stack+217, vrr_stack+406, vrr_stack+39, vrr_stack+69, NULL);
 _BUILD_p0i0(Data,vrr_stack+1287, vrr_stack+1203, vrr_stack+1259, NULL, NULL, vrr_stack+217);
 _BUILD_p0i0(Data,vrr_stack+3143, vrr_stack+1231, vrr_stack+1203, NULL, NULL, vrr_stack+238);
 _BUILD_d0i0(Data,vrr_stack+3227, vrr_stack+3143, vrr_stack+1287, vrr_stack+1231, vrr_stack+1203, vrr_stack+259);
 _BUILD_00i0(Data,vrr_stack+259, vrr_stack+443, vrr_stack+322, vrr_stack+156, vrr_stack+141, NULL);
 _BUILD_p0i0(Data,vrr_stack+3395, vrr_stack+259, vrr_stack+1231, NULL, NULL, vrr_stack+322);
 _BUILD_d0i0(Data,vrr_stack+3479, vrr_stack+3395, vrr_stack+3143, vrr_stack+259, vrr_stack+1231, vrr_stack+343);
 _BUILD_00i0(Data,vrr_stack+343, vrr_stack+406, vrr_stack+552, vrr_stack+69, vrr_stack+3, NULL);
 _BUILD_p0i0(Data,vrr_stack+30, vrr_stack+1259, vrr_stack+343, NULL, NULL, vrr_stack+406);
 _BUILD_d0i0(Data,vrr_stack+3647, vrr_stack+1287, vrr_stack+30, vrr_stack+1203, vrr_stack+1259, vrr_stack+1442);
 _BUILD_f0i0(Data,vrr_stack+3815, vrr_stack+3227, vrr_stack+3647, vrr_stack+3143, vrr_stack+1287, vrr_stack+1505);
 _BUILD_f0i0(Data,vrr_stack+4095, vrr_stack+3479, vrr_stack+3227, vrr_stack+3395, vrr_stack+3143, vrr_stack+1631);
 _BUILD_g0i0(Data,vrr_stack+4375, vrr_stack+4095, vrr_stack+3815, vrr_stack+3479, vrr_stack+3227, vrr_stack+1757);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+371, vrr_stack+21, vrr_stack+18, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+377, vrr_stack+371, vrr_stack+427, vrr_stack+21, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+387, vrr_stack+377, vrr_stack+433, vrr_stack+371, vrr_stack+427, NULL);
 _BUILD_00h0(Data,vrr_stack+287, vrr_stack+387, vrr_stack+156, vrr_stack+377, vrr_stack+433, NULL);
 _BUILD_00i0(Data,vrr_stack+114, vrr_stack+287, vrr_stack+443, vrr_stack+387, vrr_stack+156, NULL);
 _BUILD_p0i0(Data,vrr_stack+1371, vrr_stack+114, vrr_stack+259, NULL, NULL, vrr_stack+443);
 _BUILD_d0i0(Data,vrr_stack+1455, vrr_stack+1371, vrr_stack+3395, vrr_stack+114, vrr_stack+259, vrr_stack+464);
 _BUILD_f0i0(Data,vrr_stack+1623, vrr_stack+1455, vrr_stack+3479, vrr_stack+1371, vrr_stack+3395, vrr_stack+1967);
 _BUILD_g0i0(Data,vrr_stack+4795, vrr_stack+1623, vrr_stack+4095, vrr_stack+1455, vrr_stack+3479, vrr_stack+2093);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+464, vrr_stack+0, vrr_stack+18, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+470, vrr_stack+24, vrr_stack+464, vrr_stack+171, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+480, vrr_stack+527, vrr_stack+470, vrr_stack+174, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+495, vrr_stack+537, vrr_stack+480, vrr_stack+180, vrr_stack+527, NULL);
 _BUILD_00i0(Data,vrr_stack+142, vrr_stack+552, vrr_stack+495, vrr_stack+3, vrr_stack+537, NULL);
 _BUILD_p0i0(Data,vrr_stack+1903, vrr_stack+343, vrr_stack+142, NULL, NULL, vrr_stack+552);
 _BUILD_d0i0(Data,vrr_stack+1987, vrr_stack+30, vrr_stack+1903, vrr_stack+1259, vrr_stack+343, vrr_stack+573);
 _BUILD_f0i0(Data,vrr_stack+5215, vrr_stack+3647, vrr_stack+1987, vrr_stack+1287, vrr_stack+30, vrr_stack+636);
 _BUILD_g0i0(Data,vrr_stack+5495, vrr_stack+3815, vrr_stack+5215, vrr_stack+3227, vrr_stack+3647, vrr_stack+2303);
 _BUILD_h0i0(Data,vrr_stack+5915, vrr_stack+4375, vrr_stack+5495, vrr_stack+4095, vrr_stack+3815, vrr_stack+2513);
 _BUILD_h0i0(Data,vrr_stack+2155, vrr_stack+4795, vrr_stack+4375, vrr_stack+1623, vrr_stack+4095, vrr_stack+2828);
 _BUILD_i0i0(Data,vrr_stack+6503, vrr_stack+2155, vrr_stack+5915, vrr_stack+4795, vrr_stack+4375, vrr_stack+762);
 _BUILD_00k0(Data,vrr_stack+573, vrr_stack+1203, vrr_stack+1259, vrr_stack+238, vrr_stack+217, NULL);
 _BUILD_00k0(Data,vrr_stack+609, vrr_stack+1231, vrr_stack+1203, vrr_stack+322, vrr_stack+238, NULL);
 _BUILD_p0k0(Data,vrr_stack+645, vrr_stack+609, vrr_stack+573, NULL, NULL, vrr_stack+1203);
 _BUILD_00k0(Data,vrr_stack+753, vrr_stack+259, vrr_stack+1231, vrr_stack+443, vrr_stack+322, NULL);
 _BUILD_p0k0(Data,vrr_stack+789, vrr_stack+753, vrr_stack+609, NULL, NULL, vrr_stack+1231);
 _BUILD_00k0(Data,vrr_stack+897, vrr_stack+1259, vrr_stack+343, vrr_stack+217, vrr_stack+406, NULL);
 _BUILD_p0k0(Data,vrr_stack+933, vrr_stack+573, vrr_stack+897, NULL, NULL, vrr_stack+1259);
 _BUILD_d0k0(Data,vrr_stack+2743, vrr_stack+645, vrr_stack+933, vrr_stack+609, vrr_stack+573, vrr_stack+1287);
 _BUILD_d0k0(Data,vrr_stack+7287, vrr_stack+789, vrr_stack+645, vrr_stack+753, vrr_stack+609, vrr_stack+3143);
 _BUILD_f0k0(Data,vrr_stack+7503, vrr_stack+7287, vrr_stack+2743, vrr_stack+789, vrr_stack+645, vrr_stack+3227);
 _BUILD_00k0(Data,vrr_stack+1287, vrr_stack+114, vrr_stack+259, vrr_stack+287, vrr_stack+443, NULL);
 _BUILD_p0k0(Data,vrr_stack+1041, vrr_stack+1287, vrr_stack+753, NULL, NULL, vrr_stack+259);
 _BUILD_d0k0(Data,vrr_stack+2959, vrr_stack+1041, vrr_stack+789, vrr_stack+1287, vrr_stack+753, vrr_stack+3395);
 _BUILD_f0k0(Data,vrr_stack+7863, vrr_stack+2959, vrr_stack+7287, vrr_stack+1041, vrr_stack+789, vrr_stack+3479);
 _BUILD_00k0(Data,vrr_stack+1323, vrr_stack+343, vrr_stack+142, vrr_stack+406, vrr_stack+552, NULL);
 _BUILD_p0k0(Data,vrr_stack+3175, vrr_stack+897, vrr_stack+1323, NULL, NULL, vrr_stack+343);
 _BUILD_d0k0(Data,vrr_stack+3283, vrr_stack+933, vrr_stack+3175, vrr_stack+573, vrr_stack+897, vrr_stack+30);
 _BUILD_f0k0(Data,vrr_stack+8223, vrr_stack+2743, vrr_stack+3283, vrr_stack+645, vrr_stack+933, vrr_stack+3647);
 _BUILD_g0k0(Data,vrr_stack+8583, vrr_stack+7503, vrr_stack+8223, vrr_stack+7287, vrr_stack+2743, vrr_stack+3815);
 _BUILD_g0k0(Data,vrr_stack+3499, vrr_stack+7863, vrr_stack+7503, vrr_stack+2959, vrr_stack+7287, vrr_stack+4095);
 _BUILD_h0k0(Data,vrr_stack+9123, vrr_stack+3499, vrr_stack+8583, vrr_stack+7863, vrr_stack+7503, vrr_stack+4375);
 _BUILD_00p0(Data,vrr_stack+30, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+33, vrr_stack+30, vrr_stack+21, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+39, vrr_stack+33, vrr_stack+371, vrr_stack+30, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+39, vrr_stack+377, vrr_stack+33, vrr_stack+371, NULL);
 _BUILD_00h0(Data,vrr_stack+49, vrr_stack+3, vrr_stack+387, vrr_stack+39, vrr_stack+377, NULL);
 _BUILD_00i0(Data,vrr_stack+70, vrr_stack+49, vrr_stack+287, vrr_stack+3, vrr_stack+387, NULL);
 _BUILD_00k0(Data,vrr_stack+371, vrr_stack+70, vrr_stack+114, vrr_stack+49, vrr_stack+287, NULL);
 _BUILD_p0k0(Data,vrr_stack+4039, vrr_stack+371, vrr_stack+1287, NULL, NULL, vrr_stack+114);
 _BUILD_d0k0(Data,vrr_stack+4147, vrr_stack+4039, vrr_stack+1041, vrr_stack+371, vrr_stack+1287, vrr_stack+1371);
 _BUILD_f0k0(Data,vrr_stack+4363, vrr_stack+4147, vrr_stack+2959, vrr_stack+4039, vrr_stack+1041, vrr_stack+1455);
 _BUILD_g0k0(Data,vrr_stack+9879, vrr_stack+4363, vrr_stack+7863, vrr_stack+4147, vrr_stack+2959, vrr_stack+1623);
 _BUILD_h0k0(Data,vrr_stack+10419, vrr_stack+9879, vrr_stack+3499, vrr_stack+4363, vrr_stack+7863, vrr_stack+4795);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+287, vrr_stack+18, vrr_stack+21, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+293, vrr_stack+464, vrr_stack+287, vrr_stack+0, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+303, vrr_stack+470, vrr_stack+293, vrr_stack+24, vrr_stack+464, NULL);
 _BUILD_00h0(Data,vrr_stack+318, vrr_stack+480, vrr_stack+303, vrr_stack+527, vrr_stack+470, NULL);
 _BUILD_00i0(Data,vrr_stack+407, vrr_stack+495, vrr_stack+318, vrr_stack+537, vrr_stack+480, NULL);
 _BUILD_00k0(Data,vrr_stack+516, vrr_stack+142, vrr_stack+407, vrr_stack+552, vrr_stack+495, NULL);
 _BUILD_p0k0(Data,vrr_stack+1359, vrr_stack+1323, vrr_stack+516, NULL, NULL, vrr_stack+142);
 _BUILD_d0k0(Data,vrr_stack+1467, vrr_stack+3175, vrr_stack+1359, vrr_stack+897, vrr_stack+1323, vrr_stack+1903);
 _BUILD_f0k0(Data,vrr_stack+4723, vrr_stack+3283, vrr_stack+1467, vrr_stack+933, vrr_stack+3175, vrr_stack+1987);
 _BUILD_g0k0(Data,vrr_stack+11175, vrr_stack+8223, vrr_stack+4723, vrr_stack+2743, vrr_stack+3283, vrr_stack+5215);
 _BUILD_h0k0(Data,vrr_stack+11715, vrr_stack+8583, vrr_stack+11175, vrr_stack+7503, vrr_stack+8223, vrr_stack+5495);
 _BUILD_i0k0(Data,vrr_stack+12471, vrr_stack+9123, vrr_stack+11715, vrr_stack+3499, vrr_stack+8583, vrr_stack+5915);
 _BUILD_i0k0(Data,vrr_stack+5083, vrr_stack+10419, vrr_stack+9123, vrr_stack+9879, vrr_stack+3499, vrr_stack+2155);
 _BUILD_k0k0(Data,vrr_stack+13479, vrr_stack+5083, vrr_stack+12471, vrr_stack+10419, vrr_stack+9123, vrr_stack+6503);
 _BUILD_00l0(Data,vrr_stack+1683, vrr_stack+609, vrr_stack+573, vrr_stack+1231, vrr_stack+1203, NULL);
 _BUILD_00l0(Data,vrr_stack+1728, vrr_stack+753, vrr_stack+609, vrr_stack+259, vrr_stack+1231, NULL);
 _BUILD_00l0(Data,vrr_stack+1773, vrr_stack+573, vrr_stack+897, vrr_stack+1203, vrr_stack+1259, NULL);
 _BUILD_p0l0(Data,vrr_stack+1818, vrr_stack+1683, vrr_stack+1773, NULL, NULL, vrr_stack+573);
 _BUILD_p0l0(Data,vrr_stack+1953, vrr_stack+1728, vrr_stack+1683, NULL, NULL, vrr_stack+609);
 _BUILD_d0l0(Data,vrr_stack+2088, vrr_stack+1953, vrr_stack+1818, vrr_stack+1728, vrr_stack+1683, vrr_stack+645);
 _BUILD_00l0(Data,vrr_stack+645, vrr_stack+1287, vrr_stack+753, vrr_stack+114, vrr_stack+259, NULL);
 _BUILD_p0l0(Data,vrr_stack+2358, vrr_stack+645, vrr_stack+1728, NULL, NULL, vrr_stack+753);
 _BUILD_d0l0(Data,vrr_stack+6091, vrr_stack+2358, vrr_stack+1953, vrr_stack+645, vrr_stack+1728, vrr_stack+789);
 _BUILD_00l0(Data,vrr_stack+789, vrr_stack+897, vrr_stack+1323, vrr_stack+1259, vrr_stack+343, NULL);
 _BUILD_p0l0(Data,vrr_stack+2493, vrr_stack+1773, vrr_stack+789, NULL, NULL, vrr_stack+897);
 _BUILD_d0l0(Data,vrr_stack+6361, vrr_stack+1818, vrr_stack+2493, vrr_stack+1683, vrr_stack+1773, vrr_stack+933);
 _BUILD_f0l0(Data,vrr_stack+6631, vrr_stack+2088, vrr_stack+6361, vrr_stack+1953, vrr_stack+1818, vrr_stack+2743);
 _BUILD_f0l0(Data,vrr_stack+14775, vrr_stack+6091, vrr_stack+2088, vrr_stack+2358, vrr_stack+1953, vrr_stack+7287);
 _BUILD_g0l0(Data,vrr_stack+15225, vrr_stack+14775, vrr_stack+6631, vrr_stack+6091, vrr_stack+2088, vrr_stack+7503);
 _BUILD_00l0(Data,vrr_stack+933, vrr_stack+371, vrr_stack+1287, vrr_stack+70, vrr_stack+114, NULL);
 _BUILD_p0l0(Data,vrr_stack+2628, vrr_stack+933, vrr_stack+645, NULL, NULL, vrr_stack+1287);
 _BUILD_d0l0(Data,vrr_stack+7081, vrr_stack+2628, vrr_stack+2358, vrr_stack+933, vrr_stack+645, vrr_stack+1041);
 _BUILD_f0l0(Data,vrr_stack+7351, vrr_stack+7081, vrr_stack+6091, vrr_stack+2628, vrr_stack+2358, vrr_stack+2959);
 _BUILD_g0l0(Data,vrr_stack+15900, vrr_stack+7351, vrr_stack+14775, vrr_stack+7081, vrr_stack+6091, vrr_stack+7863);
 _BUILD_00l0(Data,vrr_stack+978, vrr_stack+1323, vrr_stack+516, vrr_stack+343, vrr_stack+142, NULL);
 _BUILD_p0l0(Data,vrr_stack+1023, vrr_stack+789, vrr_stack+978, NULL, NULL, vrr_stack+1323);
 _BUILD_d0l0(Data,vrr_stack+2763, vrr_stack+2493, vrr_stack+1023, vrr_stack+1773, vrr_stack+789, vrr_stack+3175);
 _BUILD_f0l0(Data,vrr_stack+16575, vrr_stack+6361, vrr_stack+2763, vrr_stack+1818, vrr_stack+2493, vrr_stack+3283);
 _BUILD_g0l0(Data,vrr_stack+17025, vrr_stack+6631, vrr_stack+16575, vrr_stack+2088, vrr_stack+6361, vrr_stack+8223);
 _BUILD_h0l0(Data,vrr_stack+17700, vrr_stack+15225, vrr_stack+17025, vrr_stack+14775, vrr_stack+6631, vrr_stack+8583);
 _BUILD_h0l0(Data,vrr_stack+7801, vrr_stack+15900, vrr_stack+15225, vrr_stack+7351, vrr_stack+14775, vrr_stack+3499);
 _BUILD_i0l0(Data,vrr_stack+18645, vrr_stack+7801, vrr_stack+17700, vrr_stack+15900, vrr_stack+15225, vrr_stack+9123);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+0, vrr_stack+30, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+1158, vrr_stack+24, vrr_stack+33, vrr_stack+0, vrr_stack+30, NULL);
 _BUILD_00g0(Data,vrr_stack+1168, vrr_stack+1158, vrr_stack+39, vrr_stack+24, vrr_stack+33, NULL);
 _BUILD_00h0(Data,vrr_stack+552, vrr_stack+1168, vrr_stack+3, vrr_stack+1158, vrr_stack+39, NULL);
 _BUILD_00i0(Data,vrr_stack+1183, vrr_stack+552, vrr_stack+49, vrr_stack+1168, vrr_stack+3, NULL);
 _BUILD_00k0(Data,vrr_stack+1211, vrr_stack+1183, vrr_stack+70, vrr_stack+552, vrr_stack+49, NULL);
 _BUILD_00l0(Data,vrr_stack+834, vrr_stack+1211, vrr_stack+371, vrr_stack+1183, vrr_stack+70, NULL);
 _BUILD_p0l0(Data,vrr_stack+3033, vrr_stack+834, vrr_stack+933, NULL, NULL, vrr_stack+371);
 _BUILD_d0l0(Data,vrr_stack+3168, vrr_stack+3033, vrr_stack+2628, vrr_stack+834, vrr_stack+933, vrr_stack+4039);
 _BUILD_f0l0(Data,vrr_stack+3438, vrr_stack+3168, vrr_stack+7081, vrr_stack+3033, vrr_stack+2628, vrr_stack+4147);
 _BUILD_g0l0(Data,vrr_stack+8746, vrr_stack+3438, vrr_stack+7351, vrr_stack+3168, vrr_stack+7081, vrr_stack+4363);
 _BUILD_h0l0(Data,vrr_stack+19905, vrr_stack+8746, vrr_stack+15900, vrr_stack+3438, vrr_stack+7351, vrr_stack+9879);
 _BUILD_i0l0(Data,vrr_stack+20850, vrr_stack+19905, vrr_stack+7801, vrr_stack+8746, vrr_stack+15900, vrr_stack+10419);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+21, vrr_stack+3, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+287, vrr_stack+6, vrr_stack+18, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+40, vrr_stack+293, vrr_stack+30, vrr_stack+464, vrr_stack+287, NULL);
 _BUILD_00h0(Data,vrr_stack+55, vrr_stack+303, vrr_stack+40, vrr_stack+470, vrr_stack+293, NULL);
 _BUILD_00i0(Data,vrr_stack+76, vrr_stack+318, vrr_stack+55, vrr_stack+480, vrr_stack+303, NULL);
 _BUILD_00k0(Data,vrr_stack+104, vrr_stack+407, vrr_stack+76, vrr_stack+495, vrr_stack+318, NULL);
 _BUILD_00l0(Data,vrr_stack+690, vrr_stack+516, vrr_stack+104, vrr_stack+142, vrr_stack+407, NULL);
 _BUILD_p0l0(Data,vrr_stack+140, vrr_stack+978, vrr_stack+690, NULL, NULL, vrr_stack+516);
 _BUILD_d0l0(Data,vrr_stack+3888, vrr_stack+1023, vrr_stack+140, vrr_stack+789, vrr_stack+978, vrr_stack+1359);
 _BUILD_f0l0(Data,vrr_stack+4158, vrr_stack+2763, vrr_stack+3888, vrr_stack+2493, vrr_stack+1023, vrr_stack+1467);
 _BUILD_g0l0(Data,vrr_stack+9421, vrr_stack+16575, vrr_stack+4158, vrr_stack+6361, vrr_stack+2763, vrr_stack+4723);
 _BUILD_h0l0(Data,vrr_stack+10096, vrr_stack+17025, vrr_stack+9421, vrr_stack+6631, vrr_stack+16575, vrr_stack+11175);
 _BUILD_i0l0(Data,vrr_stack+22110, vrr_stack+17700, vrr_stack+10096, vrr_stack+15225, vrr_stack+17025, vrr_stack+11715);
 _BUILD_k0l0(Data,vrr_stack+23370, vrr_stack+18645, vrr_stack+22110, vrr_stack+7801, vrr_stack+17700, vrr_stack+12471);
 _BUILD_k0l0(Data,vrr_stack+11041, vrr_stack+20850, vrr_stack+18645, vrr_stack+19905, vrr_stack+7801, vrr_stack+5083);
 _BUILD_l0l0(Data,vrr_stack+24990, vrr_stack+11041, vrr_stack+23370, vrr_stack+20850, vrr_stack+18645, vrr_stack+13479);
 _BUILD_00m0(Data,vrr_stack+1359, vrr_stack+1683, vrr_stack+1773, vrr_stack+609, vrr_stack+573, NULL);
 _BUILD_00m0(Data,vrr_stack+1414, vrr_stack+1728, vrr_stack+1683, vrr_stack+753, vrr_stack+609, NULL);
 _BUILD_p0m0(Data,vrr_stack+1469, vrr_stack+1414, vrr_stack+1359, NULL, NULL, vrr_stack+1683);
 _BUILD_00m0(Data,vrr_stack+435, vrr_stack+645, vrr_stack+1728, vrr_stack+1287, vrr_stack+753, NULL);
 _BUILD_p0m0(Data,vrr_stack+4608, vrr_stack+435, vrr_stack+1414, NULL, NULL, vrr_stack+1728);
 _BUILD_00m0(Data,vrr_stack+4773, vrr_stack+1773, vrr_stack+789, vrr_stack+573, vrr_stack+897, NULL);
 _BUILD_p0m0(Data,vrr_stack+4828, vrr_stack+1359, vrr_stack+4773, NULL, NULL, vrr_stack+1773);
 _BUILD_d0m0(Data,vrr_stack+4993, vrr_stack+1469, vrr_stack+4828, vrr_stack+1414, vrr_stack+1359, vrr_stack+1818);
 _BUILD_d0m0(Data,vrr_stack+5323, vrr_stack+4608, vrr_stack+1469, vrr_stack+435, vrr_stack+1414, vrr_stack+1953);
 _BUILD_f0m0(Data,vrr_stack+12661, vrr_stack+5323, vrr_stack+4993, vrr_stack+4608, vrr_stack+1469, vrr_stack+2088);
 _BUILD_00m0(Data,vrr_stack+1818, vrr_stack+933, vrr_stack+645, vrr_stack+371, vrr_stack+1287, NULL);
 _BUILD_p0m0(Data,vrr_stack+1873, vrr_stack+1818, vrr_stack+435, NULL, NULL, vrr_stack+645);
 _BUILD_d0m0(Data,vrr_stack+5653, vrr_stack+1873, vrr_stack+4608, vrr_stack+1818, vrr_stack+435, vrr_stack+2358);
 _BUILD_f0m0(Data,vrr_stack+13211, vrr_stack+5653, vrr_stack+5323, vrr_stack+1873, vrr_stack+4608, vrr_stack+6091);
 _BUILD_00m0(Data,vrr_stack+2038, vrr_stack+789, vrr_stack+978, vrr_stack+897, vrr_stack+1323, NULL);
 _BUILD_p0m0(Data,vrr_stack+2093, vrr_stack+4773, vrr_stack+2038, NULL, NULL, vrr_stack+789);
 _BUILD_d0m0(Data,vrr_stack+5983, vrr_stack+4828, vrr_stack+2093, vrr_stack+1359, vrr_stack+4773, vrr_stack+2493);
 _BUILD_f0m0(Data,vrr_stack+13761, vrr_stack+4993, vrr_stack+5983, vrr_stack+1469, vrr_stack+4828, vrr_stack+6361);
 _BUILD_g0m0(Data,vrr_stack+27015, vrr_stack+12661, vrr_stack+13761, vrr_stack+5323, vrr_stack+4993, vrr_stack+6631);
 _BUILD_g0m0(Data,vrr_stack+27840, vrr_stack+13211, vrr_stack+12661, vrr_stack+5653, vrr_stack+5323, vrr_stack+14775);
 _BUILD_h0m0(Data,vrr_stack+28665, vrr_stack+27840, vrr_stack+27015, vrr_stack+13211, vrr_stack+12661, vrr_stack+15225);
 _BUILD_00m0(Data,vrr_stack+2258, vrr_stack+834, vrr_stack+933, vrr_stack+1211, vrr_stack+371, NULL);
 _BUILD_p0m0(Data,vrr_stack+2313, vrr_stack+2258, vrr_stack+1818, NULL, NULL, vrr_stack+933);
 _BUILD_d0m0(Data,vrr_stack+6313, vrr_stack+2313, vrr_stack+1873, vrr_stack+2258, vrr_stack+1818, vrr_stack+2628);
 _BUILD_f0m0(Data,vrr_stack+14311, vrr_stack+6313, vrr_stack+5653, vrr_stack+2313, vrr_stack+1873, vrr_stack+7081);
 _BUILD_g0m0(Data,vrr_stack+14861, vrr_stack+14311, vrr_stack+13211, vrr_stack+6313, vrr_stack+5653, vrr_stack+7351);
 _BUILD_h0m0(Data,vrr_stack+6643, vrr_stack+14861, vrr_stack+27840, vrr_stack+14311, vrr_stack+13211, vrr_stack+15900);
 _BUILD_00m0(Data,vrr_stack+2478, vrr_stack+978, vrr_stack+690, vrr_stack+1323, vrr_stack+516, NULL);
 _BUILD_p0m0(Data,vrr_stack+2533, vrr_stack+2038, vrr_stack+2478, NULL, NULL, vrr_stack+978);
 _BUILD_d0m0(Data,vrr_stack+15686, vrr_stack+2093, vrr_stack+2533, vrr_stack+4773, vrr_stack+2038, vrr_stack+1023);
 _BUILD_f0m0(Data,vrr_stack+16016, vrr_stack+5983, vrr_stack+15686, vrr_stack+4828, vrr_stack+2093, vrr_stack+2763);
 _BUILD_g0m0(Data,vrr_stack+29820, vrr_stack+13761, vrr_stack+16016, vrr_stack+4993, vrr_stack+5983, vrr_stack+16575);
 _BUILD_h0m0(Data,vrr_stack+30645, vrr_stack+27015, vrr_stack+29820, vrr_stack+12661, vrr_stack+13761, vrr_stack+17025);
 _BUILD_i0m0(Data,vrr_stack+31800, vrr_stack+28665, vrr_stack+30645, vrr_stack+27840, vrr_stack+27015, vrr_stack+17700);
 _BUILD_i0m0(Data,vrr_stack+16566, vrr_stack+6643, vrr_stack+28665, vrr_stack+14861, vrr_stack+27840, vrr_stack+7801);
 _BUILD_k0m0(Data,vrr_stack+33340, vrr_stack+16566, vrr_stack+31800, vrr_stack+6643, vrr_stack+28665, vrr_stack+18645);
 _BUILD_00p0(Data,vrr_stack+1023, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1026, vrr_stack+1023, vrr_stack+0, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+1032, vrr_stack+1026, vrr_stack+24, vrr_stack+1023, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+1042, vrr_stack+1032, vrr_stack+1158, vrr_stack+1026, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+1057, vrr_stack+1042, vrr_stack+1168, vrr_stack+1032, vrr_stack+1158, NULL);
 _BUILD_00i0(Data,vrr_stack+1078, vrr_stack+1057, vrr_stack+552, vrr_stack+1042, vrr_stack+1168, NULL);
 _BUILD_00k0(Data,vrr_stack+1106, vrr_stack+1078, vrr_stack+1183, vrr_stack+1057, vrr_stack+552, NULL);
 _BUILD_00l0(Data,vrr_stack+552, vrr_stack+1106, vrr_stack+1211, vrr_stack+1078, vrr_stack+1183, NULL);
 _BUILD_00m0(Data,vrr_stack+1023, vrr_stack+552, vrr_stack+834, vrr_stack+1106, vrr_stack+1211, NULL);
 _BUILD_p0m0(Data,vrr_stack+1078, vrr_stack+1023, vrr_stack+2258, NULL, NULL, vrr_stack+834);
 _BUILD_d0m0(Data,vrr_stack+2698, vrr_stack+1078, vrr_stack+2313, vrr_stack+1023, vrr_stack+2258, vrr_stack+3033);
 _BUILD_f0m0(Data,vrr_stack+7798, vrr_stack+2698, vrr_stack+6313, vrr_stack+1078, vrr_stack+2313, vrr_stack+3168);
 _BUILD_g0m0(Data,vrr_stack+18106, vrr_stack+7798, vrr_stack+14311, vrr_stack+2698, vrr_stack+6313, vrr_stack+3438);
 _BUILD_h0m0(Data,vrr_stack+2698, vrr_stack+18106, vrr_stack+14861, vrr_stack+7798, vrr_stack+14311, vrr_stack+8746);
 _BUILD_i0m0(Data,vrr_stack+7798, vrr_stack+2698, vrr_stack+6643, vrr_stack+18106, vrr_stack+14861, vrr_stack+19905);
 _BUILD_k0m0(Data,vrr_stack+18106, vrr_stack+7798, vrr_stack+16566, vrr_stack+2698, vrr_stack+6643, vrr_stack+20850);
   tmp = vrr_stack + 18106;
   target_ptr = Libint->vrr_classes[7][9];
   for(i=0;i<1980;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+3, vrr_stack+0, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+2698, vrr_stack+6, vrr_stack+24, vrr_stack+21, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+2708, vrr_stack+30, vrr_stack+2698, vrr_stack+287, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+2723, vrr_stack+40, vrr_stack+2708, vrr_stack+293, vrr_stack+30, NULL);
 _BUILD_00i0(Data,vrr_stack+275, vrr_stack+55, vrr_stack+2723, vrr_stack+303, vrr_stack+40, NULL);
 _BUILD_00k0(Data,vrr_stack+2744, vrr_stack+76, vrr_stack+275, vrr_stack+318, vrr_stack+55, NULL);
 _BUILD_00l0(Data,vrr_stack+303, vrr_stack+104, vrr_stack+2744, vrr_stack+407, vrr_stack+76, NULL);
 _BUILD_00m0(Data,vrr_stack+348, vrr_stack+690, vrr_stack+303, vrr_stack+516, vrr_stack+104, NULL);
 _BUILD_p0m0(Data,vrr_stack+2780, vrr_stack+2478, vrr_stack+348, NULL, NULL, vrr_stack+690);
 _BUILD_d0m0(Data,vrr_stack+2945, vrr_stack+2533, vrr_stack+2780, vrr_stack+2038, vrr_stack+2478, vrr_stack+140);
 _BUILD_f0m0(Data,vrr_stack+3275, vrr_stack+15686, vrr_stack+2945, vrr_stack+2093, vrr_stack+2533, vrr_stack+3888);
 _BUILD_g0m0(Data,vrr_stack+20086, vrr_stack+16016, vrr_stack+3275, vrr_stack+5983, vrr_stack+15686, vrr_stack+4158);
 _BUILD_h0m0(Data,vrr_stack+20911, vrr_stack+29820, vrr_stack+20086, vrr_stack+13761, vrr_stack+16016, vrr_stack+9421);
 _BUILD_i0m0(Data,vrr_stack+35320, vrr_stack+30645, vrr_stack+20911, vrr_stack+27015, vrr_stack+29820, vrr_stack+10096);
 _BUILD_k0m0(Data,vrr_stack+36860, vrr_stack+31800, vrr_stack+35320, vrr_stack+28665, vrr_stack+30645, vrr_stack+22110);
 _BUILD_l0m0(Data,vrr_stack+38840, vrr_stack+33340, vrr_stack+36860, vrr_stack+16566, vrr_stack+31800, vrr_stack+23370);
 _BUILD_l0m0(Data,vrr_stack+22066, vrr_stack+18106, vrr_stack+33340, vrr_stack+7798, vrr_stack+16566, vrr_stack+11041);
   tmp = vrr_stack + 22066;
   target_ptr = Libint->vrr_classes[8][9];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+7798, vrr_stack+1359, vrr_stack+4773, vrr_stack+1683, vrr_stack+1773, NULL);
 _BUILD_00n0(Data,vrr_stack+7864, vrr_stack+1414, vrr_stack+1359, vrr_stack+1728, vrr_stack+1683, NULL);
 _BUILD_p0n0(Data,vrr_stack+7930, vrr_stack+7864, vrr_stack+7798, NULL, NULL, vrr_stack+1359);
 _BUILD_00n0(Data,vrr_stack+8128, vrr_stack+435, vrr_stack+1414, vrr_stack+645, vrr_stack+1728, NULL);
 _BUILD_p0n0(Data,vrr_stack+8194, vrr_stack+8128, vrr_stack+7864, NULL, NULL, vrr_stack+1414);
 _BUILD_00n0(Data,vrr_stack+8392, vrr_stack+4773, vrr_stack+2038, vrr_stack+1773, vrr_stack+789, NULL);
 _BUILD_p0n0(Data,vrr_stack+8458, vrr_stack+7798, vrr_stack+8392, NULL, NULL, vrr_stack+4773);
 _BUILD_d0n0(Data,vrr_stack+8656, vrr_stack+7930, vrr_stack+8458, vrr_stack+7864, vrr_stack+7798, vrr_stack+4828);
 _BUILD_d0n0(Data,vrr_stack+9052, vrr_stack+8194, vrr_stack+7930, vrr_stack+8128, vrr_stack+7864, vrr_stack+1469);
 _BUILD_f0n0(Data,vrr_stack+9448, vrr_stack+9052, vrr_stack+8656, vrr_stack+8194, vrr_stack+7930, vrr_stack+4993);
 _BUILD_00n0(Data,vrr_stack+7864, vrr_stack+1818, vrr_stack+435, vrr_stack+933, vrr_stack+645, NULL);
 _BUILD_p0n0(Data,vrr_stack+4773, vrr_stack+7864, vrr_stack+8128, NULL, NULL, vrr_stack+435);
 _BUILD_d0n0(Data,vrr_stack+10108, vrr_stack+4773, vrr_stack+8194, vrr_stack+7864, vrr_stack+8128, vrr_stack+4608);
 _BUILD_f0n0(Data,vrr_stack+10504, vrr_stack+10108, vrr_stack+9052, vrr_stack+4773, vrr_stack+8194, vrr_stack+5323);
 _BUILD_00n0(Data,vrr_stack+8128, vrr_stack+2038, vrr_stack+2478, vrr_stack+789, vrr_stack+978, NULL);
 _BUILD_p0n0(Data,vrr_stack+8194, vrr_stack+8392, vrr_stack+8128, NULL, NULL, vrr_stack+2038);
 _BUILD_d0n0(Data,vrr_stack+4971, vrr_stack+8458, vrr_stack+8194, vrr_stack+7798, vrr_stack+8392, vrr_stack+2093);
 _BUILD_f0n0(Data,vrr_stack+11164, vrr_stack+8656, vrr_stack+4971, vrr_stack+7930, vrr_stack+8458, vrr_stack+5983);
 _BUILD_g0n0(Data,vrr_stack+41315, vrr_stack+9448, vrr_stack+11164, vrr_stack+9052, vrr_stack+8656, vrr_stack+13761);
 _BUILD_g0n0(Data,vrr_stack+42305, vrr_stack+10504, vrr_stack+9448, vrr_stack+10108, vrr_stack+9052, vrr_stack+12661);
 _BUILD_h0n0(Data,vrr_stack+11824, vrr_stack+42305, vrr_stack+41315, vrr_stack+10504, vrr_stack+9448, vrr_stack+27015);
 _BUILD_00n0(Data,vrr_stack+7798, vrr_stack+2258, vrr_stack+1818, vrr_stack+834, vrr_stack+933, NULL);
 _BUILD_p0n0(Data,vrr_stack+7930, vrr_stack+7798, vrr_stack+7864, NULL, NULL, vrr_stack+1818);
 _BUILD_d0n0(Data,vrr_stack+9052, vrr_stack+7930, vrr_stack+4773, vrr_stack+7798, vrr_stack+7864, vrr_stack+1873);
 _BUILD_f0n0(Data,vrr_stack+27015, vrr_stack+9052, vrr_stack+10108, vrr_stack+7930, vrr_stack+4773, vrr_stack+5653);
 _BUILD_g0n0(Data,vrr_stack+3825, vrr_stack+27015, vrr_stack+10504, vrr_stack+9052, vrr_stack+10108, vrr_stack+13211);
 _BUILD_h0n0(Data,vrr_stack+43295, vrr_stack+3825, vrr_stack+42305, vrr_stack+27015, vrr_stack+10504, vrr_stack+27840);
 _BUILD_00n0(Data,vrr_stack+7864, vrr_stack+2478, vrr_stack+348, vrr_stack+978, vrr_stack+690, NULL);
 _BUILD_p0n0(Data,vrr_stack+10108, vrr_stack+8128, vrr_stack+7864, NULL, NULL, vrr_stack+2478);
 _BUILD_d0n0(Data,vrr_stack+10306, vrr_stack+8194, vrr_stack+10108, vrr_stack+8392, vrr_stack+8128, vrr_stack+2533);
 _BUILD_f0n0(Data,vrr_stack+27675, vrr_stack+4971, vrr_stack+10306, vrr_stack+8458, vrr_stack+8194, vrr_stack+15686);
 _BUILD_g0n0(Data,vrr_stack+13210, vrr_stack+11164, vrr_stack+27675, vrr_stack+8656, vrr_stack+4971, vrr_stack+16016);
 _BUILD_h0n0(Data,vrr_stack+44681, vrr_stack+41315, vrr_stack+13210, vrr_stack+9448, vrr_stack+11164, vrr_stack+29820);
 _BUILD_i0n0(Data,vrr_stack+46067, vrr_stack+11824, vrr_stack+44681, vrr_stack+42305, vrr_stack+41315, vrr_stack+30645);
 _BUILD_i0n0(Data,vrr_stack+29820, vrr_stack+43295, vrr_stack+11824, vrr_stack+3825, vrr_stack+42305, vrr_stack+28665);
 _BUILD_k0n0(Data,vrr_stack+47915, vrr_stack+29820, vrr_stack+46067, vrr_stack+43295, vrr_stack+11824, vrr_stack+31800);
 _BUILD_00n0(Data,vrr_stack+42305, vrr_stack+1023, vrr_stack+2258, vrr_stack+552, vrr_stack+834, NULL);
 _BUILD_p0n0(Data,vrr_stack+42371, vrr_stack+42305, vrr_stack+7798, NULL, NULL, vrr_stack+2258);
 _BUILD_d0n0(Data,vrr_stack+42569, vrr_stack+42371, vrr_stack+7930, vrr_stack+42305, vrr_stack+7798, vrr_stack+2313);
 _BUILD_f0n0(Data,vrr_stack+9448, vrr_stack+42569, vrr_stack+9052, vrr_stack+42371, vrr_stack+7930, vrr_stack+6313);
 _BUILD_g0n0(Data,vrr_stack+31668, vrr_stack+9448, vrr_stack+27015, vrr_stack+42569, vrr_stack+9052, vrr_stack+14311);
 _BUILD_h0n0(Data,vrr_stack+28335, vrr_stack+31668, vrr_stack+3825, vrr_stack+9448, vrr_stack+27015, vrr_stack+14861);
 _BUILD_i0n0(Data,vrr_stack+14200, vrr_stack+28335, vrr_stack+43295, vrr_stack+31668, vrr_stack+3825, vrr_stack+6643);
 _BUILD_k0n0(Data,vrr_stack+5367, vrr_stack+14200, vrr_stack+29820, vrr_stack+28335, vrr_stack+43295, vrr_stack+16566);
   tmp = vrr_stack + 5367;
   target_ptr = Libint->vrr_classes[7][10];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+28335, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+28338, vrr_stack+0, vrr_stack+28335, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+28344, vrr_stack+24, vrr_stack+28338, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+28354, vrr_stack+2698, vrr_stack+28344, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+2708, vrr_stack+28354, vrr_stack+30, vrr_stack+2698, NULL);
 _BUILD_00i0(Data,vrr_stack+28335, vrr_stack+2723, vrr_stack+0, vrr_stack+40, vrr_stack+2708, NULL);
 _BUILD_00k0(Data,vrr_stack+0, vrr_stack+275, vrr_stack+28335, vrr_stack+55, vrr_stack+2723, NULL);
 _BUILD_00l0(Data,vrr_stack+28335, vrr_stack+2744, vrr_stack+0, vrr_stack+76, vrr_stack+275, NULL);
 _BUILD_00m0(Data,vrr_stack+0, vrr_stack+303, vrr_stack+28335, vrr_stack+104, vrr_stack+2744, NULL);
 _BUILD_00n0(Data,vrr_stack+28335, vrr_stack+348, vrr_stack+0, vrr_stack+690, vrr_stack+303, NULL);
 _BUILD_p0n0(Data,vrr_stack+7930, vrr_stack+7864, vrr_stack+28335, NULL, NULL, vrr_stack+348);
 _BUILD_d0n0(Data,vrr_stack+28335, vrr_stack+10108, vrr_stack+7930, vrr_stack+8128, vrr_stack+7864, vrr_stack+2780);
 _BUILD_f0n0(Data,vrr_stack+27015, vrr_stack+10306, vrr_stack+28335, vrr_stack+8194, vrr_stack+10108, vrr_stack+2945);
 _BUILD_g0n0(Data,vrr_stack+28335, vrr_stack+27675, vrr_stack+27015, vrr_stack+4971, vrr_stack+10306, vrr_stack+3275);
 _BUILD_h0n0(Data,vrr_stack+0, vrr_stack+13210, vrr_stack+28335, vrr_stack+11164, vrr_stack+27675, vrr_stack+20086);
 _BUILD_i0n0(Data,vrr_stack+27015, vrr_stack+44681, vrr_stack+0, vrr_stack+41315, vrr_stack+13210, vrr_stack+20911);
 _BUILD_k0n0(Data,vrr_stack+41315, vrr_stack+46067, vrr_stack+27015, vrr_stack+11824, vrr_stack+44681, vrr_stack+35320);
 _BUILD_l0n0(Data,vrr_stack+0, vrr_stack+47915, vrr_stack+41315, vrr_stack+29820, vrr_stack+46067, vrr_stack+36860);
 _BUILD_l0n0(Data,vrr_stack+41315, vrr_stack+5367, vrr_stack+47915, vrr_stack+14200, vrr_stack+29820, vrr_stack+33340);
   tmp = vrr_stack + 41315;
   target_ptr = Libint->vrr_classes[8][10];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0m0(Data,vrr_stack+44285, vrr_stack+22066, vrr_stack+38840, vrr_stack+18106, vrr_stack+33340, vrr_stack+24990);
   tmp = vrr_stack + 44285;
   target_ptr = Libint->vrr_classes[9][9];
   for(i=0;i<3025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0n0(Data,vrr_stack+7743, vrr_stack+41315, vrr_stack+0, vrr_stack+5367, vrr_stack+47915, vrr_stack+38840);
   tmp = vrr_stack + 7743;
   target_ptr = Libint->vrr_classes[9][10];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];

}

