/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (lg|ki) integrals */

void vrr_order_lgki(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_p000(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_p000(Data,vrr_stack+3, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_p000(Data,vrr_stack+6, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+9, Data->F+10, NULL);
 _BUILD_d000(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+8, Data->F+9, NULL);
 _BUILD_f000(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_p000(Data,vrr_stack+31, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+7, Data->F+8, NULL);
 _BUILD_f000(Data,vrr_stack+40, vrr_stack+34, vrr_stack+15, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_p000(Data,vrr_stack+50, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+53, vrr_stack+6, vrr_stack+50, Data->F+10, Data->F+11, NULL);
 _BUILD_f000(Data,vrr_stack+59, vrr_stack+9, vrr_stack+53, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_g000(Data,vrr_stack+69, vrr_stack+21, vrr_stack+59, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_g000(Data,vrr_stack+84, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+15, NULL);
 _BUILD_h000(Data,vrr_stack+99, vrr_stack+84, vrr_stack+69, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+120, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+123, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+126, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+129, vrr_stack+120, vrr_stack+126, NULL, NULL, Data->F+10);
 _BUILD_p0p0(Data,vrr_stack+138, vrr_stack+123, vrr_stack+120, NULL, NULL, Data->F+9);
 _BUILD_d0p0(Data,vrr_stack+147, vrr_stack+138, vrr_stack+129, vrr_stack+123, vrr_stack+120, vrr_stack+0);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+165, vrr_stack+0, vrr_stack+123, NULL, NULL, Data->F+8);
 _BUILD_d0p0(Data,vrr_stack+174, vrr_stack+165, vrr_stack+138, vrr_stack+0, vrr_stack+123, vrr_stack+3);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+192, vrr_stack+126, vrr_stack+3, NULL, NULL, Data->F+11);
 _BUILD_d0p0(Data,vrr_stack+201, vrr_stack+129, vrr_stack+192, vrr_stack+120, vrr_stack+126, vrr_stack+6);
 _BUILD_f0p0(Data,vrr_stack+219, vrr_stack+147, vrr_stack+201, vrr_stack+138, vrr_stack+129, vrr_stack+9);
 _BUILD_f0p0(Data,vrr_stack+249, vrr_stack+174, vrr_stack+147, vrr_stack+165, vrr_stack+138, vrr_stack+15);
 _BUILD_g0p0(Data,vrr_stack+279, vrr_stack+249, vrr_stack+219, vrr_stack+174, vrr_stack+147, vrr_stack+21);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+9, vrr_stack+6, vrr_stack+0, NULL, NULL, Data->F+7);
 _BUILD_d0p0(Data,vrr_stack+324, vrr_stack+9, vrr_stack+165, vrr_stack+6, vrr_stack+0, vrr_stack+31);
 _BUILD_f0p0(Data,vrr_stack+342, vrr_stack+324, vrr_stack+174, vrr_stack+9, vrr_stack+165, vrr_stack+34);
 _BUILD_g0p0(Data,vrr_stack+372, vrr_stack+342, vrr_stack+249, vrr_stack+324, vrr_stack+174, vrr_stack+40);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+21, vrr_stack+3, vrr_stack+18, NULL, NULL, Data->F+12);
 _BUILD_d0p0(Data,vrr_stack+30, vrr_stack+192, vrr_stack+21, vrr_stack+126, vrr_stack+3, vrr_stack+50);
 _BUILD_f0p0(Data,vrr_stack+417, vrr_stack+201, vrr_stack+30, vrr_stack+129, vrr_stack+192, vrr_stack+53);
 _BUILD_g0p0(Data,vrr_stack+447, vrr_stack+219, vrr_stack+417, vrr_stack+147, vrr_stack+201, vrr_stack+59);
 _BUILD_h0p0(Data,vrr_stack+492, vrr_stack+279, vrr_stack+447, vrr_stack+249, vrr_stack+219, vrr_stack+69);
 _BUILD_h0p0(Data,vrr_stack+555, vrr_stack+372, vrr_stack+279, vrr_stack+342, vrr_stack+249, vrr_stack+84);
 _BUILD_i0p0(Data,vrr_stack+618, vrr_stack+555, vrr_stack+492, vrr_stack+372, vrr_stack+279, vrr_stack+99);
 _BUILD_00d0(Data,vrr_stack+48, vrr_stack+120, vrr_stack+126, Data->F+9, Data->F+10, NULL);
 _BUILD_00d0(Data,vrr_stack+54, vrr_stack+123, vrr_stack+120, Data->F+8, Data->F+9, NULL);
 _BUILD_p0d0(Data,vrr_stack+60, vrr_stack+54, vrr_stack+48, NULL, NULL, vrr_stack+120);
 _BUILD_00d0(Data,vrr_stack+78, vrr_stack+0, vrr_stack+123, Data->F+7, Data->F+8, NULL);
 _BUILD_p0d0(Data,vrr_stack+84, vrr_stack+78, vrr_stack+54, NULL, NULL, vrr_stack+123);
 _BUILD_00d0(Data,vrr_stack+102, vrr_stack+126, vrr_stack+3, Data->F+10, Data->F+11, NULL);
 _BUILD_p0d0(Data,vrr_stack+702, vrr_stack+48, vrr_stack+102, NULL, NULL, vrr_stack+126);
 _BUILD_d0d0(Data,vrr_stack+720, vrr_stack+60, vrr_stack+702, vrr_stack+54, vrr_stack+48, vrr_stack+129);
 _BUILD_d0d0(Data,vrr_stack+756, vrr_stack+84, vrr_stack+60, vrr_stack+78, vrr_stack+54, vrr_stack+138);
 _BUILD_f0d0(Data,vrr_stack+792, vrr_stack+756, vrr_stack+720, vrr_stack+84, vrr_stack+60, vrr_stack+147);
 _BUILD_00d0(Data,vrr_stack+129, vrr_stack+6, vrr_stack+0, Data->F+6, Data->F+7, NULL);
 _BUILD_p0d0(Data,vrr_stack+135, vrr_stack+129, vrr_stack+78, NULL, NULL, vrr_stack+0);
 _BUILD_d0d0(Data,vrr_stack+852, vrr_stack+135, vrr_stack+84, vrr_stack+129, vrr_stack+78, vrr_stack+165);
 _BUILD_f0d0(Data,vrr_stack+888, vrr_stack+852, vrr_stack+756, vrr_stack+135, vrr_stack+84, vrr_stack+174);
 _BUILD_00d0(Data,vrr_stack+153, vrr_stack+3, vrr_stack+18, Data->F+11, Data->F+12, NULL);
 _BUILD_p0d0(Data,vrr_stack+159, vrr_stack+102, vrr_stack+153, NULL, NULL, vrr_stack+3);
 _BUILD_d0d0(Data,vrr_stack+948, vrr_stack+702, vrr_stack+159, vrr_stack+48, vrr_stack+102, vrr_stack+192);
 _BUILD_f0d0(Data,vrr_stack+984, vrr_stack+720, vrr_stack+948, vrr_stack+60, vrr_stack+702, vrr_stack+201);
 _BUILD_g0d0(Data,vrr_stack+1044, vrr_stack+792, vrr_stack+984, vrr_stack+756, vrr_stack+720, vrr_stack+219);
 _BUILD_g0d0(Data,vrr_stack+1134, vrr_stack+888, vrr_stack+792, vrr_stack+852, vrr_stack+756, vrr_stack+249);
 _BUILD_h0d0(Data,vrr_stack+1224, vrr_stack+1134, vrr_stack+1044, vrr_stack+888, vrr_stack+792, vrr_stack+279);
 _BUILD_00p0(Data,vrr_stack+177, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+180, vrr_stack+177, vrr_stack+6, Data->F+5, Data->F+6, NULL);
 _BUILD_p0d0(Data,vrr_stack+186, vrr_stack+180, vrr_stack+129, NULL, NULL, vrr_stack+6);
 _BUILD_d0d0(Data,vrr_stack+204, vrr_stack+186, vrr_stack+135, vrr_stack+180, vrr_stack+129, vrr_stack+9);
 _BUILD_f0d0(Data,vrr_stack+240, vrr_stack+204, vrr_stack+852, vrr_stack+186, vrr_stack+135, vrr_stack+324);
 _BUILD_g0d0(Data,vrr_stack+1350, vrr_stack+240, vrr_stack+888, vrr_stack+204, vrr_stack+852, vrr_stack+342);
 _BUILD_h0d0(Data,vrr_stack+1440, vrr_stack+1350, vrr_stack+1134, vrr_stack+240, vrr_stack+888, vrr_stack+372);
 _BUILD_00p0(Data,vrr_stack+9, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+12, vrr_stack+18, vrr_stack+9, Data->F+12, Data->F+13, NULL);
 _BUILD_p0d0(Data,vrr_stack+300, vrr_stack+153, vrr_stack+12, NULL, NULL, vrr_stack+18);
 _BUILD_d0d0(Data,vrr_stack+318, vrr_stack+159, vrr_stack+300, vrr_stack+102, vrr_stack+153, vrr_stack+21);
 _BUILD_f0d0(Data,vrr_stack+354, vrr_stack+948, vrr_stack+318, vrr_stack+702, vrr_stack+159, vrr_stack+30);
 _BUILD_g0d0(Data,vrr_stack+1566, vrr_stack+984, vrr_stack+354, vrr_stack+720, vrr_stack+948, vrr_stack+417);
 _BUILD_h0d0(Data,vrr_stack+1656, vrr_stack+1044, vrr_stack+1566, vrr_stack+792, vrr_stack+984, vrr_stack+447);
 _BUILD_i0d0(Data,vrr_stack+1782, vrr_stack+1224, vrr_stack+1656, vrr_stack+1134, vrr_stack+1044, vrr_stack+492);
 _BUILD_i0d0(Data,vrr_stack+1950, vrr_stack+1440, vrr_stack+1224, vrr_stack+1350, vrr_stack+1134, vrr_stack+555);
 _BUILD_k0d0(Data,vrr_stack+2118, vrr_stack+1950, vrr_stack+1782, vrr_stack+1440, vrr_stack+1224, vrr_stack+618);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+54, vrr_stack+48, vrr_stack+123, vrr_stack+120, NULL);
 _BUILD_00f0(Data,vrr_stack+31, vrr_stack+78, vrr_stack+54, vrr_stack+0, vrr_stack+123, NULL);
 _BUILD_00f0(Data,vrr_stack+414, vrr_stack+48, vrr_stack+102, vrr_stack+120, vrr_stack+126, NULL);
 _BUILD_p0f0(Data,vrr_stack+424, vrr_stack+21, vrr_stack+414, NULL, NULL, vrr_stack+48);
 _BUILD_p0f0(Data,vrr_stack+454, vrr_stack+31, vrr_stack+21, NULL, NULL, vrr_stack+54);
 _BUILD_d0f0(Data,vrr_stack+484, vrr_stack+454, vrr_stack+424, vrr_stack+31, vrr_stack+21, vrr_stack+60);
 _BUILD_00f0(Data,vrr_stack+60, vrr_stack+129, vrr_stack+78, vrr_stack+6, vrr_stack+0, NULL);
 _BUILD_p0f0(Data,vrr_stack+544, vrr_stack+60, vrr_stack+31, NULL, NULL, vrr_stack+78);
 _BUILD_d0f0(Data,vrr_stack+574, vrr_stack+544, vrr_stack+454, vrr_stack+60, vrr_stack+31, vrr_stack+84);
 _BUILD_00f0(Data,vrr_stack+84, vrr_stack+102, vrr_stack+153, vrr_stack+126, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+634, vrr_stack+414, vrr_stack+84, NULL, NULL, vrr_stack+102);
 _BUILD_d0f0(Data,vrr_stack+2334, vrr_stack+424, vrr_stack+634, vrr_stack+21, vrr_stack+414, vrr_stack+702);
 _BUILD_f0f0(Data,vrr_stack+2394, vrr_stack+484, vrr_stack+2334, vrr_stack+454, vrr_stack+424, vrr_stack+720);
 _BUILD_f0f0(Data,vrr_stack+2494, vrr_stack+574, vrr_stack+484, vrr_stack+544, vrr_stack+454, vrr_stack+756);
 _BUILD_g0f0(Data,vrr_stack+2594, vrr_stack+2494, vrr_stack+2394, vrr_stack+574, vrr_stack+484, vrr_stack+792);
 _BUILD_00f0(Data,vrr_stack+664, vrr_stack+180, vrr_stack+129, vrr_stack+177, vrr_stack+6, NULL);
 _BUILD_p0f0(Data,vrr_stack+674, vrr_stack+664, vrr_stack+60, NULL, NULL, vrr_stack+129);
 _BUILD_d0f0(Data,vrr_stack+704, vrr_stack+674, vrr_stack+544, vrr_stack+664, vrr_stack+60, vrr_stack+135);
 _BUILD_f0f0(Data,vrr_stack+2744, vrr_stack+704, vrr_stack+574, vrr_stack+674, vrr_stack+544, vrr_stack+852);
 _BUILD_g0f0(Data,vrr_stack+2844, vrr_stack+2744, vrr_stack+2494, vrr_stack+704, vrr_stack+574, vrr_stack+888);
 _BUILD_00f0(Data,vrr_stack+135, vrr_stack+153, vrr_stack+12, vrr_stack+3, vrr_stack+18, NULL);
 _BUILD_p0f0(Data,vrr_stack+764, vrr_stack+84, vrr_stack+135, NULL, NULL, vrr_stack+153);
 _BUILD_d0f0(Data,vrr_stack+794, vrr_stack+634, vrr_stack+764, vrr_stack+414, vrr_stack+84, vrr_stack+159);
 _BUILD_f0f0(Data,vrr_stack+2994, vrr_stack+2334, vrr_stack+794, vrr_stack+424, vrr_stack+634, vrr_stack+948);
 _BUILD_g0f0(Data,vrr_stack+3094, vrr_stack+2394, vrr_stack+2994, vrr_stack+484, vrr_stack+2334, vrr_stack+984);
 _BUILD_h0f0(Data,vrr_stack+3244, vrr_stack+2594, vrr_stack+3094, vrr_stack+2494, vrr_stack+2394, vrr_stack+1044);
 _BUILD_h0f0(Data,vrr_stack+854, vrr_stack+2844, vrr_stack+2594, vrr_stack+2744, vrr_stack+2494, vrr_stack+1134);
 _BUILD_i0f0(Data,vrr_stack+3454, vrr_stack+854, vrr_stack+3244, vrr_stack+2844, vrr_stack+2594, vrr_stack+1224);
 _BUILD_00p0(Data,vrr_stack+159, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+162, vrr_stack+159, vrr_stack+177, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+1064, vrr_stack+162, vrr_stack+180, vrr_stack+159, vrr_stack+177, NULL);
 _BUILD_p0f0(Data,vrr_stack+1074, vrr_stack+1064, vrr_stack+664, NULL, NULL, vrr_stack+180);
 _BUILD_d0f0(Data,vrr_stack+1104, vrr_stack+1074, vrr_stack+674, vrr_stack+1064, vrr_stack+664, vrr_stack+186);
 _BUILD_f0f0(Data,vrr_stack+1164, vrr_stack+1104, vrr_stack+704, vrr_stack+1074, vrr_stack+674, vrr_stack+204);
 _BUILD_g0f0(Data,vrr_stack+3734, vrr_stack+1164, vrr_stack+2744, vrr_stack+1104, vrr_stack+704, vrr_stack+240);
 _BUILD_h0f0(Data,vrr_stack+3884, vrr_stack+3734, vrr_stack+2844, vrr_stack+1164, vrr_stack+2744, vrr_stack+1350);
 _BUILD_i0f0(Data,vrr_stack+4094, vrr_stack+3884, vrr_stack+854, vrr_stack+3734, vrr_stack+2844, vrr_stack+1440);
 _BUILD_00p0(Data,vrr_stack+186, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+189, vrr_stack+9, vrr_stack+186, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+195, vrr_stack+12, vrr_stack+189, vrr_stack+18, vrr_stack+9, NULL);
 _BUILD_p0f0(Data,vrr_stack+205, vrr_stack+135, vrr_stack+195, NULL, NULL, vrr_stack+12);
 _BUILD_d0f0(Data,vrr_stack+235, vrr_stack+764, vrr_stack+205, vrr_stack+84, vrr_stack+135, vrr_stack+300);
 _BUILD_f0f0(Data,vrr_stack+1264, vrr_stack+794, vrr_stack+235, vrr_stack+634, vrr_stack+764, vrr_stack+318);
 _BUILD_g0f0(Data,vrr_stack+1364, vrr_stack+2994, vrr_stack+1264, vrr_stack+2334, vrr_stack+794, vrr_stack+354);
 _BUILD_h0f0(Data,vrr_stack+4374, vrr_stack+3094, vrr_stack+1364, vrr_stack+2394, vrr_stack+2994, vrr_stack+1566);
 _BUILD_i0f0(Data,vrr_stack+4584, vrr_stack+3244, vrr_stack+4374, vrr_stack+2594, vrr_stack+3094, vrr_stack+1656);
 _BUILD_k0f0(Data,vrr_stack+4864, vrr_stack+3454, vrr_stack+4584, vrr_stack+854, vrr_stack+3244, vrr_stack+1782);
 _BUILD_k0f0(Data,vrr_stack+1514, vrr_stack+4094, vrr_stack+3454, vrr_stack+3884, vrr_stack+854, vrr_stack+1950);
 _BUILD_l0f0(Data,vrr_stack+5224, vrr_stack+1514, vrr_stack+4864, vrr_stack+4094, vrr_stack+3454, vrr_stack+2118);
 _BUILD_00g0(Data,vrr_stack+295, vrr_stack+21, vrr_stack+414, vrr_stack+54, vrr_stack+48, NULL);
 _BUILD_00g0(Data,vrr_stack+310, vrr_stack+31, vrr_stack+21, vrr_stack+78, vrr_stack+54, NULL);
 _BUILD_p0g0(Data,vrr_stack+325, vrr_stack+310, vrr_stack+295, NULL, NULL, vrr_stack+21);
 _BUILD_00g0(Data,vrr_stack+370, vrr_stack+60, vrr_stack+31, vrr_stack+129, vrr_stack+78, NULL);
 _BUILD_p0g0(Data,vrr_stack+1874, vrr_stack+370, vrr_stack+310, NULL, NULL, vrr_stack+31);
 _BUILD_00g0(Data,vrr_stack+385, vrr_stack+414, vrr_stack+84, vrr_stack+48, vrr_stack+102, NULL);
 _BUILD_p0g0(Data,vrr_stack+1919, vrr_stack+295, vrr_stack+385, NULL, NULL, vrr_stack+414);
 _BUILD_d0g0(Data,vrr_stack+1964, vrr_stack+325, vrr_stack+1919, vrr_stack+310, vrr_stack+295, vrr_stack+424);
 _BUILD_d0g0(Data,vrr_stack+2054, vrr_stack+1874, vrr_stack+325, vrr_stack+370, vrr_stack+310, vrr_stack+454);
 _BUILD_f0g0(Data,vrr_stack+2144, vrr_stack+2054, vrr_stack+1964, vrr_stack+1874, vrr_stack+325, vrr_stack+484);
 _BUILD_00g0(Data,vrr_stack+424, vrr_stack+664, vrr_stack+60, vrr_stack+180, vrr_stack+129, NULL);
 _BUILD_p0g0(Data,vrr_stack+439, vrr_stack+424, vrr_stack+370, NULL, NULL, vrr_stack+60);
 _BUILD_d0g0(Data,vrr_stack+5674, vrr_stack+439, vrr_stack+1874, vrr_stack+424, vrr_stack+370, vrr_stack+544);
 _BUILD_f0g0(Data,vrr_stack+5764, vrr_stack+5674, vrr_stack+2054, vrr_stack+439, vrr_stack+1874, vrr_stack+574);
 _BUILD_00g0(Data,vrr_stack+484, vrr_stack+84, vrr_stack+135, vrr_stack+102, vrr_stack+153, NULL);
 _BUILD_p0g0(Data,vrr_stack+499, vrr_stack+385, vrr_stack+484, NULL, NULL, vrr_stack+84);
 _BUILD_d0g0(Data,vrr_stack+544, vrr_stack+1919, vrr_stack+499, vrr_stack+295, vrr_stack+385, vrr_stack+634);
 _BUILD_f0g0(Data,vrr_stack+5914, vrr_stack+1964, vrr_stack+544, vrr_stack+325, vrr_stack+1919, vrr_stack+2334);
 _BUILD_g0g0(Data,vrr_stack+6064, vrr_stack+2144, vrr_stack+5914, vrr_stack+2054, vrr_stack+1964, vrr_stack+2394);
 _BUILD_g0g0(Data,vrr_stack+6289, vrr_stack+5764, vrr_stack+2144, vrr_stack+5674, vrr_stack+2054, vrr_stack+2494);
 _BUILD_h0g0(Data,vrr_stack+6514, vrr_stack+6289, vrr_stack+6064, vrr_stack+5764, vrr_stack+2144, vrr_stack+2594);
 _BUILD_00g0(Data,vrr_stack+634, vrr_stack+1064, vrr_stack+664, vrr_stack+162, vrr_stack+180, NULL);
 _BUILD_p0g0(Data,vrr_stack+2294, vrr_stack+634, vrr_stack+424, NULL, NULL, vrr_stack+664);
 _BUILD_d0g0(Data,vrr_stack+2339, vrr_stack+2294, vrr_stack+439, vrr_stack+634, vrr_stack+424, vrr_stack+674);
 _BUILD_f0g0(Data,vrr_stack+2429, vrr_stack+2339, vrr_stack+5674, vrr_stack+2294, vrr_stack+439, vrr_stack+704);
 _BUILD_g0g0(Data,vrr_stack+6829, vrr_stack+2429, vrr_stack+5764, vrr_stack+2339, vrr_stack+5674, vrr_stack+2744);
 _BUILD_h0g0(Data,vrr_stack+7054, vrr_stack+6829, vrr_stack+6289, vrr_stack+2429, vrr_stack+5764, vrr_stack+2844);
 _BUILD_00g0(Data,vrr_stack+649, vrr_stack+135, vrr_stack+195, vrr_stack+153, vrr_stack+12, NULL);
 _BUILD_p0g0(Data,vrr_stack+674, vrr_stack+484, vrr_stack+649, NULL, NULL, vrr_stack+135);
 _BUILD_d0g0(Data,vrr_stack+2579, vrr_stack+499, vrr_stack+674, vrr_stack+385, vrr_stack+484, vrr_stack+764);
 _BUILD_f0g0(Data,vrr_stack+2669, vrr_stack+544, vrr_stack+2579, vrr_stack+1919, vrr_stack+499, vrr_stack+794);
 _BUILD_g0g0(Data,vrr_stack+7369, vrr_stack+5914, vrr_stack+2669, vrr_stack+1964, vrr_stack+544, vrr_stack+2994);
 _BUILD_h0g0(Data,vrr_stack+7594, vrr_stack+6064, vrr_stack+7369, vrr_stack+2144, vrr_stack+5914, vrr_stack+3094);
 _BUILD_i0g0(Data,vrr_stack+2819, vrr_stack+6514, vrr_stack+7594, vrr_stack+6289, vrr_stack+6064, vrr_stack+3244);
 _BUILD_i0g0(Data,vrr_stack+7909, vrr_stack+7054, vrr_stack+6514, vrr_stack+6829, vrr_stack+6289, vrr_stack+854);
 _BUILD_k0g0(Data,vrr_stack+8329, vrr_stack+7909, vrr_stack+2819, vrr_stack+7054, vrr_stack+6514, vrr_stack+3454);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+719, vrr_stack+18, vrr_stack+159, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+725, vrr_stack+719, vrr_stack+162, vrr_stack+18, vrr_stack+159, NULL);
 _BUILD_00g0(Data,vrr_stack+735, vrr_stack+725, vrr_stack+1064, vrr_stack+719, vrr_stack+162, NULL);
 _BUILD_p0g0(Data,vrr_stack+750, vrr_stack+735, vrr_stack+634, NULL, NULL, vrr_stack+1064);
 _BUILD_d0g0(Data,vrr_stack+795, vrr_stack+750, vrr_stack+2294, vrr_stack+735, vrr_stack+634, vrr_stack+1074);
 _BUILD_f0g0(Data,vrr_stack+885, vrr_stack+795, vrr_stack+2339, vrr_stack+750, vrr_stack+2294, vrr_stack+1104);
 _BUILD_g0g0(Data,vrr_stack+3239, vrr_stack+885, vrr_stack+2429, vrr_stack+795, vrr_stack+2339, vrr_stack+1164);
 _BUILD_h0g0(Data,vrr_stack+8869, vrr_stack+3239, vrr_stack+6829, vrr_stack+885, vrr_stack+2429, vrr_stack+3734);
 _BUILD_i0g0(Data,vrr_stack+3464, vrr_stack+8869, vrr_stack+7054, vrr_stack+3239, vrr_stack+6829, vrr_stack+3884);
 _BUILD_k0g0(Data,vrr_stack+9184, vrr_stack+3464, vrr_stack+7909, vrr_stack+8869, vrr_stack+7054, vrr_stack+4094);
 _BUILD_00p0(Data,vrr_stack+3884, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3887, vrr_stack+186, vrr_stack+3884, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+3893, vrr_stack+189, vrr_stack+3887, vrr_stack+9, vrr_stack+186, NULL);
 _BUILD_00g0(Data,vrr_stack+3903, vrr_stack+195, vrr_stack+3893, vrr_stack+12, vrr_stack+189, NULL);
 _BUILD_p0g0(Data,vrr_stack+3918, vrr_stack+649, vrr_stack+3903, NULL, NULL, vrr_stack+195);
 _BUILD_d0g0(Data,vrr_stack+3963, vrr_stack+674, vrr_stack+3918, vrr_stack+484, vrr_stack+649, vrr_stack+205);
 _BUILD_f0g0(Data,vrr_stack+4053, vrr_stack+2579, vrr_stack+3963, vrr_stack+499, vrr_stack+674, vrr_stack+235);
 _BUILD_g0g0(Data,vrr_stack+9724, vrr_stack+2669, vrr_stack+4053, vrr_stack+544, vrr_stack+2579, vrr_stack+1264);
 _BUILD_h0g0(Data,vrr_stack+9949, vrr_stack+7369, vrr_stack+9724, vrr_stack+5914, vrr_stack+2669, vrr_stack+1364);
 _BUILD_i0g0(Data,vrr_stack+1074, vrr_stack+7594, vrr_stack+9949, vrr_stack+6064, vrr_stack+7369, vrr_stack+4374);
 _BUILD_k0g0(Data,vrr_stack+10264, vrr_stack+2819, vrr_stack+1074, vrr_stack+6514, vrr_stack+7594, vrr_stack+4584);
 _BUILD_l0g0(Data,vrr_stack+10804, vrr_stack+8329, vrr_stack+10264, vrr_stack+7909, vrr_stack+2819, vrr_stack+4864);
 _BUILD_l0g0(Data,vrr_stack+4203, vrr_stack+9184, vrr_stack+8329, vrr_stack+3464, vrr_stack+7909, vrr_stack+1514);
 _BUILD_m0g0(Data,vrr_stack+11479, vrr_stack+4203, vrr_stack+10804, vrr_stack+9184, vrr_stack+8329, vrr_stack+5224);
 _BUILD_00h0(Data,vrr_stack+205, vrr_stack+310, vrr_stack+295, vrr_stack+31, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+226, vrr_stack+370, vrr_stack+310, vrr_stack+60, vrr_stack+31, NULL);
 _BUILD_00h0(Data,vrr_stack+31, vrr_stack+295, vrr_stack+385, vrr_stack+21, vrr_stack+414, NULL);
 _BUILD_p0h0(Data,vrr_stack+4878, vrr_stack+205, vrr_stack+31, NULL, NULL, vrr_stack+295);
 _BUILD_p0h0(Data,vrr_stack+4941, vrr_stack+226, vrr_stack+205, NULL, NULL, vrr_stack+310);
 _BUILD_d0h0(Data,vrr_stack+5004, vrr_stack+4941, vrr_stack+4878, vrr_stack+226, vrr_stack+205, vrr_stack+325);
 _BUILD_00h0(Data,vrr_stack+325, vrr_stack+424, vrr_stack+370, vrr_stack+664, vrr_stack+60, NULL);
 _BUILD_p0h0(Data,vrr_stack+5130, vrr_stack+325, vrr_stack+226, NULL, NULL, vrr_stack+370);
 _BUILD_d0h0(Data,vrr_stack+5193, vrr_stack+5130, vrr_stack+4941, vrr_stack+325, vrr_stack+226, vrr_stack+1874);
 _BUILD_00h0(Data,vrr_stack+346, vrr_stack+385, vrr_stack+484, vrr_stack+414, vrr_stack+84, NULL);
 _BUILD_p0h0(Data,vrr_stack+5319, vrr_stack+31, vrr_stack+346, NULL, NULL, vrr_stack+385);
 _BUILD_d0h0(Data,vrr_stack+5382, vrr_stack+4878, vrr_stack+5319, vrr_stack+205, vrr_stack+31, vrr_stack+1919);
 _BUILD_f0h0(Data,vrr_stack+1494, vrr_stack+5004, vrr_stack+5382, vrr_stack+4941, vrr_stack+4878, vrr_stack+1964);
 _BUILD_f0h0(Data,vrr_stack+1704, vrr_stack+5193, vrr_stack+5004, vrr_stack+5130, vrr_stack+4941, vrr_stack+2054);
 _BUILD_g0h0(Data,vrr_stack+12304, vrr_stack+1704, vrr_stack+1494, vrr_stack+5193, vrr_stack+5004, vrr_stack+2144);
 _BUILD_00h0(Data,vrr_stack+52, vrr_stack+634, vrr_stack+424, vrr_stack+1064, vrr_stack+664, NULL);
 _BUILD_p0h0(Data,vrr_stack+5508, vrr_stack+52, vrr_stack+325, NULL, NULL, vrr_stack+424);
 _BUILD_d0h0(Data,vrr_stack+1914, vrr_stack+5508, vrr_stack+5130, vrr_stack+52, vrr_stack+325, vrr_stack+439);
 _BUILD_f0h0(Data,vrr_stack+2040, vrr_stack+1914, vrr_stack+5193, vrr_stack+5508, vrr_stack+5130, vrr_stack+5674);
 _BUILD_g0h0(Data,vrr_stack+12619, vrr_stack+2040, vrr_stack+1704, vrr_stack+1914, vrr_stack+5193, vrr_stack+5764);
 _BUILD_00h0(Data,vrr_stack+439, vrr_stack+484, vrr_stack+649, vrr_stack+84, vrr_stack+135, NULL);
 _BUILD_p0h0(Data,vrr_stack+5571, vrr_stack+346, vrr_stack+439, NULL, NULL, vrr_stack+484);
 _BUILD_d0h0(Data,vrr_stack+5634, vrr_stack+5319, vrr_stack+5571, vrr_stack+31, vrr_stack+346, vrr_stack+499);
 _BUILD_f0h0(Data,vrr_stack+12934, vrr_stack+5382, vrr_stack+5634, vrr_stack+4878, vrr_stack+5319, vrr_stack+544);
 _BUILD_g0h0(Data,vrr_stack+13144, vrr_stack+1494, vrr_stack+12934, vrr_stack+5004, vrr_stack+5382, vrr_stack+5914);
 _BUILD_h0h0(Data,vrr_stack+13459, vrr_stack+12304, vrr_stack+13144, vrr_stack+1704, vrr_stack+1494, vrr_stack+6064);
 _BUILD_h0h0(Data,vrr_stack+5760, vrr_stack+12619, vrr_stack+12304, vrr_stack+2040, vrr_stack+1704, vrr_stack+6289);
 _BUILD_i0h0(Data,vrr_stack+13900, vrr_stack+5760, vrr_stack+13459, vrr_stack+12619, vrr_stack+12304, vrr_stack+6514);
 _BUILD_00h0(Data,vrr_stack+499, vrr_stack+735, vrr_stack+634, vrr_stack+725, vrr_stack+1064, NULL);
 _BUILD_p0h0(Data,vrr_stack+520, vrr_stack+499, vrr_stack+52, NULL, NULL, vrr_stack+634);
 _BUILD_d0h0(Data,vrr_stack+6201, vrr_stack+520, vrr_stack+5508, vrr_stack+499, vrr_stack+52, vrr_stack+2294);
 _BUILD_f0h0(Data,vrr_stack+6327, vrr_stack+6201, vrr_stack+1914, vrr_stack+520, vrr_stack+5508, vrr_stack+2339);
 _BUILD_g0h0(Data,vrr_stack+14488, vrr_stack+6327, vrr_stack+2040, vrr_stack+6201, vrr_stack+1914, vrr_stack+2429);
 _BUILD_h0h0(Data,vrr_stack+14803, vrr_stack+14488, vrr_stack+12619, vrr_stack+6327, vrr_stack+2040, vrr_stack+6829);
 _BUILD_i0h0(Data,vrr_stack+15244, vrr_stack+14803, vrr_stack+5760, vrr_stack+14488, vrr_stack+12619, vrr_stack+7054);
 _BUILD_00h0(Data,vrr_stack+583, vrr_stack+649, vrr_stack+3903, vrr_stack+135, vrr_stack+195, NULL);
 _BUILD_p0h0(Data,vrr_stack+73, vrr_stack+439, vrr_stack+583, NULL, NULL, vrr_stack+649);
 _BUILD_d0h0(Data,vrr_stack+6537, vrr_stack+5571, vrr_stack+73, vrr_stack+346, vrr_stack+439, vrr_stack+674);
 _BUILD_f0h0(Data,vrr_stack+6663, vrr_stack+5634, vrr_stack+6537, vrr_stack+5319, vrr_stack+5571, vrr_stack+2579);
 _BUILD_g0h0(Data,vrr_stack+6873, vrr_stack+12934, vrr_stack+6663, vrr_stack+5382, vrr_stack+5634, vrr_stack+2669);
 _BUILD_h0h0(Data,vrr_stack+2250, vrr_stack+13144, vrr_stack+6873, vrr_stack+1494, vrr_stack+12934, vrr_stack+7369);
 _BUILD_i0h0(Data,vrr_stack+15832, vrr_stack+13459, vrr_stack+2250, vrr_stack+12304, vrr_stack+13144, vrr_stack+7594);
 _BUILD_k0h0(Data,vrr_stack+16420, vrr_stack+13900, vrr_stack+15832, vrr_stack+5760, vrr_stack+13459, vrr_stack+2819);
 _BUILD_k0h0(Data,vrr_stack+17176, vrr_stack+15244, vrr_stack+13900, vrr_stack+14803, vrr_stack+5760, vrr_stack+7909);
 _BUILD_l0h0(Data,vrr_stack+7188, vrr_stack+17176, vrr_stack+16420, vrr_stack+15244, vrr_stack+13900, vrr_stack+8329);
 _BUILD_00p0(Data,vrr_stack+367, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+604, vrr_stack+367, vrr_stack+18, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+604, vrr_stack+719, vrr_stack+367, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+610, vrr_stack+21, vrr_stack+725, vrr_stack+604, vrr_stack+719, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+610, vrr_stack+735, vrr_stack+21, vrr_stack+725, NULL);
 _BUILD_p0h0(Data,vrr_stack+664, vrr_stack+0, vrr_stack+499, NULL, NULL, vrr_stack+735);
 _BUILD_d0h0(Data,vrr_stack+8133, vrr_stack+664, vrr_stack+520, vrr_stack+0, vrr_stack+499, vrr_stack+750);
 _BUILD_f0h0(Data,vrr_stack+8259, vrr_stack+8133, vrr_stack+6201, vrr_stack+664, vrr_stack+520, vrr_stack+795);
 _BUILD_g0h0(Data,vrr_stack+8469, vrr_stack+8259, vrr_stack+6327, vrr_stack+8133, vrr_stack+6201, vrr_stack+885);
 _BUILD_h0h0(Data,vrr_stack+2691, vrr_stack+8469, vrr_stack+14488, vrr_stack+8259, vrr_stack+6327, vrr_stack+3239);
 _BUILD_i0h0(Data,vrr_stack+17932, vrr_stack+2691, vrr_stack+14803, vrr_stack+8469, vrr_stack+14488, vrr_stack+8869);
 _BUILD_k0h0(Data,vrr_stack+18520, vrr_stack+17932, vrr_stack+15244, vrr_stack+2691, vrr_stack+14803, vrr_stack+3464);
 _BUILD_l0h0(Data,vrr_stack+19276, vrr_stack+18520, vrr_stack+17176, vrr_stack+17932, vrr_stack+15244, vrr_stack+9184);
 _BUILD_00p0(Data,vrr_stack+750, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+753, vrr_stack+3884, vrr_stack+750, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+759, vrr_stack+3887, vrr_stack+753, vrr_stack+186, vrr_stack+3884, NULL);
 _BUILD_00g0(Data,vrr_stack+769, vrr_stack+3893, vrr_stack+759, vrr_stack+189, vrr_stack+3887, NULL);
 _BUILD_00h0(Data,vrr_stack+784, vrr_stack+3903, vrr_stack+769, vrr_stack+195, vrr_stack+3893, NULL);
 _BUILD_p0h0(Data,vrr_stack+805, vrr_stack+583, vrr_stack+784, NULL, NULL, vrr_stack+3903);
 _BUILD_d0h0(Data,vrr_stack+868, vrr_stack+73, vrr_stack+805, vrr_stack+439, vrr_stack+583, vrr_stack+3918);
 _BUILD_f0h0(Data,vrr_stack+8784, vrr_stack+6537, vrr_stack+868, vrr_stack+5571, vrr_stack+73, vrr_stack+3963);
 _BUILD_g0h0(Data,vrr_stack+8994, vrr_stack+6663, vrr_stack+8784, vrr_stack+5634, vrr_stack+6537, vrr_stack+4053);
 _BUILD_h0h0(Data,vrr_stack+3132, vrr_stack+6873, vrr_stack+8994, vrr_stack+12934, vrr_stack+6663, vrr_stack+9724);
 _BUILD_i0h0(Data,vrr_stack+9309, vrr_stack+2250, vrr_stack+3132, vrr_stack+13144, vrr_stack+6873, vrr_stack+9949);
 _BUILD_k0h0(Data,vrr_stack+20221, vrr_stack+15832, vrr_stack+9309, vrr_stack+13459, vrr_stack+2250, vrr_stack+1074);
 _BUILD_l0h0(Data,vrr_stack+20977, vrr_stack+16420, vrr_stack+20221, vrr_stack+13900, vrr_stack+15832, vrr_stack+10264);
 _BUILD_m0h0(Data,vrr_stack+21922, vrr_stack+7188, vrr_stack+20977, vrr_stack+17176, vrr_stack+16420, vrr_stack+10804);
 _BUILD_m0h0(Data,vrr_stack+9897, vrr_stack+19276, vrr_stack+7188, vrr_stack+18520, vrr_stack+17176, vrr_stack+4203);
 _BUILD_n0h0(Data,vrr_stack+23077, vrr_stack+9897, vrr_stack+21922, vrr_stack+19276, vrr_stack+7188, vrr_stack+11479);
 _BUILD_00i0(Data,vrr_stack+3918, vrr_stack+205, vrr_stack+31, vrr_stack+310, vrr_stack+295, NULL);
 _BUILD_00i0(Data,vrr_stack+3946, vrr_stack+226, vrr_stack+205, vrr_stack+370, vrr_stack+310, NULL);
 _BUILD_p0i0(Data,vrr_stack+3974, vrr_stack+3946, vrr_stack+3918, NULL, NULL, vrr_stack+205);
 _BUILD_00i0(Data,vrr_stack+4058, vrr_stack+325, vrr_stack+226, vrr_stack+424, vrr_stack+370, NULL);
 _BUILD_p0i0(Data,vrr_stack+4086, vrr_stack+4058, vrr_stack+3946, NULL, NULL, vrr_stack+226);
 _BUILD_00i0(Data,vrr_stack+4170, vrr_stack+31, vrr_stack+346, vrr_stack+295, vrr_stack+385, NULL);
 _BUILD_p0i0(Data,vrr_stack+4198, vrr_stack+3918, vrr_stack+4170, NULL, NULL, vrr_stack+31);
 _BUILD_d0i0(Data,vrr_stack+4282, vrr_stack+3974, vrr_stack+4198, vrr_stack+3946, vrr_stack+3918, vrr_stack+4878);
 _BUILD_d0i0(Data,vrr_stack+4450, vrr_stack+4086, vrr_stack+3974, vrr_stack+4058, vrr_stack+3946, vrr_stack+4941);
 _BUILD_f0i0(Data,vrr_stack+4618, vrr_stack+4450, vrr_stack+4282, vrr_stack+4086, vrr_stack+3974, vrr_stack+5004);
 _BUILD_00i0(Data,vrr_stack+4898, vrr_stack+52, vrr_stack+325, vrr_stack+634, vrr_stack+424, NULL);
 _BUILD_p0i0(Data,vrr_stack+4926, vrr_stack+4898, vrr_stack+4058, NULL, NULL, vrr_stack+325);
 _BUILD_d0i0(Data,vrr_stack+994, vrr_stack+4926, vrr_stack+4086, vrr_stack+4898, vrr_stack+4058, vrr_stack+5130);
 _BUILD_f0i0(Data,vrr_stack+1162, vrr_stack+994, vrr_stack+4450, vrr_stack+4926, vrr_stack+4086, vrr_stack+5193);
 _BUILD_00i0(Data,vrr_stack+5010, vrr_stack+346, vrr_stack+439, vrr_stack+385, vrr_stack+484, NULL);
 _BUILD_p0i0(Data,vrr_stack+5038, vrr_stack+4170, vrr_stack+5010, NULL, NULL, vrr_stack+346);
 _BUILD_d0i0(Data,vrr_stack+5122, vrr_stack+4198, vrr_stack+5038, vrr_stack+3918, vrr_stack+4170, vrr_stack+5319);
 _BUILD_f0i0(Data,vrr_stack+11052, vrr_stack+4282, vrr_stack+5122, vrr_stack+3974, vrr_stack+4198, vrr_stack+5382);
 _BUILD_g0i0(Data,vrr_stack+11332, vrr_stack+4618, vrr_stack+11052, vrr_stack+4450, vrr_stack+4282, vrr_stack+1494);
 _BUILD_g0i0(Data,vrr_stack+11752, vrr_stack+1162, vrr_stack+4618, vrr_stack+994, vrr_stack+4450, vrr_stack+1704);
 _BUILD_h0i0(Data,vrr_stack+24463, vrr_stack+11752, vrr_stack+11332, vrr_stack+1162, vrr_stack+4618, vrr_stack+12304);
 _BUILD_00i0(Data,vrr_stack+370, vrr_stack+499, vrr_stack+52, vrr_stack+735, vrr_stack+634, NULL);
 _BUILD_p0i0(Data,vrr_stack+5290, vrr_stack+370, vrr_stack+4898, NULL, NULL, vrr_stack+52);
 _BUILD_d0i0(Data,vrr_stack+1442, vrr_stack+5290, vrr_stack+4926, vrr_stack+370, vrr_stack+4898, vrr_stack+5508);
 _BUILD_f0i0(Data,vrr_stack+1610, vrr_stack+1442, vrr_stack+994, vrr_stack+5290, vrr_stack+4926, vrr_stack+1914);
 _BUILD_g0i0(Data,vrr_stack+12172, vrr_stack+1610, vrr_stack+1162, vrr_stack+1442, vrr_stack+994, vrr_stack+2040);
 _BUILD_h0i0(Data,vrr_stack+25051, vrr_stack+12172, vrr_stack+11752, vrr_stack+1610, vrr_stack+1162, vrr_stack+12619);
 _BUILD_00i0(Data,vrr_stack+398, vrr_stack+439, vrr_stack+583, vrr_stack+484, vrr_stack+649, NULL);
 _BUILD_p0i0(Data,vrr_stack+5374, vrr_stack+5010, vrr_stack+398, NULL, NULL, vrr_stack+439);
 _BUILD_d0i0(Data,vrr_stack+1890, vrr_stack+5038, vrr_stack+5374, vrr_stack+4170, vrr_stack+5010, vrr_stack+5571);
 _BUILD_f0i0(Data,vrr_stack+12592, vrr_stack+5122, vrr_stack+1890, vrr_stack+4198, vrr_stack+5038, vrr_stack+5634);
 _BUILD_g0i0(Data,vrr_stack+25639, vrr_stack+11052, vrr_stack+12592, vrr_stack+4282, vrr_stack+5122, vrr_stack+12934);
 _BUILD_h0i0(Data,vrr_stack+26059, vrr_stack+11332, vrr_stack+25639, vrr_stack+4618, vrr_stack+11052, vrr_stack+13144);
 _BUILD_i0i0(Data,vrr_stack+26647, vrr_stack+24463, vrr_stack+26059, vrr_stack+11752, vrr_stack+11332, vrr_stack+13459);
 _BUILD_i0i0(Data,vrr_stack+12872, vrr_stack+25051, vrr_stack+24463, vrr_stack+12172, vrr_stack+11752, vrr_stack+5760);
 _BUILD_k0i0(Data,vrr_stack+27431, vrr_stack+12872, vrr_stack+26647, vrr_stack+25051, vrr_stack+24463, vrr_stack+13900);
 _BUILD_00i0(Data,vrr_stack+5458, vrr_stack+0, vrr_stack+499, vrr_stack+610, vrr_stack+735, NULL);
 _BUILD_p0i0(Data,vrr_stack+5486, vrr_stack+5458, vrr_stack+370, NULL, NULL, vrr_stack+499);
 _BUILD_d0i0(Data,vrr_stack+5570, vrr_stack+5486, vrr_stack+5290, vrr_stack+5458, vrr_stack+370, vrr_stack+520);
 _BUILD_f0i0(Data,vrr_stack+5738, vrr_stack+5570, vrr_stack+1442, vrr_stack+5486, vrr_stack+5290, vrr_stack+6201);
 _BUILD_g0i0(Data,vrr_stack+13656, vrr_stack+5738, vrr_stack+1610, vrr_stack+5570, vrr_stack+1442, vrr_stack+6327);
 _BUILD_h0i0(Data,vrr_stack+28439, vrr_stack+13656, vrr_stack+12172, vrr_stack+5738, vrr_stack+1610, vrr_stack+14488);
 _BUILD_i0i0(Data,vrr_stack+29027, vrr_stack+28439, vrr_stack+25051, vrr_stack+13656, vrr_stack+12172, vrr_stack+14803);
 _BUILD_k0i0(Data,vrr_stack+14076, vrr_stack+29027, vrr_stack+12872, vrr_stack+28439, vrr_stack+25051, vrr_stack+15244);
 _BUILD_00i0(Data,vrr_stack+520, vrr_stack+583, vrr_stack+784, vrr_stack+649, vrr_stack+3903, NULL);
 _BUILD_p0i0(Data,vrr_stack+6018, vrr_stack+398, vrr_stack+520, NULL, NULL, vrr_stack+583);
 _BUILD_d0i0(Data,vrr_stack+6102, vrr_stack+5374, vrr_stack+6018, vrr_stack+5010, vrr_stack+398, vrr_stack+73);
 _BUILD_f0i0(Data,vrr_stack+15084, vrr_stack+1890, vrr_stack+6102, vrr_stack+5038, vrr_stack+5374, vrr_stack+6537);
 _BUILD_g0i0(Data,vrr_stack+15364, vrr_stack+12592, vrr_stack+15084, vrr_stack+5122, vrr_stack+1890, vrr_stack+6663);
 _BUILD_h0i0(Data,vrr_stack+6270, vrr_stack+25639, vrr_stack+15364, vrr_stack+11052, vrr_stack+12592, vrr_stack+6873);
 _BUILD_i0i0(Data,vrr_stack+29811, vrr_stack+26059, vrr_stack+6270, vrr_stack+11332, vrr_stack+25639, vrr_stack+2250);
 _BUILD_k0i0(Data,vrr_stack+30595, vrr_stack+26647, vrr_stack+29811, vrr_stack+24463, vrr_stack+26059, vrr_stack+15832);
 _BUILD_l0i0(Data,vrr_stack+31603, vrr_stack+27431, vrr_stack+30595, vrr_stack+12872, vrr_stack+26647, vrr_stack+16420);
 _BUILD_l0i0(Data,vrr_stack+15784, vrr_stack+14076, vrr_stack+27431, vrr_stack+29027, vrr_stack+12872, vrr_stack+17176);
 _BUILD_m0i0(Data,vrr_stack+32863, vrr_stack+15784, vrr_stack+31603, vrr_stack+14076, vrr_stack+27431, vrr_stack+7188);
 _BUILD_00p0(Data,vrr_stack+73, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+76, vrr_stack+73, vrr_stack+367, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+82, vrr_stack+76, vrr_stack+604, vrr_stack+73, vrr_stack+367, NULL);
 _BUILD_00g0(Data,vrr_stack+92, vrr_stack+82, vrr_stack+21, vrr_stack+76, vrr_stack+604, NULL);
 _BUILD_00h0(Data,vrr_stack+107, vrr_stack+92, vrr_stack+610, vrr_stack+82, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+128, vrr_stack+107, vrr_stack+0, vrr_stack+92, vrr_stack+610, NULL);
 _BUILD_p0i0(Data,vrr_stack+6858, vrr_stack+128, vrr_stack+5458, NULL, NULL, vrr_stack+0);
 _BUILD_d0i0(Data,vrr_stack+6942, vrr_stack+6858, vrr_stack+5486, vrr_stack+128, vrr_stack+5458, vrr_stack+664);
 _BUILD_f0i0(Data,vrr_stack+7110, vrr_stack+6942, vrr_stack+5570, vrr_stack+6858, vrr_stack+5486, vrr_stack+8133);
 _BUILD_g0i0(Data,vrr_stack+7390, vrr_stack+7110, vrr_stack+5738, vrr_stack+6942, vrr_stack+5570, vrr_stack+8259);
 _BUILD_h0i0(Data,vrr_stack+7810, vrr_stack+7390, vrr_stack+13656, vrr_stack+7110, vrr_stack+5738, vrr_stack+8469);
 _BUILD_i0i0(Data,vrr_stack+17044, vrr_stack+7810, vrr_stack+28439, vrr_stack+7390, vrr_stack+13656, vrr_stack+2691);
 _BUILD_k0i0(Data,vrr_stack+2058, vrr_stack+17044, vrr_stack+29027, vrr_stack+7810, vrr_stack+28439, vrr_stack+17932);
 _BUILD_l0i0(Data,vrr_stack+34403, vrr_stack+2058, vrr_stack+14076, vrr_stack+17044, vrr_stack+29027, vrr_stack+18520);
 _BUILD_m0i0(Data,vrr_stack+35663, vrr_stack+34403, vrr_stack+15784, vrr_stack+2058, vrr_stack+14076, vrr_stack+19276);
 _BUILD_00p0(Data,vrr_stack+367, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+750, vrr_stack+367, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+604, vrr_stack+753, vrr_stack+21, vrr_stack+3884, vrr_stack+750, NULL);
 _BUILD_00g0(Data,vrr_stack+614, vrr_stack+759, vrr_stack+604, vrr_stack+3887, vrr_stack+753, NULL);
 _BUILD_00h0(Data,vrr_stack+629, vrr_stack+769, vrr_stack+614, vrr_stack+3893, vrr_stack+759, NULL);
 _BUILD_00i0(Data,vrr_stack+650, vrr_stack+784, vrr_stack+629, vrr_stack+3903, vrr_stack+769, NULL);
 _BUILD_p0i0(Data,vrr_stack+8398, vrr_stack+520, vrr_stack+650, NULL, NULL, vrr_stack+784);
 _BUILD_d0i0(Data,vrr_stack+8482, vrr_stack+6018, vrr_stack+8398, vrr_stack+398, vrr_stack+520, vrr_stack+805);
 _BUILD_f0i0(Data,vrr_stack+17828, vrr_stack+6102, vrr_stack+8482, vrr_stack+5374, vrr_stack+6018, vrr_stack+868);
 _BUILD_g0i0(Data,vrr_stack+18108, vrr_stack+15084, vrr_stack+17828, vrr_stack+1890, vrr_stack+6102, vrr_stack+8784);
 _BUILD_h0i0(Data,vrr_stack+18528, vrr_stack+15364, vrr_stack+18108, vrr_stack+12592, vrr_stack+15084, vrr_stack+8994);
 _BUILD_i0i0(Data,vrr_stack+19116, vrr_stack+6270, vrr_stack+18528, vrr_stack+25639, vrr_stack+15364, vrr_stack+3132);
 _BUILD_k0i0(Data,vrr_stack+37203, vrr_stack+29811, vrr_stack+19116, vrr_stack+26059, vrr_stack+6270, vrr_stack+9309);
 _BUILD_l0i0(Data,vrr_stack+38211, vrr_stack+30595, vrr_stack+37203, vrr_stack+26647, vrr_stack+29811, vrr_stack+20221);
 _BUILD_m0i0(Data,vrr_stack+39471, vrr_stack+31603, vrr_stack+38211, vrr_stack+27431, vrr_stack+30595, vrr_stack+20977);
 _BUILD_n0i0(Data,vrr_stack+19900, vrr_stack+32863, vrr_stack+39471, vrr_stack+15784, vrr_stack+31603, vrr_stack+21922);
 _BUILD_n0i0(Data,vrr_stack+41011, vrr_stack+35663, vrr_stack+32863, vrr_stack+34403, vrr_stack+15784, vrr_stack+9897);
 _BUILD_o0i0(Data,vrr_stack+8650, vrr_stack+41011, vrr_stack+19900, vrr_stack+35663, vrr_stack+32863, vrr_stack+23077);
 _BUILD_00k0(Data,vrr_stack+805, vrr_stack+3946, vrr_stack+3918, vrr_stack+226, vrr_stack+205, NULL);
 _BUILD_00k0(Data,vrr_stack+841, vrr_stack+4058, vrr_stack+3946, vrr_stack+325, vrr_stack+226, NULL);
 _BUILD_00k0(Data,vrr_stack+226, vrr_stack+3918, vrr_stack+4170, vrr_stack+205, vrr_stack+31, NULL);
 _BUILD_p0k0(Data,vrr_stack+877, vrr_stack+805, vrr_stack+226, NULL, NULL, vrr_stack+3918);
 _BUILD_p0k0(Data,vrr_stack+10834, vrr_stack+841, vrr_stack+805, NULL, NULL, vrr_stack+3946);
 _BUILD_d0k0(Data,vrr_stack+3066, vrr_stack+10834, vrr_stack+877, vrr_stack+841, vrr_stack+805, vrr_stack+3974);
 _BUILD_00k0(Data,vrr_stack+3974, vrr_stack+4898, vrr_stack+4058, vrr_stack+52, vrr_stack+325, NULL);
 _BUILD_p0k0(Data,vrr_stack+10942, vrr_stack+3974, vrr_stack+841, NULL, NULL, vrr_stack+4058);
 _BUILD_d0k0(Data,vrr_stack+3282, vrr_stack+10942, vrr_stack+10834, vrr_stack+3974, vrr_stack+841, vrr_stack+4086);
 _BUILD_00k0(Data,vrr_stack+4086, vrr_stack+4170, vrr_stack+5010, vrr_stack+31, vrr_stack+346, NULL);
 _BUILD_p0k0(Data,vrr_stack+3498, vrr_stack+226, vrr_stack+4086, NULL, NULL, vrr_stack+4170);
 _BUILD_d0k0(Data,vrr_stack+3606, vrr_stack+877, vrr_stack+3498, vrr_stack+805, vrr_stack+226, vrr_stack+4198);
 _BUILD_f0k0(Data,vrr_stack+21748, vrr_stack+3066, vrr_stack+3606, vrr_stack+10834, vrr_stack+877, vrr_stack+4282);
 _BUILD_f0k0(Data,vrr_stack+22108, vrr_stack+3282, vrr_stack+3066, vrr_stack+10942, vrr_stack+10834, vrr_stack+4450);
 _BUILD_g0k0(Data,vrr_stack+22468, vrr_stack+22108, vrr_stack+21748, vrr_stack+3282, vrr_stack+3066, vrr_stack+4618);
 _BUILD_00k0(Data,vrr_stack+4198, vrr_stack+370, vrr_stack+4898, vrr_stack+499, vrr_stack+52, NULL);
 _BUILD_p0k0(Data,vrr_stack+4234, vrr_stack+4198, vrr_stack+3974, NULL, NULL, vrr_stack+4898);
 _BUILD_d0k0(Data,vrr_stack+4342, vrr_stack+4234, vrr_stack+10942, vrr_stack+4198, vrr_stack+3974, vrr_stack+4926);
 _BUILD_f0k0(Data,vrr_stack+23008, vrr_stack+4342, vrr_stack+3282, vrr_stack+4234, vrr_stack+10942, vrr_stack+994);
 _BUILD_g0k0(Data,vrr_stack+23368, vrr_stack+23008, vrr_stack+22108, vrr_stack+4342, vrr_stack+3282, vrr_stack+1162);
 _BUILD_00k0(Data,vrr_stack+4926, vrr_stack+5010, vrr_stack+398, vrr_stack+346, vrr_stack+439, NULL);
 _BUILD_p0k0(Data,vrr_stack+4558, vrr_stack+4086, vrr_stack+4926, NULL, NULL, vrr_stack+5010);
 _BUILD_d0k0(Data,vrr_stack+4666, vrr_stack+3498, vrr_stack+4558, vrr_stack+226, vrr_stack+4086, vrr_stack+5038);
 _BUILD_f0k0(Data,vrr_stack+985, vrr_stack+3606, vrr_stack+4666, vrr_stack+877, vrr_stack+3498, vrr_stack+5122);
 _BUILD_g0k0(Data,vrr_stack+23908, vrr_stack+21748, vrr_stack+985, vrr_stack+3066, vrr_stack+3606, vrr_stack+11052);
 _BUILD_h0k0(Data,vrr_stack+42859, vrr_stack+22468, vrr_stack+23908, vrr_stack+22108, vrr_stack+21748, vrr_stack+11332);
 _BUILD_h0k0(Data,vrr_stack+43615, vrr_stack+23368, vrr_stack+22468, vrr_stack+23008, vrr_stack+22108, vrr_stack+11752);
 _BUILD_i0k0(Data,vrr_stack+11050, vrr_stack+43615, vrr_stack+42859, vrr_stack+23368, vrr_stack+22468, vrr_stack+24463);
 _BUILD_00k0(Data,vrr_stack+5038, vrr_stack+5458, vrr_stack+370, vrr_stack+0, vrr_stack+499, NULL);
 _BUILD_p0k0(Data,vrr_stack+5074, vrr_stack+5038, vrr_stack+4198, NULL, NULL, vrr_stack+370);
 _BUILD_d0k0(Data,vrr_stack+24448, vrr_stack+5074, vrr_stack+4234, vrr_stack+5038, vrr_stack+4198, vrr_stack+5290);
 _BUILD_f0k0(Data,vrr_stack+24664, vrr_stack+24448, vrr_stack+4342, vrr_stack+5074, vrr_stack+4234, vrr_stack+1442);
 _BUILD_g0k0(Data,vrr_stack+44371, vrr_stack+24664, vrr_stack+23008, vrr_stack+24448, vrr_stack+4342, vrr_stack+1610);
 _BUILD_h0k0(Data,vrr_stack+44911, vrr_stack+44371, vrr_stack+23368, vrr_stack+24664, vrr_stack+23008, vrr_stack+12172);
 _BUILD_i0k0(Data,vrr_stack+45667, vrr_stack+44911, vrr_stack+43615, vrr_stack+44371, vrr_stack+23368, vrr_stack+25051);
 _BUILD_00k0(Data,vrr_stack+5182, vrr_stack+398, vrr_stack+520, vrr_stack+439, vrr_stack+583, NULL);
 _BUILD_p0k0(Data,vrr_stack+5218, vrr_stack+4926, vrr_stack+5182, NULL, NULL, vrr_stack+398);
 _BUILD_d0k0(Data,vrr_stack+1345, vrr_stack+4558, vrr_stack+5218, vrr_stack+4086, vrr_stack+4926, vrr_stack+5374);
 _BUILD_f0k0(Data,vrr_stack+12058, vrr_stack+4666, vrr_stack+1345, vrr_stack+3498, vrr_stack+4558, vrr_stack+1890);
 _BUILD_g0k0(Data,vrr_stack+25024, vrr_stack+985, vrr_stack+12058, vrr_stack+3606, vrr_stack+4666, vrr_stack+12592);
 _BUILD_h0k0(Data,vrr_stack+46675, vrr_stack+23908, vrr_stack+25024, vrr_stack+21748, vrr_stack+985, vrr_stack+25639);
 _BUILD_i0k0(Data,vrr_stack+47431, vrr_stack+42859, vrr_stack+46675, vrr_stack+22468, vrr_stack+23908, vrr_stack+26059);
 _BUILD_k0k0(Data,vrr_stack+48439, vrr_stack+11050, vrr_stack+47431, vrr_stack+43615, vrr_stack+42859, vrr_stack+26647);
 _BUILD_k0k0(Data,vrr_stack+25564, vrr_stack+45667, vrr_stack+11050, vrr_stack+44911, vrr_stack+43615, vrr_stack+12872);
 _BUILD_l0k0(Data,vrr_stack+49735, vrr_stack+25564, vrr_stack+48439, vrr_stack+45667, vrr_stack+11050, vrr_stack+27431);
 _BUILD_00k0(Data,vrr_stack+5326, vrr_stack+128, vrr_stack+5458, vrr_stack+107, vrr_stack+0, NULL);
 _BUILD_p0k0(Data,vrr_stack+1561, vrr_stack+5326, vrr_stack+5038, NULL, NULL, vrr_stack+5458);
 _BUILD_d0k0(Data,vrr_stack+1669, vrr_stack+1561, vrr_stack+5074, vrr_stack+5326, vrr_stack+5038, vrr_stack+5486);
 _BUILD_f0k0(Data,vrr_stack+12418, vrr_stack+1669, vrr_stack+24448, vrr_stack+1561, vrr_stack+5074, vrr_stack+5570);
 _BUILD_g0k0(Data,vrr_stack+12778, vrr_stack+12418, vrr_stack+24664, vrr_stack+1669, vrr_stack+24448, vrr_stack+5738);
 _BUILD_h0k0(Data,vrr_stack+26860, vrr_stack+12778, vrr_stack+44371, vrr_stack+12418, vrr_stack+24664, vrr_stack+13656);
 _BUILD_i0k0(Data,vrr_stack+51355, vrr_stack+26860, vrr_stack+44911, vrr_stack+12778, vrr_stack+44371, vrr_stack+28439);
 _BUILD_k0k0(Data,vrr_stack+27616, vrr_stack+51355, vrr_stack+45667, vrr_stack+26860, vrr_stack+44911, vrr_stack+29027);
 _BUILD_l0k0(Data,vrr_stack+52363, vrr_stack+27616, vrr_stack+25564, vrr_stack+51355, vrr_stack+45667, vrr_stack+14076);
 _BUILD_00k0(Data,vrr_stack+5486, vrr_stack+520, vrr_stack+650, vrr_stack+583, vrr_stack+784, NULL);
 _BUILD_p0k0(Data,vrr_stack+5522, vrr_stack+5182, vrr_stack+5486, NULL, NULL, vrr_stack+520);
 _BUILD_d0k0(Data,vrr_stack+5630, vrr_stack+5218, vrr_stack+5522, vrr_stack+4926, vrr_stack+5182, vrr_stack+6018);
 _BUILD_f0k0(Data,vrr_stack+13318, vrr_stack+1345, vrr_stack+5630, vrr_stack+4558, vrr_stack+5218, vrr_stack+6102);
 _BUILD_g0k0(Data,vrr_stack+13678, vrr_stack+12058, vrr_stack+13318, vrr_stack+4666, vrr_stack+1345, vrr_stack+15084);
 _BUILD_h0k0(Data,vrr_stack+14218, vrr_stack+25024, vrr_stack+13678, vrr_stack+985, vrr_stack+12058, vrr_stack+15364);
 _BUILD_i0k0(Data,vrr_stack+53983, vrr_stack+46675, vrr_stack+14218, vrr_stack+23908, vrr_stack+25024, vrr_stack+6270);
 _BUILD_k0k0(Data,vrr_stack+54991, vrr_stack+47431, vrr_stack+53983, vrr_stack+42859, vrr_stack+46675, vrr_stack+29811);
 _BUILD_l0k0(Data,vrr_stack+28912, vrr_stack+48439, vrr_stack+54991, vrr_stack+11050, vrr_stack+47431, vrr_stack+30595);
 _BUILD_m0k0(Data,vrr_stack+56287, vrr_stack+49735, vrr_stack+28912, vrr_stack+25564, vrr_stack+48439, vrr_stack+31603);
 _BUILD_m0k0(Data,vrr_stack+30532, vrr_stack+52363, vrr_stack+49735, vrr_stack+27616, vrr_stack+25564, vrr_stack+15784);
 _BUILD_n0k0(Data,vrr_stack+58267, vrr_stack+30532, vrr_stack+56287, vrr_stack+52363, vrr_stack+49735, vrr_stack+32863);
 _BUILD_00p0(Data,vrr_stack+5846, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+5849, vrr_stack+5846, vrr_stack+73, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+5855, vrr_stack+5849, vrr_stack+76, vrr_stack+5846, vrr_stack+73, NULL);
 _BUILD_00g0(Data,vrr_stack+5865, vrr_stack+5855, vrr_stack+82, vrr_stack+5849, vrr_stack+76, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+5865, vrr_stack+92, vrr_stack+5855, vrr_stack+82, NULL);
 _BUILD_00i0(Data,vrr_stack+5880, vrr_stack+0, vrr_stack+107, vrr_stack+5865, vrr_stack+92, NULL);
 _BUILD_00k0(Data,vrr_stack+5908, vrr_stack+5880, vrr_stack+128, vrr_stack+0, vrr_stack+107, NULL);
 _BUILD_p0k0(Data,vrr_stack+5944, vrr_stack+5908, vrr_stack+5326, NULL, NULL, vrr_stack+128);
 _BUILD_d0k0(Data,vrr_stack+6052, vrr_stack+5944, vrr_stack+1561, vrr_stack+5908, vrr_stack+5326, vrr_stack+6858);
 _BUILD_f0k0(Data,vrr_stack+6268, vrr_stack+6052, vrr_stack+1669, vrr_stack+5944, vrr_stack+1561, vrr_stack+6942);
 _BUILD_g0k0(Data,vrr_stack+14974, vrr_stack+6268, vrr_stack+12418, vrr_stack+6052, vrr_stack+1669, vrr_stack+7110);
 _BUILD_h0k0(Data,vrr_stack+6628, vrr_stack+14974, vrr_stack+12778, vrr_stack+6268, vrr_stack+12418, vrr_stack+7390);
 _BUILD_i0k0(Data,vrr_stack+15514, vrr_stack+6628, vrr_stack+26860, vrr_stack+14974, vrr_stack+12778, vrr_stack+7810);
 _BUILD_k0k0(Data,vrr_stack+32512, vrr_stack+15514, vrr_stack+51355, vrr_stack+6628, vrr_stack+26860, vrr_stack+17044);
 _BUILD_l0k0(Data,vrr_stack+5944, vrr_stack+32512, vrr_stack+27616, vrr_stack+15514, vrr_stack+51355, vrr_stack+2058);
   tmp = vrr_stack + 5944;
   target_ptr = Libint->vrr_classes[8][7];
   for(i=0;i<1620;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0k0(Data,vrr_stack+14974, vrr_stack+5944, vrr_stack+52363, vrr_stack+32512, vrr_stack+27616, vrr_stack+34403);
   tmp = vrr_stack + 14974;
   target_ptr = Libint->vrr_classes[9][7];
   for(i=0;i<1980;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0k0(Data,vrr_stack+32512, vrr_stack+14974, vrr_stack+30532, vrr_stack+5944, vrr_stack+52363, vrr_stack+35663);
   tmp = vrr_stack + 32512;
   target_ptr = Libint->vrr_classes[10][7];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+5944, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+5947, vrr_stack+367, vrr_stack+5944, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+5953, vrr_stack+21, vrr_stack+5947, vrr_stack+750, vrr_stack+367, NULL);
 _BUILD_00g0(Data,vrr_stack+5963, vrr_stack+604, vrr_stack+5953, vrr_stack+753, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+614, vrr_stack+5963, vrr_stack+759, vrr_stack+604, NULL);
 _BUILD_00i0(Data,vrr_stack+5978, vrr_stack+629, vrr_stack+0, vrr_stack+769, vrr_stack+614, NULL);
 _BUILD_00k0(Data,vrr_stack+6006, vrr_stack+650, vrr_stack+5978, vrr_stack+784, vrr_stack+629, NULL);
 _BUILD_p0k0(Data,vrr_stack+6042, vrr_stack+5486, vrr_stack+6006, NULL, NULL, vrr_stack+650);
 _BUILD_d0k0(Data,vrr_stack+6150, vrr_stack+5522, vrr_stack+6042, vrr_stack+5182, vrr_stack+5486, vrr_stack+8398);
 _BUILD_f0k0(Data,vrr_stack+6366, vrr_stack+5630, vrr_stack+6150, vrr_stack+5218, vrr_stack+5522, vrr_stack+8482);
 _BUILD_g0k0(Data,vrr_stack+6726, vrr_stack+13318, vrr_stack+6366, vrr_stack+1345, vrr_stack+5630, vrr_stack+17828);
 _BUILD_h0k0(Data,vrr_stack+7266, vrr_stack+13678, vrr_stack+6726, vrr_stack+12058, vrr_stack+13318, vrr_stack+18108);
 _BUILD_i0k0(Data,vrr_stack+34888, vrr_stack+14218, vrr_stack+7266, vrr_stack+25024, vrr_stack+13678, vrr_stack+18528);
 _BUILD_k0k0(Data,vrr_stack+35896, vrr_stack+53983, vrr_stack+34888, vrr_stack+46675, vrr_stack+14218, vrr_stack+19116);
 _BUILD_l0k0(Data,vrr_stack+16954, vrr_stack+54991, vrr_stack+35896, vrr_stack+47431, vrr_stack+53983, vrr_stack+37203);
 _BUILD_m0k0(Data,vrr_stack+60643, vrr_stack+28912, vrr_stack+16954, vrr_stack+48439, vrr_stack+54991, vrr_stack+38211);
 _BUILD_n0k0(Data,vrr_stack+62623, vrr_stack+56287, vrr_stack+60643, vrr_stack+49735, vrr_stack+28912, vrr_stack+39471);
 _BUILD_o0k0(Data,vrr_stack+37192, vrr_stack+58267, vrr_stack+62623, vrr_stack+30532, vrr_stack+56287, vrr_stack+19900);
 _BUILD_o0k0(Data,vrr_stack+18574, vrr_stack+32512, vrr_stack+58267, vrr_stack+14974, vrr_stack+30532, vrr_stack+41011);
   tmp = vrr_stack + 18574;
   target_ptr = Libint->vrr_classes[11][7];
   for(i=0;i<2808;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00l0(Data,vrr_stack+14974, vrr_stack+805, vrr_stack+226, vrr_stack+3946, vrr_stack+3918, NULL);
 _BUILD_00l0(Data,vrr_stack+15019, vrr_stack+841, vrr_stack+805, vrr_stack+4058, vrr_stack+3946, NULL);
 _BUILD_00l0(Data,vrr_stack+15064, vrr_stack+226, vrr_stack+4086, vrr_stack+3918, vrr_stack+4170, NULL);
 _BUILD_p0l0(Data,vrr_stack+15109, vrr_stack+14974, vrr_stack+15064, NULL, NULL, vrr_stack+226);
 _BUILD_p0l0(Data,vrr_stack+15244, vrr_stack+15019, vrr_stack+14974, NULL, NULL, vrr_stack+805);
 _BUILD_d0l0(Data,vrr_stack+15379, vrr_stack+15244, vrr_stack+15109, vrr_stack+15019, vrr_stack+14974, vrr_stack+877);
 _BUILD_00l0(Data,vrr_stack+877, vrr_stack+3974, vrr_stack+841, vrr_stack+4898, vrr_stack+4058, NULL);
 _BUILD_p0l0(Data,vrr_stack+15649, vrr_stack+877, vrr_stack+15019, NULL, NULL, vrr_stack+841);
 _BUILD_d0l0(Data,vrr_stack+15784, vrr_stack+15649, vrr_stack+15244, vrr_stack+877, vrr_stack+15019, vrr_stack+10834);
 _BUILD_00l0(Data,vrr_stack+10834, vrr_stack+4086, vrr_stack+4926, vrr_stack+4170, vrr_stack+5010, NULL);
 _BUILD_p0l0(Data,vrr_stack+16054, vrr_stack+15064, vrr_stack+10834, NULL, NULL, vrr_stack+4086);
 _BUILD_d0l0(Data,vrr_stack+16189, vrr_stack+15109, vrr_stack+16054, vrr_stack+14974, vrr_stack+15064, vrr_stack+3498);
 _BUILD_f0l0(Data,vrr_stack+16459, vrr_stack+15379, vrr_stack+16189, vrr_stack+15244, vrr_stack+15109, vrr_stack+3606);
 _BUILD_f0l0(Data,vrr_stack+3498, vrr_stack+15784, vrr_stack+15379, vrr_stack+15649, vrr_stack+15244, vrr_stack+3066);
 _BUILD_g0l0(Data,vrr_stack+40000, vrr_stack+3498, vrr_stack+16459, vrr_stack+15784, vrr_stack+15379, vrr_stack+21748);
 _BUILD_00l0(Data,vrr_stack+16909, vrr_stack+4198, vrr_stack+3974, vrr_stack+370, vrr_stack+4898, NULL);
 _BUILD_p0l0(Data,vrr_stack+8022, vrr_stack+16909, vrr_stack+877, NULL, NULL, vrr_stack+3974);
 _BUILD_d0l0(Data,vrr_stack+8157, vrr_stack+8022, vrr_stack+15649, vrr_stack+16909, vrr_stack+877, vrr_stack+10942);
 _BUILD_f0l0(Data,vrr_stack+40675, vrr_stack+8157, vrr_stack+15784, vrr_stack+8022, vrr_stack+15649, vrr_stack+3282);
 _BUILD_g0l0(Data,vrr_stack+41125, vrr_stack+40675, vrr_stack+3498, vrr_stack+8157, vrr_stack+15784, vrr_stack+22108);
 _BUILD_00l0(Data,vrr_stack+10879, vrr_stack+4926, vrr_stack+5182, vrr_stack+5010, vrr_stack+398, NULL);
 _BUILD_p0l0(Data,vrr_stack+8427, vrr_stack+10834, vrr_stack+10879, NULL, NULL, vrr_stack+4926);
 _BUILD_d0l0(Data,vrr_stack+41800, vrr_stack+16054, vrr_stack+8427, vrr_stack+15064, vrr_stack+10834, vrr_stack+4558);
 _BUILD_f0l0(Data,vrr_stack+42070, vrr_stack+16189, vrr_stack+41800, vrr_stack+15109, vrr_stack+16054, vrr_stack+4666);
 _BUILD_g0l0(Data,vrr_stack+21382, vrr_stack+16459, vrr_stack+42070, vrr_stack+15379, vrr_stack+16189, vrr_stack+985);
 _BUILD_h0l0(Data,vrr_stack+1885, vrr_stack+40000, vrr_stack+21382, vrr_stack+3498, vrr_stack+16459, vrr_stack+23908);
 _BUILD_h0l0(Data,vrr_stack+64999, vrr_stack+41125, vrr_stack+40000, vrr_stack+40675, vrr_stack+3498, vrr_stack+22468);
 _BUILD_i0l0(Data,vrr_stack+65944, vrr_stack+64999, vrr_stack+1885, vrr_stack+41125, vrr_stack+40000, vrr_stack+42859);
 _BUILD_00l0(Data,vrr_stack+23908, vrr_stack+5038, vrr_stack+4198, vrr_stack+5458, vrr_stack+370, NULL);
 _BUILD_p0l0(Data,vrr_stack+23953, vrr_stack+23908, vrr_stack+16909, NULL, NULL, vrr_stack+4198);
 _BUILD_d0l0(Data,vrr_stack+24088, vrr_stack+23953, vrr_stack+8022, vrr_stack+23908, vrr_stack+16909, vrr_stack+4234);
 _BUILD_f0l0(Data,vrr_stack+42520, vrr_stack+24088, vrr_stack+8157, vrr_stack+23953, vrr_stack+8022, vrr_stack+4342);
 _BUILD_g0l0(Data,vrr_stack+4234, vrr_stack+42520, vrr_stack+40675, vrr_stack+24088, vrr_stack+8157, vrr_stack+23008);
 _BUILD_h0l0(Data,vrr_stack+22057, vrr_stack+4234, vrr_stack+41125, vrr_stack+42520, vrr_stack+40675, vrr_stack+23368);
 _BUILD_i0l0(Data,vrr_stack+67204, vrr_stack+22057, vrr_stack+64999, vrr_stack+4234, vrr_stack+41125, vrr_stack+43615);
 _BUILD_00l0(Data,vrr_stack+24358, vrr_stack+5182, vrr_stack+5486, vrr_stack+398, vrr_stack+520, NULL);
 _BUILD_p0l0(Data,vrr_stack+370, vrr_stack+10879, vrr_stack+24358, NULL, NULL, vrr_stack+5182);
 _BUILD_d0l0(Data,vrr_stack+922, vrr_stack+8427, vrr_stack+370, vrr_stack+10834, vrr_stack+10879, vrr_stack+5218);
 _BUILD_f0l0(Data,vrr_stack+42970, vrr_stack+41800, vrr_stack+922, vrr_stack+16054, vrr_stack+8427, vrr_stack+1345);
 _BUILD_g0l0(Data,vrr_stack+43420, vrr_stack+42070, vrr_stack+42970, vrr_stack+16189, vrr_stack+41800, vrr_stack+12058);
 _BUILD_h0l0(Data,vrr_stack+68464, vrr_stack+21382, vrr_stack+43420, vrr_stack+16459, vrr_stack+42070, vrr_stack+25024);
 _BUILD_i0l0(Data,vrr_stack+69409, vrr_stack+1885, vrr_stack+68464, vrr_stack+40000, vrr_stack+21382, vrr_stack+46675);
 _BUILD_k0l0(Data,vrr_stack+70669, vrr_stack+65944, vrr_stack+69409, vrr_stack+64999, vrr_stack+1885, vrr_stack+47431);
 _BUILD_k0l0(Data,vrr_stack+46675, vrr_stack+67204, vrr_stack+65944, vrr_stack+22057, vrr_stack+64999, vrr_stack+11050);
 _BUILD_l0l0(Data,vrr_stack+72289, vrr_stack+46675, vrr_stack+70669, vrr_stack+67204, vrr_stack+65944, vrr_stack+48439);
 _BUILD_00l0(Data,vrr_stack+24403, vrr_stack+5326, vrr_stack+5038, vrr_stack+128, vrr_stack+5458, NULL);
 _BUILD_p0l0(Data,vrr_stack+48295, vrr_stack+24403, vrr_stack+23908, NULL, NULL, vrr_stack+5038);
 _BUILD_d0l0(Data,vrr_stack+48430, vrr_stack+48295, vrr_stack+23953, vrr_stack+24403, vrr_stack+23908, vrr_stack+5074);
 _BUILD_f0l0(Data,vrr_stack+48700, vrr_stack+48430, vrr_stack+24088, vrr_stack+48295, vrr_stack+23953, vrr_stack+24448);
 _BUILD_g0l0(Data,vrr_stack+10924, vrr_stack+48700, vrr_stack+42520, vrr_stack+48430, vrr_stack+24088, vrr_stack+24664);
 _BUILD_h0l0(Data,vrr_stack+24448, vrr_stack+10924, vrr_stack+4234, vrr_stack+48700, vrr_stack+42520, vrr_stack+44371);
 _BUILD_i0l0(Data,vrr_stack+74314, vrr_stack+24448, vrr_stack+22057, vrr_stack+10924, vrr_stack+4234, vrr_stack+44911);
 _BUILD_k0l0(Data,vrr_stack+75574, vrr_stack+74314, vrr_stack+67204, vrr_stack+24448, vrr_stack+22057, vrr_stack+45667);
 _BUILD_l0l0(Data,vrr_stack+44095, vrr_stack+75574, vrr_stack+46675, vrr_stack+74314, vrr_stack+67204, vrr_stack+25564);
 _BUILD_00l0(Data,vrr_stack+25393, vrr_stack+5486, vrr_stack+6006, vrr_stack+520, vrr_stack+650, NULL);
 _BUILD_p0l0(Data,vrr_stack+25438, vrr_stack+24358, vrr_stack+25393, NULL, NULL, vrr_stack+5486);
 _BUILD_d0l0(Data,vrr_stack+25573, vrr_stack+370, vrr_stack+25438, vrr_stack+10879, vrr_stack+24358, vrr_stack+5522);
 _BUILD_f0l0(Data,vrr_stack+25843, vrr_stack+922, vrr_stack+25573, vrr_stack+8427, vrr_stack+370, vrr_stack+5630);
 _BUILD_g0l0(Data,vrr_stack+11599, vrr_stack+42970, vrr_stack+25843, vrr_stack+41800, vrr_stack+922, vrr_stack+13318);
 _BUILD_h0l0(Data,vrr_stack+77194, vrr_stack+43420, vrr_stack+11599, vrr_stack+42070, vrr_stack+42970, vrr_stack+13678);
 _BUILD_i0l0(Data,vrr_stack+78139, vrr_stack+68464, vrr_stack+77194, vrr_stack+21382, vrr_stack+43420, vrr_stack+14218);
 _BUILD_k0l0(Data,vrr_stack+13318, vrr_stack+69409, vrr_stack+78139, vrr_stack+1885, vrr_stack+68464, vrr_stack+53983);
 _BUILD_l0l0(Data,vrr_stack+79399, vrr_stack+70669, vrr_stack+13318, vrr_stack+65944, vrr_stack+69409, vrr_stack+54991);
 _BUILD_m0l0(Data,vrr_stack+81424, vrr_stack+72289, vrr_stack+79399, vrr_stack+46675, vrr_stack+70669, vrr_stack+28912);
 _BUILD_m0l0(Data,vrr_stack+83899, vrr_stack+44095, vrr_stack+72289, vrr_stack+75574, vrr_stack+46675, vrr_stack+49735);
 _BUILD_n0l0(Data,vrr_stack+86374, vrr_stack+83899, vrr_stack+81424, vrr_stack+44095, vrr_stack+72289, vrr_stack+56287);
 _BUILD_00l0(Data,vrr_stack+28912, vrr_stack+5908, vrr_stack+5326, vrr_stack+5880, vrr_stack+128, NULL);
 _BUILD_p0l0(Data,vrr_stack+28957, vrr_stack+28912, vrr_stack+24403, NULL, NULL, vrr_stack+5326);
 _BUILD_d0l0(Data,vrr_stack+29092, vrr_stack+28957, vrr_stack+48295, vrr_stack+28912, vrr_stack+24403, vrr_stack+1561);
 _BUILD_f0l0(Data,vrr_stack+29362, vrr_stack+29092, vrr_stack+48430, vrr_stack+28957, vrr_stack+48295, vrr_stack+1669);
 _BUILD_g0l0(Data,vrr_stack+29812, vrr_stack+29362, vrr_stack+48700, vrr_stack+29092, vrr_stack+48430, vrr_stack+12418);
 _BUILD_h0l0(Data,vrr_stack+53983, vrr_stack+29812, vrr_stack+10924, vrr_stack+29362, vrr_stack+48700, vrr_stack+12778);
 _BUILD_i0l0(Data,vrr_stack+54928, vrr_stack+53983, vrr_stack+24448, vrr_stack+29812, vrr_stack+10924, vrr_stack+26860);
 _BUILD_k0l0(Data,vrr_stack+56188, vrr_stack+54928, vrr_stack+74314, vrr_stack+53983, vrr_stack+24448, vrr_stack+51355);
 _BUILD_l0l0(Data,vrr_stack+49150, vrr_stack+56188, vrr_stack+75574, vrr_stack+54928, vrr_stack+74314, vrr_stack+27616);
   tmp = vrr_stack + 49150;
   target_ptr = Libint->vrr_classes[8][8];
   for(i=0;i<2025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0l0(Data,vrr_stack+26293, vrr_stack+49150, vrr_stack+44095, vrr_stack+56188, vrr_stack+75574, vrr_stack+52363);
   tmp = vrr_stack + 26293;
   target_ptr = Libint->vrr_classes[9][8];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0l0(Data,vrr_stack+51175, vrr_stack+26293, vrr_stack+83899, vrr_stack+49150, vrr_stack+44095, vrr_stack+30532);
   tmp = vrr_stack + 51175;
   target_ptr = Libint->vrr_classes[10][8];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+49150, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+49153, vrr_stack+5944, vrr_stack+49150, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+49159, vrr_stack+5947, vrr_stack+49153, vrr_stack+367, vrr_stack+5944, NULL);
 _BUILD_00g0(Data,vrr_stack+49169, vrr_stack+5953, vrr_stack+49159, vrr_stack+21, vrr_stack+5947, NULL);
 _BUILD_00h0(Data,vrr_stack+21, vrr_stack+5963, vrr_stack+49169, vrr_stack+604, vrr_stack+5953, NULL);
 _BUILD_00i0(Data,vrr_stack+42, vrr_stack+0, vrr_stack+21, vrr_stack+614, vrr_stack+5963, NULL);
 _BUILD_00k0(Data,vrr_stack+14938, vrr_stack+5978, vrr_stack+42, vrr_stack+629, vrr_stack+0, NULL);
 _BUILD_00l0(Data,vrr_stack+70, vrr_stack+6006, vrr_stack+14938, vrr_stack+650, vrr_stack+5978, NULL);
 _BUILD_p0l0(Data,vrr_stack+49184, vrr_stack+25393, vrr_stack+70, NULL, NULL, vrr_stack+6006);
 _BUILD_d0l0(Data,vrr_stack+49319, vrr_stack+25438, vrr_stack+49184, vrr_stack+24358, vrr_stack+25393, vrr_stack+6042);
 _BUILD_f0l0(Data,vrr_stack+49589, vrr_stack+25573, vrr_stack+49319, vrr_stack+370, vrr_stack+25438, vrr_stack+6150);
 _BUILD_g0l0(Data,vrr_stack+50039, vrr_stack+25843, vrr_stack+49589, vrr_stack+922, vrr_stack+25573, vrr_stack+6366);
 _BUILD_h0l0(Data,vrr_stack+28957, vrr_stack+11599, vrr_stack+50039, vrr_stack+42970, vrr_stack+25843, vrr_stack+6726);
 _BUILD_i0l0(Data,vrr_stack+29902, vrr_stack+77194, vrr_stack+28957, vrr_stack+43420, vrr_stack+11599, vrr_stack+7266);
 _BUILD_k0l0(Data,vrr_stack+6042, vrr_stack+78139, vrr_stack+29902, vrr_stack+68464, vrr_stack+77194, vrr_stack+34888);
 _BUILD_l0l0(Data,vrr_stack+54145, vrr_stack+13318, vrr_stack+6042, vrr_stack+69409, vrr_stack+78139, vrr_stack+35896);
 _BUILD_m0l0(Data,vrr_stack+89344, vrr_stack+79399, vrr_stack+54145, vrr_stack+70669, vrr_stack+13318, vrr_stack+16954);
 _BUILD_n0l0(Data,vrr_stack+91819, vrr_stack+81424, vrr_stack+89344, vrr_stack+72289, vrr_stack+79399, vrr_stack+60643);
 _BUILD_o0l0(Data,vrr_stack+94789, vrr_stack+86374, vrr_stack+91819, vrr_stack+83899, vrr_stack+81424, vrr_stack+62623);
 _BUILD_o0l0(Data,vrr_stack+60643, vrr_stack+51175, vrr_stack+86374, vrr_stack+26293, vrr_stack+83899, vrr_stack+58267);
   tmp = vrr_stack + 60643;
   target_ptr = Libint->vrr_classes[11][8];
   for(i=0;i<3510;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+26293, vrr_stack+14974, vrr_stack+15064, vrr_stack+805, vrr_stack+226, NULL);
 _BUILD_00m0(Data,vrr_stack+26348, vrr_stack+15019, vrr_stack+14974, vrr_stack+841, vrr_stack+805, NULL);
 _BUILD_00m0(Data,vrr_stack+26403, vrr_stack+15064, vrr_stack+10834, vrr_stack+226, vrr_stack+4086, NULL);
 _BUILD_p0m0(Data,vrr_stack+26458, vrr_stack+26293, vrr_stack+26403, NULL, NULL, vrr_stack+15064);
 _BUILD_p0m0(Data,vrr_stack+26623, vrr_stack+26348, vrr_stack+26293, NULL, NULL, vrr_stack+14974);
 _BUILD_d0m0(Data,vrr_stack+26788, vrr_stack+26623, vrr_stack+26458, vrr_stack+26348, vrr_stack+26293, vrr_stack+15109);
 _BUILD_00m0(Data,vrr_stack+15109, vrr_stack+877, vrr_stack+15019, vrr_stack+3974, vrr_stack+841, NULL);
 _BUILD_p0m0(Data,vrr_stack+27118, vrr_stack+15109, vrr_stack+26348, NULL, NULL, vrr_stack+15019);
 _BUILD_d0m0(Data,vrr_stack+27283, vrr_stack+27118, vrr_stack+26623, vrr_stack+15109, vrr_stack+26348, vrr_stack+15244);
 _BUILD_00m0(Data,vrr_stack+15164, vrr_stack+10834, vrr_stack+10879, vrr_stack+4086, vrr_stack+4926, NULL);
 _BUILD_p0m0(Data,vrr_stack+27613, vrr_stack+26403, vrr_stack+15164, NULL, NULL, vrr_stack+10834);
 _BUILD_d0m0(Data,vrr_stack+27778, vrr_stack+26458, vrr_stack+27613, vrr_stack+26293, vrr_stack+26403, vrr_stack+16054);
 _BUILD_f0m0(Data,vrr_stack+28108, vrr_stack+26788, vrr_stack+27778, vrr_stack+26623, vrr_stack+26458, vrr_stack+16189);
 _BUILD_f0m0(Data,vrr_stack+64153, vrr_stack+27283, vrr_stack+26788, vrr_stack+27118, vrr_stack+26623, vrr_stack+15379);
 _BUILD_g0m0(Data,vrr_stack+16954, vrr_stack+64153, vrr_stack+28108, vrr_stack+27283, vrr_stack+26788, vrr_stack+16459);
 _BUILD_00m0(Data,vrr_stack+16054, vrr_stack+16909, vrr_stack+877, vrr_stack+4198, vrr_stack+3974, NULL);
 _BUILD_p0m0(Data,vrr_stack+16109, vrr_stack+16054, vrr_stack+15109, NULL, NULL, vrr_stack+877);
 _BUILD_d0m0(Data,vrr_stack+16274, vrr_stack+16109, vrr_stack+27118, vrr_stack+16054, vrr_stack+15109, vrr_stack+15649);
 _BUILD_f0m0(Data,vrr_stack+15219, vrr_stack+16274, vrr_stack+27283, vrr_stack+16109, vrr_stack+27118, vrr_stack+15784);
 _BUILD_g0m0(Data,vrr_stack+34888, vrr_stack+15219, vrr_stack+64153, vrr_stack+16274, vrr_stack+27283, vrr_stack+3498);
 _BUILD_00m0(Data,vrr_stack+16604, vrr_stack+10879, vrr_stack+24358, vrr_stack+4926, vrr_stack+5182, NULL);
 _BUILD_p0m0(Data,vrr_stack+16659, vrr_stack+15164, vrr_stack+16604, NULL, NULL, vrr_stack+10879);
 _BUILD_d0m0(Data,vrr_stack+17779, vrr_stack+27613, vrr_stack+16659, vrr_stack+26403, vrr_stack+15164, vrr_stack+8427);
 _BUILD_f0m0(Data,vrr_stack+35713, vrr_stack+27778, vrr_stack+17779, vrr_stack+26458, vrr_stack+27613, vrr_stack+41800);
 _BUILD_g0m0(Data,vrr_stack+36263, vrr_stack+28108, vrr_stack+35713, vrr_stack+26788, vrr_stack+27778, vrr_stack+42070);
 _BUILD_h0m0(Data,vrr_stack+31162, vrr_stack+16954, vrr_stack+36263, vrr_stack+64153, vrr_stack+28108, vrr_stack+21382);
 _BUILD_h0m0(Data,vrr_stack+56170, vrr_stack+34888, vrr_stack+16954, vrr_stack+15219, vrr_stack+64153, vrr_stack+40000);
 _BUILD_i0m0(Data,vrr_stack+98299, vrr_stack+56170, vrr_stack+31162, vrr_stack+34888, vrr_stack+16954, vrr_stack+1885);
 _BUILD_00m0(Data,vrr_stack+40000, vrr_stack+23908, vrr_stack+16909, vrr_stack+5038, vrr_stack+4198, NULL);
 _BUILD_p0m0(Data,vrr_stack+40055, vrr_stack+40000, vrr_stack+16054, NULL, NULL, vrr_stack+16909);
 _BUILD_d0m0(Data,vrr_stack+40220, vrr_stack+40055, vrr_stack+16109, vrr_stack+40000, vrr_stack+16054, vrr_stack+8022);
 _BUILD_f0m0(Data,vrr_stack+21382, vrr_stack+40220, vrr_stack+16274, vrr_stack+40055, vrr_stack+16109, vrr_stack+8157);
 _BUILD_g0m0(Data,vrr_stack+7662, vrr_stack+21382, vrr_stack+15219, vrr_stack+40220, vrr_stack+16274, vrr_stack+40675);
 _BUILD_h0m0(Data,vrr_stack+1192, vrr_stack+7662, vrr_stack+34888, vrr_stack+21382, vrr_stack+15219, vrr_stack+41125);
 _BUILD_i0m0(Data,vrr_stack+40550, vrr_stack+1192, vrr_stack+56170, vrr_stack+7662, vrr_stack+34888, vrr_stack+64999);
 _BUILD_00m0(Data,vrr_stack+42090, vrr_stack+24358, vrr_stack+25393, vrr_stack+5182, vrr_stack+5486, NULL);
 _BUILD_p0m0(Data,vrr_stack+42145, vrr_stack+16604, vrr_stack+42090, NULL, NULL, vrr_stack+24358);
 _BUILD_d0m0(Data,vrr_stack+64703, vrr_stack+16659, vrr_stack+42145, vrr_stack+15164, vrr_stack+16604, vrr_stack+370);
 _BUILD_f0m0(Data,vrr_stack+65033, vrr_stack+17779, vrr_stack+64703, vrr_stack+27613, vrr_stack+16659, vrr_stack+922);
 _BUILD_g0m0(Data,vrr_stack+57325, vrr_stack+35713, vrr_stack+65033, vrr_stack+27778, vrr_stack+17779, vrr_stack+42970);
 _BUILD_h0m0(Data,vrr_stack+2347, vrr_stack+36263, vrr_stack+57325, vrr_stack+28108, vrr_stack+35713, vrr_stack+43420);
 _BUILD_i0m0(Data,vrr_stack+99839, vrr_stack+31162, vrr_stack+2347, vrr_stack+16954, vrr_stack+36263, vrr_stack+68464);
 _BUILD_k0m0(Data,vrr_stack+101379, vrr_stack+98299, vrr_stack+99839, vrr_stack+56170, vrr_stack+31162, vrr_stack+69409);
 _BUILD_k0m0(Data,vrr_stack+68464, vrr_stack+40550, vrr_stack+98299, vrr_stack+1192, vrr_stack+56170, vrr_stack+65944);
 _BUILD_l0m0(Data,vrr_stack+103359, vrr_stack+68464, vrr_stack+101379, vrr_stack+40550, vrr_stack+98299, vrr_stack+70669);
 _BUILD_00m0(Data,vrr_stack+70444, vrr_stack+24403, vrr_stack+23908, vrr_stack+5326, vrr_stack+5038, NULL);
 _BUILD_p0m0(Data,vrr_stack+70499, vrr_stack+70444, vrr_stack+40000, NULL, NULL, vrr_stack+23908);
 _BUILD_d0m0(Data,vrr_stack+70664, vrr_stack+70499, vrr_stack+40055, vrr_stack+70444, vrr_stack+40000, vrr_stack+23953);
 _BUILD_f0m0(Data,vrr_stack+70994, vrr_stack+70664, vrr_stack+40220, vrr_stack+70499, vrr_stack+40055, vrr_stack+24088);
 _BUILD_g0m0(Data,vrr_stack+42970, vrr_stack+70994, vrr_stack+21382, vrr_stack+70664, vrr_stack+40220, vrr_stack+42520);
 _BUILD_h0m0(Data,vrr_stack+65583, vrr_stack+42970, vrr_stack+7662, vrr_stack+70994, vrr_stack+21382, vrr_stack+4234);
 _BUILD_i0m0(Data,vrr_stack+3502, vrr_stack+65583, vrr_stack+1192, vrr_stack+42970, vrr_stack+7662, vrr_stack+22057);
 _BUILD_k0m0(Data,vrr_stack+105834, vrr_stack+3502, vrr_stack+40550, vrr_stack+65583, vrr_stack+1192, vrr_stack+67204);
 _BUILD_l0m0(Data,vrr_stack+107814, vrr_stack+105834, vrr_stack+68464, vrr_stack+3502, vrr_stack+40550, vrr_stack+46675);
 _BUILD_00m0(Data,vrr_stack+23953, vrr_stack+25393, vrr_stack+70, vrr_stack+5486, vrr_stack+6006, NULL);
 _BUILD_p0m0(Data,vrr_stack+24008, vrr_stack+42090, vrr_stack+23953, NULL, NULL, vrr_stack+25393);
 _BUILD_d0m0(Data,vrr_stack+71544, vrr_stack+42145, vrr_stack+24008, vrr_stack+16604, vrr_stack+42090, vrr_stack+25438);
 _BUILD_f0m0(Data,vrr_stack+42310, vrr_stack+64703, vrr_stack+71544, vrr_stack+16659, vrr_stack+42145, vrr_stack+25573);
 _BUILD_g0m0(Data,vrr_stack+21932, vrr_stack+65033, vrr_stack+42310, vrr_stack+17779, vrr_stack+64703, vrr_stack+25843);
 _BUILD_h0m0(Data,vrr_stack+66738, vrr_stack+57325, vrr_stack+21932, vrr_stack+35713, vrr_stack+65033, vrr_stack+11599);
 _BUILD_i0m0(Data,vrr_stack+11599, vrr_stack+2347, vrr_stack+66738, vrr_stack+36263, vrr_stack+57325, vrr_stack+77194);
 _BUILD_k0m0(Data,vrr_stack+46120, vrr_stack+99839, vrr_stack+11599, vrr_stack+31162, vrr_stack+2347, vrr_stack+78139);
 _BUILD_l0m0(Data,vrr_stack+110289, vrr_stack+101379, vrr_stack+46120, vrr_stack+98299, vrr_stack+99839, vrr_stack+13318);
 _BUILD_m0m0(Data,vrr_stack+112764, vrr_stack+103359, vrr_stack+110289, vrr_stack+68464, vrr_stack+101379, vrr_stack+79399);
 _BUILD_m0m0(Data,vrr_stack+77194, vrr_stack+107814, vrr_stack+103359, vrr_stack+105834, vrr_stack+68464, vrr_stack+72289);
 _BUILD_n0m0(Data,vrr_stack+115789, vrr_stack+77194, vrr_stack+112764, vrr_stack+107814, vrr_stack+103359, vrr_stack+81424);
 _BUILD_00m0(Data,vrr_stack+80219, vrr_stack+28912, vrr_stack+24403, vrr_stack+5908, vrr_stack+5326, NULL);
 _BUILD_p0m0(Data,vrr_stack+80274, vrr_stack+80219, vrr_stack+70444, NULL, NULL, vrr_stack+24403);
 _BUILD_d0m0(Data,vrr_stack+80439, vrr_stack+80274, vrr_stack+70499, vrr_stack+80219, vrr_stack+70444, vrr_stack+48295);
 _BUILD_f0m0(Data,vrr_stack+80769, vrr_stack+80439, vrr_stack+70664, vrr_stack+80274, vrr_stack+70499, vrr_stack+48430);
 _BUILD_g0m0(Data,vrr_stack+81319, vrr_stack+80769, vrr_stack+70994, vrr_stack+80439, vrr_stack+70664, vrr_stack+48700);
 _BUILD_h0m0(Data,vrr_stack+82144, vrr_stack+81319, vrr_stack+42970, vrr_stack+80769, vrr_stack+70994, vrr_stack+10924);
 _BUILD_i0m0(Data,vrr_stack+13139, vrr_stack+82144, vrr_stack+65583, vrr_stack+81319, vrr_stack+42970, vrr_stack+24448);
 _BUILD_k0m0(Data,vrr_stack+71874, vrr_stack+13139, vrr_stack+3502, vrr_stack+82144, vrr_stack+65583, vrr_stack+74314);
 _BUILD_l0m0(Data,vrr_stack+80274, vrr_stack+71874, vrr_stack+105834, vrr_stack+13139, vrr_stack+3502, vrr_stack+75574);
   tmp = vrr_stack + 80274;
   target_ptr = Libint->vrr_classes[8][9];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0m0(Data,vrr_stack+73854, vrr_stack+80274, vrr_stack+107814, vrr_stack+71874, vrr_stack+105834, vrr_stack+44095);
   tmp = vrr_stack + 73854;
   target_ptr = Libint->vrr_classes[9][9];
   for(i=0;i<3025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0m0(Data,vrr_stack+119419, vrr_stack+73854, vrr_stack+77194, vrr_stack+80274, vrr_stack+107814, vrr_stack+83899);
   tmp = vrr_stack + 119419;
   target_ptr = Libint->vrr_classes[10][9];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+80274, Data->F+20, Data->F+21, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+80277, vrr_stack+49150, vrr_stack+80274, Data->F+19, Data->F+20, NULL);
 _BUILD_00f0(Data,vrr_stack+80283, vrr_stack+49153, vrr_stack+80277, vrr_stack+5944, vrr_stack+49150, NULL);
 _BUILD_00g0(Data,vrr_stack+80293, vrr_stack+49159, vrr_stack+80283, vrr_stack+5947, vrr_stack+49153, NULL);
 _BUILD_00h0(Data,vrr_stack+80308, vrr_stack+49169, vrr_stack+80293, vrr_stack+5953, vrr_stack+49159, NULL);
 _BUILD_00i0(Data,vrr_stack+80329, vrr_stack+21, vrr_stack+80308, vrr_stack+5963, vrr_stack+49169, NULL);
 _BUILD_00k0(Data,vrr_stack+80357, vrr_stack+42, vrr_stack+80329, vrr_stack+0, vrr_stack+21, NULL);
 _BUILD_00l0(Data,vrr_stack+80393, vrr_stack+14938, vrr_stack+80357, vrr_stack+5978, vrr_stack+42, NULL);
 _BUILD_00m0(Data,vrr_stack+80438, vrr_stack+70, vrr_stack+80393, vrr_stack+6006, vrr_stack+14938, NULL);
 _BUILD_p0m0(Data,vrr_stack+80493, vrr_stack+23953, vrr_stack+80438, NULL, NULL, vrr_stack+70);
 _BUILD_d0m0(Data,vrr_stack+80658, vrr_stack+24008, vrr_stack+80493, vrr_stack+42090, vrr_stack+23953, vrr_stack+49184);
 _BUILD_f0m0(Data,vrr_stack+80988, vrr_stack+71544, vrr_stack+80658, vrr_stack+42145, vrr_stack+24008, vrr_stack+49319);
 _BUILD_g0m0(Data,vrr_stack+81538, vrr_stack+42310, vrr_stack+80988, vrr_stack+64703, vrr_stack+71544, vrr_stack+49589);
 _BUILD_h0m0(Data,vrr_stack+82363, vrr_stack+21932, vrr_stack+81538, vrr_stack+65033, vrr_stack+42310, vrr_stack+50039);
 _BUILD_i0m0(Data,vrr_stack+49184, vrr_stack+66738, vrr_stack+82363, vrr_stack+57325, vrr_stack+21932, vrr_stack+28957);
 _BUILD_k0m0(Data,vrr_stack+71874, vrr_stack+11599, vrr_stack+49184, vrr_stack+2347, vrr_stack+66738, vrr_stack+29902);
 _BUILD_l0m0(Data,vrr_stack+83518, vrr_stack+46120, vrr_stack+71874, vrr_stack+99839, vrr_stack+11599, vrr_stack+6042);
 _BUILD_m0m0(Data,vrr_stack+123049, vrr_stack+110289, vrr_stack+83518, vrr_stack+101379, vrr_stack+46120, vrr_stack+54145);
 _BUILD_n0m0(Data,vrr_stack+126074, vrr_stack+112764, vrr_stack+123049, vrr_stack+103359, vrr_stack+110289, vrr_stack+89344);
 _BUILD_o0m0(Data,vrr_stack+129704, vrr_stack+115789, vrr_stack+126074, vrr_stack+77194, vrr_stack+112764, vrr_stack+91819);
 _BUILD_o0m0(Data,vrr_stack+89344, vrr_stack+119419, vrr_stack+115789, vrr_stack+73854, vrr_stack+77194, vrr_stack+86374);
   tmp = vrr_stack + 89344;
   target_ptr = Libint->vrr_classes[11][9];
   for(i=0;i<4290;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+73854, vrr_stack+26293, vrr_stack+26403, vrr_stack+14974, vrr_stack+15064, NULL);
 _BUILD_00n0(Data,vrr_stack+73920, vrr_stack+26348, vrr_stack+26293, vrr_stack+15019, vrr_stack+14974, NULL);
 _BUILD_00n0(Data,vrr_stack+73986, vrr_stack+26403, vrr_stack+15164, vrr_stack+15064, vrr_stack+10834, NULL);
 _BUILD_p0n0(Data,vrr_stack+74052, vrr_stack+73854, vrr_stack+73986, NULL, NULL, vrr_stack+26403);
 _BUILD_p0n0(Data,vrr_stack+74250, vrr_stack+73920, vrr_stack+73854, NULL, NULL, vrr_stack+26293);
 _BUILD_d0n0(Data,vrr_stack+74448, vrr_stack+74250, vrr_stack+74052, vrr_stack+73920, vrr_stack+73854, vrr_stack+26458);
 _BUILD_00n0(Data,vrr_stack+26458, vrr_stack+15109, vrr_stack+26348, vrr_stack+877, vrr_stack+15019, NULL);
 _BUILD_p0n0(Data,vrr_stack+74844, vrr_stack+26458, vrr_stack+73920, NULL, NULL, vrr_stack+26348);
 _BUILD_d0n0(Data,vrr_stack+75042, vrr_stack+74844, vrr_stack+74250, vrr_stack+26458, vrr_stack+73920, vrr_stack+26623);
 _BUILD_00n0(Data,vrr_stack+26524, vrr_stack+15164, vrr_stack+16604, vrr_stack+10834, vrr_stack+10879, NULL);
 _BUILD_p0n0(Data,vrr_stack+26590, vrr_stack+73986, vrr_stack+26524, NULL, NULL, vrr_stack+15164);
 _BUILD_d0n0(Data,vrr_stack+75438, vrr_stack+74052, vrr_stack+26590, vrr_stack+73854, vrr_stack+73986, vrr_stack+27613);
 _BUILD_f0n0(Data,vrr_stack+75834, vrr_stack+74448, vrr_stack+75438, vrr_stack+74250, vrr_stack+74052, vrr_stack+27778);
 _BUILD_f0n0(Data,vrr_stack+76494, vrr_stack+75042, vrr_stack+74448, vrr_stack+74844, vrr_stack+74250, vrr_stack+26788);
 _BUILD_g0n0(Data,vrr_stack+93634, vrr_stack+76494, vrr_stack+75834, vrr_stack+75042, vrr_stack+74448, vrr_stack+28108);
 _BUILD_00n0(Data,vrr_stack+26788, vrr_stack+16054, vrr_stack+15109, vrr_stack+16909, vrr_stack+877, NULL);
 _BUILD_p0n0(Data,vrr_stack+26854, vrr_stack+26788, vrr_stack+26458, NULL, NULL, vrr_stack+15109);
 _BUILD_d0n0(Data,vrr_stack+27613, vrr_stack+26854, vrr_stack+74844, vrr_stack+26788, vrr_stack+26458, vrr_stack+27118);
 _BUILD_f0n0(Data,vrr_stack+28009, vrr_stack+27613, vrr_stack+75042, vrr_stack+26854, vrr_stack+74844, vrr_stack+27283);
 _BUILD_g0n0(Data,vrr_stack+54145, vrr_stack+28009, vrr_stack+76494, vrr_stack+27613, vrr_stack+75042, vrr_stack+64153);
 _BUILD_00n0(Data,vrr_stack+64153, vrr_stack+16604, vrr_stack+42090, vrr_stack+10879, vrr_stack+24358, NULL);
 _BUILD_p0n0(Data,vrr_stack+64219, vrr_stack+26524, vrr_stack+64153, NULL, NULL, vrr_stack+16604);
 _BUILD_d0n0(Data,vrr_stack+27052, vrr_stack+26590, vrr_stack+64219, vrr_stack+73986, vrr_stack+26524, vrr_stack+16659);
 _BUILD_f0n0(Data,vrr_stack+10834, vrr_stack+75438, vrr_stack+27052, vrr_stack+74052, vrr_stack+26590, vrr_stack+17779);
 _BUILD_g0n0(Data,vrr_stack+55135, vrr_stack+75834, vrr_stack+10834, vrr_stack+74448, vrr_stack+75438, vrr_stack+35713);
 _BUILD_h0n0(Data,vrr_stack+28957, vrr_stack+93634, vrr_stack+55135, vrr_stack+76494, vrr_stack+75834, vrr_stack+36263);
 _BUILD_h0n0(Data,vrr_stack+35713, vrr_stack+54145, vrr_stack+93634, vrr_stack+28009, vrr_stack+76494, vrr_stack+16954);
 _BUILD_i0n0(Data,vrr_stack+43795, vrr_stack+35713, vrr_stack+28957, vrr_stack+54145, vrr_stack+93634, vrr_stack+31162);
 _BUILD_00n0(Data,vrr_stack+16954, vrr_stack+40000, vrr_stack+16054, vrr_stack+23908, vrr_stack+16909, NULL);
 _BUILD_p0n0(Data,vrr_stack+17020, vrr_stack+16954, vrr_stack+26788, NULL, NULL, vrr_stack+16054);
 _BUILD_d0n0(Data,vrr_stack+17218, vrr_stack+17020, vrr_stack+26854, vrr_stack+16954, vrr_stack+26788, vrr_stack+16109);
 _BUILD_f0n0(Data,vrr_stack+17614, vrr_stack+17218, vrr_stack+27613, vrr_stack+17020, vrr_stack+26854, vrr_stack+16274);
 _BUILD_g0n0(Data,vrr_stack+30343, vrr_stack+17614, vrr_stack+28009, vrr_stack+17218, vrr_stack+27613, vrr_stack+15219);
 _BUILD_h0n0(Data,vrr_stack+13139, vrr_stack+30343, vrr_stack+54145, vrr_stack+17614, vrr_stack+28009, vrr_stack+34888);
 _BUILD_i0n0(Data,vrr_stack+5042, vrr_stack+13139, vrr_stack+35713, vrr_stack+30343, vrr_stack+54145, vrr_stack+56170);
 _BUILD_00n0(Data,vrr_stack+34888, vrr_stack+42090, vrr_stack+23953, vrr_stack+24358, vrr_stack+25393, NULL);
 _BUILD_p0n0(Data,vrr_stack+34954, vrr_stack+64153, vrr_stack+34888, NULL, NULL, vrr_stack+42090);
 _BUILD_d0n0(Data,vrr_stack+35152, vrr_stack+64219, vrr_stack+34954, vrr_stack+26524, vrr_stack+64153, vrr_stack+42145);
 _BUILD_f0n0(Data,vrr_stack+15219, vrr_stack+27052, vrr_stack+35152, vrr_stack+26590, vrr_stack+64219, vrr_stack+64703);
 _BUILD_g0n0(Data,vrr_stack+56125, vrr_stack+10834, vrr_stack+15219, vrr_stack+75438, vrr_stack+27052, vrr_stack+65033);
 _BUILD_h0n0(Data,vrr_stack+133994, vrr_stack+55135, vrr_stack+56125, vrr_stack+75834, vrr_stack+10834, vrr_stack+57325);
 _BUILD_i0n0(Data,vrr_stack+135380, vrr_stack+28957, vrr_stack+133994, vrr_stack+93634, vrr_stack+55135, vrr_stack+2347);
 _BUILD_k0n0(Data,vrr_stack+137228, vrr_stack+43795, vrr_stack+135380, vrr_stack+35713, vrr_stack+28957, vrr_stack+99839);
 _BUILD_k0n0(Data,vrr_stack+139604, vrr_stack+5042, vrr_stack+43795, vrr_stack+13139, vrr_stack+35713, vrr_stack+98299);
 _BUILD_l0n0(Data,vrr_stack+98299, vrr_stack+139604, vrr_stack+137228, vrr_stack+5042, vrr_stack+43795, vrr_stack+101379);
 _BUILD_00n0(Data,vrr_stack+101269, vrr_stack+70444, vrr_stack+40000, vrr_stack+24403, vrr_stack+23908, NULL);
 _BUILD_p0n0(Data,vrr_stack+101335, vrr_stack+101269, vrr_stack+16954, NULL, NULL, vrr_stack+40000);
 _BUILD_d0n0(Data,vrr_stack+101533, vrr_stack+101335, vrr_stack+17020, vrr_stack+101269, vrr_stack+16954, vrr_stack+40055);
 _BUILD_f0n0(Data,vrr_stack+101929, vrr_stack+101533, vrr_stack+17218, vrr_stack+101335, vrr_stack+17020, vrr_stack+40220);
 _BUILD_g0n0(Data,vrr_stack+2347, vrr_stack+101929, vrr_stack+17614, vrr_stack+101533, vrr_stack+17218, vrr_stack+21382);
 _BUILD_h0n0(Data,vrr_stack+141980, vrr_stack+2347, vrr_stack+30343, vrr_stack+101929, vrr_stack+17614, vrr_stack+7662);
 _BUILD_i0n0(Data,vrr_stack+143366, vrr_stack+141980, vrr_stack+13139, vrr_stack+2347, vrr_stack+30343, vrr_stack+1192);
 _BUILD_k0n0(Data,vrr_stack+145214, vrr_stack+143366, vrr_stack+5042, vrr_stack+141980, vrr_stack+13139, vrr_stack+40550);
 _BUILD_l0n0(Data,vrr_stack+147590, vrr_stack+145214, vrr_stack+139604, vrr_stack+143366, vrr_stack+5042, vrr_stack+68464);
 _BUILD_00n0(Data,vrr_stack+21382, vrr_stack+23953, vrr_stack+80438, vrr_stack+25393, vrr_stack+70, NULL);
 _BUILD_p0n0(Data,vrr_stack+21448, vrr_stack+34888, vrr_stack+21382, NULL, NULL, vrr_stack+23953);
 _BUILD_d0n0(Data,vrr_stack+40055, vrr_stack+34954, vrr_stack+21448, vrr_stack+64153, vrr_stack+34888, vrr_stack+24008);
 _BUILD_f0n0(Data,vrr_stack+40451, vrr_stack+35152, vrr_stack+40055, vrr_stack+64219, vrr_stack+34954, vrr_stack+71544);
 _BUILD_g0n0(Data,vrr_stack+64417, vrr_stack+15219, vrr_stack+40451, vrr_stack+27052, vrr_stack+35152, vrr_stack+42310);
 _BUILD_h0n0(Data,vrr_stack+24448, vrr_stack+56125, vrr_stack+64417, vrr_stack+10834, vrr_stack+15219, vrr_stack+21932);
 _BUILD_i0n0(Data,vrr_stack+21646, vrr_stack+133994, vrr_stack+24448, vrr_stack+55135, vrr_stack+56125, vrr_stack+66738);
 _BUILD_k0n0(Data,vrr_stack+66738, vrr_stack+135380, vrr_stack+21646, vrr_stack+28957, vrr_stack+133994, vrr_stack+11599);
 _BUILD_l0n0(Data,vrr_stack+150560, vrr_stack+137228, vrr_stack+66738, vrr_stack+43795, vrr_stack+135380, vrr_stack+46120);
 _BUILD_m0n0(Data,vrr_stack+153530, vrr_stack+98299, vrr_stack+150560, vrr_stack+139604, vrr_stack+137228, vrr_stack+110289);
 _BUILD_m0n0(Data,vrr_stack+157160, vrr_stack+147590, vrr_stack+98299, vrr_stack+145214, vrr_stack+139604, vrr_stack+103359);
 _BUILD_n0n0(Data,vrr_stack+160790, vrr_stack+157160, vrr_stack+153530, vrr_stack+147590, vrr_stack+98299, vrr_stack+112764);
 _BUILD_00n0(Data,vrr_stack+110289, vrr_stack+80219, vrr_stack+70444, vrr_stack+28912, vrr_stack+24403, NULL);
 _BUILD_p0n0(Data,vrr_stack+110355, vrr_stack+110289, vrr_stack+101269, NULL, NULL, vrr_stack+70444);
 _BUILD_d0n0(Data,vrr_stack+110553, vrr_stack+110355, vrr_stack+101335, vrr_stack+110289, vrr_stack+101269, vrr_stack+70499);
 _BUILD_f0n0(Data,vrr_stack+110949, vrr_stack+110553, vrr_stack+101533, vrr_stack+110355, vrr_stack+101335, vrr_stack+70664);
 _BUILD_g0n0(Data,vrr_stack+111609, vrr_stack+110949, vrr_stack+101929, vrr_stack+110553, vrr_stack+101533, vrr_stack+70994);
 _BUILD_h0n0(Data,vrr_stack+112599, vrr_stack+111609, vrr_stack+2347, vrr_stack+110949, vrr_stack+101929, vrr_stack+42970);
 _BUILD_i0n0(Data,vrr_stack+102589, vrr_stack+112599, vrr_stack+141980, vrr_stack+111609, vrr_stack+2347, vrr_stack+65583);
 _BUILD_k0n0(Data,vrr_stack+45643, vrr_stack+102589, vrr_stack+143366, vrr_stack+112599, vrr_stack+141980, vrr_stack+3502);
 _BUILD_l0n0(Data,vrr_stack+110355, vrr_stack+45643, vrr_stack+145214, vrr_stack+102589, vrr_stack+143366, vrr_stack+105834);
   tmp = vrr_stack + 110355;
   target_ptr = Libint->vrr_classes[8][10];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0n0(Data,vrr_stack+102589, vrr_stack+110355, vrr_stack+147590, vrr_stack+45643, vrr_stack+145214, vrr_stack+107814);
   tmp = vrr_stack + 102589;
   target_ptr = Libint->vrr_classes[9][10];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0n0(Data,vrr_stack+165146, vrr_stack+102589, vrr_stack+157160, vrr_stack+110355, vrr_stack+147590, vrr_stack+77194);
   tmp = vrr_stack + 165146;
   target_ptr = Libint->vrr_classes[10][10];
   for(i=0;i<4356;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+110355, Data->F+21, Data->F+22, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+110358, vrr_stack+80274, vrr_stack+110355, Data->F+20, Data->F+21, NULL);
 _BUILD_00f0(Data,vrr_stack+110364, vrr_stack+80277, vrr_stack+110358, vrr_stack+49150, vrr_stack+80274, NULL);
 _BUILD_00g0(Data,vrr_stack+110374, vrr_stack+80283, vrr_stack+110364, vrr_stack+49153, vrr_stack+80277, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+80293, vrr_stack+110374, vrr_stack+49159, vrr_stack+80283, NULL);
 _BUILD_00i0(Data,vrr_stack+110389, vrr_stack+80308, vrr_stack+0, vrr_stack+49169, vrr_stack+80293, NULL);
 _BUILD_00k0(Data,vrr_stack+110417, vrr_stack+80329, vrr_stack+110389, vrr_stack+21, vrr_stack+80308, NULL);
 _BUILD_00l0(Data,vrr_stack+110453, vrr_stack+80357, vrr_stack+110417, vrr_stack+42, vrr_stack+80329, NULL);
 _BUILD_00m0(Data,vrr_stack+110498, vrr_stack+80393, vrr_stack+110453, vrr_stack+14938, vrr_stack+80357, NULL);
 _BUILD_00n0(Data,vrr_stack+110553, vrr_stack+80438, vrr_stack+110498, vrr_stack+70, vrr_stack+80393, NULL);
 _BUILD_p0n0(Data,vrr_stack+21, vrr_stack+21382, vrr_stack+110553, NULL, NULL, vrr_stack+80438);
 _BUILD_d0n0(Data,vrr_stack+219, vrr_stack+21448, vrr_stack+21, vrr_stack+34888, vrr_stack+21382, vrr_stack+80493);
 _BUILD_f0n0(Data,vrr_stack+615, vrr_stack+40055, vrr_stack+219, vrr_stack+34954, vrr_stack+21448, vrr_stack+80658);
 _BUILD_g0n0(Data,vrr_stack+1275, vrr_stack+40451, vrr_stack+615, vrr_stack+35152, vrr_stack+40055, vrr_stack+80988);
 _BUILD_h0n0(Data,vrr_stack+110619, vrr_stack+64417, vrr_stack+1275, vrr_stack+15219, vrr_stack+40451, vrr_stack+81538);
 _BUILD_i0n0(Data,vrr_stack+80493, vrr_stack+24448, vrr_stack+110619, vrr_stack+56125, vrr_stack+64417, vrr_stack+82363);
 _BUILD_k0n0(Data,vrr_stack+112005, vrr_stack+21646, vrr_stack+80493, vrr_stack+133994, vrr_stack+24448, vrr_stack+49184);
 _BUILD_l0n0(Data,vrr_stack+45643, vrr_stack+66738, vrr_stack+112005, vrr_stack+135380, vrr_stack+21646, vrr_stack+71874);
 _BUILD_m0n0(Data,vrr_stack+106219, vrr_stack+150560, vrr_stack+45643, vrr_stack+137228, vrr_stack+66738, vrr_stack+83518);
 _BUILD_n0n0(Data,vrr_stack+169502, vrr_stack+153530, vrr_stack+106219, vrr_stack+98299, vrr_stack+150560, vrr_stack+123049);
 _BUILD_o0n0(Data,vrr_stack+173858, vrr_stack+160790, vrr_stack+169502, vrr_stack+157160, vrr_stack+153530, vrr_stack+126074);
 _BUILD_o0n0(Data,vrr_stack+123049, vrr_stack+165146, vrr_stack+160790, vrr_stack+102589, vrr_stack+157160, vrr_stack+115789);
   tmp = vrr_stack + 123049;
   target_ptr = Libint->vrr_classes[11][10];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+102589, vrr_stack+73854, vrr_stack+73986, vrr_stack+26293, vrr_stack+26403, NULL);
 _BUILD_00o0(Data,vrr_stack+102667, vrr_stack+73920, vrr_stack+73854, vrr_stack+26348, vrr_stack+26293, NULL);
 _BUILD_00o0(Data,vrr_stack+102745, vrr_stack+73986, vrr_stack+26524, vrr_stack+26403, vrr_stack+15164, NULL);
 _BUILD_p0o0(Data,vrr_stack+102823, vrr_stack+102589, vrr_stack+102745, NULL, NULL, vrr_stack+73986);
 _BUILD_p0o0(Data,vrr_stack+103057, vrr_stack+102667, vrr_stack+102589, NULL, NULL, vrr_stack+73854);
 _BUILD_d0o0(Data,vrr_stack+103291, vrr_stack+103057, vrr_stack+102823, vrr_stack+102667, vrr_stack+102589, vrr_stack+74052);
 _BUILD_00o0(Data,vrr_stack+74052, vrr_stack+26458, vrr_stack+73920, vrr_stack+15109, vrr_stack+26348, NULL);
 _BUILD_p0o0(Data,vrr_stack+103759, vrr_stack+74052, vrr_stack+102667, NULL, NULL, vrr_stack+73920);
 _BUILD_d0o0(Data,vrr_stack+103993, vrr_stack+103759, vrr_stack+103057, vrr_stack+74052, vrr_stack+102667, vrr_stack+74250);
 _BUILD_00o0(Data,vrr_stack+74130, vrr_stack+26524, vrr_stack+64153, vrr_stack+15164, vrr_stack+16604, NULL);
 _BUILD_p0o0(Data,vrr_stack+74208, vrr_stack+102745, vrr_stack+74130, NULL, NULL, vrr_stack+26524);
 _BUILD_d0o0(Data,vrr_stack+104461, vrr_stack+102823, vrr_stack+74208, vrr_stack+102589, vrr_stack+102745, vrr_stack+26590);
 _BUILD_f0o0(Data,vrr_stack+104929, vrr_stack+103291, vrr_stack+104461, vrr_stack+103057, vrr_stack+102823, vrr_stack+75438);
 _BUILD_f0o0(Data,vrr_stack+128197, vrr_stack+103993, vrr_stack+103291, vrr_stack+103759, vrr_stack+103057, vrr_stack+74448);
 _BUILD_g0o0(Data,vrr_stack+82341, vrr_stack+128197, vrr_stack+104929, vrr_stack+103993, vrr_stack+103291, vrr_stack+75834);
 _BUILD_00o0(Data,vrr_stack+75438, vrr_stack+26788, vrr_stack+26458, vrr_stack+16054, vrr_stack+15109, NULL);
 _BUILD_p0o0(Data,vrr_stack+75516, vrr_stack+75438, vrr_stack+74052, NULL, NULL, vrr_stack+26458);
 _BUILD_d0o0(Data,vrr_stack+75750, vrr_stack+75516, vrr_stack+103759, vrr_stack+75438, vrr_stack+74052, vrr_stack+74844);
 _BUILD_f0o0(Data,vrr_stack+83511, vrr_stack+75750, vrr_stack+103993, vrr_stack+75516, vrr_stack+103759, vrr_stack+75042);
 _BUILD_g0o0(Data,vrr_stack+84291, vrr_stack+83511, vrr_stack+128197, vrr_stack+75750, vrr_stack+103993, vrr_stack+76494);
 _BUILD_00o0(Data,vrr_stack+76218, vrr_stack+64153, vrr_stack+34888, vrr_stack+16604, vrr_stack+42090, NULL);
 _BUILD_p0o0(Data,vrr_stack+76296, vrr_stack+74130, vrr_stack+76218, NULL, NULL, vrr_stack+64153);
 _BUILD_d0o0(Data,vrr_stack+76530, vrr_stack+74208, vrr_stack+76296, vrr_stack+102745, vrr_stack+74130, vrr_stack+64219);
 _BUILD_f0o0(Data,vrr_stack+76998, vrr_stack+104461, vrr_stack+76530, vrr_stack+102823, vrr_stack+74208, vrr_stack+27052);
 _BUILD_g0o0(Data,vrr_stack+77778, vrr_stack+104929, vrr_stack+76998, vrr_stack+103291, vrr_stack+104461, vrr_stack+10834);
 _BUILD_h0o0(Data,vrr_stack+10834, vrr_stack+82341, vrr_stack+77778, vrr_stack+128197, vrr_stack+104929, vrr_stack+55135);
 _BUILD_h0o0(Data,vrr_stack+48613, vrr_stack+84291, vrr_stack+82341, vrr_stack+83511, vrr_stack+128197, vrr_stack+93634);
 _BUILD_i0o0(Data,vrr_stack+70499, vrr_stack+48613, vrr_stack+10834, vrr_stack+84291, vrr_stack+82341, vrr_stack+28957);
 _BUILD_00o0(Data,vrr_stack+93634, vrr_stack+16954, vrr_stack+26788, vrr_stack+40000, vrr_stack+16054, NULL);
 _BUILD_p0o0(Data,vrr_stack+93712, vrr_stack+93634, vrr_stack+75438, NULL, NULL, vrr_stack+26788);
 _BUILD_d0o0(Data,vrr_stack+93946, vrr_stack+93712, vrr_stack+75516, vrr_stack+93634, vrr_stack+75438, vrr_stack+26854);
 _BUILD_f0o0(Data,vrr_stack+55135, vrr_stack+93946, vrr_stack+75750, vrr_stack+93712, vrr_stack+75516, vrr_stack+27613);
 _BUILD_g0o0(Data,vrr_stack+78948, vrr_stack+55135, vrr_stack+83511, vrr_stack+93946, vrr_stack+75750, vrr_stack+28009);
 _BUILD_h0o0(Data,vrr_stack+26854, vrr_stack+78948, vrr_stack+84291, vrr_stack+55135, vrr_stack+83511, vrr_stack+54145);
 _BUILD_i0o0(Data,vrr_stack+179006, vrr_stack+26854, vrr_stack+48613, vrr_stack+78948, vrr_stack+84291, vrr_stack+35713);
 _BUILD_00o0(Data,vrr_stack+54145, vrr_stack+34888, vrr_stack+21382, vrr_stack+42090, vrr_stack+23953, NULL);
 _BUILD_p0o0(Data,vrr_stack+54223, vrr_stack+76218, vrr_stack+54145, NULL, NULL, vrr_stack+34888);
 _BUILD_d0o0(Data,vrr_stack+54457, vrr_stack+76296, vrr_stack+54223, vrr_stack+74130, vrr_stack+76218, vrr_stack+34954);
 _BUILD_f0o0(Data,vrr_stack+28492, vrr_stack+76530, vrr_stack+54457, vrr_stack+74208, vrr_stack+76296, vrr_stack+35152);
 _BUILD_g0o0(Data,vrr_stack+34954, vrr_stack+76998, vrr_stack+28492, vrr_stack+104461, vrr_stack+76530, vrr_stack+15219);
 _BUILD_h0o0(Data,vrr_stack+41111, vrr_stack+77778, vrr_stack+34954, vrr_stack+104929, vrr_stack+76998, vrr_stack+56125);
 _BUILD_i0o0(Data,vrr_stack+55915, vrr_stack+10834, vrr_stack+41111, vrr_stack+82341, vrr_stack+77778, vrr_stack+133994);
 _BUILD_k0o0(Data,vrr_stack+181190, vrr_stack+70499, vrr_stack+55915, vrr_stack+48613, vrr_stack+10834, vrr_stack+135380);
 _BUILD_k0o0(Data,vrr_stack+133994, vrr_stack+179006, vrr_stack+70499, vrr_stack+26854, vrr_stack+48613, vrr_stack+43795);
 _BUILD_l0o0(Data,vrr_stack+183998, vrr_stack+133994, vrr_stack+181190, vrr_stack+179006, vrr_stack+70499, vrr_stack+137228);
 _BUILD_00o0(Data,vrr_stack+136802, vrr_stack+101269, vrr_stack+16954, vrr_stack+70444, vrr_stack+40000, NULL);
 _BUILD_p0o0(Data,vrr_stack+136880, vrr_stack+136802, vrr_stack+93634, NULL, NULL, vrr_stack+16954);
 _BUILD_d0o0(Data,vrr_stack+137114, vrr_stack+136880, vrr_stack+93712, vrr_stack+136802, vrr_stack+93634, vrr_stack+17020);
 _BUILD_f0o0(Data,vrr_stack+137582, vrr_stack+137114, vrr_stack+93946, vrr_stack+136880, vrr_stack+93712, vrr_stack+17218);
 _BUILD_g0o0(Data,vrr_stack+138362, vrr_stack+137582, vrr_stack+55135, vrr_stack+137114, vrr_stack+93946, vrr_stack+17614);
 _BUILD_h0o0(Data,vrr_stack+42749, vrr_stack+138362, vrr_stack+78948, vrr_stack+137582, vrr_stack+55135, vrr_stack+30343);
 _BUILD_i0o0(Data,vrr_stack+29272, vrr_stack+42749, vrr_stack+26854, vrr_stack+138362, vrr_stack+78948, vrr_stack+13139);
 _BUILD_k0o0(Data,vrr_stack+12472, vrr_stack+29272, vrr_stack+179006, vrr_stack+42749, vrr_stack+26854, vrr_stack+5042);
 _BUILD_l0o0(Data,vrr_stack+3337, vrr_stack+12472, vrr_stack+133994, vrr_stack+29272, vrr_stack+179006, vrr_stack+139604);
 _BUILD_00o0(Data,vrr_stack+17020, vrr_stack+21382, vrr_stack+110553, vrr_stack+23953, vrr_stack+80438, NULL);
 _BUILD_p0o0(Data,vrr_stack+17098, vrr_stack+54145, vrr_stack+17020, NULL, NULL, vrr_stack+21382);
 _BUILD_d0o0(Data,vrr_stack+17332, vrr_stack+54223, vrr_stack+17098, vrr_stack+76218, vrr_stack+54145, vrr_stack+21448);
 _BUILD_f0o0(Data,vrr_stack+139532, vrr_stack+54457, vrr_stack+17332, vrr_stack+76296, vrr_stack+54223, vrr_stack+40055);
 _BUILD_g0o0(Data,vrr_stack+140312, vrr_stack+28492, vrr_stack+139532, vrr_stack+76530, vrr_stack+54457, vrr_stack+40451);
 _BUILD_h0o0(Data,vrr_stack+15280, vrr_stack+34954, vrr_stack+140312, vrr_stack+76998, vrr_stack+28492, vrr_stack+64417);
 _BUILD_i0o0(Data,vrr_stack+64219, vrr_stack+41111, vrr_stack+15280, vrr_stack+77778, vrr_stack+34954, vrr_stack+24448);
 _BUILD_k0o0(Data,vrr_stack+23494, vrr_stack+55915, vrr_stack+64219, vrr_stack+10834, vrr_stack+41111, vrr_stack+21646);
 _BUILD_l0o0(Data,vrr_stack+187508, vrr_stack+181190, vrr_stack+23494, vrr_stack+70499, vrr_stack+55915, vrr_stack+66738);
 _BUILD_m0o0(Data,vrr_stack+191018, vrr_stack+183998, vrr_stack+187508, vrr_stack+133994, vrr_stack+181190, vrr_stack+150560);
 _BUILD_m0o0(Data,vrr_stack+195308, vrr_stack+3337, vrr_stack+183998, vrr_stack+12472, vrr_stack+133994, vrr_stack+98299);
 _BUILD_n0o0(Data,vrr_stack+199598, vrr_stack+195308, vrr_stack+191018, vrr_stack+3337, vrr_stack+183998, vrr_stack+153530);
 _BUILD_00o0(Data,vrr_stack+98299, vrr_stack+110289, vrr_stack+101269, vrr_stack+80219, vrr_stack+70444, NULL);
 _BUILD_p0o0(Data,vrr_stack+98377, vrr_stack+98299, vrr_stack+136802, NULL, NULL, vrr_stack+101269);
 _BUILD_d0o0(Data,vrr_stack+98611, vrr_stack+98377, vrr_stack+136880, vrr_stack+98299, vrr_stack+136802, vrr_stack+101335);
 _BUILD_f0o0(Data,vrr_stack+99079, vrr_stack+98611, vrr_stack+137114, vrr_stack+98377, vrr_stack+136880, vrr_stack+101533);
 _BUILD_g0o0(Data,vrr_stack+99859, vrr_stack+99079, vrr_stack+137582, vrr_stack+98611, vrr_stack+137114, vrr_stack+101929);
 _BUILD_h0o0(Data,vrr_stack+150560, vrr_stack+99859, vrr_stack+138362, vrr_stack+99079, vrr_stack+137582, vrr_stack+2347);
 _BUILD_i0o0(Data,vrr_stack+152198, vrr_stack+150560, vrr_stack+42749, vrr_stack+99859, vrr_stack+138362, vrr_stack+141980);
 _BUILD_k0o0(Data,vrr_stack+98377, vrr_stack+152198, vrr_stack+29272, vrr_stack+150560, vrr_stack+42749, vrr_stack+143366);
 _BUILD_l0o0(Data,vrr_stack+141482, vrr_stack+98377, vrr_stack+12472, vrr_stack+152198, vrr_stack+29272, vrr_stack+145214);
   tmp = vrr_stack + 141482;
   target_ptr = Libint->vrr_classes[8][11];
   for(i=0;i<3510;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0o0(Data,vrr_stack+150560, vrr_stack+141482, vrr_stack+3337, vrr_stack+98377, vrr_stack+12472, vrr_stack+147590);
   tmp = vrr_stack + 150560;
   target_ptr = Libint->vrr_classes[9][11];
   for(i=0;i<4290;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0o0(Data,vrr_stack+144992, vrr_stack+150560, vrr_stack+195308, vrr_stack+141482, vrr_stack+3337, vrr_stack+157160);
   tmp = vrr_stack + 144992;
   target_ptr = Libint->vrr_classes[10][11];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+141482, Data->F+22, Data->F+23, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+141485, vrr_stack+110355, vrr_stack+141482, Data->F+21, Data->F+22, NULL);
 _BUILD_00f0(Data,vrr_stack+141491, vrr_stack+110358, vrr_stack+141485, vrr_stack+80274, vrr_stack+110355, NULL);
 _BUILD_00g0(Data,vrr_stack+141501, vrr_stack+110364, vrr_stack+141491, vrr_stack+80277, vrr_stack+110358, NULL);
 _BUILD_00h0(Data,vrr_stack+141516, vrr_stack+110374, vrr_stack+141501, vrr_stack+80283, vrr_stack+110364, NULL);
 _BUILD_00i0(Data,vrr_stack+141537, vrr_stack+0, vrr_stack+141516, vrr_stack+80293, vrr_stack+110374, NULL);
 _BUILD_00k0(Data,vrr_stack+16918, vrr_stack+110389, vrr_stack+141537, vrr_stack+80308, vrr_stack+0, NULL);
 _BUILD_00l0(Data,vrr_stack+141565, vrr_stack+110417, vrr_stack+16918, vrr_stack+80329, vrr_stack+110389, NULL);
 _BUILD_00m0(Data,vrr_stack+141610, vrr_stack+110453, vrr_stack+141565, vrr_stack+80357, vrr_stack+110417, NULL);
 _BUILD_00n0(Data,vrr_stack+141665, vrr_stack+110498, vrr_stack+141610, vrr_stack+80393, vrr_stack+110453, NULL);
 _BUILD_00o0(Data,vrr_stack+141731, vrr_stack+110553, vrr_stack+141665, vrr_stack+80438, vrr_stack+110498, NULL);
 _BUILD_p0o0(Data,vrr_stack+141809, vrr_stack+17020, vrr_stack+141731, NULL, NULL, vrr_stack+110553);
 _BUILD_d0o0(Data,vrr_stack+142043, vrr_stack+17098, vrr_stack+141809, vrr_stack+54145, vrr_stack+17020, vrr_stack+21);
 _BUILD_f0o0(Data,vrr_stack+142511, vrr_stack+17332, vrr_stack+142043, vrr_stack+54223, vrr_stack+17098, vrr_stack+219);
 _BUILD_g0o0(Data,vrr_stack+143291, vrr_stack+139532, vrr_stack+142511, vrr_stack+54457, vrr_stack+17332, vrr_stack+615);
 _BUILD_h0o0(Data,vrr_stack+98377, vrr_stack+140312, vrr_stack+143291, vrr_stack+28492, vrr_stack+139532, vrr_stack+1275);
 _BUILD_i0o0(Data,vrr_stack+21, vrr_stack+15280, vrr_stack+98377, vrr_stack+34954, vrr_stack+140312, vrr_stack+110619);
 _BUILD_k0o0(Data,vrr_stack+154850, vrr_stack+64219, vrr_stack+21, vrr_stack+41111, vrr_stack+15280, vrr_stack+80493);
 _BUILD_l0o0(Data,vrr_stack+66403, vrr_stack+23494, vrr_stack+154850, vrr_stack+55915, vrr_stack+64219, vrr_stack+112005);
 _BUILD_m0o0(Data,vrr_stack+110619, vrr_stack+187508, vrr_stack+66403, vrr_stack+181190, vrr_stack+23494, vrr_stack+45643);
 _BUILD_n0o0(Data,vrr_stack+204746, vrr_stack+191018, vrr_stack+110619, vrr_stack+183998, vrr_stack+187508, vrr_stack+106219);
 _BUILD_o0o0(Data,vrr_stack+209894, vrr_stack+199598, vrr_stack+204746, vrr_stack+195308, vrr_stack+191018, vrr_stack+169502);
 _BUILD_o0o0(Data,vrr_stack+215978, vrr_stack+144992, vrr_stack+199598, vrr_stack+150560, vrr_stack+195308, vrr_stack+160790);
   tmp = vrr_stack + 215978;
   target_ptr = Libint->vrr_classes[11][11];
   for(i=0;i<6084;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+169502, vrr_stack+102589, vrr_stack+102745, vrr_stack+73854, vrr_stack+73986, NULL);
 _BUILD_00q0(Data,vrr_stack+169593, vrr_stack+102667, vrr_stack+102589, vrr_stack+73920, vrr_stack+73854, NULL);
 _BUILD_00q0(Data,vrr_stack+169684, vrr_stack+102745, vrr_stack+74130, vrr_stack+73986, vrr_stack+26524, NULL);
 _BUILD_p0q0(Data,vrr_stack+169775, vrr_stack+169502, vrr_stack+169684, NULL, NULL, vrr_stack+102745);
 _BUILD_p0q0(Data,vrr_stack+170048, vrr_stack+169593, vrr_stack+169502, NULL, NULL, vrr_stack+102589);
 _BUILD_d0q0(Data,vrr_stack+170321, vrr_stack+170048, vrr_stack+169775, vrr_stack+169593, vrr_stack+169502, vrr_stack+102823);
 _BUILD_00q0(Data,vrr_stack+102823, vrr_stack+74052, vrr_stack+102667, vrr_stack+26458, vrr_stack+73920, NULL);
 _BUILD_p0q0(Data,vrr_stack+170867, vrr_stack+102823, vrr_stack+169593, NULL, NULL, vrr_stack+102667);
 _BUILD_d0q0(Data,vrr_stack+171140, vrr_stack+170867, vrr_stack+170048, vrr_stack+102823, vrr_stack+169593, vrr_stack+103057);
 _BUILD_00q0(Data,vrr_stack+102914, vrr_stack+74130, vrr_stack+76218, vrr_stack+26524, vrr_stack+64153, NULL);
 _BUILD_p0q0(Data,vrr_stack+103005, vrr_stack+169684, vrr_stack+102914, NULL, NULL, vrr_stack+74130);
 _BUILD_d0q0(Data,vrr_stack+171686, vrr_stack+169775, vrr_stack+103005, vrr_stack+169502, vrr_stack+169684, vrr_stack+74208);
 _BUILD_f0q0(Data,vrr_stack+74208, vrr_stack+170321, vrr_stack+171686, vrr_stack+170048, vrr_stack+169775, vrr_stack+104461);
 _BUILD_f0q0(Data,vrr_stack+172232, vrr_stack+171140, vrr_stack+170321, vrr_stack+170867, vrr_stack+170048, vrr_stack+103291);
 _BUILD_g0q0(Data,vrr_stack+157658, vrr_stack+172232, vrr_stack+74208, vrr_stack+171140, vrr_stack+170321, vrr_stack+104929);
 _BUILD_00q0(Data,vrr_stack+104461, vrr_stack+75438, vrr_stack+74052, vrr_stack+26788, vrr_stack+26458, NULL);
 _BUILD_p0q0(Data,vrr_stack+104552, vrr_stack+104461, vrr_stack+102823, NULL, NULL, vrr_stack+74052);
 _BUILD_d0q0(Data,vrr_stack+104825, vrr_stack+104552, vrr_stack+170867, vrr_stack+104461, vrr_stack+102823, vrr_stack+103759);
 _BUILD_f0q0(Data,vrr_stack+105371, vrr_stack+104825, vrr_stack+171140, vrr_stack+104552, vrr_stack+170867, vrr_stack+103993);
 _BUILD_g0q0(Data,vrr_stack+106281, vrr_stack+105371, vrr_stack+172232, vrr_stack+104825, vrr_stack+171140, vrr_stack+128197);
 _BUILD_00q0(Data,vrr_stack+128197, vrr_stack+76218, vrr_stack+54145, vrr_stack+64153, vrr_stack+34888, NULL);
 _BUILD_p0q0(Data,vrr_stack+128288, vrr_stack+102914, vrr_stack+128197, NULL, NULL, vrr_stack+76218);
 _BUILD_d0q0(Data,vrr_stack+128561, vrr_stack+103005, vrr_stack+128288, vrr_stack+169684, vrr_stack+102914, vrr_stack+76296);
 _BUILD_f0q0(Data,vrr_stack+107646, vrr_stack+171686, vrr_stack+128561, vrr_stack+169775, vrr_stack+103005, vrr_stack+76530);
 _BUILD_g0q0(Data,vrr_stack+108556, vrr_stack+74208, vrr_stack+107646, vrr_stack+170321, vrr_stack+171686, vrr_stack+76998);
 _BUILD_h0q0(Data,vrr_stack+21448, vrr_stack+157658, vrr_stack+108556, vrr_stack+172232, vrr_stack+74208, vrr_stack+77778);
 _BUILD_h0q0(Data,vrr_stack+76296, vrr_stack+106281, vrr_stack+157658, vrr_stack+105371, vrr_stack+172232, vrr_stack+82341);
 _BUILD_i0q0(Data,vrr_stack+150140, vrr_stack+76296, vrr_stack+21448, vrr_stack+106281, vrr_stack+157658, vrr_stack+10834);
 _BUILD_00q0(Data,vrr_stack+10834, vrr_stack+93634, vrr_stack+75438, vrr_stack+16954, vrr_stack+26788, NULL);
 _BUILD_p0q0(Data,vrr_stack+10925, vrr_stack+10834, vrr_stack+104461, NULL, NULL, vrr_stack+75438);
 _BUILD_d0q0(Data,vrr_stack+11198, vrr_stack+10925, vrr_stack+104552, vrr_stack+10834, vrr_stack+104461, vrr_stack+75516);
 _BUILD_f0q0(Data,vrr_stack+103278, vrr_stack+11198, vrr_stack+104825, vrr_stack+10925, vrr_stack+104552, vrr_stack+75750);
 _BUILD_g0q0(Data,vrr_stack+159023, vrr_stack+103278, vrr_stack+105371, vrr_stack+11198, vrr_stack+104825, vrr_stack+83511);
 _BUILD_h0q0(Data,vrr_stack+152688, vrr_stack+159023, vrr_stack+106281, vrr_stack+103278, vrr_stack+105371, vrr_stack+84291);
 _BUILD_i0q0(Data,vrr_stack+80118, vrr_stack+152688, vrr_stack+76296, vrr_stack+159023, vrr_stack+106281, vrr_stack+48613);
 _BUILD_00q0(Data,vrr_stack+75516, vrr_stack+54145, vrr_stack+17020, vrr_stack+34888, vrr_stack+21382, NULL);
 _BUILD_p0q0(Data,vrr_stack+104188, vrr_stack+128197, vrr_stack+75516, NULL, NULL, vrr_stack+54145);
 _BUILD_d0q0(Data,vrr_stack+75607, vrr_stack+128288, vrr_stack+104188, vrr_stack+102914, vrr_stack+128197, vrr_stack+54223);
 _BUILD_f0q0(Data,vrr_stack+2205, vrr_stack+128561, vrr_stack+75607, vrr_stack+103005, vrr_stack+128288, vrr_stack+54457);
 _BUILD_g0q0(Data,vrr_stack+82666, vrr_stack+107646, vrr_stack+2205, vrr_stack+171686, vrr_stack+128561, vrr_stack+28492);
 _BUILD_h0q0(Data,vrr_stack+84031, vrr_stack+108556, vrr_stack+82666, vrr_stack+74208, vrr_stack+107646, vrr_stack+34954);
 _BUILD_i0q0(Data,vrr_stack+44387, vrr_stack+21448, vrr_stack+84031, vrr_stack+157658, vrr_stack+108556, vrr_stack+41111);
 _BUILD_k0q0(Data,vrr_stack+46935, vrr_stack+150140, vrr_stack+44387, vrr_stack+76296, vrr_stack+21448, vrr_stack+55915);
 _BUILD_k0q0(Data,vrr_stack+222062, vrr_stack+80118, vrr_stack+150140, vrr_stack+152688, vrr_stack+76296, vrr_stack+70499);
 _BUILD_l0q0(Data,vrr_stack+69913, vrr_stack+222062, vrr_stack+46935, vrr_stack+80118, vrr_stack+150140, vrr_stack+181190);
 _BUILD_00q0(Data,vrr_stack+181190, vrr_stack+136802, vrr_stack+93634, vrr_stack+101269, vrr_stack+16954, NULL);
 _BUILD_p0q0(Data,vrr_stack+181281, vrr_stack+181190, vrr_stack+10834, NULL, NULL, vrr_stack+93634);
 _BUILD_d0q0(Data,vrr_stack+181554, vrr_stack+181281, vrr_stack+10925, vrr_stack+181190, vrr_stack+10834, vrr_stack+93712);
 _BUILD_f0q0(Data,vrr_stack+182100, vrr_stack+181554, vrr_stack+11198, vrr_stack+181281, vrr_stack+10925, vrr_stack+93946);
 _BUILD_g0q0(Data,vrr_stack+55915, vrr_stack+182100, vrr_stack+103278, vrr_stack+181554, vrr_stack+11198, vrr_stack+55135);
 _BUILD_h0q0(Data,vrr_stack+34888, vrr_stack+55915, vrr_stack+159023, vrr_stack+182100, vrr_stack+103278, vrr_stack+78948);
 _BUILD_i0q0(Data,vrr_stack+40000, vrr_stack+34888, vrr_stack+152688, vrr_stack+55915, vrr_stack+159023, vrr_stack+26854);
 _BUILD_k0q0(Data,vrr_stack+225338, vrr_stack+40000, vrr_stack+80118, vrr_stack+34888, vrr_stack+152688, vrr_stack+179006);
 _BUILD_l0q0(Data,vrr_stack+228614, vrr_stack+225338, vrr_stack+222062, vrr_stack+40000, vrr_stack+80118, vrr_stack+133994);
 _BUILD_00q0(Data,vrr_stack+133994, vrr_stack+17020, vrr_stack+141731, vrr_stack+21382, vrr_stack+110553, NULL);
 _BUILD_p0q0(Data,vrr_stack+134085, vrr_stack+75516, vrr_stack+133994, NULL, NULL, vrr_stack+17020);
 _BUILD_d0q0(Data,vrr_stack+134358, vrr_stack+104188, vrr_stack+134085, vrr_stack+128197, vrr_stack+75516, vrr_stack+17098);
 _BUILD_f0q0(Data,vrr_stack+134904, vrr_stack+75607, vrr_stack+134358, vrr_stack+128288, vrr_stack+104188, vrr_stack+17332);
 _BUILD_g0q0(Data,vrr_stack+17098, vrr_stack+2205, vrr_stack+134904, vrr_stack+128561, vrr_stack+75607, vrr_stack+139532);
 _BUILD_h0q0(Data,vrr_stack+78207, vrr_stack+82666, vrr_stack+17098, vrr_stack+107646, vrr_stack+2205, vrr_stack+140312);
 _BUILD_i0q0(Data,vrr_stack+26302, vrr_stack+84031, vrr_stack+78207, vrr_stack+108556, vrr_stack+82666, vrr_stack+15280);
 _BUILD_k0q0(Data,vrr_stack+232709, vrr_stack+44387, vrr_stack+26302, vrr_stack+21448, vrr_stack+84031, vrr_stack+64219);
 _BUILD_l0q0(Data,vrr_stack+235985, vrr_stack+46935, vrr_stack+232709, vrr_stack+150140, vrr_stack+44387, vrr_stack+23494);
 _BUILD_m0q0(Data,vrr_stack+240080, vrr_stack+69913, vrr_stack+235985, vrr_stack+222062, vrr_stack+46935, vrr_stack+187508);
 _BUILD_m0q0(Data,vrr_stack+245085, vrr_stack+228614, vrr_stack+69913, vrr_stack+225338, vrr_stack+222062, vrr_stack+183998);
 _BUILD_n0q0(Data,vrr_stack+183010, vrr_stack+245085, vrr_stack+240080, vrr_stack+228614, vrr_stack+69913, vrr_stack+191018);
 _BUILD_00q0(Data,vrr_stack+15280, vrr_stack+98299, vrr_stack+136802, vrr_stack+110289, vrr_stack+101269, NULL);
 _BUILD_p0q0(Data,vrr_stack+15371, vrr_stack+15280, vrr_stack+181190, NULL, NULL, vrr_stack+136802);
 _BUILD_d0q0(Data,vrr_stack+15644, vrr_stack+15371, vrr_stack+181281, vrr_stack+15280, vrr_stack+181190, vrr_stack+136880);
 _BUILD_f0q0(Data,vrr_stack+139532, vrr_stack+15644, vrr_stack+181554, vrr_stack+15371, vrr_stack+181281, vrr_stack+137114);
 _BUILD_g0q0(Data,vrr_stack+179006, vrr_stack+139532, vrr_stack+182100, vrr_stack+15644, vrr_stack+181554, vrr_stack+137582);
 _BUILD_h0q0(Data,vrr_stack+189016, vrr_stack+179006, vrr_stack+55915, vrr_stack+139532, vrr_stack+182100, vrr_stack+138362);
 _BUILD_i0q0(Data,vrr_stack+136880, vrr_stack+189016, vrr_stack+34888, vrr_stack+179006, vrr_stack+55915, vrr_stack+42749);
 _BUILD_k0q0(Data,vrr_stack+190927, vrr_stack+136880, vrr_stack+40000, vrr_stack+189016, vrr_stack+34888, vrr_stack+29272);
 _BUILD_l0q0(Data,vrr_stack+250090, vrr_stack+190927, vrr_stack+225338, vrr_stack+136880, vrr_stack+40000, vrr_stack+12472);
   tmp = vrr_stack + 250090;
   target_ptr = Libint->vrr_classes[8][12];
   for(i=0;i<4095;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0q0(Data,vrr_stack+254185, vrr_stack+250090, vrr_stack+228614, vrr_stack+190927, vrr_stack+225338, vrr_stack+3337);
   tmp = vrr_stack + 254185;
   target_ptr = Libint->vrr_classes[9][12];
   for(i=0;i<5005;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0q0(Data,vrr_stack+189016, vrr_stack+254185, vrr_stack+245085, vrr_stack+250090, vrr_stack+228614, vrr_stack+195308);
   tmp = vrr_stack + 189016;
   target_ptr = Libint->vrr_classes[10][12];
   for(i=0;i<6006;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+250090, Data->F+23, Data->F+24, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+250093, vrr_stack+141482, vrr_stack+250090, Data->F+22, Data->F+23, NULL);
 _BUILD_00f0(Data,vrr_stack+250099, vrr_stack+141485, vrr_stack+250093, vrr_stack+110355, vrr_stack+141482, NULL);
 _BUILD_00g0(Data,vrr_stack+250109, vrr_stack+141491, vrr_stack+250099, vrr_stack+110358, vrr_stack+141485, NULL);
 _BUILD_00h0(Data,vrr_stack+250124, vrr_stack+141501, vrr_stack+250109, vrr_stack+110364, vrr_stack+141491, NULL);
 _BUILD_00i0(Data,vrr_stack+250145, vrr_stack+141516, vrr_stack+250124, vrr_stack+110374, vrr_stack+141501, NULL);
 _BUILD_00k0(Data,vrr_stack+250173, vrr_stack+141537, vrr_stack+250145, vrr_stack+0, vrr_stack+141516, NULL);
 _BUILD_00l0(Data,vrr_stack+250209, vrr_stack+16918, vrr_stack+250173, vrr_stack+110389, vrr_stack+141537, NULL);
 _BUILD_00m0(Data,vrr_stack+250254, vrr_stack+141565, vrr_stack+250209, vrr_stack+110417, vrr_stack+16918, NULL);
 _BUILD_00n0(Data,vrr_stack+21382, vrr_stack+141610, vrr_stack+250254, vrr_stack+110453, vrr_stack+141565, NULL);
 _BUILD_00o0(Data,vrr_stack+250309, vrr_stack+141665, vrr_stack+21382, vrr_stack+110498, vrr_stack+141610, NULL);
 _BUILD_00q0(Data,vrr_stack+250387, vrr_stack+141731, vrr_stack+250309, vrr_stack+110553, vrr_stack+141665, NULL);
 _BUILD_p0q0(Data,vrr_stack+250478, vrr_stack+133994, vrr_stack+250387, NULL, NULL, vrr_stack+141731);
 _BUILD_d0q0(Data,vrr_stack+250751, vrr_stack+134085, vrr_stack+250478, vrr_stack+75516, vrr_stack+133994, vrr_stack+141809);
 _BUILD_f0q0(Data,vrr_stack+251297, vrr_stack+134358, vrr_stack+250751, vrr_stack+104188, vrr_stack+134085, vrr_stack+142043);
 _BUILD_g0q0(Data,vrr_stack+252207, vrr_stack+134904, vrr_stack+251297, vrr_stack+75607, vrr_stack+134358, vrr_stack+142511);
 _BUILD_h0q0(Data,vrr_stack+136880, vrr_stack+17098, vrr_stack+252207, vrr_stack+2205, vrr_stack+134904, vrr_stack+143291);
 _BUILD_i0q0(Data,vrr_stack+141809, vrr_stack+78207, vrr_stack+136880, vrr_stack+82666, vrr_stack+17098, vrr_stack+98377);
 _BUILD_k0q0(Data,vrr_stack+98377, vrr_stack+26302, vrr_stack+141809, vrr_stack+84031, vrr_stack+78207, vrr_stack+21);
 _BUILD_l0q0(Data,vrr_stack+195022, vrr_stack+232709, vrr_stack+98377, vrr_stack+44387, vrr_stack+26302, vrr_stack+154850);
 _BUILD_m0q0(Data,vrr_stack+3115, vrr_stack+235985, vrr_stack+195022, vrr_stack+46935, vrr_stack+232709, vrr_stack+66403);
 _BUILD_n0q0(Data,vrr_stack+259190, vrr_stack+240080, vrr_stack+3115, vrr_stack+69913, vrr_stack+235985, vrr_stack+110619);
 _BUILD_o0q0(Data,vrr_stack+265196, vrr_stack+183010, vrr_stack+259190, vrr_stack+245085, vrr_stack+240080, vrr_stack+204746);
 _BUILD_o0q0(Data,vrr_stack+272294, vrr_stack+189016, vrr_stack+183010, vrr_stack+254185, vrr_stack+245085, vrr_stack+199598);
   tmp = vrr_stack + 272294;
   target_ptr = Libint->vrr_classes[11][12];
   for(i=0;i<7098;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+204746, vrr_stack+169502, vrr_stack+169684, vrr_stack+102589, vrr_stack+102745, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+204851, vrr_stack+169593, vrr_stack+169502, vrr_stack+102667, vrr_stack+102589, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+204956, vrr_stack+169684, vrr_stack+102914, vrr_stack+102745, vrr_stack+74130, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+205061, vrr_stack+204746, vrr_stack+204956, NULL, NULL, vrr_stack+169684);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+205376, vrr_stack+204851, vrr_stack+204746, NULL, NULL, vrr_stack+169502);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+205691, vrr_stack+205376, vrr_stack+205061, vrr_stack+204851, vrr_stack+204746, vrr_stack+169775);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+169684, vrr_stack+102823, vrr_stack+169593, vrr_stack+74052, vrr_stack+102667, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+206321, vrr_stack+169684, vrr_stack+204851, NULL, NULL, vrr_stack+169593);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+206636, vrr_stack+206321, vrr_stack+205376, vrr_stack+169684, vrr_stack+204851, vrr_stack+170048);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+204851, vrr_stack+102914, vrr_stack+128197, vrr_stack+74130, vrr_stack+76218, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+169789, vrr_stack+204956, vrr_stack+204851, NULL, NULL, vrr_stack+102914);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+207266, vrr_stack+205061, vrr_stack+169789, vrr_stack+204746, vrr_stack+204956, vrr_stack+103005);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+207896, vrr_stack+205691, vrr_stack+207266, vrr_stack+205376, vrr_stack+205061, vrr_stack+171686);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+101653, vrr_stack+206636, vrr_stack+205691, vrr_stack+206321, vrr_stack+205376, vrr_stack+170321);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+101653, vrr_stack+207896, vrr_stack+206636, vrr_stack+205691, vrr_stack+74208);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+204746, vrr_stack+104461, vrr_stack+102823, vrr_stack+75438, vrr_stack+74052, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+205376, vrr_stack+204746, vrr_stack+169684, NULL, NULL, vrr_stack+102823);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1575, vrr_stack+205376, vrr_stack+206321, vrr_stack+204746, vrr_stack+169684, vrr_stack+170867);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+253572, vrr_stack+1575, vrr_stack+206636, vrr_stack+205376, vrr_stack+206321, vrr_stack+171140);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+170104, vrr_stack+253572, vrr_stack+101653, vrr_stack+1575, vrr_stack+206636, vrr_stack+172232);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+206321, vrr_stack+128197, vrr_stack+75516, vrr_stack+76218, vrr_stack+54145, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+206426, vrr_stack+204851, vrr_stack+206321, NULL, NULL, vrr_stack+128197);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+171679, vrr_stack+169789, vrr_stack+206426, vrr_stack+204956, vrr_stack+204851, vrr_stack+128288);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+172309, vrr_stack+207266, vrr_stack+171679, vrr_stack+205061, vrr_stack+169789, vrr_stack+128561);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+254622, vrr_stack+207896, vrr_stack+172309, vrr_stack+205691, vrr_stack+207266, vrr_stack+107646);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+256197, vrr_stack+0, vrr_stack+254622, vrr_stack+101653, vrr_stack+207896, vrr_stack+108556);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+107646, vrr_stack+170104, vrr_stack+0, vrr_stack+253572, vrr_stack+101653, vrr_stack+157658);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+109851, vrr_stack+107646, vrr_stack+256197, vrr_stack+170104, vrr_stack+0, vrr_stack+21448);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+21448, vrr_stack+10834, vrr_stack+104461, vrr_stack+93634, vrr_stack+75438, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+21553, vrr_stack+21448, vrr_stack+204746, NULL, NULL, vrr_stack+104461);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+205691, vrr_stack+21553, vrr_stack+205376, vrr_stack+21448, vrr_stack+204746, vrr_stack+104552);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+21868, vrr_stack+205691, vrr_stack+1575, vrr_stack+21553, vrr_stack+205376, vrr_stack+104825);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+22918, vrr_stack+21868, vrr_stack+253572, vrr_stack+205691, vrr_stack+1575, vrr_stack+105371);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+112791, vrr_stack+22918, vrr_stack+170104, vrr_stack+21868, vrr_stack+253572, vrr_stack+106281);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+104461, vrr_stack+112791, vrr_stack+107646, vrr_stack+22918, vrr_stack+170104, vrr_stack+76296);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+204746, vrr_stack+75516, vrr_stack+133994, vrr_stack+54145, vrr_stack+17020, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+54145, vrr_stack+206321, vrr_stack+204746, NULL, NULL, vrr_stack+75516);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1575, vrr_stack+206426, vrr_stack+54145, vrr_stack+204851, vrr_stack+206321, vrr_stack+104188);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+253572, vrr_stack+171679, vrr_stack+1575, vrr_stack+169789, vrr_stack+206426, vrr_stack+75607);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+24493, vrr_stack+172309, vrr_stack+253572, vrr_stack+207266, vrr_stack+171679, vrr_stack+2205);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+138791, vrr_stack+254622, vrr_stack+24493, vrr_stack+207896, vrr_stack+172309, vrr_stack+82666);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+206741, vrr_stack+256197, vrr_stack+138791, vrr_stack+0, vrr_stack+254622, vrr_stack+84031);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+64153, vrr_stack+109851, vrr_stack+206741, vrr_stack+107646, vrr_stack+256197, vrr_stack+44387);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+42548, vrr_stack+104461, vrr_stack+109851, vrr_stack+112791, vrr_stack+107646, vrr_stack+150140);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+279392, vrr_stack+42548, vrr_stack+64153, vrr_stack+104461, vrr_stack+109851, vrr_stack+46935);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+150140, vrr_stack+181190, vrr_stack+10834, vrr_stack+136802, vrr_stack+93634, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+93634, vrr_stack+150140, vrr_stack+21448, NULL, NULL, vrr_stack+10834);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+93949, vrr_stack+93634, vrr_stack+21553, vrr_stack+150140, vrr_stack+21448, vrr_stack+10925);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+150245, vrr_stack+93949, vrr_stack+205691, vrr_stack+93634, vrr_stack+21553, vrr_stack+11198);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+150245, vrr_stack+21868, vrr_stack+93949, vrr_stack+205691, vrr_stack+103278);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+10834, vrr_stack+0, vrr_stack+22918, vrr_stack+150245, vrr_stack+21868, vrr_stack+159023);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+82666, vrr_stack+10834, vrr_stack+112791, vrr_stack+0, vrr_stack+22918, vrr_stack+152688);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+151295, vrr_stack+82666, vrr_stack+104461, vrr_stack+10834, vrr_stack+112791, vrr_stack+80118);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+155075, vrr_stack+151295, vrr_stack+42548, vrr_stack+82666, vrr_stack+104461, vrr_stack+222062);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+222062, vrr_stack+133994, vrr_stack+250387, vrr_stack+17020, vrr_stack+141731, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+222167, vrr_stack+204746, vrr_stack+222062, NULL, NULL, vrr_stack+133994);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+222482, vrr_stack+54145, vrr_stack+222167, vrr_stack+206321, vrr_stack+204746, vrr_stack+134085);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+223112, vrr_stack+1575, vrr_stack+222482, vrr_stack+206426, vrr_stack+54145, vrr_stack+134358);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+80118, vrr_stack+253572, vrr_stack+223112, vrr_stack+171679, vrr_stack+1575, vrr_stack+134904);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+133994, vrr_stack+24493, vrr_stack+80118, vrr_stack+172309, vrr_stack+253572, vrr_stack+17098);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+112791, vrr_stack+138791, vrr_stack+133994, vrr_stack+254622, vrr_stack+24493, vrr_stack+78207);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+101653, vrr_stack+206741, vrr_stack+112791, vrr_stack+256197, vrr_stack+138791, vrr_stack+26302);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+26068, vrr_stack+64153, vrr_stack+101653, vrr_stack+109851, vrr_stack+206741, vrr_stack+232709);
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+105433, vrr_stack+279392, vrr_stack+26068, vrr_stack+42548, vrr_stack+64153, vrr_stack+235985);
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+232709, vrr_stack+155075, vrr_stack+279392, vrr_stack+151295, vrr_stack+42548, vrr_stack+69913);
 am[0] = 10;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+42548, vrr_stack+232709, vrr_stack+105433, vrr_stack+155075, vrr_stack+279392, vrr_stack+240080);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+49478, vrr_stack+15280, vrr_stack+181190, vrr_stack+98299, vrr_stack+136802, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+49583, vrr_stack+49478, vrr_stack+150140, NULL, NULL, vrr_stack+181190);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+49898, vrr_stack+49583, vrr_stack+93634, vrr_stack+49478, vrr_stack+150140, vrr_stack+181281);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+238484, vrr_stack+49898, vrr_stack+93949, vrr_stack+49583, vrr_stack+93634, vrr_stack+181554);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+239534, vrr_stack+238484, vrr_stack+150245, vrr_stack+49898, vrr_stack+93949, vrr_stack+182100);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+241109, vrr_stack+239534, vrr_stack+0, vrr_stack+238484, vrr_stack+150245, vrr_stack+55915);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+254622, vrr_stack+241109, vrr_stack+10834, vrr_stack+239534, vrr_stack+0, vrr_stack+34888);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+13039, vrr_stack+254622, vrr_stack+82666, vrr_stack+241109, vrr_stack+10834, vrr_stack+40000);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+238484, vrr_stack+13039, vrr_stack+151295, vrr_stack+254622, vrr_stack+82666, vrr_stack+225338);
   tmp = vrr_stack + 238484;
   target_ptr = Libint->vrr_classes[8][13];
   for(i=0;i<4725;i++)
     target_ptr[i] += tmp[i];
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+67933, vrr_stack+238484, vrr_stack+155075, vrr_stack+13039, vrr_stack+151295, vrr_stack+228614);
   tmp = vrr_stack + 67933;
   target_ptr = Libint->vrr_classes[9][13];
   for(i=0;i<5775;i++)
     target_ptr[i] += tmp[i];
 am[0] = 10;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+224162, vrr_stack+67933, vrr_stack+232709, vrr_stack+238484, vrr_stack+155075, vrr_stack+245085);
   tmp = vrr_stack + 224162;
   target_ptr = Libint->vrr_classes[10][13];
   for(i=0;i<6930;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+238484, Data->F+24, Data->F+25, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+238487, vrr_stack+250090, vrr_stack+238484, Data->F+23, Data->F+24, NULL);
 _BUILD_00f0(Data,vrr_stack+238493, vrr_stack+250093, vrr_stack+238487, vrr_stack+141482, vrr_stack+250090, NULL);
 _BUILD_00g0(Data,vrr_stack+238503, vrr_stack+250099, vrr_stack+238493, vrr_stack+141485, vrr_stack+250093, NULL);
 _BUILD_00h0(Data,vrr_stack+238518, vrr_stack+250109, vrr_stack+238503, vrr_stack+141491, vrr_stack+250099, NULL);
 _BUILD_00i0(Data,vrr_stack+238484, vrr_stack+250124, vrr_stack+238518, vrr_stack+141501, vrr_stack+250109, NULL);
 _BUILD_00k0(Data,vrr_stack+238512, vrr_stack+250145, vrr_stack+238484, vrr_stack+141516, vrr_stack+250124, NULL);
 _BUILD_00l0(Data,vrr_stack+238548, vrr_stack+250173, vrr_stack+238512, vrr_stack+141537, vrr_stack+250145, NULL);
 _BUILD_00m0(Data,vrr_stack+238484, vrr_stack+250209, vrr_stack+238548, vrr_stack+16918, vrr_stack+250173, NULL);
 _BUILD_00n0(Data,vrr_stack+238539, vrr_stack+250254, vrr_stack+238484, vrr_stack+141565, vrr_stack+250209, NULL);
 _BUILD_00o0(Data,vrr_stack+98299, vrr_stack+21382, vrr_stack+238539, vrr_stack+141610, vrr_stack+250254, NULL);
 _BUILD_00q0(Data,vrr_stack+238484, vrr_stack+250309, vrr_stack+98299, vrr_stack+141665, vrr_stack+21382, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+21382, vrr_stack+250387, vrr_stack+238484, vrr_stack+141731, vrr_stack+250309, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+238484, vrr_stack+222062, vrr_stack+21382, NULL, NULL, vrr_stack+250387);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+21382, vrr_stack+222167, vrr_stack+238484, vrr_stack+204746, vrr_stack+222062, vrr_stack+250478);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+204746, vrr_stack+222482, vrr_stack+21382, vrr_stack+54145, vrr_stack+222167, vrr_stack+250751);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+223112, vrr_stack+204746, vrr_stack+1575, vrr_stack+222482, vrr_stack+251297);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+54145, vrr_stack+80118, vrr_stack+0, vrr_stack+253572, vrr_stack+223112, vrr_stack+252207);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+133994, vrr_stack+54145, vrr_stack+24493, vrr_stack+80118, vrr_stack+136880);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+54145, vrr_stack+112791, vrr_stack+0, vrr_stack+138791, vrr_stack+133994, vrr_stack+141809);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+133994, vrr_stack+101653, vrr_stack+54145, vrr_stack+206741, vrr_stack+112791, vrr_stack+98377);
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+138719, vrr_stack+26068, vrr_stack+133994, vrr_stack+64153, vrr_stack+101653, vrr_stack+195022);
 am[0] = 10;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+238484, vrr_stack+105433, vrr_stack+138719, vrr_stack+279392, vrr_stack+26068, vrr_stack+3115);
 am[0] = 11;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+133994, vrr_stack+42548, vrr_stack+238484, vrr_stack+232709, vrr_stack+105433, vrr_stack+259190);
 am[0] = 11;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+238484, vrr_stack+224162, vrr_stack+42548, vrr_stack+67933, vrr_stack+232709, vrr_stack+183010);
   tmp = vrr_stack + 238484;
   target_ptr = Libint->vrr_classes[11][13];
   for(i=0;i<8190;i++)
     target_ptr[i] += tmp[i];
 _BUILD_q0k0(Data,vrr_stack+246674, vrr_stack+18574, vrr_stack+37192, vrr_stack+32512, vrr_stack+58267, vrr_stack+8650);
   tmp = vrr_stack + 246674;
   target_ptr = Libint->vrr_classes[12][7];
   for(i=0;i<3276;i++)
     target_ptr[i] += tmp[i];
 _BUILD_q0l0(Data,vrr_stack+249950, vrr_stack+60643, vrr_stack+94789, vrr_stack+51175, vrr_stack+86374, vrr_stack+37192);
   tmp = vrr_stack + 249950;
   target_ptr = Libint->vrr_classes[12][8];
   for(i=0;i<4095;i++)
     target_ptr[i] += tmp[i];
 _BUILD_q0m0(Data,vrr_stack+254045, vrr_stack+89344, vrr_stack+129704, vrr_stack+119419, vrr_stack+115789, vrr_stack+94789);
   tmp = vrr_stack + 254045;
   target_ptr = Libint->vrr_classes[12][9];
   for(i=0;i<5005;i++)
     target_ptr[i] += tmp[i];
 _BUILD_q0n0(Data,vrr_stack+259050, vrr_stack+123049, vrr_stack+173858, vrr_stack+165146, vrr_stack+160790, vrr_stack+129704);
   tmp = vrr_stack + 259050;
   target_ptr = Libint->vrr_classes[12][10];
   for(i=0;i<6006;i++)
     target_ptr[i] += tmp[i];
 _BUILD_q0o0(Data,vrr_stack+0, vrr_stack+215978, vrr_stack+209894, vrr_stack+144992, vrr_stack+199598, vrr_stack+173858);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[12][11];
   for(i=0;i<7098;i++)
     target_ptr[i] += tmp[i];
 _BUILD_q0q0(Data,vrr_stack+195022, vrr_stack+272294, vrr_stack+265196, vrr_stack+189016, vrr_stack+183010, vrr_stack+209894);
   tmp = vrr_stack + 195022;
   target_ptr = Libint->vrr_classes[12][12];
   for(i=0;i<8281;i++)
     target_ptr[i] += tmp[i];
 am[0] = 12;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+272294, vrr_stack+238484, vrr_stack+133994, vrr_stack+224162, vrr_stack+42548, vrr_stack+265196);
   tmp = vrr_stack + 272294;
   target_ptr = Libint->vrr_classes[12][13];
   for(i=0;i<9555;i++)
     target_ptr[i] += tmp[i];

}

