/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (p0|kh) integrals */

void vrr_order_p0kh(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+3, Data->F+4, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+12, vrr_stack+3, Data->F+2, Data->F+3, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+0, vrr_stack+21, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+6, vrr_stack+24, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+15, vrr_stack+6, vrr_stack+12, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+50, vrr_stack+40, vrr_stack+30, vrr_stack+15, vrr_stack+6, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+65, vrr_stack+3, vrr_stack+12, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+71, vrr_stack+65, vrr_stack+15, vrr_stack+3, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+71, vrr_stack+40, vrr_stack+65, vrr_stack+15, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+21, vrr_stack+12, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+96, vrr_stack+24, vrr_stack+15, vrr_stack+0, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+106, vrr_stack+30, vrr_stack+96, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+121, vrr_stack+50, vrr_stack+106, vrr_stack+40, vrr_stack+30, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+81, vrr_stack+50, vrr_stack+71, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+163, vrr_stack+142, vrr_stack+121, vrr_stack+81, vrr_stack+50, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+12, vrr_stack+0, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+15, vrr_stack+6, vrr_stack+21, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+191, vrr_stack+96, vrr_stack+40, vrr_stack+24, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+206, vrr_stack+106, vrr_stack+191, vrr_stack+30, vrr_stack+96, NULL);
 _BUILD_00i0(Data,vrr_stack+227, vrr_stack+121, vrr_stack+206, vrr_stack+50, vrr_stack+106, NULL);
 _BUILD_00k0(Data,vrr_stack+255, vrr_stack+163, vrr_stack+227, vrr_stack+142, vrr_stack+121, NULL);
 _BUILD_00p0(Data,vrr_stack+50, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+53, vrr_stack+50, vrr_stack+3, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+53, vrr_stack+65, vrr_stack+50, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+291, vrr_stack+21, vrr_stack+71, vrr_stack+53, vrr_stack+65, NULL);
 _BUILD_00h0(Data,vrr_stack+50, vrr_stack+291, vrr_stack+81, vrr_stack+21, vrr_stack+71, NULL);
 _BUILD_00i0(Data,vrr_stack+306, vrr_stack+50, vrr_stack+142, vrr_stack+291, vrr_stack+81, NULL);
 _BUILD_00k0(Data,vrr_stack+334, vrr_stack+306, vrr_stack+163, vrr_stack+50, vrr_stack+142, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+142, vrr_stack+0, vrr_stack+3, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+148, vrr_stack+6, vrr_stack+142, vrr_stack+12, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+291, vrr_stack+40, vrr_stack+148, vrr_stack+15, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+12, vrr_stack+191, vrr_stack+291, vrr_stack+96, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+50, vrr_stack+206, vrr_stack+12, vrr_stack+106, vrr_stack+191, NULL);
 _BUILD_00k0(Data,vrr_stack+78, vrr_stack+227, vrr_stack+50, vrr_stack+121, vrr_stack+206, NULL);
 _BUILD_00l0(Data,vrr_stack+370, vrr_stack+255, vrr_stack+78, vrr_stack+163, vrr_stack+227, NULL);
 _BUILD_00l0(Data,vrr_stack+415, vrr_stack+334, vrr_stack+255, vrr_stack+306, vrr_stack+163, NULL);
 _BUILD_00p0(Data,vrr_stack+306, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+309, vrr_stack+3, vrr_stack+306, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+315, vrr_stack+142, vrr_stack+309, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+114, vrr_stack+148, vrr_stack+315, vrr_stack+6, vrr_stack+142, NULL);
 _BUILD_00h0(Data,vrr_stack+460, vrr_stack+291, vrr_stack+114, vrr_stack+40, vrr_stack+148, NULL);
 _BUILD_00i0(Data,vrr_stack+481, vrr_stack+12, vrr_stack+460, vrr_stack+191, vrr_stack+291, NULL);
 _BUILD_00k0(Data,vrr_stack+509, vrr_stack+50, vrr_stack+481, vrr_stack+206, vrr_stack+12, NULL);
 _BUILD_00l0(Data,vrr_stack+545, vrr_stack+78, vrr_stack+509, vrr_stack+227, vrr_stack+50, NULL);
 _BUILD_00m0(Data,vrr_stack+191, vrr_stack+370, vrr_stack+545, vrr_stack+255, vrr_stack+78, NULL);
 _BUILD_00m0(Data,vrr_stack+590, vrr_stack+415, vrr_stack+370, vrr_stack+334, vrr_stack+255, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+306, vrr_stack+0, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+33, vrr_stack+309, vrr_stack+6, vrr_stack+3, vrr_stack+306, NULL);
 _BUILD_00g0(Data,vrr_stack+645, vrr_stack+315, vrr_stack+33, vrr_stack+142, vrr_stack+309, NULL);
 _BUILD_00h0(Data,vrr_stack+660, vrr_stack+114, vrr_stack+645, vrr_stack+148, vrr_stack+315, NULL);
 _BUILD_00i0(Data,vrr_stack+129, vrr_stack+460, vrr_stack+660, vrr_stack+291, vrr_stack+114, NULL);
 _BUILD_00k0(Data,vrr_stack+681, vrr_stack+481, vrr_stack+129, vrr_stack+12, vrr_stack+460, NULL);
 _BUILD_00l0(Data,vrr_stack+717, vrr_stack+509, vrr_stack+681, vrr_stack+50, vrr_stack+481, NULL);
 _BUILD_00m0(Data,vrr_stack+762, vrr_stack+545, vrr_stack+717, vrr_stack+78, vrr_stack+509, NULL);
 _BUILD_00n0(Data,vrr_stack+43, vrr_stack+191, vrr_stack+762, vrr_stack+370, vrr_stack+545, NULL);
 _BUILD_00n0(Data,vrr_stack+817, vrr_stack+590, vrr_stack+191, vrr_stack+415, vrr_stack+370, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+157, vrr_stack+0, vrr_stack+3, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+12, vrr_stack+6, vrr_stack+157, vrr_stack+306, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+291, vrr_stack+33, vrr_stack+12, vrr_stack+309, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+883, vrr_stack+645, vrr_stack+291, vrr_stack+315, vrr_stack+33, NULL);
 _BUILD_00i0(Data,vrr_stack+306, vrr_stack+660, vrr_stack+883, vrr_stack+114, vrr_stack+645, NULL);
 _BUILD_00k0(Data,vrr_stack+904, vrr_stack+129, vrr_stack+306, vrr_stack+460, vrr_stack+660, NULL);
 _BUILD_00l0(Data,vrr_stack+940, vrr_stack+681, vrr_stack+904, vrr_stack+481, vrr_stack+129, NULL);
 _BUILD_00m0(Data,vrr_stack+985, vrr_stack+717, vrr_stack+940, vrr_stack+509, vrr_stack+681, NULL);
 _BUILD_00n0(Data,vrr_stack+460, vrr_stack+762, vrr_stack+985, vrr_stack+545, vrr_stack+717, NULL);
 _BUILD_00o0(Data,vrr_stack+1040, vrr_stack+43, vrr_stack+460, vrr_stack+191, vrr_stack+762, NULL);
 _BUILD_00o0(Data,vrr_stack+1118, vrr_stack+817, vrr_stack+43, vrr_stack+590, vrr_stack+191, NULL);
 _BUILD_00p0(Data,vrr_stack+526, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+529, vrr_stack+3, vrr_stack+526, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+535, vrr_stack+157, vrr_stack+529, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+545, vrr_stack+12, vrr_stack+535, vrr_stack+6, vrr_stack+157, NULL);
 _BUILD_00h0(Data,vrr_stack+560, vrr_stack+291, vrr_stack+545, vrr_stack+33, vrr_stack+12, NULL);
 _BUILD_00i0(Data,vrr_stack+0, vrr_stack+883, vrr_stack+560, vrr_stack+645, vrr_stack+291, NULL);
 _BUILD_00k0(Data,vrr_stack+526, vrr_stack+306, vrr_stack+0, vrr_stack+660, vrr_stack+883, NULL);
 _BUILD_00l0(Data,vrr_stack+1196, vrr_stack+904, vrr_stack+526, vrr_stack+129, vrr_stack+306, NULL);
 _BUILD_00m0(Data,vrr_stack+526, vrr_stack+940, vrr_stack+1196, vrr_stack+681, vrr_stack+904, NULL);
 _BUILD_00n0(Data,vrr_stack+1196, vrr_stack+985, vrr_stack+526, vrr_stack+717, vrr_stack+940, NULL);
 _BUILD_00o0(Data,vrr_stack+1262, vrr_stack+460, vrr_stack+1196, vrr_stack+762, vrr_stack+985, NULL);
 _BUILD_00q0(Data,vrr_stack+1340, vrr_stack+1040, vrr_stack+1262, vrr_stack+43, vrr_stack+460, NULL);
 _BUILD_00q0(Data,vrr_stack+460, vrr_stack+1118, vrr_stack+1040, vrr_stack+817, vrr_stack+43, NULL);
 _BUILD_p0k0(Data,vrr_stack+1196, vrr_stack+334, vrr_stack+255, NULL, NULL, vrr_stack+163);
   tmp = vrr_stack + 1196;
   target_ptr = Libint->vrr_classes[1][7];
   for(i=0;i<108;i++)
     target_ptr[i] += tmp[i];
 _BUILD_p0l0(Data,vrr_stack+1431, vrr_stack+415, vrr_stack+370, NULL, NULL, vrr_stack+255);
   tmp = vrr_stack + 1431;
   target_ptr = Libint->vrr_classes[1][8];
   for(i=0;i<135;i++)
     target_ptr[i] += tmp[i];
 _BUILD_p0m0(Data,vrr_stack+1566, vrr_stack+590, vrr_stack+191, NULL, NULL, vrr_stack+370);
   tmp = vrr_stack + 1566;
   target_ptr = Libint->vrr_classes[1][9];
   for(i=0;i<165;i++)
     target_ptr[i] += tmp[i];
 _BUILD_p0n0(Data,vrr_stack+551, vrr_stack+817, vrr_stack+43, NULL, NULL, vrr_stack+191);
   tmp = vrr_stack + 551;
   target_ptr = Libint->vrr_classes[1][10];
   for(i=0;i<198;i++)
     target_ptr[i] += tmp[i];
 _BUILD_p0o0(Data,vrr_stack+749, vrr_stack+1118, vrr_stack+1040, NULL, NULL, vrr_stack+43);
   tmp = vrr_stack + 749;
   target_ptr = Libint->vrr_classes[1][11];
   for(i=0;i<234;i++)
     target_ptr[i] += tmp[i];
 _BUILD_p0q0(Data,vrr_stack+0, vrr_stack+460, vrr_stack+1340, NULL, NULL, vrr_stack+1040);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[1][12];
   for(i=0;i<273;i++)
     target_ptr[i] += tmp[i];

}

