/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_00gd(Libr12_t *, prim_data *);

  /* Computes (00|gd) integrals for linear R12-methods */

void hrr_grt_order_00gd(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->gvrr_classes[1][4] = int_stack + 0;
 Libr12->t2vrr_classes[0][4] = int_stack + 45;
 Libr12->gvrr_classes[1][5] = int_stack + 60;
 Libr12->t2vrr_classes[0][5] = int_stack + 123;
 Libr12->t2vrr_classes[0][6] = int_stack + 144;
 Libr12->t1vrr_classes[0][4] = int_stack + 172;
 Libr12->t1vrr_classes[0][5] = int_stack + 187;
 Libr12->t1vrr_classes[0][6] = int_stack + 208;
 Libr12->rvrr_classes[0][4] = int_stack + 236;
 Libr12->rvrr_classes[0][5] = int_stack + 251;
 Libr12->rvrr_classes[0][6] = int_stack + 272;
 Libr12->gvrr_classes[0][4] = int_stack + 300;
 Libr12->gvrr_classes[0][5] = int_stack + 315;
 Libr12->gvrr_classes[0][6] = int_stack + 336;
 memset(int_stack,0,364*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 364;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_00gd(Libr12, Data);
   Data++;
 }

 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+364, int_stack+315, int_stack+300, 1);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+409, int_stack+60, int_stack+0, 3);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+544, int_stack+336, int_stack+315, 1);
 /*--- compute (00|[r12,T2]|gp) ---*/
   t2hrr3_build_gp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+607, int_stack+123, int_stack+45, int_stack+315, int_stack+0, int_stack+300, 0, 0);
 /*--- compute (00|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+652, int_stack+144, int_stack+123, int_stack+336, int_stack+60, int_stack+315, 0, 0);
 /*--- compute (00|[r12,T1]|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+300, int_stack+187, int_stack+172, 1);
 /*--- compute (00|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+208, int_stack+187, 1);
 /*--- compute (00||gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+63, int_stack+251, int_stack+236, 1);
 /*--- compute (00||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+108, int_stack+272, int_stack+251, 1);
 /*--- compute (00|[r12,T2]|gd) ---*/
   t2hrr3_build_gd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+171, int_stack+652, int_stack+607, int_stack+544, int_stack+409, int_stack+364, 0, 0);
     Libr12->te_ptr[3] = int_stack + 171;
 /*--- compute (00|[r12,T1]|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+409, int_stack+0, int_stack+300, 1);
     Libr12->te_ptr[2] = int_stack + 409;
 /*--- compute (00||gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+607, int_stack+108, int_stack+63, 1);
     Libr12->te_ptr[1] = int_stack + 607;
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+0, int_stack+544, int_stack+364, 1);
     Libr12->te_ptr[0] = int_stack + 0;

}
