/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_f0dp(Libr12_t *, prim_data *);

  /* Computes (f0|dp) integrals for linear R12-methods */

void hrr_grt_order_f0dp(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->gvrr_classes[4][2] = int_stack + 0;
 Libr12->t2vrr_classes[3][2] = int_stack + 90;
 Libr12->t2vrr_classes[3][3] = int_stack + 150;
 Libr12->t1vrr_classes[3][2] = int_stack + 250;
 Libr12->t1vrr_classes[3][3] = int_stack + 310;
 Libr12->rvrr_classes[3][2] = int_stack + 410;
 Libr12->rvrr_classes[3][3] = int_stack + 470;
 Libr12->gvrr_classes[3][2] = int_stack + 570;
 Libr12->gvrr_classes[3][3] = int_stack + 630;
 memset(int_stack,0,730*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 730;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_f0dp(Libr12, Data);
   Data++;
 }

 /*--- compute (f0|[r12,T2]|dp) ---*/
   t2hrr3_build_dp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+730, int_stack+150, int_stack+90, int_stack+630, int_stack+0, int_stack+570, 3, 0);
     Libr12->te_ptr[3] = int_stack + 730;
 /*--- compute (f0|[r12,T1]|dp) ---*/
   hrr3_build_dp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+310, int_stack+250, 10);
     Libr12->te_ptr[2] = int_stack + 0;
 /*--- compute (f0||dp) ---*/
   hrr3_build_dp(Libr12->ShellQuartet.CD,int_stack+180, int_stack+470, int_stack+410, 10);
     Libr12->te_ptr[1] = int_stack + 180;
 /*--- compute (f0|dp) ---*/
   hrr3_build_dp(Libr12->ShellQuartet.CD,int_stack+360, int_stack+630, int_stack+570, 10);
     Libr12->te_ptr[0] = int_stack + 360;

}
