/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_hhhh(Libr12_t *, prim_data *);

  /* Computes (hh|hh) integrals for linear R12-methods */

void hrr_grt_order_hhhh(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->t2vrr_classes[5][5] = int_stack + 0;
 Libr12->t2vrr_classes[5][6] = int_stack + 441;
 Libr12->t2vrr_classes[5][7] = int_stack + 1029;
 Libr12->t2vrr_classes[5][8] = int_stack + 1785;
 Libr12->t2vrr_classes[5][9] = int_stack + 2730;
 Libr12->t2vrr_classes[5][10] = int_stack + 3885;
 Libr12->t2vrr_classes[6][5] = int_stack + 5271;
 Libr12->t2vrr_classes[6][6] = int_stack + 5859;
 Libr12->t2vrr_classes[6][7] = int_stack + 6643;
 Libr12->t2vrr_classes[6][8] = int_stack + 7651;
 Libr12->t2vrr_classes[6][9] = int_stack + 8911;
 Libr12->t2vrr_classes[6][10] = int_stack + 10451;
 Libr12->t2vrr_classes[7][5] = int_stack + 12299;
 Libr12->t2vrr_classes[7][6] = int_stack + 13055;
 Libr12->t2vrr_classes[7][7] = int_stack + 14063;
 Libr12->t2vrr_classes[7][8] = int_stack + 15359;
 Libr12->t2vrr_classes[7][9] = int_stack + 16979;
 Libr12->t2vrr_classes[7][10] = int_stack + 18959;
 Libr12->t2vrr_classes[8][5] = int_stack + 21335;
 Libr12->t2vrr_classes[8][6] = int_stack + 22280;
 Libr12->t2vrr_classes[8][7] = int_stack + 23540;
 Libr12->t2vrr_classes[8][8] = int_stack + 25160;
 Libr12->t2vrr_classes[8][9] = int_stack + 27185;
 Libr12->t2vrr_classes[8][10] = int_stack + 29660;
 Libr12->t2vrr_classes[9][5] = int_stack + 32630;
 Libr12->t2vrr_classes[9][6] = int_stack + 33785;
 Libr12->t2vrr_classes[9][7] = int_stack + 35325;
 Libr12->t2vrr_classes[9][8] = int_stack + 37305;
 Libr12->t2vrr_classes[9][9] = int_stack + 39780;
 Libr12->t2vrr_classes[9][10] = int_stack + 42805;
 Libr12->gvrr_classes[11][5] = int_stack + 46435;
 Libr12->t2vrr_classes[10][5] = int_stack + 48073;
 Libr12->gvrr_classes[11][6] = int_stack + 49459;
 Libr12->t2vrr_classes[10][6] = int_stack + 51643;
 Libr12->gvrr_classes[11][7] = int_stack + 53491;
 Libr12->t2vrr_classes[10][7] = int_stack + 56299;
 Libr12->gvrr_classes[11][8] = int_stack + 58675;
 Libr12->t2vrr_classes[10][8] = int_stack + 62185;
 Libr12->gvrr_classes[11][9] = int_stack + 65155;
 Libr12->t2vrr_classes[10][9] = int_stack + 69445;
 Libr12->t2vrr_classes[10][10] = int_stack + 73075;
 Libr12->gvrr_classes[5][11] = int_stack + 77431;
 Libr12->t1vrr_classes[5][5] = int_stack + 79069;
 Libr12->t1vrr_classes[5][6] = int_stack + 79510;
 Libr12->t1vrr_classes[5][7] = int_stack + 80098;
 Libr12->t1vrr_classes[5][8] = int_stack + 80854;
 Libr12->t1vrr_classes[5][9] = int_stack + 81799;
 Libr12->t1vrr_classes[5][10] = int_stack + 82954;
 Libr12->gvrr_classes[6][11] = int_stack + 84340;
 Libr12->t1vrr_classes[6][5] = int_stack + 86524;
 Libr12->t1vrr_classes[6][6] = int_stack + 87112;
 Libr12->t1vrr_classes[6][7] = int_stack + 87896;
 Libr12->t1vrr_classes[6][8] = int_stack + 88904;
 Libr12->t1vrr_classes[6][9] = int_stack + 90164;
 Libr12->t1vrr_classes[6][10] = int_stack + 91704;
 Libr12->gvrr_classes[7][11] = int_stack + 93552;
 Libr12->t1vrr_classes[7][5] = int_stack + 96360;
 Libr12->t1vrr_classes[7][6] = int_stack + 97116;
 Libr12->t1vrr_classes[7][7] = int_stack + 98124;
 Libr12->t1vrr_classes[7][8] = int_stack + 99420;
 Libr12->t1vrr_classes[7][9] = int_stack + 101040;
 Libr12->t1vrr_classes[7][10] = int_stack + 103020;
 Libr12->gvrr_classes[8][11] = int_stack + 105396;
 Libr12->t1vrr_classes[8][5] = int_stack + 108906;
 Libr12->t1vrr_classes[8][6] = int_stack + 109851;
 Libr12->t1vrr_classes[8][7] = int_stack + 111111;
 Libr12->t1vrr_classes[8][8] = int_stack + 112731;
 Libr12->t1vrr_classes[8][9] = int_stack + 114756;
 Libr12->t1vrr_classes[8][10] = int_stack + 117231;
 Libr12->gvrr_classes[9][11] = int_stack + 120201;
 Libr12->t1vrr_classes[9][5] = int_stack + 124491;
 Libr12->t1vrr_classes[9][6] = int_stack + 125646;
 Libr12->t1vrr_classes[9][7] = int_stack + 127186;
 Libr12->t1vrr_classes[9][8] = int_stack + 129166;
 Libr12->t1vrr_classes[9][9] = int_stack + 131641;
 Libr12->t1vrr_classes[9][10] = int_stack + 134666;
 Libr12->t1vrr_classes[10][5] = int_stack + 138296;
 Libr12->t1vrr_classes[10][6] = int_stack + 139682;
 Libr12->t1vrr_classes[10][7] = int_stack + 141530;
 Libr12->t1vrr_classes[10][8] = int_stack + 143906;
 Libr12->t1vrr_classes[10][9] = int_stack + 146876;
 Libr12->t1vrr_classes[10][10] = int_stack + 150506;
 Libr12->rvrr_classes[5][5] = int_stack + 154862;
 Libr12->rvrr_classes[5][6] = int_stack + 155303;
 Libr12->rvrr_classes[5][7] = int_stack + 155891;
 Libr12->rvrr_classes[5][8] = int_stack + 156647;
 Libr12->rvrr_classes[5][9] = int_stack + 157592;
 Libr12->rvrr_classes[5][10] = int_stack + 158747;
 Libr12->rvrr_classes[6][5] = int_stack + 160133;
 Libr12->rvrr_classes[6][6] = int_stack + 160721;
 Libr12->rvrr_classes[6][7] = int_stack + 161505;
 Libr12->rvrr_classes[6][8] = int_stack + 162513;
 Libr12->rvrr_classes[6][9] = int_stack + 163773;
 Libr12->rvrr_classes[6][10] = int_stack + 165313;
 Libr12->rvrr_classes[7][5] = int_stack + 167161;
 Libr12->rvrr_classes[7][6] = int_stack + 167917;
 Libr12->rvrr_classes[7][7] = int_stack + 168925;
 Libr12->rvrr_classes[7][8] = int_stack + 170221;
 Libr12->rvrr_classes[7][9] = int_stack + 171841;
 Libr12->rvrr_classes[7][10] = int_stack + 173821;
 Libr12->rvrr_classes[8][5] = int_stack + 176197;
 Libr12->rvrr_classes[8][6] = int_stack + 177142;
 Libr12->rvrr_classes[8][7] = int_stack + 178402;
 Libr12->rvrr_classes[8][8] = int_stack + 180022;
 Libr12->rvrr_classes[8][9] = int_stack + 182047;
 Libr12->rvrr_classes[8][10] = int_stack + 184522;
 Libr12->rvrr_classes[9][5] = int_stack + 187492;
 Libr12->rvrr_classes[9][6] = int_stack + 188647;
 Libr12->rvrr_classes[9][7] = int_stack + 190187;
 Libr12->rvrr_classes[9][8] = int_stack + 192167;
 Libr12->rvrr_classes[9][9] = int_stack + 194642;
 Libr12->rvrr_classes[9][10] = int_stack + 197667;
 Libr12->rvrr_classes[10][5] = int_stack + 201297;
 Libr12->rvrr_classes[10][6] = int_stack + 202683;
 Libr12->rvrr_classes[10][7] = int_stack + 204531;
 Libr12->rvrr_classes[10][8] = int_stack + 206907;
 Libr12->rvrr_classes[10][9] = int_stack + 209877;
 Libr12->rvrr_classes[10][10] = int_stack + 213507;
 Libr12->gvrr_classes[5][5] = int_stack + 217863;
 Libr12->gvrr_classes[5][6] = int_stack + 218304;
 Libr12->gvrr_classes[5][7] = int_stack + 218892;
 Libr12->gvrr_classes[5][8] = int_stack + 219648;
 Libr12->gvrr_classes[5][9] = int_stack + 220593;
 Libr12->gvrr_classes[5][10] = int_stack + 221748;
 Libr12->gvrr_classes[6][5] = int_stack + 223134;
 Libr12->gvrr_classes[6][6] = int_stack + 223722;
 Libr12->gvrr_classes[6][7] = int_stack + 224506;
 Libr12->gvrr_classes[6][8] = int_stack + 225514;
 Libr12->gvrr_classes[6][9] = int_stack + 226774;
 Libr12->gvrr_classes[6][10] = int_stack + 228314;
 Libr12->gvrr_classes[7][5] = int_stack + 230162;
 Libr12->gvrr_classes[7][6] = int_stack + 230918;
 Libr12->gvrr_classes[7][7] = int_stack + 231926;
 Libr12->gvrr_classes[7][8] = int_stack + 233222;
 Libr12->gvrr_classes[7][9] = int_stack + 234842;
 Libr12->gvrr_classes[7][10] = int_stack + 236822;
 Libr12->gvrr_classes[8][5] = int_stack + 239198;
 Libr12->gvrr_classes[8][6] = int_stack + 240143;
 Libr12->gvrr_classes[8][7] = int_stack + 241403;
 Libr12->gvrr_classes[8][8] = int_stack + 243023;
 Libr12->gvrr_classes[8][9] = int_stack + 245048;
 Libr12->gvrr_classes[8][10] = int_stack + 247523;
 Libr12->gvrr_classes[9][5] = int_stack + 250493;
 Libr12->gvrr_classes[9][6] = int_stack + 251648;
 Libr12->gvrr_classes[9][7] = int_stack + 253188;
 Libr12->gvrr_classes[9][8] = int_stack + 255168;
 Libr12->gvrr_classes[9][9] = int_stack + 257643;
 Libr12->gvrr_classes[9][10] = int_stack + 260668;
 Libr12->gvrr_classes[10][5] = int_stack + 264298;
 Libr12->gvrr_classes[10][6] = int_stack + 265684;
 Libr12->gvrr_classes[10][7] = int_stack + 267532;
 Libr12->gvrr_classes[10][8] = int_stack + 269908;
 Libr12->gvrr_classes[10][9] = int_stack + 272878;
 Libr12->gvrr_classes[10][10] = int_stack + 276508;
 memset(int_stack,0,280864*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 280864;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_hhhh(Libr12, Data);
   Data++;
 }

 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+280864, int_stack+218304, int_stack+217863, 21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+282187, int_stack+218892, int_stack+218304, 21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+283951, int_stack+282187, int_stack+280864, 21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+286597, int_stack+219648, int_stack+218892, 21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+288865, int_stack+286597, int_stack+282187, 21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+292393, int_stack+288865, int_stack+283951, 21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+296803, int_stack+220593, int_stack+219648, 21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+299638, int_stack+296803, int_stack+286597, 21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+304174, int_stack+299638, int_stack+288865, 21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+310054, int_stack+304174, int_stack+292393, 21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+316669, int_stack+223722, int_stack+223134, 28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+318433, int_stack+224506, int_stack+223722, 28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+320785, int_stack+318433, int_stack+316669, 28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+324313, int_stack+225514, int_stack+224506, 28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+327337, int_stack+324313, int_stack+318433, 28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+332041, int_stack+327337, int_stack+320785, 28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+337921, int_stack+226774, int_stack+225514, 28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+341701, int_stack+337921, int_stack+324313, 28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+347749, int_stack+341701, int_stack+327337, 28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+355589, int_stack+347749, int_stack+332041, 28);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+364409, int_stack+221748, int_stack+220593, 21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+367874, int_stack+364409, int_stack+296803, 21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+373544, int_stack+367874, int_stack+299638, 21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+381104, int_stack+373544, int_stack+304174, 21);
 /*--- compute (h0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+389924, int_stack+441, int_stack+0, int_stack+218304, int_stack+223134, int_stack+217863, 5, 0);
 /*--- compute (h0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+391247, int_stack+1029, int_stack+441, int_stack+218892, int_stack+223722, int_stack+218304, 5, 0);
 /*--- compute (h0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+393011, int_stack+391247, int_stack+389924, int_stack+282187, int_stack+316669, int_stack+280864, 5, 0);
 /*--- compute (h0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+395657, int_stack+1785, int_stack+1029, int_stack+219648, int_stack+224506, int_stack+218892, 5, 0);
 /*--- compute (h0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+397925, int_stack+395657, int_stack+391247, int_stack+286597, int_stack+318433, int_stack+282187, 5, 0);
 /*--- compute (h0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+401453, int_stack+397925, int_stack+393011, int_stack+288865, int_stack+320785, int_stack+283951, 5, 0);
 /*--- compute (h0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+280864, int_stack+2730, int_stack+1785, int_stack+220593, int_stack+225514, int_stack+219648, 5, 0);
 /*--- compute (h0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+389924, int_stack+280864, int_stack+395657, int_stack+296803, int_stack+324313, int_stack+286597, 5, 0);
 /*--- compute (h0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+405863, int_stack+389924, int_stack+397925, int_stack+299638, int_stack+327337, int_stack+288865, 5, 0);
 /*--- compute (h0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+283699, int_stack+405863, int_stack+401453, int_stack+304174, int_stack+332041, int_stack+292393, 5, 0);
 /*--- compute (h0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+290314, int_stack+3885, int_stack+2730, int_stack+221748, int_stack+226774, int_stack+220593, 5, 0);
 /*--- compute (h0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+394460, int_stack+290314, int_stack+280864, int_stack+364409, int_stack+337921, int_stack+296803, 5, 0);
 /*--- compute (h0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+290314, int_stack+394460, int_stack+389924, int_stack+367874, int_stack+341701, int_stack+299638, 5, 0);
 /*--- compute (h0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+389924, int_stack+290314, int_stack+405863, int_stack+373544, int_stack+347749, int_stack+304174, 5, 0);
 /*--- compute (h0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+290314, int_stack+389924, int_stack+283699, int_stack+381104, int_stack+355589, int_stack+310054, 5, 0);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+389924, int_stack+230918, int_stack+230162, 36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+392192, int_stack+231926, int_stack+230918, 36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+395216, int_stack+392192, int_stack+389924, 36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+399752, int_stack+233222, int_stack+231926, 36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+403640, int_stack+399752, int_stack+392192, 36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+299575, int_stack+403640, int_stack+395216, 36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+280864, int_stack+234842, int_stack+233222, 36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+409688, int_stack+280864, int_stack+399752, 36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+417464, int_stack+409688, int_stack+403640, 36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+427544, int_stack+417464, int_stack+299575, 36);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+228314, int_stack+226774, 28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+438884, int_stack+0, int_stack+337921, 28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+446444, int_stack+438884, int_stack+341701, 28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+456524, int_stack+446444, int_stack+347749, 28);
 /*--- compute (i0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+307135, int_stack+5859, int_stack+5271, int_stack+223722, int_stack+230162, int_stack+223134, 6, 0);
 /*--- compute (i0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+285724, int_stack+6643, int_stack+5859, int_stack+224506, int_stack+230918, int_stack+223722, 6, 0);
 /*--- compute (i0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+217863, int_stack+285724, int_stack+307135, int_stack+318433, int_stack+389924, int_stack+316669, 6, 0);
 /*--- compute (i0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+468284, int_stack+7651, int_stack+6643, int_stack+225514, int_stack+231926, int_stack+224506, 6, 0);
 /*--- compute (i0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+471308, int_stack+468284, int_stack+285724, int_stack+324313, int_stack+392192, int_stack+318433, 6, 0);
 /*--- compute (i0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+476012, int_stack+471308, int_stack+217863, int_stack+327337, int_stack+395216, int_stack+320785, 6, 0);
 /*--- compute (i0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+217863, int_stack+8911, int_stack+7651, int_stack+226774, int_stack+233222, int_stack+225514, 6, 0);
 /*--- compute (i0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+316669, int_stack+217863, int_stack+468284, int_stack+337921, int_stack+399752, int_stack+324313, 6, 0);
 /*--- compute (i0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+481892, int_stack+316669, int_stack+471308, int_stack+341701, int_stack+403640, int_stack+327337, 6, 0);
 /*--- compute (i0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+322717, int_stack+481892, int_stack+476012, int_stack+347749, int_stack+299575, int_stack+332041, 6, 0);
 /*--- compute (i0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+468284, int_stack+10451, int_stack+8911, int_stack+228314, int_stack+234842, int_stack+226774, 6, 0);
 /*--- compute (i0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+472904, int_stack+468284, int_stack+217863, int_stack+0, int_stack+280864, int_stack+337921, 6, 0);
 /*--- compute (i0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+331537, int_stack+472904, int_stack+316669, int_stack+438884, int_stack+409688, int_stack+341701, 6, 0);
 /*--- compute (i0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+468284, int_stack+331537, int_stack+481892, int_stack+446444, int_stack+417464, int_stack+347749, 6, 0);
 /*--- compute (i0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+331537, int_stack+468284, int_stack+322717, int_stack+456524, int_stack+427544, int_stack+355589, 6, 0);
 /*--- compute (hp|[r12,T2]|hh) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+468284, int_stack+331537, int_stack+290314, 441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+343885, int_stack+240143, int_stack+239198, 45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+346720, int_stack+241403, int_stack+240143, 45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+316669, int_stack+346720, int_stack+343885, 45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+350500, int_stack+243023, int_stack+241403, 45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+322339, int_stack+350500, int_stack+346720, 45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+285724, int_stack+322339, int_stack+316669, 45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+4620, int_stack+245048, int_stack+243023, 45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+496067, int_stack+4620, int_stack+350500, 45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+505787, int_stack+496067, int_stack+322339, 45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+518387, int_stack+505787, int_stack+285724, 45);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+532562, int_stack+236822, int_stack+234842, 36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+538502, int_stack+532562, int_stack+280864, 36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+548222, int_stack+538502, int_stack+409688, 36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+561182, int_stack+548222, int_stack+417464, 36);
 /*--- compute (k0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+217863, int_stack+13055, int_stack+12299, int_stack+230918, int_stack+239198, int_stack+230162, 7, 0);
 /*--- compute (k0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+295174, int_stack+14063, int_stack+13055, int_stack+231926, int_stack+240143, int_stack+230918, 7, 0);
 /*--- compute (k0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+223134, int_stack+295174, int_stack+217863, int_stack+392192, int_stack+343885, int_stack+389924, 7, 0);
 /*--- compute (k0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+576302, int_stack+15359, int_stack+14063, int_stack+233222, int_stack+241403, int_stack+231926, 7, 0);
 /*--- compute (k0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+580190, int_stack+576302, int_stack+295174, int_stack+399752, int_stack+346720, int_stack+392192, 7, 0);
 /*--- compute (k0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+586238, int_stack+580190, int_stack+223134, int_stack+403640, int_stack+316669, int_stack+395216, 7, 0);
 /*--- compute (k0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+223134, int_stack+16979, int_stack+15359, int_stack+234842, int_stack+243023, int_stack+233222, 7, 0);
 /*--- compute (k0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+389924, int_stack+223134, int_stack+576302, int_stack+280864, int_stack+350500, int_stack+399752, 7, 0);
 /*--- compute (k0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+593798, int_stack+389924, int_stack+580190, int_stack+409688, int_stack+322339, int_stack+403640, 7, 0);
 /*--- compute (k0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+397700, int_stack+593798, int_stack+586238, int_stack+417464, int_stack+285724, int_stack+299575, 7, 0);
 /*--- compute (k0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+576302, int_stack+18959, int_stack+16979, int_stack+236822, int_stack+245048, int_stack+234842, 7, 0);
 /*--- compute (k0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+582242, int_stack+576302, int_stack+223134, int_stack+532562, int_stack+4620, int_stack+280864, 7, 0);
 /*--- compute (k0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+295174, int_stack+582242, int_stack+389924, int_stack+538502, int_stack+496067, int_stack+409688, 7, 0);
 /*--- compute (k0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+576302, int_stack+295174, int_stack+593798, int_stack+548222, int_stack+505787, int_stack+417464, 7, 0);
 /*--- compute (k0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+409040, int_stack+576302, int_stack+397700, int_stack+561182, int_stack+518387, int_stack+427544, 7, 0);
 /*--- compute (ip|[r12,T2]|hh) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+576302, int_stack+409040, int_stack+331537, 441);
 /*--- compute (hd|[r12,T2]|hh) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+613346, int_stack+576302, int_stack+468284, 441);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+468284, int_stack+251648, int_stack+250493, 55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+471749, int_stack+253188, int_stack+251648, 55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+476369, int_stack+471749, int_stack+468284, 55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+483299, int_stack+255168, int_stack+253188, 55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+295174, int_stack+483299, int_stack+471749, 55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+389924, int_stack+295174, int_stack+476369, 55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+401474, int_stack+257643, int_stack+255168, 55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+329899, int_stack+401474, int_stack+483299, 55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+668912, int_stack+329899, int_stack+295174, 55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+684312, int_stack+668912, int_stack+389924, 55);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+10695, int_stack+247523, int_stack+245048, 45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+701637, int_stack+10695, int_stack+4620, 45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+713787, int_stack+701637, int_stack+496067, 45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+729987, int_stack+713787, int_stack+505787, 45);
 /*--- compute (l0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+489239, int_stack+22280, int_stack+21335, int_stack+240143, int_stack+250493, int_stack+239198, 8, 0);
 /*--- compute (l0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+492074, int_stack+23540, int_stack+22280, int_stack+241403, int_stack+251648, int_stack+240143, 8, 0);
 /*--- compute (l0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+230162, int_stack+492074, int_stack+489239, int_stack+346720, int_stack+468284, int_stack+343885, 8, 0);
 /*--- compute (l0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+280864, int_stack+25160, int_stack+23540, int_stack+243023, int_stack+253188, int_stack+241403, 8, 0);
 /*--- compute (l0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+748887, int_stack+280864, int_stack+492074, int_stack+350500, int_stack+471749, int_stack+346720, 8, 0);
 /*--- compute (l0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+756447, int_stack+748887, int_stack+230162, int_stack+322339, int_stack+476369, int_stack+316669, 8, 0);
 /*--- compute (l0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+230162, int_stack+27185, int_stack+25160, int_stack+245048, int_stack+255168, int_stack+243023, 8, 0);
 /*--- compute (l0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+765897, int_stack+230162, int_stack+280864, int_stack+4620, int_stack+483299, int_stack+350500, 8, 0);
 /*--- compute (l0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+341779, int_stack+765897, int_stack+748887, int_stack+496067, int_stack+295174, int_stack+322339, 8, 0);
 /*--- compute (l0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+775617, int_stack+341779, int_stack+756447, int_stack+505787, int_stack+389924, int_stack+285724, 8, 0);
 /*--- compute (l0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+748887, int_stack+29660, int_stack+27185, int_stack+247523, int_stack+257643, int_stack+245048, 8, 0);
 /*--- compute (l0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+280864, int_stack+748887, int_stack+230162, int_stack+10695, int_stack+401474, int_stack+4620, 8, 0);
 /*--- compute (l0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+748887, int_stack+280864, int_stack+765897, int_stack+701637, int_stack+329899, int_stack+496067, 8, 0);
 /*--- compute (l0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+789792, int_stack+748887, int_stack+341779, int_stack+713787, int_stack+668912, int_stack+505787, 8, 0);
 /*--- compute (l0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+748887, int_stack+789792, int_stack+775617, int_stack+729987, int_stack+684312, int_stack+518387, 8, 0);
 /*--- compute (kp|[r12,T2]|hh) ---*/
   hrr1_build_kp(Libr12->ShellQuartet.AB,int_stack+768732, int_stack+748887, int_stack+409040, 441);
 /*--- compute (id|[r12,T2]|hh) ---*/
   hrr1_build_id(Libr12->ShellQuartet.AB,int_stack+816360, int_stack+768732, int_stack+576302, 441);
 /*--- compute (hf|[r12,T2]|hh) ---*/
   hrr1_build_hf(Libr12->ShellQuartet.AB,int_stack+890448, int_stack+816360, int_stack+613346, 441);
 /*--- compute (n0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+576302, int_stack+265684, int_stack+264298, 66);
 /*--- compute (n0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+580460, int_stack+267532, int_stack+265684, 66);
 /*--- compute (n0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+586004, int_stack+580460, int_stack+576302, 66);
 /*--- compute (n0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+594320, int_stack+269908, int_stack+267532, 66);
 /*--- compute (n0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+601448, int_stack+594320, int_stack+580460, 66);
 /*--- compute (n0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+612536, int_stack+601448, int_stack+586004, 66);
 /*--- compute (n0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+626396, int_stack+272878, int_stack+269908, 66);
 /*--- compute (n0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+635306, int_stack+626396, int_stack+594320, 66);
 /*--- compute (n0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+649562, int_stack+635306, int_stack+601448, 66);
 /*--- compute (n0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+489239, int_stack+649562, int_stack+612536, 66);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+341779, int_stack+260668, int_stack+257643, 55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+408899, int_stack+341779, int_stack+401474, 55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+983058, int_stack+408899, int_stack+329899, 55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+1002858, int_stack+983058, int_stack+668912, 55);
 /*--- compute (m0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+350854, int_stack+33785, int_stack+32630, int_stack+251648, int_stack+264298, int_stack+250493, 9, 0);
 /*--- compute (m0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+280864, int_stack+35325, int_stack+33785, int_stack+253188, int_stack+265684, int_stack+251648, 9, 0);
 /*--- compute (m0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+285484, int_stack+280864, int_stack+350854, int_stack+471749, int_stack+576302, int_stack+468284, 9, 0);
 /*--- compute (m0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+4620, int_stack+37305, int_stack+35325, int_stack+255168, int_stack+267532, int_stack+253188, 9, 0);
 /*--- compute (m0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+316669, int_stack+4620, int_stack+280864, int_stack+483299, int_stack+580460, int_stack+471749, 9, 0);
 /*--- compute (m0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+18120, int_stack+316669, int_stack+285484, int_stack+295174, int_stack+586004, int_stack+476369, 9, 0);
 /*--- compute (m0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+280864, int_stack+39780, int_stack+37305, int_stack+257643, int_stack+269908, int_stack+255168, 9, 0);
 /*--- compute (m0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+468284, int_stack+280864, int_stack+4620, int_stack+401474, int_stack+594320, int_stack+483299, 9, 0);
 /*--- compute (m0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+1025958, int_stack+468284, int_stack+316669, int_stack+329899, int_stack+601448, int_stack+295174, 9, 0);
 /*--- compute (m0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+288289, int_stack+1025958, int_stack+18120, int_stack+668912, int_stack+612536, int_stack+389924, 9, 0);
 /*--- compute (m0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+480164, int_stack+42805, int_stack+39780, int_stack+260668, int_stack+272878, int_stack+257643, 9, 0);
 /*--- compute (m0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+18120, int_stack+480164, int_stack+280864, int_stack+341779, int_stack+626396, int_stack+401474, 9, 0);
 /*--- compute (m0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+1041358, int_stack+18120, int_stack+468284, int_stack+408899, int_stack+635306, int_stack+329899, 9, 0);
 /*--- compute (m0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+18120, int_stack+1041358, int_stack+1025958, int_stack+983058, int_stack+649562, int_stack+668912, 9, 0);
 /*--- compute (m0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+1025958, int_stack+18120, int_stack+288289, int_stack+1002858, int_stack+489239, int_stack+684312, 9, 0);
 /*--- compute (lp|[r12,T2]|hh) ---*/
   hrr1_build_lp(Libr12->ShellQuartet.AB,int_stack+1050213, int_stack+1025958, int_stack+748887, 441);
 /*--- compute (kd|[r12,T2]|hh) ---*/
   hrr1_build_kd(Libr12->ShellQuartet.AB,int_stack+1109748, int_stack+1050213, int_stack+768732, 441);
 /*--- compute (if|[r12,T2]|hh) ---*/
   hrr1_build_if(Libr12->ShellQuartet.AB,int_stack+1205004, int_stack+1109748, int_stack+816360, 441);
 /*--- compute (hg|[r12,T2]|hh) ---*/
   hrr1_build_hg(Libr12->ShellQuartet.AB,int_stack+748887, int_stack+1205004, int_stack+890448, 441);
 /*--- compute (o0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+887802, int_stack+49459, int_stack+46435, 78);
 /*--- compute (o0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+892716, int_stack+53491, int_stack+49459, 78);
 /*--- compute (o0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+899268, int_stack+892716, int_stack+887802, 78);
 /*--- compute (o0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+909096, int_stack+58675, int_stack+53491, 78);
 /*--- compute (o0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+917520, int_stack+909096, int_stack+892716, 78);
 /*--- compute (o0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+930624, int_stack+917520, int_stack+899268, 78);
 /*--- compute (o0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+947004, int_stack+65155, int_stack+58675, 78);
 /*--- compute (o0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+957534, int_stack+947004, int_stack+909096, 78);
 /*--- compute (o0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+18120, int_stack+957534, int_stack+917520, 78);
 /*--- compute (o0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+280864, int_stack+18120, int_stack+930624, 78);
 /*--- compute (n0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+468284, int_stack+276508, int_stack+272878, 66);
 /*--- compute (n0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+389924, int_stack+468284, int_stack+626396, 66);
 /*--- compute (n0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+316669, int_stack+389924, int_stack+635306, 66);
 /*--- compute (n0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+1328484, int_stack+316669, int_stack+649562, 66);
 /*--- compute (n0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+974382, int_stack+51643, int_stack+48073, int_stack+265684, int_stack+46435, int_stack+264298, 10, 0);
 /*--- compute (n0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+39960, int_stack+56299, int_stack+51643, int_stack+267532, int_stack+49459, int_stack+265684, 10, 0);
 /*--- compute (n0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+479174, int_stack+39960, int_stack+974382, int_stack+580460, int_stack+887802, int_stack+576302, 10, 0);
 /*--- compute (n0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+974382, int_stack+62185, int_stack+56299, int_stack+269908, int_stack+53491, int_stack+267532, 10, 0);
 /*--- compute (n0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+45504, int_stack+974382, int_stack+39960, int_stack+594320, int_stack+892716, int_stack+580460, 10, 0);
 /*--- compute (n0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+668042, int_stack+45504, int_stack+479174, int_stack+601448, int_stack+899268, int_stack+586004, 10, 0);
 /*--- compute (n0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+479174, int_stack+69445, int_stack+62185, int_stack+272878, int_stack+58675, int_stack+269908, 10, 0);
 /*--- compute (n0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+576302, int_stack+479174, int_stack+974382, int_stack+626396, int_stack+909096, int_stack+594320, 10, 0);
 /*--- compute (n0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+887802, int_stack+576302, int_stack+45504, int_stack+635306, int_stack+917520, int_stack+601448, 10, 0);
 /*--- compute (n0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+39960, int_stack+887802, int_stack+668042, int_stack+649562, int_stack+930624, int_stack+612536, 10, 0);
 /*--- compute (n0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+668042, int_stack+73075, int_stack+69445, int_stack+276508, int_stack+65155, int_stack+272878, 10, 0);
 /*--- compute (n0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+590558, int_stack+668042, int_stack+479174, int_stack+468284, int_stack+947004, int_stack+626396, 10, 0);
 /*--- compute (n0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+608378, int_stack+590558, int_stack+576302, int_stack+389924, int_stack+957534, int_stack+635306, 10, 0);
 /*--- compute (n0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+576302, int_stack+608378, int_stack+887802, int_stack+316669, int_stack+18120, int_stack+649562, 10, 0);
 /*--- compute (n0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+887802, int_stack+576302, int_stack+39960, int_stack+1328484, int_stack+280864, int_stack+489239, 10, 0);
 /*--- compute (mp|[r12,T2]|hh) ---*/
   hrr1_build_mp(Libr12->ShellQuartet.AB,int_stack+576302, int_stack+887802, int_stack+1025958, 441);
 /*--- compute (ld|[r12,T2]|hh) ---*/
   hrr1_build_ld(Libr12->ShellQuartet.AB,int_stack+1356204, int_stack+576302, int_stack+1050213, 441);
 /*--- compute (kf|[r12,T2]|hh) ---*/
   hrr1_build_kf(Libr12->ShellQuartet.AB,int_stack+1475274, int_stack+1356204, int_stack+1109748, 441);
 /*--- compute (ig|[r12,T2]|hh) ---*/
   hrr1_build_ig(Libr12->ShellQuartet.AB,int_stack+1634034, int_stack+1475274, int_stack+1205004, 441);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+1356204, int_stack+381104, int_stack+310054, 21);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+1365465, int_stack+456524, int_stack+355589, 28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+1377813, int_stack+1365465, int_stack+1356204, 441);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+1405596, int_stack+561182, int_stack+427544, 36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+1421472, int_stack+1405596, int_stack+1365465, 441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+1458516, int_stack+1421472, int_stack+1377813, 441);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+1514082, int_stack+729987, int_stack+518387, 45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libr12->ShellQuartet.AB,int_stack+1533927, int_stack+1514082, int_stack+1405596, 441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libr12->ShellQuartet.AB,int_stack+576302, int_stack+1533927, int_stack+1421472, 441);
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libr12->ShellQuartet.AB,int_stack+1025958, int_stack+576302, int_stack+1458516, 441);
 /*--- compute (m0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+1581555, int_stack+1002858, int_stack+684312, 55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libr12->ShellQuartet.AB,int_stack+1118568, int_stack+1581555, int_stack+1514082, 441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libr12->ShellQuartet.AB,int_stack+887802, int_stack+1118568, int_stack+1533927, 441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libr12->ShellQuartet.AB,int_stack+1178103, int_stack+887802, int_stack+576302, 441);
 /*--- compute (hg|hh) ---*/
   hrr1_build_hg(Libr12->ShellQuartet.AB,int_stack+1819254, int_stack+1178103, int_stack+1025958, 441);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libr12->ShellQuartet.CD,int_stack+1605810, int_stack+77431, int_stack+221748, 21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libr12->ShellQuartet.CD,int_stack+1609968, int_stack+1605810, int_stack+364409, 21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libr12->ShellQuartet.CD,int_stack+1616898, int_stack+1609968, int_stack+367874, 21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libr12->ShellQuartet.CD,int_stack+650390, int_stack+1616898, int_stack+373544, 21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libr12->ShellQuartet.CD,int_stack+1605810, int_stack+650390, int_stack+381104, 21);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libr12->ShellQuartet.CD,int_stack+650390, int_stack+84340, int_stack+228314, 28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libr12->ShellQuartet.CD,int_stack+655934, int_stack+650390, int_stack+0, 28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libr12->ShellQuartet.CD,int_stack+665174, int_stack+655934, int_stack+438884, 28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libr12->ShellQuartet.CD,int_stack+677774, int_stack+665174, int_stack+446444, 28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libr12->ShellQuartet.CD,int_stack+650390, int_stack+677774, int_stack+456524, 28);
 /*--- compute (hp|ih) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+18120, int_stack+650390, int_stack+1605810, 588);
 /*--- compute (k0|np) ---*/
   hrr3_build_np(Libr12->ShellQuartet.CD,int_stack+0, int_stack+93552, int_stack+236822, 36);
 /*--- compute (k0|md) ---*/
   hrr3_build_md(Libr12->ShellQuartet.CD,int_stack+666854, int_stack+0, int_stack+532562, 36);
 /*--- compute (k0|lf) ---*/
   hrr3_build_lf(Libr12->ShellQuartet.CD,int_stack+678734, int_stack+666854, int_stack+538502, 36);
 /*--- compute (k0|kg) ---*/
   hrr3_build_kg(Libr12->ShellQuartet.CD,int_stack+1301583, int_stack+678734, int_stack+548222, 36);
 /*--- compute (k0|ih) ---*/
   hrr3_build_ih(Libr12->ShellQuartet.CD,int_stack+666854, int_stack+1301583, int_stack+561182, 36);
 /*--- compute (ip|ih) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+264298, int_stack+666854, int_stack+650390, 588);
 /*--- compute (hd|ih) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+1958169, int_stack+264298, int_stack+18120, 588);
 /*--- compute (l0|np) ---*/
   hrr3_build_np(Libr12->ShellQuartet.CD,int_stack+1301583, int_stack+105396, int_stack+247523, 45);
 /*--- compute (l0|md) ---*/
   hrr3_build_md(Libr12->ShellQuartet.CD,int_stack+1310493, int_stack+1301583, int_stack+10695, 45);
 /*--- compute (l0|lf) ---*/
   hrr3_build_lf(Libr12->ShellQuartet.CD,int_stack+55164, int_stack+1310493, int_stack+701637, 45);
 /*--- compute (l0|kg) ---*/
   hrr3_build_kg(Libr12->ShellQuartet.CD,int_stack+1301583, int_stack+55164, int_stack+713787, 45);
 /*--- compute (l0|ih) ---*/
   hrr3_build_ih(Libr12->ShellQuartet.CD,int_stack+688022, int_stack+1301583, int_stack+729987, 45);
 /*--- compute (kp|ih) ---*/
   hrr1_build_kp(Libr12->ShellQuartet.AB,int_stack+510029, int_stack+688022, int_stack+666854, 588);
 /*--- compute (id|ih) ---*/
   hrr1_build_id(Libr12->ShellQuartet.AB,int_stack+2032257, int_stack+510029, int_stack+264298, 588);
 /*--- compute (hf|ih) ---*/
   hrr1_build_hf(Libr12->ShellQuartet.AB,int_stack+2131041, int_stack+2032257, int_stack+1958169, 588);
 /*--- compute (m0|np) ---*/
   hrr3_build_np(Libr12->ShellQuartet.CD,int_stack+1301583, int_stack+120201, int_stack+260668, 55);
 /*--- compute (m0|md) ---*/
   hrr3_build_md(Libr12->ShellQuartet.CD,int_stack+55164, int_stack+1301583, int_stack+341779, 55);
 /*--- compute (m0|lf) ---*/
   hrr3_build_lf(Libr12->ShellQuartet.CD,int_stack+1301583, int_stack+55164, int_stack+408899, 55);
 /*--- compute (m0|kg) ---*/
   hrr3_build_kg(Libr12->ShellQuartet.CD,int_stack+714482, int_stack+1301583, int_stack+983058, 55);
 /*--- compute (m0|ih) ---*/
   hrr3_build_ih(Libr12->ShellQuartet.CD,int_stack+313690, int_stack+714482, int_stack+1002858, 55);
 /*--- compute (lp|ih) ---*/
   hrr1_build_lp(Libr12->ShellQuartet.AB,int_stack+346030, int_stack+313690, int_stack+688022, 588);
 /*--- compute (kd|ih) ---*/
   hrr1_build_kd(Libr12->ShellQuartet.AB,int_stack+2254521, int_stack+346030, int_stack+510029, 588);
 /*--- compute (if|ih) ---*/
   hrr1_build_if(Libr12->ShellQuartet.AB,int_stack+2381529, int_stack+2254521, int_stack+2032257, 588);
 /*--- compute (hg|ih) ---*/
   hrr1_build_hg(Libr12->ShellQuartet.AB,int_stack+2546169, int_stack+2381529, int_stack+2131041, 588);
 /*--- compute (n0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+714482, int_stack+1328484, int_stack+489239, 66);
 /*--- compute (mp|hh) ---*/
   hrr1_build_mp(Libr12->ShellQuartet.AB,int_stack+425410, int_stack+714482, int_stack+1581555, 441);
 /*--- compute (ld|hh) ---*/
   hrr1_build_ld(Libr12->ShellQuartet.AB,int_stack+2731389, int_stack+425410, int_stack+1118568, 441);
 /*--- compute (kf|hh) ---*/
   hrr1_build_kf(Libr12->ShellQuartet.AB,int_stack+2850459, int_stack+2731389, int_stack+887802, 441);
 /*--- compute (ig|hh) ---*/
   hrr1_build_ig(Libr12->ShellQuartet.AB,int_stack+3009219, int_stack+2850459, int_stack+1178103, 441);
 /*--- compute (h0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+743588, int_stack+79510, int_stack+79069, 21);
 /*--- compute (h0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+744911, int_stack+80098, int_stack+79510, 21);
 /*--- compute (h0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+983058, int_stack+744911, int_stack+743588, 21);
 /*--- compute (h0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+985704, int_stack+80854, int_stack+80098, 21);
 /*--- compute (h0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+987972, int_stack+985704, int_stack+744911, 21);
 /*--- compute (h0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+743588, int_stack+987972, int_stack+983058, 21);
 /*--- compute (h0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+991500, int_stack+81799, int_stack+80854, 21);
 /*--- compute (h0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+994335, int_stack+991500, int_stack+985704, 21);
 /*--- compute (h0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+998871, int_stack+994335, int_stack+987972, 21);
 /*--- compute (h0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+983058, int_stack+998871, int_stack+743588, 21);
 /*--- compute (h0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+743588, int_stack+82954, int_stack+81799, 21);
 /*--- compute (h0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+1004751, int_stack+743588, int_stack+991500, 21);
 /*--- compute (h0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+1010421, int_stack+1004751, int_stack+994335, 21);
 /*--- compute (h0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+989673, int_stack+1010421, int_stack+998871, 21);
 /*--- compute (h0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+998493, int_stack+989673, int_stack+983058, 21);
 /*--- compute (i0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+983058, int_stack+87112, int_stack+86524, 28);
 /*--- compute (i0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+984822, int_stack+87896, int_stack+87112, 28);
 /*--- compute (i0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+987174, int_stack+984822, int_stack+983058, 28);
 /*--- compute (i0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+990702, int_stack+88904, int_stack+87896, 28);
 /*--- compute (i0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+993726, int_stack+990702, int_stack+984822, 28);
 /*--- compute (i0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+1007754, int_stack+993726, int_stack+987174, 28);
 /*--- compute (i0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+983058, int_stack+90164, int_stack+88904, 28);
 /*--- compute (i0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+1013634, int_stack+983058, int_stack+990702, 28);
 /*--- compute (i0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+1301583, int_stack+1013634, int_stack+993726, 28);
 /*--- compute (i0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+986838, int_stack+1301583, int_stack+1007754, 28);
 /*--- compute (i0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+1007754, int_stack+91704, int_stack+90164, 28);
 /*--- compute (i0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+1309423, int_stack+1007754, int_stack+983058, 28);
 /*--- compute (i0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+1316983, int_stack+1309423, int_stack+1013634, 28);
 /*--- compute (i0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+1007754, int_stack+1316983, int_stack+1301583, 28);
 /*--- compute (i0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+1301583, int_stack+1007754, int_stack+986838, 28);
 /*--- compute (hp|[r12,T1]|hh) ---*/
   t1hrr1_build_hp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+1313931, int_stack+1301583, int_stack+998493, int_stack+1365465, int_stack+1605810, int_stack+1356204, 5, 5);
 /*--- compute (k0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1605810, int_stack+97116, int_stack+96360, 36);
 /*--- compute (k0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1608078, int_stack+98124, int_stack+97116, 36);
 /*--- compute (k0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+1611102, int_stack+1608078, int_stack+1605810, 36);
 /*--- compute (k0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+1615638, int_stack+99420, int_stack+98124, 36);
 /*--- compute (k0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+1619526, int_stack+1615638, int_stack+1608078, 36);
 /*--- compute (k0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+1625574, int_stack+1619526, int_stack+1611102, 36);
 /*--- compute (k0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+1605810, int_stack+101040, int_stack+99420, 36);
 /*--- compute (k0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+1341714, int_stack+1605810, int_stack+1615638, 36);
 /*--- compute (k0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+1349490, int_stack+1341714, int_stack+1619526, 36);
 /*--- compute (k0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+1610670, int_stack+1349490, int_stack+1625574, 36);
 /*--- compute (k0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+1622010, int_stack+103020, int_stack+101040, 36);
 /*--- compute (k0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+983058, int_stack+1622010, int_stack+1605810, 36);
 /*--- compute (k0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+992778, int_stack+983058, int_stack+1341714, 36);
 /*--- compute (k0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+1005738, int_stack+992778, int_stack+1349490, 36);
 /*--- compute (k0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+1341714, int_stack+1005738, int_stack+1610670, 36);
 /*--- compute (ip|[r12,T1]|hh) ---*/
   t1hrr1_build_ip(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+983058, int_stack+1341714, int_stack+1301583, int_stack+1405596, int_stack+650390, int_stack+1365465, 5, 5);
 /*--- compute (hd|[r12,T1]|hh) ---*/
   t1hrr1_build_hd(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+3194439, int_stack+983058, int_stack+1313931, int_stack+1421472, int_stack+18120, int_stack+1377813, 5, 5);
 /*--- compute (l0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+650390, int_stack+109851, int_stack+108906, 45);
 /*--- compute (l0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+653225, int_stack+111111, int_stack+109851, 45);
 /*--- compute (l0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+657005, int_stack+653225, int_stack+650390, 45);
 /*--- compute (l0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+1301583, int_stack+112731, int_stack+111111, 45);
 /*--- compute (l0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+1306443, int_stack+1301583, int_stack+653225, 45);
 /*--- compute (l0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+1314003, int_stack+1306443, int_stack+657005, 45);
 /*--- compute (l0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+650390, int_stack+114756, int_stack+112731, 45);
 /*--- compute (l0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+656465, int_stack+650390, int_stack+1301583, 45);
 /*--- compute (l0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+1323453, int_stack+656465, int_stack+1306443, 45);
 /*--- compute (l0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+1357590, int_stack+1323453, int_stack+1314003, 45);
 /*--- compute (l0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+1301583, int_stack+117231, int_stack+114756, 45);
 /*--- compute (l0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+1309008, int_stack+1301583, int_stack+650390, 45);
 /*--- compute (l0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+1371765, int_stack+1309008, int_stack+656465, 45);
 /*--- compute (l0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+1301583, int_stack+1371765, int_stack+1323453, 45);
 /*--- compute (l0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+1371765, int_stack+1301583, int_stack+1357590, 45);
 /*--- compute (kp|[r12,T1]|hh) ---*/
   t1hrr1_build_kp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+0, int_stack+1371765, int_stack+1341714, int_stack+1514082, int_stack+666854, int_stack+1405596, 5, 5);
 /*--- compute (id|[r12,T1]|hh) ---*/
   t1hrr1_build_id(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+47628, int_stack+0, int_stack+983058, int_stack+1533927, int_stack+264298, int_stack+1421472, 5, 5);
 /*--- compute (hf|[r12,T1]|hh) ---*/
   t1hrr1_build_hf(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+217863, int_stack+47628, int_stack+3194439, int_stack+576302, int_stack+1958169, int_stack+1458516, 5, 5);
 /*--- compute (m0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1958169, int_stack+125646, int_stack+124491, 55);
 /*--- compute (m0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1961634, int_stack+127186, int_stack+125646, 55);
 /*--- compute (m0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+1966254, int_stack+1961634, int_stack+1958169, 55);
 /*--- compute (m0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+1973184, int_stack+129166, int_stack+127186, 55);
 /*--- compute (m0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+1979124, int_stack+1973184, int_stack+1961634, 55);
 /*--- compute (m0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+1988364, int_stack+1979124, int_stack+1966254, 55);
 /*--- compute (m0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+1958169, int_stack+131641, int_stack+129166, 55);
 /*--- compute (m0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+1999914, int_stack+1958169, int_stack+1973184, 55);
 /*--- compute (m0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+2011794, int_stack+1999914, int_stack+1979124, 55);
 /*--- compute (m0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+1965594, int_stack+2011794, int_stack+1988364, 55);
 /*--- compute (m0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+1982919, int_stack+134666, int_stack+131641, 55);
 /*--- compute (m0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+3194439, int_stack+1982919, int_stack+1958169, 55);
 /*--- compute (m0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+3209289, int_stack+3194439, int_stack+1999914, 55);
 /*--- compute (m0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+1982919, int_stack+3209289, int_stack+2011794, 55);
 /*--- compute (m0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+3194439, int_stack+1982919, int_stack+1965594, 55);
 /*--- compute (lp|[r12,T1]|hh) ---*/
   t1hrr1_build_lp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+1958169, int_stack+3194439, int_stack+1371765, int_stack+1581555, int_stack+688022, int_stack+1514082, 5, 5);
 /*--- compute (kd|[r12,T1]|hh) ---*/
   t1hrr1_build_kd(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+1301583, int_stack+1958169, int_stack+0, int_stack+1118568, int_stack+510029, int_stack+1533927, 5, 5);
 /*--- compute (if|[r12,T1]|hh) ---*/
   t1hrr1_build_if(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+1396839, int_stack+1301583, int_stack+47628, int_stack+887802, int_stack+2032257, int_stack+576302, 5, 5);
 /*--- compute (hg|[r12,T1]|hh) ---*/
   t1hrr1_build_hg(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+498175, int_stack+1396839, int_stack+217863, int_stack+1178103, int_stack+2131041, int_stack+1025958, 5, 5);
 /*--- compute (n0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+217863, int_stack+139682, int_stack+138296, 66);
 /*--- compute (n0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+222021, int_stack+141530, int_stack+139682, 66);
 /*--- compute (n0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+227565, int_stack+222021, int_stack+217863, 66);
 /*--- compute (n0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+235881, int_stack+143906, int_stack+141530, 66);
 /*--- compute (n0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+243009, int_stack+235881, int_stack+222021, 66);
 /*--- compute (n0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+254097, int_stack+243009, int_stack+227565, 66);
 /*--- compute (n0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+217863, int_stack+146876, int_stack+143906, 66);
 /*--- compute (n0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+267957, int_stack+217863, int_stack+235881, 66);
 /*--- compute (n0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+282213, int_stack+267957, int_stack+243009, 66);
 /*--- compute (n0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+226773, int_stack+282213, int_stack+254097, 66);
 /*--- compute (n0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+247563, int_stack+150506, int_stack+146876, 66);
 /*--- compute (n0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+0, int_stack+247563, int_stack+217863, 66);
 /*--- compute (n0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+17820, int_stack+0, int_stack+267957, 66);
 /*--- compute (n0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+247563, int_stack+17820, int_stack+282213, 66);
 /*--- compute (n0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+0, int_stack+247563, int_stack+226773, 66);
 /*--- compute (mp|[r12,T1]|hh) ---*/
   t1hrr1_build_mp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+29106, int_stack+0, int_stack+3194439, int_stack+714482, int_stack+313690, int_stack+1581555, 5, 5);
 /*--- compute (ld|[r12,T1]|hh) ---*/
   t1hrr1_build_ld(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+217863, int_stack+29106, int_stack+1958169, int_stack+425410, int_stack+346030, int_stack+1118568, 5, 5);
 /*--- compute (kf|[r12,T1]|hh) ---*/
   t1hrr1_build_kf(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+1958169, int_stack+217863, int_stack+1301583, int_stack+2731389, int_stack+2254521, int_stack+887802, 5, 5);
 /*--- compute (ig|[r12,T1]|hh) ---*/
   t1hrr1_build_ig(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+887802, int_stack+1958169, int_stack+1396839, int_stack+2850459, int_stack+2381529, int_stack+1178103, 5, 5);
 /*--- compute (h0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1958169, int_stack+155303, int_stack+154862, 21);
 /*--- compute (h0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1959492, int_stack+155891, int_stack+155303, 21);
 /*--- compute (h0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+1961256, int_stack+1959492, int_stack+1958169, 21);
 /*--- compute (h0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+1963902, int_stack+156647, int_stack+155891, 21);
 /*--- compute (h0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+1966170, int_stack+1963902, int_stack+1959492, 21);
 /*--- compute (h0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+1969698, int_stack+1966170, int_stack+1961256, 21);
 /*--- compute (h0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+1958169, int_stack+157592, int_stack+156647, 21);
 /*--- compute (h0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+1974108, int_stack+1958169, int_stack+1963902, 21);
 /*--- compute (h0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+1978644, int_stack+1974108, int_stack+1966170, 21);
 /*--- compute (h0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+1961004, int_stack+1978644, int_stack+1969698, 21);
 /*--- compute (h0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+1967619, int_stack+158747, int_stack+157592, 21);
 /*--- compute (h0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+1984524, int_stack+1967619, int_stack+1958169, 21);
 /*--- compute (h0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+1990194, int_stack+1984524, int_stack+1974108, 21);
 /*--- compute (h0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+1967619, int_stack+1990194, int_stack+1978644, 21);
 /*--- compute (h0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+1976439, int_stack+1967619, int_stack+1961004, 21);
 /*--- compute (i0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1958169, int_stack+160721, int_stack+160133, 28);
 /*--- compute (i0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1959933, int_stack+161505, int_stack+160721, 28);
 /*--- compute (i0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+1962285, int_stack+1959933, int_stack+1958169, 28);
 /*--- compute (i0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+1965813, int_stack+162513, int_stack+161505, 28);
 /*--- compute (i0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+1968837, int_stack+1965813, int_stack+1959933, 28);
 /*--- compute (i0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+1985700, int_stack+1968837, int_stack+1962285, 28);
 /*--- compute (i0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+1958169, int_stack+163773, int_stack+162513, 28);
 /*--- compute (i0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+1991580, int_stack+1958169, int_stack+1965813, 28);
 /*--- compute (i0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+1997628, int_stack+1991580, int_stack+1968837, 28);
 /*--- compute (i0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+1961949, int_stack+1997628, int_stack+1985700, 28);
 /*--- compute (i0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+1985700, int_stack+165313, int_stack+163773, 28);
 /*--- compute (i0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+2005468, int_stack+1985700, int_stack+1958169, 28);
 /*--- compute (i0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+2013028, int_stack+2005468, int_stack+1991580, 28);
 /*--- compute (i0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+1985700, int_stack+2013028, int_stack+1997628, 28);
 /*--- compute (i0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+1997460, int_stack+1985700, int_stack+1961949, 28);
 /*--- compute (hp||hh) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+2009808, int_stack+1997460, int_stack+1976439, 441);
 /*--- compute (k0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1958169, int_stack+167917, int_stack+167161, 36);
 /*--- compute (k0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1960437, int_stack+168925, int_stack+167917, 36);
 /*--- compute (k0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+1963461, int_stack+1960437, int_stack+1958169, 36);
 /*--- compute (k0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+1967997, int_stack+170221, int_stack+168925, 36);
 /*--- compute (k0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+1971885, int_stack+1967997, int_stack+1960437, 36);
 /*--- compute (k0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+1977933, int_stack+1971885, int_stack+1963461, 36);
 /*--- compute (k0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+1958169, int_stack+171841, int_stack+170221, 36);
 /*--- compute (k0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+1985493, int_stack+1958169, int_stack+1967997, 36);
 /*--- compute (k0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+2037591, int_stack+1985493, int_stack+1971885, 36);
 /*--- compute (k0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+1963029, int_stack+2037591, int_stack+1977933, 36);
 /*--- compute (k0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+1974369, int_stack+173821, int_stack+171841, 36);
 /*--- compute (k0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+2047671, int_stack+1974369, int_stack+1958169, 36);
 /*--- compute (k0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+2057391, int_stack+2047671, int_stack+1985493, 36);
 /*--- compute (k0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+1974369, int_stack+2057391, int_stack+2037591, 36);
 /*--- compute (k0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+2037591, int_stack+1974369, int_stack+1963029, 36);
 /*--- compute (ip||hh) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+2053467, int_stack+2037591, int_stack+1997460, 441);
 /*--- compute (hd||hh) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+2090511, int_stack+2053467, int_stack+2009808, 441);
 /*--- compute (l0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+2146077, int_stack+177142, int_stack+176197, 45);
 /*--- compute (l0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+2148912, int_stack+178402, int_stack+177142, 45);
 /*--- compute (l0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+2152692, int_stack+2148912, int_stack+2146077, 45);
 /*--- compute (l0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+2158362, int_stack+180022, int_stack+178402, 45);
 /*--- compute (l0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+2163222, int_stack+2158362, int_stack+2148912, 45);
 /*--- compute (l0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+2170782, int_stack+2163222, int_stack+2152692, 45);
 /*--- compute (l0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+2146077, int_stack+182047, int_stack+180022, 45);
 /*--- compute (l0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+2180232, int_stack+2146077, int_stack+2158362, 45);
 /*--- compute (l0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+2189952, int_stack+2180232, int_stack+2163222, 45);
 /*--- compute (l0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+2152152, int_stack+2189952, int_stack+2170782, 45);
 /*--- compute (l0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+2166327, int_stack+184522, int_stack+182047, 45);
 /*--- compute (l0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+2202552, int_stack+2166327, int_stack+2146077, 45);
 /*--- compute (l0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+2214702, int_stack+2202552, int_stack+2180232, 45);
 /*--- compute (l0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+2166327, int_stack+2214702, int_stack+2189952, 45);
 /*--- compute (l0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+2185227, int_stack+2166327, int_stack+2152152, 45);
 /*--- compute (kp||hh) ---*/
   hrr1_build_kp(Libr12->ShellQuartet.AB,int_stack+2205072, int_stack+2185227, int_stack+2037591, 441);
 /*--- compute (id||hh) ---*/
   hrr1_build_id(Libr12->ShellQuartet.AB,int_stack+2252700, int_stack+2205072, int_stack+2053467, 441);
 /*--- compute (hf||hh) ---*/
   hrr1_build_hf(Libr12->ShellQuartet.AB,int_stack+2326788, int_stack+2252700, int_stack+2090511, 441);
 /*--- compute (m0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+2419398, int_stack+188647, int_stack+187492, 55);
 /*--- compute (m0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+2422863, int_stack+190187, int_stack+188647, 55);
 /*--- compute (m0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+2427483, int_stack+2422863, int_stack+2419398, 55);
 /*--- compute (m0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+2434413, int_stack+192167, int_stack+190187, 55);
 /*--- compute (m0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+2440353, int_stack+2434413, int_stack+2422863, 55);
 /*--- compute (m0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+2449593, int_stack+2440353, int_stack+2427483, 55);
 /*--- compute (m0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+2419398, int_stack+194642, int_stack+192167, 55);
 /*--- compute (m0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+2461143, int_stack+2419398, int_stack+2434413, 55);
 /*--- compute (m0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+2473023, int_stack+2461143, int_stack+2440353, 55);
 /*--- compute (m0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+2426823, int_stack+2473023, int_stack+2449593, 55);
 /*--- compute (m0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+2444148, int_stack+197667, int_stack+194642, 55);
 /*--- compute (m0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+2488423, int_stack+2444148, int_stack+2419398, 55);
 /*--- compute (m0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+2503273, int_stack+2488423, int_stack+2461143, 55);
 /*--- compute (m0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+2444148, int_stack+2503273, int_stack+2473023, 55);
 /*--- compute (m0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+2467248, int_stack+2444148, int_stack+2426823, 55);
 /*--- compute (lp||hh) ---*/
   hrr1_build_lp(Libr12->ShellQuartet.AB,int_stack+1958169, int_stack+2467248, int_stack+2185227, 441);
 /*--- compute (kd||hh) ---*/
   hrr1_build_kd(Libr12->ShellQuartet.AB,int_stack+2017704, int_stack+1958169, int_stack+2205072, 441);
 /*--- compute (if||hh) ---*/
   hrr1_build_if(Libr12->ShellQuartet.AB,int_stack+2112960, int_stack+2017704, int_stack+2252700, 441);
 /*--- compute (hg||hh) ---*/
   hrr1_build_hg(Libr12->ShellQuartet.AB,int_stack+1073022, int_stack+2112960, int_stack+2326788, 441);
 /*--- compute (n0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+2491503, int_stack+202683, int_stack+201297, 66);
 /*--- compute (n0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+2495661, int_stack+204531, int_stack+202683, 66);
 /*--- compute (n0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+2501205, int_stack+2495661, int_stack+2491503, 66);
 /*--- compute (n0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+2509521, int_stack+206907, int_stack+204531, 66);
 /*--- compute (n0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+2516649, int_stack+2509521, int_stack+2495661, 66);
 /*--- compute (n0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+2527737, int_stack+2516649, int_stack+2501205, 66);
 /*--- compute (n0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+2491503, int_stack+209877, int_stack+206907, 66);
 /*--- compute (n0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+2236440, int_stack+2491503, int_stack+2509521, 66);
 /*--- compute (n0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+2250696, int_stack+2236440, int_stack+2516649, 66);
 /*--- compute (n0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+2500413, int_stack+2250696, int_stack+2527737, 66);
 /*--- compute (n0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+2521203, int_stack+213507, int_stack+209877, 66);
 /*--- compute (n0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+2269176, int_stack+2521203, int_stack+2491503, 66);
 /*--- compute (n0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+2521203, int_stack+2269176, int_stack+2236440, 66);
 /*--- compute (n0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+2269176, int_stack+2521203, int_stack+2250696, 66);
 /*--- compute (n0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+2236440, int_stack+2269176, int_stack+2500413, 66);
 /*--- compute (mp||hh) ---*/
   hrr1_build_mp(Libr12->ShellQuartet.AB,int_stack+2265546, int_stack+2236440, int_stack+2467248, 441);
 /*--- compute (ld||hh) ---*/
   hrr1_build_ld(Libr12->ShellQuartet.AB,int_stack+2338311, int_stack+2265546, int_stack+1958169, 441);
 /*--- compute (kf||hh) ---*/
   hrr1_build_kf(Libr12->ShellQuartet.AB,int_stack+1211937, int_stack+2338311, int_stack+2017704, 441);
 /*--- compute (ig||hh) ---*/
   hrr1_build_ig(Libr12->ShellQuartet.AB,int_stack+2236440, int_stack+1211937, int_stack+2112960, 441);
 /*--- compute (hh|[r12,T2]|hh) ---*/
   hrr1_build_hh(Libr12->ShellQuartet.AB,int_stack+1211937, int_stack+1634034, int_stack+748887, 441);
     Libr12->te_ptr[3] = int_stack + 1211937;
 /*--- compute (hh|[r12,T1]|hh) ---*/
   t1hrr1_build_hh(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+1406418, int_stack+887802, int_stack+498175, int_stack+3009219, int_stack+2546169, int_stack+1819254, 5, 5);
     Libr12->te_ptr[2] = int_stack + 1406418;
 /*--- compute (hh||hh) ---*/
   hrr1_build_hh(Libr12->ShellQuartet.AB,int_stack+1600899, int_stack+2236440, int_stack+1073022, 441);
     Libr12->te_ptr[1] = int_stack + 1600899;
 /*--- compute (hh|hh) ---*/
   hrr1_build_hh(Libr12->ShellQuartet.AB,int_stack+1958169, int_stack+3009219, int_stack+1819254, 441);
     Libr12->te_ptr[0] = int_stack + 1958169;

}
