/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ds||is) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _r_build_d0i0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE oneo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[0] - U10*I3[0] + loo2p*I2[0]
        + (oneo2z)*I1[0] - (oneo4zn)*I4[0] - (sixo4zn)*I5[0];
*(vp++) = U00*I0[1] - U10*I3[1] + loo2p*I2[1]
        + (oneo2z)*I1[1] - (oneo4zn)*I4[1] - (fiveo4zn)*I5[1];
*(vp++) = U00*I0[2] - U10*I3[2] + loo2p*I2[2]
        + (oneo2z)*I1[2] - (oneo4zn)*I4[2] - (fiveo4zn)*I5[2];
*(vp++) = U00*I0[3] - U10*I3[3] + loo2p*I2[3]
        + (oneo2z)*I1[3] - (oneo4zn)*I4[3] - (fouro4zn)*I5[3];
*(vp++) = U00*I0[4] - U10*I3[4] + loo2p*I2[4]
        + (oneo2z)*I1[4] - (oneo4zn)*I4[4] - (fouro4zn)*I5[4];
*(vp++) = U00*I0[5] - U10*I3[5] + loo2p*I2[5]
        + (oneo2z)*I1[5] - (oneo4zn)*I4[5] - (fouro4zn)*I5[5];
*(vp++) = U00*I0[6] - U10*I3[6] + loo2p*I2[6]
        + (oneo2z)*I1[6] - (oneo4zn)*I4[6] - (threeo4zn)*I5[6];
*(vp++) = U00*I0[7] - U10*I3[7] + loo2p*I2[7]
        + (oneo2z)*I1[7] - (oneo4zn)*I4[7] - (threeo4zn)*I5[7];
*(vp++) = U00*I0[8] - U10*I3[8] + loo2p*I2[8]
        + (oneo2z)*I1[8] - (oneo4zn)*I4[8] - (threeo4zn)*I5[8];
*(vp++) = U00*I0[9] - U10*I3[9] + loo2p*I2[9]
        + (oneo2z)*I1[9] - (oneo4zn)*I4[9] - (threeo4zn)*I5[9];
*(vp++) = U00*I0[10] - U10*I3[10] + loo2p*I2[10]
        + (oneo2z)*I1[10] - (oneo4zn)*I4[10] - (twoo4zn)*I5[10];
*(vp++) = U00*I0[11] - U10*I3[11] + loo2p*I2[11]
        + (oneo2z)*I1[11] - (oneo4zn)*I4[11] - (twoo4zn)*I5[11];
*(vp++) = U00*I0[12] - U10*I3[12] + loo2p*I2[12]
        + (oneo2z)*I1[12] - (oneo4zn)*I4[12] - (twoo4zn)*I5[12];
*(vp++) = U00*I0[13] - U10*I3[13] + loo2p*I2[13]
        + (oneo2z)*I1[13] - (oneo4zn)*I4[13] - (twoo4zn)*I5[13];
*(vp++) = U00*I0[14] - U10*I3[14] + loo2p*I2[14]
        + (oneo2z)*I1[14] - (oneo4zn)*I4[14] - (twoo4zn)*I5[14];
*(vp++) = U00*I0[15] - U10*I3[15] + loo2p*I2[15]
        + (oneo2z)*I1[15] - (oneo4zn)*I4[15] - (oneo4zn)*I5[15];
*(vp++) = U00*I0[16] - U10*I3[16] + loo2p*I2[16]
        + (oneo2z)*I1[16] - (oneo4zn)*I4[16] - (oneo4zn)*I5[16];
*(vp++) = U00*I0[17] - U10*I3[17] + loo2p*I2[17]
        + (oneo2z)*I1[17] - (oneo4zn)*I4[17] - (oneo4zn)*I5[17];
*(vp++) = U00*I0[18] - U10*I3[18] + loo2p*I2[18]
        + (oneo2z)*I1[18] - (oneo4zn)*I4[18] - (oneo4zn)*I5[18];
*(vp++) = U00*I0[19] - U10*I3[19] + loo2p*I2[19]
        + (oneo2z)*I1[19] - (oneo4zn)*I4[19] - (oneo4zn)*I5[19];
*(vp++) = U00*I0[20] - U10*I3[20] + loo2p*I2[20]
        + (oneo2z)*I1[20] - (oneo4zn)*I4[20] - (oneo4zn)*I5[20];
*(vp++) = U00*I0[21] - U10*I3[21] + loo2p*I2[21]
        + (oneo2z)*I1[21] - (oneo4zn)*I4[21];
*(vp++) = U00*I0[22] - U10*I3[22] + loo2p*I2[22]
        + (oneo2z)*I1[22] - (oneo4zn)*I4[22];
*(vp++) = U00*I0[23] - U10*I3[23] + loo2p*I2[23]
        + (oneo2z)*I1[23] - (oneo4zn)*I4[23];
*(vp++) = U00*I0[24] - U10*I3[24] + loo2p*I2[24]
        + (oneo2z)*I1[24] - (oneo4zn)*I4[24];
*(vp++) = U00*I0[25] - U10*I3[25] + loo2p*I2[25]
        + (oneo2z)*I1[25] - (oneo4zn)*I4[25];
*(vp++) = U00*I0[26] - U10*I3[26] + loo2p*I2[26]
        + (oneo2z)*I1[26] - (oneo4zn)*I4[26];
*(vp++) = U00*I0[27] - U10*I3[27] + loo2p*I2[27]
        + (oneo2z)*I1[27] - (oneo4zn)*I4[27];
*(vp++) = U00*I0[28] - U10*I3[28] + loo2p*I2[28] - (sixo4zn)*I5[21];
*(vp++) = U00*I0[29] - U10*I3[29] + loo2p*I2[29] - (fiveo4zn)*I5[22];
*(vp++) = U00*I0[30] - U10*I3[30] + loo2p*I2[30] - (fiveo4zn)*I5[23];
*(vp++) = U00*I0[31] - U10*I3[31] + loo2p*I2[31] - (fouro4zn)*I5[24];
*(vp++) = U00*I0[32] - U10*I3[32] + loo2p*I2[32] - (fouro4zn)*I5[25];
*(vp++) = U00*I0[33] - U10*I3[33] + loo2p*I2[33] - (fouro4zn)*I5[26];
*(vp++) = U00*I0[34] - U10*I3[34] + loo2p*I2[34] - (threeo4zn)*I5[27];
*(vp++) = U00*I0[35] - U10*I3[35] + loo2p*I2[35] - (threeo4zn)*I5[28];
*(vp++) = U00*I0[36] - U10*I3[36] + loo2p*I2[36] - (threeo4zn)*I5[29];
*(vp++) = U00*I0[37] - U10*I3[37] + loo2p*I2[37] - (threeo4zn)*I5[30];
*(vp++) = U00*I0[38] - U10*I3[38] + loo2p*I2[38] - (twoo4zn)*I5[31];
*(vp++) = U00*I0[39] - U10*I3[39] + loo2p*I2[39] - (twoo4zn)*I5[32];
*(vp++) = U00*I0[40] - U10*I3[40] + loo2p*I2[40] - (twoo4zn)*I5[33];
*(vp++) = U00*I0[41] - U10*I3[41] + loo2p*I2[41] - (twoo4zn)*I5[34];
*(vp++) = U00*I0[42] - U10*I3[42] + loo2p*I2[42] - (twoo4zn)*I5[35];
*(vp++) = U00*I0[43] - U10*I3[43] + loo2p*I2[43] - (oneo4zn)*I5[36];
*(vp++) = U00*I0[44] - U10*I3[44] + loo2p*I2[44] - (oneo4zn)*I5[37];
*(vp++) = U00*I0[45] - U10*I3[45] + loo2p*I2[45] - (oneo4zn)*I5[38];
*(vp++) = U00*I0[46] - U10*I3[46] + loo2p*I2[46] - (oneo4zn)*I5[39];
*(vp++) = U00*I0[47] - U10*I3[47] + loo2p*I2[47] - (oneo4zn)*I5[40];
*(vp++) = U00*I0[48] - U10*I3[48] + loo2p*I2[48] - (oneo4zn)*I5[41];
*(vp++) = U00*I0[49] - U10*I3[49] + loo2p*I2[49];
*(vp++) = U00*I0[50] - U10*I3[50] + loo2p*I2[50];
*(vp++) = U00*I0[51] - U10*I3[51] + loo2p*I2[51];
*(vp++) = U00*I0[52] - U10*I3[52] + loo2p*I2[52];
*(vp++) = U00*I0[53] - U10*I3[53] + loo2p*I2[53];
*(vp++) = U00*I0[54] - U10*I3[54] + loo2p*I2[54];
*(vp++) = U00*I0[55] - U10*I3[55] + loo2p*I2[55];
*(vp++) = U00*I0[56] - U10*I3[56] + loo2p*I2[56] - (sixo4zn)*I5[42];
*(vp++) = U00*I0[57] - U10*I3[57] + loo2p*I2[57] - (fiveo4zn)*I5[43];
*(vp++) = U00*I0[58] - U10*I3[58] + loo2p*I2[58] - (fiveo4zn)*I5[44];
*(vp++) = U00*I0[59] - U10*I3[59] + loo2p*I2[59] - (fouro4zn)*I5[45];
*(vp++) = U00*I0[60] - U10*I3[60] + loo2p*I2[60] - (fouro4zn)*I5[46];
*(vp++) = U00*I0[61] - U10*I3[61] + loo2p*I2[61] - (fouro4zn)*I5[47];
*(vp++) = U00*I0[62] - U10*I3[62] + loo2p*I2[62] - (threeo4zn)*I5[48];
*(vp++) = U00*I0[63] - U10*I3[63] + loo2p*I2[63] - (threeo4zn)*I5[49];
*(vp++) = U00*I0[64] - U10*I3[64] + loo2p*I2[64] - (threeo4zn)*I5[50];
*(vp++) = U00*I0[65] - U10*I3[65] + loo2p*I2[65] - (threeo4zn)*I5[51];
*(vp++) = U00*I0[66] - U10*I3[66] + loo2p*I2[66] - (twoo4zn)*I5[52];
*(vp++) = U00*I0[67] - U10*I3[67] + loo2p*I2[67] - (twoo4zn)*I5[53];
*(vp++) = U00*I0[68] - U10*I3[68] + loo2p*I2[68] - (twoo4zn)*I5[54];
*(vp++) = U00*I0[69] - U10*I3[69] + loo2p*I2[69] - (twoo4zn)*I5[55];
*(vp++) = U00*I0[70] - U10*I3[70] + loo2p*I2[70] - (twoo4zn)*I5[56];
*(vp++) = U00*I0[71] - U10*I3[71] + loo2p*I2[71] - (oneo4zn)*I5[57];
*(vp++) = U00*I0[72] - U10*I3[72] + loo2p*I2[72] - (oneo4zn)*I5[58];
*(vp++) = U00*I0[73] - U10*I3[73] + loo2p*I2[73] - (oneo4zn)*I5[59];
*(vp++) = U00*I0[74] - U10*I3[74] + loo2p*I2[74] - (oneo4zn)*I5[60];
*(vp++) = U00*I0[75] - U10*I3[75] + loo2p*I2[75] - (oneo4zn)*I5[61];
*(vp++) = U00*I0[76] - U10*I3[76] + loo2p*I2[76] - (oneo4zn)*I5[62];
*(vp++) = U00*I0[77] - U10*I3[77] + loo2p*I2[77];
*(vp++) = U00*I0[78] - U10*I3[78] + loo2p*I2[78];
*(vp++) = U00*I0[79] - U10*I3[79] + loo2p*I2[79];
*(vp++) = U00*I0[80] - U10*I3[80] + loo2p*I2[80];
*(vp++) = U00*I0[81] - U10*I3[81] + loo2p*I2[81];
*(vp++) = U00*I0[82] - U10*I3[82] + loo2p*I2[82];
*(vp++) = U00*I0[83] - U10*I3[83] + loo2p*I2[83];
*(vp++) = U01*I0[28] - U11*I3[28] + loo2p*I2[84]
        + (oneo2z)*I1[0] - (oneo4zn)*I4[0];
*(vp++) = U01*I0[29] - U11*I3[29] + loo2p*I2[85]
        + (oneo2z)*I1[1] - (oneo4zn)*I4[1] - (oneo4zn)*I5[21];
*(vp++) = U01*I0[30] - U11*I3[30] + loo2p*I2[86]
        + (oneo2z)*I1[2] - (oneo4zn)*I4[2];
*(vp++) = U01*I0[31] - U11*I3[31] + loo2p*I2[87]
        + (oneo2z)*I1[3] - (oneo4zn)*I4[3] - (twoo4zn)*I5[22];
*(vp++) = U01*I0[32] - U11*I3[32] + loo2p*I2[88]
        + (oneo2z)*I1[4] - (oneo4zn)*I4[4] - (oneo4zn)*I5[23];
*(vp++) = U01*I0[33] - U11*I3[33] + loo2p*I2[89]
        + (oneo2z)*I1[5] - (oneo4zn)*I4[5];
*(vp++) = U01*I0[34] - U11*I3[34] + loo2p*I2[90]
        + (oneo2z)*I1[6] - (oneo4zn)*I4[6] - (threeo4zn)*I5[24];
*(vp++) = U01*I0[35] - U11*I3[35] + loo2p*I2[91]
        + (oneo2z)*I1[7] - (oneo4zn)*I4[7] - (twoo4zn)*I5[25];
*(vp++) = U01*I0[36] - U11*I3[36] + loo2p*I2[92]
        + (oneo2z)*I1[8] - (oneo4zn)*I4[8] - (oneo4zn)*I5[26];
*(vp++) = U01*I0[37] - U11*I3[37] + loo2p*I2[93]
        + (oneo2z)*I1[9] - (oneo4zn)*I4[9];
*(vp++) = U01*I0[38] - U11*I3[38] + loo2p*I2[94]
        + (oneo2z)*I1[10] - (oneo4zn)*I4[10] - (fouro4zn)*I5[27];
*(vp++) = U01*I0[39] - U11*I3[39] + loo2p*I2[95]
        + (oneo2z)*I1[11] - (oneo4zn)*I4[11] - (threeo4zn)*I5[28];
*(vp++) = U01*I0[40] - U11*I3[40] + loo2p*I2[96]
        + (oneo2z)*I1[12] - (oneo4zn)*I4[12] - (twoo4zn)*I5[29];
*(vp++) = U01*I0[41] - U11*I3[41] + loo2p*I2[97]
        + (oneo2z)*I1[13] - (oneo4zn)*I4[13] - (oneo4zn)*I5[30];
*(vp++) = U01*I0[42] - U11*I3[42] + loo2p*I2[98]
        + (oneo2z)*I1[14] - (oneo4zn)*I4[14];
*(vp++) = U01*I0[43] - U11*I3[43] + loo2p*I2[99]
        + (oneo2z)*I1[15] - (oneo4zn)*I4[15] - (fiveo4zn)*I5[31];
*(vp++) = U01*I0[44] - U11*I3[44] + loo2p*I2[100]
        + (oneo2z)*I1[16] - (oneo4zn)*I4[16] - (fouro4zn)*I5[32];
*(vp++) = U01*I0[45] - U11*I3[45] + loo2p*I2[101]
        + (oneo2z)*I1[17] - (oneo4zn)*I4[17] - (threeo4zn)*I5[33];
*(vp++) = U01*I0[46] - U11*I3[46] + loo2p*I2[102]
        + (oneo2z)*I1[18] - (oneo4zn)*I4[18] - (twoo4zn)*I5[34];
*(vp++) = U01*I0[47] - U11*I3[47] + loo2p*I2[103]
        + (oneo2z)*I1[19] - (oneo4zn)*I4[19] - (oneo4zn)*I5[35];
*(vp++) = U01*I0[48] - U11*I3[48] + loo2p*I2[104]
        + (oneo2z)*I1[20] - (oneo4zn)*I4[20];
*(vp++) = U01*I0[49] - U11*I3[49] + loo2p*I2[105]
        + (oneo2z)*I1[21] - (oneo4zn)*I4[21] - (sixo4zn)*I5[36];
*(vp++) = U01*I0[50] - U11*I3[50] + loo2p*I2[106]
        + (oneo2z)*I1[22] - (oneo4zn)*I4[22] - (fiveo4zn)*I5[37];
*(vp++) = U01*I0[51] - U11*I3[51] + loo2p*I2[107]
        + (oneo2z)*I1[23] - (oneo4zn)*I4[23] - (fouro4zn)*I5[38];
*(vp++) = U01*I0[52] - U11*I3[52] + loo2p*I2[108]
        + (oneo2z)*I1[24] - (oneo4zn)*I4[24] - (threeo4zn)*I5[39];
*(vp++) = U01*I0[53] - U11*I3[53] + loo2p*I2[109]
        + (oneo2z)*I1[25] - (oneo4zn)*I4[25] - (twoo4zn)*I5[40];
*(vp++) = U01*I0[54] - U11*I3[54] + loo2p*I2[110]
        + (oneo2z)*I1[26] - (oneo4zn)*I4[26] - (oneo4zn)*I5[41];
*(vp++) = U01*I0[55] - U11*I3[55] + loo2p*I2[111]
        + (oneo2z)*I1[27] - (oneo4zn)*I4[27];
*(vp++) = U01*I0[56] - U11*I3[56] + loo2p*I2[112];
*(vp++) = U01*I0[57] - U11*I3[57] + loo2p*I2[113] - (oneo4zn)*I5[42];
*(vp++) = U01*I0[58] - U11*I3[58] + loo2p*I2[114];
*(vp++) = U01*I0[59] - U11*I3[59] + loo2p*I2[115] - (twoo4zn)*I5[43];
*(vp++) = U01*I0[60] - U11*I3[60] + loo2p*I2[116] - (oneo4zn)*I5[44];
*(vp++) = U01*I0[61] - U11*I3[61] + loo2p*I2[117];
*(vp++) = U01*I0[62] - U11*I3[62] + loo2p*I2[118] - (threeo4zn)*I5[45];
*(vp++) = U01*I0[63] - U11*I3[63] + loo2p*I2[119] - (twoo4zn)*I5[46];
*(vp++) = U01*I0[64] - U11*I3[64] + loo2p*I2[120] - (oneo4zn)*I5[47];
*(vp++) = U01*I0[65] - U11*I3[65] + loo2p*I2[121];
*(vp++) = U01*I0[66] - U11*I3[66] + loo2p*I2[122] - (fouro4zn)*I5[48];
*(vp++) = U01*I0[67] - U11*I3[67] + loo2p*I2[123] - (threeo4zn)*I5[49];
*(vp++) = U01*I0[68] - U11*I3[68] + loo2p*I2[124] - (twoo4zn)*I5[50];
*(vp++) = U01*I0[69] - U11*I3[69] + loo2p*I2[125] - (oneo4zn)*I5[51];
*(vp++) = U01*I0[70] - U11*I3[70] + loo2p*I2[126];
*(vp++) = U01*I0[71] - U11*I3[71] + loo2p*I2[127] - (fiveo4zn)*I5[52];
*(vp++) = U01*I0[72] - U11*I3[72] + loo2p*I2[128] - (fouro4zn)*I5[53];
*(vp++) = U01*I0[73] - U11*I3[73] + loo2p*I2[129] - (threeo4zn)*I5[54];
*(vp++) = U01*I0[74] - U11*I3[74] + loo2p*I2[130] - (twoo4zn)*I5[55];
*(vp++) = U01*I0[75] - U11*I3[75] + loo2p*I2[131] - (oneo4zn)*I5[56];
*(vp++) = U01*I0[76] - U11*I3[76] + loo2p*I2[132];
*(vp++) = U01*I0[77] - U11*I3[77] + loo2p*I2[133] - (sixo4zn)*I5[57];
*(vp++) = U01*I0[78] - U11*I3[78] + loo2p*I2[134] - (fiveo4zn)*I5[58];
*(vp++) = U01*I0[79] - U11*I3[79] + loo2p*I2[135] - (fouro4zn)*I5[59];
*(vp++) = U01*I0[80] - U11*I3[80] + loo2p*I2[136] - (threeo4zn)*I5[60];
*(vp++) = U01*I0[81] - U11*I3[81] + loo2p*I2[137] - (twoo4zn)*I5[61];
*(vp++) = U01*I0[82] - U11*I3[82] + loo2p*I2[138] - (oneo4zn)*I5[62];
*(vp++) = U01*I0[83] - U11*I3[83] + loo2p*I2[139];
*(vp++) = U02*I0[56] - U12*I3[56] + loo2p*I2[140]
        + (oneo2z)*I1[0] - (oneo4zn)*I4[0];
*(vp++) = U02*I0[57] - U12*I3[57] + loo2p*I2[141]
        + (oneo2z)*I1[1] - (oneo4zn)*I4[1];
*(vp++) = U02*I0[58] - U12*I3[58] + loo2p*I2[142]
        + (oneo2z)*I1[2] - (oneo4zn)*I4[2] - (oneo4zn)*I5[42];
*(vp++) = U02*I0[59] - U12*I3[59] + loo2p*I2[143]
        + (oneo2z)*I1[3] - (oneo4zn)*I4[3];
*(vp++) = U02*I0[60] - U12*I3[60] + loo2p*I2[144]
        + (oneo2z)*I1[4] - (oneo4zn)*I4[4] - (oneo4zn)*I5[43];
*(vp++) = U02*I0[61] - U12*I3[61] + loo2p*I2[145]
        + (oneo2z)*I1[5] - (oneo4zn)*I4[5] - (twoo4zn)*I5[44];
*(vp++) = U02*I0[62] - U12*I3[62] + loo2p*I2[146]
        + (oneo2z)*I1[6] - (oneo4zn)*I4[6];
*(vp++) = U02*I0[63] - U12*I3[63] + loo2p*I2[147]
        + (oneo2z)*I1[7] - (oneo4zn)*I4[7] - (oneo4zn)*I5[45];
*(vp++) = U02*I0[64] - U12*I3[64] + loo2p*I2[148]
        + (oneo2z)*I1[8] - (oneo4zn)*I4[8] - (twoo4zn)*I5[46];
*(vp++) = U02*I0[65] - U12*I3[65] + loo2p*I2[149]
        + (oneo2z)*I1[9] - (oneo4zn)*I4[9] - (threeo4zn)*I5[47];
*(vp++) = U02*I0[66] - U12*I3[66] + loo2p*I2[150]
        + (oneo2z)*I1[10] - (oneo4zn)*I4[10];
*(vp++) = U02*I0[67] - U12*I3[67] + loo2p*I2[151]
        + (oneo2z)*I1[11] - (oneo4zn)*I4[11] - (oneo4zn)*I5[48];
*(vp++) = U02*I0[68] - U12*I3[68] + loo2p*I2[152]
        + (oneo2z)*I1[12] - (oneo4zn)*I4[12] - (twoo4zn)*I5[49];
*(vp++) = U02*I0[69] - U12*I3[69] + loo2p*I2[153]
        + (oneo2z)*I1[13] - (oneo4zn)*I4[13] - (threeo4zn)*I5[50];
*(vp++) = U02*I0[70] - U12*I3[70] + loo2p*I2[154]
        + (oneo2z)*I1[14] - (oneo4zn)*I4[14] - (fouro4zn)*I5[51];
*(vp++) = U02*I0[71] - U12*I3[71] + loo2p*I2[155]
        + (oneo2z)*I1[15] - (oneo4zn)*I4[15];
*(vp++) = U02*I0[72] - U12*I3[72] + loo2p*I2[156]
        + (oneo2z)*I1[16] - (oneo4zn)*I4[16] - (oneo4zn)*I5[52];
*(vp++) = U02*I0[73] - U12*I3[73] + loo2p*I2[157]
        + (oneo2z)*I1[17] - (oneo4zn)*I4[17] - (twoo4zn)*I5[53];
*(vp++) = U02*I0[74] - U12*I3[74] + loo2p*I2[158]
        + (oneo2z)*I1[18] - (oneo4zn)*I4[18] - (threeo4zn)*I5[54];
*(vp++) = U02*I0[75] - U12*I3[75] + loo2p*I2[159]
        + (oneo2z)*I1[19] - (oneo4zn)*I4[19] - (fouro4zn)*I5[55];
*(vp++) = U02*I0[76] - U12*I3[76] + loo2p*I2[160]
        + (oneo2z)*I1[20] - (oneo4zn)*I4[20] - (fiveo4zn)*I5[56];
*(vp++) = U02*I0[77] - U12*I3[77] + loo2p*I2[161]
        + (oneo2z)*I1[21] - (oneo4zn)*I4[21];
*(vp++) = U02*I0[78] - U12*I3[78] + loo2p*I2[162]
        + (oneo2z)*I1[22] - (oneo4zn)*I4[22] - (oneo4zn)*I5[57];
*(vp++) = U02*I0[79] - U12*I3[79] + loo2p*I2[163]
        + (oneo2z)*I1[23] - (oneo4zn)*I4[23] - (twoo4zn)*I5[58];
*(vp++) = U02*I0[80] - U12*I3[80] + loo2p*I2[164]
        + (oneo2z)*I1[24] - (oneo4zn)*I4[24] - (threeo4zn)*I5[59];
*(vp++) = U02*I0[81] - U12*I3[81] + loo2p*I2[165]
        + (oneo2z)*I1[25] - (oneo4zn)*I4[25] - (fouro4zn)*I5[60];
*(vp++) = U02*I0[82] - U12*I3[82] + loo2p*I2[166]
        + (oneo2z)*I1[26] - (oneo4zn)*I4[26] - (fiveo4zn)*I5[61];
*(vp++) = U02*I0[83] - U12*I3[83] + loo2p*I2[167]
        + (oneo2z)*I1[27] - (oneo4zn)*I4[27] - (sixo4zn)*I5[62];

}
