/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_00hh(Libderiv_t *, prim_data *);

  /* Computes derivatives of (00|hh) integrals */

void d12hrr_order_00hh(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[0][10][11] = int_stack + 0;
 Libderiv->deriv_classes[0][10][10] = int_stack + 66;
 Libderiv->deriv_classes[0][10][9] = int_stack + 132;
 Libderiv->deriv_classes[0][10][8] = int_stack + 198;
 Libderiv->deriv_classes[0][10][7] = int_stack + 264;
 Libderiv->dvrr_classes[0][9] = int_stack + 330;
 Libderiv->deriv_classes[0][10][6] = int_stack + 385;
 Libderiv->deriv_classes[0][10][2] = int_stack + 451;
 Libderiv->deriv_classes[0][10][1] = int_stack + 517;
 Libderiv->deriv_classes[0][10][0] = int_stack + 583;
 Libderiv->deriv2_classes[0][5][143] = int_stack + 649;
 Libderiv->deriv2_classes[0][6][143] = int_stack + 670;
 Libderiv->deriv2_classes[0][7][143] = int_stack + 698;
 Libderiv->deriv2_classes[0][8][143] = int_stack + 734;
 Libderiv->deriv2_classes[0][9][143] = int_stack + 779;
 Libderiv->deriv2_classes[0][10][143] = int_stack + 834;
 Libderiv->deriv2_classes[0][5][131] = int_stack + 900;
 Libderiv->deriv2_classes[0][6][131] = int_stack + 921;
 Libderiv->deriv2_classes[0][7][131] = int_stack + 949;
 Libderiv->deriv2_classes[0][8][131] = int_stack + 985;
 Libderiv->deriv2_classes[0][9][131] = int_stack + 1030;
 Libderiv->deriv2_classes[0][10][131] = int_stack + 1085;
 Libderiv->deriv2_classes[0][5][130] = int_stack + 1151;
 Libderiv->deriv2_classes[0][6][130] = int_stack + 1172;
 Libderiv->deriv2_classes[0][7][130] = int_stack + 1200;
 Libderiv->deriv2_classes[0][8][130] = int_stack + 1236;
 Libderiv->deriv2_classes[0][9][130] = int_stack + 1281;
 Libderiv->deriv2_classes[0][10][130] = int_stack + 1336;
 Libderiv->deriv2_classes[0][5][119] = int_stack + 1402;
 Libderiv->deriv2_classes[0][6][119] = int_stack + 1423;
 Libderiv->deriv2_classes[0][7][119] = int_stack + 1451;
 Libderiv->deriv2_classes[0][8][119] = int_stack + 1487;
 Libderiv->deriv2_classes[0][9][119] = int_stack + 1532;
 Libderiv->deriv2_classes[0][10][119] = int_stack + 1587;
 Libderiv->deriv2_classes[0][5][118] = int_stack + 1653;
 Libderiv->deriv2_classes[0][6][118] = int_stack + 1674;
 Libderiv->deriv2_classes[0][7][118] = int_stack + 1702;
 Libderiv->deriv2_classes[0][8][118] = int_stack + 1738;
 Libderiv->deriv2_classes[0][9][118] = int_stack + 1783;
 Libderiv->deriv2_classes[0][10][118] = int_stack + 1838;
 Libderiv->deriv2_classes[0][5][117] = int_stack + 1904;
 Libderiv->deriv2_classes[0][6][117] = int_stack + 1925;
 Libderiv->deriv2_classes[0][7][117] = int_stack + 1953;
 Libderiv->deriv2_classes[0][8][117] = int_stack + 1989;
 Libderiv->deriv2_classes[0][9][117] = int_stack + 2034;
 Libderiv->deriv2_classes[0][10][117] = int_stack + 2089;
 Libderiv->deriv2_classes[0][5][107] = int_stack + 2155;
 Libderiv->deriv2_classes[0][6][107] = int_stack + 2176;
 Libderiv->deriv2_classes[0][7][107] = int_stack + 2204;
 Libderiv->deriv2_classes[0][8][107] = int_stack + 2240;
 Libderiv->deriv2_classes[0][9][107] = int_stack + 2285;
 Libderiv->deriv2_classes[0][10][107] = int_stack + 2340;
 Libderiv->deriv2_classes[0][5][106] = int_stack + 2406;
 Libderiv->deriv2_classes[0][6][106] = int_stack + 2427;
 Libderiv->deriv2_classes[0][7][106] = int_stack + 2455;
 Libderiv->deriv2_classes[0][8][106] = int_stack + 2491;
 Libderiv->deriv2_classes[0][9][106] = int_stack + 2536;
 Libderiv->deriv2_classes[0][10][106] = int_stack + 2591;
 Libderiv->deriv2_classes[0][5][105] = int_stack + 2657;
 Libderiv->deriv2_classes[0][6][105] = int_stack + 2678;
 Libderiv->deriv2_classes[0][7][105] = int_stack + 2706;
 Libderiv->deriv2_classes[0][8][105] = int_stack + 2742;
 Libderiv->deriv2_classes[0][9][105] = int_stack + 2787;
 Libderiv->deriv2_classes[0][10][105] = int_stack + 2842;
 Libderiv->deriv2_classes[0][5][104] = int_stack + 2908;
 Libderiv->deriv2_classes[0][6][104] = int_stack + 2929;
 Libderiv->deriv2_classes[0][7][104] = int_stack + 2957;
 Libderiv->deriv2_classes[0][8][104] = int_stack + 2993;
 Libderiv->deriv2_classes[0][9][104] = int_stack + 3038;
 Libderiv->deriv2_classes[0][10][104] = int_stack + 3093;
 Libderiv->deriv2_classes[0][5][95] = int_stack + 3159;
 Libderiv->deriv2_classes[0][6][95] = int_stack + 3180;
 Libderiv->deriv2_classes[0][7][95] = int_stack + 3208;
 Libderiv->deriv2_classes[0][8][95] = int_stack + 3244;
 Libderiv->deriv2_classes[0][9][95] = int_stack + 3289;
 Libderiv->deriv2_classes[0][10][95] = int_stack + 3344;
 Libderiv->deriv2_classes[0][5][94] = int_stack + 3410;
 Libderiv->deriv2_classes[0][6][94] = int_stack + 3431;
 Libderiv->deriv2_classes[0][7][94] = int_stack + 3459;
 Libderiv->deriv2_classes[0][8][94] = int_stack + 3495;
 Libderiv->deriv2_classes[0][9][94] = int_stack + 3540;
 Libderiv->deriv2_classes[0][10][94] = int_stack + 3595;
 Libderiv->deriv2_classes[0][5][93] = int_stack + 3661;
 Libderiv->deriv2_classes[0][6][93] = int_stack + 3682;
 Libderiv->deriv2_classes[0][7][93] = int_stack + 3710;
 Libderiv->deriv2_classes[0][8][93] = int_stack + 3746;
 Libderiv->deriv2_classes[0][9][93] = int_stack + 3791;
 Libderiv->deriv2_classes[0][10][93] = int_stack + 3846;
 Libderiv->deriv2_classes[0][5][92] = int_stack + 3912;
 Libderiv->deriv2_classes[0][6][92] = int_stack + 3933;
 Libderiv->deriv2_classes[0][7][92] = int_stack + 3961;
 Libderiv->deriv2_classes[0][8][92] = int_stack + 3997;
 Libderiv->deriv2_classes[0][9][92] = int_stack + 4042;
 Libderiv->deriv2_classes[0][10][92] = int_stack + 4097;
 Libderiv->deriv2_classes[0][5][91] = int_stack + 4163;
 Libderiv->deriv2_classes[0][6][91] = int_stack + 4184;
 Libderiv->deriv2_classes[0][7][91] = int_stack + 4212;
 Libderiv->deriv2_classes[0][8][91] = int_stack + 4248;
 Libderiv->deriv2_classes[0][9][91] = int_stack + 4293;
 Libderiv->deriv2_classes[0][10][91] = int_stack + 4348;
 Libderiv->deriv_classes[0][5][11] = int_stack + 4414;
 Libderiv->deriv2_classes[0][5][83] = int_stack + 4435;
 Libderiv->deriv_classes[0][6][11] = int_stack + 4456;
 Libderiv->deriv2_classes[0][6][83] = int_stack + 4484;
 Libderiv->deriv_classes[0][7][11] = int_stack + 4512;
 Libderiv->deriv2_classes[0][7][83] = int_stack + 4548;
 Libderiv->deriv_classes[0][8][11] = int_stack + 4584;
 Libderiv->deriv2_classes[0][8][83] = int_stack + 4629;
 Libderiv->deriv_classes[0][9][11] = int_stack + 4674;
 Libderiv->deriv2_classes[0][9][83] = int_stack + 4729;
 Libderiv->deriv2_classes[0][10][83] = int_stack + 4784;
 Libderiv->deriv_classes[0][5][10] = int_stack + 4850;
 Libderiv->deriv2_classes[0][5][82] = int_stack + 4871;
 Libderiv->deriv_classes[0][6][10] = int_stack + 4892;
 Libderiv->deriv2_classes[0][6][82] = int_stack + 4920;
 Libderiv->deriv_classes[0][7][10] = int_stack + 4948;
 Libderiv->deriv2_classes[0][7][82] = int_stack + 4984;
 Libderiv->deriv_classes[0][8][10] = int_stack + 5020;
 Libderiv->deriv2_classes[0][8][82] = int_stack + 5065;
 Libderiv->deriv_classes[0][9][10] = int_stack + 5110;
 Libderiv->deriv2_classes[0][9][82] = int_stack + 5165;
 Libderiv->deriv2_classes[0][10][82] = int_stack + 5220;
 Libderiv->deriv_classes[0][5][9] = int_stack + 5286;
 Libderiv->deriv2_classes[0][5][81] = int_stack + 5307;
 Libderiv->deriv_classes[0][6][9] = int_stack + 5328;
 Libderiv->deriv2_classes[0][6][81] = int_stack + 5356;
 Libderiv->deriv_classes[0][7][9] = int_stack + 5384;
 Libderiv->deriv2_classes[0][7][81] = int_stack + 5420;
 Libderiv->deriv_classes[0][8][9] = int_stack + 5456;
 Libderiv->deriv2_classes[0][8][81] = int_stack + 5501;
 Libderiv->deriv_classes[0][9][9] = int_stack + 5546;
 Libderiv->deriv2_classes[0][9][81] = int_stack + 5601;
 Libderiv->deriv2_classes[0][10][81] = int_stack + 5656;
 Libderiv->deriv_classes[0][5][8] = int_stack + 5722;
 Libderiv->deriv2_classes[0][5][80] = int_stack + 5743;
 Libderiv->deriv_classes[0][6][8] = int_stack + 5764;
 Libderiv->deriv2_classes[0][6][80] = int_stack + 5792;
 Libderiv->deriv_classes[0][7][8] = int_stack + 5820;
 Libderiv->deriv2_classes[0][7][80] = int_stack + 5856;
 Libderiv->deriv_classes[0][8][8] = int_stack + 5892;
 Libderiv->deriv2_classes[0][8][80] = int_stack + 5937;
 Libderiv->deriv_classes[0][9][8] = int_stack + 5982;
 Libderiv->deriv2_classes[0][9][80] = int_stack + 6037;
 Libderiv->deriv2_classes[0][10][80] = int_stack + 6092;
 Libderiv->deriv_classes[0][5][7] = int_stack + 6158;
 Libderiv->deriv2_classes[0][5][79] = int_stack + 6179;
 Libderiv->deriv_classes[0][6][7] = int_stack + 6200;
 Libderiv->deriv2_classes[0][6][79] = int_stack + 6228;
 Libderiv->deriv_classes[0][7][7] = int_stack + 6256;
 Libderiv->deriv2_classes[0][7][79] = int_stack + 6292;
 Libderiv->deriv_classes[0][8][7] = int_stack + 6328;
 Libderiv->deriv2_classes[0][8][79] = int_stack + 6373;
 Libderiv->deriv_classes[0][9][7] = int_stack + 6418;
 Libderiv->deriv2_classes[0][9][79] = int_stack + 6473;
 Libderiv->deriv2_classes[0][10][79] = int_stack + 6528;
 Libderiv->dvrr_classes[0][5] = int_stack + 6594;
 Libderiv->deriv_classes[0][5][6] = int_stack + 6615;
 Libderiv->deriv2_classes[0][5][78] = int_stack + 6636;
 Libderiv->dvrr_classes[0][6] = int_stack + 6657;
 Libderiv->deriv_classes[0][6][6] = int_stack + 6685;
 Libderiv->deriv2_classes[0][6][78] = int_stack + 6713;
 Libderiv->dvrr_classes[0][7] = int_stack + 6741;
 Libderiv->deriv_classes[0][7][6] = int_stack + 6777;
 Libderiv->deriv2_classes[0][7][78] = int_stack + 6813;
 Libderiv->dvrr_classes[0][8] = int_stack + 6849;
 Libderiv->deriv_classes[0][8][6] = int_stack + 6894;
 Libderiv->deriv2_classes[0][8][78] = int_stack + 6939;
 Libderiv->deriv_classes[0][9][6] = int_stack + 6984;
 Libderiv->deriv2_classes[0][9][78] = int_stack + 7039;
 Libderiv->deriv2_classes[0][10][78] = int_stack + 7094;
 Libderiv->deriv2_classes[0][5][35] = int_stack + 7160;
 Libderiv->deriv2_classes[0][6][35] = int_stack + 7181;
 Libderiv->deriv2_classes[0][7][35] = int_stack + 7209;
 Libderiv->deriv2_classes[0][8][35] = int_stack + 7245;
 Libderiv->deriv2_classes[0][9][35] = int_stack + 7290;
 Libderiv->deriv2_classes[0][10][35] = int_stack + 7345;
 Libderiv->deriv2_classes[0][5][34] = int_stack + 7411;
 Libderiv->deriv2_classes[0][6][34] = int_stack + 7432;
 Libderiv->deriv2_classes[0][7][34] = int_stack + 7460;
 Libderiv->deriv2_classes[0][8][34] = int_stack + 7496;
 Libderiv->deriv2_classes[0][9][34] = int_stack + 7541;
 Libderiv->deriv2_classes[0][10][34] = int_stack + 7596;
 Libderiv->deriv2_classes[0][5][33] = int_stack + 7662;
 Libderiv->deriv2_classes[0][6][33] = int_stack + 7683;
 Libderiv->deriv2_classes[0][7][33] = int_stack + 7711;
 Libderiv->deriv2_classes[0][8][33] = int_stack + 7747;
 Libderiv->deriv2_classes[0][9][33] = int_stack + 7792;
 Libderiv->deriv2_classes[0][10][33] = int_stack + 7847;
 Libderiv->deriv2_classes[0][5][32] = int_stack + 7913;
 Libderiv->deriv2_classes[0][6][32] = int_stack + 7934;
 Libderiv->deriv2_classes[0][7][32] = int_stack + 7962;
 Libderiv->deriv2_classes[0][8][32] = int_stack + 7998;
 Libderiv->deriv2_classes[0][9][32] = int_stack + 8043;
 Libderiv->deriv2_classes[0][10][32] = int_stack + 8098;
 Libderiv->deriv2_classes[0][5][31] = int_stack + 8164;
 Libderiv->deriv2_classes[0][6][31] = int_stack + 8185;
 Libderiv->deriv2_classes[0][7][31] = int_stack + 8213;
 Libderiv->deriv2_classes[0][8][31] = int_stack + 8249;
 Libderiv->deriv2_classes[0][9][31] = int_stack + 8294;
 Libderiv->deriv2_classes[0][10][31] = int_stack + 8349;
 Libderiv->deriv_classes[0][5][2] = int_stack + 8415;
 Libderiv->deriv2_classes[0][5][30] = int_stack + 8436;
 Libderiv->deriv_classes[0][6][2] = int_stack + 8457;
 Libderiv->deriv2_classes[0][6][30] = int_stack + 8485;
 Libderiv->deriv_classes[0][7][2] = int_stack + 8513;
 Libderiv->deriv2_classes[0][7][30] = int_stack + 8549;
 Libderiv->deriv_classes[0][8][2] = int_stack + 8585;
 Libderiv->deriv2_classes[0][8][30] = int_stack + 8630;
 Libderiv->deriv_classes[0][9][2] = int_stack + 8675;
 Libderiv->deriv2_classes[0][9][30] = int_stack + 8730;
 Libderiv->deriv2_classes[0][10][30] = int_stack + 8785;
 Libderiv->deriv2_classes[0][5][26] = int_stack + 8851;
 Libderiv->deriv2_classes[0][6][26] = int_stack + 8872;
 Libderiv->deriv2_classes[0][7][26] = int_stack + 8900;
 Libderiv->deriv2_classes[0][8][26] = int_stack + 8936;
 Libderiv->deriv2_classes[0][9][26] = int_stack + 8981;
 Libderiv->deriv2_classes[0][10][26] = int_stack + 9036;
 Libderiv->deriv2_classes[0][5][23] = int_stack + 9102;
 Libderiv->deriv2_classes[0][6][23] = int_stack + 9123;
 Libderiv->deriv2_classes[0][7][23] = int_stack + 9151;
 Libderiv->deriv2_classes[0][8][23] = int_stack + 9187;
 Libderiv->deriv2_classes[0][9][23] = int_stack + 9232;
 Libderiv->deriv2_classes[0][10][23] = int_stack + 9287;
 Libderiv->deriv2_classes[0][5][22] = int_stack + 9353;
 Libderiv->deriv2_classes[0][6][22] = int_stack + 9374;
 Libderiv->deriv2_classes[0][7][22] = int_stack + 9402;
 Libderiv->deriv2_classes[0][8][22] = int_stack + 9438;
 Libderiv->deriv2_classes[0][9][22] = int_stack + 9483;
 Libderiv->deriv2_classes[0][10][22] = int_stack + 9538;
 Libderiv->deriv2_classes[0][5][21] = int_stack + 9604;
 Libderiv->deriv2_classes[0][6][21] = int_stack + 9625;
 Libderiv->deriv2_classes[0][7][21] = int_stack + 9653;
 Libderiv->deriv2_classes[0][8][21] = int_stack + 9689;
 Libderiv->deriv2_classes[0][9][21] = int_stack + 9734;
 Libderiv->deriv2_classes[0][10][21] = int_stack + 9789;
 Libderiv->deriv2_classes[0][5][20] = int_stack + 9855;
 Libderiv->deriv2_classes[0][6][20] = int_stack + 9876;
 Libderiv->deriv2_classes[0][7][20] = int_stack + 9904;
 Libderiv->deriv2_classes[0][8][20] = int_stack + 9940;
 Libderiv->deriv2_classes[0][9][20] = int_stack + 9985;
 Libderiv->deriv2_classes[0][10][20] = int_stack + 10040;
 Libderiv->deriv2_classes[0][5][19] = int_stack + 10106;
 Libderiv->deriv2_classes[0][6][19] = int_stack + 10127;
 Libderiv->deriv2_classes[0][7][19] = int_stack + 10155;
 Libderiv->deriv2_classes[0][8][19] = int_stack + 10191;
 Libderiv->deriv2_classes[0][9][19] = int_stack + 10236;
 Libderiv->deriv2_classes[0][10][19] = int_stack + 10291;
 Libderiv->deriv_classes[0][5][1] = int_stack + 10357;
 Libderiv->deriv2_classes[0][5][18] = int_stack + 10378;
 Libderiv->deriv_classes[0][6][1] = int_stack + 10399;
 Libderiv->deriv2_classes[0][6][18] = int_stack + 10427;
 Libderiv->deriv_classes[0][7][1] = int_stack + 10455;
 Libderiv->deriv2_classes[0][7][18] = int_stack + 10491;
 Libderiv->deriv_classes[0][8][1] = int_stack + 10527;
 Libderiv->deriv2_classes[0][8][18] = int_stack + 10572;
 Libderiv->deriv_classes[0][9][1] = int_stack + 10617;
 Libderiv->deriv2_classes[0][9][18] = int_stack + 10672;
 Libderiv->deriv2_classes[0][10][18] = int_stack + 10727;
 Libderiv->deriv2_classes[0][5][14] = int_stack + 10793;
 Libderiv->deriv2_classes[0][6][14] = int_stack + 10814;
 Libderiv->deriv2_classes[0][7][14] = int_stack + 10842;
 Libderiv->deriv2_classes[0][8][14] = int_stack + 10878;
 Libderiv->deriv2_classes[0][9][14] = int_stack + 10923;
 Libderiv->deriv2_classes[0][10][14] = int_stack + 10978;
 Libderiv->deriv2_classes[0][5][13] = int_stack + 11044;
 Libderiv->deriv2_classes[0][6][13] = int_stack + 11065;
 Libderiv->deriv2_classes[0][7][13] = int_stack + 11093;
 Libderiv->deriv2_classes[0][8][13] = int_stack + 11129;
 Libderiv->deriv2_classes[0][9][13] = int_stack + 11174;
 Libderiv->deriv2_classes[0][10][13] = int_stack + 11229;
 Libderiv->deriv2_classes[0][5][11] = int_stack + 11295;
 Libderiv->deriv2_classes[0][6][11] = int_stack + 11316;
 Libderiv->deriv2_classes[0][7][11] = int_stack + 11344;
 Libderiv->deriv2_classes[0][8][11] = int_stack + 11380;
 Libderiv->deriv2_classes[0][9][11] = int_stack + 11425;
 Libderiv->deriv2_classes[0][10][11] = int_stack + 11480;
 Libderiv->deriv2_classes[0][5][10] = int_stack + 11546;
 Libderiv->deriv2_classes[0][6][10] = int_stack + 11567;
 Libderiv->deriv2_classes[0][7][10] = int_stack + 11595;
 Libderiv->deriv2_classes[0][8][10] = int_stack + 11631;
 Libderiv->deriv2_classes[0][9][10] = int_stack + 11676;
 Libderiv->deriv2_classes[0][10][10] = int_stack + 11731;
 Libderiv->deriv2_classes[0][5][9] = int_stack + 11797;
 Libderiv->deriv2_classes[0][6][9] = int_stack + 11818;
 Libderiv->deriv2_classes[0][7][9] = int_stack + 11846;
 Libderiv->deriv2_classes[0][8][9] = int_stack + 11882;
 Libderiv->deriv2_classes[0][9][9] = int_stack + 11927;
 Libderiv->deriv2_classes[0][10][9] = int_stack + 11982;
 Libderiv->deriv2_classes[0][5][8] = int_stack + 12048;
 Libderiv->deriv2_classes[0][6][8] = int_stack + 12069;
 Libderiv->deriv2_classes[0][7][8] = int_stack + 12097;
 Libderiv->deriv2_classes[0][8][8] = int_stack + 12133;
 Libderiv->deriv2_classes[0][9][8] = int_stack + 12178;
 Libderiv->deriv2_classes[0][10][8] = int_stack + 12233;
 Libderiv->deriv2_classes[0][5][7] = int_stack + 12299;
 Libderiv->deriv2_classes[0][6][7] = int_stack + 12320;
 Libderiv->deriv2_classes[0][7][7] = int_stack + 12348;
 Libderiv->deriv2_classes[0][8][7] = int_stack + 12384;
 Libderiv->deriv2_classes[0][9][7] = int_stack + 12429;
 Libderiv->deriv2_classes[0][10][7] = int_stack + 12484;
 Libderiv->deriv_classes[0][5][0] = int_stack + 12550;
 Libderiv->deriv2_classes[0][5][6] = int_stack + 12571;
 Libderiv->deriv_classes[0][6][0] = int_stack + 12592;
 Libderiv->deriv2_classes[0][6][6] = int_stack + 12620;
 Libderiv->deriv_classes[0][7][0] = int_stack + 12648;
 Libderiv->deriv2_classes[0][7][6] = int_stack + 12684;
 Libderiv->deriv_classes[0][8][0] = int_stack + 12720;
 Libderiv->deriv2_classes[0][8][6] = int_stack + 12765;
 Libderiv->deriv_classes[0][9][0] = int_stack + 12810;
 Libderiv->deriv2_classes[0][9][6] = int_stack + 12865;
 Libderiv->deriv2_classes[0][10][6] = int_stack + 12920;
 Libderiv->deriv2_classes[0][5][2] = int_stack + 12986;
 Libderiv->deriv2_classes[0][6][2] = int_stack + 13007;
 Libderiv->deriv2_classes[0][7][2] = int_stack + 13035;
 Libderiv->deriv2_classes[0][8][2] = int_stack + 13071;
 Libderiv->deriv2_classes[0][9][2] = int_stack + 13116;
 Libderiv->deriv2_classes[0][10][2] = int_stack + 13171;
 Libderiv->deriv2_classes[0][5][1] = int_stack + 13237;
 Libderiv->deriv2_classes[0][6][1] = int_stack + 13258;
 Libderiv->deriv2_classes[0][7][1] = int_stack + 13286;
 Libderiv->deriv2_classes[0][8][1] = int_stack + 13322;
 Libderiv->deriv2_classes[0][9][1] = int_stack + 13367;
 Libderiv->deriv2_classes[0][10][1] = int_stack + 13422;
 Libderiv->deriv2_classes[0][5][0] = int_stack + 13488;
 Libderiv->deriv2_classes[0][6][0] = int_stack + 13509;
 Libderiv->deriv2_classes[0][7][0] = int_stack + 13537;
 Libderiv->deriv2_classes[0][8][0] = int_stack + 13573;
 Libderiv->deriv2_classes[0][9][0] = int_stack + 13618;
 Libderiv->deriv2_classes[0][10][0] = int_stack + 13673;
 memset(int_stack,0,109912);

 Libderiv->dvrr_stack = int_stack + 46869;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_00hh(Libderiv, Data);
   Data++;
 }

 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+13739,int_stack+6657,int_stack+6594,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+13802,int_stack+6741,int_stack+6657,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+13886,int_stack+13802,int_stack+13739,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+14012,int_stack+6849,int_stack+6741,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14120,int_stack+14012,int_stack+13802,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+14288,int_stack+14120,int_stack+13886,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+14498,int_stack+330,int_stack+6849,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+14633,int_stack+14498,int_stack+14012,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+14849,int_stack+14633,int_stack+14120,1);
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+15129,int_stack+14849,int_stack+14288,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15444,int_stack+4456,int_stack+4414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6594,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15507,int_stack+4512,int_stack+4456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6657,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15591,int_stack+15507,int_stack+15444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13739,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15717,int_stack+4584,int_stack+4512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6741,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15825,int_stack+15717,int_stack+15507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13802,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+15993,int_stack+15825,int_stack+15591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13886,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+16203,int_stack+4674,int_stack+4584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6849,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+16338,int_stack+16203,int_stack+15717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14012,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+16554,int_stack+16338,int_stack+15825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14120,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+16834,int_stack+16554,int_stack+15993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14288,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+17149,int_stack+0,int_stack+4674, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+330,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+17314,int_stack+17149,int_stack+16203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14498,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+17584,int_stack+17314,int_stack+16338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14633,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+17149,int_stack+17584,int_stack+16554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14849,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+17569,int_stack+4892,int_stack+4850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6594, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17632,int_stack+4948,int_stack+4892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6657, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+17716,int_stack+17632,int_stack+17569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13739, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+17842,int_stack+5020,int_stack+4948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6741, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17950,int_stack+17842,int_stack+17632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13802, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+18118,int_stack+17950,int_stack+17716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13886, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+18328,int_stack+5110,int_stack+5020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6849, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+18463,int_stack+18328,int_stack+17842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14012, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+18679,int_stack+18463,int_stack+17950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14120, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+18959,int_stack+18679,int_stack+18118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14288, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+19274,int_stack+66,int_stack+5110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+330, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+19439,int_stack+19274,int_stack+18328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14498, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+19709,int_stack+19439,int_stack+18463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14633, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+19274,int_stack+19709,int_stack+18679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14849, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19694,int_stack+5328,int_stack+5286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6594, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19757,int_stack+5384,int_stack+5328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6657, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+19841,int_stack+19757,int_stack+19694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13739, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+19967,int_stack+5456,int_stack+5384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6741, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+20075,int_stack+19967,int_stack+19757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13802, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+20243,int_stack+20075,int_stack+19841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13886, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+20453,int_stack+5546,int_stack+5456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6849, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+20588,int_stack+20453,int_stack+19967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14012, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+20804,int_stack+20588,int_stack+20075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14120, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21084,int_stack+20804,int_stack+20243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14288, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+21399,int_stack+132,int_stack+5546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+330, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+21564,int_stack+21399,int_stack+20453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14498, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+21834,int_stack+21564,int_stack+20588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14633, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+21399,int_stack+21834,int_stack+20804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14849, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21819,int_stack+5764,int_stack+5722, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21882,int_stack+5820,int_stack+5764, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21966,int_stack+21882,int_stack+21819, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+22092,int_stack+5892,int_stack+5820, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+22200,int_stack+22092,int_stack+21882, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22368,int_stack+22200,int_stack+21966, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+22578,int_stack+5982,int_stack+5892, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+22713,int_stack+22578,int_stack+22092, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22929,int_stack+22713,int_stack+22200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+23209,int_stack+22929,int_stack+22368, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+23524,int_stack+198,int_stack+5982, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+23689,int_stack+23524,int_stack+22578, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+23959,int_stack+23689,int_stack+22713, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+23524,int_stack+23959,int_stack+22929, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+23944,int_stack+6200,int_stack+6158, 0.0, zero_stack, 1.0, int_stack+6594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+24007,int_stack+6256,int_stack+6200, 0.0, zero_stack, 1.0, int_stack+6657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+24091,int_stack+24007,int_stack+23944, 0.0, zero_stack, 1.0, int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24217,int_stack+6328,int_stack+6256, 0.0, zero_stack, 1.0, int_stack+6741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+24325,int_stack+24217,int_stack+24007, 0.0, zero_stack, 1.0, int_stack+13802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+24493,int_stack+24325,int_stack+24091, 0.0, zero_stack, 1.0, int_stack+13886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+24703,int_stack+6418,int_stack+6328, 0.0, zero_stack, 1.0, int_stack+6849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+24703,int_stack+24217, 0.0, zero_stack, 1.0, int_stack+14012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+24838,int_stack+0,int_stack+24325, 0.0, zero_stack, 1.0, int_stack+14120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+25118,int_stack+24838,int_stack+24493, 0.0, zero_stack, 1.0, int_stack+14288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+25433,int_stack+264,int_stack+6418, 0.0, zero_stack, 1.0, int_stack+330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+25598,int_stack+25433,int_stack+24703, 0.0, zero_stack, 1.0, int_stack+14498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+25868,int_stack+25598,int_stack+0, 0.0, zero_stack, 1.0, int_stack+14633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+25433,int_stack+25868,int_stack+24838, 0.0, zero_stack, 1.0, int_stack+14849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25853,int_stack+6685,int_stack+6615, 1.0, int_stack+6594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25916,int_stack+6777,int_stack+6685, 1.0, int_stack+6657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+26000,int_stack+25916,int_stack+25853, 1.0, int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+26126,int_stack+6894,int_stack+6777, 1.0, int_stack+6741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+26234,int_stack+26126,int_stack+25916, 1.0, int_stack+13802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+26402,int_stack+26234,int_stack+26000, 1.0, int_stack+13886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+6984,int_stack+6894, 1.0, int_stack+6849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+26612,int_stack+13739,int_stack+26126, 1.0, int_stack+14012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+26828,int_stack+26612,int_stack+26234, 1.0, int_stack+14120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+13874,int_stack+26828,int_stack+26402, 1.0, int_stack+14288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+14189,int_stack+385,int_stack+6984, 1.0, int_stack+330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+27108,int_stack+14189,int_stack+13739, 1.0, int_stack+14498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+14189,int_stack+27108,int_stack+26612, 1.0, int_stack+14633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+27108,int_stack+14189,int_stack+26828, 1.0, int_stack+14849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+14189,int_stack+8457,int_stack+8415,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+14252,int_stack+8513,int_stack+8457,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+14336,int_stack+14252,int_stack+14189,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+14462,int_stack+8585,int_stack+8513,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14570,int_stack+14462,int_stack+14252,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+14738,int_stack+14570,int_stack+14336,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+14948,int_stack+8675,int_stack+8585,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+27528,int_stack+14948,int_stack+14462,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+27744,int_stack+27528,int_stack+14570,1);
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+28024,int_stack+27744,int_stack+14738,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+28339,int_stack+451,int_stack+8675,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+28504,int_stack+28339,int_stack+14948,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+28774,int_stack+28504,int_stack+27528,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+28339,int_stack+28774,int_stack+27744,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+28759,int_stack+10399,int_stack+10357,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+28822,int_stack+10455,int_stack+10399,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+28906,int_stack+28822,int_stack+28759,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+29032,int_stack+10527,int_stack+10455,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+29140,int_stack+29032,int_stack+28822,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+29308,int_stack+29140,int_stack+28906,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+29518,int_stack+10617,int_stack+10527,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+29653,int_stack+29518,int_stack+29032,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+216,int_stack+29653,int_stack+29140,1);
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+29869,int_stack+216,int_stack+29308,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+30184,int_stack+517,int_stack+10617,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+30349,int_stack+30184,int_stack+29518,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+30619,int_stack+30349,int_stack+29653,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+30184,int_stack+30619,int_stack+216,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+30604,int_stack+12592,int_stack+12550,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+30667,int_stack+12648,int_stack+12592,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+30751,int_stack+30667,int_stack+30604,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+30877,int_stack+12720,int_stack+12648,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+30985,int_stack+30877,int_stack+30667,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+31153,int_stack+30985,int_stack+30751,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+31363,int_stack+12810,int_stack+12720,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+31498,int_stack+31363,int_stack+30877,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+31714,int_stack+31498,int_stack+30985,1);
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+31994,int_stack+31714,int_stack+31153,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+32309,int_stack+583,int_stack+12810,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+32474,int_stack+32309,int_stack+31363,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+32744,int_stack+32474,int_stack+31498,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+32309,int_stack+32744,int_stack+31714,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32729,int_stack+670,int_stack+649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+4414,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+32792,int_stack+698,int_stack+670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+4456,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+32876,int_stack+32792,int_stack+32729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+15444,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+33002,int_stack+734,int_stack+698, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+4512,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+33110,int_stack+33002,int_stack+32792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+15507,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+33278,int_stack+33110,int_stack+32876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+15591,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+779,int_stack+734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+4584,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+33488,int_stack+32729,int_stack+33002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+15717,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+33704,int_stack+33488,int_stack+33110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+15825,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+32864,int_stack+33704,int_stack+33278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+15993,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+33179,int_stack+834,int_stack+779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+4674,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+496,int_stack+33179,int_stack+32729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+16203,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+33984,int_stack+496,int_stack+33488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+16338,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+33179,int_stack+33984,int_stack+33704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+16554,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+496,int_stack+921,int_stack+900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4414, 1.0, int_stack+4850,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+559,int_stack+949,int_stack+921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4456, 1.0, int_stack+4892,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+643,int_stack+559,int_stack+496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15444, 1.0, int_stack+17569,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+769,int_stack+985,int_stack+949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4512, 1.0, int_stack+4948,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+33599,int_stack+769,int_stack+559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15507, 1.0, int_stack+17632,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+33767,int_stack+33599,int_stack+643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15591, 1.0, int_stack+17716,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+1030,int_stack+985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4584, 1.0, int_stack+5020,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+496,int_stack+32729,int_stack+769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15717, 1.0, int_stack+17842,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+712,int_stack+496,int_stack+33599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15825, 1.0, int_stack+17950,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+33977,int_stack+712,int_stack+33767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15993, 1.0, int_stack+18118,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+33599,int_stack+1085,int_stack+1030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4674, 1.0, int_stack+5110,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+34292,int_stack+33599,int_stack+32729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16203, 1.0, int_stack+18328,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+33599,int_stack+34292,int_stack+496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16338, 1.0, int_stack+18463,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+34292,int_stack+33599,int_stack+712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16554, 1.0, int_stack+18679,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33599,int_stack+1172,int_stack+1151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+4850, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+33662,int_stack+1200,int_stack+1172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+4892, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+33746,int_stack+33662,int_stack+33599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+17569, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+496,int_stack+1236,int_stack+1200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+4948, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+604,int_stack+496,int_stack+33662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+17632, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+772,int_stack+604,int_stack+33746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+17716, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+1281,int_stack+1236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5020, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+33599,int_stack+32729,int_stack+496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+17842, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+982,int_stack+33599,int_stack+604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+17950, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+34712,int_stack+982,int_stack+772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+18118, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+496,int_stack+1336,int_stack+1281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5110, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+661,int_stack+496,int_stack+32729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+18328, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+35027,int_stack+661,int_stack+33599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+18463, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+496,int_stack+35027,int_stack+982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+18679, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+35027,int_stack+1423,int_stack+1402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4414, 0.0, zero_stack, 1.0, int_stack+5286,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+35090,int_stack+1451,int_stack+1423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4456, 0.0, zero_stack, 1.0, int_stack+5328,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+35174,int_stack+35090,int_stack+35027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15444, 0.0, zero_stack, 1.0, int_stack+19694,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+35300,int_stack+1487,int_stack+1451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4512, 0.0, zero_stack, 1.0, int_stack+5384,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+35408,int_stack+35300,int_stack+35090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15507, 0.0, zero_stack, 1.0, int_stack+19757,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+35576,int_stack+35408,int_stack+35174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15591, 0.0, zero_stack, 1.0, int_stack+19841,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+1532,int_stack+1487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4584, 0.0, zero_stack, 1.0, int_stack+5456,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+32729,int_stack+35300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15717, 0.0, zero_stack, 1.0, int_stack+19967,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+33599,int_stack+35027,int_stack+35408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15825, 0.0, zero_stack, 1.0, int_stack+20075,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+35243,int_stack+33599,int_stack+35576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15993, 0.0, zero_stack, 1.0, int_stack+20243,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+35558,int_stack+1587,int_stack+1532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4674, 0.0, zero_stack, 1.0, int_stack+5546,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+35723,int_stack+35558,int_stack+32729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16203, 0.0, zero_stack, 1.0, int_stack+20453,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+916,int_stack+35723,int_stack+35027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16338, 0.0, zero_stack, 1.0, int_stack+20588,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+35558,int_stack+916,int_stack+33599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16554, 0.0, zero_stack, 1.0, int_stack+20804,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33599,int_stack+1674,int_stack+1653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4850, 1.0, int_stack+5286, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+33662,int_stack+1702,int_stack+1674, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4892, 1.0, int_stack+5328, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+33746,int_stack+33662,int_stack+33599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17569, 1.0, int_stack+19694, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+916,int_stack+1738,int_stack+1702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4948, 1.0, int_stack+5384, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1024,int_stack+916,int_stack+33662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17632, 1.0, int_stack+19757, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1192,int_stack+1024,int_stack+33746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17716, 1.0, int_stack+19841, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+1783,int_stack+1738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5020, 1.0, int_stack+5456, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+32729,int_stack+916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17842, 1.0, int_stack+19967, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+33599,int_stack+35027,int_stack+1024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17950, 1.0, int_stack+20075, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1402,int_stack+33599,int_stack+1192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18118, 1.0, int_stack+20243, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+916,int_stack+1838,int_stack+1783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5110, 1.0, int_stack+5546, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1081,int_stack+916,int_stack+32729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18328, 1.0, int_stack+20453, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+35978,int_stack+1081,int_stack+35027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18463, 1.0, int_stack+20588, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+916,int_stack+35978,int_stack+33599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18679, 1.0, int_stack+20804, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33599,int_stack+1925,int_stack+1904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5286, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+33662,int_stack+1953,int_stack+1925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5328, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+33746,int_stack+33662,int_stack+33599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+19694, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+35978,int_stack+1989,int_stack+1953, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5384, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+36086,int_stack+35978,int_stack+33662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+19757, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+36254,int_stack+36086,int_stack+33746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+19841, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+2034,int_stack+1989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5456, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+32729,int_stack+35978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+19967, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+33599,int_stack+35027,int_stack+36086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+20075, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+36464,int_stack+33599,int_stack+36254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+20243, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+35978,int_stack+2089,int_stack+2034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5546, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+36143,int_stack+35978,int_stack+32729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+20453, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1717,int_stack+36143,int_stack+35027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+20588, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+35978,int_stack+1717,int_stack+33599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+20804, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33599,int_stack+2176,int_stack+2155, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4414, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5722,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+33662,int_stack+2204,int_stack+2176, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5764,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+33746,int_stack+33662,int_stack+33599, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15444, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21819,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1717,int_stack+2240,int_stack+2204, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4512, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5820,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1825,int_stack+1717,int_stack+33662, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15507, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21882,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1993,int_stack+1825,int_stack+33746, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15591, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21966,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+2285,int_stack+2240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4584, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5892,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+32729,int_stack+1717, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15717, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22092,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+33599,int_stack+35027,int_stack+1825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22200,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+36779,int_stack+33599,int_stack+1993, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15993, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22368,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1717,int_stack+2340,int_stack+2285, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4674, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5982,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1882,int_stack+1717,int_stack+32729, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16203, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22578,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+37094,int_stack+1882,int_stack+35027, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16338, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22713,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1717,int_stack+37094,int_stack+33599, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16554, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22929,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33599,int_stack+2427,int_stack+2406, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4850, 0.0, zero_stack, 1.0, int_stack+5722, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+33662,int_stack+2455,int_stack+2427, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4892, 0.0, zero_stack, 1.0, int_stack+5764, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+33746,int_stack+33662,int_stack+33599, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17569, 0.0, zero_stack, 1.0, int_stack+21819, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+37094,int_stack+2491,int_stack+2455, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4948, 0.0, zero_stack, 1.0, int_stack+5820, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+37202,int_stack+37094,int_stack+33662, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17632, 0.0, zero_stack, 1.0, int_stack+21882, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+37370,int_stack+37202,int_stack+33746, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17716, 0.0, zero_stack, 1.0, int_stack+21966, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+2536,int_stack+2491, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5020, 0.0, zero_stack, 1.0, int_stack+5892, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+32729,int_stack+37094, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17842, 0.0, zero_stack, 1.0, int_stack+22092, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+33599,int_stack+35027,int_stack+37202, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17950, 0.0, zero_stack, 1.0, int_stack+22200, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+37580,int_stack+33599,int_stack+37370, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18118, 0.0, zero_stack, 1.0, int_stack+22368, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+37094,int_stack+2591,int_stack+2536, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5110, 0.0, zero_stack, 1.0, int_stack+5982, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+37259,int_stack+37094,int_stack+32729, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18328, 0.0, zero_stack, 1.0, int_stack+22578, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2137,int_stack+37259,int_stack+35027, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18463, 0.0, zero_stack, 1.0, int_stack+22713, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+37094,int_stack+2137,int_stack+33599, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18679, 0.0, zero_stack, 1.0, int_stack+22929, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33599,int_stack+2678,int_stack+2657, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5286, 1.0, int_stack+5722, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+33662,int_stack+2706,int_stack+2678, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5328, 1.0, int_stack+5764, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+33746,int_stack+33662,int_stack+33599, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19694, 1.0, int_stack+21819, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2137,int_stack+2742,int_stack+2706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5384, 1.0, int_stack+5820, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2245,int_stack+2137,int_stack+33662, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19757, 1.0, int_stack+21882, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2413,int_stack+2245,int_stack+33746, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19841, 1.0, int_stack+21966, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+2787,int_stack+2742, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5456, 1.0, int_stack+5892, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+32729,int_stack+2137, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19967, 1.0, int_stack+22092, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+33599,int_stack+35027,int_stack+2245, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20075, 1.0, int_stack+22200, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+37895,int_stack+33599,int_stack+2413, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20243, 1.0, int_stack+22368, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2137,int_stack+2842,int_stack+2787, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5546, 1.0, int_stack+5982, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2302,int_stack+2137,int_stack+32729, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20453, 1.0, int_stack+22578, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+38210,int_stack+2302,int_stack+35027, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20588, 1.0, int_stack+22713, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2137,int_stack+38210,int_stack+33599, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20804, 1.0, int_stack+22929, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33599,int_stack+2929,int_stack+2908, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+33662,int_stack+2957,int_stack+2929, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+33746,int_stack+33662,int_stack+33599, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+21819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+38210,int_stack+2993,int_stack+2957, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+38318,int_stack+38210,int_stack+33662, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+21882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+38486,int_stack+38318,int_stack+33746, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+21966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+3038,int_stack+2993, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+32729,int_stack+38210, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+22092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+33599,int_stack+35027,int_stack+38318, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+22200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2557,int_stack+33599,int_stack+38486, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+22368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+38210,int_stack+3093,int_stack+3038, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+38375,int_stack+38210,int_stack+32729, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+22578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+38645,int_stack+38375,int_stack+35027, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+22713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+38210,int_stack+38645,int_stack+33599, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+22929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33599,int_stack+3180,int_stack+3159, 0.0, zero_stack, 1.0, int_stack+4414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6158,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+33662,int_stack+3208,int_stack+3180, 0.0, zero_stack, 1.0, int_stack+4456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6200,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+33746,int_stack+33662,int_stack+33599, 0.0, zero_stack, 1.0, int_stack+15444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23944,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+35027,int_stack+3244,int_stack+3208, 0.0, zero_stack, 1.0, int_stack+4512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6256,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+38630,int_stack+35027,int_stack+33662, 0.0, zero_stack, 1.0, int_stack+15507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24007,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+38798,int_stack+38630,int_stack+33746, 0.0, zero_stack, 1.0, int_stack+15591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24091,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+3289,int_stack+3244, 0.0, zero_stack, 1.0, int_stack+4584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6328,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+33599,int_stack+32729,int_stack+35027, 0.0, zero_stack, 1.0, int_stack+15717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24217,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+39008,int_stack+33599,int_stack+38630, 0.0, zero_stack, 1.0, int_stack+15825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24325,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+39288,int_stack+39008,int_stack+38798, 0.0, zero_stack, 1.0, int_stack+15993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24493,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+38630,int_stack+3344,int_stack+3289, 0.0, zero_stack, 1.0, int_stack+4674, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6418,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+39603,int_stack+38630,int_stack+32729, 0.0, zero_stack, 1.0, int_stack+16203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24703,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+38630,int_stack+39603,int_stack+33599, 0.0, zero_stack, 1.0, int_stack+16338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2872,int_stack+38630,int_stack+39008, 0.0, zero_stack, 1.0, int_stack+16554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24838,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+38630,int_stack+3431,int_stack+3410, 0.0, zero_stack, 1.0, int_stack+4850, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6158, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+38693,int_stack+3459,int_stack+3431, 0.0, zero_stack, 1.0, int_stack+4892, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6200, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38777,int_stack+38693,int_stack+38630, 0.0, zero_stack, 1.0, int_stack+17569, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23944, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+38903,int_stack+3495,int_stack+3459, 0.0, zero_stack, 1.0, int_stack+4948, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6256, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+39011,int_stack+38903,int_stack+38693, 0.0, zero_stack, 1.0, int_stack+17632, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24007, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+33599,int_stack+39011,int_stack+38777, 0.0, zero_stack, 1.0, int_stack+17716, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24091, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+3540,int_stack+3495, 0.0, zero_stack, 1.0, int_stack+5020, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6328, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+32729,int_stack+38903, 0.0, zero_stack, 1.0, int_stack+17842, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24217, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+38630,int_stack+35027,int_stack+39011, 0.0, zero_stack, 1.0, int_stack+17950, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24325, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+38910,int_stack+38630,int_stack+33599, 0.0, zero_stack, 1.0, int_stack+18118, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24493, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+33599,int_stack+3595,int_stack+3540, 0.0, zero_stack, 1.0, int_stack+5110, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6418, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+39603,int_stack+33599,int_stack+32729, 0.0, zero_stack, 1.0, int_stack+18328, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24703, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+33599,int_stack+39603,int_stack+35027, 0.0, zero_stack, 1.0, int_stack+18463, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+39603,int_stack+33599,int_stack+38630, 0.0, zero_stack, 1.0, int_stack+18679, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24838, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+39225,int_stack+3682,int_stack+3661, 0.0, zero_stack, 1.0, int_stack+5286, 0.0, zero_stack, 1.0, int_stack+6158, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+38630,int_stack+3710,int_stack+3682, 0.0, zero_stack, 1.0, int_stack+5328, 0.0, zero_stack, 1.0, int_stack+6200, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38714,int_stack+38630,int_stack+39225, 0.0, zero_stack, 1.0, int_stack+19694, 0.0, zero_stack, 1.0, int_stack+23944, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+33599,int_stack+3746,int_stack+3710, 0.0, zero_stack, 1.0, int_stack+5384, 0.0, zero_stack, 1.0, int_stack+6256, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+33707,int_stack+33599,int_stack+38630, 0.0, zero_stack, 1.0, int_stack+19757, 0.0, zero_stack, 1.0, int_stack+24007, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+35027,int_stack+33707,int_stack+38714, 0.0, zero_stack, 1.0, int_stack+19841, 0.0, zero_stack, 1.0, int_stack+24091, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+3791,int_stack+3746, 0.0, zero_stack, 1.0, int_stack+5456, 0.0, zero_stack, 1.0, int_stack+6328, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+38630,int_stack+32729,int_stack+33599, 0.0, zero_stack, 1.0, int_stack+19967, 0.0, zero_stack, 1.0, int_stack+24217, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+40023,int_stack+38630,int_stack+33707, 0.0, zero_stack, 1.0, int_stack+20075, 0.0, zero_stack, 1.0, int_stack+24325, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+33599,int_stack+40023,int_stack+35027, 0.0, zero_stack, 1.0, int_stack+20243, 0.0, zero_stack, 1.0, int_stack+24493, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+35027,int_stack+3846,int_stack+3791, 0.0, zero_stack, 1.0, int_stack+5546, 0.0, zero_stack, 1.0, int_stack+6418, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+40303,int_stack+35027,int_stack+32729, 0.0, zero_stack, 1.0, int_stack+20453, 0.0, zero_stack, 1.0, int_stack+24703, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+40573,int_stack+40303,int_stack+38630, 0.0, zero_stack, 1.0, int_stack+20588, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3292,int_stack+40573,int_stack+40023, 0.0, zero_stack, 1.0, int_stack+20804, 0.0, zero_stack, 1.0, int_stack+24838, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+3933,int_stack+3912, 0.0, zero_stack, 1.0, int_stack+5722, 1.0, int_stack+6158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40023,int_stack+3961,int_stack+3933, 0.0, zero_stack, 1.0, int_stack+5764, 1.0, int_stack+6200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+40107,int_stack+40023,int_stack+33914, 0.0, zero_stack, 1.0, int_stack+21819, 1.0, int_stack+23944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+40233,int_stack+3997,int_stack+3961, 0.0, zero_stack, 1.0, int_stack+5820, 1.0, int_stack+6256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+40341,int_stack+40233,int_stack+40023, 0.0, zero_stack, 1.0, int_stack+21882, 1.0, int_stack+24007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+40509,int_stack+40341,int_stack+40107, 0.0, zero_stack, 1.0, int_stack+21966, 1.0, int_stack+24091, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+4042,int_stack+3997, 0.0, zero_stack, 1.0, int_stack+5892, 1.0, int_stack+6328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+32729,int_stack+40233, 0.0, zero_stack, 1.0, int_stack+22092, 1.0, int_stack+24217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+38630,int_stack+35027,int_stack+40341, 0.0, zero_stack, 1.0, int_stack+22200, 1.0, int_stack+24325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+40023,int_stack+38630,int_stack+40509, 0.0, zero_stack, 1.0, int_stack+22368, 1.0, int_stack+24493, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+40338,int_stack+4097,int_stack+4042, 0.0, zero_stack, 1.0, int_stack+5982, 1.0, int_stack+6418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+40503,int_stack+40338,int_stack+32729, 0.0, zero_stack, 1.0, int_stack+22578, 1.0, int_stack+24703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3712,int_stack+40503,int_stack+35027, 0.0, zero_stack, 1.0, int_stack+22713, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+40338,int_stack+3712,int_stack+38630, 0.0, zero_stack, 1.0, int_stack+22929, 1.0, int_stack+24838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+4184,int_stack+4163, 0.0, zero_stack, 2.0, int_stack+6158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+38630,int_stack+4212,int_stack+4184, 0.0, zero_stack, 2.0, int_stack+6200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38714,int_stack+38630,int_stack+33914, 0.0, zero_stack, 2.0, int_stack+23944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3712,int_stack+4248,int_stack+4212, 0.0, zero_stack, 2.0, int_stack+6256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3820,int_stack+3712,int_stack+38630, 0.0, zero_stack, 2.0, int_stack+24007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3988,int_stack+3820,int_stack+38714, 0.0, zero_stack, 2.0, int_stack+24091, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+4293,int_stack+4248, 0.0, zero_stack, 2.0, int_stack+6328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+32729,int_stack+3712, 0.0, zero_stack, 2.0, int_stack+24217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+38630,int_stack+35027,int_stack+3820, 0.0, zero_stack, 2.0, int_stack+24325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+40758,int_stack+38630,int_stack+3988, 0.0, zero_stack, 2.0, int_stack+24493, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3712,int_stack+4348,int_stack+4293, 0.0, zero_stack, 2.0, int_stack+6418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3877,int_stack+3712,int_stack+32729, 0.0, zero_stack, 2.0, int_stack+24703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+41073,int_stack+3877,int_stack+35027, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3712,int_stack+41073,int_stack+38630, 0.0, zero_stack, 2.0, int_stack+24838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+4484,int_stack+4435, 1.0, int_stack+4414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+38630,int_stack+4548,int_stack+4484, 1.0, int_stack+4456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6685,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38714,int_stack+38630,int_stack+33914, 1.0, int_stack+15444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25853,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+41073,int_stack+4629,int_stack+4548, 1.0, int_stack+4512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6777,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+41181,int_stack+41073,int_stack+38630, 1.0, int_stack+15507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25916,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+41349,int_stack+41181,int_stack+38714, 1.0, int_stack+15591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26000,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+4729,int_stack+4629, 1.0, int_stack+4584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6894,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+32729,int_stack+41073, 1.0, int_stack+15717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26126,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+38630,int_stack+35027,int_stack+41181, 1.0, int_stack+15825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26234,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+15444,int_stack+38630,int_stack+41349, 1.0, int_stack+15993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26402,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+41073,int_stack+4784,int_stack+4729, 1.0, int_stack+4674, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6984,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+41238,int_stack+41073,int_stack+32729, 1.0, int_stack+16203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13739,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+41508,int_stack+41238,int_stack+35027, 1.0, int_stack+16338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26612,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+41073,int_stack+41508,int_stack+38630, 1.0, int_stack+16554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26828,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+4920,int_stack+4871, 1.0, int_stack+4850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+38630,int_stack+4984,int_stack+4920, 1.0, int_stack+4892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6685, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38714,int_stack+38630,int_stack+33914, 1.0, int_stack+17569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25853, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+35027,int_stack+5065,int_stack+4984, 1.0, int_stack+4948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6777, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+41493,int_stack+35027,int_stack+38630, 1.0, int_stack+17632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25916, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+41661,int_stack+41493,int_stack+38714, 1.0, int_stack+17716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26000, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+5165,int_stack+5065, 1.0, int_stack+5020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6894, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+38630,int_stack+32729,int_stack+35027, 1.0, int_stack+17842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26126, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+17569,int_stack+38630,int_stack+41493, 1.0, int_stack+17950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26234, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+15759,int_stack+17569,int_stack+41661, 1.0, int_stack+18118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26402, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+41493,int_stack+5220,int_stack+5165, 1.0, int_stack+5110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6984, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+41658,int_stack+41493,int_stack+32729, 1.0, int_stack+18328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13739, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+17849,int_stack+41658,int_stack+38630, 1.0, int_stack+18463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26612, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+41493,int_stack+17849,int_stack+17569, 1.0, int_stack+18679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26828, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+5356,int_stack+5307, 1.0, int_stack+5286, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17569,int_stack+5420,int_stack+5356, 1.0, int_stack+5328, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6685, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+17653,int_stack+17569,int_stack+33914, 1.0, int_stack+19694, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25853, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+17779,int_stack+5501,int_stack+5420, 1.0, int_stack+5384, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6777, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17887,int_stack+17779,int_stack+17569, 1.0, int_stack+19757, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25916, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+18055,int_stack+17887,int_stack+17653, 1.0, int_stack+19841, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26000, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+5601,int_stack+5501, 1.0, int_stack+5456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6894, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+32729,int_stack+17779, 1.0, int_stack+19967, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26126, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+38630,int_stack+35027,int_stack+17887, 1.0, int_stack+20075, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26234, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+17569,int_stack+38630,int_stack+18055, 1.0, int_stack+20243, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26402, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+17884,int_stack+5656,int_stack+5601, 1.0, int_stack+5546, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6984, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+18049,int_stack+17884,int_stack+32729, 1.0, int_stack+20453, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13739, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+18319,int_stack+18049,int_stack+35027, 1.0, int_stack+20588, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26612, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+17884,int_stack+18319,int_stack+38630, 1.0, int_stack+20804, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26828, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+5792,int_stack+5743, 1.0, int_stack+5722, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+38630,int_stack+5856,int_stack+5792, 1.0, int_stack+5764, 0.0, zero_stack, 1.0, int_stack+6685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38714,int_stack+38630,int_stack+33914, 1.0, int_stack+21819, 0.0, zero_stack, 1.0, int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+35027,int_stack+5937,int_stack+5856, 1.0, int_stack+5820, 0.0, zero_stack, 1.0, int_stack+6777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+18304,int_stack+35027,int_stack+38630, 1.0, int_stack+21882, 0.0, zero_stack, 1.0, int_stack+25916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+18472,int_stack+18304,int_stack+38714, 1.0, int_stack+21966, 0.0, zero_stack, 1.0, int_stack+26000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+6037,int_stack+5937, 1.0, int_stack+5892, 0.0, zero_stack, 1.0, int_stack+6894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+38630,int_stack+32729,int_stack+35027, 1.0, int_stack+22092, 0.0, zero_stack, 1.0, int_stack+26126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+21819,int_stack+38630,int_stack+18304, 1.0, int_stack+22200, 0.0, zero_stack, 1.0, int_stack+26234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+19694,int_stack+21819,int_stack+18472, 1.0, int_stack+22368, 0.0, zero_stack, 1.0, int_stack+26402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+18304,int_stack+6092,int_stack+6037, 1.0, int_stack+5982, 0.0, zero_stack, 1.0, int_stack+6984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+18469,int_stack+18304,int_stack+32729, 1.0, int_stack+22578, 0.0, zero_stack, 1.0, int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+22099,int_stack+18469,int_stack+38630, 1.0, int_stack+22713, 0.0, zero_stack, 1.0, int_stack+26612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+18304,int_stack+22099,int_stack+21819, 1.0, int_stack+22929, 0.0, zero_stack, 1.0, int_stack+26828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+6228,int_stack+6179, 1.0, int_stack+6158, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21819,int_stack+6292,int_stack+6228, 1.0, int_stack+6200, 1.0, int_stack+6685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21903,int_stack+21819,int_stack+33914, 1.0, int_stack+23944, 1.0, int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+22029,int_stack+6373,int_stack+6292, 1.0, int_stack+6256, 1.0, int_stack+6777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+22137,int_stack+22029,int_stack+21819, 1.0, int_stack+24007, 1.0, int_stack+25916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22305,int_stack+22137,int_stack+21903, 1.0, int_stack+24091, 1.0, int_stack+26000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+6473,int_stack+6373, 1.0, int_stack+6328, 1.0, int_stack+6894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+32729,int_stack+22029, 1.0, int_stack+24217, 1.0, int_stack+26126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+38630,int_stack+35027,int_stack+22137, 1.0, int_stack+24325, 1.0, int_stack+26234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21819,int_stack+38630,int_stack+22305, 1.0, int_stack+24493, 1.0, int_stack+26402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22134,int_stack+6528,int_stack+6473, 1.0, int_stack+6418, 1.0, int_stack+6984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+22299,int_stack+22134,int_stack+32729, 1.0, int_stack+24703, 1.0, int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+22569,int_stack+22299,int_stack+35027, 1.0, int_stack+0, 1.0, int_stack+26612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+22134,int_stack+22569,int_stack+38630, 1.0, int_stack+24838, 1.0, int_stack+26828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+6713,int_stack+6636, 2.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+38630,int_stack+6813,int_stack+6713, 2.0, int_stack+6685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38714,int_stack+38630,int_stack+33914, 2.0, int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+6939,int_stack+6813, 2.0, int_stack+6777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+35027,int_stack+0,int_stack+38630, 2.0, int_stack+25916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+35027,int_stack+38714, 2.0, int_stack+26000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32729,int_stack+7039,int_stack+6939, 2.0, int_stack+6894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+38630,int_stack+32729,int_stack+0, 2.0, int_stack+26126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+38630,int_stack+35027, 2.0, int_stack+26234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+22764,int_stack+25853,int_stack+22554, 2.0, int_stack+26402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+7094,int_stack+7039, 2.0, int_stack+6984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+26133,int_stack+22554,int_stack+32729, 2.0, int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+23944,int_stack+26133,int_stack+38630, 2.0, int_stack+26612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+26133,int_stack+23944,int_stack+25853, 2.0, int_stack+26828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+7181,int_stack+7160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8415,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+7209,int_stack+7181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8457,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14189,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+23944,int_stack+7245,int_stack+7209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8513,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+24052,int_stack+23944,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14252,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+24052,int_stack+25937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14336,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+7290,int_stack+7245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8585,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+13739,int_stack+23944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14462,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+35027,int_stack+24052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14570,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+23944,int_stack+25853,int_stack+22554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14738,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+7345,int_stack+7290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8675,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+24259,int_stack+22554,int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14948,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+24529,int_stack+24259,int_stack+35027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27528,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+26553,int_stack+24529,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27744,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+7432,int_stack+7411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8415, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+7460,int_stack+7432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8457, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14189, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+35027,int_stack+7496,int_stack+7460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8513, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+24259,int_stack+35027,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14252, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+24259,int_stack+25937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14336, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+7541,int_stack+7496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8585, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+13739,int_stack+35027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14462, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+0,int_stack+24259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14570, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+24259,int_stack+25853,int_stack+22554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14738, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+7596,int_stack+7541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8675, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+24574,int_stack+22554,int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14948, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+20009,int_stack+24574,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27528, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+24574,int_stack+20009,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27744, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+7683,int_stack+7662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8415, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+7711,int_stack+7683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8457, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14189, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+20009,int_stack+7747,int_stack+7711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8513, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+20117,int_stack+20009,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14252, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+20117,int_stack+25937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14336, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+7792,int_stack+7747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8585, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+13739,int_stack+20009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14462, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+0,int_stack+20117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14570, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+20009,int_stack+25853,int_stack+22554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14738, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+7847,int_stack+7792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8675, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+20324,int_stack+22554,int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14948, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+20594,int_stack+20324,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27528, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+16074,int_stack+20594,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27744, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+7934,int_stack+7913, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+7962,int_stack+7934, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+7998,int_stack+7962, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8513, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+20324,int_stack+0,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+20324,int_stack+25937, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+8043,int_stack+7998, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+13739,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+35027,int_stack+20324, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+20324,int_stack+25853,int_stack+22554, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+8098,int_stack+8043, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+20639,int_stack+22554,int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4132,int_stack+20639,int_stack+35027, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+20639,int_stack+4132,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+8185,int_stack+8164, 0.0, zero_stack, 1.0, int_stack+8415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+8213,int_stack+8185, 0.0, zero_stack, 1.0, int_stack+8457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 0.0, zero_stack, 1.0, int_stack+14189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4132,int_stack+8249,int_stack+8213, 0.0, zero_stack, 1.0, int_stack+8513, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4240,int_stack+4132,int_stack+25853, 0.0, zero_stack, 1.0, int_stack+14252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+4240,int_stack+25937, 0.0, zero_stack, 1.0, int_stack+14336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+8294,int_stack+8249, 0.0, zero_stack, 1.0, int_stack+8585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+13739,int_stack+4132, 0.0, zero_stack, 1.0, int_stack+14462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+35027,int_stack+4240, 0.0, zero_stack, 1.0, int_stack+14570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4132,int_stack+25853,int_stack+22554, 0.0, zero_stack, 1.0, int_stack+14738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+8349,int_stack+8294, 0.0, zero_stack, 1.0, int_stack+8675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4447,int_stack+22554,int_stack+13739, 0.0, zero_stack, 1.0, int_stack+14948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4717,int_stack+4447,int_stack+35027, 0.0, zero_stack, 1.0, int_stack+27528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+5077,int_stack+4717,int_stack+25853, 0.0, zero_stack, 1.0, int_stack+27744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+8485,int_stack+8436, 1.0, int_stack+8415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+8549,int_stack+8485, 1.0, int_stack+8457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 1.0, int_stack+14189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+35027,int_stack+8630,int_stack+8549, 1.0, int_stack+8513, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4447,int_stack+35027,int_stack+25853, 1.0, int_stack+14252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+4447,int_stack+25937, 1.0, int_stack+14336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+8730,int_stack+8630, 1.0, int_stack+8585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+13739,int_stack+35027, 1.0, int_stack+14462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+0,int_stack+4447, 1.0, int_stack+14570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4447,int_stack+25853,int_stack+22554, 1.0, int_stack+14738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+8785,int_stack+8730, 1.0, int_stack+8675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4762,int_stack+22554,int_stack+13739, 1.0, int_stack+14948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+14189,int_stack+4762,int_stack+0, 1.0, int_stack+27528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+14549,int_stack+14189,int_stack+25853, 1.0, int_stack+27744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+8872,int_stack+8851,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+8900,int_stack+8872,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+14189,int_stack+8936,int_stack+8900,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14297,int_stack+14189,int_stack+25853,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+14297,int_stack+25937,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+8981,int_stack+8936,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+13739,int_stack+14189,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+0,int_stack+14297,1);
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+4762,int_stack+25853,int_stack+22554,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+9036,int_stack+8981,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+14189,int_stack+22554,int_stack+13739,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+27528,int_stack+14189,int_stack+0,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5497,int_stack+27528,int_stack+25853,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+9123,int_stack+9102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10357,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+9151,int_stack+9123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10399,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28759,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+27528,int_stack+9187,int_stack+9151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10455,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+27636,int_stack+27528,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28822,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+27636,int_stack+25937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28906,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+9232,int_stack+9187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10527,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+13739,int_stack+27528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29032,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+0,int_stack+27636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29140,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+27528,int_stack+25853,int_stack+22554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29308,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+9287,int_stack+9232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10617,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+14189,int_stack+22554,int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29518,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+5917,int_stack+14189,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29653,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6277,int_stack+5917,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+9374,int_stack+9353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10357, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+9402,int_stack+9374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10399, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28759, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5917,int_stack+9438,int_stack+9402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10455, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6025,int_stack+5917,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28822, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+6025,int_stack+25937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28906, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+9483,int_stack+9438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10527, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+13739,int_stack+5917, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29032, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+0,int_stack+6025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29140, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+5917,int_stack+25853,int_stack+22554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29308, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+9538,int_stack+9483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10617, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+14189,int_stack+22554,int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29518, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6697,int_stack+14189,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29653, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7057,int_stack+6697,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+9625,int_stack+9604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10357, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+9653,int_stack+9625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10399, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28759, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6697,int_stack+9689,int_stack+9653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10455, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6805,int_stack+6697,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28822, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+6805,int_stack+25937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28906, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+9734,int_stack+9689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10527, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+13739,int_stack+6697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29032, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+0,int_stack+6805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29140, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6697,int_stack+25853,int_stack+22554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29308, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+9789,int_stack+9734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10617, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+14189,int_stack+22554,int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29518, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7477,int_stack+14189,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29653, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7837,int_stack+7477,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+9876,int_stack+9855, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+9904,int_stack+9876, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10399, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7477,int_stack+9940,int_stack+9904, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7585,int_stack+7477,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+7585,int_stack+25937, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+9985,int_stack+9940, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+13739,int_stack+7477, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+0,int_stack+7585, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+7477,int_stack+25853,int_stack+22554, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+10040,int_stack+9985, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+14189,int_stack+22554,int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+8257,int_stack+14189,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+8617,int_stack+8257,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+10127,int_stack+10106, 0.0, zero_stack, 1.0, int_stack+10357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+10155,int_stack+10127, 0.0, zero_stack, 1.0, int_stack+10399, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 0.0, zero_stack, 1.0, int_stack+28759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8257,int_stack+10191,int_stack+10155, 0.0, zero_stack, 1.0, int_stack+10455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8365,int_stack+8257,int_stack+25853, 0.0, zero_stack, 1.0, int_stack+28822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+8365,int_stack+25937, 0.0, zero_stack, 1.0, int_stack+28906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+10236,int_stack+10191, 0.0, zero_stack, 1.0, int_stack+10527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+13739,int_stack+8257, 0.0, zero_stack, 1.0, int_stack+29032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+0,int_stack+8365, 0.0, zero_stack, 1.0, int_stack+29140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+8257,int_stack+25853,int_stack+22554, 0.0, zero_stack, 1.0, int_stack+29308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+10291,int_stack+10236, 0.0, zero_stack, 1.0, int_stack+10617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+14189,int_stack+22554,int_stack+13739, 0.0, zero_stack, 1.0, int_stack+29518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+9037,int_stack+14189,int_stack+0, 0.0, zero_stack, 1.0, int_stack+29653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+9397,int_stack+9037,int_stack+25853, 0.0, zero_stack, 1.0, int_stack+216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+10427,int_stack+10378, 1.0, int_stack+10357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+10491,int_stack+10427, 1.0, int_stack+10399, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 1.0, int_stack+28759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9037,int_stack+10572,int_stack+10491, 1.0, int_stack+10455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9145,int_stack+9037,int_stack+25853, 1.0, int_stack+28822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+9145,int_stack+25937, 1.0, int_stack+28906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+10672,int_stack+10572, 1.0, int_stack+10527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+13739,int_stack+9037, 1.0, int_stack+29032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+0,int_stack+9145, 1.0, int_stack+29140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+9037,int_stack+25853,int_stack+22554, 1.0, int_stack+29308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+10727,int_stack+10672, 1.0, int_stack+10617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+28759,int_stack+22554,int_stack+13739, 1.0, int_stack+29518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+14189,int_stack+28759,int_stack+0, 1.0, int_stack+29653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+28759,int_stack+14189,int_stack+25853, 1.0, int_stack+216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+10814,int_stack+10793,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+10842,int_stack+10814,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+14189,int_stack+10878,int_stack+10842,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14297,int_stack+14189,int_stack+25853,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+14297,int_stack+25937,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+10923,int_stack+10878,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+13739,int_stack+14189,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+35027,int_stack+14297,1);
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+14189,int_stack+25853,int_stack+22554,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+10978,int_stack+10923,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+0,int_stack+22554,int_stack+13739,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+29179,int_stack+0,int_stack+35027,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+29179,int_stack+25853,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+11065,int_stack+11044,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+11093,int_stack+11065,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+29179,int_stack+11129,int_stack+11093,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+29287,int_stack+29179,int_stack+25853,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+29287,int_stack+25937,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+11174,int_stack+11129,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+13739,int_stack+29179,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+35027,int_stack+29287,1);
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+29179,int_stack+25853,int_stack+22554,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+11229,int_stack+11174,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+29494,int_stack+22554,int_stack+13739,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+9817,int_stack+29494,int_stack+35027,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+10177,int_stack+9817,int_stack+25853,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+11316,int_stack+11295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12550,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+11344,int_stack+11316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12592,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30604,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9817,int_stack+11380,int_stack+11344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12648,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9925,int_stack+9817,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30667,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+9925,int_stack+25937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30751,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+11425,int_stack+11380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12720,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+13739,int_stack+9817, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30877,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+35027,int_stack+9925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30985,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+9817,int_stack+25853,int_stack+22554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31153,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+11480,int_stack+11425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12810,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+29494,int_stack+22554,int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31363,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+10597,int_stack+29494,int_stack+35027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31498,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+10957,int_stack+10597,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31714,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+11567,int_stack+11546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12550, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+11595,int_stack+11567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12592, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30604, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10597,int_stack+11631,int_stack+11595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12648, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+10705,int_stack+10597,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30667, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+10705,int_stack+25937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30751, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+11676,int_stack+11631, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12720, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+13739,int_stack+10597, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30877, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+35027,int_stack+10705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30985, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+10597,int_stack+25853,int_stack+22554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31153, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+11731,int_stack+11676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12810, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+29494,int_stack+22554,int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31363, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+11377,int_stack+29494,int_stack+35027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31498, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+41913,int_stack+11377,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31714, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+11818,int_stack+11797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12550, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+11846,int_stack+11818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12592, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30604, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11377,int_stack+11882,int_stack+11846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12648, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+11485,int_stack+11377,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30667, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+11485,int_stack+25937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30751, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+11927,int_stack+11882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12720, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+13739,int_stack+11377, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30877, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+35027,int_stack+11485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30985, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+11377,int_stack+25853,int_stack+22554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31153, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+11982,int_stack+11927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12810, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+11692,int_stack+22554,int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31363, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+29494,int_stack+11692,int_stack+35027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31498, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+42333,int_stack+29494,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31714, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+12069,int_stack+12048, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+12097,int_stack+12069, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+29494,int_stack+12133,int_stack+12097, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+29602,int_stack+29494,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30667, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+29602,int_stack+25937, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+12178,int_stack+12133, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+13739,int_stack+29494, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+35027,int_stack+29602, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+29494,int_stack+25853,int_stack+22554, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+12233,int_stack+12178, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+11692,int_stack+22554,int_stack+13739, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+42753,int_stack+11692,int_stack+35027, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+11692,int_stack+42753,int_stack+25853, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31714, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+12320,int_stack+12299, 0.0, zero_stack, 1.0, int_stack+12550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+12348,int_stack+12320, 0.0, zero_stack, 1.0, int_stack+12592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 0.0, zero_stack, 1.0, int_stack+30604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+42753,int_stack+12384,int_stack+12348, 0.0, zero_stack, 1.0, int_stack+12648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+42861,int_stack+42753,int_stack+25853, 0.0, zero_stack, 1.0, int_stack+30667, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+42861,int_stack+25937, 0.0, zero_stack, 1.0, int_stack+30751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+12429,int_stack+12384, 0.0, zero_stack, 1.0, int_stack+12720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+13739,int_stack+42753, 0.0, zero_stack, 1.0, int_stack+30877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+35027,int_stack+42861, 0.0, zero_stack, 1.0, int_stack+30985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+42753,int_stack+25853,int_stack+22554, 0.0, zero_stack, 1.0, int_stack+31153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+12484,int_stack+12429, 0.0, zero_stack, 1.0, int_stack+12810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+43068,int_stack+22554,int_stack+13739, 0.0, zero_stack, 1.0, int_stack+31363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+43338,int_stack+43068,int_stack+35027, 0.0, zero_stack, 1.0, int_stack+31498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+12112,int_stack+43338,int_stack+25853, 0.0, zero_stack, 1.0, int_stack+31714, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+12620,int_stack+12571, 1.0, int_stack+12550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+12684,int_stack+12620, 1.0, int_stack+12592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914, 1.0, int_stack+30604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+35027,int_stack+12765,int_stack+12684, 1.0, int_stack+12648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+43068,int_stack+35027,int_stack+25853, 1.0, int_stack+30667, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+43068,int_stack+25937, 1.0, int_stack+30751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+12865,int_stack+12765, 1.0, int_stack+12720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+25853,int_stack+13739,int_stack+35027, 1.0, int_stack+30877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+38630,int_stack+25853,int_stack+43068, 1.0, int_stack+30985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+43068,int_stack+38630,int_stack+22554, 1.0, int_stack+31153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+12920,int_stack+12865, 1.0, int_stack+12810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+43383,int_stack+22554,int_stack+13739, 1.0, int_stack+31363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+30604,int_stack+43383,int_stack+25853, 1.0, int_stack+31498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+43383,int_stack+30604,int_stack+38630, 1.0, int_stack+31714, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+13007,int_stack+12986,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+38630,int_stack+13035,int_stack+13007,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+38714,int_stack+38630,int_stack+33914,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+30604,int_stack+13071,int_stack+13035,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+30712,int_stack+30604,int_stack+38630,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+30712,int_stack+38714,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+13116,int_stack+13071,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+13739,int_stack+30604,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+38630,int_stack+35027,int_stack+30712,1);
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+30604,int_stack+38630,int_stack+22554,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+13171,int_stack+13116,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+30919,int_stack+22554,int_stack+13739,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+31189,int_stack+30919,int_stack+35027,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+31549,int_stack+31189,int_stack+38630,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+13258,int_stack+13237,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+38630,int_stack+13286,int_stack+13258,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+38714,int_stack+38630,int_stack+33914,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+35027,int_stack+13322,int_stack+13286,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+30919,int_stack+35027,int_stack+38630,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+30919,int_stack+38714,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+13367,int_stack+13322,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+38630,int_stack+13739,int_stack+35027,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+38630,int_stack+30919,1);
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+30919,int_stack+25853,int_stack+22554,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+13422,int_stack+13367,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+31234,int_stack+22554,int_stack+13739,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+12532,int_stack+31234,int_stack+38630,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+12892,int_stack+12532,int_stack+25853,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+33914,int_stack+13509,int_stack+13488,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+25853,int_stack+13537,int_stack+13509,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+25937,int_stack+25853,int_stack+33914,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+12532,int_stack+13573,int_stack+13537,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+12640,int_stack+12532,int_stack+25853,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+22554,int_stack+12640,int_stack+25937,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+13739,int_stack+13618,int_stack+13573,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+35027,int_stack+13739,int_stack+12532,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+25853,int_stack+35027,int_stack+12640,1);
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+31234,int_stack+25853,int_stack+22554,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+22554,int_stack+13673,int_stack+13618,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+12532,int_stack+22554,int_stack+13739,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+13312,int_stack+12532,int_stack+35027,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+43803,int_stack+13312,int_stack+25853,1);
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+13312,int_stack+17149,int_stack+16834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15129,1);
     Libderiv->ABCD[11] = int_stack + 13312;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+44223,int_stack+19274,int_stack+18959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15129, 0.0, zero_stack,1);
     Libderiv->ABCD[10] = int_stack + 44223;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+44664,int_stack+21399,int_stack+21084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15129, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[9] = int_stack + 44664;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+45105,int_stack+23524,int_stack+23209, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[8] = int_stack + 45105;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+45546,int_stack+25433,int_stack+25118, 0.0, zero_stack, 1.0, int_stack+15129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[7] = int_stack + 45546;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+25433,int_stack+27108,int_stack+13874, 1.0, int_stack+15129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[6] = int_stack + 25433;
 /*--- compute (00|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+14969,int_stack+28339,int_stack+28024,1);
     Libderiv->ABCD[2] = int_stack + 14969;
 /*--- compute (00|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+26973,int_stack+30184,int_stack+29869,1);
     Libderiv->ABCD[1] = int_stack + 26973;
 /*--- compute (00|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+45987,int_stack+32309,int_stack+31994,1);
     Libderiv->ABCD[0] = int_stack + 45987;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+32309,int_stack+33179,int_stack+32864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+16834,1);
     Libderiv->ABCD[155] = int_stack + 32309;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+32750,int_stack+34292,int_stack+33977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16834, 1.0, int_stack+18959,1);
     Libderiv->ABCD[143] = int_stack + 32750;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+33914,int_stack+496,int_stack+34712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+18959, 0.0, zero_stack,1);
     Libderiv->ABCD[142] = int_stack + 33914;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+34355,int_stack+35558,int_stack+35243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16834, 0.0, zero_stack, 1.0, int_stack+21084,1);
     Libderiv->ABCD[131] = int_stack + 34355;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+34796,int_stack+916,int_stack+1402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18959, 1.0, int_stack+21084, 0.0, zero_stack,1);
     Libderiv->ABCD[130] = int_stack + 34796;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+35237,int_stack+35978,int_stack+36464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+21084, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[129] = int_stack + 35237;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+35678,int_stack+1717,int_stack+36779, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16834, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23209,1);
     Libderiv->ABCD[119] = int_stack + 35678;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+36119,int_stack+37094,int_stack+37580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18959, 0.0, zero_stack, 1.0, int_stack+23209, 0.0, zero_stack,1);
     Libderiv->ABCD[118] = int_stack + 36119;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+36560,int_stack+2137,int_stack+37895, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21084, 1.0, int_stack+23209, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[117] = int_stack + 36560;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+37001,int_stack+38210,int_stack+2557, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+23209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[116] = int_stack + 37001;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+37442,int_stack+2872,int_stack+39288, 0.0, zero_stack, 1.0, int_stack+16834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25118,1);
     Libderiv->ABCD[107] = int_stack + 37442;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+37883,int_stack+39603,int_stack+38910, 0.0, zero_stack, 1.0, int_stack+18959, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25118, 0.0, zero_stack,1);
     Libderiv->ABCD[106] = int_stack + 37883;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+38324,int_stack+3292,int_stack+33599, 0.0, zero_stack, 1.0, int_stack+21084, 0.0, zero_stack, 1.0, int_stack+25118, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[105] = int_stack + 38324;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+33191,int_stack+40338,int_stack+40023, 0.0, zero_stack, 1.0, int_stack+23209, 1.0, int_stack+25118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[104] = int_stack + 33191;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+38765,int_stack+3712,int_stack+40758, 0.0, zero_stack, 2.0, int_stack+25118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[103] = int_stack + 38765;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+39206,int_stack+41073,int_stack+15444, 1.0, int_stack+16834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13874,1);
     Libderiv->ABCD[95] = int_stack + 39206;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+39647,int_stack+41493,int_stack+15759, 1.0, int_stack+18959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13874, 0.0, zero_stack,1);
     Libderiv->ABCD[94] = int_stack + 39647;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+40088,int_stack+17884,int_stack+17569, 1.0, int_stack+21084, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13874, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[93] = int_stack + 40088;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+40529,int_stack+18304,int_stack+19694, 1.0, int_stack+23209, 0.0, zero_stack, 1.0, int_stack+13874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[92] = int_stack + 40529;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+40970,int_stack+22134,int_stack+21819, 1.0, int_stack+25118, 1.0, int_stack+13874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[91] = int_stack + 40970;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+41411,int_stack+26133,int_stack+22764, 2.0, int_stack+13874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[90] = int_stack + 41411;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+25874,int_stack+26553,int_stack+23944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28024,1);
     Libderiv->ABCD[47] = int_stack + 25874;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+26315,int_stack+24574,int_stack+24259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28024, 0.0, zero_stack,1);
     Libderiv->ABCD[46] = int_stack + 26315;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+46428,int_stack+16074,int_stack+20009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28024, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[45] = int_stack + 46428;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+420,int_stack+20639,int_stack+20324, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[44] = int_stack + 420;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+861,int_stack+5077,int_stack+4132, 0.0, zero_stack, 1.0, int_stack+28024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[43] = int_stack + 861;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1302,int_stack+14549,int_stack+4447, 1.0, int_stack+28024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[42] = int_stack + 1302;
 /*--- compute (00|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1743,int_stack+5497,int_stack+4762,1);
     Libderiv->ABCD[38] = int_stack + 1743;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2184,int_stack+6277,int_stack+27528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29869,1);
     Libderiv->ABCD[35] = int_stack + 2184;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2625,int_stack+7057,int_stack+5917, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29869, 0.0, zero_stack,1);
     Libderiv->ABCD[34] = int_stack + 2625;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3066,int_stack+7837,int_stack+6697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29869, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[33] = int_stack + 3066;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3507,int_stack+8617,int_stack+7477, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[32] = int_stack + 3507;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3948,int_stack+9397,int_stack+8257, 0.0, zero_stack, 1.0, int_stack+29869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[31] = int_stack + 3948;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4389,int_stack+28759,int_stack+9037, 1.0, int_stack+29869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[30] = int_stack + 4389;
 /*--- compute (00|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+29809,int_stack+0,int_stack+14189,1);
     Libderiv->ABCD[26] = int_stack + 29809;
 /*--- compute (00|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+13753,int_stack+10177,int_stack+29179,1);
     Libderiv->ABCD[25] = int_stack + 13753;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+14194,int_stack+10957,int_stack+9817, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31994,1);
     Libderiv->ABCD[23] = int_stack + 14194;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+10912,int_stack+41913,int_stack+10597, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31994, 0.0, zero_stack,1);
     Libderiv->ABCD[22] = int_stack + 10912;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+41852,int_stack+42333,int_stack+11377, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31994, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[21] = int_stack + 41852;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+42293,int_stack+11692,int_stack+29494, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[20] = int_stack + 42293;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+11353,int_stack+12112,int_stack+42753, 0.0, zero_stack, 1.0, int_stack+31994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[19] = int_stack + 11353;
 /*--- compute (00|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+11794,int_stack+43383,int_stack+43068, 1.0, int_stack+31994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[18] = int_stack + 11794;
 /*--- compute (00|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+42734,int_stack+31549,int_stack+30604,1);
     Libderiv->ABCD[14] = int_stack + 42734;
 /*--- compute (00|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+31549,int_stack+12892,int_stack+30919,1);
     Libderiv->ABCD[13] = int_stack + 31549;
 /*--- compute (00|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+43175,int_stack+43803,int_stack+31234,1);
     Libderiv->ABCD[12] = int_stack + 43175;

}
