/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_d0hh(Libderiv_t *, prim_data *);

  /* Computes derivatives of (d0|hh) integrals */

void d12hrr_order_d0hh(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][10][11] = int_stack + 0;
 Libderiv->deriv_classes[2][10][10] = int_stack + 396;
 Libderiv->deriv_classes[2][10][9] = int_stack + 792;
 Libderiv->deriv_classes[2][10][8] = int_stack + 1188;
 Libderiv->deriv_classes[2][10][7] = int_stack + 1584;
 Libderiv->dvrr_classes[2][9] = int_stack + 1980;
 Libderiv->deriv_classes[2][10][6] = int_stack + 2310;
 Libderiv->deriv_classes[2][10][2] = int_stack + 2706;
 Libderiv->deriv_classes[2][10][1] = int_stack + 3102;
 Libderiv->deriv_classes[2][10][0] = int_stack + 3498;
 Libderiv->deriv2_classes[2][5][143] = int_stack + 3894;
 Libderiv->deriv2_classes[2][6][143] = int_stack + 4020;
 Libderiv->deriv2_classes[2][7][143] = int_stack + 4188;
 Libderiv->deriv2_classes[2][8][143] = int_stack + 4404;
 Libderiv->deriv2_classes[2][9][143] = int_stack + 4674;
 Libderiv->deriv2_classes[2][10][143] = int_stack + 5004;
 Libderiv->deriv2_classes[2][5][131] = int_stack + 5400;
 Libderiv->deriv2_classes[2][6][131] = int_stack + 5526;
 Libderiv->deriv2_classes[2][7][131] = int_stack + 5694;
 Libderiv->deriv2_classes[2][8][131] = int_stack + 5910;
 Libderiv->deriv2_classes[2][9][131] = int_stack + 6180;
 Libderiv->deriv2_classes[2][10][131] = int_stack + 6510;
 Libderiv->deriv2_classes[2][5][130] = int_stack + 6906;
 Libderiv->deriv2_classes[2][6][130] = int_stack + 7032;
 Libderiv->deriv2_classes[2][7][130] = int_stack + 7200;
 Libderiv->deriv2_classes[2][8][130] = int_stack + 7416;
 Libderiv->deriv2_classes[2][9][130] = int_stack + 7686;
 Libderiv->deriv2_classes[2][10][130] = int_stack + 8016;
 Libderiv->deriv2_classes[2][5][119] = int_stack + 8412;
 Libderiv->deriv2_classes[2][6][119] = int_stack + 8538;
 Libderiv->deriv2_classes[2][7][119] = int_stack + 8706;
 Libderiv->deriv2_classes[2][8][119] = int_stack + 8922;
 Libderiv->deriv2_classes[2][9][119] = int_stack + 9192;
 Libderiv->deriv2_classes[2][10][119] = int_stack + 9522;
 Libderiv->deriv2_classes[2][5][118] = int_stack + 9918;
 Libderiv->deriv2_classes[2][6][118] = int_stack + 10044;
 Libderiv->deriv2_classes[2][7][118] = int_stack + 10212;
 Libderiv->deriv2_classes[2][8][118] = int_stack + 10428;
 Libderiv->deriv2_classes[2][9][118] = int_stack + 10698;
 Libderiv->deriv2_classes[2][10][118] = int_stack + 11028;
 Libderiv->deriv2_classes[2][5][117] = int_stack + 11424;
 Libderiv->deriv2_classes[2][6][117] = int_stack + 11550;
 Libderiv->deriv2_classes[2][7][117] = int_stack + 11718;
 Libderiv->deriv2_classes[2][8][117] = int_stack + 11934;
 Libderiv->deriv2_classes[2][9][117] = int_stack + 12204;
 Libderiv->deriv2_classes[2][10][117] = int_stack + 12534;
 Libderiv->deriv2_classes[2][5][107] = int_stack + 12930;
 Libderiv->deriv2_classes[2][6][107] = int_stack + 13056;
 Libderiv->deriv2_classes[2][7][107] = int_stack + 13224;
 Libderiv->deriv2_classes[2][8][107] = int_stack + 13440;
 Libderiv->deriv2_classes[2][9][107] = int_stack + 13710;
 Libderiv->deriv2_classes[2][10][107] = int_stack + 14040;
 Libderiv->deriv2_classes[2][5][106] = int_stack + 14436;
 Libderiv->deriv2_classes[2][6][106] = int_stack + 14562;
 Libderiv->deriv2_classes[2][7][106] = int_stack + 14730;
 Libderiv->deriv2_classes[2][8][106] = int_stack + 14946;
 Libderiv->deriv2_classes[2][9][106] = int_stack + 15216;
 Libderiv->deriv2_classes[2][10][106] = int_stack + 15546;
 Libderiv->deriv2_classes[2][5][105] = int_stack + 15942;
 Libderiv->deriv2_classes[2][6][105] = int_stack + 16068;
 Libderiv->deriv2_classes[2][7][105] = int_stack + 16236;
 Libderiv->deriv2_classes[2][8][105] = int_stack + 16452;
 Libderiv->deriv2_classes[2][9][105] = int_stack + 16722;
 Libderiv->deriv2_classes[2][10][105] = int_stack + 17052;
 Libderiv->deriv2_classes[2][5][104] = int_stack + 17448;
 Libderiv->deriv2_classes[2][6][104] = int_stack + 17574;
 Libderiv->deriv2_classes[2][7][104] = int_stack + 17742;
 Libderiv->deriv2_classes[2][8][104] = int_stack + 17958;
 Libderiv->deriv2_classes[2][9][104] = int_stack + 18228;
 Libderiv->deriv2_classes[2][10][104] = int_stack + 18558;
 Libderiv->deriv2_classes[2][5][95] = int_stack + 18954;
 Libderiv->deriv2_classes[2][6][95] = int_stack + 19080;
 Libderiv->deriv2_classes[2][7][95] = int_stack + 19248;
 Libderiv->deriv2_classes[2][8][95] = int_stack + 19464;
 Libderiv->deriv2_classes[2][9][95] = int_stack + 19734;
 Libderiv->deriv2_classes[2][10][95] = int_stack + 20064;
 Libderiv->deriv2_classes[2][5][94] = int_stack + 20460;
 Libderiv->deriv2_classes[2][6][94] = int_stack + 20586;
 Libderiv->deriv2_classes[2][7][94] = int_stack + 20754;
 Libderiv->deriv2_classes[2][8][94] = int_stack + 20970;
 Libderiv->deriv2_classes[2][9][94] = int_stack + 21240;
 Libderiv->deriv2_classes[2][10][94] = int_stack + 21570;
 Libderiv->deriv2_classes[2][5][93] = int_stack + 21966;
 Libderiv->deriv2_classes[2][6][93] = int_stack + 22092;
 Libderiv->deriv2_classes[2][7][93] = int_stack + 22260;
 Libderiv->deriv2_classes[2][8][93] = int_stack + 22476;
 Libderiv->deriv2_classes[2][9][93] = int_stack + 22746;
 Libderiv->deriv2_classes[2][10][93] = int_stack + 23076;
 Libderiv->deriv2_classes[2][5][92] = int_stack + 23472;
 Libderiv->deriv2_classes[2][6][92] = int_stack + 23598;
 Libderiv->deriv2_classes[2][7][92] = int_stack + 23766;
 Libderiv->deriv2_classes[2][8][92] = int_stack + 23982;
 Libderiv->deriv2_classes[2][9][92] = int_stack + 24252;
 Libderiv->deriv2_classes[2][10][92] = int_stack + 24582;
 Libderiv->deriv2_classes[2][5][91] = int_stack + 24978;
 Libderiv->deriv2_classes[2][6][91] = int_stack + 25104;
 Libderiv->deriv2_classes[2][7][91] = int_stack + 25272;
 Libderiv->deriv2_classes[2][8][91] = int_stack + 25488;
 Libderiv->deriv2_classes[2][9][91] = int_stack + 25758;
 Libderiv->deriv2_classes[2][10][91] = int_stack + 26088;
 Libderiv->deriv_classes[2][5][11] = int_stack + 26484;
 Libderiv->deriv2_classes[2][5][83] = int_stack + 26610;
 Libderiv->deriv_classes[2][6][11] = int_stack + 26736;
 Libderiv->deriv2_classes[2][6][83] = int_stack + 26904;
 Libderiv->deriv_classes[2][7][11] = int_stack + 27072;
 Libderiv->deriv2_classes[2][7][83] = int_stack + 27288;
 Libderiv->deriv_classes[2][8][11] = int_stack + 27504;
 Libderiv->deriv2_classes[2][8][83] = int_stack + 27774;
 Libderiv->deriv_classes[2][9][11] = int_stack + 28044;
 Libderiv->deriv2_classes[2][9][83] = int_stack + 28374;
 Libderiv->deriv2_classes[2][10][83] = int_stack + 28704;
 Libderiv->deriv_classes[2][5][10] = int_stack + 29100;
 Libderiv->deriv2_classes[2][5][82] = int_stack + 29226;
 Libderiv->deriv_classes[2][6][10] = int_stack + 29352;
 Libderiv->deriv2_classes[2][6][82] = int_stack + 29520;
 Libderiv->deriv_classes[2][7][10] = int_stack + 29688;
 Libderiv->deriv2_classes[2][7][82] = int_stack + 29904;
 Libderiv->deriv_classes[2][8][10] = int_stack + 30120;
 Libderiv->deriv2_classes[2][8][82] = int_stack + 30390;
 Libderiv->deriv_classes[2][9][10] = int_stack + 30660;
 Libderiv->deriv2_classes[2][9][82] = int_stack + 30990;
 Libderiv->deriv2_classes[2][10][82] = int_stack + 31320;
 Libderiv->deriv_classes[2][5][9] = int_stack + 31716;
 Libderiv->deriv2_classes[2][5][81] = int_stack + 31842;
 Libderiv->deriv_classes[2][6][9] = int_stack + 31968;
 Libderiv->deriv2_classes[2][6][81] = int_stack + 32136;
 Libderiv->deriv_classes[2][7][9] = int_stack + 32304;
 Libderiv->deriv2_classes[2][7][81] = int_stack + 32520;
 Libderiv->deriv_classes[2][8][9] = int_stack + 32736;
 Libderiv->deriv2_classes[2][8][81] = int_stack + 33006;
 Libderiv->deriv_classes[2][9][9] = int_stack + 33276;
 Libderiv->deriv2_classes[2][9][81] = int_stack + 33606;
 Libderiv->deriv2_classes[2][10][81] = int_stack + 33936;
 Libderiv->deriv_classes[2][5][8] = int_stack + 34332;
 Libderiv->deriv2_classes[2][5][80] = int_stack + 34458;
 Libderiv->deriv_classes[2][6][8] = int_stack + 34584;
 Libderiv->deriv2_classes[2][6][80] = int_stack + 34752;
 Libderiv->deriv_classes[2][7][8] = int_stack + 34920;
 Libderiv->deriv2_classes[2][7][80] = int_stack + 35136;
 Libderiv->deriv_classes[2][8][8] = int_stack + 35352;
 Libderiv->deriv2_classes[2][8][80] = int_stack + 35622;
 Libderiv->deriv_classes[2][9][8] = int_stack + 35892;
 Libderiv->deriv2_classes[2][9][80] = int_stack + 36222;
 Libderiv->deriv2_classes[2][10][80] = int_stack + 36552;
 Libderiv->deriv_classes[2][5][7] = int_stack + 36948;
 Libderiv->deriv2_classes[2][5][79] = int_stack + 37074;
 Libderiv->deriv_classes[2][6][7] = int_stack + 37200;
 Libderiv->deriv2_classes[2][6][79] = int_stack + 37368;
 Libderiv->deriv_classes[2][7][7] = int_stack + 37536;
 Libderiv->deriv2_classes[2][7][79] = int_stack + 37752;
 Libderiv->deriv_classes[2][8][7] = int_stack + 37968;
 Libderiv->deriv2_classes[2][8][79] = int_stack + 38238;
 Libderiv->deriv_classes[2][9][7] = int_stack + 38508;
 Libderiv->deriv2_classes[2][9][79] = int_stack + 38838;
 Libderiv->deriv2_classes[2][10][79] = int_stack + 39168;
 Libderiv->dvrr_classes[2][5] = int_stack + 39564;
 Libderiv->deriv_classes[2][5][6] = int_stack + 39690;
 Libderiv->deriv2_classes[2][5][78] = int_stack + 39816;
 Libderiv->dvrr_classes[2][6] = int_stack + 39942;
 Libderiv->deriv_classes[2][6][6] = int_stack + 40110;
 Libderiv->deriv2_classes[2][6][78] = int_stack + 40278;
 Libderiv->dvrr_classes[2][7] = int_stack + 40446;
 Libderiv->deriv_classes[2][7][6] = int_stack + 40662;
 Libderiv->deriv2_classes[2][7][78] = int_stack + 40878;
 Libderiv->dvrr_classes[2][8] = int_stack + 41094;
 Libderiv->deriv_classes[2][8][6] = int_stack + 41364;
 Libderiv->deriv2_classes[2][8][78] = int_stack + 41634;
 Libderiv->deriv_classes[2][9][6] = int_stack + 41904;
 Libderiv->deriv2_classes[2][9][78] = int_stack + 42234;
 Libderiv->deriv2_classes[2][10][78] = int_stack + 42564;
 Libderiv->deriv2_classes[2][5][35] = int_stack + 42960;
 Libderiv->deriv2_classes[2][6][35] = int_stack + 43086;
 Libderiv->deriv2_classes[2][7][35] = int_stack + 43254;
 Libderiv->deriv2_classes[2][8][35] = int_stack + 43470;
 Libderiv->deriv2_classes[2][9][35] = int_stack + 43740;
 Libderiv->deriv2_classes[2][10][35] = int_stack + 44070;
 Libderiv->deriv2_classes[2][5][34] = int_stack + 44466;
 Libderiv->deriv2_classes[2][6][34] = int_stack + 44592;
 Libderiv->deriv2_classes[2][7][34] = int_stack + 44760;
 Libderiv->deriv2_classes[2][8][34] = int_stack + 44976;
 Libderiv->deriv2_classes[2][9][34] = int_stack + 45246;
 Libderiv->deriv2_classes[2][10][34] = int_stack + 45576;
 Libderiv->deriv2_classes[2][5][33] = int_stack + 45972;
 Libderiv->deriv2_classes[2][6][33] = int_stack + 46098;
 Libderiv->deriv2_classes[2][7][33] = int_stack + 46266;
 Libderiv->deriv2_classes[2][8][33] = int_stack + 46482;
 Libderiv->deriv2_classes[2][9][33] = int_stack + 46752;
 Libderiv->deriv2_classes[2][10][33] = int_stack + 47082;
 Libderiv->deriv2_classes[2][5][32] = int_stack + 47478;
 Libderiv->deriv2_classes[2][6][32] = int_stack + 47604;
 Libderiv->deriv2_classes[2][7][32] = int_stack + 47772;
 Libderiv->deriv2_classes[2][8][32] = int_stack + 47988;
 Libderiv->deriv2_classes[2][9][32] = int_stack + 48258;
 Libderiv->deriv2_classes[2][10][32] = int_stack + 48588;
 Libderiv->deriv2_classes[2][5][31] = int_stack + 48984;
 Libderiv->deriv2_classes[2][6][31] = int_stack + 49110;
 Libderiv->deriv2_classes[2][7][31] = int_stack + 49278;
 Libderiv->deriv2_classes[2][8][31] = int_stack + 49494;
 Libderiv->deriv2_classes[2][9][31] = int_stack + 49764;
 Libderiv->deriv2_classes[2][10][31] = int_stack + 50094;
 Libderiv->deriv_classes[2][5][2] = int_stack + 50490;
 Libderiv->deriv2_classes[2][5][30] = int_stack + 50616;
 Libderiv->deriv_classes[2][6][2] = int_stack + 50742;
 Libderiv->deriv2_classes[2][6][30] = int_stack + 50910;
 Libderiv->deriv_classes[2][7][2] = int_stack + 51078;
 Libderiv->deriv2_classes[2][7][30] = int_stack + 51294;
 Libderiv->deriv_classes[2][8][2] = int_stack + 51510;
 Libderiv->deriv2_classes[2][8][30] = int_stack + 51780;
 Libderiv->deriv_classes[2][9][2] = int_stack + 52050;
 Libderiv->deriv2_classes[2][9][30] = int_stack + 52380;
 Libderiv->deriv2_classes[2][10][30] = int_stack + 52710;
 Libderiv->deriv2_classes[2][5][26] = int_stack + 53106;
 Libderiv->deriv2_classes[2][6][26] = int_stack + 53232;
 Libderiv->deriv2_classes[2][7][26] = int_stack + 53400;
 Libderiv->deriv2_classes[2][8][26] = int_stack + 53616;
 Libderiv->deriv2_classes[2][9][26] = int_stack + 53886;
 Libderiv->deriv2_classes[2][10][26] = int_stack + 54216;
 Libderiv->deriv2_classes[2][5][23] = int_stack + 54612;
 Libderiv->deriv2_classes[2][6][23] = int_stack + 54738;
 Libderiv->deriv2_classes[2][7][23] = int_stack + 54906;
 Libderiv->deriv2_classes[2][8][23] = int_stack + 55122;
 Libderiv->deriv2_classes[2][9][23] = int_stack + 55392;
 Libderiv->deriv2_classes[2][10][23] = int_stack + 55722;
 Libderiv->deriv2_classes[2][5][22] = int_stack + 56118;
 Libderiv->deriv2_classes[2][6][22] = int_stack + 56244;
 Libderiv->deriv2_classes[2][7][22] = int_stack + 56412;
 Libderiv->deriv2_classes[2][8][22] = int_stack + 56628;
 Libderiv->deriv2_classes[2][9][22] = int_stack + 56898;
 Libderiv->deriv2_classes[2][10][22] = int_stack + 57228;
 Libderiv->deriv2_classes[2][5][21] = int_stack + 57624;
 Libderiv->deriv2_classes[2][6][21] = int_stack + 57750;
 Libderiv->deriv2_classes[2][7][21] = int_stack + 57918;
 Libderiv->deriv2_classes[2][8][21] = int_stack + 58134;
 Libderiv->deriv2_classes[2][9][21] = int_stack + 58404;
 Libderiv->deriv2_classes[2][10][21] = int_stack + 58734;
 Libderiv->deriv2_classes[2][5][20] = int_stack + 59130;
 Libderiv->deriv2_classes[2][6][20] = int_stack + 59256;
 Libderiv->deriv2_classes[2][7][20] = int_stack + 59424;
 Libderiv->deriv2_classes[2][8][20] = int_stack + 59640;
 Libderiv->deriv2_classes[2][9][20] = int_stack + 59910;
 Libderiv->deriv2_classes[2][10][20] = int_stack + 60240;
 Libderiv->deriv2_classes[2][5][19] = int_stack + 60636;
 Libderiv->deriv2_classes[2][6][19] = int_stack + 60762;
 Libderiv->deriv2_classes[2][7][19] = int_stack + 60930;
 Libderiv->deriv2_classes[2][8][19] = int_stack + 61146;
 Libderiv->deriv2_classes[2][9][19] = int_stack + 61416;
 Libderiv->deriv2_classes[2][10][19] = int_stack + 61746;
 Libderiv->deriv_classes[2][5][1] = int_stack + 62142;
 Libderiv->deriv2_classes[2][5][18] = int_stack + 62268;
 Libderiv->deriv_classes[2][6][1] = int_stack + 62394;
 Libderiv->deriv2_classes[2][6][18] = int_stack + 62562;
 Libderiv->deriv_classes[2][7][1] = int_stack + 62730;
 Libderiv->deriv2_classes[2][7][18] = int_stack + 62946;
 Libderiv->deriv_classes[2][8][1] = int_stack + 63162;
 Libderiv->deriv2_classes[2][8][18] = int_stack + 63432;
 Libderiv->deriv_classes[2][9][1] = int_stack + 63702;
 Libderiv->deriv2_classes[2][9][18] = int_stack + 64032;
 Libderiv->deriv2_classes[2][10][18] = int_stack + 64362;
 Libderiv->deriv2_classes[2][5][14] = int_stack + 64758;
 Libderiv->deriv2_classes[2][6][14] = int_stack + 64884;
 Libderiv->deriv2_classes[2][7][14] = int_stack + 65052;
 Libderiv->deriv2_classes[2][8][14] = int_stack + 65268;
 Libderiv->deriv2_classes[2][9][14] = int_stack + 65538;
 Libderiv->deriv2_classes[2][10][14] = int_stack + 65868;
 Libderiv->deriv2_classes[2][5][13] = int_stack + 66264;
 Libderiv->deriv2_classes[2][6][13] = int_stack + 66390;
 Libderiv->deriv2_classes[2][7][13] = int_stack + 66558;
 Libderiv->deriv2_classes[2][8][13] = int_stack + 66774;
 Libderiv->deriv2_classes[2][9][13] = int_stack + 67044;
 Libderiv->deriv2_classes[2][10][13] = int_stack + 67374;
 Libderiv->deriv2_classes[2][5][11] = int_stack + 67770;
 Libderiv->deriv2_classes[2][6][11] = int_stack + 67896;
 Libderiv->deriv2_classes[2][7][11] = int_stack + 68064;
 Libderiv->deriv2_classes[2][8][11] = int_stack + 68280;
 Libderiv->deriv2_classes[2][9][11] = int_stack + 68550;
 Libderiv->deriv2_classes[2][10][11] = int_stack + 68880;
 Libderiv->deriv2_classes[2][5][10] = int_stack + 69276;
 Libderiv->deriv2_classes[2][6][10] = int_stack + 69402;
 Libderiv->deriv2_classes[2][7][10] = int_stack + 69570;
 Libderiv->deriv2_classes[2][8][10] = int_stack + 69786;
 Libderiv->deriv2_classes[2][9][10] = int_stack + 70056;
 Libderiv->deriv2_classes[2][10][10] = int_stack + 70386;
 Libderiv->deriv2_classes[2][5][9] = int_stack + 70782;
 Libderiv->deriv2_classes[2][6][9] = int_stack + 70908;
 Libderiv->deriv2_classes[2][7][9] = int_stack + 71076;
 Libderiv->deriv2_classes[2][8][9] = int_stack + 71292;
 Libderiv->deriv2_classes[2][9][9] = int_stack + 71562;
 Libderiv->deriv2_classes[2][10][9] = int_stack + 71892;
 Libderiv->deriv2_classes[2][5][8] = int_stack + 72288;
 Libderiv->deriv2_classes[2][6][8] = int_stack + 72414;
 Libderiv->deriv2_classes[2][7][8] = int_stack + 72582;
 Libderiv->deriv2_classes[2][8][8] = int_stack + 72798;
 Libderiv->deriv2_classes[2][9][8] = int_stack + 73068;
 Libderiv->deriv2_classes[2][10][8] = int_stack + 73398;
 Libderiv->deriv2_classes[2][5][7] = int_stack + 73794;
 Libderiv->deriv2_classes[2][6][7] = int_stack + 73920;
 Libderiv->deriv2_classes[2][7][7] = int_stack + 74088;
 Libderiv->deriv2_classes[2][8][7] = int_stack + 74304;
 Libderiv->deriv2_classes[2][9][7] = int_stack + 74574;
 Libderiv->deriv2_classes[2][10][7] = int_stack + 74904;
 Libderiv->deriv_classes[2][5][0] = int_stack + 75300;
 Libderiv->deriv2_classes[2][5][6] = int_stack + 75426;
 Libderiv->deriv_classes[2][6][0] = int_stack + 75552;
 Libderiv->deriv2_classes[2][6][6] = int_stack + 75720;
 Libderiv->deriv_classes[2][7][0] = int_stack + 75888;
 Libderiv->deriv2_classes[2][7][6] = int_stack + 76104;
 Libderiv->deriv_classes[2][8][0] = int_stack + 76320;
 Libderiv->deriv2_classes[2][8][6] = int_stack + 76590;
 Libderiv->deriv_classes[2][9][0] = int_stack + 76860;
 Libderiv->deriv2_classes[2][9][6] = int_stack + 77190;
 Libderiv->deriv2_classes[2][10][6] = int_stack + 77520;
 Libderiv->deriv2_classes[2][5][2] = int_stack + 77916;
 Libderiv->deriv2_classes[2][6][2] = int_stack + 78042;
 Libderiv->deriv2_classes[2][7][2] = int_stack + 78210;
 Libderiv->deriv2_classes[2][8][2] = int_stack + 78426;
 Libderiv->deriv2_classes[2][9][2] = int_stack + 78696;
 Libderiv->deriv2_classes[2][10][2] = int_stack + 79026;
 Libderiv->deriv2_classes[2][5][1] = int_stack + 79422;
 Libderiv->deriv2_classes[2][6][1] = int_stack + 79548;
 Libderiv->deriv2_classes[2][7][1] = int_stack + 79716;
 Libderiv->deriv2_classes[2][8][1] = int_stack + 79932;
 Libderiv->deriv2_classes[2][9][1] = int_stack + 80202;
 Libderiv->deriv2_classes[2][10][1] = int_stack + 80532;
 Libderiv->deriv2_classes[2][5][0] = int_stack + 80928;
 Libderiv->deriv2_classes[2][6][0] = int_stack + 81054;
 Libderiv->deriv2_classes[2][7][0] = int_stack + 81222;
 Libderiv->deriv2_classes[2][8][0] = int_stack + 81438;
 Libderiv->deriv2_classes[2][9][0] = int_stack + 81708;
 Libderiv->deriv2_classes[2][10][0] = int_stack + 82038;
 memset(int_stack,0,659472);

 Libderiv->dvrr_stack = int_stack + 287964;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_d0hh(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+82434,int_stack+39942,int_stack+39564,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+82812,int_stack+40446,int_stack+39942,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+83316,int_stack+82812,int_stack+82434,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+84072,int_stack+41094,int_stack+40446,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+84720,int_stack+84072,int_stack+82812,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+85728,int_stack+84720,int_stack+83316,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+86988,int_stack+1980,int_stack+41094,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+87798,int_stack+86988,int_stack+84072,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+89094,int_stack+87798,int_stack+84720,6);
 /*--- compute (d0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+90774,int_stack+89094,int_stack+85728,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+92664,int_stack+26736,int_stack+26484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39564,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+93042,int_stack+27072,int_stack+26736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39942,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+93546,int_stack+93042,int_stack+92664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82434,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+94302,int_stack+27504,int_stack+27072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40446,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+94950,int_stack+94302,int_stack+93042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82812,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+95958,int_stack+94950,int_stack+93546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83316,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+97218,int_stack+28044,int_stack+27504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41094,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+98028,int_stack+97218,int_stack+94302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84072,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+99324,int_stack+98028,int_stack+94950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84720,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+101004,int_stack+99324,int_stack+95958, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85728,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+102894,int_stack+0,int_stack+28044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1980,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+103884,int_stack+102894,int_stack+97218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86988,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+105504,int_stack+103884,int_stack+98028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87798,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102894,int_stack+105504,int_stack+99324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89094,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+105414,int_stack+29352,int_stack+29100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39564, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+105792,int_stack+29688,int_stack+29352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39942, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106296,int_stack+105792,int_stack+105414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82434, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+107052,int_stack+30120,int_stack+29688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40446, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+107700,int_stack+107052,int_stack+105792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82812, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+108708,int_stack+107700,int_stack+106296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83316, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+109968,int_stack+30660,int_stack+30120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41094, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+110778,int_stack+109968,int_stack+107052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84072, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+112074,int_stack+110778,int_stack+107700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84720, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+113754,int_stack+112074,int_stack+108708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85728, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+115644,int_stack+396,int_stack+30660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1980, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+116634,int_stack+115644,int_stack+109968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86988, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+118254,int_stack+116634,int_stack+110778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87798, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+115644,int_stack+118254,int_stack+112074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89094, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+118164,int_stack+31968,int_stack+31716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39564, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+118542,int_stack+32304,int_stack+31968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39942, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+119046,int_stack+118542,int_stack+118164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82434, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+119802,int_stack+32736,int_stack+32304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40446, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+120450,int_stack+119802,int_stack+118542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82812, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+121458,int_stack+120450,int_stack+119046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83316, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+122718,int_stack+33276,int_stack+32736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41094, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+123528,int_stack+122718,int_stack+119802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84072, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+124824,int_stack+123528,int_stack+120450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84720, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+126504,int_stack+124824,int_stack+121458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85728, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+128394,int_stack+792,int_stack+33276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1980, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+129384,int_stack+128394,int_stack+122718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86988, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+131004,int_stack+129384,int_stack+123528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87798, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+128394,int_stack+131004,int_stack+124824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89094, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+130914,int_stack+34584,int_stack+34332, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+131292,int_stack+34920,int_stack+34584, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+131796,int_stack+131292,int_stack+130914, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+132552,int_stack+35352,int_stack+34920, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+132552,int_stack+131292, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+133200,int_stack+0,int_stack+131796, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+134460,int_stack+35892,int_stack+35352, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+135270,int_stack+134460,int_stack+132552, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+136566,int_stack+135270,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+138246,int_stack+136566,int_stack+133200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+140136,int_stack+1188,int_stack+35892, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+141126,int_stack+140136,int_stack+134460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+142746,int_stack+141126,int_stack+135270, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+140136,int_stack+142746,int_stack+136566, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+142656,int_stack+37200,int_stack+36948, 0.0, zero_stack, 1.0, int_stack+39564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+143034,int_stack+37536,int_stack+37200, 0.0, zero_stack, 1.0, int_stack+39942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+143538,int_stack+143034,int_stack+142656, 0.0, zero_stack, 1.0, int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+144294,int_stack+37968,int_stack+37536, 0.0, zero_stack, 1.0, int_stack+40446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+144942,int_stack+144294,int_stack+143034, 0.0, zero_stack, 1.0, int_stack+82812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+145950,int_stack+144942,int_stack+143538, 0.0, zero_stack, 1.0, int_stack+83316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+147210,int_stack+38508,int_stack+37968, 0.0, zero_stack, 1.0, int_stack+41094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+148020,int_stack+147210,int_stack+144294, 0.0, zero_stack, 1.0, int_stack+84072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+149316,int_stack+148020,int_stack+144942, 0.0, zero_stack, 1.0, int_stack+84720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+150996,int_stack+149316,int_stack+145950, 0.0, zero_stack, 1.0, int_stack+85728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+152886,int_stack+1584,int_stack+38508, 0.0, zero_stack, 1.0, int_stack+1980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+153876,int_stack+152886,int_stack+147210, 0.0, zero_stack, 1.0, int_stack+86988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+155496,int_stack+153876,int_stack+148020, 0.0, zero_stack, 1.0, int_stack+87798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+152886,int_stack+155496,int_stack+149316, 0.0, zero_stack, 1.0, int_stack+89094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+155406,int_stack+40110,int_stack+39690, 1.0, int_stack+39564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+155784,int_stack+40662,int_stack+40110, 1.0, int_stack+39942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+156288,int_stack+155784,int_stack+155406, 1.0, int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+157044,int_stack+41364,int_stack+40662, 1.0, int_stack+40446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+157692,int_stack+157044,int_stack+155784, 1.0, int_stack+82812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+158700,int_stack+157692,int_stack+156288, 1.0, int_stack+83316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+41904,int_stack+41364, 1.0, int_stack+41094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+159960,int_stack+82434,int_stack+157044, 1.0, int_stack+84072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+161256,int_stack+159960,int_stack+157692, 1.0, int_stack+84720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+83244,int_stack+161256,int_stack+158700, 1.0, int_stack+85728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+85134,int_stack+2310,int_stack+41904, 1.0, int_stack+1980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1008,int_stack+85134,int_stack+82434, 1.0, int_stack+86988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+85134,int_stack+1008,int_stack+159960, 1.0, int_stack+87798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+162936,int_stack+85134,int_stack+161256, 1.0, int_stack+89094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+85134,int_stack+50742,int_stack+50490,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+85512,int_stack+51078,int_stack+50742,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+86016,int_stack+85512,int_stack+85134,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+86772,int_stack+51510,int_stack+51078,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+87420,int_stack+86772,int_stack+85512,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+88428,int_stack+87420,int_stack+86016,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+89688,int_stack+52050,int_stack+51510,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1008,int_stack+89688,int_stack+86772,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+1008,int_stack+87420,6);
 /*--- compute (d0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+167136,int_stack+165456,int_stack+88428,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+169026,int_stack+2706,int_stack+52050,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+170016,int_stack+169026,int_stack+89688,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+171636,int_stack+170016,int_stack+1008,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+169026,int_stack+171636,int_stack+165456,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+171546,int_stack+62394,int_stack+62142,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+171924,int_stack+62730,int_stack+62394,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+172428,int_stack+171924,int_stack+171546,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+173184,int_stack+63162,int_stack+62730,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+173832,int_stack+173184,int_stack+171924,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+174840,int_stack+173832,int_stack+172428,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+176100,int_stack+63702,int_stack+63162,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+176910,int_stack+176100,int_stack+173184,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+178206,int_stack+176910,int_stack+173832,6);
 /*--- compute (d0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+179886,int_stack+178206,int_stack+174840,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+181776,int_stack+3102,int_stack+63702,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+182766,int_stack+181776,int_stack+176100,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+184386,int_stack+182766,int_stack+176910,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+181776,int_stack+184386,int_stack+178206,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+184296,int_stack+75552,int_stack+75300,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+184674,int_stack+75888,int_stack+75552,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+185178,int_stack+184674,int_stack+184296,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+185934,int_stack+76320,int_stack+75888,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2304,int_stack+185934,int_stack+184674,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+186582,int_stack+2304,int_stack+185178,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+187842,int_stack+76860,int_stack+76320,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+188652,int_stack+187842,int_stack+185934,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+189948,int_stack+188652,int_stack+2304,6);
 /*--- compute (d0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+191628,int_stack+189948,int_stack+186582,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+193518,int_stack+3498,int_stack+76860,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+194508,int_stack+193518,int_stack+187842,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+196128,int_stack+194508,int_stack+188652,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+193518,int_stack+196128,int_stack+189948,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+196038,int_stack+4020,int_stack+3894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+26484,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+196416,int_stack+4188,int_stack+4020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+26736,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+196920,int_stack+196416,int_stack+196038, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+92664,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+197676,int_stack+4404,int_stack+4188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+27072,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3312,int_stack+197676,int_stack+196416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+93042,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+198324,int_stack+3312,int_stack+196920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+93546,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+196038,int_stack+4674,int_stack+4404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+27504,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+199584,int_stack+196038,int_stack+197676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+94302,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+200880,int_stack+199584,int_stack+3312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+94950,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+202560,int_stack+200880,int_stack+198324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+95958,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3312,int_stack+5004,int_stack+4674, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+28044,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+196848,int_stack+3312,int_stack+196038, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+97218,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+204450,int_stack+196848,int_stack+199584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+98028,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+196038,int_stack+204450,int_stack+200880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+99324,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+204450,int_stack+5526,int_stack+5400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26484, 1.0, int_stack+29100,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+204828,int_stack+5694,int_stack+5526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26736, 1.0, int_stack+29352,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+205332,int_stack+204828,int_stack+204450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92664, 1.0, int_stack+105414,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+206088,int_stack+5910,int_stack+5694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27072, 1.0, int_stack+29688,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+198558,int_stack+206088,int_stack+204828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+93042, 1.0, int_stack+105792,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+199566,int_stack+198558,int_stack+205332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+93546, 1.0, int_stack+106296,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+204450,int_stack+6180,int_stack+5910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27504, 1.0, int_stack+30120,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+200826,int_stack+204450,int_stack+206088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94302, 1.0, int_stack+107052,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+205260,int_stack+200826,int_stack+198558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94950, 1.0, int_stack+107700,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3312,int_stack+205260,int_stack+199566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95958, 1.0, int_stack+108708,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+198558,int_stack+6510,int_stack+6180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28044, 1.0, int_stack+30660,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5202,int_stack+198558,int_stack+204450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97218, 1.0, int_stack+109968,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+198558,int_stack+5202,int_stack+200826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98028, 1.0, int_stack+110778,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+206940,int_stack+198558,int_stack+205260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99324, 1.0, int_stack+112074,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+198558,int_stack+7032,int_stack+6906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+29100, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+198936,int_stack+7200,int_stack+7032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+29352, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+199440,int_stack+198936,int_stack+198558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+105414, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+200196,int_stack+7416,int_stack+7200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+29688, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+200844,int_stack+200196,int_stack+198936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+105792, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+5202,int_stack+200844,int_stack+199440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+106296, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+7686,int_stack+7416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+30120, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+204450,int_stack+198558,int_stack+200196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+107052, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+209460,int_stack+204450,int_stack+200844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+107700, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+199368,int_stack+209460,int_stack+5202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+108708, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+5202,int_stack+8016,int_stack+7686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+30660, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6192,int_stack+5202,int_stack+198558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+109968, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+211140,int_stack+6192,int_stack+204450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+110778, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+5202,int_stack+211140,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+112074, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+209460,int_stack+8538,int_stack+8412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26484, 0.0, zero_stack, 1.0, int_stack+31716,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+209838,int_stack+8706,int_stack+8538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26736, 0.0, zero_stack, 1.0, int_stack+31968,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+210342,int_stack+209838,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92664, 0.0, zero_stack, 1.0, int_stack+118164,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+211098,int_stack+8922,int_stack+8706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27072, 0.0, zero_stack, 1.0, int_stack+32304,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+211746,int_stack+211098,int_stack+209838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+93042, 0.0, zero_stack, 1.0, int_stack+118542,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+204450,int_stack+211746,int_stack+210342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+93546, 0.0, zero_stack, 1.0, int_stack+119046,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+9192,int_stack+8922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27504, 0.0, zero_stack, 1.0, int_stack+32736,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+198558,int_stack+211098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94302, 0.0, zero_stack, 1.0, int_stack+119802,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+212754,int_stack+209460,int_stack+211746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94950, 0.0, zero_stack, 1.0, int_stack+120450,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+210756,int_stack+212754,int_stack+204450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95958, 0.0, zero_stack, 1.0, int_stack+121458,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+204450,int_stack+9522,int_stack+9192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28044, 0.0, zero_stack, 1.0, int_stack+33276,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7722,int_stack+204450,int_stack+198558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97218, 0.0, zero_stack, 1.0, int_stack+122718,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+204450,int_stack+7722,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98028, 0.0, zero_stack, 1.0, int_stack+123528,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+214434,int_stack+204450,int_stack+212754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99324, 0.0, zero_stack, 1.0, int_stack+124824,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+204450,int_stack+10044,int_stack+9918, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29100, 1.0, int_stack+31716, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+204828,int_stack+10212,int_stack+10044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29352, 1.0, int_stack+31968, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+205332,int_stack+204828,int_stack+204450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105414, 1.0, int_stack+118164, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+206088,int_stack+10428,int_stack+10212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29688, 1.0, int_stack+32304, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+209460,int_stack+206088,int_stack+204828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105792, 1.0, int_stack+118542, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7722,int_stack+209460,int_stack+205332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106296, 1.0, int_stack+119046, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+10698,int_stack+10428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30120, 1.0, int_stack+32736, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+204450,int_stack+198558,int_stack+206088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107052, 1.0, int_stack+119802, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+8982,int_stack+204450,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107700, 1.0, int_stack+120450, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+216954,int_stack+8982,int_stack+7722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108708, 1.0, int_stack+121458, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7722,int_stack+11028,int_stack+10698, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30660, 1.0, int_stack+33276, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+212646,int_stack+7722,int_stack+198558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109968, 1.0, int_stack+122718, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+218844,int_stack+212646,int_stack+204450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110778, 1.0, int_stack+123528, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+221004,int_stack+218844,int_stack+8982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112074, 1.0, int_stack+124824, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+218844,int_stack+11550,int_stack+11424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+31716, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+219222,int_stack+11718,int_stack+11550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+31968, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+219726,int_stack+219222,int_stack+218844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+118164, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+204450,int_stack+11934,int_stack+11718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+32304, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+205098,int_stack+204450,int_stack+219222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+118542, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+212646,int_stack+205098,int_stack+219726, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+119046, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+12204,int_stack+11934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+32736, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+198558,int_stack+204450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+119802, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+218844,int_stack+209460,int_stack+205098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+120450, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+204450,int_stack+218844,int_stack+212646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+121458, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+212646,int_stack+12534,int_stack+12204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+33276, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7722,int_stack+212646,int_stack+198558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+122718, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+9342,int_stack+7722,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+123528, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+223524,int_stack+9342,int_stack+218844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+124824, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+218844,int_stack+13056,int_stack+12930, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34332,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+219222,int_stack+13224,int_stack+13056, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26736, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34584,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+219726,int_stack+219222,int_stack+218844, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92664, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+130914,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+209460,int_stack+13440,int_stack+13224, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27072, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34920,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7722,int_stack+209460,int_stack+219222, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+93042, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+131292,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+8730,int_stack+7722,int_stack+219726, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+93546, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+131796,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+13710,int_stack+13440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27504, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35352,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+218844,int_stack+198558,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94302, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+132552,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+9990,int_stack+218844,int_stack+7722, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94950, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+11670,int_stack+9990,int_stack+8730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95958, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133200,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7722,int_stack+14040,int_stack+13710, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28044, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35892,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+212646,int_stack+7722,int_stack+198558, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97218, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134460,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7722,int_stack+212646,int_stack+218844, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98028, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135270,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+226044,int_stack+7722,int_stack+9990, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99324, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+136566,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7722,int_stack+14562,int_stack+14436, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29100, 0.0, zero_stack, 1.0, int_stack+34332, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8100,int_stack+14730,int_stack+14562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29352, 0.0, zero_stack, 1.0, int_stack+34584, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8604,int_stack+8100,int_stack+7722, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105414, 0.0, zero_stack, 1.0, int_stack+130914, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9360,int_stack+14946,int_stack+14730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29688, 0.0, zero_stack, 1.0, int_stack+34920, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+10008,int_stack+9360,int_stack+8100, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105792, 0.0, zero_stack, 1.0, int_stack+131292, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+218844,int_stack+10008,int_stack+8604, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106296, 0.0, zero_stack, 1.0, int_stack+131796, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+15216,int_stack+14946, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30120, 0.0, zero_stack, 1.0, int_stack+35352, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+198558,int_stack+9360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107052, 0.0, zero_stack, 1.0, int_stack+132552, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7722,int_stack+209460,int_stack+10008, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107700, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+9402,int_stack+7722,int_stack+218844, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108708, 0.0, zero_stack, 1.0, int_stack+133200, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+218844,int_stack+15546,int_stack+15216, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30660, 0.0, zero_stack, 1.0, int_stack+35892, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+212646,int_stack+218844,int_stack+198558, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109968, 0.0, zero_stack, 1.0, int_stack+134460, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+218844,int_stack+212646,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110778, 0.0, zero_stack, 1.0, int_stack+135270, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+228564,int_stack+218844,int_stack+7722, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112074, 0.0, zero_stack, 1.0, int_stack+136566, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+16068,int_stack+15942, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31716, 1.0, int_stack+34332, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7722,int_stack+16236,int_stack+16068, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31968, 1.0, int_stack+34584, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8226,int_stack+7722,int_stack+11292, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+118164, 1.0, int_stack+130914, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+218844,int_stack+16452,int_stack+16236, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32304, 1.0, int_stack+34920, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+219492,int_stack+218844,int_stack+7722, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+118542, 1.0, int_stack+131292, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+209460,int_stack+219492,int_stack+8226, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119046, 1.0, int_stack+131796, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+16722,int_stack+16452, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32736, 1.0, int_stack+35352, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7722,int_stack+198558,int_stack+218844, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119802, 1.0, int_stack+132552, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+212646,int_stack+7722,int_stack+219492, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+120450, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+218844,int_stack+212646,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+121458, 1.0, int_stack+133200, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+209460,int_stack+17052,int_stack+16722, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33276, 1.0, int_stack+35892, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+13560,int_stack+209460,int_stack+198558, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122718, 1.0, int_stack+134460, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+15180,int_stack+13560,int_stack+7722, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123528, 1.0, int_stack+135270, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+231084,int_stack+15180,int_stack+212646, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124824, 1.0, int_stack+136566, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+17574,int_stack+17448, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+34332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+212646,int_stack+17742,int_stack+17574, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+34584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+213150,int_stack+212646,int_stack+11292, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+130914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7722,int_stack+17958,int_stack+17742, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+34920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8370,int_stack+7722,int_stack+212646, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+131292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+8370,int_stack+213150, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+131796, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+18228,int_stack+17958, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+35352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+198558,int_stack+7722, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+132552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+212646,int_stack+209460,int_stack+8370, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+14820,int_stack+212646,int_stack+13560, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+133200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+18558,int_stack+18228, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+35892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7722,int_stack+13560,int_stack+198558, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+134460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+16710,int_stack+7722,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+135270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+233604,int_stack+16710,int_stack+212646, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+136566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+19080,int_stack+18954, 0.0, zero_stack, 1.0, int_stack+26484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36948,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+212646,int_stack+19248,int_stack+19080, 0.0, zero_stack, 1.0, int_stack+26736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37200,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+213150,int_stack+212646,int_stack+11292, 0.0, zero_stack, 1.0, int_stack+92664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142656,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+16710,int_stack+19464,int_stack+19248, 0.0, zero_stack, 1.0, int_stack+27072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37536,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17358,int_stack+16710,int_stack+212646, 0.0, zero_stack, 1.0, int_stack+93042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143034,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+17358,int_stack+213150, 0.0, zero_stack, 1.0, int_stack+93546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143538,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+19734,int_stack+19464, 0.0, zero_stack, 1.0, int_stack+27504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37968,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+198558,int_stack+16710, 0.0, zero_stack, 1.0, int_stack+94302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144294,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7722,int_stack+209460,int_stack+17358, 0.0, zero_stack, 1.0, int_stack+94950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144942,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+16710,int_stack+7722,int_stack+13560, 0.0, zero_stack, 1.0, int_stack+95958, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145950,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+20064,int_stack+19734, 0.0, zero_stack, 1.0, int_stack+28044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38508,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+18600,int_stack+13560,int_stack+198558, 0.0, zero_stack, 1.0, int_stack+97218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147210,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+236124,int_stack+18600,int_stack+209460, 0.0, zero_stack, 1.0, int_stack+98028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+148020,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+238284,int_stack+236124,int_stack+7722, 0.0, zero_stack, 1.0, int_stack+99324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+149316,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+20586,int_stack+20460, 0.0, zero_stack, 1.0, int_stack+29100, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36948, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7722,int_stack+20754,int_stack+20586, 0.0, zero_stack, 1.0, int_stack+29352, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37200, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8226,int_stack+7722,int_stack+11292, 0.0, zero_stack, 1.0, int_stack+105414, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142656, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+236124,int_stack+20970,int_stack+20754, 0.0, zero_stack, 1.0, int_stack+29688, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37536, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+236772,int_stack+236124,int_stack+7722, 0.0, zero_stack, 1.0, int_stack+105792, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143034, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+236772,int_stack+8226, 0.0, zero_stack, 1.0, int_stack+106296, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143538, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+21240,int_stack+20970, 0.0, zero_stack, 1.0, int_stack+30120, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37968, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+198558,int_stack+236124, 0.0, zero_stack, 1.0, int_stack+107052, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144294, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7722,int_stack+209460,int_stack+236772, 0.0, zero_stack, 1.0, int_stack+107700, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144942, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+236124,int_stack+7722,int_stack+13560, 0.0, zero_stack, 1.0, int_stack+108708, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145950, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+21570,int_stack+21240, 0.0, zero_stack, 1.0, int_stack+30660, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38508, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+18600,int_stack+13560,int_stack+198558, 0.0, zero_stack, 1.0, int_stack+109968, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147210, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+240804,int_stack+18600,int_stack+209460, 0.0, zero_stack, 1.0, int_stack+110778, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+148020, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+18600,int_stack+240804,int_stack+7722, 0.0, zero_stack, 1.0, int_stack+112074, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+149316, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+22092,int_stack+21966, 0.0, zero_stack, 1.0, int_stack+31716, 0.0, zero_stack, 1.0, int_stack+36948, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7722,int_stack+22260,int_stack+22092, 0.0, zero_stack, 1.0, int_stack+31968, 0.0, zero_stack, 1.0, int_stack+37200, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8226,int_stack+7722,int_stack+11292, 0.0, zero_stack, 1.0, int_stack+118164, 0.0, zero_stack, 1.0, int_stack+142656, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+240804,int_stack+22476,int_stack+22260, 0.0, zero_stack, 1.0, int_stack+32304, 0.0, zero_stack, 1.0, int_stack+37536, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+241452,int_stack+240804,int_stack+7722, 0.0, zero_stack, 1.0, int_stack+118542, 0.0, zero_stack, 1.0, int_stack+143034, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+241452,int_stack+8226, 0.0, zero_stack, 1.0, int_stack+119046, 0.0, zero_stack, 1.0, int_stack+143538, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+22746,int_stack+22476, 0.0, zero_stack, 1.0, int_stack+32736, 0.0, zero_stack, 1.0, int_stack+37968, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+198558,int_stack+240804, 0.0, zero_stack, 1.0, int_stack+119802, 0.0, zero_stack, 1.0, int_stack+144294, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7722,int_stack+209460,int_stack+241452, 0.0, zero_stack, 1.0, int_stack+120450, 0.0, zero_stack, 1.0, int_stack+144942, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+240804,int_stack+7722,int_stack+13560, 0.0, zero_stack, 1.0, int_stack+121458, 0.0, zero_stack, 1.0, int_stack+145950, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+23076,int_stack+22746, 0.0, zero_stack, 1.0, int_stack+33276, 0.0, zero_stack, 1.0, int_stack+38508, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+21120,int_stack+13560,int_stack+198558, 0.0, zero_stack, 1.0, int_stack+122718, 0.0, zero_stack, 1.0, int_stack+147210, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+242694,int_stack+21120,int_stack+209460, 0.0, zero_stack, 1.0, int_stack+123528, 0.0, zero_stack, 1.0, int_stack+148020, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+244854,int_stack+242694,int_stack+7722, 0.0, zero_stack, 1.0, int_stack+124824, 0.0, zero_stack, 1.0, int_stack+149316, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+23598,int_stack+23472, 0.0, zero_stack, 1.0, int_stack+34332, 1.0, int_stack+36948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7722,int_stack+23766,int_stack+23598, 0.0, zero_stack, 1.0, int_stack+34584, 1.0, int_stack+37200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8226,int_stack+7722,int_stack+11292, 0.0, zero_stack, 1.0, int_stack+130914, 1.0, int_stack+142656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+242694,int_stack+23982,int_stack+23766, 0.0, zero_stack, 1.0, int_stack+34920, 1.0, int_stack+37536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+243342,int_stack+242694,int_stack+7722, 0.0, zero_stack, 1.0, int_stack+131292, 1.0, int_stack+143034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+243342,int_stack+8226, 0.0, zero_stack, 1.0, int_stack+131796, 1.0, int_stack+143538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+24252,int_stack+23982, 0.0, zero_stack, 1.0, int_stack+35352, 1.0, int_stack+37968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+198558,int_stack+242694, 0.0, zero_stack, 1.0, int_stack+132552, 1.0, int_stack+144294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7722,int_stack+209460,int_stack+243342, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+144942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+242694,int_stack+7722,int_stack+13560, 0.0, zero_stack, 1.0, int_stack+133200, 1.0, int_stack+145950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+24582,int_stack+24252, 0.0, zero_stack, 1.0, int_stack+35892, 1.0, int_stack+38508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+21120,int_stack+13560,int_stack+198558, 0.0, zero_stack, 1.0, int_stack+134460, 1.0, int_stack+147210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+22740,int_stack+21120,int_stack+209460, 0.0, zero_stack, 1.0, int_stack+135270, 1.0, int_stack+148020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+247374,int_stack+22740,int_stack+7722, 0.0, zero_stack, 1.0, int_stack+136566, 1.0, int_stack+149316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+25104,int_stack+24978, 0.0, zero_stack, 2.0, int_stack+36948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7722,int_stack+25272,int_stack+25104, 0.0, zero_stack, 2.0, int_stack+37200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8226,int_stack+7722,int_stack+11292, 0.0, zero_stack, 2.0, int_stack+142656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+209460,int_stack+25488,int_stack+25272, 0.0, zero_stack, 2.0, int_stack+37536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+21120,int_stack+209460,int_stack+7722, 0.0, zero_stack, 2.0, int_stack+143034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+21120,int_stack+8226, 0.0, zero_stack, 2.0, int_stack+143538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+25758,int_stack+25488, 0.0, zero_stack, 2.0, int_stack+37968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7722,int_stack+198558,int_stack+209460, 0.0, zero_stack, 2.0, int_stack+144294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22128,int_stack+7722,int_stack+21120, 0.0, zero_stack, 2.0, int_stack+144942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+23808,int_stack+22128,int_stack+13560, 0.0, zero_stack, 2.0, int_stack+145950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+26088,int_stack+25758, 0.0, zero_stack, 2.0, int_stack+38508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+212646,int_stack+13560,int_stack+198558, 0.0, zero_stack, 2.0, int_stack+147210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+249894,int_stack+212646,int_stack+7722, 0.0, zero_stack, 2.0, int_stack+148020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+252054,int_stack+249894,int_stack+22128, 0.0, zero_stack, 2.0, int_stack+149316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+26904,int_stack+26610, 1.0, int_stack+26484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39690,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+249894,int_stack+27288,int_stack+26904, 1.0, int_stack+26736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40110,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+250398,int_stack+249894,int_stack+11292, 1.0, int_stack+92664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155406,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+251154,int_stack+27774,int_stack+27288, 1.0, int_stack+27072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40662,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7722,int_stack+251154,int_stack+249894, 1.0, int_stack+93042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155784,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+7722,int_stack+250398, 1.0, int_stack+93546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156288,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+28374,int_stack+27774, 1.0, int_stack+27504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41364,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+198558,int_stack+251154, 1.0, int_stack+94302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157044,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+249894,int_stack+209460,int_stack+7722, 1.0, int_stack+94950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157692,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+92664,int_stack+249894,int_stack+13560, 1.0, int_stack+95958, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158700,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+28704,int_stack+28374, 1.0, int_stack+28044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41904,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7722,int_stack+13560,int_stack+198558, 1.0, int_stack+97218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82434,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+94554,int_stack+7722,int_stack+209460, 1.0, int_stack+98028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159960,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+96714,int_stack+94554,int_stack+249894, 1.0, int_stack+99324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161256,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+29520,int_stack+29226, 1.0, int_stack+29100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39690, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+249894,int_stack+29904,int_stack+29520, 1.0, int_stack+29352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40110, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+250398,int_stack+249894,int_stack+11292, 1.0, int_stack+105414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155406, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+251154,int_stack+30390,int_stack+29904, 1.0, int_stack+29688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40662, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+94554,int_stack+251154,int_stack+249894, 1.0, int_stack+105792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155784, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+94554,int_stack+250398, 1.0, int_stack+106296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156288, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+30990,int_stack+30390, 1.0, int_stack+30120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41364, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+198558,int_stack+251154, 1.0, int_stack+107052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157044, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7722,int_stack+209460,int_stack+94554, 1.0, int_stack+107700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157692, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+94554,int_stack+7722,int_stack+13560, 1.0, int_stack+108708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158700, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+31320,int_stack+30990, 1.0, int_stack+30660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41904, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+249894,int_stack+13560,int_stack+198558, 1.0, int_stack+109968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82434, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+105414,int_stack+249894,int_stack+209460, 1.0, int_stack+110778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159960, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+107574,int_stack+105414,int_stack+7722, 1.0, int_stack+112074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161256, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+32136,int_stack+31842, 1.0, int_stack+31716, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39690, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7722,int_stack+32520,int_stack+32136, 1.0, int_stack+31968, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40110, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8226,int_stack+7722,int_stack+11292, 1.0, int_stack+118164, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155406, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+105414,int_stack+33006,int_stack+32520, 1.0, int_stack+32304, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40662, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+106062,int_stack+105414,int_stack+7722, 1.0, int_stack+118542, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155784, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+106062,int_stack+8226, 1.0, int_stack+119046, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156288, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+33606,int_stack+33006, 1.0, int_stack+32736, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41364, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+198558,int_stack+105414, 1.0, int_stack+119802, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157044, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7722,int_stack+209460,int_stack+106062, 1.0, int_stack+120450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157692, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+105414,int_stack+7722,int_stack+13560, 1.0, int_stack+121458, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158700, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+33936,int_stack+33606, 1.0, int_stack+33276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41904, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+118164,int_stack+13560,int_stack+198558, 1.0, int_stack+122718, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82434, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+249894,int_stack+118164,int_stack+209460, 1.0, int_stack+123528, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159960, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+118164,int_stack+249894,int_stack+7722, 1.0, int_stack+124824, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161256, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+34752,int_stack+34458, 1.0, int_stack+34332, 0.0, zero_stack, 1.0, int_stack+39690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7722,int_stack+35136,int_stack+34752, 1.0, int_stack+34584, 0.0, zero_stack, 1.0, int_stack+40110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8226,int_stack+7722,int_stack+11292, 1.0, int_stack+130914, 0.0, zero_stack, 1.0, int_stack+155406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+249894,int_stack+35622,int_stack+35136, 1.0, int_stack+34920, 0.0, zero_stack, 1.0, int_stack+40662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+250542,int_stack+249894,int_stack+7722, 1.0, int_stack+131292, 0.0, zero_stack, 1.0, int_stack+155784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+250542,int_stack+8226, 1.0, int_stack+131796, 0.0, zero_stack, 1.0, int_stack+156288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+36222,int_stack+35622, 1.0, int_stack+35352, 0.0, zero_stack, 1.0, int_stack+41364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+198558,int_stack+249894, 1.0, int_stack+132552, 0.0, zero_stack, 1.0, int_stack+157044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7722,int_stack+209460,int_stack+250542, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+157692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+249894,int_stack+7722,int_stack+13560, 1.0, int_stack+133200, 0.0, zero_stack, 1.0, int_stack+158700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+36552,int_stack+36222, 1.0, int_stack+35892, 0.0, zero_stack, 1.0, int_stack+41904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+130914,int_stack+13560,int_stack+198558, 1.0, int_stack+134460, 0.0, zero_stack, 1.0, int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+132534,int_stack+130914,int_stack+209460, 1.0, int_stack+135270, 0.0, zero_stack, 1.0, int_stack+159960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+120684,int_stack+132534,int_stack+7722, 1.0, int_stack+136566, 0.0, zero_stack, 1.0, int_stack+161256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+37368,int_stack+37074, 1.0, int_stack+36948, 1.0, int_stack+39690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7722,int_stack+37752,int_stack+37368, 1.0, int_stack+37200, 1.0, int_stack+40110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8226,int_stack+7722,int_stack+11292, 1.0, int_stack+142656, 1.0, int_stack+155406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+209460,int_stack+38238,int_stack+37752, 1.0, int_stack+37536, 1.0, int_stack+40662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+209460,int_stack+7722, 1.0, int_stack+143034, 1.0, int_stack+155784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+0,int_stack+8226, 1.0, int_stack+143538, 1.0, int_stack+156288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+38838,int_stack+38238, 1.0, int_stack+37968, 1.0, int_stack+41364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7722,int_stack+198558,int_stack+209460, 1.0, int_stack+144294, 1.0, int_stack+157044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+142656,int_stack+7722,int_stack+0, 1.0, int_stack+144942, 1.0, int_stack+157692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+130914,int_stack+142656,int_stack+13560, 1.0, int_stack+145950, 1.0, int_stack+158700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+39168,int_stack+38838, 1.0, int_stack+38508, 1.0, int_stack+41904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+144336,int_stack+13560,int_stack+198558, 1.0, int_stack+147210, 1.0, int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+132804,int_stack+144336,int_stack+7722, 1.0, int_stack+148020, 1.0, int_stack+159960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+144336,int_stack+132804,int_stack+142656, 1.0, int_stack+149316, 1.0, int_stack+161256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+40278,int_stack+39816, 2.0, int_stack+39690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+142656,int_stack+40878,int_stack+40278, 2.0, int_stack+40110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+143160,int_stack+142656,int_stack+11292, 2.0, int_stack+155406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+132804,int_stack+41634,int_stack+40878, 2.0, int_stack+40662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+132804,int_stack+142656, 2.0, int_stack+155784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+0,int_stack+143160, 2.0, int_stack+156288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+198558,int_stack+42234,int_stack+41634, 2.0, int_stack+41364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+198558,int_stack+132804, 2.0, int_stack+157044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+142656,int_stack+209460,int_stack+0, 2.0, int_stack+157692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+132804,int_stack+142656,int_stack+13560, 2.0, int_stack+158700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+42564,int_stack+42234, 2.0, int_stack+41904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+134694,int_stack+13560,int_stack+198558, 2.0, int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+155406,int_stack+134694,int_stack+209460, 2.0, int_stack+159960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+134694,int_stack+155406,int_stack+142656, 2.0, int_stack+161256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+43086,int_stack+42960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50490,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+142656,int_stack+43254,int_stack+43086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50742,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+143160,int_stack+142656,int_stack+11292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85134,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+155406,int_stack+43470,int_stack+43254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51078,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+155406,int_stack+142656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85512,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+0,int_stack+143160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86016,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+43740,int_stack+43470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51510,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+155406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86772,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+142656,int_stack+209460,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87420,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+155406,int_stack+142656,int_stack+13560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88428,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+44070,int_stack+43740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52050,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+157296,int_stack+13560,int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89688,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+158916,int_stack+157296,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1008,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+146856,int_stack+158916,int_stack+142656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165456,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+44592,int_stack+44466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50490, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+142656,int_stack+44760,int_stack+44592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50742, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+143160,int_stack+142656,int_stack+11292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85134, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+209460,int_stack+44976,int_stack+44760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51078, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+209460,int_stack+142656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85512, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+0,int_stack+143160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86016, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+45246,int_stack+44976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51510, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+142656,int_stack+82434,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86772, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7722,int_stack+142656,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87420, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+157296,int_stack+7722,int_stack+13560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88428, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+45576,int_stack+45246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52050, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89688, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+159186,int_stack+149376,int_stack+142656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1008, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+123204,int_stack+159186,int_stack+7722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165456, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+46098,int_stack+45972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50490, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7722,int_stack+46266,int_stack+46098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50742, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8226,int_stack+7722,int_stack+11292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85134, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+159186,int_stack+46482,int_stack+46266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51078, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+159186,int_stack+7722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85512, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+0,int_stack+8226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86016, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+46752,int_stack+46482, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51510, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+159186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86772, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7722,int_stack+209460,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87420, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+159186,int_stack+7722,int_stack+13560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88428, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+47082,int_stack+46752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52050, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89688, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+110094,int_stack+149376,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1008, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+21120,int_stack+110094,int_stack+7722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165456, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+47604,int_stack+47478, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7722,int_stack+47772,int_stack+47604, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50742, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8226,int_stack+7722,int_stack+11292, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+110094,int_stack+47988,int_stack+47772, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+110094,int_stack+7722, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+0,int_stack+8226, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+48258,int_stack+47988, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+110094, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7722,int_stack+209460,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+110094,int_stack+7722,int_stack+13560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+48588,int_stack+48258, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+25698,int_stack+149376,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+27858,int_stack+25698,int_stack+7722, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+49110,int_stack+48984, 0.0, zero_stack, 1.0, int_stack+50490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7722,int_stack+49278,int_stack+49110, 0.0, zero_stack, 1.0, int_stack+50742, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8226,int_stack+7722,int_stack+11292, 0.0, zero_stack, 1.0, int_stack+85134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+25698,int_stack+49494,int_stack+49278, 0.0, zero_stack, 1.0, int_stack+51078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+25698,int_stack+7722, 0.0, zero_stack, 1.0, int_stack+85512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+0,int_stack+8226, 0.0, zero_stack, 1.0, int_stack+86016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+49764,int_stack+49494, 0.0, zero_stack, 1.0, int_stack+51510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+25698, 0.0, zero_stack, 1.0, int_stack+86772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7722,int_stack+209460,int_stack+0, 0.0, zero_stack, 1.0, int_stack+87420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+25698,int_stack+7722,int_stack+13560, 0.0, zero_stack, 1.0, int_stack+88428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+50094,int_stack+49764, 0.0, zero_stack, 1.0, int_stack+52050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 0.0, zero_stack, 1.0, int_stack+89688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+30378,int_stack+149376,int_stack+209460, 0.0, zero_stack, 1.0, int_stack+1008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+32538,int_stack+30378,int_stack+7722, 0.0, zero_stack, 1.0, int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+50910,int_stack+50616, 1.0, int_stack+50490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7722,int_stack+51294,int_stack+50910, 1.0, int_stack+50742, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8226,int_stack+7722,int_stack+11292, 1.0, int_stack+85134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+30378,int_stack+51780,int_stack+51294, 1.0, int_stack+51078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+30378,int_stack+7722, 1.0, int_stack+85512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+0,int_stack+8226, 1.0, int_stack+86016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+52380,int_stack+51780, 1.0, int_stack+51510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+30378, 1.0, int_stack+86772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7722,int_stack+209460,int_stack+0, 1.0, int_stack+87420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+30378,int_stack+7722,int_stack+13560, 1.0, int_stack+88428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+52710,int_stack+52380, 1.0, int_stack+52050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 1.0, int_stack+89688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+85134,int_stack+149376,int_stack+209460, 1.0, int_stack+1008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+87294,int_stack+85134,int_stack+7722, 1.0, int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+53232,int_stack+53106,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+53400,int_stack+53232,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+7722,int_stack+53616,int_stack+53400,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+8370,int_stack+7722,int_stack+165456,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+8370,int_stack+165960,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+53886,int_stack+53616,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+7722,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+8370,6);
 /*--- compute (d0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+85134,int_stack+165456,int_stack+13560,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+54216,int_stack+53886,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+0,int_stack+149376,int_stack+209460,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+35058,int_stack+0,int_stack+165456,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+54738,int_stack+54612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62142,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+54906,int_stack+54738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62394,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171546,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+55122,int_stack+54906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62730,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+648,int_stack+0,int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171924,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+648,int_stack+165960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172428,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+55392,int_stack+55122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63162,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173184,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173832,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+0,int_stack+165456,int_stack+13560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174840,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+55722,int_stack+55392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63702,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176100,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+37578,int_stack+149376,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176910,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+39738,int_stack+37578,int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178206,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+56244,int_stack+56118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62142, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+56412,int_stack+56244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62394, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171546, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+37578,int_stack+56628,int_stack+56412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62730, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+38226,int_stack+37578,int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171924, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+38226,int_stack+165960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172428, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+56898,int_stack+56628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63162, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+37578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173184, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+38226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173832, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+37578,int_stack+165456,int_stack+13560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174840, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+57228,int_stack+56898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63702, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176100, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+42258,int_stack+149376,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176910, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+44418,int_stack+42258,int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178206, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+57750,int_stack+57624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62142, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+57918,int_stack+57750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62394, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171546, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+42258,int_stack+58134,int_stack+57918, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62730, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+42906,int_stack+42258,int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171924, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+42906,int_stack+165960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172428, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+58404,int_stack+58134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63162, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+42258, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173184, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+42906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173832, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+42258,int_stack+165456,int_stack+13560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174840, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+58734,int_stack+58404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63702, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176100, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+46938,int_stack+149376,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176910, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+49098,int_stack+46938,int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178206, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+59256,int_stack+59130, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+59424,int_stack+59256, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+46938,int_stack+59640,int_stack+59424, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+47586,int_stack+46938,int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+47586,int_stack+165960, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+59910,int_stack+59640, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+46938, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+47586, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+46938,int_stack+165456,int_stack+13560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+60240,int_stack+59910, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+51618,int_stack+149376,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+53778,int_stack+51618,int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+60762,int_stack+60636, 0.0, zero_stack, 1.0, int_stack+62142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+60930,int_stack+60762, 0.0, zero_stack, 1.0, int_stack+62394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292, 0.0, zero_stack, 1.0, int_stack+171546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+51618,int_stack+61146,int_stack+60930, 0.0, zero_stack, 1.0, int_stack+62730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+52266,int_stack+51618,int_stack+165456, 0.0, zero_stack, 1.0, int_stack+171924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+52266,int_stack+165960, 0.0, zero_stack, 1.0, int_stack+172428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+61416,int_stack+61146, 0.0, zero_stack, 1.0, int_stack+63162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+51618, 0.0, zero_stack, 1.0, int_stack+173184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+52266, 0.0, zero_stack, 1.0, int_stack+173832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+51618,int_stack+165456,int_stack+13560, 0.0, zero_stack, 1.0, int_stack+174840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+61746,int_stack+61416, 0.0, zero_stack, 1.0, int_stack+63702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 0.0, zero_stack, 1.0, int_stack+176100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+56298,int_stack+149376,int_stack+209460, 0.0, zero_stack, 1.0, int_stack+176910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+58458,int_stack+56298,int_stack+165456, 0.0, zero_stack, 1.0, int_stack+178206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+62562,int_stack+62268, 1.0, int_stack+62142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+62946,int_stack+62562, 1.0, int_stack+62394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292, 1.0, int_stack+171546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+56298,int_stack+63432,int_stack+62946, 1.0, int_stack+62730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+56946,int_stack+56298,int_stack+165456, 1.0, int_stack+171924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+56946,int_stack+165960, 1.0, int_stack+172428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+64032,int_stack+63432, 1.0, int_stack+63162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+56298, 1.0, int_stack+173184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+56946, 1.0, int_stack+173832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+56298,int_stack+165456,int_stack+13560, 1.0, int_stack+174840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+64362,int_stack+64032, 1.0, int_stack+63702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 1.0, int_stack+176100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+171546,int_stack+149376,int_stack+209460, 1.0, int_stack+176910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+173706,int_stack+171546,int_stack+165456, 1.0, int_stack+178206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+64884,int_stack+64758,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+65052,int_stack+64884,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+171546,int_stack+65268,int_stack+65052,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+172194,int_stack+171546,int_stack+165456,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+172194,int_stack+165960,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+65538,int_stack+65268,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+171546,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+172194,6);
 /*--- compute (d0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+171546,int_stack+165456,int_stack+13560,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+65868,int_stack+65538,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+176226,int_stack+149376,int_stack+209460,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+60978,int_stack+176226,int_stack+165456,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+66390,int_stack+66264,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+66558,int_stack+66390,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+176226,int_stack+66774,int_stack+66558,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+176874,int_stack+176226,int_stack+165456,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+176874,int_stack+165960,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+67044,int_stack+66774,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+176226,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+176874,6);
 /*--- compute (d0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+176226,int_stack+165456,int_stack+13560,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+67374,int_stack+67044,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+63498,int_stack+149376,int_stack+209460,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+254574,int_stack+63498,int_stack+165456,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+67896,int_stack+67770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75300,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+68064,int_stack+67896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75552,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184296,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+63498,int_stack+68280,int_stack+68064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75888,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+64146,int_stack+63498,int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184674,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+64146,int_stack+165960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185178,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+68550,int_stack+68280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76320,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+63498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185934,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+64146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2304,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+63498,int_stack+165456,int_stack+13560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+186582,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+68880,int_stack+68550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76860,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187842,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+65388,int_stack+149376,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188652,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+257094,int_stack+65388,int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189948,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+69402,int_stack+69276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75300, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+69570,int_stack+69402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75552, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184296, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+65388,int_stack+69786,int_stack+69570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75888, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+66036,int_stack+65388,int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184674, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+66036,int_stack+165960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185178, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+70056,int_stack+69786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76320, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+65388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185934, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+66036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2304, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+65388,int_stack+165456,int_stack+13560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+186582, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+70386,int_stack+70056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76860, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187842, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+67278,int_stack+149376,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188652, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+259614,int_stack+67278,int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189948, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+70908,int_stack+70782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75300, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+71076,int_stack+70908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75552, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184296, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+67278,int_stack+71292,int_stack+71076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75888, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+67926,int_stack+67278,int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184674, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+67926,int_stack+165960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185178, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+71562,int_stack+71292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76320, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+67278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185934, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+67926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2304, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+67278,int_stack+165456,int_stack+13560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+186582, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+71892,int_stack+71562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76860, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187842, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+69168,int_stack+149376,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188652, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+262134,int_stack+69168,int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189948, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+72414,int_stack+72288, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+72582,int_stack+72414, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+69168,int_stack+72798,int_stack+72582, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+69816,int_stack+69168,int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184674, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+69816,int_stack+165960, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+73068,int_stack+72798, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+69168, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+69816, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+69168,int_stack+165456,int_stack+13560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+186582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+73398,int_stack+73068, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+71058,int_stack+149376,int_stack+209460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+264654,int_stack+71058,int_stack+165456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+73920,int_stack+73794, 0.0, zero_stack, 1.0, int_stack+75300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+74088,int_stack+73920, 0.0, zero_stack, 1.0, int_stack+75552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292, 0.0, zero_stack, 1.0, int_stack+184296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+71058,int_stack+74304,int_stack+74088, 0.0, zero_stack, 1.0, int_stack+75888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+71706,int_stack+71058,int_stack+165456, 0.0, zero_stack, 1.0, int_stack+184674, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+71706,int_stack+165960, 0.0, zero_stack, 1.0, int_stack+185178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+74574,int_stack+74304, 0.0, zero_stack, 1.0, int_stack+76320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+71058, 0.0, zero_stack, 1.0, int_stack+185934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+71706, 0.0, zero_stack, 1.0, int_stack+2304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+71058,int_stack+165456,int_stack+13560, 0.0, zero_stack, 1.0, int_stack+186582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+74904,int_stack+74574, 0.0, zero_stack, 1.0, int_stack+76860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 0.0, zero_stack, 1.0, int_stack+187842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+72948,int_stack+149376,int_stack+209460, 0.0, zero_stack, 1.0, int_stack+188652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+267174,int_stack+72948,int_stack+165456, 0.0, zero_stack, 1.0, int_stack+189948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+75720,int_stack+75426, 1.0, int_stack+75300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+76104,int_stack+75720, 1.0, int_stack+75552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292, 1.0, int_stack+184296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+72948,int_stack+76590,int_stack+76104, 1.0, int_stack+75888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+73596,int_stack+72948,int_stack+165456, 1.0, int_stack+184674, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+73596,int_stack+165960, 1.0, int_stack+185178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+77190,int_stack+76590, 1.0, int_stack+76320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+72948, 1.0, int_stack+185934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+73596, 1.0, int_stack+2304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+72948,int_stack+165456,int_stack+13560, 1.0, int_stack+186582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+77520,int_stack+77190, 1.0, int_stack+76860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434, 1.0, int_stack+187842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+74838,int_stack+149376,int_stack+209460, 1.0, int_stack+188652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+184296,int_stack+74838,int_stack+165456, 1.0, int_stack+189948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+78042,int_stack+77916,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+78210,int_stack+78042,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+74838,int_stack+78426,int_stack+78210,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+75486,int_stack+74838,int_stack+165456,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+75486,int_stack+165960,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+78696,int_stack+78426,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+74838,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+75486,6);
 /*--- compute (d0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+74838,int_stack+165456,int_stack+13560,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+79026,int_stack+78696,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+76728,int_stack+149376,int_stack+209460,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+186816,int_stack+76728,int_stack+165456,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+79548,int_stack+79422,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+79716,int_stack+79548,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+76728,int_stack+79932,int_stack+79716,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+77376,int_stack+76728,int_stack+165456,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+77376,int_stack+165960,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+80202,int_stack+79932,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+76728,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+77376,6);
 /*--- compute (d0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+76728,int_stack+165456,int_stack+13560,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+80532,int_stack+80202,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+78618,int_stack+149376,int_stack+209460,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+269694,int_stack+78618,int_stack+165456,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+11292,int_stack+81054,int_stack+80928,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+165456,int_stack+81222,int_stack+81054,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+165960,int_stack+165456,int_stack+11292,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+78618,int_stack+81438,int_stack+81222,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+79266,int_stack+78618,int_stack+165456,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+13560,int_stack+79266,int_stack+165960,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+82434,int_stack+81708,int_stack+81438,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+209460,int_stack+82434,int_stack+78618,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+165456,int_stack+209460,int_stack+79266,6);
 /*--- compute (d0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+78618,int_stack+165456,int_stack+13560,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+13560,int_stack+82038,int_stack+81708,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+149376,int_stack+13560,int_stack+82434,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+80508,int_stack+149376,int_stack+209460,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+272214,int_stack+80508,int_stack+165456,6);
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+80508,int_stack+102894,int_stack+101004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90774,6);
     Libderiv->ABCD[11] = int_stack + 80508;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+274734,int_stack+115644,int_stack+113754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90774, 0.0, zero_stack,6);
     Libderiv->ABCD[10] = int_stack + 274734;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+277380,int_stack+128394,int_stack+126504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90774, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[9] = int_stack + 277380;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+280026,int_stack+140136,int_stack+138246, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90774, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[8] = int_stack + 280026;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+140136,int_stack+152886,int_stack+150996, 0.0, zero_stack, 1.0, int_stack+90774, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[7] = int_stack + 140136;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+282672,int_stack+162936,int_stack+83244, 1.0, int_stack+90774, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[6] = int_stack + 282672;
 /*--- compute (d0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+89814,int_stack+169026,int_stack+167136,6);
     Libderiv->ABCD[2] = int_stack + 89814;
 /*--- compute (d0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+161076,int_stack+181776,int_stack+179886,6);
     Libderiv->ABCD[1] = int_stack + 161076;
 /*--- compute (d0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+163722,int_stack+193518,int_stack+191628,6);
     Libderiv->ABCD[0] = int_stack + 163722;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+285318,int_stack+196038,int_stack+202560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+101004,6);
     Libderiv->ABCD[155] = int_stack + 285318;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+193518,int_stack+206940,int_stack+3312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+101004, 1.0, int_stack+113754,6);
     Libderiv->ABCD[143] = int_stack + 193518;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+196164,int_stack+5202,int_stack+199368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+113754, 0.0, zero_stack,6);
     Libderiv->ABCD[142] = int_stack + 196164;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+198810,int_stack+214434,int_stack+210756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+101004, 0.0, zero_stack, 1.0, int_stack+126504,6);
     Libderiv->ABCD[131] = int_stack + 198810;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+201456,int_stack+221004,int_stack+216954, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113754, 1.0, int_stack+126504, 0.0, zero_stack,6);
     Libderiv->ABCD[130] = int_stack + 201456;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1890,int_stack+223524,int_stack+204450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+126504, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[129] = int_stack + 1890;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+204102,int_stack+226044,int_stack+11670, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+101004, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138246,6);
     Libderiv->ABCD[119] = int_stack + 204102;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+206748,int_stack+228564,int_stack+9402, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113754, 0.0, zero_stack, 1.0, int_stack+138246, 0.0, zero_stack,6);
     Libderiv->ABCD[118] = int_stack + 206748;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+209394,int_stack+231084,int_stack+218844, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+126504, 1.0, int_stack+138246, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[117] = int_stack + 209394;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+212040,int_stack+233604,int_stack+14820, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+138246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[116] = int_stack + 212040;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+214686,int_stack+238284,int_stack+16710, 0.0, zero_stack, 1.0, int_stack+101004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150996,6);
     Libderiv->ABCD[107] = int_stack + 214686;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+217332,int_stack+18600,int_stack+236124, 0.0, zero_stack, 1.0, int_stack+113754, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150996, 0.0, zero_stack,6);
     Libderiv->ABCD[106] = int_stack + 217332;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+219978,int_stack+244854,int_stack+240804, 0.0, zero_stack, 1.0, int_stack+126504, 0.0, zero_stack, 1.0, int_stack+150996, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[105] = int_stack + 219978;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+222624,int_stack+247374,int_stack+242694, 0.0, zero_stack, 1.0, int_stack+138246, 1.0, int_stack+150996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[104] = int_stack + 222624;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+225270,int_stack+252054,int_stack+23808, 0.0, zero_stack, 2.0, int_stack+150996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[103] = int_stack + 225270;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+227916,int_stack+96714,int_stack+92664, 1.0, int_stack+101004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83244,6);
     Libderiv->ABCD[95] = int_stack + 227916;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+230562,int_stack+107574,int_stack+94554, 1.0, int_stack+113754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83244, 0.0, zero_stack,6);
     Libderiv->ABCD[94] = int_stack + 230562;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+233208,int_stack+118164,int_stack+105414, 1.0, int_stack+126504, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83244, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[93] = int_stack + 233208;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+235854,int_stack+120684,int_stack+249894, 1.0, int_stack+138246, 0.0, zero_stack, 1.0, int_stack+83244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[92] = int_stack + 235854;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+238500,int_stack+144336,int_stack+130914, 1.0, int_stack+150996, 1.0, int_stack+83244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[91] = int_stack + 238500;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+241146,int_stack+134694,int_stack+132804, 2.0, int_stack+83244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[90] = int_stack + 241146;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+243792,int_stack+146856,int_stack+155406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167136,6);
     Libderiv->ABCD[47] = int_stack + 243792;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+246438,int_stack+123204,int_stack+157296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167136, 0.0, zero_stack,6);
     Libderiv->ABCD[46] = int_stack + 246438;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+249084,int_stack+21120,int_stack+159186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167136, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[45] = int_stack + 249084;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+251730,int_stack+27858,int_stack+110094, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[44] = int_stack + 251730;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+142782,int_stack+32538,int_stack+25698, 0.0, zero_stack, 1.0, int_stack+167136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[43] = int_stack + 142782;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+145428,int_stack+87294,int_stack+30378, 1.0, int_stack+167136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[42] = int_stack + 145428;
 /*--- compute (d0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+148074,int_stack+35058,int_stack+85134,6);
     Libderiv->ABCD[38] = int_stack + 148074;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+150720,int_stack+39738,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179886,6);
     Libderiv->ABCD[35] = int_stack + 150720;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+153366,int_stack+44418,int_stack+37578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179886, 0.0, zero_stack,6);
     Libderiv->ABCD[34] = int_stack + 153366;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+156012,int_stack+49098,int_stack+42258, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179886, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[33] = int_stack + 156012;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+83154,int_stack+53778,int_stack+46938, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[32] = int_stack + 83154;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+85800,int_stack+58458,int_stack+51618, 0.0, zero_stack, 1.0, int_stack+179886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[31] = int_stack + 85800;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+58188,int_stack+173706,int_stack+56298, 1.0, int_stack+179886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[30] = int_stack + 58188;
 /*--- compute (d0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+178116,int_stack+60978,int_stack+171546,6);
     Libderiv->ABCD[26] = int_stack + 178116;
 /*--- compute (d0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+180762,int_stack+254574,int_stack+176226,6);
     Libderiv->ABCD[25] = int_stack + 180762;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+254376,int_stack+257094,int_stack+63498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191628,6);
     Libderiv->ABCD[23] = int_stack + 254376;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+60834,int_stack+259614,int_stack+65388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191628, 0.0, zero_stack,6);
     Libderiv->ABCD[22] = int_stack + 60834;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+257022,int_stack+262134,int_stack+67278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191628, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[21] = int_stack + 257022;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+259668,int_stack+264654,int_stack+69168, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[20] = int_stack + 259668;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+262314,int_stack+267174,int_stack+71058, 0.0, zero_stack, 1.0, int_stack+191628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[19] = int_stack + 262314;
 /*--- compute (d0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+264960,int_stack+184296,int_stack+72948, 1.0, int_stack+191628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[18] = int_stack + 264960;
 /*--- compute (d0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+189336,int_stack+186816,int_stack+74838,6);
     Libderiv->ABCD[14] = int_stack + 189336;
 /*--- compute (d0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+183408,int_stack+269694,int_stack+76728,6);
     Libderiv->ABCD[13] = int_stack + 183408;
 /*--- compute (d0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+267606,int_stack+272214,int_stack+78618,6);
     Libderiv->ABCD[12] = int_stack + 267606;

}
