/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_gpff(Libderiv_t *, prim_data *);

  /* Computes derivatives of (gp|ff) integrals */

void d12hrr_order_gpff(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][6][11] = int_stack + 0;
 Libderiv->deriv_classes[5][6][10] = int_stack + 588;
 Libderiv->deriv_classes[5][6][9] = int_stack + 1176;
 Libderiv->deriv_classes[5][6][8] = int_stack + 1764;
 Libderiv->deriv_classes[5][6][7] = int_stack + 2352;
 Libderiv->dvrr_classes[5][5] = int_stack + 2940;
 Libderiv->deriv_classes[5][6][6] = int_stack + 3381;
 Libderiv->deriv_classes[5][6][2] = int_stack + 3969;
 Libderiv->deriv_classes[5][6][1] = int_stack + 4557;
 Libderiv->dvrr_classes[4][6] = int_stack + 5145;
 Libderiv->deriv_classes[5][6][0] = int_stack + 5565;
 Libderiv->deriv2_classes[4][3][143] = int_stack + 6153;
 Libderiv->deriv2_classes[4][4][143] = int_stack + 6303;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 6528;
 Libderiv->deriv2_classes[4][6][143] = int_stack + 6843;
 Libderiv->deriv2_classes[5][3][143] = int_stack + 7263;
 Libderiv->deriv2_classes[5][4][143] = int_stack + 7473;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 7788;
 Libderiv->deriv2_classes[5][6][143] = int_stack + 8229;
 Libderiv->deriv2_classes[4][3][131] = int_stack + 8817;
 Libderiv->deriv2_classes[4][4][131] = int_stack + 8967;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 9192;
 Libderiv->deriv2_classes[4][6][131] = int_stack + 9507;
 Libderiv->deriv2_classes[5][3][131] = int_stack + 9927;
 Libderiv->deriv2_classes[5][4][131] = int_stack + 10137;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 10452;
 Libderiv->deriv2_classes[5][6][131] = int_stack + 10893;
 Libderiv->deriv2_classes[4][3][130] = int_stack + 11481;
 Libderiv->deriv2_classes[4][4][130] = int_stack + 11631;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 11856;
 Libderiv->deriv2_classes[4][6][130] = int_stack + 12171;
 Libderiv->deriv2_classes[5][3][130] = int_stack + 12591;
 Libderiv->deriv2_classes[5][4][130] = int_stack + 12801;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 13116;
 Libderiv->deriv2_classes[5][6][130] = int_stack + 13557;
 Libderiv->deriv2_classes[4][3][119] = int_stack + 14145;
 Libderiv->deriv2_classes[4][4][119] = int_stack + 14295;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 14520;
 Libderiv->deriv2_classes[4][6][119] = int_stack + 14835;
 Libderiv->deriv2_classes[5][3][119] = int_stack + 15255;
 Libderiv->deriv2_classes[5][4][119] = int_stack + 15465;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 15780;
 Libderiv->deriv2_classes[5][6][119] = int_stack + 16221;
 Libderiv->deriv2_classes[4][3][118] = int_stack + 16809;
 Libderiv->deriv2_classes[4][4][118] = int_stack + 16959;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 17184;
 Libderiv->deriv2_classes[4][6][118] = int_stack + 17499;
 Libderiv->deriv2_classes[5][3][118] = int_stack + 17919;
 Libderiv->deriv2_classes[5][4][118] = int_stack + 18129;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 18444;
 Libderiv->deriv2_classes[5][6][118] = int_stack + 18885;
 Libderiv->deriv2_classes[4][3][117] = int_stack + 19473;
 Libderiv->deriv2_classes[4][4][117] = int_stack + 19623;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 19848;
 Libderiv->deriv2_classes[4][6][117] = int_stack + 20163;
 Libderiv->deriv2_classes[5][3][117] = int_stack + 20583;
 Libderiv->deriv2_classes[5][4][117] = int_stack + 20793;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 21108;
 Libderiv->deriv2_classes[5][6][117] = int_stack + 21549;
 Libderiv->deriv2_classes[4][3][107] = int_stack + 22137;
 Libderiv->deriv2_classes[4][4][107] = int_stack + 22287;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 22512;
 Libderiv->deriv2_classes[4][6][107] = int_stack + 22827;
 Libderiv->deriv2_classes[5][3][107] = int_stack + 23247;
 Libderiv->deriv2_classes[5][4][107] = int_stack + 23457;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 23772;
 Libderiv->deriv2_classes[5][6][107] = int_stack + 24213;
 Libderiv->deriv2_classes[4][3][106] = int_stack + 24801;
 Libderiv->deriv2_classes[4][4][106] = int_stack + 24951;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 25176;
 Libderiv->deriv2_classes[4][6][106] = int_stack + 25491;
 Libderiv->deriv2_classes[5][3][106] = int_stack + 25911;
 Libderiv->deriv2_classes[5][4][106] = int_stack + 26121;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 26436;
 Libderiv->deriv2_classes[5][6][106] = int_stack + 26877;
 Libderiv->deriv2_classes[4][3][105] = int_stack + 27465;
 Libderiv->deriv2_classes[4][4][105] = int_stack + 27615;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 27840;
 Libderiv->deriv2_classes[4][6][105] = int_stack + 28155;
 Libderiv->deriv2_classes[5][3][105] = int_stack + 28575;
 Libderiv->deriv2_classes[5][4][105] = int_stack + 28785;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 29100;
 Libderiv->deriv2_classes[5][6][105] = int_stack + 29541;
 Libderiv->deriv2_classes[4][3][104] = int_stack + 30129;
 Libderiv->deriv2_classes[4][4][104] = int_stack + 30279;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 30504;
 Libderiv->deriv2_classes[4][6][104] = int_stack + 30819;
 Libderiv->deriv2_classes[5][3][104] = int_stack + 31239;
 Libderiv->deriv2_classes[5][4][104] = int_stack + 31449;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 31764;
 Libderiv->deriv2_classes[5][6][104] = int_stack + 32205;
 Libderiv->deriv2_classes[4][3][95] = int_stack + 32793;
 Libderiv->deriv2_classes[4][4][95] = int_stack + 32943;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 33168;
 Libderiv->deriv2_classes[4][6][95] = int_stack + 33483;
 Libderiv->deriv2_classes[5][3][95] = int_stack + 33903;
 Libderiv->deriv2_classes[5][4][95] = int_stack + 34113;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 34428;
 Libderiv->deriv2_classes[5][6][95] = int_stack + 34869;
 Libderiv->deriv2_classes[4][3][94] = int_stack + 35457;
 Libderiv->deriv2_classes[4][4][94] = int_stack + 35607;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 35832;
 Libderiv->deriv2_classes[4][6][94] = int_stack + 36147;
 Libderiv->deriv2_classes[5][3][94] = int_stack + 36567;
 Libderiv->deriv2_classes[5][4][94] = int_stack + 36777;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 37092;
 Libderiv->deriv2_classes[5][6][94] = int_stack + 37533;
 Libderiv->deriv2_classes[4][3][93] = int_stack + 38121;
 Libderiv->deriv2_classes[4][4][93] = int_stack + 38271;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 38496;
 Libderiv->deriv2_classes[4][6][93] = int_stack + 38811;
 Libderiv->deriv2_classes[5][3][93] = int_stack + 39231;
 Libderiv->deriv2_classes[5][4][93] = int_stack + 39441;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 39756;
 Libderiv->deriv2_classes[5][6][93] = int_stack + 40197;
 Libderiv->deriv2_classes[4][3][92] = int_stack + 40785;
 Libderiv->deriv2_classes[4][4][92] = int_stack + 40935;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 41160;
 Libderiv->deriv2_classes[4][6][92] = int_stack + 41475;
 Libderiv->deriv2_classes[5][3][92] = int_stack + 41895;
 Libderiv->deriv2_classes[5][4][92] = int_stack + 42105;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 42420;
 Libderiv->deriv2_classes[5][6][92] = int_stack + 42861;
 Libderiv->deriv2_classes[4][3][91] = int_stack + 43449;
 Libderiv->deriv2_classes[4][4][91] = int_stack + 43599;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 43824;
 Libderiv->deriv2_classes[4][6][91] = int_stack + 44139;
 Libderiv->deriv2_classes[5][3][91] = int_stack + 44559;
 Libderiv->deriv2_classes[5][4][91] = int_stack + 44769;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 45084;
 Libderiv->deriv2_classes[5][6][91] = int_stack + 45525;
 Libderiv->deriv2_classes[4][3][83] = int_stack + 46113;
 Libderiv->deriv2_classes[4][4][83] = int_stack + 46263;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 46488;
 Libderiv->deriv2_classes[4][6][83] = int_stack + 46803;
 Libderiv->deriv_classes[5][3][11] = int_stack + 47223;
 Libderiv->deriv2_classes[5][3][83] = int_stack + 47433;
 Libderiv->deriv_classes[5][4][11] = int_stack + 47643;
 Libderiv->deriv2_classes[5][4][83] = int_stack + 47958;
 Libderiv->deriv_classes[5][5][11] = int_stack + 48273;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 48714;
 Libderiv->deriv2_classes[5][6][83] = int_stack + 49155;
 Libderiv->deriv2_classes[4][3][82] = int_stack + 49743;
 Libderiv->deriv2_classes[4][4][82] = int_stack + 49893;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 50118;
 Libderiv->deriv2_classes[4][6][82] = int_stack + 50433;
 Libderiv->deriv_classes[5][3][10] = int_stack + 50853;
 Libderiv->deriv2_classes[5][3][82] = int_stack + 51063;
 Libderiv->deriv_classes[5][4][10] = int_stack + 51273;
 Libderiv->deriv2_classes[5][4][82] = int_stack + 51588;
 Libderiv->deriv_classes[5][5][10] = int_stack + 51903;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 52344;
 Libderiv->deriv2_classes[5][6][82] = int_stack + 52785;
 Libderiv->deriv2_classes[4][3][81] = int_stack + 53373;
 Libderiv->deriv2_classes[4][4][81] = int_stack + 53523;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 53748;
 Libderiv->deriv2_classes[4][6][81] = int_stack + 54063;
 Libderiv->deriv_classes[5][3][9] = int_stack + 54483;
 Libderiv->deriv2_classes[5][3][81] = int_stack + 54693;
 Libderiv->deriv_classes[5][4][9] = int_stack + 54903;
 Libderiv->deriv2_classes[5][4][81] = int_stack + 55218;
 Libderiv->deriv_classes[5][5][9] = int_stack + 55533;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 55974;
 Libderiv->deriv2_classes[5][6][81] = int_stack + 56415;
 Libderiv->deriv2_classes[4][3][80] = int_stack + 57003;
 Libderiv->deriv2_classes[4][4][80] = int_stack + 57153;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 57378;
 Libderiv->deriv2_classes[4][6][80] = int_stack + 57693;
 Libderiv->deriv_classes[5][3][8] = int_stack + 58113;
 Libderiv->deriv2_classes[5][3][80] = int_stack + 58323;
 Libderiv->deriv_classes[5][4][8] = int_stack + 58533;
 Libderiv->deriv2_classes[5][4][80] = int_stack + 58848;
 Libderiv->deriv_classes[5][5][8] = int_stack + 59163;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 59604;
 Libderiv->deriv2_classes[5][6][80] = int_stack + 60045;
 Libderiv->deriv2_classes[4][3][79] = int_stack + 60633;
 Libderiv->deriv2_classes[4][4][79] = int_stack + 60783;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 61008;
 Libderiv->deriv2_classes[4][6][79] = int_stack + 61323;
 Libderiv->deriv_classes[5][3][7] = int_stack + 61743;
 Libderiv->deriv2_classes[5][3][79] = int_stack + 61953;
 Libderiv->deriv_classes[5][4][7] = int_stack + 62163;
 Libderiv->deriv2_classes[5][4][79] = int_stack + 62478;
 Libderiv->deriv_classes[5][5][7] = int_stack + 62793;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 63234;
 Libderiv->deriv2_classes[5][6][79] = int_stack + 63675;
 Libderiv->deriv2_classes[4][3][78] = int_stack + 64263;
 Libderiv->deriv2_classes[4][4][78] = int_stack + 64413;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 64638;
 Libderiv->deriv2_classes[4][6][78] = int_stack + 64953;
 Libderiv->dvrr_classes[5][3] = int_stack + 65373;
 Libderiv->deriv_classes[5][3][6] = int_stack + 65583;
 Libderiv->deriv2_classes[5][3][78] = int_stack + 65793;
 Libderiv->dvrr_classes[5][4] = int_stack + 66003;
 Libderiv->deriv_classes[5][4][6] = int_stack + 66318;
 Libderiv->deriv2_classes[5][4][78] = int_stack + 66633;
 Libderiv->deriv_classes[5][5][6] = int_stack + 66948;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 67389;
 Libderiv->deriv2_classes[5][6][78] = int_stack + 67830;
 Libderiv->deriv2_classes[4][3][35] = int_stack + 68418;
 Libderiv->deriv2_classes[4][4][35] = int_stack + 68568;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 68793;
 Libderiv->deriv2_classes[4][6][35] = int_stack + 69108;
 Libderiv->deriv2_classes[5][3][35] = int_stack + 69528;
 Libderiv->deriv2_classes[5][4][35] = int_stack + 69738;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 70053;
 Libderiv->deriv2_classes[5][6][35] = int_stack + 70494;
 Libderiv->deriv2_classes[4][3][34] = int_stack + 71082;
 Libderiv->deriv2_classes[4][4][34] = int_stack + 71232;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 71457;
 Libderiv->deriv2_classes[4][6][34] = int_stack + 71772;
 Libderiv->deriv2_classes[5][3][34] = int_stack + 72192;
 Libderiv->deriv2_classes[5][4][34] = int_stack + 72402;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 72717;
 Libderiv->deriv2_classes[5][6][34] = int_stack + 73158;
 Libderiv->deriv2_classes[4][3][33] = int_stack + 73746;
 Libderiv->deriv2_classes[4][4][33] = int_stack + 73896;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 74121;
 Libderiv->deriv2_classes[4][6][33] = int_stack + 74436;
 Libderiv->deriv2_classes[5][3][33] = int_stack + 74856;
 Libderiv->deriv2_classes[5][4][33] = int_stack + 75066;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 75381;
 Libderiv->deriv2_classes[5][6][33] = int_stack + 75822;
 Libderiv->deriv2_classes[4][3][32] = int_stack + 76410;
 Libderiv->deriv2_classes[4][4][32] = int_stack + 76560;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 76785;
 Libderiv->deriv2_classes[4][6][32] = int_stack + 77100;
 Libderiv->deriv2_classes[5][3][32] = int_stack + 77520;
 Libderiv->deriv2_classes[5][4][32] = int_stack + 77730;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 78045;
 Libderiv->deriv2_classes[5][6][32] = int_stack + 78486;
 Libderiv->deriv2_classes[4][3][31] = int_stack + 79074;
 Libderiv->deriv2_classes[4][4][31] = int_stack + 79224;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 79449;
 Libderiv->deriv2_classes[4][6][31] = int_stack + 79764;
 Libderiv->deriv2_classes[5][3][31] = int_stack + 80184;
 Libderiv->deriv2_classes[5][4][31] = int_stack + 80394;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 80709;
 Libderiv->deriv2_classes[5][6][31] = int_stack + 81150;
 Libderiv->deriv2_classes[4][3][30] = int_stack + 81738;
 Libderiv->deriv2_classes[4][4][30] = int_stack + 81888;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 82113;
 Libderiv->deriv2_classes[4][6][30] = int_stack + 82428;
 Libderiv->deriv_classes[5][3][2] = int_stack + 82848;
 Libderiv->deriv2_classes[5][3][30] = int_stack + 83058;
 Libderiv->deriv_classes[5][4][2] = int_stack + 83268;
 Libderiv->deriv2_classes[5][4][30] = int_stack + 83583;
 Libderiv->deriv_classes[5][5][2] = int_stack + 83898;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 84339;
 Libderiv->deriv2_classes[5][6][30] = int_stack + 84780;
 Libderiv->deriv2_classes[4][3][26] = int_stack + 85368;
 Libderiv->deriv2_classes[4][4][26] = int_stack + 85518;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 85743;
 Libderiv->deriv2_classes[4][6][26] = int_stack + 86058;
 Libderiv->deriv2_classes[5][3][26] = int_stack + 86478;
 Libderiv->deriv2_classes[5][4][26] = int_stack + 86688;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 87003;
 Libderiv->deriv2_classes[5][6][26] = int_stack + 87444;
 Libderiv->deriv2_classes[4][3][23] = int_stack + 88032;
 Libderiv->deriv2_classes[4][4][23] = int_stack + 88182;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 88407;
 Libderiv->deriv2_classes[4][6][23] = int_stack + 88722;
 Libderiv->deriv2_classes[5][3][23] = int_stack + 89142;
 Libderiv->deriv2_classes[5][4][23] = int_stack + 89352;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 89667;
 Libderiv->deriv2_classes[5][6][23] = int_stack + 90108;
 Libderiv->deriv2_classes[4][3][22] = int_stack + 90696;
 Libderiv->deriv2_classes[4][4][22] = int_stack + 90846;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 91071;
 Libderiv->deriv2_classes[4][6][22] = int_stack + 91386;
 Libderiv->deriv2_classes[5][3][22] = int_stack + 91806;
 Libderiv->deriv2_classes[5][4][22] = int_stack + 92016;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 92331;
 Libderiv->deriv2_classes[5][6][22] = int_stack + 92772;
 Libderiv->deriv2_classes[4][3][21] = int_stack + 93360;
 Libderiv->deriv2_classes[4][4][21] = int_stack + 93510;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 93735;
 Libderiv->deriv2_classes[4][6][21] = int_stack + 94050;
 Libderiv->deriv2_classes[5][3][21] = int_stack + 94470;
 Libderiv->deriv2_classes[5][4][21] = int_stack + 94680;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 94995;
 Libderiv->deriv2_classes[5][6][21] = int_stack + 95436;
 Libderiv->deriv2_classes[4][3][20] = int_stack + 96024;
 Libderiv->deriv2_classes[4][4][20] = int_stack + 96174;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 96399;
 Libderiv->deriv2_classes[4][6][20] = int_stack + 96714;
 Libderiv->deriv2_classes[5][3][20] = int_stack + 97134;
 Libderiv->deriv2_classes[5][4][20] = int_stack + 97344;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 97659;
 Libderiv->deriv2_classes[5][6][20] = int_stack + 98100;
 Libderiv->deriv2_classes[4][3][19] = int_stack + 98688;
 Libderiv->deriv2_classes[4][4][19] = int_stack + 98838;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 99063;
 Libderiv->deriv2_classes[4][6][19] = int_stack + 99378;
 Libderiv->deriv2_classes[5][3][19] = int_stack + 99798;
 Libderiv->deriv2_classes[5][4][19] = int_stack + 100008;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 100323;
 Libderiv->deriv2_classes[5][6][19] = int_stack + 100764;
 Libderiv->deriv2_classes[4][3][18] = int_stack + 101352;
 Libderiv->deriv2_classes[4][4][18] = int_stack + 101502;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 101727;
 Libderiv->deriv2_classes[4][6][18] = int_stack + 102042;
 Libderiv->deriv_classes[5][3][1] = int_stack + 102462;
 Libderiv->deriv2_classes[5][3][18] = int_stack + 102672;
 Libderiv->deriv_classes[5][4][1] = int_stack + 102882;
 Libderiv->deriv2_classes[5][4][18] = int_stack + 103197;
 Libderiv->deriv_classes[5][5][1] = int_stack + 103512;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 103953;
 Libderiv->deriv2_classes[5][6][18] = int_stack + 104394;
 Libderiv->deriv2_classes[4][3][14] = int_stack + 104982;
 Libderiv->deriv2_classes[4][4][14] = int_stack + 105132;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 105357;
 Libderiv->deriv2_classes[4][6][14] = int_stack + 105672;
 Libderiv->deriv2_classes[5][3][14] = int_stack + 106092;
 Libderiv->deriv2_classes[5][4][14] = int_stack + 106302;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 106617;
 Libderiv->deriv2_classes[5][6][14] = int_stack + 107058;
 Libderiv->deriv2_classes[4][3][13] = int_stack + 107646;
 Libderiv->deriv2_classes[4][4][13] = int_stack + 107796;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 108021;
 Libderiv->deriv2_classes[4][6][13] = int_stack + 108336;
 Libderiv->deriv2_classes[5][3][13] = int_stack + 108756;
 Libderiv->deriv2_classes[5][4][13] = int_stack + 108966;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 109281;
 Libderiv->deriv2_classes[5][6][13] = int_stack + 109722;
 Libderiv->deriv_classes[4][3][11] = int_stack + 110310;
 Libderiv->deriv_classes[4][4][11] = int_stack + 110460;
 Libderiv->deriv_classes[4][5][11] = int_stack + 110685;
 Libderiv->deriv_classes[4][6][11] = int_stack + 111000;
 Libderiv->deriv2_classes[4][3][11] = int_stack + 111420;
 Libderiv->deriv2_classes[4][4][11] = int_stack + 111570;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 111795;
 Libderiv->deriv2_classes[4][6][11] = int_stack + 112110;
 Libderiv->deriv2_classes[5][3][11] = int_stack + 112530;
 Libderiv->deriv2_classes[5][4][11] = int_stack + 112740;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 113055;
 Libderiv->deriv2_classes[5][6][11] = int_stack + 113496;
 Libderiv->deriv_classes[4][3][10] = int_stack + 114084;
 Libderiv->deriv_classes[4][4][10] = int_stack + 114234;
 Libderiv->deriv_classes[4][5][10] = int_stack + 114459;
 Libderiv->deriv_classes[4][6][10] = int_stack + 114774;
 Libderiv->deriv2_classes[4][3][10] = int_stack + 115194;
 Libderiv->deriv2_classes[4][4][10] = int_stack + 115344;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 115569;
 Libderiv->deriv2_classes[4][6][10] = int_stack + 115884;
 Libderiv->deriv2_classes[5][3][10] = int_stack + 116304;
 Libderiv->deriv2_classes[5][4][10] = int_stack + 116514;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 116829;
 Libderiv->deriv2_classes[5][6][10] = int_stack + 117270;
 Libderiv->deriv_classes[4][3][9] = int_stack + 117858;
 Libderiv->deriv_classes[4][4][9] = int_stack + 118008;
 Libderiv->deriv_classes[4][5][9] = int_stack + 118233;
 Libderiv->deriv_classes[4][6][9] = int_stack + 118548;
 Libderiv->deriv2_classes[4][3][9] = int_stack + 118968;
 Libderiv->deriv2_classes[4][4][9] = int_stack + 119118;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 119343;
 Libderiv->deriv2_classes[4][6][9] = int_stack + 119658;
 Libderiv->deriv2_classes[5][3][9] = int_stack + 120078;
 Libderiv->deriv2_classes[5][4][9] = int_stack + 120288;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 120603;
 Libderiv->deriv2_classes[5][6][9] = int_stack + 121044;
 Libderiv->deriv_classes[4][3][8] = int_stack + 121632;
 Libderiv->deriv_classes[4][4][8] = int_stack + 121782;
 Libderiv->deriv_classes[4][5][8] = int_stack + 122007;
 Libderiv->deriv_classes[4][6][8] = int_stack + 122322;
 Libderiv->deriv2_classes[4][3][8] = int_stack + 122742;
 Libderiv->deriv2_classes[4][4][8] = int_stack + 122892;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 123117;
 Libderiv->deriv2_classes[4][6][8] = int_stack + 123432;
 Libderiv->deriv2_classes[5][3][8] = int_stack + 123852;
 Libderiv->deriv2_classes[5][4][8] = int_stack + 124062;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 124377;
 Libderiv->deriv2_classes[5][6][8] = int_stack + 124818;
 Libderiv->deriv_classes[4][3][7] = int_stack + 125406;
 Libderiv->deriv_classes[4][4][7] = int_stack + 125556;
 Libderiv->deriv_classes[4][5][7] = int_stack + 125781;
 Libderiv->deriv_classes[4][6][7] = int_stack + 126096;
 Libderiv->deriv2_classes[4][3][7] = int_stack + 126516;
 Libderiv->deriv2_classes[4][4][7] = int_stack + 126666;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 126891;
 Libderiv->deriv2_classes[4][6][7] = int_stack + 127206;
 Libderiv->deriv2_classes[5][3][7] = int_stack + 127626;
 Libderiv->deriv2_classes[5][4][7] = int_stack + 127836;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 128151;
 Libderiv->deriv2_classes[5][6][7] = int_stack + 128592;
 Libderiv->dvrr_classes[4][3] = int_stack + 129180;
 Libderiv->deriv_classes[4][3][6] = int_stack + 129330;
 Libderiv->dvrr_classes[4][4] = int_stack + 129480;
 Libderiv->deriv_classes[4][4][6] = int_stack + 129705;
 Libderiv->dvrr_classes[4][5] = int_stack + 129930;
 Libderiv->deriv_classes[4][5][6] = int_stack + 130245;
 Libderiv->deriv_classes[4][6][6] = int_stack + 130560;
 Libderiv->deriv2_classes[4][3][6] = int_stack + 130980;
 Libderiv->deriv2_classes[4][4][6] = int_stack + 131130;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 131355;
 Libderiv->deriv2_classes[4][6][6] = int_stack + 131670;
 Libderiv->deriv_classes[5][3][0] = int_stack + 132090;
 Libderiv->deriv2_classes[5][3][6] = int_stack + 132300;
 Libderiv->deriv_classes[5][4][0] = int_stack + 132510;
 Libderiv->deriv2_classes[5][4][6] = int_stack + 132825;
 Libderiv->deriv_classes[5][5][0] = int_stack + 133140;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 133581;
 Libderiv->deriv2_classes[5][6][6] = int_stack + 134022;
 Libderiv->deriv_classes[4][3][2] = int_stack + 134610;
 Libderiv->deriv_classes[4][4][2] = int_stack + 134760;
 Libderiv->deriv_classes[4][5][2] = int_stack + 134985;
 Libderiv->deriv_classes[4][6][2] = int_stack + 135300;
 Libderiv->deriv2_classes[4][3][2] = int_stack + 135720;
 Libderiv->deriv2_classes[4][4][2] = int_stack + 135870;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 136095;
 Libderiv->deriv2_classes[4][6][2] = int_stack + 136410;
 Libderiv->deriv2_classes[5][3][2] = int_stack + 136830;
 Libderiv->deriv2_classes[5][4][2] = int_stack + 137040;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 137355;
 Libderiv->deriv2_classes[5][6][2] = int_stack + 137796;
 Libderiv->deriv_classes[4][3][1] = int_stack + 138384;
 Libderiv->deriv_classes[4][4][1] = int_stack + 138534;
 Libderiv->deriv_classes[4][5][1] = int_stack + 138759;
 Libderiv->deriv_classes[4][6][1] = int_stack + 139074;
 Libderiv->deriv2_classes[4][3][1] = int_stack + 139494;
 Libderiv->deriv2_classes[4][4][1] = int_stack + 139644;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 139869;
 Libderiv->deriv2_classes[4][6][1] = int_stack + 140184;
 Libderiv->deriv2_classes[5][3][1] = int_stack + 140604;
 Libderiv->deriv2_classes[5][4][1] = int_stack + 140814;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 141129;
 Libderiv->deriv2_classes[5][6][1] = int_stack + 141570;
 Libderiv->deriv_classes[4][3][0] = int_stack + 142158;
 Libderiv->deriv_classes[4][4][0] = int_stack + 142308;
 Libderiv->deriv_classes[4][5][0] = int_stack + 142533;
 Libderiv->deriv_classes[4][6][0] = int_stack + 142848;
 Libderiv->deriv2_classes[4][3][0] = int_stack + 143268;
 Libderiv->deriv2_classes[4][4][0] = int_stack + 143418;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 143643;
 Libderiv->deriv2_classes[4][6][0] = int_stack + 143958;
 Libderiv->deriv2_classes[5][3][0] = int_stack + 144378;
 Libderiv->deriv2_classes[5][4][0] = int_stack + 144588;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 144903;
 Libderiv->deriv2_classes[5][6][0] = int_stack + 145344;
 memset(int_stack,0,1167456);

 Libderiv->dvrr_stack = int_stack + 296679;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_gpff(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+129480,int_stack+129180,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+129930,int_stack+129480,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+147057,int_stack+146382,int_stack+145932,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+147957,int_stack+110460,int_stack+110310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129180,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+148407,int_stack+110685,int_stack+110460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129480,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+149082,int_stack+148407,int_stack+147957, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145932,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+149982,int_stack+111000,int_stack+110685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129930,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+150927,int_stack+149982,int_stack+148407, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+146382,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+152277,int_stack+150927,int_stack+149082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147057,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+149982,int_stack+66003,int_stack+65373,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+150612,int_stack+2940,int_stack+66003,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+150612,int_stack+149982,21);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+151557,int_stack+47643,int_stack+47223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+65373,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+155037,int_stack+48273,int_stack+47643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66003,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+155982,int_stack+155037,int_stack+151557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+149982,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+157242,int_stack+0,int_stack+48273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2940,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+158565,int_stack+157242,int_stack+155037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150612,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+160455,int_stack+158565,int_stack+155982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153777,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+157242,int_stack+114234,int_stack+114084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129180, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+157692,int_stack+114459,int_stack+114234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129480, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+158367,int_stack+157692,int_stack+157242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145932, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+159267,int_stack+114774,int_stack+114459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129930, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+162555,int_stack+159267,int_stack+157692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+146382, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+163905,int_stack+162555,int_stack+158367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147057, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+162555,int_stack+51273,int_stack+50853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+65373, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+159267,int_stack+51903,int_stack+51273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66003, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+165405,int_stack+159267,int_stack+162555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+149982, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+166665,int_stack+588,int_stack+51903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2940, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+167988,int_stack+166665,int_stack+159267, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150612, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+169878,int_stack+167988,int_stack+165405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153777, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+166665,int_stack+118008,int_stack+117858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129180, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+167115,int_stack+118233,int_stack+118008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129480, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+167790,int_stack+167115,int_stack+166665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145932, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+168690,int_stack+118548,int_stack+118233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129930, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+171978,int_stack+168690,int_stack+167115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+146382, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+173328,int_stack+171978,int_stack+167790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147057, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+171978,int_stack+54903,int_stack+54483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+65373, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+168690,int_stack+55533,int_stack+54903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66003, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+174828,int_stack+168690,int_stack+171978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+149982, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+176088,int_stack+1176,int_stack+55533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2940, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+177411,int_stack+176088,int_stack+168690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150612, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+179301,int_stack+177411,int_stack+174828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153777, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+176088,int_stack+121782,int_stack+121632, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+176538,int_stack+122007,int_stack+121782, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+177213,int_stack+176538,int_stack+176088, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+178113,int_stack+122322,int_stack+122007, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+178113,int_stack+176538, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+146382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+181401,int_stack+0,int_stack+177213, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+0,int_stack+58533,int_stack+58113, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+65373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+630,int_stack+59163,int_stack+58533, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+182901,int_stack+630,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+149982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+184161,int_stack+1764,int_stack+59163, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+185484,int_stack+184161,int_stack+630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+187374,int_stack+185484,int_stack+182901, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+184161,int_stack+125556,int_stack+125406, 0.0, zero_stack, 1.0, int_stack+129180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+184611,int_stack+125781,int_stack+125556, 0.0, zero_stack, 1.0, int_stack+129480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+185286,int_stack+184611,int_stack+184161, 0.0, zero_stack, 1.0, int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+186186,int_stack+126096,int_stack+125781, 0.0, zero_stack, 1.0, int_stack+129930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+186186,int_stack+184611, 0.0, zero_stack, 1.0, int_stack+146382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+190824,int_stack+189474,int_stack+185286, 0.0, zero_stack, 1.0, int_stack+147057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+189474,int_stack+62163,int_stack+61743, 0.0, zero_stack, 1.0, int_stack+65373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+186186,int_stack+62793,int_stack+62163, 0.0, zero_stack, 1.0, int_stack+66003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+192324,int_stack+186186,int_stack+189474, 0.0, zero_stack, 1.0, int_stack+149982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+193584,int_stack+2352,int_stack+62793, 0.0, zero_stack, 1.0, int_stack+2940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+194907,int_stack+193584,int_stack+186186, 0.0, zero_stack, 1.0, int_stack+150612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+196797,int_stack+194907,int_stack+192324, 0.0, zero_stack, 1.0, int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+193584,int_stack+129705,int_stack+129330, 1.0, int_stack+129180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+194034,int_stack+130245,int_stack+129705, 1.0, int_stack+129480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+194709,int_stack+194034,int_stack+193584, 1.0, int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+195609,int_stack+130560,int_stack+130245, 1.0, int_stack+129930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1575,int_stack+195609,int_stack+194034, 1.0, int_stack+146382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+198897,int_stack+1575,int_stack+194709, 1.0, int_stack+147057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+1575,int_stack+66318,int_stack+65583, 1.0, int_stack+65373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+195609,int_stack+66948,int_stack+66318, 1.0, int_stack+66003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+200397,int_stack+195609,int_stack+1575, 1.0, int_stack+149982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+201657,int_stack+3381,int_stack+66948, 1.0, int_stack+2940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+202980,int_stack+201657,int_stack+195609, 1.0, int_stack+150612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+204870,int_stack+202980,int_stack+200397, 1.0, int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+153777,int_stack+5145,int_stack+129930,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+201657,int_stack+153777,int_stack+146382,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+203007,int_stack+201657,int_stack+147057,15);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+201657,int_stack+134760,int_stack+134610,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+202107,int_stack+134985,int_stack+134760,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+202107,int_stack+201657,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+149982,int_stack+135300,int_stack+134985,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2205,int_stack+149982,int_stack+202107,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+149982,int_stack+2205,int_stack+153777,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+2205,int_stack+83268,int_stack+82848,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+2835,int_stack+83898,int_stack+83268,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+2835,int_stack+2205,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+206970,int_stack+3969,int_stack+83898,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+208293,int_stack+206970,int_stack+2835,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+210183,int_stack+208293,int_stack+145932,21);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+206970,int_stack+138534,int_stack+138384,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+207420,int_stack+138759,int_stack+138534,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+208095,int_stack+207420,int_stack+206970,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+208995,int_stack+139074,int_stack+138759,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+212283,int_stack+208995,int_stack+207420,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+213633,int_stack+212283,int_stack+208095,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+212283,int_stack+102882,int_stack+102462,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+208995,int_stack+103512,int_stack+102882,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+215133,int_stack+208995,int_stack+212283,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+216393,int_stack+4557,int_stack+103512,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+217716,int_stack+216393,int_stack+208995,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+219606,int_stack+217716,int_stack+215133,21);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+216393,int_stack+142308,int_stack+142158,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+216843,int_stack+142533,int_stack+142308,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+217518,int_stack+216843,int_stack+216393,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+218418,int_stack+142848,int_stack+142533,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+3780,int_stack+218418,int_stack+216843,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+221706,int_stack+3780,int_stack+217518,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+3780,int_stack+132510,int_stack+132090,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+4410,int_stack+133140,int_stack+132510,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+223206,int_stack+4410,int_stack+3780,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+224466,int_stack+5565,int_stack+133140,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+225789,int_stack+224466,int_stack+4410,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+227679,int_stack+225789,int_stack+223206,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+224466,int_stack+6303,int_stack+6153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+110310,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+224916,int_stack+6528,int_stack+6303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+110460,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+225591,int_stack+224916,int_stack+224466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+147957,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+226491,int_stack+6843,int_stack+6528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+110685,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+5355,int_stack+226491,int_stack+224916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+148407,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+229779,int_stack+5355,int_stack+225591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+149082,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+5355,int_stack+7473,int_stack+7263, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+47223,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5985,int_stack+7788,int_stack+7473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+47643,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+224466,int_stack+5985,int_stack+5355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+151557,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+225726,int_stack+8229,int_stack+7788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+48273,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+231279,int_stack+225726,int_stack+5985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+155037,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+5355,int_stack+231279,int_stack+224466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+155982,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+224466,int_stack+8967,int_stack+8817, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110310, 1.0, int_stack+114084,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+224916,int_stack+9192,int_stack+8967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110460, 1.0, int_stack+114234,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+225591,int_stack+224916,int_stack+224466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147957, 1.0, int_stack+157242,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+226491,int_stack+9507,int_stack+9192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110685, 1.0, int_stack+114459,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+231279,int_stack+226491,int_stack+224916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+148407, 1.0, int_stack+157692,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+7455,int_stack+231279,int_stack+225591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+149082, 1.0, int_stack+158367,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+231279,int_stack+10137,int_stack+9927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47223, 1.0, int_stack+50853,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+231909,int_stack+10452,int_stack+10137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47643, 1.0, int_stack+51273,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+224466,int_stack+231909,int_stack+231279, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151557, 1.0, int_stack+162555,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+225726,int_stack+10893,int_stack+10452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48273, 1.0, int_stack+51903,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8955,int_stack+225726,int_stack+231909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155037, 1.0, int_stack+159267,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+231279,int_stack+8955,int_stack+224466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155982, 1.0, int_stack+165405,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+224466,int_stack+11631,int_stack+11481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+114084, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+224916,int_stack+11856,int_stack+11631, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+114234, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+225591,int_stack+224916,int_stack+224466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+157242, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+226491,int_stack+12171,int_stack+11856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+114459, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8955,int_stack+226491,int_stack+224916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+157692, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+10305,int_stack+8955,int_stack+225591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+158367, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8955,int_stack+12801,int_stack+12591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+50853, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+224466,int_stack+13116,int_stack+12801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+51273, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+225411,int_stack+224466,int_stack+8955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+162555, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8955,int_stack+13557,int_stack+13116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+51903, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11805,int_stack+8955,int_stack+224466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+159267, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+233379,int_stack+11805,int_stack+225411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+165405, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+11805,int_stack+14295,int_stack+14145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110310, 0.0, zero_stack, 1.0, int_stack+117858,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12255,int_stack+14520,int_stack+14295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110460, 0.0, zero_stack, 1.0, int_stack+118008,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+12930,int_stack+12255,int_stack+11805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147957, 0.0, zero_stack, 1.0, int_stack+166665,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+224466,int_stack+14835,int_stack+14520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110685, 0.0, zero_stack, 1.0, int_stack+118233,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8955,int_stack+224466,int_stack+12255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+148407, 0.0, zero_stack, 1.0, int_stack+167115,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+224466,int_stack+8955,int_stack+12930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+149082, 0.0, zero_stack, 1.0, int_stack+167790,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8955,int_stack+15465,int_stack+15255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47223, 0.0, zero_stack, 1.0, int_stack+54483,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+225966,int_stack+15780,int_stack+15465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47643, 0.0, zero_stack, 1.0, int_stack+54903,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+11805,int_stack+225966,int_stack+8955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151557, 0.0, zero_stack, 1.0, int_stack+171978,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8955,int_stack+16221,int_stack+15780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48273, 0.0, zero_stack, 1.0, int_stack+55533,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+13065,int_stack+8955,int_stack+225966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155037, 0.0, zero_stack, 1.0, int_stack+168690,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+235479,int_stack+13065,int_stack+11805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155982, 0.0, zero_stack, 1.0, int_stack+174828,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+11805,int_stack+16959,int_stack+16809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114084, 1.0, int_stack+117858, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12255,int_stack+17184,int_stack+16959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114234, 1.0, int_stack+118008, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+12930,int_stack+12255,int_stack+11805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157242, 1.0, int_stack+166665, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+13830,int_stack+17499,int_stack+17184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114459, 1.0, int_stack+118233, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8955,int_stack+13830,int_stack+12255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157692, 1.0, int_stack+167115, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+13830,int_stack+8955,int_stack+12930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158367, 1.0, int_stack+167790, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8955,int_stack+18129,int_stack+17919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50853, 1.0, int_stack+54483, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15330,int_stack+18444,int_stack+18129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51273, 1.0, int_stack+54903, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+16275,int_stack+15330,int_stack+8955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162555, 1.0, int_stack+171978, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8955,int_stack+18885,int_stack+18444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51903, 1.0, int_stack+55533, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+17535,int_stack+8955,int_stack+15330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159267, 1.0, int_stack+168690, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+237579,int_stack+17535,int_stack+16275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165405, 1.0, int_stack+174828, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+15330,int_stack+19623,int_stack+19473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+117858, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15780,int_stack+19848,int_stack+19623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+118008, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+16455,int_stack+15780,int_stack+15330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+166665, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+17355,int_stack+20163,int_stack+19848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+118233, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8955,int_stack+17355,int_stack+15780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+167115, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+17355,int_stack+8955,int_stack+16455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+167790, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8955,int_stack+20793,int_stack+20583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+54483, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+18855,int_stack+21108,int_stack+20793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+54903, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+19800,int_stack+18855,int_stack+8955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+171978, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8955,int_stack+21549,int_stack+21108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+55533, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+15330,int_stack+8955,int_stack+18855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+168690, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+239679,int_stack+15330,int_stack+19800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+174828, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+15330,int_stack+22287,int_stack+22137, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110310, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+121632,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15780,int_stack+22512,int_stack+22287, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+121782,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+16455,int_stack+15780,int_stack+15330, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147957, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176088,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+18855,int_stack+22827,int_stack+22512, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110685, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122007,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8955,int_stack+18855,int_stack+15780, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+148407, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176538,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+18855,int_stack+8955,int_stack+16455, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+149082, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177213,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8955,int_stack+23457,int_stack+23247, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47223, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+58113,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+20355,int_stack+23772,int_stack+23457, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47643, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+58533,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+21300,int_stack+20355,int_stack+8955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151557, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8955,int_stack+24213,int_stack+23772, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48273, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59163,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22560,int_stack+8955,int_stack+20355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155037, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+630,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+241779,int_stack+22560,int_stack+21300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155982, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+182901,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+20355,int_stack+24951,int_stack+24801, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114084, 0.0, zero_stack, 1.0, int_stack+121632, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+20805,int_stack+25176,int_stack+24951, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114234, 0.0, zero_stack, 1.0, int_stack+121782, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+21480,int_stack+20805,int_stack+20355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157242, 0.0, zero_stack, 1.0, int_stack+176088, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22380,int_stack+25491,int_stack+25176, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114459, 0.0, zero_stack, 1.0, int_stack+122007, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8955,int_stack+22380,int_stack+20805, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157692, 0.0, zero_stack, 1.0, int_stack+176538, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+22380,int_stack+8955,int_stack+21480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158367, 0.0, zero_stack, 1.0, int_stack+177213, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8955,int_stack+26121,int_stack+25911, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50853, 0.0, zero_stack, 1.0, int_stack+58113, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+23880,int_stack+26436,int_stack+26121, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51273, 0.0, zero_stack, 1.0, int_stack+58533, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+24825,int_stack+23880,int_stack+8955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162555, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8955,int_stack+26877,int_stack+26436, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51903, 0.0, zero_stack, 1.0, int_stack+59163, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+20355,int_stack+8955,int_stack+23880, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159267, 0.0, zero_stack, 1.0, int_stack+630, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+243879,int_stack+20355,int_stack+24825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165405, 0.0, zero_stack, 1.0, int_stack+182901, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+20355,int_stack+27615,int_stack+27465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+117858, 1.0, int_stack+121632, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+20805,int_stack+27840,int_stack+27615, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+118008, 1.0, int_stack+121782, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+21480,int_stack+20805,int_stack+20355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166665, 1.0, int_stack+176088, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+23880,int_stack+28155,int_stack+27840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+118233, 1.0, int_stack+122007, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8955,int_stack+23880,int_stack+20805, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167115, 1.0, int_stack+176538, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+23880,int_stack+8955,int_stack+21480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167790, 1.0, int_stack+177213, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8955,int_stack+28785,int_stack+28575, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54483, 1.0, int_stack+58113, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+25380,int_stack+29100,int_stack+28785, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54903, 1.0, int_stack+58533, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+26325,int_stack+25380,int_stack+8955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171978, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8955,int_stack+29541,int_stack+29100, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55533, 1.0, int_stack+59163, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+27585,int_stack+8955,int_stack+25380, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+168690, 1.0, int_stack+630, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+245979,int_stack+27585,int_stack+26325, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174828, 1.0, int_stack+182901, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+25380,int_stack+30279,int_stack+30129, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+121632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+25830,int_stack+30504,int_stack+30279, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+121782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+26505,int_stack+25830,int_stack+25380, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+176088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+27405,int_stack+30819,int_stack+30504, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+122007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8955,int_stack+27405,int_stack+25830, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+176538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+27405,int_stack+8955,int_stack+26505, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+177213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8955,int_stack+31449,int_stack+31239, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+58113, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+28905,int_stack+31764,int_stack+31449, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+58533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+29850,int_stack+28905,int_stack+8955, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8955,int_stack+32205,int_stack+31764, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+59163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+25380,int_stack+8955,int_stack+28905, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+248079,int_stack+25380,int_stack+29850, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+182901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+25380,int_stack+32943,int_stack+32793, 0.0, zero_stack, 1.0, int_stack+110310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125406,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+25830,int_stack+33168,int_stack+32943, 0.0, zero_stack, 1.0, int_stack+110460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125556,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+26505,int_stack+25830,int_stack+25380, 0.0, zero_stack, 1.0, int_stack+147957, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184161,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+28905,int_stack+33483,int_stack+33168, 0.0, zero_stack, 1.0, int_stack+110685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125781,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8955,int_stack+28905,int_stack+25830, 0.0, zero_stack, 1.0, int_stack+148407, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184611,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+28905,int_stack+8955,int_stack+26505, 0.0, zero_stack, 1.0, int_stack+149082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185286,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8955,int_stack+34113,int_stack+33903, 0.0, zero_stack, 1.0, int_stack+47223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+61743,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+30405,int_stack+34428,int_stack+34113, 0.0, zero_stack, 1.0, int_stack+47643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62163,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+31350,int_stack+30405,int_stack+8955, 0.0, zero_stack, 1.0, int_stack+151557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189474,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8955,int_stack+34869,int_stack+34428, 0.0, zero_stack, 1.0, int_stack+48273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62793,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+32610,int_stack+8955,int_stack+30405, 0.0, zero_stack, 1.0, int_stack+155037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+186186,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+250179,int_stack+32610,int_stack+31350, 0.0, zero_stack, 1.0, int_stack+155982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192324,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+30405,int_stack+35607,int_stack+35457, 0.0, zero_stack, 1.0, int_stack+114084, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125406, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+30855,int_stack+35832,int_stack+35607, 0.0, zero_stack, 1.0, int_stack+114234, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125556, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+31530,int_stack+30855,int_stack+30405, 0.0, zero_stack, 1.0, int_stack+157242, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184161, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32430,int_stack+36147,int_stack+35832, 0.0, zero_stack, 1.0, int_stack+114459, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125781, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8955,int_stack+32430,int_stack+30855, 0.0, zero_stack, 1.0, int_stack+157692, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184611, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+32430,int_stack+8955,int_stack+31530, 0.0, zero_stack, 1.0, int_stack+158367, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185286, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8955,int_stack+36777,int_stack+36567, 0.0, zero_stack, 1.0, int_stack+50853, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+61743, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+33930,int_stack+37092,int_stack+36777, 0.0, zero_stack, 1.0, int_stack+51273, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62163, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+34875,int_stack+33930,int_stack+8955, 0.0, zero_stack, 1.0, int_stack+162555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189474, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8955,int_stack+37533,int_stack+37092, 0.0, zero_stack, 1.0, int_stack+51903, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62793, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+36135,int_stack+8955,int_stack+33930, 0.0, zero_stack, 1.0, int_stack+159267, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+186186, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+252279,int_stack+36135,int_stack+34875, 0.0, zero_stack, 1.0, int_stack+165405, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192324, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+33930,int_stack+38271,int_stack+38121, 0.0, zero_stack, 1.0, int_stack+117858, 0.0, zero_stack, 1.0, int_stack+125406, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+34380,int_stack+38496,int_stack+38271, 0.0, zero_stack, 1.0, int_stack+118008, 0.0, zero_stack, 1.0, int_stack+125556, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+35055,int_stack+34380,int_stack+33930, 0.0, zero_stack, 1.0, int_stack+166665, 0.0, zero_stack, 1.0, int_stack+184161, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+35955,int_stack+38811,int_stack+38496, 0.0, zero_stack, 1.0, int_stack+118233, 0.0, zero_stack, 1.0, int_stack+125781, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8955,int_stack+35955,int_stack+34380, 0.0, zero_stack, 1.0, int_stack+167115, 0.0, zero_stack, 1.0, int_stack+184611, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+35955,int_stack+8955,int_stack+35055, 0.0, zero_stack, 1.0, int_stack+167790, 0.0, zero_stack, 1.0, int_stack+185286, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8955,int_stack+39441,int_stack+39231, 0.0, zero_stack, 1.0, int_stack+54483, 0.0, zero_stack, 1.0, int_stack+61743, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+37455,int_stack+39756,int_stack+39441, 0.0, zero_stack, 1.0, int_stack+54903, 0.0, zero_stack, 1.0, int_stack+62163, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+38400,int_stack+37455,int_stack+8955, 0.0, zero_stack, 1.0, int_stack+171978, 0.0, zero_stack, 1.0, int_stack+189474, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8955,int_stack+40197,int_stack+39756, 0.0, zero_stack, 1.0, int_stack+55533, 0.0, zero_stack, 1.0, int_stack+62793, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+33930,int_stack+8955,int_stack+37455, 0.0, zero_stack, 1.0, int_stack+168690, 0.0, zero_stack, 1.0, int_stack+186186, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+254379,int_stack+33930,int_stack+38400, 0.0, zero_stack, 1.0, int_stack+174828, 0.0, zero_stack, 1.0, int_stack+192324, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+33930,int_stack+40935,int_stack+40785, 0.0, zero_stack, 1.0, int_stack+121632, 1.0, int_stack+125406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+34380,int_stack+41160,int_stack+40935, 0.0, zero_stack, 1.0, int_stack+121782, 1.0, int_stack+125556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+35055,int_stack+34380,int_stack+33930, 0.0, zero_stack, 1.0, int_stack+176088, 1.0, int_stack+184161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+37455,int_stack+41475,int_stack+41160, 0.0, zero_stack, 1.0, int_stack+122007, 1.0, int_stack+125781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8955,int_stack+37455,int_stack+34380, 0.0, zero_stack, 1.0, int_stack+176538, 1.0, int_stack+184611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+37455,int_stack+8955,int_stack+35055, 0.0, zero_stack, 1.0, int_stack+177213, 1.0, int_stack+185286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8955,int_stack+42105,int_stack+41895, 0.0, zero_stack, 1.0, int_stack+58113, 1.0, int_stack+61743, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38955,int_stack+42420,int_stack+42105, 0.0, zero_stack, 1.0, int_stack+58533, 1.0, int_stack+62163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+39900,int_stack+38955,int_stack+8955, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+189474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8955,int_stack+42861,int_stack+42420, 0.0, zero_stack, 1.0, int_stack+59163, 1.0, int_stack+62793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+41160,int_stack+8955,int_stack+38955, 0.0, zero_stack, 1.0, int_stack+630, 1.0, int_stack+186186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+256479,int_stack+41160,int_stack+39900, 0.0, zero_stack, 1.0, int_stack+182901, 1.0, int_stack+192324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+38955,int_stack+43599,int_stack+43449, 0.0, zero_stack, 2.0, int_stack+125406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+39405,int_stack+43824,int_stack+43599, 0.0, zero_stack, 2.0, int_stack+125556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+40080,int_stack+39405,int_stack+38955, 0.0, zero_stack, 2.0, int_stack+184161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+40980,int_stack+44139,int_stack+43824, 0.0, zero_stack, 2.0, int_stack+125781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8955,int_stack+40980,int_stack+39405, 0.0, zero_stack, 2.0, int_stack+184611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+40980,int_stack+8955,int_stack+40080, 0.0, zero_stack, 2.0, int_stack+185286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8955,int_stack+44769,int_stack+44559, 0.0, zero_stack, 2.0, int_stack+61743, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42480,int_stack+45084,int_stack+44769, 0.0, zero_stack, 2.0, int_stack+62163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+43425,int_stack+42480,int_stack+8955, 0.0, zero_stack, 2.0, int_stack+189474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8955,int_stack+45525,int_stack+45084, 0.0, zero_stack, 2.0, int_stack+62793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+38955,int_stack+8955,int_stack+42480, 0.0, zero_stack, 2.0, int_stack+186186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+258579,int_stack+38955,int_stack+43425, 0.0, zero_stack, 2.0, int_stack+192324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+38955,int_stack+46263,int_stack+46113, 1.0, int_stack+110310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129330,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+39405,int_stack+46488,int_stack+46263, 1.0, int_stack+110460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129705,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+40080,int_stack+39405,int_stack+38955, 1.0, int_stack+147957, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193584,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+42480,int_stack+46803,int_stack+46488, 1.0, int_stack+110685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+130245,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8955,int_stack+42480,int_stack+39405, 1.0, int_stack+148407, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194034,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+42480,int_stack+8955,int_stack+40080, 1.0, int_stack+149082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194709,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8955,int_stack+47958,int_stack+47433, 1.0, int_stack+47223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+65583,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+43980,int_stack+48714,int_stack+47958, 1.0, int_stack+47643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66318,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+44925,int_stack+43980,int_stack+8955, 1.0, int_stack+151557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8955,int_stack+49155,int_stack+48714, 1.0, int_stack+48273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66948,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+46185,int_stack+8955,int_stack+43980, 1.0, int_stack+155037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195609,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+147192,int_stack+46185,int_stack+44925, 1.0, int_stack+155982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200397,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+43980,int_stack+49893,int_stack+49743, 1.0, int_stack+114084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129330, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+44430,int_stack+50118,int_stack+49893, 1.0, int_stack+114234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129705, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+45105,int_stack+44430,int_stack+43980, 1.0, int_stack+157242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193584, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+46005,int_stack+50433,int_stack+50118, 1.0, int_stack+114459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+130245, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8955,int_stack+46005,int_stack+44430, 1.0, int_stack+157692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194034, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+46005,int_stack+8955,int_stack+45105, 1.0, int_stack+158367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194709, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8955,int_stack+51588,int_stack+51063, 1.0, int_stack+50853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+65583, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+47505,int_stack+52344,int_stack+51588, 1.0, int_stack+51273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66318, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+48450,int_stack+47505,int_stack+8955, 1.0, int_stack+162555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+162555,int_stack+52785,int_stack+52344, 1.0, int_stack+51903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66948, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+49710,int_stack+162555,int_stack+47505, 1.0, int_stack+159267, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195609, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+154677,int_stack+49710,int_stack+48450, 1.0, int_stack+165405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200397, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+165405,int_stack+53523,int_stack+53373, 1.0, int_stack+117858, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129330, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+165855,int_stack+53748,int_stack+53523, 1.0, int_stack+118008, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129705, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+47505,int_stack+165855,int_stack+165405, 1.0, int_stack+166665, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193584, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+48405,int_stack+54063,int_stack+53748, 1.0, int_stack+118233, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+130245, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+162555,int_stack+48405,int_stack+165855, 1.0, int_stack+167115, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194034, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+48405,int_stack+162555,int_stack+47505, 1.0, int_stack+167790, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194709, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+47505,int_stack+55218,int_stack+54693, 1.0, int_stack+54483, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+65583, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+162555,int_stack+55974,int_stack+55218, 1.0, int_stack+54903, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66318, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+49905,int_stack+162555,int_stack+47505, 1.0, int_stack+171978, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+171978,int_stack+56415,int_stack+55974, 1.0, int_stack+55533, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66948, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+51165,int_stack+171978,int_stack+162555, 1.0, int_stack+168690, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195609, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+53055,int_stack+51165,int_stack+49905, 1.0, int_stack+174828, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200397, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+174828,int_stack+57153,int_stack+57003, 1.0, int_stack+121632, 0.0, zero_stack, 1.0, int_stack+129330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+175278,int_stack+57378,int_stack+57153, 1.0, int_stack+121782, 0.0, zero_stack, 1.0, int_stack+129705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+47505,int_stack+175278,int_stack+174828, 1.0, int_stack+176088, 0.0, zero_stack, 1.0, int_stack+193584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+49905,int_stack+57693,int_stack+57378, 1.0, int_stack+122007, 0.0, zero_stack, 1.0, int_stack+130245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+162555,int_stack+49905,int_stack+175278, 1.0, int_stack+176538, 0.0, zero_stack, 1.0, int_stack+194034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+49905,int_stack+162555,int_stack+47505, 1.0, int_stack+177213, 0.0, zero_stack, 1.0, int_stack+194709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+47505,int_stack+58848,int_stack+58323, 1.0, int_stack+58113, 0.0, zero_stack, 1.0, int_stack+65583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+162555,int_stack+59604,int_stack+58848, 1.0, int_stack+58533, 0.0, zero_stack, 1.0, int_stack+66318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+51405,int_stack+162555,int_stack+47505, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+1575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+174828,int_stack+60045,int_stack+59604, 1.0, int_stack+59163, 0.0, zero_stack, 1.0, int_stack+66948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+176151,int_stack+174828,int_stack+162555, 1.0, int_stack+630, 0.0, zero_stack, 1.0, int_stack+195609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+55155,int_stack+176151,int_stack+51405, 1.0, int_stack+182901, 0.0, zero_stack, 1.0, int_stack+200397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+182901,int_stack+60783,int_stack+60633, 1.0, int_stack+125406, 1.0, int_stack+129330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+183351,int_stack+61008,int_stack+60783, 1.0, int_stack+125556, 1.0, int_stack+129705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+47505,int_stack+183351,int_stack+182901, 1.0, int_stack+184161, 1.0, int_stack+193584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+51405,int_stack+61323,int_stack+61008, 1.0, int_stack+125781, 1.0, int_stack+130245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+162555,int_stack+51405,int_stack+183351, 1.0, int_stack+184611, 1.0, int_stack+194034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+51405,int_stack+162555,int_stack+47505, 1.0, int_stack+185286, 1.0, int_stack+194709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+47505,int_stack+62478,int_stack+61953, 1.0, int_stack+61743, 1.0, int_stack+65583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+162555,int_stack+63234,int_stack+62478, 1.0, int_stack+62163, 1.0, int_stack+66318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+182901,int_stack+162555,int_stack+47505, 1.0, int_stack+189474, 1.0, int_stack+1575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+189474,int_stack+63675,int_stack+63234, 1.0, int_stack+62793, 1.0, int_stack+66948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+184161,int_stack+189474,int_stack+162555, 1.0, int_stack+186186, 1.0, int_stack+195609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+174828,int_stack+184161,int_stack+182901, 1.0, int_stack+192324, 1.0, int_stack+200397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+192324,int_stack+64413,int_stack+64263, 2.0, int_stack+129330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+192774,int_stack+64638,int_stack+64413, 2.0, int_stack+129705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+47505,int_stack+192774,int_stack+192324, 2.0, int_stack+193584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+182901,int_stack+64953,int_stack+64638, 2.0, int_stack+130245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+162555,int_stack+182901,int_stack+192774, 2.0, int_stack+194034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+182901,int_stack+162555,int_stack+47505, 2.0, int_stack+194709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+47505,int_stack+66633,int_stack+65793, 2.0, int_stack+65583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+162555,int_stack+67389,int_stack+66633, 2.0, int_stack+66318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+184401,int_stack+162555,int_stack+47505, 2.0, int_stack+1575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+185661,int_stack+67830,int_stack+67389, 2.0, int_stack+66948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+192324,int_stack+185661,int_stack+162555, 2.0, int_stack+195609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+194214,int_stack+192324,int_stack+184401, 2.0, int_stack+200397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+200397,int_stack+68568,int_stack+68418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134610,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+200847,int_stack+68793,int_stack+68568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134760,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+47505,int_stack+200847,int_stack+200397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201657,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+184401,int_stack+69108,int_stack+68793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134985,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+162555,int_stack+184401,int_stack+200847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202107,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+184401,int_stack+162555,int_stack+47505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153777,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+47505,int_stack+69738,int_stack+69528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82848,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+162555,int_stack+70053,int_stack+69738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83268,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+200397,int_stack+162555,int_stack+47505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+185901,int_stack+70494,int_stack+70053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83898,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+192324,int_stack+185901,int_stack+162555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+176928,int_stack+192324,int_stack+200397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145932,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+200397,int_stack+71232,int_stack+71082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134610, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+200847,int_stack+71457,int_stack+71232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134760, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+47505,int_stack+200847,int_stack+200397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201657, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+192324,int_stack+71772,int_stack+71457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134985, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+162555,int_stack+192324,int_stack+200847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202107, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+192324,int_stack+162555,int_stack+47505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153777, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+47505,int_stack+72402,int_stack+72192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82848, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+162555,int_stack+72717,int_stack+72402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83268, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+200397,int_stack+162555,int_stack+47505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+185901,int_stack+73158,int_stack+72717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83898, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+185901,int_stack+162555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+57255,int_stack+0,int_stack+200397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145932, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+200397,int_stack+73896,int_stack+73746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134610, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+200847,int_stack+74121,int_stack+73896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134760, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+47505,int_stack+200847,int_stack+200397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201657, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+74436,int_stack+74121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134985, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+162555,int_stack+0,int_stack+200847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202107, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+0,int_stack+162555,int_stack+47505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153777, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+47505,int_stack+75066,int_stack+74856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82848, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+162555,int_stack+75381,int_stack+75066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83268, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+200397,int_stack+162555,int_stack+47505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+185901,int_stack+75822,int_stack+75381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83898, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+59355,int_stack+185901,int_stack+162555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+61245,int_stack+59355,int_stack+200397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145932, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+200397,int_stack+76560,int_stack+76410, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+200847,int_stack+76785,int_stack+76560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+47505,int_stack+200847,int_stack+200397, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+59355,int_stack+77100,int_stack+76785, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+162555,int_stack+59355,int_stack+200847, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+59355,int_stack+162555,int_stack+47505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+47505,int_stack+77730,int_stack+77520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+162555,int_stack+78045,int_stack+77730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+200397,int_stack+162555,int_stack+47505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+185901,int_stack+78486,int_stack+78045, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+63345,int_stack+185901,int_stack+162555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+65235,int_stack+63345,int_stack+200397, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+200397,int_stack+79224,int_stack+79074, 0.0, zero_stack, 1.0, int_stack+134610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+200847,int_stack+79449,int_stack+79224, 0.0, zero_stack, 1.0, int_stack+134760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+47505,int_stack+200847,int_stack+200397, 0.0, zero_stack, 1.0, int_stack+201657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+63345,int_stack+79764,int_stack+79449, 0.0, zero_stack, 1.0, int_stack+134985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+162555,int_stack+63345,int_stack+200847, 0.0, zero_stack, 1.0, int_stack+202107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+63345,int_stack+162555,int_stack+47505, 0.0, zero_stack, 1.0, int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+47505,int_stack+80394,int_stack+80184, 0.0, zero_stack, 1.0, int_stack+82848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+162555,int_stack+80709,int_stack+80394, 0.0, zero_stack, 1.0, int_stack+83268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+200397,int_stack+162555,int_stack+47505, 0.0, zero_stack, 1.0, int_stack+2205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+185901,int_stack+81150,int_stack+80709, 0.0, zero_stack, 1.0, int_stack+83898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+67335,int_stack+185901,int_stack+162555, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+69225,int_stack+67335,int_stack+200397, 0.0, zero_stack, 1.0, int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+200397,int_stack+81888,int_stack+81738, 1.0, int_stack+134610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+200847,int_stack+82113,int_stack+81888, 1.0, int_stack+134760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+47505,int_stack+200847,int_stack+200397, 1.0, int_stack+201657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+67335,int_stack+82428,int_stack+82113, 1.0, int_stack+134985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+162555,int_stack+67335,int_stack+200847, 1.0, int_stack+202107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+67335,int_stack+162555,int_stack+47505, 1.0, int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+83583,int_stack+83058, 1.0, int_stack+82848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+162555,int_stack+84339,int_stack+83583, 1.0, int_stack+83268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+200397,int_stack+162555,int_stack+153777, 1.0, int_stack+2205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+201657,int_stack+84780,int_stack+84339, 1.0, int_stack+83898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+71325,int_stack+201657,int_stack+162555, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+1500,int_stack+71325,int_stack+200397, 1.0, int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+85518,int_stack+85368,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+85743,int_stack+85518,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+146382,int_stack+145932,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+200397,int_stack+86058,int_stack+85743,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+162555,int_stack+200397,int_stack+146382,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+200397,int_stack+162555,int_stack+153777,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+86688,int_stack+86478,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+162555,int_stack+87003,int_stack+86688,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+162555,int_stack+153777,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+71325,int_stack+87444,int_stack+87003,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+72648,int_stack+71325,int_stack+162555,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+74538,int_stack+72648,int_stack+145932,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+88182,int_stack+88032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138384,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+88407,int_stack+88182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138534,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+146382,int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206970,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+162555,int_stack+88722,int_stack+88407, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138759,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+162555,int_stack+146382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207420,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+71325,int_stack+189474,int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208095,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+89352,int_stack+89142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102462,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+89667,int_stack+89352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102882,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212283,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+162555,int_stack+90108,int_stack+89667, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103512,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+76638,int_stack+162555,int_stack+189474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208995,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+78528,int_stack+76638,int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215133,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+90846,int_stack+90696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138384, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+91071,int_stack+90846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138534, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+146382,int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206970, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+76638,int_stack+91386,int_stack+91071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138759, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+76638,int_stack+146382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207420, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+76638,int_stack+189474,int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208095, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+92016,int_stack+91806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102462, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+92331,int_stack+92016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102882, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212283, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+162555,int_stack+92772,int_stack+92331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103512, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+80628,int_stack+162555,int_stack+189474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208995, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+82518,int_stack+80628,int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215133, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+93510,int_stack+93360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138384, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+93735,int_stack+93510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138534, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+146382,int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206970, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+80628,int_stack+94050,int_stack+93735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138759, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+80628,int_stack+146382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207420, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+80628,int_stack+189474,int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208095, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+94680,int_stack+94470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102462, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+94995,int_stack+94680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102882, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212283, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+162555,int_stack+95436,int_stack+94995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103512, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+84618,int_stack+162555,int_stack+189474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208995, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+86508,int_stack+84618,int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215133, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+96174,int_stack+96024, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+96399,int_stack+96174, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+146382,int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+84618,int_stack+96714,int_stack+96399, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+84618,int_stack+146382, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+84618,int_stack+189474,int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+97344,int_stack+97134, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+97659,int_stack+97344, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+162555,int_stack+98100,int_stack+97659, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+88608,int_stack+162555,int_stack+189474, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+90498,int_stack+88608,int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+98838,int_stack+98688, 0.0, zero_stack, 1.0, int_stack+138384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+99063,int_stack+98838, 0.0, zero_stack, 1.0, int_stack+138534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+146382,int_stack+145932, 0.0, zero_stack, 1.0, int_stack+206970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+88608,int_stack+99378,int_stack+99063, 0.0, zero_stack, 1.0, int_stack+138759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+88608,int_stack+146382, 0.0, zero_stack, 1.0, int_stack+207420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+88608,int_stack+189474,int_stack+153777, 0.0, zero_stack, 1.0, int_stack+208095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+100008,int_stack+99798, 0.0, zero_stack, 1.0, int_stack+102462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+100323,int_stack+100008, 0.0, zero_stack, 1.0, int_stack+102882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777, 0.0, zero_stack, 1.0, int_stack+212283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+162555,int_stack+100764,int_stack+100323, 0.0, zero_stack, 1.0, int_stack+103512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+92598,int_stack+162555,int_stack+189474, 0.0, zero_stack, 1.0, int_stack+208995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+94488,int_stack+92598,int_stack+145932, 0.0, zero_stack, 1.0, int_stack+215133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+101502,int_stack+101352, 1.0, int_stack+138384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+101727,int_stack+101502, 1.0, int_stack+138534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+146382,int_stack+145932, 1.0, int_stack+206970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+92598,int_stack+102042,int_stack+101727, 1.0, int_stack+138759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+92598,int_stack+146382, 1.0, int_stack+207420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+92598,int_stack+189474,int_stack+153777, 1.0, int_stack+208095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+103197,int_stack+102672, 1.0, int_stack+102462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+103953,int_stack+103197, 1.0, int_stack+102882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777, 1.0, int_stack+212283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+212283,int_stack+104394,int_stack+103953, 1.0, int_stack+103512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+206970,int_stack+212283,int_stack+189474, 1.0, int_stack+208995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+96588,int_stack+206970,int_stack+145932, 1.0, int_stack+215133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+215133,int_stack+105132,int_stack+104982,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+215583,int_stack+105357,int_stack+105132,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+215583,int_stack+215133,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+145932,int_stack+105672,int_stack+105357,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+145932,int_stack+215583,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+206970,int_stack+189474,int_stack+153777,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+106302,int_stack+106092,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+106617,int_stack+106302,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+208470,int_stack+107058,int_stack+106617,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+98688,int_stack+208470,int_stack+189474,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+100578,int_stack+98688,int_stack+145932,21);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+107796,int_stack+107646,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+108021,int_stack+107796,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+146382,int_stack+145932,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+98688,int_stack+108336,int_stack+108021,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+98688,int_stack+146382,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+98688,int_stack+189474,int_stack+153777,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+108966,int_stack+108756,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+109281,int_stack+108966,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+208470,int_stack+109722,int_stack+109281,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+102678,int_stack+208470,int_stack+189474,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+104568,int_stack+102678,int_stack+145932,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+111570,int_stack+111420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142158,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+111795,int_stack+111570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142308,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+146382,int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216393,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102678,int_stack+112110,int_stack+111795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142533,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+102678,int_stack+146382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216843,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+102678,int_stack+189474,int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217518,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+112740,int_stack+112530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+132090,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+113055,int_stack+112740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+132510,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3780,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+208470,int_stack+113496,int_stack+113055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133140,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+106668,int_stack+208470,int_stack+189474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4410,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+108558,int_stack+106668,int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223206,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+115344,int_stack+115194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142158, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+115569,int_stack+115344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142308, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+146382,int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216393, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+106668,int_stack+115884,int_stack+115569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142533, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+106668,int_stack+146382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216843, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+106668,int_stack+189474,int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217518, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+116514,int_stack+116304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+132090, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+116829,int_stack+116514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+132510, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3780, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+208470,int_stack+117270,int_stack+116829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133140, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+110658,int_stack+208470,int_stack+189474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4410, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+112548,int_stack+110658,int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223206, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+119118,int_stack+118968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142158, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+119343,int_stack+119118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142308, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+146382,int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216393, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+110658,int_stack+119658,int_stack+119343, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142533, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+110658,int_stack+146382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216843, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+110658,int_stack+189474,int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217518, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+120288,int_stack+120078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+132090, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+120603,int_stack+120288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+132510, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+208470,int_stack+121044,int_stack+120603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133140, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+114648,int_stack+208470,int_stack+189474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4410, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+116538,int_stack+114648,int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223206, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+122892,int_stack+122742, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+123117,int_stack+122892, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+146382,int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216393, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114648,int_stack+123432,int_stack+123117, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+114648,int_stack+146382, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+114648,int_stack+189474,int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+124062,int_stack+123852, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+132090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+124377,int_stack+124062, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+132510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+208470,int_stack+124818,int_stack+124377, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+118638,int_stack+208470,int_stack+189474, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+120528,int_stack+118638,int_stack+145932, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+126666,int_stack+126516, 0.0, zero_stack, 1.0, int_stack+142158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+126891,int_stack+126666, 0.0, zero_stack, 1.0, int_stack+142308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+146382,int_stack+145932, 0.0, zero_stack, 1.0, int_stack+216393, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+118638,int_stack+127206,int_stack+126891, 0.0, zero_stack, 1.0, int_stack+142533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+118638,int_stack+146382, 0.0, zero_stack, 1.0, int_stack+216843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+118638,int_stack+189474,int_stack+153777, 0.0, zero_stack, 1.0, int_stack+217518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+127836,int_stack+127626, 0.0, zero_stack, 1.0, int_stack+132090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+128151,int_stack+127836, 0.0, zero_stack, 1.0, int_stack+132510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777, 0.0, zero_stack, 1.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+208470,int_stack+128592,int_stack+128151, 0.0, zero_stack, 1.0, int_stack+133140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+122628,int_stack+208470,int_stack+189474, 0.0, zero_stack, 1.0, int_stack+4410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+124518,int_stack+122628,int_stack+145932, 0.0, zero_stack, 1.0, int_stack+223206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+131130,int_stack+130980, 1.0, int_stack+142158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+131355,int_stack+131130, 1.0, int_stack+142308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+146382,int_stack+145932, 1.0, int_stack+216393, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+122628,int_stack+131670,int_stack+131355, 1.0, int_stack+142533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+122628,int_stack+146382, 1.0, int_stack+216843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+122628,int_stack+189474,int_stack+153777, 1.0, int_stack+217518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+132825,int_stack+132300, 1.0, int_stack+132090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+133581,int_stack+132825, 1.0, int_stack+132510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777, 1.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+208470,int_stack+134022,int_stack+133581, 1.0, int_stack+133140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+215133,int_stack+208470,int_stack+189474, 1.0, int_stack+4410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+217023,int_stack+215133,int_stack+145932, 1.0, int_stack+223206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+223206,int_stack+135870,int_stack+135720,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+223656,int_stack+136095,int_stack+135870,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+223656,int_stack+223206,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+145932,int_stack+136410,int_stack+136095,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+145932,int_stack+223656,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+215133,int_stack+189474,int_stack+153777,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+137040,int_stack+136830,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+137355,int_stack+137040,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+208470,int_stack+137796,int_stack+137355,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+126618,int_stack+208470,int_stack+189474,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+128508,int_stack+126618,int_stack+145932,21);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+139644,int_stack+139494,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+139869,int_stack+139644,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+146382,int_stack+145932,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+126618,int_stack+140184,int_stack+139869,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+126618,int_stack+146382,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+126618,int_stack+189474,int_stack+153777,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+140814,int_stack+140604,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+141129,int_stack+140814,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+208470,int_stack+141570,int_stack+141129,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+130608,int_stack+208470,int_stack+189474,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+132498,int_stack+130608,int_stack+145932,21);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+145932,int_stack+143418,int_stack+143268,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+146382,int_stack+143643,int_stack+143418,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+153777,int_stack+146382,int_stack+145932,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+130608,int_stack+143958,int_stack+143643,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+189474,int_stack+130608,int_stack+146382,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+130608,int_stack+189474,int_stack+153777,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+153777,int_stack+144588,int_stack+144378,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+189474,int_stack+144903,int_stack+144588,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+145932,int_stack+189474,int_stack+153777,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+208470,int_stack+145344,int_stack+144903,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+134598,int_stack+208470,int_stack+189474,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+136488,int_stack+134598,int_stack+145932,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+138588,int_stack+160455,int_stack+152277,100);
     Libderiv->ABCD[11] = int_stack + 138588;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+156777,int_stack+169878,int_stack+163905,100);
     Libderiv->ABCD[10] = int_stack + 156777;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+165405,int_stack+179301,int_stack+173328,100);
     Libderiv->ABCD[9] = int_stack + 165405;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+260679,int_stack+187374,int_stack+181401,100);
     Libderiv->ABCD[8] = int_stack + 260679;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+185901,int_stack+196797,int_stack+190824,100);
     Libderiv->ABCD[7] = int_stack + 185901;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+265179,int_stack+204870,int_stack+198897,100);
     Libderiv->ABCD[6] = int_stack + 265179;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+269679,int_stack+210183,int_stack+149982, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[2] = int_stack + 269679;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+208470,int_stack+219606,int_stack+213633, 0.0, zero_stack, 1.0, int_stack+203007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[1] = int_stack + 208470;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+274179,int_stack+227679,int_stack+221706, 1.0, int_stack+203007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[0] = int_stack + 274179;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+201897,int_stack+5355,int_stack+229779,100);
     Libderiv->ABCD[155] = int_stack + 201897;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+225966,int_stack+231279,int_stack+7455,100);
     Libderiv->ABCD[143] = int_stack + 225966;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+3600,int_stack+233379,int_stack+10305,100);
     Libderiv->ABCD[142] = int_stack + 3600;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+8100,int_stack+235479,int_stack+224466,100);
     Libderiv->ABCD[131] = int_stack + 8100;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+230466,int_stack+237579,int_stack+13830,100);
     Libderiv->ABCD[130] = int_stack + 230466;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+12600,int_stack+239679,int_stack+17355,100);
     Libderiv->ABCD[129] = int_stack + 12600;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+234966,int_stack+241779,int_stack+18855,100);
     Libderiv->ABCD[119] = int_stack + 234966;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+17100,int_stack+243879,int_stack+22380,100);
     Libderiv->ABCD[118] = int_stack + 17100;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+239466,int_stack+245979,int_stack+23880,100);
     Libderiv->ABCD[117] = int_stack + 239466;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+21600,int_stack+248079,int_stack+27405,100);
     Libderiv->ABCD[116] = int_stack + 21600;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+243966,int_stack+250179,int_stack+28905,100);
     Libderiv->ABCD[107] = int_stack + 243966;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+26100,int_stack+252279,int_stack+32430,100);
     Libderiv->ABCD[106] = int_stack + 26100;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+30600,int_stack+254379,int_stack+35955,100);
     Libderiv->ABCD[105] = int_stack + 30600;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+248466,int_stack+256479,int_stack+37455,100);
     Libderiv->ABCD[104] = int_stack + 248466;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+35100,int_stack+258579,int_stack+40980,100);
     Libderiv->ABCD[103] = int_stack + 35100;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+252966,int_stack+147192,int_stack+42480,100);
     Libderiv->ABCD[95] = int_stack + 252966;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+143088,int_stack+154677,int_stack+46005,100);
     Libderiv->ABCD[94] = int_stack + 143088;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+39600,int_stack+53055,int_stack+48405,100);
     Libderiv->ABCD[93] = int_stack + 39600;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+44100,int_stack+55155,int_stack+49905,100);
     Libderiv->ABCD[92] = int_stack + 44100;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+278679,int_stack+174828,int_stack+51405,100);
     Libderiv->ABCD[91] = int_stack + 278679;
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+48600,int_stack+194214,int_stack+182901,100);
     Libderiv->ABCD[90] = int_stack + 48600;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+193824,int_stack+176928,int_stack+184401, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[47] = int_stack + 193824;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+174828,int_stack+57255,int_stack+192324, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[46] = int_stack + 174828;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+53100,int_stack+61245,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[45] = int_stack + 53100;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+283179,int_stack+65235,int_stack+59355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[44] = int_stack + 283179;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+57600,int_stack+69225,int_stack+63345, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[43] = int_stack + 57600;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+62100,int_stack+1500,int_stack+67335, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[42] = int_stack + 62100;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+66600,int_stack+74538,int_stack+200397, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+149982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[38] = int_stack + 66600;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+287679,int_stack+78528,int_stack+71325, 0.0, zero_stack, 1.0, int_stack+152277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[35] = int_stack + 287679;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+71100,int_stack+82518,int_stack+76638, 0.0, zero_stack, 1.0, int_stack+163905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[34] = int_stack + 71100;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+75600,int_stack+86508,int_stack+80628, 0.0, zero_stack, 1.0, int_stack+173328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[33] = int_stack + 75600;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+80100,int_stack+90498,int_stack+84618, 0.0, zero_stack, 1.0, int_stack+181401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[32] = int_stack + 80100;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+292179,int_stack+94488,int_stack+88608, 0.0, zero_stack, 1.0, int_stack+190824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[31] = int_stack + 292179;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+84600,int_stack+96588,int_stack+92598, 0.0, zero_stack, 1.0, int_stack+198897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[30] = int_stack + 84600;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+89100,int_stack+100578,int_stack+206970, 0.0, zero_stack, 1.0, int_stack+149982, 1.0, int_stack+213633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[26] = int_stack + 89100;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+93600,int_stack+104568,int_stack+98688, 0.0, zero_stack, 2.0, int_stack+213633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[25] = int_stack + 93600;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+98100,int_stack+108558,int_stack+102678, 1.0, int_stack+152277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[23] = int_stack + 98100;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+151482,int_stack+112548,int_stack+106668, 1.0, int_stack+163905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[22] = int_stack + 151482;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+102600,int_stack+116538,int_stack+110658, 1.0, int_stack+173328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[21] = int_stack + 102600;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+107100,int_stack+120528,int_stack+114648, 1.0, int_stack+181401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[20] = int_stack + 107100;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+179328,int_stack+124518,int_stack+118638, 1.0, int_stack+190824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[19] = int_stack + 179328;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+111600,int_stack+217023,int_stack+122628, 1.0, int_stack+198897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[18] = int_stack + 111600;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+216633,int_stack+128508,int_stack+215133, 1.0, int_stack+149982, 0.0, zero_stack, 1.0, int_stack+221706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[14] = int_stack + 216633;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+116100,int_stack+132498,int_stack+126618, 1.0, int_stack+213633, 1.0, int_stack+221706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[13] = int_stack + 116100;
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+120600,int_stack+136488,int_stack+130608, 2.0, int_stack+221706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[12] = int_stack + 120600;

}
