/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_hhhh(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hh|hh) integrals */

void d1hrr_order_hhhh(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][5][11] = int_stack + 0;
 Libderiv->deriv_classes[5][6][11] = int_stack + 441;
 Libderiv->deriv_classes[5][7][11] = int_stack + 1029;
 Libderiv->deriv_classes[5][8][11] = int_stack + 1785;
 Libderiv->deriv_classes[5][9][11] = int_stack + 2730;
 Libderiv->deriv_classes[5][10][11] = int_stack + 3885;
 Libderiv->deriv_classes[6][5][11] = int_stack + 5271;
 Libderiv->deriv_classes[6][6][11] = int_stack + 5859;
 Libderiv->deriv_classes[6][7][11] = int_stack + 6643;
 Libderiv->deriv_classes[6][8][11] = int_stack + 7651;
 Libderiv->deriv_classes[6][9][11] = int_stack + 8911;
 Libderiv->deriv_classes[6][10][11] = int_stack + 10451;
 Libderiv->deriv_classes[7][5][11] = int_stack + 12299;
 Libderiv->deriv_classes[7][6][11] = int_stack + 13055;
 Libderiv->deriv_classes[7][7][11] = int_stack + 14063;
 Libderiv->deriv_classes[7][8][11] = int_stack + 15359;
 Libderiv->deriv_classes[7][9][11] = int_stack + 16979;
 Libderiv->deriv_classes[7][10][11] = int_stack + 18959;
 Libderiv->deriv_classes[8][5][11] = int_stack + 21335;
 Libderiv->deriv_classes[8][6][11] = int_stack + 22280;
 Libderiv->deriv_classes[8][7][11] = int_stack + 23540;
 Libderiv->deriv_classes[8][8][11] = int_stack + 25160;
 Libderiv->deriv_classes[8][9][11] = int_stack + 27185;
 Libderiv->deriv_classes[8][10][11] = int_stack + 29660;
 Libderiv->deriv_classes[9][5][11] = int_stack + 32630;
 Libderiv->deriv_classes[9][6][11] = int_stack + 33785;
 Libderiv->deriv_classes[9][7][11] = int_stack + 35325;
 Libderiv->deriv_classes[9][8][11] = int_stack + 37305;
 Libderiv->deriv_classes[9][9][11] = int_stack + 39780;
 Libderiv->deriv_classes[9][10][11] = int_stack + 42805;
 Libderiv->deriv_classes[10][5][11] = int_stack + 46435;
 Libderiv->deriv_classes[10][6][11] = int_stack + 47821;
 Libderiv->deriv_classes[10][7][11] = int_stack + 49669;
 Libderiv->deriv_classes[10][8][11] = int_stack + 52045;
 Libderiv->deriv_classes[10][9][11] = int_stack + 55015;
 Libderiv->deriv_classes[10][10][11] = int_stack + 58645;
 Libderiv->deriv_classes[5][5][10] = int_stack + 63001;
 Libderiv->deriv_classes[5][6][10] = int_stack + 63442;
 Libderiv->deriv_classes[5][7][10] = int_stack + 64030;
 Libderiv->deriv_classes[5][8][10] = int_stack + 64786;
 Libderiv->deriv_classes[5][9][10] = int_stack + 65731;
 Libderiv->deriv_classes[5][10][10] = int_stack + 66886;
 Libderiv->deriv_classes[6][5][10] = int_stack + 68272;
 Libderiv->deriv_classes[6][6][10] = int_stack + 68860;
 Libderiv->deriv_classes[6][7][10] = int_stack + 69644;
 Libderiv->deriv_classes[6][8][10] = int_stack + 70652;
 Libderiv->deriv_classes[6][9][10] = int_stack + 71912;
 Libderiv->deriv_classes[6][10][10] = int_stack + 73452;
 Libderiv->deriv_classes[7][5][10] = int_stack + 75300;
 Libderiv->deriv_classes[7][6][10] = int_stack + 76056;
 Libderiv->deriv_classes[7][7][10] = int_stack + 77064;
 Libderiv->deriv_classes[7][8][10] = int_stack + 78360;
 Libderiv->deriv_classes[7][9][10] = int_stack + 79980;
 Libderiv->deriv_classes[7][10][10] = int_stack + 81960;
 Libderiv->deriv_classes[8][5][10] = int_stack + 84336;
 Libderiv->deriv_classes[8][6][10] = int_stack + 85281;
 Libderiv->deriv_classes[8][7][10] = int_stack + 86541;
 Libderiv->deriv_classes[8][8][10] = int_stack + 88161;
 Libderiv->deriv_classes[8][9][10] = int_stack + 90186;
 Libderiv->deriv_classes[8][10][10] = int_stack + 92661;
 Libderiv->deriv_classes[9][5][10] = int_stack + 95631;
 Libderiv->deriv_classes[9][6][10] = int_stack + 96786;
 Libderiv->deriv_classes[9][7][10] = int_stack + 98326;
 Libderiv->deriv_classes[9][8][10] = int_stack + 100306;
 Libderiv->deriv_classes[9][9][10] = int_stack + 102781;
 Libderiv->deriv_classes[9][10][10] = int_stack + 105806;
 Libderiv->deriv_classes[10][5][10] = int_stack + 109436;
 Libderiv->deriv_classes[10][6][10] = int_stack + 110822;
 Libderiv->deriv_classes[10][7][10] = int_stack + 112670;
 Libderiv->deriv_classes[10][8][10] = int_stack + 115046;
 Libderiv->deriv_classes[10][9][10] = int_stack + 118016;
 Libderiv->deriv_classes[10][10][10] = int_stack + 121646;
 Libderiv->deriv_classes[5][5][9] = int_stack + 126002;
 Libderiv->deriv_classes[5][6][9] = int_stack + 126443;
 Libderiv->deriv_classes[5][7][9] = int_stack + 127031;
 Libderiv->deriv_classes[5][8][9] = int_stack + 127787;
 Libderiv->deriv_classes[5][9][9] = int_stack + 128732;
 Libderiv->deriv_classes[5][10][9] = int_stack + 129887;
 Libderiv->deriv_classes[6][5][9] = int_stack + 131273;
 Libderiv->deriv_classes[6][6][9] = int_stack + 131861;
 Libderiv->deriv_classes[6][7][9] = int_stack + 132645;
 Libderiv->deriv_classes[6][8][9] = int_stack + 133653;
 Libderiv->deriv_classes[6][9][9] = int_stack + 134913;
 Libderiv->deriv_classes[6][10][9] = int_stack + 136453;
 Libderiv->deriv_classes[7][5][9] = int_stack + 138301;
 Libderiv->deriv_classes[7][6][9] = int_stack + 139057;
 Libderiv->deriv_classes[7][7][9] = int_stack + 140065;
 Libderiv->deriv_classes[7][8][9] = int_stack + 141361;
 Libderiv->deriv_classes[7][9][9] = int_stack + 142981;
 Libderiv->deriv_classes[7][10][9] = int_stack + 144961;
 Libderiv->deriv_classes[8][5][9] = int_stack + 147337;
 Libderiv->deriv_classes[8][6][9] = int_stack + 148282;
 Libderiv->deriv_classes[8][7][9] = int_stack + 149542;
 Libderiv->deriv_classes[8][8][9] = int_stack + 151162;
 Libderiv->deriv_classes[8][9][9] = int_stack + 153187;
 Libderiv->deriv_classes[8][10][9] = int_stack + 155662;
 Libderiv->deriv_classes[9][5][9] = int_stack + 158632;
 Libderiv->deriv_classes[9][6][9] = int_stack + 159787;
 Libderiv->deriv_classes[9][7][9] = int_stack + 161327;
 Libderiv->deriv_classes[9][8][9] = int_stack + 163307;
 Libderiv->deriv_classes[9][9][9] = int_stack + 165782;
 Libderiv->deriv_classes[9][10][9] = int_stack + 168807;
 Libderiv->deriv_classes[10][5][9] = int_stack + 172437;
 Libderiv->deriv_classes[10][6][9] = int_stack + 173823;
 Libderiv->deriv_classes[10][7][9] = int_stack + 175671;
 Libderiv->deriv_classes[10][8][9] = int_stack + 178047;
 Libderiv->deriv_classes[10][9][9] = int_stack + 181017;
 Libderiv->deriv_classes[10][10][9] = int_stack + 184647;
 Libderiv->deriv_classes[5][5][8] = int_stack + 189003;
 Libderiv->deriv_classes[5][6][8] = int_stack + 189444;
 Libderiv->deriv_classes[5][7][8] = int_stack + 190032;
 Libderiv->deriv_classes[5][8][8] = int_stack + 190788;
 Libderiv->deriv_classes[5][9][8] = int_stack + 191733;
 Libderiv->deriv_classes[5][10][8] = int_stack + 192888;
 Libderiv->deriv_classes[6][5][8] = int_stack + 194274;
 Libderiv->deriv_classes[6][6][8] = int_stack + 194862;
 Libderiv->deriv_classes[6][7][8] = int_stack + 195646;
 Libderiv->deriv_classes[6][8][8] = int_stack + 196654;
 Libderiv->deriv_classes[6][9][8] = int_stack + 197914;
 Libderiv->deriv_classes[6][10][8] = int_stack + 199454;
 Libderiv->deriv_classes[7][5][8] = int_stack + 201302;
 Libderiv->deriv_classes[7][6][8] = int_stack + 202058;
 Libderiv->deriv_classes[7][7][8] = int_stack + 203066;
 Libderiv->deriv_classes[7][8][8] = int_stack + 204362;
 Libderiv->deriv_classes[7][9][8] = int_stack + 205982;
 Libderiv->deriv_classes[7][10][8] = int_stack + 207962;
 Libderiv->deriv_classes[8][5][8] = int_stack + 210338;
 Libderiv->deriv_classes[8][6][8] = int_stack + 211283;
 Libderiv->deriv_classes[8][7][8] = int_stack + 212543;
 Libderiv->deriv_classes[8][8][8] = int_stack + 214163;
 Libderiv->deriv_classes[8][9][8] = int_stack + 216188;
 Libderiv->deriv_classes[8][10][8] = int_stack + 218663;
 Libderiv->deriv_classes[9][5][8] = int_stack + 221633;
 Libderiv->deriv_classes[9][6][8] = int_stack + 222788;
 Libderiv->deriv_classes[9][7][8] = int_stack + 224328;
 Libderiv->deriv_classes[9][8][8] = int_stack + 226308;
 Libderiv->deriv_classes[9][9][8] = int_stack + 228783;
 Libderiv->deriv_classes[9][10][8] = int_stack + 231808;
 Libderiv->deriv_classes[10][5][8] = int_stack + 235438;
 Libderiv->deriv_classes[10][6][8] = int_stack + 236824;
 Libderiv->deriv_classes[10][7][8] = int_stack + 238672;
 Libderiv->deriv_classes[10][8][8] = int_stack + 241048;
 Libderiv->deriv_classes[10][9][8] = int_stack + 244018;
 Libderiv->deriv_classes[10][10][8] = int_stack + 247648;
 Libderiv->deriv_classes[5][5][7] = int_stack + 252004;
 Libderiv->deriv_classes[5][6][7] = int_stack + 252445;
 Libderiv->deriv_classes[5][7][7] = int_stack + 253033;
 Libderiv->deriv_classes[5][8][7] = int_stack + 253789;
 Libderiv->deriv_classes[5][9][7] = int_stack + 254734;
 Libderiv->deriv_classes[5][10][7] = int_stack + 255889;
 Libderiv->deriv_classes[6][5][7] = int_stack + 257275;
 Libderiv->deriv_classes[6][6][7] = int_stack + 257863;
 Libderiv->deriv_classes[6][7][7] = int_stack + 258647;
 Libderiv->deriv_classes[6][8][7] = int_stack + 259655;
 Libderiv->deriv_classes[6][9][7] = int_stack + 260915;
 Libderiv->deriv_classes[6][10][7] = int_stack + 262455;
 Libderiv->deriv_classes[7][5][7] = int_stack + 264303;
 Libderiv->deriv_classes[7][6][7] = int_stack + 265059;
 Libderiv->deriv_classes[7][7][7] = int_stack + 266067;
 Libderiv->deriv_classes[7][8][7] = int_stack + 267363;
 Libderiv->deriv_classes[7][9][7] = int_stack + 268983;
 Libderiv->deriv_classes[7][10][7] = int_stack + 270963;
 Libderiv->deriv_classes[8][5][7] = int_stack + 273339;
 Libderiv->deriv_classes[8][6][7] = int_stack + 274284;
 Libderiv->deriv_classes[8][7][7] = int_stack + 275544;
 Libderiv->deriv_classes[8][8][7] = int_stack + 277164;
 Libderiv->deriv_classes[8][9][7] = int_stack + 279189;
 Libderiv->deriv_classes[8][10][7] = int_stack + 281664;
 Libderiv->deriv_classes[9][5][7] = int_stack + 284634;
 Libderiv->deriv_classes[9][6][7] = int_stack + 285789;
 Libderiv->deriv_classes[9][7][7] = int_stack + 287329;
 Libderiv->deriv_classes[9][8][7] = int_stack + 289309;
 Libderiv->deriv_classes[9][9][7] = int_stack + 291784;
 Libderiv->deriv_classes[9][10][7] = int_stack + 294809;
 Libderiv->deriv_classes[10][5][7] = int_stack + 298439;
 Libderiv->deriv_classes[10][6][7] = int_stack + 299825;
 Libderiv->deriv_classes[10][7][7] = int_stack + 301673;
 Libderiv->deriv_classes[10][8][7] = int_stack + 304049;
 Libderiv->deriv_classes[10][9][7] = int_stack + 307019;
 Libderiv->deriv_classes[10][10][7] = int_stack + 310649;
 Libderiv->deriv_classes[5][5][6] = int_stack + 315005;
 Libderiv->deriv_classes[5][6][6] = int_stack + 315446;
 Libderiv->deriv_classes[5][7][6] = int_stack + 316034;
 Libderiv->deriv_classes[5][8][6] = int_stack + 316790;
 Libderiv->deriv_classes[5][9][6] = int_stack + 317735;
 Libderiv->deriv_classes[5][10][6] = int_stack + 318890;
 Libderiv->deriv_classes[6][5][6] = int_stack + 320276;
 Libderiv->deriv_classes[6][6][6] = int_stack + 320864;
 Libderiv->deriv_classes[6][7][6] = int_stack + 321648;
 Libderiv->deriv_classes[6][8][6] = int_stack + 322656;
 Libderiv->deriv_classes[6][9][6] = int_stack + 323916;
 Libderiv->deriv_classes[6][10][6] = int_stack + 325456;
 Libderiv->deriv_classes[7][5][6] = int_stack + 327304;
 Libderiv->deriv_classes[7][6][6] = int_stack + 328060;
 Libderiv->deriv_classes[7][7][6] = int_stack + 329068;
 Libderiv->deriv_classes[7][8][6] = int_stack + 330364;
 Libderiv->deriv_classes[7][9][6] = int_stack + 331984;
 Libderiv->deriv_classes[7][10][6] = int_stack + 333964;
 Libderiv->deriv_classes[8][5][6] = int_stack + 336340;
 Libderiv->deriv_classes[8][6][6] = int_stack + 337285;
 Libderiv->deriv_classes[8][7][6] = int_stack + 338545;
 Libderiv->deriv_classes[8][8][6] = int_stack + 340165;
 Libderiv->deriv_classes[8][9][6] = int_stack + 342190;
 Libderiv->deriv_classes[8][10][6] = int_stack + 344665;
 Libderiv->deriv_classes[9][5][6] = int_stack + 347635;
 Libderiv->deriv_classes[9][6][6] = int_stack + 348790;
 Libderiv->deriv_classes[9][7][6] = int_stack + 350330;
 Libderiv->deriv_classes[9][8][6] = int_stack + 352310;
 Libderiv->deriv_classes[9][9][6] = int_stack + 354785;
 Libderiv->deriv_classes[9][10][6] = int_stack + 357810;
 Libderiv->dvrr_classes[10][5] = int_stack + 361440;
 Libderiv->deriv_classes[10][5][6] = int_stack + 362826;
 Libderiv->dvrr_classes[10][6] = int_stack + 364212;
 Libderiv->deriv_classes[10][6][6] = int_stack + 366060;
 Libderiv->dvrr_classes[10][7] = int_stack + 367908;
 Libderiv->deriv_classes[10][7][6] = int_stack + 370284;
 Libderiv->dvrr_classes[10][8] = int_stack + 372660;
 Libderiv->deriv_classes[10][8][6] = int_stack + 375630;
 Libderiv->dvrr_classes[10][9] = int_stack + 378600;
 Libderiv->deriv_classes[10][9][6] = int_stack + 382230;
 Libderiv->deriv_classes[10][10][6] = int_stack + 385860;
 Libderiv->deriv_classes[5][5][2] = int_stack + 390216;
 Libderiv->deriv_classes[5][6][2] = int_stack + 390657;
 Libderiv->deriv_classes[5][7][2] = int_stack + 391245;
 Libderiv->deriv_classes[5][8][2] = int_stack + 392001;
 Libderiv->deriv_classes[5][9][2] = int_stack + 392946;
 Libderiv->deriv_classes[5][10][2] = int_stack + 394101;
 Libderiv->deriv_classes[6][5][2] = int_stack + 395487;
 Libderiv->deriv_classes[6][6][2] = int_stack + 396075;
 Libderiv->deriv_classes[6][7][2] = int_stack + 396859;
 Libderiv->deriv_classes[6][8][2] = int_stack + 397867;
 Libderiv->deriv_classes[6][9][2] = int_stack + 399127;
 Libderiv->deriv_classes[6][10][2] = int_stack + 400667;
 Libderiv->deriv_classes[7][5][2] = int_stack + 402515;
 Libderiv->deriv_classes[7][6][2] = int_stack + 403271;
 Libderiv->deriv_classes[7][7][2] = int_stack + 404279;
 Libderiv->deriv_classes[7][8][2] = int_stack + 405575;
 Libderiv->deriv_classes[7][9][2] = int_stack + 407195;
 Libderiv->deriv_classes[7][10][2] = int_stack + 409175;
 Libderiv->deriv_classes[8][5][2] = int_stack + 411551;
 Libderiv->deriv_classes[8][6][2] = int_stack + 412496;
 Libderiv->deriv_classes[8][7][2] = int_stack + 413756;
 Libderiv->deriv_classes[8][8][2] = int_stack + 415376;
 Libderiv->deriv_classes[8][9][2] = int_stack + 417401;
 Libderiv->deriv_classes[8][10][2] = int_stack + 419876;
 Libderiv->deriv_classes[9][5][2] = int_stack + 422846;
 Libderiv->deriv_classes[9][6][2] = int_stack + 424001;
 Libderiv->deriv_classes[9][7][2] = int_stack + 425541;
 Libderiv->deriv_classes[9][8][2] = int_stack + 427521;
 Libderiv->deriv_classes[9][9][2] = int_stack + 429996;
 Libderiv->deriv_classes[9][10][2] = int_stack + 433021;
 Libderiv->deriv_classes[10][5][2] = int_stack + 436651;
 Libderiv->deriv_classes[10][6][2] = int_stack + 438037;
 Libderiv->deriv_classes[10][7][2] = int_stack + 439885;
 Libderiv->deriv_classes[10][8][2] = int_stack + 442261;
 Libderiv->deriv_classes[10][9][2] = int_stack + 445231;
 Libderiv->deriv_classes[10][10][2] = int_stack + 448861;
 Libderiv->deriv_classes[5][5][1] = int_stack + 453217;
 Libderiv->deriv_classes[5][6][1] = int_stack + 453658;
 Libderiv->deriv_classes[5][7][1] = int_stack + 454246;
 Libderiv->deriv_classes[5][8][1] = int_stack + 455002;
 Libderiv->deriv_classes[5][9][1] = int_stack + 455947;
 Libderiv->deriv_classes[5][10][1] = int_stack + 457102;
 Libderiv->deriv_classes[6][5][1] = int_stack + 458488;
 Libderiv->deriv_classes[6][6][1] = int_stack + 459076;
 Libderiv->deriv_classes[6][7][1] = int_stack + 459860;
 Libderiv->deriv_classes[6][8][1] = int_stack + 460868;
 Libderiv->deriv_classes[6][9][1] = int_stack + 462128;
 Libderiv->deriv_classes[6][10][1] = int_stack + 463668;
 Libderiv->deriv_classes[7][5][1] = int_stack + 465516;
 Libderiv->deriv_classes[7][6][1] = int_stack + 466272;
 Libderiv->deriv_classes[7][7][1] = int_stack + 467280;
 Libderiv->deriv_classes[7][8][1] = int_stack + 468576;
 Libderiv->deriv_classes[7][9][1] = int_stack + 470196;
 Libderiv->deriv_classes[7][10][1] = int_stack + 472176;
 Libderiv->deriv_classes[8][5][1] = int_stack + 474552;
 Libderiv->deriv_classes[8][6][1] = int_stack + 475497;
 Libderiv->deriv_classes[8][7][1] = int_stack + 476757;
 Libderiv->deriv_classes[8][8][1] = int_stack + 478377;
 Libderiv->deriv_classes[8][9][1] = int_stack + 480402;
 Libderiv->deriv_classes[8][10][1] = int_stack + 482877;
 Libderiv->deriv_classes[9][5][1] = int_stack + 485847;
 Libderiv->deriv_classes[9][6][1] = int_stack + 487002;
 Libderiv->deriv_classes[9][7][1] = int_stack + 488542;
 Libderiv->deriv_classes[9][8][1] = int_stack + 490522;
 Libderiv->deriv_classes[9][9][1] = int_stack + 492997;
 Libderiv->deriv_classes[9][10][1] = int_stack + 496022;
 Libderiv->deriv_classes[10][5][1] = int_stack + 499652;
 Libderiv->deriv_classes[10][6][1] = int_stack + 501038;
 Libderiv->deriv_classes[10][7][1] = int_stack + 502886;
 Libderiv->deriv_classes[10][8][1] = int_stack + 505262;
 Libderiv->deriv_classes[10][9][1] = int_stack + 508232;
 Libderiv->deriv_classes[10][10][1] = int_stack + 511862;
 Libderiv->dvrr_classes[5][5] = int_stack + 516218;
 Libderiv->dvrr_classes[5][6] = int_stack + 516659;
 Libderiv->dvrr_classes[5][7] = int_stack + 517247;
 Libderiv->dvrr_classes[5][8] = int_stack + 518003;
 Libderiv->dvrr_classes[5][9] = int_stack + 518948;
 Libderiv->dvrr_classes[5][10] = int_stack + 520103;
 Libderiv->deriv_classes[5][5][0] = int_stack + 521489;
 Libderiv->deriv_classes[5][6][0] = int_stack + 521930;
 Libderiv->deriv_classes[5][7][0] = int_stack + 522518;
 Libderiv->deriv_classes[5][8][0] = int_stack + 523274;
 Libderiv->deriv_classes[5][9][0] = int_stack + 524219;
 Libderiv->deriv_classes[5][10][0] = int_stack + 525374;
 Libderiv->dvrr_classes[6][5] = int_stack + 526760;
 Libderiv->dvrr_classes[6][6] = int_stack + 527348;
 Libderiv->dvrr_classes[6][7] = int_stack + 528132;
 Libderiv->dvrr_classes[6][8] = int_stack + 529140;
 Libderiv->dvrr_classes[6][9] = int_stack + 530400;
 Libderiv->dvrr_classes[6][10] = int_stack + 531940;
 Libderiv->deriv_classes[6][5][0] = int_stack + 533788;
 Libderiv->deriv_classes[6][6][0] = int_stack + 534376;
 Libderiv->deriv_classes[6][7][0] = int_stack + 535160;
 Libderiv->deriv_classes[6][8][0] = int_stack + 536168;
 Libderiv->deriv_classes[6][9][0] = int_stack + 537428;
 Libderiv->deriv_classes[6][10][0] = int_stack + 538968;
 Libderiv->dvrr_classes[7][5] = int_stack + 540816;
 Libderiv->dvrr_classes[7][6] = int_stack + 541572;
 Libderiv->dvrr_classes[7][7] = int_stack + 542580;
 Libderiv->dvrr_classes[7][8] = int_stack + 543876;
 Libderiv->dvrr_classes[7][9] = int_stack + 545496;
 Libderiv->dvrr_classes[7][10] = int_stack + 547476;
 Libderiv->deriv_classes[7][5][0] = int_stack + 549852;
 Libderiv->deriv_classes[7][6][0] = int_stack + 550608;
 Libderiv->deriv_classes[7][7][0] = int_stack + 551616;
 Libderiv->deriv_classes[7][8][0] = int_stack + 552912;
 Libderiv->deriv_classes[7][9][0] = int_stack + 554532;
 Libderiv->deriv_classes[7][10][0] = int_stack + 556512;
 Libderiv->dvrr_classes[8][5] = int_stack + 558888;
 Libderiv->dvrr_classes[8][6] = int_stack + 559833;
 Libderiv->dvrr_classes[8][7] = int_stack + 561093;
 Libderiv->dvrr_classes[8][8] = int_stack + 562713;
 Libderiv->dvrr_classes[8][9] = int_stack + 564738;
 Libderiv->dvrr_classes[8][10] = int_stack + 567213;
 Libderiv->deriv_classes[8][5][0] = int_stack + 570183;
 Libderiv->deriv_classes[8][6][0] = int_stack + 571128;
 Libderiv->deriv_classes[8][7][0] = int_stack + 572388;
 Libderiv->deriv_classes[8][8][0] = int_stack + 574008;
 Libderiv->deriv_classes[8][9][0] = int_stack + 576033;
 Libderiv->deriv_classes[8][10][0] = int_stack + 578508;
 Libderiv->dvrr_classes[9][5] = int_stack + 581478;
 Libderiv->dvrr_classes[9][6] = int_stack + 582633;
 Libderiv->dvrr_classes[9][7] = int_stack + 584173;
 Libderiv->dvrr_classes[9][8] = int_stack + 586153;
 Libderiv->dvrr_classes[9][9] = int_stack + 588628;
 Libderiv->dvrr_classes[9][10] = int_stack + 591653;
 Libderiv->deriv_classes[9][5][0] = int_stack + 595283;
 Libderiv->deriv_classes[9][6][0] = int_stack + 596438;
 Libderiv->deriv_classes[9][7][0] = int_stack + 597978;
 Libderiv->deriv_classes[9][8][0] = int_stack + 599958;
 Libderiv->deriv_classes[9][9][0] = int_stack + 602433;
 Libderiv->deriv_classes[9][10][0] = int_stack + 605458;
 Libderiv->deriv_classes[10][5][0] = int_stack + 609088;
 Libderiv->deriv_classes[10][6][0] = int_stack + 610474;
 Libderiv->deriv_classes[10][7][0] = int_stack + 612322;
 Libderiv->deriv_classes[10][8][0] = int_stack + 614698;
 Libderiv->deriv_classes[10][9][0] = int_stack + 617668;
 Libderiv->deriv_classes[10][10][0] = int_stack + 621298;
 memset(int_stack,0,5005232);

 Libderiv->dvrr_stack = int_stack + 4503386;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_hhhh(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+625654,int_stack+516659,int_stack+516218,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+626977,int_stack+517247,int_stack+516659,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+628741,int_stack+626977,int_stack+625654,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+631387,int_stack+518003,int_stack+517247,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+633655,int_stack+631387,int_stack+626977,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+637183,int_stack+633655,int_stack+628741,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+641593,int_stack+518948,int_stack+518003,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+644428,int_stack+641593,int_stack+631387,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+648964,int_stack+644428,int_stack+633655,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+654844,int_stack+648964,int_stack+637183,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+661459,int_stack+441,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+516218,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+662782,int_stack+1029,int_stack+441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+516659,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+664546,int_stack+662782,int_stack+661459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+625654,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+667192,int_stack+1785,int_stack+1029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+517247,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+669460,int_stack+667192,int_stack+662782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+626977,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+672988,int_stack+669460,int_stack+664546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+628741,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+661459,int_stack+2730,int_stack+1785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518003,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+677398,int_stack+661459,int_stack+667192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+631387,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+681934,int_stack+677398,int_stack+669460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633655,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+664294,int_stack+681934,int_stack+672988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+637183,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+670909,int_stack+3885,int_stack+2730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518948,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+687814,int_stack+670909,int_stack+661459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641593,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+693484,int_stack+687814,int_stack+677398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644428,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+670909,int_stack+693484,int_stack+681934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648964,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+679729,int_stack+670909,int_stack+664294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+654844,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+661459,int_stack+527348,int_stack+526760,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+663223,int_stack+528132,int_stack+527348,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+665575,int_stack+663223,int_stack+661459,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+669103,int_stack+529140,int_stack+528132,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+672127,int_stack+669103,int_stack+663223,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+688990,int_stack+672127,int_stack+665575,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+694870,int_stack+530400,int_stack+529140,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+698650,int_stack+694870,int_stack+669103,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+704698,int_stack+698650,int_stack+672127,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+712538,int_stack+704698,int_stack+688990,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+676831,int_stack+5859,int_stack+5271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+526760,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+6643,int_stack+5859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527348,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2352,int_stack+0,int_stack+676831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+661459,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+721358,int_stack+7651,int_stack+6643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+528132,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+724382,int_stack+721358,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+663223,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+729086,int_stack+724382,int_stack+2352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665575,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+8911,int_stack+7651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529140,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+734966,int_stack+0,int_stack+721358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669103,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+741014,int_stack+734966,int_stack+724382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+672127,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+748854,int_stack+741014,int_stack+729086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688990,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+721358,int_stack+10451,int_stack+8911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+530400,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+725978,int_stack+721358,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694870,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+0,int_stack+725978,int_stack+734966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+698650,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+721358,int_stack+0,int_stack+741014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+704698,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+733118,int_stack+721358,int_stack+748854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+712538,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+745466,int_stack+733118,int_stack+679729,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+721358,int_stack+541572,int_stack+540816,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+723626,int_stack+542580,int_stack+541572,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+726650,int_stack+723626,int_stack+721358,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+543876,int_stack+542580,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3888,int_stack+0,int_stack+723626,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+676831,int_stack+3888,int_stack+726650,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+773249,int_stack+545496,int_stack+543876,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+778109,int_stack+773249,int_stack+0,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+785885,int_stack+778109,int_stack+3888,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+795965,int_stack+785885,int_stack+676831,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9936,int_stack+13055,int_stack+12299, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540816,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+684391,int_stack+14063,int_stack+13055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541572,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+807305,int_stack+684391,int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+721358,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9936,int_stack+15359,int_stack+14063, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542580,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+811841,int_stack+9936,int_stack+684391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723626,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+817889,int_stack+811841,int_stack+807305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726650,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+825449,int_stack+16979,int_stack+15359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+543876,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+830309,int_stack+825449,int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+838085,int_stack+830309,int_stack+811841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3888,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+848165,int_stack+838085,int_stack+817889, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676831,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+9936,int_stack+18959,int_stack+16979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+545496,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+807305,int_stack+9936,int_stack+825449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773249,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+817025,int_stack+807305,int_stack+830309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778109,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+859505,int_stack+817025,int_stack+838085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+785885,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+807305,int_stack+859505,int_stack+848165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795965,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+823181,int_stack+807305,int_stack+733118,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+860225,int_stack+823181,int_stack+745466,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+9936,int_stack+559833,int_stack+558888,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+12771,int_stack+561093,int_stack+559833,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+731186,int_stack+12771,int_stack+9936,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+736856,int_stack+562713,int_stack+561093,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+741716,int_stack+736856,int_stack+12771,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+749276,int_stack+741716,int_stack+731186,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+758726,int_stack+564738,int_stack+562713,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+915791,int_stack+758726,int_stack+736856,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+925511,int_stack+915791,int_stack+741716,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+938111,int_stack+925511,int_stack+749276,45);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16551,int_stack+22280,int_stack+21335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558888,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+684391,int_stack+23540,int_stack+22280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559833,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+764801,int_stack+684391,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9936,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+16551,int_stack+25160,int_stack+23540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+561093,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+952286,int_stack+16551,int_stack+684391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12771,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+959846,int_stack+952286,int_stack+764801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+731186,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+764801,int_stack+27185,int_stack+25160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+562713,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+969296,int_stack+764801,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+736856,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+979016,int_stack+969296,int_stack+952286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+741716,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+991616,int_stack+979016,int_stack+959846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749276,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+952286,int_stack+29660,int_stack+27185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+564738,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+16551,int_stack+952286,int_stack+764801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+758726,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+952286,int_stack+16551,int_stack+969296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+915791,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1005791,int_stack+952286,int_stack+979016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+925511,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+952286,int_stack+1005791,int_stack+991616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+938111,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+972131,int_stack+952286,int_stack+807305,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1019759,int_stack+972131,int_stack+823181,441);
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1093847,int_stack+1019759,int_stack+860225,441);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+807305,int_stack+582633,int_stack+581478,55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+810770,int_stack+584173,int_stack+582633,55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+815390,int_stack+810770,int_stack+807305,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+822320,int_stack+586153,int_stack+584173,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+828260,int_stack+822320,int_stack+810770,55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+837500,int_stack+828260,int_stack+815390,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+849050,int_stack+588628,int_stack+586153,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+856475,int_stack+849050,int_stack+822320,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+868355,int_stack+856475,int_stack+828260,55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+883755,int_stack+868355,int_stack+837500,55);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+901080,int_stack+33785,int_stack+32630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+581478,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+904545,int_stack+35325,int_stack+33785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+582633,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+16551,int_stack+904545,int_stack+901080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+807305,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+909165,int_stack+37305,int_stack+35325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+584173,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+23481,int_stack+909165,int_stack+904545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810770,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1186457,int_stack+23481,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815390,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+901080,int_stack+39780,int_stack+37305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+586153,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1198007,int_stack+901080,int_stack+909165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+822320,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1209887,int_stack+1198007,int_stack+23481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828260,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+16551,int_stack+1209887,int_stack+1186457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+837500,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1186457,int_stack+42805,int_stack+39780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588628,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1225287,int_stack+1186457,int_stack+901080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+849050,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1240137,int_stack+1225287,int_stack+1198007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+856475,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1186457,int_stack+1240137,int_stack+1209887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+868355,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1209557,int_stack+1186457,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+883755,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1233812,int_stack+1209557,int_stack+952286,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+1293347,int_stack+1233812,int_stack+972131,441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+1388603,int_stack+1293347,int_stack+1019759,441);
 /*--- compute (hg|hh) ---*/
   hrr1_build_hg(Libderiv->AB,int_stack+952286,int_stack+1388603,int_stack+1093847,441);
 /*--- compute (n0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1091201,int_stack+364212,int_stack+361440,66);
 /*--- compute (n0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1095359,int_stack+367908,int_stack+364212,66);
 /*--- compute (n0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1100903,int_stack+1095359,int_stack+1091201,66);
 /*--- compute (n0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1109219,int_stack+372660,int_stack+367908,66);
 /*--- compute (n0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1116347,int_stack+1109219,int_stack+1095359,66);
 /*--- compute (n0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1127435,int_stack+1116347,int_stack+1100903,66);
 /*--- compute (n0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1141295,int_stack+378600,int_stack+372660,66);
 /*--- compute (n0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1150205,int_stack+1141295,int_stack+1109219,66);
 /*--- compute (n0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1164461,int_stack+1150205,int_stack+1116347,66);
 /*--- compute (n0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1182941,int_stack+1164461,int_stack+1127435,66);
 /*--- compute (n0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1203731,int_stack+47821,int_stack+46435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361440,66);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+16551,int_stack+49669,int_stack+47821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364212,66);
 /*--- compute (n0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22095,int_stack+16551,int_stack+1203731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1091201,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+30411,int_stack+52045,int_stack+49669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+367908,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+37539,int_stack+30411,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1095359,66);
 /*--- compute (n0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+901080,int_stack+37539,int_stack+22095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1100903,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+16551,int_stack+55015,int_stack+52045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372660,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1512083,int_stack+16551,int_stack+30411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1109219,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1526339,int_stack+1512083,int_stack+37539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1116347,66);
 /*--- compute (n0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+25461,int_stack+1526339,int_stack+901080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1127435,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+901080,int_stack+58645,int_stack+55015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378600,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1544819,int_stack+901080,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1141295,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1562639,int_stack+1544819,int_stack+1512083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1150205,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1586399,int_stack+1562639,int_stack+1526339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1164461,66);
 /*--- compute (n0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1512083,int_stack+1586399,int_stack+25461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1182941,66);
 /*--- compute (mp|hh) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+1541189,int_stack+1512083,int_stack+1209557,441);
 /*--- compute (ld|hh) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+1613954,int_stack+1541189,int_stack+1233812,441);
 /*--- compute (kf|hh) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+1733024,int_stack+1613954,int_stack+1293347,441);
 /*--- compute (ig|hh) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+1512083,int_stack+1733024,int_stack+1388603,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1697303,int_stack+63442,int_stack+63001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+516218, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1698626,int_stack+64030,int_stack+63442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+516659, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1700390,int_stack+1698626,int_stack+1697303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+625654, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1703036,int_stack+64786,int_stack+64030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+517247, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1705304,int_stack+1703036,int_stack+1698626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+626977, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1708832,int_stack+1705304,int_stack+1700390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+628741, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1697303,int_stack+65731,int_stack+64786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518003, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1713242,int_stack+1697303,int_stack+1703036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+631387, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1717778,int_stack+1713242,int_stack+1705304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633655, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1700138,int_stack+1717778,int_stack+1708832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+637183, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1706753,int_stack+66886,int_stack+65731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518948, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1723658,int_stack+1706753,int_stack+1697303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641593, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1729328,int_stack+1723658,int_stack+1713242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644428, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1706753,int_stack+1729328,int_stack+1717778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648964, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1715573,int_stack+1706753,int_stack+1700138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+654844, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1697303,int_stack+68860,int_stack+68272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+526760, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1699067,int_stack+69644,int_stack+68860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527348, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1701419,int_stack+1699067,int_stack+1697303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+661459, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704947,int_stack+70652,int_stack+69644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+528132, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1707971,int_stack+1704947,int_stack+1699067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+663223, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1724834,int_stack+1707971,int_stack+1701419, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665575, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1697303,int_stack+71912,int_stack+70652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529140, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1730714,int_stack+1697303,int_stack+1704947, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669103, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1736762,int_stack+1730714,int_stack+1707971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+672127, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1701083,int_stack+1736762,int_stack+1724834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688990, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1724834,int_stack+73452,int_stack+71912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+530400, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1744602,int_stack+1724834,int_stack+1697303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694870, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1752162,int_stack+1744602,int_stack+1730714, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+698650, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1724834,int_stack+1752162,int_stack+1736762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+704698, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1736594,int_stack+1724834,int_stack+1701083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+712538, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1748942,int_stack+1736594,int_stack+1715573,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1697303,int_stack+76056,int_stack+75300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540816, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1699571,int_stack+77064,int_stack+76056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541572, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1702595,int_stack+1699571,int_stack+1697303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+721358, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1707131,int_stack+78360,int_stack+77064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542580, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1711019,int_stack+1707131,int_stack+1699571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723626, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1717067,int_stack+1711019,int_stack+1702595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726650, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1697303,int_stack+79980,int_stack+78360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+543876, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1724627,int_stack+1697303,int_stack+1707131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1776725,int_stack+1724627,int_stack+1711019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3888, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1702163,int_stack+1776725,int_stack+1717067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676831, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1713503,int_stack+81960,int_stack+79980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+545496, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1786805,int_stack+1713503,int_stack+1697303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773249, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1796525,int_stack+1786805,int_stack+1724627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778109, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1713503,int_stack+1796525,int_stack+1776725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+785885, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1776725,int_stack+1713503,int_stack+1702163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795965, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+1792601,int_stack+1776725,int_stack+1736594,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+1829645,int_stack+1792601,int_stack+1748942,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1885211,int_stack+85281,int_stack+84336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558888, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1888046,int_stack+86541,int_stack+85281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559833, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1697303,int_stack+1888046,int_stack+1885211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9936, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1702973,int_stack+88161,int_stack+86541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+561093, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1707833,int_stack+1702973,int_stack+1888046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12771, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1715393,int_stack+1707833,int_stack+1697303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+731186, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1885211,int_stack+90186,int_stack+88161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+562713, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1724843,int_stack+1885211,int_stack+1702973, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+736856, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1734563,int_stack+1724843,int_stack+1707833, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+741716, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1697303,int_stack+1734563,int_stack+1715393, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749276, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1711478,int_stack+92661,int_stack+90186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+564738, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1747163,int_stack+1711478,int_stack+1885211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+758726, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1759313,int_stack+1747163,int_stack+1724843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+915791, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1711478,int_stack+1759313,int_stack+1734563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+925511, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1730378,int_stack+1711478,int_stack+1697303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+938111, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+16551,int_stack+1730378,int_stack+1776725,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1203731,int_stack+16551,int_stack+1792601,441);
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1277819,int_stack+1203731,int_stack+1829645,441);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1697303,int_stack+96786,int_stack+95631, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+581478, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1700768,int_stack+98326,int_stack+96786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+582633, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1705388,int_stack+1700768,int_stack+1697303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+807305, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1712318,int_stack+100306,int_stack+98326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+584173, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1718258,int_stack+1712318,int_stack+1700768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810770, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1750223,int_stack+1718258,int_stack+1705388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815390, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1697303,int_stack+102781,int_stack+100306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+586153, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1761773,int_stack+1697303,int_stack+1712318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+822320, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1773653,int_stack+1761773,int_stack+1718258, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828260, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1704728,int_stack+1773653,int_stack+1750223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+837500, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1750223,int_stack+105806,int_stack+102781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588628, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1789053,int_stack+1750223,int_stack+1697303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+849050, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1803903,int_stack+1789053,int_stack+1761773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+856475, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1750223,int_stack+1803903,int_stack+1773653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+868355, 0.0, zero_stack,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1773323,int_stack+1750223,int_stack+1704728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+883755, 0.0, zero_stack,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1797578,int_stack+1773323,int_stack+1730378,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+1370429,int_stack+1797578,int_stack+16551,441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+1857113,int_stack+1370429,int_stack+1203731,441);
 /*--- compute (hg|hh) ---*/
   hrr1_build_hg(Libderiv->AB,int_stack+1980593,int_stack+1857113,int_stack+1277819,441);
 /*--- compute (n0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1203731,int_stack+110822,int_stack+109436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361440, 0.0, zero_stack,66);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1207889,int_stack+112670,int_stack+110822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364212, 0.0, zero_stack,66);
 /*--- compute (n0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1213433,int_stack+1207889,int_stack+1203731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1091201, 0.0, zero_stack,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1221749,int_stack+115046,int_stack+112670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+367908, 0.0, zero_stack,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1228877,int_stack+1221749,int_stack+1207889, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1095359, 0.0, zero_stack,66);
 /*--- compute (n0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1239965,int_stack+1228877,int_stack+1213433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1100903, 0.0, zero_stack,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1203731,int_stack+118016,int_stack+115046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372660, 0.0, zero_stack,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1253825,int_stack+1203731,int_stack+1221749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1109219, 0.0, zero_stack,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1268081,int_stack+1253825,int_stack+1228877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1116347, 0.0, zero_stack,66);
 /*--- compute (n0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1212641,int_stack+1268081,int_stack+1239965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1127435, 0.0, zero_stack,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1233431,int_stack+121646,int_stack+118016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378600, 0.0, zero_stack,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1286561,int_stack+1233431,int_stack+1203731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1141295, 0.0, zero_stack,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1304381,int_stack+1286561,int_stack+1253825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1150205, 0.0, zero_stack,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1233431,int_stack+1304381,int_stack+1268081, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1164461, 0.0, zero_stack,66);
 /*--- compute (n0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1261151,int_stack+1233431,int_stack+1212641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1182941, 0.0, zero_stack,66);
 /*--- compute (mp|hh) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+1290257,int_stack+1261151,int_stack+1773323,441);
 /*--- compute (ld|hh) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+2119508,int_stack+1290257,int_stack+1797578,441);
 /*--- compute (kf|hh) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+1203731,int_stack+2119508,int_stack+1370429,441);
 /*--- compute (ig|hh) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+2119508,int_stack+1203731,int_stack+1857113,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1203731,int_stack+126443,int_stack+126002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+516218, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1205054,int_stack+127031,int_stack+126443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+516659, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1206818,int_stack+1205054,int_stack+1203731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+625654, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1209464,int_stack+127787,int_stack+127031, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+517247, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1211732,int_stack+1209464,int_stack+1205054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+626977, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1215260,int_stack+1211732,int_stack+1206818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+628741, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1203731,int_stack+128732,int_stack+127787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518003, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1219670,int_stack+1203731,int_stack+1209464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+631387, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1224206,int_stack+1219670,int_stack+1211732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633655, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1206566,int_stack+1224206,int_stack+1215260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+637183, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1213181,int_stack+129887,int_stack+128732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518948, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1230086,int_stack+1213181,int_stack+1203731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641593, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1235756,int_stack+1230086,int_stack+1219670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644428, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1213181,int_stack+1235756,int_stack+1224206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648964, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1222001,int_stack+1213181,int_stack+1206566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+654844, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1203731,int_stack+131861,int_stack+131273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+526760, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1205495,int_stack+132645,int_stack+131861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527348, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1207847,int_stack+1205495,int_stack+1203731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+661459, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1211375,int_stack+133653,int_stack+132645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+528132, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1214399,int_stack+1211375,int_stack+1205495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+663223, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1231262,int_stack+1214399,int_stack+1207847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665575, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1203731,int_stack+134913,int_stack+133653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529140, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1237142,int_stack+1203731,int_stack+1211375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669103, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1243190,int_stack+1237142,int_stack+1214399, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+672127, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1207511,int_stack+1243190,int_stack+1231262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688990, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1231262,int_stack+136453,int_stack+134913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+530400, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1251030,int_stack+1231262,int_stack+1203731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694870, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1258590,int_stack+1251030,int_stack+1237142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+698650, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1231262,int_stack+1258590,int_stack+1243190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+704698, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1243022,int_stack+1231262,int_stack+1207511, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+712538, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1255370,int_stack+1243022,int_stack+1222001,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1203731,int_stack+139057,int_stack+138301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540816, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1205999,int_stack+140065,int_stack+139057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541572, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1209023,int_stack+1205999,int_stack+1203731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+721358, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1213559,int_stack+141361,int_stack+140065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542580, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1217447,int_stack+1213559,int_stack+1205999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723626, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1223495,int_stack+1217447,int_stack+1209023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726650, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1203731,int_stack+142981,int_stack+141361, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+543876, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1231055,int_stack+1203731,int_stack+1213559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1283153,int_stack+1231055,int_stack+1217447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3888, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1208591,int_stack+1283153,int_stack+1223495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676831, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1219931,int_stack+144961,int_stack+142981, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+545496, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1293233,int_stack+1219931,int_stack+1203731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773249, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1302953,int_stack+1293233,int_stack+1231055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778109, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1219931,int_stack+1302953,int_stack+1283153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+785885, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1283153,int_stack+1219931,int_stack+1208591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795965, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+1299029,int_stack+1283153,int_stack+1243022,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+1336073,int_stack+1299029,int_stack+1255370,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1391639,int_stack+148282,int_stack+147337, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558888, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1394474,int_stack+149542,int_stack+148282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559833, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1398254,int_stack+1394474,int_stack+1391639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9936, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1403924,int_stack+151162,int_stack+149542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+561093, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1408784,int_stack+1403924,int_stack+1394474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12771, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1416344,int_stack+1408784,int_stack+1398254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+731186, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1391639,int_stack+153187,int_stack+151162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+562713, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1425794,int_stack+1391639,int_stack+1403924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+736856, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1435514,int_stack+1425794,int_stack+1408784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+741716, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1397714,int_stack+1435514,int_stack+1416344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749276, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1411889,int_stack+155662,int_stack+153187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+564738, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1448114,int_stack+1411889,int_stack+1391639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+758726, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1460264,int_stack+1448114,int_stack+1425794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+915791, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1411889,int_stack+1460264,int_stack+1435514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+925511, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1430789,int_stack+1411889,int_stack+1397714, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+938111, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1450634,int_stack+1430789,int_stack+1283153,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1203731,int_stack+1450634,int_stack+1299029,441);
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+16551,int_stack+1203731,int_stack+1336073,441);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1498262,int_stack+159787,int_stack+158632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+581478, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1501727,int_stack+161327,int_stack+159787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+582633, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1277819,int_stack+1501727,int_stack+1498262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+807305, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1284749,int_stack+163307,int_stack+161327, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+584173, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1290689,int_stack+1284749,int_stack+1501727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810770, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1498262,int_stack+1290689,int_stack+1277819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815390, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1299929,int_stack+165782,int_stack+163307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+586153, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1307354,int_stack+1299929,int_stack+1284749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+822320, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1319234,int_stack+1307354,int_stack+1290689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828260, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1277819,int_stack+1319234,int_stack+1498262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+837500, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1498262,int_stack+168807,int_stack+165782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588628, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1334634,int_stack+1498262,int_stack+1299929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+849050, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1349484,int_stack+1334634,int_stack+1307354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+856475, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1295144,int_stack+1349484,int_stack+1319234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+868355, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1318244,int_stack+1295144,int_stack+1277819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+883755, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1342499,int_stack+1318244,int_stack+1430789,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+1697303,int_stack+1342499,int_stack+1450634,441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+1792559,int_stack+1697303,int_stack+1203731,441);
 /*--- compute (hg|hh) ---*/
   hrr1_build_hg(Libderiv->AB,int_stack+2304728,int_stack+1792559,int_stack+16551,441);
 /*--- compute (n0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16551,int_stack+173823,int_stack+172437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361440, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+20709,int_stack+175671,int_stack+173823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364212, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+26253,int_stack+20709,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1091201, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+34569,int_stack+178047,int_stack+175671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+367908, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+41697,int_stack+34569,int_stack+20709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1095359, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+52785,int_stack+41697,int_stack+26253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1100903, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+16551,int_stack+181017,int_stack+178047, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372660, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+66645,int_stack+16551,int_stack+34569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1109219, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+80901,int_stack+66645,int_stack+41697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1116347, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+25461,int_stack+80901,int_stack+52785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1127435, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+46251,int_stack+184647,int_stack+181017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378600, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+99381,int_stack+46251,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1141295, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+117201,int_stack+99381,int_stack+66645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1150205, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+46251,int_stack+117201,int_stack+80901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1164461, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+73971,int_stack+46251,int_stack+25461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1182941, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (mp|hh) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+103077,int_stack+73971,int_stack+1318244,441);
 /*--- compute (ld|hh) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+1203731,int_stack+103077,int_stack+1342499,441);
 /*--- compute (kf|hh) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+16551,int_stack+1203731,int_stack+1697303,441);
 /*--- compute (ig|hh) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+1203731,int_stack+16551,int_stack+1792559,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16551,int_stack+189444,int_stack+189003, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+516218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17874,int_stack+190032,int_stack+189444, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+516659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+19638,int_stack+17874,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+625654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+22284,int_stack+190788,int_stack+190032, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+517247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+24552,int_stack+22284,int_stack+17874, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+626977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+28080,int_stack+24552,int_stack+19638, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+628741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+16551,int_stack+191733,int_stack+190788, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+32490,int_stack+16551,int_stack+22284, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+631387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+37026,int_stack+32490,int_stack+24552, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+19386,int_stack+37026,int_stack+28080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+637183, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+26001,int_stack+192888,int_stack+191733, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+42906,int_stack+26001,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+48576,int_stack+42906,int_stack+32490, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+26001,int_stack+48576,int_stack+37026, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+34821,int_stack+26001,int_stack+19386, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+654844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16551,int_stack+194862,int_stack+194274, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+526760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+18315,int_stack+195646,int_stack+194862, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+20667,int_stack+18315,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+661459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24195,int_stack+196654,int_stack+195646, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+528132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+27219,int_stack+24195,int_stack+18315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+663223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+44082,int_stack+27219,int_stack+20667, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+16551,int_stack+197914,int_stack+196654, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+49962,int_stack+16551,int_stack+24195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+56010,int_stack+49962,int_stack+27219, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+672127, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+20331,int_stack+56010,int_stack+44082, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+44082,int_stack+199454,int_stack+197914, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+530400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+63850,int_stack+44082,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+71410,int_stack+63850,int_stack+49962, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+698650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+44082,int_stack+71410,int_stack+56010, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+704698, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+55842,int_stack+44082,int_stack+20331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+712538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+68190,int_stack+55842,int_stack+34821,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16551,int_stack+202058,int_stack+201302, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+18819,int_stack+203066,int_stack+202058, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21843,int_stack+18819,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+721358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+26379,int_stack+204362,int_stack+203066, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+30267,int_stack+26379,int_stack+18819, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+36315,int_stack+30267,int_stack+21843, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+16551,int_stack+205982,int_stack+204362, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+543876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+43875,int_stack+16551,int_stack+26379, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+95973,int_stack+43875,int_stack+30267, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21411,int_stack+95973,int_stack+36315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+32751,int_stack+207962,int_stack+205982, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+545496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+106053,int_stack+32751,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+115773,int_stack+106053,int_stack+43875, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+32751,int_stack+115773,int_stack+95973, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+785885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+95973,int_stack+32751,int_stack+21411, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+111849,int_stack+95973,int_stack+55842,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+148893,int_stack+111849,int_stack+68190,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+204459,int_stack+211283,int_stack+210338, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+207294,int_stack+212543,int_stack+211283, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559833, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+16551,int_stack+207294,int_stack+204459, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+22221,int_stack+214163,int_stack+212543, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+561093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+27081,int_stack+22221,int_stack+207294, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+204459,int_stack+27081,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+731186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+34641,int_stack+216188,int_stack+214163, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+562713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+40716,int_stack+34641,int_stack+22221, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+736856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+50436,int_stack+40716,int_stack+27081, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+741716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+16551,int_stack+50436,int_stack+204459, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+204459,int_stack+218663,int_stack+216188, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+564738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+63036,int_stack+204459,int_stack+34641, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+758726, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+204459,int_stack+63036,int_stack+40716, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+915791, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+63036,int_stack+204459,int_stack+50436, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+925511, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+30726,int_stack+63036,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+938111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1697303,int_stack+30726,int_stack+95973,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1744931,int_stack+1697303,int_stack+111849,441);
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+50571,int_stack+1744931,int_stack+148893,441);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16551,int_stack+222788,int_stack+221633, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+581478, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+20016,int_stack+224328,int_stack+222788, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+582633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+143181,int_stack+20016,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+807305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24636,int_stack+226308,int_stack+224328, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+584173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+150111,int_stack+24636,int_stack+20016, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+159351,int_stack+150111,int_stack+143181, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+16551,int_stack+228783,int_stack+226308, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+586153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+170901,int_stack+16551,int_stack+24636, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+822320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+182781,int_stack+170901,int_stack+150111, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+198181,int_stack+182781,int_stack+159351, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+837500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+143181,int_stack+231808,int_stack+228783, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+152256,int_stack+143181,int_stack+16551, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+849050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+215506,int_stack+152256,int_stack+170901, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+856475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+143181,int_stack+215506,int_stack+182781, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+868355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+166281,int_stack+143181,int_stack+198181, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+883755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1819019,int_stack+166281,int_stack+30726,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+1878554,int_stack+1819019,int_stack+1697303,441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+2443643,int_stack+1878554,int_stack+1744931,441);
 /*--- compute (hg|hh) ---*/
   hrr1_build_hg(Libderiv->AB,int_stack+2567123,int_stack+2443643,int_stack+50571,441);
 /*--- compute (n0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1697303,int_stack+236824,int_stack+235438, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1701461,int_stack+238672,int_stack+236824, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1707005,int_stack+1701461,int_stack+1697303, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1091201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1715321,int_stack+241048,int_stack+238672, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+367908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1722449,int_stack+1715321,int_stack+1701461, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1095359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1733537,int_stack+1722449,int_stack+1707005, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1100903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1697303,int_stack+244018,int_stack+241048, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1747397,int_stack+1697303,int_stack+1715321, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1109219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1761653,int_stack+1747397,int_stack+1722449, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1116347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1706213,int_stack+1761653,int_stack+1733537, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1127435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1727003,int_stack+247648,int_stack+244018, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1780133,int_stack+1727003,int_stack+1697303, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1141295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+16551,int_stack+1780133,int_stack+1747397, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1150205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1780133,int_stack+16551,int_stack+1761653, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1164461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16551,int_stack+1780133,int_stack+1706213, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1182941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (mp|hh) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+45657,int_stack+16551,int_stack+166281,441);
 /*--- compute (ld|hh) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+118422,int_stack+45657,int_stack+1819019,441);
 /*--- compute (kf|hh) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+1697303,int_stack+118422,int_stack+1878554,441);
 /*--- compute (ig|hh) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+16551,int_stack+1697303,int_stack+2443643,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2443643,int_stack+252445,int_stack+252004, 0.0, zero_stack, 1.0, int_stack+516218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2444966,int_stack+253033,int_stack+252445, 0.0, zero_stack, 1.0, int_stack+516659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2446730,int_stack+2444966,int_stack+2443643, 0.0, zero_stack, 1.0, int_stack+625654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2449376,int_stack+253789,int_stack+253033, 0.0, zero_stack, 1.0, int_stack+517247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2451644,int_stack+2449376,int_stack+2444966, 0.0, zero_stack, 1.0, int_stack+626977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2455172,int_stack+2451644,int_stack+2446730, 0.0, zero_stack, 1.0, int_stack+628741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2443643,int_stack+254734,int_stack+253789, 0.0, zero_stack, 1.0, int_stack+518003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2459582,int_stack+2443643,int_stack+2449376, 0.0, zero_stack, 1.0, int_stack+631387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2464118,int_stack+2459582,int_stack+2451644, 0.0, zero_stack, 1.0, int_stack+633655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2446478,int_stack+2464118,int_stack+2455172, 0.0, zero_stack, 1.0, int_stack+637183, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2453093,int_stack+255889,int_stack+254734, 0.0, zero_stack, 1.0, int_stack+518948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2469998,int_stack+2453093,int_stack+2443643, 0.0, zero_stack, 1.0, int_stack+641593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2475668,int_stack+2469998,int_stack+2459582, 0.0, zero_stack, 1.0, int_stack+644428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2453093,int_stack+2475668,int_stack+2464118, 0.0, zero_stack, 1.0, int_stack+648964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2461913,int_stack+2453093,int_stack+2446478, 0.0, zero_stack, 1.0, int_stack+654844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2443643,int_stack+257863,int_stack+257275, 0.0, zero_stack, 1.0, int_stack+526760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2445407,int_stack+258647,int_stack+257863, 0.0, zero_stack, 1.0, int_stack+527348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2447759,int_stack+2445407,int_stack+2443643, 0.0, zero_stack, 1.0, int_stack+661459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2451287,int_stack+259655,int_stack+258647, 0.0, zero_stack, 1.0, int_stack+528132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2454311,int_stack+2451287,int_stack+2445407, 0.0, zero_stack, 1.0, int_stack+663223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2471174,int_stack+2454311,int_stack+2447759, 0.0, zero_stack, 1.0, int_stack+665575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2443643,int_stack+260915,int_stack+259655, 0.0, zero_stack, 1.0, int_stack+529140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2477054,int_stack+2443643,int_stack+2451287, 0.0, zero_stack, 1.0, int_stack+669103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2483102,int_stack+2477054,int_stack+2454311, 0.0, zero_stack, 1.0, int_stack+672127, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2447423,int_stack+2483102,int_stack+2471174, 0.0, zero_stack, 1.0, int_stack+688990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2471174,int_stack+262455,int_stack+260915, 0.0, zero_stack, 1.0, int_stack+530400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2490942,int_stack+2471174,int_stack+2443643, 0.0, zero_stack, 1.0, int_stack+694870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2498502,int_stack+2490942,int_stack+2477054, 0.0, zero_stack, 1.0, int_stack+698650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2471174,int_stack+2498502,int_stack+2483102, 0.0, zero_stack, 1.0, int_stack+704698, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2482934,int_stack+2471174,int_stack+2447423, 0.0, zero_stack, 1.0, int_stack+712538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2495282,int_stack+2482934,int_stack+2461913,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2443643,int_stack+265059,int_stack+264303, 0.0, zero_stack, 1.0, int_stack+540816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2445911,int_stack+266067,int_stack+265059, 0.0, zero_stack, 1.0, int_stack+541572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2448935,int_stack+2445911,int_stack+2443643, 0.0, zero_stack, 1.0, int_stack+721358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2453471,int_stack+267363,int_stack+266067, 0.0, zero_stack, 1.0, int_stack+542580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2457359,int_stack+2453471,int_stack+2445911, 0.0, zero_stack, 1.0, int_stack+723626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2463407,int_stack+2457359,int_stack+2448935, 0.0, zero_stack, 1.0, int_stack+726650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2443643,int_stack+268983,int_stack+267363, 0.0, zero_stack, 1.0, int_stack+543876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2470967,int_stack+2443643,int_stack+2453471, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2523065,int_stack+2470967,int_stack+2457359, 0.0, zero_stack, 1.0, int_stack+3888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2448503,int_stack+2523065,int_stack+2463407, 0.0, zero_stack, 1.0, int_stack+676831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2459843,int_stack+270963,int_stack+268983, 0.0, zero_stack, 1.0, int_stack+545496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2533145,int_stack+2459843,int_stack+2443643, 0.0, zero_stack, 1.0, int_stack+773249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2542865,int_stack+2533145,int_stack+2470967, 0.0, zero_stack, 1.0, int_stack+778109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2459843,int_stack+2542865,int_stack+2523065, 0.0, zero_stack, 1.0, int_stack+785885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2523065,int_stack+2459843,int_stack+2448503, 0.0, zero_stack, 1.0, int_stack+795965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2443643,int_stack+2523065,int_stack+2482934,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+1697303,int_stack+2443643,int_stack+2495282,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2538941,int_stack+274284,int_stack+273339, 0.0, zero_stack, 1.0, int_stack+558888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2541776,int_stack+275544,int_stack+274284, 0.0, zero_stack, 1.0, int_stack+559833, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2545556,int_stack+2541776,int_stack+2538941, 0.0, zero_stack, 1.0, int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2551226,int_stack+277164,int_stack+275544, 0.0, zero_stack, 1.0, int_stack+561093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2556086,int_stack+2551226,int_stack+2541776, 0.0, zero_stack, 1.0, int_stack+12771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2480687,int_stack+2556086,int_stack+2545556, 0.0, zero_stack, 1.0, int_stack+731186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2538941,int_stack+279189,int_stack+277164, 0.0, zero_stack, 1.0, int_stack+562713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2490137,int_stack+2538941,int_stack+2551226, 0.0, zero_stack, 1.0, int_stack+736856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2499857,int_stack+2490137,int_stack+2556086, 0.0, zero_stack, 1.0, int_stack+741716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2545016,int_stack+2499857,int_stack+2480687, 0.0, zero_stack, 1.0, int_stack+749276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2480687,int_stack+281664,int_stack+279189, 0.0, zero_stack, 1.0, int_stack+564738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1752869,int_stack+2480687,int_stack+2538941, 0.0, zero_stack, 1.0, int_stack+758726, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1765019,int_stack+1752869,int_stack+2490137, 0.0, zero_stack, 1.0, int_stack+915791, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2480687,int_stack+1765019,int_stack+2499857, 0.0, zero_stack, 1.0, int_stack+925511, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1752869,int_stack+2480687,int_stack+2545016, 0.0, zero_stack, 1.0, int_stack+938111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1772714,int_stack+1752869,int_stack+2523065,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+2480687,int_stack+1772714,int_stack+2443643,441);
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1820342,int_stack+2480687,int_stack+1697303,441);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1697303,int_stack+285789,int_stack+284634, 0.0, zero_stack, 1.0, int_stack+581478, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1700768,int_stack+287329,int_stack+285789, 0.0, zero_stack, 1.0, int_stack+582633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1705388,int_stack+1700768,int_stack+1697303, 0.0, zero_stack, 1.0, int_stack+807305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1712318,int_stack+289309,int_stack+287329, 0.0, zero_stack, 1.0, int_stack+584173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1718258,int_stack+1712318,int_stack+1700768, 0.0, zero_stack, 1.0, int_stack+810770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1727498,int_stack+1718258,int_stack+1705388, 0.0, zero_stack, 1.0, int_stack+815390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1697303,int_stack+291784,int_stack+289309, 0.0, zero_stack, 1.0, int_stack+586153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1739048,int_stack+1697303,int_stack+1712318, 0.0, zero_stack, 1.0, int_stack+822320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2443643,int_stack+1739048,int_stack+1718258, 0.0, zero_stack, 1.0, int_stack+828260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1704728,int_stack+2443643,int_stack+1727498, 0.0, zero_stack, 1.0, int_stack+837500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1722053,int_stack+294809,int_stack+291784, 0.0, zero_stack, 1.0, int_stack+588628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2459043,int_stack+1722053,int_stack+1697303, 0.0, zero_stack, 1.0, int_stack+849050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1912952,int_stack+2459043,int_stack+1739048, 0.0, zero_stack, 1.0, int_stack+856475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1722053,int_stack+1912952,int_stack+2443643, 0.0, zero_stack, 1.0, int_stack+868355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2443643,int_stack+1722053,int_stack+1704728, 0.0, zero_stack, 1.0, int_stack+883755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1912952,int_stack+2443643,int_stack+1752869,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+201771,int_stack+1912952,int_stack+1772714,441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+2706038,int_stack+201771,int_stack+2480687,441);
 /*--- compute (hg|hh) ---*/
   hrr1_build_hg(Libderiv->AB,int_stack+2829518,int_stack+2706038,int_stack+1820342,441);
 /*--- compute (n0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2467898,int_stack+299825,int_stack+298439, 0.0, zero_stack, 1.0, int_stack+361440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2472056,int_stack+301673,int_stack+299825, 0.0, zero_stack, 1.0, int_stack+364212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2477600,int_stack+2472056,int_stack+2467898, 0.0, zero_stack, 1.0, int_stack+1091201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2485916,int_stack+304049,int_stack+301673, 0.0, zero_stack, 1.0, int_stack+367908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2493044,int_stack+2485916,int_stack+2472056, 0.0, zero_stack, 1.0, int_stack+1095359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2504132,int_stack+2493044,int_stack+2477600, 0.0, zero_stack, 1.0, int_stack+1100903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2467898,int_stack+307019,int_stack+304049, 0.0, zero_stack, 1.0, int_stack+372660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2517992,int_stack+2467898,int_stack+2485916, 0.0, zero_stack, 1.0, int_stack+1109219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2532248,int_stack+2517992,int_stack+2493044, 0.0, zero_stack, 1.0, int_stack+1116347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2476808,int_stack+2532248,int_stack+2504132, 0.0, zero_stack, 1.0, int_stack+1127435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2497598,int_stack+310649,int_stack+307019, 0.0, zero_stack, 1.0, int_stack+378600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1697303,int_stack+2497598,int_stack+2467898, 0.0, zero_stack, 1.0, int_stack+1141295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1715123,int_stack+1697303,int_stack+2517992, 0.0, zero_stack, 1.0, int_stack+1150205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2497598,int_stack+1715123,int_stack+2532248, 0.0, zero_stack, 1.0, int_stack+1164461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1697303,int_stack+2497598,int_stack+2476808, 0.0, zero_stack, 1.0, int_stack+1182941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (mp|hh) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+1726409,int_stack+1697303,int_stack+2443643,441);
 /*--- compute (ld|hh) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+2443643,int_stack+1726409,int_stack+1912952,441);
 /*--- compute (kf|hh) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+1697303,int_stack+2443643,int_stack+201771,441);
 /*--- compute (ig|hh) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+2968433,int_stack+1697303,int_stack+2706038,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2706038,int_stack+315446,int_stack+315005, 1.0, int_stack+516218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2707361,int_stack+316034,int_stack+315446, 1.0, int_stack+516659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2709125,int_stack+2707361,int_stack+2706038, 1.0, int_stack+625654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2711771,int_stack+316790,int_stack+316034, 1.0, int_stack+517247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2714039,int_stack+2711771,int_stack+2707361, 1.0, int_stack+626977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2717567,int_stack+2714039,int_stack+2709125, 1.0, int_stack+628741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+625654,int_stack+317735,int_stack+316790, 1.0, int_stack+518003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2706038,int_stack+625654,int_stack+2711771, 1.0, int_stack+631387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2721977,int_stack+2706038,int_stack+2714039, 1.0, int_stack+633655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+628489,int_stack+2721977,int_stack+2717567, 1.0, int_stack+637183, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+635104,int_stack+318890,int_stack+317735, 1.0, int_stack+518948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2710574,int_stack+635104,int_stack+625654, 1.0, int_stack+641593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2727857,int_stack+2710574,int_stack+2706038, 1.0, int_stack+644428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2706038,int_stack+2727857,int_stack+2721977, 1.0, int_stack+648964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2714858,int_stack+2706038,int_stack+628489, 1.0, int_stack+654844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2706038,int_stack+320864,int_stack+320276, 1.0, int_stack+526760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2707802,int_stack+321648,int_stack+320864, 1.0, int_stack+527348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2710154,int_stack+2707802,int_stack+2706038, 1.0, int_stack+661459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2724119,int_stack+322656,int_stack+321648, 1.0, int_stack+528132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2727143,int_stack+2724119,int_stack+2707802, 1.0, int_stack+663223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2731847,int_stack+2727143,int_stack+2710154, 1.0, int_stack+665575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+661459,int_stack+323916,int_stack+322656, 1.0, int_stack+529140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2706038,int_stack+661459,int_stack+2724119, 1.0, int_stack+669103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2737727,int_stack+2706038,int_stack+2727143, 1.0, int_stack+672127, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+665239,int_stack+2737727,int_stack+2731847, 1.0, int_stack+688990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2724119,int_stack+325456,int_stack+323916, 1.0, int_stack+530400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2728739,int_stack+2724119,int_stack+661459, 1.0, int_stack+694870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2745567,int_stack+2728739,int_stack+2706038, 1.0, int_stack+698650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2724119,int_stack+2745567,int_stack+2737727, 1.0, int_stack+704698, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2735879,int_stack+2724119,int_stack+665239, 1.0, int_stack+712538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2748227,int_stack+2735879,int_stack+2714858,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2706038,int_stack+328060,int_stack+327304, 1.0, int_stack+540816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2708306,int_stack+329068,int_stack+328060, 1.0, int_stack+541572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2711330,int_stack+2708306,int_stack+2706038, 1.0, int_stack+721358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2715866,int_stack+330364,int_stack+329068, 1.0, int_stack+542580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2719754,int_stack+2715866,int_stack+2708306, 1.0, int_stack+723626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2725802,int_stack+2719754,int_stack+2711330, 1.0, int_stack+726650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+721358,int_stack+331984,int_stack+330364, 1.0, int_stack+543876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2706038,int_stack+721358,int_stack+2715866, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+661459,int_stack+2706038,int_stack+2719754, 1.0, int_stack+3888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2713814,int_stack+661459,int_stack+2725802, 1.0, int_stack+676831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+333964,int_stack+331984, 1.0, int_stack+545496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2725154,int_stack+0,int_stack+721358, 1.0, int_stack+773249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+671539,int_stack+2725154,int_stack+2706038, 1.0, int_stack+778109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2776010,int_stack+671539,int_stack+661459, 1.0, int_stack+785885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+661459,int_stack+2776010,int_stack+2713814, 1.0, int_stack+795965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2776010,int_stack+661459,int_stack+2735879,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+1697303,int_stack+2776010,int_stack+2748227,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2813054,int_stack+337285,int_stack+336340, 1.0, int_stack+558888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2815889,int_stack+338545,int_stack+337285, 1.0, int_stack+559833, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2819669,int_stack+2815889,int_stack+2813054, 1.0, int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+677335,int_stack+340165,int_stack+338545, 1.0, int_stack+561093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+682195,int_stack+677335,int_stack+2815889, 1.0, int_stack+12771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2706038,int_stack+682195,int_stack+2819669, 1.0, int_stack+731186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2813054,int_stack+342190,int_stack+340165, 1.0, int_stack+562713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2819129,int_stack+2813054,int_stack+677335, 1.0, int_stack+736856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2715488,int_stack+2819129,int_stack+682195, 1.0, int_stack+741716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+677335,int_stack+2715488,int_stack+2706038, 1.0, int_stack+749276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2706038,int_stack+344665,int_stack+342190, 1.0, int_stack+564738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2728088,int_stack+2706038,int_stack+2813054, 1.0, int_stack+758726, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2740238,int_stack+2728088,int_stack+2819129, 1.0, int_stack+915791, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2756438,int_stack+2740238,int_stack+2715488, 1.0, int_stack+925511, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2706038,int_stack+2756438,int_stack+677335, 1.0, int_stack+938111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+2725883,int_stack+2706038,int_stack+661459,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1752869,int_stack+2725883,int_stack+2776010,441);
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1826957,int_stack+1752869,int_stack+1697303,441);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1697303,int_stack+348790,int_stack+347635, 1.0, int_stack+581478, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1700768,int_stack+350330,int_stack+348790, 1.0, int_stack+582633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1705388,int_stack+1700768,int_stack+1697303, 1.0, int_stack+807305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1712318,int_stack+352310,int_stack+350330, 1.0, int_stack+584173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1718258,int_stack+1712318,int_stack+1700768, 1.0, int_stack+810770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1727498,int_stack+1718258,int_stack+1705388, 1.0, int_stack+815390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+807305,int_stack+354785,int_stack+352310, 1.0, int_stack+586153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1697303,int_stack+807305,int_stack+1712318, 1.0, int_stack+822320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+661459,int_stack+1697303,int_stack+1718258, 1.0, int_stack+828260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+814730,int_stack+661459,int_stack+1727498, 1.0, int_stack+837500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+832055,int_stack+357810,int_stack+354785, 1.0, int_stack+588628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1709183,int_stack+832055,int_stack+807305, 1.0, int_stack+849050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1724033,int_stack+1709183,int_stack+1697303, 1.0, int_stack+856475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1697303,int_stack+1724033,int_stack+661459, 1.0, int_stack+868355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+661459,int_stack+1697303,int_stack+814730, 1.0, int_stack+883755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1919567,int_stack+661459,int_stack+2706038,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+201771,int_stack+1919567,int_stack+2725883,441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+2706038,int_stack+201771,int_stack+1752869,441);
 /*--- compute (hg|hh) ---*/
   hrr1_build_hg(Libderiv->AB,int_stack+3153653,int_stack+2706038,int_stack+1826957,441);
 /*--- compute (n0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1697303,int_stack+366060,int_stack+362826, 1.0, int_stack+361440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1701461,int_stack+370284,int_stack+366060, 1.0, int_stack+364212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1707005,int_stack+1701461,int_stack+1697303, 1.0, int_stack+1091201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1715321,int_stack+375630,int_stack+370284, 1.0, int_stack+367908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1722449,int_stack+1715321,int_stack+1701461, 1.0, int_stack+1095359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1733537,int_stack+1722449,int_stack+1707005, 1.0, int_stack+1100903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1091201,int_stack+382230,int_stack+375630, 1.0, int_stack+372660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1697303,int_stack+1091201,int_stack+1715321, 1.0, int_stack+1109219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1747397,int_stack+1697303,int_stack+1722449, 1.0, int_stack+1116347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1100111,int_stack+1747397,int_stack+1733537, 1.0, int_stack+1127435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1120901,int_stack+385860,int_stack+382230, 1.0, int_stack+378600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1711559,int_stack+1120901,int_stack+1091201, 1.0, int_stack+1141295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1120901,int_stack+1711559,int_stack+1697303, 1.0, int_stack+1150205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1697303,int_stack+1120901,int_stack+1747397, 1.0, int_stack+1164461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1120901,int_stack+1697303,int_stack+1100111, 1.0, int_stack+1182941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (mp|hh) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+1697303,int_stack+1120901,int_stack+661459,441);
 /*--- compute (ld|hh) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+1770068,int_stack+1697303,int_stack+1919567,441);
 /*--- compute (kf|hh) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+3292568,int_stack+1770068,int_stack+201771,441);
 /*--- compute (ig|hh) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+201771,int_stack+3292568,int_stack+2706038,441);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2706038,int_stack+520103,int_stack+518948,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2709503,int_stack+2706038,int_stack+641593,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2715173,int_stack+2709503,int_stack+644428,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2706038,int_stack+2715173,int_stack+648964,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2714858,int_stack+2706038,int_stack+654844,21);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2706038,int_stack+531940,int_stack+530400,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2724119,int_stack+2706038,int_stack+694870,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2731679,int_stack+2724119,int_stack+698650,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2741759,int_stack+2731679,int_stack+704698,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2724119,int_stack+2741759,int_stack+712538,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2736467,int_stack+2724119,int_stack+2714858,441);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2764250,int_stack+547476,int_stack+545496,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2770190,int_stack+2764250,int_stack+773249,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2779910,int_stack+2770190,int_stack+778109,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2764250,int_stack+2779910,int_stack+785885,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2779370,int_stack+2764250,int_stack+795965,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+3292568,int_stack+2779370,int_stack+2724119,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+3329612,int_stack+3292568,int_stack+2736467,441);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2764250,int_stack+567213,int_stack+564738,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2795246,int_stack+2764250,int_stack+758726,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2807396,int_stack+2795246,int_stack+915791,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+3385178,int_stack+2807396,int_stack+925511,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2795246,int_stack+3385178,int_stack+938111,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+3385178,int_stack+2795246,int_stack+2779370,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1697303,int_stack+3385178,int_stack+3292568,441);
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1771391,int_stack+1697303,int_stack+3329612,441);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+3432806,int_stack+591653,int_stack+588628,55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2764250,int_stack+3432806,int_stack+849050,55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1864001,int_stack+2764250,int_stack+856475,55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1883801,int_stack+1864001,int_stack+868355,55);
 /*--- compute (m0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1906901,int_stack+1883801,int_stack+883755,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1091201,int_stack+1906901,int_stack+2795246,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+625654,int_stack+1091201,int_stack+3385178,441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+2443643,int_stack+625654,int_stack+1697303,441);
 /*--- compute (hg|hh) ---*/
   hrr1_build_hg(Libderiv->AB,int_stack+720910,int_stack+2443643,int_stack+1771391,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1864001,int_stack+390657,int_stack+390216,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1865324,int_stack+391245,int_stack+390657,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1867088,int_stack+1865324,int_stack+1864001,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1869734,int_stack+392001,int_stack+391245,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1872002,int_stack+1869734,int_stack+1865324,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1875530,int_stack+1872002,int_stack+1867088,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1864001,int_stack+392946,int_stack+392001,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1879940,int_stack+1864001,int_stack+1869734,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1884476,int_stack+1879940,int_stack+1872002,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1866836,int_stack+1884476,int_stack+1875530,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1873451,int_stack+394101,int_stack+392946,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1890356,int_stack+1873451,int_stack+1864001,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1896026,int_stack+1890356,int_stack+1879940,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2706038,int_stack+1896026,int_stack+1884476,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1873451,int_stack+2706038,int_stack+1866836,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2706038,int_stack+396075,int_stack+395487,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2707802,int_stack+396859,int_stack+396075,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2710154,int_stack+2707802,int_stack+2706038,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1864001,int_stack+397867,int_stack+396859,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1867025,int_stack+1864001,int_stack+2707802,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1882712,int_stack+1867025,int_stack+2710154,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2706038,int_stack+399127,int_stack+397867,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1888592,int_stack+2706038,int_stack+1864001,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1894640,int_stack+1888592,int_stack+1867025,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1864001,int_stack+1894640,int_stack+1882712,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1882712,int_stack+400667,int_stack+399127,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2764250,int_stack+1882712,int_stack+2706038,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+3432806,int_stack+2764250,int_stack+1888592,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2764250,int_stack+3432806,int_stack+1894640,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+3432806,int_stack+2764250,int_stack+1864001,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1931156,int_stack+3432806,int_stack+1873451, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2714858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1864001,int_stack+403271,int_stack+402515,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1866269,int_stack+404279,int_stack+403271,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1869293,int_stack+1866269,int_stack+1864001,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1873829,int_stack+405575,int_stack+404279,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1877717,int_stack+1873829,int_stack+1866269,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1883765,int_stack+1877717,int_stack+1869293,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1864001,int_stack+407195,int_stack+405575,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1891325,int_stack+1864001,int_stack+1873829,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2764250,int_stack+1891325,int_stack+1877717,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1868861,int_stack+2764250,int_stack+1883765,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1880201,int_stack+409175,int_stack+407195,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2815091,int_stack+1880201,int_stack+1864001,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+386991,int_stack+2815091,int_stack+1891325,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1880201,int_stack+386991,int_stack+2764250,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+386991,int_stack+1880201,int_stack+1868861,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+1864001,int_stack+386991,int_stack+3432806, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2724119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+859825,int_stack+1864001,int_stack+1931156, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2736467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1931156,int_stack+412496,int_stack+411551,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1933991,int_stack+413756,int_stack+412496,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1937771,int_stack+1933991,int_stack+1931156,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1943441,int_stack+415376,int_stack+413756,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1948301,int_stack+1943441,int_stack+1933991,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1955861,int_stack+1948301,int_stack+1937771,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1931156,int_stack+417401,int_stack+415376,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1965311,int_stack+1931156,int_stack+1943441,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+3432806,int_stack+1965311,int_stack+1948301,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1937231,int_stack+3432806,int_stack+1955861,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1951406,int_stack+419876,int_stack+417401,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2764250,int_stack+1951406,int_stack+1931156,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+402867,int_stack+2764250,int_stack+1965311,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1951406,int_stack+402867,int_stack+3432806,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+402867,int_stack+1951406,int_stack+1937231,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+1931156,int_stack+402867,int_stack+386991, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2779370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+1388951,int_stack+1931156,int_stack+1864001, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3292568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+3432806,int_stack+1388951,int_stack+859825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3329612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+859825,int_stack+424001,int_stack+422846,55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+863290,int_stack+425541,int_stack+424001,55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+867910,int_stack+863290,int_stack+859825,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+874840,int_stack+427521,int_stack+425541,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+880780,int_stack+874840,int_stack+863290,55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+890020,int_stack+880780,int_stack+867910,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+859825,int_stack+429996,int_stack+427521,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+901570,int_stack+859825,int_stack+874840,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+913450,int_stack+901570,int_stack+880780,55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+867250,int_stack+913450,int_stack+890020,55);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+884575,int_stack+433021,int_stack+429996,55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+928850,int_stack+884575,int_stack+859825,55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1864001,int_stack+928850,int_stack+901570,55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1883801,int_stack+1864001,int_stack+913450,55);
 /*--- compute (m0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+884575,int_stack+1883801,int_stack+867250,55);
 /*--- compute (lp|hh) ---*/
   d1hrr1_build_lp(Libderiv->AB,int_stack+3525416,int_stack+884575,int_stack+402867, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2795246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (kd|hh) ---*/
   d1hrr1_build_kd(Libderiv->AB,int_stack+3584951,int_stack+3525416,int_stack+1931156, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3385178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (if|hh) ---*/
   d1hrr1_build_if(Libderiv->AB,int_stack+3680207,int_stack+3584951,int_stack+1388951, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1697303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hg|hh) ---*/
   d1hrr1_build_hg(Libderiv->AB,int_stack+3803687,int_stack+3680207,int_stack+3432806, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1771391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (n0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3432806,int_stack+438037,int_stack+436651,66);
 /*--- compute (n0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3436964,int_stack+439885,int_stack+438037,66);
 /*--- compute (n0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3442508,int_stack+3436964,int_stack+3432806,66);
 /*--- compute (n0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3450824,int_stack+442261,int_stack+439885,66);
 /*--- compute (n0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3457952,int_stack+3450824,int_stack+3436964,66);
 /*--- compute (n0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+3469040,int_stack+3457952,int_stack+3442508,66);
 /*--- compute (n0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3432806,int_stack+445231,int_stack+442261,66);
 /*--- compute (n0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+3482900,int_stack+3432806,int_stack+3450824,66);
 /*--- compute (n0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+3497156,int_stack+3482900,int_stack+3457952,66);
 /*--- compute (n0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3441716,int_stack+3497156,int_stack+3469040,66);
 /*--- compute (n0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+3462506,int_stack+448861,int_stack+445231,66);
 /*--- compute (n0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1388951,int_stack+3462506,int_stack+3432806,66);
 /*--- compute (n0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1406771,int_stack+1388951,int_stack+3482900,66);
 /*--- compute (n0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+3462506,int_stack+1406771,int_stack+3497156,66);
 /*--- compute (n0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1388951,int_stack+3462506,int_stack+3441716,66);
 /*--- compute (mp|hh) ---*/
   d1hrr1_build_mp(Libderiv->AB,int_stack+1418057,int_stack+1388951,int_stack+884575, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1906901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (ld|hh) ---*/
   d1hrr1_build_ld(Libderiv->AB,int_stack+3942602,int_stack+1418057,int_stack+3525416, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1091201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (kf|hh) ---*/
   d1hrr1_build_kf(Libderiv->AB,int_stack+4061672,int_stack+3942602,int_stack+3584951, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+625654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (ig|hh) ---*/
   d1hrr1_build_ig(Libderiv->AB,int_stack+3432806,int_stack+4061672,int_stack+3680207, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2443643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3942602,int_stack+453658,int_stack+453217,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3943925,int_stack+454246,int_stack+453658,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3945689,int_stack+3943925,int_stack+3942602,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3948335,int_stack+455002,int_stack+454246,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3950603,int_stack+3948335,int_stack+3943925,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+3954131,int_stack+3950603,int_stack+3945689,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3942602,int_stack+455947,int_stack+455002,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+3958541,int_stack+3942602,int_stack+3948335,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+3963077,int_stack+3958541,int_stack+3950603,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3945437,int_stack+3963077,int_stack+3954131,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+3952052,int_stack+457102,int_stack+455947,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+3968957,int_stack+3952052,int_stack+3942602,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+3974627,int_stack+3968957,int_stack+3958541,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2706038,int_stack+3974627,int_stack+3963077,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+3952052,int_stack+2706038,int_stack+3945437,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2706038,int_stack+459076,int_stack+458488,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2707802,int_stack+459860,int_stack+459076,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2710154,int_stack+2707802,int_stack+2706038,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3942602,int_stack+460868,int_stack+459860,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3945626,int_stack+3942602,int_stack+2707802,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+3961313,int_stack+3945626,int_stack+2710154,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2706038,int_stack+462128,int_stack+460868,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+3967193,int_stack+2706038,int_stack+3942602,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+3973241,int_stack+3967193,int_stack+3945626,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3942602,int_stack+3973241,int_stack+3961313,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+3961313,int_stack+463668,int_stack+462128,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+3981081,int_stack+3961313,int_stack+2706038,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+3988641,int_stack+3981081,int_stack+3967193,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+3961313,int_stack+3988641,int_stack+3973241,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+3973073,int_stack+3961313,int_stack+3942602,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+3985421,int_stack+3973073,int_stack+3952052, 0.0, zero_stack, 1.0, int_stack+2714858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3942602,int_stack+466272,int_stack+465516,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3944870,int_stack+467280,int_stack+466272,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3947894,int_stack+3944870,int_stack+3942602,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3952430,int_stack+468576,int_stack+467280,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3956318,int_stack+3952430,int_stack+3944870,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+3962366,int_stack+3956318,int_stack+3947894,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3942602,int_stack+470196,int_stack+468576,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2706038,int_stack+3942602,int_stack+3952430,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+4013204,int_stack+2706038,int_stack+3956318,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3947462,int_stack+4013204,int_stack+3962366,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+3958802,int_stack+472176,int_stack+470196,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+4023284,int_stack+3958802,int_stack+3942602,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+3958802,int_stack+4023284,int_stack+2706038,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2764250,int_stack+3958802,int_stack+4013204,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+4013204,int_stack+2764250,int_stack+3947462,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+4029080,int_stack+4013204,int_stack+3973073, 0.0, zero_stack, 1.0, int_stack+2724119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+4066124,int_stack+4029080,int_stack+3985421, 0.0, zero_stack, 1.0, int_stack+2736467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2764250,int_stack+475497,int_stack+474552,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2767085,int_stack+476757,int_stack+475497,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2770865,int_stack+2767085,int_stack+2764250,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+4121690,int_stack+478377,int_stack+476757,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4126550,int_stack+4121690,int_stack+2767085,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+4134110,int_stack+4126550,int_stack+2770865,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2764250,int_stack+480402,int_stack+478377,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+4143560,int_stack+2764250,int_stack+4121690,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+4153280,int_stack+4143560,int_stack+4126550,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+4165880,int_stack+4153280,int_stack+4134110,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+4121690,int_stack+482877,int_stack+480402,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+4129115,int_stack+4121690,int_stack+2764250,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+4180055,int_stack+4129115,int_stack+4143560,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+4121690,int_stack+4180055,int_stack+4153280,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+4180055,int_stack+4121690,int_stack+4165880,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+4121690,int_stack+4180055,int_stack+4013204, 0.0, zero_stack, 1.0, int_stack+2779370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+3942602,int_stack+4121690,int_stack+4029080, 0.0, zero_stack, 1.0, int_stack+3292568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+1388951,int_stack+3942602,int_stack+4066124, 0.0, zero_stack, 1.0, int_stack+3329612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4169318,int_stack+487002,int_stack+485847,55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4172783,int_stack+488542,int_stack+487002,55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+4199900,int_stack+4172783,int_stack+4169318,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+4206830,int_stack+490522,int_stack+488542,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2764250,int_stack+4206830,int_stack+4172783,55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+4016690,int_stack+2764250,int_stack+4199900,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+4169318,int_stack+492997,int_stack+490522,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+4028240,int_stack+4169318,int_stack+4206830,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+4199900,int_stack+4028240,int_stack+2764250,55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+4040120,int_stack+4199900,int_stack+4016690,55);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+4016690,int_stack+496022,int_stack+492997,55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2764250,int_stack+4016690,int_stack+4169318,55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+4057445,int_stack+2764250,int_stack+4028240,55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+4016690,int_stack+4057445,int_stack+4199900,55);
 /*--- compute (m0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+4057445,int_stack+4016690,int_stack+4040120,55);
 /*--- compute (lp|hh) ---*/
   d1hrr1_build_lp(Libderiv->AB,int_stack+3618026,int_stack+4057445,int_stack+4180055, 0.0, zero_stack, 1.0, int_stack+2795246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (kd|hh) ---*/
   d1hrr1_build_kd(Libderiv->AB,int_stack+3677561,int_stack+3618026,int_stack+4121690, 0.0, zero_stack, 1.0, int_stack+3385178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (if|hh) ---*/
   d1hrr1_build_if(Libderiv->AB,int_stack+4081700,int_stack+3677561,int_stack+3942602, 0.0, zero_stack, 1.0, int_stack+1697303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hg|hh) ---*/
   d1hrr1_build_hg(Libderiv->AB,int_stack+4205180,int_stack+4081700,int_stack+1388951, 0.0, zero_stack, 1.0, int_stack+1771391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (n0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1388951,int_stack+501038,int_stack+499652,66);
 /*--- compute (n0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1393109,int_stack+502886,int_stack+501038,66);
 /*--- compute (n0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1398653,int_stack+1393109,int_stack+1388951,66);
 /*--- compute (n0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1406969,int_stack+505262,int_stack+502886,66);
 /*--- compute (n0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1414097,int_stack+1406969,int_stack+1393109,66);
 /*--- compute (n0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1425185,int_stack+1414097,int_stack+1398653,66);
 /*--- compute (n0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1388951,int_stack+508232,int_stack+505262,66);
 /*--- compute (n0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1439045,int_stack+1388951,int_stack+1406969,66);
 /*--- compute (n0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1453301,int_stack+1439045,int_stack+1414097,66);
 /*--- compute (n0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1397861,int_stack+1453301,int_stack+1425185,66);
 /*--- compute (n0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1418651,int_stack+511862,int_stack+508232,66);
 /*--- compute (n0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1471781,int_stack+1418651,int_stack+1388951,66);
 /*--- compute (n0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+3942602,int_stack+1471781,int_stack+1439045,66);
 /*--- compute (n0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1471781,int_stack+3942602,int_stack+1453301,66);
 /*--- compute (n0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+3942602,int_stack+1471781,int_stack+1397861,66);
 /*--- compute (mp|hh) ---*/
   d1hrr1_build_mp(Libderiv->AB,int_stack+3971708,int_stack+3942602,int_stack+4057445, 0.0, zero_stack, 1.0, int_stack+1906901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (ld|hh) ---*/
   d1hrr1_build_ld(Libderiv->AB,int_stack+1388951,int_stack+3971708,int_stack+3618026, 0.0, zero_stack, 1.0, int_stack+1091201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (kf|hh) ---*/
   d1hrr1_build_kf(Libderiv->AB,int_stack+4344095,int_stack+1388951,int_stack+3677561, 0.0, zero_stack, 1.0, int_stack+625654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (ig|hh) ---*/
   d1hrr1_build_ig(Libderiv->AB,int_stack+3618026,int_stack+4344095,int_stack+4081700, 0.0, zero_stack, 1.0, int_stack+2443643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4344095,int_stack+521930,int_stack+521489,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4345418,int_stack+522518,int_stack+521930,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+4347182,int_stack+4345418,int_stack+4344095,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+4349828,int_stack+523274,int_stack+522518,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4352096,int_stack+4349828,int_stack+4345418,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+4355624,int_stack+4352096,int_stack+4347182,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+4344095,int_stack+524219,int_stack+523274,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+4360034,int_stack+4344095,int_stack+4349828,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+4364570,int_stack+4360034,int_stack+4352096,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+4346930,int_stack+4364570,int_stack+4355624,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+4353545,int_stack+525374,int_stack+524219,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+4370450,int_stack+4353545,int_stack+4344095,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+4376120,int_stack+4370450,int_stack+4360034,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2706038,int_stack+4376120,int_stack+4364570,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+4353545,int_stack+2706038,int_stack+4346930,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2706038,int_stack+534376,int_stack+533788,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2707802,int_stack+535160,int_stack+534376,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2710154,int_stack+2707802,int_stack+2706038,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+4344095,int_stack+536168,int_stack+535160,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4347119,int_stack+4344095,int_stack+2707802,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+4362806,int_stack+4347119,int_stack+2710154,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2706038,int_stack+537428,int_stack+536168,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+4368686,int_stack+2706038,int_stack+4344095,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+4374734,int_stack+4368686,int_stack+4347119,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+4344095,int_stack+4374734,int_stack+4362806,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+4362806,int_stack+538968,int_stack+537428,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+4382574,int_stack+4362806,int_stack+2706038,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+4390134,int_stack+4382574,int_stack+4368686,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+4362806,int_stack+4390134,int_stack+4374734,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+4374566,int_stack+4362806,int_stack+4344095,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+4386914,int_stack+4374566,int_stack+4353545, 1.0, int_stack+2714858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4344095,int_stack+550608,int_stack+549852,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4346363,int_stack+551616,int_stack+550608,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+4349387,int_stack+4346363,int_stack+4344095,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+4353923,int_stack+552912,int_stack+551616,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4357811,int_stack+4353923,int_stack+4346363,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+4363859,int_stack+4357811,int_stack+4349387,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+4344095,int_stack+554532,int_stack+552912,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2706038,int_stack+4344095,int_stack+4353923,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2713814,int_stack+2706038,int_stack+4357811,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+4348955,int_stack+2713814,int_stack+4363859,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+4360295,int_stack+556512,int_stack+554532,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+4414697,int_stack+4360295,int_stack+4344095,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+4360295,int_stack+4414697,int_stack+2706038,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2764250,int_stack+4360295,int_stack+2713814,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2706038,int_stack+2764250,int_stack+4348955,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+4414697,int_stack+2706038,int_stack+4374566, 1.0, int_stack+2724119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1388951,int_stack+4414697,int_stack+4386914, 1.0, int_stack+2736467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2721914,int_stack+571128,int_stack+570183,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2724749,int_stack+572388,int_stack+571128,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2728529,int_stack+2724749,int_stack+2721914,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2734199,int_stack+574008,int_stack+572388,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2739059,int_stack+2734199,int_stack+2724749,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2746619,int_stack+2739059,int_stack+2728529,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2721914,int_stack+576033,int_stack+574008,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2756069,int_stack+2721914,int_stack+2734199,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2765789,int_stack+2756069,int_stack+2739059,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2727989,int_stack+2765789,int_stack+2746619,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2742164,int_stack+578508,int_stack+576033,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+4451741,int_stack+2742164,int_stack+2721914,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+4463891,int_stack+4451741,int_stack+2756069,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2742164,int_stack+4463891,int_stack+2765789,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+4451741,int_stack+2742164,int_stack+2727989,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+2721914,int_stack+4451741,int_stack+2706038, 1.0, int_stack+2779370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+3942602,int_stack+2721914,int_stack+4414697, 1.0, int_stack+3292568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+4344095,int_stack+3942602,int_stack+1388951, 1.0, int_stack+3329612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1388951,int_stack+596438,int_stack+595283,55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1392416,int_stack+597978,int_stack+596438,55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1397036,int_stack+1392416,int_stack+1388951,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1403966,int_stack+599958,int_stack+597978,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1409906,int_stack+1403966,int_stack+1392416,55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1419146,int_stack+1409906,int_stack+1397036,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1388951,int_stack+602433,int_stack+599958,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1430696,int_stack+1388951,int_stack+1403966,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1442576,int_stack+1430696,int_stack+1409906,55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1396376,int_stack+1442576,int_stack+1419146,55);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1413701,int_stack+605458,int_stack+602433,55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1457976,int_stack+1413701,int_stack+1388951,55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1472826,int_stack+1457976,int_stack+1430696,55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1413701,int_stack+1472826,int_stack+1442576,55);
 /*--- compute (m0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1436801,int_stack+1413701,int_stack+1396376,55);
 /*--- compute (lp|hh) ---*/
   d1hrr1_build_lp(Libderiv->AB,int_stack+3292568,int_stack+1436801,int_stack+4451741, 1.0, int_stack+2795246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (kd|hh) ---*/
   d1hrr1_build_kd(Libderiv->AB,int_stack+4016690,int_stack+3292568,int_stack+2721914, 1.0, int_stack+3385178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (if|hh) ---*/
   d1hrr1_build_if(Libderiv->AB,int_stack+2706038,int_stack+4016690,int_stack+3942602, 1.0, int_stack+1697303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hg|hh) ---*/
   d1hrr1_build_hg(Libderiv->AB,int_stack+386991,int_stack+2706038,int_stack+4344095, 1.0, int_stack+1771391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (n0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4344095,int_stack+610474,int_stack+609088,66);
 /*--- compute (n0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4348253,int_stack+612322,int_stack+610474,66);
 /*--- compute (n0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+4353797,int_stack+4348253,int_stack+4344095,66);
 /*--- compute (n0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+4362113,int_stack+614698,int_stack+612322,66);
 /*--- compute (n0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4369241,int_stack+4362113,int_stack+4348253,66);
 /*--- compute (n0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+4380329,int_stack+4369241,int_stack+4353797,66);
 /*--- compute (n0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+4344095,int_stack+617668,int_stack+614698,66);
 /*--- compute (n0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+4394189,int_stack+4344095,int_stack+4362113,66);
 /*--- compute (n0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+4408445,int_stack+4394189,int_stack+4369241,66);
 /*--- compute (n0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+4353005,int_stack+4408445,int_stack+4380329,66);
 /*--- compute (n0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+4373795,int_stack+621298,int_stack+617668,66);
 /*--- compute (n0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+4426925,int_stack+4373795,int_stack+4344095,66);
 /*--- compute (n0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+4444745,int_stack+4426925,int_stack+4394189,66);
 /*--- compute (n0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+4373795,int_stack+4444745,int_stack+4408445,66);
 /*--- compute (n0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+4401515,int_stack+4373795,int_stack+4353005,66);
 /*--- compute (mp|hh) ---*/
   d1hrr1_build_mp(Libderiv->AB,int_stack+4430621,int_stack+4401515,int_stack+1436801, 1.0, int_stack+1906901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (ld|hh) ---*/
   d1hrr1_build_ld(Libderiv->AB,int_stack+1697303,int_stack+4430621,int_stack+3292568, 1.0, int_stack+1091201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (kf|hh) ---*/
   d1hrr1_build_kf(Libderiv->AB,int_stack+4344095,int_stack+1697303,int_stack+4016690, 1.0, int_stack+625654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (ig|hh) ---*/
   d1hrr1_build_ig(Libderiv->AB,int_stack+1697303,int_stack+4344095,int_stack+2706038, 1.0, int_stack+2443643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hh|hh) ---*/
   hrr1_build_hh(Libderiv->AB,int_stack+3942602,int_stack+1512083,int_stack+952286,441);
     Libderiv->ABCD[11] = int_stack + 3942602;
 /*--- compute (hh|hh) ---*/
   hrr1_build_hh(Libderiv->AB,int_stack+1388951,int_stack+2119508,int_stack+1980593,441);
     Libderiv->ABCD[10] = int_stack + 1388951;
 /*--- compute (hh|hh) ---*/
   hrr1_build_hh(Libderiv->AB,int_stack+1882523,int_stack+1203731,int_stack+2304728,441);
     Libderiv->ABCD[9] = int_stack + 1882523;
 /*--- compute (hh|hh) ---*/
   hrr1_build_hh(Libderiv->AB,int_stack+2077004,int_stack+16551,int_stack+2567123,441);
     Libderiv->ABCD[8] = int_stack + 2077004;
 /*--- compute (hh|hh) ---*/
   hrr1_build_hh(Libderiv->AB,int_stack+2271485,int_stack+2968433,int_stack+2829518,441);
     Libderiv->ABCD[7] = int_stack + 2271485;
 /*--- compute (hh|hh) ---*/
   hrr1_build_hh(Libderiv->AB,int_stack+2465966,int_stack+201771,int_stack+3153653,441);
     Libderiv->ABCD[6] = int_stack + 2465966;
 /*--- compute (hh|hh) ---*/
   d1hrr1_build_hh(Libderiv->AB,int_stack+2660447,int_stack+3432806,int_stack+3803687, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+720910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[2] = int_stack + 2660447;
 /*--- compute (hh|hh) ---*/
   d1hrr1_build_hh(Libderiv->AB,int_stack+2854928,int_stack+3618026,int_stack+4205180, 0.0, zero_stack, 1.0, int_stack+720910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[1] = int_stack + 2854928;
 /*--- compute (hh|hh) ---*/
   d1hrr1_build_hh(Libderiv->AB,int_stack+3049409,int_stack+1697303,int_stack+386991, 1.0, int_stack+720910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[0] = int_stack + 3049409;

}
