/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ms|is) integrals */

#include "libint.h"

REALTYPE *_build_m0i0_0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2zn;
  REALTYPE twoo2zn;
  REALTYPE threeo2zn;
  REALTYPE fouro2zn;
  REALTYPE fiveo2zn;
  REALTYPE sixo2zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  REALTYPE seveno2z;
  REALTYPE eighto2z;
  oneo2zn = 1.0*Data->oo2zn;
  twoo2zn = 2.0*Data->oo2zn;
  threeo2zn = 3.0*Data->oo2zn;
  fouro2zn = 4.0*Data->oo2zn;
  fiveo2zn = 5.0*Data->oo2zn;
  sixo2zn = 6.0*Data->oo2zn;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  seveno2z = 7.0*Data->oo2z;
  eighto2z = 8.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U40 = Data->U[4][0];
  U41 = Data->U[4][1];
  U42 = Data->U[4][2];


*(vp++) = U00*I0[0] + U40*I1[0]
           + (eighto2z)*(I2[0] - (lpoz)*I3[0])
           + (sixo2zn)*I4[0];
*(vp++) = U00*I0[1] + U40*I1[1]
           + (eighto2z)*(I2[1] - (lpoz)*I3[1])
           + (fiveo2zn)*I4[1];
*(vp++) = U00*I0[2] + U40*I1[2]
           + (eighto2z)*(I2[2] - (lpoz)*I3[2])
           + (fiveo2zn)*I4[2];
*(vp++) = U00*I0[3] + U40*I1[3]
           + (eighto2z)*(I2[3] - (lpoz)*I3[3])
           + (fouro2zn)*I4[3];
*(vp++) = U00*I0[4] + U40*I1[4]
           + (eighto2z)*(I2[4] - (lpoz)*I3[4])
           + (fouro2zn)*I4[4];
*(vp++) = U00*I0[5] + U40*I1[5]
           + (eighto2z)*(I2[5] - (lpoz)*I3[5])
           + (fouro2zn)*I4[5];
*(vp++) = U00*I0[6] + U40*I1[6]
           + (eighto2z)*(I2[6] - (lpoz)*I3[6])
           + (threeo2zn)*I4[6];
*(vp++) = U00*I0[7] + U40*I1[7]
           + (eighto2z)*(I2[7] - (lpoz)*I3[7])
           + (threeo2zn)*I4[7];
*(vp++) = U00*I0[8] + U40*I1[8]
           + (eighto2z)*(I2[8] - (lpoz)*I3[8])
           + (threeo2zn)*I4[8];
*(vp++) = U00*I0[9] + U40*I1[9]
           + (eighto2z)*(I2[9] - (lpoz)*I3[9])
           + (threeo2zn)*I4[9];
*(vp++) = U00*I0[10] + U40*I1[10]
           + (eighto2z)*(I2[10] - (lpoz)*I3[10])
           + (twoo2zn)*I4[10];
*(vp++) = U00*I0[11] + U40*I1[11]
           + (eighto2z)*(I2[11] - (lpoz)*I3[11])
           + (twoo2zn)*I4[11];
*(vp++) = U00*I0[12] + U40*I1[12]
           + (eighto2z)*(I2[12] - (lpoz)*I3[12])
           + (twoo2zn)*I4[12];
*(vp++) = U00*I0[13] + U40*I1[13]
           + (eighto2z)*(I2[13] - (lpoz)*I3[13])
           + (twoo2zn)*I4[13];
*(vp++) = U00*I0[14] + U40*I1[14]
           + (eighto2z)*(I2[14] - (lpoz)*I3[14])
           + (twoo2zn)*I4[14];
*(vp++) = U00*I0[15] + U40*I1[15]
           + (eighto2z)*(I2[15] - (lpoz)*I3[15])
           + (oneo2zn)*I4[15];
*(vp++) = U00*I0[16] + U40*I1[16]
           + (eighto2z)*(I2[16] - (lpoz)*I3[16])
           + (oneo2zn)*I4[16];
*(vp++) = U00*I0[17] + U40*I1[17]
           + (eighto2z)*(I2[17] - (lpoz)*I3[17])
           + (oneo2zn)*I4[17];
*(vp++) = U00*I0[18] + U40*I1[18]
           + (eighto2z)*(I2[18] - (lpoz)*I3[18])
           + (oneo2zn)*I4[18];
*(vp++) = U00*I0[19] + U40*I1[19]
           + (eighto2z)*(I2[19] - (lpoz)*I3[19])
           + (oneo2zn)*I4[19];
*(vp++) = U00*I0[20] + U40*I1[20]
           + (eighto2z)*(I2[20] - (lpoz)*I3[20])
           + (oneo2zn)*I4[20];
*(vp++) = U00*I0[21] + U40*I1[21]
           + (eighto2z)*(I2[21] - (lpoz)*I3[21]);
*(vp++) = U00*I0[22] + U40*I1[22]
           + (eighto2z)*(I2[22] - (lpoz)*I3[22]);
*(vp++) = U00*I0[23] + U40*I1[23]
           + (eighto2z)*(I2[23] - (lpoz)*I3[23]);
*(vp++) = U00*I0[24] + U40*I1[24]
           + (eighto2z)*(I2[24] - (lpoz)*I3[24]);
*(vp++) = U00*I0[25] + U40*I1[25]
           + (eighto2z)*(I2[25] - (lpoz)*I3[25]);
*(vp++) = U00*I0[26] + U40*I1[26]
           + (eighto2z)*(I2[26] - (lpoz)*I3[26]);
*(vp++) = U00*I0[27] + U40*I1[27]
           + (eighto2z)*(I2[27] - (lpoz)*I3[27]);
*(vp++) = U00*I0[28] + U40*I1[28]
           + (seveno2z)*(I2[28] - (lpoz)*I3[28])
           + (sixo2zn)*I4[21];
*(vp++) = U00*I0[29] + U40*I1[29]
           + (seveno2z)*(I2[29] - (lpoz)*I3[29])
           + (fiveo2zn)*I4[22];
*(vp++) = U00*I0[30] + U40*I1[30]
           + (seveno2z)*(I2[30] - (lpoz)*I3[30])
           + (fiveo2zn)*I4[23];
*(vp++) = U00*I0[31] + U40*I1[31]
           + (seveno2z)*(I2[31] - (lpoz)*I3[31])
           + (fouro2zn)*I4[24];
*(vp++) = U00*I0[32] + U40*I1[32]
           + (seveno2z)*(I2[32] - (lpoz)*I3[32])
           + (fouro2zn)*I4[25];
*(vp++) = U00*I0[33] + U40*I1[33]
           + (seveno2z)*(I2[33] - (lpoz)*I3[33])
           + (fouro2zn)*I4[26];
*(vp++) = U00*I0[34] + U40*I1[34]
           + (seveno2z)*(I2[34] - (lpoz)*I3[34])
           + (threeo2zn)*I4[27];
*(vp++) = U00*I0[35] + U40*I1[35]
           + (seveno2z)*(I2[35] - (lpoz)*I3[35])
           + (threeo2zn)*I4[28];
*(vp++) = U00*I0[36] + U40*I1[36]
           + (seveno2z)*(I2[36] - (lpoz)*I3[36])
           + (threeo2zn)*I4[29];
*(vp++) = U00*I0[37] + U40*I1[37]
           + (seveno2z)*(I2[37] - (lpoz)*I3[37])
           + (threeo2zn)*I4[30];
*(vp++) = U00*I0[38] + U40*I1[38]
           + (seveno2z)*(I2[38] - (lpoz)*I3[38])
           + (twoo2zn)*I4[31];
*(vp++) = U00*I0[39] + U40*I1[39]
           + (seveno2z)*(I2[39] - (lpoz)*I3[39])
           + (twoo2zn)*I4[32];
*(vp++) = U00*I0[40] + U40*I1[40]
           + (seveno2z)*(I2[40] - (lpoz)*I3[40])
           + (twoo2zn)*I4[33];
*(vp++) = U00*I0[41] + U40*I1[41]
           + (seveno2z)*(I2[41] - (lpoz)*I3[41])
           + (twoo2zn)*I4[34];
*(vp++) = U00*I0[42] + U40*I1[42]
           + (seveno2z)*(I2[42] - (lpoz)*I3[42])
           + (twoo2zn)*I4[35];
*(vp++) = U00*I0[43] + U40*I1[43]
           + (seveno2z)*(I2[43] - (lpoz)*I3[43])
           + (oneo2zn)*I4[36];
*(vp++) = U00*I0[44] + U40*I1[44]
           + (seveno2z)*(I2[44] - (lpoz)*I3[44])
           + (oneo2zn)*I4[37];
*(vp++) = U00*I0[45] + U40*I1[45]
           + (seveno2z)*(I2[45] - (lpoz)*I3[45])
           + (oneo2zn)*I4[38];
*(vp++) = U00*I0[46] + U40*I1[46]
           + (seveno2z)*(I2[46] - (lpoz)*I3[46])
           + (oneo2zn)*I4[39];
*(vp++) = U00*I0[47] + U40*I1[47]
           + (seveno2z)*(I2[47] - (lpoz)*I3[47])
           + (oneo2zn)*I4[40];
*(vp++) = U00*I0[48] + U40*I1[48]
           + (seveno2z)*(I2[48] - (lpoz)*I3[48])
           + (oneo2zn)*I4[41];
*(vp++) = U00*I0[49] + U40*I1[49]
           + (seveno2z)*(I2[49] - (lpoz)*I3[49]);
*(vp++) = U00*I0[50] + U40*I1[50]
           + (seveno2z)*(I2[50] - (lpoz)*I3[50]);
*(vp++) = U00*I0[51] + U40*I1[51]
           + (seveno2z)*(I2[51] - (lpoz)*I3[51]);
*(vp++) = U00*I0[52] + U40*I1[52]
           + (seveno2z)*(I2[52] - (lpoz)*I3[52]);
*(vp++) = U00*I0[53] + U40*I1[53]
           + (seveno2z)*(I2[53] - (lpoz)*I3[53]);
*(vp++) = U00*I0[54] + U40*I1[54]
           + (seveno2z)*(I2[54] - (lpoz)*I3[54]);
*(vp++) = U00*I0[55] + U40*I1[55]
           + (seveno2z)*(I2[55] - (lpoz)*I3[55]);
*(vp++) = U00*I0[56] + U40*I1[56]
           + (seveno2z)*(I2[56] - (lpoz)*I3[56])
           + (sixo2zn)*I4[42];
*(vp++) = U00*I0[57] + U40*I1[57]
           + (seveno2z)*(I2[57] - (lpoz)*I3[57])
           + (fiveo2zn)*I4[43];
*(vp++) = U00*I0[58] + U40*I1[58]
           + (seveno2z)*(I2[58] - (lpoz)*I3[58])
           + (fiveo2zn)*I4[44];
*(vp++) = U00*I0[59] + U40*I1[59]
           + (seveno2z)*(I2[59] - (lpoz)*I3[59])
           + (fouro2zn)*I4[45];
*(vp++) = U00*I0[60] + U40*I1[60]
           + (seveno2z)*(I2[60] - (lpoz)*I3[60])
           + (fouro2zn)*I4[46];
*(vp++) = U00*I0[61] + U40*I1[61]
           + (seveno2z)*(I2[61] - (lpoz)*I3[61])
           + (fouro2zn)*I4[47];
*(vp++) = U00*I0[62] + U40*I1[62]
           + (seveno2z)*(I2[62] - (lpoz)*I3[62])
           + (threeo2zn)*I4[48];
*(vp++) = U00*I0[63] + U40*I1[63]
           + (seveno2z)*(I2[63] - (lpoz)*I3[63])
           + (threeo2zn)*I4[49];
*(vp++) = U00*I0[64] + U40*I1[64]
           + (seveno2z)*(I2[64] - (lpoz)*I3[64])
           + (threeo2zn)*I4[50];
*(vp++) = U00*I0[65] + U40*I1[65]
           + (seveno2z)*(I2[65] - (lpoz)*I3[65])
           + (threeo2zn)*I4[51];
*(vp++) = U00*I0[66] + U40*I1[66]
           + (seveno2z)*(I2[66] - (lpoz)*I3[66])
           + (twoo2zn)*I4[52];
*(vp++) = U00*I0[67] + U40*I1[67]
           + (seveno2z)*(I2[67] - (lpoz)*I3[67])
           + (twoo2zn)*I4[53];
*(vp++) = U00*I0[68] + U40*I1[68]
           + (seveno2z)*(I2[68] - (lpoz)*I3[68])
           + (twoo2zn)*I4[54];
*(vp++) = U00*I0[69] + U40*I1[69]
           + (seveno2z)*(I2[69] - (lpoz)*I3[69])
           + (twoo2zn)*I4[55];
*(vp++) = U00*I0[70] + U40*I1[70]
           + (seveno2z)*(I2[70] - (lpoz)*I3[70])
           + (twoo2zn)*I4[56];
*(vp++) = U00*I0[71] + U40*I1[71]
           + (seveno2z)*(I2[71] - (lpoz)*I3[71])
           + (oneo2zn)*I4[57];
*(vp++) = U00*I0[72] + U40*I1[72]
           + (seveno2z)*(I2[72] - (lpoz)*I3[72])
           + (oneo2zn)*I4[58];
*(vp++) = U00*I0[73] + U40*I1[73]
           + (seveno2z)*(I2[73] - (lpoz)*I3[73])
           + (oneo2zn)*I4[59];
*(vp++) = U00*I0[74] + U40*I1[74]
           + (seveno2z)*(I2[74] - (lpoz)*I3[74])
           + (oneo2zn)*I4[60];
*(vp++) = U00*I0[75] + U40*I1[75]
           + (seveno2z)*(I2[75] - (lpoz)*I3[75])
           + (oneo2zn)*I4[61];
*(vp++) = U00*I0[76] + U40*I1[76]
           + (seveno2z)*(I2[76] - (lpoz)*I3[76])
           + (oneo2zn)*I4[62];
*(vp++) = U00*I0[77] + U40*I1[77]
           + (seveno2z)*(I2[77] - (lpoz)*I3[77]);
*(vp++) = U00*I0[78] + U40*I1[78]
           + (seveno2z)*(I2[78] - (lpoz)*I3[78]);
*(vp++) = U00*I0[79] + U40*I1[79]
           + (seveno2z)*(I2[79] - (lpoz)*I3[79]);
*(vp++) = U00*I0[80] + U40*I1[80]
           + (seveno2z)*(I2[80] - (lpoz)*I3[80]);
*(vp++) = U00*I0[81] + U40*I1[81]
           + (seveno2z)*(I2[81] - (lpoz)*I3[81]);
*(vp++) = U00*I0[82] + U40*I1[82]
           + (seveno2z)*(I2[82] - (lpoz)*I3[82]);
*(vp++) = U00*I0[83] + U40*I1[83]
           + (seveno2z)*(I2[83] - (lpoz)*I3[83]);
*(vp++) = U00*I0[84] + U40*I1[84]
           + (sixo2z)*(I2[84] - (lpoz)*I3[84])
           + (sixo2zn)*I4[63];
*(vp++) = U00*I0[85] + U40*I1[85]
           + (sixo2z)*(I2[85] - (lpoz)*I3[85])
           + (fiveo2zn)*I4[64];
*(vp++) = U00*I0[86] + U40*I1[86]
           + (sixo2z)*(I2[86] - (lpoz)*I3[86])
           + (fiveo2zn)*I4[65];
*(vp++) = U00*I0[87] + U40*I1[87]
           + (sixo2z)*(I2[87] - (lpoz)*I3[87])
           + (fouro2zn)*I4[66];
*(vp++) = U00*I0[88] + U40*I1[88]
           + (sixo2z)*(I2[88] - (lpoz)*I3[88])
           + (fouro2zn)*I4[67];
*(vp++) = U00*I0[89] + U40*I1[89]
           + (sixo2z)*(I2[89] - (lpoz)*I3[89])
           + (fouro2zn)*I4[68];
*(vp++) = U00*I0[90] + U40*I1[90]
           + (sixo2z)*(I2[90] - (lpoz)*I3[90])
           + (threeo2zn)*I4[69];
*(vp++) = U00*I0[91] + U40*I1[91]
           + (sixo2z)*(I2[91] - (lpoz)*I3[91])
           + (threeo2zn)*I4[70];
*(vp++) = U00*I0[92] + U40*I1[92]
           + (sixo2z)*(I2[92] - (lpoz)*I3[92])
           + (threeo2zn)*I4[71];
*(vp++) = U00*I0[93] + U40*I1[93]
           + (sixo2z)*(I2[93] - (lpoz)*I3[93])
           + (threeo2zn)*I4[72];
*(vp++) = U00*I0[94] + U40*I1[94]
           + (sixo2z)*(I2[94] - (lpoz)*I3[94])
           + (twoo2zn)*I4[73];
*(vp++) = U00*I0[95] + U40*I1[95]
           + (sixo2z)*(I2[95] - (lpoz)*I3[95])
           + (twoo2zn)*I4[74];
*(vp++) = U00*I0[96] + U40*I1[96]
           + (sixo2z)*(I2[96] - (lpoz)*I3[96])
           + (twoo2zn)*I4[75];
*(vp++) = U00*I0[97] + U40*I1[97]
           + (sixo2z)*(I2[97] - (lpoz)*I3[97])
           + (twoo2zn)*I4[76];
*(vp++) = U00*I0[98] + U40*I1[98]
           + (sixo2z)*(I2[98] - (lpoz)*I3[98])
           + (twoo2zn)*I4[77];
*(vp++) = U00*I0[99] + U40*I1[99]
           + (sixo2z)*(I2[99] - (lpoz)*I3[99])
           + (oneo2zn)*I4[78];
*(vp++) = U00*I0[100] + U40*I1[100]
           + (sixo2z)*(I2[100] - (lpoz)*I3[100])
           + (oneo2zn)*I4[79];
*(vp++) = U00*I0[101] + U40*I1[101]
           + (sixo2z)*(I2[101] - (lpoz)*I3[101])
           + (oneo2zn)*I4[80];
*(vp++) = U00*I0[102] + U40*I1[102]
           + (sixo2z)*(I2[102] - (lpoz)*I3[102])
           + (oneo2zn)*I4[81];
*(vp++) = U00*I0[103] + U40*I1[103]
           + (sixo2z)*(I2[103] - (lpoz)*I3[103])
           + (oneo2zn)*I4[82];
*(vp++) = U00*I0[104] + U40*I1[104]
           + (sixo2z)*(I2[104] - (lpoz)*I3[104])
           + (oneo2zn)*I4[83];
*(vp++) = U00*I0[105] + U40*I1[105]
           + (sixo2z)*(I2[105] - (lpoz)*I3[105]);
*(vp++) = U00*I0[106] + U40*I1[106]
           + (sixo2z)*(I2[106] - (lpoz)*I3[106]);
*(vp++) = U00*I0[107] + U40*I1[107]
           + (sixo2z)*(I2[107] - (lpoz)*I3[107]);
*(vp++) = U00*I0[108] + U40*I1[108]
           + (sixo2z)*(I2[108] - (lpoz)*I3[108]);
*(vp++) = U00*I0[109] + U40*I1[109]
           + (sixo2z)*(I2[109] - (lpoz)*I3[109]);
*(vp++) = U00*I0[110] + U40*I1[110]
           + (sixo2z)*(I2[110] - (lpoz)*I3[110]);
*(vp++) = U00*I0[111] + U40*I1[111]
           + (sixo2z)*(I2[111] - (lpoz)*I3[111]);
*(vp++) = U00*I0[112] + U40*I1[112]
           + (sixo2z)*(I2[112] - (lpoz)*I3[112])
           + (sixo2zn)*I4[84];
*(vp++) = U00*I0[113] + U40*I1[113]
           + (sixo2z)*(I2[113] - (lpoz)*I3[113])
           + (fiveo2zn)*I4[85];
*(vp++) = U00*I0[114] + U40*I1[114]
           + (sixo2z)*(I2[114] - (lpoz)*I3[114])
           + (fiveo2zn)*I4[86];
*(vp++) = U00*I0[115] + U40*I1[115]
           + (sixo2z)*(I2[115] - (lpoz)*I3[115])
           + (fouro2zn)*I4[87];
*(vp++) = U00*I0[116] + U40*I1[116]
           + (sixo2z)*(I2[116] - (lpoz)*I3[116])
           + (fouro2zn)*I4[88];
*(vp++) = U00*I0[117] + U40*I1[117]
           + (sixo2z)*(I2[117] - (lpoz)*I3[117])
           + (fouro2zn)*I4[89];
*(vp++) = U00*I0[118] + U40*I1[118]
           + (sixo2z)*(I2[118] - (lpoz)*I3[118])
           + (threeo2zn)*I4[90];
*(vp++) = U00*I0[119] + U40*I1[119]
           + (sixo2z)*(I2[119] - (lpoz)*I3[119])
           + (threeo2zn)*I4[91];
*(vp++) = U00*I0[120] + U40*I1[120]
           + (sixo2z)*(I2[120] - (lpoz)*I3[120])
           + (threeo2zn)*I4[92];
*(vp++) = U00*I0[121] + U40*I1[121]
           + (sixo2z)*(I2[121] - (lpoz)*I3[121])
           + (threeo2zn)*I4[93];
*(vp++) = U00*I0[122] + U40*I1[122]
           + (sixo2z)*(I2[122] - (lpoz)*I3[122])
           + (twoo2zn)*I4[94];
*(vp++) = U00*I0[123] + U40*I1[123]
           + (sixo2z)*(I2[123] - (lpoz)*I3[123])
           + (twoo2zn)*I4[95];
*(vp++) = U00*I0[124] + U40*I1[124]
           + (sixo2z)*(I2[124] - (lpoz)*I3[124])
           + (twoo2zn)*I4[96];
*(vp++) = U00*I0[125] + U40*I1[125]
           + (sixo2z)*(I2[125] - (lpoz)*I3[125])
           + (twoo2zn)*I4[97];
*(vp++) = U00*I0[126] + U40*I1[126]
           + (sixo2z)*(I2[126] - (lpoz)*I3[126])
           + (twoo2zn)*I4[98];
*(vp++) = U00*I0[127] + U40*I1[127]
           + (sixo2z)*(I2[127] - (lpoz)*I3[127])
           + (oneo2zn)*I4[99];
*(vp++) = U00*I0[128] + U40*I1[128]
           + (sixo2z)*(I2[128] - (lpoz)*I3[128])
           + (oneo2zn)*I4[100];
*(vp++) = U00*I0[129] + U40*I1[129]
           + (sixo2z)*(I2[129] - (lpoz)*I3[129])
           + (oneo2zn)*I4[101];
*(vp++) = U00*I0[130] + U40*I1[130]
           + (sixo2z)*(I2[130] - (lpoz)*I3[130])
           + (oneo2zn)*I4[102];
*(vp++) = U00*I0[131] + U40*I1[131]
           + (sixo2z)*(I2[131] - (lpoz)*I3[131])
           + (oneo2zn)*I4[103];
*(vp++) = U00*I0[132] + U40*I1[132]
           + (sixo2z)*(I2[132] - (lpoz)*I3[132])
           + (oneo2zn)*I4[104];
*(vp++) = U00*I0[133] + U40*I1[133]
           + (sixo2z)*(I2[133] - (lpoz)*I3[133]);
*(vp++) = U00*I0[134] + U40*I1[134]
           + (sixo2z)*(I2[134] - (lpoz)*I3[134]);
*(vp++) = U00*I0[135] + U40*I1[135]
           + (sixo2z)*(I2[135] - (lpoz)*I3[135]);
*(vp++) = U00*I0[136] + U40*I1[136]
           + (sixo2z)*(I2[136] - (lpoz)*I3[136]);
*(vp++) = U00*I0[137] + U40*I1[137]
           + (sixo2z)*(I2[137] - (lpoz)*I3[137]);
*(vp++) = U00*I0[138] + U40*I1[138]
           + (sixo2z)*(I2[138] - (lpoz)*I3[138]);
*(vp++) = U00*I0[139] + U40*I1[139]
           + (sixo2z)*(I2[139] - (lpoz)*I3[139]);
*(vp++) = U00*I0[140] + U40*I1[140]
           + (sixo2z)*(I2[140] - (lpoz)*I3[140])
           + (sixo2zn)*I4[105];
*(vp++) = U00*I0[141] + U40*I1[141]
           + (sixo2z)*(I2[141] - (lpoz)*I3[141])
           + (fiveo2zn)*I4[106];
*(vp++) = U00*I0[142] + U40*I1[142]
           + (sixo2z)*(I2[142] - (lpoz)*I3[142])
           + (fiveo2zn)*I4[107];
*(vp++) = U00*I0[143] + U40*I1[143]
           + (sixo2z)*(I2[143] - (lpoz)*I3[143])
           + (fouro2zn)*I4[108];
*(vp++) = U00*I0[144] + U40*I1[144]
           + (sixo2z)*(I2[144] - (lpoz)*I3[144])
           + (fouro2zn)*I4[109];
*(vp++) = U00*I0[145] + U40*I1[145]
           + (sixo2z)*(I2[145] - (lpoz)*I3[145])
           + (fouro2zn)*I4[110];
*(vp++) = U00*I0[146] + U40*I1[146]
           + (sixo2z)*(I2[146] - (lpoz)*I3[146])
           + (threeo2zn)*I4[111];
*(vp++) = U00*I0[147] + U40*I1[147]
           + (sixo2z)*(I2[147] - (lpoz)*I3[147])
           + (threeo2zn)*I4[112];
*(vp++) = U00*I0[148] + U40*I1[148]
           + (sixo2z)*(I2[148] - (lpoz)*I3[148])
           + (threeo2zn)*I4[113];
*(vp++) = U00*I0[149] + U40*I1[149]
           + (sixo2z)*(I2[149] - (lpoz)*I3[149])
           + (threeo2zn)*I4[114];
*(vp++) = U00*I0[150] + U40*I1[150]
           + (sixo2z)*(I2[150] - (lpoz)*I3[150])
           + (twoo2zn)*I4[115];
*(vp++) = U00*I0[151] + U40*I1[151]
           + (sixo2z)*(I2[151] - (lpoz)*I3[151])
           + (twoo2zn)*I4[116];
*(vp++) = U00*I0[152] + U40*I1[152]
           + (sixo2z)*(I2[152] - (lpoz)*I3[152])
           + (twoo2zn)*I4[117];
*(vp++) = U00*I0[153] + U40*I1[153]
           + (sixo2z)*(I2[153] - (lpoz)*I3[153])
           + (twoo2zn)*I4[118];
*(vp++) = U00*I0[154] + U40*I1[154]
           + (sixo2z)*(I2[154] - (lpoz)*I3[154])
           + (twoo2zn)*I4[119];
*(vp++) = U00*I0[155] + U40*I1[155]
           + (sixo2z)*(I2[155] - (lpoz)*I3[155])
           + (oneo2zn)*I4[120];
*(vp++) = U00*I0[156] + U40*I1[156]
           + (sixo2z)*(I2[156] - (lpoz)*I3[156])
           + (oneo2zn)*I4[121];
*(vp++) = U00*I0[157] + U40*I1[157]
           + (sixo2z)*(I2[157] - (lpoz)*I3[157])
           + (oneo2zn)*I4[122];
*(vp++) = U00*I0[158] + U40*I1[158]
           + (sixo2z)*(I2[158] - (lpoz)*I3[158])
           + (oneo2zn)*I4[123];
*(vp++) = U00*I0[159] + U40*I1[159]
           + (sixo2z)*(I2[159] - (lpoz)*I3[159])
           + (oneo2zn)*I4[124];
*(vp++) = U00*I0[160] + U40*I1[160]
           + (sixo2z)*(I2[160] - (lpoz)*I3[160])
           + (oneo2zn)*I4[125];
*(vp++) = U00*I0[161] + U40*I1[161]
           + (sixo2z)*(I2[161] - (lpoz)*I3[161]);
*(vp++) = U00*I0[162] + U40*I1[162]
           + (sixo2z)*(I2[162] - (lpoz)*I3[162]);
*(vp++) = U00*I0[163] + U40*I1[163]
           + (sixo2z)*(I2[163] - (lpoz)*I3[163]);
*(vp++) = U00*I0[164] + U40*I1[164]
           + (sixo2z)*(I2[164] - (lpoz)*I3[164]);
*(vp++) = U00*I0[165] + U40*I1[165]
           + (sixo2z)*(I2[165] - (lpoz)*I3[165]);
*(vp++) = U00*I0[166] + U40*I1[166]
           + (sixo2z)*(I2[166] - (lpoz)*I3[166]);
*(vp++) = U00*I0[167] + U40*I1[167]
           + (sixo2z)*(I2[167] - (lpoz)*I3[167]);
*(vp++) = U00*I0[168] + U40*I1[168]
           + (fiveo2z)*(I2[168] - (lpoz)*I3[168])
           + (sixo2zn)*I4[126];
*(vp++) = U00*I0[169] + U40*I1[169]
           + (fiveo2z)*(I2[169] - (lpoz)*I3[169])
           + (fiveo2zn)*I4[127];
*(vp++) = U00*I0[170] + U40*I1[170]
           + (fiveo2z)*(I2[170] - (lpoz)*I3[170])
           + (fiveo2zn)*I4[128];
*(vp++) = U00*I0[171] + U40*I1[171]
           + (fiveo2z)*(I2[171] - (lpoz)*I3[171])
           + (fouro2zn)*I4[129];
*(vp++) = U00*I0[172] + U40*I1[172]
           + (fiveo2z)*(I2[172] - (lpoz)*I3[172])
           + (fouro2zn)*I4[130];
*(vp++) = U00*I0[173] + U40*I1[173]
           + (fiveo2z)*(I2[173] - (lpoz)*I3[173])
           + (fouro2zn)*I4[131];
*(vp++) = U00*I0[174] + U40*I1[174]
           + (fiveo2z)*(I2[174] - (lpoz)*I3[174])
           + (threeo2zn)*I4[132];
*(vp++) = U00*I0[175] + U40*I1[175]
           + (fiveo2z)*(I2[175] - (lpoz)*I3[175])
           + (threeo2zn)*I4[133];
*(vp++) = U00*I0[176] + U40*I1[176]
           + (fiveo2z)*(I2[176] - (lpoz)*I3[176])
           + (threeo2zn)*I4[134];
*(vp++) = U00*I0[177] + U40*I1[177]
           + (fiveo2z)*(I2[177] - (lpoz)*I3[177])
           + (threeo2zn)*I4[135];
*(vp++) = U00*I0[178] + U40*I1[178]
           + (fiveo2z)*(I2[178] - (lpoz)*I3[178])
           + (twoo2zn)*I4[136];
*(vp++) = U00*I0[179] + U40*I1[179]
           + (fiveo2z)*(I2[179] - (lpoz)*I3[179])
           + (twoo2zn)*I4[137];
*(vp++) = U00*I0[180] + U40*I1[180]
           + (fiveo2z)*(I2[180] - (lpoz)*I3[180])
           + (twoo2zn)*I4[138];
*(vp++) = U00*I0[181] + U40*I1[181]
           + (fiveo2z)*(I2[181] - (lpoz)*I3[181])
           + (twoo2zn)*I4[139];
*(vp++) = U00*I0[182] + U40*I1[182]
           + (fiveo2z)*(I2[182] - (lpoz)*I3[182])
           + (twoo2zn)*I4[140];
*(vp++) = U00*I0[183] + U40*I1[183]
           + (fiveo2z)*(I2[183] - (lpoz)*I3[183])
           + (oneo2zn)*I4[141];
*(vp++) = U00*I0[184] + U40*I1[184]
           + (fiveo2z)*(I2[184] - (lpoz)*I3[184])
           + (oneo2zn)*I4[142];
*(vp++) = U00*I0[185] + U40*I1[185]
           + (fiveo2z)*(I2[185] - (lpoz)*I3[185])
           + (oneo2zn)*I4[143];
*(vp++) = U00*I0[186] + U40*I1[186]
           + (fiveo2z)*(I2[186] - (lpoz)*I3[186])
           + (oneo2zn)*I4[144];
*(vp++) = U00*I0[187] + U40*I1[187]
           + (fiveo2z)*(I2[187] - (lpoz)*I3[187])
           + (oneo2zn)*I4[145];
*(vp++) = U00*I0[188] + U40*I1[188]
           + (fiveo2z)*(I2[188] - (lpoz)*I3[188])
           + (oneo2zn)*I4[146];
*(vp++) = U00*I0[189] + U40*I1[189]
           + (fiveo2z)*(I2[189] - (lpoz)*I3[189]);
*(vp++) = U00*I0[190] + U40*I1[190]
           + (fiveo2z)*(I2[190] - (lpoz)*I3[190]);
*(vp++) = U00*I0[191] + U40*I1[191]
           + (fiveo2z)*(I2[191] - (lpoz)*I3[191]);
*(vp++) = U00*I0[192] + U40*I1[192]
           + (fiveo2z)*(I2[192] - (lpoz)*I3[192]);
*(vp++) = U00*I0[193] + U40*I1[193]
           + (fiveo2z)*(I2[193] - (lpoz)*I3[193]);
*(vp++) = U00*I0[194] + U40*I1[194]
           + (fiveo2z)*(I2[194] - (lpoz)*I3[194]);
*(vp++) = U00*I0[195] + U40*I1[195]
           + (fiveo2z)*(I2[195] - (lpoz)*I3[195]);
*(vp++) = U00*I0[196] + U40*I1[196]
           + (fiveo2z)*(I2[196] - (lpoz)*I3[196])
           + (sixo2zn)*I4[147];
*(vp++) = U00*I0[197] + U40*I1[197]
           + (fiveo2z)*(I2[197] - (lpoz)*I3[197])
           + (fiveo2zn)*I4[148];
*(vp++) = U00*I0[198] + U40*I1[198]
           + (fiveo2z)*(I2[198] - (lpoz)*I3[198])
           + (fiveo2zn)*I4[149];
*(vp++) = U00*I0[199] + U40*I1[199]
           + (fiveo2z)*(I2[199] - (lpoz)*I3[199])
           + (fouro2zn)*I4[150];
*(vp++) = U00*I0[200] + U40*I1[200]
           + (fiveo2z)*(I2[200] - (lpoz)*I3[200])
           + (fouro2zn)*I4[151];
*(vp++) = U00*I0[201] + U40*I1[201]
           + (fiveo2z)*(I2[201] - (lpoz)*I3[201])
           + (fouro2zn)*I4[152];
*(vp++) = U00*I0[202] + U40*I1[202]
           + (fiveo2z)*(I2[202] - (lpoz)*I3[202])
           + (threeo2zn)*I4[153];
*(vp++) = U00*I0[203] + U40*I1[203]
           + (fiveo2z)*(I2[203] - (lpoz)*I3[203])
           + (threeo2zn)*I4[154];
*(vp++) = U00*I0[204] + U40*I1[204]
           + (fiveo2z)*(I2[204] - (lpoz)*I3[204])
           + (threeo2zn)*I4[155];
*(vp++) = U00*I0[205] + U40*I1[205]
           + (fiveo2z)*(I2[205] - (lpoz)*I3[205])
           + (threeo2zn)*I4[156];
*(vp++) = U00*I0[206] + U40*I1[206]
           + (fiveo2z)*(I2[206] - (lpoz)*I3[206])
           + (twoo2zn)*I4[157];
*(vp++) = U00*I0[207] + U40*I1[207]
           + (fiveo2z)*(I2[207] - (lpoz)*I3[207])
           + (twoo2zn)*I4[158];
*(vp++) = U00*I0[208] + U40*I1[208]
           + (fiveo2z)*(I2[208] - (lpoz)*I3[208])
           + (twoo2zn)*I4[159];
*(vp++) = U00*I0[209] + U40*I1[209]
           + (fiveo2z)*(I2[209] - (lpoz)*I3[209])
           + (twoo2zn)*I4[160];
*(vp++) = U00*I0[210] + U40*I1[210]
           + (fiveo2z)*(I2[210] - (lpoz)*I3[210])
           + (twoo2zn)*I4[161];
*(vp++) = U00*I0[211] + U40*I1[211]
           + (fiveo2z)*(I2[211] - (lpoz)*I3[211])
           + (oneo2zn)*I4[162];
*(vp++) = U00*I0[212] + U40*I1[212]
           + (fiveo2z)*(I2[212] - (lpoz)*I3[212])
           + (oneo2zn)*I4[163];
*(vp++) = U00*I0[213] + U40*I1[213]
           + (fiveo2z)*(I2[213] - (lpoz)*I3[213])
           + (oneo2zn)*I4[164];
*(vp++) = U00*I0[214] + U40*I1[214]
           + (fiveo2z)*(I2[214] - (lpoz)*I3[214])
           + (oneo2zn)*I4[165];
*(vp++) = U00*I0[215] + U40*I1[215]
           + (fiveo2z)*(I2[215] - (lpoz)*I3[215])
           + (oneo2zn)*I4[166];
*(vp++) = U00*I0[216] + U40*I1[216]
           + (fiveo2z)*(I2[216] - (lpoz)*I3[216])
           + (oneo2zn)*I4[167];
*(vp++) = U00*I0[217] + U40*I1[217]
           + (fiveo2z)*(I2[217] - (lpoz)*I3[217]);
*(vp++) = U00*I0[218] + U40*I1[218]
           + (fiveo2z)*(I2[218] - (lpoz)*I3[218]);
*(vp++) = U00*I0[219] + U40*I1[219]
           + (fiveo2z)*(I2[219] - (lpoz)*I3[219]);
*(vp++) = U00*I0[220] + U40*I1[220]
           + (fiveo2z)*(I2[220] - (lpoz)*I3[220]);
*(vp++) = U00*I0[221] + U40*I1[221]
           + (fiveo2z)*(I2[221] - (lpoz)*I3[221]);
*(vp++) = U00*I0[222] + U40*I1[222]
           + (fiveo2z)*(I2[222] - (lpoz)*I3[222]);
*(vp++) = U00*I0[223] + U40*I1[223]
           + (fiveo2z)*(I2[223] - (lpoz)*I3[223]);
*(vp++) = U00*I0[224] + U40*I1[224]
           + (fiveo2z)*(I2[224] - (lpoz)*I3[224])
           + (sixo2zn)*I4[168];
*(vp++) = U00*I0[225] + U40*I1[225]
           + (fiveo2z)*(I2[225] - (lpoz)*I3[225])
           + (fiveo2zn)*I4[169];
*(vp++) = U00*I0[226] + U40*I1[226]
           + (fiveo2z)*(I2[226] - (lpoz)*I3[226])
           + (fiveo2zn)*I4[170];
*(vp++) = U00*I0[227] + U40*I1[227]
           + (fiveo2z)*(I2[227] - (lpoz)*I3[227])
           + (fouro2zn)*I4[171];
*(vp++) = U00*I0[228] + U40*I1[228]
           + (fiveo2z)*(I2[228] - (lpoz)*I3[228])
           + (fouro2zn)*I4[172];
*(vp++) = U00*I0[229] + U40*I1[229]
           + (fiveo2z)*(I2[229] - (lpoz)*I3[229])
           + (fouro2zn)*I4[173];
*(vp++) = U00*I0[230] + U40*I1[230]
           + (fiveo2z)*(I2[230] - (lpoz)*I3[230])
           + (threeo2zn)*I4[174];
*(vp++) = U00*I0[231] + U40*I1[231]
           + (fiveo2z)*(I2[231] - (lpoz)*I3[231])
           + (threeo2zn)*I4[175];
*(vp++) = U00*I0[232] + U40*I1[232]
           + (fiveo2z)*(I2[232] - (lpoz)*I3[232])
           + (threeo2zn)*I4[176];
*(vp++) = U00*I0[233] + U40*I1[233]
           + (fiveo2z)*(I2[233] - (lpoz)*I3[233])
           + (threeo2zn)*I4[177];
*(vp++) = U00*I0[234] + U40*I1[234]
           + (fiveo2z)*(I2[234] - (lpoz)*I3[234])
           + (twoo2zn)*I4[178];
*(vp++) = U00*I0[235] + U40*I1[235]
           + (fiveo2z)*(I2[235] - (lpoz)*I3[235])
           + (twoo2zn)*I4[179];
*(vp++) = U00*I0[236] + U40*I1[236]
           + (fiveo2z)*(I2[236] - (lpoz)*I3[236])
           + (twoo2zn)*I4[180];
*(vp++) = U00*I0[237] + U40*I1[237]
           + (fiveo2z)*(I2[237] - (lpoz)*I3[237])
           + (twoo2zn)*I4[181];
*(vp++) = U00*I0[238] + U40*I1[238]
           + (fiveo2z)*(I2[238] - (lpoz)*I3[238])
           + (twoo2zn)*I4[182];
*(vp++) = U00*I0[239] + U40*I1[239]
           + (fiveo2z)*(I2[239] - (lpoz)*I3[239])
           + (oneo2zn)*I4[183];
*(vp++) = U00*I0[240] + U40*I1[240]
           + (fiveo2z)*(I2[240] - (lpoz)*I3[240])
           + (oneo2zn)*I4[184];
*(vp++) = U00*I0[241] + U40*I1[241]
           + (fiveo2z)*(I2[241] - (lpoz)*I3[241])
           + (oneo2zn)*I4[185];
*(vp++) = U00*I0[242] + U40*I1[242]
           + (fiveo2z)*(I2[242] - (lpoz)*I3[242])
           + (oneo2zn)*I4[186];
*(vp++) = U00*I0[243] + U40*I1[243]
           + (fiveo2z)*(I2[243] - (lpoz)*I3[243])
           + (oneo2zn)*I4[187];
*(vp++) = U00*I0[244] + U40*I1[244]
           + (fiveo2z)*(I2[244] - (lpoz)*I3[244])
           + (oneo2zn)*I4[188];
*(vp++) = U00*I0[245] + U40*I1[245]
           + (fiveo2z)*(I2[245] - (lpoz)*I3[245]);
*(vp++) = U00*I0[246] + U40*I1[246]
           + (fiveo2z)*(I2[246] - (lpoz)*I3[246]);
*(vp++) = U00*I0[247] + U40*I1[247]
           + (fiveo2z)*(I2[247] - (lpoz)*I3[247]);
*(vp++) = U00*I0[248] + U40*I1[248]
           + (fiveo2z)*(I2[248] - (lpoz)*I3[248]);
*(vp++) = U00*I0[249] + U40*I1[249]
           + (fiveo2z)*(I2[249] - (lpoz)*I3[249]);
*(vp++) = U00*I0[250] + U40*I1[250]
           + (fiveo2z)*(I2[250] - (lpoz)*I3[250]);
*(vp++) = U00*I0[251] + U40*I1[251]
           + (fiveo2z)*(I2[251] - (lpoz)*I3[251]);
*(vp++) = U00*I0[252] + U40*I1[252]
           + (fiveo2z)*(I2[252] - (lpoz)*I3[252])
           + (sixo2zn)*I4[189];
*(vp++) = U00*I0[253] + U40*I1[253]
           + (fiveo2z)*(I2[253] - (lpoz)*I3[253])
           + (fiveo2zn)*I4[190];
*(vp++) = U00*I0[254] + U40*I1[254]
           + (fiveo2z)*(I2[254] - (lpoz)*I3[254])
           + (fiveo2zn)*I4[191];
*(vp++) = U00*I0[255] + U40*I1[255]
           + (fiveo2z)*(I2[255] - (lpoz)*I3[255])
           + (fouro2zn)*I4[192];
*(vp++) = U00*I0[256] + U40*I1[256]
           + (fiveo2z)*(I2[256] - (lpoz)*I3[256])
           + (fouro2zn)*I4[193];
return vp;
}

REALTYPE *_build_m0i0_1(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2zn;
  REALTYPE twoo2zn;
  REALTYPE threeo2zn;
  REALTYPE fouro2zn;
  REALTYPE fiveo2zn;
  REALTYPE sixo2zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  REALTYPE seveno2z;
  REALTYPE eighto2z;
  oneo2zn = 1.0*Data->oo2zn;
  twoo2zn = 2.0*Data->oo2zn;
  threeo2zn = 3.0*Data->oo2zn;
  fouro2zn = 4.0*Data->oo2zn;
  fiveo2zn = 5.0*Data->oo2zn;
  sixo2zn = 6.0*Data->oo2zn;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  seveno2z = 7.0*Data->oo2z;
  eighto2z = 8.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U40 = Data->U[4][0];
  U41 = Data->U[4][1];
  U42 = Data->U[4][2];


*(vp++) = U00*I0[257] + U40*I1[257]
           + (fiveo2z)*(I2[257] - (lpoz)*I3[257])
           + (fouro2zn)*I4[194];
*(vp++) = U00*I0[258] + U40*I1[258]
           + (fiveo2z)*(I2[258] - (lpoz)*I3[258])
           + (threeo2zn)*I4[195];
*(vp++) = U00*I0[259] + U40*I1[259]
           + (fiveo2z)*(I2[259] - (lpoz)*I3[259])
           + (threeo2zn)*I4[196];
*(vp++) = U00*I0[260] + U40*I1[260]
           + (fiveo2z)*(I2[260] - (lpoz)*I3[260])
           + (threeo2zn)*I4[197];
*(vp++) = U00*I0[261] + U40*I1[261]
           + (fiveo2z)*(I2[261] - (lpoz)*I3[261])
           + (threeo2zn)*I4[198];
*(vp++) = U00*I0[262] + U40*I1[262]
           + (fiveo2z)*(I2[262] - (lpoz)*I3[262])
           + (twoo2zn)*I4[199];
*(vp++) = U00*I0[263] + U40*I1[263]
           + (fiveo2z)*(I2[263] - (lpoz)*I3[263])
           + (twoo2zn)*I4[200];
*(vp++) = U00*I0[264] + U40*I1[264]
           + (fiveo2z)*(I2[264] - (lpoz)*I3[264])
           + (twoo2zn)*I4[201];
*(vp++) = U00*I0[265] + U40*I1[265]
           + (fiveo2z)*(I2[265] - (lpoz)*I3[265])
           + (twoo2zn)*I4[202];
*(vp++) = U00*I0[266] + U40*I1[266]
           + (fiveo2z)*(I2[266] - (lpoz)*I3[266])
           + (twoo2zn)*I4[203];
*(vp++) = U00*I0[267] + U40*I1[267]
           + (fiveo2z)*(I2[267] - (lpoz)*I3[267])
           + (oneo2zn)*I4[204];
*(vp++) = U00*I0[268] + U40*I1[268]
           + (fiveo2z)*(I2[268] - (lpoz)*I3[268])
           + (oneo2zn)*I4[205];
*(vp++) = U00*I0[269] + U40*I1[269]
           + (fiveo2z)*(I2[269] - (lpoz)*I3[269])
           + (oneo2zn)*I4[206];
*(vp++) = U00*I0[270] + U40*I1[270]
           + (fiveo2z)*(I2[270] - (lpoz)*I3[270])
           + (oneo2zn)*I4[207];
*(vp++) = U00*I0[271] + U40*I1[271]
           + (fiveo2z)*(I2[271] - (lpoz)*I3[271])
           + (oneo2zn)*I4[208];
*(vp++) = U00*I0[272] + U40*I1[272]
           + (fiveo2z)*(I2[272] - (lpoz)*I3[272])
           + (oneo2zn)*I4[209];
*(vp++) = U00*I0[273] + U40*I1[273]
           + (fiveo2z)*(I2[273] - (lpoz)*I3[273]);
*(vp++) = U00*I0[274] + U40*I1[274]
           + (fiveo2z)*(I2[274] - (lpoz)*I3[274]);
*(vp++) = U00*I0[275] + U40*I1[275]
           + (fiveo2z)*(I2[275] - (lpoz)*I3[275]);
*(vp++) = U00*I0[276] + U40*I1[276]
           + (fiveo2z)*(I2[276] - (lpoz)*I3[276]);
*(vp++) = U00*I0[277] + U40*I1[277]
           + (fiveo2z)*(I2[277] - (lpoz)*I3[277]);
*(vp++) = U00*I0[278] + U40*I1[278]
           + (fiveo2z)*(I2[278] - (lpoz)*I3[278]);
*(vp++) = U00*I0[279] + U40*I1[279]
           + (fiveo2z)*(I2[279] - (lpoz)*I3[279]);
*(vp++) = U00*I0[280] + U40*I1[280]
           + (fouro2z)*(I2[280] - (lpoz)*I3[280])
           + (sixo2zn)*I4[210];
*(vp++) = U00*I0[281] + U40*I1[281]
           + (fouro2z)*(I2[281] - (lpoz)*I3[281])
           + (fiveo2zn)*I4[211];
*(vp++) = U00*I0[282] + U40*I1[282]
           + (fouro2z)*(I2[282] - (lpoz)*I3[282])
           + (fiveo2zn)*I4[212];
*(vp++) = U00*I0[283] + U40*I1[283]
           + (fouro2z)*(I2[283] - (lpoz)*I3[283])
           + (fouro2zn)*I4[213];
*(vp++) = U00*I0[284] + U40*I1[284]
           + (fouro2z)*(I2[284] - (lpoz)*I3[284])
           + (fouro2zn)*I4[214];
*(vp++) = U00*I0[285] + U40*I1[285]
           + (fouro2z)*(I2[285] - (lpoz)*I3[285])
           + (fouro2zn)*I4[215];
*(vp++) = U00*I0[286] + U40*I1[286]
           + (fouro2z)*(I2[286] - (lpoz)*I3[286])
           + (threeo2zn)*I4[216];
*(vp++) = U00*I0[287] + U40*I1[287]
           + (fouro2z)*(I2[287] - (lpoz)*I3[287])
           + (threeo2zn)*I4[217];
*(vp++) = U00*I0[288] + U40*I1[288]
           + (fouro2z)*(I2[288] - (lpoz)*I3[288])
           + (threeo2zn)*I4[218];
*(vp++) = U00*I0[289] + U40*I1[289]
           + (fouro2z)*(I2[289] - (lpoz)*I3[289])
           + (threeo2zn)*I4[219];
*(vp++) = U00*I0[290] + U40*I1[290]
           + (fouro2z)*(I2[290] - (lpoz)*I3[290])
           + (twoo2zn)*I4[220];
*(vp++) = U00*I0[291] + U40*I1[291]
           + (fouro2z)*(I2[291] - (lpoz)*I3[291])
           + (twoo2zn)*I4[221];
*(vp++) = U00*I0[292] + U40*I1[292]
           + (fouro2z)*(I2[292] - (lpoz)*I3[292])
           + (twoo2zn)*I4[222];
*(vp++) = U00*I0[293] + U40*I1[293]
           + (fouro2z)*(I2[293] - (lpoz)*I3[293])
           + (twoo2zn)*I4[223];
*(vp++) = U00*I0[294] + U40*I1[294]
           + (fouro2z)*(I2[294] - (lpoz)*I3[294])
           + (twoo2zn)*I4[224];
*(vp++) = U00*I0[295] + U40*I1[295]
           + (fouro2z)*(I2[295] - (lpoz)*I3[295])
           + (oneo2zn)*I4[225];
*(vp++) = U00*I0[296] + U40*I1[296]
           + (fouro2z)*(I2[296] - (lpoz)*I3[296])
           + (oneo2zn)*I4[226];
*(vp++) = U00*I0[297] + U40*I1[297]
           + (fouro2z)*(I2[297] - (lpoz)*I3[297])
           + (oneo2zn)*I4[227];
*(vp++) = U00*I0[298] + U40*I1[298]
           + (fouro2z)*(I2[298] - (lpoz)*I3[298])
           + (oneo2zn)*I4[228];
*(vp++) = U00*I0[299] + U40*I1[299]
           + (fouro2z)*(I2[299] - (lpoz)*I3[299])
           + (oneo2zn)*I4[229];
*(vp++) = U00*I0[300] + U40*I1[300]
           + (fouro2z)*(I2[300] - (lpoz)*I3[300])
           + (oneo2zn)*I4[230];
*(vp++) = U00*I0[301] + U40*I1[301]
           + (fouro2z)*(I2[301] - (lpoz)*I3[301]);
*(vp++) = U00*I0[302] + U40*I1[302]
           + (fouro2z)*(I2[302] - (lpoz)*I3[302]);
*(vp++) = U00*I0[303] + U40*I1[303]
           + (fouro2z)*(I2[303] - (lpoz)*I3[303]);
*(vp++) = U00*I0[304] + U40*I1[304]
           + (fouro2z)*(I2[304] - (lpoz)*I3[304]);
*(vp++) = U00*I0[305] + U40*I1[305]
           + (fouro2z)*(I2[305] - (lpoz)*I3[305]);
*(vp++) = U00*I0[306] + U40*I1[306]
           + (fouro2z)*(I2[306] - (lpoz)*I3[306]);
*(vp++) = U00*I0[307] + U40*I1[307]
           + (fouro2z)*(I2[307] - (lpoz)*I3[307]);
*(vp++) = U00*I0[308] + U40*I1[308]
           + (fouro2z)*(I2[308] - (lpoz)*I3[308])
           + (sixo2zn)*I4[231];
*(vp++) = U00*I0[309] + U40*I1[309]
           + (fouro2z)*(I2[309] - (lpoz)*I3[309])
           + (fiveo2zn)*I4[232];
*(vp++) = U00*I0[310] + U40*I1[310]
           + (fouro2z)*(I2[310] - (lpoz)*I3[310])
           + (fiveo2zn)*I4[233];
*(vp++) = U00*I0[311] + U40*I1[311]
           + (fouro2z)*(I2[311] - (lpoz)*I3[311])
           + (fouro2zn)*I4[234];
*(vp++) = U00*I0[312] + U40*I1[312]
           + (fouro2z)*(I2[312] - (lpoz)*I3[312])
           + (fouro2zn)*I4[235];
*(vp++) = U00*I0[313] + U40*I1[313]
           + (fouro2z)*(I2[313] - (lpoz)*I3[313])
           + (fouro2zn)*I4[236];
*(vp++) = U00*I0[314] + U40*I1[314]
           + (fouro2z)*(I2[314] - (lpoz)*I3[314])
           + (threeo2zn)*I4[237];
*(vp++) = U00*I0[315] + U40*I1[315]
           + (fouro2z)*(I2[315] - (lpoz)*I3[315])
           + (threeo2zn)*I4[238];
*(vp++) = U00*I0[316] + U40*I1[316]
           + (fouro2z)*(I2[316] - (lpoz)*I3[316])
           + (threeo2zn)*I4[239];
*(vp++) = U00*I0[317] + U40*I1[317]
           + (fouro2z)*(I2[317] - (lpoz)*I3[317])
           + (threeo2zn)*I4[240];
*(vp++) = U00*I0[318] + U40*I1[318]
           + (fouro2z)*(I2[318] - (lpoz)*I3[318])
           + (twoo2zn)*I4[241];
*(vp++) = U00*I0[319] + U40*I1[319]
           + (fouro2z)*(I2[319] - (lpoz)*I3[319])
           + (twoo2zn)*I4[242];
*(vp++) = U00*I0[320] + U40*I1[320]
           + (fouro2z)*(I2[320] - (lpoz)*I3[320])
           + (twoo2zn)*I4[243];
*(vp++) = U00*I0[321] + U40*I1[321]
           + (fouro2z)*(I2[321] - (lpoz)*I3[321])
           + (twoo2zn)*I4[244];
*(vp++) = U00*I0[322] + U40*I1[322]
           + (fouro2z)*(I2[322] - (lpoz)*I3[322])
           + (twoo2zn)*I4[245];
*(vp++) = U00*I0[323] + U40*I1[323]
           + (fouro2z)*(I2[323] - (lpoz)*I3[323])
           + (oneo2zn)*I4[246];
*(vp++) = U00*I0[324] + U40*I1[324]
           + (fouro2z)*(I2[324] - (lpoz)*I3[324])
           + (oneo2zn)*I4[247];
*(vp++) = U00*I0[325] + U40*I1[325]
           + (fouro2z)*(I2[325] - (lpoz)*I3[325])
           + (oneo2zn)*I4[248];
*(vp++) = U00*I0[326] + U40*I1[326]
           + (fouro2z)*(I2[326] - (lpoz)*I3[326])
           + (oneo2zn)*I4[249];
*(vp++) = U00*I0[327] + U40*I1[327]
           + (fouro2z)*(I2[327] - (lpoz)*I3[327])
           + (oneo2zn)*I4[250];
*(vp++) = U00*I0[328] + U40*I1[328]
           + (fouro2z)*(I2[328] - (lpoz)*I3[328])
           + (oneo2zn)*I4[251];
*(vp++) = U00*I0[329] + U40*I1[329]
           + (fouro2z)*(I2[329] - (lpoz)*I3[329]);
*(vp++) = U00*I0[330] + U40*I1[330]
           + (fouro2z)*(I2[330] - (lpoz)*I3[330]);
*(vp++) = U00*I0[331] + U40*I1[331]
           + (fouro2z)*(I2[331] - (lpoz)*I3[331]);
*(vp++) = U00*I0[332] + U40*I1[332]
           + (fouro2z)*(I2[332] - (lpoz)*I3[332]);
*(vp++) = U00*I0[333] + U40*I1[333]
           + (fouro2z)*(I2[333] - (lpoz)*I3[333]);
*(vp++) = U00*I0[334] + U40*I1[334]
           + (fouro2z)*(I2[334] - (lpoz)*I3[334]);
*(vp++) = U00*I0[335] + U40*I1[335]
           + (fouro2z)*(I2[335] - (lpoz)*I3[335]);
*(vp++) = U00*I0[336] + U40*I1[336]
           + (fouro2z)*(I2[336] - (lpoz)*I3[336])
           + (sixo2zn)*I4[252];
*(vp++) = U00*I0[337] + U40*I1[337]
           + (fouro2z)*(I2[337] - (lpoz)*I3[337])
           + (fiveo2zn)*I4[253];
*(vp++) = U00*I0[338] + U40*I1[338]
           + (fouro2z)*(I2[338] - (lpoz)*I3[338])
           + (fiveo2zn)*I4[254];
*(vp++) = U00*I0[339] + U40*I1[339]
           + (fouro2z)*(I2[339] - (lpoz)*I3[339])
           + (fouro2zn)*I4[255];
*(vp++) = U00*I0[340] + U40*I1[340]
           + (fouro2z)*(I2[340] - (lpoz)*I3[340])
           + (fouro2zn)*I4[256];
*(vp++) = U00*I0[341] + U40*I1[341]
           + (fouro2z)*(I2[341] - (lpoz)*I3[341])
           + (fouro2zn)*I4[257];
*(vp++) = U00*I0[342] + U40*I1[342]
           + (fouro2z)*(I2[342] - (lpoz)*I3[342])
           + (threeo2zn)*I4[258];
*(vp++) = U00*I0[343] + U40*I1[343]
           + (fouro2z)*(I2[343] - (lpoz)*I3[343])
           + (threeo2zn)*I4[259];
*(vp++) = U00*I0[344] + U40*I1[344]
           + (fouro2z)*(I2[344] - (lpoz)*I3[344])
           + (threeo2zn)*I4[260];
*(vp++) = U00*I0[345] + U40*I1[345]
           + (fouro2z)*(I2[345] - (lpoz)*I3[345])
           + (threeo2zn)*I4[261];
*(vp++) = U00*I0[346] + U40*I1[346]
           + (fouro2z)*(I2[346] - (lpoz)*I3[346])
           + (twoo2zn)*I4[262];
*(vp++) = U00*I0[347] + U40*I1[347]
           + (fouro2z)*(I2[347] - (lpoz)*I3[347])
           + (twoo2zn)*I4[263];
*(vp++) = U00*I0[348] + U40*I1[348]
           + (fouro2z)*(I2[348] - (lpoz)*I3[348])
           + (twoo2zn)*I4[264];
*(vp++) = U00*I0[349] + U40*I1[349]
           + (fouro2z)*(I2[349] - (lpoz)*I3[349])
           + (twoo2zn)*I4[265];
*(vp++) = U00*I0[350] + U40*I1[350]
           + (fouro2z)*(I2[350] - (lpoz)*I3[350])
           + (twoo2zn)*I4[266];
*(vp++) = U00*I0[351] + U40*I1[351]
           + (fouro2z)*(I2[351] - (lpoz)*I3[351])
           + (oneo2zn)*I4[267];
*(vp++) = U00*I0[352] + U40*I1[352]
           + (fouro2z)*(I2[352] - (lpoz)*I3[352])
           + (oneo2zn)*I4[268];
*(vp++) = U00*I0[353] + U40*I1[353]
           + (fouro2z)*(I2[353] - (lpoz)*I3[353])
           + (oneo2zn)*I4[269];
*(vp++) = U00*I0[354] + U40*I1[354]
           + (fouro2z)*(I2[354] - (lpoz)*I3[354])
           + (oneo2zn)*I4[270];
*(vp++) = U00*I0[355] + U40*I1[355]
           + (fouro2z)*(I2[355] - (lpoz)*I3[355])
           + (oneo2zn)*I4[271];
*(vp++) = U00*I0[356] + U40*I1[356]
           + (fouro2z)*(I2[356] - (lpoz)*I3[356])
           + (oneo2zn)*I4[272];
*(vp++) = U00*I0[357] + U40*I1[357]
           + (fouro2z)*(I2[357] - (lpoz)*I3[357]);
*(vp++) = U00*I0[358] + U40*I1[358]
           + (fouro2z)*(I2[358] - (lpoz)*I3[358]);
*(vp++) = U00*I0[359] + U40*I1[359]
           + (fouro2z)*(I2[359] - (lpoz)*I3[359]);
*(vp++) = U00*I0[360] + U40*I1[360]
           + (fouro2z)*(I2[360] - (lpoz)*I3[360]);
*(vp++) = U00*I0[361] + U40*I1[361]
           + (fouro2z)*(I2[361] - (lpoz)*I3[361]);
*(vp++) = U00*I0[362] + U40*I1[362]
           + (fouro2z)*(I2[362] - (lpoz)*I3[362]);
*(vp++) = U00*I0[363] + U40*I1[363]
           + (fouro2z)*(I2[363] - (lpoz)*I3[363]);
*(vp++) = U00*I0[364] + U40*I1[364]
           + (fouro2z)*(I2[364] - (lpoz)*I3[364])
           + (sixo2zn)*I4[273];
*(vp++) = U00*I0[365] + U40*I1[365]
           + (fouro2z)*(I2[365] - (lpoz)*I3[365])
           + (fiveo2zn)*I4[274];
*(vp++) = U00*I0[366] + U40*I1[366]
           + (fouro2z)*(I2[366] - (lpoz)*I3[366])
           + (fiveo2zn)*I4[275];
*(vp++) = U00*I0[367] + U40*I1[367]
           + (fouro2z)*(I2[367] - (lpoz)*I3[367])
           + (fouro2zn)*I4[276];
*(vp++) = U00*I0[368] + U40*I1[368]
           + (fouro2z)*(I2[368] - (lpoz)*I3[368])
           + (fouro2zn)*I4[277];
*(vp++) = U00*I0[369] + U40*I1[369]
           + (fouro2z)*(I2[369] - (lpoz)*I3[369])
           + (fouro2zn)*I4[278];
*(vp++) = U00*I0[370] + U40*I1[370]
           + (fouro2z)*(I2[370] - (lpoz)*I3[370])
           + (threeo2zn)*I4[279];
*(vp++) = U00*I0[371] + U40*I1[371]
           + (fouro2z)*(I2[371] - (lpoz)*I3[371])
           + (threeo2zn)*I4[280];
*(vp++) = U00*I0[372] + U40*I1[372]
           + (fouro2z)*(I2[372] - (lpoz)*I3[372])
           + (threeo2zn)*I4[281];
*(vp++) = U00*I0[373] + U40*I1[373]
           + (fouro2z)*(I2[373] - (lpoz)*I3[373])
           + (threeo2zn)*I4[282];
*(vp++) = U00*I0[374] + U40*I1[374]
           + (fouro2z)*(I2[374] - (lpoz)*I3[374])
           + (twoo2zn)*I4[283];
*(vp++) = U00*I0[375] + U40*I1[375]
           + (fouro2z)*(I2[375] - (lpoz)*I3[375])
           + (twoo2zn)*I4[284];
*(vp++) = U00*I0[376] + U40*I1[376]
           + (fouro2z)*(I2[376] - (lpoz)*I3[376])
           + (twoo2zn)*I4[285];
*(vp++) = U00*I0[377] + U40*I1[377]
           + (fouro2z)*(I2[377] - (lpoz)*I3[377])
           + (twoo2zn)*I4[286];
*(vp++) = U00*I0[378] + U40*I1[378]
           + (fouro2z)*(I2[378] - (lpoz)*I3[378])
           + (twoo2zn)*I4[287];
*(vp++) = U00*I0[379] + U40*I1[379]
           + (fouro2z)*(I2[379] - (lpoz)*I3[379])
           + (oneo2zn)*I4[288];
*(vp++) = U00*I0[380] + U40*I1[380]
           + (fouro2z)*(I2[380] - (lpoz)*I3[380])
           + (oneo2zn)*I4[289];
*(vp++) = U00*I0[381] + U40*I1[381]
           + (fouro2z)*(I2[381] - (lpoz)*I3[381])
           + (oneo2zn)*I4[290];
*(vp++) = U00*I0[382] + U40*I1[382]
           + (fouro2z)*(I2[382] - (lpoz)*I3[382])
           + (oneo2zn)*I4[291];
*(vp++) = U00*I0[383] + U40*I1[383]
           + (fouro2z)*(I2[383] - (lpoz)*I3[383])
           + (oneo2zn)*I4[292];
*(vp++) = U00*I0[384] + U40*I1[384]
           + (fouro2z)*(I2[384] - (lpoz)*I3[384])
           + (oneo2zn)*I4[293];
*(vp++) = U00*I0[385] + U40*I1[385]
           + (fouro2z)*(I2[385] - (lpoz)*I3[385]);
*(vp++) = U00*I0[386] + U40*I1[386]
           + (fouro2z)*(I2[386] - (lpoz)*I3[386]);
*(vp++) = U00*I0[387] + U40*I1[387]
           + (fouro2z)*(I2[387] - (lpoz)*I3[387]);
*(vp++) = U00*I0[388] + U40*I1[388]
           + (fouro2z)*(I2[388] - (lpoz)*I3[388]);
*(vp++) = U00*I0[389] + U40*I1[389]
           + (fouro2z)*(I2[389] - (lpoz)*I3[389]);
*(vp++) = U00*I0[390] + U40*I1[390]
           + (fouro2z)*(I2[390] - (lpoz)*I3[390]);
*(vp++) = U00*I0[391] + U40*I1[391]
           + (fouro2z)*(I2[391] - (lpoz)*I3[391]);
*(vp++) = U00*I0[392] + U40*I1[392]
           + (fouro2z)*(I2[392] - (lpoz)*I3[392])
           + (sixo2zn)*I4[294];
*(vp++) = U00*I0[393] + U40*I1[393]
           + (fouro2z)*(I2[393] - (lpoz)*I3[393])
           + (fiveo2zn)*I4[295];
*(vp++) = U00*I0[394] + U40*I1[394]
           + (fouro2z)*(I2[394] - (lpoz)*I3[394])
           + (fiveo2zn)*I4[296];
*(vp++) = U00*I0[395] + U40*I1[395]
           + (fouro2z)*(I2[395] - (lpoz)*I3[395])
           + (fouro2zn)*I4[297];
*(vp++) = U00*I0[396] + U40*I1[396]
           + (fouro2z)*(I2[396] - (lpoz)*I3[396])
           + (fouro2zn)*I4[298];
*(vp++) = U00*I0[397] + U40*I1[397]
           + (fouro2z)*(I2[397] - (lpoz)*I3[397])
           + (fouro2zn)*I4[299];
*(vp++) = U00*I0[398] + U40*I1[398]
           + (fouro2z)*(I2[398] - (lpoz)*I3[398])
           + (threeo2zn)*I4[300];
*(vp++) = U00*I0[399] + U40*I1[399]
           + (fouro2z)*(I2[399] - (lpoz)*I3[399])
           + (threeo2zn)*I4[301];
*(vp++) = U00*I0[400] + U40*I1[400]
           + (fouro2z)*(I2[400] - (lpoz)*I3[400])
           + (threeo2zn)*I4[302];
*(vp++) = U00*I0[401] + U40*I1[401]
           + (fouro2z)*(I2[401] - (lpoz)*I3[401])
           + (threeo2zn)*I4[303];
*(vp++) = U00*I0[402] + U40*I1[402]
           + (fouro2z)*(I2[402] - (lpoz)*I3[402])
           + (twoo2zn)*I4[304];
*(vp++) = U00*I0[403] + U40*I1[403]
           + (fouro2z)*(I2[403] - (lpoz)*I3[403])
           + (twoo2zn)*I4[305];
*(vp++) = U00*I0[404] + U40*I1[404]
           + (fouro2z)*(I2[404] - (lpoz)*I3[404])
           + (twoo2zn)*I4[306];
*(vp++) = U00*I0[405] + U40*I1[405]
           + (fouro2z)*(I2[405] - (lpoz)*I3[405])
           + (twoo2zn)*I4[307];
*(vp++) = U00*I0[406] + U40*I1[406]
           + (fouro2z)*(I2[406] - (lpoz)*I3[406])
           + (twoo2zn)*I4[308];
*(vp++) = U00*I0[407] + U40*I1[407]
           + (fouro2z)*(I2[407] - (lpoz)*I3[407])
           + (oneo2zn)*I4[309];
*(vp++) = U00*I0[408] + U40*I1[408]
           + (fouro2z)*(I2[408] - (lpoz)*I3[408])
           + (oneo2zn)*I4[310];
*(vp++) = U00*I0[409] + U40*I1[409]
           + (fouro2z)*(I2[409] - (lpoz)*I3[409])
           + (oneo2zn)*I4[311];
*(vp++) = U00*I0[410] + U40*I1[410]
           + (fouro2z)*(I2[410] - (lpoz)*I3[410])
           + (oneo2zn)*I4[312];
*(vp++) = U00*I0[411] + U40*I1[411]
           + (fouro2z)*(I2[411] - (lpoz)*I3[411])
           + (oneo2zn)*I4[313];
*(vp++) = U00*I0[412] + U40*I1[412]
           + (fouro2z)*(I2[412] - (lpoz)*I3[412])
           + (oneo2zn)*I4[314];
*(vp++) = U00*I0[413] + U40*I1[413]
           + (fouro2z)*(I2[413] - (lpoz)*I3[413]);
*(vp++) = U00*I0[414] + U40*I1[414]
           + (fouro2z)*(I2[414] - (lpoz)*I3[414]);
*(vp++) = U00*I0[415] + U40*I1[415]
           + (fouro2z)*(I2[415] - (lpoz)*I3[415]);
*(vp++) = U00*I0[416] + U40*I1[416]
           + (fouro2z)*(I2[416] - (lpoz)*I3[416]);
*(vp++) = U00*I0[417] + U40*I1[417]
           + (fouro2z)*(I2[417] - (lpoz)*I3[417]);
*(vp++) = U00*I0[418] + U40*I1[418]
           + (fouro2z)*(I2[418] - (lpoz)*I3[418]);
*(vp++) = U00*I0[419] + U40*I1[419]
           + (fouro2z)*(I2[419] - (lpoz)*I3[419]);
*(vp++) = U00*I0[420] + U40*I1[420]
           + (threeo2z)*(I2[420] - (lpoz)*I3[420])
           + (sixo2zn)*I4[315];
*(vp++) = U00*I0[421] + U40*I1[421]
           + (threeo2z)*(I2[421] - (lpoz)*I3[421])
           + (fiveo2zn)*I4[316];
*(vp++) = U00*I0[422] + U40*I1[422]
           + (threeo2z)*(I2[422] - (lpoz)*I3[422])
           + (fiveo2zn)*I4[317];
*(vp++) = U00*I0[423] + U40*I1[423]
           + (threeo2z)*(I2[423] - (lpoz)*I3[423])
           + (fouro2zn)*I4[318];
*(vp++) = U00*I0[424] + U40*I1[424]
           + (threeo2z)*(I2[424] - (lpoz)*I3[424])
           + (fouro2zn)*I4[319];
*(vp++) = U00*I0[425] + U40*I1[425]
           + (threeo2z)*(I2[425] - (lpoz)*I3[425])
           + (fouro2zn)*I4[320];
*(vp++) = U00*I0[426] + U40*I1[426]
           + (threeo2z)*(I2[426] - (lpoz)*I3[426])
           + (threeo2zn)*I4[321];
*(vp++) = U00*I0[427] + U40*I1[427]
           + (threeo2z)*(I2[427] - (lpoz)*I3[427])
           + (threeo2zn)*I4[322];
*(vp++) = U00*I0[428] + U40*I1[428]
           + (threeo2z)*(I2[428] - (lpoz)*I3[428])
           + (threeo2zn)*I4[323];
*(vp++) = U00*I0[429] + U40*I1[429]
           + (threeo2z)*(I2[429] - (lpoz)*I3[429])
           + (threeo2zn)*I4[324];
*(vp++) = U00*I0[430] + U40*I1[430]
           + (threeo2z)*(I2[430] - (lpoz)*I3[430])
           + (twoo2zn)*I4[325];
*(vp++) = U00*I0[431] + U40*I1[431]
           + (threeo2z)*(I2[431] - (lpoz)*I3[431])
           + (twoo2zn)*I4[326];
*(vp++) = U00*I0[432] + U40*I1[432]
           + (threeo2z)*(I2[432] - (lpoz)*I3[432])
           + (twoo2zn)*I4[327];
*(vp++) = U00*I0[433] + U40*I1[433]
           + (threeo2z)*(I2[433] - (lpoz)*I3[433])
           + (twoo2zn)*I4[328];
*(vp++) = U00*I0[434] + U40*I1[434]
           + (threeo2z)*(I2[434] - (lpoz)*I3[434])
           + (twoo2zn)*I4[329];
*(vp++) = U00*I0[435] + U40*I1[435]
           + (threeo2z)*(I2[435] - (lpoz)*I3[435])
           + (oneo2zn)*I4[330];
*(vp++) = U00*I0[436] + U40*I1[436]
           + (threeo2z)*(I2[436] - (lpoz)*I3[436])
           + (oneo2zn)*I4[331];
*(vp++) = U00*I0[437] + U40*I1[437]
           + (threeo2z)*(I2[437] - (lpoz)*I3[437])
           + (oneo2zn)*I4[332];
*(vp++) = U00*I0[438] + U40*I1[438]
           + (threeo2z)*(I2[438] - (lpoz)*I3[438])
           + (oneo2zn)*I4[333];
*(vp++) = U00*I0[439] + U40*I1[439]
           + (threeo2z)*(I2[439] - (lpoz)*I3[439])
           + (oneo2zn)*I4[334];
*(vp++) = U00*I0[440] + U40*I1[440]
           + (threeo2z)*(I2[440] - (lpoz)*I3[440])
           + (oneo2zn)*I4[335];
*(vp++) = U00*I0[441] + U40*I1[441]
           + (threeo2z)*(I2[441] - (lpoz)*I3[441]);
*(vp++) = U00*I0[442] + U40*I1[442]
           + (threeo2z)*(I2[442] - (lpoz)*I3[442]);
*(vp++) = U00*I0[443] + U40*I1[443]
           + (threeo2z)*(I2[443] - (lpoz)*I3[443]);
*(vp++) = U00*I0[444] + U40*I1[444]
           + (threeo2z)*(I2[444] - (lpoz)*I3[444]);
*(vp++) = U00*I0[445] + U40*I1[445]
           + (threeo2z)*(I2[445] - (lpoz)*I3[445]);
*(vp++) = U00*I0[446] + U40*I1[446]
           + (threeo2z)*(I2[446] - (lpoz)*I3[446]);
*(vp++) = U00*I0[447] + U40*I1[447]
           + (threeo2z)*(I2[447] - (lpoz)*I3[447]);
*(vp++) = U00*I0[448] + U40*I1[448]
           + (threeo2z)*(I2[448] - (lpoz)*I3[448])
           + (sixo2zn)*I4[336];
*(vp++) = U00*I0[449] + U40*I1[449]
           + (threeo2z)*(I2[449] - (lpoz)*I3[449])
           + (fiveo2zn)*I4[337];
*(vp++) = U00*I0[450] + U40*I1[450]
           + (threeo2z)*(I2[450] - (lpoz)*I3[450])
           + (fiveo2zn)*I4[338];
*(vp++) = U00*I0[451] + U40*I1[451]
           + (threeo2z)*(I2[451] - (lpoz)*I3[451])
           + (fouro2zn)*I4[339];
*(vp++) = U00*I0[452] + U40*I1[452]
           + (threeo2z)*(I2[452] - (lpoz)*I3[452])
           + (fouro2zn)*I4[340];
*(vp++) = U00*I0[453] + U40*I1[453]
           + (threeo2z)*(I2[453] - (lpoz)*I3[453])
           + (fouro2zn)*I4[341];
*(vp++) = U00*I0[454] + U40*I1[454]
           + (threeo2z)*(I2[454] - (lpoz)*I3[454])
           + (threeo2zn)*I4[342];
*(vp++) = U00*I0[455] + U40*I1[455]
           + (threeo2z)*(I2[455] - (lpoz)*I3[455])
           + (threeo2zn)*I4[343];
*(vp++) = U00*I0[456] + U40*I1[456]
           + (threeo2z)*(I2[456] - (lpoz)*I3[456])
           + (threeo2zn)*I4[344];
*(vp++) = U00*I0[457] + U40*I1[457]
           + (threeo2z)*(I2[457] - (lpoz)*I3[457])
           + (threeo2zn)*I4[345];
*(vp++) = U00*I0[458] + U40*I1[458]
           + (threeo2z)*(I2[458] - (lpoz)*I3[458])
           + (twoo2zn)*I4[346];
*(vp++) = U00*I0[459] + U40*I1[459]
           + (threeo2z)*(I2[459] - (lpoz)*I3[459])
           + (twoo2zn)*I4[347];
*(vp++) = U00*I0[460] + U40*I1[460]
           + (threeo2z)*(I2[460] - (lpoz)*I3[460])
           + (twoo2zn)*I4[348];
*(vp++) = U00*I0[461] + U40*I1[461]
           + (threeo2z)*(I2[461] - (lpoz)*I3[461])
           + (twoo2zn)*I4[349];
*(vp++) = U00*I0[462] + U40*I1[462]
           + (threeo2z)*(I2[462] - (lpoz)*I3[462])
           + (twoo2zn)*I4[350];
*(vp++) = U00*I0[463] + U40*I1[463]
           + (threeo2z)*(I2[463] - (lpoz)*I3[463])
           + (oneo2zn)*I4[351];
*(vp++) = U00*I0[464] + U40*I1[464]
           + (threeo2z)*(I2[464] - (lpoz)*I3[464])
           + (oneo2zn)*I4[352];
*(vp++) = U00*I0[465] + U40*I1[465]
           + (threeo2z)*(I2[465] - (lpoz)*I3[465])
           + (oneo2zn)*I4[353];
*(vp++) = U00*I0[466] + U40*I1[466]
           + (threeo2z)*(I2[466] - (lpoz)*I3[466])
           + (oneo2zn)*I4[354];
*(vp++) = U00*I0[467] + U40*I1[467]
           + (threeo2z)*(I2[467] - (lpoz)*I3[467])
           + (oneo2zn)*I4[355];
*(vp++) = U00*I0[468] + U40*I1[468]
           + (threeo2z)*(I2[468] - (lpoz)*I3[468])
           + (oneo2zn)*I4[356];
*(vp++) = U00*I0[469] + U40*I1[469]
           + (threeo2z)*(I2[469] - (lpoz)*I3[469]);
*(vp++) = U00*I0[470] + U40*I1[470]
           + (threeo2z)*(I2[470] - (lpoz)*I3[470]);
*(vp++) = U00*I0[471] + U40*I1[471]
           + (threeo2z)*(I2[471] - (lpoz)*I3[471]);
*(vp++) = U00*I0[472] + U40*I1[472]
           + (threeo2z)*(I2[472] - (lpoz)*I3[472]);
*(vp++) = U00*I0[473] + U40*I1[473]
           + (threeo2z)*(I2[473] - (lpoz)*I3[473]);
*(vp++) = U00*I0[474] + U40*I1[474]
           + (threeo2z)*(I2[474] - (lpoz)*I3[474]);
*(vp++) = U00*I0[475] + U40*I1[475]
           + (threeo2z)*(I2[475] - (lpoz)*I3[475]);
*(vp++) = U00*I0[476] + U40*I1[476]
           + (threeo2z)*(I2[476] - (lpoz)*I3[476])
           + (sixo2zn)*I4[357];
*(vp++) = U00*I0[477] + U40*I1[477]
           + (threeo2z)*(I2[477] - (lpoz)*I3[477])
           + (fiveo2zn)*I4[358];
*(vp++) = U00*I0[478] + U40*I1[478]
           + (threeo2z)*(I2[478] - (lpoz)*I3[478])
           + (fiveo2zn)*I4[359];
*(vp++) = U00*I0[479] + U40*I1[479]
           + (threeo2z)*(I2[479] - (lpoz)*I3[479])
           + (fouro2zn)*I4[360];
*(vp++) = U00*I0[480] + U40*I1[480]
           + (threeo2z)*(I2[480] - (lpoz)*I3[480])
           + (fouro2zn)*I4[361];
*(vp++) = U00*I0[481] + U40*I1[481]
           + (threeo2z)*(I2[481] - (lpoz)*I3[481])
           + (fouro2zn)*I4[362];
*(vp++) = U00*I0[482] + U40*I1[482]
           + (threeo2z)*(I2[482] - (lpoz)*I3[482])
           + (threeo2zn)*I4[363];
*(vp++) = U00*I0[483] + U40*I1[483]
           + (threeo2z)*(I2[483] - (lpoz)*I3[483])
           + (threeo2zn)*I4[364];
*(vp++) = U00*I0[484] + U40*I1[484]
           + (threeo2z)*(I2[484] - (lpoz)*I3[484])
           + (threeo2zn)*I4[365];
*(vp++) = U00*I0[485] + U40*I1[485]
           + (threeo2z)*(I2[485] - (lpoz)*I3[485])
           + (threeo2zn)*I4[366];
*(vp++) = U00*I0[486] + U40*I1[486]
           + (threeo2z)*(I2[486] - (lpoz)*I3[486])
           + (twoo2zn)*I4[367];
*(vp++) = U00*I0[487] + U40*I1[487]
           + (threeo2z)*(I2[487] - (lpoz)*I3[487])
           + (twoo2zn)*I4[368];
*(vp++) = U00*I0[488] + U40*I1[488]
           + (threeo2z)*(I2[488] - (lpoz)*I3[488])
           + (twoo2zn)*I4[369];
*(vp++) = U00*I0[489] + U40*I1[489]
           + (threeo2z)*(I2[489] - (lpoz)*I3[489])
           + (twoo2zn)*I4[370];
*(vp++) = U00*I0[490] + U40*I1[490]
           + (threeo2z)*(I2[490] - (lpoz)*I3[490])
           + (twoo2zn)*I4[371];
*(vp++) = U00*I0[491] + U40*I1[491]
           + (threeo2z)*(I2[491] - (lpoz)*I3[491])
           + (oneo2zn)*I4[372];
*(vp++) = U00*I0[492] + U40*I1[492]
           + (threeo2z)*(I2[492] - (lpoz)*I3[492])
           + (oneo2zn)*I4[373];
*(vp++) = U00*I0[493] + U40*I1[493]
           + (threeo2z)*(I2[493] - (lpoz)*I3[493])
           + (oneo2zn)*I4[374];
*(vp++) = U00*I0[494] + U40*I1[494]
           + (threeo2z)*(I2[494] - (lpoz)*I3[494])
           + (oneo2zn)*I4[375];
*(vp++) = U00*I0[495] + U40*I1[495]
           + (threeo2z)*(I2[495] - (lpoz)*I3[495])
           + (oneo2zn)*I4[376];
*(vp++) = U00*I0[496] + U40*I1[496]
           + (threeo2z)*(I2[496] - (lpoz)*I3[496])
           + (oneo2zn)*I4[377];
*(vp++) = U00*I0[497] + U40*I1[497]
           + (threeo2z)*(I2[497] - (lpoz)*I3[497]);
*(vp++) = U00*I0[498] + U40*I1[498]
           + (threeo2z)*(I2[498] - (lpoz)*I3[498]);
*(vp++) = U00*I0[499] + U40*I1[499]
           + (threeo2z)*(I2[499] - (lpoz)*I3[499]);
*(vp++) = U00*I0[500] + U40*I1[500]
           + (threeo2z)*(I2[500] - (lpoz)*I3[500]);
*(vp++) = U00*I0[501] + U40*I1[501]
           + (threeo2z)*(I2[501] - (lpoz)*I3[501]);
*(vp++) = U00*I0[502] + U40*I1[502]
           + (threeo2z)*(I2[502] - (lpoz)*I3[502]);
*(vp++) = U00*I0[503] + U40*I1[503]
           + (threeo2z)*(I2[503] - (lpoz)*I3[503]);
*(vp++) = U00*I0[504] + U40*I1[504]
           + (threeo2z)*(I2[504] - (lpoz)*I3[504])
           + (sixo2zn)*I4[378];
*(vp++) = U00*I0[505] + U40*I1[505]
           + (threeo2z)*(I2[505] - (lpoz)*I3[505])
           + (fiveo2zn)*I4[379];
*(vp++) = U00*I0[506] + U40*I1[506]
           + (threeo2z)*(I2[506] - (lpoz)*I3[506])
           + (fiveo2zn)*I4[380];
*(vp++) = U00*I0[507] + U40*I1[507]
           + (threeo2z)*(I2[507] - (lpoz)*I3[507])
           + (fouro2zn)*I4[381];
*(vp++) = U00*I0[508] + U40*I1[508]
           + (threeo2z)*(I2[508] - (lpoz)*I3[508])
           + (fouro2zn)*I4[382];
*(vp++) = U00*I0[509] + U40*I1[509]
           + (threeo2z)*(I2[509] - (lpoz)*I3[509])
           + (fouro2zn)*I4[383];
*(vp++) = U00*I0[510] + U40*I1[510]
           + (threeo2z)*(I2[510] - (lpoz)*I3[510])
           + (threeo2zn)*I4[384];
*(vp++) = U00*I0[511] + U40*I1[511]
           + (threeo2z)*(I2[511] - (lpoz)*I3[511])
           + (threeo2zn)*I4[385];
*(vp++) = U00*I0[512] + U40*I1[512]
           + (threeo2z)*(I2[512] - (lpoz)*I3[512])
           + (threeo2zn)*I4[386];
*(vp++) = U00*I0[513] + U40*I1[513]
           + (threeo2z)*(I2[513] - (lpoz)*I3[513])
           + (threeo2zn)*I4[387];
return vp;
}

REALTYPE *_build_m0i0_2(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2zn;
  REALTYPE twoo2zn;
  REALTYPE threeo2zn;
  REALTYPE fouro2zn;
  REALTYPE fiveo2zn;
  REALTYPE sixo2zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  REALTYPE seveno2z;
  REALTYPE eighto2z;
  oneo2zn = 1.0*Data->oo2zn;
  twoo2zn = 2.0*Data->oo2zn;
  threeo2zn = 3.0*Data->oo2zn;
  fouro2zn = 4.0*Data->oo2zn;
  fiveo2zn = 5.0*Data->oo2zn;
  sixo2zn = 6.0*Data->oo2zn;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  seveno2z = 7.0*Data->oo2z;
  eighto2z = 8.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U40 = Data->U[4][0];
  U41 = Data->U[4][1];
  U42 = Data->U[4][2];


*(vp++) = U00*I0[514] + U40*I1[514]
           + (threeo2z)*(I2[514] - (lpoz)*I3[514])
           + (twoo2zn)*I4[388];
*(vp++) = U00*I0[515] + U40*I1[515]
           + (threeo2z)*(I2[515] - (lpoz)*I3[515])
           + (twoo2zn)*I4[389];
*(vp++) = U00*I0[516] + U40*I1[516]
           + (threeo2z)*(I2[516] - (lpoz)*I3[516])
           + (twoo2zn)*I4[390];
*(vp++) = U00*I0[517] + U40*I1[517]
           + (threeo2z)*(I2[517] - (lpoz)*I3[517])
           + (twoo2zn)*I4[391];
*(vp++) = U00*I0[518] + U40*I1[518]
           + (threeo2z)*(I2[518] - (lpoz)*I3[518])
           + (twoo2zn)*I4[392];
*(vp++) = U00*I0[519] + U40*I1[519]
           + (threeo2z)*(I2[519] - (lpoz)*I3[519])
           + (oneo2zn)*I4[393];
*(vp++) = U00*I0[520] + U40*I1[520]
           + (threeo2z)*(I2[520] - (lpoz)*I3[520])
           + (oneo2zn)*I4[394];
*(vp++) = U00*I0[521] + U40*I1[521]
           + (threeo2z)*(I2[521] - (lpoz)*I3[521])
           + (oneo2zn)*I4[395];
*(vp++) = U00*I0[522] + U40*I1[522]
           + (threeo2z)*(I2[522] - (lpoz)*I3[522])
           + (oneo2zn)*I4[396];
*(vp++) = U00*I0[523] + U40*I1[523]
           + (threeo2z)*(I2[523] - (lpoz)*I3[523])
           + (oneo2zn)*I4[397];
*(vp++) = U00*I0[524] + U40*I1[524]
           + (threeo2z)*(I2[524] - (lpoz)*I3[524])
           + (oneo2zn)*I4[398];
*(vp++) = U00*I0[525] + U40*I1[525]
           + (threeo2z)*(I2[525] - (lpoz)*I3[525]);
*(vp++) = U00*I0[526] + U40*I1[526]
           + (threeo2z)*(I2[526] - (lpoz)*I3[526]);
*(vp++) = U00*I0[527] + U40*I1[527]
           + (threeo2z)*(I2[527] - (lpoz)*I3[527]);
*(vp++) = U00*I0[528] + U40*I1[528]
           + (threeo2z)*(I2[528] - (lpoz)*I3[528]);
*(vp++) = U00*I0[529] + U40*I1[529]
           + (threeo2z)*(I2[529] - (lpoz)*I3[529]);
*(vp++) = U00*I0[530] + U40*I1[530]
           + (threeo2z)*(I2[530] - (lpoz)*I3[530]);
*(vp++) = U00*I0[531] + U40*I1[531]
           + (threeo2z)*(I2[531] - (lpoz)*I3[531]);
*(vp++) = U00*I0[532] + U40*I1[532]
           + (threeo2z)*(I2[532] - (lpoz)*I3[532])
           + (sixo2zn)*I4[399];
*(vp++) = U00*I0[533] + U40*I1[533]
           + (threeo2z)*(I2[533] - (lpoz)*I3[533])
           + (fiveo2zn)*I4[400];
*(vp++) = U00*I0[534] + U40*I1[534]
           + (threeo2z)*(I2[534] - (lpoz)*I3[534])
           + (fiveo2zn)*I4[401];
*(vp++) = U00*I0[535] + U40*I1[535]
           + (threeo2z)*(I2[535] - (lpoz)*I3[535])
           + (fouro2zn)*I4[402];
*(vp++) = U00*I0[536] + U40*I1[536]
           + (threeo2z)*(I2[536] - (lpoz)*I3[536])
           + (fouro2zn)*I4[403];
*(vp++) = U00*I0[537] + U40*I1[537]
           + (threeo2z)*(I2[537] - (lpoz)*I3[537])
           + (fouro2zn)*I4[404];
*(vp++) = U00*I0[538] + U40*I1[538]
           + (threeo2z)*(I2[538] - (lpoz)*I3[538])
           + (threeo2zn)*I4[405];
*(vp++) = U00*I0[539] + U40*I1[539]
           + (threeo2z)*(I2[539] - (lpoz)*I3[539])
           + (threeo2zn)*I4[406];
*(vp++) = U00*I0[540] + U40*I1[540]
           + (threeo2z)*(I2[540] - (lpoz)*I3[540])
           + (threeo2zn)*I4[407];
*(vp++) = U00*I0[541] + U40*I1[541]
           + (threeo2z)*(I2[541] - (lpoz)*I3[541])
           + (threeo2zn)*I4[408];
*(vp++) = U00*I0[542] + U40*I1[542]
           + (threeo2z)*(I2[542] - (lpoz)*I3[542])
           + (twoo2zn)*I4[409];
*(vp++) = U00*I0[543] + U40*I1[543]
           + (threeo2z)*(I2[543] - (lpoz)*I3[543])
           + (twoo2zn)*I4[410];
*(vp++) = U00*I0[544] + U40*I1[544]
           + (threeo2z)*(I2[544] - (lpoz)*I3[544])
           + (twoo2zn)*I4[411];
*(vp++) = U00*I0[545] + U40*I1[545]
           + (threeo2z)*(I2[545] - (lpoz)*I3[545])
           + (twoo2zn)*I4[412];
*(vp++) = U00*I0[546] + U40*I1[546]
           + (threeo2z)*(I2[546] - (lpoz)*I3[546])
           + (twoo2zn)*I4[413];
*(vp++) = U00*I0[547] + U40*I1[547]
           + (threeo2z)*(I2[547] - (lpoz)*I3[547])
           + (oneo2zn)*I4[414];
*(vp++) = U00*I0[548] + U40*I1[548]
           + (threeo2z)*(I2[548] - (lpoz)*I3[548])
           + (oneo2zn)*I4[415];
*(vp++) = U00*I0[549] + U40*I1[549]
           + (threeo2z)*(I2[549] - (lpoz)*I3[549])
           + (oneo2zn)*I4[416];
*(vp++) = U00*I0[550] + U40*I1[550]
           + (threeo2z)*(I2[550] - (lpoz)*I3[550])
           + (oneo2zn)*I4[417];
*(vp++) = U00*I0[551] + U40*I1[551]
           + (threeo2z)*(I2[551] - (lpoz)*I3[551])
           + (oneo2zn)*I4[418];
*(vp++) = U00*I0[552] + U40*I1[552]
           + (threeo2z)*(I2[552] - (lpoz)*I3[552])
           + (oneo2zn)*I4[419];
*(vp++) = U00*I0[553] + U40*I1[553]
           + (threeo2z)*(I2[553] - (lpoz)*I3[553]);
*(vp++) = U00*I0[554] + U40*I1[554]
           + (threeo2z)*(I2[554] - (lpoz)*I3[554]);
*(vp++) = U00*I0[555] + U40*I1[555]
           + (threeo2z)*(I2[555] - (lpoz)*I3[555]);
*(vp++) = U00*I0[556] + U40*I1[556]
           + (threeo2z)*(I2[556] - (lpoz)*I3[556]);
*(vp++) = U00*I0[557] + U40*I1[557]
           + (threeo2z)*(I2[557] - (lpoz)*I3[557]);
*(vp++) = U00*I0[558] + U40*I1[558]
           + (threeo2z)*(I2[558] - (lpoz)*I3[558]);
*(vp++) = U00*I0[559] + U40*I1[559]
           + (threeo2z)*(I2[559] - (lpoz)*I3[559]);
*(vp++) = U00*I0[560] + U40*I1[560]
           + (threeo2z)*(I2[560] - (lpoz)*I3[560])
           + (sixo2zn)*I4[420];
*(vp++) = U00*I0[561] + U40*I1[561]
           + (threeo2z)*(I2[561] - (lpoz)*I3[561])
           + (fiveo2zn)*I4[421];
*(vp++) = U00*I0[562] + U40*I1[562]
           + (threeo2z)*(I2[562] - (lpoz)*I3[562])
           + (fiveo2zn)*I4[422];
*(vp++) = U00*I0[563] + U40*I1[563]
           + (threeo2z)*(I2[563] - (lpoz)*I3[563])
           + (fouro2zn)*I4[423];
*(vp++) = U00*I0[564] + U40*I1[564]
           + (threeo2z)*(I2[564] - (lpoz)*I3[564])
           + (fouro2zn)*I4[424];
*(vp++) = U00*I0[565] + U40*I1[565]
           + (threeo2z)*(I2[565] - (lpoz)*I3[565])
           + (fouro2zn)*I4[425];
*(vp++) = U00*I0[566] + U40*I1[566]
           + (threeo2z)*(I2[566] - (lpoz)*I3[566])
           + (threeo2zn)*I4[426];
*(vp++) = U00*I0[567] + U40*I1[567]
           + (threeo2z)*(I2[567] - (lpoz)*I3[567])
           + (threeo2zn)*I4[427];
*(vp++) = U00*I0[568] + U40*I1[568]
           + (threeo2z)*(I2[568] - (lpoz)*I3[568])
           + (threeo2zn)*I4[428];
*(vp++) = U00*I0[569] + U40*I1[569]
           + (threeo2z)*(I2[569] - (lpoz)*I3[569])
           + (threeo2zn)*I4[429];
*(vp++) = U00*I0[570] + U40*I1[570]
           + (threeo2z)*(I2[570] - (lpoz)*I3[570])
           + (twoo2zn)*I4[430];
*(vp++) = U00*I0[571] + U40*I1[571]
           + (threeo2z)*(I2[571] - (lpoz)*I3[571])
           + (twoo2zn)*I4[431];
*(vp++) = U00*I0[572] + U40*I1[572]
           + (threeo2z)*(I2[572] - (lpoz)*I3[572])
           + (twoo2zn)*I4[432];
*(vp++) = U00*I0[573] + U40*I1[573]
           + (threeo2z)*(I2[573] - (lpoz)*I3[573])
           + (twoo2zn)*I4[433];
*(vp++) = U00*I0[574] + U40*I1[574]
           + (threeo2z)*(I2[574] - (lpoz)*I3[574])
           + (twoo2zn)*I4[434];
*(vp++) = U00*I0[575] + U40*I1[575]
           + (threeo2z)*(I2[575] - (lpoz)*I3[575])
           + (oneo2zn)*I4[435];
*(vp++) = U00*I0[576] + U40*I1[576]
           + (threeo2z)*(I2[576] - (lpoz)*I3[576])
           + (oneo2zn)*I4[436];
*(vp++) = U00*I0[577] + U40*I1[577]
           + (threeo2z)*(I2[577] - (lpoz)*I3[577])
           + (oneo2zn)*I4[437];
*(vp++) = U00*I0[578] + U40*I1[578]
           + (threeo2z)*(I2[578] - (lpoz)*I3[578])
           + (oneo2zn)*I4[438];
*(vp++) = U00*I0[579] + U40*I1[579]
           + (threeo2z)*(I2[579] - (lpoz)*I3[579])
           + (oneo2zn)*I4[439];
*(vp++) = U00*I0[580] + U40*I1[580]
           + (threeo2z)*(I2[580] - (lpoz)*I3[580])
           + (oneo2zn)*I4[440];
*(vp++) = U00*I0[581] + U40*I1[581]
           + (threeo2z)*(I2[581] - (lpoz)*I3[581]);
*(vp++) = U00*I0[582] + U40*I1[582]
           + (threeo2z)*(I2[582] - (lpoz)*I3[582]);
*(vp++) = U00*I0[583] + U40*I1[583]
           + (threeo2z)*(I2[583] - (lpoz)*I3[583]);
*(vp++) = U00*I0[584] + U40*I1[584]
           + (threeo2z)*(I2[584] - (lpoz)*I3[584]);
*(vp++) = U00*I0[585] + U40*I1[585]
           + (threeo2z)*(I2[585] - (lpoz)*I3[585]);
*(vp++) = U00*I0[586] + U40*I1[586]
           + (threeo2z)*(I2[586] - (lpoz)*I3[586]);
*(vp++) = U00*I0[587] + U40*I1[587]
           + (threeo2z)*(I2[587] - (lpoz)*I3[587]);
*(vp++) = U00*I0[588] + U40*I1[588]
           + (twoo2z)*(I2[588] - (lpoz)*I3[588])
           + (sixo2zn)*I4[441];
*(vp++) = U00*I0[589] + U40*I1[589]
           + (twoo2z)*(I2[589] - (lpoz)*I3[589])
           + (fiveo2zn)*I4[442];
*(vp++) = U00*I0[590] + U40*I1[590]
           + (twoo2z)*(I2[590] - (lpoz)*I3[590])
           + (fiveo2zn)*I4[443];
*(vp++) = U00*I0[591] + U40*I1[591]
           + (twoo2z)*(I2[591] - (lpoz)*I3[591])
           + (fouro2zn)*I4[444];
*(vp++) = U00*I0[592] + U40*I1[592]
           + (twoo2z)*(I2[592] - (lpoz)*I3[592])
           + (fouro2zn)*I4[445];
*(vp++) = U00*I0[593] + U40*I1[593]
           + (twoo2z)*(I2[593] - (lpoz)*I3[593])
           + (fouro2zn)*I4[446];
*(vp++) = U00*I0[594] + U40*I1[594]
           + (twoo2z)*(I2[594] - (lpoz)*I3[594])
           + (threeo2zn)*I4[447];
*(vp++) = U00*I0[595] + U40*I1[595]
           + (twoo2z)*(I2[595] - (lpoz)*I3[595])
           + (threeo2zn)*I4[448];
*(vp++) = U00*I0[596] + U40*I1[596]
           + (twoo2z)*(I2[596] - (lpoz)*I3[596])
           + (threeo2zn)*I4[449];
*(vp++) = U00*I0[597] + U40*I1[597]
           + (twoo2z)*(I2[597] - (lpoz)*I3[597])
           + (threeo2zn)*I4[450];
*(vp++) = U00*I0[598] + U40*I1[598]
           + (twoo2z)*(I2[598] - (lpoz)*I3[598])
           + (twoo2zn)*I4[451];
*(vp++) = U00*I0[599] + U40*I1[599]
           + (twoo2z)*(I2[599] - (lpoz)*I3[599])
           + (twoo2zn)*I4[452];
*(vp++) = U00*I0[600] + U40*I1[600]
           + (twoo2z)*(I2[600] - (lpoz)*I3[600])
           + (twoo2zn)*I4[453];
*(vp++) = U00*I0[601] + U40*I1[601]
           + (twoo2z)*(I2[601] - (lpoz)*I3[601])
           + (twoo2zn)*I4[454];
*(vp++) = U00*I0[602] + U40*I1[602]
           + (twoo2z)*(I2[602] - (lpoz)*I3[602])
           + (twoo2zn)*I4[455];
*(vp++) = U00*I0[603] + U40*I1[603]
           + (twoo2z)*(I2[603] - (lpoz)*I3[603])
           + (oneo2zn)*I4[456];
*(vp++) = U00*I0[604] + U40*I1[604]
           + (twoo2z)*(I2[604] - (lpoz)*I3[604])
           + (oneo2zn)*I4[457];
*(vp++) = U00*I0[605] + U40*I1[605]
           + (twoo2z)*(I2[605] - (lpoz)*I3[605])
           + (oneo2zn)*I4[458];
*(vp++) = U00*I0[606] + U40*I1[606]
           + (twoo2z)*(I2[606] - (lpoz)*I3[606])
           + (oneo2zn)*I4[459];
*(vp++) = U00*I0[607] + U40*I1[607]
           + (twoo2z)*(I2[607] - (lpoz)*I3[607])
           + (oneo2zn)*I4[460];
*(vp++) = U00*I0[608] + U40*I1[608]
           + (twoo2z)*(I2[608] - (lpoz)*I3[608])
           + (oneo2zn)*I4[461];
*(vp++) = U00*I0[609] + U40*I1[609]
           + (twoo2z)*(I2[609] - (lpoz)*I3[609]);
*(vp++) = U00*I0[610] + U40*I1[610]
           + (twoo2z)*(I2[610] - (lpoz)*I3[610]);
*(vp++) = U00*I0[611] + U40*I1[611]
           + (twoo2z)*(I2[611] - (lpoz)*I3[611]);
*(vp++) = U00*I0[612] + U40*I1[612]
           + (twoo2z)*(I2[612] - (lpoz)*I3[612]);
*(vp++) = U00*I0[613] + U40*I1[613]
           + (twoo2z)*(I2[613] - (lpoz)*I3[613]);
*(vp++) = U00*I0[614] + U40*I1[614]
           + (twoo2z)*(I2[614] - (lpoz)*I3[614]);
*(vp++) = U00*I0[615] + U40*I1[615]
           + (twoo2z)*(I2[615] - (lpoz)*I3[615]);
*(vp++) = U00*I0[616] + U40*I1[616]
           + (twoo2z)*(I2[616] - (lpoz)*I3[616])
           + (sixo2zn)*I4[462];
*(vp++) = U00*I0[617] + U40*I1[617]
           + (twoo2z)*(I2[617] - (lpoz)*I3[617])
           + (fiveo2zn)*I4[463];
*(vp++) = U00*I0[618] + U40*I1[618]
           + (twoo2z)*(I2[618] - (lpoz)*I3[618])
           + (fiveo2zn)*I4[464];
*(vp++) = U00*I0[619] + U40*I1[619]
           + (twoo2z)*(I2[619] - (lpoz)*I3[619])
           + (fouro2zn)*I4[465];
*(vp++) = U00*I0[620] + U40*I1[620]
           + (twoo2z)*(I2[620] - (lpoz)*I3[620])
           + (fouro2zn)*I4[466];
*(vp++) = U00*I0[621] + U40*I1[621]
           + (twoo2z)*(I2[621] - (lpoz)*I3[621])
           + (fouro2zn)*I4[467];
*(vp++) = U00*I0[622] + U40*I1[622]
           + (twoo2z)*(I2[622] - (lpoz)*I3[622])
           + (threeo2zn)*I4[468];
*(vp++) = U00*I0[623] + U40*I1[623]
           + (twoo2z)*(I2[623] - (lpoz)*I3[623])
           + (threeo2zn)*I4[469];
*(vp++) = U00*I0[624] + U40*I1[624]
           + (twoo2z)*(I2[624] - (lpoz)*I3[624])
           + (threeo2zn)*I4[470];
*(vp++) = U00*I0[625] + U40*I1[625]
           + (twoo2z)*(I2[625] - (lpoz)*I3[625])
           + (threeo2zn)*I4[471];
*(vp++) = U00*I0[626] + U40*I1[626]
           + (twoo2z)*(I2[626] - (lpoz)*I3[626])
           + (twoo2zn)*I4[472];
*(vp++) = U00*I0[627] + U40*I1[627]
           + (twoo2z)*(I2[627] - (lpoz)*I3[627])
           + (twoo2zn)*I4[473];
*(vp++) = U00*I0[628] + U40*I1[628]
           + (twoo2z)*(I2[628] - (lpoz)*I3[628])
           + (twoo2zn)*I4[474];
*(vp++) = U00*I0[629] + U40*I1[629]
           + (twoo2z)*(I2[629] - (lpoz)*I3[629])
           + (twoo2zn)*I4[475];
*(vp++) = U00*I0[630] + U40*I1[630]
           + (twoo2z)*(I2[630] - (lpoz)*I3[630])
           + (twoo2zn)*I4[476];
*(vp++) = U00*I0[631] + U40*I1[631]
           + (twoo2z)*(I2[631] - (lpoz)*I3[631])
           + (oneo2zn)*I4[477];
*(vp++) = U00*I0[632] + U40*I1[632]
           + (twoo2z)*(I2[632] - (lpoz)*I3[632])
           + (oneo2zn)*I4[478];
*(vp++) = U00*I0[633] + U40*I1[633]
           + (twoo2z)*(I2[633] - (lpoz)*I3[633])
           + (oneo2zn)*I4[479];
*(vp++) = U00*I0[634] + U40*I1[634]
           + (twoo2z)*(I2[634] - (lpoz)*I3[634])
           + (oneo2zn)*I4[480];
*(vp++) = U00*I0[635] + U40*I1[635]
           + (twoo2z)*(I2[635] - (lpoz)*I3[635])
           + (oneo2zn)*I4[481];
*(vp++) = U00*I0[636] + U40*I1[636]
           + (twoo2z)*(I2[636] - (lpoz)*I3[636])
           + (oneo2zn)*I4[482];
*(vp++) = U00*I0[637] + U40*I1[637]
           + (twoo2z)*(I2[637] - (lpoz)*I3[637]);
*(vp++) = U00*I0[638] + U40*I1[638]
           + (twoo2z)*(I2[638] - (lpoz)*I3[638]);
*(vp++) = U00*I0[639] + U40*I1[639]
           + (twoo2z)*(I2[639] - (lpoz)*I3[639]);
*(vp++) = U00*I0[640] + U40*I1[640]
           + (twoo2z)*(I2[640] - (lpoz)*I3[640]);
*(vp++) = U00*I0[641] + U40*I1[641]
           + (twoo2z)*(I2[641] - (lpoz)*I3[641]);
*(vp++) = U00*I0[642] + U40*I1[642]
           + (twoo2z)*(I2[642] - (lpoz)*I3[642]);
*(vp++) = U00*I0[643] + U40*I1[643]
           + (twoo2z)*(I2[643] - (lpoz)*I3[643]);
*(vp++) = U00*I0[644] + U40*I1[644]
           + (twoo2z)*(I2[644] - (lpoz)*I3[644])
           + (sixo2zn)*I4[483];
*(vp++) = U00*I0[645] + U40*I1[645]
           + (twoo2z)*(I2[645] - (lpoz)*I3[645])
           + (fiveo2zn)*I4[484];
*(vp++) = U00*I0[646] + U40*I1[646]
           + (twoo2z)*(I2[646] - (lpoz)*I3[646])
           + (fiveo2zn)*I4[485];
*(vp++) = U00*I0[647] + U40*I1[647]
           + (twoo2z)*(I2[647] - (lpoz)*I3[647])
           + (fouro2zn)*I4[486];
*(vp++) = U00*I0[648] + U40*I1[648]
           + (twoo2z)*(I2[648] - (lpoz)*I3[648])
           + (fouro2zn)*I4[487];
*(vp++) = U00*I0[649] + U40*I1[649]
           + (twoo2z)*(I2[649] - (lpoz)*I3[649])
           + (fouro2zn)*I4[488];
*(vp++) = U00*I0[650] + U40*I1[650]
           + (twoo2z)*(I2[650] - (lpoz)*I3[650])
           + (threeo2zn)*I4[489];
*(vp++) = U00*I0[651] + U40*I1[651]
           + (twoo2z)*(I2[651] - (lpoz)*I3[651])
           + (threeo2zn)*I4[490];
*(vp++) = U00*I0[652] + U40*I1[652]
           + (twoo2z)*(I2[652] - (lpoz)*I3[652])
           + (threeo2zn)*I4[491];
*(vp++) = U00*I0[653] + U40*I1[653]
           + (twoo2z)*(I2[653] - (lpoz)*I3[653])
           + (threeo2zn)*I4[492];
*(vp++) = U00*I0[654] + U40*I1[654]
           + (twoo2z)*(I2[654] - (lpoz)*I3[654])
           + (twoo2zn)*I4[493];
*(vp++) = U00*I0[655] + U40*I1[655]
           + (twoo2z)*(I2[655] - (lpoz)*I3[655])
           + (twoo2zn)*I4[494];
*(vp++) = U00*I0[656] + U40*I1[656]
           + (twoo2z)*(I2[656] - (lpoz)*I3[656])
           + (twoo2zn)*I4[495];
*(vp++) = U00*I0[657] + U40*I1[657]
           + (twoo2z)*(I2[657] - (lpoz)*I3[657])
           + (twoo2zn)*I4[496];
*(vp++) = U00*I0[658] + U40*I1[658]
           + (twoo2z)*(I2[658] - (lpoz)*I3[658])
           + (twoo2zn)*I4[497];
*(vp++) = U00*I0[659] + U40*I1[659]
           + (twoo2z)*(I2[659] - (lpoz)*I3[659])
           + (oneo2zn)*I4[498];
*(vp++) = U00*I0[660] + U40*I1[660]
           + (twoo2z)*(I2[660] - (lpoz)*I3[660])
           + (oneo2zn)*I4[499];
*(vp++) = U00*I0[661] + U40*I1[661]
           + (twoo2z)*(I2[661] - (lpoz)*I3[661])
           + (oneo2zn)*I4[500];
*(vp++) = U00*I0[662] + U40*I1[662]
           + (twoo2z)*(I2[662] - (lpoz)*I3[662])
           + (oneo2zn)*I4[501];
*(vp++) = U00*I0[663] + U40*I1[663]
           + (twoo2z)*(I2[663] - (lpoz)*I3[663])
           + (oneo2zn)*I4[502];
*(vp++) = U00*I0[664] + U40*I1[664]
           + (twoo2z)*(I2[664] - (lpoz)*I3[664])
           + (oneo2zn)*I4[503];
*(vp++) = U00*I0[665] + U40*I1[665]
           + (twoo2z)*(I2[665] - (lpoz)*I3[665]);
*(vp++) = U00*I0[666] + U40*I1[666]
           + (twoo2z)*(I2[666] - (lpoz)*I3[666]);
*(vp++) = U00*I0[667] + U40*I1[667]
           + (twoo2z)*(I2[667] - (lpoz)*I3[667]);
*(vp++) = U00*I0[668] + U40*I1[668]
           + (twoo2z)*(I2[668] - (lpoz)*I3[668]);
*(vp++) = U00*I0[669] + U40*I1[669]
           + (twoo2z)*(I2[669] - (lpoz)*I3[669]);
*(vp++) = U00*I0[670] + U40*I1[670]
           + (twoo2z)*(I2[670] - (lpoz)*I3[670]);
*(vp++) = U00*I0[671] + U40*I1[671]
           + (twoo2z)*(I2[671] - (lpoz)*I3[671]);
*(vp++) = U00*I0[672] + U40*I1[672]
           + (twoo2z)*(I2[672] - (lpoz)*I3[672])
           + (sixo2zn)*I4[504];
*(vp++) = U00*I0[673] + U40*I1[673]
           + (twoo2z)*(I2[673] - (lpoz)*I3[673])
           + (fiveo2zn)*I4[505];
*(vp++) = U00*I0[674] + U40*I1[674]
           + (twoo2z)*(I2[674] - (lpoz)*I3[674])
           + (fiveo2zn)*I4[506];
*(vp++) = U00*I0[675] + U40*I1[675]
           + (twoo2z)*(I2[675] - (lpoz)*I3[675])
           + (fouro2zn)*I4[507];
*(vp++) = U00*I0[676] + U40*I1[676]
           + (twoo2z)*(I2[676] - (lpoz)*I3[676])
           + (fouro2zn)*I4[508];
*(vp++) = U00*I0[677] + U40*I1[677]
           + (twoo2z)*(I2[677] - (lpoz)*I3[677])
           + (fouro2zn)*I4[509];
*(vp++) = U00*I0[678] + U40*I1[678]
           + (twoo2z)*(I2[678] - (lpoz)*I3[678])
           + (threeo2zn)*I4[510];
*(vp++) = U00*I0[679] + U40*I1[679]
           + (twoo2z)*(I2[679] - (lpoz)*I3[679])
           + (threeo2zn)*I4[511];
*(vp++) = U00*I0[680] + U40*I1[680]
           + (twoo2z)*(I2[680] - (lpoz)*I3[680])
           + (threeo2zn)*I4[512];
*(vp++) = U00*I0[681] + U40*I1[681]
           + (twoo2z)*(I2[681] - (lpoz)*I3[681])
           + (threeo2zn)*I4[513];
*(vp++) = U00*I0[682] + U40*I1[682]
           + (twoo2z)*(I2[682] - (lpoz)*I3[682])
           + (twoo2zn)*I4[514];
*(vp++) = U00*I0[683] + U40*I1[683]
           + (twoo2z)*(I2[683] - (lpoz)*I3[683])
           + (twoo2zn)*I4[515];
*(vp++) = U00*I0[684] + U40*I1[684]
           + (twoo2z)*(I2[684] - (lpoz)*I3[684])
           + (twoo2zn)*I4[516];
*(vp++) = U00*I0[685] + U40*I1[685]
           + (twoo2z)*(I2[685] - (lpoz)*I3[685])
           + (twoo2zn)*I4[517];
*(vp++) = U00*I0[686] + U40*I1[686]
           + (twoo2z)*(I2[686] - (lpoz)*I3[686])
           + (twoo2zn)*I4[518];
*(vp++) = U00*I0[687] + U40*I1[687]
           + (twoo2z)*(I2[687] - (lpoz)*I3[687])
           + (oneo2zn)*I4[519];
*(vp++) = U00*I0[688] + U40*I1[688]
           + (twoo2z)*(I2[688] - (lpoz)*I3[688])
           + (oneo2zn)*I4[520];
*(vp++) = U00*I0[689] + U40*I1[689]
           + (twoo2z)*(I2[689] - (lpoz)*I3[689])
           + (oneo2zn)*I4[521];
*(vp++) = U00*I0[690] + U40*I1[690]
           + (twoo2z)*(I2[690] - (lpoz)*I3[690])
           + (oneo2zn)*I4[522];
*(vp++) = U00*I0[691] + U40*I1[691]
           + (twoo2z)*(I2[691] - (lpoz)*I3[691])
           + (oneo2zn)*I4[523];
*(vp++) = U00*I0[692] + U40*I1[692]
           + (twoo2z)*(I2[692] - (lpoz)*I3[692])
           + (oneo2zn)*I4[524];
*(vp++) = U00*I0[693] + U40*I1[693]
           + (twoo2z)*(I2[693] - (lpoz)*I3[693]);
*(vp++) = U00*I0[694] + U40*I1[694]
           + (twoo2z)*(I2[694] - (lpoz)*I3[694]);
*(vp++) = U00*I0[695] + U40*I1[695]
           + (twoo2z)*(I2[695] - (lpoz)*I3[695]);
*(vp++) = U00*I0[696] + U40*I1[696]
           + (twoo2z)*(I2[696] - (lpoz)*I3[696]);
*(vp++) = U00*I0[697] + U40*I1[697]
           + (twoo2z)*(I2[697] - (lpoz)*I3[697]);
*(vp++) = U00*I0[698] + U40*I1[698]
           + (twoo2z)*(I2[698] - (lpoz)*I3[698]);
*(vp++) = U00*I0[699] + U40*I1[699]
           + (twoo2z)*(I2[699] - (lpoz)*I3[699]);
*(vp++) = U00*I0[700] + U40*I1[700]
           + (twoo2z)*(I2[700] - (lpoz)*I3[700])
           + (sixo2zn)*I4[525];
*(vp++) = U00*I0[701] + U40*I1[701]
           + (twoo2z)*(I2[701] - (lpoz)*I3[701])
           + (fiveo2zn)*I4[526];
*(vp++) = U00*I0[702] + U40*I1[702]
           + (twoo2z)*(I2[702] - (lpoz)*I3[702])
           + (fiveo2zn)*I4[527];
*(vp++) = U00*I0[703] + U40*I1[703]
           + (twoo2z)*(I2[703] - (lpoz)*I3[703])
           + (fouro2zn)*I4[528];
*(vp++) = U00*I0[704] + U40*I1[704]
           + (twoo2z)*(I2[704] - (lpoz)*I3[704])
           + (fouro2zn)*I4[529];
*(vp++) = U00*I0[705] + U40*I1[705]
           + (twoo2z)*(I2[705] - (lpoz)*I3[705])
           + (fouro2zn)*I4[530];
*(vp++) = U00*I0[706] + U40*I1[706]
           + (twoo2z)*(I2[706] - (lpoz)*I3[706])
           + (threeo2zn)*I4[531];
*(vp++) = U00*I0[707] + U40*I1[707]
           + (twoo2z)*(I2[707] - (lpoz)*I3[707])
           + (threeo2zn)*I4[532];
*(vp++) = U00*I0[708] + U40*I1[708]
           + (twoo2z)*(I2[708] - (lpoz)*I3[708])
           + (threeo2zn)*I4[533];
*(vp++) = U00*I0[709] + U40*I1[709]
           + (twoo2z)*(I2[709] - (lpoz)*I3[709])
           + (threeo2zn)*I4[534];
*(vp++) = U00*I0[710] + U40*I1[710]
           + (twoo2z)*(I2[710] - (lpoz)*I3[710])
           + (twoo2zn)*I4[535];
*(vp++) = U00*I0[711] + U40*I1[711]
           + (twoo2z)*(I2[711] - (lpoz)*I3[711])
           + (twoo2zn)*I4[536];
*(vp++) = U00*I0[712] + U40*I1[712]
           + (twoo2z)*(I2[712] - (lpoz)*I3[712])
           + (twoo2zn)*I4[537];
*(vp++) = U00*I0[713] + U40*I1[713]
           + (twoo2z)*(I2[713] - (lpoz)*I3[713])
           + (twoo2zn)*I4[538];
*(vp++) = U00*I0[714] + U40*I1[714]
           + (twoo2z)*(I2[714] - (lpoz)*I3[714])
           + (twoo2zn)*I4[539];
*(vp++) = U00*I0[715] + U40*I1[715]
           + (twoo2z)*(I2[715] - (lpoz)*I3[715])
           + (oneo2zn)*I4[540];
*(vp++) = U00*I0[716] + U40*I1[716]
           + (twoo2z)*(I2[716] - (lpoz)*I3[716])
           + (oneo2zn)*I4[541];
*(vp++) = U00*I0[717] + U40*I1[717]
           + (twoo2z)*(I2[717] - (lpoz)*I3[717])
           + (oneo2zn)*I4[542];
*(vp++) = U00*I0[718] + U40*I1[718]
           + (twoo2z)*(I2[718] - (lpoz)*I3[718])
           + (oneo2zn)*I4[543];
*(vp++) = U00*I0[719] + U40*I1[719]
           + (twoo2z)*(I2[719] - (lpoz)*I3[719])
           + (oneo2zn)*I4[544];
*(vp++) = U00*I0[720] + U40*I1[720]
           + (twoo2z)*(I2[720] - (lpoz)*I3[720])
           + (oneo2zn)*I4[545];
*(vp++) = U00*I0[721] + U40*I1[721]
           + (twoo2z)*(I2[721] - (lpoz)*I3[721]);
*(vp++) = U00*I0[722] + U40*I1[722]
           + (twoo2z)*(I2[722] - (lpoz)*I3[722]);
*(vp++) = U00*I0[723] + U40*I1[723]
           + (twoo2z)*(I2[723] - (lpoz)*I3[723]);
*(vp++) = U00*I0[724] + U40*I1[724]
           + (twoo2z)*(I2[724] - (lpoz)*I3[724]);
*(vp++) = U00*I0[725] + U40*I1[725]
           + (twoo2z)*(I2[725] - (lpoz)*I3[725]);
*(vp++) = U00*I0[726] + U40*I1[726]
           + (twoo2z)*(I2[726] - (lpoz)*I3[726]);
*(vp++) = U00*I0[727] + U40*I1[727]
           + (twoo2z)*(I2[727] - (lpoz)*I3[727]);
*(vp++) = U00*I0[728] + U40*I1[728]
           + (twoo2z)*(I2[728] - (lpoz)*I3[728])
           + (sixo2zn)*I4[546];
*(vp++) = U00*I0[729] + U40*I1[729]
           + (twoo2z)*(I2[729] - (lpoz)*I3[729])
           + (fiveo2zn)*I4[547];
*(vp++) = U00*I0[730] + U40*I1[730]
           + (twoo2z)*(I2[730] - (lpoz)*I3[730])
           + (fiveo2zn)*I4[548];
*(vp++) = U00*I0[731] + U40*I1[731]
           + (twoo2z)*(I2[731] - (lpoz)*I3[731])
           + (fouro2zn)*I4[549];
*(vp++) = U00*I0[732] + U40*I1[732]
           + (twoo2z)*(I2[732] - (lpoz)*I3[732])
           + (fouro2zn)*I4[550];
*(vp++) = U00*I0[733] + U40*I1[733]
           + (twoo2z)*(I2[733] - (lpoz)*I3[733])
           + (fouro2zn)*I4[551];
*(vp++) = U00*I0[734] + U40*I1[734]
           + (twoo2z)*(I2[734] - (lpoz)*I3[734])
           + (threeo2zn)*I4[552];
*(vp++) = U00*I0[735] + U40*I1[735]
           + (twoo2z)*(I2[735] - (lpoz)*I3[735])
           + (threeo2zn)*I4[553];
*(vp++) = U00*I0[736] + U40*I1[736]
           + (twoo2z)*(I2[736] - (lpoz)*I3[736])
           + (threeo2zn)*I4[554];
*(vp++) = U00*I0[737] + U40*I1[737]
           + (twoo2z)*(I2[737] - (lpoz)*I3[737])
           + (threeo2zn)*I4[555];
*(vp++) = U00*I0[738] + U40*I1[738]
           + (twoo2z)*(I2[738] - (lpoz)*I3[738])
           + (twoo2zn)*I4[556];
*(vp++) = U00*I0[739] + U40*I1[739]
           + (twoo2z)*(I2[739] - (lpoz)*I3[739])
           + (twoo2zn)*I4[557];
*(vp++) = U00*I0[740] + U40*I1[740]
           + (twoo2z)*(I2[740] - (lpoz)*I3[740])
           + (twoo2zn)*I4[558];
*(vp++) = U00*I0[741] + U40*I1[741]
           + (twoo2z)*(I2[741] - (lpoz)*I3[741])
           + (twoo2zn)*I4[559];
*(vp++) = U00*I0[742] + U40*I1[742]
           + (twoo2z)*(I2[742] - (lpoz)*I3[742])
           + (twoo2zn)*I4[560];
*(vp++) = U00*I0[743] + U40*I1[743]
           + (twoo2z)*(I2[743] - (lpoz)*I3[743])
           + (oneo2zn)*I4[561];
*(vp++) = U00*I0[744] + U40*I1[744]
           + (twoo2z)*(I2[744] - (lpoz)*I3[744])
           + (oneo2zn)*I4[562];
*(vp++) = U00*I0[745] + U40*I1[745]
           + (twoo2z)*(I2[745] - (lpoz)*I3[745])
           + (oneo2zn)*I4[563];
*(vp++) = U00*I0[746] + U40*I1[746]
           + (twoo2z)*(I2[746] - (lpoz)*I3[746])
           + (oneo2zn)*I4[564];
*(vp++) = U00*I0[747] + U40*I1[747]
           + (twoo2z)*(I2[747] - (lpoz)*I3[747])
           + (oneo2zn)*I4[565];
*(vp++) = U00*I0[748] + U40*I1[748]
           + (twoo2z)*(I2[748] - (lpoz)*I3[748])
           + (oneo2zn)*I4[566];
*(vp++) = U00*I0[749] + U40*I1[749]
           + (twoo2z)*(I2[749] - (lpoz)*I3[749]);
*(vp++) = U00*I0[750] + U40*I1[750]
           + (twoo2z)*(I2[750] - (lpoz)*I3[750]);
*(vp++) = U00*I0[751] + U40*I1[751]
           + (twoo2z)*(I2[751] - (lpoz)*I3[751]);
*(vp++) = U00*I0[752] + U40*I1[752]
           + (twoo2z)*(I2[752] - (lpoz)*I3[752]);
*(vp++) = U00*I0[753] + U40*I1[753]
           + (twoo2z)*(I2[753] - (lpoz)*I3[753]);
*(vp++) = U00*I0[754] + U40*I1[754]
           + (twoo2z)*(I2[754] - (lpoz)*I3[754]);
*(vp++) = U00*I0[755] + U40*I1[755]
           + (twoo2z)*(I2[755] - (lpoz)*I3[755]);
*(vp++) = U00*I0[756] + U40*I1[756]
           + (twoo2z)*(I2[756] - (lpoz)*I3[756])
           + (sixo2zn)*I4[567];
*(vp++) = U00*I0[757] + U40*I1[757]
           + (twoo2z)*(I2[757] - (lpoz)*I3[757])
           + (fiveo2zn)*I4[568];
*(vp++) = U00*I0[758] + U40*I1[758]
           + (twoo2z)*(I2[758] - (lpoz)*I3[758])
           + (fiveo2zn)*I4[569];
*(vp++) = U00*I0[759] + U40*I1[759]
           + (twoo2z)*(I2[759] - (lpoz)*I3[759])
           + (fouro2zn)*I4[570];
*(vp++) = U00*I0[760] + U40*I1[760]
           + (twoo2z)*(I2[760] - (lpoz)*I3[760])
           + (fouro2zn)*I4[571];
*(vp++) = U00*I0[761] + U40*I1[761]
           + (twoo2z)*(I2[761] - (lpoz)*I3[761])
           + (fouro2zn)*I4[572];
*(vp++) = U00*I0[762] + U40*I1[762]
           + (twoo2z)*(I2[762] - (lpoz)*I3[762])
           + (threeo2zn)*I4[573];
*(vp++) = U00*I0[763] + U40*I1[763]
           + (twoo2z)*(I2[763] - (lpoz)*I3[763])
           + (threeo2zn)*I4[574];
*(vp++) = U00*I0[764] + U40*I1[764]
           + (twoo2z)*(I2[764] - (lpoz)*I3[764])
           + (threeo2zn)*I4[575];
*(vp++) = U00*I0[765] + U40*I1[765]
           + (twoo2z)*(I2[765] - (lpoz)*I3[765])
           + (threeo2zn)*I4[576];
*(vp++) = U00*I0[766] + U40*I1[766]
           + (twoo2z)*(I2[766] - (lpoz)*I3[766])
           + (twoo2zn)*I4[577];
*(vp++) = U00*I0[767] + U40*I1[767]
           + (twoo2z)*(I2[767] - (lpoz)*I3[767])
           + (twoo2zn)*I4[578];
*(vp++) = U00*I0[768] + U40*I1[768]
           + (twoo2z)*(I2[768] - (lpoz)*I3[768])
           + (twoo2zn)*I4[579];
*(vp++) = U00*I0[769] + U40*I1[769]
           + (twoo2z)*(I2[769] - (lpoz)*I3[769])
           + (twoo2zn)*I4[580];
*(vp++) = U00*I0[770] + U40*I1[770]
           + (twoo2z)*(I2[770] - (lpoz)*I3[770])
           + (twoo2zn)*I4[581];
return vp;
}

REALTYPE *_build_m0i0_3(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2zn;
  REALTYPE twoo2zn;
  REALTYPE threeo2zn;
  REALTYPE fouro2zn;
  REALTYPE fiveo2zn;
  REALTYPE sixo2zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  REALTYPE seveno2z;
  REALTYPE eighto2z;
  oneo2zn = 1.0*Data->oo2zn;
  twoo2zn = 2.0*Data->oo2zn;
  threeo2zn = 3.0*Data->oo2zn;
  fouro2zn = 4.0*Data->oo2zn;
  fiveo2zn = 5.0*Data->oo2zn;
  sixo2zn = 6.0*Data->oo2zn;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  seveno2z = 7.0*Data->oo2z;
  eighto2z = 8.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U40 = Data->U[4][0];
  U41 = Data->U[4][1];
  U42 = Data->U[4][2];


*(vp++) = U00*I0[771] + U40*I1[771]
           + (twoo2z)*(I2[771] - (lpoz)*I3[771])
           + (oneo2zn)*I4[582];
*(vp++) = U00*I0[772] + U40*I1[772]
           + (twoo2z)*(I2[772] - (lpoz)*I3[772])
           + (oneo2zn)*I4[583];
*(vp++) = U00*I0[773] + U40*I1[773]
           + (twoo2z)*(I2[773] - (lpoz)*I3[773])
           + (oneo2zn)*I4[584];
*(vp++) = U00*I0[774] + U40*I1[774]
           + (twoo2z)*(I2[774] - (lpoz)*I3[774])
           + (oneo2zn)*I4[585];
*(vp++) = U00*I0[775] + U40*I1[775]
           + (twoo2z)*(I2[775] - (lpoz)*I3[775])
           + (oneo2zn)*I4[586];
*(vp++) = U00*I0[776] + U40*I1[776]
           + (twoo2z)*(I2[776] - (lpoz)*I3[776])
           + (oneo2zn)*I4[587];
*(vp++) = U00*I0[777] + U40*I1[777]
           + (twoo2z)*(I2[777] - (lpoz)*I3[777]);
*(vp++) = U00*I0[778] + U40*I1[778]
           + (twoo2z)*(I2[778] - (lpoz)*I3[778]);
*(vp++) = U00*I0[779] + U40*I1[779]
           + (twoo2z)*(I2[779] - (lpoz)*I3[779]);
*(vp++) = U00*I0[780] + U40*I1[780]
           + (twoo2z)*(I2[780] - (lpoz)*I3[780]);
*(vp++) = U00*I0[781] + U40*I1[781]
           + (twoo2z)*(I2[781] - (lpoz)*I3[781]);
*(vp++) = U00*I0[782] + U40*I1[782]
           + (twoo2z)*(I2[782] - (lpoz)*I3[782]);
*(vp++) = U00*I0[783] + U40*I1[783]
           + (twoo2z)*(I2[783] - (lpoz)*I3[783]);
*(vp++) = U00*I0[784] + U40*I1[784]
           + (oneo2z)*(I2[784] - (lpoz)*I3[784])
           + (sixo2zn)*I4[588];
*(vp++) = U00*I0[785] + U40*I1[785]
           + (oneo2z)*(I2[785] - (lpoz)*I3[785])
           + (fiveo2zn)*I4[589];
*(vp++) = U00*I0[786] + U40*I1[786]
           + (oneo2z)*(I2[786] - (lpoz)*I3[786])
           + (fiveo2zn)*I4[590];
*(vp++) = U00*I0[787] + U40*I1[787]
           + (oneo2z)*(I2[787] - (lpoz)*I3[787])
           + (fouro2zn)*I4[591];
*(vp++) = U00*I0[788] + U40*I1[788]
           + (oneo2z)*(I2[788] - (lpoz)*I3[788])
           + (fouro2zn)*I4[592];
*(vp++) = U00*I0[789] + U40*I1[789]
           + (oneo2z)*(I2[789] - (lpoz)*I3[789])
           + (fouro2zn)*I4[593];
*(vp++) = U00*I0[790] + U40*I1[790]
           + (oneo2z)*(I2[790] - (lpoz)*I3[790])
           + (threeo2zn)*I4[594];
*(vp++) = U00*I0[791] + U40*I1[791]
           + (oneo2z)*(I2[791] - (lpoz)*I3[791])
           + (threeo2zn)*I4[595];
*(vp++) = U00*I0[792] + U40*I1[792]
           + (oneo2z)*(I2[792] - (lpoz)*I3[792])
           + (threeo2zn)*I4[596];
*(vp++) = U00*I0[793] + U40*I1[793]
           + (oneo2z)*(I2[793] - (lpoz)*I3[793])
           + (threeo2zn)*I4[597];
*(vp++) = U00*I0[794] + U40*I1[794]
           + (oneo2z)*(I2[794] - (lpoz)*I3[794])
           + (twoo2zn)*I4[598];
*(vp++) = U00*I0[795] + U40*I1[795]
           + (oneo2z)*(I2[795] - (lpoz)*I3[795])
           + (twoo2zn)*I4[599];
*(vp++) = U00*I0[796] + U40*I1[796]
           + (oneo2z)*(I2[796] - (lpoz)*I3[796])
           + (twoo2zn)*I4[600];
*(vp++) = U00*I0[797] + U40*I1[797]
           + (oneo2z)*(I2[797] - (lpoz)*I3[797])
           + (twoo2zn)*I4[601];
*(vp++) = U00*I0[798] + U40*I1[798]
           + (oneo2z)*(I2[798] - (lpoz)*I3[798])
           + (twoo2zn)*I4[602];
*(vp++) = U00*I0[799] + U40*I1[799]
           + (oneo2z)*(I2[799] - (lpoz)*I3[799])
           + (oneo2zn)*I4[603];
*(vp++) = U00*I0[800] + U40*I1[800]
           + (oneo2z)*(I2[800] - (lpoz)*I3[800])
           + (oneo2zn)*I4[604];
*(vp++) = U00*I0[801] + U40*I1[801]
           + (oneo2z)*(I2[801] - (lpoz)*I3[801])
           + (oneo2zn)*I4[605];
*(vp++) = U00*I0[802] + U40*I1[802]
           + (oneo2z)*(I2[802] - (lpoz)*I3[802])
           + (oneo2zn)*I4[606];
*(vp++) = U00*I0[803] + U40*I1[803]
           + (oneo2z)*(I2[803] - (lpoz)*I3[803])
           + (oneo2zn)*I4[607];
*(vp++) = U00*I0[804] + U40*I1[804]
           + (oneo2z)*(I2[804] - (lpoz)*I3[804])
           + (oneo2zn)*I4[608];
*(vp++) = U00*I0[805] + U40*I1[805]
           + (oneo2z)*(I2[805] - (lpoz)*I3[805]);
*(vp++) = U00*I0[806] + U40*I1[806]
           + (oneo2z)*(I2[806] - (lpoz)*I3[806]);
*(vp++) = U00*I0[807] + U40*I1[807]
           + (oneo2z)*(I2[807] - (lpoz)*I3[807]);
*(vp++) = U00*I0[808] + U40*I1[808]
           + (oneo2z)*(I2[808] - (lpoz)*I3[808]);
*(vp++) = U00*I0[809] + U40*I1[809]
           + (oneo2z)*(I2[809] - (lpoz)*I3[809]);
*(vp++) = U00*I0[810] + U40*I1[810]
           + (oneo2z)*(I2[810] - (lpoz)*I3[810]);
*(vp++) = U00*I0[811] + U40*I1[811]
           + (oneo2z)*(I2[811] - (lpoz)*I3[811]);
*(vp++) = U00*I0[812] + U40*I1[812]
           + (oneo2z)*(I2[812] - (lpoz)*I3[812])
           + (sixo2zn)*I4[609];
*(vp++) = U00*I0[813] + U40*I1[813]
           + (oneo2z)*(I2[813] - (lpoz)*I3[813])
           + (fiveo2zn)*I4[610];
*(vp++) = U00*I0[814] + U40*I1[814]
           + (oneo2z)*(I2[814] - (lpoz)*I3[814])
           + (fiveo2zn)*I4[611];
*(vp++) = U00*I0[815] + U40*I1[815]
           + (oneo2z)*(I2[815] - (lpoz)*I3[815])
           + (fouro2zn)*I4[612];
*(vp++) = U00*I0[816] + U40*I1[816]
           + (oneo2z)*(I2[816] - (lpoz)*I3[816])
           + (fouro2zn)*I4[613];
*(vp++) = U00*I0[817] + U40*I1[817]
           + (oneo2z)*(I2[817] - (lpoz)*I3[817])
           + (fouro2zn)*I4[614];
*(vp++) = U00*I0[818] + U40*I1[818]
           + (oneo2z)*(I2[818] - (lpoz)*I3[818])
           + (threeo2zn)*I4[615];
*(vp++) = U00*I0[819] + U40*I1[819]
           + (oneo2z)*(I2[819] - (lpoz)*I3[819])
           + (threeo2zn)*I4[616];
*(vp++) = U00*I0[820] + U40*I1[820]
           + (oneo2z)*(I2[820] - (lpoz)*I3[820])
           + (threeo2zn)*I4[617];
*(vp++) = U00*I0[821] + U40*I1[821]
           + (oneo2z)*(I2[821] - (lpoz)*I3[821])
           + (threeo2zn)*I4[618];
*(vp++) = U00*I0[822] + U40*I1[822]
           + (oneo2z)*(I2[822] - (lpoz)*I3[822])
           + (twoo2zn)*I4[619];
*(vp++) = U00*I0[823] + U40*I1[823]
           + (oneo2z)*(I2[823] - (lpoz)*I3[823])
           + (twoo2zn)*I4[620];
*(vp++) = U00*I0[824] + U40*I1[824]
           + (oneo2z)*(I2[824] - (lpoz)*I3[824])
           + (twoo2zn)*I4[621];
*(vp++) = U00*I0[825] + U40*I1[825]
           + (oneo2z)*(I2[825] - (lpoz)*I3[825])
           + (twoo2zn)*I4[622];
*(vp++) = U00*I0[826] + U40*I1[826]
           + (oneo2z)*(I2[826] - (lpoz)*I3[826])
           + (twoo2zn)*I4[623];
*(vp++) = U00*I0[827] + U40*I1[827]
           + (oneo2z)*(I2[827] - (lpoz)*I3[827])
           + (oneo2zn)*I4[624];
*(vp++) = U00*I0[828] + U40*I1[828]
           + (oneo2z)*(I2[828] - (lpoz)*I3[828])
           + (oneo2zn)*I4[625];
*(vp++) = U00*I0[829] + U40*I1[829]
           + (oneo2z)*(I2[829] - (lpoz)*I3[829])
           + (oneo2zn)*I4[626];
*(vp++) = U00*I0[830] + U40*I1[830]
           + (oneo2z)*(I2[830] - (lpoz)*I3[830])
           + (oneo2zn)*I4[627];
*(vp++) = U00*I0[831] + U40*I1[831]
           + (oneo2z)*(I2[831] - (lpoz)*I3[831])
           + (oneo2zn)*I4[628];
*(vp++) = U00*I0[832] + U40*I1[832]
           + (oneo2z)*(I2[832] - (lpoz)*I3[832])
           + (oneo2zn)*I4[629];
*(vp++) = U00*I0[833] + U40*I1[833]
           + (oneo2z)*(I2[833] - (lpoz)*I3[833]);
*(vp++) = U00*I0[834] + U40*I1[834]
           + (oneo2z)*(I2[834] - (lpoz)*I3[834]);
*(vp++) = U00*I0[835] + U40*I1[835]
           + (oneo2z)*(I2[835] - (lpoz)*I3[835]);
*(vp++) = U00*I0[836] + U40*I1[836]
           + (oneo2z)*(I2[836] - (lpoz)*I3[836]);
*(vp++) = U00*I0[837] + U40*I1[837]
           + (oneo2z)*(I2[837] - (lpoz)*I3[837]);
*(vp++) = U00*I0[838] + U40*I1[838]
           + (oneo2z)*(I2[838] - (lpoz)*I3[838]);
*(vp++) = U00*I0[839] + U40*I1[839]
           + (oneo2z)*(I2[839] - (lpoz)*I3[839]);
*(vp++) = U00*I0[840] + U40*I1[840]
           + (oneo2z)*(I2[840] - (lpoz)*I3[840])
           + (sixo2zn)*I4[630];
*(vp++) = U00*I0[841] + U40*I1[841]
           + (oneo2z)*(I2[841] - (lpoz)*I3[841])
           + (fiveo2zn)*I4[631];
*(vp++) = U00*I0[842] + U40*I1[842]
           + (oneo2z)*(I2[842] - (lpoz)*I3[842])
           + (fiveo2zn)*I4[632];
*(vp++) = U00*I0[843] + U40*I1[843]
           + (oneo2z)*(I2[843] - (lpoz)*I3[843])
           + (fouro2zn)*I4[633];
*(vp++) = U00*I0[844] + U40*I1[844]
           + (oneo2z)*(I2[844] - (lpoz)*I3[844])
           + (fouro2zn)*I4[634];
*(vp++) = U00*I0[845] + U40*I1[845]
           + (oneo2z)*(I2[845] - (lpoz)*I3[845])
           + (fouro2zn)*I4[635];
*(vp++) = U00*I0[846] + U40*I1[846]
           + (oneo2z)*(I2[846] - (lpoz)*I3[846])
           + (threeo2zn)*I4[636];
*(vp++) = U00*I0[847] + U40*I1[847]
           + (oneo2z)*(I2[847] - (lpoz)*I3[847])
           + (threeo2zn)*I4[637];
*(vp++) = U00*I0[848] + U40*I1[848]
           + (oneo2z)*(I2[848] - (lpoz)*I3[848])
           + (threeo2zn)*I4[638];
*(vp++) = U00*I0[849] + U40*I1[849]
           + (oneo2z)*(I2[849] - (lpoz)*I3[849])
           + (threeo2zn)*I4[639];
*(vp++) = U00*I0[850] + U40*I1[850]
           + (oneo2z)*(I2[850] - (lpoz)*I3[850])
           + (twoo2zn)*I4[640];
*(vp++) = U00*I0[851] + U40*I1[851]
           + (oneo2z)*(I2[851] - (lpoz)*I3[851])
           + (twoo2zn)*I4[641];
*(vp++) = U00*I0[852] + U40*I1[852]
           + (oneo2z)*(I2[852] - (lpoz)*I3[852])
           + (twoo2zn)*I4[642];
*(vp++) = U00*I0[853] + U40*I1[853]
           + (oneo2z)*(I2[853] - (lpoz)*I3[853])
           + (twoo2zn)*I4[643];
*(vp++) = U00*I0[854] + U40*I1[854]
           + (oneo2z)*(I2[854] - (lpoz)*I3[854])
           + (twoo2zn)*I4[644];
*(vp++) = U00*I0[855] + U40*I1[855]
           + (oneo2z)*(I2[855] - (lpoz)*I3[855])
           + (oneo2zn)*I4[645];
*(vp++) = U00*I0[856] + U40*I1[856]
           + (oneo2z)*(I2[856] - (lpoz)*I3[856])
           + (oneo2zn)*I4[646];
*(vp++) = U00*I0[857] + U40*I1[857]
           + (oneo2z)*(I2[857] - (lpoz)*I3[857])
           + (oneo2zn)*I4[647];
*(vp++) = U00*I0[858] + U40*I1[858]
           + (oneo2z)*(I2[858] - (lpoz)*I3[858])
           + (oneo2zn)*I4[648];
*(vp++) = U00*I0[859] + U40*I1[859]
           + (oneo2z)*(I2[859] - (lpoz)*I3[859])
           + (oneo2zn)*I4[649];
*(vp++) = U00*I0[860] + U40*I1[860]
           + (oneo2z)*(I2[860] - (lpoz)*I3[860])
           + (oneo2zn)*I4[650];
*(vp++) = U00*I0[861] + U40*I1[861]
           + (oneo2z)*(I2[861] - (lpoz)*I3[861]);
*(vp++) = U00*I0[862] + U40*I1[862]
           + (oneo2z)*(I2[862] - (lpoz)*I3[862]);
*(vp++) = U00*I0[863] + U40*I1[863]
           + (oneo2z)*(I2[863] - (lpoz)*I3[863]);
*(vp++) = U00*I0[864] + U40*I1[864]
           + (oneo2z)*(I2[864] - (lpoz)*I3[864]);
*(vp++) = U00*I0[865] + U40*I1[865]
           + (oneo2z)*(I2[865] - (lpoz)*I3[865]);
*(vp++) = U00*I0[866] + U40*I1[866]
           + (oneo2z)*(I2[866] - (lpoz)*I3[866]);
*(vp++) = U00*I0[867] + U40*I1[867]
           + (oneo2z)*(I2[867] - (lpoz)*I3[867]);
*(vp++) = U00*I0[868] + U40*I1[868]
           + (oneo2z)*(I2[868] - (lpoz)*I3[868])
           + (sixo2zn)*I4[651];
*(vp++) = U00*I0[869] + U40*I1[869]
           + (oneo2z)*(I2[869] - (lpoz)*I3[869])
           + (fiveo2zn)*I4[652];
*(vp++) = U00*I0[870] + U40*I1[870]
           + (oneo2z)*(I2[870] - (lpoz)*I3[870])
           + (fiveo2zn)*I4[653];
*(vp++) = U00*I0[871] + U40*I1[871]
           + (oneo2z)*(I2[871] - (lpoz)*I3[871])
           + (fouro2zn)*I4[654];
*(vp++) = U00*I0[872] + U40*I1[872]
           + (oneo2z)*(I2[872] - (lpoz)*I3[872])
           + (fouro2zn)*I4[655];
*(vp++) = U00*I0[873] + U40*I1[873]
           + (oneo2z)*(I2[873] - (lpoz)*I3[873])
           + (fouro2zn)*I4[656];
*(vp++) = U00*I0[874] + U40*I1[874]
           + (oneo2z)*(I2[874] - (lpoz)*I3[874])
           + (threeo2zn)*I4[657];
*(vp++) = U00*I0[875] + U40*I1[875]
           + (oneo2z)*(I2[875] - (lpoz)*I3[875])
           + (threeo2zn)*I4[658];
*(vp++) = U00*I0[876] + U40*I1[876]
           + (oneo2z)*(I2[876] - (lpoz)*I3[876])
           + (threeo2zn)*I4[659];
*(vp++) = U00*I0[877] + U40*I1[877]
           + (oneo2z)*(I2[877] - (lpoz)*I3[877])
           + (threeo2zn)*I4[660];
*(vp++) = U00*I0[878] + U40*I1[878]
           + (oneo2z)*(I2[878] - (lpoz)*I3[878])
           + (twoo2zn)*I4[661];
*(vp++) = U00*I0[879] + U40*I1[879]
           + (oneo2z)*(I2[879] - (lpoz)*I3[879])
           + (twoo2zn)*I4[662];
*(vp++) = U00*I0[880] + U40*I1[880]
           + (oneo2z)*(I2[880] - (lpoz)*I3[880])
           + (twoo2zn)*I4[663];
*(vp++) = U00*I0[881] + U40*I1[881]
           + (oneo2z)*(I2[881] - (lpoz)*I3[881])
           + (twoo2zn)*I4[664];
*(vp++) = U00*I0[882] + U40*I1[882]
           + (oneo2z)*(I2[882] - (lpoz)*I3[882])
           + (twoo2zn)*I4[665];
*(vp++) = U00*I0[883] + U40*I1[883]
           + (oneo2z)*(I2[883] - (lpoz)*I3[883])
           + (oneo2zn)*I4[666];
*(vp++) = U00*I0[884] + U40*I1[884]
           + (oneo2z)*(I2[884] - (lpoz)*I3[884])
           + (oneo2zn)*I4[667];
*(vp++) = U00*I0[885] + U40*I1[885]
           + (oneo2z)*(I2[885] - (lpoz)*I3[885])
           + (oneo2zn)*I4[668];
*(vp++) = U00*I0[886] + U40*I1[886]
           + (oneo2z)*(I2[886] - (lpoz)*I3[886])
           + (oneo2zn)*I4[669];
*(vp++) = U00*I0[887] + U40*I1[887]
           + (oneo2z)*(I2[887] - (lpoz)*I3[887])
           + (oneo2zn)*I4[670];
*(vp++) = U00*I0[888] + U40*I1[888]
           + (oneo2z)*(I2[888] - (lpoz)*I3[888])
           + (oneo2zn)*I4[671];
*(vp++) = U00*I0[889] + U40*I1[889]
           + (oneo2z)*(I2[889] - (lpoz)*I3[889]);
*(vp++) = U00*I0[890] + U40*I1[890]
           + (oneo2z)*(I2[890] - (lpoz)*I3[890]);
*(vp++) = U00*I0[891] + U40*I1[891]
           + (oneo2z)*(I2[891] - (lpoz)*I3[891]);
*(vp++) = U00*I0[892] + U40*I1[892]
           + (oneo2z)*(I2[892] - (lpoz)*I3[892]);
*(vp++) = U00*I0[893] + U40*I1[893]
           + (oneo2z)*(I2[893] - (lpoz)*I3[893]);
*(vp++) = U00*I0[894] + U40*I1[894]
           + (oneo2z)*(I2[894] - (lpoz)*I3[894]);
*(vp++) = U00*I0[895] + U40*I1[895]
           + (oneo2z)*(I2[895] - (lpoz)*I3[895]);
*(vp++) = U00*I0[896] + U40*I1[896]
           + (oneo2z)*(I2[896] - (lpoz)*I3[896])
           + (sixo2zn)*I4[672];
*(vp++) = U00*I0[897] + U40*I1[897]
           + (oneo2z)*(I2[897] - (lpoz)*I3[897])
           + (fiveo2zn)*I4[673];
*(vp++) = U00*I0[898] + U40*I1[898]
           + (oneo2z)*(I2[898] - (lpoz)*I3[898])
           + (fiveo2zn)*I4[674];
*(vp++) = U00*I0[899] + U40*I1[899]
           + (oneo2z)*(I2[899] - (lpoz)*I3[899])
           + (fouro2zn)*I4[675];
*(vp++) = U00*I0[900] + U40*I1[900]
           + (oneo2z)*(I2[900] - (lpoz)*I3[900])
           + (fouro2zn)*I4[676];
*(vp++) = U00*I0[901] + U40*I1[901]
           + (oneo2z)*(I2[901] - (lpoz)*I3[901])
           + (fouro2zn)*I4[677];
*(vp++) = U00*I0[902] + U40*I1[902]
           + (oneo2z)*(I2[902] - (lpoz)*I3[902])
           + (threeo2zn)*I4[678];
*(vp++) = U00*I0[903] + U40*I1[903]
           + (oneo2z)*(I2[903] - (lpoz)*I3[903])
           + (threeo2zn)*I4[679];
*(vp++) = U00*I0[904] + U40*I1[904]
           + (oneo2z)*(I2[904] - (lpoz)*I3[904])
           + (threeo2zn)*I4[680];
*(vp++) = U00*I0[905] + U40*I1[905]
           + (oneo2z)*(I2[905] - (lpoz)*I3[905])
           + (threeo2zn)*I4[681];
*(vp++) = U00*I0[906] + U40*I1[906]
           + (oneo2z)*(I2[906] - (lpoz)*I3[906])
           + (twoo2zn)*I4[682];
*(vp++) = U00*I0[907] + U40*I1[907]
           + (oneo2z)*(I2[907] - (lpoz)*I3[907])
           + (twoo2zn)*I4[683];
*(vp++) = U00*I0[908] + U40*I1[908]
           + (oneo2z)*(I2[908] - (lpoz)*I3[908])
           + (twoo2zn)*I4[684];
*(vp++) = U00*I0[909] + U40*I1[909]
           + (oneo2z)*(I2[909] - (lpoz)*I3[909])
           + (twoo2zn)*I4[685];
*(vp++) = U00*I0[910] + U40*I1[910]
           + (oneo2z)*(I2[910] - (lpoz)*I3[910])
           + (twoo2zn)*I4[686];
*(vp++) = U00*I0[911] + U40*I1[911]
           + (oneo2z)*(I2[911] - (lpoz)*I3[911])
           + (oneo2zn)*I4[687];
*(vp++) = U00*I0[912] + U40*I1[912]
           + (oneo2z)*(I2[912] - (lpoz)*I3[912])
           + (oneo2zn)*I4[688];
*(vp++) = U00*I0[913] + U40*I1[913]
           + (oneo2z)*(I2[913] - (lpoz)*I3[913])
           + (oneo2zn)*I4[689];
*(vp++) = U00*I0[914] + U40*I1[914]
           + (oneo2z)*(I2[914] - (lpoz)*I3[914])
           + (oneo2zn)*I4[690];
*(vp++) = U00*I0[915] + U40*I1[915]
           + (oneo2z)*(I2[915] - (lpoz)*I3[915])
           + (oneo2zn)*I4[691];
*(vp++) = U00*I0[916] + U40*I1[916]
           + (oneo2z)*(I2[916] - (lpoz)*I3[916])
           + (oneo2zn)*I4[692];
*(vp++) = U00*I0[917] + U40*I1[917]
           + (oneo2z)*(I2[917] - (lpoz)*I3[917]);
*(vp++) = U00*I0[918] + U40*I1[918]
           + (oneo2z)*(I2[918] - (lpoz)*I3[918]);
*(vp++) = U00*I0[919] + U40*I1[919]
           + (oneo2z)*(I2[919] - (lpoz)*I3[919]);
*(vp++) = U00*I0[920] + U40*I1[920]
           + (oneo2z)*(I2[920] - (lpoz)*I3[920]);
*(vp++) = U00*I0[921] + U40*I1[921]
           + (oneo2z)*(I2[921] - (lpoz)*I3[921]);
*(vp++) = U00*I0[922] + U40*I1[922]
           + (oneo2z)*(I2[922] - (lpoz)*I3[922]);
*(vp++) = U00*I0[923] + U40*I1[923]
           + (oneo2z)*(I2[923] - (lpoz)*I3[923]);
*(vp++) = U00*I0[924] + U40*I1[924]
           + (oneo2z)*(I2[924] - (lpoz)*I3[924])
           + (sixo2zn)*I4[693];
*(vp++) = U00*I0[925] + U40*I1[925]
           + (oneo2z)*(I2[925] - (lpoz)*I3[925])
           + (fiveo2zn)*I4[694];
*(vp++) = U00*I0[926] + U40*I1[926]
           + (oneo2z)*(I2[926] - (lpoz)*I3[926])
           + (fiveo2zn)*I4[695];
*(vp++) = U00*I0[927] + U40*I1[927]
           + (oneo2z)*(I2[927] - (lpoz)*I3[927])
           + (fouro2zn)*I4[696];
*(vp++) = U00*I0[928] + U40*I1[928]
           + (oneo2z)*(I2[928] - (lpoz)*I3[928])
           + (fouro2zn)*I4[697];
*(vp++) = U00*I0[929] + U40*I1[929]
           + (oneo2z)*(I2[929] - (lpoz)*I3[929])
           + (fouro2zn)*I4[698];
*(vp++) = U00*I0[930] + U40*I1[930]
           + (oneo2z)*(I2[930] - (lpoz)*I3[930])
           + (threeo2zn)*I4[699];
*(vp++) = U00*I0[931] + U40*I1[931]
           + (oneo2z)*(I2[931] - (lpoz)*I3[931])
           + (threeo2zn)*I4[700];
*(vp++) = U00*I0[932] + U40*I1[932]
           + (oneo2z)*(I2[932] - (lpoz)*I3[932])
           + (threeo2zn)*I4[701];
*(vp++) = U00*I0[933] + U40*I1[933]
           + (oneo2z)*(I2[933] - (lpoz)*I3[933])
           + (threeo2zn)*I4[702];
*(vp++) = U00*I0[934] + U40*I1[934]
           + (oneo2z)*(I2[934] - (lpoz)*I3[934])
           + (twoo2zn)*I4[703];
*(vp++) = U00*I0[935] + U40*I1[935]
           + (oneo2z)*(I2[935] - (lpoz)*I3[935])
           + (twoo2zn)*I4[704];
*(vp++) = U00*I0[936] + U40*I1[936]
           + (oneo2z)*(I2[936] - (lpoz)*I3[936])
           + (twoo2zn)*I4[705];
*(vp++) = U00*I0[937] + U40*I1[937]
           + (oneo2z)*(I2[937] - (lpoz)*I3[937])
           + (twoo2zn)*I4[706];
*(vp++) = U00*I0[938] + U40*I1[938]
           + (oneo2z)*(I2[938] - (lpoz)*I3[938])
           + (twoo2zn)*I4[707];
*(vp++) = U00*I0[939] + U40*I1[939]
           + (oneo2z)*(I2[939] - (lpoz)*I3[939])
           + (oneo2zn)*I4[708];
*(vp++) = U00*I0[940] + U40*I1[940]
           + (oneo2z)*(I2[940] - (lpoz)*I3[940])
           + (oneo2zn)*I4[709];
*(vp++) = U00*I0[941] + U40*I1[941]
           + (oneo2z)*(I2[941] - (lpoz)*I3[941])
           + (oneo2zn)*I4[710];
*(vp++) = U00*I0[942] + U40*I1[942]
           + (oneo2z)*(I2[942] - (lpoz)*I3[942])
           + (oneo2zn)*I4[711];
*(vp++) = U00*I0[943] + U40*I1[943]
           + (oneo2z)*(I2[943] - (lpoz)*I3[943])
           + (oneo2zn)*I4[712];
*(vp++) = U00*I0[944] + U40*I1[944]
           + (oneo2z)*(I2[944] - (lpoz)*I3[944])
           + (oneo2zn)*I4[713];
*(vp++) = U00*I0[945] + U40*I1[945]
           + (oneo2z)*(I2[945] - (lpoz)*I3[945]);
*(vp++) = U00*I0[946] + U40*I1[946]
           + (oneo2z)*(I2[946] - (lpoz)*I3[946]);
*(vp++) = U00*I0[947] + U40*I1[947]
           + (oneo2z)*(I2[947] - (lpoz)*I3[947]);
*(vp++) = U00*I0[948] + U40*I1[948]
           + (oneo2z)*(I2[948] - (lpoz)*I3[948]);
*(vp++) = U00*I0[949] + U40*I1[949]
           + (oneo2z)*(I2[949] - (lpoz)*I3[949]);
*(vp++) = U00*I0[950] + U40*I1[950]
           + (oneo2z)*(I2[950] - (lpoz)*I3[950]);
*(vp++) = U00*I0[951] + U40*I1[951]
           + (oneo2z)*(I2[951] - (lpoz)*I3[951]);
*(vp++) = U00*I0[952] + U40*I1[952]
           + (oneo2z)*(I2[952] - (lpoz)*I3[952])
           + (sixo2zn)*I4[714];
*(vp++) = U00*I0[953] + U40*I1[953]
           + (oneo2z)*(I2[953] - (lpoz)*I3[953])
           + (fiveo2zn)*I4[715];
*(vp++) = U00*I0[954] + U40*I1[954]
           + (oneo2z)*(I2[954] - (lpoz)*I3[954])
           + (fiveo2zn)*I4[716];
*(vp++) = U00*I0[955] + U40*I1[955]
           + (oneo2z)*(I2[955] - (lpoz)*I3[955])
           + (fouro2zn)*I4[717];
*(vp++) = U00*I0[956] + U40*I1[956]
           + (oneo2z)*(I2[956] - (lpoz)*I3[956])
           + (fouro2zn)*I4[718];
*(vp++) = U00*I0[957] + U40*I1[957]
           + (oneo2z)*(I2[957] - (lpoz)*I3[957])
           + (fouro2zn)*I4[719];
*(vp++) = U00*I0[958] + U40*I1[958]
           + (oneo2z)*(I2[958] - (lpoz)*I3[958])
           + (threeo2zn)*I4[720];
*(vp++) = U00*I0[959] + U40*I1[959]
           + (oneo2z)*(I2[959] - (lpoz)*I3[959])
           + (threeo2zn)*I4[721];
*(vp++) = U00*I0[960] + U40*I1[960]
           + (oneo2z)*(I2[960] - (lpoz)*I3[960])
           + (threeo2zn)*I4[722];
*(vp++) = U00*I0[961] + U40*I1[961]
           + (oneo2z)*(I2[961] - (lpoz)*I3[961])
           + (threeo2zn)*I4[723];
*(vp++) = U00*I0[962] + U40*I1[962]
           + (oneo2z)*(I2[962] - (lpoz)*I3[962])
           + (twoo2zn)*I4[724];
*(vp++) = U00*I0[963] + U40*I1[963]
           + (oneo2z)*(I2[963] - (lpoz)*I3[963])
           + (twoo2zn)*I4[725];
*(vp++) = U00*I0[964] + U40*I1[964]
           + (oneo2z)*(I2[964] - (lpoz)*I3[964])
           + (twoo2zn)*I4[726];
*(vp++) = U00*I0[965] + U40*I1[965]
           + (oneo2z)*(I2[965] - (lpoz)*I3[965])
           + (twoo2zn)*I4[727];
*(vp++) = U00*I0[966] + U40*I1[966]
           + (oneo2z)*(I2[966] - (lpoz)*I3[966])
           + (twoo2zn)*I4[728];
*(vp++) = U00*I0[967] + U40*I1[967]
           + (oneo2z)*(I2[967] - (lpoz)*I3[967])
           + (oneo2zn)*I4[729];
*(vp++) = U00*I0[968] + U40*I1[968]
           + (oneo2z)*(I2[968] - (lpoz)*I3[968])
           + (oneo2zn)*I4[730];
*(vp++) = U00*I0[969] + U40*I1[969]
           + (oneo2z)*(I2[969] - (lpoz)*I3[969])
           + (oneo2zn)*I4[731];
*(vp++) = U00*I0[970] + U40*I1[970]
           + (oneo2z)*(I2[970] - (lpoz)*I3[970])
           + (oneo2zn)*I4[732];
*(vp++) = U00*I0[971] + U40*I1[971]
           + (oneo2z)*(I2[971] - (lpoz)*I3[971])
           + (oneo2zn)*I4[733];
*(vp++) = U00*I0[972] + U40*I1[972]
           + (oneo2z)*(I2[972] - (lpoz)*I3[972])
           + (oneo2zn)*I4[734];
*(vp++) = U00*I0[973] + U40*I1[973]
           + (oneo2z)*(I2[973] - (lpoz)*I3[973]);
*(vp++) = U00*I0[974] + U40*I1[974]
           + (oneo2z)*(I2[974] - (lpoz)*I3[974]);
*(vp++) = U00*I0[975] + U40*I1[975]
           + (oneo2z)*(I2[975] - (lpoz)*I3[975]);
*(vp++) = U00*I0[976] + U40*I1[976]
           + (oneo2z)*(I2[976] - (lpoz)*I3[976]);
*(vp++) = U00*I0[977] + U40*I1[977]
           + (oneo2z)*(I2[977] - (lpoz)*I3[977]);
*(vp++) = U00*I0[978] + U40*I1[978]
           + (oneo2z)*(I2[978] - (lpoz)*I3[978]);
*(vp++) = U00*I0[979] + U40*I1[979]
           + (oneo2z)*(I2[979] - (lpoz)*I3[979]);
*(vp++) = U00*I0[980] + U40*I1[980]
           + (oneo2z)*(I2[980] - (lpoz)*I3[980])
           + (sixo2zn)*I4[735];
*(vp++) = U00*I0[981] + U40*I1[981]
           + (oneo2z)*(I2[981] - (lpoz)*I3[981])
           + (fiveo2zn)*I4[736];
*(vp++) = U00*I0[982] + U40*I1[982]
           + (oneo2z)*(I2[982] - (lpoz)*I3[982])
           + (fiveo2zn)*I4[737];
*(vp++) = U00*I0[983] + U40*I1[983]
           + (oneo2z)*(I2[983] - (lpoz)*I3[983])
           + (fouro2zn)*I4[738];
*(vp++) = U00*I0[984] + U40*I1[984]
           + (oneo2z)*(I2[984] - (lpoz)*I3[984])
           + (fouro2zn)*I4[739];
*(vp++) = U00*I0[985] + U40*I1[985]
           + (oneo2z)*(I2[985] - (lpoz)*I3[985])
           + (fouro2zn)*I4[740];
*(vp++) = U00*I0[986] + U40*I1[986]
           + (oneo2z)*(I2[986] - (lpoz)*I3[986])
           + (threeo2zn)*I4[741];
*(vp++) = U00*I0[987] + U40*I1[987]
           + (oneo2z)*(I2[987] - (lpoz)*I3[987])
           + (threeo2zn)*I4[742];
*(vp++) = U00*I0[988] + U40*I1[988]
           + (oneo2z)*(I2[988] - (lpoz)*I3[988])
           + (threeo2zn)*I4[743];
*(vp++) = U00*I0[989] + U40*I1[989]
           + (oneo2z)*(I2[989] - (lpoz)*I3[989])
           + (threeo2zn)*I4[744];
*(vp++) = U00*I0[990] + U40*I1[990]
           + (oneo2z)*(I2[990] - (lpoz)*I3[990])
           + (twoo2zn)*I4[745];
*(vp++) = U00*I0[991] + U40*I1[991]
           + (oneo2z)*(I2[991] - (lpoz)*I3[991])
           + (twoo2zn)*I4[746];
*(vp++) = U00*I0[992] + U40*I1[992]
           + (oneo2z)*(I2[992] - (lpoz)*I3[992])
           + (twoo2zn)*I4[747];
*(vp++) = U00*I0[993] + U40*I1[993]
           + (oneo2z)*(I2[993] - (lpoz)*I3[993])
           + (twoo2zn)*I4[748];
*(vp++) = U00*I0[994] + U40*I1[994]
           + (oneo2z)*(I2[994] - (lpoz)*I3[994])
           + (twoo2zn)*I4[749];
*(vp++) = U00*I0[995] + U40*I1[995]
           + (oneo2z)*(I2[995] - (lpoz)*I3[995])
           + (oneo2zn)*I4[750];
*(vp++) = U00*I0[996] + U40*I1[996]
           + (oneo2z)*(I2[996] - (lpoz)*I3[996])
           + (oneo2zn)*I4[751];
*(vp++) = U00*I0[997] + U40*I1[997]
           + (oneo2z)*(I2[997] - (lpoz)*I3[997])
           + (oneo2zn)*I4[752];
*(vp++) = U00*I0[998] + U40*I1[998]
           + (oneo2z)*(I2[998] - (lpoz)*I3[998])
           + (oneo2zn)*I4[753];
*(vp++) = U00*I0[999] + U40*I1[999]
           + (oneo2z)*(I2[999] - (lpoz)*I3[999])
           + (oneo2zn)*I4[754];
*(vp++) = U00*I0[1000] + U40*I1[1000]
           + (oneo2z)*(I2[1000] - (lpoz)*I3[1000])
           + (oneo2zn)*I4[755];
*(vp++) = U00*I0[1001] + U40*I1[1001]
           + (oneo2z)*(I2[1001] - (lpoz)*I3[1001]);
*(vp++) = U00*I0[1002] + U40*I1[1002]
           + (oneo2z)*(I2[1002] - (lpoz)*I3[1002]);
*(vp++) = U00*I0[1003] + U40*I1[1003]
           + (oneo2z)*(I2[1003] - (lpoz)*I3[1003]);
*(vp++) = U00*I0[1004] + U40*I1[1004]
           + (oneo2z)*(I2[1004] - (lpoz)*I3[1004]);
*(vp++) = U00*I0[1005] + U40*I1[1005]
           + (oneo2z)*(I2[1005] - (lpoz)*I3[1005]);
*(vp++) = U00*I0[1006] + U40*I1[1006]
           + (oneo2z)*(I2[1006] - (lpoz)*I3[1006]);
*(vp++) = U00*I0[1007] + U40*I1[1007]
           + (oneo2z)*(I2[1007] - (lpoz)*I3[1007]);
*(vp++) = U00*I0[1008] + U40*I1[1008]
           + (sixo2zn)*I4[756];
*(vp++) = U00*I0[1009] + U40*I1[1009]
           + (fiveo2zn)*I4[757];
*(vp++) = U00*I0[1010] + U40*I1[1010]
           + (fiveo2zn)*I4[758];
*(vp++) = U00*I0[1011] + U40*I1[1011]
           + (fouro2zn)*I4[759];
*(vp++) = U00*I0[1012] + U40*I1[1012]
           + (fouro2zn)*I4[760];
*(vp++) = U00*I0[1013] + U40*I1[1013]
           + (fouro2zn)*I4[761];
*(vp++) = U00*I0[1014] + U40*I1[1014]
           + (threeo2zn)*I4[762];
*(vp++) = U00*I0[1015] + U40*I1[1015]
           + (threeo2zn)*I4[763];
*(vp++) = U00*I0[1016] + U40*I1[1016]
           + (threeo2zn)*I4[764];
*(vp++) = U00*I0[1017] + U40*I1[1017]
           + (threeo2zn)*I4[765];
*(vp++) = U00*I0[1018] + U40*I1[1018]
           + (twoo2zn)*I4[766];
*(vp++) = U00*I0[1019] + U40*I1[1019]
           + (twoo2zn)*I4[767];
*(vp++) = U00*I0[1020] + U40*I1[1020]
           + (twoo2zn)*I4[768];
*(vp++) = U00*I0[1021] + U40*I1[1021]
           + (twoo2zn)*I4[769];
*(vp++) = U00*I0[1022] + U40*I1[1022]
           + (twoo2zn)*I4[770];
*(vp++) = U00*I0[1023] + U40*I1[1023]
           + (oneo2zn)*I4[771];
*(vp++) = U00*I0[1024] + U40*I1[1024]
           + (oneo2zn)*I4[772];
*(vp++) = U00*I0[1025] + U40*I1[1025]
           + (oneo2zn)*I4[773];
*(vp++) = U00*I0[1026] + U40*I1[1026]
           + (oneo2zn)*I4[774];
*(vp++) = U00*I0[1027] + U40*I1[1027]
           + (oneo2zn)*I4[775];
return vp;
}

REALTYPE *_build_m0i0_4(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2zn;
  REALTYPE twoo2zn;
  REALTYPE threeo2zn;
  REALTYPE fouro2zn;
  REALTYPE fiveo2zn;
  REALTYPE sixo2zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  REALTYPE seveno2z;
  REALTYPE eighto2z;
  oneo2zn = 1.0*Data->oo2zn;
  twoo2zn = 2.0*Data->oo2zn;
  threeo2zn = 3.0*Data->oo2zn;
  fouro2zn = 4.0*Data->oo2zn;
  fiveo2zn = 5.0*Data->oo2zn;
  sixo2zn = 6.0*Data->oo2zn;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  seveno2z = 7.0*Data->oo2z;
  eighto2z = 8.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U40 = Data->U[4][0];
  U41 = Data->U[4][1];
  U42 = Data->U[4][2];


*(vp++) = U00*I0[1028] + U40*I1[1028]
           + (oneo2zn)*I4[776];
*(vp++) = U00*I0[1029] + U40*I1[1029];
*(vp++) = U00*I0[1030] + U40*I1[1030];
*(vp++) = U00*I0[1031] + U40*I1[1031];
*(vp++) = U00*I0[1032] + U40*I1[1032];
*(vp++) = U00*I0[1033] + U40*I1[1033];
*(vp++) = U00*I0[1034] + U40*I1[1034];
*(vp++) = U00*I0[1035] + U40*I1[1035];
*(vp++) = U00*I0[1036] + U40*I1[1036]
           + (sixo2zn)*I4[777];
*(vp++) = U00*I0[1037] + U40*I1[1037]
           + (fiveo2zn)*I4[778];
*(vp++) = U00*I0[1038] + U40*I1[1038]
           + (fiveo2zn)*I4[779];
*(vp++) = U00*I0[1039] + U40*I1[1039]
           + (fouro2zn)*I4[780];
*(vp++) = U00*I0[1040] + U40*I1[1040]
           + (fouro2zn)*I4[781];
*(vp++) = U00*I0[1041] + U40*I1[1041]
           + (fouro2zn)*I4[782];
*(vp++) = U00*I0[1042] + U40*I1[1042]
           + (threeo2zn)*I4[783];
*(vp++) = U00*I0[1043] + U40*I1[1043]
           + (threeo2zn)*I4[784];
*(vp++) = U00*I0[1044] + U40*I1[1044]
           + (threeo2zn)*I4[785];
*(vp++) = U00*I0[1045] + U40*I1[1045]
           + (threeo2zn)*I4[786];
*(vp++) = U00*I0[1046] + U40*I1[1046]
           + (twoo2zn)*I4[787];
*(vp++) = U00*I0[1047] + U40*I1[1047]
           + (twoo2zn)*I4[788];
*(vp++) = U00*I0[1048] + U40*I1[1048]
           + (twoo2zn)*I4[789];
*(vp++) = U00*I0[1049] + U40*I1[1049]
           + (twoo2zn)*I4[790];
*(vp++) = U00*I0[1050] + U40*I1[1050]
           + (twoo2zn)*I4[791];
*(vp++) = U00*I0[1051] + U40*I1[1051]
           + (oneo2zn)*I4[792];
*(vp++) = U00*I0[1052] + U40*I1[1052]
           + (oneo2zn)*I4[793];
*(vp++) = U00*I0[1053] + U40*I1[1053]
           + (oneo2zn)*I4[794];
*(vp++) = U00*I0[1054] + U40*I1[1054]
           + (oneo2zn)*I4[795];
*(vp++) = U00*I0[1055] + U40*I1[1055]
           + (oneo2zn)*I4[796];
*(vp++) = U00*I0[1056] + U40*I1[1056]
           + (oneo2zn)*I4[797];
*(vp++) = U00*I0[1057] + U40*I1[1057];
*(vp++) = U00*I0[1058] + U40*I1[1058];
*(vp++) = U00*I0[1059] + U40*I1[1059];
*(vp++) = U00*I0[1060] + U40*I1[1060];
*(vp++) = U00*I0[1061] + U40*I1[1061];
*(vp++) = U00*I0[1062] + U40*I1[1062];
*(vp++) = U00*I0[1063] + U40*I1[1063];
*(vp++) = U00*I0[1064] + U40*I1[1064]
           + (sixo2zn)*I4[798];
*(vp++) = U00*I0[1065] + U40*I1[1065]
           + (fiveo2zn)*I4[799];
*(vp++) = U00*I0[1066] + U40*I1[1066]
           + (fiveo2zn)*I4[800];
*(vp++) = U00*I0[1067] + U40*I1[1067]
           + (fouro2zn)*I4[801];
*(vp++) = U00*I0[1068] + U40*I1[1068]
           + (fouro2zn)*I4[802];
*(vp++) = U00*I0[1069] + U40*I1[1069]
           + (fouro2zn)*I4[803];
*(vp++) = U00*I0[1070] + U40*I1[1070]
           + (threeo2zn)*I4[804];
*(vp++) = U00*I0[1071] + U40*I1[1071]
           + (threeo2zn)*I4[805];
*(vp++) = U00*I0[1072] + U40*I1[1072]
           + (threeo2zn)*I4[806];
*(vp++) = U00*I0[1073] + U40*I1[1073]
           + (threeo2zn)*I4[807];
*(vp++) = U00*I0[1074] + U40*I1[1074]
           + (twoo2zn)*I4[808];
*(vp++) = U00*I0[1075] + U40*I1[1075]
           + (twoo2zn)*I4[809];
*(vp++) = U00*I0[1076] + U40*I1[1076]
           + (twoo2zn)*I4[810];
*(vp++) = U00*I0[1077] + U40*I1[1077]
           + (twoo2zn)*I4[811];
*(vp++) = U00*I0[1078] + U40*I1[1078]
           + (twoo2zn)*I4[812];
*(vp++) = U00*I0[1079] + U40*I1[1079]
           + (oneo2zn)*I4[813];
*(vp++) = U00*I0[1080] + U40*I1[1080]
           + (oneo2zn)*I4[814];
*(vp++) = U00*I0[1081] + U40*I1[1081]
           + (oneo2zn)*I4[815];
*(vp++) = U00*I0[1082] + U40*I1[1082]
           + (oneo2zn)*I4[816];
*(vp++) = U00*I0[1083] + U40*I1[1083]
           + (oneo2zn)*I4[817];
*(vp++) = U00*I0[1084] + U40*I1[1084]
           + (oneo2zn)*I4[818];
*(vp++) = U00*I0[1085] + U40*I1[1085];
*(vp++) = U00*I0[1086] + U40*I1[1086];
*(vp++) = U00*I0[1087] + U40*I1[1087];
*(vp++) = U00*I0[1088] + U40*I1[1088];
*(vp++) = U00*I0[1089] + U40*I1[1089];
*(vp++) = U00*I0[1090] + U40*I1[1090];
*(vp++) = U00*I0[1091] + U40*I1[1091];
*(vp++) = U00*I0[1092] + U40*I1[1092]
           + (sixo2zn)*I4[819];
*(vp++) = U00*I0[1093] + U40*I1[1093]
           + (fiveo2zn)*I4[820];
*(vp++) = U00*I0[1094] + U40*I1[1094]
           + (fiveo2zn)*I4[821];
*(vp++) = U00*I0[1095] + U40*I1[1095]
           + (fouro2zn)*I4[822];
*(vp++) = U00*I0[1096] + U40*I1[1096]
           + (fouro2zn)*I4[823];
*(vp++) = U00*I0[1097] + U40*I1[1097]
           + (fouro2zn)*I4[824];
*(vp++) = U00*I0[1098] + U40*I1[1098]
           + (threeo2zn)*I4[825];
*(vp++) = U00*I0[1099] + U40*I1[1099]
           + (threeo2zn)*I4[826];
*(vp++) = U00*I0[1100] + U40*I1[1100]
           + (threeo2zn)*I4[827];
*(vp++) = U00*I0[1101] + U40*I1[1101]
           + (threeo2zn)*I4[828];
*(vp++) = U00*I0[1102] + U40*I1[1102]
           + (twoo2zn)*I4[829];
*(vp++) = U00*I0[1103] + U40*I1[1103]
           + (twoo2zn)*I4[830];
*(vp++) = U00*I0[1104] + U40*I1[1104]
           + (twoo2zn)*I4[831];
*(vp++) = U00*I0[1105] + U40*I1[1105]
           + (twoo2zn)*I4[832];
*(vp++) = U00*I0[1106] + U40*I1[1106]
           + (twoo2zn)*I4[833];
*(vp++) = U00*I0[1107] + U40*I1[1107]
           + (oneo2zn)*I4[834];
*(vp++) = U00*I0[1108] + U40*I1[1108]
           + (oneo2zn)*I4[835];
*(vp++) = U00*I0[1109] + U40*I1[1109]
           + (oneo2zn)*I4[836];
*(vp++) = U00*I0[1110] + U40*I1[1110]
           + (oneo2zn)*I4[837];
*(vp++) = U00*I0[1111] + U40*I1[1111]
           + (oneo2zn)*I4[838];
*(vp++) = U00*I0[1112] + U40*I1[1112]
           + (oneo2zn)*I4[839];
*(vp++) = U00*I0[1113] + U40*I1[1113];
*(vp++) = U00*I0[1114] + U40*I1[1114];
*(vp++) = U00*I0[1115] + U40*I1[1115];
*(vp++) = U00*I0[1116] + U40*I1[1116];
*(vp++) = U00*I0[1117] + U40*I1[1117];
*(vp++) = U00*I0[1118] + U40*I1[1118];
*(vp++) = U00*I0[1119] + U40*I1[1119];
*(vp++) = U00*I0[1120] + U40*I1[1120]
           + (sixo2zn)*I4[840];
*(vp++) = U00*I0[1121] + U40*I1[1121]
           + (fiveo2zn)*I4[841];
*(vp++) = U00*I0[1122] + U40*I1[1122]
           + (fiveo2zn)*I4[842];
*(vp++) = U00*I0[1123] + U40*I1[1123]
           + (fouro2zn)*I4[843];
*(vp++) = U00*I0[1124] + U40*I1[1124]
           + (fouro2zn)*I4[844];
*(vp++) = U00*I0[1125] + U40*I1[1125]
           + (fouro2zn)*I4[845];
*(vp++) = U00*I0[1126] + U40*I1[1126]
           + (threeo2zn)*I4[846];
*(vp++) = U00*I0[1127] + U40*I1[1127]
           + (threeo2zn)*I4[847];
*(vp++) = U00*I0[1128] + U40*I1[1128]
           + (threeo2zn)*I4[848];
*(vp++) = U00*I0[1129] + U40*I1[1129]
           + (threeo2zn)*I4[849];
*(vp++) = U00*I0[1130] + U40*I1[1130]
           + (twoo2zn)*I4[850];
*(vp++) = U00*I0[1131] + U40*I1[1131]
           + (twoo2zn)*I4[851];
*(vp++) = U00*I0[1132] + U40*I1[1132]
           + (twoo2zn)*I4[852];
*(vp++) = U00*I0[1133] + U40*I1[1133]
           + (twoo2zn)*I4[853];
*(vp++) = U00*I0[1134] + U40*I1[1134]
           + (twoo2zn)*I4[854];
*(vp++) = U00*I0[1135] + U40*I1[1135]
           + (oneo2zn)*I4[855];
*(vp++) = U00*I0[1136] + U40*I1[1136]
           + (oneo2zn)*I4[856];
*(vp++) = U00*I0[1137] + U40*I1[1137]
           + (oneo2zn)*I4[857];
*(vp++) = U00*I0[1138] + U40*I1[1138]
           + (oneo2zn)*I4[858];
*(vp++) = U00*I0[1139] + U40*I1[1139]
           + (oneo2zn)*I4[859];
*(vp++) = U00*I0[1140] + U40*I1[1140]
           + (oneo2zn)*I4[860];
*(vp++) = U00*I0[1141] + U40*I1[1141];
*(vp++) = U00*I0[1142] + U40*I1[1142];
*(vp++) = U00*I0[1143] + U40*I1[1143];
*(vp++) = U00*I0[1144] + U40*I1[1144];
*(vp++) = U00*I0[1145] + U40*I1[1145];
*(vp++) = U00*I0[1146] + U40*I1[1146];
*(vp++) = U00*I0[1147] + U40*I1[1147];
*(vp++) = U00*I0[1148] + U40*I1[1148]
           + (sixo2zn)*I4[861];
*(vp++) = U00*I0[1149] + U40*I1[1149]
           + (fiveo2zn)*I4[862];
*(vp++) = U00*I0[1150] + U40*I1[1150]
           + (fiveo2zn)*I4[863];
*(vp++) = U00*I0[1151] + U40*I1[1151]
           + (fouro2zn)*I4[864];
*(vp++) = U00*I0[1152] + U40*I1[1152]
           + (fouro2zn)*I4[865];
*(vp++) = U00*I0[1153] + U40*I1[1153]
           + (fouro2zn)*I4[866];
*(vp++) = U00*I0[1154] + U40*I1[1154]
           + (threeo2zn)*I4[867];
*(vp++) = U00*I0[1155] + U40*I1[1155]
           + (threeo2zn)*I4[868];
*(vp++) = U00*I0[1156] + U40*I1[1156]
           + (threeo2zn)*I4[869];
*(vp++) = U00*I0[1157] + U40*I1[1157]
           + (threeo2zn)*I4[870];
*(vp++) = U00*I0[1158] + U40*I1[1158]
           + (twoo2zn)*I4[871];
*(vp++) = U00*I0[1159] + U40*I1[1159]
           + (twoo2zn)*I4[872];
*(vp++) = U00*I0[1160] + U40*I1[1160]
           + (twoo2zn)*I4[873];
*(vp++) = U00*I0[1161] + U40*I1[1161]
           + (twoo2zn)*I4[874];
*(vp++) = U00*I0[1162] + U40*I1[1162]
           + (twoo2zn)*I4[875];
*(vp++) = U00*I0[1163] + U40*I1[1163]
           + (oneo2zn)*I4[876];
*(vp++) = U00*I0[1164] + U40*I1[1164]
           + (oneo2zn)*I4[877];
*(vp++) = U00*I0[1165] + U40*I1[1165]
           + (oneo2zn)*I4[878];
*(vp++) = U00*I0[1166] + U40*I1[1166]
           + (oneo2zn)*I4[879];
*(vp++) = U00*I0[1167] + U40*I1[1167]
           + (oneo2zn)*I4[880];
*(vp++) = U00*I0[1168] + U40*I1[1168]
           + (oneo2zn)*I4[881];
*(vp++) = U00*I0[1169] + U40*I1[1169];
*(vp++) = U00*I0[1170] + U40*I1[1170];
*(vp++) = U00*I0[1171] + U40*I1[1171];
*(vp++) = U00*I0[1172] + U40*I1[1172];
*(vp++) = U00*I0[1173] + U40*I1[1173];
*(vp++) = U00*I0[1174] + U40*I1[1174];
*(vp++) = U00*I0[1175] + U40*I1[1175];
*(vp++) = U00*I0[1176] + U40*I1[1176]
           + (sixo2zn)*I4[882];
*(vp++) = U00*I0[1177] + U40*I1[1177]
           + (fiveo2zn)*I4[883];
*(vp++) = U00*I0[1178] + U40*I1[1178]
           + (fiveo2zn)*I4[884];
*(vp++) = U00*I0[1179] + U40*I1[1179]
           + (fouro2zn)*I4[885];
*(vp++) = U00*I0[1180] + U40*I1[1180]
           + (fouro2zn)*I4[886];
*(vp++) = U00*I0[1181] + U40*I1[1181]
           + (fouro2zn)*I4[887];
*(vp++) = U00*I0[1182] + U40*I1[1182]
           + (threeo2zn)*I4[888];
*(vp++) = U00*I0[1183] + U40*I1[1183]
           + (threeo2zn)*I4[889];
*(vp++) = U00*I0[1184] + U40*I1[1184]
           + (threeo2zn)*I4[890];
*(vp++) = U00*I0[1185] + U40*I1[1185]
           + (threeo2zn)*I4[891];
*(vp++) = U00*I0[1186] + U40*I1[1186]
           + (twoo2zn)*I4[892];
*(vp++) = U00*I0[1187] + U40*I1[1187]
           + (twoo2zn)*I4[893];
*(vp++) = U00*I0[1188] + U40*I1[1188]
           + (twoo2zn)*I4[894];
*(vp++) = U00*I0[1189] + U40*I1[1189]
           + (twoo2zn)*I4[895];
*(vp++) = U00*I0[1190] + U40*I1[1190]
           + (twoo2zn)*I4[896];
*(vp++) = U00*I0[1191] + U40*I1[1191]
           + (oneo2zn)*I4[897];
*(vp++) = U00*I0[1192] + U40*I1[1192]
           + (oneo2zn)*I4[898];
*(vp++) = U00*I0[1193] + U40*I1[1193]
           + (oneo2zn)*I4[899];
*(vp++) = U00*I0[1194] + U40*I1[1194]
           + (oneo2zn)*I4[900];
*(vp++) = U00*I0[1195] + U40*I1[1195]
           + (oneo2zn)*I4[901];
*(vp++) = U00*I0[1196] + U40*I1[1196]
           + (oneo2zn)*I4[902];
*(vp++) = U00*I0[1197] + U40*I1[1197];
*(vp++) = U00*I0[1198] + U40*I1[1198];
*(vp++) = U00*I0[1199] + U40*I1[1199];
*(vp++) = U00*I0[1200] + U40*I1[1200];
*(vp++) = U00*I0[1201] + U40*I1[1201];
*(vp++) = U00*I0[1202] + U40*I1[1202];
*(vp++) = U00*I0[1203] + U40*I1[1203];
*(vp++) = U00*I0[1204] + U40*I1[1204]
           + (sixo2zn)*I4[903];
*(vp++) = U00*I0[1205] + U40*I1[1205]
           + (fiveo2zn)*I4[904];
*(vp++) = U00*I0[1206] + U40*I1[1206]
           + (fiveo2zn)*I4[905];
*(vp++) = U00*I0[1207] + U40*I1[1207]
           + (fouro2zn)*I4[906];
*(vp++) = U00*I0[1208] + U40*I1[1208]
           + (fouro2zn)*I4[907];
*(vp++) = U00*I0[1209] + U40*I1[1209]
           + (fouro2zn)*I4[908];
*(vp++) = U00*I0[1210] + U40*I1[1210]
           + (threeo2zn)*I4[909];
*(vp++) = U00*I0[1211] + U40*I1[1211]
           + (threeo2zn)*I4[910];
*(vp++) = U00*I0[1212] + U40*I1[1212]
           + (threeo2zn)*I4[911];
*(vp++) = U00*I0[1213] + U40*I1[1213]
           + (threeo2zn)*I4[912];
*(vp++) = U00*I0[1214] + U40*I1[1214]
           + (twoo2zn)*I4[913];
*(vp++) = U00*I0[1215] + U40*I1[1215]
           + (twoo2zn)*I4[914];
*(vp++) = U00*I0[1216] + U40*I1[1216]
           + (twoo2zn)*I4[915];
*(vp++) = U00*I0[1217] + U40*I1[1217]
           + (twoo2zn)*I4[916];
*(vp++) = U00*I0[1218] + U40*I1[1218]
           + (twoo2zn)*I4[917];
*(vp++) = U00*I0[1219] + U40*I1[1219]
           + (oneo2zn)*I4[918];
*(vp++) = U00*I0[1220] + U40*I1[1220]
           + (oneo2zn)*I4[919];
*(vp++) = U00*I0[1221] + U40*I1[1221]
           + (oneo2zn)*I4[920];
*(vp++) = U00*I0[1222] + U40*I1[1222]
           + (oneo2zn)*I4[921];
*(vp++) = U00*I0[1223] + U40*I1[1223]
           + (oneo2zn)*I4[922];
*(vp++) = U00*I0[1224] + U40*I1[1224]
           + (oneo2zn)*I4[923];
*(vp++) = U00*I0[1225] + U40*I1[1225];
*(vp++) = U00*I0[1226] + U40*I1[1226];
*(vp++) = U00*I0[1227] + U40*I1[1227];
*(vp++) = U00*I0[1228] + U40*I1[1228];
*(vp++) = U00*I0[1229] + U40*I1[1229];
*(vp++) = U00*I0[1230] + U40*I1[1230];
*(vp++) = U00*I0[1231] + U40*I1[1231];
*(vp++) = U00*I0[1232] + U40*I1[1232]
           + (sixo2zn)*I4[924];
*(vp++) = U00*I0[1233] + U40*I1[1233]
           + (fiveo2zn)*I4[925];
*(vp++) = U00*I0[1234] + U40*I1[1234]
           + (fiveo2zn)*I4[926];
*(vp++) = U00*I0[1235] + U40*I1[1235]
           + (fouro2zn)*I4[927];
*(vp++) = U00*I0[1236] + U40*I1[1236]
           + (fouro2zn)*I4[928];
*(vp++) = U00*I0[1237] + U40*I1[1237]
           + (fouro2zn)*I4[929];
*(vp++) = U00*I0[1238] + U40*I1[1238]
           + (threeo2zn)*I4[930];
*(vp++) = U00*I0[1239] + U40*I1[1239]
           + (threeo2zn)*I4[931];
*(vp++) = U00*I0[1240] + U40*I1[1240]
           + (threeo2zn)*I4[932];
*(vp++) = U00*I0[1241] + U40*I1[1241]
           + (threeo2zn)*I4[933];
*(vp++) = U00*I0[1242] + U40*I1[1242]
           + (twoo2zn)*I4[934];
*(vp++) = U00*I0[1243] + U40*I1[1243]
           + (twoo2zn)*I4[935];
*(vp++) = U00*I0[1244] + U40*I1[1244]
           + (twoo2zn)*I4[936];
*(vp++) = U00*I0[1245] + U40*I1[1245]
           + (twoo2zn)*I4[937];
*(vp++) = U00*I0[1246] + U40*I1[1246]
           + (twoo2zn)*I4[938];
*(vp++) = U00*I0[1247] + U40*I1[1247]
           + (oneo2zn)*I4[939];
*(vp++) = U00*I0[1248] + U40*I1[1248]
           + (oneo2zn)*I4[940];
*(vp++) = U00*I0[1249] + U40*I1[1249]
           + (oneo2zn)*I4[941];
*(vp++) = U00*I0[1250] + U40*I1[1250]
           + (oneo2zn)*I4[942];
*(vp++) = U00*I0[1251] + U40*I1[1251]
           + (oneo2zn)*I4[943];
*(vp++) = U00*I0[1252] + U40*I1[1252]
           + (oneo2zn)*I4[944];
*(vp++) = U00*I0[1253] + U40*I1[1253];
*(vp++) = U00*I0[1254] + U40*I1[1254];
*(vp++) = U00*I0[1255] + U40*I1[1255];
*(vp++) = U00*I0[1256] + U40*I1[1256];
*(vp++) = U00*I0[1257] + U40*I1[1257];
*(vp++) = U00*I0[1258] + U40*I1[1258];
*(vp++) = U00*I0[1259] + U40*I1[1259];
*(vp++) = U01*I0[1008] + U41*I1[1008]
           + (eighto2z)*(I2[784] - (lpoz)*I3[784]);
*(vp++) = U01*I0[1009] + U41*I1[1009]
           + (eighto2z)*(I2[785] - (lpoz)*I3[785])
           + (oneo2zn)*I4[756];
*(vp++) = U01*I0[1010] + U41*I1[1010]
           + (eighto2z)*(I2[786] - (lpoz)*I3[786]);
*(vp++) = U01*I0[1011] + U41*I1[1011]
           + (eighto2z)*(I2[787] - (lpoz)*I3[787])
           + (twoo2zn)*I4[757];
*(vp++) = U01*I0[1012] + U41*I1[1012]
           + (eighto2z)*(I2[788] - (lpoz)*I3[788])
           + (oneo2zn)*I4[758];
*(vp++) = U01*I0[1013] + U41*I1[1013]
           + (eighto2z)*(I2[789] - (lpoz)*I3[789]);
*(vp++) = U01*I0[1014] + U41*I1[1014]
           + (eighto2z)*(I2[790] - (lpoz)*I3[790])
           + (threeo2zn)*I4[759];
*(vp++) = U01*I0[1015] + U41*I1[1015]
           + (eighto2z)*(I2[791] - (lpoz)*I3[791])
           + (twoo2zn)*I4[760];
*(vp++) = U01*I0[1016] + U41*I1[1016]
           + (eighto2z)*(I2[792] - (lpoz)*I3[792])
           + (oneo2zn)*I4[761];
*(vp++) = U01*I0[1017] + U41*I1[1017]
           + (eighto2z)*(I2[793] - (lpoz)*I3[793]);
*(vp++) = U01*I0[1018] + U41*I1[1018]
           + (eighto2z)*(I2[794] - (lpoz)*I3[794])
           + (fouro2zn)*I4[762];
*(vp++) = U01*I0[1019] + U41*I1[1019]
           + (eighto2z)*(I2[795] - (lpoz)*I3[795])
           + (threeo2zn)*I4[763];
*(vp++) = U01*I0[1020] + U41*I1[1020]
           + (eighto2z)*(I2[796] - (lpoz)*I3[796])
           + (twoo2zn)*I4[764];
*(vp++) = U01*I0[1021] + U41*I1[1021]
           + (eighto2z)*(I2[797] - (lpoz)*I3[797])
           + (oneo2zn)*I4[765];
*(vp++) = U01*I0[1022] + U41*I1[1022]
           + (eighto2z)*(I2[798] - (lpoz)*I3[798]);
*(vp++) = U01*I0[1023] + U41*I1[1023]
           + (eighto2z)*(I2[799] - (lpoz)*I3[799])
           + (fiveo2zn)*I4[766];
*(vp++) = U01*I0[1024] + U41*I1[1024]
           + (eighto2z)*(I2[800] - (lpoz)*I3[800])
           + (fouro2zn)*I4[767];
*(vp++) = U01*I0[1025] + U41*I1[1025]
           + (eighto2z)*(I2[801] - (lpoz)*I3[801])
           + (threeo2zn)*I4[768];
*(vp++) = U01*I0[1026] + U41*I1[1026]
           + (eighto2z)*(I2[802] - (lpoz)*I3[802])
           + (twoo2zn)*I4[769];
*(vp++) = U01*I0[1027] + U41*I1[1027]
           + (eighto2z)*(I2[803] - (lpoz)*I3[803])
           + (oneo2zn)*I4[770];
*(vp++) = U01*I0[1028] + U41*I1[1028]
           + (eighto2z)*(I2[804] - (lpoz)*I3[804]);
*(vp++) = U01*I0[1029] + U41*I1[1029]
           + (eighto2z)*(I2[805] - (lpoz)*I3[805])
           + (sixo2zn)*I4[771];
*(vp++) = U01*I0[1030] + U41*I1[1030]
           + (eighto2z)*(I2[806] - (lpoz)*I3[806])
           + (fiveo2zn)*I4[772];
*(vp++) = U01*I0[1031] + U41*I1[1031]
           + (eighto2z)*(I2[807] - (lpoz)*I3[807])
           + (fouro2zn)*I4[773];
*(vp++) = U01*I0[1032] + U41*I1[1032]
           + (eighto2z)*(I2[808] - (lpoz)*I3[808])
           + (threeo2zn)*I4[774];
return vp;
}

REALTYPE *_build_m0i0_5(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2zn;
  REALTYPE twoo2zn;
  REALTYPE threeo2zn;
  REALTYPE fouro2zn;
  REALTYPE fiveo2zn;
  REALTYPE sixo2zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  REALTYPE seveno2z;
  REALTYPE eighto2z;
  oneo2zn = 1.0*Data->oo2zn;
  twoo2zn = 2.0*Data->oo2zn;
  threeo2zn = 3.0*Data->oo2zn;
  fouro2zn = 4.0*Data->oo2zn;
  fiveo2zn = 5.0*Data->oo2zn;
  sixo2zn = 6.0*Data->oo2zn;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  seveno2z = 7.0*Data->oo2z;
  eighto2z = 8.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U40 = Data->U[4][0];
  U41 = Data->U[4][1];
  U42 = Data->U[4][2];


*(vp++) = U01*I0[1033] + U41*I1[1033]
           + (eighto2z)*(I2[809] - (lpoz)*I3[809])
           + (twoo2zn)*I4[775];
*(vp++) = U01*I0[1034] + U41*I1[1034]
           + (eighto2z)*(I2[810] - (lpoz)*I3[810])
           + (oneo2zn)*I4[776];
*(vp++) = U01*I0[1035] + U41*I1[1035]
           + (eighto2z)*(I2[811] - (lpoz)*I3[811]);
*(vp++) = U01*I0[1036] + U41*I1[1036]
           + (seveno2z)*(I2[812] - (lpoz)*I3[812]);
*(vp++) = U01*I0[1037] + U41*I1[1037]
           + (seveno2z)*(I2[813] - (lpoz)*I3[813])
           + (oneo2zn)*I4[777];
*(vp++) = U01*I0[1038] + U41*I1[1038]
           + (seveno2z)*(I2[814] - (lpoz)*I3[814]);
*(vp++) = U01*I0[1039] + U41*I1[1039]
           + (seveno2z)*(I2[815] - (lpoz)*I3[815])
           + (twoo2zn)*I4[778];
*(vp++) = U01*I0[1040] + U41*I1[1040]
           + (seveno2z)*(I2[816] - (lpoz)*I3[816])
           + (oneo2zn)*I4[779];
*(vp++) = U01*I0[1041] + U41*I1[1041]
           + (seveno2z)*(I2[817] - (lpoz)*I3[817]);
*(vp++) = U01*I0[1042] + U41*I1[1042]
           + (seveno2z)*(I2[818] - (lpoz)*I3[818])
           + (threeo2zn)*I4[780];
*(vp++) = U01*I0[1043] + U41*I1[1043]
           + (seveno2z)*(I2[819] - (lpoz)*I3[819])
           + (twoo2zn)*I4[781];
*(vp++) = U01*I0[1044] + U41*I1[1044]
           + (seveno2z)*(I2[820] - (lpoz)*I3[820])
           + (oneo2zn)*I4[782];
*(vp++) = U01*I0[1045] + U41*I1[1045]
           + (seveno2z)*(I2[821] - (lpoz)*I3[821]);
*(vp++) = U01*I0[1046] + U41*I1[1046]
           + (seveno2z)*(I2[822] - (lpoz)*I3[822])
           + (fouro2zn)*I4[783];
*(vp++) = U01*I0[1047] + U41*I1[1047]
           + (seveno2z)*(I2[823] - (lpoz)*I3[823])
           + (threeo2zn)*I4[784];
*(vp++) = U01*I0[1048] + U41*I1[1048]
           + (seveno2z)*(I2[824] - (lpoz)*I3[824])
           + (twoo2zn)*I4[785];
*(vp++) = U01*I0[1049] + U41*I1[1049]
           + (seveno2z)*(I2[825] - (lpoz)*I3[825])
           + (oneo2zn)*I4[786];
*(vp++) = U01*I0[1050] + U41*I1[1050]
           + (seveno2z)*(I2[826] - (lpoz)*I3[826]);
*(vp++) = U01*I0[1051] + U41*I1[1051]
           + (seveno2z)*(I2[827] - (lpoz)*I3[827])
           + (fiveo2zn)*I4[787];
*(vp++) = U01*I0[1052] + U41*I1[1052]
           + (seveno2z)*(I2[828] - (lpoz)*I3[828])
           + (fouro2zn)*I4[788];
*(vp++) = U01*I0[1053] + U41*I1[1053]
           + (seveno2z)*(I2[829] - (lpoz)*I3[829])
           + (threeo2zn)*I4[789];
*(vp++) = U01*I0[1054] + U41*I1[1054]
           + (seveno2z)*(I2[830] - (lpoz)*I3[830])
           + (twoo2zn)*I4[790];
*(vp++) = U01*I0[1055] + U41*I1[1055]
           + (seveno2z)*(I2[831] - (lpoz)*I3[831])
           + (oneo2zn)*I4[791];
*(vp++) = U01*I0[1056] + U41*I1[1056]
           + (seveno2z)*(I2[832] - (lpoz)*I3[832]);
*(vp++) = U01*I0[1057] + U41*I1[1057]
           + (seveno2z)*(I2[833] - (lpoz)*I3[833])
           + (sixo2zn)*I4[792];
*(vp++) = U01*I0[1058] + U41*I1[1058]
           + (seveno2z)*(I2[834] - (lpoz)*I3[834])
           + (fiveo2zn)*I4[793];
*(vp++) = U01*I0[1059] + U41*I1[1059]
           + (seveno2z)*(I2[835] - (lpoz)*I3[835])
           + (fouro2zn)*I4[794];
*(vp++) = U01*I0[1060] + U41*I1[1060]
           + (seveno2z)*(I2[836] - (lpoz)*I3[836])
           + (threeo2zn)*I4[795];
*(vp++) = U01*I0[1061] + U41*I1[1061]
           + (seveno2z)*(I2[837] - (lpoz)*I3[837])
           + (twoo2zn)*I4[796];
*(vp++) = U01*I0[1062] + U41*I1[1062]
           + (seveno2z)*(I2[838] - (lpoz)*I3[838])
           + (oneo2zn)*I4[797];
*(vp++) = U01*I0[1063] + U41*I1[1063]
           + (seveno2z)*(I2[839] - (lpoz)*I3[839]);
*(vp++) = U01*I0[1064] + U41*I1[1064]
           + (sixo2z)*(I2[840] - (lpoz)*I3[840]);
*(vp++) = U01*I0[1065] + U41*I1[1065]
           + (sixo2z)*(I2[841] - (lpoz)*I3[841])
           + (oneo2zn)*I4[798];
*(vp++) = U01*I0[1066] + U41*I1[1066]
           + (sixo2z)*(I2[842] - (lpoz)*I3[842]);
*(vp++) = U01*I0[1067] + U41*I1[1067]
           + (sixo2z)*(I2[843] - (lpoz)*I3[843])
           + (twoo2zn)*I4[799];
*(vp++) = U01*I0[1068] + U41*I1[1068]
           + (sixo2z)*(I2[844] - (lpoz)*I3[844])
           + (oneo2zn)*I4[800];
*(vp++) = U01*I0[1069] + U41*I1[1069]
           + (sixo2z)*(I2[845] - (lpoz)*I3[845]);
*(vp++) = U01*I0[1070] + U41*I1[1070]
           + (sixo2z)*(I2[846] - (lpoz)*I3[846])
           + (threeo2zn)*I4[801];
*(vp++) = U01*I0[1071] + U41*I1[1071]
           + (sixo2z)*(I2[847] - (lpoz)*I3[847])
           + (twoo2zn)*I4[802];
*(vp++) = U01*I0[1072] + U41*I1[1072]
           + (sixo2z)*(I2[848] - (lpoz)*I3[848])
           + (oneo2zn)*I4[803];
*(vp++) = U01*I0[1073] + U41*I1[1073]
           + (sixo2z)*(I2[849] - (lpoz)*I3[849]);
*(vp++) = U01*I0[1074] + U41*I1[1074]
           + (sixo2z)*(I2[850] - (lpoz)*I3[850])
           + (fouro2zn)*I4[804];
*(vp++) = U01*I0[1075] + U41*I1[1075]
           + (sixo2z)*(I2[851] - (lpoz)*I3[851])
           + (threeo2zn)*I4[805];
*(vp++) = U01*I0[1076] + U41*I1[1076]
           + (sixo2z)*(I2[852] - (lpoz)*I3[852])
           + (twoo2zn)*I4[806];
*(vp++) = U01*I0[1077] + U41*I1[1077]
           + (sixo2z)*(I2[853] - (lpoz)*I3[853])
           + (oneo2zn)*I4[807];
*(vp++) = U01*I0[1078] + U41*I1[1078]
           + (sixo2z)*(I2[854] - (lpoz)*I3[854]);
*(vp++) = U01*I0[1079] + U41*I1[1079]
           + (sixo2z)*(I2[855] - (lpoz)*I3[855])
           + (fiveo2zn)*I4[808];
*(vp++) = U01*I0[1080] + U41*I1[1080]
           + (sixo2z)*(I2[856] - (lpoz)*I3[856])
           + (fouro2zn)*I4[809];
*(vp++) = U01*I0[1081] + U41*I1[1081]
           + (sixo2z)*(I2[857] - (lpoz)*I3[857])
           + (threeo2zn)*I4[810];
*(vp++) = U01*I0[1082] + U41*I1[1082]
           + (sixo2z)*(I2[858] - (lpoz)*I3[858])
           + (twoo2zn)*I4[811];
*(vp++) = U01*I0[1083] + U41*I1[1083]
           + (sixo2z)*(I2[859] - (lpoz)*I3[859])
           + (oneo2zn)*I4[812];
*(vp++) = U01*I0[1084] + U41*I1[1084]
           + (sixo2z)*(I2[860] - (lpoz)*I3[860]);
*(vp++) = U01*I0[1085] + U41*I1[1085]
           + (sixo2z)*(I2[861] - (lpoz)*I3[861])
           + (sixo2zn)*I4[813];
*(vp++) = U01*I0[1086] + U41*I1[1086]
           + (sixo2z)*(I2[862] - (lpoz)*I3[862])
           + (fiveo2zn)*I4[814];
*(vp++) = U01*I0[1087] + U41*I1[1087]
           + (sixo2z)*(I2[863] - (lpoz)*I3[863])
           + (fouro2zn)*I4[815];
*(vp++) = U01*I0[1088] + U41*I1[1088]
           + (sixo2z)*(I2[864] - (lpoz)*I3[864])
           + (threeo2zn)*I4[816];
*(vp++) = U01*I0[1089] + U41*I1[1089]
           + (sixo2z)*(I2[865] - (lpoz)*I3[865])
           + (twoo2zn)*I4[817];
*(vp++) = U01*I0[1090] + U41*I1[1090]
           + (sixo2z)*(I2[866] - (lpoz)*I3[866])
           + (oneo2zn)*I4[818];
*(vp++) = U01*I0[1091] + U41*I1[1091]
           + (sixo2z)*(I2[867] - (lpoz)*I3[867]);
*(vp++) = U01*I0[1092] + U41*I1[1092]
           + (fiveo2z)*(I2[868] - (lpoz)*I3[868]);
*(vp++) = U01*I0[1093] + U41*I1[1093]
           + (fiveo2z)*(I2[869] - (lpoz)*I3[869])
           + (oneo2zn)*I4[819];
*(vp++) = U01*I0[1094] + U41*I1[1094]
           + (fiveo2z)*(I2[870] - (lpoz)*I3[870]);
*(vp++) = U01*I0[1095] + U41*I1[1095]
           + (fiveo2z)*(I2[871] - (lpoz)*I3[871])
           + (twoo2zn)*I4[820];
*(vp++) = U01*I0[1096] + U41*I1[1096]
           + (fiveo2z)*(I2[872] - (lpoz)*I3[872])
           + (oneo2zn)*I4[821];
*(vp++) = U01*I0[1097] + U41*I1[1097]
           + (fiveo2z)*(I2[873] - (lpoz)*I3[873]);
*(vp++) = U01*I0[1098] + U41*I1[1098]
           + (fiveo2z)*(I2[874] - (lpoz)*I3[874])
           + (threeo2zn)*I4[822];
*(vp++) = U01*I0[1099] + U41*I1[1099]
           + (fiveo2z)*(I2[875] - (lpoz)*I3[875])
           + (twoo2zn)*I4[823];
*(vp++) = U01*I0[1100] + U41*I1[1100]
           + (fiveo2z)*(I2[876] - (lpoz)*I3[876])
           + (oneo2zn)*I4[824];
*(vp++) = U01*I0[1101] + U41*I1[1101]
           + (fiveo2z)*(I2[877] - (lpoz)*I3[877]);
*(vp++) = U01*I0[1102] + U41*I1[1102]
           + (fiveo2z)*(I2[878] - (lpoz)*I3[878])
           + (fouro2zn)*I4[825];
*(vp++) = U01*I0[1103] + U41*I1[1103]
           + (fiveo2z)*(I2[879] - (lpoz)*I3[879])
           + (threeo2zn)*I4[826];
*(vp++) = U01*I0[1104] + U41*I1[1104]
           + (fiveo2z)*(I2[880] - (lpoz)*I3[880])
           + (twoo2zn)*I4[827];
*(vp++) = U01*I0[1105] + U41*I1[1105]
           + (fiveo2z)*(I2[881] - (lpoz)*I3[881])
           + (oneo2zn)*I4[828];
*(vp++) = U01*I0[1106] + U41*I1[1106]
           + (fiveo2z)*(I2[882] - (lpoz)*I3[882]);
*(vp++) = U01*I0[1107] + U41*I1[1107]
           + (fiveo2z)*(I2[883] - (lpoz)*I3[883])
           + (fiveo2zn)*I4[829];
*(vp++) = U01*I0[1108] + U41*I1[1108]
           + (fiveo2z)*(I2[884] - (lpoz)*I3[884])
           + (fouro2zn)*I4[830];
*(vp++) = U01*I0[1109] + U41*I1[1109]
           + (fiveo2z)*(I2[885] - (lpoz)*I3[885])
           + (threeo2zn)*I4[831];
*(vp++) = U01*I0[1110] + U41*I1[1110]
           + (fiveo2z)*(I2[886] - (lpoz)*I3[886])
           + (twoo2zn)*I4[832];
*(vp++) = U01*I0[1111] + U41*I1[1111]
           + (fiveo2z)*(I2[887] - (lpoz)*I3[887])
           + (oneo2zn)*I4[833];
*(vp++) = U01*I0[1112] + U41*I1[1112]
           + (fiveo2z)*(I2[888] - (lpoz)*I3[888]);
*(vp++) = U01*I0[1113] + U41*I1[1113]
           + (fiveo2z)*(I2[889] - (lpoz)*I3[889])
           + (sixo2zn)*I4[834];
*(vp++) = U01*I0[1114] + U41*I1[1114]
           + (fiveo2z)*(I2[890] - (lpoz)*I3[890])
           + (fiveo2zn)*I4[835];
*(vp++) = U01*I0[1115] + U41*I1[1115]
           + (fiveo2z)*(I2[891] - (lpoz)*I3[891])
           + (fouro2zn)*I4[836];
*(vp++) = U01*I0[1116] + U41*I1[1116]
           + (fiveo2z)*(I2[892] - (lpoz)*I3[892])
           + (threeo2zn)*I4[837];
*(vp++) = U01*I0[1117] + U41*I1[1117]
           + (fiveo2z)*(I2[893] - (lpoz)*I3[893])
           + (twoo2zn)*I4[838];
*(vp++) = U01*I0[1118] + U41*I1[1118]
           + (fiveo2z)*(I2[894] - (lpoz)*I3[894])
           + (oneo2zn)*I4[839];
*(vp++) = U01*I0[1119] + U41*I1[1119]
           + (fiveo2z)*(I2[895] - (lpoz)*I3[895]);
*(vp++) = U01*I0[1120] + U41*I1[1120]
           + (fouro2z)*(I2[896] - (lpoz)*I3[896]);
*(vp++) = U01*I0[1121] + U41*I1[1121]
           + (fouro2z)*(I2[897] - (lpoz)*I3[897])
           + (oneo2zn)*I4[840];
*(vp++) = U01*I0[1122] + U41*I1[1122]
           + (fouro2z)*(I2[898] - (lpoz)*I3[898]);
*(vp++) = U01*I0[1123] + U41*I1[1123]
           + (fouro2z)*(I2[899] - (lpoz)*I3[899])
           + (twoo2zn)*I4[841];
*(vp++) = U01*I0[1124] + U41*I1[1124]
           + (fouro2z)*(I2[900] - (lpoz)*I3[900])
           + (oneo2zn)*I4[842];
*(vp++) = U01*I0[1125] + U41*I1[1125]
           + (fouro2z)*(I2[901] - (lpoz)*I3[901]);
*(vp++) = U01*I0[1126] + U41*I1[1126]
           + (fouro2z)*(I2[902] - (lpoz)*I3[902])
           + (threeo2zn)*I4[843];
*(vp++) = U01*I0[1127] + U41*I1[1127]
           + (fouro2z)*(I2[903] - (lpoz)*I3[903])
           + (twoo2zn)*I4[844];
*(vp++) = U01*I0[1128] + U41*I1[1128]
           + (fouro2z)*(I2[904] - (lpoz)*I3[904])
           + (oneo2zn)*I4[845];
*(vp++) = U01*I0[1129] + U41*I1[1129]
           + (fouro2z)*(I2[905] - (lpoz)*I3[905]);
*(vp++) = U01*I0[1130] + U41*I1[1130]
           + (fouro2z)*(I2[906] - (lpoz)*I3[906])
           + (fouro2zn)*I4[846];
*(vp++) = U01*I0[1131] + U41*I1[1131]
           + (fouro2z)*(I2[907] - (lpoz)*I3[907])
           + (threeo2zn)*I4[847];
*(vp++) = U01*I0[1132] + U41*I1[1132]
           + (fouro2z)*(I2[908] - (lpoz)*I3[908])
           + (twoo2zn)*I4[848];
*(vp++) = U01*I0[1133] + U41*I1[1133]
           + (fouro2z)*(I2[909] - (lpoz)*I3[909])
           + (oneo2zn)*I4[849];
*(vp++) = U01*I0[1134] + U41*I1[1134]
           + (fouro2z)*(I2[910] - (lpoz)*I3[910]);
*(vp++) = U01*I0[1135] + U41*I1[1135]
           + (fouro2z)*(I2[911] - (lpoz)*I3[911])
           + (fiveo2zn)*I4[850];
*(vp++) = U01*I0[1136] + U41*I1[1136]
           + (fouro2z)*(I2[912] - (lpoz)*I3[912])
           + (fouro2zn)*I4[851];
*(vp++) = U01*I0[1137] + U41*I1[1137]
           + (fouro2z)*(I2[913] - (lpoz)*I3[913])
           + (threeo2zn)*I4[852];
*(vp++) = U01*I0[1138] + U41*I1[1138]
           + (fouro2z)*(I2[914] - (lpoz)*I3[914])
           + (twoo2zn)*I4[853];
*(vp++) = U01*I0[1139] + U41*I1[1139]
           + (fouro2z)*(I2[915] - (lpoz)*I3[915])
           + (oneo2zn)*I4[854];
*(vp++) = U01*I0[1140] + U41*I1[1140]
           + (fouro2z)*(I2[916] - (lpoz)*I3[916]);
*(vp++) = U01*I0[1141] + U41*I1[1141]
           + (fouro2z)*(I2[917] - (lpoz)*I3[917])
           + (sixo2zn)*I4[855];
*(vp++) = U01*I0[1142] + U41*I1[1142]
           + (fouro2z)*(I2[918] - (lpoz)*I3[918])
           + (fiveo2zn)*I4[856];
*(vp++) = U01*I0[1143] + U41*I1[1143]
           + (fouro2z)*(I2[919] - (lpoz)*I3[919])
           + (fouro2zn)*I4[857];
*(vp++) = U01*I0[1144] + U41*I1[1144]
           + (fouro2z)*(I2[920] - (lpoz)*I3[920])
           + (threeo2zn)*I4[858];
*(vp++) = U01*I0[1145] + U41*I1[1145]
           + (fouro2z)*(I2[921] - (lpoz)*I3[921])
           + (twoo2zn)*I4[859];
*(vp++) = U01*I0[1146] + U41*I1[1146]
           + (fouro2z)*(I2[922] - (lpoz)*I3[922])
           + (oneo2zn)*I4[860];
*(vp++) = U01*I0[1147] + U41*I1[1147]
           + (fouro2z)*(I2[923] - (lpoz)*I3[923]);
*(vp++) = U01*I0[1148] + U41*I1[1148]
           + (threeo2z)*(I2[924] - (lpoz)*I3[924]);
*(vp++) = U01*I0[1149] + U41*I1[1149]
           + (threeo2z)*(I2[925] - (lpoz)*I3[925])
           + (oneo2zn)*I4[861];
*(vp++) = U01*I0[1150] + U41*I1[1150]
           + (threeo2z)*(I2[926] - (lpoz)*I3[926]);
*(vp++) = U01*I0[1151] + U41*I1[1151]
           + (threeo2z)*(I2[927] - (lpoz)*I3[927])
           + (twoo2zn)*I4[862];
*(vp++) = U01*I0[1152] + U41*I1[1152]
           + (threeo2z)*(I2[928] - (lpoz)*I3[928])
           + (oneo2zn)*I4[863];
*(vp++) = U01*I0[1153] + U41*I1[1153]
           + (threeo2z)*(I2[929] - (lpoz)*I3[929]);
*(vp++) = U01*I0[1154] + U41*I1[1154]
           + (threeo2z)*(I2[930] - (lpoz)*I3[930])
           + (threeo2zn)*I4[864];
*(vp++) = U01*I0[1155] + U41*I1[1155]
           + (threeo2z)*(I2[931] - (lpoz)*I3[931])
           + (twoo2zn)*I4[865];
*(vp++) = U01*I0[1156] + U41*I1[1156]
           + (threeo2z)*(I2[932] - (lpoz)*I3[932])
           + (oneo2zn)*I4[866];
*(vp++) = U01*I0[1157] + U41*I1[1157]
           + (threeo2z)*(I2[933] - (lpoz)*I3[933]);
*(vp++) = U01*I0[1158] + U41*I1[1158]
           + (threeo2z)*(I2[934] - (lpoz)*I3[934])
           + (fouro2zn)*I4[867];
*(vp++) = U01*I0[1159] + U41*I1[1159]
           + (threeo2z)*(I2[935] - (lpoz)*I3[935])
           + (threeo2zn)*I4[868];
*(vp++) = U01*I0[1160] + U41*I1[1160]
           + (threeo2z)*(I2[936] - (lpoz)*I3[936])
           + (twoo2zn)*I4[869];
*(vp++) = U01*I0[1161] + U41*I1[1161]
           + (threeo2z)*(I2[937] - (lpoz)*I3[937])
           + (oneo2zn)*I4[870];
*(vp++) = U01*I0[1162] + U41*I1[1162]
           + (threeo2z)*(I2[938] - (lpoz)*I3[938]);
*(vp++) = U01*I0[1163] + U41*I1[1163]
           + (threeo2z)*(I2[939] - (lpoz)*I3[939])
           + (fiveo2zn)*I4[871];
*(vp++) = U01*I0[1164] + U41*I1[1164]
           + (threeo2z)*(I2[940] - (lpoz)*I3[940])
           + (fouro2zn)*I4[872];
*(vp++) = U01*I0[1165] + U41*I1[1165]
           + (threeo2z)*(I2[941] - (lpoz)*I3[941])
           + (threeo2zn)*I4[873];
*(vp++) = U01*I0[1166] + U41*I1[1166]
           + (threeo2z)*(I2[942] - (lpoz)*I3[942])
           + (twoo2zn)*I4[874];
*(vp++) = U01*I0[1167] + U41*I1[1167]
           + (threeo2z)*(I2[943] - (lpoz)*I3[943])
           + (oneo2zn)*I4[875];
*(vp++) = U01*I0[1168] + U41*I1[1168]
           + (threeo2z)*(I2[944] - (lpoz)*I3[944]);
*(vp++) = U01*I0[1169] + U41*I1[1169]
           + (threeo2z)*(I2[945] - (lpoz)*I3[945])
           + (sixo2zn)*I4[876];
*(vp++) = U01*I0[1170] + U41*I1[1170]
           + (threeo2z)*(I2[946] - (lpoz)*I3[946])
           + (fiveo2zn)*I4[877];
*(vp++) = U01*I0[1171] + U41*I1[1171]
           + (threeo2z)*(I2[947] - (lpoz)*I3[947])
           + (fouro2zn)*I4[878];
*(vp++) = U01*I0[1172] + U41*I1[1172]
           + (threeo2z)*(I2[948] - (lpoz)*I3[948])
           + (threeo2zn)*I4[879];
*(vp++) = U01*I0[1173] + U41*I1[1173]
           + (threeo2z)*(I2[949] - (lpoz)*I3[949])
           + (twoo2zn)*I4[880];
*(vp++) = U01*I0[1174] + U41*I1[1174]
           + (threeo2z)*(I2[950] - (lpoz)*I3[950])
           + (oneo2zn)*I4[881];
*(vp++) = U01*I0[1175] + U41*I1[1175]
           + (threeo2z)*(I2[951] - (lpoz)*I3[951]);
*(vp++) = U01*I0[1176] + U41*I1[1176]
           + (twoo2z)*(I2[952] - (lpoz)*I3[952]);
*(vp++) = U01*I0[1177] + U41*I1[1177]
           + (twoo2z)*(I2[953] - (lpoz)*I3[953])
           + (oneo2zn)*I4[882];
*(vp++) = U01*I0[1178] + U41*I1[1178]
           + (twoo2z)*(I2[954] - (lpoz)*I3[954]);
*(vp++) = U01*I0[1179] + U41*I1[1179]
           + (twoo2z)*(I2[955] - (lpoz)*I3[955])
           + (twoo2zn)*I4[883];
*(vp++) = U01*I0[1180] + U41*I1[1180]
           + (twoo2z)*(I2[956] - (lpoz)*I3[956])
           + (oneo2zn)*I4[884];
*(vp++) = U01*I0[1181] + U41*I1[1181]
           + (twoo2z)*(I2[957] - (lpoz)*I3[957]);
*(vp++) = U01*I0[1182] + U41*I1[1182]
           + (twoo2z)*(I2[958] - (lpoz)*I3[958])
           + (threeo2zn)*I4[885];
*(vp++) = U01*I0[1183] + U41*I1[1183]
           + (twoo2z)*(I2[959] - (lpoz)*I3[959])
           + (twoo2zn)*I4[886];
*(vp++) = U01*I0[1184] + U41*I1[1184]
           + (twoo2z)*(I2[960] - (lpoz)*I3[960])
           + (oneo2zn)*I4[887];
*(vp++) = U01*I0[1185] + U41*I1[1185]
           + (twoo2z)*(I2[961] - (lpoz)*I3[961]);
*(vp++) = U01*I0[1186] + U41*I1[1186]
           + (twoo2z)*(I2[962] - (lpoz)*I3[962])
           + (fouro2zn)*I4[888];
*(vp++) = U01*I0[1187] + U41*I1[1187]
           + (twoo2z)*(I2[963] - (lpoz)*I3[963])
           + (threeo2zn)*I4[889];
*(vp++) = U01*I0[1188] + U41*I1[1188]
           + (twoo2z)*(I2[964] - (lpoz)*I3[964])
           + (twoo2zn)*I4[890];
*(vp++) = U01*I0[1189] + U41*I1[1189]
           + (twoo2z)*(I2[965] - (lpoz)*I3[965])
           + (oneo2zn)*I4[891];
*(vp++) = U01*I0[1190] + U41*I1[1190]
           + (twoo2z)*(I2[966] - (lpoz)*I3[966]);
*(vp++) = U01*I0[1191] + U41*I1[1191]
           + (twoo2z)*(I2[967] - (lpoz)*I3[967])
           + (fiveo2zn)*I4[892];
*(vp++) = U01*I0[1192] + U41*I1[1192]
           + (twoo2z)*(I2[968] - (lpoz)*I3[968])
           + (fouro2zn)*I4[893];
*(vp++) = U01*I0[1193] + U41*I1[1193]
           + (twoo2z)*(I2[969] - (lpoz)*I3[969])
           + (threeo2zn)*I4[894];
*(vp++) = U01*I0[1194] + U41*I1[1194]
           + (twoo2z)*(I2[970] - (lpoz)*I3[970])
           + (twoo2zn)*I4[895];
*(vp++) = U01*I0[1195] + U41*I1[1195]
           + (twoo2z)*(I2[971] - (lpoz)*I3[971])
           + (oneo2zn)*I4[896];
*(vp++) = U01*I0[1196] + U41*I1[1196]
           + (twoo2z)*(I2[972] - (lpoz)*I3[972]);
*(vp++) = U01*I0[1197] + U41*I1[1197]
           + (twoo2z)*(I2[973] - (lpoz)*I3[973])
           + (sixo2zn)*I4[897];
*(vp++) = U01*I0[1198] + U41*I1[1198]
           + (twoo2z)*(I2[974] - (lpoz)*I3[974])
           + (fiveo2zn)*I4[898];
*(vp++) = U01*I0[1199] + U41*I1[1199]
           + (twoo2z)*(I2[975] - (lpoz)*I3[975])
           + (fouro2zn)*I4[899];
*(vp++) = U01*I0[1200] + U41*I1[1200]
           + (twoo2z)*(I2[976] - (lpoz)*I3[976])
           + (threeo2zn)*I4[900];
*(vp++) = U01*I0[1201] + U41*I1[1201]
           + (twoo2z)*(I2[977] - (lpoz)*I3[977])
           + (twoo2zn)*I4[901];
*(vp++) = U01*I0[1202] + U41*I1[1202]
           + (twoo2z)*(I2[978] - (lpoz)*I3[978])
           + (oneo2zn)*I4[902];
*(vp++) = U01*I0[1203] + U41*I1[1203]
           + (twoo2z)*(I2[979] - (lpoz)*I3[979]);
*(vp++) = U01*I0[1204] + U41*I1[1204]
           + (oneo2z)*(I2[980] - (lpoz)*I3[980]);
*(vp++) = U01*I0[1205] + U41*I1[1205]
           + (oneo2z)*(I2[981] - (lpoz)*I3[981])
           + (oneo2zn)*I4[903];
*(vp++) = U01*I0[1206] + U41*I1[1206]
           + (oneo2z)*(I2[982] - (lpoz)*I3[982]);
*(vp++) = U01*I0[1207] + U41*I1[1207]
           + (oneo2z)*(I2[983] - (lpoz)*I3[983])
           + (twoo2zn)*I4[904];
*(vp++) = U01*I0[1208] + U41*I1[1208]
           + (oneo2z)*(I2[984] - (lpoz)*I3[984])
           + (oneo2zn)*I4[905];
*(vp++) = U01*I0[1209] + U41*I1[1209]
           + (oneo2z)*(I2[985] - (lpoz)*I3[985]);
*(vp++) = U01*I0[1210] + U41*I1[1210]
           + (oneo2z)*(I2[986] - (lpoz)*I3[986])
           + (threeo2zn)*I4[906];
*(vp++) = U01*I0[1211] + U41*I1[1211]
           + (oneo2z)*(I2[987] - (lpoz)*I3[987])
           + (twoo2zn)*I4[907];
*(vp++) = U01*I0[1212] + U41*I1[1212]
           + (oneo2z)*(I2[988] - (lpoz)*I3[988])
           + (oneo2zn)*I4[908];
*(vp++) = U01*I0[1213] + U41*I1[1213]
           + (oneo2z)*(I2[989] - (lpoz)*I3[989]);
*(vp++) = U01*I0[1214] + U41*I1[1214]
           + (oneo2z)*(I2[990] - (lpoz)*I3[990])
           + (fouro2zn)*I4[909];
*(vp++) = U01*I0[1215] + U41*I1[1215]
           + (oneo2z)*(I2[991] - (lpoz)*I3[991])
           + (threeo2zn)*I4[910];
*(vp++) = U01*I0[1216] + U41*I1[1216]
           + (oneo2z)*(I2[992] - (lpoz)*I3[992])
           + (twoo2zn)*I4[911];
*(vp++) = U01*I0[1217] + U41*I1[1217]
           + (oneo2z)*(I2[993] - (lpoz)*I3[993])
           + (oneo2zn)*I4[912];
*(vp++) = U01*I0[1218] + U41*I1[1218]
           + (oneo2z)*(I2[994] - (lpoz)*I3[994]);
*(vp++) = U01*I0[1219] + U41*I1[1219]
           + (oneo2z)*(I2[995] - (lpoz)*I3[995])
           + (fiveo2zn)*I4[913];
*(vp++) = U01*I0[1220] + U41*I1[1220]
           + (oneo2z)*(I2[996] - (lpoz)*I3[996])
           + (fouro2zn)*I4[914];
*(vp++) = U01*I0[1221] + U41*I1[1221]
           + (oneo2z)*(I2[997] - (lpoz)*I3[997])
           + (threeo2zn)*I4[915];
*(vp++) = U01*I0[1222] + U41*I1[1222]
           + (oneo2z)*(I2[998] - (lpoz)*I3[998])
           + (twoo2zn)*I4[916];
*(vp++) = U01*I0[1223] + U41*I1[1223]
           + (oneo2z)*(I2[999] - (lpoz)*I3[999])
           + (oneo2zn)*I4[917];
*(vp++) = U01*I0[1224] + U41*I1[1224]
           + (oneo2z)*(I2[1000] - (lpoz)*I3[1000]);
*(vp++) = U01*I0[1225] + U41*I1[1225]
           + (oneo2z)*(I2[1001] - (lpoz)*I3[1001])
           + (sixo2zn)*I4[918];
*(vp++) = U01*I0[1226] + U41*I1[1226]
           + (oneo2z)*(I2[1002] - (lpoz)*I3[1002])
           + (fiveo2zn)*I4[919];
*(vp++) = U01*I0[1227] + U41*I1[1227]
           + (oneo2z)*(I2[1003] - (lpoz)*I3[1003])
           + (fouro2zn)*I4[920];
*(vp++) = U01*I0[1228] + U41*I1[1228]
           + (oneo2z)*(I2[1004] - (lpoz)*I3[1004])
           + (threeo2zn)*I4[921];
*(vp++) = U01*I0[1229] + U41*I1[1229]
           + (oneo2z)*(I2[1005] - (lpoz)*I3[1005])
           + (twoo2zn)*I4[922];
*(vp++) = U01*I0[1230] + U41*I1[1230]
           + (oneo2z)*(I2[1006] - (lpoz)*I3[1006])
           + (oneo2zn)*I4[923];
*(vp++) = U01*I0[1231] + U41*I1[1231]
           + (oneo2z)*(I2[1007] - (lpoz)*I3[1007]);
*(vp++) = U01*I0[1232] + U41*I1[1232];
*(vp++) = U01*I0[1233] + U41*I1[1233]
           + (oneo2zn)*I4[924];
*(vp++) = U01*I0[1234] + U41*I1[1234];
*(vp++) = U01*I0[1235] + U41*I1[1235]
           + (twoo2zn)*I4[925];
*(vp++) = U01*I0[1236] + U41*I1[1236]
           + (oneo2zn)*I4[926];
*(vp++) = U01*I0[1237] + U41*I1[1237];
*(vp++) = U01*I0[1238] + U41*I1[1238]
           + (threeo2zn)*I4[927];
*(vp++) = U01*I0[1239] + U41*I1[1239]
           + (twoo2zn)*I4[928];
*(vp++) = U01*I0[1240] + U41*I1[1240]
           + (oneo2zn)*I4[929];
*(vp++) = U01*I0[1241] + U41*I1[1241];
*(vp++) = U01*I0[1242] + U41*I1[1242]
           + (fouro2zn)*I4[930];
*(vp++) = U01*I0[1243] + U41*I1[1243]
           + (threeo2zn)*I4[931];
*(vp++) = U01*I0[1244] + U41*I1[1244]
           + (twoo2zn)*I4[932];
*(vp++) = U01*I0[1245] + U41*I1[1245]
           + (oneo2zn)*I4[933];
*(vp++) = U01*I0[1246] + U41*I1[1246];
*(vp++) = U01*I0[1247] + U41*I1[1247]
           + (fiveo2zn)*I4[934];
*(vp++) = U01*I0[1248] + U41*I1[1248]
           + (fouro2zn)*I4[935];
*(vp++) = U01*I0[1249] + U41*I1[1249]
           + (threeo2zn)*I4[936];
*(vp++) = U01*I0[1250] + U41*I1[1250]
           + (twoo2zn)*I4[937];
*(vp++) = U01*I0[1251] + U41*I1[1251]
           + (oneo2zn)*I4[938];
*(vp++) = U01*I0[1252] + U41*I1[1252];
*(vp++) = U01*I0[1253] + U41*I1[1253]
           + (sixo2zn)*I4[939];
*(vp++) = U01*I0[1254] + U41*I1[1254]
           + (fiveo2zn)*I4[940];
*(vp++) = U01*I0[1255] + U41*I1[1255]
           + (fouro2zn)*I4[941];
*(vp++) = U01*I0[1256] + U41*I1[1256]
           + (threeo2zn)*I4[942];
*(vp++) = U01*I0[1257] + U41*I1[1257]
           + (twoo2zn)*I4[943];
*(vp++) = U01*I0[1258] + U41*I1[1258]
           + (oneo2zn)*I4[944];
*(vp++) = U01*I0[1259] + U41*I1[1259];
*(vp++) = U02*I0[1232] + U42*I1[1232]
           + (eighto2z)*(I2[980] - (lpoz)*I3[980]);
*(vp++) = U02*I0[1233] + U42*I1[1233]
           + (eighto2z)*(I2[981] - (lpoz)*I3[981]);
*(vp++) = U02*I0[1234] + U42*I1[1234]
           + (eighto2z)*(I2[982] - (lpoz)*I3[982])
           + (oneo2zn)*I4[924];
*(vp++) = U02*I0[1235] + U42*I1[1235]
           + (eighto2z)*(I2[983] - (lpoz)*I3[983]);
*(vp++) = U02*I0[1236] + U42*I1[1236]
           + (eighto2z)*(I2[984] - (lpoz)*I3[984])
           + (oneo2zn)*I4[925];
*(vp++) = U02*I0[1237] + U42*I1[1237]
           + (eighto2z)*(I2[985] - (lpoz)*I3[985])
           + (twoo2zn)*I4[926];
*(vp++) = U02*I0[1238] + U42*I1[1238]
           + (eighto2z)*(I2[986] - (lpoz)*I3[986]);
*(vp++) = U02*I0[1239] + U42*I1[1239]
           + (eighto2z)*(I2[987] - (lpoz)*I3[987])
           + (oneo2zn)*I4[927];
*(vp++) = U02*I0[1240] + U42*I1[1240]
           + (eighto2z)*(I2[988] - (lpoz)*I3[988])
           + (twoo2zn)*I4[928];
*(vp++) = U02*I0[1241] + U42*I1[1241]
           + (eighto2z)*(I2[989] - (lpoz)*I3[989])
           + (threeo2zn)*I4[929];
*(vp++) = U02*I0[1242] + U42*I1[1242]
           + (eighto2z)*(I2[990] - (lpoz)*I3[990]);
*(vp++) = U02*I0[1243] + U42*I1[1243]
           + (eighto2z)*(I2[991] - (lpoz)*I3[991])
           + (oneo2zn)*I4[930];
*(vp++) = U02*I0[1244] + U42*I1[1244]
           + (eighto2z)*(I2[992] - (lpoz)*I3[992])
           + (twoo2zn)*I4[931];
*(vp++) = U02*I0[1245] + U42*I1[1245]
           + (eighto2z)*(I2[993] - (lpoz)*I3[993])
           + (threeo2zn)*I4[932];
*(vp++) = U02*I0[1246] + U42*I1[1246]
           + (eighto2z)*(I2[994] - (lpoz)*I3[994])
           + (fouro2zn)*I4[933];
*(vp++) = U02*I0[1247] + U42*I1[1247]
           + (eighto2z)*(I2[995] - (lpoz)*I3[995]);
*(vp++) = U02*I0[1248] + U42*I1[1248]
           + (eighto2z)*(I2[996] - (lpoz)*I3[996])
           + (oneo2zn)*I4[934];
*(vp++) = U02*I0[1249] + U42*I1[1249]
           + (eighto2z)*(I2[997] - (lpoz)*I3[997])
           + (twoo2zn)*I4[935];
*(vp++) = U02*I0[1250] + U42*I1[1250]
           + (eighto2z)*(I2[998] - (lpoz)*I3[998])
           + (threeo2zn)*I4[936];
*(vp++) = U02*I0[1251] + U42*I1[1251]
           + (eighto2z)*(I2[999] - (lpoz)*I3[999])
           + (fouro2zn)*I4[937];
*(vp++) = U02*I0[1252] + U42*I1[1252]
           + (eighto2z)*(I2[1000] - (lpoz)*I3[1000])
           + (fiveo2zn)*I4[938];
*(vp++) = U02*I0[1253] + U42*I1[1253]
           + (eighto2z)*(I2[1001] - (lpoz)*I3[1001]);
*(vp++) = U02*I0[1254] + U42*I1[1254]
           + (eighto2z)*(I2[1002] - (lpoz)*I3[1002])
           + (oneo2zn)*I4[939];
*(vp++) = U02*I0[1255] + U42*I1[1255]
           + (eighto2z)*(I2[1003] - (lpoz)*I3[1003])
           + (twoo2zn)*I4[940];
*(vp++) = U02*I0[1256] + U42*I1[1256]
           + (eighto2z)*(I2[1004] - (lpoz)*I3[1004])
           + (threeo2zn)*I4[941];
*(vp++) = U02*I0[1257] + U42*I1[1257]
           + (eighto2z)*(I2[1005] - (lpoz)*I3[1005])
           + (fouro2zn)*I4[942];
*(vp++) = U02*I0[1258] + U42*I1[1258]
           + (eighto2z)*(I2[1006] - (lpoz)*I3[1006])
           + (fiveo2zn)*I4[943];
*(vp++) = U02*I0[1259] + U42*I1[1259]
           + (eighto2z)*(I2[1007] - (lpoz)*I3[1007])
           + (sixo2zn)*I4[944];
return vp;
}
/* Total number of FLOPs = 11970 */
