/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ks||is) integrals */

#include <libint/libint.h>
#include "libr12.h"

REALTYPE *_r_build_k0i0_0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[0] - U10*I3[0] + loo2p*I2[0]
        + (sixo2z)*I1[0] - (sixo4zn)*I4[0] - (sixo4zn)*I5[0];
*(vp++) = U00*I0[1] - U10*I3[1] + loo2p*I2[1]
        + (sixo2z)*I1[1] - (sixo4zn)*I4[1] - (fiveo4zn)*I5[1];
*(vp++) = U00*I0[2] - U10*I3[2] + loo2p*I2[2]
        + (sixo2z)*I1[2] - (sixo4zn)*I4[2] - (fiveo4zn)*I5[2];
*(vp++) = U00*I0[3] - U10*I3[3] + loo2p*I2[3]
        + (sixo2z)*I1[3] - (sixo4zn)*I4[3] - (fouro4zn)*I5[3];
*(vp++) = U00*I0[4] - U10*I3[4] + loo2p*I2[4]
        + (sixo2z)*I1[4] - (sixo4zn)*I4[4] - (fouro4zn)*I5[4];
*(vp++) = U00*I0[5] - U10*I3[5] + loo2p*I2[5]
        + (sixo2z)*I1[5] - (sixo4zn)*I4[5] - (fouro4zn)*I5[5];
*(vp++) = U00*I0[6] - U10*I3[6] + loo2p*I2[6]
        + (sixo2z)*I1[6] - (sixo4zn)*I4[6] - (threeo4zn)*I5[6];
*(vp++) = U00*I0[7] - U10*I3[7] + loo2p*I2[7]
        + (sixo2z)*I1[7] - (sixo4zn)*I4[7] - (threeo4zn)*I5[7];
*(vp++) = U00*I0[8] - U10*I3[8] + loo2p*I2[8]
        + (sixo2z)*I1[8] - (sixo4zn)*I4[8] - (threeo4zn)*I5[8];
*(vp++) = U00*I0[9] - U10*I3[9] + loo2p*I2[9]
        + (sixo2z)*I1[9] - (sixo4zn)*I4[9] - (threeo4zn)*I5[9];
*(vp++) = U00*I0[10] - U10*I3[10] + loo2p*I2[10]
        + (sixo2z)*I1[10] - (sixo4zn)*I4[10] - (twoo4zn)*I5[10];
*(vp++) = U00*I0[11] - U10*I3[11] + loo2p*I2[11]
        + (sixo2z)*I1[11] - (sixo4zn)*I4[11] - (twoo4zn)*I5[11];
*(vp++) = U00*I0[12] - U10*I3[12] + loo2p*I2[12]
        + (sixo2z)*I1[12] - (sixo4zn)*I4[12] - (twoo4zn)*I5[12];
*(vp++) = U00*I0[13] - U10*I3[13] + loo2p*I2[13]
        + (sixo2z)*I1[13] - (sixo4zn)*I4[13] - (twoo4zn)*I5[13];
*(vp++) = U00*I0[14] - U10*I3[14] + loo2p*I2[14]
        + (sixo2z)*I1[14] - (sixo4zn)*I4[14] - (twoo4zn)*I5[14];
*(vp++) = U00*I0[15] - U10*I3[15] + loo2p*I2[15]
        + (sixo2z)*I1[15] - (sixo4zn)*I4[15] - (oneo4zn)*I5[15];
*(vp++) = U00*I0[16] - U10*I3[16] + loo2p*I2[16]
        + (sixo2z)*I1[16] - (sixo4zn)*I4[16] - (oneo4zn)*I5[16];
*(vp++) = U00*I0[17] - U10*I3[17] + loo2p*I2[17]
        + (sixo2z)*I1[17] - (sixo4zn)*I4[17] - (oneo4zn)*I5[17];
*(vp++) = U00*I0[18] - U10*I3[18] + loo2p*I2[18]
        + (sixo2z)*I1[18] - (sixo4zn)*I4[18] - (oneo4zn)*I5[18];
*(vp++) = U00*I0[19] - U10*I3[19] + loo2p*I2[19]
        + (sixo2z)*I1[19] - (sixo4zn)*I4[19] - (oneo4zn)*I5[19];
*(vp++) = U00*I0[20] - U10*I3[20] + loo2p*I2[20]
        + (sixo2z)*I1[20] - (sixo4zn)*I4[20] - (oneo4zn)*I5[20];
*(vp++) = U00*I0[21] - U10*I3[21] + loo2p*I2[21]
        + (sixo2z)*I1[21] - (sixo4zn)*I4[21];
*(vp++) = U00*I0[22] - U10*I3[22] + loo2p*I2[22]
        + (sixo2z)*I1[22] - (sixo4zn)*I4[22];
*(vp++) = U00*I0[23] - U10*I3[23] + loo2p*I2[23]
        + (sixo2z)*I1[23] - (sixo4zn)*I4[23];
*(vp++) = U00*I0[24] - U10*I3[24] + loo2p*I2[24]
        + (sixo2z)*I1[24] - (sixo4zn)*I4[24];
*(vp++) = U00*I0[25] - U10*I3[25] + loo2p*I2[25]
        + (sixo2z)*I1[25] - (sixo4zn)*I4[25];
*(vp++) = U00*I0[26] - U10*I3[26] + loo2p*I2[26]
        + (sixo2z)*I1[26] - (sixo4zn)*I4[26];
*(vp++) = U00*I0[27] - U10*I3[27] + loo2p*I2[27]
        + (sixo2z)*I1[27] - (sixo4zn)*I4[27];
*(vp++) = U00*I0[28] - U10*I3[28] + loo2p*I2[28]
        + (fiveo2z)*I1[28] - (fiveo4zn)*I4[28] - (sixo4zn)*I5[21];
*(vp++) = U00*I0[29] - U10*I3[29] + loo2p*I2[29]
        + (fiveo2z)*I1[29] - (fiveo4zn)*I4[29] - (fiveo4zn)*I5[22];
*(vp++) = U00*I0[30] - U10*I3[30] + loo2p*I2[30]
        + (fiveo2z)*I1[30] - (fiveo4zn)*I4[30] - (fiveo4zn)*I5[23];
*(vp++) = U00*I0[31] - U10*I3[31] + loo2p*I2[31]
        + (fiveo2z)*I1[31] - (fiveo4zn)*I4[31] - (fouro4zn)*I5[24];
*(vp++) = U00*I0[32] - U10*I3[32] + loo2p*I2[32]
        + (fiveo2z)*I1[32] - (fiveo4zn)*I4[32] - (fouro4zn)*I5[25];
*(vp++) = U00*I0[33] - U10*I3[33] + loo2p*I2[33]
        + (fiveo2z)*I1[33] - (fiveo4zn)*I4[33] - (fouro4zn)*I5[26];
*(vp++) = U00*I0[34] - U10*I3[34] + loo2p*I2[34]
        + (fiveo2z)*I1[34] - (fiveo4zn)*I4[34] - (threeo4zn)*I5[27];
*(vp++) = U00*I0[35] - U10*I3[35] + loo2p*I2[35]
        + (fiveo2z)*I1[35] - (fiveo4zn)*I4[35] - (threeo4zn)*I5[28];
*(vp++) = U00*I0[36] - U10*I3[36] + loo2p*I2[36]
        + (fiveo2z)*I1[36] - (fiveo4zn)*I4[36] - (threeo4zn)*I5[29];
*(vp++) = U00*I0[37] - U10*I3[37] + loo2p*I2[37]
        + (fiveo2z)*I1[37] - (fiveo4zn)*I4[37] - (threeo4zn)*I5[30];
*(vp++) = U00*I0[38] - U10*I3[38] + loo2p*I2[38]
        + (fiveo2z)*I1[38] - (fiveo4zn)*I4[38] - (twoo4zn)*I5[31];
*(vp++) = U00*I0[39] - U10*I3[39] + loo2p*I2[39]
        + (fiveo2z)*I1[39] - (fiveo4zn)*I4[39] - (twoo4zn)*I5[32];
*(vp++) = U00*I0[40] - U10*I3[40] + loo2p*I2[40]
        + (fiveo2z)*I1[40] - (fiveo4zn)*I4[40] - (twoo4zn)*I5[33];
*(vp++) = U00*I0[41] - U10*I3[41] + loo2p*I2[41]
        + (fiveo2z)*I1[41] - (fiveo4zn)*I4[41] - (twoo4zn)*I5[34];
*(vp++) = U00*I0[42] - U10*I3[42] + loo2p*I2[42]
        + (fiveo2z)*I1[42] - (fiveo4zn)*I4[42] - (twoo4zn)*I5[35];
*(vp++) = U00*I0[43] - U10*I3[43] + loo2p*I2[43]
        + (fiveo2z)*I1[43] - (fiveo4zn)*I4[43] - (oneo4zn)*I5[36];
*(vp++) = U00*I0[44] - U10*I3[44] + loo2p*I2[44]
        + (fiveo2z)*I1[44] - (fiveo4zn)*I4[44] - (oneo4zn)*I5[37];
*(vp++) = U00*I0[45] - U10*I3[45] + loo2p*I2[45]
        + (fiveo2z)*I1[45] - (fiveo4zn)*I4[45] - (oneo4zn)*I5[38];
*(vp++) = U00*I0[46] - U10*I3[46] + loo2p*I2[46]
        + (fiveo2z)*I1[46] - (fiveo4zn)*I4[46] - (oneo4zn)*I5[39];
*(vp++) = U00*I0[47] - U10*I3[47] + loo2p*I2[47]
        + (fiveo2z)*I1[47] - (fiveo4zn)*I4[47] - (oneo4zn)*I5[40];
*(vp++) = U00*I0[48] - U10*I3[48] + loo2p*I2[48]
        + (fiveo2z)*I1[48] - (fiveo4zn)*I4[48] - (oneo4zn)*I5[41];
*(vp++) = U00*I0[49] - U10*I3[49] + loo2p*I2[49]
        + (fiveo2z)*I1[49] - (fiveo4zn)*I4[49];
*(vp++) = U00*I0[50] - U10*I3[50] + loo2p*I2[50]
        + (fiveo2z)*I1[50] - (fiveo4zn)*I4[50];
*(vp++) = U00*I0[51] - U10*I3[51] + loo2p*I2[51]
        + (fiveo2z)*I1[51] - (fiveo4zn)*I4[51];
*(vp++) = U00*I0[52] - U10*I3[52] + loo2p*I2[52]
        + (fiveo2z)*I1[52] - (fiveo4zn)*I4[52];
*(vp++) = U00*I0[53] - U10*I3[53] + loo2p*I2[53]
        + (fiveo2z)*I1[53] - (fiveo4zn)*I4[53];
*(vp++) = U00*I0[54] - U10*I3[54] + loo2p*I2[54]
        + (fiveo2z)*I1[54] - (fiveo4zn)*I4[54];
*(vp++) = U00*I0[55] - U10*I3[55] + loo2p*I2[55]
        + (fiveo2z)*I1[55] - (fiveo4zn)*I4[55];
*(vp++) = U00*I0[56] - U10*I3[56] + loo2p*I2[56]
        + (fiveo2z)*I1[56] - (fiveo4zn)*I4[56] - (sixo4zn)*I5[42];
*(vp++) = U00*I0[57] - U10*I3[57] + loo2p*I2[57]
        + (fiveo2z)*I1[57] - (fiveo4zn)*I4[57] - (fiveo4zn)*I5[43];
*(vp++) = U00*I0[58] - U10*I3[58] + loo2p*I2[58]
        + (fiveo2z)*I1[58] - (fiveo4zn)*I4[58] - (fiveo4zn)*I5[44];
*(vp++) = U00*I0[59] - U10*I3[59] + loo2p*I2[59]
        + (fiveo2z)*I1[59] - (fiveo4zn)*I4[59] - (fouro4zn)*I5[45];
*(vp++) = U00*I0[60] - U10*I3[60] + loo2p*I2[60]
        + (fiveo2z)*I1[60] - (fiveo4zn)*I4[60] - (fouro4zn)*I5[46];
*(vp++) = U00*I0[61] - U10*I3[61] + loo2p*I2[61]
        + (fiveo2z)*I1[61] - (fiveo4zn)*I4[61] - (fouro4zn)*I5[47];
*(vp++) = U00*I0[62] - U10*I3[62] + loo2p*I2[62]
        + (fiveo2z)*I1[62] - (fiveo4zn)*I4[62] - (threeo4zn)*I5[48];
*(vp++) = U00*I0[63] - U10*I3[63] + loo2p*I2[63]
        + (fiveo2z)*I1[63] - (fiveo4zn)*I4[63] - (threeo4zn)*I5[49];
*(vp++) = U00*I0[64] - U10*I3[64] + loo2p*I2[64]
        + (fiveo2z)*I1[64] - (fiveo4zn)*I4[64] - (threeo4zn)*I5[50];
*(vp++) = U00*I0[65] - U10*I3[65] + loo2p*I2[65]
        + (fiveo2z)*I1[65] - (fiveo4zn)*I4[65] - (threeo4zn)*I5[51];
*(vp++) = U00*I0[66] - U10*I3[66] + loo2p*I2[66]
        + (fiveo2z)*I1[66] - (fiveo4zn)*I4[66] - (twoo4zn)*I5[52];
*(vp++) = U00*I0[67] - U10*I3[67] + loo2p*I2[67]
        + (fiveo2z)*I1[67] - (fiveo4zn)*I4[67] - (twoo4zn)*I5[53];
*(vp++) = U00*I0[68] - U10*I3[68] + loo2p*I2[68]
        + (fiveo2z)*I1[68] - (fiveo4zn)*I4[68] - (twoo4zn)*I5[54];
*(vp++) = U00*I0[69] - U10*I3[69] + loo2p*I2[69]
        + (fiveo2z)*I1[69] - (fiveo4zn)*I4[69] - (twoo4zn)*I5[55];
*(vp++) = U00*I0[70] - U10*I3[70] + loo2p*I2[70]
        + (fiveo2z)*I1[70] - (fiveo4zn)*I4[70] - (twoo4zn)*I5[56];
*(vp++) = U00*I0[71] - U10*I3[71] + loo2p*I2[71]
        + (fiveo2z)*I1[71] - (fiveo4zn)*I4[71] - (oneo4zn)*I5[57];
*(vp++) = U00*I0[72] - U10*I3[72] + loo2p*I2[72]
        + (fiveo2z)*I1[72] - (fiveo4zn)*I4[72] - (oneo4zn)*I5[58];
*(vp++) = U00*I0[73] - U10*I3[73] + loo2p*I2[73]
        + (fiveo2z)*I1[73] - (fiveo4zn)*I4[73] - (oneo4zn)*I5[59];
*(vp++) = U00*I0[74] - U10*I3[74] + loo2p*I2[74]
        + (fiveo2z)*I1[74] - (fiveo4zn)*I4[74] - (oneo4zn)*I5[60];
*(vp++) = U00*I0[75] - U10*I3[75] + loo2p*I2[75]
        + (fiveo2z)*I1[75] - (fiveo4zn)*I4[75] - (oneo4zn)*I5[61];
*(vp++) = U00*I0[76] - U10*I3[76] + loo2p*I2[76]
        + (fiveo2z)*I1[76] - (fiveo4zn)*I4[76] - (oneo4zn)*I5[62];
*(vp++) = U00*I0[77] - U10*I3[77] + loo2p*I2[77]
        + (fiveo2z)*I1[77] - (fiveo4zn)*I4[77];
*(vp++) = U00*I0[78] - U10*I3[78] + loo2p*I2[78]
        + (fiveo2z)*I1[78] - (fiveo4zn)*I4[78];
*(vp++) = U00*I0[79] - U10*I3[79] + loo2p*I2[79]
        + (fiveo2z)*I1[79] - (fiveo4zn)*I4[79];
*(vp++) = U00*I0[80] - U10*I3[80] + loo2p*I2[80]
        + (fiveo2z)*I1[80] - (fiveo4zn)*I4[80];
*(vp++) = U00*I0[81] - U10*I3[81] + loo2p*I2[81]
        + (fiveo2z)*I1[81] - (fiveo4zn)*I4[81];
*(vp++) = U00*I0[82] - U10*I3[82] + loo2p*I2[82]
        + (fiveo2z)*I1[82] - (fiveo4zn)*I4[82];
*(vp++) = U00*I0[83] - U10*I3[83] + loo2p*I2[83]
        + (fiveo2z)*I1[83] - (fiveo4zn)*I4[83];
*(vp++) = U00*I0[84] - U10*I3[84] + loo2p*I2[84]
        + (fouro2z)*I1[84] - (fouro4zn)*I4[84] - (sixo4zn)*I5[63];
*(vp++) = U00*I0[85] - U10*I3[85] + loo2p*I2[85]
        + (fouro2z)*I1[85] - (fouro4zn)*I4[85] - (fiveo4zn)*I5[64];
*(vp++) = U00*I0[86] - U10*I3[86] + loo2p*I2[86]
        + (fouro2z)*I1[86] - (fouro4zn)*I4[86] - (fiveo4zn)*I5[65];
*(vp++) = U00*I0[87] - U10*I3[87] + loo2p*I2[87]
        + (fouro2z)*I1[87] - (fouro4zn)*I4[87] - (fouro4zn)*I5[66];
*(vp++) = U00*I0[88] - U10*I3[88] + loo2p*I2[88]
        + (fouro2z)*I1[88] - (fouro4zn)*I4[88] - (fouro4zn)*I5[67];
*(vp++) = U00*I0[89] - U10*I3[89] + loo2p*I2[89]
        + (fouro2z)*I1[89] - (fouro4zn)*I4[89] - (fouro4zn)*I5[68];
*(vp++) = U00*I0[90] - U10*I3[90] + loo2p*I2[90]
        + (fouro2z)*I1[90] - (fouro4zn)*I4[90] - (threeo4zn)*I5[69];
*(vp++) = U00*I0[91] - U10*I3[91] + loo2p*I2[91]
        + (fouro2z)*I1[91] - (fouro4zn)*I4[91] - (threeo4zn)*I5[70];
*(vp++) = U00*I0[92] - U10*I3[92] + loo2p*I2[92]
        + (fouro2z)*I1[92] - (fouro4zn)*I4[92] - (threeo4zn)*I5[71];
*(vp++) = U00*I0[93] - U10*I3[93] + loo2p*I2[93]
        + (fouro2z)*I1[93] - (fouro4zn)*I4[93] - (threeo4zn)*I5[72];
*(vp++) = U00*I0[94] - U10*I3[94] + loo2p*I2[94]
        + (fouro2z)*I1[94] - (fouro4zn)*I4[94] - (twoo4zn)*I5[73];
*(vp++) = U00*I0[95] - U10*I3[95] + loo2p*I2[95]
        + (fouro2z)*I1[95] - (fouro4zn)*I4[95] - (twoo4zn)*I5[74];
*(vp++) = U00*I0[96] - U10*I3[96] + loo2p*I2[96]
        + (fouro2z)*I1[96] - (fouro4zn)*I4[96] - (twoo4zn)*I5[75];
*(vp++) = U00*I0[97] - U10*I3[97] + loo2p*I2[97]
        + (fouro2z)*I1[97] - (fouro4zn)*I4[97] - (twoo4zn)*I5[76];
*(vp++) = U00*I0[98] - U10*I3[98] + loo2p*I2[98]
        + (fouro2z)*I1[98] - (fouro4zn)*I4[98] - (twoo4zn)*I5[77];
*(vp++) = U00*I0[99] - U10*I3[99] + loo2p*I2[99]
        + (fouro2z)*I1[99] - (fouro4zn)*I4[99] - (oneo4zn)*I5[78];
*(vp++) = U00*I0[100] - U10*I3[100] + loo2p*I2[100]
        + (fouro2z)*I1[100] - (fouro4zn)*I4[100] - (oneo4zn)*I5[79];
*(vp++) = U00*I0[101] - U10*I3[101] + loo2p*I2[101]
        + (fouro2z)*I1[101] - (fouro4zn)*I4[101] - (oneo4zn)*I5[80];
*(vp++) = U00*I0[102] - U10*I3[102] + loo2p*I2[102]
        + (fouro2z)*I1[102] - (fouro4zn)*I4[102] - (oneo4zn)*I5[81];
*(vp++) = U00*I0[103] - U10*I3[103] + loo2p*I2[103]
        + (fouro2z)*I1[103] - (fouro4zn)*I4[103] - (oneo4zn)*I5[82];
*(vp++) = U00*I0[104] - U10*I3[104] + loo2p*I2[104]
        + (fouro2z)*I1[104] - (fouro4zn)*I4[104] - (oneo4zn)*I5[83];
*(vp++) = U00*I0[105] - U10*I3[105] + loo2p*I2[105]
        + (fouro2z)*I1[105] - (fouro4zn)*I4[105];
*(vp++) = U00*I0[106] - U10*I3[106] + loo2p*I2[106]
        + (fouro2z)*I1[106] - (fouro4zn)*I4[106];
*(vp++) = U00*I0[107] - U10*I3[107] + loo2p*I2[107]
        + (fouro2z)*I1[107] - (fouro4zn)*I4[107];
*(vp++) = U00*I0[108] - U10*I3[108] + loo2p*I2[108]
        + (fouro2z)*I1[108] - (fouro4zn)*I4[108];
*(vp++) = U00*I0[109] - U10*I3[109] + loo2p*I2[109]
        + (fouro2z)*I1[109] - (fouro4zn)*I4[109];
*(vp++) = U00*I0[110] - U10*I3[110] + loo2p*I2[110]
        + (fouro2z)*I1[110] - (fouro4zn)*I4[110];
*(vp++) = U00*I0[111] - U10*I3[111] + loo2p*I2[111]
        + (fouro2z)*I1[111] - (fouro4zn)*I4[111];
*(vp++) = U00*I0[112] - U10*I3[112] + loo2p*I2[112]
        + (fouro2z)*I1[112] - (fouro4zn)*I4[112] - (sixo4zn)*I5[84];
*(vp++) = U00*I0[113] - U10*I3[113] + loo2p*I2[113]
        + (fouro2z)*I1[113] - (fouro4zn)*I4[113] - (fiveo4zn)*I5[85];
*(vp++) = U00*I0[114] - U10*I3[114] + loo2p*I2[114]
        + (fouro2z)*I1[114] - (fouro4zn)*I4[114] - (fiveo4zn)*I5[86];
*(vp++) = U00*I0[115] - U10*I3[115] + loo2p*I2[115]
        + (fouro2z)*I1[115] - (fouro4zn)*I4[115] - (fouro4zn)*I5[87];
*(vp++) = U00*I0[116] - U10*I3[116] + loo2p*I2[116]
        + (fouro2z)*I1[116] - (fouro4zn)*I4[116] - (fouro4zn)*I5[88];
*(vp++) = U00*I0[117] - U10*I3[117] + loo2p*I2[117]
        + (fouro2z)*I1[117] - (fouro4zn)*I4[117] - (fouro4zn)*I5[89];
*(vp++) = U00*I0[118] - U10*I3[118] + loo2p*I2[118]
        + (fouro2z)*I1[118] - (fouro4zn)*I4[118] - (threeo4zn)*I5[90];
*(vp++) = U00*I0[119] - U10*I3[119] + loo2p*I2[119]
        + (fouro2z)*I1[119] - (fouro4zn)*I4[119] - (threeo4zn)*I5[91];
*(vp++) = U00*I0[120] - U10*I3[120] + loo2p*I2[120]
        + (fouro2z)*I1[120] - (fouro4zn)*I4[120] - (threeo4zn)*I5[92];
*(vp++) = U00*I0[121] - U10*I3[121] + loo2p*I2[121]
        + (fouro2z)*I1[121] - (fouro4zn)*I4[121] - (threeo4zn)*I5[93];
*(vp++) = U00*I0[122] - U10*I3[122] + loo2p*I2[122]
        + (fouro2z)*I1[122] - (fouro4zn)*I4[122] - (twoo4zn)*I5[94];
*(vp++) = U00*I0[123] - U10*I3[123] + loo2p*I2[123]
        + (fouro2z)*I1[123] - (fouro4zn)*I4[123] - (twoo4zn)*I5[95];
*(vp++) = U00*I0[124] - U10*I3[124] + loo2p*I2[124]
        + (fouro2z)*I1[124] - (fouro4zn)*I4[124] - (twoo4zn)*I5[96];
*(vp++) = U00*I0[125] - U10*I3[125] + loo2p*I2[125]
        + (fouro2z)*I1[125] - (fouro4zn)*I4[125] - (twoo4zn)*I5[97];
*(vp++) = U00*I0[126] - U10*I3[126] + loo2p*I2[126]
        + (fouro2z)*I1[126] - (fouro4zn)*I4[126] - (twoo4zn)*I5[98];
*(vp++) = U00*I0[127] - U10*I3[127] + loo2p*I2[127]
        + (fouro2z)*I1[127] - (fouro4zn)*I4[127] - (oneo4zn)*I5[99];
*(vp++) = U00*I0[128] - U10*I3[128] + loo2p*I2[128]
        + (fouro2z)*I1[128] - (fouro4zn)*I4[128] - (oneo4zn)*I5[100];
*(vp++) = U00*I0[129] - U10*I3[129] + loo2p*I2[129]
        + (fouro2z)*I1[129] - (fouro4zn)*I4[129] - (oneo4zn)*I5[101];
*(vp++) = U00*I0[130] - U10*I3[130] + loo2p*I2[130]
        + (fouro2z)*I1[130] - (fouro4zn)*I4[130] - (oneo4zn)*I5[102];
*(vp++) = U00*I0[131] - U10*I3[131] + loo2p*I2[131]
        + (fouro2z)*I1[131] - (fouro4zn)*I4[131] - (oneo4zn)*I5[103];
*(vp++) = U00*I0[132] - U10*I3[132] + loo2p*I2[132]
        + (fouro2z)*I1[132] - (fouro4zn)*I4[132] - (oneo4zn)*I5[104];
*(vp++) = U00*I0[133] - U10*I3[133] + loo2p*I2[133]
        + (fouro2z)*I1[133] - (fouro4zn)*I4[133];
*(vp++) = U00*I0[134] - U10*I3[134] + loo2p*I2[134]
        + (fouro2z)*I1[134] - (fouro4zn)*I4[134];
*(vp++) = U00*I0[135] - U10*I3[135] + loo2p*I2[135]
        + (fouro2z)*I1[135] - (fouro4zn)*I4[135];
*(vp++) = U00*I0[136] - U10*I3[136] + loo2p*I2[136]
        + (fouro2z)*I1[136] - (fouro4zn)*I4[136];
*(vp++) = U00*I0[137] - U10*I3[137] + loo2p*I2[137]
        + (fouro2z)*I1[137] - (fouro4zn)*I4[137];
*(vp++) = U00*I0[138] - U10*I3[138] + loo2p*I2[138]
        + (fouro2z)*I1[138] - (fouro4zn)*I4[138];
*(vp++) = U00*I0[139] - U10*I3[139] + loo2p*I2[139]
        + (fouro2z)*I1[139] - (fouro4zn)*I4[139];
*(vp++) = U00*I0[140] - U10*I3[140] + loo2p*I2[140]
        + (fouro2z)*I1[140] - (fouro4zn)*I4[140] - (sixo4zn)*I5[105];
*(vp++) = U00*I0[141] - U10*I3[141] + loo2p*I2[141]
        + (fouro2z)*I1[141] - (fouro4zn)*I4[141] - (fiveo4zn)*I5[106];
*(vp++) = U00*I0[142] - U10*I3[142] + loo2p*I2[142]
        + (fouro2z)*I1[142] - (fouro4zn)*I4[142] - (fiveo4zn)*I5[107];
*(vp++) = U00*I0[143] - U10*I3[143] + loo2p*I2[143]
        + (fouro2z)*I1[143] - (fouro4zn)*I4[143] - (fouro4zn)*I5[108];
*(vp++) = U00*I0[144] - U10*I3[144] + loo2p*I2[144]
        + (fouro2z)*I1[144] - (fouro4zn)*I4[144] - (fouro4zn)*I5[109];
*(vp++) = U00*I0[145] - U10*I3[145] + loo2p*I2[145]
        + (fouro2z)*I1[145] - (fouro4zn)*I4[145] - (fouro4zn)*I5[110];
*(vp++) = U00*I0[146] - U10*I3[146] + loo2p*I2[146]
        + (fouro2z)*I1[146] - (fouro4zn)*I4[146] - (threeo4zn)*I5[111];
*(vp++) = U00*I0[147] - U10*I3[147] + loo2p*I2[147]
        + (fouro2z)*I1[147] - (fouro4zn)*I4[147] - (threeo4zn)*I5[112];
*(vp++) = U00*I0[148] - U10*I3[148] + loo2p*I2[148]
        + (fouro2z)*I1[148] - (fouro4zn)*I4[148] - (threeo4zn)*I5[113];
*(vp++) = U00*I0[149] - U10*I3[149] + loo2p*I2[149]
        + (fouro2z)*I1[149] - (fouro4zn)*I4[149] - (threeo4zn)*I5[114];
*(vp++) = U00*I0[150] - U10*I3[150] + loo2p*I2[150]
        + (fouro2z)*I1[150] - (fouro4zn)*I4[150] - (twoo4zn)*I5[115];
*(vp++) = U00*I0[151] - U10*I3[151] + loo2p*I2[151]
        + (fouro2z)*I1[151] - (fouro4zn)*I4[151] - (twoo4zn)*I5[116];
*(vp++) = U00*I0[152] - U10*I3[152] + loo2p*I2[152]
        + (fouro2z)*I1[152] - (fouro4zn)*I4[152] - (twoo4zn)*I5[117];
*(vp++) = U00*I0[153] - U10*I3[153] + loo2p*I2[153]
        + (fouro2z)*I1[153] - (fouro4zn)*I4[153] - (twoo4zn)*I5[118];
*(vp++) = U00*I0[154] - U10*I3[154] + loo2p*I2[154]
        + (fouro2z)*I1[154] - (fouro4zn)*I4[154] - (twoo4zn)*I5[119];
*(vp++) = U00*I0[155] - U10*I3[155] + loo2p*I2[155]
        + (fouro2z)*I1[155] - (fouro4zn)*I4[155] - (oneo4zn)*I5[120];
*(vp++) = U00*I0[156] - U10*I3[156] + loo2p*I2[156]
        + (fouro2z)*I1[156] - (fouro4zn)*I4[156] - (oneo4zn)*I5[121];
*(vp++) = U00*I0[157] - U10*I3[157] + loo2p*I2[157]
        + (fouro2z)*I1[157] - (fouro4zn)*I4[157] - (oneo4zn)*I5[122];
*(vp++) = U00*I0[158] - U10*I3[158] + loo2p*I2[158]
        + (fouro2z)*I1[158] - (fouro4zn)*I4[158] - (oneo4zn)*I5[123];
*(vp++) = U00*I0[159] - U10*I3[159] + loo2p*I2[159]
        + (fouro2z)*I1[159] - (fouro4zn)*I4[159] - (oneo4zn)*I5[124];
*(vp++) = U00*I0[160] - U10*I3[160] + loo2p*I2[160]
        + (fouro2z)*I1[160] - (fouro4zn)*I4[160] - (oneo4zn)*I5[125];
*(vp++) = U00*I0[161] - U10*I3[161] + loo2p*I2[161]
        + (fouro2z)*I1[161] - (fouro4zn)*I4[161];
*(vp++) = U00*I0[162] - U10*I3[162] + loo2p*I2[162]
        + (fouro2z)*I1[162] - (fouro4zn)*I4[162];
*(vp++) = U00*I0[163] - U10*I3[163] + loo2p*I2[163]
        + (fouro2z)*I1[163] - (fouro4zn)*I4[163];
*(vp++) = U00*I0[164] - U10*I3[164] + loo2p*I2[164]
        + (fouro2z)*I1[164] - (fouro4zn)*I4[164];
*(vp++) = U00*I0[165] - U10*I3[165] + loo2p*I2[165]
        + (fouro2z)*I1[165] - (fouro4zn)*I4[165];
*(vp++) = U00*I0[166] - U10*I3[166] + loo2p*I2[166]
        + (fouro2z)*I1[166] - (fouro4zn)*I4[166];
*(vp++) = U00*I0[167] - U10*I3[167] + loo2p*I2[167]
        + (fouro2z)*I1[167] - (fouro4zn)*I4[167];
*(vp++) = U00*I0[168] - U10*I3[168] + loo2p*I2[168]
        + (threeo2z)*I1[168] - (threeo4zn)*I4[168] - (sixo4zn)*I5[126];
*(vp++) = U00*I0[169] - U10*I3[169] + loo2p*I2[169]
        + (threeo2z)*I1[169] - (threeo4zn)*I4[169] - (fiveo4zn)*I5[127];
*(vp++) = U00*I0[170] - U10*I3[170] + loo2p*I2[170]
        + (threeo2z)*I1[170] - (threeo4zn)*I4[170] - (fiveo4zn)*I5[128];
*(vp++) = U00*I0[171] - U10*I3[171] + loo2p*I2[171]
        + (threeo2z)*I1[171] - (threeo4zn)*I4[171] - (fouro4zn)*I5[129];
*(vp++) = U00*I0[172] - U10*I3[172] + loo2p*I2[172]
        + (threeo2z)*I1[172] - (threeo4zn)*I4[172] - (fouro4zn)*I5[130];
*(vp++) = U00*I0[173] - U10*I3[173] + loo2p*I2[173]
        + (threeo2z)*I1[173] - (threeo4zn)*I4[173] - (fouro4zn)*I5[131];
*(vp++) = U00*I0[174] - U10*I3[174] + loo2p*I2[174]
        + (threeo2z)*I1[174] - (threeo4zn)*I4[174] - (threeo4zn)*I5[132];
*(vp++) = U00*I0[175] - U10*I3[175] + loo2p*I2[175]
        + (threeo2z)*I1[175] - (threeo4zn)*I4[175] - (threeo4zn)*I5[133];
*(vp++) = U00*I0[176] - U10*I3[176] + loo2p*I2[176]
        + (threeo2z)*I1[176] - (threeo4zn)*I4[176] - (threeo4zn)*I5[134];
*(vp++) = U00*I0[177] - U10*I3[177] + loo2p*I2[177]
        + (threeo2z)*I1[177] - (threeo4zn)*I4[177] - (threeo4zn)*I5[135];
*(vp++) = U00*I0[178] - U10*I3[178] + loo2p*I2[178]
        + (threeo2z)*I1[178] - (threeo4zn)*I4[178] - (twoo4zn)*I5[136];
*(vp++) = U00*I0[179] - U10*I3[179] + loo2p*I2[179]
        + (threeo2z)*I1[179] - (threeo4zn)*I4[179] - (twoo4zn)*I5[137];
*(vp++) = U00*I0[180] - U10*I3[180] + loo2p*I2[180]
        + (threeo2z)*I1[180] - (threeo4zn)*I4[180] - (twoo4zn)*I5[138];
*(vp++) = U00*I0[181] - U10*I3[181] + loo2p*I2[181]
        + (threeo2z)*I1[181] - (threeo4zn)*I4[181] - (twoo4zn)*I5[139];
*(vp++) = U00*I0[182] - U10*I3[182] + loo2p*I2[182]
        + (threeo2z)*I1[182] - (threeo4zn)*I4[182] - (twoo4zn)*I5[140];
*(vp++) = U00*I0[183] - U10*I3[183] + loo2p*I2[183]
        + (threeo2z)*I1[183] - (threeo4zn)*I4[183] - (oneo4zn)*I5[141];
*(vp++) = U00*I0[184] - U10*I3[184] + loo2p*I2[184]
        + (threeo2z)*I1[184] - (threeo4zn)*I4[184] - (oneo4zn)*I5[142];
*(vp++) = U00*I0[185] - U10*I3[185] + loo2p*I2[185]
        + (threeo2z)*I1[185] - (threeo4zn)*I4[185] - (oneo4zn)*I5[143];
*(vp++) = U00*I0[186] - U10*I3[186] + loo2p*I2[186]
        + (threeo2z)*I1[186] - (threeo4zn)*I4[186] - (oneo4zn)*I5[144];
*(vp++) = U00*I0[187] - U10*I3[187] + loo2p*I2[187]
        + (threeo2z)*I1[187] - (threeo4zn)*I4[187] - (oneo4zn)*I5[145];
*(vp++) = U00*I0[188] - U10*I3[188] + loo2p*I2[188]
        + (threeo2z)*I1[188] - (threeo4zn)*I4[188] - (oneo4zn)*I5[146];
*(vp++) = U00*I0[189] - U10*I3[189] + loo2p*I2[189]
        + (threeo2z)*I1[189] - (threeo4zn)*I4[189];
*(vp++) = U00*I0[190] - U10*I3[190] + loo2p*I2[190]
        + (threeo2z)*I1[190] - (threeo4zn)*I4[190];
*(vp++) = U00*I0[191] - U10*I3[191] + loo2p*I2[191]
        + (threeo2z)*I1[191] - (threeo4zn)*I4[191];
*(vp++) = U00*I0[192] - U10*I3[192] + loo2p*I2[192]
        + (threeo2z)*I1[192] - (threeo4zn)*I4[192];
*(vp++) = U00*I0[193] - U10*I3[193] + loo2p*I2[193]
        + (threeo2z)*I1[193] - (threeo4zn)*I4[193];
*(vp++) = U00*I0[194] - U10*I3[194] + loo2p*I2[194]
        + (threeo2z)*I1[194] - (threeo4zn)*I4[194];
*(vp++) = U00*I0[195] - U10*I3[195] + loo2p*I2[195]
        + (threeo2z)*I1[195] - (threeo4zn)*I4[195];
*(vp++) = U00*I0[196] - U10*I3[196] + loo2p*I2[196]
        + (threeo2z)*I1[196] - (threeo4zn)*I4[196] - (sixo4zn)*I5[147];
*(vp++) = U00*I0[197] - U10*I3[197] + loo2p*I2[197]
        + (threeo2z)*I1[197] - (threeo4zn)*I4[197] - (fiveo4zn)*I5[148];
*(vp++) = U00*I0[198] - U10*I3[198] + loo2p*I2[198]
        + (threeo2z)*I1[198] - (threeo4zn)*I4[198] - (fiveo4zn)*I5[149];
*(vp++) = U00*I0[199] - U10*I3[199] + loo2p*I2[199]
        + (threeo2z)*I1[199] - (threeo4zn)*I4[199] - (fouro4zn)*I5[150];
*(vp++) = U00*I0[200] - U10*I3[200] + loo2p*I2[200]
        + (threeo2z)*I1[200] - (threeo4zn)*I4[200] - (fouro4zn)*I5[151];
*(vp++) = U00*I0[201] - U10*I3[201] + loo2p*I2[201]
        + (threeo2z)*I1[201] - (threeo4zn)*I4[201] - (fouro4zn)*I5[152];
*(vp++) = U00*I0[202] - U10*I3[202] + loo2p*I2[202]
        + (threeo2z)*I1[202] - (threeo4zn)*I4[202] - (threeo4zn)*I5[153];
*(vp++) = U00*I0[203] - U10*I3[203] + loo2p*I2[203]
        + (threeo2z)*I1[203] - (threeo4zn)*I4[203] - (threeo4zn)*I5[154];
*(vp++) = U00*I0[204] - U10*I3[204] + loo2p*I2[204]
        + (threeo2z)*I1[204] - (threeo4zn)*I4[204] - (threeo4zn)*I5[155];
*(vp++) = U00*I0[205] - U10*I3[205] + loo2p*I2[205]
        + (threeo2z)*I1[205] - (threeo4zn)*I4[205] - (threeo4zn)*I5[156];
*(vp++) = U00*I0[206] - U10*I3[206] + loo2p*I2[206]
        + (threeo2z)*I1[206] - (threeo4zn)*I4[206] - (twoo4zn)*I5[157];
*(vp++) = U00*I0[207] - U10*I3[207] + loo2p*I2[207]
        + (threeo2z)*I1[207] - (threeo4zn)*I4[207] - (twoo4zn)*I5[158];
*(vp++) = U00*I0[208] - U10*I3[208] + loo2p*I2[208]
        + (threeo2z)*I1[208] - (threeo4zn)*I4[208] - (twoo4zn)*I5[159];
*(vp++) = U00*I0[209] - U10*I3[209] + loo2p*I2[209]
        + (threeo2z)*I1[209] - (threeo4zn)*I4[209] - (twoo4zn)*I5[160];
*(vp++) = U00*I0[210] - U10*I3[210] + loo2p*I2[210]
        + (threeo2z)*I1[210] - (threeo4zn)*I4[210] - (twoo4zn)*I5[161];
*(vp++) = U00*I0[211] - U10*I3[211] + loo2p*I2[211]
        + (threeo2z)*I1[211] - (threeo4zn)*I4[211] - (oneo4zn)*I5[162];
*(vp++) = U00*I0[212] - U10*I3[212] + loo2p*I2[212]
        + (threeo2z)*I1[212] - (threeo4zn)*I4[212] - (oneo4zn)*I5[163];
*(vp++) = U00*I0[213] - U10*I3[213] + loo2p*I2[213]
        + (threeo2z)*I1[213] - (threeo4zn)*I4[213] - (oneo4zn)*I5[164];
*(vp++) = U00*I0[214] - U10*I3[214] + loo2p*I2[214]
        + (threeo2z)*I1[214] - (threeo4zn)*I4[214] - (oneo4zn)*I5[165];
*(vp++) = U00*I0[215] - U10*I3[215] + loo2p*I2[215]
        + (threeo2z)*I1[215] - (threeo4zn)*I4[215] - (oneo4zn)*I5[166];
*(vp++) = U00*I0[216] - U10*I3[216] + loo2p*I2[216]
        + (threeo2z)*I1[216] - (threeo4zn)*I4[216] - (oneo4zn)*I5[167];
*(vp++) = U00*I0[217] - U10*I3[217] + loo2p*I2[217]
        + (threeo2z)*I1[217] - (threeo4zn)*I4[217];
*(vp++) = U00*I0[218] - U10*I3[218] + loo2p*I2[218]
        + (threeo2z)*I1[218] - (threeo4zn)*I4[218];
*(vp++) = U00*I0[219] - U10*I3[219] + loo2p*I2[219]
        + (threeo2z)*I1[219] - (threeo4zn)*I4[219];
*(vp++) = U00*I0[220] - U10*I3[220] + loo2p*I2[220]
        + (threeo2z)*I1[220] - (threeo4zn)*I4[220];
*(vp++) = U00*I0[221] - U10*I3[221] + loo2p*I2[221]
        + (threeo2z)*I1[221] - (threeo4zn)*I4[221];
*(vp++) = U00*I0[222] - U10*I3[222] + loo2p*I2[222]
        + (threeo2z)*I1[222] - (threeo4zn)*I4[222];
*(vp++) = U00*I0[223] - U10*I3[223] + loo2p*I2[223]
        + (threeo2z)*I1[223] - (threeo4zn)*I4[223];
*(vp++) = U00*I0[224] - U10*I3[224] + loo2p*I2[224]
        + (threeo2z)*I1[224] - (threeo4zn)*I4[224] - (sixo4zn)*I5[168];
*(vp++) = U00*I0[225] - U10*I3[225] + loo2p*I2[225]
        + (threeo2z)*I1[225] - (threeo4zn)*I4[225] - (fiveo4zn)*I5[169];
*(vp++) = U00*I0[226] - U10*I3[226] + loo2p*I2[226]
        + (threeo2z)*I1[226] - (threeo4zn)*I4[226] - (fiveo4zn)*I5[170];
*(vp++) = U00*I0[227] - U10*I3[227] + loo2p*I2[227]
        + (threeo2z)*I1[227] - (threeo4zn)*I4[227] - (fouro4zn)*I5[171];
*(vp++) = U00*I0[228] - U10*I3[228] + loo2p*I2[228]
        + (threeo2z)*I1[228] - (threeo4zn)*I4[228] - (fouro4zn)*I5[172];
*(vp++) = U00*I0[229] - U10*I3[229] + loo2p*I2[229]
        + (threeo2z)*I1[229] - (threeo4zn)*I4[229] - (fouro4zn)*I5[173];
*(vp++) = U00*I0[230] - U10*I3[230] + loo2p*I2[230]
        + (threeo2z)*I1[230] - (threeo4zn)*I4[230] - (threeo4zn)*I5[174];
*(vp++) = U00*I0[231] - U10*I3[231] + loo2p*I2[231]
        + (threeo2z)*I1[231] - (threeo4zn)*I4[231] - (threeo4zn)*I5[175];
*(vp++) = U00*I0[232] - U10*I3[232] + loo2p*I2[232]
        + (threeo2z)*I1[232] - (threeo4zn)*I4[232] - (threeo4zn)*I5[176];
*(vp++) = U00*I0[233] - U10*I3[233] + loo2p*I2[233]
        + (threeo2z)*I1[233] - (threeo4zn)*I4[233] - (threeo4zn)*I5[177];
*(vp++) = U00*I0[234] - U10*I3[234] + loo2p*I2[234]
        + (threeo2z)*I1[234] - (threeo4zn)*I4[234] - (twoo4zn)*I5[178];
*(vp++) = U00*I0[235] - U10*I3[235] + loo2p*I2[235]
        + (threeo2z)*I1[235] - (threeo4zn)*I4[235] - (twoo4zn)*I5[179];
*(vp++) = U00*I0[236] - U10*I3[236] + loo2p*I2[236]
        + (threeo2z)*I1[236] - (threeo4zn)*I4[236] - (twoo4zn)*I5[180];
*(vp++) = U00*I0[237] - U10*I3[237] + loo2p*I2[237]
        + (threeo2z)*I1[237] - (threeo4zn)*I4[237] - (twoo4zn)*I5[181];
*(vp++) = U00*I0[238] - U10*I3[238] + loo2p*I2[238]
        + (threeo2z)*I1[238] - (threeo4zn)*I4[238] - (twoo4zn)*I5[182];
*(vp++) = U00*I0[239] - U10*I3[239] + loo2p*I2[239]
        + (threeo2z)*I1[239] - (threeo4zn)*I4[239] - (oneo4zn)*I5[183];
*(vp++) = U00*I0[240] - U10*I3[240] + loo2p*I2[240]
        + (threeo2z)*I1[240] - (threeo4zn)*I4[240] - (oneo4zn)*I5[184];
*(vp++) = U00*I0[241] - U10*I3[241] + loo2p*I2[241]
        + (threeo2z)*I1[241] - (threeo4zn)*I4[241] - (oneo4zn)*I5[185];
*(vp++) = U00*I0[242] - U10*I3[242] + loo2p*I2[242]
        + (threeo2z)*I1[242] - (threeo4zn)*I4[242] - (oneo4zn)*I5[186];
*(vp++) = U00*I0[243] - U10*I3[243] + loo2p*I2[243]
        + (threeo2z)*I1[243] - (threeo4zn)*I4[243] - (oneo4zn)*I5[187];
*(vp++) = U00*I0[244] - U10*I3[244] + loo2p*I2[244]
        + (threeo2z)*I1[244] - (threeo4zn)*I4[244] - (oneo4zn)*I5[188];
*(vp++) = U00*I0[245] - U10*I3[245] + loo2p*I2[245]
        + (threeo2z)*I1[245] - (threeo4zn)*I4[245];
*(vp++) = U00*I0[246] - U10*I3[246] + loo2p*I2[246]
        + (threeo2z)*I1[246] - (threeo4zn)*I4[246];
*(vp++) = U00*I0[247] - U10*I3[247] + loo2p*I2[247]
        + (threeo2z)*I1[247] - (threeo4zn)*I4[247];
*(vp++) = U00*I0[248] - U10*I3[248] + loo2p*I2[248]
        + (threeo2z)*I1[248] - (threeo4zn)*I4[248];
*(vp++) = U00*I0[249] - U10*I3[249] + loo2p*I2[249]
        + (threeo2z)*I1[249] - (threeo4zn)*I4[249];
*(vp++) = U00*I0[250] - U10*I3[250] + loo2p*I2[250]
        + (threeo2z)*I1[250] - (threeo4zn)*I4[250];
*(vp++) = U00*I0[251] - U10*I3[251] + loo2p*I2[251]
        + (threeo2z)*I1[251] - (threeo4zn)*I4[251];
*(vp++) = U00*I0[252] - U10*I3[252] + loo2p*I2[252]
        + (threeo2z)*I1[252] - (threeo4zn)*I4[252] - (sixo4zn)*I5[189];
return vp;
}

REALTYPE *_r_build_k0i0_1(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[253] - U10*I3[253] + loo2p*I2[253]
        + (threeo2z)*I1[253] - (threeo4zn)*I4[253] - (fiveo4zn)*I5[190];
*(vp++) = U00*I0[254] - U10*I3[254] + loo2p*I2[254]
        + (threeo2z)*I1[254] - (threeo4zn)*I4[254] - (fiveo4zn)*I5[191];
*(vp++) = U00*I0[255] - U10*I3[255] + loo2p*I2[255]
        + (threeo2z)*I1[255] - (threeo4zn)*I4[255] - (fouro4zn)*I5[192];
*(vp++) = U00*I0[256] - U10*I3[256] + loo2p*I2[256]
        + (threeo2z)*I1[256] - (threeo4zn)*I4[256] - (fouro4zn)*I5[193];
*(vp++) = U00*I0[257] - U10*I3[257] + loo2p*I2[257]
        + (threeo2z)*I1[257] - (threeo4zn)*I4[257] - (fouro4zn)*I5[194];
*(vp++) = U00*I0[258] - U10*I3[258] + loo2p*I2[258]
        + (threeo2z)*I1[258] - (threeo4zn)*I4[258] - (threeo4zn)*I5[195];
*(vp++) = U00*I0[259] - U10*I3[259] + loo2p*I2[259]
        + (threeo2z)*I1[259] - (threeo4zn)*I4[259] - (threeo4zn)*I5[196];
*(vp++) = U00*I0[260] - U10*I3[260] + loo2p*I2[260]
        + (threeo2z)*I1[260] - (threeo4zn)*I4[260] - (threeo4zn)*I5[197];
*(vp++) = U00*I0[261] - U10*I3[261] + loo2p*I2[261]
        + (threeo2z)*I1[261] - (threeo4zn)*I4[261] - (threeo4zn)*I5[198];
*(vp++) = U00*I0[262] - U10*I3[262] + loo2p*I2[262]
        + (threeo2z)*I1[262] - (threeo4zn)*I4[262] - (twoo4zn)*I5[199];
*(vp++) = U00*I0[263] - U10*I3[263] + loo2p*I2[263]
        + (threeo2z)*I1[263] - (threeo4zn)*I4[263] - (twoo4zn)*I5[200];
*(vp++) = U00*I0[264] - U10*I3[264] + loo2p*I2[264]
        + (threeo2z)*I1[264] - (threeo4zn)*I4[264] - (twoo4zn)*I5[201];
*(vp++) = U00*I0[265] - U10*I3[265] + loo2p*I2[265]
        + (threeo2z)*I1[265] - (threeo4zn)*I4[265] - (twoo4zn)*I5[202];
*(vp++) = U00*I0[266] - U10*I3[266] + loo2p*I2[266]
        + (threeo2z)*I1[266] - (threeo4zn)*I4[266] - (twoo4zn)*I5[203];
*(vp++) = U00*I0[267] - U10*I3[267] + loo2p*I2[267]
        + (threeo2z)*I1[267] - (threeo4zn)*I4[267] - (oneo4zn)*I5[204];
*(vp++) = U00*I0[268] - U10*I3[268] + loo2p*I2[268]
        + (threeo2z)*I1[268] - (threeo4zn)*I4[268] - (oneo4zn)*I5[205];
*(vp++) = U00*I0[269] - U10*I3[269] + loo2p*I2[269]
        + (threeo2z)*I1[269] - (threeo4zn)*I4[269] - (oneo4zn)*I5[206];
*(vp++) = U00*I0[270] - U10*I3[270] + loo2p*I2[270]
        + (threeo2z)*I1[270] - (threeo4zn)*I4[270] - (oneo4zn)*I5[207];
*(vp++) = U00*I0[271] - U10*I3[271] + loo2p*I2[271]
        + (threeo2z)*I1[271] - (threeo4zn)*I4[271] - (oneo4zn)*I5[208];
*(vp++) = U00*I0[272] - U10*I3[272] + loo2p*I2[272]
        + (threeo2z)*I1[272] - (threeo4zn)*I4[272] - (oneo4zn)*I5[209];
*(vp++) = U00*I0[273] - U10*I3[273] + loo2p*I2[273]
        + (threeo2z)*I1[273] - (threeo4zn)*I4[273];
*(vp++) = U00*I0[274] - U10*I3[274] + loo2p*I2[274]
        + (threeo2z)*I1[274] - (threeo4zn)*I4[274];
*(vp++) = U00*I0[275] - U10*I3[275] + loo2p*I2[275]
        + (threeo2z)*I1[275] - (threeo4zn)*I4[275];
*(vp++) = U00*I0[276] - U10*I3[276] + loo2p*I2[276]
        + (threeo2z)*I1[276] - (threeo4zn)*I4[276];
*(vp++) = U00*I0[277] - U10*I3[277] + loo2p*I2[277]
        + (threeo2z)*I1[277] - (threeo4zn)*I4[277];
*(vp++) = U00*I0[278] - U10*I3[278] + loo2p*I2[278]
        + (threeo2z)*I1[278] - (threeo4zn)*I4[278];
*(vp++) = U00*I0[279] - U10*I3[279] + loo2p*I2[279]
        + (threeo2z)*I1[279] - (threeo4zn)*I4[279];
*(vp++) = U00*I0[280] - U10*I3[280] + loo2p*I2[280]
        + (twoo2z)*I1[280] - (twoo4zn)*I4[280] - (sixo4zn)*I5[210];
*(vp++) = U00*I0[281] - U10*I3[281] + loo2p*I2[281]
        + (twoo2z)*I1[281] - (twoo4zn)*I4[281] - (fiveo4zn)*I5[211];
*(vp++) = U00*I0[282] - U10*I3[282] + loo2p*I2[282]
        + (twoo2z)*I1[282] - (twoo4zn)*I4[282] - (fiveo4zn)*I5[212];
*(vp++) = U00*I0[283] - U10*I3[283] + loo2p*I2[283]
        + (twoo2z)*I1[283] - (twoo4zn)*I4[283] - (fouro4zn)*I5[213];
*(vp++) = U00*I0[284] - U10*I3[284] + loo2p*I2[284]
        + (twoo2z)*I1[284] - (twoo4zn)*I4[284] - (fouro4zn)*I5[214];
*(vp++) = U00*I0[285] - U10*I3[285] + loo2p*I2[285]
        + (twoo2z)*I1[285] - (twoo4zn)*I4[285] - (fouro4zn)*I5[215];
*(vp++) = U00*I0[286] - U10*I3[286] + loo2p*I2[286]
        + (twoo2z)*I1[286] - (twoo4zn)*I4[286] - (threeo4zn)*I5[216];
*(vp++) = U00*I0[287] - U10*I3[287] + loo2p*I2[287]
        + (twoo2z)*I1[287] - (twoo4zn)*I4[287] - (threeo4zn)*I5[217];
*(vp++) = U00*I0[288] - U10*I3[288] + loo2p*I2[288]
        + (twoo2z)*I1[288] - (twoo4zn)*I4[288] - (threeo4zn)*I5[218];
*(vp++) = U00*I0[289] - U10*I3[289] + loo2p*I2[289]
        + (twoo2z)*I1[289] - (twoo4zn)*I4[289] - (threeo4zn)*I5[219];
*(vp++) = U00*I0[290] - U10*I3[290] + loo2p*I2[290]
        + (twoo2z)*I1[290] - (twoo4zn)*I4[290] - (twoo4zn)*I5[220];
*(vp++) = U00*I0[291] - U10*I3[291] + loo2p*I2[291]
        + (twoo2z)*I1[291] - (twoo4zn)*I4[291] - (twoo4zn)*I5[221];
*(vp++) = U00*I0[292] - U10*I3[292] + loo2p*I2[292]
        + (twoo2z)*I1[292] - (twoo4zn)*I4[292] - (twoo4zn)*I5[222];
*(vp++) = U00*I0[293] - U10*I3[293] + loo2p*I2[293]
        + (twoo2z)*I1[293] - (twoo4zn)*I4[293] - (twoo4zn)*I5[223];
*(vp++) = U00*I0[294] - U10*I3[294] + loo2p*I2[294]
        + (twoo2z)*I1[294] - (twoo4zn)*I4[294] - (twoo4zn)*I5[224];
*(vp++) = U00*I0[295] - U10*I3[295] + loo2p*I2[295]
        + (twoo2z)*I1[295] - (twoo4zn)*I4[295] - (oneo4zn)*I5[225];
*(vp++) = U00*I0[296] - U10*I3[296] + loo2p*I2[296]
        + (twoo2z)*I1[296] - (twoo4zn)*I4[296] - (oneo4zn)*I5[226];
*(vp++) = U00*I0[297] - U10*I3[297] + loo2p*I2[297]
        + (twoo2z)*I1[297] - (twoo4zn)*I4[297] - (oneo4zn)*I5[227];
*(vp++) = U00*I0[298] - U10*I3[298] + loo2p*I2[298]
        + (twoo2z)*I1[298] - (twoo4zn)*I4[298] - (oneo4zn)*I5[228];
*(vp++) = U00*I0[299] - U10*I3[299] + loo2p*I2[299]
        + (twoo2z)*I1[299] - (twoo4zn)*I4[299] - (oneo4zn)*I5[229];
*(vp++) = U00*I0[300] - U10*I3[300] + loo2p*I2[300]
        + (twoo2z)*I1[300] - (twoo4zn)*I4[300] - (oneo4zn)*I5[230];
*(vp++) = U00*I0[301] - U10*I3[301] + loo2p*I2[301]
        + (twoo2z)*I1[301] - (twoo4zn)*I4[301];
*(vp++) = U00*I0[302] - U10*I3[302] + loo2p*I2[302]
        + (twoo2z)*I1[302] - (twoo4zn)*I4[302];
*(vp++) = U00*I0[303] - U10*I3[303] + loo2p*I2[303]
        + (twoo2z)*I1[303] - (twoo4zn)*I4[303];
*(vp++) = U00*I0[304] - U10*I3[304] + loo2p*I2[304]
        + (twoo2z)*I1[304] - (twoo4zn)*I4[304];
*(vp++) = U00*I0[305] - U10*I3[305] + loo2p*I2[305]
        + (twoo2z)*I1[305] - (twoo4zn)*I4[305];
*(vp++) = U00*I0[306] - U10*I3[306] + loo2p*I2[306]
        + (twoo2z)*I1[306] - (twoo4zn)*I4[306];
*(vp++) = U00*I0[307] - U10*I3[307] + loo2p*I2[307]
        + (twoo2z)*I1[307] - (twoo4zn)*I4[307];
*(vp++) = U00*I0[308] - U10*I3[308] + loo2p*I2[308]
        + (twoo2z)*I1[308] - (twoo4zn)*I4[308] - (sixo4zn)*I5[231];
*(vp++) = U00*I0[309] - U10*I3[309] + loo2p*I2[309]
        + (twoo2z)*I1[309] - (twoo4zn)*I4[309] - (fiveo4zn)*I5[232];
*(vp++) = U00*I0[310] - U10*I3[310] + loo2p*I2[310]
        + (twoo2z)*I1[310] - (twoo4zn)*I4[310] - (fiveo4zn)*I5[233];
*(vp++) = U00*I0[311] - U10*I3[311] + loo2p*I2[311]
        + (twoo2z)*I1[311] - (twoo4zn)*I4[311] - (fouro4zn)*I5[234];
*(vp++) = U00*I0[312] - U10*I3[312] + loo2p*I2[312]
        + (twoo2z)*I1[312] - (twoo4zn)*I4[312] - (fouro4zn)*I5[235];
*(vp++) = U00*I0[313] - U10*I3[313] + loo2p*I2[313]
        + (twoo2z)*I1[313] - (twoo4zn)*I4[313] - (fouro4zn)*I5[236];
*(vp++) = U00*I0[314] - U10*I3[314] + loo2p*I2[314]
        + (twoo2z)*I1[314] - (twoo4zn)*I4[314] - (threeo4zn)*I5[237];
*(vp++) = U00*I0[315] - U10*I3[315] + loo2p*I2[315]
        + (twoo2z)*I1[315] - (twoo4zn)*I4[315] - (threeo4zn)*I5[238];
*(vp++) = U00*I0[316] - U10*I3[316] + loo2p*I2[316]
        + (twoo2z)*I1[316] - (twoo4zn)*I4[316] - (threeo4zn)*I5[239];
*(vp++) = U00*I0[317] - U10*I3[317] + loo2p*I2[317]
        + (twoo2z)*I1[317] - (twoo4zn)*I4[317] - (threeo4zn)*I5[240];
*(vp++) = U00*I0[318] - U10*I3[318] + loo2p*I2[318]
        + (twoo2z)*I1[318] - (twoo4zn)*I4[318] - (twoo4zn)*I5[241];
*(vp++) = U00*I0[319] - U10*I3[319] + loo2p*I2[319]
        + (twoo2z)*I1[319] - (twoo4zn)*I4[319] - (twoo4zn)*I5[242];
*(vp++) = U00*I0[320] - U10*I3[320] + loo2p*I2[320]
        + (twoo2z)*I1[320] - (twoo4zn)*I4[320] - (twoo4zn)*I5[243];
*(vp++) = U00*I0[321] - U10*I3[321] + loo2p*I2[321]
        + (twoo2z)*I1[321] - (twoo4zn)*I4[321] - (twoo4zn)*I5[244];
*(vp++) = U00*I0[322] - U10*I3[322] + loo2p*I2[322]
        + (twoo2z)*I1[322] - (twoo4zn)*I4[322] - (twoo4zn)*I5[245];
*(vp++) = U00*I0[323] - U10*I3[323] + loo2p*I2[323]
        + (twoo2z)*I1[323] - (twoo4zn)*I4[323] - (oneo4zn)*I5[246];
*(vp++) = U00*I0[324] - U10*I3[324] + loo2p*I2[324]
        + (twoo2z)*I1[324] - (twoo4zn)*I4[324] - (oneo4zn)*I5[247];
*(vp++) = U00*I0[325] - U10*I3[325] + loo2p*I2[325]
        + (twoo2z)*I1[325] - (twoo4zn)*I4[325] - (oneo4zn)*I5[248];
*(vp++) = U00*I0[326] - U10*I3[326] + loo2p*I2[326]
        + (twoo2z)*I1[326] - (twoo4zn)*I4[326] - (oneo4zn)*I5[249];
*(vp++) = U00*I0[327] - U10*I3[327] + loo2p*I2[327]
        + (twoo2z)*I1[327] - (twoo4zn)*I4[327] - (oneo4zn)*I5[250];
*(vp++) = U00*I0[328] - U10*I3[328] + loo2p*I2[328]
        + (twoo2z)*I1[328] - (twoo4zn)*I4[328] - (oneo4zn)*I5[251];
*(vp++) = U00*I0[329] - U10*I3[329] + loo2p*I2[329]
        + (twoo2z)*I1[329] - (twoo4zn)*I4[329];
*(vp++) = U00*I0[330] - U10*I3[330] + loo2p*I2[330]
        + (twoo2z)*I1[330] - (twoo4zn)*I4[330];
*(vp++) = U00*I0[331] - U10*I3[331] + loo2p*I2[331]
        + (twoo2z)*I1[331] - (twoo4zn)*I4[331];
*(vp++) = U00*I0[332] - U10*I3[332] + loo2p*I2[332]
        + (twoo2z)*I1[332] - (twoo4zn)*I4[332];
*(vp++) = U00*I0[333] - U10*I3[333] + loo2p*I2[333]
        + (twoo2z)*I1[333] - (twoo4zn)*I4[333];
*(vp++) = U00*I0[334] - U10*I3[334] + loo2p*I2[334]
        + (twoo2z)*I1[334] - (twoo4zn)*I4[334];
*(vp++) = U00*I0[335] - U10*I3[335] + loo2p*I2[335]
        + (twoo2z)*I1[335] - (twoo4zn)*I4[335];
*(vp++) = U00*I0[336] - U10*I3[336] + loo2p*I2[336]
        + (twoo2z)*I1[336] - (twoo4zn)*I4[336] - (sixo4zn)*I5[252];
*(vp++) = U00*I0[337] - U10*I3[337] + loo2p*I2[337]
        + (twoo2z)*I1[337] - (twoo4zn)*I4[337] - (fiveo4zn)*I5[253];
*(vp++) = U00*I0[338] - U10*I3[338] + loo2p*I2[338]
        + (twoo2z)*I1[338] - (twoo4zn)*I4[338] - (fiveo4zn)*I5[254];
*(vp++) = U00*I0[339] - U10*I3[339] + loo2p*I2[339]
        + (twoo2z)*I1[339] - (twoo4zn)*I4[339] - (fouro4zn)*I5[255];
*(vp++) = U00*I0[340] - U10*I3[340] + loo2p*I2[340]
        + (twoo2z)*I1[340] - (twoo4zn)*I4[340] - (fouro4zn)*I5[256];
*(vp++) = U00*I0[341] - U10*I3[341] + loo2p*I2[341]
        + (twoo2z)*I1[341] - (twoo4zn)*I4[341] - (fouro4zn)*I5[257];
*(vp++) = U00*I0[342] - U10*I3[342] + loo2p*I2[342]
        + (twoo2z)*I1[342] - (twoo4zn)*I4[342] - (threeo4zn)*I5[258];
*(vp++) = U00*I0[343] - U10*I3[343] + loo2p*I2[343]
        + (twoo2z)*I1[343] - (twoo4zn)*I4[343] - (threeo4zn)*I5[259];
*(vp++) = U00*I0[344] - U10*I3[344] + loo2p*I2[344]
        + (twoo2z)*I1[344] - (twoo4zn)*I4[344] - (threeo4zn)*I5[260];
*(vp++) = U00*I0[345] - U10*I3[345] + loo2p*I2[345]
        + (twoo2z)*I1[345] - (twoo4zn)*I4[345] - (threeo4zn)*I5[261];
*(vp++) = U00*I0[346] - U10*I3[346] + loo2p*I2[346]
        + (twoo2z)*I1[346] - (twoo4zn)*I4[346] - (twoo4zn)*I5[262];
*(vp++) = U00*I0[347] - U10*I3[347] + loo2p*I2[347]
        + (twoo2z)*I1[347] - (twoo4zn)*I4[347] - (twoo4zn)*I5[263];
*(vp++) = U00*I0[348] - U10*I3[348] + loo2p*I2[348]
        + (twoo2z)*I1[348] - (twoo4zn)*I4[348] - (twoo4zn)*I5[264];
*(vp++) = U00*I0[349] - U10*I3[349] + loo2p*I2[349]
        + (twoo2z)*I1[349] - (twoo4zn)*I4[349] - (twoo4zn)*I5[265];
*(vp++) = U00*I0[350] - U10*I3[350] + loo2p*I2[350]
        + (twoo2z)*I1[350] - (twoo4zn)*I4[350] - (twoo4zn)*I5[266];
*(vp++) = U00*I0[351] - U10*I3[351] + loo2p*I2[351]
        + (twoo2z)*I1[351] - (twoo4zn)*I4[351] - (oneo4zn)*I5[267];
*(vp++) = U00*I0[352] - U10*I3[352] + loo2p*I2[352]
        + (twoo2z)*I1[352] - (twoo4zn)*I4[352] - (oneo4zn)*I5[268];
*(vp++) = U00*I0[353] - U10*I3[353] + loo2p*I2[353]
        + (twoo2z)*I1[353] - (twoo4zn)*I4[353] - (oneo4zn)*I5[269];
*(vp++) = U00*I0[354] - U10*I3[354] + loo2p*I2[354]
        + (twoo2z)*I1[354] - (twoo4zn)*I4[354] - (oneo4zn)*I5[270];
*(vp++) = U00*I0[355] - U10*I3[355] + loo2p*I2[355]
        + (twoo2z)*I1[355] - (twoo4zn)*I4[355] - (oneo4zn)*I5[271];
*(vp++) = U00*I0[356] - U10*I3[356] + loo2p*I2[356]
        + (twoo2z)*I1[356] - (twoo4zn)*I4[356] - (oneo4zn)*I5[272];
*(vp++) = U00*I0[357] - U10*I3[357] + loo2p*I2[357]
        + (twoo2z)*I1[357] - (twoo4zn)*I4[357];
*(vp++) = U00*I0[358] - U10*I3[358] + loo2p*I2[358]
        + (twoo2z)*I1[358] - (twoo4zn)*I4[358];
*(vp++) = U00*I0[359] - U10*I3[359] + loo2p*I2[359]
        + (twoo2z)*I1[359] - (twoo4zn)*I4[359];
*(vp++) = U00*I0[360] - U10*I3[360] + loo2p*I2[360]
        + (twoo2z)*I1[360] - (twoo4zn)*I4[360];
*(vp++) = U00*I0[361] - U10*I3[361] + loo2p*I2[361]
        + (twoo2z)*I1[361] - (twoo4zn)*I4[361];
*(vp++) = U00*I0[362] - U10*I3[362] + loo2p*I2[362]
        + (twoo2z)*I1[362] - (twoo4zn)*I4[362];
*(vp++) = U00*I0[363] - U10*I3[363] + loo2p*I2[363]
        + (twoo2z)*I1[363] - (twoo4zn)*I4[363];
*(vp++) = U00*I0[364] - U10*I3[364] + loo2p*I2[364]
        + (twoo2z)*I1[364] - (twoo4zn)*I4[364] - (sixo4zn)*I5[273];
*(vp++) = U00*I0[365] - U10*I3[365] + loo2p*I2[365]
        + (twoo2z)*I1[365] - (twoo4zn)*I4[365] - (fiveo4zn)*I5[274];
*(vp++) = U00*I0[366] - U10*I3[366] + loo2p*I2[366]
        + (twoo2z)*I1[366] - (twoo4zn)*I4[366] - (fiveo4zn)*I5[275];
*(vp++) = U00*I0[367] - U10*I3[367] + loo2p*I2[367]
        + (twoo2z)*I1[367] - (twoo4zn)*I4[367] - (fouro4zn)*I5[276];
*(vp++) = U00*I0[368] - U10*I3[368] + loo2p*I2[368]
        + (twoo2z)*I1[368] - (twoo4zn)*I4[368] - (fouro4zn)*I5[277];
*(vp++) = U00*I0[369] - U10*I3[369] + loo2p*I2[369]
        + (twoo2z)*I1[369] - (twoo4zn)*I4[369] - (fouro4zn)*I5[278];
*(vp++) = U00*I0[370] - U10*I3[370] + loo2p*I2[370]
        + (twoo2z)*I1[370] - (twoo4zn)*I4[370] - (threeo4zn)*I5[279];
*(vp++) = U00*I0[371] - U10*I3[371] + loo2p*I2[371]
        + (twoo2z)*I1[371] - (twoo4zn)*I4[371] - (threeo4zn)*I5[280];
*(vp++) = U00*I0[372] - U10*I3[372] + loo2p*I2[372]
        + (twoo2z)*I1[372] - (twoo4zn)*I4[372] - (threeo4zn)*I5[281];
*(vp++) = U00*I0[373] - U10*I3[373] + loo2p*I2[373]
        + (twoo2z)*I1[373] - (twoo4zn)*I4[373] - (threeo4zn)*I5[282];
*(vp++) = U00*I0[374] - U10*I3[374] + loo2p*I2[374]
        + (twoo2z)*I1[374] - (twoo4zn)*I4[374] - (twoo4zn)*I5[283];
*(vp++) = U00*I0[375] - U10*I3[375] + loo2p*I2[375]
        + (twoo2z)*I1[375] - (twoo4zn)*I4[375] - (twoo4zn)*I5[284];
*(vp++) = U00*I0[376] - U10*I3[376] + loo2p*I2[376]
        + (twoo2z)*I1[376] - (twoo4zn)*I4[376] - (twoo4zn)*I5[285];
*(vp++) = U00*I0[377] - U10*I3[377] + loo2p*I2[377]
        + (twoo2z)*I1[377] - (twoo4zn)*I4[377] - (twoo4zn)*I5[286];
*(vp++) = U00*I0[378] - U10*I3[378] + loo2p*I2[378]
        + (twoo2z)*I1[378] - (twoo4zn)*I4[378] - (twoo4zn)*I5[287];
*(vp++) = U00*I0[379] - U10*I3[379] + loo2p*I2[379]
        + (twoo2z)*I1[379] - (twoo4zn)*I4[379] - (oneo4zn)*I5[288];
*(vp++) = U00*I0[380] - U10*I3[380] + loo2p*I2[380]
        + (twoo2z)*I1[380] - (twoo4zn)*I4[380] - (oneo4zn)*I5[289];
*(vp++) = U00*I0[381] - U10*I3[381] + loo2p*I2[381]
        + (twoo2z)*I1[381] - (twoo4zn)*I4[381] - (oneo4zn)*I5[290];
*(vp++) = U00*I0[382] - U10*I3[382] + loo2p*I2[382]
        + (twoo2z)*I1[382] - (twoo4zn)*I4[382] - (oneo4zn)*I5[291];
*(vp++) = U00*I0[383] - U10*I3[383] + loo2p*I2[383]
        + (twoo2z)*I1[383] - (twoo4zn)*I4[383] - (oneo4zn)*I5[292];
*(vp++) = U00*I0[384] - U10*I3[384] + loo2p*I2[384]
        + (twoo2z)*I1[384] - (twoo4zn)*I4[384] - (oneo4zn)*I5[293];
*(vp++) = U00*I0[385] - U10*I3[385] + loo2p*I2[385]
        + (twoo2z)*I1[385] - (twoo4zn)*I4[385];
*(vp++) = U00*I0[386] - U10*I3[386] + loo2p*I2[386]
        + (twoo2z)*I1[386] - (twoo4zn)*I4[386];
*(vp++) = U00*I0[387] - U10*I3[387] + loo2p*I2[387]
        + (twoo2z)*I1[387] - (twoo4zn)*I4[387];
*(vp++) = U00*I0[388] - U10*I3[388] + loo2p*I2[388]
        + (twoo2z)*I1[388] - (twoo4zn)*I4[388];
*(vp++) = U00*I0[389] - U10*I3[389] + loo2p*I2[389]
        + (twoo2z)*I1[389] - (twoo4zn)*I4[389];
*(vp++) = U00*I0[390] - U10*I3[390] + loo2p*I2[390]
        + (twoo2z)*I1[390] - (twoo4zn)*I4[390];
*(vp++) = U00*I0[391] - U10*I3[391] + loo2p*I2[391]
        + (twoo2z)*I1[391] - (twoo4zn)*I4[391];
*(vp++) = U00*I0[392] - U10*I3[392] + loo2p*I2[392]
        + (twoo2z)*I1[392] - (twoo4zn)*I4[392] - (sixo4zn)*I5[294];
*(vp++) = U00*I0[393] - U10*I3[393] + loo2p*I2[393]
        + (twoo2z)*I1[393] - (twoo4zn)*I4[393] - (fiveo4zn)*I5[295];
*(vp++) = U00*I0[394] - U10*I3[394] + loo2p*I2[394]
        + (twoo2z)*I1[394] - (twoo4zn)*I4[394] - (fiveo4zn)*I5[296];
*(vp++) = U00*I0[395] - U10*I3[395] + loo2p*I2[395]
        + (twoo2z)*I1[395] - (twoo4zn)*I4[395] - (fouro4zn)*I5[297];
*(vp++) = U00*I0[396] - U10*I3[396] + loo2p*I2[396]
        + (twoo2z)*I1[396] - (twoo4zn)*I4[396] - (fouro4zn)*I5[298];
*(vp++) = U00*I0[397] - U10*I3[397] + loo2p*I2[397]
        + (twoo2z)*I1[397] - (twoo4zn)*I4[397] - (fouro4zn)*I5[299];
*(vp++) = U00*I0[398] - U10*I3[398] + loo2p*I2[398]
        + (twoo2z)*I1[398] - (twoo4zn)*I4[398] - (threeo4zn)*I5[300];
*(vp++) = U00*I0[399] - U10*I3[399] + loo2p*I2[399]
        + (twoo2z)*I1[399] - (twoo4zn)*I4[399] - (threeo4zn)*I5[301];
*(vp++) = U00*I0[400] - U10*I3[400] + loo2p*I2[400]
        + (twoo2z)*I1[400] - (twoo4zn)*I4[400] - (threeo4zn)*I5[302];
*(vp++) = U00*I0[401] - U10*I3[401] + loo2p*I2[401]
        + (twoo2z)*I1[401] - (twoo4zn)*I4[401] - (threeo4zn)*I5[303];
*(vp++) = U00*I0[402] - U10*I3[402] + loo2p*I2[402]
        + (twoo2z)*I1[402] - (twoo4zn)*I4[402] - (twoo4zn)*I5[304];
*(vp++) = U00*I0[403] - U10*I3[403] + loo2p*I2[403]
        + (twoo2z)*I1[403] - (twoo4zn)*I4[403] - (twoo4zn)*I5[305];
*(vp++) = U00*I0[404] - U10*I3[404] + loo2p*I2[404]
        + (twoo2z)*I1[404] - (twoo4zn)*I4[404] - (twoo4zn)*I5[306];
*(vp++) = U00*I0[405] - U10*I3[405] + loo2p*I2[405]
        + (twoo2z)*I1[405] - (twoo4zn)*I4[405] - (twoo4zn)*I5[307];
*(vp++) = U00*I0[406] - U10*I3[406] + loo2p*I2[406]
        + (twoo2z)*I1[406] - (twoo4zn)*I4[406] - (twoo4zn)*I5[308];
*(vp++) = U00*I0[407] - U10*I3[407] + loo2p*I2[407]
        + (twoo2z)*I1[407] - (twoo4zn)*I4[407] - (oneo4zn)*I5[309];
*(vp++) = U00*I0[408] - U10*I3[408] + loo2p*I2[408]
        + (twoo2z)*I1[408] - (twoo4zn)*I4[408] - (oneo4zn)*I5[310];
*(vp++) = U00*I0[409] - U10*I3[409] + loo2p*I2[409]
        + (twoo2z)*I1[409] - (twoo4zn)*I4[409] - (oneo4zn)*I5[311];
*(vp++) = U00*I0[410] - U10*I3[410] + loo2p*I2[410]
        + (twoo2z)*I1[410] - (twoo4zn)*I4[410] - (oneo4zn)*I5[312];
*(vp++) = U00*I0[411] - U10*I3[411] + loo2p*I2[411]
        + (twoo2z)*I1[411] - (twoo4zn)*I4[411] - (oneo4zn)*I5[313];
*(vp++) = U00*I0[412] - U10*I3[412] + loo2p*I2[412]
        + (twoo2z)*I1[412] - (twoo4zn)*I4[412] - (oneo4zn)*I5[314];
*(vp++) = U00*I0[413] - U10*I3[413] + loo2p*I2[413]
        + (twoo2z)*I1[413] - (twoo4zn)*I4[413];
*(vp++) = U00*I0[414] - U10*I3[414] + loo2p*I2[414]
        + (twoo2z)*I1[414] - (twoo4zn)*I4[414];
*(vp++) = U00*I0[415] - U10*I3[415] + loo2p*I2[415]
        + (twoo2z)*I1[415] - (twoo4zn)*I4[415];
*(vp++) = U00*I0[416] - U10*I3[416] + loo2p*I2[416]
        + (twoo2z)*I1[416] - (twoo4zn)*I4[416];
*(vp++) = U00*I0[417] - U10*I3[417] + loo2p*I2[417]
        + (twoo2z)*I1[417] - (twoo4zn)*I4[417];
*(vp++) = U00*I0[418] - U10*I3[418] + loo2p*I2[418]
        + (twoo2z)*I1[418] - (twoo4zn)*I4[418];
*(vp++) = U00*I0[419] - U10*I3[419] + loo2p*I2[419]
        + (twoo2z)*I1[419] - (twoo4zn)*I4[419];
*(vp++) = U00*I0[420] - U10*I3[420] + loo2p*I2[420]
        + (oneo2z)*I1[420] - (oneo4zn)*I4[420] - (sixo4zn)*I5[315];
*(vp++) = U00*I0[421] - U10*I3[421] + loo2p*I2[421]
        + (oneo2z)*I1[421] - (oneo4zn)*I4[421] - (fiveo4zn)*I5[316];
*(vp++) = U00*I0[422] - U10*I3[422] + loo2p*I2[422]
        + (oneo2z)*I1[422] - (oneo4zn)*I4[422] - (fiveo4zn)*I5[317];
*(vp++) = U00*I0[423] - U10*I3[423] + loo2p*I2[423]
        + (oneo2z)*I1[423] - (oneo4zn)*I4[423] - (fouro4zn)*I5[318];
*(vp++) = U00*I0[424] - U10*I3[424] + loo2p*I2[424]
        + (oneo2z)*I1[424] - (oneo4zn)*I4[424] - (fouro4zn)*I5[319];
*(vp++) = U00*I0[425] - U10*I3[425] + loo2p*I2[425]
        + (oneo2z)*I1[425] - (oneo4zn)*I4[425] - (fouro4zn)*I5[320];
*(vp++) = U00*I0[426] - U10*I3[426] + loo2p*I2[426]
        + (oneo2z)*I1[426] - (oneo4zn)*I4[426] - (threeo4zn)*I5[321];
*(vp++) = U00*I0[427] - U10*I3[427] + loo2p*I2[427]
        + (oneo2z)*I1[427] - (oneo4zn)*I4[427] - (threeo4zn)*I5[322];
*(vp++) = U00*I0[428] - U10*I3[428] + loo2p*I2[428]
        + (oneo2z)*I1[428] - (oneo4zn)*I4[428] - (threeo4zn)*I5[323];
*(vp++) = U00*I0[429] - U10*I3[429] + loo2p*I2[429]
        + (oneo2z)*I1[429] - (oneo4zn)*I4[429] - (threeo4zn)*I5[324];
*(vp++) = U00*I0[430] - U10*I3[430] + loo2p*I2[430]
        + (oneo2z)*I1[430] - (oneo4zn)*I4[430] - (twoo4zn)*I5[325];
*(vp++) = U00*I0[431] - U10*I3[431] + loo2p*I2[431]
        + (oneo2z)*I1[431] - (oneo4zn)*I4[431] - (twoo4zn)*I5[326];
*(vp++) = U00*I0[432] - U10*I3[432] + loo2p*I2[432]
        + (oneo2z)*I1[432] - (oneo4zn)*I4[432] - (twoo4zn)*I5[327];
*(vp++) = U00*I0[433] - U10*I3[433] + loo2p*I2[433]
        + (oneo2z)*I1[433] - (oneo4zn)*I4[433] - (twoo4zn)*I5[328];
*(vp++) = U00*I0[434] - U10*I3[434] + loo2p*I2[434]
        + (oneo2z)*I1[434] - (oneo4zn)*I4[434] - (twoo4zn)*I5[329];
*(vp++) = U00*I0[435] - U10*I3[435] + loo2p*I2[435]
        + (oneo2z)*I1[435] - (oneo4zn)*I4[435] - (oneo4zn)*I5[330];
*(vp++) = U00*I0[436] - U10*I3[436] + loo2p*I2[436]
        + (oneo2z)*I1[436] - (oneo4zn)*I4[436] - (oneo4zn)*I5[331];
*(vp++) = U00*I0[437] - U10*I3[437] + loo2p*I2[437]
        + (oneo2z)*I1[437] - (oneo4zn)*I4[437] - (oneo4zn)*I5[332];
*(vp++) = U00*I0[438] - U10*I3[438] + loo2p*I2[438]
        + (oneo2z)*I1[438] - (oneo4zn)*I4[438] - (oneo4zn)*I5[333];
*(vp++) = U00*I0[439] - U10*I3[439] + loo2p*I2[439]
        + (oneo2z)*I1[439] - (oneo4zn)*I4[439] - (oneo4zn)*I5[334];
*(vp++) = U00*I0[440] - U10*I3[440] + loo2p*I2[440]
        + (oneo2z)*I1[440] - (oneo4zn)*I4[440] - (oneo4zn)*I5[335];
*(vp++) = U00*I0[441] - U10*I3[441] + loo2p*I2[441]
        + (oneo2z)*I1[441] - (oneo4zn)*I4[441];
*(vp++) = U00*I0[442] - U10*I3[442] + loo2p*I2[442]
        + (oneo2z)*I1[442] - (oneo4zn)*I4[442];
*(vp++) = U00*I0[443] - U10*I3[443] + loo2p*I2[443]
        + (oneo2z)*I1[443] - (oneo4zn)*I4[443];
*(vp++) = U00*I0[444] - U10*I3[444] + loo2p*I2[444]
        + (oneo2z)*I1[444] - (oneo4zn)*I4[444];
*(vp++) = U00*I0[445] - U10*I3[445] + loo2p*I2[445]
        + (oneo2z)*I1[445] - (oneo4zn)*I4[445];
*(vp++) = U00*I0[446] - U10*I3[446] + loo2p*I2[446]
        + (oneo2z)*I1[446] - (oneo4zn)*I4[446];
*(vp++) = U00*I0[447] - U10*I3[447] + loo2p*I2[447]
        + (oneo2z)*I1[447] - (oneo4zn)*I4[447];
*(vp++) = U00*I0[448] - U10*I3[448] + loo2p*I2[448]
        + (oneo2z)*I1[448] - (oneo4zn)*I4[448] - (sixo4zn)*I5[336];
*(vp++) = U00*I0[449] - U10*I3[449] + loo2p*I2[449]
        + (oneo2z)*I1[449] - (oneo4zn)*I4[449] - (fiveo4zn)*I5[337];
*(vp++) = U00*I0[450] - U10*I3[450] + loo2p*I2[450]
        + (oneo2z)*I1[450] - (oneo4zn)*I4[450] - (fiveo4zn)*I5[338];
*(vp++) = U00*I0[451] - U10*I3[451] + loo2p*I2[451]
        + (oneo2z)*I1[451] - (oneo4zn)*I4[451] - (fouro4zn)*I5[339];
*(vp++) = U00*I0[452] - U10*I3[452] + loo2p*I2[452]
        + (oneo2z)*I1[452] - (oneo4zn)*I4[452] - (fouro4zn)*I5[340];
*(vp++) = U00*I0[453] - U10*I3[453] + loo2p*I2[453]
        + (oneo2z)*I1[453] - (oneo4zn)*I4[453] - (fouro4zn)*I5[341];
*(vp++) = U00*I0[454] - U10*I3[454] + loo2p*I2[454]
        + (oneo2z)*I1[454] - (oneo4zn)*I4[454] - (threeo4zn)*I5[342];
*(vp++) = U00*I0[455] - U10*I3[455] + loo2p*I2[455]
        + (oneo2z)*I1[455] - (oneo4zn)*I4[455] - (threeo4zn)*I5[343];
*(vp++) = U00*I0[456] - U10*I3[456] + loo2p*I2[456]
        + (oneo2z)*I1[456] - (oneo4zn)*I4[456] - (threeo4zn)*I5[344];
*(vp++) = U00*I0[457] - U10*I3[457] + loo2p*I2[457]
        + (oneo2z)*I1[457] - (oneo4zn)*I4[457] - (threeo4zn)*I5[345];
*(vp++) = U00*I0[458] - U10*I3[458] + loo2p*I2[458]
        + (oneo2z)*I1[458] - (oneo4zn)*I4[458] - (twoo4zn)*I5[346];
*(vp++) = U00*I0[459] - U10*I3[459] + loo2p*I2[459]
        + (oneo2z)*I1[459] - (oneo4zn)*I4[459] - (twoo4zn)*I5[347];
*(vp++) = U00*I0[460] - U10*I3[460] + loo2p*I2[460]
        + (oneo2z)*I1[460] - (oneo4zn)*I4[460] - (twoo4zn)*I5[348];
*(vp++) = U00*I0[461] - U10*I3[461] + loo2p*I2[461]
        + (oneo2z)*I1[461] - (oneo4zn)*I4[461] - (twoo4zn)*I5[349];
*(vp++) = U00*I0[462] - U10*I3[462] + loo2p*I2[462]
        + (oneo2z)*I1[462] - (oneo4zn)*I4[462] - (twoo4zn)*I5[350];
*(vp++) = U00*I0[463] - U10*I3[463] + loo2p*I2[463]
        + (oneo2z)*I1[463] - (oneo4zn)*I4[463] - (oneo4zn)*I5[351];
*(vp++) = U00*I0[464] - U10*I3[464] + loo2p*I2[464]
        + (oneo2z)*I1[464] - (oneo4zn)*I4[464] - (oneo4zn)*I5[352];
*(vp++) = U00*I0[465] - U10*I3[465] + loo2p*I2[465]
        + (oneo2z)*I1[465] - (oneo4zn)*I4[465] - (oneo4zn)*I5[353];
*(vp++) = U00*I0[466] - U10*I3[466] + loo2p*I2[466]
        + (oneo2z)*I1[466] - (oneo4zn)*I4[466] - (oneo4zn)*I5[354];
*(vp++) = U00*I0[467] - U10*I3[467] + loo2p*I2[467]
        + (oneo2z)*I1[467] - (oneo4zn)*I4[467] - (oneo4zn)*I5[355];
*(vp++) = U00*I0[468] - U10*I3[468] + loo2p*I2[468]
        + (oneo2z)*I1[468] - (oneo4zn)*I4[468] - (oneo4zn)*I5[356];
*(vp++) = U00*I0[469] - U10*I3[469] + loo2p*I2[469]
        + (oneo2z)*I1[469] - (oneo4zn)*I4[469];
*(vp++) = U00*I0[470] - U10*I3[470] + loo2p*I2[470]
        + (oneo2z)*I1[470] - (oneo4zn)*I4[470];
*(vp++) = U00*I0[471] - U10*I3[471] + loo2p*I2[471]
        + (oneo2z)*I1[471] - (oneo4zn)*I4[471];
*(vp++) = U00*I0[472] - U10*I3[472] + loo2p*I2[472]
        + (oneo2z)*I1[472] - (oneo4zn)*I4[472];
*(vp++) = U00*I0[473] - U10*I3[473] + loo2p*I2[473]
        + (oneo2z)*I1[473] - (oneo4zn)*I4[473];
*(vp++) = U00*I0[474] - U10*I3[474] + loo2p*I2[474]
        + (oneo2z)*I1[474] - (oneo4zn)*I4[474];
*(vp++) = U00*I0[475] - U10*I3[475] + loo2p*I2[475]
        + (oneo2z)*I1[475] - (oneo4zn)*I4[475];
*(vp++) = U00*I0[476] - U10*I3[476] + loo2p*I2[476]
        + (oneo2z)*I1[476] - (oneo4zn)*I4[476] - (sixo4zn)*I5[357];
*(vp++) = U00*I0[477] - U10*I3[477] + loo2p*I2[477]
        + (oneo2z)*I1[477] - (oneo4zn)*I4[477] - (fiveo4zn)*I5[358];
*(vp++) = U00*I0[478] - U10*I3[478] + loo2p*I2[478]
        + (oneo2z)*I1[478] - (oneo4zn)*I4[478] - (fiveo4zn)*I5[359];
*(vp++) = U00*I0[479] - U10*I3[479] + loo2p*I2[479]
        + (oneo2z)*I1[479] - (oneo4zn)*I4[479] - (fouro4zn)*I5[360];
*(vp++) = U00*I0[480] - U10*I3[480] + loo2p*I2[480]
        + (oneo2z)*I1[480] - (oneo4zn)*I4[480] - (fouro4zn)*I5[361];
*(vp++) = U00*I0[481] - U10*I3[481] + loo2p*I2[481]
        + (oneo2z)*I1[481] - (oneo4zn)*I4[481] - (fouro4zn)*I5[362];
*(vp++) = U00*I0[482] - U10*I3[482] + loo2p*I2[482]
        + (oneo2z)*I1[482] - (oneo4zn)*I4[482] - (threeo4zn)*I5[363];
*(vp++) = U00*I0[483] - U10*I3[483] + loo2p*I2[483]
        + (oneo2z)*I1[483] - (oneo4zn)*I4[483] - (threeo4zn)*I5[364];
*(vp++) = U00*I0[484] - U10*I3[484] + loo2p*I2[484]
        + (oneo2z)*I1[484] - (oneo4zn)*I4[484] - (threeo4zn)*I5[365];
*(vp++) = U00*I0[485] - U10*I3[485] + loo2p*I2[485]
        + (oneo2z)*I1[485] - (oneo4zn)*I4[485] - (threeo4zn)*I5[366];
*(vp++) = U00*I0[486] - U10*I3[486] + loo2p*I2[486]
        + (oneo2z)*I1[486] - (oneo4zn)*I4[486] - (twoo4zn)*I5[367];
*(vp++) = U00*I0[487] - U10*I3[487] + loo2p*I2[487]
        + (oneo2z)*I1[487] - (oneo4zn)*I4[487] - (twoo4zn)*I5[368];
*(vp++) = U00*I0[488] - U10*I3[488] + loo2p*I2[488]
        + (oneo2z)*I1[488] - (oneo4zn)*I4[488] - (twoo4zn)*I5[369];
*(vp++) = U00*I0[489] - U10*I3[489] + loo2p*I2[489]
        + (oneo2z)*I1[489] - (oneo4zn)*I4[489] - (twoo4zn)*I5[370];
*(vp++) = U00*I0[490] - U10*I3[490] + loo2p*I2[490]
        + (oneo2z)*I1[490] - (oneo4zn)*I4[490] - (twoo4zn)*I5[371];
*(vp++) = U00*I0[491] - U10*I3[491] + loo2p*I2[491]
        + (oneo2z)*I1[491] - (oneo4zn)*I4[491] - (oneo4zn)*I5[372];
*(vp++) = U00*I0[492] - U10*I3[492] + loo2p*I2[492]
        + (oneo2z)*I1[492] - (oneo4zn)*I4[492] - (oneo4zn)*I5[373];
*(vp++) = U00*I0[493] - U10*I3[493] + loo2p*I2[493]
        + (oneo2z)*I1[493] - (oneo4zn)*I4[493] - (oneo4zn)*I5[374];
*(vp++) = U00*I0[494] - U10*I3[494] + loo2p*I2[494]
        + (oneo2z)*I1[494] - (oneo4zn)*I4[494] - (oneo4zn)*I5[375];
*(vp++) = U00*I0[495] - U10*I3[495] + loo2p*I2[495]
        + (oneo2z)*I1[495] - (oneo4zn)*I4[495] - (oneo4zn)*I5[376];
*(vp++) = U00*I0[496] - U10*I3[496] + loo2p*I2[496]
        + (oneo2z)*I1[496] - (oneo4zn)*I4[496] - (oneo4zn)*I5[377];
*(vp++) = U00*I0[497] - U10*I3[497] + loo2p*I2[497]
        + (oneo2z)*I1[497] - (oneo4zn)*I4[497];
*(vp++) = U00*I0[498] - U10*I3[498] + loo2p*I2[498]
        + (oneo2z)*I1[498] - (oneo4zn)*I4[498];
*(vp++) = U00*I0[499] - U10*I3[499] + loo2p*I2[499]
        + (oneo2z)*I1[499] - (oneo4zn)*I4[499];
*(vp++) = U00*I0[500] - U10*I3[500] + loo2p*I2[500]
        + (oneo2z)*I1[500] - (oneo4zn)*I4[500];
*(vp++) = U00*I0[501] - U10*I3[501] + loo2p*I2[501]
        + (oneo2z)*I1[501] - (oneo4zn)*I4[501];
*(vp++) = U00*I0[502] - U10*I3[502] + loo2p*I2[502]
        + (oneo2z)*I1[502] - (oneo4zn)*I4[502];
*(vp++) = U00*I0[503] - U10*I3[503] + loo2p*I2[503]
        + (oneo2z)*I1[503] - (oneo4zn)*I4[503];
*(vp++) = U00*I0[504] - U10*I3[504] + loo2p*I2[504]
        + (oneo2z)*I1[504] - (oneo4zn)*I4[504] - (sixo4zn)*I5[378];
*(vp++) = U00*I0[505] - U10*I3[505] + loo2p*I2[505]
        + (oneo2z)*I1[505] - (oneo4zn)*I4[505] - (fiveo4zn)*I5[379];
return vp;
}

REALTYPE *_r_build_k0i0_2(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[506] - U10*I3[506] + loo2p*I2[506]
        + (oneo2z)*I1[506] - (oneo4zn)*I4[506] - (fiveo4zn)*I5[380];
*(vp++) = U00*I0[507] - U10*I3[507] + loo2p*I2[507]
        + (oneo2z)*I1[507] - (oneo4zn)*I4[507] - (fouro4zn)*I5[381];
*(vp++) = U00*I0[508] - U10*I3[508] + loo2p*I2[508]
        + (oneo2z)*I1[508] - (oneo4zn)*I4[508] - (fouro4zn)*I5[382];
*(vp++) = U00*I0[509] - U10*I3[509] + loo2p*I2[509]
        + (oneo2z)*I1[509] - (oneo4zn)*I4[509] - (fouro4zn)*I5[383];
*(vp++) = U00*I0[510] - U10*I3[510] + loo2p*I2[510]
        + (oneo2z)*I1[510] - (oneo4zn)*I4[510] - (threeo4zn)*I5[384];
*(vp++) = U00*I0[511] - U10*I3[511] + loo2p*I2[511]
        + (oneo2z)*I1[511] - (oneo4zn)*I4[511] - (threeo4zn)*I5[385];
*(vp++) = U00*I0[512] - U10*I3[512] + loo2p*I2[512]
        + (oneo2z)*I1[512] - (oneo4zn)*I4[512] - (threeo4zn)*I5[386];
*(vp++) = U00*I0[513] - U10*I3[513] + loo2p*I2[513]
        + (oneo2z)*I1[513] - (oneo4zn)*I4[513] - (threeo4zn)*I5[387];
*(vp++) = U00*I0[514] - U10*I3[514] + loo2p*I2[514]
        + (oneo2z)*I1[514] - (oneo4zn)*I4[514] - (twoo4zn)*I5[388];
*(vp++) = U00*I0[515] - U10*I3[515] + loo2p*I2[515]
        + (oneo2z)*I1[515] - (oneo4zn)*I4[515] - (twoo4zn)*I5[389];
*(vp++) = U00*I0[516] - U10*I3[516] + loo2p*I2[516]
        + (oneo2z)*I1[516] - (oneo4zn)*I4[516] - (twoo4zn)*I5[390];
*(vp++) = U00*I0[517] - U10*I3[517] + loo2p*I2[517]
        + (oneo2z)*I1[517] - (oneo4zn)*I4[517] - (twoo4zn)*I5[391];
*(vp++) = U00*I0[518] - U10*I3[518] + loo2p*I2[518]
        + (oneo2z)*I1[518] - (oneo4zn)*I4[518] - (twoo4zn)*I5[392];
*(vp++) = U00*I0[519] - U10*I3[519] + loo2p*I2[519]
        + (oneo2z)*I1[519] - (oneo4zn)*I4[519] - (oneo4zn)*I5[393];
*(vp++) = U00*I0[520] - U10*I3[520] + loo2p*I2[520]
        + (oneo2z)*I1[520] - (oneo4zn)*I4[520] - (oneo4zn)*I5[394];
*(vp++) = U00*I0[521] - U10*I3[521] + loo2p*I2[521]
        + (oneo2z)*I1[521] - (oneo4zn)*I4[521] - (oneo4zn)*I5[395];
*(vp++) = U00*I0[522] - U10*I3[522] + loo2p*I2[522]
        + (oneo2z)*I1[522] - (oneo4zn)*I4[522] - (oneo4zn)*I5[396];
*(vp++) = U00*I0[523] - U10*I3[523] + loo2p*I2[523]
        + (oneo2z)*I1[523] - (oneo4zn)*I4[523] - (oneo4zn)*I5[397];
*(vp++) = U00*I0[524] - U10*I3[524] + loo2p*I2[524]
        + (oneo2z)*I1[524] - (oneo4zn)*I4[524] - (oneo4zn)*I5[398];
*(vp++) = U00*I0[525] - U10*I3[525] + loo2p*I2[525]
        + (oneo2z)*I1[525] - (oneo4zn)*I4[525];
*(vp++) = U00*I0[526] - U10*I3[526] + loo2p*I2[526]
        + (oneo2z)*I1[526] - (oneo4zn)*I4[526];
*(vp++) = U00*I0[527] - U10*I3[527] + loo2p*I2[527]
        + (oneo2z)*I1[527] - (oneo4zn)*I4[527];
*(vp++) = U00*I0[528] - U10*I3[528] + loo2p*I2[528]
        + (oneo2z)*I1[528] - (oneo4zn)*I4[528];
*(vp++) = U00*I0[529] - U10*I3[529] + loo2p*I2[529]
        + (oneo2z)*I1[529] - (oneo4zn)*I4[529];
*(vp++) = U00*I0[530] - U10*I3[530] + loo2p*I2[530]
        + (oneo2z)*I1[530] - (oneo4zn)*I4[530];
*(vp++) = U00*I0[531] - U10*I3[531] + loo2p*I2[531]
        + (oneo2z)*I1[531] - (oneo4zn)*I4[531];
*(vp++) = U00*I0[532] - U10*I3[532] + loo2p*I2[532]
        + (oneo2z)*I1[532] - (oneo4zn)*I4[532] - (sixo4zn)*I5[399];
*(vp++) = U00*I0[533] - U10*I3[533] + loo2p*I2[533]
        + (oneo2z)*I1[533] - (oneo4zn)*I4[533] - (fiveo4zn)*I5[400];
*(vp++) = U00*I0[534] - U10*I3[534] + loo2p*I2[534]
        + (oneo2z)*I1[534] - (oneo4zn)*I4[534] - (fiveo4zn)*I5[401];
*(vp++) = U00*I0[535] - U10*I3[535] + loo2p*I2[535]
        + (oneo2z)*I1[535] - (oneo4zn)*I4[535] - (fouro4zn)*I5[402];
*(vp++) = U00*I0[536] - U10*I3[536] + loo2p*I2[536]
        + (oneo2z)*I1[536] - (oneo4zn)*I4[536] - (fouro4zn)*I5[403];
*(vp++) = U00*I0[537] - U10*I3[537] + loo2p*I2[537]
        + (oneo2z)*I1[537] - (oneo4zn)*I4[537] - (fouro4zn)*I5[404];
*(vp++) = U00*I0[538] - U10*I3[538] + loo2p*I2[538]
        + (oneo2z)*I1[538] - (oneo4zn)*I4[538] - (threeo4zn)*I5[405];
*(vp++) = U00*I0[539] - U10*I3[539] + loo2p*I2[539]
        + (oneo2z)*I1[539] - (oneo4zn)*I4[539] - (threeo4zn)*I5[406];
*(vp++) = U00*I0[540] - U10*I3[540] + loo2p*I2[540]
        + (oneo2z)*I1[540] - (oneo4zn)*I4[540] - (threeo4zn)*I5[407];
*(vp++) = U00*I0[541] - U10*I3[541] + loo2p*I2[541]
        + (oneo2z)*I1[541] - (oneo4zn)*I4[541] - (threeo4zn)*I5[408];
*(vp++) = U00*I0[542] - U10*I3[542] + loo2p*I2[542]
        + (oneo2z)*I1[542] - (oneo4zn)*I4[542] - (twoo4zn)*I5[409];
*(vp++) = U00*I0[543] - U10*I3[543] + loo2p*I2[543]
        + (oneo2z)*I1[543] - (oneo4zn)*I4[543] - (twoo4zn)*I5[410];
*(vp++) = U00*I0[544] - U10*I3[544] + loo2p*I2[544]
        + (oneo2z)*I1[544] - (oneo4zn)*I4[544] - (twoo4zn)*I5[411];
*(vp++) = U00*I0[545] - U10*I3[545] + loo2p*I2[545]
        + (oneo2z)*I1[545] - (oneo4zn)*I4[545] - (twoo4zn)*I5[412];
*(vp++) = U00*I0[546] - U10*I3[546] + loo2p*I2[546]
        + (oneo2z)*I1[546] - (oneo4zn)*I4[546] - (twoo4zn)*I5[413];
*(vp++) = U00*I0[547] - U10*I3[547] + loo2p*I2[547]
        + (oneo2z)*I1[547] - (oneo4zn)*I4[547] - (oneo4zn)*I5[414];
*(vp++) = U00*I0[548] - U10*I3[548] + loo2p*I2[548]
        + (oneo2z)*I1[548] - (oneo4zn)*I4[548] - (oneo4zn)*I5[415];
*(vp++) = U00*I0[549] - U10*I3[549] + loo2p*I2[549]
        + (oneo2z)*I1[549] - (oneo4zn)*I4[549] - (oneo4zn)*I5[416];
*(vp++) = U00*I0[550] - U10*I3[550] + loo2p*I2[550]
        + (oneo2z)*I1[550] - (oneo4zn)*I4[550] - (oneo4zn)*I5[417];
*(vp++) = U00*I0[551] - U10*I3[551] + loo2p*I2[551]
        + (oneo2z)*I1[551] - (oneo4zn)*I4[551] - (oneo4zn)*I5[418];
*(vp++) = U00*I0[552] - U10*I3[552] + loo2p*I2[552]
        + (oneo2z)*I1[552] - (oneo4zn)*I4[552] - (oneo4zn)*I5[419];
*(vp++) = U00*I0[553] - U10*I3[553] + loo2p*I2[553]
        + (oneo2z)*I1[553] - (oneo4zn)*I4[553];
*(vp++) = U00*I0[554] - U10*I3[554] + loo2p*I2[554]
        + (oneo2z)*I1[554] - (oneo4zn)*I4[554];
*(vp++) = U00*I0[555] - U10*I3[555] + loo2p*I2[555]
        + (oneo2z)*I1[555] - (oneo4zn)*I4[555];
*(vp++) = U00*I0[556] - U10*I3[556] + loo2p*I2[556]
        + (oneo2z)*I1[556] - (oneo4zn)*I4[556];
*(vp++) = U00*I0[557] - U10*I3[557] + loo2p*I2[557]
        + (oneo2z)*I1[557] - (oneo4zn)*I4[557];
*(vp++) = U00*I0[558] - U10*I3[558] + loo2p*I2[558]
        + (oneo2z)*I1[558] - (oneo4zn)*I4[558];
*(vp++) = U00*I0[559] - U10*I3[559] + loo2p*I2[559]
        + (oneo2z)*I1[559] - (oneo4zn)*I4[559];
*(vp++) = U00*I0[560] - U10*I3[560] + loo2p*I2[560]
        + (oneo2z)*I1[560] - (oneo4zn)*I4[560] - (sixo4zn)*I5[420];
*(vp++) = U00*I0[561] - U10*I3[561] + loo2p*I2[561]
        + (oneo2z)*I1[561] - (oneo4zn)*I4[561] - (fiveo4zn)*I5[421];
*(vp++) = U00*I0[562] - U10*I3[562] + loo2p*I2[562]
        + (oneo2z)*I1[562] - (oneo4zn)*I4[562] - (fiveo4zn)*I5[422];
*(vp++) = U00*I0[563] - U10*I3[563] + loo2p*I2[563]
        + (oneo2z)*I1[563] - (oneo4zn)*I4[563] - (fouro4zn)*I5[423];
*(vp++) = U00*I0[564] - U10*I3[564] + loo2p*I2[564]
        + (oneo2z)*I1[564] - (oneo4zn)*I4[564] - (fouro4zn)*I5[424];
*(vp++) = U00*I0[565] - U10*I3[565] + loo2p*I2[565]
        + (oneo2z)*I1[565] - (oneo4zn)*I4[565] - (fouro4zn)*I5[425];
*(vp++) = U00*I0[566] - U10*I3[566] + loo2p*I2[566]
        + (oneo2z)*I1[566] - (oneo4zn)*I4[566] - (threeo4zn)*I5[426];
*(vp++) = U00*I0[567] - U10*I3[567] + loo2p*I2[567]
        + (oneo2z)*I1[567] - (oneo4zn)*I4[567] - (threeo4zn)*I5[427];
*(vp++) = U00*I0[568] - U10*I3[568] + loo2p*I2[568]
        + (oneo2z)*I1[568] - (oneo4zn)*I4[568] - (threeo4zn)*I5[428];
*(vp++) = U00*I0[569] - U10*I3[569] + loo2p*I2[569]
        + (oneo2z)*I1[569] - (oneo4zn)*I4[569] - (threeo4zn)*I5[429];
*(vp++) = U00*I0[570] - U10*I3[570] + loo2p*I2[570]
        + (oneo2z)*I1[570] - (oneo4zn)*I4[570] - (twoo4zn)*I5[430];
*(vp++) = U00*I0[571] - U10*I3[571] + loo2p*I2[571]
        + (oneo2z)*I1[571] - (oneo4zn)*I4[571] - (twoo4zn)*I5[431];
*(vp++) = U00*I0[572] - U10*I3[572] + loo2p*I2[572]
        + (oneo2z)*I1[572] - (oneo4zn)*I4[572] - (twoo4zn)*I5[432];
*(vp++) = U00*I0[573] - U10*I3[573] + loo2p*I2[573]
        + (oneo2z)*I1[573] - (oneo4zn)*I4[573] - (twoo4zn)*I5[433];
*(vp++) = U00*I0[574] - U10*I3[574] + loo2p*I2[574]
        + (oneo2z)*I1[574] - (oneo4zn)*I4[574] - (twoo4zn)*I5[434];
*(vp++) = U00*I0[575] - U10*I3[575] + loo2p*I2[575]
        + (oneo2z)*I1[575] - (oneo4zn)*I4[575] - (oneo4zn)*I5[435];
*(vp++) = U00*I0[576] - U10*I3[576] + loo2p*I2[576]
        + (oneo2z)*I1[576] - (oneo4zn)*I4[576] - (oneo4zn)*I5[436];
*(vp++) = U00*I0[577] - U10*I3[577] + loo2p*I2[577]
        + (oneo2z)*I1[577] - (oneo4zn)*I4[577] - (oneo4zn)*I5[437];
*(vp++) = U00*I0[578] - U10*I3[578] + loo2p*I2[578]
        + (oneo2z)*I1[578] - (oneo4zn)*I4[578] - (oneo4zn)*I5[438];
*(vp++) = U00*I0[579] - U10*I3[579] + loo2p*I2[579]
        + (oneo2z)*I1[579] - (oneo4zn)*I4[579] - (oneo4zn)*I5[439];
*(vp++) = U00*I0[580] - U10*I3[580] + loo2p*I2[580]
        + (oneo2z)*I1[580] - (oneo4zn)*I4[580] - (oneo4zn)*I5[440];
*(vp++) = U00*I0[581] - U10*I3[581] + loo2p*I2[581]
        + (oneo2z)*I1[581] - (oneo4zn)*I4[581];
*(vp++) = U00*I0[582] - U10*I3[582] + loo2p*I2[582]
        + (oneo2z)*I1[582] - (oneo4zn)*I4[582];
*(vp++) = U00*I0[583] - U10*I3[583] + loo2p*I2[583]
        + (oneo2z)*I1[583] - (oneo4zn)*I4[583];
*(vp++) = U00*I0[584] - U10*I3[584] + loo2p*I2[584]
        + (oneo2z)*I1[584] - (oneo4zn)*I4[584];
*(vp++) = U00*I0[585] - U10*I3[585] + loo2p*I2[585]
        + (oneo2z)*I1[585] - (oneo4zn)*I4[585];
*(vp++) = U00*I0[586] - U10*I3[586] + loo2p*I2[586]
        + (oneo2z)*I1[586] - (oneo4zn)*I4[586];
*(vp++) = U00*I0[587] - U10*I3[587] + loo2p*I2[587]
        + (oneo2z)*I1[587] - (oneo4zn)*I4[587];
*(vp++) = U00*I0[588] - U10*I3[588] + loo2p*I2[588] - (sixo4zn)*I5[441];
*(vp++) = U00*I0[589] - U10*I3[589] + loo2p*I2[589] - (fiveo4zn)*I5[442];
*(vp++) = U00*I0[590] - U10*I3[590] + loo2p*I2[590] - (fiveo4zn)*I5[443];
*(vp++) = U00*I0[591] - U10*I3[591] + loo2p*I2[591] - (fouro4zn)*I5[444];
*(vp++) = U00*I0[592] - U10*I3[592] + loo2p*I2[592] - (fouro4zn)*I5[445];
*(vp++) = U00*I0[593] - U10*I3[593] + loo2p*I2[593] - (fouro4zn)*I5[446];
*(vp++) = U00*I0[594] - U10*I3[594] + loo2p*I2[594] - (threeo4zn)*I5[447];
*(vp++) = U00*I0[595] - U10*I3[595] + loo2p*I2[595] - (threeo4zn)*I5[448];
*(vp++) = U00*I0[596] - U10*I3[596] + loo2p*I2[596] - (threeo4zn)*I5[449];
*(vp++) = U00*I0[597] - U10*I3[597] + loo2p*I2[597] - (threeo4zn)*I5[450];
*(vp++) = U00*I0[598] - U10*I3[598] + loo2p*I2[598] - (twoo4zn)*I5[451];
*(vp++) = U00*I0[599] - U10*I3[599] + loo2p*I2[599] - (twoo4zn)*I5[452];
*(vp++) = U00*I0[600] - U10*I3[600] + loo2p*I2[600] - (twoo4zn)*I5[453];
*(vp++) = U00*I0[601] - U10*I3[601] + loo2p*I2[601] - (twoo4zn)*I5[454];
*(vp++) = U00*I0[602] - U10*I3[602] + loo2p*I2[602] - (twoo4zn)*I5[455];
*(vp++) = U00*I0[603] - U10*I3[603] + loo2p*I2[603] - (oneo4zn)*I5[456];
*(vp++) = U00*I0[604] - U10*I3[604] + loo2p*I2[604] - (oneo4zn)*I5[457];
*(vp++) = U00*I0[605] - U10*I3[605] + loo2p*I2[605] - (oneo4zn)*I5[458];
*(vp++) = U00*I0[606] - U10*I3[606] + loo2p*I2[606] - (oneo4zn)*I5[459];
*(vp++) = U00*I0[607] - U10*I3[607] + loo2p*I2[607] - (oneo4zn)*I5[460];
*(vp++) = U00*I0[608] - U10*I3[608] + loo2p*I2[608] - (oneo4zn)*I5[461];
*(vp++) = U00*I0[609] - U10*I3[609] + loo2p*I2[609];
*(vp++) = U00*I0[610] - U10*I3[610] + loo2p*I2[610];
*(vp++) = U00*I0[611] - U10*I3[611] + loo2p*I2[611];
*(vp++) = U00*I0[612] - U10*I3[612] + loo2p*I2[612];
*(vp++) = U00*I0[613] - U10*I3[613] + loo2p*I2[613];
*(vp++) = U00*I0[614] - U10*I3[614] + loo2p*I2[614];
*(vp++) = U00*I0[615] - U10*I3[615] + loo2p*I2[615];
*(vp++) = U00*I0[616] - U10*I3[616] + loo2p*I2[616] - (sixo4zn)*I5[462];
*(vp++) = U00*I0[617] - U10*I3[617] + loo2p*I2[617] - (fiveo4zn)*I5[463];
*(vp++) = U00*I0[618] - U10*I3[618] + loo2p*I2[618] - (fiveo4zn)*I5[464];
*(vp++) = U00*I0[619] - U10*I3[619] + loo2p*I2[619] - (fouro4zn)*I5[465];
*(vp++) = U00*I0[620] - U10*I3[620] + loo2p*I2[620] - (fouro4zn)*I5[466];
*(vp++) = U00*I0[621] - U10*I3[621] + loo2p*I2[621] - (fouro4zn)*I5[467];
*(vp++) = U00*I0[622] - U10*I3[622] + loo2p*I2[622] - (threeo4zn)*I5[468];
*(vp++) = U00*I0[623] - U10*I3[623] + loo2p*I2[623] - (threeo4zn)*I5[469];
*(vp++) = U00*I0[624] - U10*I3[624] + loo2p*I2[624] - (threeo4zn)*I5[470];
*(vp++) = U00*I0[625] - U10*I3[625] + loo2p*I2[625] - (threeo4zn)*I5[471];
*(vp++) = U00*I0[626] - U10*I3[626] + loo2p*I2[626] - (twoo4zn)*I5[472];
*(vp++) = U00*I0[627] - U10*I3[627] + loo2p*I2[627] - (twoo4zn)*I5[473];
*(vp++) = U00*I0[628] - U10*I3[628] + loo2p*I2[628] - (twoo4zn)*I5[474];
*(vp++) = U00*I0[629] - U10*I3[629] + loo2p*I2[629] - (twoo4zn)*I5[475];
*(vp++) = U00*I0[630] - U10*I3[630] + loo2p*I2[630] - (twoo4zn)*I5[476];
*(vp++) = U00*I0[631] - U10*I3[631] + loo2p*I2[631] - (oneo4zn)*I5[477];
*(vp++) = U00*I0[632] - U10*I3[632] + loo2p*I2[632] - (oneo4zn)*I5[478];
*(vp++) = U00*I0[633] - U10*I3[633] + loo2p*I2[633] - (oneo4zn)*I5[479];
*(vp++) = U00*I0[634] - U10*I3[634] + loo2p*I2[634] - (oneo4zn)*I5[480];
*(vp++) = U00*I0[635] - U10*I3[635] + loo2p*I2[635] - (oneo4zn)*I5[481];
*(vp++) = U00*I0[636] - U10*I3[636] + loo2p*I2[636] - (oneo4zn)*I5[482];
*(vp++) = U00*I0[637] - U10*I3[637] + loo2p*I2[637];
*(vp++) = U00*I0[638] - U10*I3[638] + loo2p*I2[638];
*(vp++) = U00*I0[639] - U10*I3[639] + loo2p*I2[639];
*(vp++) = U00*I0[640] - U10*I3[640] + loo2p*I2[640];
*(vp++) = U00*I0[641] - U10*I3[641] + loo2p*I2[641];
*(vp++) = U00*I0[642] - U10*I3[642] + loo2p*I2[642];
*(vp++) = U00*I0[643] - U10*I3[643] + loo2p*I2[643];
*(vp++) = U00*I0[644] - U10*I3[644] + loo2p*I2[644] - (sixo4zn)*I5[483];
*(vp++) = U00*I0[645] - U10*I3[645] + loo2p*I2[645] - (fiveo4zn)*I5[484];
*(vp++) = U00*I0[646] - U10*I3[646] + loo2p*I2[646] - (fiveo4zn)*I5[485];
*(vp++) = U00*I0[647] - U10*I3[647] + loo2p*I2[647] - (fouro4zn)*I5[486];
*(vp++) = U00*I0[648] - U10*I3[648] + loo2p*I2[648] - (fouro4zn)*I5[487];
*(vp++) = U00*I0[649] - U10*I3[649] + loo2p*I2[649] - (fouro4zn)*I5[488];
*(vp++) = U00*I0[650] - U10*I3[650] + loo2p*I2[650] - (threeo4zn)*I5[489];
*(vp++) = U00*I0[651] - U10*I3[651] + loo2p*I2[651] - (threeo4zn)*I5[490];
*(vp++) = U00*I0[652] - U10*I3[652] + loo2p*I2[652] - (threeo4zn)*I5[491];
*(vp++) = U00*I0[653] - U10*I3[653] + loo2p*I2[653] - (threeo4zn)*I5[492];
*(vp++) = U00*I0[654] - U10*I3[654] + loo2p*I2[654] - (twoo4zn)*I5[493];
*(vp++) = U00*I0[655] - U10*I3[655] + loo2p*I2[655] - (twoo4zn)*I5[494];
*(vp++) = U00*I0[656] - U10*I3[656] + loo2p*I2[656] - (twoo4zn)*I5[495];
*(vp++) = U00*I0[657] - U10*I3[657] + loo2p*I2[657] - (twoo4zn)*I5[496];
*(vp++) = U00*I0[658] - U10*I3[658] + loo2p*I2[658] - (twoo4zn)*I5[497];
*(vp++) = U00*I0[659] - U10*I3[659] + loo2p*I2[659] - (oneo4zn)*I5[498];
*(vp++) = U00*I0[660] - U10*I3[660] + loo2p*I2[660] - (oneo4zn)*I5[499];
*(vp++) = U00*I0[661] - U10*I3[661] + loo2p*I2[661] - (oneo4zn)*I5[500];
*(vp++) = U00*I0[662] - U10*I3[662] + loo2p*I2[662] - (oneo4zn)*I5[501];
*(vp++) = U00*I0[663] - U10*I3[663] + loo2p*I2[663] - (oneo4zn)*I5[502];
*(vp++) = U00*I0[664] - U10*I3[664] + loo2p*I2[664] - (oneo4zn)*I5[503];
*(vp++) = U00*I0[665] - U10*I3[665] + loo2p*I2[665];
*(vp++) = U00*I0[666] - U10*I3[666] + loo2p*I2[666];
*(vp++) = U00*I0[667] - U10*I3[667] + loo2p*I2[667];
*(vp++) = U00*I0[668] - U10*I3[668] + loo2p*I2[668];
*(vp++) = U00*I0[669] - U10*I3[669] + loo2p*I2[669];
*(vp++) = U00*I0[670] - U10*I3[670] + loo2p*I2[670];
*(vp++) = U00*I0[671] - U10*I3[671] + loo2p*I2[671];
*(vp++) = U00*I0[672] - U10*I3[672] + loo2p*I2[672] - (sixo4zn)*I5[504];
*(vp++) = U00*I0[673] - U10*I3[673] + loo2p*I2[673] - (fiveo4zn)*I5[505];
*(vp++) = U00*I0[674] - U10*I3[674] + loo2p*I2[674] - (fiveo4zn)*I5[506];
*(vp++) = U00*I0[675] - U10*I3[675] + loo2p*I2[675] - (fouro4zn)*I5[507];
*(vp++) = U00*I0[676] - U10*I3[676] + loo2p*I2[676] - (fouro4zn)*I5[508];
*(vp++) = U00*I0[677] - U10*I3[677] + loo2p*I2[677] - (fouro4zn)*I5[509];
*(vp++) = U00*I0[678] - U10*I3[678] + loo2p*I2[678] - (threeo4zn)*I5[510];
*(vp++) = U00*I0[679] - U10*I3[679] + loo2p*I2[679] - (threeo4zn)*I5[511];
*(vp++) = U00*I0[680] - U10*I3[680] + loo2p*I2[680] - (threeo4zn)*I5[512];
*(vp++) = U00*I0[681] - U10*I3[681] + loo2p*I2[681] - (threeo4zn)*I5[513];
*(vp++) = U00*I0[682] - U10*I3[682] + loo2p*I2[682] - (twoo4zn)*I5[514];
*(vp++) = U00*I0[683] - U10*I3[683] + loo2p*I2[683] - (twoo4zn)*I5[515];
*(vp++) = U00*I0[684] - U10*I3[684] + loo2p*I2[684] - (twoo4zn)*I5[516];
*(vp++) = U00*I0[685] - U10*I3[685] + loo2p*I2[685] - (twoo4zn)*I5[517];
*(vp++) = U00*I0[686] - U10*I3[686] + loo2p*I2[686] - (twoo4zn)*I5[518];
*(vp++) = U00*I0[687] - U10*I3[687] + loo2p*I2[687] - (oneo4zn)*I5[519];
*(vp++) = U00*I0[688] - U10*I3[688] + loo2p*I2[688] - (oneo4zn)*I5[520];
*(vp++) = U00*I0[689] - U10*I3[689] + loo2p*I2[689] - (oneo4zn)*I5[521];
*(vp++) = U00*I0[690] - U10*I3[690] + loo2p*I2[690] - (oneo4zn)*I5[522];
*(vp++) = U00*I0[691] - U10*I3[691] + loo2p*I2[691] - (oneo4zn)*I5[523];
*(vp++) = U00*I0[692] - U10*I3[692] + loo2p*I2[692] - (oneo4zn)*I5[524];
*(vp++) = U00*I0[693] - U10*I3[693] + loo2p*I2[693];
*(vp++) = U00*I0[694] - U10*I3[694] + loo2p*I2[694];
*(vp++) = U00*I0[695] - U10*I3[695] + loo2p*I2[695];
*(vp++) = U00*I0[696] - U10*I3[696] + loo2p*I2[696];
*(vp++) = U00*I0[697] - U10*I3[697] + loo2p*I2[697];
*(vp++) = U00*I0[698] - U10*I3[698] + loo2p*I2[698];
*(vp++) = U00*I0[699] - U10*I3[699] + loo2p*I2[699];
*(vp++) = U00*I0[700] - U10*I3[700] + loo2p*I2[700] - (sixo4zn)*I5[525];
*(vp++) = U00*I0[701] - U10*I3[701] + loo2p*I2[701] - (fiveo4zn)*I5[526];
*(vp++) = U00*I0[702] - U10*I3[702] + loo2p*I2[702] - (fiveo4zn)*I5[527];
*(vp++) = U00*I0[703] - U10*I3[703] + loo2p*I2[703] - (fouro4zn)*I5[528];
*(vp++) = U00*I0[704] - U10*I3[704] + loo2p*I2[704] - (fouro4zn)*I5[529];
*(vp++) = U00*I0[705] - U10*I3[705] + loo2p*I2[705] - (fouro4zn)*I5[530];
*(vp++) = U00*I0[706] - U10*I3[706] + loo2p*I2[706] - (threeo4zn)*I5[531];
*(vp++) = U00*I0[707] - U10*I3[707] + loo2p*I2[707] - (threeo4zn)*I5[532];
*(vp++) = U00*I0[708] - U10*I3[708] + loo2p*I2[708] - (threeo4zn)*I5[533];
*(vp++) = U00*I0[709] - U10*I3[709] + loo2p*I2[709] - (threeo4zn)*I5[534];
*(vp++) = U00*I0[710] - U10*I3[710] + loo2p*I2[710] - (twoo4zn)*I5[535];
*(vp++) = U00*I0[711] - U10*I3[711] + loo2p*I2[711] - (twoo4zn)*I5[536];
*(vp++) = U00*I0[712] - U10*I3[712] + loo2p*I2[712] - (twoo4zn)*I5[537];
*(vp++) = U00*I0[713] - U10*I3[713] + loo2p*I2[713] - (twoo4zn)*I5[538];
*(vp++) = U00*I0[714] - U10*I3[714] + loo2p*I2[714] - (twoo4zn)*I5[539];
*(vp++) = U00*I0[715] - U10*I3[715] + loo2p*I2[715] - (oneo4zn)*I5[540];
*(vp++) = U00*I0[716] - U10*I3[716] + loo2p*I2[716] - (oneo4zn)*I5[541];
*(vp++) = U00*I0[717] - U10*I3[717] + loo2p*I2[717] - (oneo4zn)*I5[542];
*(vp++) = U00*I0[718] - U10*I3[718] + loo2p*I2[718] - (oneo4zn)*I5[543];
*(vp++) = U00*I0[719] - U10*I3[719] + loo2p*I2[719] - (oneo4zn)*I5[544];
*(vp++) = U00*I0[720] - U10*I3[720] + loo2p*I2[720] - (oneo4zn)*I5[545];
*(vp++) = U00*I0[721] - U10*I3[721] + loo2p*I2[721];
*(vp++) = U00*I0[722] - U10*I3[722] + loo2p*I2[722];
*(vp++) = U00*I0[723] - U10*I3[723] + loo2p*I2[723];
*(vp++) = U00*I0[724] - U10*I3[724] + loo2p*I2[724];
*(vp++) = U00*I0[725] - U10*I3[725] + loo2p*I2[725];
*(vp++) = U00*I0[726] - U10*I3[726] + loo2p*I2[726];
*(vp++) = U00*I0[727] - U10*I3[727] + loo2p*I2[727];
*(vp++) = U00*I0[728] - U10*I3[728] + loo2p*I2[728] - (sixo4zn)*I5[546];
*(vp++) = U00*I0[729] - U10*I3[729] + loo2p*I2[729] - (fiveo4zn)*I5[547];
*(vp++) = U00*I0[730] - U10*I3[730] + loo2p*I2[730] - (fiveo4zn)*I5[548];
*(vp++) = U00*I0[731] - U10*I3[731] + loo2p*I2[731] - (fouro4zn)*I5[549];
*(vp++) = U00*I0[732] - U10*I3[732] + loo2p*I2[732] - (fouro4zn)*I5[550];
*(vp++) = U00*I0[733] - U10*I3[733] + loo2p*I2[733] - (fouro4zn)*I5[551];
*(vp++) = U00*I0[734] - U10*I3[734] + loo2p*I2[734] - (threeo4zn)*I5[552];
*(vp++) = U00*I0[735] - U10*I3[735] + loo2p*I2[735] - (threeo4zn)*I5[553];
*(vp++) = U00*I0[736] - U10*I3[736] + loo2p*I2[736] - (threeo4zn)*I5[554];
*(vp++) = U00*I0[737] - U10*I3[737] + loo2p*I2[737] - (threeo4zn)*I5[555];
*(vp++) = U00*I0[738] - U10*I3[738] + loo2p*I2[738] - (twoo4zn)*I5[556];
*(vp++) = U00*I0[739] - U10*I3[739] + loo2p*I2[739] - (twoo4zn)*I5[557];
*(vp++) = U00*I0[740] - U10*I3[740] + loo2p*I2[740] - (twoo4zn)*I5[558];
*(vp++) = U00*I0[741] - U10*I3[741] + loo2p*I2[741] - (twoo4zn)*I5[559];
*(vp++) = U00*I0[742] - U10*I3[742] + loo2p*I2[742] - (twoo4zn)*I5[560];
*(vp++) = U00*I0[743] - U10*I3[743] + loo2p*I2[743] - (oneo4zn)*I5[561];
*(vp++) = U00*I0[744] - U10*I3[744] + loo2p*I2[744] - (oneo4zn)*I5[562];
*(vp++) = U00*I0[745] - U10*I3[745] + loo2p*I2[745] - (oneo4zn)*I5[563];
*(vp++) = U00*I0[746] - U10*I3[746] + loo2p*I2[746] - (oneo4zn)*I5[564];
*(vp++) = U00*I0[747] - U10*I3[747] + loo2p*I2[747] - (oneo4zn)*I5[565];
*(vp++) = U00*I0[748] - U10*I3[748] + loo2p*I2[748] - (oneo4zn)*I5[566];
*(vp++) = U00*I0[749] - U10*I3[749] + loo2p*I2[749];
*(vp++) = U00*I0[750] - U10*I3[750] + loo2p*I2[750];
*(vp++) = U00*I0[751] - U10*I3[751] + loo2p*I2[751];
*(vp++) = U00*I0[752] - U10*I3[752] + loo2p*I2[752];
*(vp++) = U00*I0[753] - U10*I3[753] + loo2p*I2[753];
*(vp++) = U00*I0[754] - U10*I3[754] + loo2p*I2[754];
*(vp++) = U00*I0[755] - U10*I3[755] + loo2p*I2[755];
*(vp++) = U00*I0[756] - U10*I3[756] + loo2p*I2[756] - (sixo4zn)*I5[567];
*(vp++) = U00*I0[757] - U10*I3[757] + loo2p*I2[757] - (fiveo4zn)*I5[568];
*(vp++) = U00*I0[758] - U10*I3[758] + loo2p*I2[758] - (fiveo4zn)*I5[569];
return vp;
}

REALTYPE *_r_build_k0i0_3(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[759] - U10*I3[759] + loo2p*I2[759] - (fouro4zn)*I5[570];
*(vp++) = U00*I0[760] - U10*I3[760] + loo2p*I2[760] - (fouro4zn)*I5[571];
*(vp++) = U00*I0[761] - U10*I3[761] + loo2p*I2[761] - (fouro4zn)*I5[572];
*(vp++) = U00*I0[762] - U10*I3[762] + loo2p*I2[762] - (threeo4zn)*I5[573];
*(vp++) = U00*I0[763] - U10*I3[763] + loo2p*I2[763] - (threeo4zn)*I5[574];
*(vp++) = U00*I0[764] - U10*I3[764] + loo2p*I2[764] - (threeo4zn)*I5[575];
*(vp++) = U00*I0[765] - U10*I3[765] + loo2p*I2[765] - (threeo4zn)*I5[576];
*(vp++) = U00*I0[766] - U10*I3[766] + loo2p*I2[766] - (twoo4zn)*I5[577];
*(vp++) = U00*I0[767] - U10*I3[767] + loo2p*I2[767] - (twoo4zn)*I5[578];
*(vp++) = U00*I0[768] - U10*I3[768] + loo2p*I2[768] - (twoo4zn)*I5[579];
*(vp++) = U00*I0[769] - U10*I3[769] + loo2p*I2[769] - (twoo4zn)*I5[580];
*(vp++) = U00*I0[770] - U10*I3[770] + loo2p*I2[770] - (twoo4zn)*I5[581];
*(vp++) = U00*I0[771] - U10*I3[771] + loo2p*I2[771] - (oneo4zn)*I5[582];
*(vp++) = U00*I0[772] - U10*I3[772] + loo2p*I2[772] - (oneo4zn)*I5[583];
*(vp++) = U00*I0[773] - U10*I3[773] + loo2p*I2[773] - (oneo4zn)*I5[584];
*(vp++) = U00*I0[774] - U10*I3[774] + loo2p*I2[774] - (oneo4zn)*I5[585];
*(vp++) = U00*I0[775] - U10*I3[775] + loo2p*I2[775] - (oneo4zn)*I5[586];
*(vp++) = U00*I0[776] - U10*I3[776] + loo2p*I2[776] - (oneo4zn)*I5[587];
*(vp++) = U00*I0[777] - U10*I3[777] + loo2p*I2[777];
*(vp++) = U00*I0[778] - U10*I3[778] + loo2p*I2[778];
*(vp++) = U00*I0[779] - U10*I3[779] + loo2p*I2[779];
*(vp++) = U00*I0[780] - U10*I3[780] + loo2p*I2[780];
*(vp++) = U00*I0[781] - U10*I3[781] + loo2p*I2[781];
*(vp++) = U00*I0[782] - U10*I3[782] + loo2p*I2[782];
*(vp++) = U00*I0[783] - U10*I3[783] + loo2p*I2[783];
*(vp++) = U01*I0[588] - U11*I3[588] + loo2p*I2[784]
        + (sixo2z)*I1[420] - (sixo4zn)*I4[420];
*(vp++) = U01*I0[589] - U11*I3[589] + loo2p*I2[785]
        + (sixo2z)*I1[421] - (sixo4zn)*I4[421] - (oneo4zn)*I5[441];
*(vp++) = U01*I0[590] - U11*I3[590] + loo2p*I2[786]
        + (sixo2z)*I1[422] - (sixo4zn)*I4[422];
*(vp++) = U01*I0[591] - U11*I3[591] + loo2p*I2[787]
        + (sixo2z)*I1[423] - (sixo4zn)*I4[423] - (twoo4zn)*I5[442];
*(vp++) = U01*I0[592] - U11*I3[592] + loo2p*I2[788]
        + (sixo2z)*I1[424] - (sixo4zn)*I4[424] - (oneo4zn)*I5[443];
*(vp++) = U01*I0[593] - U11*I3[593] + loo2p*I2[789]
        + (sixo2z)*I1[425] - (sixo4zn)*I4[425];
*(vp++) = U01*I0[594] - U11*I3[594] + loo2p*I2[790]
        + (sixo2z)*I1[426] - (sixo4zn)*I4[426] - (threeo4zn)*I5[444];
*(vp++) = U01*I0[595] - U11*I3[595] + loo2p*I2[791]
        + (sixo2z)*I1[427] - (sixo4zn)*I4[427] - (twoo4zn)*I5[445];
*(vp++) = U01*I0[596] - U11*I3[596] + loo2p*I2[792]
        + (sixo2z)*I1[428] - (sixo4zn)*I4[428] - (oneo4zn)*I5[446];
*(vp++) = U01*I0[597] - U11*I3[597] + loo2p*I2[793]
        + (sixo2z)*I1[429] - (sixo4zn)*I4[429];
*(vp++) = U01*I0[598] - U11*I3[598] + loo2p*I2[794]
        + (sixo2z)*I1[430] - (sixo4zn)*I4[430] - (fouro4zn)*I5[447];
*(vp++) = U01*I0[599] - U11*I3[599] + loo2p*I2[795]
        + (sixo2z)*I1[431] - (sixo4zn)*I4[431] - (threeo4zn)*I5[448];
*(vp++) = U01*I0[600] - U11*I3[600] + loo2p*I2[796]
        + (sixo2z)*I1[432] - (sixo4zn)*I4[432] - (twoo4zn)*I5[449];
*(vp++) = U01*I0[601] - U11*I3[601] + loo2p*I2[797]
        + (sixo2z)*I1[433] - (sixo4zn)*I4[433] - (oneo4zn)*I5[450];
*(vp++) = U01*I0[602] - U11*I3[602] + loo2p*I2[798]
        + (sixo2z)*I1[434] - (sixo4zn)*I4[434];
*(vp++) = U01*I0[603] - U11*I3[603] + loo2p*I2[799]
        + (sixo2z)*I1[435] - (sixo4zn)*I4[435] - (fiveo4zn)*I5[451];
*(vp++) = U01*I0[604] - U11*I3[604] + loo2p*I2[800]
        + (sixo2z)*I1[436] - (sixo4zn)*I4[436] - (fouro4zn)*I5[452];
*(vp++) = U01*I0[605] - U11*I3[605] + loo2p*I2[801]
        + (sixo2z)*I1[437] - (sixo4zn)*I4[437] - (threeo4zn)*I5[453];
*(vp++) = U01*I0[606] - U11*I3[606] + loo2p*I2[802]
        + (sixo2z)*I1[438] - (sixo4zn)*I4[438] - (twoo4zn)*I5[454];
*(vp++) = U01*I0[607] - U11*I3[607] + loo2p*I2[803]
        + (sixo2z)*I1[439] - (sixo4zn)*I4[439] - (oneo4zn)*I5[455];
*(vp++) = U01*I0[608] - U11*I3[608] + loo2p*I2[804]
        + (sixo2z)*I1[440] - (sixo4zn)*I4[440];
*(vp++) = U01*I0[609] - U11*I3[609] + loo2p*I2[805]
        + (sixo2z)*I1[441] - (sixo4zn)*I4[441] - (sixo4zn)*I5[456];
*(vp++) = U01*I0[610] - U11*I3[610] + loo2p*I2[806]
        + (sixo2z)*I1[442] - (sixo4zn)*I4[442] - (fiveo4zn)*I5[457];
*(vp++) = U01*I0[611] - U11*I3[611] + loo2p*I2[807]
        + (sixo2z)*I1[443] - (sixo4zn)*I4[443] - (fouro4zn)*I5[458];
*(vp++) = U01*I0[612] - U11*I3[612] + loo2p*I2[808]
        + (sixo2z)*I1[444] - (sixo4zn)*I4[444] - (threeo4zn)*I5[459];
*(vp++) = U01*I0[613] - U11*I3[613] + loo2p*I2[809]
        + (sixo2z)*I1[445] - (sixo4zn)*I4[445] - (twoo4zn)*I5[460];
*(vp++) = U01*I0[614] - U11*I3[614] + loo2p*I2[810]
        + (sixo2z)*I1[446] - (sixo4zn)*I4[446] - (oneo4zn)*I5[461];
*(vp++) = U01*I0[615] - U11*I3[615] + loo2p*I2[811]
        + (sixo2z)*I1[447] - (sixo4zn)*I4[447];
*(vp++) = U01*I0[616] - U11*I3[616] + loo2p*I2[812]
        + (fiveo2z)*I1[448] - (fiveo4zn)*I4[448];
*(vp++) = U01*I0[617] - U11*I3[617] + loo2p*I2[813]
        + (fiveo2z)*I1[449] - (fiveo4zn)*I4[449] - (oneo4zn)*I5[462];
*(vp++) = U01*I0[618] - U11*I3[618] + loo2p*I2[814]
        + (fiveo2z)*I1[450] - (fiveo4zn)*I4[450];
*(vp++) = U01*I0[619] - U11*I3[619] + loo2p*I2[815]
        + (fiveo2z)*I1[451] - (fiveo4zn)*I4[451] - (twoo4zn)*I5[463];
*(vp++) = U01*I0[620] - U11*I3[620] + loo2p*I2[816]
        + (fiveo2z)*I1[452] - (fiveo4zn)*I4[452] - (oneo4zn)*I5[464];
*(vp++) = U01*I0[621] - U11*I3[621] + loo2p*I2[817]
        + (fiveo2z)*I1[453] - (fiveo4zn)*I4[453];
*(vp++) = U01*I0[622] - U11*I3[622] + loo2p*I2[818]
        + (fiveo2z)*I1[454] - (fiveo4zn)*I4[454] - (threeo4zn)*I5[465];
*(vp++) = U01*I0[623] - U11*I3[623] + loo2p*I2[819]
        + (fiveo2z)*I1[455] - (fiveo4zn)*I4[455] - (twoo4zn)*I5[466];
*(vp++) = U01*I0[624] - U11*I3[624] + loo2p*I2[820]
        + (fiveo2z)*I1[456] - (fiveo4zn)*I4[456] - (oneo4zn)*I5[467];
*(vp++) = U01*I0[625] - U11*I3[625] + loo2p*I2[821]
        + (fiveo2z)*I1[457] - (fiveo4zn)*I4[457];
*(vp++) = U01*I0[626] - U11*I3[626] + loo2p*I2[822]
        + (fiveo2z)*I1[458] - (fiveo4zn)*I4[458] - (fouro4zn)*I5[468];
*(vp++) = U01*I0[627] - U11*I3[627] + loo2p*I2[823]
        + (fiveo2z)*I1[459] - (fiveo4zn)*I4[459] - (threeo4zn)*I5[469];
*(vp++) = U01*I0[628] - U11*I3[628] + loo2p*I2[824]
        + (fiveo2z)*I1[460] - (fiveo4zn)*I4[460] - (twoo4zn)*I5[470];
*(vp++) = U01*I0[629] - U11*I3[629] + loo2p*I2[825]
        + (fiveo2z)*I1[461] - (fiveo4zn)*I4[461] - (oneo4zn)*I5[471];
*(vp++) = U01*I0[630] - U11*I3[630] + loo2p*I2[826]
        + (fiveo2z)*I1[462] - (fiveo4zn)*I4[462];
*(vp++) = U01*I0[631] - U11*I3[631] + loo2p*I2[827]
        + (fiveo2z)*I1[463] - (fiveo4zn)*I4[463] - (fiveo4zn)*I5[472];
*(vp++) = U01*I0[632] - U11*I3[632] + loo2p*I2[828]
        + (fiveo2z)*I1[464] - (fiveo4zn)*I4[464] - (fouro4zn)*I5[473];
*(vp++) = U01*I0[633] - U11*I3[633] + loo2p*I2[829]
        + (fiveo2z)*I1[465] - (fiveo4zn)*I4[465] - (threeo4zn)*I5[474];
*(vp++) = U01*I0[634] - U11*I3[634] + loo2p*I2[830]
        + (fiveo2z)*I1[466] - (fiveo4zn)*I4[466] - (twoo4zn)*I5[475];
*(vp++) = U01*I0[635] - U11*I3[635] + loo2p*I2[831]
        + (fiveo2z)*I1[467] - (fiveo4zn)*I4[467] - (oneo4zn)*I5[476];
*(vp++) = U01*I0[636] - U11*I3[636] + loo2p*I2[832]
        + (fiveo2z)*I1[468] - (fiveo4zn)*I4[468];
*(vp++) = U01*I0[637] - U11*I3[637] + loo2p*I2[833]
        + (fiveo2z)*I1[469] - (fiveo4zn)*I4[469] - (sixo4zn)*I5[477];
*(vp++) = U01*I0[638] - U11*I3[638] + loo2p*I2[834]
        + (fiveo2z)*I1[470] - (fiveo4zn)*I4[470] - (fiveo4zn)*I5[478];
*(vp++) = U01*I0[639] - U11*I3[639] + loo2p*I2[835]
        + (fiveo2z)*I1[471] - (fiveo4zn)*I4[471] - (fouro4zn)*I5[479];
*(vp++) = U01*I0[640] - U11*I3[640] + loo2p*I2[836]
        + (fiveo2z)*I1[472] - (fiveo4zn)*I4[472] - (threeo4zn)*I5[480];
*(vp++) = U01*I0[641] - U11*I3[641] + loo2p*I2[837]
        + (fiveo2z)*I1[473] - (fiveo4zn)*I4[473] - (twoo4zn)*I5[481];
*(vp++) = U01*I0[642] - U11*I3[642] + loo2p*I2[838]
        + (fiveo2z)*I1[474] - (fiveo4zn)*I4[474] - (oneo4zn)*I5[482];
*(vp++) = U01*I0[643] - U11*I3[643] + loo2p*I2[839]
        + (fiveo2z)*I1[475] - (fiveo4zn)*I4[475];
*(vp++) = U01*I0[644] - U11*I3[644] + loo2p*I2[840]
        + (fouro2z)*I1[476] - (fouro4zn)*I4[476];
*(vp++) = U01*I0[645] - U11*I3[645] + loo2p*I2[841]
        + (fouro2z)*I1[477] - (fouro4zn)*I4[477] - (oneo4zn)*I5[483];
*(vp++) = U01*I0[646] - U11*I3[646] + loo2p*I2[842]
        + (fouro2z)*I1[478] - (fouro4zn)*I4[478];
*(vp++) = U01*I0[647] - U11*I3[647] + loo2p*I2[843]
        + (fouro2z)*I1[479] - (fouro4zn)*I4[479] - (twoo4zn)*I5[484];
*(vp++) = U01*I0[648] - U11*I3[648] + loo2p*I2[844]
        + (fouro2z)*I1[480] - (fouro4zn)*I4[480] - (oneo4zn)*I5[485];
*(vp++) = U01*I0[649] - U11*I3[649] + loo2p*I2[845]
        + (fouro2z)*I1[481] - (fouro4zn)*I4[481];
*(vp++) = U01*I0[650] - U11*I3[650] + loo2p*I2[846]
        + (fouro2z)*I1[482] - (fouro4zn)*I4[482] - (threeo4zn)*I5[486];
*(vp++) = U01*I0[651] - U11*I3[651] + loo2p*I2[847]
        + (fouro2z)*I1[483] - (fouro4zn)*I4[483] - (twoo4zn)*I5[487];
*(vp++) = U01*I0[652] - U11*I3[652] + loo2p*I2[848]
        + (fouro2z)*I1[484] - (fouro4zn)*I4[484] - (oneo4zn)*I5[488];
*(vp++) = U01*I0[653] - U11*I3[653] + loo2p*I2[849]
        + (fouro2z)*I1[485] - (fouro4zn)*I4[485];
*(vp++) = U01*I0[654] - U11*I3[654] + loo2p*I2[850]
        + (fouro2z)*I1[486] - (fouro4zn)*I4[486] - (fouro4zn)*I5[489];
*(vp++) = U01*I0[655] - U11*I3[655] + loo2p*I2[851]
        + (fouro2z)*I1[487] - (fouro4zn)*I4[487] - (threeo4zn)*I5[490];
*(vp++) = U01*I0[656] - U11*I3[656] + loo2p*I2[852]
        + (fouro2z)*I1[488] - (fouro4zn)*I4[488] - (twoo4zn)*I5[491];
*(vp++) = U01*I0[657] - U11*I3[657] + loo2p*I2[853]
        + (fouro2z)*I1[489] - (fouro4zn)*I4[489] - (oneo4zn)*I5[492];
*(vp++) = U01*I0[658] - U11*I3[658] + loo2p*I2[854]
        + (fouro2z)*I1[490] - (fouro4zn)*I4[490];
*(vp++) = U01*I0[659] - U11*I3[659] + loo2p*I2[855]
        + (fouro2z)*I1[491] - (fouro4zn)*I4[491] - (fiveo4zn)*I5[493];
*(vp++) = U01*I0[660] - U11*I3[660] + loo2p*I2[856]
        + (fouro2z)*I1[492] - (fouro4zn)*I4[492] - (fouro4zn)*I5[494];
*(vp++) = U01*I0[661] - U11*I3[661] + loo2p*I2[857]
        + (fouro2z)*I1[493] - (fouro4zn)*I4[493] - (threeo4zn)*I5[495];
*(vp++) = U01*I0[662] - U11*I3[662] + loo2p*I2[858]
        + (fouro2z)*I1[494] - (fouro4zn)*I4[494] - (twoo4zn)*I5[496];
*(vp++) = U01*I0[663] - U11*I3[663] + loo2p*I2[859]
        + (fouro2z)*I1[495] - (fouro4zn)*I4[495] - (oneo4zn)*I5[497];
*(vp++) = U01*I0[664] - U11*I3[664] + loo2p*I2[860]
        + (fouro2z)*I1[496] - (fouro4zn)*I4[496];
*(vp++) = U01*I0[665] - U11*I3[665] + loo2p*I2[861]
        + (fouro2z)*I1[497] - (fouro4zn)*I4[497] - (sixo4zn)*I5[498];
*(vp++) = U01*I0[666] - U11*I3[666] + loo2p*I2[862]
        + (fouro2z)*I1[498] - (fouro4zn)*I4[498] - (fiveo4zn)*I5[499];
*(vp++) = U01*I0[667] - U11*I3[667] + loo2p*I2[863]
        + (fouro2z)*I1[499] - (fouro4zn)*I4[499] - (fouro4zn)*I5[500];
*(vp++) = U01*I0[668] - U11*I3[668] + loo2p*I2[864]
        + (fouro2z)*I1[500] - (fouro4zn)*I4[500] - (threeo4zn)*I5[501];
*(vp++) = U01*I0[669] - U11*I3[669] + loo2p*I2[865]
        + (fouro2z)*I1[501] - (fouro4zn)*I4[501] - (twoo4zn)*I5[502];
*(vp++) = U01*I0[670] - U11*I3[670] + loo2p*I2[866]
        + (fouro2z)*I1[502] - (fouro4zn)*I4[502] - (oneo4zn)*I5[503];
*(vp++) = U01*I0[671] - U11*I3[671] + loo2p*I2[867]
        + (fouro2z)*I1[503] - (fouro4zn)*I4[503];
*(vp++) = U01*I0[672] - U11*I3[672] + loo2p*I2[868]
        + (threeo2z)*I1[504] - (threeo4zn)*I4[504];
*(vp++) = U01*I0[673] - U11*I3[673] + loo2p*I2[869]
        + (threeo2z)*I1[505] - (threeo4zn)*I4[505] - (oneo4zn)*I5[504];
*(vp++) = U01*I0[674] - U11*I3[674] + loo2p*I2[870]
        + (threeo2z)*I1[506] - (threeo4zn)*I4[506];
*(vp++) = U01*I0[675] - U11*I3[675] + loo2p*I2[871]
        + (threeo2z)*I1[507] - (threeo4zn)*I4[507] - (twoo4zn)*I5[505];
*(vp++) = U01*I0[676] - U11*I3[676] + loo2p*I2[872]
        + (threeo2z)*I1[508] - (threeo4zn)*I4[508] - (oneo4zn)*I5[506];
*(vp++) = U01*I0[677] - U11*I3[677] + loo2p*I2[873]
        + (threeo2z)*I1[509] - (threeo4zn)*I4[509];
*(vp++) = U01*I0[678] - U11*I3[678] + loo2p*I2[874]
        + (threeo2z)*I1[510] - (threeo4zn)*I4[510] - (threeo4zn)*I5[507];
*(vp++) = U01*I0[679] - U11*I3[679] + loo2p*I2[875]
        + (threeo2z)*I1[511] - (threeo4zn)*I4[511] - (twoo4zn)*I5[508];
*(vp++) = U01*I0[680] - U11*I3[680] + loo2p*I2[876]
        + (threeo2z)*I1[512] - (threeo4zn)*I4[512] - (oneo4zn)*I5[509];
*(vp++) = U01*I0[681] - U11*I3[681] + loo2p*I2[877]
        + (threeo2z)*I1[513] - (threeo4zn)*I4[513];
*(vp++) = U01*I0[682] - U11*I3[682] + loo2p*I2[878]
        + (threeo2z)*I1[514] - (threeo4zn)*I4[514] - (fouro4zn)*I5[510];
*(vp++) = U01*I0[683] - U11*I3[683] + loo2p*I2[879]
        + (threeo2z)*I1[515] - (threeo4zn)*I4[515] - (threeo4zn)*I5[511];
*(vp++) = U01*I0[684] - U11*I3[684] + loo2p*I2[880]
        + (threeo2z)*I1[516] - (threeo4zn)*I4[516] - (twoo4zn)*I5[512];
*(vp++) = U01*I0[685] - U11*I3[685] + loo2p*I2[881]
        + (threeo2z)*I1[517] - (threeo4zn)*I4[517] - (oneo4zn)*I5[513];
*(vp++) = U01*I0[686] - U11*I3[686] + loo2p*I2[882]
        + (threeo2z)*I1[518] - (threeo4zn)*I4[518];
*(vp++) = U01*I0[687] - U11*I3[687] + loo2p*I2[883]
        + (threeo2z)*I1[519] - (threeo4zn)*I4[519] - (fiveo4zn)*I5[514];
*(vp++) = U01*I0[688] - U11*I3[688] + loo2p*I2[884]
        + (threeo2z)*I1[520] - (threeo4zn)*I4[520] - (fouro4zn)*I5[515];
*(vp++) = U01*I0[689] - U11*I3[689] + loo2p*I2[885]
        + (threeo2z)*I1[521] - (threeo4zn)*I4[521] - (threeo4zn)*I5[516];
*(vp++) = U01*I0[690] - U11*I3[690] + loo2p*I2[886]
        + (threeo2z)*I1[522] - (threeo4zn)*I4[522] - (twoo4zn)*I5[517];
*(vp++) = U01*I0[691] - U11*I3[691] + loo2p*I2[887]
        + (threeo2z)*I1[523] - (threeo4zn)*I4[523] - (oneo4zn)*I5[518];
*(vp++) = U01*I0[692] - U11*I3[692] + loo2p*I2[888]
        + (threeo2z)*I1[524] - (threeo4zn)*I4[524];
*(vp++) = U01*I0[693] - U11*I3[693] + loo2p*I2[889]
        + (threeo2z)*I1[525] - (threeo4zn)*I4[525] - (sixo4zn)*I5[519];
*(vp++) = U01*I0[694] - U11*I3[694] + loo2p*I2[890]
        + (threeo2z)*I1[526] - (threeo4zn)*I4[526] - (fiveo4zn)*I5[520];
*(vp++) = U01*I0[695] - U11*I3[695] + loo2p*I2[891]
        + (threeo2z)*I1[527] - (threeo4zn)*I4[527] - (fouro4zn)*I5[521];
*(vp++) = U01*I0[696] - U11*I3[696] + loo2p*I2[892]
        + (threeo2z)*I1[528] - (threeo4zn)*I4[528] - (threeo4zn)*I5[522];
*(vp++) = U01*I0[697] - U11*I3[697] + loo2p*I2[893]
        + (threeo2z)*I1[529] - (threeo4zn)*I4[529] - (twoo4zn)*I5[523];
*(vp++) = U01*I0[698] - U11*I3[698] + loo2p*I2[894]
        + (threeo2z)*I1[530] - (threeo4zn)*I4[530] - (oneo4zn)*I5[524];
*(vp++) = U01*I0[699] - U11*I3[699] + loo2p*I2[895]
        + (threeo2z)*I1[531] - (threeo4zn)*I4[531];
*(vp++) = U01*I0[700] - U11*I3[700] + loo2p*I2[896]
        + (twoo2z)*I1[532] - (twoo4zn)*I4[532];
*(vp++) = U01*I0[701] - U11*I3[701] + loo2p*I2[897]
        + (twoo2z)*I1[533] - (twoo4zn)*I4[533] - (oneo4zn)*I5[525];
*(vp++) = U01*I0[702] - U11*I3[702] + loo2p*I2[898]
        + (twoo2z)*I1[534] - (twoo4zn)*I4[534];
*(vp++) = U01*I0[703] - U11*I3[703] + loo2p*I2[899]
        + (twoo2z)*I1[535] - (twoo4zn)*I4[535] - (twoo4zn)*I5[526];
*(vp++) = U01*I0[704] - U11*I3[704] + loo2p*I2[900]
        + (twoo2z)*I1[536] - (twoo4zn)*I4[536] - (oneo4zn)*I5[527];
*(vp++) = U01*I0[705] - U11*I3[705] + loo2p*I2[901]
        + (twoo2z)*I1[537] - (twoo4zn)*I4[537];
*(vp++) = U01*I0[706] - U11*I3[706] + loo2p*I2[902]
        + (twoo2z)*I1[538] - (twoo4zn)*I4[538] - (threeo4zn)*I5[528];
*(vp++) = U01*I0[707] - U11*I3[707] + loo2p*I2[903]
        + (twoo2z)*I1[539] - (twoo4zn)*I4[539] - (twoo4zn)*I5[529];
*(vp++) = U01*I0[708] - U11*I3[708] + loo2p*I2[904]
        + (twoo2z)*I1[540] - (twoo4zn)*I4[540] - (oneo4zn)*I5[530];
*(vp++) = U01*I0[709] - U11*I3[709] + loo2p*I2[905]
        + (twoo2z)*I1[541] - (twoo4zn)*I4[541];
*(vp++) = U01*I0[710] - U11*I3[710] + loo2p*I2[906]
        + (twoo2z)*I1[542] - (twoo4zn)*I4[542] - (fouro4zn)*I5[531];
*(vp++) = U01*I0[711] - U11*I3[711] + loo2p*I2[907]
        + (twoo2z)*I1[543] - (twoo4zn)*I4[543] - (threeo4zn)*I5[532];
*(vp++) = U01*I0[712] - U11*I3[712] + loo2p*I2[908]
        + (twoo2z)*I1[544] - (twoo4zn)*I4[544] - (twoo4zn)*I5[533];
*(vp++) = U01*I0[713] - U11*I3[713] + loo2p*I2[909]
        + (twoo2z)*I1[545] - (twoo4zn)*I4[545] - (oneo4zn)*I5[534];
*(vp++) = U01*I0[714] - U11*I3[714] + loo2p*I2[910]
        + (twoo2z)*I1[546] - (twoo4zn)*I4[546];
*(vp++) = U01*I0[715] - U11*I3[715] + loo2p*I2[911]
        + (twoo2z)*I1[547] - (twoo4zn)*I4[547] - (fiveo4zn)*I5[535];
*(vp++) = U01*I0[716] - U11*I3[716] + loo2p*I2[912]
        + (twoo2z)*I1[548] - (twoo4zn)*I4[548] - (fouro4zn)*I5[536];
*(vp++) = U01*I0[717] - U11*I3[717] + loo2p*I2[913]
        + (twoo2z)*I1[549] - (twoo4zn)*I4[549] - (threeo4zn)*I5[537];
*(vp++) = U01*I0[718] - U11*I3[718] + loo2p*I2[914]
        + (twoo2z)*I1[550] - (twoo4zn)*I4[550] - (twoo4zn)*I5[538];
*(vp++) = U01*I0[719] - U11*I3[719] + loo2p*I2[915]
        + (twoo2z)*I1[551] - (twoo4zn)*I4[551] - (oneo4zn)*I5[539];
*(vp++) = U01*I0[720] - U11*I3[720] + loo2p*I2[916]
        + (twoo2z)*I1[552] - (twoo4zn)*I4[552];
*(vp++) = U01*I0[721] - U11*I3[721] + loo2p*I2[917]
        + (twoo2z)*I1[553] - (twoo4zn)*I4[553] - (sixo4zn)*I5[540];
*(vp++) = U01*I0[722] - U11*I3[722] + loo2p*I2[918]
        + (twoo2z)*I1[554] - (twoo4zn)*I4[554] - (fiveo4zn)*I5[541];
*(vp++) = U01*I0[723] - U11*I3[723] + loo2p*I2[919]
        + (twoo2z)*I1[555] - (twoo4zn)*I4[555] - (fouro4zn)*I5[542];
*(vp++) = U01*I0[724] - U11*I3[724] + loo2p*I2[920]
        + (twoo2z)*I1[556] - (twoo4zn)*I4[556] - (threeo4zn)*I5[543];
*(vp++) = U01*I0[725] - U11*I3[725] + loo2p*I2[921]
        + (twoo2z)*I1[557] - (twoo4zn)*I4[557] - (twoo4zn)*I5[544];
*(vp++) = U01*I0[726] - U11*I3[726] + loo2p*I2[922]
        + (twoo2z)*I1[558] - (twoo4zn)*I4[558] - (oneo4zn)*I5[545];
*(vp++) = U01*I0[727] - U11*I3[727] + loo2p*I2[923]
        + (twoo2z)*I1[559] - (twoo4zn)*I4[559];
*(vp++) = U01*I0[728] - U11*I3[728] + loo2p*I2[924]
        + (oneo2z)*I1[560] - (oneo4zn)*I4[560];
*(vp++) = U01*I0[729] - U11*I3[729] + loo2p*I2[925]
        + (oneo2z)*I1[561] - (oneo4zn)*I4[561] - (oneo4zn)*I5[546];
*(vp++) = U01*I0[730] - U11*I3[730] + loo2p*I2[926]
        + (oneo2z)*I1[562] - (oneo4zn)*I4[562];
*(vp++) = U01*I0[731] - U11*I3[731] + loo2p*I2[927]
        + (oneo2z)*I1[563] - (oneo4zn)*I4[563] - (twoo4zn)*I5[547];
*(vp++) = U01*I0[732] - U11*I3[732] + loo2p*I2[928]
        + (oneo2z)*I1[564] - (oneo4zn)*I4[564] - (oneo4zn)*I5[548];
*(vp++) = U01*I0[733] - U11*I3[733] + loo2p*I2[929]
        + (oneo2z)*I1[565] - (oneo4zn)*I4[565];
*(vp++) = U01*I0[734] - U11*I3[734] + loo2p*I2[930]
        + (oneo2z)*I1[566] - (oneo4zn)*I4[566] - (threeo4zn)*I5[549];
*(vp++) = U01*I0[735] - U11*I3[735] + loo2p*I2[931]
        + (oneo2z)*I1[567] - (oneo4zn)*I4[567] - (twoo4zn)*I5[550];
*(vp++) = U01*I0[736] - U11*I3[736] + loo2p*I2[932]
        + (oneo2z)*I1[568] - (oneo4zn)*I4[568] - (oneo4zn)*I5[551];
*(vp++) = U01*I0[737] - U11*I3[737] + loo2p*I2[933]
        + (oneo2z)*I1[569] - (oneo4zn)*I4[569];
*(vp++) = U01*I0[738] - U11*I3[738] + loo2p*I2[934]
        + (oneo2z)*I1[570] - (oneo4zn)*I4[570] - (fouro4zn)*I5[552];
*(vp++) = U01*I0[739] - U11*I3[739] + loo2p*I2[935]
        + (oneo2z)*I1[571] - (oneo4zn)*I4[571] - (threeo4zn)*I5[553];
*(vp++) = U01*I0[740] - U11*I3[740] + loo2p*I2[936]
        + (oneo2z)*I1[572] - (oneo4zn)*I4[572] - (twoo4zn)*I5[554];
*(vp++) = U01*I0[741] - U11*I3[741] + loo2p*I2[937]
        + (oneo2z)*I1[573] - (oneo4zn)*I4[573] - (oneo4zn)*I5[555];
*(vp++) = U01*I0[742] - U11*I3[742] + loo2p*I2[938]
        + (oneo2z)*I1[574] - (oneo4zn)*I4[574];
*(vp++) = U01*I0[743] - U11*I3[743] + loo2p*I2[939]
        + (oneo2z)*I1[575] - (oneo4zn)*I4[575] - (fiveo4zn)*I5[556];
*(vp++) = U01*I0[744] - U11*I3[744] + loo2p*I2[940]
        + (oneo2z)*I1[576] - (oneo4zn)*I4[576] - (fouro4zn)*I5[557];
*(vp++) = U01*I0[745] - U11*I3[745] + loo2p*I2[941]
        + (oneo2z)*I1[577] - (oneo4zn)*I4[577] - (threeo4zn)*I5[558];
*(vp++) = U01*I0[746] - U11*I3[746] + loo2p*I2[942]
        + (oneo2z)*I1[578] - (oneo4zn)*I4[578] - (twoo4zn)*I5[559];
*(vp++) = U01*I0[747] - U11*I3[747] + loo2p*I2[943]
        + (oneo2z)*I1[579] - (oneo4zn)*I4[579] - (oneo4zn)*I5[560];
*(vp++) = U01*I0[748] - U11*I3[748] + loo2p*I2[944]
        + (oneo2z)*I1[580] - (oneo4zn)*I4[580];
*(vp++) = U01*I0[749] - U11*I3[749] + loo2p*I2[945]
        + (oneo2z)*I1[581] - (oneo4zn)*I4[581] - (sixo4zn)*I5[561];
*(vp++) = U01*I0[750] - U11*I3[750] + loo2p*I2[946]
        + (oneo2z)*I1[582] - (oneo4zn)*I4[582] - (fiveo4zn)*I5[562];
*(vp++) = U01*I0[751] - U11*I3[751] + loo2p*I2[947]
        + (oneo2z)*I1[583] - (oneo4zn)*I4[583] - (fouro4zn)*I5[563];
*(vp++) = U01*I0[752] - U11*I3[752] + loo2p*I2[948]
        + (oneo2z)*I1[584] - (oneo4zn)*I4[584] - (threeo4zn)*I5[564];
*(vp++) = U01*I0[753] - U11*I3[753] + loo2p*I2[949]
        + (oneo2z)*I1[585] - (oneo4zn)*I4[585] - (twoo4zn)*I5[565];
*(vp++) = U01*I0[754] - U11*I3[754] + loo2p*I2[950]
        + (oneo2z)*I1[586] - (oneo4zn)*I4[586] - (oneo4zn)*I5[566];
*(vp++) = U01*I0[755] - U11*I3[755] + loo2p*I2[951]
        + (oneo2z)*I1[587] - (oneo4zn)*I4[587];
*(vp++) = U01*I0[756] - U11*I3[756] + loo2p*I2[952];
*(vp++) = U01*I0[757] - U11*I3[757] + loo2p*I2[953] - (oneo4zn)*I5[567];
*(vp++) = U01*I0[758] - U11*I3[758] + loo2p*I2[954];
*(vp++) = U01*I0[759] - U11*I3[759] + loo2p*I2[955] - (twoo4zn)*I5[568];
*(vp++) = U01*I0[760] - U11*I3[760] + loo2p*I2[956] - (oneo4zn)*I5[569];
*(vp++) = U01*I0[761] - U11*I3[761] + loo2p*I2[957];
*(vp++) = U01*I0[762] - U11*I3[762] + loo2p*I2[958] - (threeo4zn)*I5[570];
*(vp++) = U01*I0[763] - U11*I3[763] + loo2p*I2[959] - (twoo4zn)*I5[571];
*(vp++) = U01*I0[764] - U11*I3[764] + loo2p*I2[960] - (oneo4zn)*I5[572];
*(vp++) = U01*I0[765] - U11*I3[765] + loo2p*I2[961];
*(vp++) = U01*I0[766] - U11*I3[766] + loo2p*I2[962] - (fouro4zn)*I5[573];
*(vp++) = U01*I0[767] - U11*I3[767] + loo2p*I2[963] - (threeo4zn)*I5[574];
*(vp++) = U01*I0[768] - U11*I3[768] + loo2p*I2[964] - (twoo4zn)*I5[575];
*(vp++) = U01*I0[769] - U11*I3[769] + loo2p*I2[965] - (oneo4zn)*I5[576];
*(vp++) = U01*I0[770] - U11*I3[770] + loo2p*I2[966];
*(vp++) = U01*I0[771] - U11*I3[771] + loo2p*I2[967] - (fiveo4zn)*I5[577];
*(vp++) = U01*I0[772] - U11*I3[772] + loo2p*I2[968] - (fouro4zn)*I5[578];
*(vp++) = U01*I0[773] - U11*I3[773] + loo2p*I2[969] - (threeo4zn)*I5[579];
*(vp++) = U01*I0[774] - U11*I3[774] + loo2p*I2[970] - (twoo4zn)*I5[580];
*(vp++) = U01*I0[775] - U11*I3[775] + loo2p*I2[971] - (oneo4zn)*I5[581];
*(vp++) = U01*I0[776] - U11*I3[776] + loo2p*I2[972];
*(vp++) = U01*I0[777] - U11*I3[777] + loo2p*I2[973] - (sixo4zn)*I5[582];
*(vp++) = U01*I0[778] - U11*I3[778] + loo2p*I2[974] - (fiveo4zn)*I5[583];
*(vp++) = U01*I0[779] - U11*I3[779] + loo2p*I2[975] - (fouro4zn)*I5[584];
*(vp++) = U01*I0[780] - U11*I3[780] + loo2p*I2[976] - (threeo4zn)*I5[585];
*(vp++) = U01*I0[781] - U11*I3[781] + loo2p*I2[977] - (twoo4zn)*I5[586];
*(vp++) = U01*I0[782] - U11*I3[782] + loo2p*I2[978] - (oneo4zn)*I5[587];
*(vp++) = U01*I0[783] - U11*I3[783] + loo2p*I2[979];
*(vp++) = U02*I0[756] - U12*I3[756] + loo2p*I2[980]
        + (sixo2z)*I1[560] - (sixo4zn)*I4[560];
*(vp++) = U02*I0[757] - U12*I3[757] + loo2p*I2[981]
        + (sixo2z)*I1[561] - (sixo4zn)*I4[561];
*(vp++) = U02*I0[758] - U12*I3[758] + loo2p*I2[982]
        + (sixo2z)*I1[562] - (sixo4zn)*I4[562] - (oneo4zn)*I5[567];
*(vp++) = U02*I0[759] - U12*I3[759] + loo2p*I2[983]
        + (sixo2z)*I1[563] - (sixo4zn)*I4[563];
*(vp++) = U02*I0[760] - U12*I3[760] + loo2p*I2[984]
        + (sixo2z)*I1[564] - (sixo4zn)*I4[564] - (oneo4zn)*I5[568];
*(vp++) = U02*I0[761] - U12*I3[761] + loo2p*I2[985]
        + (sixo2z)*I1[565] - (sixo4zn)*I4[565] - (twoo4zn)*I5[569];
*(vp++) = U02*I0[762] - U12*I3[762] + loo2p*I2[986]
        + (sixo2z)*I1[566] - (sixo4zn)*I4[566];
*(vp++) = U02*I0[763] - U12*I3[763] + loo2p*I2[987]
        + (sixo2z)*I1[567] - (sixo4zn)*I4[567] - (oneo4zn)*I5[570];
*(vp++) = U02*I0[764] - U12*I3[764] + loo2p*I2[988]
        + (sixo2z)*I1[568] - (sixo4zn)*I4[568] - (twoo4zn)*I5[571];
*(vp++) = U02*I0[765] - U12*I3[765] + loo2p*I2[989]
        + (sixo2z)*I1[569] - (sixo4zn)*I4[569] - (threeo4zn)*I5[572];
*(vp++) = U02*I0[766] - U12*I3[766] + loo2p*I2[990]
        + (sixo2z)*I1[570] - (sixo4zn)*I4[570];
*(vp++) = U02*I0[767] - U12*I3[767] + loo2p*I2[991]
        + (sixo2z)*I1[571] - (sixo4zn)*I4[571] - (oneo4zn)*I5[573];
*(vp++) = U02*I0[768] - U12*I3[768] + loo2p*I2[992]
        + (sixo2z)*I1[572] - (sixo4zn)*I4[572] - (twoo4zn)*I5[574];
*(vp++) = U02*I0[769] - U12*I3[769] + loo2p*I2[993]
        + (sixo2z)*I1[573] - (sixo4zn)*I4[573] - (threeo4zn)*I5[575];
*(vp++) = U02*I0[770] - U12*I3[770] + loo2p*I2[994]
        + (sixo2z)*I1[574] - (sixo4zn)*I4[574] - (fouro4zn)*I5[576];
*(vp++) = U02*I0[771] - U12*I3[771] + loo2p*I2[995]
        + (sixo2z)*I1[575] - (sixo4zn)*I4[575];
*(vp++) = U02*I0[772] - U12*I3[772] + loo2p*I2[996]
        + (sixo2z)*I1[576] - (sixo4zn)*I4[576] - (oneo4zn)*I5[577];
*(vp++) = U02*I0[773] - U12*I3[773] + loo2p*I2[997]
        + (sixo2z)*I1[577] - (sixo4zn)*I4[577] - (twoo4zn)*I5[578];
*(vp++) = U02*I0[774] - U12*I3[774] + loo2p*I2[998]
        + (sixo2z)*I1[578] - (sixo4zn)*I4[578] - (threeo4zn)*I5[579];
*(vp++) = U02*I0[775] - U12*I3[775] + loo2p*I2[999]
        + (sixo2z)*I1[579] - (sixo4zn)*I4[579] - (fouro4zn)*I5[580];
*(vp++) = U02*I0[776] - U12*I3[776] + loo2p*I2[1000]
        + (sixo2z)*I1[580] - (sixo4zn)*I4[580] - (fiveo4zn)*I5[581];
*(vp++) = U02*I0[777] - U12*I3[777] + loo2p*I2[1001]
        + (sixo2z)*I1[581] - (sixo4zn)*I4[581];
*(vp++) = U02*I0[778] - U12*I3[778] + loo2p*I2[1002]
        + (sixo2z)*I1[582] - (sixo4zn)*I4[582] - (oneo4zn)*I5[582];
*(vp++) = U02*I0[779] - U12*I3[779] + loo2p*I2[1003]
        + (sixo2z)*I1[583] - (sixo4zn)*I4[583] - (twoo4zn)*I5[583];
*(vp++) = U02*I0[780] - U12*I3[780] + loo2p*I2[1004]
        + (sixo2z)*I1[584] - (sixo4zn)*I4[584] - (threeo4zn)*I5[584];
*(vp++) = U02*I0[781] - U12*I3[781] + loo2p*I2[1005]
        + (sixo2z)*I1[585] - (sixo4zn)*I4[585] - (fouro4zn)*I5[585];
*(vp++) = U02*I0[782] - U12*I3[782] + loo2p*I2[1006]
        + (sixo2z)*I1[586] - (sixo4zn)*I4[586] - (fiveo4zn)*I5[586];
*(vp++) = U02*I0[783] - U12*I3[783] + loo2p*I2[1007]
        + (sixo2z)*I1[587] - (sixo4zn)*I4[587] - (sixo4zn)*I5[587];
return vp;
}
